/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/errors","vs/base/common/uri","vs/base/common/path","vs/platform/log/common/log","vs/platform/environment/common/environment","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/network","vs/base/common/arrays","vs/base/common/types","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/process","vs/base/common/json","os","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/jsonEdit","vs/base/common/map","vs/base/common/extpath","child_process","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/instantiation/common/extensions","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensions/node/extensionHostStarter","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(X){for(var e=[],k=0,T=X.length;k<T;k++)e[k]=te[X[k]];return e};define(te[102],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function k(T,D){if(!T)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=k}),define(te[67],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const k=Object.prototype.hasOwnProperty;function T(I){const w=[];for(let f in I)k.call(I,f)&&w.push(I[f]);return w}e.values=T;function D(I,w){for(let f in I)if(k.call(I,f)&&w({key:f,value:I[f]},function(){delete I[f]})===!1)return}e.forEach=D;function R(I,w){const f=Object.create(null);for(const p of I){const h=w(p);let E=f[h];E||(E=f[h]=[]),E.push(p)}return f}e.groupBy=R;function r(I){const w=Object.create(null);return I&&I.forEach((f,p)=>{w[p]=f}),w}e.fromMap=r;function P(I,w){const f=[],p=[];for(let h of I)w.has(h)||f.push(h);for(let h of w)I.has(h)||p.push(h);return{removed:f,added:p}}e.diffSets=P;function y(I,w){const f=[],p=[];for(let[h,E]of I)w.has(h)||f.push(E);for(let[h,E]of w)I.has(h)||p.push(E);return{removed:f,added:p}}e.diffMaps=y;class C{constructor(){this.map=new Map}add(w,f){let p=this.map.get(w);p||(p=new Set,this.map.set(w,p)),p.add(f)}delete(w,f){const p=this.map.get(w);!p||(p.delete(f),p.size===0&&this.map.delete(w))}forEach(w,f){const p=this.map.get(w);!p||p.forEach(f)}}e.SetMap=C}),define(te[68],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function k(r){return(P,y,C)=>{let I=null,w=null;if(typeof C.value=="function"?(I="value",w=C.value):typeof C.get=="function"&&(I="get",w=C.get),!w)throw new Error("not supported");C[I]=r(w,y)}}e.createDecorator=k;function T(r,P,y){let C=null,I=null;if(typeof y.value=="function"?(C="value",I=y.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(C="get",I=y.get),!I)throw new Error("not supported");const w=`$memoize$${P}`;y[C]=function(...f){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,f)}),this[w]}}e.memoize=T;function D(r,P,y){return k((C,I)=>{const w=`$debounce$${I}`,f=`$debounce$result$${I}`;return function(...p){this[f]||(this[f]=y?y():void 0),clearTimeout(this[w]),P&&(this[f]=P(this[f],...p),p=[this[f]]),this[w]=setTimeout(()=>{C.apply(this,p),this[f]=y?y():void 0},r)}})}e.debounce=D;function R(r,P,y){return k((C,I)=>{const w=`$throttle$timer$${I}`,f=`$throttle$result$${I}`,p=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...E){if(this[f]||(this[f]=y?y():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),P&&(this[f]=P(this[f],...E)),this[h])return;const S=this[p]+r;S<=Date.now()?(this[p]=Date.now(),C.apply(this,[this[f]]),this[f]=y?y():void 0):(this[h]=!0,this[w]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),C.apply(this,[this[f]]),this[f]=y?y():void 0},S-Date.now()))}})}e.throttle=R}),define(te[7],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class k{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(s=>{s(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=k,e.errorHandler=new k;function T(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=T;function D(l){y(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function R(l){y(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function r(l){if(l instanceof Error){let{name:n,message:s}=l;const i=l.stacktrace||l.stack;return{$isError:!0,name:n,message:s,stack:i}}return l}e.transformErrorForSerialization=r;const P="Canceled";function y(l){return l instanceof Error&&l.name===P&&l.message===P}e.isPromiseCanceledError=y;class C extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=C;function I(){const l=new Error(P);return l.name=l.message,l}e.canceled=I;function w(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=w;function f(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=f;function p(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(l){const n=new Error(`${l} has been disposed`);return n.name="DISPOSED",n}e.disposed=h;function E(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=E;class S extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=S;class m extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=m;class v extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=v;function d(l){const n=l;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=d;function c(l,n=Object.create(null)){const s=new Error(l);return n.actions&&(s.actions=n.actions),s}e.createErrorWithActions=c}),define(te[16],ne([0,1,7]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(F,B=0){return F[F.length-(1+B)]}e.tail=T;function D(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=D;function R(F,B,V=(Q,Z)=>Q===Z){if(F===B)return!0;if(!F||!B||F.length!==B.length)return!1;for(let Q=0,Z=F.length;Q<Z;Q++)if(!V(F[Q],B[Q]))return!1;return!0}e.equals=R;function r(F,B,V){let Q=0,Z=F.length-1;for(;Q<=Z;){const G=(Q+Z)/2|0,H=V(F[G],B);if(H<0)Q=G+1;else if(H>0)Z=G-1;else return G}return-(Q+1)}e.binarySearch=r;function P(F,B){let V=0,Q=F.length;if(Q===0)return 0;for(;V<Q;){const Z=Math.floor((V+Q)/2);B(F[Z])?Q=Z:V=Z+1}return V}e.findFirstInSorted=P;function y(F,B,V){if(F=F|0,F>=B.length)throw new TypeError("invalid index");let Q=B[Math.floor(B.length*Math.random())],Z=[],G=[],H=[];for(let re of B){const ie=V(re,Q);ie<0?Z.push(re):ie>0?G.push(re):H.push(re)}return F<Z.length?y(F,Z,V):F<Z.length+H.length?H[0]:y(F-(Z.length+H.length),G,V)}e.quickSelect=y;function C(F,B){const V=[];let Q;for(const Z of F.slice(0).sort(B))!Q||B(Q[0],Z)!==0?(Q=[Z],V.push(Q)):Q.push(Z);return V}e.groupBy=C;function I(F,B,V){const Q=[];function Z(re,ie,ce){if(ie===0&&ce.length===0)return;const le=Q[Q.length-1];le&&le.start+le.deleteCount===re?(le.deleteCount+=ie,le.toInsert.push(...ce)):Q.push({start:re,deleteCount:ie,toInsert:ce})}let G=0,H=0;for(;;){if(G===F.length){Z(G,0,B.slice(H));break}if(H===B.length){Z(G,F.length-G,[]);break}const re=F[G],ie=B[H],ce=V(re,ie);ce===0?(G+=1,H+=1):ce<0?(Z(G,1,[]),G+=1):ce>0&&(Z(G,0,[ie]),H+=1)}return Q}e.sortedDiff=I;function w(F,B,V){const Q=I(F,B,V),Z=[],G=[];for(const H of Q)Z.push(...F.slice(H.start,H.start+H.deleteCount)),G.push(...H.toInsert);return{removed:Z,added:G}}e.delta=w;function f(F,B,V){if(V===0)return[];const Q=F.slice(0,V).sort(B);return h(F,B,Q,V,F.length),Q}e.top=f;function p(F,B,V,Q,Z){return V===0?Promise.resolve([]):new Promise((G,H)=>{(async()=>{const re=F.length,ie=F.slice(0,V).sort(B);for(let ce=V,le=Math.min(V+Q,re);ce<re;ce=le,le=Math.min(le+Q,re)){if(ce>V&&await new Promise(fe=>setTimeout(fe)),Z&&Z.isCancellationRequested)throw(0,k.canceled)();h(F,B,ie,ce,le)}return ie})().then(G,H)})}e.topAsync=p;function h(F,B,V,Q,Z){for(const G=V.length;Q<Z;Q++){const H=F[Q];if(B(H,V[G-1])<0){V.pop();const re=P(V,ie=>B(H,ie)<0);V.splice(re,0,H)}}}function E(F){return F.filter(B=>!!B)}e.coalesce=E;function S(F){let B=0;for(let V=0;V<F.length;V++)F[V]&&(F[B]=F[V],B+=1);F.length=B}e.coalesceInPlace=S;function m(F,B,V){F.splice(V,0,F.splice(B,1)[0])}e.move=m;function v(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=v;function d(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=d;function c(F,B=V=>V){const V=new Set;return F.filter(Q=>{const Z=B(Q);return V.has(Z)?!1:(V.add(Z),!0)})}e.distinct=c;function l(F){const B=Object.create(null);return V=>{const Q=F(V);return B[Q]?!1:(B[Q]=!0,!0)}}e.uniqueFilter=l;function n(F,B){const V=s(F,B);if(V!==-1)return F[V]}e.findLast=n;function s(F,B){for(let V=F.length-1;V>=0;V--){const Q=F[V];if(B(Q))return V}return-1}e.lastIndex=s;function i(F,B){return F.length>0?F[0]:B}e.firstOrDefault=i;function t(F,B,V=(Q,Z)=>Q===Z){let Q=0;for(let Z=0,G=Math.min(F.length,B.length);Z<G&&V(F[Z],B[Z]);Z++)Q++;return Q}e.commonPrefixLength=t;function o(F){return[].concat(...F)}e.flatten=o;function a(F,B){let V=typeof B=="number"?F:0;typeof B=="number"?V=F:(V=0,B=F);const Q=[];if(V<=B)for(let Z=V;Z<B;Z++)Q.push(Z);else for(let Z=V;Z>B;Z--)Q.push(Z);return Q}e.range=a;function u(F,B,V){return F.reduce((Q,Z)=>(Q[B(Z)]=V?V(Z):Z,Q),Object.create(null))}e.index=u;function g(F,B){return F.push(B),()=>b(F,B)}e.insert=g;function b(F,B){const V=F.indexOf(B);if(V>-1)return F.splice(V,1),B}e.remove=b;function A(F,B,V){const Q=F.slice(0,B),Z=F.slice(B);return Q.concat(V,Z)}e.arrayInsert=A;function O(F,B){let V;if(typeof B=="number"){let Q=B;V=()=>{const Z=Math.sin(Q++)*179426549;return Z-Math.floor(Z)}}else V=Math.random;for(let Q=F.length-1;Q>0;Q-=1){const Z=Math.floor(V()*(Q+1)),G=F[Q];F[Q]=F[Z],F[Z]=G}}e.shuffle=O;function U(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.unshift(B))}e.pushToStart=U;function x(F,B){const V=F.indexOf(B);V>-1&&(F.splice(V,1),F.push(B))}e.pushToEnd=x;function N(F,B){return Array.isArray(F)?F.map(B):B(F)}e.mapArrayOrNot=N;function L(F){return Array.isArray(F)?F:[F]}e.asArray=L;function $(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=$;function _(F,B){for(const V of F){const Q=B(V);if(Q!==void 0)return Q}}e.mapFind=_;function M(F,B,V){const Q=j(F,B),Z=F.length,G=V.length;F.length=Z+G;for(let H=Z-1;H>=Q;H--)F[H+G]=F[H];for(let H=0;H<G;H++)F[H+Q]=V[H]}e.insertInto=M;function W(F,B,V,Q){const Z=j(F,B),G=F.splice(Z,V);return M(F,Z,Q),G}e.splice=W;function j(F,B){return B<0?Math.max(B+F.length,0):Math.min(B,F.length)}function q(F,B){let V=Number.MAX_SAFE_INTEGER,Q=0;return F.forEach((Z,G)=>{const H=B(Z);H<V&&(V=H,Q=G)}),Q}e.minIndex=q;function z(F,B){let V=Number.MIN_SAFE_INTEGER,Q=0;return F.forEach((Z,G)=>{const H=B(Z);H>V&&(V=H,Q=G)}),Q}e.maxIndex=z;class K{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let V=this.firstIdx;for(;V<this.items.length&&B(this.items[V]);)V++;const Q=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,Q}takeFromEndWhile(B){let V=this.lastIdx;for(;V>=0&&B(this.items[V]);)V--;const Q=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,Q}peek(){return this.items[this.firstIdx]}dequeue(){const B=this.items[this.firstIdx];return this.firstIdx++,B}takeCount(B){const V=this.items.slice(this.firstIdx,this.firstIdx+B);return this.firstIdx+=B,V}}e.ArrayQueue=K}),define(te[69],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function k(T){const D=this;let R=!1,r;return function(){return R||(R=!0,r=T.apply(D,arguments)),r}}e.once=k}),define(te[56],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(T){function D(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}T.is=D;const R=Object.freeze([]);function r(){return R}T.empty=r;function*P(l){yield l}T.single=P;function y(l){return l||R}T.from=y;function C(l){return!l||l[Symbol.iterator]().next().done===!0}T.isEmpty=C;function I(l){return l[Symbol.iterator]().next().value}T.first=I;function w(l,n){for(const s of l)if(n(s))return!0;return!1}T.some=w;function f(l,n){for(const s of l)if(n(s))return s}T.find=f;function*p(l,n){for(const s of l)n(s)&&(yield s)}T.filter=p;function*h(l,n){let s=0;for(const i of l)yield n(i,s++)}T.map=h;function*E(...l){for(const n of l)for(const s of n)yield s}T.concat=E;function*S(l){for(const n of l)for(const s of n)yield s}T.concatNested=S;function m(l,n,s){let i=s;for(const t of l)i=n(i,t);return i}T.reduce=m;function*v(l,n,s=l.length){for(n<0&&(n+=l.length),s<0?s+=l.length:s>l.length&&(s=l.length);n<s;n++)yield l[n]}T.slice=v;function d(l,n=Number.POSITIVE_INFINITY){const s=[];if(n===0)return[s,l];const i=l[Symbol.iterator]();for(let t=0;t<n;t++){const o=i.next();if(o.done)return[s,T.empty()];s.push(o.value)}return[s,{[Symbol.iterator](){return i}}]}T.consume=d;function c(l,n,s=(i,t)=>i===t){const i=l[Symbol.iterator](),t=n[Symbol.iterator]();for(;;){const o=i.next(),a=t.next();if(o.done!==a.done)return!1;if(o.done)return!0;if(!s(o.value,a.value))return!1}}T.equals=c})(k=e.Iterable||(e.Iterable={}))}),define(te[32],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(k=e.ScanError||(e.ScanError={}));var T;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function r(n,s=!1){let i=0,t=n.length,o="",a=0,u=16,g=0;function b($){let _=0,M=0;for(;_<$;){const W=n.charCodeAt(i);if(W>=48&&W<=57)M=M*16+W-48;else if(W>=65&&W<=70)M=M*16+W-65+10;else if(W>=97&&W<=102)M=M*16+W-97+10;else break;i++,_++}return _<$&&(M=-1),M}function A($){i=$,o="",a=0,u=16,g=0}function O(){const $=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&C(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&C(n.charCodeAt(i)))for(i++;i<n.length&&C(n.charCodeAt(i));)i++;else return g=3,n.substring($,i);let _=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&C(n.charCodeAt(i))){for(i++;i<n.length&&C(n.charCodeAt(i));)i++;_=i}else g=3;return n.substring($,_)}function U(){let $="",_=i;for(;;){if(i>=t){$+=n.substring(_,i),g=2;break}const M=n.charCodeAt(i);if(M===34){$+=n.substring(_,i),i++;break}if(M===92){if($+=n.substring(_,i),i++,i>=t){g=2;break}switch(n.charCodeAt(i++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const j=b(4);j>=0?$+=String.fromCharCode(j):g=4;break;default:g=5}_=i;continue}if(M>=0&&M<=31)if(y(M)){$+=n.substring(_,i),g=2;break}else g=6;i++}return $}function x(){if(o="",g=0,a=i,i>=t)return a=t,u=17;let $=n.charCodeAt(i);if(P($)){do i++,o+=String.fromCharCode($),$=n.charCodeAt(i);while(P($));return u=15}if(y($))return i++,o+=String.fromCharCode($),$===13&&n.charCodeAt(i)===10&&(i++,o+=`
`),u=14;switch($){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,o=U(),u=10;case 47:const _=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<t&&!y(n.charCodeAt(i));)i++;return o=n.substring(_,i),u=12}if(n.charCodeAt(i+1)===42){i+=2;const M=t-1;let W=!1;for(;i<M;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,W=!0;break}i++}return W||(i++,g=1),o=n.substring(_,i),u=13}return o+=String.fromCharCode($),i++,u=16;case 45:if(o+=String.fromCharCode($),i++,i===t||!C(n.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),u=11;default:for(;i<t&&N($);)i++,$=n.charCodeAt(i);if(a!==i){switch(o=n.substring(a,i),o){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return o+=String.fromCharCode($),i++,u=16}}function N($){if(P($)||y($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let $;do $=x();while($>=12&&$<=15);return $}return{setPosition:A,getPosition:()=>i,scan:s?L:x,getToken:()=>u,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>g}}e.createScanner=r;function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function y(n){return n===10||n===13||n===8232||n===8233}function C(n){return n>=48&&n<=57}var I;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(I||(I={}));function w(n,s){const i=[],t=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function g(b,A,O,U){a.value=b,a.offset=A,a.length=O,a.type=U,a.colonOffset=void 0,o=a}try{d(n,{onObjectBegin:(b,A)=>{if(s<=b)throw t;o=void 0,u=s>b,i.push("")},onObjectProperty:(b,A,O)=>{if(s<A||(g(b,A,O,"property"),i[i.length-1]=b,s<=A+O))throw t},onObjectEnd:(b,A)=>{if(s<=b)throw t;o=void 0,i.pop()},onArrayBegin:(b,A)=>{if(s<=b)throw t;o=void 0,i.push(0)},onArrayEnd:(b,A)=>{if(s<=b)throw t;o=void 0,i.pop()},onLiteralValue:(b,A,O)=>{if(s<A||(g(b,A,O,l(b)),s<=A+O))throw t},onSeparator:(b,A,O)=>{if(s<=A)throw t;if(b===":"&&o&&o.type==="property")o.colonOffset=A,u=!1,o=void 0;else if(b===","){const U=i[i.length-1];typeof U=="number"?i[i.length-1]=U+1:(u=!0,i[i.length-1]=""),o=void 0}}})}catch(b){if(b!==t)throw b}return{path:i,previousNode:o,isAtPropertyKey:u,matches:b=>{let A=0;for(let O=0;A<b.length&&O<i.length;O++)if(b[A]===i[O]||b[A]==="*")A++;else if(b[A]!=="**")return!1;return A===b.length}}}e.getLocation=w;function f(n,s=[],i=R.DEFAULT){let t=null,o=[];const a=[];function u(b){Array.isArray(o)?o.push(b):t!==null&&(o[t]=b)}return d(n,{onObjectBegin:()=>{const b={};u(b),a.push(o),o=b,t=null},onObjectProperty:b=>{t=b},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const b=[];u(b),a.push(o),o=b,t=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:u,onError:(b,A,O)=>{s.push({error:b,offset:A,length:O})}},i),o[0]}e.parse=f;function p(n,s=[],i=R.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(b){t.type==="property"&&(t.length=b-t.offset,t=t.parent)}function a(b){return t.children.push(b),b}d(n,{onObjectBegin:b=>{t=a({type:"object",offset:b,length:-1,parent:t,children:[]})},onObjectProperty:(b,A,O)=>{t=a({type:"property",offset:A,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:b,offset:A,length:O,parent:t})},onObjectEnd:(b,A)=>{t.length=b+A-t.offset,t=t.parent,o(b+A)},onArrayBegin:(b,A)=>{t=a({type:"array",offset:b,length:-1,parent:t,children:[]})},onArrayEnd:(b,A)=>{t.length=b+A-t.offset,t=t.parent,o(b+A)},onLiteralValue:(b,A,O)=>{a({type:l(b),offset:A,length:O,parent:t,value:b}),o(A+O)},onSeparator:(b,A,O)=>{t.type==="property"&&(b===":"?t.colonOffset=A:b===","&&o(A))},onError:(b,A,O)=>{s.push({error:b,offset:A,length:O})}},i);const g=t.children[0];return g&&delete g.parent,g}e.parseTree=p;function h(n,s){if(!n)return;let i=n;for(let t of s)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===t){i=a.children[1],o=!0;break}if(!o)return}else{const o=t;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=h;function E(n){if(!n.parent||!n.parent.children)return[];const s=E(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;s.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&s.push(i)}return s}e.getNodePath=E;function S(n){switch(n.type){case"array":return n.children.map(S);case"object":const s=Object.create(null);for(let i of n.children){const t=i.children[1];t&&(s[i.children[0].value]=S(t))}return s;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=S;function m(n,s,i=!1){return s>=n.offset&&s<n.offset+n.length||i&&s===n.offset+n.length}e.contains=m;function v(n,s,i=!1){if(m(n,s,i)){const t=n.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=s;o++){const a=v(t[o],s,i);if(a)return a}return n}}e.findNodeAtOffset=v;function d(n,s,i=R.DEFAULT){const t=r(n,!1);function o(V){return V?()=>V(t.getTokenOffset(),t.getTokenLength()):()=>!0}function a(V){return V?Q=>V(Q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=o(s.onObjectBegin),g=a(s.onObjectProperty),b=o(s.onObjectEnd),A=o(s.onArrayBegin),O=o(s.onArrayEnd),U=a(s.onLiteralValue),x=a(s.onSeparator),N=o(s.onComment),L=a(s.onError),$=i&&i.disallowComments,_=i&&i.allowTrailingComma;function M(){for(;;){const V=t.scan();switch(t.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:$||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(V){case 12:case 13:$?W(10):N();break;case 16:W(1);break;case 15:case 14:break;default:return V}}}function W(V,Q=[],Z=[]){if(L(V),Q.length+Z.length>0){let G=t.getToken();for(;G!==17;){if(Q.indexOf(G)!==-1){M();break}else if(Z.indexOf(G)!==-1)break;G=M()}}}function j(V){const Q=t.getTokenValue();return V?U(Q):g(Q),M(),!0}function q(){switch(t.getToken()){case 11:let V=0;try{V=JSON.parse(t.getTokenValue()),typeof V!="number"&&(W(2),V=0)}catch(Q){W(2)}U(V);break;case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return M(),!0}function z(){return t.getToken()!==10?(W(3,[],[2,5]),!1):(j(!1),t.getToken()===6?(x(":"),M(),B()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function K(){u(),M();let V=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(V||W(4,[],[]),x(","),M(),t.getToken()===2&&_)break}else V&&W(6,[],[]);z()||W(4,[],[2,5]),V=!0}return b(),t.getToken()!==2?W(7,[2],[]):M(),!0}function F(){A(),M();let V=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(V||W(4,[],[]),x(","),M(),t.getToken()===4&&_)break}else V&&W(6,[],[]);B()||W(4,[],[4,5]),V=!0}return O(),t.getToken()!==4?W(8,[4],[]):M(),!0}function B(){switch(t.getToken()){case 3:return F();case 1:return K();case 10:return j(!0);default:return q()}}return M(),t.getToken()===17?i.allowEmptyContent?!0:(W(4,[],[]),!1):B()?(t.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=d;function c(n,s){let i=r(n),t=[],o,a=0,u;do switch(u=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:a!==u&&t.push(n.substring(a,u)),s!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,s)),a=i.getPosition();break}while(o!==17);return t.join("")}e.stripComments=c;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(te[48],ne([0,1,32]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function T(y,C,I){let w,f,p,h,E;if(C){for(h=C.offset,E=h+C.length,p=h;p>0&&!P(y,p-1);)p--;let a=E;for(;a<y.length&&!P(y,a);)a++;f=y.substring(p,a),w=R(f,I)}else f=y,w=0,p=0,h=0,E=y.length;const S=r(I,y);let m=!1,v=0,d;I.insertSpaces?d=D(" ",I.tabSize||4):d="	";const c=(0,k.createScanner)(f,!1);let l=!1;function n(){return S+D(d,w+v)}function s(){let a=c.scan();for(m=!1;a===15||a===14;)m=m||a===14,a=c.scan();return l=a===16||c.getTokenError()!==0,a}const i=[];function t(a,u,g){!l&&u<E&&g>h&&y.substring(u,g)!==a&&i.push({offset:u,length:g-u,content:a})}let o=s();if(o!==17){const a=c.getTokenOffset()+p,u=D(d,w);t(u,p,a)}for(;o!==17;){let a=c.getTokenOffset()+c.getTokenLength()+p,u=s(),g="";for(;!m&&(u===12||u===13);){const A=c.getTokenOffset()+p;t(" ",a,A),a=c.getTokenOffset()+c.getTokenLength()+p,g=u===12?n():"",u=s()}if(u===2)o!==1&&(v--,g=n());else if(u===4)o!==3&&(v--,g=n());else{switch(o){case 3:case 1:v++,g=n();break;case 5:case 12:g=n();break;case 13:m?g=n():g=" ";break;case 6:g=" ";break;case 10:if(u===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?g=" ":u!==5&&u!==17&&(l=!0);break;case 16:l=!0;break}m&&(u===12||u===13)&&(g=n())}const b=c.getTokenOffset()+p;t(g,a,b),o=u}return i}e.format=T;function D(y,C){let I="";for(let w=0;w<C;w++)I+=y;return I}function R(y,C){let I=0,w=0;const f=C.tabSize||4;for(;I<y.length;){const p=y.charAt(I);if(p===" ")w++;else if(p==="	")w+=f;else break;I++}return Math.floor(w/f)}function r(y,C){for(let I=0;I<C.length;I++){const w=C.charAt(I);if(w==="\r")return I+1<C.length&&C.charAt(I+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=r;function P(y,C){return`\r
`.indexOf(y.charAt(C))!==-1}e.isEOL=P}),define(te[40],ne([0,1,32,48]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(C,I,w){return R(C,I,void 0,w)}e.removeProperty=D;function R(C,I,w,f,p){const h=I.slice(),E=[],S=(0,k.parseTree)(C,E);let m,v;for(;h.length>0&&(v=h.pop(),m=(0,k.findNodeAtLocation)(S,h),m===void 0&&w!==void 0);)typeof v=="string"?w={[v]:w}:w=[w];if(m)if(m.type==="object"&&typeof v=="string"&&Array.isArray(m.children)){const d=(0,k.findNodeAtLocation)(m,[v]);if(d!==void 0)if(w===void 0){if(!d.parent)throw new Error("Malformed AST");const c=m.children.indexOf(d.parent);let l,n=d.parent.offset+d.parent.length;if(c>0){const s=m.children[c-1];l=s.offset+s.length}else l=m.offset+1,m.children.length>1&&(n=m.children[1].offset);return r(C,{offset:l,length:n-l,content:""},f)}else return r(C,{offset:d.offset,length:d.length,content:JSON.stringify(w)},f);else{if(w===void 0)return[];const c=`${JSON.stringify(v)}: ${JSON.stringify(w)}`,l=p?p(m.children.map(s=>s.children[0].value)):m.children.length;let n;if(l>0){const s=m.children[l-1];n={offset:s.offset+s.length,length:0,content:","+c}}else m.children.length===0?n={offset:m.offset+1,length:0,content:c}:n={offset:m.offset+1,length:0,content:c+","};return r(C,n,f)}}else if(m.type==="array"&&typeof v=="number"&&Array.isArray(m.children))if(w!==void 0){const d=`${JSON.stringify(w)}`;let c;if(m.children.length===0||v===0)c={offset:m.offset+1,length:0,content:m.children.length===0?d:d+","};else{const l=v===-1||v>m.children.length?m.children.length:v,n=m.children[l-1];c={offset:n.offset+n.length,length:0,content:","+d}}return r(C,c,f)}else{const d=v,c=m.children[d];let l;if(m.children.length===1)l={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===d){const n=m.children[d-1],s=n.offset+n.length,i=m.offset+m.length;l={offset:s,length:i-2-s,content:""}}else l={offset:c.offset,length:m.children[d+1].offset-c.offset,content:""};return r(C,l,f)}else throw new Error(`Can not add ${typeof v!="number"?"index":"property"} to parent of type ${m.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return r(C,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(w)},f)}}e.setProperty=R;function r(C,I,w){let f=P(C,I),p=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;p>0&&!(0,T.isEOL)(f,p-1);)p--;for(;h<f.length&&!(0,T.isEOL)(f,h);)h++}const E=(0,T.format)(f,{offset:p,length:h-p},w);for(let m=E.length-1;m>=0;m--){const v=E[m];f=P(f,v),p=Math.min(p,v.offset),h=Math.max(h,v.offset+v.length),h+=v.content.length-v.length}const S=C.length-(f.length-h)-p;return[{offset:p,length:S,content:f.substring(p,h)}]}e.withFormatting=r;function P(C,I){return C.substring(0,I.offset)+I.content+C.substring(I.offset+I.length)}e.applyEdit=P;function y(C,I){let w=I.slice(0).sort((p,h)=>{const E=p.offset-h.offset;return E===0?p.length-h.length:E}),f=C.length;for(let p=w.length-1;p>=0;p--){let h=w[p];if(h.offset+h.length<=f)C=P(C,h);else throw new Error("Overlapping edit");f=h.offset}return C}e.applyEdits=y}),define(te[2],ne([0,1,69,56]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let R=null;function r(t){R=t}if(e.setDisposableTracker=r,D){const t="__is_disposable_tracked__";r(new class{trackDisposable(o){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[t]||console.log(a)},3e3)}setParent(o,a){if(o&&o!==v.None)try{o[t]=!0}catch{}}markAsDisposed(o){if(o&&o!==v.None)try{o[t]=!0}catch{}}markAsSingleton(o){}})}function P(t){return R?.trackDisposable(t),t}function y(t){R?.markAsDisposed(t)}function C(t,o){R?.setParent(t,o)}function I(t,o){if(!!R)for(const a of t)R.setParent(a,o)}function w(t){return R?.markAsSingleton(t),t}e.markAsSingleton=w;class f extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=f;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function h(t){if(T.Iterable.is(t)){let o=[];for(const a of t)if(a)try{a.dispose()}catch(u){o.push(u)}if(o.length===1)throw o[0];if(o.length>1)throw new f(o);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function E(...t){const o=S(()=>h(t));return I(t,o),o}e.combinedDisposable=E;function S(t){const o=P({dispose:(0,k.once)(()=>{y(o),t()})});return o}e.toDisposable=S;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,P(this)}dispose(){this._isDisposed||(y(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return C(o,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class v{constructor(){this._store=new m,P(this),C(this._store,this)}dispose(){y(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=v,v.None=Object.freeze({dispose(){}});class d{constructor(){this._isDisposed=!1,P(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&C(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,y(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&C(o,null),o}}e.MutableDisposable=d;class c{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class l{constructor(){this.references=new Map}acquire(o,...a){let u=this.references.get(o);u||(u={counter:0,object:this.createReferencedObject(o,...a)},this.references.set(o,u));const{object:g}=u,b=(0,k.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(o,u.object),this.references.delete(o))});return u.counter++,{object:g,dispose:b}}}e.ReferenceCollection=l;class n{constructor(o){this.referenceCollection=o}async acquire(o,...a){const u=this.referenceCollection.acquire(o,...a);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(g){throw u.dispose(),g}}}e.AsyncReferenceCollection=n;class s{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=s;function i(t){const o=new m;try{t(o)}finally{o.dispose()}}e.disposeOnReturn=i}),define(te[103],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class k{constructor(R){this.element=R,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class T{constructor(){this._first=k.Undefined,this._last=k.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===k.Undefined}clear(){let R=this._first;for(;R!==k.Undefined;){const r=R.next;R.prev=k.Undefined,R.next=k.Undefined,R=r}this._first=k.Undefined,this._last=k.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,r){const P=new k(R);if(this._first===k.Undefined)this._first=P,this._last=P;else if(r){const C=this._last;this._last=P,P.prev=C,C.next=P}else{const C=this._first;this._first=P,P.next=C,C.prev=P}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(P))}}shift(){if(this._first!==k.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==k.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==k.Undefined&&R.next!==k.Undefined){const r=R.prev;r.next=R.next,R.next.prev=r}else R.prev===k.Undefined&&R.next===k.Undefined?(this._first=k.Undefined,this._last=k.Undefined):R.next===k.Undefined?(this._last=this._last.prev,this._last.next=k.Undefined):R.prev===k.Undefined&&(this._first=this._first.next,this._first.prev=k.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==k.Undefined;)yield R.element,R=R.next}}e.LinkedList=T}),function(){function X(D){const R=[];typeof D=="number"&&R.push("code/timeOrigin",D);function r(y){R.push(y,Date.now())}function P(){const y=[];for(let C=0;C<R.length;C+=2)y.push({name:R[C],startTime:R[C+1]});return y}return{mark:r,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const r of performance.getEntriesByType("mark"))R.push({name:r.name,startTime:Math.round(D+r.startTime)});return R}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function k(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=k(T))}(),define(te[4],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const k="en";let T=!1,D=!1,R=!1,r=!1,P=!1,y=!1,C=!1,I,w=k,f,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const E=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=E&&h?.sandboxed,typeof navigator=="object"&&!E)p=navigator.userAgent,T=p.indexOf("Windows")>=0,D=p.indexOf("Macintosh")>=0,C=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=p.indexOf("Linux")>=0,y=!0,I=navigator.language,w=I;else if(typeof h=="object"){T=h.platform==="win32",D=h.platform==="darwin",R=h.platform==="linux",r=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,I=k,w=k;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const t=JSON.parse(i),o=t.availableLanguages["*"];I=t.locale,w=o||k,f=t._translationsConfigFile}catch(t){}P=!0}else console.error("Unable to resolve platform.");var S;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function m(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let v=0;D?v=1:T?v=3:R&&(v=2),e.isWindows=T,e.isMacintosh=D,e.isLinux=R,e.isLinuxSnap=r,e.isNative=P,e.isWeb=y,e.isIOS=C,e.platform=v,e.userAgent=p,e.language=w;var d;(function(i){function t(){return e.language}i.value=t;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=o;function a(){return e.language==="en"}i.isDefault=a})(d=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=f,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let g=0,b=o.length;g<b;g++){const A=o[g];if(A.id===u.data.vscodeSetImmediateId){o.splice(g,1),A.callback();return}}});let a=0;return u=>{const g=++a;o.push({id:g,callback:u}),e.globals.postMessage({vscodeSetImmediateId:g},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const t=Promise.resolve();return o=>t.then(o)}();var c;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||C?2:T?1:3;let l=!0,n=!1;function s(){if(!n){n=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,l=new Uint16Array(i.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.process!="undefined"){const D=k.globals.vscode.process;T={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(R){return(0,k.setImmediate)(R)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:T={get platform(){return k.isWindows?"win32":k.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,k.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick,e.arch=T.arch}),define(te[9],ne([0,1,31]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,D=97,R=90,r=122,P=46,y=47,C=92,I=58,w=63;class f extends Error{constructor(c,l,n){let s;typeof l=="string"&&l.indexOf("not ")===0?(s="must not be",l=l.replace(/^not /,"")):s="must be";const i=c.indexOf(".")!==-1?"property":"argument";let t=`The "${c}" ${i} ${s} of type ${l}`;t+=`. Received type ${typeof n}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function p(d,c){if(typeof d!="string")throw new f(c,"string",d)}function h(d){return d===y||d===C}function E(d){return d===y}function S(d){return d>=T&&d<=R||d>=D&&d<=r}function m(d,c,l,n){let s="",i=0,t=-1,o=0,a=0;for(let u=0;u<=d.length;++u){if(u<d.length)a=d.charCodeAt(u);else{if(n(a))break;a=y}if(n(a)){if(!(t===u-1||o===1))if(o===2){if(s.length<2||i!==2||s.charCodeAt(s.length-1)!==P||s.charCodeAt(s.length-2)!==P){if(s.length>2){const g=s.lastIndexOf(l);g===-1?(s="",i=0):(s=s.slice(0,g),i=s.length-1-s.lastIndexOf(l)),t=u,o=0;continue}else if(s.length!==0){s="",i=0,t=u,o=0;continue}}c&&(s+=s.length>0?`${l}..`:"..",i=2)}else s.length>0?s+=`${l}${d.slice(t+1,u)}`:s=d.slice(t+1,u),i=u-t-1;t=u,o=0}else a===P&&o!==-1?++o:o=-1}return s}function v(d,c){if(c===null||typeof c!="object")throw new f("pathObject","Object",c);const l=c.dir||c.root,n=c.base||`${c.name||""}${c.ext||""}`;return l?l===c.root?`${l}${n}`:`${l}${d}${n}`:n}e.win32={resolve(...d){let c="",l="",n=!1;for(let s=d.length-1;s>=-1;s--){let i;if(s>=0){if(i=d[s],p(i,"path"),i.length===0)continue}else c.length===0?i=k.cwd():(i=k.env[`=${c}`]||k.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==c.toLowerCase()&&i.charCodeAt(2)===C)&&(i=`${c}\\`));const t=i.length;let o=0,a="",u=!1;const g=i.charCodeAt(0);if(t===1)h(g)&&(o=1,u=!0);else if(h(g))if(u=!0,h(i.charCodeAt(1))){let b=2,A=b;for(;b<t&&!h(i.charCodeAt(b));)b++;if(b<t&&b!==A){const O=i.slice(A,b);for(A=b;b<t&&h(i.charCodeAt(b));)b++;if(b<t&&b!==A){for(A=b;b<t&&!h(i.charCodeAt(b));)b++;(b===t||b!==A)&&(a=`\\\\${O}\\${i.slice(A,b)}`,o=b)}}}else o=1;else S(g)&&i.charCodeAt(1)===I&&(a=i.slice(0,2),o=2,t>2&&h(i.charCodeAt(2))&&(u=!0,o=3));if(a.length>0)if(c.length>0){if(a.toLowerCase()!==c.toLowerCase())continue}else c=a;if(n){if(c.length>0)break}else if(l=`${i.slice(o)}\\${l}`,n=u,u&&c.length>0)break}return l=m(l,!n,"\\",h),n?`${c}\\${l}`:`${c}${l}`||"."},normalize(d){p(d,"path");const c=d.length;if(c===0)return".";let l=0,n,s=!1;const i=d.charCodeAt(0);if(c===1)return E(i)?"\\":d;if(h(i))if(s=!0,h(d.charCodeAt(1))){let o=2,a=o;for(;o<c&&!h(d.charCodeAt(o));)o++;if(o<c&&o!==a){const u=d.slice(a,o);for(a=o;o<c&&h(d.charCodeAt(o));)o++;if(o<c&&o!==a){for(a=o;o<c&&!h(d.charCodeAt(o));)o++;if(o===c)return`\\\\${u}\\${d.slice(a)}\\`;o!==a&&(n=`\\\\${u}\\${d.slice(a,o)}`,l=o)}}}else l=1;else S(i)&&d.charCodeAt(1)===I&&(n=d.slice(0,2),l=2,c>2&&h(d.charCodeAt(2))&&(s=!0,l=3));let t=l<c?m(d.slice(l),!s,"\\",h):"";return t.length===0&&!s&&(t="."),t.length>0&&h(d.charCodeAt(c-1))&&(t+="\\"),n===void 0?s?`\\${t}`:t:s?`${n}\\${t}`:`${n}${t}`},isAbsolute(d){p(d,"path");const c=d.length;if(c===0)return!1;const l=d.charCodeAt(0);return h(l)||c>2&&S(l)&&d.charCodeAt(1)===I&&h(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let c,l;for(let i=0;i<d.length;++i){const t=d[i];p(t,"path"),t.length>0&&(c===void 0?c=l=t:c+=`\\${t}`)}if(c===void 0)return".";let n=!0,s=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++s;const i=l.length;i>1&&h(l.charCodeAt(1))&&(++s,i>2&&(h(l.charCodeAt(2))?++s:n=!1))}if(n){for(;s<c.length&&h(c.charCodeAt(s));)s++;s>=2&&(c=`\\${c.slice(s)}`)}return e.win32.normalize(c)},relative(d,c){if(p(d,"from"),p(c,"to"),d===c)return"";const l=e.win32.resolve(d),n=e.win32.resolve(c);if(l===n||(d=l.toLowerCase(),c=n.toLowerCase(),d===c))return"";let s=0;for(;s<d.length&&d.charCodeAt(s)===C;)s++;let i=d.length;for(;i-1>s&&d.charCodeAt(i-1)===C;)i--;const t=i-s;let o=0;for(;o<c.length&&c.charCodeAt(o)===C;)o++;let a=c.length;for(;a-1>o&&c.charCodeAt(a-1)===C;)a--;const u=a-o,g=t<u?t:u;let b=-1,A=0;for(;A<g;A++){const U=d.charCodeAt(s+A);if(U!==c.charCodeAt(o+A))break;U===C&&(b=A)}if(A!==g){if(b===-1)return n}else{if(u>g){if(c.charCodeAt(o+A)===C)return n.slice(o+A+1);if(A===2)return n.slice(o+A)}t>g&&(d.charCodeAt(s+A)===C?b=A:A===2&&(b=3)),b===-1&&(b=0)}let O="";for(A=s+b+1;A<=i;++A)(A===i||d.charCodeAt(A)===C)&&(O+=O.length===0?"..":"\\..");return o+=b,O.length>0?`${O}${n.slice(o,a)}`:(n.charCodeAt(o)===C&&++o,n.slice(o,a))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const c=e.win32.resolve(d);if(c.length<=2)return d;if(c.charCodeAt(0)===C){if(c.charCodeAt(1)===C){const l=c.charCodeAt(2);if(l!==w&&l!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(S(c.charCodeAt(0))&&c.charCodeAt(1)===I&&c.charCodeAt(2)===C)return`\\\\?\\${c}`;return d},dirname(d){p(d,"path");const c=d.length;if(c===0)return".";let l=-1,n=0;const s=d.charCodeAt(0);if(c===1)return h(s)?d:".";if(h(s)){if(l=n=1,h(d.charCodeAt(1))){let o=2,a=o;for(;o<c&&!h(d.charCodeAt(o));)o++;if(o<c&&o!==a){for(a=o;o<c&&h(d.charCodeAt(o));)o++;if(o<c&&o!==a){for(a=o;o<c&&!h(d.charCodeAt(o));)o++;if(o===c)return d;o!==a&&(l=n=o+1)}}}}else S(s)&&d.charCodeAt(1)===I&&(l=c>2&&h(d.charCodeAt(2))?3:2,n=l);let i=-1,t=!0;for(let o=c-1;o>=n;--o)if(h(d.charCodeAt(o))){if(!t){i=o;break}}else t=!1;if(i===-1){if(l===-1)return".";i=l}return d.slice(0,i)},basename(d,c){c!==void 0&&p(c,"ext"),p(d,"path");let l=0,n=-1,s=!0,i;if(d.length>=2&&S(d.charCodeAt(0))&&d.charCodeAt(1)===I&&(l=2),c!==void 0&&c.length>0&&c.length<=d.length){if(c===d)return"";let t=c.length-1,o=-1;for(i=d.length-1;i>=l;--i){const a=d.charCodeAt(i);if(h(a)){if(!s){l=i+1;break}}else o===-1&&(s=!1,o=i+1),t>=0&&(a===c.charCodeAt(t)?--t==-1&&(n=i):(t=-1,n=o))}return l===n?n=o:n===-1&&(n=d.length),d.slice(l,n)}for(i=d.length-1;i>=l;--i)if(h(d.charCodeAt(i))){if(!s){l=i+1;break}}else n===-1&&(s=!1,n=i+1);return n===-1?"":d.slice(l,n)},extname(d){p(d,"path");let c=0,l=-1,n=0,s=-1,i=!0,t=0;d.length>=2&&d.charCodeAt(1)===I&&S(d.charCodeAt(0))&&(c=n=2);for(let o=d.length-1;o>=c;--o){const a=d.charCodeAt(o);if(h(a)){if(!i){n=o+1;break}continue}s===-1&&(i=!1,s=o+1),a===P?l===-1?l=o:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||s===-1||t===0||t===1&&l===s-1&&l===n+1?"":d.slice(l,s)},format:v.bind(null,"\\"),parse(d){p(d,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return c;const l=d.length;let n=0,s=d.charCodeAt(0);if(l===1)return h(s)?(c.root=c.dir=d,c):(c.base=c.name=d,c);if(h(s)){if(n=1,h(d.charCodeAt(1))){let b=2,A=b;for(;b<l&&!h(d.charCodeAt(b));)b++;if(b<l&&b!==A){for(A=b;b<l&&h(d.charCodeAt(b));)b++;if(b<l&&b!==A){for(A=b;b<l&&!h(d.charCodeAt(b));)b++;b===l?n=b:b!==A&&(n=b+1)}}}}else if(S(s)&&d.charCodeAt(1)===I){if(l<=2)return c.root=c.dir=d,c;if(n=2,h(d.charCodeAt(2))){if(l===3)return c.root=c.dir=d,c;n=3}}n>0&&(c.root=d.slice(0,n));let i=-1,t=n,o=-1,a=!0,u=d.length-1,g=0;for(;u>=n;--u){if(s=d.charCodeAt(u),h(s)){if(!a){t=u+1;break}continue}o===-1&&(a=!1,o=u+1),s===P?i===-1?i=u:g!==1&&(g=1):i!==-1&&(g=-1)}return o!==-1&&(i===-1||g===0||g===1&&i===o-1&&i===t+1?c.base=c.name=d.slice(t,o):(c.name=d.slice(t,i),c.base=d.slice(t,o),c.ext=d.slice(i,o))),t>0&&t!==n?c.dir=d.slice(0,t-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let c="",l=!1;for(let n=d.length-1;n>=-1&&!l;n--){const s=n>=0?d[n]:k.cwd();p(s,"path"),s.length!==0&&(c=`${s}/${c}`,l=s.charCodeAt(0)===y)}return c=m(c,!l,"/",E),l?`/${c}`:c.length>0?c:"."},normalize(d){if(p(d,"path"),d.length===0)return".";const c=d.charCodeAt(0)===y,l=d.charCodeAt(d.length-1)===y;return d=m(d,!c,"/",E),d.length===0?c?"/":l?"./":".":(l&&(d+="/"),c?`/${d}`:d)},isAbsolute(d){return p(d,"path"),d.length>0&&d.charCodeAt(0)===y},join(...d){if(d.length===0)return".";let c;for(let l=0;l<d.length;++l){const n=d[l];p(n,"path"),n.length>0&&(c===void 0?c=n:c+=`/${n}`)}return c===void 0?".":e.posix.normalize(c)},relative(d,c){if(p(d,"from"),p(c,"to"),d===c||(d=e.posix.resolve(d),c=e.posix.resolve(c),d===c))return"";const l=1,n=d.length,s=n-l,i=1,t=c.length-i,o=s<t?s:t;let a=-1,u=0;for(;u<o;u++){const b=d.charCodeAt(l+u);if(b!==c.charCodeAt(i+u))break;b===y&&(a=u)}if(u===o)if(t>o){if(c.charCodeAt(i+u)===y)return c.slice(i+u+1);if(u===0)return c.slice(i+u)}else s>o&&(d.charCodeAt(l+u)===y?a=u:u===0&&(a=0));let g="";for(u=l+a+1;u<=n;++u)(u===n||d.charCodeAt(u)===y)&&(g+=g.length===0?"..":"/..");return`${g}${c.slice(i+a)}`},toNamespacedPath(d){return d},dirname(d){if(p(d,"path"),d.length===0)return".";const c=d.charCodeAt(0)===y;let l=-1,n=!0;for(let s=d.length-1;s>=1;--s)if(d.charCodeAt(s)===y){if(!n){l=s;break}}else n=!1;return l===-1?c?"/":".":c&&l===1?"//":d.slice(0,l)},basename(d,c){c!==void 0&&p(c,"ext"),p(d,"path");let l=0,n=-1,s=!0,i;if(c!==void 0&&c.length>0&&c.length<=d.length){if(c===d)return"";let t=c.length-1,o=-1;for(i=d.length-1;i>=0;--i){const a=d.charCodeAt(i);if(a===y){if(!s){l=i+1;break}}else o===-1&&(s=!1,o=i+1),t>=0&&(a===c.charCodeAt(t)?--t==-1&&(n=i):(t=-1,n=o))}return l===n?n=o:n===-1&&(n=d.length),d.slice(l,n)}for(i=d.length-1;i>=0;--i)if(d.charCodeAt(i)===y){if(!s){l=i+1;break}}else n===-1&&(s=!1,n=i+1);return n===-1?"":d.slice(l,n)},extname(d){p(d,"path");let c=-1,l=0,n=-1,s=!0,i=0;for(let t=d.length-1;t>=0;--t){const o=d.charCodeAt(t);if(o===y){if(!s){l=t+1;break}continue}n===-1&&(s=!1,n=t+1),o===P?c===-1?c=t:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||n===-1||i===0||i===1&&c===n-1&&c===l+1?"":d.slice(c,n)},format:v.bind(null,"/"),parse(d){p(d,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return c;const l=d.charCodeAt(0)===y;let n;l?(c.root="/",n=1):n=0;let s=-1,i=0,t=-1,o=!0,a=d.length-1,u=0;for(;a>=n;--a){const g=d.charCodeAt(a);if(g===y){if(!o){i=a+1;break}continue}t===-1&&(o=!1,t=a+1),g===P?s===-1?s=a:u!==1&&(u=1):s!==-1&&(u=-1)}if(t!==-1){const g=i===0&&l?1:i;s===-1||u===0||u===1&&s===t-1&&s===i+1?c.base=c.name=d.slice(g,t):(c.name=d.slice(g,s),c.base=d.slice(g,t),c.ext=d.slice(s,t))}return i>0?c.dir=d.slice(0,i-1):l&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=k.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=k.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=k.platform==="win32"?e.win32.join:e.posix.join,e.resolve=k.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=k.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=k.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=k.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=k.platform==="win32"?e.win32.extname:e.posix.extname,e.format=k.platform==="win32"?e.win32.format:e.posix.format,e.parse=k.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=k.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=k.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=k.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[104],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var T;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(T=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(R,...r){const P=r.reduce((I,w)=>(I[w]=!0,I),{}),y=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(I=>!P[I]).forEach(I=>{for(let w=0;w<y.length;w++)if(I.search(y[w])!==-1){delete R[I];break}})}e.sanitizeProcessEnvironment=D}),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var T in k)(typeof exports=="object"?exports:X)[T]=k[T]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function k(T){if(e[T])return e[T].exports;var D=e[T]={i:T,l:!1,exports:{}};return X[T].call(D.exports,D,D.exports,k),D.l=!0,D.exports}return k.m=X,k.c=e,k.d=function(T,D,R){k.o(T,D)||Object.defineProperty(T,D,{enumerable:!0,get:R})},k.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},k.t=function(T,D){if(1&D&&(T=k(T)),8&D||4&D&&typeof T=="object"&&T&&T.__esModule)return T;var R=Object.create(null);if(k.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:T}),2&D&&typeof T!="string")for(var r in T)k.d(R,r,function(P){return T[P]}.bind(null,r));return R},k.n=function(T){var D=T&&T.__esModule?function(){return T.default}:function(){return T};return k.d(D,"a",D),D},k.o=function(T,D){return Object.prototype.hasOwnProperty.call(T,D)},k.p="",k(k.s=0)}([function(X,e,k){(function(T){var D;e=X.exports=Z,D=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,r=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],y=e.src=[],C=0,I=C++;y[I]="0|[1-9]\\d*";var w=C++;y[w]="[0-9]+";var f=C++;y[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=C++;y[p]="("+y[I]+")\\.("+y[I]+")\\.("+y[I]+")";var h=C++;y[h]="("+y[w]+")\\.("+y[w]+")\\.("+y[w]+")";var E=C++;y[E]="(?:"+y[I]+"|"+y[f]+")";var S=C++;y[S]="(?:"+y[w]+"|"+y[f]+")";var m=C++;y[m]="(?:-("+y[E]+"(?:\\."+y[E]+")*))";var v=C++;y[v]="(?:-?("+y[S]+"(?:\\."+y[S]+")*))";var d=C++;y[d]="[0-9A-Za-z-]+";var c=C++;y[c]="(?:\\+("+y[d]+"(?:\\."+y[d]+")*))";var l=C++,n="v?"+y[p]+y[m]+"?"+y[c]+"?";y[l]="^"+n+"$";var s="[v=\\s]*"+y[h]+y[v]+"?"+y[c]+"?",i=C++;y[i]="^"+s+"$";var t=C++;y[t]="((?:<|>)?=?)";var o=C++;y[o]=y[w]+"|x|X|\\*";var a=C++;y[a]=y[I]+"|x|X|\\*";var u=C++;y[u]="[v=\\s]*("+y[a]+")(?:\\.("+y[a]+")(?:\\.("+y[a]+")(?:"+y[m]+")?"+y[c]+"?)?)?";var g=C++;y[g]="[v=\\s]*("+y[o]+")(?:\\.("+y[o]+")(?:\\.("+y[o]+")(?:"+y[v]+")?"+y[c]+"?)?)?";var b=C++;y[b]="^"+y[t]+"\\s*"+y[u]+"$";var A=C++;y[A]="^"+y[t]+"\\s*"+y[g]+"$";var O=C++;y[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=C++;y[U]="(?:~>?)";var x=C++;y[x]="(\\s*)"+y[U]+"\\s+",P[x]=new RegExp(y[x],"g");var N=C++;y[N]="^"+y[U]+y[u]+"$";var L=C++;y[L]="^"+y[U]+y[g]+"$";var $=C++;y[$]="(?:\\^)";var _=C++;y[_]="(\\s*)"+y[$]+"\\s+",P[_]=new RegExp(y[_],"g");var M=C++;y[M]="^"+y[$]+y[u]+"$";var W=C++;y[W]="^"+y[$]+y[g]+"$";var j=C++;y[j]="^"+y[t]+"\\s*("+s+")$|^$";var q=C++;y[q]="^"+y[t]+"\\s*("+n+")$|^$";var z=C++;y[z]="(\\s*)"+y[t]+"\\s*("+s+"|"+y[u]+")",P[z]=new RegExp(y[z],"g");var K=C++;y[K]="^\\s*("+y[u]+")\\s+-\\s+("+y[u]+")\\s*$";var F=C++;y[F]="^\\s*("+y[g]+")\\s+-\\s+("+y[g]+")\\s*$";var B=C++;y[B]="(<|>)?=?\\s*\\*";for(var V=0;V<35;V++)D(V,y[V]),P[V]||(P[V]=new RegExp(y[V]));function Q(ee,oe){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>R||!(oe?P[i]:P[l]).test(ee))return null;try{return new Z(ee,oe)}catch(ae){return null}}function Z(ee,oe){if(ee instanceof Z){if(ee.loose===oe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Z))return new Z(ee,oe);D("SemVer",ee,oe),this.loose=oe;var ae=ee.trim().match(oe?P[i]:P[l]);if(!ae)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>r||this.major<0)throw new TypeError("Invalid major version");if(this.minor>r||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>r||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(pe){if(/^[0-9]+$/.test(pe)){var ye=+pe;if(ye>=0&&ye<r)return ye}return pe}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=Q,e.valid=function(ee,oe){var ae=Q(ee,oe);return ae?ae.version:null},e.clean=function(ee,oe){var ae=Q(ee.trim().replace(/^[=v]+/,""),oe);return ae?ae.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return D("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),H(this.major,ee.major)||H(this.minor,ee.minor)||H(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var oe=0;do{var ae=this.prerelease[oe],pe=ee.prerelease[oe];if(D("prerelease compare",oe,ae,pe),ae===void 0&&pe===void 0)return 0;if(pe===void 0)return 1;if(ae===void 0)return-1;if(ae!==pe)return H(ae,pe)}while(++oe)},Z.prototype.inc=function(ee,oe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,oe,ae,pe){typeof ae=="string"&&(pe=ae,ae=void 0);try{return new Z(ee,ae).inc(oe,pe).version}catch(ye){return null}},e.diff=function(ee,oe){if(le(ee,oe))return null;var ae=Q(ee),pe=Q(oe);if(ae.prerelease.length||pe.prerelease.length){for(var ye in ae)if((ye==="major"||ye==="minor"||ye==="patch")&&ae[ye]!==pe[ye])return"pre"+ye;return"prerelease"}for(var ye in ae)if((ye==="major"||ye==="minor"||ye==="patch")&&ae[ye]!==pe[ye])return ye},e.compareIdentifiers=H;var G=/^[0-9]+$/;function H(ee,oe){var ae=G.test(ee),pe=G.test(oe);return ae&&pe&&(ee=+ee,oe=+oe),ae&&!pe?-1:pe&&!ae?1:ee<oe?-1:ee>oe?1:0}function re(ee,oe,ae){return new Z(ee,ae).compare(new Z(oe,ae))}function ie(ee,oe,ae){return re(ee,oe,ae)>0}function ce(ee,oe,ae){return re(ee,oe,ae)<0}function le(ee,oe,ae){return re(ee,oe,ae)===0}function fe(ee,oe,ae){return re(ee,oe,ae)!==0}function de(ee,oe,ae){return re(ee,oe,ae)>=0}function be(ee,oe,ae){return re(ee,oe,ae)<=0}function Ie(ee,oe,ae,pe){var ye;switch(oe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ae=="object"&&(ae=ae.version),ye=ee===ae;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ae=="object"&&(ae=ae.version),ye=ee!==ae;break;case"":case"=":case"==":ye=le(ee,ae,pe);break;case"!=":ye=fe(ee,ae,pe);break;case">":ye=ie(ee,ae,pe);break;case">=":ye=de(ee,ae,pe);break;case"<":ye=ce(ee,ae,pe);break;case"<=":ye=be(ee,ae,pe);break;default:throw new TypeError("Invalid operator: "+oe)}return ye}function Ee(ee,oe){if(ee instanceof Ee){if(ee.loose===oe)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,oe);D("comparator",ee,oe),this.loose=oe,this.parse(ee),this.semver===Ae?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ee,oe){return H(oe,ee)},e.major=function(ee,oe){return new Z(ee,oe).major},e.minor=function(ee,oe){return new Z(ee,oe).minor},e.patch=function(ee,oe){return new Z(ee,oe).patch},e.compare=re,e.compareLoose=function(ee,oe){return re(ee,oe,!0)},e.rcompare=function(ee,oe,ae){return re(oe,ee,ae)},e.sort=function(ee,oe){return ee.sort(function(ae,pe){return e.compare(ae,pe,oe)})},e.rsort=function(ee,oe){return ee.sort(function(ae,pe){return e.rcompare(ae,pe,oe)})},e.gt=ie,e.lt=ce,e.eq=le,e.neq=fe,e.gte=de,e.lte=be,e.cmp=Ie,e.Comparator=Ee;var Ae={};function Pe(ee,oe){if(ee instanceof Pe)return ee.loose===oe?ee:new Pe(ee.raw,oe);if(ee instanceof Ee)return new Pe(ee.value,oe);if(!(this instanceof Pe))return new Pe(ee,oe);if(this.loose=oe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Le(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,oe,ae,pe,ye,_e,Re,Y,se,ue,ge,me,Ce){return((oe=Le(ae)?"":Le(pe)?">="+ae+".0.0":Le(ye)?">="+ae+"."+pe+".0":">="+oe)+" "+(Y=Le(se)?"":Le(ue)?"<"+(+se+1)+".0.0":Le(ge)?"<"+se+"."+(+ue+1)+".0":me?"<="+se+"."+ue+"."+ge+"-"+me:"<="+Y)).trim()}function Ne(ee,oe){for(var ae=0;ae<ee.length;ae++)if(!ee[ae].test(oe))return!1;if(oe.prerelease.length){for(ae=0;ae<ee.length;ae++)if(D(ee[ae].semver),ee[ae].semver!==Ae&&ee[ae].semver.prerelease.length>0){var pe=ee[ae].semver;if(pe.major===oe.major&&pe.minor===oe.minor&&pe.patch===oe.patch)return!0}return!1}return!0}function $e(ee,oe,ae){try{oe=new Pe(oe,ae)}catch(pe){return!1}return oe.test(ee)}function qe(ee,oe,ae,pe){var ye,_e,Re,Y,se;switch(ee=new Z(ee,pe),oe=new Pe(oe,pe),ae){case">":ye=ie,_e=be,Re=ce,Y=">",se=">=";break;case"<":ye=ce,_e=de,Re=ie,Y="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(ee,oe,pe))return!1;for(var ue=0;ue<oe.set.length;++ue){var ge=oe.set[ue],me=null,Ce=null;if(ge.forEach(function(ke){ke.semver===Ae&&(ke=new Ee(">=0.0.0")),me=me||ke,Ce=Ce||ke,ye(ke.semver,me.semver,pe)?me=ke:Re(ke.semver,Ce.semver,pe)&&(Ce=ke)}),me.operator===Y||me.operator===se||(!Ce.operator||Ce.operator===Y)&&_e(ee,Ce.semver)||Ce.operator===se&&Re(ee,Ce.semver))return!1}return!0}Ee.prototype.parse=function(ee){var oe=this.loose?P[j]:P[q],ae=ee.match(oe);if(!ae)throw new TypeError("Invalid comparator: "+ee);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new Z(ae[2],this.loose):this.semver=Ae},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return D("Comparator.test",ee,this.loose),this.semver===Ae||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Ie(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,oe){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new Pe(ee.value,oe),$e(this.value,ae,oe);if(ee.operator==="")return ae=new Pe(this.value,oe),$e(ee.semver,ae,oe);var pe=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),_e=this.semver.version===ee.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Y=Ie(this.semver,"<",ee.semver,oe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),se=Ie(this.semver,">",ee.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return pe||ye||_e&&Re||Y||se},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ee){var oe=this.loose;ee=ee.trim(),D("range",ee,oe);var ae=oe?P[F]:P[K];ee=ee.replace(ae,Fe),D("hyphen replace",ee),ee=ee.replace(P[z],"$1$2$3"),D("comparator trim",ee,P[z]),ee=(ee=(ee=ee.replace(P[x],"$1~")).replace(P[_],"$1^")).split(/\s+/).join(" ");var pe=oe?P[j]:P[q],ye=ee.split(" ").map(function(_e){return function(Re,Y){return D("comp",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ce){D("caret",me,Ce);var ke=Ce?P[W]:P[M];return me.replace(ke,function(Te,Se,we,De,Oe){var Me;return D("caret",me,Te,Se,we,De,Oe),Le(Se)?Me="":Le(we)?Me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Le(De)?Me=Se==="0"?">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+".0 <"+(+Se+1)+".0.0":Oe?(D("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=Se==="0"?we==="0"?">="+Se+"."+we+"."+De+Oe+" <"+Se+"."+we+"."+(+De+1):">="+Se+"."+we+"."+De+Oe+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+De+Oe+" <"+(+Se+1)+".0.0"):(D("no pr"),Me=Se==="0"?we==="0"?">="+Se+"."+we+"."+De+" <"+Se+"."+we+"."+(+De+1):">="+Se+"."+we+"."+De+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+De+" <"+(+Se+1)+".0.0"),D("caret return",Me),Me})}(ge,ue)}).join(" ")}(Re,Y),D("caret",Re),Re=function(se,ue){return se.trim().split(/\s+/).map(function(ge){return function(me,Ce){var ke=Ce?P[L]:P[N];return me.replace(ke,function(Te,Se,we,De,Oe){var Me;return D("tilde",me,Te,Se,we,De,Oe),Le(Se)?Me="":Le(we)?Me=">="+Se+".0.0 <"+(+Se+1)+".0.0":Le(De)?Me=">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":Oe?(D("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=">="+Se+"."+we+"."+De+Oe+" <"+Se+"."+(+we+1)+".0"):Me=">="+Se+"."+we+"."+De+" <"+Se+"."+(+we+1)+".0",D("tilde return",Me),Me})}(ge,ue)}).join(" ")}(Re,Y),D("tildes",Re),Re=function(se,ue){return D("replaceXRanges",se,ue),se.split(/\s+/).map(function(ge){return function(me,Ce){me=me.trim();var ke=Ce?P[A]:P[b];return me.replace(ke,function(Te,Se,we,De,Oe,Me){D("xRange",me,Te,Se,we,De,Oe,Me);var Qe=Le(we),Ye=Qe||Le(De),We=Ye||Le(Oe);return Se==="="&&We&&(Se=""),Qe?Te=Se===">"||Se==="<"?"<0.0.0":"*":Se&&We?(Ye&&(De=0),We&&(Oe=0),Se===">"?(Se=">=",Ye?(we=+we+1,De=0,Oe=0):We&&(De=+De+1,Oe=0)):Se==="<="&&(Se="<",Ye?we=+we+1:De=+De+1),Te=Se+we+"."+De+"."+Oe):Ye?Te=">="+we+".0.0 <"+(+we+1)+".0.0":We&&(Te=">="+we+"."+De+".0 <"+we+"."+(+De+1)+".0"),D("xRange return",Te),Te})}(ge,ue)}).join(" ")}(Re,Y),D("xrange",Re),Re=function(se,ue){return D("replaceStars",se,ue),se.trim().replace(P[B],"")}(Re,Y),D("stars",Re),Re}(_e,oe)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(_e){return!!_e.match(pe)})),ye=ye.map(function(_e){return new Ee(_e,oe)})},Pe.prototype.intersects=function(ee,oe){if(!(ee instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(pe){return ee.set.some(function(ye){return ye.every(function(_e){return pe.intersects(_e,oe)})})})})},e.toComparators=function(ee,oe){return new Pe(ee,oe).set.map(function(ae){return ae.map(function(pe){return pe.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var oe=0;oe<this.set.length;oe++)if(Ne(this.set[oe],ee))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(ee,oe,ae){var pe=null,ye=null;try{var _e=new Pe(oe,ae)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&ye.compare(Re)!==-1||(ye=new Z(pe=Re,ae)))}),pe},e.minSatisfying=function(ee,oe,ae){var pe=null,ye=null;try{var _e=new Pe(oe,ae)}catch(Re){return null}return ee.forEach(function(Re){_e.test(Re)&&(pe&&ye.compare(Re)!==1||(ye=new Z(pe=Re,ae)))}),pe},e.validRange=function(ee,oe){try{return new Pe(ee,oe).range||"*"}catch(ae){return null}},e.ltr=function(ee,oe,ae){return qe(ee,oe,"<",ae)},e.gtr=function(ee,oe,ae){return qe(ee,oe,">",ae)},e.outside=qe,e.prerelease=function(ee,oe){var ae=Q(ee,oe);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(ee,oe,ae){return ee=new Pe(ee,ae),oe=new Pe(oe,ae),ee.intersects(oe)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var oe=ee.match(P[O]);return oe==null?null:Q((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,k(1))},function(X,e){var k,T,D=X.exports={};function R(){throw new Error("setTimeout has not been defined")}function r(){throw new Error("clearTimeout has not been defined")}function P(S){if(k===setTimeout)return setTimeout(S,0);if((k===R||!k)&&setTimeout)return k=setTimeout,setTimeout(S,0);try{return k(S,0)}catch(m){try{return k.call(null,S,0)}catch(v){return k.call(this,S,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:R}catch(S){k=R}try{T=typeof clearTimeout=="function"?clearTimeout:r}catch(S){T=r}})();var y,C=[],I=!1,w=-1;function f(){I&&y&&(I=!1,y.length?C=y.concat(C):w=-1,C.length&&p())}function p(){if(!I){var S=P(f);I=!0;for(var m=C.length;m;){for(y=C,C=[];++w<m;)y&&y[w].run();w=-1,m=C.length}y=null,I=!1,function(v){if(T===clearTimeout)return clearTimeout(v);if((T===r||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(v);try{T(v)}catch(d){try{return T.call(null,v)}catch(c){return T.call(this,v)}}}(S)}}function h(S,m){this.fun=S,this.array=m}function E(){}D.nextTick=function(S){var m=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)m[v-1]=arguments[v];C.push(new h(S,m)),C.length!==1||I||P(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=E,D.addListener=E,D.once=E,D.off=E,D.removeListener=E,D.removeAllListeners=E,D.emit=E,D.prependListener=E,D.prependOnceListener=E,D.listeners=function(S){return[]},D.binding=function(S){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(S){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(te[105],ne([0,1]),function(X,e){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class T{constructor(P,y,C){this.level=P,this.key=y,this.value=C,this.forward=[]}}const D=void 0;class R{constructor(P,y=2**16){this.comparator=P,this[k]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(y)|0),this._header=new T(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new T(this._maxLevel,D,D)}has(P){return Boolean(R._search(this,P,this.comparator))}get(P){return R._search(this,P,this.comparator)?.value}set(P,y){return R._insert(this,P,y,this.comparator)&&(this._size+=1),this}delete(P){const y=R._delete(this,P,this.comparator);return y&&(this._size-=1),y}forEach(P,y){let C=this._header.forward[0];for(;C;)P.call(y,C.value,C.key,this),C=C.forward[0]}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this._header.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this._header.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this._header.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",y=this._header.forward[0];for(;y;)P+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return P}static _search(P,y,C){let I=P._header;for(let w=P._level-1;w>=0;w--)for(;I.forward[w]&&C(I.forward[w].key,y)<0;)I=I.forward[w];if(I=I.forward[0],I&&C(I.key,y)===0)return I}static _insert(P,y,C,I){let w=[],f=P._header;for(let p=P._level-1;p>=0;p--){for(;f.forward[p]&&I(f.forward[p].key,y)<0;)f=f.forward[p];w[p]=f}if(f=f.forward[0],f&&I(f.key,y)===0)return f.value=C,!1;{let p=R._randomLevel(P);if(p>P._level){for(let h=P._level;h<p;h++)w[h]=P._header;P._level=p}f=new T(p,y,C);for(let h=0;h<p;h++)f.forward[h]=w[h].forward[h],w[h].forward[h]=f;return!0}}static _randomLevel(P,y=.5){let C=1;for(;Math.random()<y&&C<P._maxLevel;)C+=1;return C}static _delete(P,y,C){let I=[],w=P._header;for(let f=P._level-1;f>=0;f--){for(;w.forward[f]&&C(w.forward[f].key,y)<0;)w=w.forward[f];I[f]=w}if(w=w.forward[0],!w||C(w.key,y)!==0)return!1;for(let f=0;f<P._level&&I[f].forward[f]===w;f++)I[f].forward[f]=w.forward[f];for(;P._level>0&&P._header.forward[P._level-1]===D;)P._level-=1;return!0}}e.SkipList=R}),define(te[70],ne([0,1,4]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=k.globals.performance&&typeof k.globals.performance.now=="function";class D{constructor(r){this._highResolution=T&&r,this._startTime=this._now(),this._stopTime=-1}static create(r=!0){return new D(r)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?k.globals.performance.now():Date.now()}}e.StopWatch=D}),define(te[3],ne([0,1,7,69,2,103,70]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(c){c.None=()=>D.Disposable.None;function l(_){return(M,W=null,j)=>{let q=!1,z;return z=_(K=>{if(!q)return z?z.dispose():q=!0,M.call(W,K)},null,j),q&&z.dispose(),z}}c.once=l;function n(_,M){return u((W,j=null,q)=>_(z=>W.call(j,M(z)),null,q))}c.map=n;function s(_,M){return u((W,j=null,q)=>_(z=>{M(z),W.call(j,z)},null,q))}c.forEach=s;function i(_,M){return u((W,j=null,q)=>_(z=>M(z)&&W.call(j,z),null,q))}c.filter=i;function t(_){return _}c.signal=t;function o(..._){return(M,W=null,j)=>(0,D.combinedDisposable)(..._.map(q=>q(z=>M.call(W,z),null,j)))}c.any=o;function a(_,M,W){let j=W;return n(_,q=>(j=M(j,q),j))}c.reduce=a;function u(_){let M;const W=new f({onFirstListenerAdd(){M=_(W.fire,W)},onLastListenerRemove(){M.dispose()}});return W.event}function g(_,M,W=100,j=!1,q){let z,K,F,B=0;const V=new f({leakWarningThreshold:q,onFirstListenerAdd(){z=_(Q=>{B++,K=M(K,Q),j&&!F&&(V.fire(K),K=void 0),clearTimeout(F),F=setTimeout(()=>{const Z=K;K=void 0,F=void 0,(!j||B>1)&&V.fire(Z),B=0},W)})},onLastListenerRemove(){z.dispose()}});return V.event}c.debounce=g;function b(_,M=(W,j)=>W===j){let W=!0,j;return i(_,q=>{const z=W||!M(q,j);return W=!1,j=q,z})}c.latch=b;function A(_,M){return[c.filter(_,M),c.filter(_,W=>!M(W))]}c.split=A;function O(_,M=!1,W=[]){let j=W.slice(),q=_(F=>{j?j.push(F):K.fire(F)});const z=()=>{j&&j.forEach(F=>K.fire(F)),j=null},K=new f({onFirstListenerAdd(){q||(q=_(F=>K.fire(F)))},onFirstListenerDidAdd(){j&&(M?setTimeout(z):z())},onLastListenerRemove(){q&&q.dispose(),q=null}});return K.event}c.buffer=O;class U{constructor(M){this.event=M}map(M){return new U(n(this.event,M))}forEach(M){return new U(s(this.event,M))}filter(M){return new U(i(this.event,M))}reduce(M,W){return new U(a(this.event,M,W))}latch(){return new U(b(this.event))}debounce(M,W=100,j=!1,q){return new U(g(this.event,M,W,j,q))}on(M,W,j){return this.event(M,W,j)}once(M,W,j){return l(this.event)(M,W,j)}}function x(_){return new U(_)}c.chain=x;function N(_,M,W=j=>j){const j=(...F)=>K.fire(W(...F)),q=()=>_.on(M,j),z=()=>_.removeListener(M,j),K=new f({onFirstListenerAdd:q,onLastListenerRemove:z});return K.event}c.fromNodeEventEmitter=N;function L(_,M,W=j=>j){const j=(...F)=>K.fire(W(...F)),q=()=>_.addEventListener(M,j),z=()=>_.removeEventListener(M,j),K=new f({onFirstListenerAdd:q,onLastListenerRemove:z});return K.event}c.fromDOMEventEmitter=L;function $(_){return new Promise(M=>l(_)(M))}c.toPromise=$})(P=e.Event||(e.Event={}));class y{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${y._idPool++}`}start(l){this._stopWatch=new r.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let C=-1;function I(c){const l=C;return C=c,{dispose(){C=l}}}e.setGlobalLeakWarningThreshold=I;class w{constructor(l,n=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let n=C;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||l<n)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(s)||0;if(this._stacks.set(s,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let t,o=0;for(const[a,u]of this._stacks)(!t||o<u)&&(t=a,o=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${o}):`),console.warn(t)}return()=>{const t=this._stacks.get(s)||0;this._stacks.set(s,t-1)}}}class f{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=C>0?new w(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(l,n,s)=>{this._listeners||(this._listeners=new R.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(n?[l,n]:l);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,n);const o=this._leakageMon?.check(this._listeners.size),a=(0,D.toDisposable)(()=>{o&&o(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof D.DisposableStore?s.add(a):Array.isArray(s)&&s.push(a),a}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new R.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,s]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,s):n[0].call(n[1],s)}catch(i){(0,k.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class p extends f{async fireAsync(l,n,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,l]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),o=[],a={...t,waitUntil:u=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof i=="function"?i:i[0])),o.push(u)}};try{typeof i=="function"?i.call(void 0,a):i[0].call(i[1],a)}catch(u){(0,k.onUnexpectedError)(u);continue}Object.freeze(o),await Promise.allSettled(o).then(u=>{for(const g of u)g.status==="rejected"&&(0,k.onUnexpectedError)(g.reason)})}}}}e.AsyncEmitter=p;class h extends f{constructor(l){super(l);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class E extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=E;class S extends f{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=S;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const n={event:l,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const s=()=>{this.hasListeners&&this.unhook(n);const i=this.events.indexOf(n);this.events.splice(i,1)};return(0,D.toDisposable)((0,T.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(n=>this.emitter.fire(n))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class v{constructor(){this.buffers=[]}wrapEvent(l){return(n,s,i)=>l(t=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>n.call(s,t)):n.call(s,t)},void 0,i)}bufferEvents(l){const n=[];this.buffers.push(n);const s=l();return this.buffers.pop(),n.forEach(i=>i()),s}}e.EventBufferer=v;class d{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=D.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=d}),define(te[28],ne([0,1,3]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(P,y){const C=setTimeout(P.bind(y),0);return{dispose(){clearTimeout(C)}}});var D;(function(P){function y(C){return C===P.None||C===P.Cancelled||C instanceof R?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}P.isCancellationToken=y,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(D=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new k.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class r{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=D.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=r}),define(te[49],ne([0,1,3]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new k.Emitter}add(I){const w=this._icons.get(I.id);w?I.description?w.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new T;e.iconRegistry=D;function R(C){return C?C.replace(/\$\((.*?)\)/g,(I,w)=>` ${w} `).trim():""}e.getCodiconAriaLabel=R;class r{constructor(I,w,f){this.id=I,this.definition=w,this.description=f,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=r,r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",r.add.definition),r.gistNew=new r("gist-new",r.add.definition),r.repoCreate=new r("repo-create",r.add.definition),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eba4"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.layers=new r("layers",{fontCharacter:"\\ebd2"}),r.layersDot=new r("layers-dot",{fontCharacter:"\\ebd3"}),r.layersActive=new r("layers-active",{fontCharacter:"\\ebd4"}),r.compass=new r("compass",{fontCharacter:"\\ebd5"}),r.compassDot=new r("compass-dot",{fontCharacter:"\\ebd6"}),r.compassActive=new r("compass-active",{fontCharacter:"\\ebd7"}),r.azure=new r("azure",{fontCharacter:"\\ebd8"}),r.issueDraft=new r("issue-draft",{fontCharacter:"\\ebd9"}),r.gitPullRequestClosed=new r("git-pull-request-closed",{fontCharacter:"\\ebda"}),r.gitPullRequestDraft=new r("git-pull-request-draft",{fontCharacter:"\\ebdb"}),r.debugAll=new r("debug-all",{fontCharacter:"\\ebdc"}),r.debugCoverage=new r("debug-coverage",{fontCharacter:"\\ebdd"}),r.runErrors=new r("run-errors",{fontCharacter:"\\ebde"}),r.folderLibrary=new r("folder-library",{fontCharacter:"\\ebdf"}),r.debugContinueSmall=new r("debug-continue-small",{fontCharacter:"\\ebe0"}),r.beakerStop=new r("beaker-stop",{fontCharacter:"\\ebe1"}),r.graphLine=new r("graph-line",{fontCharacter:"\\ebe2"}),r.graphScatter=new r("graph-scatter",{fontCharacter:"\\ebe3"}),r.pieChart=new r("pie-chart",{fontCharacter:"\\ebe4"}),r.bracket=new r("bracket",r.json.definition),r.bracketDot=new r("bracket-dot",{fontCharacter:"\\ebe5"}),r.bracketError=new r("bracket-error",{fontCharacter:"\\ebe6"}),r.lockSmall=new r("lock-small",{fontCharacter:"\\ebe7"}),r.azureDevops=new r("azure-devops",{fontCharacter:"\\ebe8"}),r.verifiedFilled=new r("verified-filled",{fontCharacter:"\\ebe9"}),r.newLine=new r("newline",{fontCharacter:"\\ebea"}),r.dialogError=new r("dialog-error",r.error.definition),r.dialogWarning=new r("dialog-warning",r.warning.definition),r.dialogInfo=new r("dialog-info",r.info.definition),r.dialogClose=new r("dialog-close",r.close.definition),r.treeItemExpanded=new r("tree-item-expanded",r.chevronDown.definition),r.treeFilterOnTypeOn=new r("tree-filter-on-type-on",r.listFilter.definition),r.treeFilterOnTypeOff=new r("tree-filter-on-type-off",r.listSelection.definition),r.treeFilterClear=new r("tree-filter-clear",r.close.definition),r.treeItemLoading=new r("tree-item-loading",r.loading.definition),r.menuSelection=new r("menu-selection",r.check.definition),r.menuSubmenu=new r("menu-submenu",r.chevronRight.definition),r.menuBarMore=new r("menubar-more",r.more.definition),r.scrollbarButtonLeft=new r("scrollbar-button-left",r.triangleLeft.definition),r.scrollbarButtonRight=new r("scrollbar-button-right",r.triangleRight.definition),r.scrollbarButtonUp=new r("scrollbar-button-up",r.triangleUp.definition),r.scrollbarButtonDown=new r("scrollbar-button-down",r.triangleDown.definition),r.toolBarMore=new r("toolbar-more",r.more.definition),r.quickInputBack=new r("quick-input-back",r.arrowLeft.definition);function P(C,I){const w=["codicon","codicon-"+C];return I&&w.push("codicon-modifier-"+I),w}e.getClassNamesArray=P;var y;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9\\-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9\\-~]";const I=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function w(h){if(h instanceof r)return["codicon","codicon-"+h.id];const E=I.exec(h.id);if(!E)return w(r.error);let[,S,m]=E;const v=["codicon","codicon-"+S];return m&&v.push("codicon-modifier-"+m.substr(1)),v}C.asClassNameArray=w;function f(h){return w(h).join(" ")}C.asClassName=f;function p(h){return"."+w(h).join(".")}C.asCSSSelector=p})(y=e.CSSIcon||(e.CSSIcon={}))}),define(te[50],ne([0,1,7,2]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(d){const c=d;return c?[c.on,c.pause,c.resume,c.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=D;function R(d){const c=d;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=R;function r(d,c){return new P(d,c)}e.newWriteableStream=r;class P{constructor(c,l){this.reducer=c,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(l=>l(c))}emitError(c){this.listeners.error.length===0?(0,k.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(l=>l(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,l){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(c,l){if(this.state.destroyed)return;let n;switch(c){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const s=n.indexOf(l);s>=0&&n.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(d,c){const l=[];let n;for(;(n=d.read())!==null;)l.push(n);return c(l)}e.consumeReadable=y;function C(d,c,l){const n=[];let s;for(;(s=d.read())!==null&&n.length<l;)n.push(s);return s===null&&n.length>0?c(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s!="undefined"){const i=s;return s=void 0,i}return d.read()}}}e.peekReadable=C;function I(d,c){return new Promise((l,n)=>{const s=[];w(d,{onData:i=>{c&&s.push(i)},onError:i=>{c?n(i):l(void 0)},onEnd:()=>{l(c?c(s):void 0)}})})}e.consumeStream=I;function w(d,c){d.on("error",l=>c.onError(l)),d.on("end",()=>c.onEnd()),d.on("data",l=>c.onData(l))}e.listenStream=w;function f(d,c){return new Promise((l,n)=>{const s=new T.DisposableStore,i=[],t=u=>{if(i.push(u),i.length>c)return s.dispose(),d.pause(),l({stream:d,buffer:i,ended:!1})},o=u=>n(u),a=()=>l({stream:d,buffer:i,ended:!0});s.add((0,T.toDisposable)(()=>d.removeListener("error",o))),d.on("error",o),s.add((0,T.toDisposable)(()=>d.removeListener("end",a))),d.on("end",a),s.add((0,T.toDisposable)(()=>d.removeListener("data",t))),d.on("data",t)})}e.peekStream=f;function p(d,c){const l=r(c);return l.end(d),l}e.toStream=p;function h(){const d=r(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=h;function E(d){let c=!1;return{read:()=>c?null:(c=!0,d)}}e.toReadable=E;function S(d,c,l){const n=r(l);return w(d,{onData:s=>n.write(c.data(s)),onError:s=>n.error(c.error?c.error(s):s),onEnd:()=>n.end()}),n}e.transform=S;function m(d,c,l){let n=!1;return{read:()=>{const s=c.read();return n?s:(n=!0,s!==null?l([d,s]):d)}}}e.prefixedReadable=m;function v(d,c,l){let n=!1;const s=r(l);return w(c,{onData:i=>n?s.write(i):(n=!0,s.write(l([d,i]))),onError:i=>s.error(i),onEnd:()=>{n||(n=!0,s.write(d)),s.end()}}),s}e.prefixedStream=v}),define(te[19],ne([0,1,50]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const T=typeof Buffer!="undefined";let D,R;class r{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return T?new r(Buffer.allocUnsafe(t)):new r(new Uint8Array(t))}static wrap(t){return T&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new r(t)}static fromString(t,o){return!(o?.dontUseNodeBuffer||!1)&&T?new r(Buffer.from(t)):(D||(D=new TextEncoder),new r(D.encode(t)))}static concat(t,o){if(typeof o=="undefined"){o=0;for(let g=0,b=t.length;g<b;g++)o+=t[g].byteLength}const a=r.alloc(o);let u=0;for(let g=0,b=t.length;g<b;g++){const A=t[g];a.set(A,u),u+=A.byteLength}return a}toString(){return T?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(t,o){return new r(this.buffer.subarray(t,o))}set(t,o){t instanceof r?this.buffer.set(t.buffer,o):this.buffer.set(t,o)}readUInt32BE(t){return C(this.buffer,t)}writeUInt32BE(t,o){I(this.buffer,t,o)}readUInt32LE(t){return w(this.buffer,t)}writeUInt32LE(t,o){f(this.buffer,t,o)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,o){h(this.buffer,t,o)}}e.VSBuffer=r;function P(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0}e.readUInt16LE=P;function y(i,t,o){i[o+0]=t&255,t=t>>>8,i[o+1]=t&255}e.writeUInt16LE=y;function C(i,t){return i[t]*2**24+i[t+1]*2**16+i[t+2]*2**8+i[t+3]}e.readUInt32BE=C;function I(i,t,o){i[o+3]=t,t=t>>>8,i[o+2]=t,t=t>>>8,i[o+1]=t,t=t>>>8,i[o]=t}e.writeUInt32BE=I;function w(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0|i[t+2]<<16>>>0|i[t+3]<<24>>>0}e.readUInt32LE=w;function f(i,t,o){i[o+0]=t&255,t=t>>>8,i[o+1]=t&255,t=t>>>8,i[o+2]=t&255,t=t>>>8,i[o+3]=t&255}e.writeUInt32LE=f;function p(i,t){return i[t]}e.readUInt8=p;function h(i,t,o){i[o]=t}e.writeUInt8=h;function E(i){return k.consumeReadable(i,t=>r.concat(t))}e.readableToBuffer=E;function S(i){return k.toReadable(i)}e.bufferToReadable=S;function m(i){return k.consumeStream(i,t=>r.concat(t))}e.streamToBuffer=m;async function v(i){return i.ended?r.concat(i.buffer):r.concat([...i.buffer,await m(i.stream)])}e.bufferedStreamToBuffer=v;function d(i){return k.toStream(i,t=>r.concat(t))}e.bufferToStream=d;function c(i){return k.transform(i,{data:t=>typeof t=="string"?r.fromString(t):r.wrap(t)},t=>r.concat(t))}e.streamToBufferReadableStream=c;function l(i){return k.newWriteableStream(t=>r.concat(t),i)}e.newWriteableBufferStream=l;function n(i,t){return k.prefixedReadable(i,t,o=>r.concat(o))}e.prefixedBufferReadable=n;function s(i,t){return k.prefixedStream(i,t,o=>r.concat(o))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function k(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=k;const T=/{(\d+)}/g;function D(Y,...se){return se.length===0?Y:Y.replace(T,function(ue,ge){const me=parseInt(ge,10);return isNaN(me)||me<0||me>=se.length?ue:se[me]})}e.format=D;const R=/{([^}]+)}/g;function r(Y,se){return Y.replace(R,(ue,ge)=>se[ge]??ue)}e.format2=r;function P(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=P;function y(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function C(Y,se){let ue=0;const ge=se.charCodeAt(0);for(let me=Y.length-1;me>=0;me--)Y.charCodeAt(me)===ge&&ue++;return ue}e.count=C;function I(Y,se,ue="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${ue}`}e.truncate=I;function w(Y,se=" "){const ue=f(Y,se);return p(ue,se)}e.trim=w;function f(Y,se){if(!Y||!se)return Y;const ue=se.length;if(ue===0||Y.length===0)return Y;let ge=0;for(;Y.indexOf(se,ge)===ge;)ge=ge+ue;return Y.substring(ge)}e.ltrim=f;function p(Y,se){if(!Y||!se)return Y;const ue=se.length,ge=Y.length;if(ue===0||ge===0)return Y;let me=ge,Ce=-1;for(;Ce=Y.lastIndexOf(se,me-1),!(Ce===-1||Ce+ue!==me);){if(Ce===0)return"";me=Ce}return Y.substring(0,me)}e.rtrim=p;function h(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function E(Y){return Y.replace(/\*/g,"")}e.stripWildcards=E;function S(Y,se,ue={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=y(Y)),ue.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ge="";return ue.global&&(ge+="g"),ue.matchCase||(ge+="i"),ue.multiline&&(ge+="m"),ue.unicode&&(ge+="u"),new RegExp(Y,ge)}e.createRegExp=S;function m(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function v(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function d(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=d;function c(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=c;function l(Y){for(let se=0,ue=Y.length;se<ue;se++){const ge=Y.charCodeAt(se);if(ge!==32&&ge!==9)return se}return-1}e.firstNonWhitespaceIndex=l;function n(Y,se=0,ue=Y.length){for(let ge=se;ge<ue;ge++){const me=Y.charCodeAt(ge);if(me!==32&&me!==9)return Y.substring(se,ge)}return Y.substring(se,ue)}e.getLeadingWhitespace=n;function s(Y,se=Y.length-1){for(let ue=se;ue>=0;ue--){const ge=Y.charCodeAt(ue);if(ge!==32&&ge!==9)return ue}return-1}e.lastNonWhitespaceIndex=s;function i(Y,se){return Y<se?-1:Y>se?1:0}e.compare=i;function t(Y,se,ue=0,ge=Y.length,me=0,Ce=se.length){for(;ue<ge&&me<Ce;ue++,me++){let Se=Y.charCodeAt(ue),we=se.charCodeAt(me);if(Se<we)return-1;if(Se>we)return 1}const ke=ge-ue,Te=Ce-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstring=t;function o(Y,se){return a(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=o;function a(Y,se,ue=0,ge=Y.length,me=0,Ce=se.length){for(;ue<ge&&me<Ce;ue++,me++){let Se=Y.charCodeAt(ue),we=se.charCodeAt(me);if(Se===we)continue;if(Se>=128||we>=128)return t(Y.toLowerCase(),se.toLowerCase(),ue,ge,me,Ce);u(Se)&&(Se-=32),u(we)&&(we-=32);const De=Se-we;if(De!==0)return De}const ke=ge-ue,Te=Ce-me;return ke<Te?-1:ke>Te?1:0}e.compareSubstringIgnoreCase=a;function u(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=u;function g(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=g;function b(Y,se){return Y.length===se.length&&a(Y,se)===0}e.equalsIgnoreCase=b;function A(Y,se){const ue=se.length;return se.length>Y.length?!1:a(Y,se,0,ue)===0}e.startsWithIgnoreCase=A;function O(Y,se){let ue,ge=Math.min(Y.length,se.length);for(ue=0;ue<ge;ue++)if(Y.charCodeAt(ue)!==se.charCodeAt(ue))return ue;return ge}e.commonPrefixLength=O;function U(Y,se){let ue,ge=Math.min(Y.length,se.length);const me=Y.length-1,Ce=se.length-1;for(ue=0;ue<ge;ue++)if(Y.charCodeAt(me-ue)!==se.charCodeAt(Ce-ue))return ue;return ge}e.commonSuffixLength=U;function x(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=x;function N(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=N;function L(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=L;function $(Y,se,ue){const ge=Y.charCodeAt(ue);if(x(ge)&&ue+1<se){const me=Y.charCodeAt(ue+1);if(N(me))return L(ge,me)}return ge}e.getNextCodePoint=$;function _(Y,se){const ue=Y.charCodeAt(se-1);if(N(ue)&&se>1){const ge=Y.charCodeAt(se-2);if(x(ge))return L(ge,ue)}return ue}function M(Y,se){const ue=ee.getInstance(),ge=se,me=Y.length,Ce=$(Y,me,se);se+=Ce>=65536?2:1;let ke=ue.getGraphemeBreakType(Ce);for(;se<me;){const Te=$(Y,me,se),Se=ue.getGraphemeBreakType(Te);if($e(ke,Se))break;se+=Te>=65536?2:1,ke=Se}return se-ge}e.nextCharLength=M;function W(Y,se){const ue=ee.getInstance(),ge=se,me=_(Y,se);se-=me>=65536?2:1;let Ce=ue.getGraphemeBreakType(me);for(;se>0;){const ke=_(Y,se),Te=ue.getGraphemeBreakType(ke);if($e(Te,Ce))break;se-=ke>=65536?2:1,Ce=Te}return ge-se}e.prevCharLength=W;function j(Y,se){const ue=ee.getInstance(),ge=Y.length,me=se,Ce=$(Y,ge,se),ke=ue.getGraphemeBreakType(Ce);se+=Ce>=65536?2:1;let Te=ke;for(;se<ge;){const we=$(Y,ge,se),De=ue.getGraphemeBreakType(we);if($e(Te,De))break;se+=we>=65536?2:1,Te=De}const Se=se;for(se=me,Te=ke;se>0;){const we=_(Y,se),De=ue.getGraphemeBreakType(we);if($e(De,Te))break;se-=we>=65536?2:1,Te=De}return[se,Se]}function q(Y,se){return se>0&&N(Y.charCodeAt(se))?j(Y,se-1):j(Y,se)}e.getCharContainingOffset=q;const z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(Y){return z.test(Y)}e.containsRTL=K;const F=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function B(Y){return F.test(Y)}e.containsEmoji=B;const V=/^[\t\n\r\x20-\x7E]*$/;function Q(Y){return V.test(Y)}e.isBasicASCII=Q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=Z;function G(Y){for(let se=0,ue=Y.length;se<ue;se++)if(H(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=G;function H(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=H;function re(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=re;function ie(Y,se){if(Y.length<se)return Y;const ue=/\b/g;let ge=0;for(;ue.test(Y)&&!(Y.length-ue.lastIndex<se);)ge=ue.lastIndex,ue.lastIndex+=1;return Y.substring(ge).replace(/^\s/,"")}e.lcut=ie;const ce=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function de(Y){return Y&&(Y=Y.replace(ce,""),Y=Y.replace(le,""),Y=Y.replace(fe,"")),Y}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ie(Y){return be(Y)?Y.substr(1):Y}e.stripUTF8BOM=Ie;function Ee(Y,se){if(!Y||!se||Y.length<se.length)return!1;const ue=se.length,ge=Y.toLowerCase();let me=0,Ce=-1;for(;me<ue;){const ke=ge.indexOf(se[me],Ce+1);if(ke<0)return!1;Ce=ke,me++}return!0}e.fuzzyContains=Ee;function Ae(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=Ae;function Pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Pe;function Le(Y,se=1){if(se===0)return"";let ue=-1;do ue=Y.indexOf(`
`,ue+1),se--;while(se>0&&ue>=0);return ue===-1?Y:(Y[ue-1]==="\r"&&ue--,Y.substr(0,ue))}e.getNLines=Le;function Fe(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Fe;function Ne(Y){return ee.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=Ne;function $e(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=$e;var qe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ee{constructor(){this._data=oe()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ue=this._data,ge=ue.length/3;let me=1;for(;me<=ge;)if(se<ue[3*me])me=2*me;else if(se>ue[3*me+1])me=2*me+1;else return ue[3*me+2];return 0}}ee._INSTANCE=null;function oe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ae(Y,se){if(Y===0)return 0;const ue=pe(Y,se);if(ue!==void 0)return ue;const ge=_(se,Y);return Y-=ye(ge),Y}e.getLeftDeleteOffset=ae;function pe(Y,se){let ue=_(se,Y);for(Y-=ye(ue);_e(ue)||ue===65039||ue===8419;){if(Y===0)return;ue=_(se,Y),Y-=ye(ue)}if(!!re(ue)){if(Y>=0){const ge=_(se,Y);ge===8205&&(Y-=ye(ge))}return Y}}function ye(Y){return Y>=65536?2:1}function _e(Y){return 127995<=Y&&Y<=127999}var Re;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(Re||(Re={})),e.noBreakWhitespace="\xA0"}),define(te[106],ne([0,1,25]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function T(m){return D(m,0)}e.hash=T;function D(m,v){switch(typeof m){case"object":return m===null?R(349,v):Array.isArray(m)?y(m,v):C(m,v);case"string":return P(m,v);case"boolean":return r(m,v);case"number":return R(m,v);case"undefined":return R(937,v);default:return R(617,v)}}e.doHash=D;function R(m,v){return(v<<5)-v+m|0}e.numberHash=R;function r(m,v){return R(m?433:863,v)}function P(m,v){v=R(149417,v);for(let d=0,c=m.length;d<c;d++)v=R(m.charCodeAt(d),v);return v}e.stringHash=P;function y(m,v){return v=R(104579,v),m.reduce((d,c)=>D(c,d),v)}function C(m,v){return v=R(181387,v),Object.keys(m).sort().reduce((d,c)=>(d=P(c,d),D(m[c],d)),v)}class I{constructor(){this._value=0}get value(){return this._value}hash(v){return this._value=D(v,this._value),this._value}}e.Hasher=I;var w;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function f(m,v,d=32){const c=d-v,l=~((1<<c)-1);return(m<<v|(l&m)>>>c)>>>0}function p(m,v=0,d=m.byteLength,c=0){for(let l=0;l<d;l++)m[v+l]=c}function h(m,v,d="0"){for(;m.length<v;)m=d+m;return m}function E(m,v=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(d=>d.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),v/4)}e.toHexString=E;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(v){const d=v.length;if(d===0)return;const c=this._buff;let l=this._buffLen,n=this._leftoverHighSurrogate,s,i;for(n!==0?(s=n,i=-1,n=0):(s=v.charCodeAt(0),i=0);;){let t=s;if(k.isHighSurrogate(s))if(i+1<d){const o=v.charCodeAt(i+1);k.isLowSurrogate(o)?(i++,t=k.computeCodePoint(s,o)):t=65533}else{n=s;break}else k.isLowSurrogate(s)&&(t=65533);if(l=this._push(c,l,t),i++,i<d)s=v.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=n}_push(v,d,c){return c<128?v[d++]=c:c<2048?(v[d++]=192|(c&1984)>>>6,v[d++]=128|(c&63)>>>0):c<65536?(v[d++]=224|(c&61440)>>>12,v[d++]=128|(c&4032)>>>6,v[d++]=128|(c&63)>>>0):(v[d++]=240|(c&1835008)>>>18,v[d++]=128|(c&258048)>>>12,v[d++]=128|(c&4032)>>>6,v[d++]=128|(c&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const v=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(v/4294967296),!1),this._buffDV.setUint32(60,v%4294967296,!1),this._step()}_step(){const v=S._bigBlock32,d=this._buffDV;for(let u=0;u<64;u+=4)v.setUint32(u,d.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)v.setUint32(u,f(v.getUint32(u-12,!1)^v.getUint32(u-32,!1)^v.getUint32(u-56,!1)^v.getUint32(u-64,!1),1),!1);let c=this._h0,l=this._h1,n=this._h2,s=this._h3,i=this._h4,t,o,a;for(let u=0;u<80;u++)u<20?(t=l&n|~l&s,o=1518500249):u<40?(t=l^n^s,o=1859775393):u<60?(t=l&n|l&s|n&s,o=2400959708):(t=l^n^s,o=3395469782),a=f(c,5)+t+i+o+v.getUint32(u*4,!1)&4294967295,i=s,s=n,n=f(l,30),l=c,c=a;this._h0=this._h0+c&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+s&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))});var It=this&&this.__classPrivateFieldSet||function(X,e,k,T,D){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?D.call(X,k):D?D.value=k:e.set(X,k),k},Ve=this&&this.__classPrivateFieldGet||function(X,e,k,T){if(k==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!T:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return k==="m"?T:k==="a"?T.call(X):T?T.value:e.get(X)};define(te[41],ne([0,1,16,25]),function(X,e,k,T){"use strict";var D,R,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(i,t,o){let a=i.get(t);return a===void 0&&(a=o,i.set(t,a)),a}e.getOrSet=P;function y(i){const t=[];return i.forEach((o,a)=>{t.push(`${a} => ${o}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=y;function C(i){const t=[];return i.forEach(o=>{t.push(o)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=C;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),a=this._value.charCodeAt(this._pos);return o-a}value(){return this._value[this._pos]}}e.StringIterator=I;class w{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,T.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class f{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,T.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,T.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var p;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,T.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,T.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,T.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,T.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(S||(S={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new h(t))}static forPaths(){return new m(new f)}static forStrings(){return new m(new I)}static forConfigKeys(){return new m(new w)}clear(){this._root=void 0}fill(t,o){if(o){const a=o.slice(0);(0,k.shuffle)(a);for(let u of a)this.set(u,t)}else{const a=t.slice(0);(0,k.shuffle)(a);for(let u of a)this.set(u[0],u[1])}}set(t,o){const a=this._iter.reset(t);let u;this._root||(this._root=new E,this._root.segment=a.value());const g=[];for(u=this._root;;){const A=a.cmp(u.segment);if(A>0)u.left||(u.left=new E,u.left.segment=a.value()),g.push([-1,u]),u=u.left;else if(A<0)u.right||(u.right=new E,u.right.segment=a.value()),g.push([1,u]),u=u.right;else if(a.hasNext())a.next(),u.mid||(u.mid=new E,u.mid.segment=a.value()),g.push([0,u]),u=u.mid;else break}const b=u.value;u.value=o,u.key=t;for(let A=g.length-1;A>=0;A--){const O=g[A][1];O.updateHeight();const U=O.balanceFactor();if(U<-1||U>1){const x=g[A][0],N=g[A+1][0];if(x===1&&N===1)g[A][1]=O.rotateLeft();else if(x===-1&&N===-1)g[A][1]=O.rotateRight();else if(x===1&&N===-1)O.right=g[A+1][1]=g[A+1][1].rotateRight(),g[A][1]=O.rotateLeft();else if(x===-1&&N===1)O.left=g[A+1][1]=g[A+1][1].rotateLeft(),g[A][1]=O.rotateRight();else throw new Error;if(A>0)switch(g[A-1][0]){case-1:g[A-1][1].left=g[A][1];break;case 1:g[A-1][1].right=g[A][1];break;case 0:g[A-1][1].mid=g[A][1];break}else this._root=g[0][1]}}return b}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let a=this._root;for(;a;){const u=o.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else break}return a}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const a=this._iter.reset(t),u=[];let g=this._root;for(;g;){const b=a.cmp(g.segment);if(b>0)u.push([-1,g]),g=g.left;else if(b<0)u.push([1,g]),g=g.right;else if(a.hasNext())a.next(),u.push([0,g]),g=g.mid;else break}if(!!g){if(o?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const b=this._min(g.right),{key:A,value:O,segment:U}=b;this._delete(b.key,!1),g.key=A,g.value=O,g.segment=U}else{const b=g.left??g.right;if(u.length>0){const[A,O]=u[u.length-1];switch(A){case-1:O.left=b;break;case 0:O.mid=b;break;case 1:O.right=b;break}}else this._root=b}for(let b=u.length-1;b>=0;b--){const A=u[b][1];A.updateHeight();const O=A.balanceFactor();if(O>1?(A.right.balanceFactor()>=0||(A.right=u[b+1][1]=u[b+1][1].rotateRight()),u[b][1]=A.rotateLeft()):O<-1&&(A.left.balanceFactor()<=0||(A.left=u[b+1][1]=u[b+1][1].rotateLeft()),u[b][1]=A.rotateRight()),b>0)switch(u[b-1][0]){case-1:u[b-1][1].left=u[b][1];break;case 1:u[b-1][1].right=u[b][1];break;case 0:u[b-1][1].mid=u[b][1];break}else this._root=u[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let a=this._root,u;for(;a;){const g=o.cmp(a.segment);if(g>0)a=a.left;else if(g<0)a=a.right;else if(o.hasNext())o.next(),u=a.value||u,a=a.mid;else break}return a&&a.value||u}findSuperstr(t){const o=this._iter.reset(t);let a=this._root;for(;a;){const u=o.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(t){for(const[o,a]of this)t(a,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const a=o.balanceFactor();return a<-1||a>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=m;class v{constructor(t,o){this.uri=t,this.value=o}}class d{constructor(t,o){this[D]="ResourceMap",t instanceof d?(this.map=new Map(t.map),this.toKey=o??d.defaultToKey):(this.map=new Map,this.toKey=t??d.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new v(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(let[a,u]of this.map)t(u.value,u.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=d,d.defaultToKey=i=>i.toString();var c;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class l{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const a=this._map.get(t);if(!!a)return o!==0&&this.touch(a,o),a.value}set(t,o,a=0){let u=this._map.get(t);if(u)u.value=o,a!==0&&this.touch(u,a);else{switch(u={key:t,value:o,next:void 0,previous:void 0},a){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(t,u),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const a=this._state;let u=this._head;for(;u;){if(o?t.bind(o)(u.value,u.key,this):t(u.value,u.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const t=this,o=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:a.key,done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return u}values(){const t=this,o=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:a.value,done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return u}entries(){const t=this,o=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const g={value:[a.key,a.value],done:!1};return a=a.next,g}else return{value:void 0,done:!0}}};return u}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,a=this.size;for(;o&&a>t;)this._map.delete(o.key),o=o.next,a--;this._head=o,this._size=a,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,a=t.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const a=t.next,u=t.previous;t===this._tail?(u.next=void 0,this._tail=u):(a.previous=u,u.next=a),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const a=t.next,u=t.previous;t===this._head?(a.previous=void 0,this._head=a):(a.previous=u,u.next=a),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,a)=>{t.push([a,o])}),t}fromJSON(t){this.clear();for(const[o,a]of t)this.set(o,a)}}e.LinkedMap=l;class n extends l{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class s{constructor(t){r.set(this,void 0),It(this,r,t,"f")}get size(){return Ve(this,r,"f").size}forEach(t,o){Ve(this,r,"f").forEach(t,o)}get(t){return Ve(this,r,"f").get(t)}has(t){return Ve(this,r,"f").has(t)}entries(){return Ve(this,r,"f").entries()}keys(){return Ve(this,r,"f").keys()}values(){return Ve(this,r,"f").values()}[(r=new WeakMap,Symbol.iterator)](){return Ve(this,r,"f").entries()}}e.ReadonlyMapView=s}),define(te[71],ne([0,1,41]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const T=new k.LRUCache(1e4);function D(C){return y(C,"NFC",T)}e.normalizeNFC=D;const R=new k.LRUCache(1e4);function r(C){return y(C,"NFD",R)}e.normalizeNFD=r;const P=/[^\u0000-\u0080]/;function y(C,I,w){if(!C)return C;const f=w.get(C);if(f)return f;let p;return P.test(C)?p=C.normalize(I):p=C,w.set(C,p),p}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(I){return r(I).replace(C,"")}}()}),define(te[17],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function k(g){return Array.isArray(g)}e.isArray=k;function T(g){return typeof g=="string"}e.isString=T;function D(g){return Array.isArray(g)&&g.every(b=>T(b))}e.isStringArray=D;function R(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=R;function r(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=r;function P(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=P;function y(g){return g===!0||g===!1}e.isBoolean=y;function C(g){return typeof g=="undefined"}e.isUndefined=C;function I(g){return!w(g)}e.isDefined=I;function w(g){return C(g)||g===null}e.isUndefinedOrNull=w;function f(g,b){if(!g)throw new Error(b?`Unexpected type, expected '${b}'`:"Unexpected type")}e.assertType=f;function p(g){if(w(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=p;function h(...g){const b=[];for(let A=0;A<g.length;A++){const O=g[A];if(w(O))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);b.push(O)}return b}e.assertAllDefined=h;const E=Object.prototype.hasOwnProperty;function S(g){if(!R(g))return!1;for(let b in g)if(E.call(g,b))return!1;return!0}e.isEmptyObject=S;function m(g){return typeof g=="function"}e.isFunction=m;function v(...g){return g.length>0&&g.every(m)}e.areFunctions=v;function d(g,b){const A=Math.min(g.length,b.length);for(let O=0;O<A;O++)c(g[O],b[O])}e.validateConstraints=d;function c(g,b){if(T(b)){if(typeof g!==b)throw new Error(`argument does not match constraint: typeof ${b}`)}else if(m(b)){try{if(g instanceof b)return}catch{}if(!w(g)&&g.constructor===b||b.length===1&&b.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function l(g){let b=[],A=Object.getPrototypeOf(g);for(;Object.prototype!==A;)b=b.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return b}e.getAllPropertyNames=l;function n(g){const b=[];for(const A of l(g))typeof g[A]=="function"&&b.push(A);return b}e.getAllMethodNames=n;function s(g,b){const A=U=>function(){const x=Array.prototype.slice.call(arguments,0);return b(U,x)};let O={};for(const U of g)O[U]=A(U);return O}e.createProxyObject=s;function i(g){return g===null?void 0:g}e.withNullAsUndefined=i;function t(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=t;function o(g){return class{constructor(){return new Proxy({},{get(b,A){if(b[A])return b[A];throw new Error(`Not Implemented: ${g}->${String(A)}`)}})}}}e.NotImplementedProxy=o;function a(g,b="Unreachable"){throw new Error(b)}e.assertNever=a;function u(g){return!!g&&typeof g.then=="function"&&typeof g.catch=="function"}e.isPromise=u}),define(te[42],ne([0,1,9,4,25,17]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function r(i){return i===47||i===92}e.isPathSeparator=r;function P(i){return i.replace(/[\\/]/g,k.posix.sep)}e.toSlashes=P;function y(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=y;function C(i,t=k.posix.sep){if(!i)return"";const o=i.length,a=i.charCodeAt(0);if(r(a)){if(r(i.charCodeAt(1))&&!r(i.charCodeAt(2))){let g=3;const b=g;for(;g<o&&!r(i.charCodeAt(g));g++);if(b!==g&&!r(i.charCodeAt(g+1))){for(g+=1;g<o;g++)if(r(i.charCodeAt(g)))return i.slice(0,g+1).replace(/[\\/]/g,t)}}return t}else if(m(a)&&i.charCodeAt(1)===58)return r(i.charCodeAt(2))?i.slice(0,2)+t:i.slice(0,2);let u=i.indexOf("://");if(u!==-1){for(u+=3;u<o;u++)if(r(i.charCodeAt(u)))return i.slice(0,u+1)}return""}e.getRoot=C;function I(i){if(!T.isWindows||!i||i.length<5)return!1;let t=i.charCodeAt(0);if(t!==92||(t=i.charCodeAt(1),t!==92))return!1;let o=2;const a=o;for(;o<i.length&&(t=i.charCodeAt(o),t!==92);o++);return!(a===o||(t=i.charCodeAt(o+1),isNaN(t)||t===92))}e.isUNC=I;const w=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,t=T.isWindows){const o=t?w:f;return!(!i||i.length===0||/^\s+$/.test(i)||(o.lastIndex=0,o.test(i))||t&&p.test(i)||i==="."||i===".."||t&&i[i.length-1]==="."||t&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function E(i,t,o){const a=i===t;return!o||a?a:!i||!t?!1:(0,D.equalsIgnoreCase)(i,t)}e.isEqual=E;function S(i,t,o,a=k.sep){if(i===t)return!0;if(!i||!t||t.length>i.length)return!1;if(o){if(!(0,D.startsWithIgnoreCase)(i,t))return!1;if(t.length===i.length)return!0;let g=t.length;return t.charAt(t.length-1)===a&&g--,i.charAt(g)===a}return t.charAt(t.length-1)!==a&&(t+=a),i.indexOf(t)===0}e.isEqualOrParent=S;function m(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=m;function v(i,t){return T.isWindows&&i.endsWith(":")&&(i+=k.sep),(0,k.isAbsolute)(i)||(i=(0,k.join)(t,i)),i=(0,k.normalize)(i),T.isWindows?(i=(0,D.rtrim)(i,k.sep),i.endsWith(":")&&(i+=k.sep)):(i=(0,D.rtrim)(i,k.sep),i||(i=k.sep)),i}e.sanitizeFilePath=v;function d(i){const t=(0,k.normalize)(i);return T.isWindows?i.length>3?!1:c(t)&&(i.length===2||t.charCodeAt(2)===92):t===k.posix.sep}e.isRootOrDriveLetter=d;function c(i,t){return(t!==void 0?t:T.isWindows)?m(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(i){return c(i)?i[0]:void 0}e.getDriveLetter=l;function n(i,t,o){return t.length>i.length?-1:i===t?0:(o&&(i=i.toLowerCase(),t=t.toLowerCase()),i.indexOf(t))}e.indexOfPath=n;function s(i){const t=i.split(":");let o,a,u;if(t.forEach(g=>{const b=Number(g);(0,R.isNumber)(b)?a===void 0?a=b:u===void 0&&(u=b):o=o?[o,g].join(":"):g}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:a!==void 0?a:void 0,column:u!==void 0?u:a!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,17]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(E){if(!E||typeof E!="object"||E instanceof RegExp)return E;const S=Array.isArray(E)?[]:{};return Object.keys(E).forEach(m=>{E[m]&&typeof E[m]=="object"?S[m]=T(E[m]):S[m]=E[m]}),S}e.deepClone=T;function D(E){if(!E||typeof E!="object")return E;const S=[E];for(;S.length>0;){const m=S.shift();Object.freeze(m);for(const v in m)if(R.call(m,v)){const d=m[v];typeof d=="object"&&!Object.isFrozen(d)&&S.push(d)}}return E}e.deepFreeze=D;const R=Object.prototype.hasOwnProperty;function r(E,S){return P(E,S,new Set)}e.cloneAndChange=r;function P(E,S,m){if((0,k.isUndefinedOrNull)(E))return E;const v=S(E);if(typeof v!="undefined")return v;if((0,k.isArray)(E)){const d=[];for(const c of E)d.push(P(c,S,m));return d}if((0,k.isObject)(E)){if(m.has(E))throw new Error("Cannot clone recursive data-structure");m.add(E);const d={};for(let c in E)R.call(E,c)&&(d[c]=P(E[c],S,m));return m.delete(E),d}return E}function y(E,S,m=!0){return(0,k.isObject)(E)?((0,k.isObject)(S)&&Object.keys(S).forEach(v=>{v in E?m&&((0,k.isObject)(E[v])&&(0,k.isObject)(S[v])?y(E[v],S[v],m):E[v]=S[v]):E[v]=S[v]}),E):S}e.mixin=y;function C(E,S){if(E===S)return!0;if(E==null||S===null||S===void 0||typeof E!=typeof S||typeof E!="object"||Array.isArray(E)!==Array.isArray(S))return!1;let m,v;if(Array.isArray(E)){if(E.length!==S.length)return!1;for(m=0;m<E.length;m++)if(!C(E[m],S[m]))return!1}else{const d=[];for(v in E)d.push(v);d.sort();const c=[];for(v in S)c.push(v);if(c.sort(),!C(d,c))return!1;for(m=0;m<d.length;m++)if(!C(E[d[m]],S[d[m]]))return!1}return!0}e.equals=C;function I(E){const S=new Set;return JSON.stringify(E,(m,v)=>{if((0,k.isObject)(v)||Array.isArray(v)){if(S.has(v))return"[Circular]";S.add(v)}return v})}e.safeStringify=I;function w(E,S,m){const v=S(E);return typeof v=="undefined"?m:v}e.getOrDefault=w;function f(E,S){const m=Object.create(null);return!E||!S||Object.keys(S).forEach(d=>{const c=E[d],l=S[d];C(c,l)||(m[d]=l)}),m}e.distinct=f;function p(E,S){const m=S.toLowerCase(),v=Object.keys(E).find(d=>d.toLowerCase()===m);return v?E[v]:E[S]}e.getCaseInsensitive=p;function h(E,S){const m=Object.create(null);for(const[v,d]of Object.entries(E))S(v,d)&&(m[v]=d);return m}e.filter=h}),define(te[8],ne([0,1,9,4]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,R=/^\//,r=/^\/\//;function P(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!D.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(r.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(i,t){return!i&&!t?"file":i}function C(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==w&&(t=w+t):t=w;break}return t}const I="",w="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,o,a,u,g,b=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=y(t,b),this.authority=o||I,this.path=C(this.scheme,a||I),this.query=u||I,this.fragment=g||I,P(this,b))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return d(this,!1)}with(t){if(!t)return this;let{scheme:o,authority:a,path:u,query:g,fragment:b}=t;return o===void 0?o=this.scheme:o===null&&(o=I),a===void 0?a=this.authority:a===null&&(a=I),u===void 0?u=this.path:u===null&&(u=I),g===void 0?g=this.query:g===null&&(g=I),b===void 0?b=this.fragment:b===null&&(b=I),o===this.scheme&&a===this.authority&&u===this.path&&g===this.query&&b===this.fragment?this:new E(o,a,u,g,b)}static parse(t,o=!1){const a=f.exec(t);return a?new E(a[2]||I,s(a[4]||I),s(a[5]||I),s(a[7]||I),s(a[9]||I),o):new E(I,I,I,I,I)}static file(t){let o=I;if(T.isWindows&&(t=t.replace(/\\/g,w)),t[0]===w&&t[1]===w){const a=t.indexOf(w,2);a===-1?(o=t.substring(2),t=w):(o=t.substring(2,a),t=t.substring(a)||w)}return new E("file",o,t,I,I)}static from(t){const o=new E(t.scheme,t.authority,t.path,t.query,t.fragment);return P(o,!0),o}static joinPath(t,...o){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return T.isWindows&&t.scheme==="file"?a=p.file(k.win32.join(d(t,!0),...o)).path:a=k.posix.join(t.path,...o),t.with({path:a})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const o=new E(t);return o._formatted=t.external,o._fsPath=t._sep===h?t.fsPath:null,o}}else return t}}e.URI=p;const h=T.isWindows?1:void 0;class E extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(i,t){let o,a=-1;for(let u=0;u<i.length;u++){const g=i.charCodeAt(u);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||t&&g===47)a!==-1&&(o+=encodeURIComponent(i.substring(a,u)),a=-1),o!==void 0&&(o+=i.charAt(u));else{o===void 0&&(o=i.substr(0,u));const b=S[g];b!==void 0?(a!==-1&&(o+=encodeURIComponent(i.substring(a,u)),a=-1),o+=b):a===-1&&(a=u)}}return a!==-1&&(o+=encodeURIComponent(i.substring(a))),o!==void 0?o:i}function v(i){let t;for(let o=0;o<i.length;o++){const a=i.charCodeAt(o);a===35||a===63?(t===void 0&&(t=i.substr(0,o)),t+=S[a]):t!==void 0&&(t+=i[o])}return t!==void 0?t:i}function d(i,t){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,T.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=d;function c(i,t){const o=t?v:m;let a="",{scheme:u,authority:g,path:b,query:A,fragment:O}=i;if(u&&(a+=u,a+=":"),(g||u==="file")&&(a+=w,a+=w),g){let U=g.indexOf("@");if(U!==-1){const x=g.substr(0,U);g=g.substr(U+1),U=x.indexOf(":"),U===-1?a+=o(x,!1):(a+=o(x.substr(0,U),!1),a+=":",a+=o(x.substr(U+1),!1)),a+="@"}g=g.toLowerCase(),U=g.indexOf(":"),U===-1?a+=o(g,!1):(a+=o(g.substr(0,U),!1),a+=g.substr(U))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const U=b.charCodeAt(1);U>=65&&U<=90&&(b=`/${String.fromCharCode(U+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const U=b.charCodeAt(0);U>=65&&U<=90&&(b=`${String.fromCharCode(U+32)}:${b.substr(2)}`)}a+=o(b,!0)}return A&&(a+="?",a+=o(A,!1)),O&&(a+="#",a+=t?O:m(O,!1)),a}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(n)?i.replace(n,t=>l(t)):i}}),define(te[107],ne([0,1,8]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function T(C){const I=C;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=T;function D(C){const I=[];let w;try{const f=JSON.parse(C.arguments),p=f[f.length-1];p&&p.__$stack&&(f.pop(),w=p.__$stack),I.push(...f)}catch(f){I.push("Unable to log remote console arguments",C.arguments)}return{args:I,stack:w}}e.parse=D;function R(C){if(typeof C!="string")return R(D(C).stack);const I=C;if(I){const w=r(I),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(f&&f.length===4)return{uri:k.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=R;function r(C){if(!C)return C;const I=C.indexOf(`
`);return I===-1?C:C.substring(0,I)}function P(C,I){const{args:w,stack:f}=D(C),p=typeof w[0]=="string"&&w.length===1;let h=r(f);h&&(h=`(${h.trim()})`);let E=[];if(typeof w[0]=="string"?h&&p?E=[`%c[${I}] %c${w[0]} %c${h}`,y("blue"),y(""),y("grey")]:E=[`%c[${I}] %c${w[0]}`,y("blue"),y(""),...w.slice(1)]:E=[`%c[${I}]%`,y("blue"),...w],h&&!p&&E.push(h),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,E)}e.log=P;function y(C){return`color: ${C}`}}),define(te[108],ne([0,1,19,25,8]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function R(I){return JSON.stringify(I,y)}e.stringify=R;function r(I){let w=JSON.parse(I);return w=C(w),w}e.parse=r;var P;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function y(I,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,T.regExpFlags)(w)}:w}function C(I,w=0){if(!I||w>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return D.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof k.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let f=0;f<I.length;++f)I[f]=C(I[f],w+1);else for(const f in I)Object.hasOwnProperty.call(I,f)&&(I[f]=C(I[f],w+1))}return I}e.revive=C}),define(te[15],ne([0,1,4,8]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,C,I){this._hosts[y]=C,this._ports[y]=I}setConnectionToken(y,C){this._connectionTokens[y]=C}rewrite(y){if(this._delegate)return this._delegate(y);const C=y.authority;let I=this._hosts[C];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const w=this._ports[C],f=this._connectionTokens[C];let p=`path=${encodeURIComponent(y.path)}`;return typeof f=="string"&&(p+=`&tkn=${encodeURIComponent(f)}`),T.URI.from({scheme:k.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${I}:${w}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new R;class r{asBrowserUri(y,C){const I=this.toUri(y,C);return I.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===D.file&&(k.isNative||typeof k.globals.importScripts=="function"&&k.globals.origin===`${D.vscodeFileResource}://${r.FALLBACK_AUTHORITY}`)?I.with({scheme:D.vscodeFileResource,authority:I.authority||r.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(y,C){const I=this.toUri(y,C);return I.scheme===D.vscodeFileResource?I.with({scheme:D.file,authority:I.authority!==r.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(y,C){return T.URI.isUri(y)?y:T.URI.parse(C.toUrl(y))}}r.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new r}),define(te[18],ne([0,1,42,15,9,4,25,8]),function(X,e,k,T,D,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(p){return(0,P.uriToFsPath)(p,!0)}e.originalFSPath=y;class C{constructor(h){this._ignorePathCasing=h}compare(h,E,S=!1){return h===E?0:(0,r.compare)(this.getComparisonKey(h,S),this.getComparisonKey(E,S))}isEqual(h,E,S=!1){return h===E?!0:!h||!E?!1:this.getComparisonKey(h,S)===this.getComparisonKey(E,S)}getComparisonKey(h,E=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,E,S=!1){if(h.scheme===E.scheme){if(h.scheme===T.Schemas.file)return k.isEqualOrParent(y(h),y(E),this._ignorePathCasing(h))&&h.query===E.query&&(S||h.fragment===E.fragment);if((0,e.isEqualAuthority)(h.authority,E.authority))return k.isEqualOrParent(h.path,E.path,this._ignorePathCasing(h),"/")&&h.query===E.query&&(S||h.fragment===E.fragment)}return!1}joinPath(h,...E){return P.URI.joinPath(h,...E)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let E;return h.scheme===T.Schemas.file?E=P.URI.file(D.dirname(y(h))).path:(E=D.posix.dirname(h.path),h.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),E="/")),h.with({path:E})}normalizePath(h){if(!h.path.length)return h;let E;return h.scheme===T.Schemas.file?E=P.URI.file(D.normalize(y(h))).path:E=D.posix.normalize(h.path),h.with({path:E})}relativePath(h,E){if(h.scheme!==E.scheme||!(0,e.isEqualAuthority)(h.authority,E.authority))return;if(h.scheme===T.Schemas.file){const v=D.relative(y(h),y(E));return R.isWindows?k.toSlashes(v):v}let S=h.path||"/",m=E.path||"/";if(this._ignorePathCasing(h)){let v=0;for(const d=Math.min(S.length,m.length);v<d&&!(S.charCodeAt(v)!==m.charCodeAt(v)&&S.charAt(v).toLowerCase()!==m.charAt(v).toLowerCase());v++);S=m.substr(0,v)+S.substr(v)}return D.posix.relative(S,m)}resolvePath(h,E){if(h.scheme===T.Schemas.file){const S=P.URI.file(D.resolve(y(h),E));return h.with({authority:S.authority,path:S.path})}return E=k.toPosixPath(E),h.with({path:D.posix.resolve(h.path,E)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,E){return h===E||h!==void 0&&E!==void 0&&(0,r.equalsIgnoreCase)(h,E)}hasTrailingPathSeparator(h,E=D.sep){if(h.scheme===T.Schemas.file){const S=y(h);return S.length>k.getRoot(S).length&&S[S.length-1]===E}else{const S=h.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,E=D.sep){return(0,e.hasTrailingPathSeparator)(h,E)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,E=D.sep){let S=!1;if(h.scheme===T.Schemas.file){const m=y(h);S=m!==void 0&&m.length===k.getRoot(m).length&&m[m.length-1]===E}else{E="/";const m=h.path;S=m.length===1&&m.charCodeAt(m.length-1)===47}return!S&&!(0,e.hasTrailingPathSeparator)(h,E)?h.with({path:h.path+"/"}):h}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(p=>p.scheme===T.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new C(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(p,h){const E=[];for(let S=0;S<p.length;S++){const m=h(p[S]);p.some((v,d)=>d===S?!1:(0,e.isEqualOrParent)(m,h(v)))||E.push(p[S])}return E}e.distinctParents=I;var w;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(E){const S=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(d=>{const[c,l]=d.split(":");c&&l&&S.set(c,l)});const v=E.path.substring(0,E.path.indexOf(";"));return v&&S.set(p.META_DATA_MIME,v),S}p.parseMetaData=h})(w=e.DataUri||(e.DataUri={}));function f(p,h,E){if(h){let S=p.path;return S&&S[0]!==D.posix.sep&&(S=D.posix.sep+S),p.with({scheme:E,authority:h,path:S})}return p.with({scheme:E})}e.toLocalResource=f}),define(te[5],ne([0,1,28,7,3,2,18]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(W){return!!W&&typeof W.then=="function"}e.isThenable=P;function y(W){const j=new k.CancellationTokenSource,q=W(j.token),z=new Promise((K,F)=>{const B=j.token.onCancellationRequested(()=>{B.dispose(),j.dispose(),F((0,T.canceled)())});Promise.resolve(q).then(V=>{B.dispose(),j.dispose(),K(V)},V=>{B.dispose(),j.dispose(),F(V)})});return new class{cancel(){j.cancel()}then(K,F){return z.then(K,F)}catch(K){return this.then(void 0,K)}finally(K){return z.finally(K)}}}e.createCancelablePromise=y;function C(W,j,q){return Promise.race([W,new Promise(z=>j.onCancellationRequested(()=>z(q)))])}e.raceCancellation=C;async function I(W){let j=-1;const q=W.map((K,F)=>K.then(B=>(j=F,B))),z=await Promise.race(q);return W.forEach((K,F)=>{F!==j&&K.cancel()}),z}e.raceCancellablePromises=I;function w(W,j,q){let z;const K=setTimeout(()=>{z?.(void 0),q?.()},j);return Promise.race([W.finally(()=>clearTimeout(K)),new Promise(F=>z=F)])}e.raceTimeout=w;function f(W){return new Promise((j,q)=>{const z=W();P(z)?z.then(j,q):j(z)})}e.asPromise=f;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(j){if(this.activePromise){if(this.queuedPromiseFactory=j,!this.queuedPromise){const q=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(q,q).then(z)})}return new Promise((q,z)=>{this.queuedPromise.then(q,z)})}return this.activePromise=j(),new Promise((q,z)=>{this.activePromise.then(K=>{this.activePromise=null,q(K)},K=>{this.activePromise=null,z(K)})})}}e.Throttler=p;class h{constructor(){this.current=Promise.resolve(null)}queue(j){return this.current=this.current.then(()=>j(),()=>j())}}e.Sequencer=h;class E{constructor(){this.promiseMap=new Map}queue(j,q){const K=(this.promiseMap.get(j)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.promiseMap.get(j)===K&&this.promiseMap.delete(j)});return this.promiseMap.set(j,K),K}}e.SequencerByKey=E;class S{constructor(j){this.defaultDelay=j,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(j,q=this.defaultDelay){return this.task=j,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,K)=>{this.doResolve=z,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},q),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,T.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=S;class m{constructor(j){this.delayer=new S(j),this.throttler=new p}trigger(j,q){return this.delayer.trigger(()=>this.throttler.queue(j),q)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=m;class v{constructor(){this._isOpen=!1,this._promise=new Promise((j,q)=>{this._completePromise=j})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class d extends v{constructor(j){super();this._timeout=setTimeout(()=>this.open(),j)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function c(W,j){return j?new Promise((q,z)=>{const K=setTimeout(()=>{F.dispose(),q()},W),F=j.onCancellationRequested(()=>{clearTimeout(K),F.dispose(),z((0,T.canceled)())})}):y(q=>c(W,q))}e.timeout=c;function l(W,j=0){const q=setTimeout(W,j);return(0,R.toDisposable)(()=>clearTimeout(q))}e.disposableTimeout=l;function n(W){const j=[];let q=0;const z=W.length;function K(){return q<z?W[q++]():null}function F(B){B!=null&&j.push(B);const V=K();return V?V.then(F):Promise.resolve(j)}return Promise.resolve(null).then(F)}e.sequence=n;function s(W,j=z=>!!z,q=null){let z=0;const K=W.length,F=()=>{if(z>=K)return Promise.resolve(q);const B=W[z++];return Promise.resolve(B()).then(Q=>j(Q)?Promise.resolve(Q):F())};return F()}e.first=s;function i(W,j=z=>!!z,q=null){if(W.length===0)return Promise.resolve(q);let z=W.length;const K=()=>{z=-1;for(const F of W)F.cancel?.()};return new Promise((F,B)=>{for(const V of W)V.then(Q=>{--z>=0&&j(Q)?(K(),F(Q)):z===0&&F(q)}).catch(Q=>{--z>=0&&(K(),B(Q))})})}e.firstParallel=i;class t{constructor(j){this._size=0,this.maxDegreeOfParalellism=j,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(j){return this._size++,new Promise((q,z)=>{this.outstandingPromises.push({factory:j,c:q,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const j=this.outstandingPromises.shift();this.runningPromises++;const q=j.factory();q.then(j.c,j.e),q.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class o extends t{constructor(){super(1)}}e.Queue=o;class a{constructor(){this.queues=new Map}queueFor(j,q=r.extUri){const z=q.getComparisonKey(j);let K=this.queues.get(z);return K||(K=new o,D.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete(z)}),this.queues.set(z,K)),K}dispose(){this.queues.forEach(j=>j.dispose()),this.queues.clear()}}e.ResourceQueue=a;class u{constructor(j,q){this._token=-1,typeof j=="function"&&typeof q=="number"&&this.setIfNotSet(j,q)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(j,q){this.cancel(),this._token=setTimeout(()=>{this._token=-1,j()},q)}setIfNotSet(j,q){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,j()},q))}}e.TimeoutTimer=u;class g{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(j,q){this.cancel(),this._token=setInterval(()=>{j()},q)}}e.IntervalTimer=g;class b{constructor(j,q){this.timeoutToken=-1,this.runner=j,this.timeout=q,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(j=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,j)}get delay(){return this.timeout}set delay(j){this.timeout=j}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=b;class A{constructor(j,q){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.runner=j,this.timeout=q,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(j=this.timeout){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(j/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class O extends b{constructor(j,q){super(j,q);this.units=[]}work(j){this.units.push(j),this.isScheduled()||this.schedule()}doRun(){const j=this.units;this.units=[],this.runner&&this.runner(j)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class U extends R.Disposable{constructor(j,q,z,K){super();this.maxWorkChunkSize=j,this.maxPendingWork=q,this.throttleDelay=z,this.handler=K,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(j){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+j.length>this.maxPendingWork)return!1}else if(this.pending+j.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...j),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new b(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{const j=setTimeout(()=>{const z=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0,clearTimeout(j))}}}:e.runWhenIdle=(W,j)=>{const q=requestIdleCallback(W,typeof j=="number"?{timeout:j}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(q))}}}}();class x{constructor(j){this._didRun=!1,this._executor=()=>{try{this._value=j()}catch(q){this._error=q}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function N(W,j,q){let z;for(let K=0;K<q;K++)try{return await W()}catch(F){z=F,await c(j)}throw z}e.retry=N;class L{hasPending(j){return this._pending?typeof j=="number"?this._pending.taskId===j:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(j,q,z){return this._pending={taskId:j,cancel:()=>z?.(),promise:q},q.then(()=>this.donePending(j),()=>this.donePending(j)),q}donePending(j){this._pending&&j===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const j=this._next;this._next=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}setNext(j){if(this._next)this._next.run=j;else{let q,z;const K=new Promise((F,B)=>{q=F,z=B});this._next={run:j,promise:K,promiseResolve:q,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=L;class ${constructor(j){this.interval=j,this.lastIncrementTime=0,this.value=0}increment(){const j=Date.now();return j-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=j,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((j,q)=>{this.completeCallback=j,this.errorCallback=q})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(j){return new Promise(q=>{this.completeCallback(j),this.resolved=!0,q()})}error(j){return new Promise(q=>{this.errorCallback(j),this.rejected=!0,q()})}cancel(){new Promise(j=>{this.errorCallback((0,T.canceled)()),this.rejected=!0,j()})}}e.DeferredPromise=_;var M;(function(W){async function j(z){let K;const F=await Promise.all(z.map(B=>B.then(V=>V,V=>{K||(K=V)})));if(typeof K!="undefined")throw K;return F}W.settled=j;function q(z){return new Promise(async(K,F)=>{try{await z(K,F)}catch(B){F(B)}})}W.withAsyncBody=q})(M=e.Promises||(e.Promises={}))}),define(te[109],ne([0,1,5,42,41,9,25]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const y="**",C="/",I="[/\\\\]",w="[^/\\\\]",f=/\//g;function p(z){switch(z){case 0:return"";case 1:return`${w}*?`;default:return`(?:${I}|${w}+${I}|${I}${w}+)*?`}}function h(z,K){if(!z)return[];const F=[];let B=!1,V=!1,Q="";for(const Z of z){switch(Z){case K:if(!B&&!V){F.push(Q),Q="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":V=!0;break;case"]":V=!1;break}Q+=Z}return Q&&F.push(Q),F}e.splitGlobAware=h;function E(z){if(!z)return"";let K="";const F=h(z,C);if(F.every(B=>B===y))K=".*";else{let B=!1;F.forEach((V,Q)=>{if(V===y){B||(K+=p(2),B=!0);return}let Z=!1,G="",H=!1,re="";for(const ie of V){if(ie!=="}"&&Z){G+=ie;continue}if(H&&(ie!=="]"||!re)){let ce;ie==="-"?ce=ie:(ie==="^"||ie==="!")&&!re?ce="^":ie===C?ce="":ce=r.escapeRegExpCharacters(ie),re+=ce;continue}switch(ie){case"{":Z=!0;continue;case"[":H=!0;continue;case"}":K+=`(?:${h(G,",").map(fe=>E(fe)).join("|")})`,Z=!1,G="";break;case"]":K+="["+re+"]",H=!1,re="";break;case"?":K+=w;continue;case"*":K+=p(1);continue;default:K+=r.escapeRegExpCharacters(ie)}}Q<F.length-1&&(F[Q+1]!==y||Q+2<F.length)&&(K+=I),B=!1})}return K}const S=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new D.LRUCache(1e4),s=function(){return!1},i=function(){return null};function t(z,K){if(!z)return i;let F;typeof z!="string"?F=z.pattern:F=z,F=F.trim();const B=`${F}_${!!K.trimForExclusions}`;let V=n.get(B);if(V)return o(V,z);let Q;if(S.test(F)){const Z=F.substr(4);V=function(G,H){return typeof G=="string"&&G.endsWith(Z)?F:null}}else(Q=m.exec(a(F,K)))?V=u(Q[1],F):(K.trimForExclusions?d:v).test(F)?V=g(F,K):(Q=c.exec(a(F,K)))?V=b(Q[1].substr(1),F,!0):(Q=l.exec(a(F,K)))?V=b(Q[1],F,!1):V=A(F);return n.set(B,V),o(V,z)}function o(z,K){return typeof K=="string"?z:function(F,B){return T.isEqualOrParent(F,K.base)?z(R.relative(K.base,F),B):null}}function a(z,K){return K.trimForExclusions&&z.endsWith("/**")?z.substr(0,z.length-2):z}function u(z,K){const F=`/${z}`,B=`\\${z}`,V=function(Z,G){return typeof Z!="string"?null:G?G===z?K:null:Z===z||Z.endsWith(F)||Z.endsWith(B)?K:null},Q=[z];return V.basenames=Q,V.patterns=[K],V.allBasenames=Q,V}function g(z,K){const F=q(z.slice(1,-1).split(",").map(G=>t(G,K)).filter(G=>G!==i),z),B=F.length;if(!B)return i;if(B===1)return F[0];const V=function(G,H){for(let re=0,ie=F.length;re<ie;re++)if(F[re](G,H))return z;return null},Q=F.find(G=>!!G.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=F.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(V.allPaths=Z),V}function b(z,K,F){const B=R.sep===R.posix.sep,V=B?z:z.replace(f,R.sep),Q=R.sep+V,Z=R.posix.sep+z,G=F?function(H,re){return typeof H=="string"&&(H===V||H.endsWith(Q)||!B&&(H===z||H.endsWith(Z)))?K:null}:function(H,re){return typeof H=="string"&&(H===V||!B&&H===z)?K:null};return G.allPaths=[(F?"*/":"./")+z],G}function A(z){try{const K=new RegExp(`^${E(z)}$`);return function(F){return K.lastIndex=0,typeof F=="string"&&K.test(F)?z:null}}catch(K){return i}}function O(z,K,F){return!z||typeof K!="string"?!1:U(z)(K,void 0,F)}e.match=O;function U(z,K={}){if(!z)return s;if(typeof z=="string"||$(z)){const F=t(z,K);if(F===i)return s;const B=function(V,Q){return!!F(V,Q)};return F.allBasenames&&(B.allBasenames=F.allBasenames),F.allPaths&&(B.allPaths=F.allPaths),B}return W(z,K)}e.parse=U;function x(z){if(!z)return;let K;return F=>(K||(K=(z()||Promise.resolve([])).then(B=>B?L(B):{})),K.then(B=>!!B[F]))}e.hasSiblingPromiseFn=x;function N(z){if(!z)return;let K;return F=>{if(!K){const B=z();K=B?L(B):{}}return!!K[F]}}e.hasSiblingFn=N;function L(z){const K={};for(const F of z)K[F]=!0;return K}function $(z){const K=z;return K&&typeof K.base=="string"&&typeof K.pattern=="string"}e.isRelativePattern=$;function _(z){return z.allBasenames||[]}e.getBasenameTerms=_;function M(z){return z.allPaths||[]}e.getPathTerms=M;function W(z,K){const F=q(Object.getOwnPropertyNames(z).map(G=>j(G,z[G],K)).filter(G=>G!==i)),B=F.length;if(!B)return i;if(!F.some(G=>!!G.requiresSiblings)){if(B===1)return F[0];const G=function(ie,ce){for(let le=0,fe=F.length;le<fe;le++){const de=F[le](ie,ce);if(de)return de}return null},H=F.find(ie=>!!ie.allBasenames);H&&(G.allBasenames=H.allBasenames);const re=F.reduce((ie,ce)=>ce.allPaths?ie.concat(ce.allPaths):ie,[]);return re.length&&(G.allPaths=re),G}const V=function(G,H,re){let ie;for(let ce=0,le=F.length;ce<le;ce++){const fe=F[ce];fe.requiresSiblings&&re&&(H||(H=R.basename(G)),ie||(ie=H.substr(0,H.length-R.extname(G).length)));const de=fe(G,H,ie,re);if(de)return de}return null},Q=F.find(G=>!!G.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const Z=F.reduce((G,H)=>H.allPaths?G.concat(H.allPaths):G,[]);return Z.length&&(V.allPaths=Z),V}function j(z,K,F){if(K===!1)return i;const B=t(z,F);if(B===i)return i;if(typeof K=="boolean")return B;if(K){const V=K.when;if(typeof V=="string"){const Q=(Z,G,H,re)=>{if(!re||!B(Z,G))return null;const ie=V.replace("$(basename)",H),ce=re(ie);return(0,k.isThenable)(ce)?ce.then(le=>le?z:null):ce?z:null};return Q.requiresSiblings=!0,Q}}return B}function q(z,K){const F=z.filter(G=>!!G.basenames);if(F.length<2)return z;const B=F.reduce((G,H)=>{const re=H.basenames;return re?G.concat(re):G},[]);let V;if(K){V=[];for(let G=0,H=B.length;G<H;G++)V.push(K)}else V=F.reduce((G,H)=>{const re=H.patterns;return re?G.concat(re):G},[]);const Q=function(G,H){if(typeof G!="string")return null;if(!H){let ie;for(ie=G.length;ie>0;ie--){const ce=G.charCodeAt(ie-1);if(ce===47||ce===92)break}H=G.substr(ie)}const re=B.indexOf(H);return re!==-1?V[re]:null};Q.basenames=B,Q.patterns=V,Q.allBasenames=B;const Z=z.filter(G=>!G.basenames);return Z.push(Q),Z}}),define(te[110],ne([0,1,109,15,9,18,25]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(P=e.Mimes||(e.Mimes={}));let y=[],C=[],I=[];function w(t,o=!1){const a=f(t);y.push(a),a.userConfigured?I.push(a):C.push(a),o&&!a.userConfigured&&y.forEach(u=>{u.mime===a.mime||u.userConfigured||(a.extension&&u.extension===a.extension&&console.warn(`Overwriting extension <<${a.extension}>> to now point to mime <<${a.mime}>>`),a.filename&&u.filename===a.filename&&console.warn(`Overwriting filename <<${a.filename}>> to now point to mime <<${a.mime}>>`),a.filepattern&&u.filepattern===a.filepattern&&console.warn(`Overwriting filepattern <<${a.filepattern}>> to now point to mime <<${a.mime}>>`),a.firstline&&u.firstline===a.firstline&&console.warn(`Overwriting firstline <<${a.firstline}>> to now point to mime <<${a.mime}>>`))})}e.registerTextMime=w;function f(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,k.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(D.posix.sep)>=0:!1}}function p(t){t?(y=y.filter(o=>!o.userConfigured),I=[]):(y=[],C=[],I=[])}e.clearTextMimes=p;function h(t,o){let a;if(t)switch(t.scheme){case T.Schemas.file:a=t.fsPath;break;case T.Schemas.data:a=R.DataUri.parseMetaData(t).get(R.DataUri.META_DATA_LABEL);break;default:a=t.path}if(!a)return[P.unknown];a=a.toLowerCase();const u=(0,D.basename)(a),g=E(a,u,I);if(g)return[g,P.text];const b=E(a,u,C);if(b)return[b,P.text];if(o){const A=S(o);if(A)return[A,P.text]}return[P.unknown]}e.guessMimeTypes=h;function E(t,o,a){let u=null,g=null,b=null;for(let A=a.length-1;A>=0;A--){const O=a[A];if(o===O.filenameLowercase){u=O;break}if(O.filepattern&&(!g||O.filepattern.length>g.filepattern.length)){const U=O.filepatternOnPath?t:o;O.filepatternLowercase?.(U)&&(g=O)}O.extension&&(!b||O.extension.length>b.extension.length)&&o.endsWith(O.extensionLowercase)&&(b=O)}return u?u.mime:g?g.mime:b?b.mime:null}function S(t){if((0,r.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let o=y.length-1;o>=0;o--){const a=y[o];if(!a.firstline)continue;const u=t.match(a.firstline);if(u&&u.length>0)return a.mime}return null}function m(t){return t?typeof t=="string"?t===P.binary||t===P.text||t===P.unknown:t.length===1&&m(t[0]):!0}e.isUnspecific=m;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},d={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function c(t){const o=(0,D.extname)(t),a=v[o.toLowerCase()];return a!==void 0?a:l(t)}e.getMediaOrTextMime=c;function l(t){const o=(0,D.extname)(t);return d[o.toLowerCase()]}e.getMediaMime=l;function n(t){for(const o in d)if(d[o]===t)return o}e.getExtensionForMimeType=n;const s=/^(.+)\/(.+?)(;.+)?$/;function i(t,o){const a=s.exec(t);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:o?void 0:t}e.normalizeMimeType=i}),define(te[111],ne([0,1,8]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(I){return I.toJSON()}class D{constructor(w){this._uriTransformer=w}transformIncoming(w){const f=this._uriTransformer.transformIncoming(w);return f===w?w:T(k.URI.from(f))}transformOutgoing(w){const f=this._uriTransformer.transformOutgoing(w);return f===w?w:T(k.URI.from(f))}transformOutgoingURI(w){const f=this._uriTransformer.transformOutgoing(w);return f===w?w:k.URI.from(f)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,w,f){if(!I||f>200)return null;if(typeof I=="object"){if(I instanceof k.URI)return w.transformOutgoing(I);for(let p in I)if(Object.hasOwnProperty.call(I,p)){const h=R(I[p],w,f+1);h!==null&&(I[p]=h)}}return null}function r(I,w){const f=R(I,w,0);return f===null?I:f}e.transformOutgoingURIs=r;function P(I,w,f,p){if(!I||p>200)return null;if(typeof I=="object"){if(I.$mid===1)return f?k.URI.revive(w.transformIncoming(I)):w.transformIncoming(I);for(let h in I)if(Object.hasOwnProperty.call(I,h)){const E=P(I[h],w,f,p+1);E!==null&&(I[h]=E)}}return null}function y(I,w){const f=P(I,w,!1,0);return f===null?I:f}e.transformIncomingURIs=y;function C(I,w){const f=P(I,w,!0,0);return f===null?I:f}e.transformAndReviveIncomingURIs=C}),define(te[29],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(y){return k.test(y)}e.isUUID=T;const D=new Uint8Array(16),R=[];for(let y=0;y<256;y++)R.push(y.toString(16).padStart(2,"0"));let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(y){for(let C=0;C<y.length;C++)y[C]=Math.floor(Math.random()*256);return y};function P(){r(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let y=0,C="";return C+=R[D[y++]],C+=R[D[y++]],C+=R[D[y++]],C+=R[D[y++]],C+="-",C+=R[D[y++]],C+=R[D[y++]],C+="-",C+=R[D[y++]],C+=R[D[y++]],C+="-",C+=R[D[y++]],C+=R[D[y++]],C+="-",C+=R[D[y++]],C+=R[D[y++]],C+=R[D[y++]],C+=R[D[y++]],C+=R[D[y++]],C+=R[D[y++]],C}e.generateUuid=P}),define(te[112],ne([0,1,113]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class T{constructor(R="utf8"){this.stringDecoder=new k.StringDecoder(R),this.remaining=null}write(R){const r=[],P=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(P.length<1)return r;let y=0,C,I=y;for(;I<P.length;)if(C=P.charCodeAt(I),C===13||C===10){if(r.push(P.substring(y,I)),I++,I<P.length){const w=C;C=P.charCodeAt(I),(w===13&&C===10||w===10&&C===13)&&I++}y=I}else I++;return this.remaining=y<P.length?P.substr(y):null,r}end(){return this.remaining}}e.LineDecoder=T}),define(te[114],ne([0,1,33]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(r){const P=r.replace(/\-/g,":").toLowerCase();return!T.has(P)}function R(){const r=(0,k.networkInterfaces)();for(let P in r){const y=r[P];if(y){for(const{mac:C}of y)if(D(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(te[115],ne([0,1,33,7,41,29,114]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,w=0;const f=(0,k.networkInterfaces)();for(let p in f){const h=f[p];if(h)for(const{mac:E,internal:S}of h)S||(w+=1,this._isVirtualMachineMacAddress(E.toUpperCase())&&(I+=1))}this._value=w>0?I/w:0}return this._value}};let P;async function y(){return P||(P=(async()=>await C()||R.generateUuid())()),P}e.getMachineId=y;async function C(){try{const I=await new Promise((f,p)=>{X(["crypto"],f,p)}),w=(0,r.getMac)();return I.createHash("sha256").update(w,"utf8").digest("hex")}catch(I){T.onUnexpectedError(I);return}}}),define(te[20],ne([0,1,51,33,246,5,42,71,9,4,18,8,29]),function(X,e,k,T,D,R,r,P,y,C,I,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(p=e.RimRafMode||(e.RimRafMode={}));async function h(_,M=p.UNLINK){if((0,r.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");return M===p.UNLINK?S(_):E(_)}async function E(_){try{const M=(0,y.join)((0,T.tmpdir)(),(0,f.generateUuid)());try{await e.Promises.rename(_,M)}catch(W){return S(_)}S(M).catch(W=>{})}catch(M){if(M.code!=="ENOENT")throw M}}async function S(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function m(_){if((0,r.isRootOrDriveLetter)(_))throw new Error("rimraf - will refuse to recursively delete root");k.rmdirSync(_,{recursive:!0})}e.rimrafSync=m;async function v(_,M){return l(await(M?d(_):(0,D.promisify)(k.readdir)(_)))}async function d(_){try{return await(0,D.promisify)(k.readdir)(_,{withFileTypes:!0})}catch(j){console.warn("[node.js fs] readdir with filetypes failed with error: ",j)}const M=[],W=await v(_);for(const j of W){let q=!1,z=!1,K=!1;try{const F=await e.Promises.lstat((0,y.join)(_,j));q=F.isFile(),z=F.isDirectory(),K=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}M.push({name:j,isFile:()=>q,isDirectory:()=>z,isSymbolicLink:()=>K})}return M}function c(_){return l(k.readdirSync(_))}e.readdirSync=c;function l(_){return _.map(M=>typeof M=="string"?C.isMacintosh?(0,P.normalizeNFC)(M):M:(M.name=C.isMacintosh?(0,P.normalizeNFC)(M.name):M.name,M))}async function n(_){const M=await v(_),W=[];for(const j of M)await i.existsDirectory((0,y.join)(_,j))&&W.push(j);return W}function s(_,M=1e3){return new Promise(W=>{let j=!1;const q=setInterval(()=>{j||(j=!0,k.access(_,z=>{j=!1,z&&(clearInterval(q),W(void 0))}))},M)})}e.whenDeleted=s;var i;(function(_){async function M(q){let z;try{if(z=await e.Promises.lstat(q),!z.isSymbolicLink())return{stat:z}}catch(K){}try{return{stat:await e.Promises.stat(q),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(C.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw F}throw K}}_.stat=M;async function W(q){try{const{stat:z,symbolicLink:K}=await _.stat(q);return z.isFile()&&K?.dangling!==!0}catch(z){}return!1}_.existsFile=W;async function j(q){try{const{stat:z,symbolicLink:K}=await _.stat(q);return z.isDirectory()&&K?.dangling!==!0}catch(z){}return!1}_.existsDirectory=j})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new R.ResourceQueue;function o(_,M,W){return t.queueFor(w.URI.file(_),I.extUriBiasedIgnorePathCase).queue(()=>{const j=b(W);return new Promise((q,z)=>u(_,M,j,K=>K?z(K):q()))})}let a=!0;function u(_,M,W,j){if(!a)return k.writeFile(_,M,{mode:W.mode,flag:W.flag},j);k.open(_,W.flag,W.mode,(q,z)=>{if(q)return j(q);k.writeFile(z,M,K=>{if(K)return k.close(z,()=>j(K));k.fdatasync(z,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),a=!1),k.close(z,B=>j(B))))})})}function g(_,M,W){const j=b(W);if(!a)return k.writeFileSync(_,M,{mode:j.mode,flag:j.flag});const q=k.openSync(_,j.flag,j.mode);try{k.writeFileSync(q,M);try{k.fdatasyncSync(q)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),a=!1}}finally{k.closeSync(q)}}e.writeFileSync=g;function b(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function A(_,M){if(_===M)return;async function W(j){try{const q=await e.Promises.lstat(j);if(q.isDirectory()||q.isSymbolicLink())return;await e.Promises.utimes(j,q.atime,new Date)}catch(q){}}try{await e.Promises.rename(_,M),await W(M)}catch(j){if(_.toLowerCase()!==M.toLowerCase()&&j.code==="EXDEV"||_.endsWith("."))await O(_,M,{preserveSymlinks:!1}),await h(_,p.MOVE),await W(M);else throw j}}async function O(_,M,W){return x(_,M,{root:{source:_,target:M},options:W,handledSourcePaths:new Set})}const U=511;async function x(_,M,W){if(W.handledSourcePaths.has(_))return;W.handledSourcePaths.add(_);const{stat:j,symbolicLink:q}=await i.stat(_);if(q){if(W.options.preserveSymlinks)try{return await $(_,M,W)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if(q.dangling)return}return j.isDirectory()?N(_,M,j.mode&U,W):L(_,M,j.mode&U)}async function N(_,M,W,j){await e.Promises.mkdir(M,{recursive:!0,mode:W});const q=await v(_);for(const z of q)await x((0,y.join)(_,z),(0,y.join)(M,z),j)}async function L(_,M,W){await e.Promises.copyFile(_,M),await e.Promises.chmod(M,W)}async function $(_,M,W){let j=await e.Promises.readlink(_);(0,r.isEqualOrParent)(j,W.root.source,!C.isLinux)&&(j=(0,y.join)(W.root.target,j.substr(W.root.source.length+1))),await e.Promises.symlink(j,M)}e.Promises=new class{get access(){return(0,D.promisify)(k.access)}get stat(){return(0,D.promisify)(k.stat)}get lstat(){return(0,D.promisify)(k.lstat)}get utimes(){return(0,D.promisify)(k.utimes)}get read(){return(0,D.promisify)(k.read)}get readFile(){return(0,D.promisify)(k.readFile)}get write(){return(0,D.promisify)(k.write)}get appendFile(){return(0,D.promisify)(k.appendFile)}get fdatasync(){return(0,D.promisify)(k.fdatasync)}get truncate(){return(0,D.promisify)(k.truncate)}get rename(){return(0,D.promisify)(k.rename)}get copyFile(){return(0,D.promisify)(k.copyFile)}get open(){return(0,D.promisify)(k.open)}get close(){return(0,D.promisify)(k.close)}get symlink(){return(0,D.promisify)(k.symlink)}get readlink(){return(0,D.promisify)(k.readlink)}get chmod(){return(0,D.promisify)(k.chmod)}get mkdir(){return(0,D.promisify)(k.mkdir)}get unlink(){return(0,D.promisify)(k.unlink)}get rmdir(){return(0,D.promisify)(k.rmdir)}get realpath(){return(0,D.promisify)(k.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return v}get readDirsInDir(){return n}get writeFile(){return o}get rm(){return h}get move(){return A}get copy(){return O}}}),define(te[116],ne([0,1,51,9,25,20]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function r(I){const w=(0,T.dirname)(I);if(I===w)return I;const f=((0,T.basename)(I)||I).toLowerCase();try{const h=(0,R.readdirSync)(w).filter(E=>E.toLowerCase()===f);if(h.length===1){const E=r(w);if(E)return(0,T.join)(E,h[0])}else if(h.length>1){const E=h.indexOf(f);if(E>=0){const S=r(w);if(S)return(0,T.join)(S,h[E])}}}catch(p){}return null}e.realcaseSync=r;async function P(I){try{return await R.Promises.realpath(I)}catch(w){const f=C(I);return await R.Promises.access(f,k.constants.R_OK),f}}e.realpath=P;function y(I){try{return k.realpathSync(I)}catch(w){const f=C(I);return k.accessSync(f,k.constants.R_OK),f}}e.realpathSync=y;function C(I){return(0,D.rtrim)((0,T.normalize)(I),T.sep)}}),define(te[117],ne([0,1,57]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function T(P,y,C,I=1){let w=!1;return new Promise(f=>{const p=setTimeout(()=>{if(!w)return w=!0,f(0)},C);D(P,y,I,h=>{if(!w)return w=!0,clearTimeout(p),f(h)})})}e.findFreePort=T;function D(P,y,C,I){if(y===0)return I(0);const w=new k.Socket;w.once("connect",()=>(r(w),D(P+C,y-1,C,I))),w.once("data",()=>{}),w.once("error",f=>(r(w),f.code!=="ECONNREFUSED"?D(P+C,y-1,C,I):I(P))),w.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(P,y,C){let I=!1,w,f=1;const p=k.createServer({pauseOnConnect:!0});function h(E,S){I||(I=!0,p.removeAllListeners(),p.close(),w&&clearTimeout(w),S(E))}return new Promise(E=>{w=setTimeout(()=>{h(0,E)},C),p.on("listening",()=>{h(P,E)}),p.on("error",S=>{S&&(S.code==="EADDRINUSE"||S.code==="EACCES")&&f<y?(P++,f++,p.listen(P,"127.0.0.1")):h(0,E)}),p.on("close",()=>{h(0,E)}),p.listen(P,"127.0.0.1")})}e.findFreePortFaster=R;function r(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(y){console.error(y)}}}),define(te[72],ne([0,1,33,9,20]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,r=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var y;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(y||(y={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class w{constructor(l,n,s){this.exePath=l,this.displayName=n,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:c=!1}={}){return c?C===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:c=!1,findPreview:l=!1}={}){const n=f({useAlternateBitness:c});if(!n)return null;const s=T.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(s))return null;let i=-1,t=null;for(const u of await D.Promises.readdir(s)){let g=-1;if(l){const A=u.indexOf("-");if(A<0)continue;const O=u.substring(0,A);if(!R.test(O)||u.substring(A+1)!=="preview")continue;g=parseInt(O,10)}else{if(!R.test(u))continue;g=parseInt(u,10)}if(g<=i)continue;const b=T.join(s,u,"pwsh.exe");!await D.SymlinkSupport.existsFile(b)||(t=b,i=g)}if(!t)return null;const o=n.includes("x86")?" (x86)":"",a=l?" Preview":"";return new w(t,`PowerShell${a}${o}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const l=T.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:n,pwshMsixName:s}=c?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:r,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(l))if(n.test(i)){const t=T.join(l,i,"pwsh.exe");return new w(t,s)}return null}function E(){const c=T.join(k.homedir(),".dotnet","tools","pwsh.exe");return new w(c,".NET Core PowerShell Global Tool")}function S(){const c=T.join(process.env.windir,C===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(c,"Windows PowerShell",!0)}async function*m(){let c=await p();c&&(yield c),c=await p({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=E(),c&&(yield c),c=await p({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await p({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=S(),c&&(yield c)}async function*v(){for await(const c of m())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=v;async function d(){for await(const c of v())return c;return null}e.getFirstAvailablePowerShellInstallation=d}),define(te[118],ne([0,1,43,15]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(r){return new Promise((P,y)=>{let C;const I=new Map;function w(p,h,E,S,m){const v=I.get(h);if(p===r||v){const d={name:f(E),cmd:E,pid:p,ppid:h,load:S,mem:m};I.set(p,d),p===r&&(C=d),v&&(v.children||(v.children=[]),v.children.push(d),v.children.length>1&&(v.children=v.children.sort((c,l)=>c.pid-l.pid)))}}function f(p){const h=/--disable-blink-features=Auxclick/,E=/\\watcher\\win32\\CodeHelper\.exe/,S=/--crashes-directory/,m=/\\pipe\\winpty-control/,v=/conhost\.exe/,d=/--type=([a-zA-Z-]+)/;if(E.exec(p))return"watcherService ";if(S.exec(p))return"electron-crash-reporter";if(m.exec(p))return"winpty-process";if(v.exec(p))return"console-window-host (Windows internal process)";let c=d.exec(p);if(c&&c.length===2)return c[1]==="renderer"?h.exec(p)?"shared-process":"window":c[1];const l=/[a-zA-Z-]+\.js/g;let n="";do c=l.exec(p),c&&(n+=c+" ");while(c);return n&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${n}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,E)=>{X(["windows-process-tree"],h,E)}).then(h=>{h.getProcessList(r,E=>{h.getProcessCpuUsage(E,S=>{const m=new Map;S.forEach(v=>{const d=p(v.commandLine||"");m.set(v.pid,{name:f(d),cmd:d,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),C=m.get(r),C?(m.forEach(v=>{const d=m.get(v.ppid);d&&(d.children||(d.children=[]),d.children.push(v))}),m.forEach(v=>{v.children&&(v.children=v.children.sort((d,c)=>d.pid-c.pid))}),P(C)):y(new Error(`Root process ${r} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[C];const E=[];for(;h.length;){const m=h.shift();m&&(E.push(m.pid),m.children&&(h=h.concat(m.children)))}let S=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);S+=" "+E.join(" "),(0,k.exec)(S,{},(m,v,d)=>{if(m||d)y(m||new Error(d.toString()));else{const c=v.toString().split(`
`);for(let l=0;l<E.length;l++){const n=I.get(E[l]);n.load=parseFloat(c[l])}if(!C){y(new Error(`Root process ${r} not found`));return}P(C)}})};(0,k.exec)("which ps",{},(h,E,S)=>{if(h||S)if(process.platform!=="linux")y(h||new Error(S.toString()));else{const m=JSON.stringify(T.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);(0,k.exec)(m,{},(v,d,c)=>{v||c?y(v||new Error(c.toString())):(R(d,w),p())})}else{const m=E.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,k.exec)(`${m} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,c,l)=>{d||l&&!l.includes("screen size is bogus")?y(d||new Error(l.toString())):(R(c,w),process.platform==="linux"?p():C?P(C):y(new Error(`Root process ${r} not found`)))})}})}})}e.listProcesses=D;function R(r,P){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=r.toString().split(`
`);for(const I of C){const w=y.exec(I.trim());w&&w.length===6&&P(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(te[119],ne([0,1,51,28,42,2,71,9,4,20]),function(X,e,k,T,D,R,r,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function I(h,E,S){return f({path:h,isDirectory:!1},E,S)}e.watchFile=I;function w(h,E,S){return f({path:h,isDirectory:!0},E,S)}e.watchFolder=w,e.CHANGE_BUFFER_DELAY=100;function f(h,E,S){if(y.isMacintosh&&(0,D.isEqualOrParent)(h.path,"/Volumes/"))return S(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const m=(0,P.basename)(h.path),v=new Map;let d=!1,c=[(0,R.toDisposable)(()=>{v.forEach(l=>(0,R.dispose)(l)),v.clear()})];try{const l=(0,k.watch)(h.path);c.push((0,R.toDisposable)(()=>{l.removeAllListeners(),l.close()}));const n=new Set;h.isDirectory&&C.Promises.readdir(h.path).then(s=>s.forEach(i=>n.add(i))),l.on("error",(s,i)=>{d||S(`Failed to watch ${h.path} for changes using fs.watch() (${s}, ${i})`)}),l.on("change",(s,i)=>{if(d)return;let t="";if(i&&(t=i.toString(),y.isMacintosh&&(t=(0,r.normalizeNFC)(t))),!t||s!=="change"&&s!=="rename")return;const o=h.isDirectory?(0,P.join)(h.path,t):h.path;if(h.isDirectory)if(s==="rename"){const a=v.get(o);a&&(0,R.dispose)(a);const u=setTimeout(async()=>{v.delete(o);const g=await C.Promises.exists(o);if(d)return;let b;g?n.has(t)?b="changed":(b="added",n.add(t)):(n.delete(t),b="deleted"),E(b,o)},e.CHANGE_BUFFER_DELAY);v.set(o,(0,R.toDisposable)(()=>clearTimeout(u)))}else{let a;n.has(t)?a="changed":(a="added",n.add(t)),E(a,o)}else if(s==="rename"||t!==m){const a=setTimeout(async()=>{const u=await C.Promises.exists(o);d||(u?(E("changed",o),c=[f(h,E,S)]):E("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,R.dispose)(c),c=[(0,R.toDisposable)(()=>clearTimeout(a))]}else E("changed",o)})}catch(l){C.Promises.exists(h.path).then(n=>{n&&!d&&S(`Failed to watch ${h.path} for changes using fs.watch() (${l.toString()})`)})}return(0,R.toDisposable)(()=>{d=!0,c=(0,R.dispose)(c)})}async function p(h,E,S,m=512){const v=await C.Promises.open(h,"r"),d=Buffer.allocUnsafe(m),c=new T.CancellationTokenSource(S);let l,n=!1;const s=I(h,async i=>{if(i==="changed"){if(n)return;n=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:t}=await C.Promises.read(v,d,0,m,null);if(!t||c.token.isCancellationRequested)break;E(d.slice(0,t))}}catch(t){l=new Error(t),c.dispose(!0)}finally{n=!1}}},i=>{l=new Error(i),c.dispose(!0)});return new Promise((i,t)=>{c.token.onCancellationRequested(async()=>{s.dispose(),await C.Promises.close(v),l?t(l):i()})})}e.watchFileContents=p});var he=this&&this.__decorate||function(X,e,k,T){var D=arguments.length,R=D<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,k):T,r;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(X,e,k,T);else for(var P=X.length-1;P>=0;P--)(r=X[P])&&(R=(D<3?r(R):D>3?r(e,k,R):r(e,k))||R);return D>3&&R&&Object.defineProperty(e,k,R),R};define(te[34],ne([0,1,16,5,19,28,68,7,3,2,108,25,17]),function(X,e,k,T,D,R,r,P,y,C,I,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(E=e.ResponseType||(e.ResponseType={}));function S(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(m||(m={}));class v{constructor(z){this.buffer=z,this.pos=0}read(z){const K=this.buffer.slice(this.pos,this.pos+z);return this.pos+=K.byteLength,K}}class d{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(z){this.buffers.push(z)}}var c;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(c||(c={}));function l(q){const z=D.VSBuffer.alloc(4);return z.writeUInt32BE(q,0),z}function n(q){return q.read(4).readUInt32BE(0)}function s(q){const z=D.VSBuffer.alloc(1);return z.writeUInt8(q,0),z}const i={Undefined:s(c.Undefined),String:s(c.String),Buffer:s(c.Buffer),VSBuffer:s(c.VSBuffer),Array:s(c.Array),Object:s(c.Object)},t=typeof Buffer!="undefined";function o(q,z){if(typeof z=="undefined")q.write(i.Undefined);else if(typeof z=="string"){const K=D.VSBuffer.fromString(z);q.write(i.String),q.write(l(K.byteLength)),q.write(K)}else if(t&&Buffer.isBuffer(z)){const K=D.VSBuffer.wrap(z);q.write(i.Buffer),q.write(l(K.byteLength)),q.write(K)}else if(z instanceof D.VSBuffer)q.write(i.VSBuffer),q.write(l(z.byteLength)),q.write(z);else if(Array.isArray(z)){q.write(i.Array),q.write(l(z.length));for(const K of z)o(q,K)}else{const K=D.VSBuffer.fromString(JSON.stringify(z));q.write(i.Object),q.write(l(K.byteLength)),q.write(K)}}function a(q){switch(q.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return q.read(n(q)).toString();case c.Buffer:return q.read(n(q)).buffer;case c.VSBuffer:return q.read(n(q));case c.Array:{const K=n(q),F=[];for(let B=0;B<K;B++)F.push(a(q));return F}case c.Object:return JSON.parse(q.read(n(q)).toString())}}class u{constructor(z,K,F=null,B=1e3){this.protocol=z,this.ctx=K,this.logger=F,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(z,K){this.channels.set(z,K),setTimeout(()=>this.flushPendingRequests(z),0)}sendResponse(z){switch(z.type){case 200:{const K=this.send([z.type]);this.logger&&this.logger.logOutgoing(K,0,1,S(z.type));return}case 201:case 202:case 204:case 203:{const K=this.send([z.type,z.id],z.data);this.logger&&this.logger.logOutgoing(K,z.id,1,S(z.type),z.data);return}}}send(z,K=void 0){const F=new d;return o(F,z),o(F,K),this.sendBuffer(F.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(K){return 0}}onRawMessage(z){const K=new v(z),F=a(K),B=a(K),V=F[0];switch(V){case 100:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}: ${F[2]}.${F[3]}`,B),this.onPromise({type:V,id:F[1],channelName:F[2],name:F[3],arg:B});case 102:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}: ${F[2]}.${F[3]}`,B),this.onEventListen({type:V,id:F[1],channelName:F[2],name:F[3],arg:B});case 101:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],1,`${h(V)}`),this.disposeActiveRequest({type:V,id:F[1]})}}onPromise(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const F=new R.CancellationTokenSource;let B;try{B=K.call(this.ctx,z.name,z.arg,F.token)}catch(Z){B=Promise.reject(Z)}const V=z.id;B.then(Z=>{this.sendResponse({id:V,data:Z,type:201}),this.activeRequests.delete(z.id)},Z=>{Z instanceof Error?this.sendResponse({id:V,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:V,data:Z,type:203}),this.activeRequests.delete(z.id)});const Q=(0,C.toDisposable)(()=>F.cancel());this.activeRequests.set(z.id,Q)}onEventListen(z){const K=this.channels.get(z.channelName);if(!K){this.collectPendingRequest(z);return}const F=z.id,V=K.listen(this.ctx,z.name,z.arg)(Q=>this.sendResponse({id:F,data:Q,type:204}));this.activeRequests.set(z.id,V)}disposeActiveRequest(z){const K=this.activeRequests.get(z.id);K&&(K.dispose(),this.activeRequests.delete(z.id))}collectPendingRequest(z){let K=this.pendingRequests.get(z.channelName);K||(K=[],this.pendingRequests.set(z.channelName,K));const F=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.sendResponse({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:z,timeoutTimer:F})}flushPendingRequests(z){const K=this.pendingRequests.get(z);if(K){for(const F of K)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var g;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(z,K=null){this.protocol=z,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new y.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=K}getChannel(z){const K=this;return{call(F,B,V){return K.isDisposed?Promise.reject(P.canceled()):K.requestPromise(z,F,B,V)},listen(F,B){return K.isDisposed?Promise.reject(P.canceled()):K.requestEvent(z,F,B)}}}requestPromise(z,K,F,B=R.CancellationToken.None){const V=this.lastRequestId++,Z={id:V,type:100,channelName:z,name:K,arg:F};if(B.isCancellationRequested)return Promise.reject(P.canceled());let G;return new Promise((re,ie)=>{if(B.isCancellationRequested)return ie(P.canceled());const ce=()=>{const be=Ie=>{switch(Ie.type){case 201:this.handlers.delete(V),re(Ie.data);break;case 202:this.handlers.delete(V);const Ee=new Error(Ie.data.message);Ee.stack=Ie.data.stack,Ee.name=Ie.data.name,ie(Ee);break;case 203:this.handlers.delete(V),ie(Ie.data);break}};this.handlers.set(V,be),this.sendRequest(Z)};let le=null;this.state===m.Idle?ce():(le=(0,T.createCancelablePromise)(be=>this.whenInitialized()),le.then(()=>{le=null,ce()}));const fe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:V,type:101}),ie(P.canceled())},de=B.onCancellationRequested(fe);G=(0,C.combinedDisposable)((0,C.toDisposable)(fe),de),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(z,K,F){const B=this.lastRequestId++,Q={id:B,type:102,channelName:z,name:K,arg:F};let Z=null;const G=new y.Emitter({onFirstListenerAdd:()=>{Z=(0,T.createCancelablePromise)(re=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(G),this.sendRequest(Q)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(G),this.sendRequest({id:B,type:103}))}}),H=re=>G.fire(re.data);return this.handlers.set(B,H),G.event}sendRequest(z){switch(z.type){case 100:case 102:{const K=this.send([z.type,z.id,z.channelName,z.name],z.arg);this.logger&&this.logger.logOutgoing(K,z.id,0,`${h(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const K=this.send([z.type,z.id]);this.logger&&this.logger.logOutgoing(K,z.id,0,h(z.type));return}}}send(z,K=void 0){const F=new d;return o(F,z),o(F,K),this.sendBuffer(F.buffer)}sendBuffer(z){try{return this.protocol.send(z),z.byteLength}catch(K){return 0}}onBuffer(z){const K=new v(z),F=a(K),B=a(K),V=F[0];switch(V){case 200:return this.logger&&this.logger.logIncoming(z.byteLength,0,0,S(V)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(z.byteLength,F[1],0,S(V),B),this.onResponse({type:F[0],id:F[1],data:B})}}onResponse(z){if(z.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(z.id);K&&K(z)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(z=>z.dispose()),this.activeRequests.clear()}}he([r.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class A{constructor(z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new y.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new y.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,z(({protocol:K,onDidClientDisconnect:F})=>{y.Event.once(K.onMessage)(V=>{const Q=new v(V),Z=a(Q),G=new u(K,Z),H=new b(K);this.channels.forEach((ie,ce)=>G.registerChannel(ce,ie));const re={channelServer:G,channelClient:H,ctx:Z};this._connections.add(re),this._onDidAddConnection.fire(re),F(()=>{G.dispose(),H.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const z=[];return this._connections.forEach(K=>z.push(K)),z}getChannel(z,K){const F=this;return{call(B,V,Q){let Z;if((0,f.isFunction)(K)){let H=(0,k.getRandomElement)(F.connections.filter(K));Z=H?Promise.resolve(H):y.Event.toPromise(y.Event.filter(F.onDidAddConnection,K))}else Z=K.routeCall(F,B,V);const G=Z.then(H=>H.channelClient.getChannel(z));return U(G).call(B,V,Q)},listen(B,V){if((0,f.isFunction)(K))return F.getMulticastEvent(z,K,B,V);const Q=K.routeEvent(F,B,V).then(Z=>Z.channelClient.getChannel(z));return U(Q).listen(B,V)}}}getMulticastEvent(z,K,F,B){const V=this;let Q=new C.DisposableStore;const Z=new y.Emitter({onFirstListenerAdd:()=>{Q=new C.DisposableStore;const G=new y.EventMultiplexer,H=new Map,re=ce=>{const fe=ce.channelClient.getChannel(z).listen(F,B),de=G.add(fe);H.set(ce,de)},ie=ce=>{const le=H.get(ce);!le||(le.dispose(),H.delete(ce))};V.connections.filter(K).forEach(re),y.Event.filter(V.onDidAddConnection,K)(re,void 0,Q),V.onDidRemoveConnection(ie,void 0,Q),G.event(Z.fire,Z,Q),Q.add(G)},onLastListenerRemove:()=>{Q.dispose()}});return Z.event}registerChannel(z,K){this.channels.set(z,K),this._connections.forEach(F=>{F.channelServer.registerChannel(z,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(z,K,F=null){const B=new d;o(B,K),z.send(B.buffer),this.channelClient=new b(z,F),this.channelServer=new u(z,K,F)}getChannel(z){return this.channelClient.getChannel(z)}registerChannel(z,K){this.channelServer.registerChannel(z,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function U(q){return{call(z,K,F){return q.then(B=>B.call(z,K,F))},listen(z,K){const F=new y.Relay;return q.then(B=>F.input=B.listen(z,K)),F.event}}}e.getDelayedChannel=U;function x(q){let z=!1;return{call(K,F,B){return z?q.call(K,F,B):(0,T.timeout)(0).then(()=>z=!0).then(()=>q.call(K,F,B))},listen(K,F){if(z)return q.listen(K,F);const B=new y.Relay;return(0,T.timeout)(0).then(()=>z=!0).then(()=>B.input=q.listen(K,F)),B.event}}}e.getNextTickChannel=x;class N{constructor(z){this.fn=z}routeCall(z){return this.route(z)}routeEvent(z){return this.route(z)}async route(z){for(const K of z.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await y.Event.toPromise(z.onDidAddConnection),await this.route(z)}}e.StaticRouter=N;var L;(function(q){function z(V,Q){const Z=V,G=Q&&Q.disableMarshalling,H=new Map;for(const re in Z)F(re)&&H.set(re,y.Event.buffer(Z[re],!0));return new class{listen(re,ie,ce){const le=H.get(ie);if(le)return le;if(B(ie)){const fe=Z[ie];if(typeof fe=="function")return fe.call(Z,ce)}throw new Error(`Event not found: ${ie}`)}call(re,ie,ce){const le=Z[ie];if(typeof le=="function"){if(!G&&Array.isArray(ce))for(let fe=0;fe<ce.length;fe++)ce[fe]=(0,I.revive)(ce[fe]);return le.apply(Z,ce)}throw new Error(`Method not found: ${ie}`)}}}q.fromService=z;function K(V,Q){const Z=Q&&Q.disableMarshalling;return new Proxy({},{get(G,H){if(typeof H=="string")return Q?.properties?.has(H)?Q.properties.get(H):B(H)?function(re){return V.listen(H,re)}:F(H)?V.listen(H):async function(...re){let ie;Q&&!(0,f.isUndefinedOrNull)(Q.context)?ie=[Q.context,...re]:ie=re;const ce=await V.call(H,ie);return Z?ce:(0,I.revive)(ce)};throw new Error(`Property not found: ${String(H)}`)}})}q.toService=K;function F(V){return V[0]==="o"&&V[1]==="n"&&w.isUpperAsciiLetter(V.charCodeAt(2))}function B(V){return/^onDynamic/.test(V)&&w.isUpperAsciiLetter(V.charCodeAt(9))}})(L=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){let z=q.toString();if(z!=="[object Object]")return z}return q}function M(q){return Array.isArray(q)?q.map(_):_(q)}function W(q,z,K,F,B,V,Q){Q=M(Q);const Z=$[B],G=Z[F%Z.length];let H=[`%c[${q}]%c[${String(z).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(V)?(H=H.concat(Q),H.push(")")):H.push(Q),console.log.apply(console,H)}e.logWithColors=W;class j{constructor(z,K){this._outgoingPrefix=z,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(z,K,F,B,V){this._totalOutgoing+=z,W(this._outgoingPrefix,this._totalOutgoing,z,K,F,B,V)}logIncoming(z,K,F,B,V){this._totalIncoming+=z,W(this._incomingPrefix,this._totalIncoming,z,K,F,B,V)}}e.IPCLogger=j}),define(te[120],ne([0,1,19,3,34]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(y){this.port=y,this.onMessage=T.Event.fromDOMEventEmitter(this.port,"message",C=>k.VSBuffer.wrap(C.data)),y.start()}send(y){this.port.postMessage(y.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class r extends D.IPCClient{constructor(y,C){const I=new R(y);super(I,C);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=r}),define(te[73],ne([0,1,19,3,2,4,31,34]),function(X,e,k,T,D,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var y;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function I(){return C||(C=k.VSBuffer.alloc(0)),C}class w{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,o){if(t===0)return I();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const b=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=t),b}if(this._chunks[0].byteLength>t){const b=this._chunks[0].slice(0,t);return o&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),b}let a=k.VSBuffer.alloc(t),u=0,g=0;for(;t>0;){const b=this._chunks[g];if(b.byteLength>t){const A=b.slice(0,t);a.set(A,u),u+=t,o&&(this._chunks[g]=b.slice(t),this._totalLength-=t),t-=t}else a.set(b,u),u+=b.byteLength,o?(this._chunks.shift(),this._totalLength-=b.byteLength):g++,t-=b.byteLength}return a}}e.ChunkStream=w;var f;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(f||(f={}));var p;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(t,o,a,u){this.type=t,this.id=o,this.ack=a,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends D.Disposable{constructor(t){super();this._onMessage=this._register(new T.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const a=this._state.messageType,u=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(a,u,g,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class S{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=k.VSBuffer.alloc(13);o.writeUInt8(t.type,0),o.writeUInt32BE(t.id,1),o.writeUInt32BE(t.ack,5),o.writeUInt32BE(t.data.byteLength,9),this._writeSoon(o,t.data)}_bufferAdd(t,o){const a=this._totalLength===0;return this._data.push(t,o),this._totalLength+=t.byteLength+o.byteLength,a}_bufferTake(){const t=k.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,o){this._bufferAdd(t,o)&&R.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class m extends D.Disposable{constructor(t){super();this._onMessage=new T.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new S(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new h(1,0,0,t))}}e.Protocol=m;class v extends P.IPCClient{constructor(t,o,a=null){super(t,o,a);this.protocol=t}static fromSocket(t,o){return new v(new m(t),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=v;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new T.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,r.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class c{constructor(t){this.data=t,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],o=0,a=this._first;for(;a;)t[o++]=a.data,a=a.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const o=new c(t);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class n{constructor(){this.lastRuns=[];const t=Date.now();for(let o=0;o<n._HISTORY_LENGTH;o++)this.lastRuns[o]=t-1e3*o;setInterval(()=>{for(let o=n._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const t=Date.now(),o=(1+n._HISTORY_LENGTH)*1e3;let a=0;for(let u=0;u<n._HISTORY_LENGTH;u++)t-this.lastRuns[u]<=o&&a++;return 1-a/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class s{constructor(t,o=null,a=n.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new h(5,0,0,I());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const o=new h(4,0,0,I());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,o){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new S(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let o=0,a=t.length;o<a;o++)this._socketWriter.write(t[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new h(6,0,0,I())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const o=this._outgoingUnackMsg.toArray();for(let a=0,u=o.length;a<u;a++)this._socketWriter.write(o[a]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new h(1,o,this._incomingAckId,t);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(t){const o=new h(2,0,0,t);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),o=Date.now()-t.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new h(3,0,this._incomingAckId,I());this._socketWriter.write(t)}}e.PersistentProtocol=s}),define(te[121],ne([0,1,74,3,34,120]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class r extends D.IPCServer{static getOnDidClientConnect(){const y=T.Event.fromNodeEventEmitter(k.ipcRenderer,"vscode:createMessageChannel",(C,I)=>I);return T.Event.map(y,C=>{const{port1:I,port2:w}=new MessageChannel,p={protocol:new R.Protocol(I),onDidClientDisconnect:T.Event.fromDOMEventEmitter(I,"close")};return k.ipcRenderer.postMessage("vscode:createMessageChannelResult",C,[w]),p})}constructor(){super(r.getOnDidClientConnect())}}e.Server=r}),define(te[122],ne([0,1,19,7]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(P,y){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((I,w)=>{C.open(P.type||"GET",P.url||"",!0,P.user,P.password),R(C,P),C.responseType="arraybuffer",C.onerror=f=>w(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=f=>{I({res:{statusCode:C.status,headers:r(C)},stream:(0,k.bufferToStream)(k.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=f=>w(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(C.timeout=P.timeout),C.send(P.data),y.onCancellationRequested(()=>{C.abort(),w((0,T.canceled)())})})}e.request=D;function R(P,y){if(y.headers){e:for(let C in y.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(C,y.headers[C])}}}function r(P){const y=Object.create(null);for(const C of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const I=C.indexOf(":");y[C.substr(0,I).trim().toLowerCase()]=C.substr(I+1).trim()}return y}}),define(te[75],ne([0,1,5,3,2,17]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var r;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(r=e.StorageHint||(e.StorageHint={}));function P(w){const f=w;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var y;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(y||(y={}));class C extends D.Disposable{constructor(f,p=Object.create(null)){super();this.database=f,this.options=p,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=y.None,this.cache=new Map,this.flushDelayer=new k.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((p,h)=>this.accept(h,p)),f.deleted?.forEach(p=>this.accept(p,void 0))}accept(f,p){if(this.state===y.Closed)return;let h=!1;(0,R.isUndefinedOrNull)(p)?h=this.cache.delete(f):this.cache.get(f)!==p&&(this.cache.set(f,p),h=!0),h&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===y.None&&(this.state=y.Initialized,this.options.hint!==r.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,p){const h=this.cache.get(f);return(0,R.isUndefinedOrNull)(h)?p:h}getBoolean(f,p){const h=this.get(f);return(0,R.isUndefinedOrNull)(h)?p:h==="true"}getNumber(f,p){const h=this.get(f);return(0,R.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(f,p){if(this.state===y.Closed)return;if((0,R.isUndefinedOrNull)(p))return this.delete(f);const h=String(p);if(this.cache.get(f)!==h)return this.cache.set(f,h),this.pendingInserts.set(f,h),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===y.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=y.Closed;try{await this.doFlush(0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((p,h)=>this.items.set(h,p)),f.delete&&f.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=I}),define(te[123],ne([12,13]),function(X,e){return X.create("vs/base/common/date",e)}),define(te[58],ne([0,1,123]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const T=60,D=T*60,R=D*24,r=R*7,P=R*30,y=R*365;function C(w,f){typeof w!="number"&&(w=w.getTime());const p=Math.round((new Date().getTime()-w)/1e3);if(p<-30)return(0,k.localize)(0,null,C(new Date().getTime()+p*1e3,!1));if(p<30)return(0,k.localize)(1,null);let h;return p<T?(h=p,f?h===1?(0,k.localize)(2,null,h):(0,k.localize)(3,null,h):h===1?(0,k.localize)(4,null,h):(0,k.localize)(5,null,h)):p<D?(h=Math.floor(p/T),f?h===1?(0,k.localize)(6,null,h):(0,k.localize)(7,null,h):h===1?(0,k.localize)(8,null,h):(0,k.localize)(9,null,h)):p<R?(h=Math.floor(p/D),f?h===1?(0,k.localize)(10,null,h):(0,k.localize)(11,null,h):h===1?(0,k.localize)(12,null,h):(0,k.localize)(13,null,h)):p<r?(h=Math.floor(p/R),f?h===1?(0,k.localize)(14,null,h):(0,k.localize)(15,null,h):h===1?(0,k.localize)(16,null,h):(0,k.localize)(17,null,h)):p<P?(h=Math.floor(p/r),f?h===1?(0,k.localize)(18,null,h):(0,k.localize)(19,null,h):h===1?(0,k.localize)(20,null,h):(0,k.localize)(21,null,h)):p<y?(h=Math.floor(p/P),f?h===1?(0,k.localize)(22,null,h):(0,k.localize)(23,null,h):h===1?(0,k.localize)(24,null,h):(0,k.localize)(25,null,h)):(h=Math.floor(p/y),f?h===1?(0,k.localize)(26,null,h):(0,k.localize)(27,null,h):h===1?(0,k.localize)(28,null,h):(0,k.localize)(29,null,h))}e.fromNow=C;function I(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(te[124],ne([12,13]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,16,17,124]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(C,I){return I&&(C.stack||C.stacktrace)?D.localize(0,null,P(C),r(C.stack)||r(C.stacktrace)):P(C)}function r(C){return Array.isArray(C)?C.join(`
`):C}function P(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?D.localize(1,null,C.message):C.message||D.localize(2,null)}function y(C=null,I=!1){if(!C)return D.localize(3,null);if(Array.isArray(C)){const w=k.coalesce(C),f=y(w[0],I);return w.length>1?D.localize(4,null,f,w.length):f}if(T.isString(C))return C;if(C.detail){const w=C.detail;if(w.error)return R(w.error,I);if(w.exception)return R(w.exception,I)}return C.stack?R(C,I):C.message?C.message:D.localize(5,null)}e.toErrorMessage=y}),define(te[125],ne([12,13]),function(X,e){return X.create("vs/base/node/processes",e)}),define(te[76],ne([0,1,43,42,15,26,9,4,31,104,17,112,20,125]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function h(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function E(n,s){if(P.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};s&&(i.cwd=s);const t=k.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],i);return new Promise(o=>{t.once("error",a=>{o({success:!1,error:a})}),t.once("exit",(a,u)=>{o(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?h(i.status):1})}else if(P.isLinux||P.isMacintosh)try{const i=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(t=>{k.execFile(i,[n.pid.toString()],{encoding:"utf8",shell:!0},(o,a,u)=>{t(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function S(n){!n||(delete n.DEBUG,P.isMacintosh&&delete n.DYLD_LIBRARY_PATH,P.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=S;function m(n=y.env){return n.comspec||"cmd.exe"}e.getWindowsShell=m;class v{constructor(s,i,t,o){if(i!==void 0&&t!==void 0&&o!==void 0)this.cmd=s,this.args=i,this.shell=t,this.options=o;else{const a=s;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(y.env).forEach(u=>{a[u]=y.env[u]}),Object.keys(this.options.env).forEach(u=>{a[u]=this.options.env[u]}),this.options.env=a}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const i=s.lastIndexOf(r.sep);return i!==-1&&(s=s.substring(i+1)),v.WellKnowCommands[s]?s:"other"}start(s){return P.isWindows&&(this.options&&this.options.cwd&&T.isUNC(this.options.cwd)||!this.options&&T.isUNC(y.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(i=>{let t,o;const a=new Promise((u,g)=>{t=u,o=g});if(i){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=k.exec(u,this.options,(g,b,A)=>{this.childProcess=null;const O=g;O&&O.killed?o({killed:this.terminateRequested,stdout:b.toString(),stderr:A.toString()}):this.handleExec(t,s,g,b,A)})}else{let u=null;const g=b=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(b,t,s,o);const A={terminated:this.terminateRequested};I.isNumber(b)&&(A.cmdCode=b),t(A)};if(this.shell&&P.isWindows){const b=R.deepClone(this.options);b.windowsVerbatimArguments=!0,b.detached=!1;let A=!1,O=!1;const U=[];let x=this.ensureQuotes(this.cmd);U.push(x.value),A=x.quoted,this.args&&this.args.forEach(L=>{x=this.ensureQuotes(L),U.push(x.value),O=O&&x.quoted});const N=["/s","/c"];A?O?N.push('"'+U.join(" ")+'"'):U.length>1?N.push('"'+U[0]+'" '+U.slice(1).join(" ")):N.push('"'+U[0]+'"'):N.push(U.join(" ")),u=k.spawn(m(),N,b)}else this.cmd&&(u=k.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(I.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",b=>{this.childProcess=null,o({terminated:this.terminateRequested,error:b})}),u.pid&&(this.childProcess.on("close",g),this.handleSpawn(u,t,s,o,!0)))}return a})}handleClose(s,i,t,o){}ensureQuotes(s){return v.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,E(s,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!P.isWindows)return s(!1);const i=k.spawn(m(),["/s","/c"]);i.on("error",t=>s(!0)),i.on("exit",t=>s(!1))})}}e.AbstractProcess=v,v.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},v.regexp=/^[^"].* .*[^"]/;class d extends v{constructor(s,i,t,o){super(s,i,t,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,i,t,o,a){[o,a].forEach((u,g)=>{const b=new w.LineDecoder;b.write(u).forEach(U=>{i({line:U,source:g===0?0:1})});const O=b.end();O&&i({line:O,source:g===0?0:1})}),s({terminated:this.terminateRequested,error:t})}handleSpawn(s,i,t,o,a){const u=new w.LineDecoder,g=new w.LineDecoder;s.stdout.on("data",b=>{u.write(b).forEach(O=>t({line:O,source:0}))}),s.stderr.on("data",b=>{g.write(b).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=g}handleClose(s,i,t,o){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&t({line:a,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&t({line:u,source:1})}}e.LineProcess=d;function c(n){let s=[],i=!1;const t=function(o){if(i){s.push(o);return}(!n.send(o,u=>{if(u&&console.error(u),i=!1,s.length>0){const g=s.slice(0);s=[],g.forEach(b=>t(b))}})||P.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=c;var l;(function(n){async function s(i,t,o){if(r.isAbsolute(i))return i;if(t===void 0&&(t=y.cwd()),r.dirname(i)!=="."||(o===void 0&&I.isString(y.env.PATH)&&(o=y.env.PATH.split(r.delimiter)),o===void 0||o.length===0))return r.join(t,i);async function u(g){if(await f.Promises.exists(g)){let b;try{b=await f.Promises.stat(g)}catch(A){A.message.startsWith("EACCES")&&(b=await f.Promises.lstat(g))}return b?!b.isDirectory():!1}return!1}for(let g of o){let b;if(r.isAbsolute(g)?b=r.join(g,i):b=r.join(t,g,i),await u(b))return b;let A=b+".com";if(await u(A)||(A=b+".exe",await u(A)))return A}return r.join(t,i)}n.findExecutable=s})(l=e.win32||(e.win32={}))}),define(te[126],ne([0,1,33,4,72,76]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function r(p,h){return p===1?T.isWindows?w():R.getWindowsShell(h):C(p,h)}e.getSystemShell=r;function P(p,h){return p===1?T.isWindows?f(h):R.getWindowsShell(h):C(p,h)}e.getSystemShellSync=P;let y=null;function C(p,h){if(T.isLinux&&p===2||T.isMacintosh&&p===3)return"/bin/bash";if(!y){let E;if(T.isWindows)E="/bin/bash";else{if(E=h.SHELL,!E)try{E=(0,k.userInfo)().shell}catch(S){}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}y=E}return y}let I=null;async function w(){return I||(I=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),I}function f(p){if(I)return I;const h=T.isWindows&&parseFloat((0,k.release)())>=10,E=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${p.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?S:R.getWindowsShell(p)}}),define(te[52],ne([0,1,43,5,19,28,107,7,3,2,26,76,34]),function(X,e,k,T,D,R,r,P,y,C,I,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends f.ChannelServer{constructor(S){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(v){}},onMessage:y.Event.fromNodeEventEmitter(process,"message",m=>D.VSBuffer.wrap(Buffer.from(m,"base64")))},S);process.once("disconnect",()=>this.dispose())}}e.Server=p;class h{constructor(S,m){this.modulePath=S,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new y.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new T.Delayer(v),this.child=null,this._client=null}getChannel(S){const m=this;return{call(v,d,c){return m.requestPromise(S,v,d,c)},listen(v,d){return m.requestEvent(S,v,d)}}}requestPromise(S,m,v,d=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(P.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(S),l=(0,T.createCancelablePromise)(i=>c.call(m,v,i)),n=d.onCancellationRequested(()=>l.cancel()),s=(0,C.toDisposable)(()=>l.cancel());return this.activeRequests.add(s),l.finally(()=>{n.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(S,m,v){if(!this.disposeDelayer)return y.Event.None;this.disposeDelayer.cancel();let d;const c=new y.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(S).listen(m,v)(c.fire,c),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,w.removeDangerousEnvVariables)(m.env),this.child=(0,k.fork)(this.modulePath,S,m);const v=new y.Emitter;y.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,r.isRemoteConsoleLog)(t)){(0,r.log)(t,`IPC Library: ${this.options.serverName}`);return}v.fire(D.VSBuffer.wrap(Buffer.from(t,"base64")))});const c=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&c.send(t.buffer.toString("base64")),n=v.event,s={send:l,onMessage:n};this._client=new f.ChannelClient(s);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(a=>(0,C.dispose)(a)),this.activeRequests.clear(),t!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:o})})}return this._client}getCachedChannel(S){let m=this.channels.get(S);return m||(m=this.client.getChannel(S),this.channels.set(S,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[127],ne([12,13]),function(X,e){return X.create("vs/base/node/zip",e)}),define(te[128],ne([12,13]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[129],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(te[130],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(te[131],ne([12,13]),function(X,e){return X.create("vs/platform/environment/node/shellEnv",e)}),define(te[132],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[133],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[134],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[135],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[136],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[137],ne([12,13]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[138],ne([12,13]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[139],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(te[140],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(te[141],ne([12,13]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(te[142],ne([12,13]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[143],ne([12,13]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(te[144],ne([12,13]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[145],ne([12,13]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[146],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[147],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[148],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[149],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[150],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[151],ne([12,13]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[152],ne([0,1,4]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var T;(function(r){r.Team="team",r.Internal="internal",r.Insiders="insider",r.Public="public"})(T=e.TargetPopulation||(e.TargetPopulation={}));var D;(function(r){r.Market="X-MSEdge-Market",r.CorpNet="X-FD-Corpnet",r.ApplicationVersion="X-VSCode-AppVersion",r.Build="X-VSCode-Build",r.ClientId="X-MSEdge-ClientId",r.ExtensionName="X-VSCode-ExtensionName",r.Language="X-VSCode-Language",r.TargetPopulation="X-VSCode-TargetPopulation"})(D=e.Filters||(e.Filters={}));class R{constructor(P,y,C,I){this.version=P,this.appName=y,this.machineId=C,this.targetPopulation=I}getFilterValue(P){switch(P){case D.ApplicationVersion:return this.version;case D.Build:return this.appName;case D.ClientId:return this.machineId;case D.Language:return k.language;case D.ExtensionName:return"vscode-core";case D.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let P=new Map,y=Object.values(D);for(let C of y)P.set(C,this.getFilterValue(C));return P}}e.AssignmentFilterProvider=R}),define(te[77],ne([0,1,58,68,15,9,31,18,8]),function(X,e,k,T,D,R,r,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class C{constructor(E,S,m){this._args=E,this.paths=S,this.productService=m}get appRoot(){return(0,R.dirname)(D.FileAccess.asFileUri("",X).fsPath)}get userHome(){return y.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return y.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return y.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(y.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return y.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return y.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=r.env.VSCODE_PORTABLE;return E?y.URI.file((0,R.join)(E,"argv.json")):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,P.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,R.resolve)(E):(0,R.normalize)((0,R.join)(D.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const E=this.args["extensions-download-dir"];return E?(0,R.resolve)(E):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,R.resolve)(E);const S=r.env.VSCODE_EXTENSIONS;if(S)return S;const m=r.env.VSCODE_PORTABLE;return m?(0,R.join)(m,"extensions"):(0,P.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(S=>/^[^:/?#]+?:\/\//.test(S)?y.URI.parse(S):y.URI.file((0,R.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?y.URI.parse(E):y.URI.file((0,R.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!r.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,P.joinPath)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return y.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([T.memoize],C.prototype,"appRoot",null),he([T.memoize],C.prototype,"userHome",null),he([T.memoize],C.prototype,"userDataPath",null),he([T.memoize],C.prototype,"appSettingsHome",null),he([T.memoize],C.prototype,"tmpDir",null),he([T.memoize],C.prototype,"userRoamingDataHome",null),he([T.memoize],C.prototype,"settingsResource",null),he([T.memoize],C.prototype,"userDataSyncHome",null),he([T.memoize],C.prototype,"userDataSyncLogResource",null),he([T.memoize],C.prototype,"sync",null),he([T.memoize],C.prototype,"machineSettingsResource",null),he([T.memoize],C.prototype,"globalStorageHome",null),he([T.memoize],C.prototype,"workspaceStorageHome",null),he([T.memoize],C.prototype,"keybindingsResource",null),he([T.memoize],C.prototype,"keyboardLayoutResource",null),he([T.memoize],C.prototype,"argvResource",null),he([T.memoize],C.prototype,"snippetsHome",null),he([T.memoize],C.prototype,"isExtensionDevelopment",null),he([T.memoize],C.prototype,"untitledWorkspacesHome",null),he([T.memoize],C.prototype,"installSourcePath",null),he([T.memoize],C.prototype,"builtinExtensionsPath",null),he([T.memoize],C.prototype,"extensionsPath",null),he([T.memoize],C.prototype,"extensionDevelopmentLocationURI",null),he([T.memoize],C.prototype,"extensionDevelopmentKind",null),he([T.memoize],C.prototype,"extensionTestsLocationURI",null),he([T.memoize],C.prototype,"debugExtensionHost",null),he([T.memoize],C.prototype,"serviceMachineIdResource",null),he([T.memoize],C.prototype,"telemetryLogResource",null),he([T.memoize],C.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=C;function I(h,E){return p(h["inspect-extensions"],h["inspect-brk-extensions"],5870,E,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function w(h,E){return p(h["inspect-search"],h["inspect-brk-search"],5876,E,h.extensionEnvironment)}e.parseSearchPort=w;function f(h,E){return p(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,E,h.extensionEnvironment)}e.parsePtyHostPort=f;function p(h,E,S,m,v,d){const l=Number(E||h)||(m?null:S),n=l?Boolean(!!E):!1;let s;if(d)try{s=JSON.parse(d)}catch{}return{port:l,break:n,debugId:v,env:s}}}),define(te[153],ne([0,1,247,4,129]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const r={onUnknownOption:()=>{},onMultipleValues:()=>{}};function P(h,E,S=r){const m={},v=[],d=[];for(let s in E){const i=E[s];i.alias&&(m[s]=i.alias),i.type==="string"||i.type==="string[]"?(v.push(s),i.deprecates&&v.push(i.deprecates)):i.type==="boolean"&&(d.push(s),i.deprecates&&d.push(i.deprecates))}const c=k(h,{string:v,boolean:d,alias:m}),l={},n=c;l._=c._.map(s=>String(s)).filter(s=>s.length>0),delete n._;for(let s in E){const i=E[s];i.alias&&delete n[i.alias];let t=n[s];i.deprecates&&n.hasOwnProperty(i.deprecates)&&(t||(t=n[i.deprecates]),delete n[i.deprecates]),typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),S.onMultipleValues(s,t)),l[s]=t),delete n[s]}for(let s in n)S.onUnknownOption(s);return l}e.parseArgs=P;function y(h,E){let S="";return E.args&&(Array.isArray(E.args)?S=` <${E.args.join("> <")}>`:S=` <${E.args}>`),E.alias?`-${E.alias} --${h}${S}`:`--${h}${S}`}function C(h,E){let S=0,m=[];for(const l in h){const n=h[l],s=y(l,n);S=Math.max(S,s.length),m.push([s,n.description])}let v=S+2+1;if(E-v<25)return m.reduce((l,n)=>l.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let d=E-v-1,c=[];for(const l of m){let n=l[0],s=w(l[1],d),i=I(v-n.length-2);c.push("  "+n+i+s[0]);for(let t=1;t<s.length;t++)c.push(I(v)+s[t])}return c}e.formatOptions=C;function I(h){return" ".repeat(h)}function w(h,E){let S=[];for(;h.length;){let m=h.length<E?h.length:h.lastIndexOf(" ",E),v=h.slice(0,m).trim();h=h.slice(m),S.push(v)}return S}function f(h,E,S,m,v=!0){const d=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${h} ${S}`];c.push(""),c.push(`${(0,D.localize)(32,null)}: ${E} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),c.push(""),v&&(T.isWindows?c.push((0,D.localize)(35,null,E)):c.push((0,D.localize)(36,null,E)),c.push(""));const l={};for(const n in m){const s=m[n];if(s.description&&s.cat){let i=l[s.cat];i||(l[s.cat]=i={}),i[n]=s}}for(let n in l){const s=n;let i=l[s];i&&(c.push(R[s]),c.push(...C(i,d)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=f;function p(h,E){return`${h||(0,D.localize)(37,null)}
${E||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function X(e,k,T,D){function R(P){const y=r(P),C=[y];return e.isAbsolute(y)||C.unshift(D),e.resolve(...C)}function r(P){const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,T);const I=P["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(w,"AppData","Roaming")}break;case"darwin":C=e.join(k.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(k.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,T)}return{getUserDataPath:R}}if(typeof define=="function")define(te[154],ne([0,155,33,15,18,31]),function(e,k,T,D,R,r){const P=R.dirname(D.FileAccess.asFileUri("",e)),y=e.__$__nodeRequire(R.joinPath(P,"package.json").fsPath);return X(k,T,y.name,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),k=require("path"),T=require("os");module.exports=X(k,T,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[156],ne([0,1,33,77,154]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends T.AbstractNativeEnvironmentService{constructor(P,y){super(P,{homeDir:(0,k.homedir)(),tmpDir:(0,k.tmpdir)(),userDataDir:(0,D.getUserDataPath)(P)},y)}}e.NativeEnvironmentService=R}),define(te[157],ne([0,1,8]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const T=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,R=/^([^@]+@)?([^:]+)(:\d+)?$/,r=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,y=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function C(S){const m=S.match(r);return m?m[1]:null}function I(S){if(S.indexOf("://")===-1){const m=S.match(T);return m?C(m[2]):null}try{const m=k.URI.parse(S);if(m.authority)return C(m.authority)}catch(m){}return null}function w(S,m){const v=new Set;let d;for(;d=P.exec(S);){const l=I(d[1]);l&&v.add(l)}const c=new Set(m);return Array.from(v).map(l=>c.has(l)?l:l.replace(y,"a"))}e.getDomainsOfRemotes=w;function f(S){const m=S.match(R);return m?m[2]:null}function p(S,m,v){return S&&m?(v&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${S}${m}`:`${S}/${m}`):null}function h(S,m){if(S.indexOf("://")===-1){const v=S.match(D);if(v)return p(v[2],v[3],m)}try{const v=k.URI.parse(S);if(v.authority)return p(f(v.authority),v.path,m)}catch(v){}return null}function E(S,m=!1){const v=[];let d;for(;d=P.exec(S);){const c=h(d[1],m);c&&v.push(c)}return v}e.getRemotes=E}),define(te[158],ne([0,1,26]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function D(R,r){const P=y=>{if(typeof y!="string")return;const C=T.exec(y);if(!C)return;const I=r[C[1]]??y;return typeof I=="string"?I:typeof I.message=="string"?I.message:y};return(0,k.cloneAndChange)(R,P)}e.localizeManifest=D}),define(te[159],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class k{constructor(R){this.channel=R}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(R,r,P,y){return this.channel.call("promptImportantExtensionsInstallNotification",[R,r,P,y])}promptWorkspaceRecommendations(R){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=k;class T{constructor(R){this.service=R}listen(R,r){throw new Error(`Event not found: ${r}`)}call(R,r,P){switch(r){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${r}`)}}e.ExtensionRecommendationNotificationServiceChannel=T}),define(te[78],ne([0,1,138]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function R(f){return f=f.trim(),f==="*"||T.test(f)}e.isValidVersionStr=R;function r(f){if(!R(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=f.match(T);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=r;function P(f){if(!f)return null;let p=f.majorBase,h=f.majorMustEqual,E=f.minorBase,S=f.minorMustEqual,m=f.patchBase,v=f.patchMustEqual;f.hasCaret&&(p===0||(S=!1),v=!1);let d=0;if(f.preRelease){const c=D.exec(f.preRelease);if(c){const[,l,n,s]=c;d=Date.UTC(Number(l),Number(n)-1,Number(s))}}return{majorBase:p,majorMustEqual:h,minorBase:E,minorMustEqual:S,patchBase:m,patchMustEqual:v,isMinimum:f.hasGreaterEquals,notBefore:d}}e.normalizeVersion=P;function y(f,p,h){let E;typeof f=="string"?E=P(r(f)):E=f;let S;p instanceof Date?S=p.getTime():typeof p=="string"&&(S=new Date(p).getTime());let m;if(typeof h=="string"?m=P(r(h)):m=h,!E||!m)return!1;let v=E.majorBase,d=E.minorBase,c=E.patchBase,l=m.majorBase,n=m.minorBase,s=m.patchBase,i=m.notBefore,t=m.majorMustEqual,o=m.minorMustEqual,a=m.patchMustEqual;return m.isMinimum?v>l?!0:v<l?!1:d>n?!0:d<n||S&&S<i?!1:c>=s:(v===1&&l===0&&(!t||!o||!a)&&(l=1,n=0,s=0,t=!0,o=!1,a=!1),v<l?!1:v>l?!t:d<n?!1:d>n?!o:c<s?!1:c>s?!a:!(S&&S<i))}e.isValidVersion=y;function C(f,p,h,E){return h.isBuiltin||typeof h.main=="undefined"?!0:w(f,p,h.engines.vscode,E)}e.isValidExtensionVersion=C;function I(f,p,h){return f==="*"||w(p,h,f)}e.isEngineValid=I;function w(f,p,h,E=[]){let S=P(r(h));if(!S)return E.push(k.localize(0,null,h)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return E.push(k.localize(1,null,h)),!1}else if(!S.majorMustEqual)return E.push(k.localize(2,null,h)),!1;return y(f,p,S)?!0:(E.push(k.localize(3,null,f,h)),!1)}}),define(te[53],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class k{constructor(D,R=[],r=!1){this.ctor=D,this.staticArguments=R,this.supportsDelayedInstantiation=r}}e.SyncDescriptor=k}),define(te[59],ne([0,1,53]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function D(r,P,y){P instanceof k.SyncDescriptor||(P=new k.SyncDescriptor(P,[],y)),T.push([r,P])}e.registerSingleton=D;function R(){return T}e.getSingletonServiceDescriptors=R}),define(te[160],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class k{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=k;class T{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let r of this._nodes.values())r.outgoing.size===0&&R.push(r);return R}insertEdge(R,r){const P=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(r);P.outgoing.set(this._hashFn(r),y),y.incoming.set(this._hashFn(R),P)}removeNode(R){const r=this._hashFn(R);this._nodes.delete(r);for(let P of this._nodes.values())P.outgoing.delete(r),P.incoming.delete(r)}lookupOrInsertNode(R){const r=this._hashFn(R);let P=this._nodes.get(r);return P||(P=new k(R),this._nodes.set(r,P)),P}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[r,P]of this._nodes)R.push(`${r}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,r]of this._nodes){const P=new Set([R]),y=this._findCycle(r,P);if(y)return y}}_findCycle(R,r){for(let[P,y]of R.outgoing){if(r.has(P))return[...r,P].join(" -> ");r.add(P);const C=this._findCycle(y,r);if(C)return C;r.delete(P)}}}e.Graph=T}),define(te[6],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var k;(function(r){r.serviceIds=new Map,r.DI_TARGET="$di$target",r.DI_DEPENDENCIES="$di$dependencies";function P(y){return y[r.DI_DEPENDENCIES]||[]}r.getServiceDependencies=P})(k=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function T(r,P,y,C){P[k.DI_TARGET]===P?P[k.DI_DEPENDENCIES].push({id:r,index:y,optional:C}):(P[k.DI_DEPENDENCIES]=[{id:r,index:y,optional:C}],P[k.DI_TARGET]=P)}function D(r){if(k.serviceIds.has(r))return k.serviceIds.get(r);const P=function(y,C,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(P,y,I,!1)};return P.toString=()=>r,k.serviceIds.set(r,P),P}e.createDecorator=D;function R(r){return r}e.refineServiceDecorator=R}),define(te[161],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,k.createDecorator)("checksumService")}),define(te[162],ne([0,1,4,25,6]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=k.userAgent||"";const r=new Map;r.set("false",!1),r.set("true",!0),r.set("isMac",k.isMacintosh),r.set("isLinux",k.isLinux),r.set("isWindows",k.isWindows),r.set("isWeb",k.isWeb),r.set("isMacNative",k.isMacintosh&&!k.isWeb),r.set("isEdge",R.indexOf("Edg/")>=0),r.set("isFirefox",R.indexOf("Firefox")>=0),r.set("isChrome",R.indexOf("Chrome")>=0),r.set("isSafari",R.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var y;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return f.INSTANCE}static true(){return p.INSTANCE}static has(L){return h.create(L)}static equals(L,$){return E.create(L,$)}static notEquals(L,$){return v.create(L,$)}static regex(L,$){return t.create(L,$)}static in(L,$){return S.create(L,$)}static not(L){return d.create(L)}static and(...L){return u.create(L,null)}static or(...L){return g.create(L,null,!0)}static greater(L,$){return l.create(L,$)}static greaterEquals(L,$){return n.create(L,$)}static smaller(L,$){return s.create(L,$)}static smallerEquals(L,$){return i.create(L,$)}static deserialize(L,$=!1){if(!!L)return this._deserializeOrExpression(L,$)}static _deserializeOrExpression(L,$){let _=L.split("||");return g.create(_.map(M=>this._deserializeAndExpression(M,$)),null,!0)}static _deserializeAndExpression(L,$){let _=L.split("&&");return u.create(_.map(M=>this._deserializeOne(M,$)),null)}static _deserializeOne(L,$){if(L=L.trim(),L.indexOf("!=")>=0){let _=L.split("!=");return v.create(_[0].trim(),this._deserializeValue(_[1],$))}if(L.indexOf("==")>=0){let _=L.split("==");return E.create(_[0].trim(),this._deserializeValue(_[1],$))}if(L.indexOf("=~")>=0){let _=L.split("=~");return t.create(_[0].trim(),this._deserializeRegexValue(_[1],$))}if(L.indexOf(" in ")>=0){let _=L.split(" in ");return S.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const _=L.split(">=");return n.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const _=L.split(">");return l.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const _=L.split("<=");return i.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const _=L.split("<");return s.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(L)?d.create(L.substr(1).trim()):h.create(L)}static _deserializeValue(L,$){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;let _=/^'([^']*)'$/.exec(L);return _?_[1].trim():L}static _deserializeRegexValue(L,$){if((0,T.isFalsyOrWhitespace)(L)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=L.indexOf("/"),M=L.lastIndexOf("/");if(_===M||_<0){if($)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}let W=L.slice(_+1,M),j=L[M+1]==="i"?"i":"";try{return new RegExp(W,j)}catch(q){if($)throw new Error(`bad regexp-value '${L}', parse error: ${q}`);return console.warn(`bad regexp-value '${L}', parse error: ${q}`),null}}}e.ContextKeyExpr=C;function I(N,L){const $=N?N.substituteConstants():void 0,_=L?L.substituteConstants():void 0;return!$&&!_?!0:!$||!_?!1:$.equals(_)}e.expressionsAreEqualWithConstantSubstitution=I;function w(N,L){return N.cmp(L)}class f{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class p{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(L,$){this.key=L,this.negated=$,this.type=2}static create(L,$=null){const _=r.get(L);return typeof _=="boolean"?_?p.INSTANCE:f.INSTANCE:new h(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=r.get(this.key);return typeof L=="boolean"?L?p.INSTANCE:f.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=d.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class E{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=4}static create(L,$,_=null){if(typeof $=="boolean")return $?h.create(L,_):d.create(L,_);const M=r.get(L);return typeof M=="boolean"?$===(M?"true":"false")?p.INSTANCE:f.INSTANCE:new E(L,$,_)}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=r.get(this.key);if(typeof L=="boolean"){const $=L?"true":"false";return this.value===$?p.INSTANCE:f.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=E;class S{constructor(L,$){this.key=L,this.valueKey=$,this.type=10,this.negated=null}static create(L,$){return new S(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const $=L.getValue(this.valueKey),_=L.getValue(this.key);return Array.isArray($)?$.indexOf(_)>=0:typeof _=="string"&&typeof $=="object"&&$!==null?P.call($,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=S;class m{constructor(L){this._actual=L,this.type=11}static create(L){return new m(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new m(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class v{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=5}static create(L,$,_=null){if(typeof $=="boolean")return $?d.create(L,_):h.create(L,_);const M=r.get(L);return typeof M=="boolean"?$===(M?"true":"false")?f.INSTANCE:p.INSTANCE:new v(L,$,_)}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=r.get(this.key);if(typeof L=="boolean"){const $=L?"true":"false";return this.value===$?f.INSTANCE:p.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=v;class d{constructor(L,$){this.key=L,this.negated=$,this.type=3}static create(L,$=null){const _=r.get(L);return typeof _=="boolean"?_?f.INSTANCE:p.INSTANCE:new d(L,$)}cmp(L){return L.type!==this.type?this.type-L.type:A(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=r.get(this.key);return typeof L=="boolean"?L?f.INSTANCE:p.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=d;function c(N,L){if(typeof N=="string"){const $=parseFloat(N);isNaN($)||(N=$)}return typeof N=="string"||typeof N=="number"?L(N):f.INSTANCE}class l{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=12}static create(L,$,_=null){return c($,M=>new l(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class n{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=13}static create(L,$,_=null){return c($,M=>new n(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=n;class s{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=14}static create(L,$,_=null){return c($,M=>new s(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class i{constructor(L,$,_){this.key=L,this.value=$,this.negated=_,this.type=15}static create(L,$,_=null){return c($,M=>new i(L,M,_))}cmp(L){return L.type!==this.type?this.type-L.type:O(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class t{constructor(L,$){this.key=L,this.regexp=$,this.type=7,this.negated=null}static create(L,$){return new t(L,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const $=this.regexp?this.regexp.source:"",_=L.regexp?L.regexp.source:"";return $<_?-1:$>_?1:0}equals(L){if(L.type===this.type){const $=this.regexp?this.regexp.source:"",_=L.regexp?L.regexp.source:"";return this.key===L.key&&$===_}return!1}substituteConstants(){return this}evaluate(L){let $=L.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class o{constructor(L){this._actual=L,this.type=8}static create(L){return new o(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new o(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function a(N){let L=null;for(let $=0,_=N.length;$<_;$++){const M=N[$].substituteConstants();if(N[$]!==M&&L===null){L=[];for(let W=0;W<$;W++)L[W]=N[W]}L!==null&&(L[$]=M)}return L===null?N:L}class u{constructor(L,$){this.expr=L,this.negated=$,this.type=6}static create(L,$){return u._normalizeArr(L,$)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,_=this.expr.length;$<_;$++){const M=w(this.expr[$],L.expr[$]);if(M!==0)return M}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:u.create(L,this.negated)}evaluate(L){for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].evaluate(L))return!1;return!0}static _normalizeArr(L,$){const _=[];let M=!1;for(const W of L)if(!!W){if(W.type===1){M=!0;continue}if(W.type===0)return f.INSTANCE;if(W.type===6){_.push(...W.expr);continue}_.push(W)}if(_.length===0&&M)return p.INSTANCE;if(_.length!==0){if(_.length===1)return _[0];_.sort(w);for(let W=1;W<_.length;W++)_[W-1].equals(_[W])&&(_.splice(W,1),W--);if(_.length===1)return _[0];for(;_.length>1;){const W=_[_.length-1];if(W.type!==9)break;_.pop();const j=_.pop(),q=_.length===0,z=g.create(W.expr.map(K=>u.create([K,j],null)),null,q);z&&(_.push(z),_.sort(w))}return _.length===1?_[0]:new u(_,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(let $ of this.expr)L.push(...$.keys());return L}map(L){return new u(this.expr.map($=>$.map(L)),null)}negate(){if(!this.negated){const L=[];for(let $ of this.expr)L.push($.negate());this.negated=g.create(L,this,!0)}return this.negated}}class g{constructor(L,$){this.expr=L,this.negated=$,this.type=9}static create(L,$,_){return g._normalizeArr(L,$,_)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let $=0,_=this.expr.length;$<_;$++){const M=w(this.expr[$],L.expr[$]);if(M!==0)return M}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let $=0,_=this.expr.length;$<_;$++)if(!this.expr[$].equals(L.expr[$]))return!1;return!0}return!1}substituteConstants(){const L=a(this.expr);return L===this.expr?this:g.create(L,this.negated,!1)}evaluate(L){for(let $=0,_=this.expr.length;$<_;$++)if(this.expr[$].evaluate(L))return!0;return!1}static _normalizeArr(L,$,_){let M=[],W=!1;if(L){for(let j=0,q=L.length;j<q;j++){const z=L[j];if(!!z){if(z.type===0){W=!0;continue}if(z.type===1)return p.INSTANCE;if(z.type===9){M=M.concat(z.expr);continue}M.push(z)}}if(M.length===0&&W)return f.INSTANCE;M.sort(w)}if(M.length!==0){if(M.length===1)return M[0];for(let j=1;j<M.length;j++)M[j-1].equals(M[j])&&(M.splice(j,1),j--);if(M.length===1)return M[0];if(_){for(let j=0;j<M.length;j++)for(let q=j+1;q<M.length;q++)U(M[j],M[q])&&(M.splice(q,1),q--);if(M.length===1)return M[0]}return new g(M,$)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(let $ of this.expr)L.push(...$.keys());return L}map(L){return new g(this.expr.map($=>$.map(L)),null)}negate(){if(!this.negated){let L=[];for(let $ of this.expr)L.push($.negate());for(;L.length>1;){const $=L.shift(),_=L.shift(),M=[];for(const j of x($))for(const q of x(_))M.push(u.create([j,q],null));const W=L.length===0;L.unshift(g.create(M,null,W))}this.negated=L[0]}return this.negated}}class b extends h{constructor(L,$,_){super(L,null);this._defaultValue=$,typeof _=="object"?b._info.push({..._,key:L}):_!==!0&&b._info.push({key:L,description:_,type:$!=null?typeof $:void 0})}static all(){return b._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return E.create(this.key,L)}notEqualsTo(L){return v.create(this.key,L)}}e.RawContextKey=b,b._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function A(N,L){return N<L?-1:N>L?1:0}function O(N,L,$,_){return N<$?-1:N>$?1:L<_?-1:L>_?1:0}function U(N,L){if(L.type===6&&N.type!==9&&N.type!==6){for(const M of L.expr)if(N.equals(M))return!0}const $=N.negate(),_=x($).concat(x(L));_.sort(w);for(let M=0;M<_.length;M++){const j=_[M].negate();for(let q=M+1;q<_.length;q++){const z=_[q];if(j.equals(z))return!0}}return!1}e.implies=U;function x(N){return N.type===9?N.expr:[N]}}),define(te[79],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,k.createDecorator)(e.ID);function T(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=T}),define(te[80],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,k.createDecorator)("downloadService")}),define(te[11],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,k.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,k.refineServiceDecorator)(e.IEnvironmentService)}),define(te[30],ne([0,1,15,133,6]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var R;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(R=e.TargetPlatform||(e.TargetPlatform={}));function r(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=r;function P(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=P;function y(d,c){switch(d){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function C(d,c){return c==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function I(d,c,l){return C(c,l)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===l?!0:w(l).includes(d)}e.isTargetPlatformCompatible=I;function w(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function f(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=f;var p;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var E;(function(d){d.Install="install",d.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var S;(function(d){d[d.None=0]="None",d[d.Install=1]="Install",d[d.Update=2]="Update"})(S=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var m;(function(d){d.Unsupported="Unsupported",d.Malicious="Malicious",d.Incompatible="Incompatible",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class v extends Error{constructor(c,l){super(c);this.code=l,this.name=l}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=k.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=(0,T.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,T.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var J=this&&this.__param||function(X,e){return function(k,T){e(k,T,X)}};define(te[163],ne([0,1,2,30]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let D=class extends k.Disposable{constructor(r){super();this.extensionManagementService=r,this._register(r),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};D=he([J(0,T.IExtensionManagementService)],D),e.DeprecatedExtensionsCleaner=D}),define(te[164],ne([0,1,3,2,26,8,111,30]),function(X,e,k,T,D,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function y(E,S){return R.URI.revive(S?S.transformIncoming(E):E)}function C(E,S){return S?S.transformOutgoingURI(E):E}function I(E,S){S=S||r.DefaultURITransformer;const m=E.manifest;return{...(0,r.transformAndReviveIncomingURIs)({...E,manifest:void 0},S),manifest:m}}function w(E,S){return S?(0,D.cloneAndChange)(E,m=>m instanceof R.URI?S.transformOutgoingURI(m):void 0):E}class f{constructor(S,m){this.service=S,this.getUriTransformer=m,this.onInstallExtension=k.Event.buffer(S.onInstallExtension,!0),this.onDidInstallExtensions=k.Event.buffer(S.onDidInstallExtensions,!0),this.onUninstallExtension=k.Event.buffer(S.onUninstallExtension,!0),this.onDidUninstallExtension=k.Event.buffer(S.onDidUninstallExtension,!0)}listen(S,m){const v=this.getUriTransformer(S);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return k.Event.map(this.onDidInstallExtensions,d=>d.map(c=>({...c,local:c.local?w(c.local,v):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(S,m,v){const d=this.getUriTransformer(S);switch(m){case"zip":return this.service.zip(I(v[0],d)).then(c=>C(c,d));case"unzip":return this.service.unzip(y(v[0],d));case"install":return this.service.install(y(v[0],d),v[1]);case"getManifest":return this.service.getManifest(y(v[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(v[0]);case"installFromGallery":return this.service.installFromGallery(v[0],v[1]);case"uninstall":return this.service.uninstall(I(v[0],d),v[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(I(v[0],d));case"getInstalled":return this.service.getInstalled(v[0]).then(c=>c.map(l=>w(l,d)));case"updateMetadata":return this.service.updateMetadata(I(v[0],d),v[1]).then(c=>w(c,d));case"updateExtensionScope":return this.service.updateExtensionScope(I(v[0],d),v[1]).then(c=>w(c,d));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class p extends T.Disposable{constructor(S){super();this.channel=S,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?R.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(v=>({...v,local:v.local?I(v.local,null):v.local,source:this.isUriComponents(v.source)?R.URI.revive(v.source):v.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(S){return S?typeof S.path=="string"&&typeof S.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(S){const m=await this.getTargetPlatform();return S.allTargetPlatforms.some(v=>(0,P.isTargetPlatformCompatible)(v,S.allTargetPlatforms,m))}zip(S){return Promise.resolve(this.channel.call("zip",[S]).then(m=>R.URI.revive(m)))}unzip(S){return Promise.resolve(this.channel.call("unzip",[S]))}install(S,m){return Promise.resolve(this.channel.call("install",[S,m])).then(v=>I(v,null))}getManifest(S){return Promise.resolve(this.channel.call("getManifest",[S]))}installFromGallery(S,m){return Promise.resolve(this.channel.call("installFromGallery",[S,m])).then(v=>I(v,null))}uninstall(S,m){return Promise.resolve(this.channel.call("uninstall",[S,m]))}reinstallFromGallery(S){return Promise.resolve(this.channel.call("reinstallFromGallery",[S]))}getInstalled(S=null){return Promise.resolve(this.channel.call("getInstalled",[S])).then(m=>m.map(v=>I(v,null)))}updateMetadata(S,m){return Promise.resolve(this.channel.call("updateMetadata",[S,m])).then(v=>I(v,null))}updateExtensionScope(S,m){return Promise.resolve(this.channel.call("updateExtensionScope",[S,m])).then(v=>I(v,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class h{constructor(S){this.service=S}listen(S,m){throw new Error("Invalid listen")}call(S,m,v){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(R.URI.revive(v[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[81],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var T;(function(r){r[r.FILE=1]="FILE",r[r.WORKSPACE=2]="WORKSPACE",r[r.EXE=3]="EXE"})(T=e.RecommendationSource||(e.RecommendationSource={}));function D(r){switch(r){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var R;(function(r){r.Ignored="ignored",r.Cancelled="cancelled",r.TooMany="toomany",r.IncompatibleWindow="incompatibleWindow",r.Accepted="reacted"})(R=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,k.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[82],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,k.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[14],ne([0,1,41,9,25,17,8,140,6]),function(X,e,k,T,D,R,r,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function C(_){return _.create===!0}e.isFileOpenForWriteOptions=C;var I;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var w;(function(_){_[_.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var f;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=p;function h(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=h;function E(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=E;function S(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=S;var m;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(M,W){super(M);this.code=W}}e.FileSystemProviderError=v;function d(_,M){const W=new v(_.toString(),M);return l(W,M),W}e.createFileSystemProviderError=d;function c(_){return _||d((0,P.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=c;function l(_,M){return _.name=M?`${M} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=l;function n(_){if(!_)return m.Unknown;if(_ instanceof v)return _.code;const M=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!M)return m.Unknown;switch(M[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=n;function s(_){if(_ instanceof g)return _.fileOperationResult;switch(n(_)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var i;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class t{constructor(M,W,j){this.resource=M,this.operation=W,this.target=j}isOperation(M){return this.operation===M}}e.FileOperationEvent=t;var o;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class a{constructor(M,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;const j=new Map;for(const q of M){const z=j.get(q.type);z?z.push([q.resource,q]):j.set(q.type,[[q.resource,q]])}for(const[q,z]of j)switch(q){case 1:this.added=k.TernarySearchTree.forUris(()=>W),this.added.fill(z);break;case 0:this.updated=k.TernarySearchTree.forUris(()=>W),this.updated.fill(z);break;case 2:this.deleted=k.TernarySearchTree.forUris(()=>W),this.deleted.fill(z);break}}contains(M,...W){return this.doContains(M,{includeChildren:!1},...W)}affects(M,...W){return this.doContains(M,{includeChildren:!0},...W)}doContains(M,W,...j){if(!M)return!1;const q=j.length>0;return!!((!q||j.includes(1))&&(this.added?.get(M)||W.includeChildren&&this.added?.findSuperstr(M))||(!q||j.includes(0))&&(this.updated?.get(M)||W.includeChildren&&this.updated?.findSuperstr(M))||(!q||j.includes(2))&&(this.deleted?.findSubstr(M)||W.includeChildren&&this.deleted?.findSuperstr(M)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=a;function u(_,M,W){return!_||!M||_===M||M.length>_.length?!1:(M.charAt(M.length-1)!==T.sep&&(M+=T.sep),W?(0,D.startsWithIgnoreCase)(_,M):_.indexOf(M)===0)}e.isParent=u;class g extends Error{constructor(M,W,j){super(M);this.fileOperationResult=W,this.options=j}}e.FileOperationError=g;class b extends g{constructor(M,W,j){super(M,2,j);this.stat=W}}e.NotModifiedSinceFileOperationError=b;var A;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=U;async function x(_,M){if(!M.hasProvider(r.URI.from({scheme:_.scheme})))return new Promise(W=>{const j=M.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===_.scheme&&q.added&&(j.dispose(),W())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(M){return(0,R.isNumber)(M)||(M=0),M<N.KB?(0,P.localize)(1,null,M.toFixed(0)):M<N.MB?(0,P.localize)(2,null,(M/N.KB).toFixed(2)):M<N.GB?(0,P.localize)(3,null,(M/N.MB).toFixed(2)):M<N.TB?(0,P.localize)(4,null,(M/N.GB).toFixed(2)):(0,P.localize)(5,null,(M/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var L;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function $(_){return{maxFileSize:_===0?300*N.MB:16*N.GB,maxHeapSize:_===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=$}),define(te[165],ne([0,1,83,50,14]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let R=class{constructor(P){this.fileService=P}async checksum(P){const y=(await this.fileService.readFileStream(P)).value;return new Promise((C,I)=>{const w=(0,k.createHash)("md5");(0,T.listenStream)(y,{onData:f=>w.update(f.buffer),onError:f=>I(f),onEnd:()=>C(w.digest("base64").replace(/=+$/,""))})})}};R=he([J(0,D.IFileService)],R),e.ChecksumService=R}),define(te[166],ne([0,1,248,130,153,14]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function r(f,p){const h={onUnknownOption:S=>{console.warn((0,T.localize)(0,null,S))},onMultipleValues:(S,m)=>{console.warn((0,T.localize)(1,null,S,m))}},E=(0,D.parseArgs)(f,D.OPTIONS,p?h:void 0);return E.goto&&E._.forEach(S=>k(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,T.localize)(2,null))),E["max-memory"]&&k(parseInt(E["max-memory"])>=R.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${R.MIN_MAX_MEMORY_SIZE_MB} MB.`),E}function P(f){const p=f.findIndex(h=>!/^-/.test(h));if(p>-1)return[...f.slice(0,p),...f.slice(p+1)]}function y(f){let[,...p]=f;process.env.VSCODE_DEV&&(p=P(p)||[]);const h=!w(process.env);return r(p,h)}e.parseMainProcessArgv=y;function C(f){const[,,...p]=f;return r(p,!0)}e.parseCLIProcessArgv=C;function I(f,...p){const h=f.indexOf("--");return h===-1?f.push(...p):f.splice(h,0,...p),f}e.addArg=I;function w(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),define(te[167],ne([0,1,43,9,131,28,38,7,4,29,126,166,5]),function(X,e,k,T,D,R,r,P,y,C,I,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const p=1e4;let h;async function E(m,v,d){return v["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(d)&&!v["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(d)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=f.Promises.withAsyncBody(async(c,l)=>{const n=new R.CancellationTokenSource,s=setTimeout(()=>{n.dispose(!0),l(new Error((0,D.localize)(0,null)))},p);try{c(await S(m,n.token))}catch(i){!(0,P.isPromiseCanceledError)(i)&&!n.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,r.toErrorMessage)(i)))):c({})}finally{clearTimeout(s),n.dispose()}})),h)}e.resolveShellEnv=E;async function S(m,v){const d=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",d);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",c);const l=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(l+"(.*)"+l),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",s);const i=await(0,I.getSystemShell)(y.OS,s);return m.trace("getUnixShellEnvironment#shell",i),new Promise((t,o)=>{if(v.isCancellationRequested)return o((0,P.canceled)());const a=(0,T.basename)(i);let u,g;const b=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(u=`& '${process.execPath}' ${b} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,g=["-Login","-Command"]):(u=`'${process.execPath}' ${b} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,a==="tcsh"?g=["-ic"]:g=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(g),u);const A=(0,k.spawn)(i,[...g,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});v.onCancellationRequested(()=>(A.kill(),o((0,P.canceled)()))),A.on("error",x=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,r.toErrorMessage)(x)),o(x)});const O=[];A.stdout.on("data",x=>O.push(x));const U=[];A.stderr.on("data",x=>U.push(x)),A.on("close",(x,N)=>{const L=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",L);const $=Buffer.concat(U).toString("utf8");if($.trim()&&m.trace("getUnixShellEnvironment#stderr",$),x||N)return o(new Error((0,D.localize)(2,null,x,N)));const _=n.exec(L),M=_?_[1]:"{}";try{const W=JSON.parse(M);d?W.ELECTRON_RUN_AS_NODE=d:delete W.ELECTRON_RUN_AS_NODE,c?W.ELECTRON_NO_ATTACH_CONSOLE=c:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",W),t(W)}catch(W){m.error("getUnixShellEnvironment#errorCaught",(0,r.toErrorMessage)(W)),o(W)}})})}}),define(te[84],ne([0,1,19,7,141,14]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function r(I,w,f,p,h,E){let S;try{await P(I,w,f,p,h,E)}catch(m){S=m}finally{S&&h.errorTransformer&&(S=h.errorTransformer(S)),typeof S!="undefined"&&f.error(S),f.end()}}e.readFileIntoStream=r;async function P(I,w,f,p,h,E){y(E);const S=await I.open(w,{create:!1});try{y(E);let m=0,v=0,d=h&&typeof h.length=="number"?h.length:void 0,c=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof d=="number"?d:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,n=0;do v=await I.read(S,l,c.buffer,n,c.byteLength-n),l+=v,n+=v,m+=v,typeof d=="number"&&(d-=v),n===c.byteLength&&(await f.write(p(c)),c=k.VSBuffer.alloc(Math.min(h.bufferSize,typeof d=="number"?d:h.bufferSize)),n=0);while(v>0&&(typeof d!="number"||d>0)&&y(E)&&C(m,h));if(n>0){let s=n;typeof d=="number"&&(s=Math.min(n,d)),f.write(p(c.slice(0,s)))}}catch(m){throw(0,R.ensureFileSystemProviderError)(m)}finally{await I.close(S)}}function y(I){if(I.isCancellationRequested)throw(0,T.canceled)();return!0}function C(I,w){if(w?.limits){if(typeof w.limits.memory=="number"&&I>w.limits.memory)throw(0,R.createFileSystemProviderError)((0,D.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&I>w.limits.size)throw(0,R.createFileSystemProviderError)((0,D.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[54],ne([0,1,2,4,8,14]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class r extends k.Disposable{constructor(f,p,h){super();this.onFileChanges=f,this.onLogMessage=p,this.verboseLogging=h,this.serviceDisposables=this._register(new k.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const f=new k.DisposableStore;this.serviceDisposables.value=f,this.service=this.createService(f),this.service.setVerboseLogging(this.verboseLogging),f.add(this.service.onDidChangeFile(p=>this.onFileChanges(p))),f.add(this.service.onDidLogMessage(p=>this.onLogMessage(p))),f.add(this.service.onDidError(p=>this.onError(p)))}onError(f){this.restartCounter<r.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${f}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${f}`)}restart(f){this.restartCounter++,this.init(),this.watch(f)}async watch(f){this.requests=f,await this.service?.watch(f)}async setVerboseLogging(f){this.verboseLogging=f,await this.service?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${f}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=r,r.MAX_RESTARTS=5;class P extends k.Disposable{}e.WatcherService=P;function y(w){return w.map(f=>({type:f.type,resource:D.URI.file(f.path)}))}e.toFileChanges=y;function C(w){const f=new I;for(const p of w)f.processEvent(p);return f.coalesce()}e.coalesceEvents=C;class I{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(f){return T.isLinux?f.path:f.path.toLowerCase()}processEvent(f){const p=this.mapPathToChange.get(this.toKey(f));let h=!1;if(p){const E=p.type,S=f.type;p.path!==f.path&&f.type===2?h=!0:E===1&&S===2?(this.mapPathToChange.delete(this.toKey(f)),this.coalesced.delete(p)):E===2&&S===1?p.type=0:E===1&&S===0||(p.type=S)}else h=!0;h&&(this.coalesced.add(f),this.mapPathToChange.set(this.toKey(f),f))}coalesce(){const f=[],p=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(f.push(h),!1):!0).sort((h,E)=>h.path.length-E.path.length).filter(h=>p.some(E=>(0,R.isParent)(h.path,E,!T.isLinux))?!1:(p.push(h.path),!0)).concat(f)}}}),define(te[168],ne([0,1,5,2,9,116,20,119,54]),function(X,e,k,T,D,R,r,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class C extends T.Disposable{constructor(w,f,p,h){super();this.path=w,this.onDidFilesChange=f,this.onLogMessage=p,this.verboseLogging=h,this.fileChangesDelayer=this._register(new k.ThrottledDelayer(P.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(w){this.verboseLogging=w}async startWatching(){try{const{stat:w,symbolicLink:f}=await r.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let p=this.path;if(f)try{p=await(0,R.realpath)(p)}catch(h){if(this.onError(h),f.dangling)return}w.isDirectory()?this._register((0,P.watchFolder)(p,(h,E)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(E))})},h=>this.onError(h))):this._register((0,P.watchFile)(p,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(w){w.code!=="ENOENT"&&this.onError(w)}}onFileChange(w){this.fileChangesBuffer.push(w),this.verboseLogging&&this.onVerbose(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const p=(0,y.coalesceEvents)(f);if(this.verboseLogging)for(const h of p)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);p.length>0&&this.onDidFilesChange(p)})}onError(w){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${w}`})}onVerbose(w){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=C}),define(te[169],ne([0,1,15,34,52,54]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class r extends R.WatcherService{constructor(y,C,I){super();this.onDidFilesChange=y,this.onLogMessage=C,this.verboseLogging=I,this.isDisposed=!1,this.startWatching()}startWatching(){const y=this._register(new D.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=T.ProxyChannel.toService((0,T.getNextTickChannel)(y.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(C=>!this.isDisposed&&this.onDidFilesChange(C))),this._register(this.service.onDidLogMessage(C=>this.onLogMessage(C)))}async setVerboseLogging(y){this.verboseLogging=y,this.isDisposed||await this.service?.setVerboseLogging(y)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${y}`})}async watch(y){this.isDisposed||await this.service?.watch(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=r}),define(te[170],ne([0,1,15,34,52,54]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class r extends R.AbstractWatcherService{constructor(y,C,I){super(y,C,I);this.init()}createService(y){const C=y.add(new D.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(C.onDidProcessExit(({code:I,signal:w})=>this.onError(`terminated by itself with code ${I}, signal: ${w}`))),T.ProxyChannel.toService((0,T.getNextTickChannel)(C.getChannel("watcher")))}}e.FileWatcher=r}),define(te[85],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class k{constructor(...D){this._entries=new Map;for(let[R,r]of D)this.set(R,r)}set(D,R){const r=this._entries.get(D);return this._entries.set(D,R),r}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=k}),define(te[171],ne([0,1,5,7,53,160,6,85]),function(X,e,k,T,D,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class C extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new P.ServiceCollection,E=!1,S){this._activeInstantiations=new Set,this._services=h,this._strict=E,this._parent=S,this._services.set(r.IInstantiationService,this)}createChild(h){return new I(h,this._strict,this)}invokeFunction(h,...E){let S=f.traceInvocation(h),m=!1;try{return h({get:d=>{if(m)throw(0,T.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(d,S);if(!c)throw new Error(`[invokeFunction] unknown service '${d}'`);return c}},...E)}finally{m=!0,S.stop()}}createInstance(h,...E){let S,m;return h instanceof D.SyncDescriptor?(S=f.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(E),S)):(S=f.traceCreation(h),m=this._createInstance(h,E,S)),S.stop(),m}_createInstance(h,E=[],S){let m=r._util.getServiceDependencies(h).sort((c,l)=>c.index-l.index),v=[];for(const c of m){let l=this._getOrCreateServiceInstance(c.id,S);if(!l&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);v.push(l)}let d=m.length>0?m[0].index:E.length;if(E.length!==d){console.warn(`[createInstance] First service dependency of ${h.name} at position ${d+1} conflicts with ${E.length} static arguments`);let c=d-E.length;c>0?E=E.concat(new Array(c)):E=E.slice(0,d)}return new h(...[...E,...v])}_setServiceInstance(h,E){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,E);else if(this._parent)this._parent._setServiceInstance(h,E);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let E=this._services.get(h);return!E&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):E}_getOrCreateServiceInstance(h,E){let S=this._getServiceInstanceOrDescriptor(h);return S instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,S,E.branch(h,!0)):(E.branch(h,!1),S)}_safeCreateAndCacheServiceInstance(h,E,S){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,E,S)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,E,S){const m=new R.Graph(c=>c.id.toString());let v=0;const d=[{id:h,desc:E,_trace:S}];for(;d.length;){const c=d.pop();if(m.lookupOrInsertNode(c),v++>1e3)throw new C(m);for(let l of r._util.getServiceDependencies(c.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(l.id);if(!n&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),n instanceof D.SyncDescriptor){const s={id:l.id,desc:n,_trace:c._trace.branch(l.id,!0)};m.insertEdge(c,s),d.push(s)}}}for(;;){const c=m.roots();if(c.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:l}of c){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const s=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,s)}m.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,E,S=[],m,v){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(E,S,m,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,E,S,m,v);throw new Error(`illegalState - creating UNKNOWN service instance ${E.name}`)}_createServiceInstance(h,E=[],S,m){if(S){const v=new k.IdleValue(()=>this._createInstance(h,E,m));return new Proxy(Object.create(null),{get(d,c){if(c in d)return d[c];let l=v.value,n=l[c];return typeof n!="function"||(n=n.bind(l),d[c]=n),n},set(d,c,l){return v.value[c]=l,!0}})}else return this._createInstance(h,E,m)}}e.InstantiationService=I;var w;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(w||(w={}));class f{constructor(h,E){this.type=h,this.name=E,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return y?new f(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(h){return y?new f(0,h.name):f._None}branch(h,E){let S=new f(2,h.toString());return this._dep.push([h,E,S]),S}stop(){let h=Date.now()-this._start;f._totals+=h;let E=!1;function S(v,d){let c=[],l=new Array(v+1).join("	");for(const[n,s,i]of d._dep)if(s&&i){E=!0,c.push(`${l}CREATES -> ${n}`);let t=S(v+1,i);t&&c.push(t)}else c.push(`${l}uses -> ${n}`);return c.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(h>2||E)&&console.log(m.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(te[172],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class k{constructor(D,R){this.server=D,this.router=R}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,R){this.server.registerChannel(D,R)}}e.MessagePortMainProcessService=k}),define(te[173],ne([0,1,34,53,59,6]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class r{constructor(p,h,E){const S=E.getChannel(p);return P(h)?new h.channelClientCtor(S):k.ProxyChannel.toService(S,h?.proxyOptions)}}function P(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,R.createDecorator)("mainProcessService");let y=class extends r{constructor(p,h,E){super(p,h,E)}};y=he([J(2,e.IMainProcessService)],y);function C(f,p,h){(0,D.registerSingleton)(f,new T.SyncDescriptor(y,[p,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=C,e.ISharedProcessService=(0,R.createDecorator)("sharedProcessService");let I=class extends r{constructor(p,h,E){super(p,h,E)}};I=he([J(2,e.ISharedProcessService)],I);function w(f,p,h){(0,D.registerSingleton)(f,new T.SyncDescriptor(I,[p,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=w}),define(te[60],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,k.createDecorator)("localizationsService");function T(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const R of D.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=T}),define(te[174],ne([0,1,2,60]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends k.Disposable{constructor(r){super();this.localizationsService=r,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=he([J(0,T.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(te[10],ne([0,1,38,3,2,4,6]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,r.createDecorator)("logService"),e.ILoggerService=(0,r.createDecorator)("loggerService");function P(){return new Date().toISOString()}var y;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function C(s,i,t){switch(i){case y.Trace:s.trace(t);break;case y.Debug:s.debug(t);break;case y.Info:s.info(t);break;case y.Warning:s.warn(t);break;case y.Error:s.error(t);break;case y.Critical:s.critical(t);break;default:throw new Error("Invalid log level")}}e.log=C;function I(s){let i="";for(let t=0;t<s.length;t++){let o=s[t];if(typeof o=="object")try{o=JSON.stringify(o)}catch(a){}i+=(t>0?" ":"")+o}return i}e.format=I;class w extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class f extends w{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(y.Trace)&&this.log(y.Trace,I([i,...t]))}debug(i,...t){this.checkLogLevel(y.Debug)&&this.log(y.Debug,I([i,...t]))}info(i,...t){this.checkLogLevel(y.Info)&&this.log(y.Info,I([i,...t]))}warn(i,...t){this.checkLogLevel(y.Warning)&&this.log(y.Warning,I([i,...t]))}error(i,...t){if(this.checkLogLevel(y.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(y.Error,I(o))}else this.log(y.Error,I([i,...t]))}critical(i,...t){this.checkLogLevel(y.Critical)&&this.log(y.Critical,I([i,...t]))}flush(){}}e.AbstractMessageLogger=f;class p extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!R.isWindows}trace(i,...t){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}debug(i,...t){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}info(i,...t){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,i,...t):console.log(`[main ${P()}]`,i,...t))}warn(i,...t){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,i,...t):console.warn(`[main ${P()}]`,i,...t))}error(i,...t){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,i,...t):console.error(`[main ${P()}]`,i,...t))}critical(i,...t){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,i,...t):console.error(`[main ${P()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class h extends w{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class E extends w{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,k.toErrorMessage)(i,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=E;class S extends w{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const o of this.logServices)o.trace(i,...t)}debug(i,...t){for(const o of this.logServices)o.debug(i,...t)}info(i,...t){for(const o of this.logServices)o.info(i,...t)}warn(i,...t){for(const o of this.logServices)o.warn(i,...t)}error(i,...t){for(const o of this.logServices)o.error(i,...t)}critical(i,...t){for(const o of this.logServices)o.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=S;class m extends D.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=m;class v extends D.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,t?.always?y.Trace:this.logLevel,t),this.loggers.set(i.toString(),o),t?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class d{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(i){}getLevel(){return y.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=d;function c(s){if(s.verbose)return y.Trace;if(typeof s.logLevel=="string"){const i=l(s.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function l(s){switch(s){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=l;function n(s){switch(s){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=n}),define(te[175],ne([0,1,5,7,2,9,20,11,10]),function(X,e,k,T,D,R,r,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends D.Disposable{constructor(w,f){super();this.environmentService=w,this.logService=f,this._register(new k.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,R.basename)(this.environmentService.logsPath),f=(0,R.dirname)(this.environmentService.logsPath),E=(await r.Promises.readdir(f)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==w),S=E.slice(0,Math.max(0,E.length-9));S.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${S.join(", ")}'`),await Promise.all(S.map(m=>r.Promises.rm((0,R.join)(f,m)))))}catch(w){(0,T.onUnexpectedError)(w)}}};C=he([J(0,P.IEnvironmentService),J(1,y.ILogService)],C),e.LogsDataCleaner=C}),define(te[176],ne([0,1,5,7,2,9,20,11,10]),function(X,e,k,T,D,R,r,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let C=class Et extends D.Disposable{constructor(w,f,p){super();this.backupWorkspacesPath=w,this.environmentService=f,this.logService=p,this._register(new k.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const w=await r.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(w).emptyWorkspaceInfos.map(E=>E.backupFolder),h=await r.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async E=>{E.length!==Et.NON_EMPTY_WORKSPACE_ID_LENGTH&&p.indexOf(E)===-1&&(this.logService.trace(`[storage cleanup]: Deleting storage folder ${E}.`),await r.Promises.rm((0,R.join)(this.environmentService.workspaceStorageHome.fsPath,E)))}))}catch(w){(0,T.onUnexpectedError)(w)}}};C.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,C=he([J(1,P.INativeEnvironmentService),J(2,y.ILogService)],C),e.StorageDataCleaner=C}),define(te[86],ne([0,1,5,19,32,40,11,14,6,10]),function(X,e,k,T,D,R,r,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var I;(function(f){f.ERROR_INVALID_FILE="ERROR_INVALID_FILE",f.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(I=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,y.createDecorator)(e.UserConfigurationFileServiceId);let w=class{constructor(p,h,E){this.environmentService=p,this.fileService=h,this.logService=E,this.queue=new k.Queue}async updateSettings(p,h){return this.queue.queue(()=>this.doWrite(p,h))}async doWrite(p,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),p);const{value:E,mtime:S,etag:m}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let v=E.toString();const d=[];if((0,D.parse)(v,d,{allowTrailingComma:!0,allowEmptyContent:!0}),d.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(p,v,h)[0];if(c){v=v.substring(0,c.offset)+c.content+v.substring(c.offset+c.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,T.VSBuffer.fromString(v),{etag:m,mtime:S})}catch(l){if(l.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(p,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,p,h)})}getEdits({value:p,path:h},E,S){return h.length?(0,R.setProperty)(E,h,p,S):[{content:JSON.stringify(p,null,S.insertSpaces&&S.tabSize?" ".repeat(S.tabSize):"	"),length:E.length,offset:0}]}};w=he([J(0,r.IEnvironmentService),J(1,P.IFileService),J(2,C.ILogService)],w),e.UserConfigurationFileService=w}),define(te[177],ne([0,1,43,5,38,3,2,15,9,20,11,10]),function(X,e,k,T,D,R,r,P,y,C,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends r.Disposable{constructor(h,E){super();this.environmentService=h,this.logService=E,this.processesLimiter=new T.Limiter(5)}async postUninstall(h){const E=this.parseScript(h,"uninstall");return E&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(E.script,"uninstall",E.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${S}`)))),C.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(h,E){const S=`vscode:${E}`;if(h.location.scheme===P.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[S]=="string"){const m=h.manifest.scripts[S].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${S} should be a node script`),null):{script:(0,y.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,E,S,m,v){return new Promise((d,c)=>{const l=this.start(h,E,S,v);let n;const s=i=>{n&&(clearTimeout(n),n=null),i?c(i):d(void 0)};l.on("error",i=>{s((0,D.toErrorMessage)(i)||"Unknown")}),l.on("exit",(i,t)=>{s(i?`post-${E} process exited with code ${i}`:void 0)}),m&&(n=setTimeout(()=>{n=null,l.kill(),c("timed out")},5e3))})}start(h,E,S,m){const v={silent:!0,execArgv:void 0},d=(0,k.fork)(h,[`--type=extension-post-${E}`,...S],v);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const c=R.Event.fromNodeEventEmitter(d.stdout,"data"),l=R.Event.fromNodeEventEmitter(d.stderr,"data");c(i=>this.logService.info(m.identifier.id,m.manifest.version,`post-${E}`,i)),l(i=>this.logService.error(m.identifier.id,m.manifest.version,`post-${E}`,i));const n=R.Event.any(R.Event.map(c,i=>({data:`%c${i}`,format:[""]})),R.Event.map(l,i=>({data:`%c${i}`,format:["color: red"]})));return R.Event.debounce(n,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(m.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),d}getExtensionStoragePath(h){return(0,y.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};f=he([J(0,I.IEnvironmentService),J(1,w.ILogService)],f),e.ExtensionsLifecycle=f}),define(te[178],ne([0,1,7,2,82,3,43,15,113,4,10,59,26,31,70,5]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let S=class extends T.Disposable{constructor(d,c){super();this.id=d,this._logService=c,this._onStdout=this._register(new R.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new R.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new R.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onExit=this._register(new R.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(d){const c=h.StopWatch.create(!1);this._process=(0,r.fork)(P.FileAccess.asFileUri("bootstrap-fork",X).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,f.mixin)({cwd:(0,p.cwd)()},d));const l=c.elapsed(),n=this._process.pid;this._logService.info(`Starting extension host with pid ${n} (fork() took ${l} ms).`);const s=new y.StringDecoder("utf-8");this._process.stdout?.on("data",t=>{const o=typeof t=="string"?t:s.write(t);this._onStdout.fire(o)});const i=new y.StringDecoder("utf-8");return this._process.stderr?.on("data",t=>{const o=typeof t=="string"?t:i.write(t);this._onStderr.fire(o)}),this._process.on("message",t=>{this._onMessage.fire(t)}),this._process.on("error",t=>{this._onError.fire({error:(0,k.transformErrorForSerialization)(t)})}),this._process.on("exit",(t,o)=>{this._hasExited=!0,this._onExit.fire({pid:n,code:t,signal:o})}),{pid:n}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):C.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(d){if(!this._process)return;const c=this._process.pid;this._logService.info(`Waiting for extension host with pid ${c} to exit.`),await Promise.race([R.Event.toPromise(this.onExit),(0,E.timeout)(d)]),this._hasExited||(this._logService.info(`Extension host with pid ${c} did not exit within ${d}ms.`),this._process.kill())}};S=he([J(1,I.ILogService)],S);let m=class bt{constructor(d){this._logService=d,this._extHosts=new Map}dispose(){}_getExtHost(d){const c=this._extHosts.get(d);if(!c)throw new Error("Unknown extension host!");return c}onDynamicStdout(d){return this._getExtHost(d).onStdout}onDynamicStderr(d){return this._getExtHost(d).onStderr}onDynamicMessage(d){return this._getExtHost(d).onMessage}onDynamicError(d){return this._getExtHost(d).onError}onDynamicExit(d){return this._getExtHost(d).onExit}async createExtensionHost(){const d=String(++bt._lastId),c=new S(d,this._logService);return this._extHosts.set(d,c),c.onExit(({pid:l,code:n,signal:s})=>{this._logService.info(`Extension host with pid ${l} exited with code: ${n}, signal: ${s}.`),setTimeout(()=>{c.dispose(),this._extHosts.delete(d)})}),{id:d}}async start(d,c){return this._getExtHost(d).start(c)}async enableInspectPort(d){const c=this._extHosts.get(d);return c?c.enableInspectPort():!1}async kill(d){const c=this._extHosts.get(d);!c||c.kill()}async killAllNow(){for(const[,d]of this._extHosts)d.kill()}async waitForAllExit(d){const c=[];for(const[,l]of this._extHosts)c.push(l.waitForExit(d));return E.Promises.settled(c).then(()=>{})}};m._lastId=0,m=he([J(0,I.ILogService)],m),e.ExtensionHostStarter=m,(0,w.registerSingleton)(D.IExtensionHostStarter,m,!0)}),define(te[179],ne([0,1,16,5,7,3,2,9,54,10]),function(X,e,k,T,D,R,r,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends r.Disposable{constructor(f){super();this.logService=f,this._onDidErrorOccur=this._register(new R.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new T.ThrottledDelayer(0))}watch(f,p){return p.recursive?this.watchRecursive(f,p):this.watchNonRecursive(f)}watchRecursive(f,p){const h={path:this.toFilePath(f),excludes:p.excludes},E=(0,k.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,r.toDisposable)(()=>{E(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(f=>(0,D.onUnexpectedError)(f))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(f=>this._onDidChangeFile.fire((0,y.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(f,p){return f.watch(p)}watchNonRecursive(f){const p=this.createNonRecursiveWatcher(this.toFilePath(f),E=>this._onDidChangeFile.fire((0,y.toFileChanges)(E)),E=>this.onWatcherLogMessage(E),this.logService.getLevel()===C.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{p.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)});return(0,r.combinedDisposable)(p,h)}onWatcherLogMessage(f){f.type==="error"&&this._onDidErrorOccur.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,P.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(te[180],ne([0,1,16,5,19,28,3,56,2,41,15,181,18,50,139,14,84,10]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class Ke extends y.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new r.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new r.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new r.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new r.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new r.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new r.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new E.FileChangesEvent(l,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new T.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,l=>this._onDidFilesChange.fire(new E.FileChangesEvent(l,!0)))),this.watchedResources=C.TernarySearchTree.forUris(l=>{const n=this.getProvider(l.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new T.ResourceQueue)}registerProvider(c,l){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,l),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:l});const n=new y.DisposableStore;return n.add(l.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(l)))),n.add(l.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:l,scheme:c}))),typeof l.onDidErrorOccur=="function"&&n.add(l.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,y.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:l}),this.provider.delete(c),(0,y.dispose)(n)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const l=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(n){l.push(n)}}),!this.provider.has(c)&&await T.Promises.settled(l)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,l){const n=this.provider.get(c.scheme);return!!(n&&n.capabilities&l)}listCapabilities(){return P.Iterable.map(this.provider,([c,l])=>({scheme:c,capabilities:l.capabilities}))}async withProvider(c){if(!(0,f.isAbsolutePath)(c))throw new E.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const l=this.provider.get(c.scheme);if(!l){const n=new Error;throw n.name="ENOPRO",n.message=(0,h.localize)(1,null,c.toString()),n}return l}async withReadProvider(c){const l=await this.withProvider(c);if((0,E.hasOpenReadWriteCloseCapability)(l)||(0,E.hasReadWriteCapability)(l)||(0,E.hasFileReadStreamCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const l=await this.withProvider(c);if((0,E.hasOpenReadWriteCloseCapability)(l)||(0,E.hasReadWriteCapability)(l))return l;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,l){try{return await this.doResolveFile(c,l)}catch(n){throw(0,E.toFileSystemProviderErrorCode)(n)===E.FileSystemProviderErrorCode.FileNotFound?new E.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,E.ensureFileSystemProviderError)(n)}}async doResolveFile(c,l){const n=await this.withProvider(c),s=this.isPathCaseSensitive(n),i=l?.resolveTo,t=l?.resolveSingleChildDescendants,o=l?.resolveMetadata,a=await n.stat(c);let u;return this.toFileStat(n,c,a,void 0,!!o,(g,b)=>(u||(u=C.TernarySearchTree.forUris(()=>!s),u.set(c,!0),i&&u.fill(!0,i)),u.get(g.resource)||u.findSuperstr(g.resource.with({query:null,fragment:null}))?!0:g.isDirectory&&t?b===1:!1))}async toFileStat(c,l,n,s,i,t){const{providerExtUri:o}=this.getExtUri(c),a={resource:l,name:o.basename(l),isFile:(n.type&E.FileType.File)!=0,isDirectory:(n.type&E.FileType.Directory)!=0,isSymbolicLink:(n.type&E.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&E.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,E.etag)({mtime:n.mtime,size:n.size})};if(a.isDirectory&&t(a,s)){try{const u=await c.readdir(l),g=await T.Promises.settled(u.map(async([b,A])=>{try{const O=o.joinPath(l,b),U=i?await c.stat(O):{type:A};return await this.toFileStat(c,O,U,u.length,i,t)}catch(O){return this.logService.trace(O),null}}));a.children=(0,k.coalesce)(g)}catch(u){this.logService.trace(u),a.children=[]}return a}return a}async resolveAll(c){return T.Promises.settled(c.map(async l=>{try{return{stat:await this.doResolveFile(l.resource,l.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(c){const l=await this.withProvider(c);try{return!!await l.stat(c)}catch(n){return!1}}async canCreateFile(c,l){try{await this.doValidateCreateFile(c,l)}catch(n){return n}return!0}async doValidateCreateFile(c,l){if(!l?.overwrite&&await this.exists(c))throw new E.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,l)}async createFile(c,l=D.VSBuffer.fromString(""),n){await this.doValidateCreateFile(c,n);const s=await this.writeFile(c,l);return this._onDidRunOperation.fire(new E.FileOperationEvent(c,0,s)),s}async writeFile(c,l,n){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:i}=this.getExtUri(s);try{await this.validateWriteFile(s,c,n)||await this.mkdirp(s,i.dirname(c));let o;if((0,E.hasReadWriteCapability)(s)&&!(l instanceof D.VSBuffer))if((0,p.isReadableStream)(l)){const a=await(0,p.peekStream)(l,3);a.ended?o=D.VSBuffer.concat(a.buffer):o=a}else o=(0,p.peekReadable)(l,a=>D.VSBuffer.concat(a),3);else o=l;!(0,E.hasOpenReadWriteCloseCapability)(s)||(0,E.hasReadWriteCapability)(s)&&o instanceof D.VSBuffer?await this.doWriteUnbuffered(s,c,n,o):await this.doWriteBuffered(s,c,n,o instanceof D.VSBuffer?(0,D.bufferToReadable)(o):o)}catch(t){throw new E.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,E.ensureFileSystemProviderError)(t).toString()),(0,E.toFileOperationResult)(t),n)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,l,n){if(!!n?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(l)));let i;try{i=await c.stat(l)}catch(t){return}if((i.type&E.FileType.Directory)!=0)throw new E.FileOperationError((0,h.localize)(6,null,this.resourceForError(l)),0,n);if(this.throwIfFileIsReadonly(l,i),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==E.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&n.mtime<i.mtime&&n.etag!==(0,E.etag)({mtime:n.mtime,size:i.size}))throw new E.FileOperationError((0,h.localize)(7,null),3,n);return i}async readFile(c,l){const n=await this.withReadProvider(c);return l?.atomic?this.doReadFileAtomic(n,c,l):this.doReadFile(n,c,l)}async doReadFileAtomic(c,l,n){return new Promise((s,i)=>{this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(c,l,n);s(t)}catch(t){i(t)}})})}async doReadFile(c,l,n){const s=await this.doReadFileStream(c,l,{...n,preferUnbuffered:!0});return{...s,value:await(0,D.streamToBuffer)(s.value)}}async readFileStream(c,l){const n=await this.withReadProvider(c);return this.doReadFileStream(n,c,l)}async doReadFileStream(c,l,n){const s=new R.CancellationTokenSource,i=this.validateReadFile(l,n).then(o=>o,o=>{throw s.cancel(),o});let t;try{return typeof n?.etag=="string"&&n.etag!==E.ETAG_DISABLED&&await i,!((0,E.hasOpenReadWriteCloseCapability)(c)||(0,E.hasFileReadStreamCapability)(c))||(0,E.hasReadWriteCapability)(c)&&n?.preferUnbuffered?t=this.readFileUnbuffered(c,l,n):(0,E.hasFileReadStreamCapability)(c)?t=this.readFileStreamed(c,l,s.token,n):t=this.readFileBuffered(c,l,s.token,n),{...await i,value:t}}catch(o){t&&await(0,p.consumeStream)(t);const a=(0,h.localize)(8,null,this.resourceForError(l),(0,E.ensureFileSystemProviderError)(o).toString());throw o instanceof E.NotModifiedSinceFileOperationError?new E.NotModifiedSinceFileOperationError(a,o.stat,n):new E.FileOperationError(a,(0,E.toFileOperationResult)(o),n)}}readFileStreamed(c,l,n,s=Object.create(null)){const i=c.readFileStream(l,s,n);return(0,p.transform)(i,{data:t=>t instanceof D.VSBuffer?t:D.VSBuffer.wrap(t),error:t=>new E.FileOperationError((0,h.localize)(9,null,this.resourceForError(l),(0,E.ensureFileSystemProviderError)(t).toString()),(0,E.toFileOperationResult)(t),s)},t=>D.VSBuffer.concat(t))}readFileBuffered(c,l,n,s=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,S.readFileIntoStream)(c,l,i,t=>t,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new E.FileOperationError((0,h.localize)(10,null,this.resourceForError(l),(0,E.ensureFileSystemProviderError)(t).toString()),(0,E.toFileOperationResult)(t),s)},n),i}readFileUnbuffered(c,l,n){const s=(0,p.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i=await c.readFile(l);typeof n?.position=="number"&&(i=i.slice(n.position)),typeof n?.length=="number"&&(i=i.slice(0,n.length)),this.validateReadFileLimits(l,i.byteLength,n),s.end(D.VSBuffer.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async validateReadFile(c,l){const n=await this.resolve(c,{resolveMetadata:!0});if(n.isDirectory)throw new E.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,l);if(typeof l?.etag=="string"&&l.etag!==E.ETAG_DISABLED&&l.etag===n.etag)throw new E.NotModifiedSinceFileOperationError((0,h.localize)(12,null),n,l);return this.validateReadFileLimits(c,n.size,l),n}validateReadFileLimits(c,l,n){if(n?.limits){let s;if(typeof n.limits.memory=="number"&&l>n.limits.memory&&(s=9),typeof n.limits.size=="number"&&l>n.limits.size&&(s=7),typeof s=="number")throw new E.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),s)}}async canMove(c,l,n){return this.doCanMoveCopy(c,l,"move",n)}async canCopy(c,l,n){return this.doCanMoveCopy(c,l,"copy",n)}async doCanMoveCopy(c,l,n,s){if(c.toString()!==l.toString())try{const i=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l);await this.doValidateMoveCopy(i,c,t,l,n,s)}catch(i){return i}return!0}async move(c,l,n){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(s,c,i,l,"move",!!n),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(c,t==="move"?2:3,o)),o}async copy(c,l,n){const s=await this.withReadProvider(c),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=await this.doMoveCopy(s,c,i,l,"copy",!!n),o=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(c,t==="copy"?3:2,o)),o}async doMoveCopy(c,l,n,s,i,t){if(l.toString()===s.toString())return i;const{exists:o,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(c,l,n,s,i,t);if(o&&!a&&t&&await this.del(s,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s)),i==="copy"){if(c===n&&(0,E.hasFileFolderCopyCapability)(c))await c.copy(l,s,{overwrite:t});else{const u=await this.resolve(l);u.isDirectory?await this.doCopyFolder(c,u,n,s):await this.doCopyFile(c,l,n,s)}return i}else return c===n?(await c.rename(l,s,{overwrite:t}),i):(await this.doMoveCopy(c,l,n,s,"copy",t),await this.del(l,{recursive:!0}),"copy")}async doCopyFile(c,l,n,s){if((0,E.hasOpenReadWriteCloseCapability)(c)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(c,l,n,s);if((0,E.hasOpenReadWriteCloseCapability)(c)&&(0,E.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(c,l,n,s);if((0,E.hasReadWriteCapability)(c)&&(0,E.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(c,l,n,s);if((0,E.hasReadWriteCapability)(c)&&(0,E.hasReadWriteCapability)(n))return this.doPipeUnbuffered(c,l,n,s)}async doCopyFolder(c,l,n,s){await n.mkdir(s),Array.isArray(l.children)&&await T.Promises.settled(l.children.map(async i=>{const t=this.getExtUri(n).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.doCopyFolder(c,await this.resolve(i.resource),n,t):this.doCopyFile(c,i.resource,n,t)}))}async doValidateMoveCopy(c,l,n,s,i,t){let o=!1;if(c===n){const{providerExtUri:u,isPathCaseSensitive:g}=this.getExtUri(c);if(g||(o=u.isEqual(l,s)),o&&i==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(l),this.resourceForError(s)));if(!o&&u.isEqualOrParent(s,l))throw new Error((0,h.localize)(15,null,this.resourceForError(l),this.resourceForError(s)))}const a=await this.exists(s);if(a&&!o){if(!t)throw new E.FileOperationError((0,h.localize)(16,null,this.resourceForError(l),this.resourceForError(s)),4);if(c===n){const{providerExtUri:u}=this.getExtUri(c);if(u.isEqualOrParent(l,s))throw new Error((0,h.localize)(17,null,this.resourceForError(l),this.resourceForError(s)))}}return{exists:a,isSameResourceWithDifferentPathCase:o}}getExtUri(c){const l=this.isPathCaseSensitive(c);return{providerExtUri:l?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:l}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const l=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(l,c);const n=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new E.FileOperationEvent(c,0,n)),n}async mkdirp(c,l){const n=[],{providerExtUri:s}=this.getExtUri(c);for(;!s.isEqual(l,s.dirname(l));)try{if(((await c.stat(l)).type&E.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(l)));break}catch(i){if((0,E.toFileSystemProviderErrorCode)(i)!==E.FileSystemProviderErrorCode.FileNotFound)throw i;n.push(s.basename(l)),l=s.dirname(l)}for(let i=n.length-1;i>=0;i--){l=s.joinPath(l,n[i]);try{await c.mkdir(l)}catch(t){if((0,E.toFileSystemProviderErrorCode)(t)!==E.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(c,l){try{await this.doValidateDelete(c,l)}catch(n){return n}return!0}async doValidateDelete(c,l){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!l?.useTrash&&!(n.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let i;try{i=await n.stat(c)}catch(o){}if(i)this.throwIfFileIsReadonly(c,i);else throw new E.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!l?.recursive){const o=await this.resolve(c);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return n}async del(c,l){const n=await this.doValidateDelete(c,l),s=!!l?.useTrash,i=!!l?.recursive;await n.delete(c,{recursive:i,useTrash:s}),this._onDidRunOperation.fire(new E.FileOperationEvent(c,1))}onDidChangeFile(c,l){this._onDidChangeFilesRaw.fire({changes:c});let n,s;{for(const i of c)this.watchedResources.has(i.resource)?(n||(n=[]),n.push(i)):(s||(s=[]),s.push(i));n&&this._onDidFilesChange.fire(new E.FileChangesEvent(n,!l))}if(s){const i=l?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(s)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,l={recursive:!1,excludes:[]}){const n=new y.DisposableStore;let s=!1,i=()=>{s=!0};return n.add((0,y.toDisposable)(()=>i())),this.doWatch(c,l).then(t=>{s?(0,y.dispose)(t):i=()=>(0,y.dispose)(t)},t=>this.logService.error(t)),l.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),n.add((0,y.toDisposable)(()=>{const t=this.watchedResources.get(c);typeof t=="number"&&(t<=1?this.watchedResources.delete(c):this.watchedResources.set(c,t-1))}))),n}async doWatch(c,l){const n=await this.withProvider(c),s=this.toWatchKey(n,c,l);let i=this.activeWatchers.get(s);return i||(i={count:0,disposable:n.watch(c,l)},this.activeWatchers.set(s,i)),i.count+=1,(0,y.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,y.dispose)(i.disposable),this.activeWatchers.delete(s)))})}toWatchKey(c,l,n){const{providerExtUri:s}=this.getExtUri(c);return[s.getComparisonKey(l),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,y.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,l,n,s){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(async()=>{const i=await c.open(l,{create:!0,unlock:n?.unlock??!1});try{(0,p.isReadableStream)(s)||(0,p.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(c,i,s):await this.doWriteReadableBufferedQueued(c,i,s)}catch(t){throw(0,E.ensureFileSystemProviderError)(t)}finally{await c.close(i)}})}async doWriteStreamBufferedQueued(c,l,n){let s=0,i;if((0,p.isReadableBufferedStream)(n)){if(n.buffer.length>0){const t=D.VSBuffer.concat(n.buffer);await this.doWriteBuffer(c,l,t,t.byteLength,s,0),s+=t.byteLength}if(n.ended)return;i=n.stream}else i=n;return new Promise((t,o)=>{(0,p.listenStream)(i,{onData:async a=>{i.pause();try{await this.doWriteBuffer(c,l,a,a.byteLength,s,0)}catch(u){return o(u)}s+=a.byteLength,setTimeout(()=>i.resume())},onError:a=>o(a),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(c,l,n){let s=0,i;for(;(i=n.read())!==null;)await this.doWriteBuffer(c,l,i,i.byteLength,s,0),s+=i.byteLength}async doWriteBuffer(c,l,n,s,i,t){let o=0;for(;o<s;)o+=await c.write(l,i+o,n.buffer,t+o,s-o)}async doWriteUnbuffered(c,l,n,s){return this.writeQueue.queueFor(l,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,l,n,s))}async doWriteUnbufferedQueued(c,l,n,s){let i;s instanceof D.VSBuffer?i=s:(0,p.isReadableStream)(s)?i=await(0,D.streamToBuffer)(s):(0,p.isReadableBufferedStream)(s)?i=await(0,D.bufferedStreamToBuffer)(s):i=(0,D.readableToBuffer)(s),await c.writeFile(l,i.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(c,l,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,l,n,s))}async doPipeBufferedQueued(c,l,n,s){let i,t;try{i=await c.open(l,{create:!1}),t=await n.open(s,{create:!0,unlock:!1});const o=D.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,u=0,g=0;do g=await c.read(i,a,o.buffer,u,o.byteLength-u),await this.doWriteBuffer(n,t,o,g,a,u),a+=g,u+=g,u===o.byteLength&&(u=0);while(g>0)}catch(o){throw(0,E.ensureFileSystemProviderError)(o)}finally{await T.Promises.settled([typeof i=="number"?c.close(i):Promise.resolve(),typeof t=="number"?n.close(t):Promise.resolve()])}}async doPipeUnbuffered(c,l,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,l,n,s))}async doPipeUnbufferedQueued(c,l,n,s){return n.writeFile(s,await c.readFile(l),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,l,n,s){return this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,l,n,s))}async doPipeUnbufferedToBufferedQueued(c,l,n,s){const i=await n.open(s,{create:!0,unlock:!1});try{const t=await c.readFile(l);await this.doWriteBuffer(n,i,D.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,E.ensureFileSystemProviderError)(t)}finally{await n.close(i)}}async doPipeBufferedToUnbuffered(c,l,n,s){const i=await(0,D.streamToBuffer)(this.readFileBuffered(c,l,R.CancellationToken.None));await this.doWriteUnbuffered(n,s,void 0,i)}throwIfFileSystemIsReadonly(c,l){if(c.capabilities&2048)throw new E.FileOperationError((0,h.localize)(22,null,this.resourceForError(l)),6);return c}throwIfFileIsReadonly(c,l){if((l.permissions??0)&E.FilePermission.Readonly)throw new E.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===I.Schemas.file?c.fsPath:c.toString(!0)}};v.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},v=he([J(0,m.ILogService)],v),e.FileService=v}),define(te[182],ne([0,1,51,249,5,19,3,42,9,4,18,50,20,142,14,84,168,169,170,179,38]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,T.gracefulify)(k)}catch(n){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(n)}`)}})();class l extends d.AbstractDiskFileSystemProvider{constructor(s,i){super(s);this.options=i,this.onDidChangeCapabilities=r.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:i,symbolicLink:t}=await f.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(s){try{const i=await f.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,I.joinPath)(s,o.name))).type:a=this.toType(o),t.push([o.name,a])}catch(a){this.logService.trace(a)}})),t}catch(i){throw this.toFileSystemProviderError(i)}}toType(s,i){let t;return i?.dangling?t=h.FileType.Unknown:s.isFile()?t=h.FileType.File:s.isDirectory()?t=h.FileType.Directory:t=h.FileType.Unknown,i&&(t|=h.FileType.SymbolicLink),t}async readFile(s){try{const i=this.toFilePath(s);return await f.Promises.readFile(i)}catch(i){throw this.toFileSystemProviderError(i)}}readFileStream(s,i,t){const o=(0,w.newWriteableStream)(a=>R.VSBuffer.concat(a.map(u=>R.VSBuffer.wrap(u))).buffer);return(0,E.readFileIntoStream)(this,s,o,a=>a.buffer,{...i,bufferSize:256*1024},t),o}async writeFile(s,i,t){let o;try{const a=this.toFilePath(s);if(!t.create||!t.overwrite){if(await f.Promises.exists(a)){if(!t.overwrite)throw(0,h.createFileSystemProviderError)((0,p.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,h.createFileSystemProviderError)((0,p.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(s,{create:!0,unlock:t.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(s,a)}finally{typeof o=="number"&&await this.close(o)}}async open(s,i){try{const t=this.toFilePath(s);if((0,h.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:u}=await f.SymlinkSupport.stat(t);u.mode&128||await f.Promises.chmod(t,u.mode|128)}catch(u){this.logService.trace(u)}let o;if((0,h.isFileOpenForWriteOptions)(i)){if(C.isWindows)try{await f.Promises.truncate(t,0),o="r+"}catch(u){u.code!=="ENOENT"&&this.logService.trace(u)}o||(o="w")}else o="r";const a=await f.Promises.open(t,o);return this.mapHandleToPos.set(a,0),(0,h.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,s),a}catch(t){throw(0,h.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(s,t):this.toFileSystemProviderError(t)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await f.Promises.fdatasync(s)}catch(i){this.canFlush=!1,this.logService.error(i)}return await f.Promises.close(s)}catch(i){throw this.toFileSystemProviderError(i)}}async read(s,i,t,o,a){const u=this.normalizePos(s,i);let g=null;try{const b=await f.Promises.read(s,t,o,a,u);return typeof b=="number"?g=b:g=b.bytesRead,g}catch(b){throw this.toFileSystemProviderError(b)}finally{this.updatePos(s,u,g)}}normalizePos(s,i){return i===this.mapHandleToPos.get(s)?null:i}updatePos(s,i,t){const o=this.mapHandleToPos.get(s);typeof o=="number"&&(typeof i=="number"||(typeof t=="number"?this.mapHandleToPos.set(s,o+t):this.mapHandleToPos.delete(s)))}async write(s,i,t,o,a){return(0,D.retry)(()=>this.doWrite(s,i,t,o,a),100,3)}async doWrite(s,i,t,o,a){const u=this.normalizePos(s,i);let g=null;try{const b=await f.Promises.write(s,t,o,a,u);return typeof b=="number"?g=b:g=b.bytesWritten,g}catch(b){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),b)}finally{this.updatePos(s,u,g)}}async mkdir(s){try{await f.Promises.mkdir(this.toFilePath(s))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(s,i){try{const t=this.toFilePath(s);await this.doDelete(t,i)}catch(t){throw this.toFileSystemProviderError(t)}}async doDelete(s,i){i.recursive?await f.Promises.rm(s,f.RimRafMode.MOVE):await f.Promises.unlink(s)}async rename(s,i,t){const o=this.toFilePath(s),a=this.toFilePath(i);if(o!==a)try{await this.validateTargetDeleted(s,i,"move",t.overwrite),await f.Promises.move(o,a)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(2,null,(0,y.basename)(o),(0,y.basename)((0,y.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(s,i,t){const o=this.toFilePath(s),a=this.toFilePath(i);if(o!==a)try{await this.validateTargetDeleted(s,i,"copy",t.overwrite),await f.Promises.copy(o,a,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,p.localize)(3,null,(0,y.basename)(o),(0,y.basename)((0,y.dirname)(a)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(s,i,t,o){const a=this.toFilePath(s),u=this.toFilePath(i);let g=!1;if(!!(this.capabilities&1024)||(g=(0,P.isEqual)(a,u,!0)),g&&t==="copy")throw(0,h.createFileSystemProviderError)((0,p.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!g&&await f.Promises.exists(u)){if(!o)throw(0,h.createFileSystemProviderError)((0,p.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(s,i,t){let o,a=!1;return this.options?.watcher?.usePolling?a=!1:a=this.options?.legacyWatcher==="on",a?o=m.FileWatcher:o=v.FileWatcher,new o(u=>s(u),u=>i(u),t,this.options?.watcher)}doWatch(s,i){const t=this.options?.watcher?.usePolling;if(t===!0)for(const o of i)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(t))for(const o of i)t.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(s,i)}createNonRecursiveWatcher(s,i,t,o){return new S.FileWatcher(s,a=>i(a),a=>t(a),o)}toFileSystemProviderError(s){if(s instanceof h.FileSystemProviderError)return s;let i;switch(s.code){case"ENOENT":i=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=h.FileSystemProviderErrorCode.NoPermissions;break;default:i=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(s,i)}async toFileSystemProviderWriteError(s,i){let t=this.toFileSystemProviderError(i);if(s&&t.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await f.SymlinkSupport.stat(this.toFilePath(s));o.mode&128||(t=(0,h.createFileSystemProviderError)(i,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return t}}e.DiskFileSystemProvider=l}),define(te[87],ne([0,1,3,8,10]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(f){this.service=f,this.onDidChangeLogLevel=k.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=R;class r{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){r.setLevel(this.channel,f)}static setLevel(f,p){return f.call("setLevel",p)}}e.LogLevelChannelClient=r;class P{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,p){throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"createLogger":this.createLogger(T.URI.revive(h[0]),h[1]);return;case"log":return this.log(T.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(f,p){this.loggers.set(f.toString(),this.loggerService.createLogger(f,p))}consoleLog(f,p){let h=console.log;switch(f){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(f,p){const h=this.loggers.get(f.toString());if(!h)throw new Error("Create the logger before logging");for(const[E,S]of p)(0,D.log)(h,E,S)}}e.LoggerChannel=P;class y extends D.AbstractLoggerService{constructor(f,p,h){super(f,p);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(f,p)=>{this.channel.call("consoleLog",[f,p])}})}doCreateLogger(f,p,h){return new C(this.channel,f,p,h)}}e.LoggerChannelClient=y;class C extends D.AbstractMessageLogger{constructor(f,p,h,E){super(E?.always);this.channel=f,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[p,E]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,p){const h=[[f,p]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(f){this.channel.call("log",[this.file,f])}}class I extends D.LogService{constructor(f,p){super(p);this.parent=f,this._register(f.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=I}),define(te[61],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,k.createDecorator)("nativeHostService")}),define(te[88],ne([0,1,15,4,31,18]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof T.globals.vscode!="undefined"&&typeof T.globals.vscode.context!="undefined"){const P=T.globals.vscode.context.configuration();if(P)r=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const P=(0,R.dirname)(k.FileAccess.asFileUri("",X));r=X.__$__nodeRequire((0,R.joinPath)(P,"product.json").fsPath);const y=X.__$__nodeRequire((0,R.joinPath)(P,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`}),Object.assign(r,{version:y.version})}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=r}),define(te[27],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,k.createDecorator)("productService")}),define(te[183],ne([0,1,5,7,2,9,20,10,27]),function(X,e,k,T,D,R,r,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let C=class extends D.Disposable{constructor(w,f,p){super();this.productService=f,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},30*1e3)).schedule()}async cleanUpCodeCaches(w){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),p=(0,R.dirname)(w),h=(0,R.basename)(w),E=await r.Promises.readdir(p);await Promise.all(E.map(async S=>{if(S===h)return;const m=(0,R.join)(p,S),v=await r.Promises.stat(m);if(v.isDirectory()&&f-v.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${S}.`),r.Promises.rm(m)}))}catch(f){(0,T.onUnexpectedError)(f)}}};C=he([J(1,y.IProductService),J(2,P.ILogService)],C),e.CodeCacheCleaner=C}),define(te[184],ne([0,1,5,7,2,9,20,11,10,27]),function(X,e,k,T,D,R,r,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends D.Disposable{constructor(f,p,h){super();this.environmentService=f,this.logService=p,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new k.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),p=JSON.parse(await r.Promises.readFile((0,R.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let v of Object.keys(p)){const d=p[v];f[`${d.hash}.${v}`]=!0}const h=(0,R.join)(this.environmentService.userDataPath,"clp");if(!await r.Promises.exists(h))return;const S=await r.Promises.readdir(h);for(const v of S){if(f[v]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${v}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${v}`),await r.Promises.rm((0,R.join)(h,v))}const m=Date.now();for(const v of Object.keys(f)){const d=(0,R.join)(h,v),c=await r.Promises.readdir(d);for(const l of c){if(l==="tcf.json")continue;const n=(0,R.join)(d,l),s=await r.Promises.stat(n);s.isDirectory()&&m-s.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,R.join)(v,l)}`),await r.Promises.rm(n))}}}catch(f){(0,T.onUnexpectedError)(f)}}};I=he([J(0,P.INativeEnvironmentService),J(1,y.ILogService),J(2,C.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(te[35],ne([0,1,102,17]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(r,P){k.ok(T.isString(r)),k.ok(T.isObject(P)),k.ok(!this.data.has(r),"There is already an extension with this id"),this.data.set(r,P)}knows(r){return this.data.has(r)}as(r){return this.data.get(r)||null}}e.Registry=new D}),define(te[89],ne([0,1,3,35]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class R{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,C){this.schemasById[D(y)]=C,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const r=new R;T.Registry.add(e.Extensions.JSONContribution,r)}),define(te[39],ne([0,1,16,3,17,128,89,35]),function(X,e,k,T,D,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const I=P.Registry.as(r.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(d,c=!0){this.registerConfigurations([d],c)}registerConfigurations(d,c=!0){const l=this.doRegisterConfigurations(d,c);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(d){const c=this.doDeregisterConfigurations(d);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}updateConfigurations({add:d,remove:c}){const l=[];l.push(...this.doDeregisterConfigurations(c)),l.push(...this.doRegisterConfigurations(d,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,k.distinct)(l))}registerDefaultConfigurations(d){const c=[],l=[];for(const n of d)for(const s in n)if(c.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...n[s]};const i={type:"object",default:this.defaultValues[s],description:R.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};l.push(p(s)),this.configurationProperties[s]=i,this.defaultLanguageConfigurationOverridesNode.properties[s]=i}else{this.defaultValues[s]=n[s];const i=this.configurationProperties[s];i&&(this.updatePropertyDefaultValue(s,i),this.updateSchema(s,i))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(d){const c=[];for(const l of d)for(const n in l)if(c.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const s=this.configurationProperties[n];s&&(this.updatePropertyDefaultValue(n,s),this.updateSchema(n,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...d){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(d){for(const c of d)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(d,c){const l=[];return d.forEach(n=>{l.push(...this.validateAndRegisterProperties(n,c,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),l}doDeregisterConfigurations(d){const c=[],l=n=>{if(n.properties)for(const s in n.properties)c.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,n.properties[s]);n.allOf&&n.allOf.forEach(s=>l(s))};for(const n of d){l(n);const s=this.configurationContributors.indexOf(n);s!==-1&&this.configurationContributors.splice(s,1)}return c}validateAndRegisterProperties(d,c=!0,l,n=3){n=D.isUndefinedOrNull(d.scope)?n:d.scope;let s=[],i=d.properties;if(i)for(let o in i){if(c&&S(o)){delete i[o];continue}const a=i[o];if(this.updatePropertyDefaultValue(o,a),e.OVERRIDE_PROPERTY_PATTERN.test(o)?a.scope=void 0:(a.scope=D.isUndefinedOrNull(a.scope)?n:a.scope,a.restricted=D.isUndefinedOrNull(a.restricted)?!!l?.restrictedConfigurations?.includes(o):a.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),s.push(o)}let t=d.allOf;if(t)for(let o of t)s.push(...this.validateAndRegisterProperties(o,c,l,n));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(d){const c=l=>{let n=l.properties;if(n)for(const i in n)this.updateSchema(i,n[i]);let s=l.allOf;s&&s.forEach(c)};c(d)}updateSchema(d,c){switch(e.allSettings.properties[d]=c,c.scope){case 1:e.applicationSettings.properties[d]=c;break;case 2:e.machineSettings.properties[d]=c;break;case 6:e.machineOverridableSettings.properties[d]=c;break;case 3:e.windowSettings.properties[d]=c;break;case 4:e.resourceSettings.properties[d]=c;break;case 5:e.resourceSettings.properties[d]=c,this.resourceLanguageSettingsSchema.properties[d]=c;break}}removeFromSchema(d,c){switch(delete e.allSettings.properties[d],c.scope){case 1:delete e.applicationSettings.properties[d];break;case 2:delete e.machineSettings.properties[d];break;case 6:delete e.machineOverridableSettings.properties[d];break;case 3:delete e.windowSettings.properties[d];break;case 4:case 5:delete e.resourceSettings.properties[d];break}}updateOverridePropertyPatternKey(){for(const d of this.overrideIdentifiers.values()){const c=`[${d}]`,l={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,l),e.allSettings.properties[c]=l,e.applicationSettings.properties[c]=l,e.machineSettings.properties[c]=l,e.machineOverridableSettings.properties[c]=l,e.windowSettings.properties[c]=l,e.resourceSettings.properties[c]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(d,c){let l=this.defaultValues[d];D.isUndefined(l)&&(l=c.default),D.isUndefined(l)&&(l=h(c.type)),c.default=l}}const f="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(f);function p(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=p;function h(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const E=new w;P.Registry.add(e.Extensions.Configuration,E);function S(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?R.localize(5,null,v):E.getConfigurationProperties()[v]!==void 0?R.localize(6,null,v):null:R.localize(4,null)}e.validateProperty=S;function m(){const v=[],d=E.getConfigurationProperties();for(const c of Object.keys(d))v.push([c,d[c].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=m}),define(te[21],ne([0,1,26,17,8,39,6,35]),function(X,e,k,T,D,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,r.createDecorator)("configurationService");function y(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof D.URI)}e.isConfigurationOverrides=y;var C;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function I(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=I;function w(s,i){const t=i?s?i.keys.filter(O=>s.keys.indexOf(O)===-1):[...i.keys]:[],o=s?i?s.keys.filter(O=>i.keys.indexOf(O)===-1):[...s.keys]:[],a=[];if(i&&s){for(const O of s.keys)if(i.keys.indexOf(O)!==-1){const U=m(s.contents,O),x=m(i.contents,O);k.equals(U,x)||a.push(O)}}const u=[],g=O=>{const U={};for(const x of O)for(const N of x.identifiers)U[l(N)]=x;return U},b=i?g(i.overrides):{},A=s?g(s.overrides):{};if(Object.keys(b).length)for(const O of t){const U=b[O];U&&u.push([(0,R.overrideIdentifierFromKey)(O),U.keys])}if(Object.keys(A).length)for(const O of o){const U=A[O];U&&u.push([(0,R.overrideIdentifierFromKey)(O),U.keys])}if(Object.keys(b).length&&Object.keys(A).length)for(const O of a){const U=A[O],x=b[O];if(U&&x){const N=w({contents:U.contents,keys:U.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});u.push([(0,R.overrideIdentifierFromKey)(O),[...N.added,...N.removed,...N.updated]])}}return{added:t,removed:o,updated:a,overrides:u}}e.compare=w;function f(s,i){const t=[];for(const o of Object.keys(s))if(R.OVERRIDE_PROPERTY_PATTERN.test(o)){const a={};for(const u in s[o])a[u]=s[o][u];t.push({identifiers:[(0,R.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(a),contents:p(a,i)})}return t}e.toOverrides=f;function p(s,i){const t=Object.create(null);for(let o in s)h(t,o,s[o],i);return t}e.toValuesTree=p;function h(s,i,t,o){const a=i.split("."),u=a.pop();let g=s;for(let b=0;b<a.length;b++){let A=a[b],O=g[A];switch(typeof O){case"undefined":O=g[A]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${a.slice(0,b+1).join(".")} is ${JSON.stringify(O)}`);return}g=O}if(typeof g=="object"&&g!==null)try{g[u]=t}catch(b){o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(g)}`)}else o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(g)}`)}e.addToValueTree=h;function E(s,i){const t=i.split(".");S(s,t)}e.removeFromValueTree=E;function S(s,i){const t=i.shift();if(i.length===0){delete s[t];return}if(Object.keys(s).indexOf(t)!==-1){const o=s[t];typeof o=="object"&&!Array.isArray(o)&&(S(o,i),Object.keys(o).length===0&&delete s[t])}}function m(s,i,t){function o(g,b){let A=g;for(const O of b){if(typeof A!="object"||A===null)return;A=A[O]}return A}const a=i.split("."),u=o(s,a);return typeof u=="undefined"?t:u}e.getConfigurationValue=m;function v(s,i,t){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in s?T.isObject(s[o])&&T.isObject(i[o])?v(s[o],i[o],t):t&&(s[o]=i[o]):s[o]=i[o])})}e.merge=v;function d(){const s=P.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=d;function c(){const s=Object.create(null),i=P.Registry.as(R.Extensions.Configuration).getConfigurationProperties();for(let t in i){let o=i[t].default;h(s,t,o,a=>console.error(`Conflict in default settings: ${a}`))}return s}e.getDefaultValues=c;function l(s){return`[${s}]`}e.keyFromOverrideIdentifier=l;function n(s,i,t){const o=s.inspect(i),a=s.inspect(t);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:o.defaultValue}e.getMigratedSettingValue=n}),define(te[90],ne([0,1,16,3,32,2,41,26,17,8,21,39,35]),function(X,e,k,T,D,R,r,P,y,C,I,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},s=[],i=[]){this._contents=n,this._keys=s,this._overrides=i,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,s){const i=this.getContentsForOverrideIdentifer(s);return i?n?(0,I.getConfigurationValue)(i,n):i:void 0}getKeysForOverrideIdentifier(n){for(const s of this.overrides)if(s.identifiers.indexOf(n)!==-1)return s.keys;return[]}override(n){let s=this.overrideConfigurations.get(n);return s||(s=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,s)),s}merge(...n){const s=P.deepClone(this.contents),i=P.deepClone(this.overrides),t=[...this.keys];for(const o of n){this.mergeContents(s,o.contents);for(const a of o.overrides){const[u]=i.filter(g=>k.equals(g.identifiers,a.identifiers));u?this.mergeContents(u.contents,a.contents):i.push(P.deepClone(a))}for(const a of o.keys)t.indexOf(a)===-1&&t.push(a)}return new p(s,t,i)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const s=this.getContentsForOverrideIdentifer(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let i={};for(const t of k.distinct([...Object.keys(this.contents),...Object.keys(s)])){let o=this.contents[t],a=s[t];a&&(typeof o=="object"&&typeof a=="object"?(o=P.deepClone(o),this.mergeContents(o,a)):o=a),i[t]=o}return new p(i,this.keys,this.overrides)}mergeContents(n,s){for(const i of Object.keys(s)){if(i in n&&y.isObject(n[i])&&y.isObject(s[i])){this.mergeContents(n[i],s[i]);continue}n[i]=P.deepClone(s[i])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?P.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const s of this.overrides)if(s.identifiers.indexOf(n)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,s){this.addKey(n),(0,I.addToValueTree)(this.contents,n,s,i=>{throw new Error(i)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let s=this.keys.length;for(let i=0;i<s;i++)n.indexOf(this.keys[i])===0&&(s=i);this.keys.splice(s,1,n)}removeKey(n){let s=this.keys.indexOf(n);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(){const n=(0,I.getDefaultValues)(),s=(0,I.getConfigurationKeys)(),i=[];for(const t of Object.keys(n))w.OVERRIDE_PROPERTY_PATTERN.test(t)&&i.push({identifiers:[(0,w.overrideIdentifierFromKey)(t).trim()],keys:Object.keys(n[t]),contents:(0,I.toValuesTree)(n[t],o=>console.error(`Conflict in default settings file: ${o}`))});super(n,s,i)}}e.DefaultConfigurationModel=h;class E{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,s){if(!y.isUndefinedOrNull(n)){const i=this.doParseContent(n);this.parseRaw(i,s)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,s){this._raw=n;const{contents:i,keys:t,overrides:o,restricted:a}=this.doParseRaw(n,s);this._configurationModel=new p(i,t,o),this._restrictedConfigurations=a||[]}doParseContent(n){let s={},i=null,t=[],o=[],a=[];function u(b){Array.isArray(t)?t.push(b):i!==null&&(t[i]=b)}let g={onObjectBegin:()=>{let b={};u(b),o.push(t),t=b,i=null},onObjectProperty:b=>{i=b},onObjectEnd:()=>{t=o.pop()},onArrayBegin:()=>{let b=[];u(b),o.push(t),t=b,i=null},onArrayEnd:()=>{t=o.pop()},onLiteralValue:u,onError:(b,A,O)=>{a.push({error:b,offset:A,length:O})}};if(n)try{D.visit(n,g),s=t[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return s}doParseRaw(n,s){const i=f.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),t=this.filter(n,i,!0,s);n=t.raw;const o=(0,I.toValuesTree)(n,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),a=Object.keys(n),u=(0,I.toOverrides)(n,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:o,keys:a,overrides:u,restricted:t.restricted}}filter(n,s,i,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:n,restricted:[]};const o={},a=[];for(let u in n)if(w.OVERRIDE_PROPERTY_PATTERN.test(u)&&i){const g=this.filter(n[u],s,!1,t);o[u]=g.raw,a.push(...g.restricted)}else{const g=s[u],b=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&a.push(u),(b===void 0||t.scopes===void 0||t.scopes.includes(b))&&(t.skipRestricted&&g?.restricted||(o[u]=n[u]))}return{raw:o,restricted:a}}}e.ConfigurationModelParser=E;class S extends R.Disposable{constructor(n,s,i,t){super();this.userSettingsResource=n,this.scopes=s,this.fileService=t,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new E(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(T.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class m{constructor(n,s,i=new p,t=new p,o=new r.ResourceMap,a=new p,u=new r.ResourceMap,g=!0){this._defaultConfiguration=n,this._localUserConfiguration=s,this._remoteUserConfiguration=i,this._workspaceConfiguration=t,this._folderConfigurations=o,this._memoryConfiguration=a,this._memoryConfigurationByResource=u,this._freeze=g,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new r.ResourceMap,this._userConfiguration=null}getValue(n,s,i){return this.getConsolidateConfigurationModel(s,i).getValue(n)}updateValue(n,s,i={}){let t;i.resource?(t=this._memoryConfigurationByResource.get(i.resource),t||(t=new p,this._memoryConfigurationByResource.set(i.resource,t))):t=this._memoryConfiguration,s===void 0?t.removeValue(n):t.setValue(n,s),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,s,i){const t=this.getConsolidateConfigurationModel(s,i),o=this.getFolderConfigurationModelForResource(s.resource,i),a=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),g=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),b=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),O=i?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,U=o?s.overrideIdentifier?o.freeze().override(s.overrideIdentifier).getValue(n):o.freeze().getValue(n):void 0,x=s.overrideIdentifier?a.override(s.overrideIdentifier).getValue(n):a.getValue(n),N=t.getValue(n),L=k.distinct(k.flatten(t.overrides.map($=>$.identifiers))).filter($=>t.getOverrideValue(n,$)!==void 0);return{defaultValue:u,userValue:g,userLocalValue:b,userRemoteValue:A,workspaceValue:O,workspaceFolderValue:U,memoryValue:x,value:N,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,user:g!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,workspaceFolder:U!==void 0?{value:o?.freeze().getValue(n),override:s.overrideIdentifier?o?.freeze().getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:a.getValue(n),override:s.overrideIdentifier?a.getOverrideValue(n,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:L.length?L:void 0}}keys(n){const s=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,s){this._folderConfigurations.set(n,s),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=s.filter(t=>w.OVERRIDE_PROPERTY_PATTERN.test(t)).map(t=>{const o=(0,w.overrideIdentifierFromKey)(t),a=this._defaultConfiguration.getKeysForOverrideIdentifier(o),u=n.getKeysForOverrideIdentifier(o),g=[...u.filter(b=>a.indexOf(b)===-1),...a.filter(b=>u.indexOf(b)===-1),...a.filter(b=>!P.equals(this._defaultConfiguration.override(o).getValue(b),n.override(o).getValue(b)))];return[o,g]});return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:t,overrides:o}=(0,I.compare)(this.localUserConfiguration,n),a=[...s,...i,...t];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:o}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:t,overrides:o}=(0,I.compare)(this.remoteUserConfiguration,n);let a=[...s,...i,...t];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:o}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:t,overrides:o}=(0,I.compare)(this.workspaceConfiguration,n);let a=[...s,...i,...t];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:o}}compareAndUpdateFolderConfiguration(n,s){const i=this.folderConfigurations.get(n),{added:t,updated:o,removed:a,overrides:u}=(0,I.compare)(i,s);let g=[...t,...o,...a];return(g.length||!i)&&this.updateFolderConfiguration(n,s),{keys:g,overrides:u}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:t,removed:o,overrides:a}=(0,I.compare)(s,void 0);return{keys:[...i,...t,...o],overrides:a}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,s){let i=this.getConsolidatedConfigurationModelForResource(n,s);return n.overrideIdentifier?i.override(n.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:n},s){let i=this.getWorkspaceConsolidatedConfiguration();if(s&&n){const t=s.getFolder(n);t&&(i=this.getFolderConsolidatedConfiguration(t.uri)||i);const o=this._memoryConfigurationByResource.get(n);o&&(i=i.merge(o))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let s=this._foldersConsolidatedConfigurations.get(n);if(!s){const i=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(n);t?(s=i.merge(t),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(n,s)):s=i}return s}getFolderConfigurationModelForResource(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,s)=>{const{contents:i,overrides:t,keys:o}=this._folderConfigurations.get(s);return n.push([s,{contents:i,overrides:t,keys:o}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>n.add(s)),this.userConfiguration.freeze().keys.forEach(s=>n.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(i=>n.add(i))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t))),[...s.values()]}static parse(n){const s=this.parseConfigurationModel(n.defaults),i=this.parseConfigurationModel(n.user),t=this.parseConfigurationModel(n.workspace),o=n.folders.reduce((a,u)=>(a.set(C.URI.revive(u[0]),this.parseConfigurationModel(u[1])),a),new r.ResourceMap);return new m(s,i,new p,t,o,new p,new r.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=m;function v(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const n=new Set,s=new Map;for(const t of l)t.keys.forEach(o=>n.add(o)),t.overrides.forEach(([o,a])=>{const u=(0,r.getOrSet)(s,o,new Set);a.forEach(g=>u.add(g))});const i=[];return s.forEach((t,o)=>i.push([o,[...t.values()]])),{keys:[...n.values()],overrides:i}}e.mergeChanges=v;class d{constructor(n,s,i,t){this.change=n,this.previous=s,this.currentConfiguraiton=i,this.currentWorkspace=t,this._previousConfiguration=void 0;const o=new Set;n.keys.forEach(u=>o.add(u)),n.overrides.forEach(([,u])=>u.forEach(g=>o.add(g))),this.affectedKeys=[...o.values()];const a=new p;this.affectedKeys.forEach(u=>a.setValue(u,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(s){const i=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(n,s,this.currentWorkspace);return!P.equals(i,t)}return!0}return!1}doesAffectedKeysTreeContains(n,s){let i=(0,I.toValuesTree)({[s]:!0},()=>{}),t;for(;typeof i=="object"&&(t=Object.keys(i)[0]);){if(n=n[t],!n)return!1;i=i[t]}return!0}}e.ConfigurationChangeEvent=d;class c extends d{constructor(n,s,i,t){super({keys:n.allKeys(),overrides:[]},void 0,n,s);this.source=i,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=c}),define(te[185],ne([0,1,5,3,2,18,21,90,39,35]),function(X,e,k,T,D,R,r,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends D.Disposable{constructor(f,p){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new T.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new P.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,p)),this.configuration=new P.Configuration(new P.DefaultConfigurationModel,new P.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new k.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(C.Registry.as(y.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new P.Configuration(new P.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,p){const h=typeof f=="string"?f:void 0,E=(0,r.isConfigurationOverrides)(f)?f:(0,r.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,E,void 0)}updateValue(f,p,h,E){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(h,p,1)}onDidDefaultConfigurationChange(f){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new P.DefaultConfigurationModel,f);this.trigger(h,p,6)}trigger(f,p,h){const E=new P.ConfigurationChangeEvent(f,{data:p},this.configuration);E.source=h,E.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(te[186],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var T;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(r,P=T.Unknown,y){super(r);this._message=r,this._code=P,this._detail=y,this.isHandled=P===T.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(r){return r instanceof D&&r._code===T.TemporarilyNotAvailable}static isNoResolverFound(r){return r instanceof D&&r._code===T.NoResolverFound}static isHandled(r){return r instanceof D&&r.isHandled}}e.RemoteAuthorityResolverError=D}),define(te[187],ne([0,1,5,19,28,7,3,2,29,73,186]),function(X,e,k,T,D,R,r,P,y,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const w=30*1e3;var f;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function p(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(F){const B=new D.CancellationTokenSource;return setTimeout(()=>B.cancel(),F),B.token}function E(F,B){if(F.isCancellationRequested||B.isCancellationRequested)return D.CancellationToken.Cancelled;const V=new D.CancellationTokenSource;return F.onCancellationRequested(()=>V.cancel()),B.onCancellationRequested(()=>V.cancel()),V.token}class S{constructor(B){this._state="pending",this._disposables=new P.DisposableStore,this.promise=new Promise((V,Q)=>{this._resolvePromise=V,this._rejectPromise=Q}),B.isCancellationRequested?this._timeout():this._disposables.add(B.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(B){this._state==="pending"?this._disposables.add(B):B.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(B))}reject(B){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(B))}}function m(F,B){const V=new S(B);return V.registerDisposable(F.onControlMessage(Q=>{const Z=JSON.parse(Q.toString()),G=W(Z);G?V.reject(G):V.resolve(Z)})),V.promise}function v(F,B,V,Q,Z,G){const H=new S(G);return B.connect(V,Q,Z,(re,ie)=>{H.didTimeout?(re&&F.error(re),ie?.dispose()):re||!ie?H.reject(re):H.resolve(ie)}),H.promise}function d(F,B){const V=new S(B);return F.then(Q=>{V.didTimeout||V.resolve(Q)},Q=>{V.didTimeout||V.reject(Q)}),V.promise}async function c(F,B,V,Q){const Z=z(F,B);F.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let G;try{G=await v(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,Q)}catch(le){throw F.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),F.logService.error(le),le}F.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let H,re;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(G,null),H=F.reconnectionProtocol,re=!1):(H=new C.PersistentProtocol(G,null),re=!0),F.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const ie=await d(F.signService.createNewMessage((0,y.generateUuid)()),Q),ce={type:"auth",auth:F.connectionToken||"00000000000000000000",data:ie.data};H.sendControl(T.VSBuffer.fromString(JSON.stringify(ce)));try{const le=await m(H,E(Q,h(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(F.logService.trace(`${Z} 4/6. received SignRequest control message.`),!await d(F.signService.validate(ie,le.signedData),Q)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const de=await d(F.signService.sign(le.data),Q),be={type:"connectionType",commit:F.commit,signedData:de,desiredConnectionType:B};return V&&(be.args=V),F.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),H.sendControl(T.VSBuffer.fromString(JSON.stringify(be))),{protocol:H,ownsProtocol:re}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(F.logService.error(`${Z} the handshake timed out. Error:`),F.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${Z} received error control message when negotiating connection. Error:`),F.logService.error(le)),re&&M(H),le}}async function l(F,B,V,Q){const Z=Date.now(),G=z(F,B),{protocol:H,ownsProtocol:re}=await c(F,B,V,Q),ie=new S(Q);return ie.registerDisposable(H.onControlMessage(ce=>{const le=JSON.parse(ce.toString()),fe=W(le);fe?(F.logService.error(`${G} received error control message when negotiating connection. Error:`),F.logService.error(fe),re&&M(H),ie.reject(fe)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${K(Z)}!`),ie.resolve({protocol:H,firstMessage:le}))})),ie.promise}async function n(F,B){const{protocol:V}=await l(F,1,void 0,B);return{protocol:V}}async function s(F,B,V){const{protocol:Q,firstMessage:Z}=await l(F,2,B,V),G=Z&&Z.debugPort;return{protocol:Q,debugPort:G}}async function i(F,B,V){const Q=Date.now(),Z=z(F,3),{protocol:G}=await c(F,3,B,V);return F.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${K(Q)}!`),G}async function t(F,B,V){const{host:Q,port:Z,connectionToken:G}=await F.addressProvider.getAddress();return{commit:F.commit,host:Q,port:Z,connectionToken:G,reconnectionToken:B,reconnectionProtocol:V,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function o(F,B,V){try{const Q=(0,y.generateUuid)(),Z=await t(F,Q,null),{protocol:G}=await n(Z,D.CancellationToken.None);return new $(F,B,V,Q,G)}catch(Q){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(Q),L.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(Q)),Q}}e.connectRemoteAgentManagement=o;async function a(F,B){try{const V=(0,y.generateUuid)(),Q=await t(F,V,null),{protocol:Z,debugPort:G}=await s(Q,B,D.CancellationToken.None);return new _(F,B,V,Z,G)}catch(V){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(V),L.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentExtensionHost=a;async function u(F,B,V){const Q=await t(F,(0,y.generateUuid)(),null);return await i(Q,{host:B,port:V},D.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function g(F){return(0,k.createCancelablePromise)(B=>new Promise((V,Q)=>{const Z=setTimeout(V,F*1e3);B.onCancellationRequested(()=>{clearTimeout(Z),V()})}))}var b;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(b=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(B,V){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.type=0}}e.ConnectionLostEvent=A;class O{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.durationSeconds=Q,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class U{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=2}}e.ReconnectionRunningEvent=U;class x{constructor(B,V,Q){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.type=4}}e.ConnectionGainEvent=x;class N{constructor(B,V,Q,Z){this.reconnectionToken=B,this.millisSinceLastIncomingData=V,this.attempt=Q,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=N;class L extends P.Disposable{constructor(B,V,Q,Z){super();this._connectionType=B,this._onDidStateChange=this._register(new r.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=V,this.reconnectionToken=Q,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(G=>{const H=q(this._connectionType,this.reconnectionToken,!0);G?G.type===0?(this._options.logService.info(`${H} received socket close event (hadError: ${G.hadError}).`),G.error&&this._options.logService.error(G.error)):(this._options.logService.info(`${H} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this._options.logService.error(G.event)):this._options.logService.info(`${H} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const G=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${G} received socket timeout event.`),this._beginReconnecting()})),L._instances.push(this),L._permanentFailure&&this._gotoPermanentFailure(L._permanentFailureMillisSinceLastIncomingData,L._permanentFailureAttempt,L._permanentFailureHandled)}static triggerPermanentFailure(B,V,Q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=B,this._permanentFailureAttempt=V,this._permanentFailureHandled=Q,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(L._permanentFailure)return;const B=q(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const V=[0,5,5,10,10,10,10,10,30];let Q=-1;do{Q++;const Z=Q<V.length?V[Q]:V[V.length-1];try{if(Z>0){const H=g(Z);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,H)),this._options.logService.info(`${B} waiting for ${Z} seconds before reconnecting...`);try{await H}catch{}}if(L._permanentFailure){this._options.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1)),this._options.logService.info(`${B} resolving connection...`);const G=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${B} connecting to ${G.host}:${G.port}...`),await this._reconnect(G,h(w)),this._options.logService.info(`${B} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Q+1));break}catch(G){if(G.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(Q>360){this._options.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(G)){this._options.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((G.code==="ETIMEDOUT"||G.code==="ENETUNREACH"||G.code==="ECONNREFUSED"||G.code==="ECONNRESET")&&G.syscall==="connect"){this._options.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if((0,R.isPromiseCanceledError)(G)){this._options.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(G);continue}if(G instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,I.RemoteAuthorityResolverError.isHandled(G));break}this._options.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(G),L.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),Q+1,!1);break}}while(!L._permanentFailure)}_gotoPermanentFailure(B,V,Q){this._onDidStateChange.fire(new N(this.reconnectionToken,B,V,Q)),M(this.protocol)}}L._permanentFailure=!1,L._permanentFailureMillisSinceLastIncomingData=0,L._permanentFailureAttempt=0,L._permanentFailureHandled=!1,L._instances=[];class $ extends L{constructor(B,V,Q,Z,G){super(1,B,Z,G);this.client=this._register(new C.Client(G,{remoteAuthority:V,clientId:Q},B.ipcLogger))}async _reconnect(B,V){await n(B,V)}}e.ManagementPersistentConnection=$;class _ extends L{constructor(B,V,Q,Z,G){super(2,B,Q,Z);this._startArguments=V,this.debugPort=G}async _reconnect(B,V){await s(B,this._startArguments,V)}}e.ExtensionHostPersistentConnection=_;function M(F){try{F.acceptDisconnect();const B=F.getSocket();F.dispose(),B.dispose()}catch(B){(0,R.onUnexpectedError)(B)}}function W(F){if(F&&F.type==="error"){const B=new Error(`Connection error: ${F.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function j(F,B){for(;F.length<B;)F+=" ";return F}function q(F,B,V){return`[remote-connection][${j(p(F),13)}][${B.substr(0,5)}\u2026][${V?"reconnect":"initial"}]`}function z(F,B){return`${q(B,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function K(F){return`${Date.now()-F} ms`}}),define(te[188],ne([0,1,15]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function T(C){return C.scheme===k.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=T;function D(C){if(!C)return;const I=C.indexOf("+");return I<0?C:C.substr(0,I)}e.getRemoteName=D;function R(C){return C.scheme!==k.Schemas.file&&C.scheme!==k.Schemas.vscodeRemote}e.isVirtualResource=R;function r(C){if(C.folders.length)return C.folders.every(I=>R(I.uri))?C.folders[0].uri:void 0;if(C.configuration&&R(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=r;function P(C){return r(C)?.scheme}e.getVirtualWorkspaceScheme=P;function y(C){return r(C)!==void 0}e.isVirtualWorkspace=y}),define(te[91],ne([0,1,25,6,188]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=R;function r(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=r,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class y{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let E=typeof p=="string"?p:p.value,S=typeof h=="string"?h:h.value;return k.equalsIgnoreCase(E,S)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=y;function C(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function I(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function w(f,p){if(p){const h=`onResolveRemoteAuthority:${(0,D.getRemoteName)(p)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=w,e.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[36],ne([0,1,25,91]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,E){return h.uuid&&E.uuid?h.uuid===E.uuid:h.id===E.id?!0:(0,k.compareIgnoreCase)(h.id,E.id)===0}e.areSameExtensions=D;class R{constructor(E,S){this.version=S,this.id=E.id,this.uuid=E.uuid}key(){return`${this.id}-${this.version}`}equals(E){return E instanceof R?D(this,E)&&this.version===E.version:!1}}e.ExtensionIdentifierWithVersion=R;function r(h,E){return`${h}.${E}`}e.getExtensionId=r;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function y(h,E){return P(r(h,E))}e.getGalleryExtensionId=y;function C(h,E){const S=[],m=v=>{for(const d of S)if(d.some(c=>D(E(c),E(v))))return d;return null};for(const v of h){const d=m(v);d?d.push(v):S.push([v])}return S}e.groupByExtension=C;function I(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function w(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function f(h){const E=new Set;for(const S of h)S.malicious&&E.add(S.id.id);return E}e.getMaliciousExtensionsSet=f;function p(h,E){const S=[],m=E.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const v=m.shift();if(v&&S.every(d=>!D(d.identifier,{id:v}))){const d=h.filter(c=>D(c.identifier,{id:v}));d.length===1&&(S.push(d[0]),m.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}e.getExtensionDependencies=p}),define(te[189],ne([0,1,5,7,2,4,18,62,8,29,20,11,30,36,14,10]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends D.Disposable{constructor(d,c,l,n){super();this.fileService=c,this.extensionGalleryService=l,this.logService=n,this.extensionsDownloadDir=y.URI.file(d.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(d,c){await this.cleanUpPromise;const l=this.getName(d),n=(0,r.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(n)){const s=(0,r.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(d,s,c);try{await this.rename(s,n,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(s)}catch(t){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",d.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,T.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,s.path),i}}return n}async delete(d){await this.cleanUpPromise,await this.fileService.del(d)}async rename(d,c,l){try{await I.Promises.rename(d.fsPath,c.fsPath)}catch(n){if(R.isWindows&&n&&n.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${d} to ${c} with 'EPERM' error. Trying again...`),this.rename(d,c,l);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const d=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(d.children){const c=[],l=[];for(const i of d.children){const t=this.parse(i.name);t&&l.push([t,i])}const n=(0,p.groupByExtension)(l,([i])=>i),s=[];for(const i of n)i.sort((t,o)=>P.rcompare(t[0].version,o[0].version)),c.push(...i.slice(1).map(t=>t[1].resource)),s.push(i[0][1]);s.sort((i,t)=>i.mtime-t.mtime),c.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(i=>i.resource)),await k.Promises.settled(c.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(d){this.logService.error(d)}}getName(d){return this.cache?`${new p.ExtensionIdentifierWithVersion(d.identifier,d.version).key().toLowerCase()}${d.properties.targetPlatform!=="undefined"?`-${d.properties.targetPlatform}`:""}`:(0,C.generateUuid)()}parse(d){const c=S.exec(d);return c&&c[1]&&c[2]?new p.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};m=he([J(0,w.INativeEnvironmentService),J(1,h.IFileService),J(2,f.IExtensionGalleryService),J(3,E.ILogService)],m),e.ExtensionsDownloader=m}),define(te[190],ne([0,1,2,9,20,91]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class r extends k.Disposable{constructor(y,C){super();this.environmentService=y,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(C.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(y){y.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(y){y.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=r}),define(te[191],ne([0,1,83,16,5,2,15,9,20,11,30,36,60,10]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends R.Disposable{constructor(m,v,d){super();this.extensionManagementService=m,this.logService=d,this.cache=this._register(new E(v,d)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),v=["en",...Object.keys(m)];return(0,T.distinct)(v)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const v=await this.cache.getLanguagePacks();Object.keys(v).some(d=>v[d]&&v[d].extensions.some(c=>(0,w.areSameExtensions)(c.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,v]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),d=await this.cache.update(v);return!(0,T.equals)(Object.keys(m),Object.keys(d))}};h=he([J(0,I.IExtensionManagementService),J(1,C.INativeEnvironmentService),J(2,p.ILogService)],h),e.LocalizationsService=h;let E=class extends R.Disposable{constructor(m,v){super();this.logService=v,this.languagePacks={},this.languagePacksFilePath=(0,P.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(v=>{Object.keys(v).forEach(d=>delete v[d]),this.createLanguagePacksFromExtensions(v,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...v){for(const d of v)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,d);Object.keys(m).forEach(d=>this.updateHash(m[d]))}createLanguagePacksFromExtension(m,v){const d=v.identifier,c=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const l of c)if(v.location.scheme===r.Schemas.file&&(0,f.isValidLocalization)(l)){let n=m[l.languageId];n||(n={hash:"",extensions:[],translations:{}},m[l.languageId]=n);let s=n.extensions.filter(i=>(0,w.areSameExtensions)(i.extensionIdentifier,d))[0];s?s.version=v.manifest.version:n.extensions.push({extensionIdentifier:d,version:v.manifest.version});for(const i of l.translations)n.translations[i.id]=(0,P.join)(v.location.fsPath,i.path)}}updateHash(m){if(m){const v=(0,k.createHash)("md5");for(const d of m.extensions)v.update(d.extensionIdentifier.uuid||d.extensionIdentifier.id).update(d.version);m.hash=v.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let v=null;return y.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,d=>d.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(d)).then(d=>{try{return JSON.parse(d)}catch(c){return{}}}).then(d=>(v=m(d),d)).then(d=>{for(const l of Object.keys(d))d[l]||delete d[l];this.languagePacks=d,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),y.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>v,d=>this.logService.error(d))})}};E=he([J(0,C.INativeEnvironmentService),J(1,p.ILogService)],E)}),define(te[192],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,k.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[63],ne([0,1,3,4,6,10]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var r;(function(h){h.Http="http",h.Https="https"})(r=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const E=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!E)return{address:E[1],port:+E[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=w;function f(h,E){return E?E!==1&&h<1024:!T.isWindows&&h<1024}e.isPortPrivileged=f;let p=class{constructor(E){this.logService=E,this._onTunnelOpened=new k.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new k.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new k.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(E,S){return this._tunnelProvider=E,E?(this._canElevate=S.elevation,this._privacyOptions=S.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const E=[],S=Array.from(this._tunnels.values());for(let m of S){const v=Array.from(m.values());for(let d of v){const c=await d.value;c&&E.push(c)}}return E}async dispose(){for(const E of this._tunnels.values()){for(const{value:S}of E.values())await S.then(m=>m?.dispose());E.clear()}this._tunnels.clear()}openTunnel(E,S,m,v,d=!1,c=P.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${S}:${m} on local port ${v}.`),!E)return;S||(S="localhost");const n=this.retainOrCreateTunnel(E,S,m,v,d,c,l);return n?n.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(S,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(s);return(s.tunnelRemoteHost!==S||s.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(E){return{tunnelRemotePort:E.tunnelRemotePort,tunnelRemoteHost:E.tunnelRemoteHost,tunnelLocalPort:E.tunnelLocalPort,localAddress:E.localAddress,privacy:E.privacy,protocol:E.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${E.tunnelRemoteHost}:${E.tunnelRemotePort} `);const S=this._tunnels.get(E.tunnelRemoteHost);if(S){const m=S.get(E.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(E.tunnelRemoteHost,E.tunnelRemotePort,m))}}}}async tryDisposeTunnel(E,S,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${E}:${S}.`);const v=m.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(E)&&this._tunnels.get(E).delete(S),v}}async closeTunnel(E,S){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${E}:${S} `);const m=this._tunnels.get(E);if(m&&m.has(S)){const v=m.get(S);v.refcount=0,await this.tryDisposeTunnel(E,S,v)}}addTunnelToMap(E,S,m){this._tunnels.has(E)||this._tunnels.set(E,new Map),this._tunnels.get(E).set(S,{refcount:1,value:m})}async removeEmptyTunnelFromMap(E,S){const m=this._tunnels.get(E);m&&(await m.get(S)||m.delete(S),m.size===0&&this._tunnels.delete(E))}getTunnelFromMap(E,S){let m=[E];I(E)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):w(E)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const v=m.map(d=>this._tunnels.get(d));for(const d of v){const c=d?.get(S);if(c)return c}}canTunnel(E){return!!C(E)}createWithProvider(E,S,m,v,d,c,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${S}:${m} on local port ${v}.`);const s={elevationRequired:d?f(v===void 0?m:v):!1},i={remoteAddress:{host:S,port:m},localAddressPort:v,privacy:c,public:c!==P.Private,protocol:l},t=E.forwardPort(i,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(S,m,t),t}};p=he([J(0,R.ILogService)],p),e.AbstractTunnelService=p}),define(te[193],ne([0,1,10,63,2,7,5]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class P extends D.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new r.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let y=class Ct extends D.Disposable{constructor(I,w){super();this._tunnelService=I,this._logService=w,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(I,w,f,p,h,E){const S=new P,m=await Promise.resolve(this._tunnelService.openTunnel(I,S,f,p,h,E));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${p} (remote).`),S.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(w))throw this._disposedTunnels.delete(w),S.dispose(),await m.dispose(),(0,R.canceled)();return S.setTunnel(m),this._tunnels.set(w,S),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${m.localAddress} (local) to ${f}:${p} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(I,w){const f=this._tunnels.get(I);!f||f.setAddress(w)}async destroyTunnel(I){const w=this._tunnels.get(I);if(w){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await w.dispose();return}this._disposedTunnels.add(I)}};y._lastId=0,y=he([J(0,T.ISharedTunnelsService),J(1,k.ILogService)],y),e.SharedProcessTunnelService=y}),define(te[194],ne([0,1,122,21,10]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let R=class{constructor(P,y){this.configurationService=P,this.logService=y}request(P,y){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,k.request)(P,y)}async resolveProxy(P){}};R=he([J(0,T.IConfigurationService),J(1,D.ILogService)],R),e.RequestService=R}),define(te[44],ne([0,1,19,143,39,6,35]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function y(h){return h.res.statusCode===204}async function C(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return y(h)?null:(await(0,k.streamToBuffer)(h.stream)).toString()}e.asText=C;async function I(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(y(h))return null;const S=(await(0,k.streamToBuffer)(h.stream)).toString();try{return JSON.parse(S)}catch(m){throw m.message+=`:
`+S,m}}e.asJson=I;function w(h){p(h)}e.updateProxyConfigurationsScope=w;let f;function p(h){const E=r.Registry.as(D.Extensions.Configuration),S=f;f={id:"http",order:15,title:(0,T.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(4,null),(0,T.localize)(5,null),(0,T.localize)(6,null),(0,T.localize)(7,null)],default:"override",description:(0,T.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(9,null),restricted:!0}}},E.updateConfigurations({add:[f],remove:S?[S]:[]})}p(2)}),define(te[195],ne([0,1,28,15,14,44]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let r=class{constructor(y,C){this.requestService=y,this.fileService=C}async download(y,C,I=k.CancellationToken.None){if(y.scheme===T.Schemas.file||y.scheme===T.Schemas.vscodeRemote){await this.fileService.copy(y,C);return}const w={type:"GET",url:y.toString()},f=await this.requestService.request(w,I);if(f.res.statusCode===200)await this.fileService.writeFile(C,f.stream);else{const p=await(0,R.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${p}`)}}};r=he([J(0,R.IRequestService),J(1,D.IFileService)],r),e.DownloadService=r}),define(te[196],ne([0,1,16,28,67,2,18,157,14,10,27,44]),function(X,e,k,T,D,R,r,P,y,C,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends R.Disposable{constructor(h,E,S,m){super();this.fileService=h,this.productService=E,this.requestService=S,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:v})=>this.allConfigBasedTips.set(v.configPath,v))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const E=[];for(const[S,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const v=await this.fileService.readFile((0,r.joinPath)(h,S)),d=new Map;(0,D.forEach)(m.recommendations,({key:l,value:n})=>{if((0,k.isNonEmptyArray)(n.remotes))for(const s of n.remotes)d.set(s,{extensionId:l,extensionName:n.name,configName:m.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack});else E.push({extensionId:l,extensionName:n.name,configName:m.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack})});const c=(0,P.getDomainsOfRemotes)(v.value.toString(),[...d.keys()]);for(const l of c){const n=d.get(l);n&&E.push(n)}}catch(v){}return E}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},T.CancellationToken.None);if(h.res.statusCode!==200)return[];const E=await(0,w.asJson)(h);return E?E.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};f=he([J(0,y.IFileService),J(1,I.IProductService),J(2,w.IRequestService),J(3,C.ILogService)],f),e.ExtensionTipsService=f}),define(te[46],ne([0,1,19,29]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(R,r,P){let y=P&&P.get("storage.serviceMachineId",0)||null;if(y)return y;try{const I=(await r.readFile(R.serviceMachineIdResource)).value.toString();y=(0,T.isUUID)(I)?I:null}catch(C){y=null}if(!y){y=(0,T.generateUuid)();try{await r.writeFile(R.serviceMachineIdResource,k.VSBuffer.fromString(y))}catch(C){}}return P&&P.store("storage.serviceMachineId",y,0,1),y}e.getServiceMachineId=D}),define(te[92],ne([0,1,106,6]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(R){return(0,k.hash)({moduleId:R.process.moduleId,windowId:R.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,T.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[197],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var k;(function(T){T.Spawn="vscode:shared-process->shared-process-worker=spawn",T.Terminate="vscode:shared-process->shared-process-worker=terminate",T.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",T.Ready="vscode:shared-process-worker->shared-process=ready",T.Ack="vscode:shared-process-worker->shared-process=ack",T.Trace="vscode:shared-process-worker->shared-process=trace",T.Info="vscode:shared-process-worker->shared-process=info",T.Warn="vscode:shared-process-worker->shared-process=warn",T.Error="vscode:shared-process-worker->shared-process=error"})(k=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[198],ne([0,1,74,155,28,3,2,15,4,29,11,10,27,92,197]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let E=class{constructor(v,d,c){this.logService=v,this.productService=d,this.environmentService=c,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(v){const d=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${d})`);const c=(0,p.hash)(v);this.processeDisposables.has(c)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${d})`),this.doDisposeWorker(v));const l=new D.CancellationTokenSource;let n,s,i;this.processeDisposables.set(c,u=>{l.dispose(!0),n?.terminate(v,D.CancellationToken.None),s?.close(),i?.close(),this.processeDisposables.delete(c);const g=this.processResolvers.get(c);g&&(this.processResolvers.delete(c),g({reason:u}))}),n=await this.getOrCreateWebWorker(v);const t=new Promise(u=>{this.processResolvers.set(c,u)});if(l.token.isCancellationRequested)return t;const{port1:o,port2:a}=new MessageChannel;return s=o,i=a,await n.spawn(v,i,l.token),l.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${d})`),k.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",v,[s])),t}getOrCreateWebWorker(v){let d=this.workers.get(v.process.moduleId);if(!d){this.logService.trace(`SharedProcess: creating new web worker (${v.process.moduleId})`);const c=new S(v.process.type,this.logService,this.productService,this.environmentService);d=c.init(),c.onDidProcessSelfTerminate(({configuration:l,reason:n})=>{this.doDisposeWorker(l,n)}),this.workers.set(v.process.moduleId,d)}return d}async disposeWorker(v){return this.doDisposeWorker(v)}doDisposeWorker(v,d){const c=this.processeDisposables.get((0,p.hash)(v));c&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),c(d))}};E=he([J(0,w.ILogService),J(1,f.IProductService),J(2,I.INativeEnvironmentService)],E),e.SharedProcessWorkerService=E;class S extends r.Disposable{constructor(v,d,c,l){super();this.type=v,this.logService=d,this.productService=c,this.environmentService=l,this._onDidProcessSelfTerminate=this._register(new R.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){let v;const d=new Promise(l=>v=l),c=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return c.onerror=l=>{this.logService.error(`SharedProcess: worker error (${this.type})`,l.message)},c.onmessageerror=l=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,l)},c.onmessage=l=>{const{id:n,message:s,configuration:i,nonce:t}=l.data;switch(n){case h.SharedProcessWorkerMessages.Ready:v(c);break;case h.SharedProcessWorkerMessages.Ack:if(t){const o=this.mapMessageNonceToPendingMessageResolve.get(t);o&&(this.mapMessageNonceToPendingMessageResolve.delete(t),o())}break;case h.SharedProcessWorkerMessages.SelfTerminated:i&&s&&this._onDidProcessSelfTerminate.fire({configuration:i,reason:JSON.parse(s)});break;case h.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,s);break;case h.SharedProcessWorkerMessages.Info:s&&this.logService.info(s);break;case h.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,s);break;case h.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,s);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,l)}},c.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),d}async send(v,d,c){const l=await this.workerReady;if(!d.isCancellationRequested)return new Promise(n=>{const s=(0,C.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(s,n);const i={...v,nonce:s};c?l.postMessage(i,[c]):l.postMessage(i),d.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(s)&&n()})})}spawn(v,d,c){const l={id:h.SharedProcessWorkerMessages.Spawn,configuration:v,environment:this.getSharedProcessWorkerEnvironment()};return this.send(l,c,d)}getSharedProcessWorkerEnvironment(){const v={bootstrapPath:P.FileAccess.asFileUri("bootstrap-fork",X).fsPath,env:Object.create(null)};if(y.isLinux){const d={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},c=this.environmentService.args["crash-reporter-id"],l=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&l&&c&&(0,C.isUUID)(c)){const i=l["linux-x64"];d.submitURL=i.concat("&uid=",c,"&iid=",c,"&sid=",c),d.uploadToServer=!0}const s=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;v.env.BREAKPAD_DUMP_LOCATION=(0,T.join)(s,this.type),v.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(d)}return v}terminate(v,d){const c={id:h.SharedProcessWorkerMessages.Terminate,configuration:v};return this.send(c,d)}}}),define(te[93],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,k.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[199],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class k{constructor(){this.validators=new Map}vsda(){return new Promise((D,R)=>X(["vsda"],D,R))}async createNewMessage(D){try{const R=await this.vsda(),r=new R.validator;if(r){const P=String(k._nextId++);return this.validators.set(P,r),{id:P,data:r.createNewMessage(D)}}}catch(R){}return{id:"",data:D}}async validate(D,R){if(!D.id)return!0;const r=this.validators.get(D.id);if(!r)return!1;this.validators.delete(D.id);try{return r.validate(R)==="ok"}catch(P){return!1}}async sign(D){try{const R=await this.vsda(),r=new R.signer;if(r)return r.sign(D)}catch(R){}return D}}e.SignService=k,k._nextId=1}),define(te[23],ne([0,1,5,3,2,181,17,75,6]),function(X,e,k,T,D,R,r,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,y.createDecorator)("storageService");var I;(function(S){S[S.NONE=0]="NONE",S[S.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var w;(function(S){S[S.GLOBAL=0]="GLOBAL",S[S.WORKSPACE=1]="WORKSPACE"})(w=e.StorageScope||(e.StorageScope={}));var f;(function(S){S[S.USER=0]="USER",S[S.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class p extends D.Disposable{constructor(m={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new k.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,k.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,v){v===C?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:v,target:this.getKeyTargets(m)[v]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,v,d){return this.getStorage(v)?.get(m,d)}getBoolean(m,v,d){return this.getStorage(v)?.getBoolean(m,d)}getNumber(m,v,d){return this.getStorage(v)?.getNumber(m,d)}store(m,v,d,c){if((0,r.isUndefinedOrNull)(v)){this.remove(m,d);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,d,c),this.getStorage(d)?.set(m,v)})}remove(m,v){this.withPausedEmitters(()=>{this.updateKeyTarget(m,v,void 0),this.getStorage(v)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,v){const d=[],c=this.getKeyTargets(m);for(const l of Object.keys(c))c[l]===v&&d.push(l);return d}updateKeyTarget(m,v,d){const c=this.getKeyTargets(v);typeof d=="number"?c[m]!==d&&(c[m]=d,this.getStorage(v)?.set(C,JSON.stringify(c))):typeof c[m]=="number"&&(delete c[m],this.getStorage(v)?.set(C,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const v=this.get(C,m);if(v)try{return JSON.parse(v)}catch(d){}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=I.NONE){this._onWillSaveState.fire({reason:m});const v=this.getStorage(0),d=this.getStorage(1);switch(m){case I.NONE:await k.Promises.settled([v?.whenFlushed()??Promise.resolve(),d?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await k.Promises.settled([v?.flush(0)??Promise.resolve(),d?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return E(m,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends p{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function E(S,m,v,d){const c=a=>{try{return JSON.parse(a)}catch(u){return a}},l=new Map,n=new Map;S.forEach((a,u)=>{l.set(u,a),n.set(u,c(a))});const s=new Map,i=new Map;m.forEach((a,u)=>{s.set(u,a),i.set(u,c(a))}),console.group(`Storage: Global (path: ${v})`);let t=[];l.forEach((a,u)=>{t.push({key:u,value:a})}),console.table(t),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${d})`);let o=[];s.forEach((a,u)=>{o.push({key:u,value:a})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=E}),define(te[200],ne([0,1,3,2,17,30,36,23]),function(X,e,k,T,D,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let y=class extends T.Disposable{constructor(w){super();this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new C(w)),this._register(this.storageManger.onDidChange(f=>this._onDidChangeEnablement.fire({extensions:f,source:"storage"})))}async enableExtension(w,f){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:f}),!0):!1}async disableExtension(w,f){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){let f=this.getDisabledExtensions();return f.every(p=>!(0,r.areSameExtensions)(p,w))?(f.push(w),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(w){let f=this.getDisabledExtensions();for(let p=0;p<f.length;p++){const h=f[p];if((0,r.areSameExtensions)(h,w))return f.splice(p,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(w){this._setExtensions(R.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,f){this.storageManger.set(w,f,0)}};y=he([J(0,P.IStorageService)],y),e.GlobalExtensionEnablementService=y;class C extends T.Disposable{constructor(w){super();this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(w,f){let p;return f===0?((0,D.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,f)),p=this.storage[w]):p=this._get(w,f),JSON.parse(p)}set(w,f,p){let h=JSON.stringify(f.map(({id:S,uuid:m})=>({id:S,uuid:m})));this._get(w,p)!==h&&(p===0&&(f.length?this.storage[w]=h:delete this.storage[w]),this._set(w,f.length?h:void 0,p))}onDidStorageChange(w){if(w.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const p=this.get(w.key,w.scope);delete this.storage[w.key];const h=this.get(w.key,w.scope),E=p.filter(m=>!h.some(v=>(0,r.areSameExtensions)(m,v))),S=h.filter(m=>!p.some(v=>(0,r.areSameExtensions)(v,m)));(E.length||S.length)&&this._onDidChange.fire([...E,...S])}}_get(w,f){return this.storageService.get(w,f,"[]")}_set(w,f,p){f?this.storageService.store(w,f,p,1):this.storageService.remove(w,p)}}e.StorageManager=C}),define(te[201],ne([0,1,3,2]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends T.Disposable{constructor(C,I){super();this.channel=C,this.workspace=I}async getItems(){const C={workspace:this.workspace},I=await this.channel.call("getItems",C);return new Map(I)}updateItems(C){const I={workspace:this.workspace};return C.insert&&(I.insert=Array.from(C.insert.entries())),C.delete&&(I.delete=Array.from(C.delete.values())),this.channel.call("updateItems",I)}}class R extends D{constructor(C){super(C,void 0);this._onDidChangeItemsExternal=this._register(new k.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(C=>this.onDidChangeGlobalStorage(C)))}onDidChangeGlobalStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}async close(){this.dispose()}}class r extends D{constructor(C,I){super(C,I);this.onDidChangeItemsExternal=k.Event.None}async close(){const C={workspace:this.workspace};return this.channel.call("close",C)}}class P extends T.Disposable{constructor(C,I){super();this.channel=C,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new R(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new r(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(te[202],ne([0,1,5,2,18,75,23,201]),function(X,e,k,T,D,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class y extends r.AbstractStorageService{constructor(I,w,f){super();this.mainProcessService=w,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new T.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),w=new R.Storage(I.globalStorage);return this._register(w.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),w}createWorkspaceStorage(I){const w=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(w.workspaceStorage){const f=new R.Storage(w.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=I?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await k.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,D.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(r.WillSaveStateReason.SHUTDOWN),await k.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const w=this.workspaceStorage,f=w?.items??new Map;w&&(await w.close(),w.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[p,h]of f)this.workspaceStorage.set(p,h)}}e.NativeStorageService=y}),define(te[203],ne([0,1,4,31,8,29]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function r(C){if(k.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function P(C,I,w,f,p,h,E,S,m,v){const d=Object.create(null);d["common.machineId"]=E,d.sessionID=(0,R.generateUuid)()+Date.now(),d.commitHash=p,d.version=h,d["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,k.PlatformToString)(k.platform),d["common.nodePlatform"]=T.platform,d["common.nodeArch"]=f,d["common.product"]=v||"desktop";const c=y(S||[]);c&&(d["common.msftInternal"]=c);let l=0;const n=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),k.isLinuxSnap&&(d["common.snap"]="true");const s=r(w);s&&(d["common.platformDetail"]=s);try{const i=await C.readFile(D.URI.file(m));d["common.source"]=i.value.toString().slice(0,30)}catch(i){}return d}e.resolveCommonProperties=P;function y(C){const I=T.env.USERDNSDOMAIN;if(!I)return!1;const w=I.toLowerCase();return C.some(f=>w===f)}e.verifyMicrosoftInternalDomain=y}),define(te[22],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,k.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,k.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var T;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(T=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[204],ne([0,1,33,56,5,32,15,9,4,8,115,20,118,79,14,27,22]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(n,s){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],t=new Map,o=new Map,a=2e4;function u(A,O,U,x){const N=O.substring(A.length+1);return D.Promises.withAsyncBody(async L=>{let $;try{$=await w.Promises.readdir(O,{withFileTypes:!0})}catch(W){L();return}if(x.count>=a){x.count+=$.length,x.maxReached=!0,L();return}let _=$.length;if(_===0){L();return}let M=$;x.count+$.length>a&&(x.maxReached=!0,_=a-x.count,M=$.slice(0,_)),x.count+=$.length;for(const W of M)if(W.isDirectory()){if(U.includes(W.name)||await u(A,(0,P.join)(O,W.name),U,x),--_==0){L();return}}else{const j=W.name.lastIndexOf(".");if(j>=0){const q=W.name.substring(j+1);q&&t.set(q,(t.get(q)??0)+1)}for(const q of i)q.relativePathPattern?.test(N)!==!1&&q.filePattern.test(W.name)&&o.set(q.tag,(o.get(q.tag)??0)+1);if(--_==0){L();return}}})}const g={count:0,maxReached:!1};await u(n,n,s,g);const b=await c(n);return{configFiles:v(o),fileTypes:v(t),fileCount:g.count,maxFilesReached:g.maxReached,launchConfigFiles:b}}e.collectWorkspaceStats=m;function v(n){return[...T.Iterable.map(n.entries(),([s,i])=>({name:s,count:i}))].sort((s,i)=>i.count-s.count)}function d(){const n={os:`${k.type()} ${k.arch()} ${k.release()}`,memory:`${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},s=k.cpus();return s&&s.length>0&&(n.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),n}e.getMachineInfo=d;async function c(n){try{const s=new Map,i=(0,P.join)(n,".vscode","launch.json"),t=await w.Promises.readFile(i),o=[],a=(0,R.parse)(t.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,R.getNodeType)(a)==="object"&&a.configurations)for(const u of a.configurations){const g=u.type;g&&(s.has(g)?s.set(g,s.get(g)+1):s.set(g,1))}return v(s)}catch(s){return[]}}e.collectLaunchConfigs=c;let l=class{constructor(s,i){this.telemetryService=s,this.productService=i}formatMachineInfo(s){const i=[];return i.push(`OS Version:       ${s.os}`),i.push(`CPUs:             ${s.cpus}`),i.push(`Memory (System):  ${s.memory}`),i.push(`VM:               ${s.vmHint}`),i.join(`
`)}formatEnvironment(s){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${k.type()} ${k.arch()} ${k.release()}`);const t=k.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(k.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(k.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),y.isWindows||i.push(`Load (avg):       ${k.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${s.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(s.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(s,i){return Promise.all([(0,f.listProcesses)(s.mainPID),this.formatWorkspaceMetadata(s)]).then(async t=>{let[o,a]=t,u=this.formatProcessList(s,o);return i.forEach(g=>{if((0,p.isRemoteDiagnosticError)(g))u+=`
${g.errorMessage}`,a+=`
${g.errorMessage}`;else if(u+=`

Remote: ${g.hostName}`,g.processes&&(u+=`
${this.formatProcessList(s,g.processes)}`),g.workspaceMetadata){a+=`
|  Remote: ${g.hostName}`;for(const b of Object.keys(g.workspaceMetadata)){const A=g.workspaceMetadata[b];let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${b}): ${O}`,a+=this.formatWorkspaceStats(A)}}}),{processInfo:u,workspaceInfo:a}})}async getSystemInfo(s,i){const{memory:t,vmHint:o,os:a,cpus:u}=d(),g={os:a,memory:t,cpus:u,vmHint:o,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:i};return y.isWindows||(g.load=`${k.loadavg().map(b=>Math.round(b)).join(", ")}`),y.isLinux&&(g.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(g)}async getDiagnostics(s,i){const t=[];return(0,f.listProcesses)(s.mainPID).then(async o=>(t.push(""),t.push(this.formatEnvironment(s)),t.push(""),t.push(this.formatProcessList(s,o)),s.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(s))),i.forEach(a=>{if((0,p.isRemoteDiagnosticError)(a))t.push(`
${a.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${a.hostName}`),t.push(this.formatMachineInfo(a.machineInfo)),a.processes&&t.push(this.formatProcessList(s,a.processes)),a.workspaceMetadata)for(const u of Object.keys(a.workspaceMetadata)){const g=a.workspaceMetadata[u];let b=`${g.fileCount} files`;g.maxFilesReached&&(b=`more than ${b}`),t.push(`Folder (${u}): ${b}`),t.push(this.formatWorkspaceStats(g))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(s){const i=[],t=60;let o=0;const a=(A,O)=>{const U=` ${A}(${O})`;o+U.length>t?(i.push(u),u="|                 ",o=u.length):o+=U.length,u+=U};let u="|      File types:";const g=10;let b=s.fileTypes.length>g?g:s.fileTypes.length;for(let A=0;A<b;A++){const O=s.fileTypes[A];a(O.name,O.count)}if(i.push(u),s.configFiles.length>=0&&(u="|      Conf files:",o=0,s.configFiles.forEach(A=>{a(A.name,A.count)}),i.push(u)),s.launchConfigFiles.length>0){let A="|      Launch Configs:";s.launchConfigFiles.forEach(O=>{A+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(A)}return i.join(`
`)}expandGPUFeatures(s){const i=Math.max(...Object.keys(s).map(t=>t.length));return Object.keys(s).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${s[t]}`).join(`
                  `)}formatWorkspaceMetadata(s){const i=[],t=[];return s.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(a=>{const u=C.URI.revive(a);if(u.scheme===r.Schemas.file){const g=u.fsPath;t.push(m(g,["node_modules",".git"]).then(b=>{let A=`${b.fileCount} files`;b.maxFilesReached&&(A=`more than ${A}`),i.push(`|    Folder (${(0,P.basename)(g)}): ${A}`),i.push(this.formatWorkspaceStats(b))}).catch(b=>{i.push(`|      Error: Unable to collect workspace stats for folder ${g} (${b.toString()})`)}))}else i.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(s,i){const t=new Map;s.windows.forEach(a=>t.set(a.pid,a.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(s.mainPID,t,o,i,0),o.join(`
`)}formatProcessItem(s,i,t,o,a){const u=a===0;let g;u?g=o.pid===s?`${this.productService.applicationName} main`:"remote agent":(g=`${"  ".repeat(a)} ${o.name}`,o.name==="window"&&(g=`${g} (${i.get(o.pid)})`));const b=process.platform==="win32"?o.mem:k.totalmem()*(o.mem/100);t.push(`${o.load.toFixed(0).padStart(5," ")}	${(b/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${g}`),Array.isArray(o.children)&&o.children.forEach(A=>this.formatProcessItem(s,i,t,A,a+1))}async reportWorkspaceStats(s){for(const{uri:i}of s.folders){const t=C.URI.revive(i);if(t.scheme!==r.Schemas.file)continue;const o=t.fsPath;try{const a=await m(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),a.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),a.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})}),a.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:u.name,count:u.count})})}catch{}}}};l=he([J(0,S.ITelemetryService),J(1,E.IProductService)],l),e.DiagnosticsService=l}),define(te[205],ne([0,1,16,5,28,7,3,2,4,8,132,30,36,10,27,22]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let S=class extends P.Disposable{constructor(n,s,i,t){super();this.galleryService=n,this.telemetryService=s,this.logService=i,this.productService=t,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new r.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new r.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new r.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new r.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,P.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(n){const s=await this.getTargetPlatform();return n.allTargetPlatforms.some(i=>(0,w.isTargetPlatformCompatible)(i,n.allTargetPlatforms,s))}async installFromGallery(n,s={}){try{return await this.doInstallFromGallery(n,s)}catch(i){throw this.logService.error("Failed to install extension.",n.identifier.id),this.logService.error(i),v(i)}}async uninstall(n,s={}){return this.logService.trace("ExtensionManagementService#uninstall",n.identifier.id),this.unininstallExtension(n,s)}async reinstallFromGallery(n){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",n.identifier.id),!this.galleryService.isEnabled())throw new Error(I.localize(0,null));const s=await this.findGalleryExtension(n);if(!s)throw new Error(I.localize(1,null));await this.createUninstallExtensionTask(n,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsReport(){const n=new Date().getTime();return(!this.reportedExtensions||n-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=n),this.reportedExtensions}registerParticipant(n){this.participants.push(n)}async doInstallFromGallery(n,s={}){if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(I.localize(2,null),w.ExtensionManagementErrorCode.Internal);if(!await this.canInstall(n)){const t=await this.getTargetPlatform(),o=new w.ExtensionManagementError(I.localize(3,null,n.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(t)),w.ExtensionManagementErrorCode.Incompatible);throw d(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(n),void 0,o),o}try{n=await this.checkAndGetCompatibleVersion(n,!s.installGivenVersion)}catch(t){throw d(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(n),void 0,t),t}const i=await this.galleryService.getManifest(n,D.CancellationToken.None);if(i===null){const t=new w.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);throw d(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(n),void 0,t),t}if(i.version!==n.version){const t=new w.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);throw d(this.telemetryService,"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(n),void 0,t),t}return this.installExtension(i,n,s)}async installExtension(n,s,i){if(!C.URI.isUri(s)){let g=this.installingExtensions.get(new f.ExtensionIdentifierWithVersion(s.identifier,s.version).key());if(g)return this.logService.info("Extensions is already requested to install",s.identifier.id),g.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const t=[],o=[],a=this.createInstallExtensionTask(n,s,i);C.URI.isUri(s)||this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(a.identifier,n.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:s}),this.logService.info("Installing extension:",a.identifier.id),t.push({task:a,manifest:n});let u=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const b=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,n,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:A,manifest:O}of b)if(u=u||!!O.extensionDependencies?.some(U=>(0,f.areSameExtensions)({id:U},a.identifier)),this.installingExtensions.has(new f.ExtensionIdentifierWithVersion(A.identifier,A.version).key()))this.logService.info("Extension is already requested to install",A.identifier.id);else{const U=this.createInstallExtensionTask(O,A,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new f.ExtensionIdentifierWithVersion(U.identifier,O.version).key(),U),this._onInstallExtension.fire({identifier:U.identifier,source:A}),this.logService.info("Installing extension:",U.identifier.id),t.push({task:U,manifest:O})}}catch(b){if(C.URI.isUri(a.source))(0,k.isNonEmptyArray)(n.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,b.message),(0,k.isNonEmptyArray)(n.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,b.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),b}const g=t.reduce((b,{task:A,manifest:O})=>(b.set(A.identifier.id.toLowerCase(),{task:A,manifest:O}),b),new Map);for(;g.size;){let b;const A=[...g.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(U=>g.has(U.toLowerCase())));A.length?b=g.size===1?A:A.filter(({task:O})=>!(O===a&&!u)):(this.logService.info("Found extensions with circular dependencies",A.map(({task:O})=>O.identifier.id)),b=[...g.values()]),await this.joinAllSettled(b.map(async({task:O})=>{const U=new Date().getTime();try{const x=await O.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(x,O.source,i,D.CancellationToken.None))),!C.URI.isUri(O.source)&&(d(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,void 0),y.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch(N){}o.push({local:x,identifier:O.identifier,operation:O.operation,source:O.source})}catch(x){throw C.URI.isUri(O.source)||d(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,f.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-U,x),this.logService.error("Error while installing the extension:",O.identifier.id),x}finally{g.delete(O.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:b})=>this.logService.info("Extension installed successfully:",b.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:b})=>(0,f.areSameExtensions)(b,a.identifier))[0].local}catch(g){if(t.forEach(({task:b})=>b.cancel()),o.length)try{const b=await Promise.allSettled(o.map(({local:A})=>this.createUninstallExtensionTask(A,{versionOnly:!0}).run()));for(let A=0;A<b.length;A++){const O=b[A],{identifier:U}=o[A];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",U.id):this.logService.warn("Rollback: Error while uninstalling extension",U.id,(0,R.getErrorMessage)(O.reason))}}catch(b){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(b),o.map(({identifier:A})=>A.id))}throw this._onDidInstallExtensions.fire(t.map(({task:b})=>({identifier:b.identifier,operation:1,source:b.source}))),g}finally{for(const{task:g,manifest:b}of t)if(!C.URI.isUri(g.source)){const A=new f.ExtensionIdentifierWithVersion(g.identifier,b.version).key();this.installingExtensions.delete(A)||this.logService.warn("Installation task is not found in the cache",A)}}}async joinAllSettled(n){const s=[],i=[],t=await Promise.allSettled(n);for(const o of t)o.status==="fulfilled"?s.push(o.value):i.push(o.reason);if(i.length)throw m(i);return s}async getAllDepsAndPackExtensionsToInstall(n,s,i){if(!this.galleryService.isEnabled())return[];let t=await this.getInstalled();const o=[n,...t.map(g=>g.identifier)],a=[],u=async(g,b)=>{const A=b.extensionDependencies||[],O=[...A];if(b.extensionPack){const U=i?t.find(x=>(0,f.areSameExtensions)(x.identifier,g)):void 0;for(const x of b.extensionPack)U&&U.manifest.extensionPack&&U.manifest.extensionPack.some(N=>(0,f.areSameExtensions)({id:N},{id:x}))||O.every(N=>!(0,f.areSameExtensions)({id:N},{id:x}))&&O.push(x)}if(O.length){const U=[...o,...a.map(N=>N.gallery.identifier)],x=O.filter(N=>U.every(L=>!(0,f.areSameExtensions)(L,{id:N})));if(x.length){const N=await this.galleryService.query({names:x,pageSize:O.length},D.CancellationToken.None);for(const L of N.firstPage){if(U.find(W=>(0,f.areSameExtensions)(W,L.identifier)))continue;if(!A.some(W=>(0,f.areSameExtensions)({id:W},L.identifier))&&!await this.canInstall(L)){this.logService.info("Skipping the packed extension as it cannot be installed",L.identifier.id);continue}const _=await this.checkAndGetCompatibleVersion(L,!0),M=await this.galleryService.getManifest(_,D.CancellationToken.None);if(M===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${_.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);a.push({gallery:_,manifest:M}),await u(_.identifier,M)}}}};return await u(n,s),t=await this.getInstalled(),a.filter(g=>!t.some(b=>(0,f.areSameExtensions)(b.identifier,g.gallery.identifier)))}async checkAndGetCompatibleVersion(n,s){if(await this.isMalicious(n))throw new w.ExtensionManagementError(I.localize(4,null,n.identifier.id),w.ExtensionManagementErrorCode.Malicious);const i=await this.getCompatibleVersion(n,s);if(!i)throw new w.ExtensionManagementError(I.localize(5,null,n.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);return i}async getCompatibleVersion(n,s){const i=await this.getTargetPlatform();let t=null;return await this.galleryService.isExtensionCompatible(n,i)&&(t=n),!t&&s&&(t=await this.galleryService.getCompatibleExtension(n,i)),t}async isMalicious(n){const s=await this.getExtensionsReport();return(0,f.getMaliciousExtensionsSet)(s).has(n.identifier.id)}async unininstallExtension(n,s){const i=this.uninstallingExtensions.get(n.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",n.identifier.id),i.waitUntilTaskIsFinished();const t=(g,b)=>{const A=this.createUninstallExtensionTask(g,b);return this.uninstallingExtensions.set(A.extension.identifier.id.toLowerCase(),A),this.logService.info("Uninstalling extension:",g.identifier.id),this._onUninstallExtension.fire(g.identifier),A},o=(g,b)=>{b?this.logService.error("Failed to uninstall extension:",g.identifier.id,b.message):this.logService.info("Successfully uninstalled extension:",g.identifier.id),d(this.telemetryService,"extensionGallery:uninstall",(0,f.getLocalExtensionTelemetryData)(g),void 0,b),this._onDidUninstallExtension.fire({identifier:g.identifier,error:b?.code})},a=[],u=[];try{a.push(t(n,{}));const g=await this.getInstalled(1);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",n.identifier.id);else{const b=this.getAllPackExtensionsToUninstall(n,g);for(const A of b)this.uninstallingExtensions.has(A.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",A.identifier.id):a.push(t(A,{}))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",n.identifier.id):this.checkForDependents(a.map(b=>b.extension),g,n),await this.joinAllSettled(a.map(async b=>{try{if(await b.run(),await this.joinAllSettled(this.participants.map(A=>A.postUninstall(b.extension,s,D.CancellationToken.None))),b.extension.identifier.uuid)try{await this.galleryService.reportStatistic(b.extension.manifest.publisher,b.extension.manifest.name,b.extension.manifest.version,"uninstall")}catch(A){}o(b.extension)}catch(A){const O=A instanceof w.ExtensionManagementError?A:new w.ExtensionManagementError((0,R.getErrorMessage)(A),w.ExtensionManagementErrorCode.Internal);throw o(b.extension,O),O}finally{u.push(b)}}))}catch(g){const b=g instanceof w.ExtensionManagementError?g:new w.ExtensionManagementError((0,R.getErrorMessage)(g),w.ExtensionManagementErrorCode.Internal);for(const A of a){try{A.cancel()}catch(O){}u.includes(A)||o(A.extension,b)}throw b}finally{for(const g of a)this.uninstallingExtensions.delete(g.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",g.extension.identifier.id)}}checkForDependents(n,s,i){for(const t of n){const o=this.getDependents(t,s);if(o.length){const a=o.filter(u=>!n.some(g=>(0,f.areSameExtensions)(g.identifier,u.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(t,a,i))}}}getDependentsErrorMessage(n,s,i){return i===n?s.length===1?I.localize(6,null,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(7,null,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(8,null,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?I.localize(9,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?I.localize(10,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):I.localize(11,null,i.manifest.displayName||i.manifest.name,n.manifest.displayName||n.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(n,s,i=[]){if(i.indexOf(n)!==-1)return[];i.push(n);const t=n.manifest.extensionPack?n.manifest.extensionPack:[];if(t.length){const o=s.filter(u=>!u.isBuiltin&&t.some(g=>(0,f.areSameExtensions)({id:g},u.identifier))),a=[];for(const u of o)a.push(...this.getAllPackExtensionsToUninstall(u,s,i));return[...o,...a]}return[]}getDependents(n,s){return s.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(t=>(0,f.areSameExtensions)({id:t},n.identifier)))}async findGalleryExtension(n){if(n.identifier.uuid){const s=await this.findGalleryExtensionById(n.identifier.uuid);return s||this.findGalleryExtensionByName(n.identifier.id)}return this.findGalleryExtensionByName(n.identifier.id)}async findGalleryExtensionById(n){return(await this.galleryService.query({ids:[n],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(n){return(await this.galleryService.query({names:[n],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const n=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${n.length} reported extensions from service`),n}catch(n){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};S=he([J(0,w.IExtensionGalleryService),J(1,E.ITelemetryService),J(2,p.ILogService),J(3,h.IProductService)],S),e.AbstractExtensionManagementService=S;function m(l){const n=Array.isArray(l)?l:[l];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((s,i)=>new Error(`${s.message}${s.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}e.joinErrors=m;function v(l){if(l instanceof w.ExtensionManagementError)return l;const n=new w.ExtensionManagementError(l.message,w.ExtensionManagementErrorCode.Internal);return n.stack=l.stack,n}function d(l,n,s,i,t){const o=t?t instanceof w.ExtensionManagementError?t.code:w.ExtensionManagementErrorCode.Internal:void 0;l.publicLogError(n,{...s,success:!t,duration:i,errorcode:o})}e.reportTelemetry=d;class c{constructor(){this.barrier=new T.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(n=>this.doRun(n))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,T.createCancelablePromise)(n=>new Promise((s,i)=>{const t=n.onCancellationRequested(()=>{t.dispose(),i((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=c}),define(te[206],ne([0,1,16,5,67,3,9,4,31,8,134,11,30,196,81,14,10,61,27,44,23,22]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v,d,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const n="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let i=class extends p.ExtensionTipsService{constructor(o,a,u,g,b,A,O,U,x,N){super(O,U,x,N);this.environmentService=o,this.telemetryService=a,this.extensionManagementService=u,this.storageService=g,this.nativeHostService=b,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,U.exeBasedExtensionTips&&(0,D.forEach)(U.exeBasedExtensionTips,({key:L,value:$})=>{const _=[],M=[],W=[];(0,D.forEach)($.recommendations,({key:j,value:q})=>{q.important?$.important?_.push({extensionId:j,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):M.push({extensionId:j,extensionName:q.name,isExtensionPack:!!q.isExtensionPack}):W.push({extensionId:j,extensionName:q.name,isExtensionPack:!!q.isExtensionPack})}),_.length&&this.highImportanceExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:_}),M.length&&this.mediumImportanceExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:M}),W.length&&this.allOtherExecutableTips.set(L,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:W})}),(0,T.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...a]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),a=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(a,u)}groupImportantTipsByExe(o,a){const u=new Map;o.forEach(U=>u.set(U.extensionId.toLowerCase(),U));const{installed:g,uninstalled:b}=this.groupByInstalled([...u.keys()],a);for(const U of g){const x=u.get(U);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:U,exeName:x.exeName})}for(const U of b){const x=u.get(U);x&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:U,exeName:x.exeName})}const A=this.getPromptedExecutableTips(),O=new Map;for(const U of b){const x=u.get(U);if(x&&(!A[x.exeName]||!A[x.exeName].includes(x.extensionId))){let N=O.get(x.exeName);N||(N=[],O.set(x.exeName,N)),N.push(x)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,a]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(a).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(a[0].exeName,a);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":const g=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(g(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const b=this._register((0,T.disposableTimeout)(()=>{b.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),a=Date.now()-o,u=7*24*60*60*1e3;if(a<u){const A=this._register((0,T.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},u-a));return}const[g,b]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(b).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(g),this.addToRecommendedExecutables(b[0].exeName,b);const O=this._register((0,T.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(g),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const U=R.Event.once(R.Event.latch(R.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(U(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const x=this._register((0,T.disposableTimeout)(()=>{x.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(o){const a=o.map(({extensionId:g})=>g.toLowerCase()),u=(0,I.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,u,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(s,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(s,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(n,0,"{}"))}addToRecommendedExecutables(o,a){const u=this.getPromptedExecutableTips();u[o]=a.map(({extensionId:g})=>g.toLowerCase()),this.storageService.store(n,JSON.stringify(u),0,0)}groupByInstalled(o,a){const u=[],g=[],b=a.reduce((A,O)=>(A.add(O.identifier.id.toLowerCase()),A),new Set);return o.forEach(A=>{b.has(A.toLowerCase())?u.push(A):g.push(A)}),{installed:u,uninstalled:g}}async getValidExecutableBasedExtensionTips(o){const a=[],u=new Map;for(const g of o.keys()){const b=o.get(g);if(!b||!(0,k.isNonEmptyArray)(b.recommendations))continue;const A=[];P.isWindows?b.windowsPath&&A.push(b.windowsPath.replace("%USERPROFILE%",y.env.USERPROFILE).replace("%ProgramFiles(x86)%",y.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",y.env.ProgramFiles).replace("%APPDATA%",y.env.APPDATA).replace("%WINDIR%",y.env.WINDIR)):(A.push((0,r.join)("/usr/local/bin",g)),A.push((0,r.join)("/usr/bin",g)),A.push((0,r.join)(this.environmentService.userHome.fsPath,g)));for(const O of A){let U=u.get(O);if(U===void 0&&(U=await this.fileService.exists(C.URI.file(O)),u.set(O,U)),U)for(const{extensionId:x,extensionName:N,isExtensionPack:L}of b.recommendations)a.push({extensionId:x,extensionName:N,isExtensionPack:L,exeName:g,exeFriendlyName:b.exeFriendlyName,windowsPath:b.windowsPath})}}return a}};i=he([J(0,w.INativeEnvironmentService),J(1,l.ITelemetryService),J(2,f.IExtensionManagementService),J(3,c.IStorageService),J(4,m.INativeHostService),J(5,h.IExtensionRecommendationNotificationService),J(6,E.IFileService),J(7,v.IProductService),J(8,d.IRequestService),J(9,S.ILogService)],i),e.ExtensionTipsService=i}),define(te[94],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class k{constructor(R){this.appenders=R}listen(R,r){throw new Error(`Event not found: ${r}`)}call(R,r,{eventName:P,data:y}){return this.appenders.forEach(C=>C.log(P,y)),Promise.resolve(null)}}e.TelemetryAppenderChannel=k;class T{constructor(R){this.channel=R}log(R,r){return this.channel.call("log",{eventName:R,data:r}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=T}),define(te[45],ne([0,1,26,17,21,22]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class r{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,v){return Promise.resolve(void 0)}publicLog2(m,v){return this.publicLog(m,v)}publicLogError(m,v){return Promise.resolve(void 0)}publicLogError2(m,v){return this.publicLogError(m,v)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=r,e.NullTelemetryService=new r;class P{async publicLog(m,v,d){}async publicLogError(m,v,d){}}e.NullEndpointTelemetryService=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(S,m){return m.onDidChangeConfiguration(v=>{v.source!==6&&S.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(v.source),configurationKeys:h(v.sourceConfig)})})}e.configurationTelemetry=y;function C(S,m){return!(m.disableTelemetry||!S.enableTelemetry)}e.supportsTelemetry=C;function I(S){const m=S.getValue(R.TELEMETRY_SETTING_ID),v=S.getValue("telemetry.enableCrashReporter");if(S.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||v===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function w(S){const m=Object.create(null),v=Object.create(null),d=Object.create(null);p(S,d);for(let c in d){c=c.length>150?c.substr(c.length-149):c;const l=d[c];typeof l=="number"?v[c]=l:typeof l=="boolean"?v[c]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${l.length}`),m[c]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(m[c]=l)}return{properties:m,measurements:v}}e.validateTelemetryData=w;function f(S){if(!S)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(d=>{S.indexOf(`${d}+`)===0&&(m=d)}),m}e.cleanRemoteAuthority=f;function p(S,m,v=0,d){if(!!S)for(let c of Object.getOwnPropertyNames(S)){const l=S[c],n=d?d+c:c;Array.isArray(l)?m[n]=(0,k.safeStringify)(l):l instanceof Date?m[n]=l.toISOString():(0,T.isObject)(l)?v<2?p(l,m,v+1,n+"."):m[n]=(0,k.safeStringify)(l):m[n]=l}}function h(S){if(!S)return[];const m=[];return E(m,"",S),m}function E(S,m,v){v&&typeof v=="object"&&!Array.isArray(v)?Object.keys(v).forEach(d=>E(S,m?`${m}.${d}`:d,v[d])):S.push(m)}}),define(te[207],ne([0,1,45,152]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class D{constructor(){}setSharedProperty(y,C){}postEvent(y,C){}}class R{constructor(y,C,I,w,f){this.getMachineId=y,this.configurationService=C,this.productService=I,this.telemetry=w,this.keyValueStorage=f,this.networkInitialized=!1,I.tasConfig&&this.experimentsEnabled&&(0,k.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),h=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(E=>setTimeout(E,h))}get experimentsEnabled(){return!0}async getTreatment(y){await this.overrideInitDelay;const C=this.configurationService.getValue("experiments.override."+y);if(C!==void 0)return C;if(!this.tasClient||!this.experimentsEnabled)return;let I;const w=await this.tasClient;return this.networkInitialized?I=w.getTreatmentVariable("vscode",y):I=await w.getTreatmentVariableAsync("vscode",y,!0),I=w.getTreatmentVariable("vscode",y),I}async setupTASClient(){const y=this.productService.quality==="stable"?T.TargetPopulation.Public:T.TargetPopulation.Insiders,C=await this.getMachineId(),I=new T.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,C,y),w=this.productService.tasConfig,f=new(await new Promise((p,h)=>{X(["tas-client-umd"],p,h)})).ExperimentationService({filterProviders:[I],telemetry:this.telemetry,storageKey:T.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:w.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:w.assignmentContextTelemetryPropertyName,telemetryEventName:w.telemetryEventName,endpoint:w.endpoint,refetchInterval:T.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=R;class r extends R{constructor(y,C,I){super(()=>Promise.resolve(y),C,I,new D)}}e.AssignmentService=r}),define(te[208],ne([0,1,16,28,7,26,4,31,8,21,11,30,36,78,14,10,27,44,46,23,22,45]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v,d,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const n=r.isWeb?"web":(0,w.getTargetPlatform)(r.platform,P.arch);var s;(function(G){G[G.None=0]="None",G[G.IncludeVersions=1]="IncludeVersions",G[G.IncludeFiles=2]="IncludeFiles",G[G.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",G[G.IncludeSharedAccounts=8]="IncludeSharedAccounts",G[G.IncludeVersionProperties=16]="IncludeVersionProperties",G[G.ExcludeNonValidated=32]="ExcludeNonValidated",G[G.IncludeInstallationTargets=64]="IncludeInstallationTargets",G[G.IncludeAssetUri=128]="IncludeAssetUri",G[G.IncludeStatistics=256]="IncludeStatistics",G[G.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",G[G.Unpublished=4096]="Unpublished"})(s||(s={}));function i(...G){return String(G.reduce((H,re)=>H|re,0))}var t;(function(G){G[G.Tag=1]="Tag",G[G.ExtensionId=4]="ExtensionId",G[G.Category=5]="Category",G[G.ExtensionName=7]="ExtensionName",G[G.Target=8]="Target",G[G.Featured=9]="Featured",G[G.SearchText=10]="SearchText",G[G.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},g={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class b{constructor(H=g){this.state=H}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(H,re=this.state.pageSize){return new b({...this.state,pageNumber:H,pageSize:re})}withFilter(H,...re){const ie=[...this.state.criteria,...re.length?re.map(ce=>({filterType:H,value:ce})):[{filterType:H}]];return new b({...this.state,criteria:ie})}withSortBy(H){return new b({...this.state,sortBy:H})}withSortOrder(H){return new b({...this.state,sortOrder:H})}withFlags(...H){return new b({...this.state,flags:H.reduce((re,ie)=>re|ie,0)})}withAssetTypes(...H){return new b({...this.state,assetTypes:H})}get raw(){const{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le,flags:fe,assetTypes:de}=this.state;return{filters:[{criteria:H,pageNumber:re,pageSize:ie,sortBy:ce,sortOrder:le}],assetTypes:de,flags:fe}}get searchText(){const H=this.state.criteria.filter(re=>re.filterType===t.SearchText)[0];return H&&H.value?H.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(H=>String(H.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(G,H){const re=(G||[]).filter(ie=>ie.statisticName===H)[0];return re?re.value:0}function O(G){const H="Microsoft.VisualStudio.Code.Translation.";return G.files.filter(ie=>ie.assetType.indexOf(H)===0).reduce((ie,ce)=>{const le=L(G,ce.assetType);return le&&ie.push([ce.assetType.substring(H.length),le]),ie},[])}function U(G){if(G.properties){const H=G.properties.filter(ce=>ce.key===o.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=H.filter(ce=>re.test(ce.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return L(G,o.Repository)}function x(G){return{uri:`${G.fallbackAssetUri}/${o.VSIX}?redirect=true${G.targetPlatform?`&targetPlatform=${G.targetPlatform}`:""}`,fallbackUri:`${G.fallbackAssetUri}/${o.VSIX}${G.targetPlatform?`?targetPlatform=${G.targetPlatform}`:""}`}}function N(G){const H=L(G,o.Icon);if(H)return H;const re=w.DefaultIconPath;return{uri:re,fallbackUri:re}}function L(G,H){return G.files.filter(ie=>ie.assetType===H)[0]?{uri:`${G.assetUri}/${H}`,fallbackUri:`${G.fallbackAssetUri}/${H}`}:null}function $(G,H){const re=G.properties?G.properties.filter(ce=>ce.key===H):[],ie=re.length>0&&re[0].value;return ie?ie.split(",").map(ce=>(0,f.adoptToGalleryExtensionId)(ce)):[]}function _(G){const H=G.properties?G.properties.filter(re=>re.key===a.Engine):[];return H.length>0&&H[0].value||""}function M(G){const H=G.properties?G.properties.filter(ie=>ie.key===a.LocalizedLanguages):[],re=H.length>0&&H[0].value||"";return re?re.split(","):[]}function W(G){return G.indexOf("preview")!==-1}function j(G){return G.targetPlatform?(0,w.toTargetPlatform)(G.targetPlatform):"undefined"}function q(G){const H=(0,k.distinct)(G.versions.map(j)),re=!!G.tags?.includes(w.WEB_EXTENSION_TAG),ie=H.indexOf("web");return re?ie===-1&&H.push("web"):ie!==-1&&H.splice(ie,1),H}function z(G,H){const re=(0,w.getFallbackTargetPlarforms)(H);for(let ie=0;ie<G.length;ie++){const ce=G[ie];if(ce.version===G[ie-1]?.version){let le=ie;const fe=j(ce);if(fe===H)for(;le>0&&G[le-1].version===ce.version;)le--;else if(re.includes(fe))for(;le>0&&G[le-1].version===ce.version&&j(G[le-1])!==H;)le--;le!==ie&&(G.splice(ie,1),G.splice(le,0,ce))}}return G}e.sortExtensionVersions=z;function K(G,H,re,ie,ce){const le=q(G);let fe=G.versions[0];return fe=G.versions.find(de=>de.version===fe.version&&(0,w.isTargetPlatformCompatible)(j(de),le,ce))||fe,F(G,fe,le,H,re,ie)}function F(G,H,re,ie,ce,le){const fe={manifest:L(H,o.Manifest),readme:L(H,o.Details),changelog:L(H,o.Changelog),license:L(H,o.License),repository:U(H),download:x(H),icon:N(H),coreTranslations:O(H)};return{identifier:{id:(0,f.getGalleryExtensionId)(G.publisher.publisherName,G.extensionName),uuid:G.extensionId},name:G.extensionName,version:H.version,displayName:G.displayName,publisherId:G.publisher.publisherId,publisher:G.publisher.publisherName,publisherDisplayName:G.publisher.displayName,publisherDomain:G.publisher.domain?{link:G.publisher.domain,verified:!!G.publisher.isDomainVerified}:void 0,description:G.shortDescription||"",installCount:A(G.statistics,"install"),rating:A(G.statistics,"averagerating"),ratingCount:A(G.statistics,"ratingcount"),categories:G.categories||[],tags:G.tags||[],releaseDate:Date.parse(G.releaseDate),lastUpdated:Date.parse(G.lastUpdated),allTargetPlatforms:re,assets:fe,properties:{dependencies:$(H,a.Dependency),extensionPack:$(H,a.ExtensionPack),engine:_(H),localizedLanguages:M(H),targetPlatform:j(H)},preview:W(G.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+ie,querySource:le}}}let B=class{constructor(H,re,ie,ce,le,fe,de,be){this.requestService=re,this.logService=ie,this.environmentService=ce,this.telemetryService=le,this.fileService=fe,this.productService=de,this.configurationService=be;const Ie=de.extensionsGallery;this.extensionsGalleryUrl=Ie&&Ie.serviceUrl,this.extensionsControlUrl=Ie&&Ie.controlUrl,this.commonHeadersPromise=Z(de.version,de,this.environmentService,this.configurationService,this.fileService,H)}api(H=""){return`${this.extensionsGalleryUrl}${H}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(H,re){const ie=[];let ce=new b().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,H.length).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExtensionName,...H.map(({id:fe})=>fe.toLowerCase()));H.every(fe=>!fe.version)&&(ce=ce.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,n,T.CancellationToken.None);for(let fe=0;fe<le.length;fe++){const de=le[fe];if(!de.versions.length)continue;const be=(0,f.getGalleryExtensionId)(de.publisher.publisherName,de.extensionName),Ie=H.find(Ee=>(0,f.areSameExtensions)(Ee,{id:be}))?.version;if(Ie){const Ee=de.versions.find(Ae=>Ae.version===Ie);Ee&&ie.push(F(de,Ee,q(de),fe,ce))}else ie.push(K(de,fe,ce,void 0,n))}return ie}async getCompatibleExtension(H,re){const ie=(0,w.isIExtensionIdentifier)(H)?null:H;if(ie){if((0,w.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(ie,re))return ie}const{id:ce,uuid:le}=ie?ie.identifier:H;let fe=new b().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");le?fe=fe.withFilter(t.ExtensionId,le):fe=fe.withFilter(t.ExtensionName,ce);const{galleryExtensions:de}=await this.queryGallery(fe,re,T.CancellationToken.None),[be]=de;if(!be||!be.versions.length)return null;const Ie=q(be);if((0,w.isNotWebExtensionInWebTargetPlatform)(Ie,re))return null;for(let Ee of be.versions){if(!_(Ee)){const Ae=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:a.Engine,value:Ae}]}}if(await this.isRawExtensionVersionCompatible(Ee,Ie,re))return F(be,Ee,Ie,0,fe)}return null}async isExtensionCompatible(H,re){if(!(0,w.isTargetPlatformCompatible)(H.properties.targetPlatform,H.allTargetPlatforms,re))return!1;let ie=H.properties.engine;if(!ie){const ce=await this.getManifest(H,T.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");ie=ce.engines.vscode}return(0,p.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(H,re,ie){if(!(0,w.isTargetPlatformCompatible)(j(H),re,ie))return!1;const ce=await this.getEngine(H);return(0,p.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(H,re){const ie=T.CancellationToken.isCancellationToken(H)?{}:H,ce=T.CancellationToken.isCancellationToken(H)?H:re;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=ie.text||"";const fe=(0,R.getOrDefault)(ie,Pe=>Pe.pageSize,50);let de=new b().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,fe).withFilter(t.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(de=de.withFilter(t.Category,Fe||Le),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,Le,Fe)=>(de=de.withFilter(t.Tag,Fe||Le),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(de=de.withFilter(t.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),de=de.withFilter(t.SearchText,le)),de=de.withSortBy(0)):ie.ids?de=de.withFilter(t.ExtensionId,...ie.ids):ie.names?de=de.withFilter(t.ExtensionName,...ie.names):de=de.withSortBy(4),typeof ie.sortBy=="number"&&(de=de.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(de=de.withSortOrder(ie.sortOrder));const{galleryExtensions:be,total:Ie}=await this.queryGallery(de,n,ce),Ee=be.map((Pe,Le)=>K(Pe,Le,de,ie.source,n)),Ae=async(Pe,Le)=>{if(Le.isCancellationRequested)throw(0,D.canceled)();const Fe=de.withPage(Pe+1),{galleryExtensions:Ne}=await this.queryGallery(Fe,n,Le);return Ne.map(($e,qe)=>K($e,qe,Fe,ie.source,n))};return{firstPage:Ee,total:Ie,pageSize:de.pageSize,getPage:Ae}}async queryGallery(H,re,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");H=H.withFlags(H.flags,s.ExcludeNonValidated).withFilter(t.ExcludeWithFlags,i(s.Unpublished));const ce=await this.commonHeadersPromise,le=JSON.stringify(H.raw),fe={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},de=new Date().getTime();let be,Ie,Ee=0;try{if(be=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:fe},ie),be.res.statusCode&&be.res.statusCode>=400&&be.res.statusCode<500)return{galleryExtensions:[],total:Ee};const Ae=await(0,m.asJson)(be);if(Ae){const Pe=Ae.results[0],Le=Pe.extensions;Le.forEach(Ne=>z(Ne.versions,re));const Fe=Pe.resultMetadata&&Pe.resultMetadata.filter(Ne=>Ne.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter(Ne=>Ne.name==="TotalCount")[0].count||0,{galleryExtensions:Le,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(Ae){throw Ie=Ae,Ae}finally{this.telemetryService.publicLog2("galleryService:query",{...H.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-de,success:!!be&&(0,m.isSuccess)(be),responseBodySize:be?.res.headers["Content-Length"],statusCode:be?String(be.res.statusCode):void 0,errorCode:Ie?(0,D.isPromiseCanceledError)(Ie)?"canceled":(0,D.getErrorMessage)(Ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(H,re,ie,ce){if(!this.isEnabled())return;const le=r.isWeb?this.api(`/itemName/${H}.${re}/version/${ie}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${H}/extensions/${re}/${ie}/stats?statType=${ce}`),fe=r.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",be={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:le,headers:be},T.CancellationToken.None)}catch(Ie){}}async download(H,re,ie){this.logService.trace("ExtensionGalleryService#download",H.identifier.id);const ce=(0,f.getGalleryExtensionTelemetryData)(H),le=new Date().getTime(),fe=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Ee}),de=ie===1?"install":ie===2?"update":"",be=de?{uri:`${H.assets.download.uri}${y.URI.parse(H.assets.download.uri).query?"&":"?"}${de}=true`,fallbackUri:`${H.assets.download.fallbackUri}${y.URI.parse(H.assets.download.fallbackUri).query?"&":"?"}${de}=true`}:H.assets.download,Ie=await this.getAsset(be);await this.fileService.writeFile(re,Ie.stream),fe(new Date().getTime()-le)}async getReadme(H,re){if(H.assets.readme){const ie=await this.getAsset(H.assets.readme,{},re);return await(0,m.asText)(ie)||""}return""}async getManifest(H,re){if(H.assets.manifest){const ie=await this.getAsset(H.assets.manifest,{},re),ce=await(0,m.asText)(ie);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(H,re){const ie=L(H,o.Manifest);if(!ie)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},le=await this.getAsset(ie,{headers:ce});return await(0,m.asJson)(le)}async getCoreTranslation(H,re){const ie=H.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(ie){const ce=await this.getAsset(ie[1]),le=await(0,m.asText)(ce);return le?JSON.parse(le):null}return null}async getChangelog(H,re){if(H.assets.changelog){const ie=await this.getAsset(H.assets.changelog,{},re);return await(0,m.asText)(ie)||""}return""}async getAllCompatibleVersions(H,re){let ie=new b().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(t.Target,"Microsoft.VisualStudio.Code");H.identifier.uuid?ie=ie.withFilter(t.ExtensionId,H.identifier.uuid):ie=ie.withFilter(t.ExtensionName,H.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(ie,re,T.CancellationToken.None);if(!ce.length)return[];const le=q(ce[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(le,re))return[];const fe=[];for(const de of ce[0].versions)try{fe[fe.length-1]?.version!==de.version&&await this.isRawExtensionVersionCompatible(de,le,re)&&fe.push({version:de.version,date:de.lastUpdated})}catch(be){}return fe}async getAsset(H,re={},ie=T.CancellationToken.None){const ce=await this.commonHeadersPromise,le={type:"GET"},fe={...ce,...re.headers||{}};re={...re,...le,headers:fe};const de=H.uri,be=H.fallbackUri,Ie={...re,url:de};try{const Ee=await this.requestService.request(Ie,ie);if(Ee.res.statusCode===200)return Ee;const Ae=await(0,m.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${Ae}`)}catch(Ee){if((0,D.isPromiseCanceledError)(Ee))throw Ee;const Ae=(0,D.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:de,message:Ae});const Pe={...re,url:be};return this.requestService.request(Pe,ie)}}async getEngine(H){let re=_(H);if(!re){const ie=await this.getManifestFromRawExtensionVersion(H,T.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");re=ie.engines.vscode}return re}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const H=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},T.CancellationToken.None);if(H.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,m.asJson)(H),ie=new Map;if(re)for(const ce of re.malicious){const le=ie.get(ce)||{id:{id:ce},malicious:!0,slow:!1};le.malicious=!0,ie.set(ce,le)}return[...ie.values()]}};B=he([J(1,m.IRequestService),J(2,E.ILogService),J(3,I.IEnvironmentService),J(4,c.ITelemetryService),J(5,h.IFileService),J(6,S.IProductService),J(7,C.IConfigurationService)],B);let V=class extends B{constructor(H,re,ie,ce,le,fe,de,be){super(H,re,ie,ce,le,fe,de,be)}};V=he([J(0,d.IStorageService),J(1,m.IRequestService),J(2,E.ILogService),J(3,I.IEnvironmentService),J(4,c.ITelemetryService),J(5,h.IFileService),J(6,S.IProductService),J(7,C.IConfigurationService)],V),e.ExtensionGalleryService=V;let Q=class extends B{constructor(H,re,ie,ce,le,fe,de){super(void 0,H,re,ie,ce,le,fe,de)}};Q=he([J(0,m.IRequestService),J(1,E.ILogService),J(2,I.IEnvironmentService),J(3,c.ITelemetryService),J(4,h.IFileService),J(5,S.IProductService),J(6,C.IConfigurationService)],Q),e.ExtensionGalleryServiceWithNoStorageService=Q;async function Z(G,H,re,ie,ce,le){const fe={"X-Market-Client-Id":`VSCode ${G}`,"User-Agent":`VSCode ${G}`},de=await(0,v.getServiceMachineId)(re,ce,le);return(0,l.supportsTelemetry)(H,re)&&(0,l.getTelemetryLevel)(ie)===3&&(fe["X-Market-User-Id"]=de),fe}e.resolveMarketplaceHeaders=Z}),define(te[95],ne([0,1,2,11,10,45]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let r=class extends k.Disposable{constructor(y,C,I=""){super();this.prefix=I;const w=y.getLogger(C.telemetryLogResource);w?this.logger=this._register(w):(this.logger=this._register(y.createLogger(C.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(y,C){this.logger.trace(`${this.prefix}telemetry/${y}`,(0,R.validateTelemetryData)(C))}};r=he([J(0,D.ILoggerService),J(1,T.IEnvironmentService)],r),e.TelemetryLogAppender=r}),define(te[96],ne([0,1,2,26,4,25,144,21,39,88,35,22,45]),function(X,e,k,T,D,R,r,P,y,C,I,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(S,m){this._configurationService=m,this._experimentProperties={},this._disposables=new k.DisposableStore,this._cleanupPatterns=[],this._appenders=S.appenders,this._commonProperties=S.commonProperties||Promise.resolve({}),this._piiPaths=S.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!S.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let v of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(v),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(v=>{const d=/^[a-f0-9]+$/i.test(v["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!d})})}setExperimentProperty(S,m){this._experimentProperties[S]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const S=await this._commonProperties;let m=S.sessionID,v=S["common.instanceId"],d=S["common.machineId"],c=S["common.firstSessionDate"],l=S["common.msftInternal"];return{sessionId:m,instanceId:v,machineId:d,firstSessionDate:c,msftInternal:l}}dispose(){this._disposables.dispose()}_log(S,m,v,d){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(c=>{v=(0,T.mixin)(v,c),v=(0,T.mixin)(v,this._experimentProperties),v=(0,T.cloneAndChange)(v,l=>{if(typeof l=="string")return this._cleanupInfo(l,d)}),this._appenders.forEach(l=>l.log(S,v))},c=>{console.error(c)})}publicLog(S,m,v){return this._log(S,3,m,v)}publicLog2(S,m,v){return this.publicLog(S,m,v)}publicLogError(S,m){return this.sendErrorTelemetry?this._log(S,2,m,!0):Promise.resolve(void 0)}publicLogError2(S,m){return this.publicLogError(S,m)}_anonymizeFilePaths(S){let m=S;const v=[];for(let n of this._cleanupPatterns)for(;;){const s=n.exec(S);if(!s)break;v.push([s.index,n.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(m="";;){const n=c.exec(S);if(!n)break;!d.test(n[0])&&v.every(([s,i])=>n.index<s||n.index>=i)&&(m+=S.substring(l,n.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}return l<S.length&&(m+=S.substr(l)),m}_removePropertiesWithPossibleUserInfo(S){if(!S)return S;const m=S.toLowerCase(),v=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":v.test(m)?"<REDACTED: email>":S}_cleanupInfo(S,m){let v=S;m&&(v=this._anonymizeFilePaths(v));for(let d of this._cleanupPatterns)v=v.replace(d,"");return v=this._removePropertiesWithPossibleUserInfo(v),v}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=he([J(1,P.IConfigurationService)],p),e.TelemetryService=p;function h(){const E=(0,r.localize)(0,null,C.default.nameLong),S=C.default.privacyStatementUrl?(0,r.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,r.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=D.isWeb?"":(0,r.localize)(3,null),v=(0,r.localize)(4,null),d=(0,r.localize)(5,null),c=(0,r.localize)(6,null),l=(0,r.localize)(7,null),n=`
|       | ${v} | ${d} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,r.localize)(8,null);return`
${E} ${S} ${m}

&nbsp;

${l}
${n}

&nbsp;

${s}
`}I.Registry.as(y.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,r.localize)(9,null),properties:{[w.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,r.localize)(10,null),(0,r.localize)(11,null),(0,r.localize)(12,null),(0,r.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(y.Extensions.Configuration).registerConfiguration({id:w.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,r.localize)(14,null),properties:{[w.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,r.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,r.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,r.localize)(17,null,`\`#${w.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[209],ne([0,1,7,26,45]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function R(P,y){const C=await new Promise((w,f)=>{X(["applicationinsights"],w,f)});let I;return C.defaultClient?(I=new C.TelemetryClient(P),I.channel.setUseDiskRetryCaching(!0)):(C.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=C.defaultClient),P.indexOf("AIF-")===0&&(I.config.endpointUrl=y?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class r{constructor(y,C,I,w,f){this._eventPrefix=y,this._defaultData=C,this.testCollector=w,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(y){if(!!this._aiClient){if(typeof this._aiClient!="string"){y(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(C=>{y(C)},C=>{(0,k.onUnexpectedError)(C),console.error(C)})}}log(y,C){!this._aiClient||(C=(0,T.mixin)(C,this._defaultData),C=(0,D.validateTelemetryData)(C),this.testCollector&&(C.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+y,properties:C.properties,measurements:C.measurements})))}flush(){return this._aiClient?new Promise(y=>{this._withAIClient(C=>{C.flush({callback:()=>{this._aiClient=void 0,y(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=r}),define(te[210],ne([0,1,15,52,21,11,10,22,94,95,96]),function(X,e,k,T,D,R,r,P,y,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let w=class{constructor(p,h,E,S){this.configurationService=p,this.telemetryService=h,this.loggerService=E,this.environmentService=S,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:h,sessionId:E}=await this.telemetryService.getTelemetryInfo(),S=Object.create(null);S["common.vscodemachineid"]=h,S["common.vscodesessionid"]=E;const m=[p.id,JSON.stringify(S),p.aiKey],d=new T.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new y.TelemetryAppenderClient(d),new C.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new I.TelemetryService({appenders:c,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,h,E){await(await this.getCustomTelemetryService(p)).publicLog(h,E)}async publicLogError(p,h,E){await(await this.getCustomTelemetryService(p)).publicLogError(h,E)}};w=he([J(0,D.IConfigurationService),J(1,P.ITelemetryService),J(2,r.ILoggerService),J(3,R.IEnvironmentService)],w),e.CustomEndpointTelemetryService=w}),define(te[211],ne([0,1,5,28,3,2,10]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends R.Disposable{constructor(C,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((I,w)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,I),this._onCreateRequest.fire({requestId:f,...C});const p=new T.CancellationTokenSource;(0,k.timeout)(this._timeout,p.token).then(()=>w(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,R.toDisposable)(()=>p.cancel())])})}acceptReply(C,I){const w=this._pendingRequests.get(C);w?(this._pendingRequests.delete(C),(0,R.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),w(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};P=he([J(1,r.ILogService)],P),e.RequestStore=P}),define(te[97],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var T;(function(S){S.Shell="terminal.integrated.shell.",S.ShellArgs="terminal.integrated.shellArgs.",S.DefaultProfile="terminal.integrated.defaultProfile.",S.Profiles="terminal.integrated.profiles."})(T=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(S){S.ShellLinux="terminal.integrated.shell.linux",S.ShellMacOs="terminal.integrated.shell.osx",S.ShellWindows="terminal.integrated.shell.windows",S.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",S.AutomationShellLinux="terminal.integrated.automationShell.linux",S.AutomationShellMacOs="terminal.integrated.automationShell.osx",S.AutomationShellWindows="terminal.integrated.automationShell.windows",S.AutomationProfileLinux="terminal.integrated.automationProfile.linux",S.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",S.AutomationProfileWindows="terminal.integrated.automationProfile.windows",S.ShellArgsLinux="terminal.integrated.shellArgs.linux",S.ShellArgsMacOs="terminal.integrated.shellArgs.osx",S.ShellArgsWindows="terminal.integrated.shellArgs.windows",S.ProfilesWindows="terminal.integrated.profiles.windows",S.ProfilesMacOs="terminal.integrated.profiles.osx",S.ProfilesLinux="terminal.integrated.profiles.linux",S.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",S.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",S.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",S.UseWslProfiles="terminal.integrated.useWslProfiles",S.TabsEnabled="terminal.integrated.tabs.enabled",S.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",S.TabsHideCondition="terminal.integrated.tabs.hideCondition",S.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",S.TabsShowActions="terminal.integrated.tabs.showActions",S.TabsLocation="terminal.integrated.tabs.location",S.TabsFocusMode="terminal.integrated.tabs.focusMode",S.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",S.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",S.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",S.CopyOnSelection="terminal.integrated.copyOnSelection",S.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",S.FontFamily="terminal.integrated.fontFamily",S.FontSize="terminal.integrated.fontSize",S.LetterSpacing="terminal.integrated.letterSpacing",S.LineHeight="terminal.integrated.lineHeight",S.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",S.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",S.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",S.BellDuration="terminal.integrated.bellDuration",S.FontWeight="terminal.integrated.fontWeight",S.FontWeightBold="terminal.integrated.fontWeightBold",S.CursorBlinking="terminal.integrated.cursorBlinking",S.CursorStyle="terminal.integrated.cursorStyle",S.CursorWidth="terminal.integrated.cursorWidth",S.Scrollback="terminal.integrated.scrollback",S.DetectLocale="terminal.integrated.detectLocale",S.DefaultLocation="terminal.integrated.defaultLocation",S.GpuAcceleration="terminal.integrated.gpuAcceleration",S.TerminalTitleSeparator="terminal.integrated.tabs.separator",S.TerminalTitle="terminal.integrated.tabs.title",S.TerminalDescription="terminal.integrated.tabs.description",S.RightClickBehavior="terminal.integrated.rightClickBehavior",S.Cwd="terminal.integrated.cwd",S.ConfirmOnExit="terminal.integrated.confirmOnExit",S.ConfirmOnKill="terminal.integrated.confirmOnKill",S.EnableBell="terminal.integrated.enableBell",S.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",S.AllowChords="terminal.integrated.allowChords",S.AllowMnemonics="terminal.integrated.allowMnemonics",S.EnvMacOs="terminal.integrated.env.osx",S.EnvLinux="terminal.integrated.env.linux",S.EnvWindows="terminal.integrated.env.windows",S.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",S.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",S.ShowExitAlert="terminal.integrated.showExitAlert",S.SplitCwd="terminal.integrated.splitCwd",S.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",S.WordSeparators="terminal.integrated.wordSeparators",S.EnableFileLinks="terminal.integrated.enableFileLinks",S.UnicodeVersion="terminal.integrated.unicodeVersion",S.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",S.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",S.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",S.LocalEchoStyle="terminal.integrated.localEchoStyle",S.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",S.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",S.CustomGlyphs="terminal.integrated.customGlyphs",S.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",S.InheritEnv="terminal.integrated.inheritEnv",S.ShowLinkHover="terminal.integrated.showLinkHover",S.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var R;(function(S){S.CommandPrompt="cmd",S.PowerShell="pwsh",S.Wsl="wsl",S.GitBash="gitbash"})(R=e.WindowsShellType||(e.WindowsShellType={}));var r;(function(S){S[S.Api=0]="Api",S[S.Process=1]="Process",S[S.Sequence=2]="Sequence",S[S.Config=3]="Config"})(r=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(S){S.LocalPty="localPty",S.PtyHost="ptyHost",S.Log="log",S.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,k.createDecorator)("ptyService");var y;(function(S){S.Cwd="cwd",S.InitialCwd="initialCwd",S.FixedDimensions="fixedDimensions",S.Title="title",S.ShellType="shellType",S.HasChildProcesses="hasChildProcesses",S.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",S.OverrideDimensions="overrideDimensions"})(y=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(S){S[S.BeatInterval=5e3]="BeatInterval",S[S.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",S[S.SecondWaitMultiplier=1]="SecondWaitMultiplier",S[S.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(S){S[S.Panel=1]="Panel",S[S.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var w;(function(S){S.TerminalView="view",S.Editor="editor"})(w=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(S){S.CwdDetection="cwdDetection"})(f=e.ProcessCapability||(e.ProcessCapability={}));var p;(function(S){S[S.GraceTime=6e4]="GraceTime",S[S.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(S){S[S.HighWatermarkChars=1e5]="HighWatermarkChars",S[S.LowWatermarkChars=5e3]="LowWatermarkChars",S[S.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var E;(function(S){S.GitBash="Git Bash",S.Pwsh="PowerShell"})(E=e.ProfileSource||(e.ProfileSource={}))}),define(te[212],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,k.createDecorator)("localPtyService")}),define(te[213],ne([0,1,33,26,9,4,31,17,20]),function(X,e,k,T,D,R,r,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(k.release());let f=0;return w&&w.length===4&&(f=parseInt(w[3])),f}e.getWindowsBuildNumber=C;async function I(w,f,p,h=r.env,E=y.Promises.exists){if(D.isAbsolute(w))return await E(w)?w:void 0;if(f===void 0&&(f=r.cwd()),D.dirname(w)!=="."){const d=D.join(f,w);return await E(d)?d:void 0}const m=(0,T.getCaseInsensitive)(h,"PATH");if(p===void 0&&(0,P.isString)(m)&&(p=m.split(D.delimiter)),p===void 0||p.length===0){const d=D.join(f,w);return await E(d)?d:void 0}for(let d of p){let c;if(D.isAbsolute(d)?c=D.join(d,w):c=D.join(f,d,w),await E(c))return c;if(R.isWindows){let l=c+".com";if(await E(l)||(l=c+".exe",await E(l)))return l}}const v=D.join(f,w);return await E(v)?v:void 0}e.findExecutable=I}),define(te[214],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var k;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST="hc"})(k=e.ColorScheme||(e.ColorScheme={}))}),define(te[98],ne([0,1,49,3,2,6,35,214]),function(X,e,k,T,D,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var y;(function(S){function m(v){return v&&typeof v=="object"&&typeof v.id=="string"}S.isThemeColor=m})(y=e.ThemeColor||(e.ThemeColor={}));function C(S){return{id:S}}e.themeColorFromId=C;var I;(function(S){function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||y.isThemeColor(i.color))}S.isThemeIcon=m;const v=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function d(i){const t=v.exec(i);if(!t)return;let[,o]=t;return{id:o}}S.fromString=d;function c(i,t){let o=i.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),t&&(o=`${o}~${t}`),{id:o}}S.modify=c;function l(i){const t=i.id.lastIndexOf("~");if(t!==-1)return i.id.substring(t+1)}S.getModifier=l;function n(i,t){return i.id===t.id&&i.color?.id===t.color?.id}S.isEqual=n;function s(i,t){return{id:i.id,color:t?C(t):void 0}}S.asThemeIcon=s,S.asClassNameArray=k.CSSIcon.asClassNameArray,S.asClassName=k.CSSIcon.asClassName,S.asCSSSelector=k.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function w(S){switch(S){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,D.toDisposable)(()=>{const v=this.themingParticipants.indexOf(m);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new f;r.Registry.add(e.Extensions.ThemingContribution,p);function h(S){return p.onColorThemeChange(S)}e.registerThemingParticipant=h;class E extends D.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,v){let d=this.theme.getColor(m);return d&&v&&(d=v(d,this.theme)),d?d.toString():null}}e.Themable=E}),define(te[215],ne([0,1,49,8,98]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function R(w,f){const p=w.map(h=>({name:h.profileName,description:r(h)}));return f&&p.push(...f.map(h=>({name:h.title,description:P(h)}))),{values:p.map(h=>h.name),markdownDescriptions:p.map(h=>h.description)}}e.createProfileSchemaEnums=R;function r(w){let f=`$(${D.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:k.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?f+=`
- args: "${w.args}"`:f+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(f+=`
- overrideName: ${w.overrideName}`),w.color&&(f+=`
- color: ${w.color}`),w.env&&(f+=`
- env: ${JSON.stringify(w.env)}`),f}function P(w){return`$(${D.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:k.Codicon.terminal.id}) ${w.title}
- extensionIdenfifier: ${w.extensionIdentifier}`}function y(w,f){if(!w&&!f)return!0;if(typeof w=="string"&&typeof f=="string")return w===f;if(Array.isArray(w)&&Array.isArray(f)){if(w.length!==f.length)return!1;for(let p=0;p<w.length;p++)if(w[p]!==f[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=y;function C(w,f){if(!w&&!f)return!0;if(!w||!f)return!1;if(D.ThemeIcon.isThemeIcon(w)&&D.ThemeIcon.isThemeIcon(f))return w.id===f.id&&w.color===f.color;if(typeof w=="object"&&w&&"light"in w&&"dark"in w&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const p=w,h=f;if((T.URI.isUri(p.light)||I(p.light))&&(T.URI.isUri(p.dark)||I(p.dark))&&(T.URI.isUri(h.light)||I(h.light))&&(T.URI.isUri(h.dark)||I(h.dark)))return p.light.path===h.light.path&&p.dark.path===h.dark.path}if(T.URI.isUri(w)&&T.URI.isUri(f)||I(w)||I(f)){const p=w,h=f;return p.path===h.path&&p.scheme===h.scheme}return!1}e.terminalIconsEqual=C;function I(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}e.isUriComponents=I}),define(te[216],ne([0,1,49,145,39,35,215]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:(0,T.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,T.localize)(1,null),type:"boolean"},icon:{description:(0,T.localize)(2,null),type:"string",enum:Array.from(k.iconRegistry.all,d=>d.id),markdownEnumDescriptions:Array.from(k.iconRegistry.all,d=>`$(${d.id})`)},color:{description:(0,T.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,T.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},y={type:"object",required:["path"],properties:{path:{description:(0,T.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},C=(0,T.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),I=(0,T.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),w=(0,T.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),f=(0,T.localize)(9,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,T.localize)(10,null,"`#terminal.integrated.automationProfile.osx#`"),h=(0,T.localize)(11,null,"`#terminal.integrated.automationProfile.windows#`"),E={id:"terminal",order:100,title:(0,T.localize)(12,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(13,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(14,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(15,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(16,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},y]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,T.localize)(17,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},y]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,T.localize)(18,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},y]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(19,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(22,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(23,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(24,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,T.localize)(25,null)}},{type:"string",markdownDescription:(0,T.localize)(26,null)}],default:[],markdownDeprecationMessage:w},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(27,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,T.localize)(28,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(29,null),type:"string"},id:{description:(0,T.localize)(30,null),type:"string"},title:{description:(0,T.localize)(31,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(32,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(33,null),type:"string"},id:{description:(0,T.localize)(34,null),type:"string"},title:{description:(0,T.localize)(35,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(36,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,T.localize)(37,null),type:"string"},id:{description:(0,T.localize)(38,null),type:"string"},title:{description:(0,T.localize)(39,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.useWslProfiles"]:{description:(0,T.localize)(40,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,T.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,T.localize)(42,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,T.localize)(43,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,T.localize)(44,null),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function S(){R.Registry.as(D.Extensions.Configuration).registerConfiguration(E),v()}e.registerTerminalPlatformConfiguration=S;let m;function v(d,c){const l=R.Registry.as(D.Extensions.Configuration);let n;d&&(n=(0,r.createProfileSchemaEnums)(d?.profiles,c));const s=m;m={id:"terminal",order:100,title:(0,T.localize)(45,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,T.localize)(46,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:d?.os===3?n?.values:void 0,markdownEnumDescriptions:d?.os===3?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,T.localize)(47,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:d?.os===2?n?.values:void 0,markdownEnumDescriptions:d?.os===2?n?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,T.localize)(48,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:d?.os===1?n?.values:void 0,markdownEnumDescriptions:d?.os===1?n?.markdownDescriptions:void 0}}},l.updateConfigurations({add:[m],remove:s?[s]:[]})}e.registerTerminalDefaultProfileConfiguration=v}),define(te[217],ne([0,1,43,49,9,4,20,72,213,98]),function(X,e,k,T,D,R,r,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,w=!0;function f(s,i,t,o,a=process.env,u,g,b,A){return u=u||{existsFile:r.SymlinkSupport.existsFile,readFile:r.Promises.readFile},R.isWindows?p(t,u,a,g,o.getValue("terminal.integrated.useWslProfiles")!==!1,s&&typeof s=="object"?{...s}:o.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:o.getValue("terminal.integrated.defaultProfile.windows"),A,b):c(u,g,t,s&&typeof s=="object"?{...s}:o.getValue(R.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:o.getValue(R.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),A,b,a)}e.detectAvailableProfiles=f;async function p(s,i,t,o,a,u,g,b,A){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let x=!1;(0,y.getWindowsBuildNumber)()>=16299&&(x=!0),await S(b);const N=new Map;s&&(N.set("PowerShell",{source:"PowerShell",icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:T.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),N.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:T.Codicon.terminalCmd,isAutoDetected:!0})),l(u,N);const L=await h(N.entries(),g,i,t,o,A);if(s||!s&&a)try{const $=await v(`${U}\\${x?"wsl":"bash"}.exe`,g);for(const _ of $)(!u||!(_.profileName in u))&&L.push(_)}catch($){w&&(o?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return L}async function h(s,i,t,o=process.env,a,u){const g=[];for(const[b,A]of s){if(A===null)continue;let O,U,x;if("source"in A){const $=I?.get(A.source);if(!$)continue;O=$.paths,U=A.args||$.args,A.icon?x=E(A.icon):$.icon&&(x=$.icon)}else O=Array.isArray(A.path)?A.path:[A.path],U=R.isWindows||Array.isArray(A.args)?A.args:void 0,x=E(A.icon)||void 0;const N=await u?.(O)||O.slice(),L=await n(b,i,N,t,o,U,A.env,A.overrideName,A.isAutoDetected,a);L?(L.isAutoDetected=A.isAutoDetected,L.icon=x,L.color=A.color,g.push(L)):a?.trace("profile not validated",b,O)}return g}function E(s){return typeof s=="string"?{id:s}:s}async function S(s){I&&!s||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:s||await m(),icon:C.ThemeIcon.asThemeIcon(T.Codicon.terminalPowershell)}))}async function m(){const s=[];for await(const i of(0,P.enumeratePowerShellInstallations)())s.push(i.exePath);return s}async function v(s,i){const t=[],o=await new Promise((g,b)=>{k.exec("wsl.exe -l -q",{encoding:"utf16le"},(A,O)=>{if(A)return b("Problem occurred when getting wsl distros");g(O)})});if(!o)return[];const a=new RegExp(/[\r?\n]/),u=o.split(a).filter(g=>g.trim().length>0&&g!=="");for(const g of u){if(g===""||g.startsWith("docker-desktop"))continue;const b=`${g} (WSL)`,A={profileName:b,path:s,args:["-d",`${g}`],isDefault:b===i,icon:d(g)};t.push(A)}return t}function d(s){return s.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(T.Codicon.terminalUbuntu):s.includes("Debian")?C.ThemeIcon.asThemeIcon(T.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(T.Codicon.terminalLinux)}async function c(s,i,t,o,a,u,g,b){const A=new Map;if(t){const O=(await s.readFile("/etc/shells")).toString(),U=u||O.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),x=new Map;for(const N of U){let L=(0,D.basename)(N),$=x.get(L)||0;$++,$>1&&(L=`${L} (${$})`),x.set(L,$),A.set(L,{path:N,isAutoDetected:!0})}}return l(o,A),await h(A.entries(),a,s,b,i,g)}function l(s,i){if(!!s)for(const[t,o]of Object.entries(s))o===null||!("path"in o)&&!("source"in o)?i.delete(t):i.set(t,o)}async function n(s,i,t,o,a,u,g,b,A,O){if(t.length===0)return Promise.resolve(void 0);const U=t.shift();if(U==="")return n(s,i,t,o,a,u,g,b,A);const x={profileName:s,path:U,args:u,env:g,overrideName:b,isAutoDetected:A,isDefault:s===i};if((0,D.basename)(U)===U){const L=a.PATH?a.PATH.split(D.delimiter):void 0;return await(0,y.findExecutable)(U,void 0,L,void 0,o.existsFile)?x:n(s,i,t,o,a,u)}return await o.existsFile((0,D.normalize)(U))?x:n(s,i,t,o,a,u,g,b,A)}}),define(te[218],ne([0,1,3,2,15,4,34,52,21,11,77,167,10,87,22,211,97,216,217]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(n){n[n.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let c=0,l=class extends T.Disposable{constructor(s,i,t,o,a){super();this._reconnectConstants=s,this._configurationService=i,this._environmentService=t,this._logService=o,this._telemetryService=a,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new k.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new k.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new k.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new k.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new k.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new k.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new k.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new k.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new k.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new k.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new k.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new k.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,T.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new E.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(R.isWindows)return process.env;try{return await(0,w.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?s.debugBrk=i.port:!i.break&&i.port&&(s.debug=i.port));const t=new P.Client(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,s);this._onPtyHostStart.fire(),r.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(g=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(g.code),this._isDisposed||(this._restartCount<=d.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${g.code}, giving up`))}));const a=t.getChannel(S.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(a,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(a,this._logService.getLevel())}));const u=r.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(g=>this._onProcessData.fire(g))),this._register(u.onProcessReady(g=>this._onProcessReady.fire(g))),this._register(u.onProcessExit(g=>this._onProcessExit.fire(g))),this._register(u.onDidChangeProperty(g=>this._onDidChangeProperty.fire(g))),this._register(u.onProcessReplay(g=>this._onProcessReplay.fire(g))),this._register(u.onProcessOrphanQuestion(g=>this._onProcessOrphanQuestion.fire(g))),this._register(u.onDidRequestDetach(g=>this._onDidRequestDetach.fire(g))),[t,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,i,t,o,a,u,g,b,A,O,U){const x=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),N=await this._proxy.createProcess(s,i,t,o,a,u,g,b,A,O,U);return clearTimeout(x),c=Math.max(c,N),N}updateTitle(s,i,t){return this._proxy.updateTitle(s,i,t)}updateIcon(s,i,t){return this._proxy.updateIcon(s,i,t)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,i){return this._proxy.shutdown(s,i)}input(s,i){return this._proxy.input(s,i)}processBinary(s,i){return this._proxy.processBinary(s,i)}resize(s,i,t){return this._proxy.resize(s,i,t)}acknowledgeDataEvent(s,i){return this._proxy.acknowledgeDataEvent(s,i)}setUnicodeVersion(s,i){return this._proxy.setUnicodeVersion(s,i)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,i,t,o=!1){const a=await this._shellEnv;return(0,v.detectAvailableProfiles)(i,t,o,this._configurationService,a,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,i){return this._proxy.requestDetachInstance(s,i)}async acceptDetachInstanceReply(s,i){return this._proxy.acceptDetachInstanceReply(s,i)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,i){return this._proxy.refreshProperty(s,i)}async updateProperty(s,i,t){return this._proxy.updateProperty(s,i,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:i})}async acceptPtyHostResolvedVariables(s,i){this._resolveVariablesRequestStore.acceptReply(s,i)}};l=he([J(1,y.IConfigurationService),J(2,C.IEnvironmentService),J(3,f.ILogService),J(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(te[37],ne([0,1,6]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,k.createDecorator)("IUriIdentityService")}),define(te[219],ne([0,1,3,2,8,11,36,14,10,37]),function(X,e,k,T,D,R,r,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends T.Disposable{constructor(f,p,h,E,S){super();this.extensionsManagementService=f,this.logService=E,this.uriIdentityService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new k.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(v=>{this.installedExtensions=v.map(d=>d.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(v=>this.onInstallExtension(v))),this._register(f.onDidInstallExtensions(v=>this.onDidInstallExtensions(v))),this._register(f.onDidUninstallExtension(v=>this.onDidUninstallExtension(v)));const m=D.URI.file(h.extensionsPath);this._register(p.watch(m)),this._register(k.Event.filter(p.onDidChangeFilesRaw,v=>v.changes.some(d=>this.doesChangeAffects(d,m)))(()=>this.onDidChange()))}doesChangeAffects(f,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),p)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const p of f)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(p=>!(0,r.areSameExtensions)(p,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,r.areSameExtensions)(p,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),p=f.filter(E=>[...this.installingExtensions,...this.installedExtensions].some(S=>(0,r.areSameExtensions)(S,E.identifier))?!1:E.installedTimestamp&&E.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",E.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",E.identifier.id),!1)),h=this.installedExtensions.filter(E=>this.installingExtensions.some(S=>(0,r.areSameExtensions)(S,E))?!1:f.every(S=>!(0,r.areSameExtensions)(S.identifier,E))?(this.logService.info("Detected extension removed from another source",E.id),!0):!1);this.installedExtensions=f.map(E=>E.identifier),(p.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:h})}}};I=he([J(1,P.IFileService),J(2,R.INativeEnvironmentService),J(3,y.ILogService),J(4,C.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(te[220],ne([0,1,37,59,14,18,105,3,2]),function(X,e,k,T,D,R,r,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(f){this.uri=f,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let I=class{constructor(f){this._fileService=f,this._dispooables=new y.DisposableStore,this._limit=2**16;const p=new Map,h=E=>{let S=p.get(E.scheme);return S===void 0&&(S=f.hasProvider(E)&&!this._fileService.hasCapability(E,1024),p.set(E.scheme,S)),S};this._dispooables.add(P.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(E=>{p.delete(E.scheme)})),this.extUri=new R.ExtUri(h),this._canonicalUris=new r.SkipList((E,S)=>this.extUri.compare(E,S,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,R.normalizePath)(f));let p=this._canonicalUris.get(f);return p?p.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new C(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((h,E)=>h[1].touch<E[1].touch?1:h[1].touch>E[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let h=0;h<p;h++)this._canonicalUris.set(f[h][0],f[h][1].touch())}};I=he([J(0,D.IFileService)],I),e.UriIdentityService=I,(0,T.registerSingleton)(k.IUriIdentityService,I,!0)}),define(te[55],ne([0,1,40]),function(X,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function T(r,P,y,C){const I=(0,k.setProperty)(r,P,y,C)[0];return I&&(r=r.substring(0,I.offset)+I.content+r.substring(I.offset+I.length)),r}e.edit=T;function D(r,P,y){let C=y;for(;C>=0;){if(r.charAt(C)===P.charAt(P.length-1)&&P.length===1)return C+1;if(C--,P.length===2&&C>=0&&r.charAt(C)===P.charAt(0))return C+2}return 0}e.getLineStartOffset=D;function R(r,P,y){let C=y;for(;C>=0;)if(r.charAt(C)===P.charAt(P.length-1)&&P.length===1||(C++,P.length===2&&C>=0&&r.charAt(C)===P.charAt(1)))return C;return r.length-1}e.getLineEndOffset=R}),define(te[221],ne([0,1,26,62]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(w,f,p,h,E){const S=[],m=[],v=[];if(!f){const O=w.filter(({identifier:U})=>E.every(x=>x.toLowerCase()!==U.id.toLowerCase()));return{local:{added:S,removed:m,updated:v},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}w=w.map(C),f=f.map(C),p=p?p.map(C):null;const d=new Map,c=O=>{O.uuid&&d.set(O.id.toLowerCase(),O.uuid)};w.forEach(({identifier:O})=>c(O)),f.forEach(({identifier:O})=>c(O)),p&&p.forEach(({identifier:O})=>c(O));const l=O=>{const U=O.identifier.uuid||d.get(O.identifier.id.toLowerCase());return U?`uuid:${U}`:`id:${O.identifier.id.toLowerCase()}`},n=(O,U)=>(O.set(l(U),U),O),s=w.reduce(n,new Map),i=f.reduce(n,new Map),t=f.reduce((O,U)=>{const x=l(U);U=(0,k.deepClone)(U);const N=s.get(x);return N&&(N.installed&&(U.installed=!0),U.version||(U.version=N.version)),n(O,U)},new Map),o=p?p.reduce(n,new Map):null,a=h.reduce(n,new Map),u=E.reduce((O,U)=>{const x=d.get(U.toLowerCase());return O.add(x?`uuid:${x}`:`id:${U.toLowerCase()}`)},new Set),g=R(s,i,u);if(g.added.size>0||g.removed.size>0||g.updated.size>0){const O=R(o,s,u),U=R(o,i,u),x=(N,L)=>{const $=s.get(N);if($){const _=i.get(N);return{...L?_:$,version:(_.version&&T.gt(_.version,$.version),$.version),state:r($,_,o?.get(N))}}};for(const N of U.removed.values()){const L=s.get(N);L&&m.push(L.identifier)}for(const N of U.added.values())if(O.added.has(N)){if(g.updated.has(N)){const L=x(N,!0);L&&(v.push(I(L,N)),t.set(N,L))}}else{const L=i.get(N);L.installed&&S.push(I(L,N))}for(const N of U.updated.values()){const L=x(N,!0);L&&(v.push(I(L,N)),t.set(N,L))}for(const N of O.added.values())U.added.has(N)||t.set(N,s.get(N));for(const N of O.updated.values())if(!U.removed.has(N)&&!U.updated.has(N)){const L=x(N,!1);L&&(t.get(N)?.installed&&(L.installed=!0),t.set(N,L))}for(const N of O.removed.values())!a.has(N)&&!U.updated.has(N)&&o?.get(N)?.installed&&t.delete(N)}const b=[],A=R(i,t,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&t.forEach((O,U)=>b.push(I(O,U))),{local:{added:S,removed:m,updated:v},remote:b.length?{added:[...A.added].map(O=>t.get(O)),updated:[...A.updated].map(O=>t.get(O)),removed:[...A.removed].map(O=>i.get(O)),all:b}:null}}e.merge=D;function R(w,f,p,{checkInstalledProperty:h,checkVersionProperty:E}={checkInstalledProperty:!1,checkVersionProperty:!1}){const S=w?[...w.keys()].filter(l=>!p.has(l)):[],m=[...f.keys()].filter(l=>!p.has(l)),v=m.filter(l=>S.indexOf(l)===-1).reduce((l,n)=>(l.add(n),l),new Set),d=S.filter(l=>m.indexOf(l)===-1).reduce((l,n)=>(l.add(n),l),new Set),c=new Set;for(const l of S){if(d.has(l))continue;const n=w.get(l),s=f.get(l);(!s||n.disabled!==s.disabled||!y(n.state,s.state)||E&&n.version!==s.version||h&&n.installed!==s.installed)&&c.add(l)}return{added:v,removed:d,updated:c}}function r(w,f,p){const h=w.state,E=f.state,S=p?.state;if(!f.version||h&&T.gt(w.version,f.version))return h;if(E&&T.gt(f.version,w.version)||!h)return E;if(!E)return h;const m=(0,k.deepClone)(h),v=S?P(S,E):{added:Object.keys(E).reduce((c,l)=>(c.add(l),c),new Set),removed:new Set,updated:new Set},d=S?P(S,h):{added:Object.keys(h).reduce((c,l)=>(c.add(l),c),new Set),removed:new Set,updated:new Set};for(const c of[...v.added.values(),...v.updated.values()])m[c]=E[c];for(const c of v.removed.values())d.updated.has(c)||delete m[c];return m}function P(w,f){const p=Object.keys(w),h=Object.keys(f),E=h.filter(v=>p.indexOf(v)===-1).reduce((v,d)=>(v.add(d),v),new Set),S=p.filter(v=>h.indexOf(v)===-1).reduce((v,d)=>(v.add(d),v),new Set),m=new Set;for(const v of p){if(S.has(v))continue;const d=w[v],c=f[v];(0,k.equals)(d,c)||m.add(v)}return{added:E,removed:S,updated:m}}function y(w={},f={}){const{added:p,removed:h,updated:E}=P(w,f);return p.size===0&&h.size===0&&E.size===0}function C(w){return{...w,disabled:!!w.disabled,installed:!!w.installed}}function I(w,f){const p={identifier:{id:w.identifier.id,uuid:f.startsWith("uuid:")?f.substring("uuid:".length):void 0}};return w.version&&(p.version=w.version),w.disabled&&(p.disabled=!0),w.installed&&(p.installed=!0),w.state&&(p.state=w.state),p}}),define(te[99],ne([0,1,16,3,2,36,6,27,23]),function(X,e,k,T,D,R,r,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,r.createDecorator)("IExtensionsStorageSyncService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let I=class it extends D.Disposable{constructor(f,p){super();this.storageService=f,this.productService=p,this._onDidChangeExtensionsStorage=this._register(new T.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(f){return`extensionKeys/${(0,R.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const p=C.exec(f);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const f=this.storageService.keys(0,1);for(const p of f){const h=it.fromKey(p);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const p=it.fromKey(f.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(f,p){this.storageService.store(it.toKey(f),JSON.stringify(p),0,1)}getKeysForSync(f){const p=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],h=this.storageService.get(it.toKey(f),0),E=h?JSON.parse(h):void 0;return E&&p?(0,k.distinct)([...E,...p]):E||p}};I=he([J(0,y.IStorageService),J(1,P.IProductService)],I),e.ExtensionsStorageSyncService=I}),define(te[100],ne([0,1,16,21,6]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let R=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,y){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return C=C.filter(I=>I!==P&&I!==`-${P}`),y&&C.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}updateSynchronizedExtensions(P,y){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return C=C.filter(I=>I!==P&&I!==`-${P}`),y&&C.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}getIgnoredExtensions(P){const y=P.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),C=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),I=[],w=[];if(Array.isArray(C))for(const f of C)f.startsWith("-")?w.push(f.substring(1)):I.push(f);return(0,k.distinct)([...y,...I].filter(f=>w.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(y=>y.toLowerCase())}};R=he([J(0,T.IConfigurationService)],R),e.IgnoredExtensionsManagementService=R}),define(te[222],ne([0,1,16,32,26,162,55]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(c){return(0,T.parse)(c)||[]}e.parseKeybindings=P;async function y(c,l,n,s,i){const t=P(c),o=P(l),a=n?P(n):null,u=[...t,...o,...a||[]].map(M=>M.key),g=await i.resolveUserBindings(u);let b=I(t,o,a,g);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const A=f(t),O=f(o),U=a?f(a):null,x=h(A,O,g),N=U?h(U,A,g):{added:[...A.keys()].reduce((M,W)=>(M.add(W),M),new Set),removed:new Set,updated:new Set},L=U?h(U,O,g):{added:[...O.keys()].reduce((M,W)=>(M.add(W),M),new Set),removed:new Set,updated:new Set},$=C(x,N,L);let _=c;for(const M of $.removed.values())$.conflicts.has(M)||(_=v(_,M,s));for(const M of $.added.values()){if($.conflicts.has(M))continue;const W=O.get(M);if(W.some(j=>j.command!==`-${M}`&&b.conflicts.has(g[j.key]))){$.conflicts.add(M);continue}_=m(_,W,s)}for(const M of $.updated.values()){if($.conflicts.has(M))continue;const W=O.get(M);if(W.some(j=>j.command!==`-${M}`&&b.conflicts.has(g[j.key]))){$.conflicts.add(M);continue}_=d(_,M,W,s)}return{mergeContent:_,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=y;function C(c,l,n){const s=new Set,i=new Set,t=new Set,o=new Set;for(const a of l.removed.values())n.updated.has(a)&&o.add(a);for(const a of n.removed.values())o.has(a)||(l.updated.has(a)?o.add(a):i.add(a));for(const a of l.added.values())o.has(a)||n.added.has(a)&&c.updated.has(a)&&o.add(a);for(const a of n.added.values())o.has(a)||(l.added.has(a)?c.updated.has(a)&&o.add(a):s.add(a));for(const a of l.updated.values())o.has(a)||n.updated.has(a)&&c.updated.has(a)&&o.add(a);for(const a of n.updated.values())o.has(a)||(l.updated.has(a)?c.updated.has(a)&&o.add(a):t.add(a));return{added:s,removed:i,updated:t,conflicts:o}}function I(c,l,n,s){const i=new Set,t=w(c,s),o=w(l,s),a=n?w(n,s):null,u=p(t,o);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const g=a?p(a,t):{added:[...t.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const b=a?p(a,o):{added:[...o.keys()].reduce((N,L)=>(N.add(L),N),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:A,removed:O,updated:U,conflicts:x}=C(u,g,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:O,updated:U,conflicts:x}}function w(c,l){const n=new Map;for(const s of c){const i=l[s.key];let t=n.get(i);t||(t=[],n.set(i,t)),t.push(s)}return n}function f(c){const l=new Map;for(const n of c){const s=n.command[0]==="-"?n.command.substring(1):n.command;let i=l.get(s);i||(i=[],l.set(s,i)),i.push(n)}return l}function p(c,l){const n=[...c.keys()],s=[...l.keys()],i=s.filter(a=>n.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),t=n.filter(a=>s.indexOf(a)===-1).reduce((a,u)=>(a.add(u),a),new Set),o=new Set;for(const a of n){if(t.has(a))continue;const u=c.get(a).map(b=>({...b,key:a})),g=l.get(a).map(b=>({...b,key:a}));(0,k.equals)(u,g,(b,A)=>S(b,A))||o.add(a)}return{added:i,removed:t,updated:o}}function h(c,l,n){const s=[...c.keys()],i=[...l.keys()],t=i.filter(u=>s.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),o=s.filter(u=>i.indexOf(u)===-1).reduce((u,g)=>(u.add(g),u),new Set),a=new Set;for(const u of s){if(o.has(u))continue;const g=c.get(u).map(A=>({...A,key:n[A.key]})),b=l.get(u).map(A=>({...A,key:n[A.key]}));E(g,b)||a.add(u)}return{added:t,removed:o,updated:a}}function E(c,l){return!(!(0,k.equals)(c.filter(({command:n})=>n[0]!=="-"),l.filter(({command:n})=>n[0]!=="-"),(n,s)=>S(n,s))||!(0,k.equals)(c.filter(({command:n})=>n[0]==="-"),l.filter(({command:n})=>n[0]==="-"),(n,s)=>S(n,s)))}function S(c,l){if(c.command!==l.command||c.key!==l.key)return!1;const n=R.ContextKeyExpr.deserialize(c.when),s=R.ContextKeyExpr.deserialize(l.when);return!(n&&!s||!n&&s||n&&s&&!n.equals(s)||!D.equals(c.args,l.args))}function m(c,l,n){for(const s of l)c=r.edit(c,[-1],s,n);return c}function v(c,l,n){const s=P(c);for(let i=s.length-1;i>=0;i--)(s[i].command===l||s[i].command===`-${l}`)&&(c=r.edit(c,[i],void 0,n));return c}function d(c,l,n,s){const i=P(c),t=i.findIndex(o=>o.command===l||o.command===`-${l}`);for(let o=i.length-1;o>=0;o--)(i[o].command===l||i[o].command===`-${l}`)&&(c=r.edit(c,[o],void 0,s));for(let o=n.length-1;o>=0;o--)c=r.edit(c,[t],n[o],s);return c}}),define(te[223],ne([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function k(R,r,P){const y={},C={},I=new Set;if(!r)return{local:{added:y,updated:C,removed:[...I.values()]},remote:{added:R,updated:{},removed:[]},conflicts:[]};const w=T(R,r);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:y,updated:C,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=T(P,R),p=T(P,r),h={},E={},S=new Set,m=new Set;for(const v of f.removed.values())p.updated.has(v)?y[v]=r[v]:S.add(v);for(const v of p.removed.values())m.has(v)||(f.updated.has(v)?m.add(v):I.add(v));for(const v of f.updated.values())m.has(v)||(p.updated.has(v)?w.updated.has(v)&&m.add(v):E[v]=R[v]);for(const v of p.updated.values())m.has(v)||(f.updated.has(v)?w.updated.has(v)&&m.add(v):R[v]!==void 0&&(C[v]=r[v]));for(const v of f.added.values())m.has(v)||(p.added.has(v)?w.updated.has(v)&&m.add(v):h[v]=R[v]);for(const v of p.added.values())m.has(v)||(f.added.has(v)?w.updated.has(v)&&m.add(v):y[v]=r[v]);return{local:{added:y,removed:[...I.values()],updated:C},remote:{added:h,removed:[...S.values()],updated:E},conflicts:[...m.values()]}}e.merge=k;function T(R,r){const P=R?Object.keys(R):[],y=r?Object.keys(r):[],C=y.filter(f=>P.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),I=P.filter(f=>y.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),w=new Set;for(const f of P){if(I.has(f))continue;const p=R[f],h=r[f];p!==h&&w.add(f)}return{added:C,removed:I,updated:w}}function D(R,r){const{added:P,removed:y,updated:C}=T(R,r);return P.size===0&&y.size===0&&C.size===0}e.areSame=D}),define(te[24],ne([0,1,16,18,17,150,39,30,6,89,35]),function(X,e,k,T,D,R,r,P,y,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function w(){const a=I.Registry.as(r.Extensions.Configuration).getConfigurationProperties();return Object.keys(a).filter(u=>!!a[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=w;function f(){const a=I.Registry.as(r.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(a).filter(A=>!!a[A].ignoreSync),g=Object.keys(a).filter(A=>a[A].scope===2||a[A].scope===6),b=w();return(0,k.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...g,...b])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const a="vscode://schemas/ignoredSettings",u=I.Registry.as(r.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,R.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,R.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,R.localize)(2,null),items:[{type:"string",pattern:P.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,R.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,R.localize)(4,null),default:[],scope:1,$ref:a,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const g=I.Registry.as(C.Extensions.JSONContribution),b=()=>{const A=w(),O=f().filter(L=>L!==e.CONFIGURATION_SYNC_STORE_KEY),U=Object.keys(r.allSettings.properties).filter(L=>O.indexOf(L)===-1),x=O.filter(L=>A.indexOf(L)===-1),N={items:{type:"string",enum:[...U,...x.map(L=>`-${L}`)]}};g.registerSchema(a,N)};return u.onDidUpdateConfiguration(()=>b())}e.registerConfiguration=p;function h(a){return a&&(0,D.isObject)(a)&&(0,D.isString)(a.id)&&(0,D.isArray)(a.scopes)}e.isAuthenticationProvider=h;var E;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Extensions="extensions",a.GlobalState="globalState"})(E=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function S(a,u,g){return g.joinPath(u.userDataSyncHome,a,`lastSync${a}.json`)}e.getLastSyncResourceUri=S,e.IUserDataSyncStoreManagementService=(0,y.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,y.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,y.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(a){const u={};return u[e.HEADER_EXECUTION_ID]=a,u}e.createSyncHeaders=m;var v;(function(a){a.Unauthorized="Unauthorized",a.Conflict="Conflict",a.Gone="Gone",a.PreconditionFailed="PreconditionFailed",a.TooLarge="TooLarge",a.UpgradeRequired="UpgradeRequired",a.PreconditionRequired="PreconditionRequired",a.TooManyRequests="RemoteTooManyRequests",a.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",a.RequestFailed="RequestFailed",a.RequestCanceled="RequestCanceled",a.RequestTimeout="RequestTimeout",a.RequestProtocolNotSupported="RequestProtocolNotSupported",a.RequestPathNotEscaped="RequestPathNotEscaped",a.RequestHeadersNotObject="RequestHeadersNotObject",a.NoRef="NoRef",a.EmptyResponse="EmptyResponse",a.TurnedOff="TurnedOff",a.SessionExpired="SessionExpired",a.ServiceChanged="ServiceChanged",a.DefaultServiceChanged="DefaultServiceChanged",a.LocalTooManyRequests="LocalTooManyRequests",a.LocalPreconditionFailed="LocalPreconditionFailed",a.LocalInvalidContent="LocalInvalidContent",a.LocalError="LocalError",a.IncompatibleLocalContent="IncompatibleLocalContent",a.IncompatibleRemoteContent="IncompatibleRemoteContent",a.UnresolvedConflicts="UnresolvedConflicts",a.Unknown="Unknown"})(v=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class d extends Error{constructor(u,g,b,A){super(u);this.code=g,this.resource=b,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=d;class c extends d{constructor(u,g,b,A,O){super(u,b,void 0,O);this.url=g,this.serverCode=A}}e.UserDataSyncStoreError=c;class l extends d{constructor(u,g){super(u,g)}}e.UserDataAutoSyncError=l,function(a){function u(g){if(g instanceof a)return g;const b=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(g.name);if(b&&b[1]){const A=b[2]==="unknown"?void 0:b[2],O=b[3]==="unknown"?void 0:b[3];return new a(g.message,b[1],A,O)}return new a(g.message,"Unknown")}a.toUserDataSyncError=u}(d=e.UserDataSyncError||(e.UserDataSyncError={}));var n;(function(a){a.Uninitialized="uninitialized",a.Idle="idle",a.Syncing="syncing",a.HasConflicts="hasConflicts"})(n=e.SyncStatus||(e.SyncStatus={}));var s;(function(a){a[a.None=0]="None",a[a.Added=1]="Added",a[a.Modified=2]="Modified",a[a.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var i;(function(a){a.Preview="preview",a.Conflict="conflict",a.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(a){return`sync.enable.${a}`}e.getEnablementKey=t,e.IUserDataSyncResourceEnablementService=(0,y.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,y.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,y.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,y.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,y.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,y.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(a,u){if(a.scheme!==e.USER_DATA_SYNC_SCHEME)return a=a.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(g=>(0,T.isEqualOrParent)(a,(0,T.joinPath)(u.userDataSyncHome,g,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(te[47],ne([0,1,16,5,19,28,3,32,2,25,17,8,146,21,11,14,46,23,22,37,24]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function l(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=l;let n=class extends y.Disposable{constructor(a,u,g,b,A,O,U,x,N,L,$){super();this.resource=a,this.fileService=u,this.environmentService=g,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=O,this.userDataSyncResourceEnablementService=U,this.telemetryService=x,this.logService=N,this.configurationService=L,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new r.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new r.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new T.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new r.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=$.extUri,this.syncFolder=this.extUri.joinPath(g.userDataSyncHome,a),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,c.PREVIEW_DIR_NAME),this.lastSyncResource=(0,c.getLastSyncResourceUri)(a,g,this.extUri),this.currentMachineIdPromise=(0,S.getServiceMachineId)(g,u,b)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const a=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(a.remoteUserData,a.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const a=await this.getLastSyncUserData();(a?(await this.doGenerateSyncResourcePreview(a,a,!0,this.getUserDataSyncConfiguration(),R.CancellationToken.None)).resourcePreviews.some(({remoteChange:g})=>g!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(a){if(this._status!==a){const u=this._status;a==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&a==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=a,this._onDidChangStatus.fire(a)}}async sync(a,u={}){await this._sync(a,!0,this.getUserDataSyncConfiguration(),u)}async preview(a,u,g={}){return this._sync(a,!1,u,g)}async apply(a,u={}){try{this.syncHeaders={...u};const g=await this.doApply(a);return this.setStatus(g),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(a,u,g,b){try{if(this.syncHeaders={...b},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const O=await this.getLastSyncUserData(),U=await this.getLatestRemoteUserData(a,O);return A=await this.performSync(U,O,u,g),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(a){const u=await this.resolveContent(a);if(!u)return!1;const g=this.parseSyncData(u);if(!g)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const b=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,b),O=await this.isRemoteDataFromCurrentMachine(A),U=await this.generateSyncPreview({ref:A.ref,syncData:g},b,O,this.getUserDataSyncConfiguration(),R.CancellationToken.None),x=[];for(const N of U){const L=await this.getAcceptResult(N,N.remoteResource,void 0,R.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(N,N.previewResource,N.remoteContent,R.CancellationToken.None);x.push([N,{...L,remoteChange:$!==0?$:2}])}await this.applyResult(A,b,x,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(a){const u=await this.currentMachineIdPromise;return!!a.syncData?.machineId&&a.syncData.machineId===u}async getLatestRemoteUserData(a,u){if(u){const g=a&&a.latest?a.latest[this.resource]:void 0;if(u.ref===g||g===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(a,u,g,b){if(a.syncData&&a.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new c.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,a.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(a,u,g,b)}catch(A){if(A instanceof c.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(a,u,g,b);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),a=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(a,u,g,b)}throw A}}async doSync(a,u,g,b){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,T.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(a,u,g,b,O)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":g?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(a){return await this.updateSyncResourcePreview(a,async u=>{const g=await this.getMergeResult(u,R.CancellationToken.None);await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(g?.content||""));const b=g&&!g.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,R.CancellationToken.None):void 0;return u.acceptResult=b,u.mergeState=g.hasConflicts?"conflict":b?"accepted":"preview",u.localChange=b?b.localChange:g.localChange,u.remoteChange=b?b.remoteChange:g.remoteChange,u}),this.syncPreviewPromise}async accept(a,u){return await this.updateSyncResourcePreview(a,async g=>{const b=await this.getAcceptResult(g,a,u,R.CancellationToken.None);return g.acceptResult=b,g.mergeState="accepted",g.localChange=b.localChange,g.remoteChange=b.remoteChange,g}),this.syncPreviewPromise}async discard(a){return await this.updateSyncResourcePreview(a,async u=>{const g=await this.getMergeResult(u,R.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,D.VSBuffer.fromString(g.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=g.localChange,u.remoteChange=g.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(a,u){if(!this.syncPreviewPromise)return;let g=await this.syncPreviewPromise;const b=g.resourcePreviews.findIndex(({localResource:A,remoteResource:O,previewResource:U})=>this.extUri.isEqual(A,a)||this.extUri.isEqual(O,a)||this.extUri.isEqual(U,a));b!==-1&&(this.syncPreviewPromise=(0,T.createCancelablePromise)(async A=>{const O=[...g.resourcePreviews];return O[b]=await u(O[b]),{...g,resourcePreviews:O}}),g=await this.syncPreviewPromise,this.updateConflicts(g.resourcePreviews),g.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(a){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:g})=>g==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:g})=>g!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(g=>[g,g.acceptResult]),a),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(a){}}updateConflicts(a){const u=a.filter(({mergeState:g})=>g==="conflict");(0,k.equals)(this._conflicts,u,(g,b)=>this.extUri.isEqual(g.previewResource,b.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toRemoteBackupResource(g)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:g})=>({created:u,uri:this.toLocalBackupResource(g)}))}toRemoteBackupResource(a){return w.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${a}`})}toLocalBackupResource(a){return w.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${a}`})}async getMachineId({uri:a}){const u=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);if(g)return this.parseSyncData(g)?.machineId}}async resolveContent(a){const u=this.extUri.basename(a);if(this.extUri.isEqual(a,this.toRemoteBackupResource(u))){const{content:g}=await this.getUserData(u);return g}return this.extUri.isEqual(a,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(a){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const g of u.resourcePreviews){if(this.extUri.isEqual(g.acceptedResource,a))return g.acceptResult?g.acceptResult.content:null;if(this.extUri.isEqual(g.remoteResource,a))return g.remoteContent;if(this.extUri.isEqual(g.localResource,a))return g.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(a){}}async doGenerateSyncResourcePreview(a,u,g,b,A){const O=await this.isRemoteDataFromCurrentMachine(a),U=await this.generateSyncPreview(a,u,O,b,A),x=[];for(const N of U){const L=N.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(N.localChange===0&&N.remoteChange===0)x.push({...N,acceptedResource:L,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const $=g?await this.getMergeResult(N,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(N.previewResource,D.VSBuffer.fromString($?.content||""));const _=$&&!$.hasConflicts?await this.getAcceptResult(N,N.previewResource,void 0,A):void 0;x.push({...N,acceptResult:_,mergeState:$?.hasConflicts?"conflict":_?"accepted":"preview",localChange:_?_.localChange:$?$.localChange:N.localChange,remoteChange:_?_.remoteChange:$?$.remoteChange:N.remoteChange})}}return{remoteUserData:a,lastSyncUserData:u,resourcePreviews:x,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const a=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(a.value.toString()),g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&g&&u.version!==g,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${g}.`),await this.resetLocal(),null;const b=u;if(b.content===null)return{ref:u.ref,syncData:null};const A=JSON.parse(b.content);if(l(A))return{...u,syncData:A,content:void 0}}catch(a){a instanceof E.FileOperationError&&a.fileOperationResult===1||this.logService.error(a)}return null}async updateLastSyncUserData(a,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const g=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),b={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,version:g,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(b)))}async getRemoteUserData(a){const{ref:u,content:g}=await this.getUserData(a);let b=null;return g!==null&&(b=this.parseSyncData(g)),{ref:u,syncData:b}}parseSyncData(a){try{const u=JSON.parse(a);if(l(u))return u}catch(u){this.logService.error(u)}throw new c.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(a){if((0,I.isString)(a)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,a);return{ref:a,content:u}}else{const u=a?{ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(a,u){const g=await this.currentMachineIdPromise,b={version:this.version,machineId:g,content:a};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(b),u,this.syncHeaders),{ref:u,syncData:b}}async backupLocal(a){const u={version:this.version,content:a};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};n=he([J(1,E.IFileService),J(2,h.IEnvironmentService),J(3,m.IStorageService),J(4,c.IUserDataSyncStoreService),J(5,c.IUserDataSyncBackupStoreService),J(6,c.IUserDataSyncResourceEnablementService),J(7,v.ITelemetryService),J(8,c.IUserDataSyncLogService),J(9,p.IConfigurationService),J(10,d.IUriIdentityService)],n),e.AbstractSynchroniser=n;let s=class extends n{constructor(a,u,g,b,A,O,U,x,N,L,$,_){super(u,g,b,A,O,U,x,N,L,$,_);this.file=a,this._register(this.fileService.watch(this.extUri.dirname(a))),this._register(this.fileService.onDidFilesChange(M=>this.onFileChanges(M)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(a){return null}}async updateLocalFileContent(a,u,g){try{u?await this.writeFileContent(a,u,g):await this.fileService.createFile(this.file,D.VSBuffer.fromString(a),{overwrite:g})}catch(b){throw b instanceof E.FileOperationError&&b.fileOperationResult===1||b instanceof E.FileOperationError&&b.fileOperationResult===3?new c.UserDataSyncError(b.message,"LocalPreconditionFailed"):b}}async writeFileContent(a,u,g){await this.fileService.writeFile(this.file,D.VSBuffer.fromString(a),g?void 0:u)}onFileChanges(a){!a.contains(this.file)||this.triggerLocalChange()}};s=he([J(2,E.IFileService),J(3,h.IEnvironmentService),J(4,m.IStorageService),J(5,c.IUserDataSyncStoreService),J(6,c.IUserDataSyncBackupStoreService),J(7,c.IUserDataSyncResourceEnablementService),J(8,v.ITelemetryService),J(9,c.IUserDataSyncLogService),J(10,p.IConfigurationService),J(11,d.IUriIdentityService)],s),e.AbstractFileSynchroniser=s;let i=class extends s{constructor(a,u,g,b,A,O,U,x,N,L,$,_,M){super(a,u,g,b,A,O,U,x,N,L,_,M);this.userDataSyncUtilService=$,this._formattingOptions=void 0}hasErrors(a){const u=[];return(0,P.parse)(a,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=he([J(2,E.IFileService),J(3,h.IEnvironmentService),J(4,m.IStorageService),J(5,c.IUserDataSyncStoreService),J(6,c.IUserDataSyncBackupStoreService),J(7,c.IUserDataSyncResourceEnablementService),J(8,v.ITelemetryService),J(9,c.IUserDataSyncLogService),J(10,c.IUserDataSyncUtilService),J(11,p.IConfigurationService),J(12,d.IUriIdentityService)],i),e.AbstractJsonFileSynchroniser=i;let t=class{constructor(a,u,g,b,A){this.resource=a,this.environmentService=u,this.logService=g,this.fileService=b,this.extUri=A.extUri,this.lastSyncResource=(0,c.getLastSyncResourceUri)(this.resource,u,this.extUri)}async initialize({ref:a,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const g=this.parseSyncData(u);if(!g)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:a,syncData:g})}catch(A){this.logService.error(A)}}parseSyncData(a){try{const u=JSON.parse(a);if(l(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(a,u={}){const g={ref:a.ref,content:a.syncData?JSON.stringify(a.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(g)))}};t=he([J(1,h.IEnvironmentService),J(2,c.IUserDataSyncLogService),J(3,E.IFileService),J(4,d.IUriIdentityService)],t),e.AbstractInitializer=t}),define(te[224],ne([0,1,5,28,7,3,40,48,25,8,21,11,30,36,14,23,22,37,47,221,99,100,24]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v,d,c,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function s(u,g){const b=JSON.parse(u.content);if(u.version===1||u.version===2){const A=(await g.getInstalled(0)).filter(O=>O.isBuiltin);for(const O of b)u.version===1&&(O.enabled===!1&&(O.disabled=!0),delete O.enabled),u.version===2&&A.every(U=>!(0,p.areSameExtensions)(U.identifier,O.identifier))&&(O.installed=!0)}return b}function i(u,g,b){const A=b.get((0,p.getExtensionId)(u,g),0)||"{}";return JSON.parse(A)}e.getExtensionStorageState=i;function t(u,g,b,A){A.store((0,p.getExtensionId)(u,g),JSON.stringify(b),0,1)}e.storeExtensionStorageState=t;let o=class gt extends v.AbstractSynchroniser{constructor(g,b,A,O,U,x,N,L,$,_,M,W,j,q,z){super("extensions",b,g,A,O,U,W,j,$,M,z);this.storageService=A,this.extensionManagementService=x,this.extensionEnablementService=N,this.ignoredExtensionsManagementService=L,this.extensionGalleryService=_,this.extensionsStorageSyncService=q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.debounce(R.Event.any(R.Event.filter(this.extensionManagementService.onDidInstallExtensions,K=>K.some(({local:F})=>!!F)),R.Event.filter(this.extensionManagementService.onDidUninstallExtension,K=>!K.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(g,b){const A=g.syncData?await s(g.syncData,this.extensionManagementService):null,O=b?.skippedExtensions||[],U=b?.syncData?await s(b.syncData,this.extensionManagementService):null,x=await this.extensionManagementService.getInstalled(void 0,!0),N=this.getLocalExtensions(x),L=this.ignoredExtensionsManagementService.getIgnoredExtensions(x);A?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:_}=(0,d.merge)(N,A,U,O,L),M={local:$,remote:_,content:this.getPreviewContent(N,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:_!==null?2:0};return[{skippedExtensions:O,localResource:this.localResource,localContent:this.format(N),localExtensions:N,remoteResource:this.remoteResource,remoteContent:A?this.format(A):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(g,b,A,O){const U=[...b,...A],x=new Set,N=L=>{x.add(L.id.toLowerCase()),L.uuid&&x.add(L.uuid)};U.forEach(({identifier:L})=>N(L)),O.forEach(N);for(const L of g)x.has(L.identifier.id.toLowerCase())||L.identifier.uuid&&x.has(L.identifier.uuid)||U.push(L);return this.format(U)}async getMergeResult(g,b){return{...g.previewResult,hasConflicts:!1}}async getAcceptResult(g,b,A,O){if(this.extUri.isEqual(b,this.localResource))return this.acceptLocal(g);if(this.extUri.isEqual(b,this.remoteResource))return this.acceptRemote(g);if(this.extUri.isEqual(b,this.previewResource))return g.previewResult;throw new Error(`Invalid Resource: ${b.toString()}`)}async acceptLocal(g){const b=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(b),O=(0,d.merge)(g.localExtensions,null,null,g.skippedExtensions,A),{local:U,remote:x}=O;return{content:g.localContent,local:U,remote:x,localChange:U.added.length>0||U.removed.length>0||U.updated.length>0?2:0,remoteChange:x!==null?2:0}}async acceptRemote(g){const b=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(b),O=g.remoteContent?JSON.parse(g.remoteContent):null;if(O!==null){const U=(0,d.merge)(g.localExtensions,O,g.localExtensions,[],A),{local:x,remote:N}=U;return{content:g.remoteContent,local:x,remote:N,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:g.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(g,b,A,O){let{skippedExtensions:U,localExtensions:x}=A[0][0],{local:N,remote:L,localChange:$,remoteChange:_}=A[0][1];if($===0&&_===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(x)),U=await this.updateLocalExtensions(N.added,N.removed,N.updated,U)),L){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(L.all);g=await this.updateRemoteUserData(M,O?null:g.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${L.added.length?` Added: ${JSON.stringify(L.added.map(W=>W.identifier.id))}.`:""}${L.updated.length?` Updated: ${JSON.stringify(L.updated.map(W=>W.identifier.id))}.`:""}${L.removed.length?` Removed: ${JSON.stringify(L.removed.map(W=>W.identifier.id))}.`:""}`)}b?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(g,{skippedExtensions:U}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${U.length?` Skipped: ${JSON.stringify(U.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:g}){return[{resource:this.extUri.joinPath(g,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(g){if(this.extUri.isEqual(g,gt.EXTENSIONS_DATA_URI)){const A=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(A),U=this.getLocalExtensions(A).filter(x=>!O.some(N=>(0,p.areSameExtensions)({id:N},x.identifier)));return this.format(U)}if(this.extUri.isEqual(this.remoteResource,g)||this.extUri.isEqual(this.localResource,g)||this.extUri.isEqual(this.acceptedResource,g))return this.resolvePreviewContent(g);let b=await super.resolveContent(g);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(g)),b){const A=this.parseSyncData(b);if(A)switch(this.extUri.basename(g)){case"extensions.json":return this.format(this.parseExtensions(A))}}return null}format(g){g.sort((O,U)=>!O.identifier.uuid&&U.identifier.uuid?-1:O.identifier.uuid&&!U.identifier.uuid?1:(0,y.compare)(O.identifier.id,U.identifier.id));const b=JSON.stringify(g),A=(0,P.format)(b,void 0,{});return(0,r.applyEdits)(b,A)}async hasLocalData(){try{const g=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(g).some(A=>A.installed||A.disabled))return!0}catch(g){}return!1}async updateLocalExtensions(g,b,A,O){const U=[],x=[],N=await this.extensionManagementService.getInstalled();if(b.length){const $=N.filter(({identifier:_,isBuiltin:M})=>!M&&b.some(W=>(0,p.areSameExtensions)(_,W)));await k.Promises.settled($.map(async _=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,_.identifier.id),await this.extensionManagementService.uninstall(_,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,_.identifier.id),U.push(_.identifier)}))}(g.length||A.length)&&await k.Promises.settled([...g,...A].map(async $=>{const _=N.find(W=>(0,p.areSameExtensions)(W.identifier,$.identifier));if(_&&_.isBuiltin){$.state&&_.manifest.version===$.version&&this.updateExtensionState($.state,_.manifest.publisher,_.manifest.name,_.manifest.version),$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id)),U.push($.identifier);return}const M=(await this.extensionGalleryService.getExtensions([$.identifier],T.CancellationToken.None))[0];if($.state&&(_?_.manifest.version===$.version:!!M)){const W=_?_.manifest.publisher:M.publisher,j=_?_.manifest.name:M.name;this.updateExtensionState($.state,W,j,_?.manifest.version)}if(M)try{$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,M.version)),_||(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,M.version),U.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),x.push($)))}catch(W){x.push($),W instanceof f.ExtensionManagementError&&W.code===f.ExtensionManagementErrorCode.Incompatible?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(W),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else x.push($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,$.identifier.id)}));const L=[];for(const $ of O)U.some(_=>(0,p.areSameExtensions)(_,$.identifier))||L.push($);for(const $ of x)L.some(_=>(0,p.areSameExtensions)(_.identifier,$.identifier))||L.push($);return L}updateExtensionState(g,b,A,O){const U=i(b,A,this.storageService),x=O?this.extensionsStorageSyncService.getKeysForSync({id:(0,p.getGalleryExtensionId)(b,A),version:O}):void 0;x?x.forEach(N=>{U[N]=g[N]}):Object.keys(g).forEach(N=>U[N]=g[N]),t(b,A,U,this.storageService)}parseExtensions(g){return JSON.parse(g.content)}getLocalExtensions(g){const b=this.extensionEnablementService.getDisabledExtensions();return g.map(({identifier:A,isBuiltin:O,manifest:U})=>{const x={identifier:A,version:U.version};b.some(N=>(0,p.areSameExtensions)(N,A))&&(x.disabled=!0),O||(x.installed=!0);try{const N=this.extensionsStorageSyncService.getKeysForSync({id:A.id,version:U.version});if(N){const L=i(U.publisher,U.name,this.storageService);x.state=Object.keys(L).reduce(($,_)=>(N.includes(_)&&($[_]=L[_]),$),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(N))}return x})}};o.EXTENSIONS_DATA_URI=C.URI.from({scheme:n.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),o=he([J(0,w.IEnvironmentService),J(1,h.IFileService),J(2,E.IStorageService),J(3,n.IUserDataSyncStoreService),J(4,n.IUserDataSyncBackupStoreService),J(5,f.IExtensionManagementService),J(6,f.IGlobalExtensionEnablementService),J(7,l.IIgnoredExtensionsManagementService),J(8,n.IUserDataSyncLogService),J(9,f.IExtensionGalleryService),J(10,I.IConfigurationService),J(11,n.IUserDataSyncResourceEnablementService),J(12,S.ITelemetryService),J(13,c.IExtensionsStorageSyncService),J(14,m.IUriIdentityService)],o),e.ExtensionsSynchroniser=o;let a=class extends v.AbstractInitializer{constructor(g,b,A,O,U,x){super("extensions",O,U,A,x);this.extensionManagementService=g,this.ignoredExtensionsManagementService=b}async parseExtensions(g){return g.syncData?await s(g.syncData,this.extensionManagementService):null}generatePreview(g,b){const A=[],O=[],U=[];for(const x of g){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(x.identifier.id))continue;const N=b.find(L=>(0,p.areSameExtensions)(L.identifier,x.identifier));N?(A.push(N),x.disabled&&U.push(x.identifier)):x.installed&&(O.push(x.identifier),x.disabled&&U.push(x.identifier))}return{installedExtensions:A,newExtensions:O,disabledExtensions:U,remoteExtensions:g}}};a=he([J(0,f.IExtensionManagementService),J(1,l.IIgnoredExtensionsManagementService),J(2,h.IFileService),J(3,w.IEnvironmentService),J(4,n.IUserDataSyncLogService),J(5,m.IUriIdentityService)],a),e.AbstractExtensionsInitializer=a}),define(te[225],ne([0,1,26,24]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(P,y,C,I,w){if(!y)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const f=R(P,y);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=C?R(C,y):{added:Object.keys(y).reduce((v,d)=>(v.add(d),v),new Set),removed:new Set,updated:new Set},h=C?R(C,P):{added:Object.keys(P).reduce((v,d)=>(v.add(d),v),new Set),removed:new Set,updated:new Set},E={added:{},removed:[],updated:{}},S=k.deepClone(y),m=!C;for(const v of h.added.values())v!==T.SYNC_SERVICE_URL_TYPE&&m&&p.added.has(v)||(S[v]=P[v]);for(const v of h.updated.values())S[v]=P[v];for(const v of h.removed.values())I.unregistered.includes(v)||delete S[v];for(const v of p.added.values()){const d=y[v];if(I.machine.includes(v)){w.info(`GlobalState: Skipped adding ${v} in local storage because it is declared as machine scoped.`);continue}if(C&&h.added.has(v))continue;const c=P[v];c&&c.value===d.value||v===T.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(v)||(c?E.updated[v]=d:E.added[v]=d)}for(const v of p.updated.values()){const d=y[v];if(I.machine.includes(v)){w.info(`GlobalState: Skipped updating ${v} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(v)||h.removed.has(v))continue;const c=P[v];c&&c.value===d.value||(E.updated[v]=d)}for(const v of p.removed.values()){if(I.machine.includes(v)){w.trace(`GlobalState: Skipped removing ${v} in local storage because it is declared as machine scoped.`);continue}h.updated.has(v)||h.removed.has(v)||E.removed.push(v)}return{local:E,remote:r(S,y)?null:S}}e.merge=D;function R(P,y){const C=Object.keys(P),I=Object.keys(y),w=I.filter(h=>C.indexOf(h)===-1).reduce((h,E)=>(h.add(E),h),new Set),f=C.filter(h=>I.indexOf(h)===-1).reduce((h,E)=>(h.add(E),h),new Set),p=new Set;for(const h of C){if(f.has(h))continue;const E=P[h],S=y[h];k.equals(E,S)||p.add(h)}return{added:w,removed:f,updated:p}}function r(P,y){const{added:C,removed:I,updated:w}=R(P,y);return C.size===0&&I.size===0&&w.size===0}}),define(te[226],ne([0,1,19,7,3,32,40,48,4,8,29,21,11,14,10,46,23,22,37,47,55,225,24]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v,d,c,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",i=["locale"];function t(b){const A=b.storage?Object.keys(b.storage).sort():[],O={};A.forEach(N=>O[N]=b.storage[N]),b.storage=O;const U=JSON.stringify(b),x=(0,P.format)(U,void 0,{});return(0,r.applyEdits)(U,x)}const o=1;let a=class mt extends d.AbstractSynchroniser{constructor(A,O,U,x,N,L,$,_,M,W){super("globalState",A,N,M,O,U,L,$,x,_,W);this.storageService=M,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:n.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(A.onDidFilesChange,j=>j.contains(this.environmentService.argvResource)),D.Event.filter(M.onDidChangeValue,j=>j.scope===0&&j.target!==void 0?j.target===0:M.keys(0,0).includes(j.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(A,O,U){const x=A.syncData?JSON.parse(A.syncData.content):null;O=O===null&&U?A:O;const N=O&&O.syncData?JSON.parse(O.syncData.content):null,L=await this.getLocalGlobalState();x?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=this.getStorageKeys(N),{local:_,remote:M}=(0,l.merge)(L.storage,x?x.storage:null,N?N.storage:null,$,this.logService),W={content:null,local:_,remote:M,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:t(L),localUserData:L,remoteResource:this.remoteResource,remoteContent:x?t(x):null,previewResource:this.previewResource,previewResult:W,localChange:W.localChange,remoteChange:W.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async getMergeResult(A,O){return{...A.previewResult,hasConflicts:!1}}async getAcceptResult(A,O,U,x){if(this.extUri.isEqual(O,this.localResource))return this.acceptLocal(A);if(this.extUri.isEqual(O,this.remoteResource))return this.acceptRemote(A);if(this.extUri.isEqual(O,this.previewResource))return A.previewResult;throw new Error(`Invalid Resource: ${O.toString()}`)}async acceptLocal(A){return{content:A.localContent,local:{added:{},removed:[],updated:{}},remote:A.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(A){if(A.remoteContent!==null){const O=JSON.parse(A.remoteContent),{local:U,remote:x}=(0,l.merge)(A.localUserData.storage,O.storage,null,A.storageKeys,this.logService);return{content:A.remoteContent,local:U,remote:x,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?2:0,remoteChange:x!==null?2:0}}else return{content:A.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(A,O,U,x){let{localUserData:N}=U[0][0],{local:L,remote:$,localChange:_,remoteChange:M}=U[0][1];if(_===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),_!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState(L),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),M!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const W=JSON.stringify({storage:$});A=await this.updateRemoteUserData(W,x?null:A.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}O?.ref!==A.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(A),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:A}){return[{resource:this.extUri.joinPath(A,"globalState.json"),comparableResource:mt.GLOBAL_STATE_DATA_URI}]}async resolveContent(A){if(this.extUri.isEqual(A,mt.GLOBAL_STATE_DATA_URI)){const U=await this.getLocalGlobalState();return t(U)}if(this.extUri.isEqual(this.remoteResource,A)||this.extUri.isEqual(this.localResource,A)||this.extUri.isEqual(this.acceptedResource,A))return this.resolvePreviewContent(A);let O=await super.resolveContent(A);if(O)return O;if(O=await super.resolveContent(this.extUri.dirname(A)),O){const U=this.parseSyncData(O);if(U)switch(this.extUri.basename(A)){case"globalState.json":return t(JSON.parse(U.content))}}return null}async hasLocalData(){try{const{storage:A}=await this.getLocalGlobalState();if(Object.keys(A).length>1||A[`${s}.locale`]?.value!=="en")return!0}catch(A){}return!1}async getLocalGlobalState(){const A={},O=await this.getLocalArgvContent(),U=(0,R.parse)(O);for(const x of i)U[x]!==void 0&&(A[`${s}${x}`]={version:1,value:U[x]});for(const x of this.storageService.keys(0,0)){const N=this.storageService.get(x,0);N&&(A[x]={version:1,value:N})}return{storage:A}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const A=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),A.value.toString()}catch(A){this.logService.debug((0,T.getErrorMessage)(A))}return"{}"}async writeLocalGlobalState({added:A,removed:O,updated:U}){const x={},N={},L=(_,M)=>{for(const W of _){if(W.startsWith(s)){x[W.substring(s.length)]=M?M[W].value:void 0;continue}if(M){const j=M[W];j.value!==String(this.storageService.get(W,0))&&(N[W]=j.value)}else this.storageService.get(W,0)!==void 0&&(N[W]=void 0)}};if(L(Object.keys(A),A),L(Object.keys(U),U),L(O),Object.keys(x).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(x),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const _ of Object.keys(N))this.storageService.store(_,N[_],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(A){const O=await this.getLocalArgvContent();let U=O;for(const x of Object.keys(A))U=(0,c.edit)(U,[x],A[x],{});O!==U&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(U)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(A){const O=this.storageService.keys(0,0),U=this.storageService.keys(0,1),x=[...O,...U],N=A?.storage?Object.keys(A.storage).filter(L=>!L.startsWith(s)&&!x.includes(L)&&this.storageService.get(L,0)!==void 0):[];if(!y.isWeb){const L=[...n.ALL_SYNC_RESOURCES.map($=>(0,n.getEnablementKey)($)),n.SYNC_SERVICE_URL_TYPE];N.push(...L),U.push(...L)}return{user:O,machine:U,unregistered:N}}};a.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:n.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),a=he([J(0,p.IFileService),J(1,n.IUserDataSyncStoreService),J(2,n.IUserDataSyncBackupStoreService),J(3,n.IUserDataSyncLogService),J(4,f.IEnvironmentService),J(5,n.IUserDataSyncResourceEnablementService),J(6,m.ITelemetryService),J(7,w.IConfigurationService),J(8,S.IStorageService),J(9,v.IUriIdentityService)],a),e.GlobalStateSynchroniser=a;let u=class extends d.AbstractInitializer{constructor(A,O,U,x,N){super("globalState",U,x,O,N);this.storageService=A}async doInitialize(A){const O=A.syncData?JSON.parse(A.syncData.content):null;if(!O){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const U={},x={};for(const N of Object.keys(O.storage))N.startsWith(s)?U[N.substring(s.length)]=O.storage[N].value:this.storageService.get(N,0)===void 0&&(x[N]=O.storage[N].value);if(Object.keys(U).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(L){}for(const L of Object.keys(U))N=(0,c.edit)(N,[L],U[L],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(N))}if(Object.keys(x).length)for(const N of Object.keys(x))this.storageService.store(N,x[N],0,0)}};u=he([J(0,S.IStorageService),J(1,p.IFileService),J(2,f.IEnvironmentService),J(3,n.IUserDataSyncLogService),J(4,v.IUriIdentityService)],u),e.GlobalStateInitializer=u;let g=class{constructor(A,O,U,x,N){this.userDataSyncStoreClient=A,this.storageService=O,this.environmentService=U,this.fileService=x,this.logService=N}getSyncStoreType(A){return this.parseGlobalState(A)?.storage[n.SYNC_SERVICE_URL_TYPE]?.value}async sync(A){const O=(0,n.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(A,O)}catch(U){if(U instanceof n.UserDataSyncError)switch(U.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(A,O)}throw U}}async doSync(A,O){const U=await this.userDataSyncStoreClient.read("globalState",null,O),x=this.parseGlobalState(U)||{storage:{}};x.storage[n.SYNC_SERVICE_URL_TYPE]={value:A,version:o};const N=await(0,E.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),L={version:o,machineId:N,content:t(x)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(L),U.ref,O)}parseGlobalState({content:A}){if(!A)return null;const O=JSON.parse(A);if((0,d.isSyncData)(O))return O?JSON.parse(O.content):null;throw new Error("Invalid remote data")}};g=he([J(1,S.IStorageService),J(2,f.IEnvironmentService),J(3,p.IFileService),J(4,h.ILogService)],g),e.UserDataSyncStoreTypeSynchronizer=g}),define(te[227],ne([0,1,16,19,3,32,4,17,147,21,11,14,23,22,37,47,222,24]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function v(l,n,s){try{const i=JSON.parse(l);if(!n)return(0,P.isUndefined)(i.all)?null:i.all;switch(r.OS){case 2:return(0,P.isUndefined)(i.mac)?null:i.mac;case 3:return(0,P.isUndefined)(i.linux)?null:i.linux;case 1:return(0,P.isUndefined)(i.windows)?null:i.windows}}catch(i){return s.error(i),null}}e.getKeybindingsContentFromSyncContent=v;let d=class extends E.AbstractJsonFileSynchroniser{constructor(n,s,i,t,o,a,u,g,b,A,O){super(u.keybindingsResource,"keybindings",a,u,g,n,s,o,A,i,b,t,O);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(t.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(n,s,i,t){const o=n.syncData?v(n.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;s=s===null&&i?n:s;const a=s?this.getKeybindingsContentFromLastSyncUserData(s):null,u=await this.getLocalFileContent(),g=await this.getFormattingOptions();let b=null,A=!1,O=!1,U=!1;if(o){let N=u?u.value.toString():"[]";if(N=N||"[]",this.hasErrors(N))throw new m.UserDataSyncError((0,y.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==N||a!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const L=await(0,S.merge)(N,o,a,g,this.userDataSyncUtilService);L.hasChanges&&(b=L.mergeContent,U=L.hasConflicts,A=U||L.mergeContent!==N,O=U||L.mergeContent!==o)}}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),b=u.value.toString(),O=!0);const x={content:b,localChange:A?u?2:1:0,remoteChange:O?2:0,hasConflicts:U};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:x.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:x.remoteChange,previewResource:this.previewResource,previewResult:x,acceptedResource:this.acceptedResource}]}async getMergeResult(n,s){return n.previewResult}async getAcceptResult(n,s,i,t){if(this.extUri.isEqual(s,this.localResource))return{content:n.fileContent?n.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(s,this.remoteResource))return{content:n.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(s,this.previewResource))return i===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async applyResult(n,s,i,t){const{fileContent:o}=i[0][0];let{content:a,localChange:u,remoteChange:g}=i[0][1];if(u===0&&g===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a)))throw new m.UserDataSyncError((0,y.localize)(1,null),"LocalInvalidContent",this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(a||"[]",o,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),g!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const b=this.toSyncContent(a||"[]",n.syncData?.content);n=await this.updateRemoteUserData(b,t?null:n.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(b){}s?.ref!==n.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(n,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const n=await this.getLocalFileContent();if(n){const s=(0,R.parse)(n.value.toString());if((0,k.isNonEmptyArray)(s))return!0}}catch(n){if(n.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:n}){const s=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(n,"keybindings.json"),comparableResource:s}]}async resolveContent(n){if(this.extUri.isEqual(this.remoteResource,n)||this.extUri.isEqual(this.localResource,n)||this.extUri.isEqual(this.acceptedResource,n))return this.resolvePreviewContent(n);let s=await super.resolveContent(n);if(s)return s;if(s=await super.resolveContent(this.extUri.dirname(n)),s){const i=this.parseSyncData(s);if(i)switch(this.extUri.basename(n)){case"keybindings.json":return v(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(n){return!n.syncData||n.platformSpecific!==void 0&&n.platformSpecific!==this.syncKeybindingsPerPlatform()?null:v(n.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(n,s){let i={};try{i=JSON.parse(s||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=n,r.OS){case 2:i.mac=n;break;case 3:i.linux=n;break;case 1:i.windows=n;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};d=he([J(0,m.IUserDataSyncStoreService),J(1,m.IUserDataSyncBackupStoreService),J(2,m.IUserDataSyncLogService),J(3,C.IConfigurationService),J(4,m.IUserDataSyncResourceEnablementService),J(5,w.IFileService),J(6,I.IEnvironmentService),J(7,f.IStorageService),J(8,m.IUserDataSyncUtilService),J(9,p.ITelemetryService),J(10,h.IUriIdentityService)],d),e.KeybindingsSynchroniser=d;let c=class extends E.AbstractInitializer{constructor(n,s,i,t){super("keybindings",s,i,n,t)}async doInitialize(n){const s=n.syncData?this.getKeybindingsContentFromSyncContent(n.syncData.content):null;if(!s){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,T.VSBuffer.fromString(s)),await this.updateLastSyncUserData(n)}async isEmpty(){try{const n=await this.fileService.readFile(this.environmentService.settingsResource),s=(0,R.parse)(n.value.toString());return!(0,k.isNonEmptyArray)(s)}catch(n){return n.fileOperationResult===1}}getKeybindingsContentFromSyncContent(n){try{return v(n,!0,this.logService)}catch(s){return this.logService.error(s),null}}};c=he([J(0,w.IFileService),J(1,I.IEnvironmentService),J(2,m.IUserDataSyncLogService),J(3,h.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(te[228],ne([0,1,16,32,40,48,26,55,24]),function(X,e,k,T,D,R,r,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function C(a,u,g){let b=[];g?b=w(g):b=I(u);const A=[],O=[...(0,y.getDisallowedIgnoredSettings)()];if(Array.isArray(b))for(const U of b)U.startsWith("-")?O.push(U.substring(1)):A.push(U);return(0,k.distinct)([...a,...A].filter(U=>O.indexOf(U)===-1))}e.getIgnoredSettings=C;function I(a){let u=a.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=a.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:a.getValue("settingsSync.ignoredSettings")||[]}function w(a){const u=(0,T.parse)(a);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function f(a,u,g,b){if(g.length){const A=o(u),O=(0,T.parse)(u),U=(0,T.parse)(a),x=[];for(const N of g){const L=O[N],$=U[N];L===void 0?a=P.edit(a,[N],void 0,b):$!==void 0?a=P.edit(a,[N],L,b):x.push(l(N,A))}x.sort((N,L)=>N.startOffset-L.startOffset),x.forEach(N=>a=m(N.setting.key,u,a,b))}return a}e.updateIgnoredSettings=f;function p(a,u,g,b,A,O){const U=f(a,u,b,O),x=g!==U,N=g!==u;if(!x&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(x&&!N)return{conflictsSettings:[],localContent:null,remoteContent:U,hasConflicts:!1};if(N&&!x)return{conflictsSettings:[],localContent:f(u,a,b,O),remoteContent:null,hasConflicts:!1};if(g===null&&E(a)){const H=h(a,u,b)?null:f(u,a,b,O);return{conflictsSettings:[],localContent:H,remoteContent:null,hasConflicts:!1}}let L=a,$=u;const _=(0,T.parse)(a),M=(0,T.parse)(u),W=g?(0,T.parse)(g):null,j=b.reduce((H,re)=>(H.add(re),H),new Set),q=S(_,M,j),z=S(W,_,j),K=S(W,M,j),F=new Map,B=new Set,V=H=>{B.add(H);const re=A.filter(({key:ie})=>ie===H)[0];re?(L=P.edit(L,[H],re.value,O),$=P.edit($,[H],re.value,O)):F.set(H,{key:H,localValue:_[H],remoteValue:M[H]})};for(const H of z.removed.values())K.updated.has(H)?V(H):$=P.edit($,[H],void 0,O);for(const H of K.removed.values())B.has(H)||(z.updated.has(H)?V(H):L=P.edit(L,[H],void 0,O));for(const H of z.updated.values())B.has(H)||(K.updated.has(H)?q.updated.has(H)&&V(H):$=P.edit($,[H],_[H],O));for(const H of K.updated.values())B.has(H)||(z.updated.has(H)?q.updated.has(H)&&V(H):L=P.edit(L,[H],M[H],O));for(const H of z.added.values())B.has(H)||(K.added.has(H)?q.updated.has(H)&&V(H):$=m(H,L,$,O));for(const H of K.added.values())B.has(H)||(z.added.has(H)?q.updated.has(H)&&V(H):L=m(H,$,L,O));const Q=F.size>0||!h(L,$,b),Z=Q||!h(L,a,[]),G=Q||!h($,u,[]);return{localContent:Z?L:null,remoteContent:G?$:null,conflictsSettings:[...F.values()],hasConflicts:Q}}e.merge=p;function h(a,u,g){if(a===u)return!0;const b=(0,T.parse)(a),A=(0,T.parse)(u),O=g.reduce((N,L)=>(N.add(L),N),new Set),U=o(a).filter(N=>!(N.setting&&O.has(N.setting.key))),x=o(u).filter(N=>!(N.setting&&O.has(N.setting.key)));if(U.length!==x.length)return!1;for(let N=0;N<U.length;N++){const L=U[N],$=x[N];if(L.setting&&$.setting){if(L.setting.key!==$.setting.key||!r.equals(b[L.setting.key],A[L.setting.key]))return!1}else if(!L.setting&&!$.setting){if(L.value!==$.value)return!1}else return!1}return!0}e.areSame=h;function E(a){return a?o(a).length===0:!0}e.isEmpty=E;function S(a,u,g){const b=a?Object.keys(a).filter(N=>!g.has(N)):[],A=Object.keys(u).filter(N=>!g.has(N)),O=A.filter(N=>b.indexOf(N)===-1).reduce((N,L)=>(N.add(L),N),new Set),U=b.filter(N=>A.indexOf(N)===-1).reduce((N,L)=>(N.add(L),N),new Set),x=new Set;if(a)for(const N of b){if(U.has(N))continue;const L=a[N],$=u[N];r.equals(L,$)||x.add(N)}return{added:O,removed:U,updated:x}}function m(a,u,g,b){const A=(0,T.parse)(u),O=o(u),U=o(g),x=v(a,O,U);return d(g,a,A[a],x,U,b)}e.addSetting=m;function v(a,u,g){const b=u.findIndex(O=>O.setting?.key===a),A=u[b-1];if(A){if(A.setting){const U=l(A.setting.key,g);if(U)return{index:g.indexOf(U),insertAfter:!0}}else{const U=n(b,u);if(U){const x=l(U.setting.key,g);if(x){const N=s(g.indexOf(x),g),L=i(u,U,u[b]);if(N){const $=i(g,x,N),_=t(L,$);return _?{index:g.indexOf(_),insertAfter:!0}:{index:g.indexOf(N),insertAfter:!1}}else{const $=i(g,x,g[g.length-1]),_=t(L,$);return _?{index:g.indexOf(_),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const O=u[b+1];if(O)if(O.setting){const U=l(O.setting.key,g);if(U)return{index:g.indexOf(U),insertAfter:!1}}else{const U=s(b,u);if(U){const x=l(U.setting.key,g);if(x){const N=n(g.indexOf(x),g),L=i(u,u[b],U);if(N){const $=i(g,N,x),_=t(L.reverse(),$.reverse());return _?{index:g.indexOf(_),insertAfter:!1}:{index:g.indexOf(N),insertAfter:!0}}else{const $=i(g,g[0],x),_=t(L.reverse(),$.reverse());return _?{index:g.indexOf(_),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function d(a,u,g,b,A,O){let U;return b.index===-1?U=(0,D.setProperty)(a,[u],g,O):U=c(a,u,g,b,A,O).map(x=>(0,D.withFormatting)(a,x,O)[0]),(0,D.applyEdits)(a,U)}function c(a,u,g,b,A,O){const U=`${JSON.stringify(u)}: ${JSON.stringify(g)}`,x=(0,R.getEOL)(O,a),N=A[b.index];if(b.insertAfter){const L=[];if(N.setting)L.push({offset:N.endOffset,length:0,content:","+U});else{const $=s(b.index,A),_=n(b.index,A),M=_?.setting?.commaOffset;_&&M===void 0&&L.push({offset:_.endOffset,length:0,content:","});const W=M!==void 0&&M>N.endOffset;L.push({offset:W?M+1:N.endOffset,length:0,content:$?x+U+",":x+U})}return L}else{if(N.setting)return[{offset:N.startOffset,length:0,content:U+","}];const L=(A[b.index-1]&&!A[b.index-1].setting?x:"")+U+(s(b.index,A)?",":"")+x;return[{offset:N.startOffset,length:0,content:L}]}}function l(a,u){return u.filter(g=>g.setting?.key===a)[0]}function n(a,u){for(let g=a-1;g>=0;g--)if(u[g].setting)return u[g]}function s(a,u){for(let g=a+1;g<u.length;g++)if(u[g].setting)return u[g]}function i(a,u,g){const b=a.indexOf(u),A=a.indexOf(g);return a.filter((O,U)=>b<U&&U<A)}function t(a,u){if(a.length&&u.length){let g=0;for(;g<u.length&&g<a.length;g++)if(a[g].value!==u[g].value)return u[g-1];return u[g-1]}}function o(a){const u=[];let g=-1,b,A;const O={onObjectBegin:U=>{g++},onObjectProperty:(U,x,N)=>{g===0&&(b=x,A=U)},onObjectEnd:(U,x)=>{g--,g===0&&u.push({startOffset:b,endOffset:U+x,value:a.substring(b,U+x),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(U,x)=>{g++},onArrayEnd:(U,x)=>{g--,g===0&&u.push({startOffset:b,endOffset:U+x,value:a.substring(b,U+x),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(U,x,N)=>{g===0&&u.push({startOffset:b,endOffset:x+N,value:a.substring(b,x+N),setting:{key:A,commaOffset:void 0}})},onSeparator:(U,x,N)=>{if(g===0&&U===","){let L=u.length-1;for(;L>=0&&!u[L].setting;L--);const $=u[L];$&&u.splice(L,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:x}})}},onComment:(U,x)=>{g===0&&u.push({startOffset:U,endOffset:U+x,value:a.substring(U,U+x)})}};return(0,T.visit)(a,O),u}}),define(te[229],ne([0,1,19,3,40,148,21,90,86,11,30,14,23,22,37,47,55,228,24]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function d(i){return i&&i.settings&&typeof i.settings=="string"&&Object.keys(i).length===1}function c(i){const t=JSON.parse(i);return d(t)?t:{settings:i}}e.parseSettingsSyncContent=c;let l=class extends E.AbstractJsonFileSynchroniser{constructor(t,o,a,u,g,b,A,O,U,x,N,L,$){super(o.settingsResource,"settings",t,o,a,u,g,U,x,b,A,O,$);this.extensionManagementService=N,this.userConfigurationFileService=L,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(t){const o=await this.getLastSyncUserData(),a=await this.getLatestRemoteUserData(t,o),u=this.getSettingsSyncContent(a),g=new P.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return u?.settings&&g.parse(u.settings),g.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(t,o,a){const u=await this.getLocalFileContent(),g=await this.getFormattingOptions(),b=this.getSettingsSyncContent(t);o=o===null&&a?t:o;const A=o?this.getSettingsSyncContent(o):null,O=await this.getIgnoredSettings();let U=null,x=!1,N=!1,L=!1;if(b){let _=u?u.value.toString().trim():"{}";_=_||"{}",this.validateContent(_),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const M=(0,m.merge)(_,b.settings,A?A.settings:null,O,[],g);U=M.localContent||M.remoteContent,x=M.localContent!==null,N=M.remoteContent!==null,L=M.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),U=u.value.toString(),N=!0);const $={content:U,localChange:x?2:0,remoteChange:N?2:0,hasConflicts:L};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:b?b.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async getMergeResult(t,o){const a=await this.getFormattingOptions(),u=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?(0,m.updateIgnoredSettings)(t.previewResult.content,"{}",u,a):null}}async getAcceptResult(t,o,a,u){const g=await this.getFormattingOptions(),b=await this.getIgnoredSettings();if(this.extUri.isEqual(o,this.localResource))return{content:t.fileContent?(0,m.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",b,g):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(o,this.remoteResource))return{content:t.remoteContent!==null?(0,m.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",b,g):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(o,this.previewResource))return a===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:a!==null?(0,m.updateIgnoredSettings)(a,t.fileContent?t.fileContent.value.toString():"{}",b,g):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async applyResult(t,o,a,u){const{fileContent:g}=a[0][0];let{content:b,localChange:A,remoteChange:O}=a[0][1];if(A===0&&O===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),b=b?b.trim():"{}",b=b||"{}",this.validateContent(b),A!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),g&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(g.value.toString()))),await this.updateLocalFileContent(b,g,u),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),O!==0){const U=await this.getFormattingOptions(),x=this.getSettingsSyncContent(t),N=await this.getIgnoredSettings(b);b=(0,m.updateIgnoredSettings)(b,x?x.settings:"{}",N,U),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(b)),u?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(U){}o?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const o=await this.getFormattingOptions(),a=(0,S.edit)(t.value.toString(),[v.CONFIGURATION_SYNC_STORE_KEY],void 0,o);return!(0,m.isEmpty)(a)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const o=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:o}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let o=await super.resolveContent(t);if(o)return o;if(o=await super.resolveContent(this.extUri.dirname(t)),o){const a=this.parseSyncData(o);if(a){const u=this.parseSettingsSyncContent(a.content);if(u)switch(this.extUri.basename(t)){case"settings.json":return u.settings}}}return null}async resolvePreviewContent(t){let o=await super.resolvePreviewContent(t);if(o){const a=await this.getFormattingOptions(),u=await this.getIgnoredSettings();o=(0,m.updateIgnoredSettings)(o,"{}",u,a)}return o}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return c(t)}catch(o){this.logService.error(o)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const a=T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,u=>u.some(({local:g})=>!!g)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,u=>!u.error))(()=>{a.dispose(),this._defaultIgnoredSettings=void 0})}const o=await this._defaultIgnoredSettings;return(0,m.getIgnoredSettings)(o,this.configurationService,t)}async writeFileContent(t,o,a){await this.userConfigurationFileService.write(k.VSBuffer.fromString(t),a?void 0:{etag:o.etag,mtime:o.mtime})}validateContent(t){if(this.hasErrors(t))throw new v.UserDataSyncError((0,R.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const o=JSON.parse(t.value.toString());if(!s(o))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const a=this.parseSettingsSyncContent(o.content);if(!a||!a.settings)return;let u=a.settings;const g=await this.getFormattingOptions();for(const b in o)if(["version","content","machineId"].indexOf(b)===-1&&o[b]!==void 0){const A=(0,D.setProperty)(u,[b],o[b],g);A.length&&(u=(0,D.applyEdits)(u,A))}await this.fileService.writeFile(this.file,k.VSBuffer.fromString(u))}catch(t){}}};l=he([J(0,w.IFileService),J(1,C.IEnvironmentService),J(2,f.IStorageService),J(3,v.IUserDataSyncStoreService),J(4,v.IUserDataSyncBackupStoreService),J(5,v.IUserDataSyncLogService),J(6,v.IUserDataSyncUtilService),J(7,r.IConfigurationService),J(8,v.IUserDataSyncResourceEnablementService),J(9,p.ITelemetryService),J(10,I.IExtensionManagementService),J(11,y.IUserConfigurationFileService),J(12,h.IUriIdentityService)],l),e.SettingsSynchroniser=l;let n=class extends E.AbstractInitializer{constructor(t,o,a,u){super("settings",o,a,t,u)}async doInitialize(t){const o=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!o){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,k.VSBuffer.fromString(o.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,m.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return c(t)}catch(o){this.logService.error(o)}return null}};n=he([J(0,w.IFileService),J(1,C.IEnvironmentService),J(2,v.IUserDataSyncLogService),J(3,h.IUriIdentityService)],n),e.SettingsInitializer=n;function s(i){return!!(i&&i.version!==void 0&&typeof i.version=="number"&&i.content!==void 0&&typeof i.content=="string"&&i.machineId!==void 0&&typeof i.machineId=="string")}}),define(te[230],ne([0,1,19,3,26,21,11,14,23,22,37,47,223,24]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends w.AbstractSynchroniser{constructor(m,v,d,c,l,n,s,i,t,o){super("snippets",v,m,d,c,l,i,t,n,s,o);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(T.Event.filter(this.fileService.onDidFilesChange,a=>a.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,v,d){const c=await this.getSnippetsFileContents(),l=this.toSnippetsContents(c),n=m.syncData?this.parseSnippets(m.syncData):null;v=v===null&&d?m:v;const s=v&&v.syncData?this.parseSnippets(v.syncData):null;n?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,f.merge)(l,n,s);return this.getResourcePreviews(i,c,n||{})}async getMergeResult(m,v){return m.previewResult}async getAcceptResult(m,v,d,c){if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(v,this.syncPreviewFolder))return d===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:d,localChange:d===null?m.fileContent!==null?3:0:2,remoteChange:d===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${v.toString()}`)}async applyResult(m,v,d,c){const l=d.map(([n,s])=>({...n,acceptResult:s}));l.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:n})=>n!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,c)),l.some(({remoteChange:n})=>n!==0)&&(m=await this.updateRemoteSnippets(l,m,c)),v?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:n}of l)try{await this.fileService.del(n)}catch(s){}}getResourcePreviews(m,v,d){const c=new Map;for(const l of Object.keys(m.local.added)){const n={content:m.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};c.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.local.updated)){const n={content:m.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.added)){const n={content:m.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(m.remote.updated)){const n={content:m.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l],localContent:v[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of m.conflicts){const n={content:v[l]?v[l].value.toString():null,hasConflicts:!0,localChange:v[l]?2:1,remoteChange:d[l]?2:1};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l]||null,localContent:v[l]?v[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(v))if(!c.has(l)){const n={content:v[l]?v[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};c.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:v[l]||null,localContent:v[l]?v[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...c.values()]}async getAssociatedResources({uri:m}){let v=await super.resolveContent(m);if(v){const d=this.parseSyncData(v);if(d){const c=this.parseSnippets(d),l=[];for(const n of Object.keys(c)){const s=this.extUri.joinPath(m,n),i=this.extUri.joinPath(this.snippetsFolder,n),t=await this.fileService.exists(i);l.push({resource:s,comparableResource:t?i:this.extUri.joinPath(this.syncPreviewFolder,n).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let v=await super.resolveContent(m);if(v)return v;if(v=await super.resolveContent(this.extUri.dirname(m)),v){const d=this.parseSyncData(v);if(d)return this.parseSnippets(d)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch(m){}return!1}async updateLocalBackup(m){const v={};for(const d of m)d.fileContent&&(v[this.extUri.basename(d.localResource)]=d.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(v)))}async updateLocalSnippets(m,v){for(const{fileContent:d,acceptResult:c,localResource:l,remoteResource:n,localChange:s}of m)if(s!==0){const i=n?this.extUri.basename(n):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,i);s===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):s===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,k.VSBuffer.fromString(c.content),{overwrite:v}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,k.VSBuffer.fromString(c.content),v?void 0:d),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,v,d){const c=v.syncData?this.parseSnippets(v.syncData):{},l=(0,D.deepClone)(c);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:t}of m)if(t!==0){const o=s?this.extUri.basename(s):this.extUri.basename(i);t===3?delete l[o]:l[o]=n.content}return(0,f.areSame)(c,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),v=await this.updateRemoteUserData(JSON.stringify(l),d?null:v.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),v}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const v={};for(const d of Object.keys(m))v[d]=m[d].value.toString();return v}async getSnippetsFileContents(){const m={};let v;try{v=await this.fileService.resolve(this.snippetsFolder)}catch(d){if(d instanceof P.FileOperationError&&d.fileOperationResult===1)return m;throw d}for(const d of v.children||[]){const c=d.resource,l=this.extUri.extname(c);if(l===".json"||l===".code-snippets"){const n=this.extUri.relativePath(this.snippetsFolder,c),s=await this.fileService.readFile(c);m[n]=s}}return m}};h=he([J(0,r.IEnvironmentService),J(1,P.IFileService),J(2,y.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncBackupStoreService),J(5,p.IUserDataSyncLogService),J(6,R.IConfigurationService),J(7,p.IUserDataSyncResourceEnablementService),J(8,C.ITelemetryService),J(9,I.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let E=class extends w.AbstractInitializer{constructor(m,v,d,c){super("snippets",v,d,m,c)}async doInitialize(m){const v=m.syncData?JSON.parse(m.syncData.content):null;if(!v){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(v)){const l=v[c];if(l){const n=this.extUri.joinPath(this.environmentService.snippetsHome,c);await this.fileService.createFile(n,k.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(n))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};E=he([J(0,P.IFileService),J(1,r.IEnvironmentService),J(2,p.IUserDataSyncLogService),J(3,I.IUriIdentityService)],E),e.SnippetsInitializer=E}),define(te[64],ne([0,1,3,2,6,24]),function(X,e,k,T,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let r=class extends T.Disposable{constructor(y,C){super();this.userDataSyncStoreService=y,this.logService=C,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(y.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(y.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(y){(y&&this._account?y.token!==this._account.token||y.authenticationProviderId!==this._account.authenticationProviderId:y!==this._account)&&(this._account=y,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(y))}};r=he([J(0,R.IUserDataSyncStoreService),J(1,R.IUserDataSyncLogService)],r),e.UserDataSyncAccountService=r}),define(te[231],ne([0,1,5,19,58,2,18,21,11,14,24]),function(X,e,k,T,D,R,r,P,y,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends R.Disposable{constructor(p,h,E,S){super();this.environmentService=p,this.fileService=h,this.configurationService=E,this.logService=S,I.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(p){const h=(0,r.joinPath)(this.environmentService.userDataSyncHome,p),E=await this.fileService.resolve(h);return E.children?E.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(p,h){if(!h){const E=await this.getAllRefs(p);E.length&&(h=E[E.length-1].ref)}if(h){const E=(0,r.joinPath)(this.environmentService.userDataSyncHome,p,h);return(await this.fileService.readFile(E)).value.toString()}return null}async backup(p,h){const E=(0,r.joinPath)(this.environmentService.userDataSyncHome,p),S=(0,r.joinPath)(E,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(S,T.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(p)}catch(m){}}async cleanUpBackup(p){const h=(0,r.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(h))return}catch(S){return}const E=await this.fileService.resolve(h);if(E.children){const S=E.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let v=S.filter(c=>Date.now()-this.getCreationTime(c)>m);const d=S.length-v.length;d<10&&(v=v.slice(10-d)),await k.Promises.settled(v.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(E){this.logService.error(E)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};w=he([J(0,y.IEnvironmentService),J(1,C.IFileService),J(2,P.IConfigurationService),J(3,I.IUserDataSyncLogService)],w),e.UserDataSyncBackupStoreService=w}),define(te[232],ne([0,1,2,8]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(f){this.service=f}listen(f,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class R{constructor(f){this.service=f}listen(f,p){throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(T.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=R;class r{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=r;class P{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(f,p,h){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class y{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=y;class C{constructor(f){this.service=f}listen(f,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(f,p,h){switch(p){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=C;class I extends k.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:T.URI.revive(f.url),type:f.type,defaultUrl:T.URI.revive(f.defaultUrl),insidersUrl:T.URI.revive(f.insidersUrl),stableUrl:T.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(te[233],ne([0,1,11,10]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends T.AbstractLogger{constructor(r,P){super();this.logger=this._register(r.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(r,...P){this.logger.trace(r,...P)}debug(r,...P){this.logger.debug(r,...P)}info(r,...P){this.logger.info(r,...P)}warn(r,...P){this.logger.warn(r,...P)}error(r,...P){this.logger.error(r,...P)}critical(r,...P){this.logger.critical(r,...P)}flush(){this.logger.flush()}};D=he([J(0,T.ILoggerService),J(1,k.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(te[65],ne([0,1,3,2,4,25,151,11,14,6,27,46,23,24]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,C.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let E=class tt extends T.Disposable{constructor(m,v,d,c,l,n){super();this.storageService=d,this.userDataSyncStoreService=c,this.logService=l,this.productService=n,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(m,v,d)}async getMachines(m){const v=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(c=>({...c,isCurrent:c.id===v}))}async addCurrentMachine(m){const v=await this.currentMachineIdPromise,d=await this.readMachinesData(m);d.machines.some(({id:c})=>c===v)||(d.machines.push({id:v,name:this.computeCurrentMachineName(d.machines)}),await this.writeMachinesData(d))}async removeCurrentMachine(m){const v=await this.currentMachineIdPromise,d=await this.readMachinesData(m),c=d.machines.filter(({id:l})=>l!==v);c.length!==d.machines.length&&(d.machines=c,await this.writeMachinesData(d))}async renameMachine(m,v,d){const c=await this.currentMachineIdPromise,l=await this.readMachinesData(d),n=l.machines.find(({id:s})=>s===m);n&&(n.name=v,await this.writeMachinesData(l),l.machines.some(({id:s})=>s===c)&&this.storageService.store(h,v,0,1))}async setEnablement(m,v){const d=await this.readMachinesData(),c=d.machines.find(({id:l})=>l===m);c&&(c.disabled=v?void 0:!0,await this.writeMachinesData(d))}computeCurrentMachineName(m){const v=this.storageService.get(h,0);if(v)return v;const d=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,c=new RegExp(`${(0,R.escapeRegExpCharacters)(d)}\\s#(\\d+)`);let l=0;for(const n of m){const s=c.exec(n.name),i=s?parseInt(s[1]):0;l=i>l?i:l}return`${d} #${l+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const v=this.parse(this.userData);if(v.version!==tt.VERSION)throw new Error((0,r.localize)(0,null,this.productService.nameLong));return v}async writeMachinesData(m){const v=JSON.stringify(m),d=await this.userDataSyncStoreService.write(tt.RESOURCE,v,this.userData?.ref||null);this.userData={ref:d,content:v},this._onDidChange.fire()}async readUserData(m){if(this.userData){const v=m&&m.latest?m.latest[tt.RESOURCE]:void 0;if(this.userData.ref===v)return this.userData;if(v===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(tt.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(v){this.logService.error(v)}return{version:tt.VERSION,machines:[]}}};E.VERSION=1,E.RESOURCE="machines",E=he([J(0,P.IEnvironmentService),J(1,y.IFileService),J(2,f.IStorageService),J(3,p.IUserDataSyncStoreService),J(4,p.IUserDataSyncLogService),J(5,I.IProductService)],E),e.UserDataSyncMachinesService=E}),define(te[101],ne([0,1,5,58,38,7,3,2,4,18,8,149,11,27,23,22,24,64,65]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const d="sync.enable",c="sync.disableMachineEventually",l="sync.sessionId",n="sync.storeUrl",s="sync.productQuality";let i=class extends P.Disposable{constructor(u,g,b){super();this.storageService=u,this.environmentService=g,this.userDataSyncStoreManagementService=b,this._onDidChangeEnablement=new r.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(d,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(d,u,0,1)}onDidStorageChange(u){if(u.scope===0&&d===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=he([J(0,h.IStorageService),J(1,f.IEnvironmentService),J(2,S.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let t=class extends P.Disposable{constructor(u,g,b,A,O,U,x,N,L,$,_){super();this.userDataSyncStoreManagementService=g,this.userDataSyncStoreService=b,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=O,this.logService=U,this.userDataSyncAccountService=x,this.telemetryService=N,this.userDataSyncMachinesService=L,this.storageService=$,this.autoSync=this._register(new P.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new r.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=_,this.syncTriggerDelayer=this._register(new k.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(g.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,g.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=g.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(x.onDidChangeAccount(()=>this.updateAutoSync())),this._register(b.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(r.Event.debounce(O.onDidChangeLocal,(M,W)=>M?[...M,W]:[W],1e3)(M=>this.triggerSync(M,!1,!1))),this._register(r.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(n,0);return u?I.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(n,u.toString(),0,1):this.storageService.remove(n,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:g}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(b=>this.onDidFinishSync(b))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(g&&this.logService.info(g),this.autoSync.clear()):g&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(g))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,T.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,g,b){try{this.userDataSyncAccountService.account&&!b&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(l,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(g)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(d,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const g=S.UserDataSyncError.toUserDataSyncError(u);g instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:g.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),g.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):g.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):g.code==="LocalTooManyRequests"||g.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):g.code==="UpgradeRequired"||g.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):g.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with newer version than of client. Requires client upgrade.`)):g.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${g.resource} content with older version than of client. Requires server reset.`)):g.code==="ServiceChanged"||g.code==="DefaultServiceChanged"?y.isWeb&&g.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(g),this.successiveFailures++),this._onError.fire(g)}async disableMachineEventually(){this.storageService.store(c,!0,0,1),await(0,k.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(c,0,!1)}stopDisableMachineEventually(){this.storageService.remove(c,0)}async triggerSync(u,g,b){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(g&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",b)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};t=he([J(0,p.IProductService),J(1,S.IUserDataSyncStoreManagementService),J(2,S.IUserDataSyncStoreService),J(3,S.IUserDataSyncResourceEnablementService),J(4,S.IUserDataSyncService),J(5,S.IUserDataSyncLogService),J(6,m.IUserDataSyncAccountService),J(7,E.ITelemetryService),J(8,v.IUserDataSyncMachinesService),J(9,h.IStorageService),J(10,S.IUserDataAutoSyncEnablementService)],t),e.UserDataAutoSyncService=t;class o extends P.Disposable{constructor(u,g,b,A,O,U,x,N){super();this.lastSyncUrl=u,this.interval=g,this.userDataSyncStoreManagementService=b,this.userDataSyncStoreService=A,this.userDataSyncService=O,this.userDataSyncMachinesService=U,this.logService=x,this.storageService=N,this.intervalHandler=this._register(new P.MutableDisposable),this._onDidStartSync=this._register(new r.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new r.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,P.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,k.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(u,g){const b=(0,k.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(O){if((0,R.isPromiseCanceledError)(O))return}return this.doSync(u,g,A)});return this.syncPromise=b,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),g=this.userDataSyncStoreManagementService.userDataSyncStore;return!!g&&!!u&&(!(0,C.isEqual)(g.defaultUrl,u.defaultUrl)||!(0,C.isEqual)(g.insidersUrl,u.insidersUrl)||!(0,C.isEqual)(g.stableUrl,u.stableUrl))}async doSync(u,g,b){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,g),b.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const O=this.storageService.get(l,0);if(O&&this.manifest&&O!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const U=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(b.isCancellationRequested)return;const x=U.find(N=>N.isCurrent);if(x?.disabled)throw new S.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(N){throw new S.UserDataAutoSyncError((0,D.toErrorMessage)(N),N instanceof S.UserDataSyncError?N.code:"Unknown")}if(this.manifest&&this.manifest.session!==O&&this.storageService.store(l,this.manifest.session,0,1),b.isCancellationRequested)return;x||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(O){this.logService.error(O),A=O}this._onDidFinishSync.fire(A)}register(u){return super._register(u)}}o.INTERVAL_SYNCING="Interval"}),define(te[234],ne([0,1,3,2,4,23,22,24]),function(X,e,k,T,D,R,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let y=class extends T.Disposable{constructor(I,w){super();this.storageService=I,this.telemetryService=w,this._onDidChangeResourceEnablement=new k.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(I.onDidChangeValue(f=>this.onDidStorageChange(f)))}isResourceEnabled(I){return this.storageService.getBoolean((0,P.getEnablementKey)(I),0,!0)}setResourceEnablement(I,w){if(this.isResourceEnabled(I)!==w){const f=(0,P.getEnablementKey)(I);this.telemetryService.publicLog2(f,{enabled:w}),this.storeResourceEnablement(f,w)}}getResourceSyncStateVersion(I){}storeResourceEnablement(I,w){this.storageService.store(I,w,0,D.isWeb?0:1)}onDidStorageChange(I){if(I.scope===0){const w=P.ALL_SYNC_RESOURCES.filter(f=>(0,P.getEnablementKey)(f)===I.key)[0];if(w){this._onDidChangeResourceEnablement.fire([w,this.isResourceEnabled(w)]);return}}}};y=he([J(0,R.IStorageService),J(1,r.ITelemetryService)],y),e.UserDataSyncResourceEnablementService=y}),define(te[235],ne([0,1,16,5,38,7,3,2,18,29,21,6,23,22,224,226,227,229,230,24]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const c="sync.lastSyncTime";let l=class extends P.Disposable{constructor(t,o,a,u,g,b,A){super();this.userDataSyncStoreService=t,this.userDataSyncStoreManagementService=o,this.instantiationService=a,this.configurationService=u,this.logService=g,this.telemetryService=b,this.storageService=A,this._status="uninitialized",this._onDidChangeStatus=this._register(new r.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new r.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new r.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new r.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new r.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new r.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(m.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(S.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(v.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(E.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(h.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(r.Event.any(...this.synchronisers.map(O=>r.Event.map(O.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(r.Event.any(...this.synchronisers.map(O=>r.Event.map(O.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(c,0,void 0),this.onDidChangeLocal=r.Event.any(...this.synchronisers.map(O=>r.Event.map(O.onDidChangeLocal,()=>O.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(t,o){await this.checkEnablement();const a=(0,C.generateUuid)();try{const A=(0,d.createSyncHeaders)(a);o&&(A["Cache-Control"]="no-cache"),t=await this.userDataSyncStoreService.manifest(t,A)}catch(A){const O=d.UserDataSyncError.toUserDataSyncError(A);throw this.reportUserDataSyncError(O,a),O}let u=!1;const g=this;let b;return{manifest:t,run(){if(u)throw new Error("Can run a task only once");return b=(0,T.createCancelablePromise)(A=>g.sync(t,a,A)),b.finally(()=>b=void 0)},async stop(){if(b&&b.cancel(),g.status!=="idle")return g.stop()}}}async createManualSyncTask(){await this.checkEnablement();const t=(0,C.generateUuid)(),o=(0,d.createSyncHeaders)(t);let a;try{a=await this.userDataSyncStoreService.manifest(null,o)}catch(u){const g=d.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(g,t),g}return new n(t,a,o,this.synchronisers,this.configurationService,this.logService)}async sync(t,o,a){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),a.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const g=(0,d.createSyncHeaders)(o);for(const b of this.synchronisers){if(a.isCancellationRequested)return;try{await b.sync(t,g)}catch(A){let O=!1;if(A instanceof d.UserDataSyncError)switch(A.code){case"TooLarge":A=new d.UserDataSyncError(A.message,A.code,b.resource),O=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":O=!0;break}const U=d.UserDataSyncError.toUserDataSyncError(A);if(this.reportUserDataSyncError(U,o),O)throw U;this.logService.error(A),this.logService.error(`${b.resource}: ${(0,D.toErrorMessage)(A)}`),this._syncErrors.push([b.resource,U])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(g){const b=d.UserDataSyncError.toUserDataSyncError(g);throw this.reportUserDataSyncError(b,o),b}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const t of this.synchronisers)try{t.status!=="idle"&&await t.stop()}catch(o){this.logService.error(o)}}async replace(t){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(t))return}async accept(t,o,a,u){await this.checkEnablement();const g=this.getSynchroniser(t);await g.accept(o,a),u&&await g.apply(!1,(0,d.createSyncHeaders)((0,C.generateUuid)()))}async resolveContent(t){for(const o of this.synchronisers){const a=await o.resolveContent(t);if(a)return a}return null}getRemoteSyncResourceHandles(t){return this.getSynchroniser(t).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(t){return this.getSynchroniser(t).getLocalSyncResourceHandles()}getAssociatedResources(t,o){return this.getSynchroniser(t).getAssociatedResources(o)}getMachineId(t,o){return this.getSynchroniser(t).getMachineId(o)}async hasLocalData(){const t=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of t)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(t){this.logService.error(t)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(c,0);for(const t of this.synchronisers)try{await t.resetLocal()}catch(o){this.logService.error(`${t.resource}: ${(0,D.toErrorMessage)(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const t of this.synchronisers)if(await t.hasPreviouslySynced())return!0;return!1}setStatus(t){const o=this._status;this._status!==t&&(this._status=t,this._onDidChangeStatus.fire(t),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const t=this.computeStatus();this.setStatus(t)}updateConflicts(){const t=this.computeConflicts();(0,k.equals)(this._conflicts,t,([o,a],[u,g])=>o===o&&(0,k.equals)(a,g,(b,A)=>(0,y.isEqual)(b.previewResource,A.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(t))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(c,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(t,o){this.telemetryService.publicLog2("sync/error",{code:t.code,serverCode:t instanceof d.UserDataSyncStoreError?String(t.serverCode):void 0,url:t instanceof d.UserDataSyncStoreError?t.url:void 0,resource:t.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(t=>t.status==="hasConflicts").map(t=>[t.resource,t.conflicts.map(s)])}getSynchroniser(t){return this.synchronisers.find(o=>o.resource===t)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};l=he([J(0,d.IUserDataSyncStoreService),J(1,d.IUserDataSyncStoreManagementService),J(2,w.IInstantiationService),J(3,I.IConfigurationService),J(4,d.IUserDataSyncLogService),J(5,p.ITelemetryService),J(6,f.IStorageService)],l),e.UserDataSyncService=l;class n extends P.Disposable{constructor(t,o,a,u,g,b){super();this.id=t,this.manifest=o,this.syncHeaders=a,this.synchronisers=u,this.configurationService=g,this.logService=b,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new r.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(t=>t.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(t=>t.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,T.createCancelablePromise)(t=>this.getPreviews(t))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(t){throw this.logService.error(t),t}}async accept(t,o){try{return await this.performAction(t,a=>a.accept(t,o))}catch(a){throw this.logService.error(a),a}}async merge(t){try{return t?await this.performAction(t,o=>o.merge(t)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(t){try{return await this.performAction(t,o=>o.discard(t))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const t=[];for(const[,o]of this.previews)for(const a of o.resourcePreviews)a.mergeState==="conflict"&&t.push(a.previewResource);for(const o of t)await this.discard(o);return this.previews}catch(t){throw this.logService.error(t),t}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const t=[];for(const[o,a]of this.previews){this.synchronizingResources.push([o,a.resourcePreviews.map(b=>b.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(b=>b.resource===o);for(const b of a.resourcePreviews)(b.localChange!==0||b.remoteChange!==0)&&b.mergeState==="preview"&&await u.merge(b.previewResource);const g=await u.apply(!1,this.syncHeaders);g&&t.push(this.toSyncResourcePreview(u.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(b=>b[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}catch(t){throw this.logService.error(t),t}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,o]of this.previews){this.synchronizingResources.push([t,o.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(u=>u.resource===t);for(const u of o.resourcePreviews)await a.accept(u.remoteResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[t,o]of this.previews){this.synchronizingResources.push([t,o.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const a=this.synchronisers.find(u=>u.resource===t);for(const u of o.resourcePreviews)await a.accept(u.localResource);await a.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===t),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(t){throw this.logService.error(t),t}}async stop(){for(const t of this.synchronisers)try{await t.stop()}catch(o){(0,R.isPromiseCanceledError)(o)||this.logService.error(o)}this.reset()}async performAction(t,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const a=this.previews.findIndex(([,N])=>N.resourcePreviews.some(({localResource:L,previewResource:$,remoteResource:_})=>(0,y.isEqual)(t,L)||(0,y.isEqual)(t,$)||(0,y.isEqual)(t,_)));if(a===-1)return this.previews;const[u,g]=this.previews[a],b=g.resourcePreviews.find(({localResource:N,remoteResource:L,previewResource:$})=>(0,y.isEqual)(N,t)||(0,y.isEqual)(L,t)||(0,y.isEqual)($,t));if(!b)return this.previews;let A=this.synchronizingResources.find(N=>N[0]===u);A||(A=[u,[]],this.synchronizingResources.push(A)),A[1].some(N=>(0,y.isEqual)(N,b.localResource))||(A[1].push(b.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const O=this.synchronisers.find(N=>N.resource===this.previews[a][0]),U=await o(O);U?this.previews.splice(a,1,this.toSyncResourcePreview(O.resource,U)):this.previews.splice(a,1);const x=this.synchronizingResources.findIndex(N=>N[0]===u);return this.synchronizingResources[x][1].splice(A[1].findIndex(N=>(0,y.isEqual)(N,b.localResource)),1),A[1].length||(this.synchronizingResources.splice(x,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const t=[];for(const[o,a]of this.previews){this.synchronizingResources.push([o,a.resourcePreviews.map(b=>b.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(b=>b.resource===o);let g=a;for(const b of a.resourcePreviews)(b.localChange!==0||b.remoteChange!==0)&&b.mergeState==="preview"&&(g=await u.merge(b.previewResource));g&&t.push(this.toSyncResourcePreview(u.resource,g)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(b=>b[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=t,this.previews}async getPreviews(t){const o=[],a=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(t.isCancellationRequested)return[];const g=await u.preview(this.manifest,a,this.syncHeaders);g&&o.push(this.toSyncResourcePreview(u.resource,g))}return o}async getUserDataSyncConfiguration(){const t=this.configurationService.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE),o=await this.synchronisers.find(a=>a instanceof m.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...t,...o}}toSyncResourcePreview(t,o){return[t,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(i){return{localResource:i.localResource,previewResource:i.previewResource,remoteResource:i.remoteResource,acceptedResource:i.acceptedResource,localChange:i.localChange,remoteChange:i.remoteChange,mergeState:i.mergeState}}}),define(te[236],ne([0,1,3,2,17,8,24]),function(X,e,k,T,D,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(w,f){this.service=w,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new k.Emitter}listen(w,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(w,f,p){try{return await this._call(w,f,p)}catch(h){throw this.logService.error(h),h}}async _call(w,f,p){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(R.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],R.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(R.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:R.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:R.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const h=f.substring("manualSync/".length),E=p[0],S=this.getManualSyncTask(E);switch(p=p.slice(1),h){case"preview":return S.preview();case"accept":return S.accept(R.URI.revive(p[0]),p[1]);case"merge":return S.merge(R.URI.revive(p[0]));case"discard":return S.discard(R.URI.revive(p[0]));case"discardConflicts":return S.discardConflicts();case"apply":return S.apply();case"pull":return S.pull();case"push":return S.push();case"stop":return S.stop();case"_getStatus":return S.status;case"dispose":return this.disposeManualSyncTask(S)}}throw new Error("Invalid call")}getManualSyncTask(w){const f=this.manualSyncTasks.get(this.createKey(w));if(!f)throw new Error(`Manual sync taks not found: ${w}`);return f.manualSyncTask}async createManualSyncTask(){const w=new T.DisposableStore,f=w.add(await this.service.createManualSyncTask());return w.add(f.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:p}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:w}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(w){w.dispose();const f=this.createKey(w.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(w){return`manualSyncTask-${w}`}}e.UserDataSyncChannel=P;class y extends T.Disposable{constructor(w){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,p,h){return w.call(f,p,h).then(null,E=>{throw r.UserDataSyncError.toUserDataSyncError(E)})},listen(f,p){return w.listen(f,p)}},this.channel.call("_getInitialData").then(([f,p,h])=>{this.updateStatus(f),this.updateConflicts(p),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(E=>this.updateStatus(E))),this._register(this.channel.listen("onDidChangeLastSyncTime")(E=>this.updateLastSyncTime(E)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([p,h])=>[p,r.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:w,manifest:f,status:p}=await this.channel.call("createManualSyncTask"),h=this,E=new C(w,f,p,{async call(S,m,v){return h.channel.call(`manualSync/${S}`,[w,...(0,D.isArray)(m)?m:[m]],v)},listen(S,m){return k.Event.map(k.Event.filter(h.channel.listen(`manualSync/${S}`,m),v=>!E.isDiposed()&&v.manualSyncTaskId===w),v=>v.data)}});return E}replace(w){return this.channel.call("replace",[w])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(w,f,p,h){return this.channel.call("accept",[w,f,p,h])}resolveContent(w){return this.channel.call("resolveContent",[w])}async getLocalSyncResourceHandles(w){return(await this.channel.call("getLocalSyncResourceHandles",[w])).map(({created:p,uri:h})=>({created:p,uri:R.URI.revive(h)}))}async getRemoteSyncResourceHandles(w){return(await this.channel.call("getRemoteSyncResourceHandles",[w])).map(({created:p,uri:h})=>({created:p,uri:R.URI.revive(h)}))}async getAssociatedResources(w,f){return(await this.channel.call("getAssociatedResources",[w,f])).map(({resource:h,comparableResource:E})=>({resource:R.URI.revive(h),comparableResource:R.URI.revive(E)}))}async getMachineId(w,f){return this.channel.call("getMachineId",[w,f])}async updateStatus(w){this._status=w,this._onDidChangeStatus.fire(w)}async updateConflicts(w){this._conflicts=w.map(([f,p])=>[f,p.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(w){this._lastSyncTime!==w&&(this._lastSyncTime=w,this._onDidChangeLastSyncTime.fire(w))}}e.UserDataSyncChannelClient=y;class C extends T.Disposable{constructor(w,f,p,h){super();this.id=w,this.manifest=f,this._disposed=!1,this._status=p;const E=this;this.channel={async call(S,m,v){try{const d=await h.call(S,m,v);return E.isDiposed()||(E._status=await h.call("_getStatus")),d}catch(d){throw r.UserDataSyncError.toUserDataSyncError(d)}},listen(S,m){return h.listen(S,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const w=await this.channel.call("preview");return this.deserializePreviews(w)}async accept(w,f){const p=await this.channel.call("accept",[w,f]);return this.deserializePreviews(p)}async merge(w){const f=await this.channel.call("merge",[w]);return this.deserializePreviews(f)}async discard(w){const f=await this.channel.call("discard",[w]);return this.deserializePreviews(f)}async discardConflicts(){const w=await this.channel.call("discardConflicts");return this.deserializePreviews(w)}async apply(){const w=await this.channel.call("apply");return this.deserializePreviews(w)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(w){return w.map(([f,p])=>[f,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(h=>({...h,localResource:R.URI.revive(h.localResource),remoteResource:R.URI.revive(h.remoteResource),previewResource:R.URI.revive(h.previewResource),acceptedResource:R.URI.revive(h.acceptedResource)}))}])}}}),define(te[237],ne([0,1,5,28,7,3,2,110,4,18,17,8,29,21,11,14,27,44,46,23,24]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",n="sync.donot-make-requests-until",s="sync.user-session-id",i="sync.machine-session-id",t=100,o=1e3*60*5;let a=class extends r.Disposable{constructor(U,x,N){super();this.productService=U,this.configurationService=x,this.storageService=N,this._onDidChangeUserDataSyncStore=this._register(new R.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(R.Event.filter(N.onDidChangeValue,L=>L.key===c.SYNC_SERVICE_URL_TYPE&&L.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(U){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,U,0,y.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(U,x){U=y.isWeb&&U?.web?{...U,...U.web}:U;const N={...U||{},...x||{}};if(N&&(0,I.isString)(N.url)&&(0,I.isObject)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(L=>(0,I.isArray)(N.authenticationProviders[L].scopes))){const L=N,$=!!L.canSwitch&&!x?.url,_=L.url===L.insidersUrl?"insiders":"stable",M=($?this.userDataSyncStoreType:void 0)||_,W=x?.url||(M==="insiders"?L.insidersUrl:M==="stable"?L.stableUrl:L.url);return{url:w.URI.parse(W),type:M,defaultType:_,defaultUrl:w.URI.parse(L.url),stableUrl:w.URI.parse(L.stableUrl),insidersUrl:w.URI.parse(L.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(L.authenticationProviders).reduce((j,q)=>(j.push({id:q,scopes:L.authenticationProviders[q].scopes}),j),[])}}}};a=he([J(0,S.IProductService),J(1,p.IConfigurationService),J(2,d.IStorageService)],a),e.AbstractUserDataSyncStoreManagementService=a;let u=class extends a{constructor(U,x,N){super(U,x,N);const L=this.storageService.get(l,0);L&&(this.previousConfigurationSyncStore=JSON.parse(L));const $=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(l,JSON.stringify($),0,1):this.storageService.remove(l,0)}async switch(U){U!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=U,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([J(0,S.IProductService),J(1,p.IConfigurationService),J(2,d.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let g=class extends r.Disposable{constructor(U,x,N,L,$,_,M){super();this.requestService=N,this.logService=L,this.storageService=M,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new R.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new R.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(U),this.commonHeadersPromise=(0,v.getServiceMachineId)($,_,M).then(W=>{const j={"X-Client-Name":`${x.applicationName}${y.isWeb?"-web":""}`,"X-Client-Version":x.version};return x.commit&&(j["X-Client-Commit"]=x.commit),j}),this.session=new A(t,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,r.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(U,x){this.authToken={token:U,type:x}}updateUserDataSyncStoreUrl(U){this.userDataSyncStoreUrl=U?(0,C.joinPath)(U,"v1"):void 0}initDonotMakeRequestsUntil(){const U=this.storageService.getNumber(n,0);U&&Date.now()<U&&this.setDonotMakeRequestsUntil(new Date(U))}setDonotMakeRequestsUntil(U){this._donotMakeRequestsUntil?.getTime()!==U?.getTime()&&(this._donotMakeRequestsUntil=U,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(n,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,k.createCancelablePromise)(x=>(0,k.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),x).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,x=>null)):this.storageService.remove(n,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U),N={},L=await this.request(x.toString(),{type:"GET",headers:N},[],T.CancellationToken.None);return(await(0,m.asJson)(L)||[]).map(({url:_,created:M})=>({ref:(0,C.relativePath)(x,x.with({path:_})),created:M*1e3}))}async resolveContent(U,x){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U,x).toString(),L={};L["Cache-Control"]="no-cache";const $=await this.request(N,{type:"GET",headers:L},[],T.CancellationToken.None);return await(0,m.asText)($)}async delete(U){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const x=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString(),N={};await this.request(x,{type:"DELETE",headers:N},[],T.CancellationToken.None)}async read(U,x,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U,"latest").toString();N={...N},N["Cache-Control"]="no-cache",x&&(N["If-None-Match"]=x.ref);const $=await this.request(L,{type:"GET",headers:N},[304],T.CancellationToken.None);let _=null;if($.res.statusCode===304&&(_=x),_===null){const M=$.res.headers.etag;if(!M)throw new c.UserDataSyncStoreError("Server did not return the ref",L,"NoRef",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);const W=await(0,m.asText)($);if(!W&&$.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",L,"EmptyResponse",$.res.statusCode,$.res.headers[c.HEADER_OPERATION_ID]);_={ref:M,content:W}}return _}async write(U,x,N,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",U).toString();L={...L},L["Content-Type"]=P.Mimes.text,N&&(L["If-Match"]=N);const _=await this.request($,{type:"POST",data:x,headers:L},[],T.CancellationToken.None),M=_.res.headers.etag;if(!M)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",_.res.statusCode,_.res.headers[c.HEADER_OPERATION_ID]);return M}async manifest(U,x={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();x={...x},x["Content-Type"]="application/json",U&&(x["If-None-Match"]=U.ref);const L=await this.request(N,{type:"GET",headers:x},[304],T.CancellationToken.None);let $=null;if(L.res.statusCode===304&&($=U),!$){const M=L.res.headers.etag;if(!M)throw new c.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",L.res.statusCode,L.res.headers[c.HEADER_OPERATION_ID]);const W=await(0,m.asText)(L);if(!W&&L.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",N,"EmptyResponse",L.res.statusCode,L.res.headers[c.HEADER_OPERATION_ID]);W&&($={...JSON.parse(W),ref:M})}const _=this.storageService.get(s,0);return _&&$&&_!==$.session&&this.clearSession(),$===null&&_&&this.clearSession(),$&&this.storageService.store(s,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const U=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),x={"Content-Type":P.Mimes.text};await this.request(U,{type:"DELETE",headers:x},[],T.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(i,0)}async request(U,x,N,L){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",U,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${x.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;x.headers={...x.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(x.headers),this.logService.trace("Sending request to server",{url:U,type:x.type,headers:{...x.headers,authorization:void 0}});let _;try{_=await this.session.request(U,x,L)}catch(q){if(!(q instanceof c.UserDataSyncStoreError)){let z="RequestFailed";const K=(0,D.getErrorMessage)(q).toLowerCase();K.includes("xhr timeout")?z="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?z="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?z="RequestPathNotEscaped":K.includes("headers must be an object")?z="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(q)&&(z="RequestCanceled"),q=new c.UserDataSyncStoreError(`Connection refused for the request '${U}'.`,U,z,void 0,void 0)}throw this.logService.info("Request failed",U),q}const M=_.res.headers[c.HEADER_OPERATION_ID],W={url:U,status:_.res.statusCode,"execution-id":x.headers[c.HEADER_EXECUTION_ID],"operation-id":M},j=(0,m.isSuccess)(_)||_.res.statusCode&&N.indexOf(_.res.statusCode)!==-1;if(j?this.logService.trace("Request succeeded",W):this.logService.info("Request failed",W),_.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${U}' failed because of Unauthorized (401).`,U,"Unauthorized",_.res.statusCode,M);if(this._onTokenSucceed.fire(),_.res.statusCode===409)throw new c.UserDataSyncStoreError(`${x.type} request '${U}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,U,"Conflict",_.res.statusCode,M);if(_.res.statusCode===410)throw new c.UserDataSyncStoreError(`${x.type} request '${U}' failed because the requested resource is not longer available (410).`,U,"Gone",_.res.statusCode,M);if(_.res.statusCode===412)throw new c.UserDataSyncStoreError(`${x.type} request '${U}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,U,"PreconditionFailed",_.res.statusCode,M);if(_.res.statusCode===413)throw new c.UserDataSyncStoreError(`${x.type} request '${U}' failed because of too large payload (413).`,U,"TooLarge",_.res.statusCode,M);if(_.res.statusCode===426)throw new c.UserDataSyncStoreError(`${x.type} request '${U}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,U,"UpgradeRequired",_.res.statusCode,M);if(_.res.statusCode===429){const q=_.res.headers["retry-after"];throw q?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(q)*1e3)),new c.UserDataSyncStoreError(`${x.type} request '${U}' failed because of too many requests (429).`,U,"TooManyRequestsAndRetryAfter",_.res.statusCode,M)):new c.UserDataSyncStoreError(`${x.type} request '${U}' failed because of too many requests (429).`,U,"RemoteTooManyRequests",_.res.statusCode,M)}if(!j)throw new c.UserDataSyncStoreError("Server returned "+_.res.statusCode,U,"Unknown",_.res.statusCode,M);return _}addSessionHeaders(U){let x=this.storageService.get(i,0);x===void 0&&(x=(0,f.generateUuid)(),this.storageService.store(i,x,0,1)),U["X-Machine-Session-Id"]=x;const N=this.storageService.get(s,0);N!==void 0&&(U["X-User-Session-Id"]=N)}};g=he([J(1,S.IProductService),J(2,m.IRequestService),J(3,c.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,E.IFileService),J(6,d.IStorageService)],g),e.UserDataSyncStoreClient=g;let b=class extends g{constructor(U,x,N,L,$,_,M){super(U.userDataSyncStore?.url,x,N,L,$,_,M);this._register(U.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(U.userDataSyncStore?.url)))}};b=he([J(0,c.IUserDataSyncStoreManagementService),J(1,S.IProductService),J(2,m.IRequestService),J(3,c.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,E.IFileService),J(6,d.IStorageService)],b),e.UserDataSyncStoreService=b;class A{constructor(U,x,N,L){this.limit=U,this.interval=x,this.requestService=N,this.logService=L,this.requests=[],this.startTime=void 0}request(U,x,N){if(this.isExpired()&&this.reset(),x.url=U,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,U,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(U),this.requestService.request(x,N)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(te[238],ne([0,1,3,61,27,23,22,101,24,64,65]),function(X,e,k,T,D,R,r,P,y,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends P.UserDataAutoSyncService{constructor(p,h,E,S,m,v,d,c,l,n,s,i){super(p,h,E,S,m,d,c,l,n,s,i);this._register(k.Event.debounce(k.Event.any(k.Event.map(v.onDidFocusWindow,()=>"windowFocus"),k.Event.map(v.onDidOpenWindow,()=>"windowOpen")),(t,o)=>t?[...t,o]:[o],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=he([J(0,D.IProductService),J(1,y.IUserDataSyncStoreManagementService),J(2,y.IUserDataSyncStoreService),J(3,y.IUserDataSyncResourceEnablementService),J(4,y.IUserDataSyncService),J(5,T.INativeHostService),J(6,y.IUserDataSyncLogService),J(7,C.IUserDataSyncAccountService),J(8,r.ITelemetryService),J(9,I.IUserDataSyncMachinesService),J(10,R.IStorageService),J(11,y.IUserDataAutoSyncEnablementService)],w),e.UserDataAutoSyncService=w}),define(te[239],ne([0,1,5,3,2]),function(X,e,k,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends D.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:y,getActiveWindowId:C}){super();this.disposables=this._register(new D.DisposableStore),T.Event.latch(T.Event.any(P,y))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,k.createCancelablePromise)(()=>C()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch(w){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(te[66],ne([0,1,51,5,9,17,20,127,250,251]),function(X,e,k,T,D,R,r,P,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(n,s){let i=s.message;switch(n){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=n,this.cause=s}}e.ExtractError=I;function w(l){const n=l.externalFileAttributes>>16||33188;return[448,56,7].map(s=>n&s).reduce((s,i)=>s+i,n&61440)}function f(l){if(l instanceof I)return l;let n;return/end of central directory record signature not found/.test(l.message)&&(n="CorruptZip"),new I(n,l)}function p(l,n,s,i,t,o){const a=D.dirname(n),u=D.join(i,a);if(!u.startsWith(i))return Promise.reject(new Error(P.localize(0,null,n)));const g=D.join(i,n);let b;return o.onCancellationRequested(()=>{b&&b.destroy()}),Promise.resolve(r.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((A,O)=>{if(!o.isCancellationRequested)try{b=(0,k.createWriteStream)(g,{mode:s}),b.once("close",()=>A()),b.once("error",O),l.once("error",O),l.pipe(b)}catch(U){O(U)}}))}function h(l,n,s,i){let t=(0,T.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((a,u)=>{const g=new T.Sequencer,b=A=>{A.isCancellationRequested||(o++,l.readEntry())};l.once("error",u),l.once("close",()=>t.then(()=>{i.isCancellationRequested||l.entryCount===o?a():u(new I("Incomplete",new Error(P.localize(1,null,o,l.entryCount))))},u)),l.readEntry(),l.on("entry",A=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){b(i);return}const O=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(O)){const N=D.join(n,O);t=(0,T.createCancelablePromise)(L=>r.Promises.mkdir(N,{recursive:!0}).then(()=>b(L)).then(void 0,u));return}const U=S(l,A),x=w(A);t=(0,T.createCancelablePromise)(N=>g.queue(()=>U.then(L=>p(L,O,x,n,s,N).then(()=>b(N)))).then(null,u))})})}function E(l,n=!1){return new Promise((s,i)=>{(0,y.open)(l,n?{lazyEntries:!0}:void 0,(t,o)=>{t?i(f(t)):s((0,R.assertIsDefined)(o))})})}function S(l,n){return new Promise((s,i)=>{l.openReadStream(n,(t,o)=>{t?i(f(t)):s((0,R.assertIsDefined)(o))})})}function m(l,n){return new Promise((s,i)=>{const t=new C.ZipFile;n.forEach(a=>{a.contents?t.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&t.addFile(a.localPath,a.path)}),t.end();const o=(0,k.createWriteStream)(l);t.outputStream.pipe(o),t.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>s(l))})}e.zip=m;function v(l,n,s={},i){const t=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let o=E(l,!0);return s.overwrite&&(o=o.then(a=>r.Promises.rm(n).then(()=>a))),o.then(a=>h(a,n,{sourcePathRegex:t},i))}e.extract=v;function d(l,n){return E(l).then(s=>new Promise((i,t)=>{s.on("entry",o=>{o.fileName===n&&S(s,o).then(a=>i(a),a=>t(a))}),s.once("close",()=>t(new Error(P.localize(2,null,n))))}))}function c(l,n){return d(l,n).then(s=>new Promise((i,t)=>{const o=[];s.once("error",t),s.on("data",a=>o.push(a)),s.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=c}),define(te[240],ne([0,1,66,136]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(R){return(0,k.buffer)(R,"extension/package.json").then(r=>{try{return JSON.parse(r.toString("utf8"))}catch(P){throw new Error((0,T.localize)(0,null))}})}e.getManifest=D}),define(te[241],ne([0,1,16,5,7,2,15,9,4,18,62,8,29,20,66,137,11,30,36,158,14,10,27]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v,d,c,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let s=class extends R.Disposable{constructor(t,o,a,u,g){super();this.beforeRemovingExtension=t,this.fileService=o,this.logService=a,this.environmentService=u,this.productService=g,this._devSystemExtensionsPath=null,this.systemExtensionsPath=u.builtinExtensionsPath,this.extensionsPath=u.extensionsPath,this.uninstalledPath=P.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new T.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const o=[];(t===null||t===0)&&o.push(this.scanSystemExtensions().then(null,a=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(a).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&o.push(this.scanUserExtensions(!0).then(null,a=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(a).message,m.ExtensionManagementErrorCode.Internal))));try{const a=await Promise.all(o);return(0,k.flatten)(a)}catch(a){throw this.joinErrors(a)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[o,a]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return a=a.filter(u=>!o[new v.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).key()]),t&&(a=(0,v.groupByExtension)(a,g=>g.identifier).map(g=>g.sort((b,A)=>I.rcompare(b.manifest.version,A.manifest.version))[0])),this.logService.trace("Scanned user extensions:",a.length),a}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,o,a,u){const g=t.key(),b=P.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),A=P.join(this.extensionsPath,g);try{await p.Promises.rm(A)}catch(U){try{await p.Promises.rm(A)}catch(x){}throw new m.ExtensionManagementError((0,E.localize)(0,null,A,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,o,b,u);let O=await this.scanExtension(w.URI.file(b),1);if(!O)throw new Error((0,E.localize)(1,null,b));await this.storeMetadata(O,{...a,installedTimestamp:Date.now()});try{await this.rename(t,b,A,Date.now()+2*60*1e3),this.logService.info("Renamed to",A)}catch(U){try{await p.Promises.rm(b)}catch(x){}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(U)}. Deleted from extracted location`,b),U}try{O=await this.scanExtension(w.URI.file(A),1)}catch(U){}if(O)return O;throw new Error((0,E.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,o){return this.setMetadata(t,o),await this.storeMetadata(t,{...o,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const a=P.join(t.location.fsPath,"package.json"),u=await p.Promises.readFile(a,"utf8"),{manifest:g}=await this.parseManifest(u);return g.__metadata=o,await p.Promises.writeFile(a,JSON.stringify(g,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const o=t.map(a=>new v.ExtensionIdentifierWithVersion(a.identifier,a.manifest.version));await this.withUninstalledExtensions(a=>{o.forEach(u=>a[u.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(u=>delete u[t.key()]);const a=(await this.scanExtensions(1)).find(u=>new v.ExtensionIdentifierWithVersion(u.identifier,u.manifest.version).equals(t))||null;return a?(await this.storeMetadata(a,{installedTimestamp:Date.now()}),this.scanExtension(a.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(u){if(u.code!=="ENOENT")throw u}let a={};if(o)try{a=JSON.parse(o)}catch(u){}return t&&(t(a),Object.keys(a).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(a)):await p.Promises.rm(this.uninstalledPath)),a})}async removeExtension(t,o){this.logService.trace(`Deleting ${o} extension from disk`,t.identifier.id,t.location.fsPath),await p.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new v.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,o,a,u){this.logService.trace(`Started extracting the extension from ${o} to ${a}`);try{await p.Promises.rm(a)}catch(g){throw new m.ExtensionManagementError(this.joinErrors(g).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(o,a,{sourcePath:"extension",overwrite:!0},u),this.logService.info(`Extracted extension to ${a}:`,t.id)}catch(g){try{await p.Promises.rm(a)}catch(A){}let b=m.ExtensionManagementErrorCode.Extract;throw g instanceof h.ExtractError&&(g.type==="CorruptZip"?b=m.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(b=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(g.message,b)}}async rename(t,o,a,u){try{await p.Promises.rename(o,a)}catch(g){if(y.isWindows&&g&&g.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${o} to ${a} with 'EPERM' error. Trying again...`,t.id),this.rename(t,o,a,u);throw new m.ExtensionManagementError(g.message||(0,E.localize)(3,null,o,a),g.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const o=this.scanDevSystemExtensions(),[a,u]=await Promise.all([t,o]);return[...a,...u]}async scanExtensionsInDir(t,o){const a=new T.Limiter(10),u=await this.fileService.resolve(w.URI.file(t));return u.children?(await Promise.all(u.children.filter(b=>b.isDirectory).map(b=>a.queue(async()=>o===1&&(0,C.basename)(b.resource).indexOf(".")===0?null:this.scanExtension(b.resource,o))))).filter(b=>b&&b.identifier):[]}async scanExtension(t,o){try{const a=await this.fileService.resolve(t);if(a.children){const{manifest:u,metadata:g}=await this.readManifest(t.fsPath),b=a.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,A=a.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource,O={id:(0,v.getGalleryExtensionId)(u.publisher,u.name)},U={type:o,identifier:O,manifest:u,location:t,readmeUrl:b,changelogUrl:A,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return g&&(this.setMetadata(U,g),U.installedTimestamp=g.installedTimestamp),U}}catch(a){o!==0&&this.logService.trace(a)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(a=>t.some(u=>(0,v.areSameExtensions)(a.identifier,{id:u})))}else return[]}setMetadata(t,o){t.publisherDisplayName=o.publisherDisplayName||null,t.publisherId=o.publisherId||null,t.identifier.uuid=o.id,t.isMachineScoped=!!o.isMachineScoped,t.isBuiltin=t.type===0||!!o.isBuiltin}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),a=new Set;for(const b of o)t[new v.ExtensionIdentifierWithVersion(b.identifier,b.manifest.version).key()]||a.add(b.identifier.id.toLowerCase());const u=(0,v.groupByExtension)(o,b=>b.identifier);await T.Promises.settled(u.map(async b=>{const A=b.sort((O,U)=>I.rcompare(O.manifest.version,U.manifest.version))[0];a.has(A.identifier.id.toLowerCase())||await this.beforeRemovingExtension(A)}));const g=o.filter(b=>t[new v.ExtensionIdentifierWithVersion(b.identifier,b.manifest.version).key()]);await T.Promises.settled(g.map(b=>this.removeUninstalledExtension(b)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),o=[],a=(0,v.groupByExtension)(t,u=>u.identifier);o.push(...(0,k.flatten)(a.map(u=>u.sort((g,b)=>I.rcompare(g.manifest.version,b.manifest.version)).slice(1)))),await T.Promises.settled(o.map(u=>this.removeExtension(u,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const o=Array.isArray(t)?t:[t];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((a,u)=>new Error(`${a.message}${a.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=P.normalize(P.join(r.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const o=[p.Promises.readFile(P.join(t,"package.json"),"utf8").then(b=>this.parseManifest(b)),p.Promises.readFile(P.join(t,"package.nls.json"),"utf8").then(void 0,b=>b.code!=="ENOENT"?Promise.reject(b):"{}").then(b=>JSON.parse(b))],[{manifest:a,metadata:u},g]=await Promise.all(o);return{manifest:(0,d.localizeManifest)(a,g),metadata:u}}parseManifest(t){return new Promise((o,a)=>{try{const u=JSON.parse(t),g=u.__metadata||null;o({manifest:u,metadata:g})}catch(u){a(new Error((0,E.localize)(4,null)))}})}};s=he([J(1,c.IFileService),J(2,l.ILogService),J(3,S.INativeEnvironmentService),J(4,n.IProductService)],s),e.ExtensionsScanner=s}),define(te[242],ne([0,1,38,7,15,9,4,31,18,62,8,29,20,66,135,80,11,205,30,36,189,177,240,190,241,219,78,14,6,10,27,22,37]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v,d,c,l,n,s,i,t,o,a,u,g,b,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let U=class extends m.AbstractExtensionManagementService{constructor(M,W,j,q,z,K,F,B,V){super(M,W,j,B);this.environmentService=q,this.downloadService=z,this.fileService=F;const Q=this._register(K.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(K.createInstance(i.ExtensionsScanner,G=>Q.postUninstall(G))),this.manifestCache=this._register(new s.ExtensionsManifestCache(q,this)),this.extensionsDownloader=this._register(K.createInstance(c.ExtensionsDownloader));const Z=this._register(new t.ExtensionsWatcher(this,F,q,j,V));this._register(Z.onDidChangeExtensionsByAnotherSource(({added:G,removed:H})=>{G.length&&this._onDidInstallExtensions.fire(G.map(re=>({identifier:re.identifier,operation:0,local:re}))),H.forEach(re=>this._onDidUninstallExtension.fire({identifier:re}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const M=await this.isAlpineLinux(),W=(0,v.getTargetPlatform)(M?"alpine":r.platform,P.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",W),W})()),this._targetPlatformPromise}async isAlpineLinux(){if(!r.isLinux)return!1;let M;try{M=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch(W){try{M=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(j){this.logService.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(j))}}return!!M&&(M.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(M){this.logService.trace("ExtensionManagementService#zip",M.identifier.id);const W=await this.collectFiles(M),j=await(0,p.zip)((0,y.joinPath)(this.environmentService.tmpDir,(0,w.generateUuid)()).fsPath,W);return I.URI.file(j)}async unzip(M){return this.logService.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const W=await this.downloadVsix(M),j=R.resolve(W.fsPath);return(0,n.getManifest)(j)}getInstalled(M=null){return this.extensionsScanner.scanExtensions(M)}async install(M,W={}){this.logService.trace("ExtensionManagementService#install",M.toString());const j=await this.downloadVsix(M),q=await(0,n.getManifest)(R.resolve(j.fsPath));if(q.engines&&q.engines.vscode&&!(0,o.isEngineValid)(q.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,d.getGalleryExtensionId)(q.publisher,q.name),this.productService.version));return this.installExtension(q,j,W)}async updateMetadata(M,W){return this.logService.trace("ExtensionManagementService#updateMetadata",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},...W}),this.manifestCache.invalidate(),M}async updateExtensionScope(M,W){return this.logService.trace("ExtensionManagementService#updateExtensionScope",M.identifier.id),M=await this.extensionsScanner.saveMetadataForLocalExtension(M,{...M.manifest.__metadata||{},isMachineScoped:W}),this.manifestCache.invalidate(),M}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(M){if(M.scheme===D.Schemas.file)return M;const W=(0,y.joinPath)(this.environmentService.tmpDir,(0,w.generateUuid)());return await this.downloadService.download(M,W),W}createInstallExtensionTask(M,W,j){return I.URI.isUri(W)?new L(M,W,j,this.galleryService,this.extensionsScanner,this.logService):new N(W,j,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(M,W){return new $(M,W,this.extensionsScanner)}async collectFiles(M){const W=async q=>{let z=await f.Promises.readdir(q);z=z.map(B=>R.join(q,B));const K=await Promise.all(z.map(B=>f.Promises.stat(B)));let F=Promise.resolve([]);return K.forEach((B,V)=>{const Q=z[V];B.isFile()&&(F=F.then(Z=>[...Z,Q])),B.isDirectory()&&(F=F.then(Z=>W(Q).then(G=>[...Z,...G])))}),F};return(await W(M.location.fsPath)).map(q=>({path:`extension/${R.relative(M.location.fsPath,q)}`,localPath:q}))}};U=he([J(0,v.IExtensionGalleryService),J(1,A.ITelemetryService),J(2,g.ILogService),J(3,S.INativeEnvironmentService),J(4,E.IDownloadService),J(5,u.IInstantiationService),J(6,a.IFileService),J(7,b.IProductService),J(8,O.IUriIdentityService)],U),e.ExtensionManagementService=U;class x extends m.AbstractExtensionTask{constructor(M,W,j,q){super();this.identifier=M,this.source=W,this.extensionsScanner=j,this.logService=q,this._operation=1}get operation(){return this._operation}async installExtension(M,W){try{const j=await this.unsetUninstalledAndGetLocal(M.identifierWithVersion);if(j)return M.metadata?this.extensionsScanner.saveMetadataForLocalExtension(j,M.metadata):j}catch(j){throw r.isMacintosh?new v.ExtensionManagementError(h.localize(1,null),v.ExtensionManagementErrorCode.Internal):new v.ExtensionManagementError(h.localize(2,null),v.ExtensionManagementErrorCode.Internal)}return this.extract(M,W)}async unsetUninstalledAndGetLocal(M){if(!await this.isUninstalled(M))return null;this.logService.trace("Removing the extension from uninstalled list:",M.id);const j=await this.extensionsScanner.setInstalled(M);return this.logService.info("Removed the extension from uninstalled list:",M.id),j}async isUninstalled(M){return!!(await this.extensionsScanner.getUninstalledExtensions())[M.key()]}async extract({zipPath:M,identifierWithVersion:W,metadata:j},q){let z=await this.extensionsScanner.extractUserExtension(W,M,j,q);return this.logService.info("Extracting completed.",W.id),z}}class N extends x{constructor(M,W,j,q,z){super(M.identifier,M,q,z);this.gallery=M,this.options=W,this.extensionsDownloader=j}async doRun(M){const j=(await this.extensionsScanner.scanExtensions(null)).find(z=>(0,d.areSameExtensions)(z.identifier,this.gallery.identifier));j&&(this._operation=2);const q=await this.downloadInstallableExtension(this.gallery,this._operation);q.metadata.isMachineScoped=this.options.isMachineScoped||j?.isMachineScoped,q.metadata.isBuiltin=this.options.isBuiltin||j?.isBuiltin;try{const z=await this.installExtension(q,M);return j&&C.neq(j.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(j),z}catch(z){throw await this.deleteDownloadedVSIX(q.zipPath),z}}async deleteDownloadedVSIX(M){try{await this.extensionsDownloader.delete(I.URI.file(M))}catch(W){this.logService.warn("Error while deleting the downloaded vsix",M.toString(),(0,T.getErrorMessage)(W))}}async downloadInstallableExtension(M,W){const j={id:M.identifier.uuid,publisherId:M.publisherId,publisherDisplayName:M.publisherDisplayName};let q;try{this.logService.trace("Started downloading extension:",M.identifier.id),q=(await this.extensionsDownloader.downloadExtension(M,W)).fsPath,this.logService.info("Downloaded extension:",M.identifier.id,q)}catch(z){throw new v.ExtensionManagementError((0,m.joinErrors)(z).message,v.ExtensionManagementErrorCode.Download)}try{const z=await(0,n.getManifest)(q);return{zipPath:q,identifierWithVersion:new d.ExtensionIdentifierWithVersion(M.identifier,z.version),metadata:j}}catch(z){throw await this.deleteDownloadedVSIX(q),new v.ExtensionManagementError((0,m.joinErrors)(z).message,v.ExtensionManagementErrorCode.Invalid)}}}class L extends x{constructor(M,W,j,q,z,K){super({id:(0,d.getGalleryExtensionId)(M.publisher,M.name)},W,z,K);this.manifest=M,this.location=W,this.options=j,this.galleryService=q}async doRun(M){const W=new d.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),q=(await this.extensionsScanner.scanExtensions(1)).find(K=>(0,d.areSameExtensions)(this.identifier,K.identifier)),z=await this.getMetadata(this.identifier.id,M);if(z.isMachineScoped=this.options.isMachineScoped||q?.isMachineScoped,z.isBuiltin=this.options.isBuiltin||q?.isBuiltin,q)if(this._operation=2,W.equals(new d.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version)))try{await this.extensionsScanner.removeExtension(q,"existing")}catch(K){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else C.gt(q.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(q);else{const K=await this.unsetUninstalledAndGetLocal(W);if(K)try{await this.extensionsScanner.removeExtension(K,"existing")}catch(F){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:W,metadata:z},M)}async getMetadata(M,W){try{const j=(await this.galleryService.query({names:[M],pageSize:1},W)).firstPage[0];if(j)return{id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId}}catch(j){}return{}}}class $ extends m.AbstractExtensionTask{constructor(M,W,j){super();this.extension=M,this.options=W,this.extensionsScanner=j}async doRun(M){const W=[],j=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const q=new d.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);W.push(...j.filter(z=>q.equals(new d.ExtensionIdentifierWithVersion(z.identifier,z.manifest.version))))}else W.push(...j.filter(q=>(0,d.areSameExtensions)(q.identifier,this.extension.identifier)));if(!W.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...W),this.options.remove)for(const q of W)try{M.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(q)}catch(z){throw new Error(h.localize(6,null,(0,k.toErrorMessage)(z)))}}}}),define(te[243],ne([0,1,83,57,33,19,7,3,2,9,4,29,34,73,252]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class E{constructor(u){this.socket=u,this._errorListener=g=>{if(g){if(g.code==="EPIPE")return;(0,r.onUnexpectedError)(g)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const g=b=>u(R.VSBuffer.wrap(b));return this.socket.on("data",g),{dispose:()=>this.socket.off("data",g)}}onClose(u){const g=b=>{u({type:0,hadError:b,error:void 0})};return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,g=>{if(g){if(g.code==="EPIPE")return;(0,r.onUnexpectedError)(g)}})}catch(g){if(g.code==="EPIPE")return;(0,r.onUnexpectedError)(g)}}end(){this.socket.end()}drain(){return new Promise((u,g)=>{if(this.socket.bufferSize===0){u();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),u()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.NodeSocket=E;var S;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var m;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(m||(m={}));class v extends y.Disposable{constructor(u,g,b,A){super();this._onDidZlibFlush=this._register(new P.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new P.Emitter),this._onClose=this._register(new P.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=g,this._recordInflateBytes=A,g?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),(0,r.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),b&&(this._zlibInflate.write(b.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),(0,r.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new p.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):R.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let g=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,g=g.slice(0,g.length-4),this._isEnded||this._write(R.VSBuffer.wrap(g),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,g){let b=2;u.byteLength<126?b+=0:u.byteLength<2**16?b+=2:b+=8;const A=R.VSBuffer.alloc(b);if(g?A.writeUInt8(194,0):A.writeUInt8(130,0),u.byteLength<126)A.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){A.writeUInt8(126,1);let O=1;A.writeUInt8(u.byteLength>>>8&255,++O),A.writeUInt8(u.byteLength>>>0&255,++O)}else{A.writeUInt8(127,1);let O=1;A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(u.byteLength>>>24&255,++O),A.writeUInt8(u.byteLength>>>16&255,++O),A.writeUInt8(u.byteLength>>>8&255,++O),A.writeUInt8(u.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=A.byteLength+u.byteLength,this.socket.write(R.VSBuffer.concat([A,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const g=this._incomingData.peek(this._state.readLen),b=g.readUInt8(0),A=(b&128)>>>7,O=(b&64)>>>6,U=g.readUInt8(1),x=(U&128)>>>7,N=U&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(N===126?2:0)+(N===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const g=this._incomingData.read(this._state.readLen),b=g.readUInt8(1),A=(b&128)>>>7;let O=b&127,U=1;O===126?O=g.readUInt8(++U)*2**8+g.readUInt8(++U):O===127&&(O=g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*0+g.readUInt8(++U)*2**24+g.readUInt8(++U)*2**16+g.readUInt8(++U)*2**8+g.readUInt8(++U));let x=0;A&&(x=g.readUInt8(++U)*2**24+g.readUInt8(++U)*2**16+g.readUInt8(++U)*2**8+g.readUInt8(++U)),this._state.state=3,this._state.readLen=O,this._state.mask=x}else if(this._state.state===3){const g=this._incomingData.read(this._state.readLen);d(g,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(g.buffer)),this._zlibInflate.write(g.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const b=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=b.length,this._onData.fire(R.VSBuffer.wrap(b))})):(this._totalIncomingDataBytes+=g.byteLength,this._onData.fire(g))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await P.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=v;function d(a,u){if(u===0)return;let g=a.byteLength>>>2;for(let N=0;N<g;N++){const L=a.readUInt32BE(N*4);a.writeUInt32BE(L^u,N*4)}let b=g*4,A=a.byteLength-b;const O=u>>>24&255,U=u>>>16&255,x=u>>>8&255;A>=1&&a.writeUInt8(a.readUInt8(b)^O,b),A>=2&&a.writeUInt8(a.readUInt8(b+1)^U,b+1),A>=3&&a.writeUInt8(a.readUInt8(b+2)^x,b+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function l(){const a=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):u=(0,C.join)((0,D.tmpdir)(),`vscode-ipc-${a}.sock`),s(u),u}e.createRandomIPCHandle=l;function n(a,u,g){const b=(0,k.createHash)("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${b}-${g}-${u}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${b.substr(0,8)}-${g}-${u}.sock`):A=(0,C.join)(a,`${g}-${u}.sock`),s(A),A}e.createStaticIPCHandle=n;function s(a){const u=c[I.platform];typeof u=="number"&&a.length>=u&&console.warn(`WARNING: IPC handle "${a}" is longer than ${u} chars, try a shorter --user-data-dir`)}class i extends f.IPCServer{constructor(u){super(i.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const g=P.Event.fromNodeEventEmitter(u,"connection");return P.Event.map(g,b=>({protocol:new p.Protocol(new E(b)),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(b,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function t(a){return new Promise((u,g)=>{const b=(0,T.createServer)();b.on("error",g),b.listen(a,()=>{b.removeListener("error",g),u(new i(b))})})}e.serve=t;function o(a,u){return new Promise((g,b)=>{const A=(0,T.createConnection)(a,()=>{A.removeListener("error",b),g(p.Client.fromSocket(new E(A),u))});A.once("error",b)})}e.connect=o}),define(te[244],ne([0,1,57,243]),function(X,e,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,R,r,P){const y=I=>P(I,void 0),C=k.createConnection({host:D,port:R},()=>{C.removeListener("error",y);const I=Buffer.alloc(16);for(let h=0;h<16;h++)I[h]=Math.round(Math.random()*256);const w=I.toString("base64");let f=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${R}/?${r}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${w}`];C.write(f.join(`\r
`)+`\r
\r
`);const p=h=>{h.toString().indexOf(`\r
\r
`)>=0&&(C.off("data",p),P(void 0,new T.NodeSocket(C)))};C.on("data",p)});C.once("error",y)}}}),define(te[245],ne([0,1,57,117,244,5,2,21,10,27,187,63,93]),function(X,e,k,T,D,R,r,P,y,C,I,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(v,d,c,l,n){let s;for(let i=3;i&&(s&&s.dispose(),s=await new h(v,d,c,l,n).waitForReady(),!(n&&T.BROWSER_RESTRICTED_PORTS[n]||!T.BROWSER_RESTRICTED_PORTS[s.tunnelLocalPort]));i--);return s}class h extends r.Disposable{constructor(d,c,l,n,s){super();this.defaultTunnelHost=c,this.suggestedLocalPort=s,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=d,this._server=k.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=n,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){let d=await(0,T.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(d=0,this._server.listen(d,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(d){d.pause();const c=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,I.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),n=l.getSocket().socket,s=l.readEntireBuffer();l.dispose(),s.byteLength>0&&d.write(s.buffer),d.on("end",()=>{this._socketsDispose.delete(d.localAddress),n.end()}),d.on("close",()=>n.end()),d.on("error",()=>{this._socketsDispose.delete(d.localAddress),n.destroy()}),n.on("end",()=>d.end()),n.on("close",()=>d.end()),n.on("error",()=>{d.destroy()}),d.pipe(n),n.pipe(d),this._socketsDispose.set(d.localAddress,()=>{d.end(),n.end()})}}let E=class extends w.AbstractTunnelService{constructor(d,c,l,n,s){super(c);this.socketFactory=d,this.signService=l,this.productService=n,this.configurationService=s}get defaultTunnelHost(){const d=this.configurationService.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(d,c,l,n,s,i,t){const o=this.getTunnelFromMap(c,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,c,l,n,s,i,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${l} on local port ${n}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:d,signService:this.signService,logService:this.logService,ipcLogger:null},u=p(a,this.defaultTunnelHost,c,l,n);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,l,u),u}}};E=he([J(1,y.ILogService),J(2,f.ISignService),J(3,C.IProductService),J(4,P.IConfigurationService)],E),e.BaseTunnelService=E;let S=class extends E{constructor(d,c,l,n){super(D.nodeSocketFactory,d,c,l,n)}};S=he([J(0,y.ILogService),J(1,f.ISignService),J(2,C.IProductService),J(3,P.IConfigurationService)],S),e.TunnelService=S;let m=class extends r.Disposable{constructor(d,c,l,n){super();this.logService=d,this.productService=c,this.signService=l,this.configurationService=n,this._tunnelServices=new Map}async openTunnel(d,c,l,n,s,i,t,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${n} on local port ${s}.`),!this._tunnelServices.has(d)){const a=new S(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(d,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(d))})}return this._tunnelServices.get(d).openTunnel(c,l,n,s,i,t,o)}};m=he([J(0,y.ILogService),J(1,C.IProductService),J(2,f.ISignService),J(3,P.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[253],ne([0,1,74,33,38,7,2,15,18,8,34,121,183,163,184,174,175,176,161,165,21,185,79,204,80,195,11,156,200,208,30,164,206,242,81,159,14,180,182,53,6,171,85,172,173,60,191,10,87,61,88,27,194,44,23,202,203,22,94,95,96,45,209,210,97,212,218,99,100,101,24,64,231,232,233,65,234,235,236,237,238,239,82,178,93,199,63,245,192,193,92,198,86,207,37,220]),function(X,e,k,T,D,R,r,P,y,C,I,w,f,p,h,E,S,m,v,d,c,l,n,s,i,t,o,a,u,g,b,A,O,U,x,N,L,$,_,M,W,j,q,z,K,F,B,V,Q,Z,G,H,re,ie,ce,le,fe,de,be,Ie,Ee,Ae,Pe,Le,Fe,Ne,$e,qe,ee,oe,ae,pe,ye,_e,Re,Y,se,ue,ge,me,Ce,ke,Te,Se,we,De,Oe,Me,Qe,Ye,We,Pt,vt,Dt,Rt,kt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends r.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new w.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),k.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Ue="vscode:electron-main->shared-process=disposeWorker",xe=(He,ze)=>this.onDisposeWorker(ze);k.ipcRenderer.on(Ue,xe),this._register((0,r.toDisposable)(()=>k.ipcRenderer.removeListener(Ue,xe)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,ae.registerConfiguration)(),ve.invokeFunction(Ue=>{const xe=Ue.get(V.ILogService);xe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(xe)}),this._register((0,r.combinedDisposable)(ve.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(h.LanguagePackCachedDataCleaner),ve.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(S.LogsDataCleaner),ve.createInstance(E.LocalizationsUpdater),ve.createInstance(p.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new q.ServiceCollection,Ue={_serviceBrand:void 0,...G.default};ve.set(H.IProductService,Ue);const xe=new I.StaticRouter(Be=>Be==="main"),He=new z.MessagePortMainProcessService(this.server,xe);ve.set(K.IMainProcessService,He);const ze=new a.NativeEnvironmentService(this.configuration.args,Ue);ve.set(o.INativeEnvironmentService,ze);const rt=new Q.LogLevelChannelClient(this.server.getChannel("logLevel",xe)),Ze=new Q.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,He.getChannel("logger"));ve.set(V.ILoggerService,Ze);const at=this._register(new V.MultiplexLogService([this._register(new V.ConsoleLogger(this.configuration.logLevel)),this._register(Ze.createLogger((0,y.joinPath)(C.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ge=this._register(new Q.FollowerLogService(rt,at));ve.set(V.ILogService,Ge),this.sharedProcessWorkerService=new Pt.SharedProcessWorkerService(Ge,Ue,ze),ve.set(We.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Je=this._register(new $.FileService(Ge));ve.set(L.IFileService,Je);const ct=this._register(new _.DiskFileSystemProvider(Ge));Je.registerProvider(P.Schemas.file,ct);const je=this._register(new l.ConfigurationService(ze.settingsResource,Je));ve.set(c.IConfigurationService,je);const nt=new le.NativeStorageService(void 0,He,ze);ve.set(ce.IStorageService,nt),this._register((0,r.toDisposable)(()=>nt.flush())),await Promise.all([je.initialize(),nt.initialize()]),ve.set(vt.IUserConfigurationFileService,I.ProxyChannel.toService(He.getChannel(vt.UserConfigurationFileServiceId))),ve.set(Rt.IUriIdentityService,new kt.UriIdentityService(Je)),ve.set(ie.IRequestService,new M.SyncDescriptor(re.RequestService)),ve.set(v.IChecksumService,new M.SyncDescriptor(d.ChecksumService));const st=I.ProxyChannel.toService(He.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(Z.INativeHostService,st),ve.set(i.IDownloadService,new M.SyncDescriptor(t.DownloadService));const lt=this._register(new ke.ActiveWindowManager(st)),ut=new I.StaticRouter(Be=>lt.getActiveClientId().then(dt=>Be===dt));ve.set(x.IExtensionRecommendationNotificationService,new N.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new Dt.AssignmentService(this.configuration.machineId,je,Ue);let Xe;const et=[];if((0,Ae.supportsTelemetry)(Ue,ze)){const Be=new Ie.TelemetryLogAppender(Ze,ze);et.push(Be);const{appRoot:dt,extensionsPath:_t,installSourcePath:Ot}=ze;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const ot=await ht.getTreatment("telemetryMigration")??!1,ft=Ue.quality!=="stable";if(ft&&ot){const wt=new Pe.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ot,!0);this._register((0,r.toDisposable)(()=>wt.flush())),et.push(wt)}const yt=new Pe.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ft?!1:ot,ot&&ft);this._register((0,r.toDisposable)(()=>yt.flush())),et.push(yt)}Xe=new Ee.TelemetryService({appenders:et,commonProperties:(0,fe.resolveCommonProperties)(Je,(0,T.release)(),(0,T.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[dt,_t]},je)}else{Xe=Ae.NullTelemetryService;const Be=Ae.NullAppender;et.push(Be)}this.server.registerChannel("telemetryAppender",new be.TelemetryAppenderChannel(et)),ve.set(de.ITelemetryService,Xe);const At=new Le.CustomEndpointTelemetryService(je,Xe,Ze,ze);ve.set(de.ICustomEndpointTelemetryService,At),ve.set(b.IExtensionManagementService,new M.SyncDescriptor(U.ExtensionManagementService)),ve.set(b.IExtensionGalleryService,new M.SyncDescriptor(g.ExtensionGalleryService)),ve.set(b.IExtensionTipsService,new M.SyncDescriptor(O.ExtensionTipsService)),ve.set(F.ILocalizationsService,new M.SyncDescriptor(B.LocalizationsService)),ve.set(n.IDiagnosticsService,new M.SyncDescriptor(s.DiagnosticsService)),ve.set(pe.IUserDataSyncAccountService,new M.SyncDescriptor(pe.UserDataSyncAccountService)),ve.set(ae.IUserDataSyncLogService,new M.SyncDescriptor(Re.UserDataSyncLogService)),ve.set(ae.IUserDataSyncUtilService,new _e.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),ve.set(b.IGlobalExtensionEnablementService,new M.SyncDescriptor(u.GlobalExtensionEnablementService)),ve.set(ee.IIgnoredExtensionsManagementService,new M.SyncDescriptor(ee.IgnoredExtensionsManagementService)),ve.set(qe.IExtensionsStorageSyncService,new M.SyncDescriptor(qe.ExtensionsStorageSyncService)),ve.set(ae.IUserDataSyncStoreManagementService,new M.SyncDescriptor(me.UserDataSyncStoreManagementService)),ve.set(ae.IUserDataSyncStoreService,new M.SyncDescriptor(me.UserDataSyncStoreService)),ve.set(Y.IUserDataSyncMachinesService,new M.SyncDescriptor(Y.UserDataSyncMachinesService)),ve.set(ae.IUserDataSyncBackupStoreService,new M.SyncDescriptor(ye.UserDataSyncBackupStoreService)),ve.set(ae.IUserDataAutoSyncEnablementService,new M.SyncDescriptor(oe.UserDataAutoSyncEnablementService)),ve.set(ae.IUserDataSyncResourceEnablementService,new M.SyncDescriptor(se.UserDataSyncResourceEnablementService)),ve.set(ae.IUserDataSyncService,new M.SyncDescriptor(ue.UserDataSyncService));const St=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:je.getValue("terminal.integrated.persistentSessionScrollback")??100},je,ze,Ge,Xe);return await St.initialize(),ve.set(Ne.ILocalPtyService,this._register(St)),ve.set(Te.IExtensionHostStarter,this._register(new Se.ExtensionHostStarter(Ge))),ve.set(we.ISignService,new M.SyncDescriptor(De.SignService)),ve.set(Oe.ISharedTunnelsService,new M.SyncDescriptor(Me.SharedTunnelsService)),ve.set(Qe.ISharedProcessTunnelService,new M.SyncDescriptor(Ye.SharedProcessTunnelService)),new j.InstantiationService(ve)}initChannels(ve){const Ue=new A.ExtensionManagementChannel(ve.get(b.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const xe=I.ProxyChannel.fromService(ve.get(F.ILocalizationsService));this.server.registerChannel("localizations",xe);const He=I.ProxyChannel.fromService(ve.get(n.IDiagnosticsService));this.server.registerChannel("diagnostics",He);const ze=new A.ExtensionTipsChannel(ve.get(b.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const rt=I.ProxyChannel.fromService(ve.get(v.IChecksumService));this.server.registerChannel("checksum",rt);const Ze=new _e.UserDataSyncMachinesServiceChannel(ve.get(Y.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ze);const at=I.ProxyChannel.fromService(ve.get(de.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Ge=new _e.UserDataSyncAccountServiceChannel(ve.get(pe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ge);const Je=new _e.UserDataSyncStoreManagementServiceChannel(ve.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Je);const ct=new ge.UserDataSyncChannel(ve.get(ae.IUserDataSyncService),ve.get(V.ILogService));this.server.registerChannel("userDataSync",ct);const je=this._register(ve.get(W.IInstantiationService).createInstance(Ce.UserDataAutoSyncService)),nt=new _e.UserDataAutoSyncChannel(je);this.server.registerChannel("userDataAutoSync",nt);const st=ve.get(Ne.ILocalPtyService),lt=I.ProxyChannel.fromService(st);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,lt);const ut=I.ProxyChannel.fromService(ve.get(Te.IExtensionHostStarter));this.server.registerChannel(Te.ipcExtensionHostStarterChannelName,ut);const ht=I.ProxyChannel.fromService(ve.get(Qe.ISharedProcessTunnelService));this.server.registerChannel(Qe.ipcSharedProcessTunnelChannelName,ht);const Xe=I.ProxyChannel.fromService(ve.get(We.ISharedProcessWorkerService));this.server.registerChannel(We.ipcSharedProcessWorkerChannelName,Xe)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Ue=>{(0,R.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,R.setUnexpectedErrorHandler)(Ue=>{const xe=(0,D.toErrorMessage)(Ue,!0);!xe||ve.error(`[uncaught exception in sharedProcess]: ${xe}`)})}}async function Lt(pt){const ve=new Tt(pt);k.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),k.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Lt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3bd29c1d6c6ef5b6265614def99b7257b671ae19/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
