/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","fs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/process","vs/base/common/extpath","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","child_process","vs/base/common/errorMessage","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],J=function(j){for(var e=[],p=0,D=j.length;p<D;p++)e[p]=Q[j[p]];return e};define(Q[104],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(D,C){if(!D)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=p}),define(Q[47],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(i){return(I,h,f)=>{let y=null,b=null;if(typeof f.value=="function"?(y="value",b=f.value):typeof f.get=="function"&&(y="get",b=f.get),!b)throw new Error("not supported");f[y]=i(b,h)}}e.createDecorator=p;function D(i,I,h){let f=null,y=null;if(typeof h.value=="function"?(f="value",y=h.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(f="get",y=h.get),!y)throw new Error("not supported");const b=`$memoize$${I}`;h[f]=function(...g){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,g)}),this[b]}}e.memoize=D;function C(i,I,h){return p((f,y)=>{const b=`$debounce$${y}`,g=`$debounce$result$${y}`;return function(...w){this[g]||(this[g]=h?h():void 0),clearTimeout(this[b]),I&&(this[g]=I(this[g],...w),w=[this[g]]),this[b]=setTimeout(()=>{f.apply(this,w),this[g]=h?h():void 0},i)}})}e.debounce=C;function k(i,I,h){return p((f,y)=>{const b=`$throttle$timer$${y}`,g=`$throttle$result$${y}`,w=`$throttle$lastRun$${y}`,t=`$throttle$pending$${y}`;return function(...m){if(this[g]||(this[g]=h?h():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[g]=I(this[g],...m)),this[t])return;const E=this[w]+i;E<=Date.now()?(this[w]=Date.now(),f.apply(this,[this[g]]),this[g]=h?h():void 0):(this[t]=!0,this[b]=setTimeout(()=>{this[t]=!1,this[w]=Date.now(),f.apply(this,[this[g]]),this[g]=h?h():void 0},E-Date.now()))}})}e.throttle=k}),define(Q[16],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=p,e.errorHandler=new p;function D(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=D;function C(u){h(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=C;function k(u){h(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=k;function i(u){if(u instanceof Error){let{name:r,message:a}=u;const s=u.stacktrace||u.stack;return{$isError:!0,name:r,message:a,stack:s}}return u}e.transformErrorForSerialization=i;const I="Canceled";function h(u){return u instanceof Error&&u.name===I&&u.message===I}e.isPromiseCanceledError=h;class f extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=f;function y(){const u=new Error(I);return u.name=u.message,u}e.canceled=y;function b(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=b;function g(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=g;function w(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function t(u){const r=new Error(`${u} has been disposed`);return r.name="DISPOSED",r}e.disposed=t;function m(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=m;class E extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=E;class S extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=S;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function l(u){const r=u;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=l;function c(u,r=Object.create(null)){const a=new Error(u);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=c}),define(Q[31],J([0,1,16]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function D(F,R=0){return F[F.length-(1+R)]}e.tail=D;function C(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=C;function k(F,R,O=($,X)=>$===X){if(F===R)return!0;if(!F||!R||F.length!==R.length)return!1;for(let $=0,X=F.length;$<X;$++)if(!O(F[$],R[$]))return!1;return!0}e.equals=k;function i(F,R,O){let $=0,X=F.length-1;for(;$<=X;){const V=($+X)/2|0,B=O(F[V],R);if(B<0)$=V+1;else if(B>0)X=V-1;else return V}return-($+1)}e.binarySearch=i;function I(F,R){let O=0,$=F.length;if($===0)return 0;for(;O<$;){const X=Math.floor((O+$)/2);R(F[X])?$=X:O=X+1}return O}e.findFirstInSorted=I;function h(F,R,O){if(F=F|0,F>=R.length)throw new TypeError("invalid index");let $=R[Math.floor(R.length*Math.random())],X=[],V=[],B=[];for(let x of R){const te=O(x,$);te<0?X.push(x):te>0?V.push(x):B.push(x)}return F<X.length?h(F,X,O):F<X.length+B.length?B[0]:h(F-(X.length+B.length),V,O)}e.quickSelect=h;function f(F,R){const O=[];let $;for(const X of F.slice(0).sort(R))!$||R($[0],X)!==0?($=[X],O.push($)):$.push(X);return O}e.groupBy=f;function y(F,R,O){const $=[];function X(x,te,ce){if(te===0&&ce.length===0)return;const se=$[$.length-1];se&&se.start+se.deleteCount===x?(se.deleteCount+=te,se.toInsert.push(...ce)):$.push({start:x,deleteCount:te,toInsert:ce})}let V=0,B=0;for(;;){if(V===F.length){X(V,0,R.slice(B));break}if(B===R.length){X(V,F.length-V,[]);break}const x=F[V],te=R[B],ce=O(x,te);ce===0?(V+=1,B+=1):ce<0?(X(V,1,[]),V+=1):ce>0&&(X(V,0,[te]),B+=1)}return $}e.sortedDiff=y;function b(F,R,O){const $=y(F,R,O),X=[],V=[];for(const B of $)X.push(...F.slice(B.start,B.start+B.deleteCount)),V.push(...B.toInsert);return{removed:X,added:V}}e.delta=b;function g(F,R,O){if(O===0)return[];const $=F.slice(0,O).sort(R);return t(F,R,$,O,F.length),$}e.top=g;function w(F,R,O,$,X){return O===0?Promise.resolve([]):new Promise((V,B)=>{(async()=>{const x=F.length,te=F.slice(0,O).sort(R);for(let ce=O,se=Math.min(O+$,x);ce<x;ce=se,se=Math.min(se+$,x)){if(ce>O&&await new Promise(ie=>setTimeout(ie)),X&&X.isCancellationRequested)throw(0,p.canceled)();t(F,R,te,ce,se)}return te})().then(V,B)})}e.topAsync=w;function t(F,R,O,$,X){for(const V=O.length;$<X;$++){const B=F[$];if(R(B,O[V-1])<0){O.pop();const x=I(O,te=>R(B,te)<0);O.splice(x,0,B)}}}function m(F){return F.filter(R=>!!R)}e.coalesce=m;function E(F){let R=0;for(let O=0;O<F.length;O++)F[O]&&(F[R]=F[O],R+=1);F.length=R}e.coalesceInPlace=E;function S(F,R,O){F.splice(O,0,F.splice(R,1)[0])}e.move=S;function P(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=P;function l(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=l;function c(F,R=O=>O){const O=new Set;return F.filter($=>{const X=R($);return O.has(X)?!1:(O.add(X),!0)})}e.distinct=c;function u(F){const R=Object.create(null);return O=>{const $=F(O);return R[$]?!1:(R[$]=!0,!0)}}e.uniqueFilter=u;function r(F,R){const O=a(F,R);if(O!==-1)return F[O]}e.findLast=r;function a(F,R){for(let O=F.length-1;O>=0;O--){const $=F[O];if(R($))return O}return-1}e.lastIndex=a;function s(F,R){return F.length>0?F[0]:R}e.firstOrDefault=s;function n(F,R,O=($,X)=>$===X){let $=0;for(let X=0,V=Math.min(F.length,R.length);X<V&&O(F[X],R[X]);X++)$++;return $}e.commonPrefixLength=n;function o(F){return[].concat(...F)}e.flatten=o;function d(F,R){let O=typeof R=="number"?F:0;typeof R=="number"?O=F:(O=0,R=F);const $=[];if(O<=R)for(let X=O;X<R;X++)$.push(X);else for(let X=O;X>R;X--)$.push(X);return $}e.range=d;function v(F,R,O){return F.reduce(($,X)=>($[R(X)]=O?O(X):X,$),Object.create(null))}e.index=v;function M(F,R){return F.push(R),()=>L(F,R)}e.insert=M;function L(F,R){const O=F.indexOf(R);if(O>-1)return F.splice(O,1),R}e.remove=L;function A(F,R,O){const $=F.slice(0,R),X=F.slice(R);return $.concat(O,X)}e.arrayInsert=A;function W(F,R){let O;if(typeof R=="number"){let $=R;O=()=>{const X=Math.sin($++)*179426549;return X-Math.floor(X)}}else O=Math.random;for(let $=F.length-1;$>0;$-=1){const X=Math.floor(O()*($+1)),V=F[$];F[$]=F[X],F[X]=V}}e.shuffle=W;function H(F,R){const O=F.indexOf(R);O>-1&&(F.splice(O,1),F.unshift(R))}e.pushToStart=H;function Z(F,R){const O=F.indexOf(R);O>-1&&(F.splice(O,1),F.push(R))}e.pushToEnd=Z;function ne(F,R){return Array.isArray(F)?F.map(R):R(F)}e.mapArrayOrNot=ne;function oe(F){return Array.isArray(F)?F:[F]}e.asArray=oe;function G(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=G;function T(F,R){for(const O of F){const $=R(O);if($!==void 0)return $}}e.mapFind=T;function z(F,R,O){const $=U(F,R),X=F.length,V=O.length;F.length=X+V;for(let B=X-1;B>=$;B--)F[B+V]=F[B];for(let B=0;B<V;B++)F[B+$]=O[B]}e.insertInto=z;function q(F,R,O,$){const X=U(F,R),V=F.splice(X,O);return z(F,X,$),V}e.splice=q;function U(F,R){return R<0?Math.max(R+F.length,0):Math.min(R,F.length)}function N(F,R){let O=Number.MAX_SAFE_INTEGER,$=0;return F.forEach((X,V)=>{const B=R(X);B<O&&(O=B,$=V)}),$}e.minIndex=N;function _(F,R){let O=Number.MIN_SAFE_INTEGER,$=0;return F.forEach((X,V)=>{const B=R(X);B>O&&(O=B,$=V)}),$}e.maxIndex=_;class Y{constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let O=this.firstIdx;for(;O<this.items.length&&R(this.items[O]);)O++;const $=O===this.firstIdx?null:this.items.slice(this.firstIdx,O);return this.firstIdx=O,$}takeFromEndWhile(R){let O=this.lastIdx;for(;O>=0&&R(this.items[O]);)O--;const $=O===this.lastIdx?null:this.items.slice(O+1,this.lastIdx+1);return this.lastIdx=O,$}peek(){return this.items[this.firstIdx]}dequeue(){const R=this.items[this.firstIdx];return this.firstIdx++,R}takeCount(R){const O=this.items.slice(this.firstIdx,this.firstIdx+R);return this.firstIdx+=R,O}}e.ArrayQueue=Y}),define(Q[42],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(D){const C=this;let k=!1,i;return function(){return k||(k=!0,i=D.apply(C,arguments)),i}}e.once=p}),define(Q[69],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(D){function C(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}D.is=C;const k=Object.freeze([]);function i(){return k}D.empty=i;function*I(u){yield u}D.single=I;function h(u){return u||k}D.from=h;function f(u){return!u||u[Symbol.iterator]().next().done===!0}D.isEmpty=f;function y(u){return u[Symbol.iterator]().next().value}D.first=y;function b(u,r){for(const a of u)if(r(a))return!0;return!1}D.some=b;function g(u,r){for(const a of u)if(r(a))return a}D.find=g;function*w(u,r){for(const a of u)r(a)&&(yield a)}D.filter=w;function*t(u,r){let a=0;for(const s of u)yield r(s,a++)}D.map=t;function*m(...u){for(const r of u)for(const a of r)yield a}D.concat=m;function*E(u){for(const r of u)for(const a of r)yield a}D.concatNested=E;function S(u,r,a){let s=a;for(const n of u)s=r(s,n);return s}D.reduce=S;function*P(u,r,a=u.length){for(r<0&&(r+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);r<a;r++)yield u[r]}D.slice=P;function l(u,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,u];const s=u[Symbol.iterator]();for(let n=0;n<r;n++){const o=s.next();if(o.done)return[a,D.empty()];a.push(o.value)}return[a,{[Symbol.iterator](){return s}}]}D.consume=l;function c(u,r,a=(s,n)=>s===n){const s=u[Symbol.iterator](),n=r[Symbol.iterator]();for(;;){const o=s.next(),d=n.next();if(o.done!==d.done)return!1;if(o.done)return!0;if(!a(o.value,d.value))return!1}}D.equals=c})(p=e.Iterable||(e.Iterable={}))}),define(Q[39],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var D;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(r){r.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function i(r,a=!1){let s=0,n=r.length,o="",d=0,v=16,M=0;function L(G){let T=0,z=0;for(;T<G;){const q=r.charCodeAt(s);if(q>=48&&q<=57)z=z*16+q-48;else if(q>=65&&q<=70)z=z*16+q-65+10;else if(q>=97&&q<=102)z=z*16+q-97+10;else break;s++,T++}return T<G&&(z=-1),z}function A(G){s=G,o="",d=0,v=16,M=0}function W(){const G=s;if(r.charCodeAt(s)===48)s++;else for(s++;s<r.length&&f(r.charCodeAt(s));)s++;if(s<r.length&&r.charCodeAt(s)===46)if(s++,s<r.length&&f(r.charCodeAt(s)))for(s++;s<r.length&&f(r.charCodeAt(s));)s++;else return M=3,r.substring(G,s);let T=s;if(s<r.length&&(r.charCodeAt(s)===69||r.charCodeAt(s)===101))if(s++,(s<r.length&&r.charCodeAt(s)===43||r.charCodeAt(s)===45)&&s++,s<r.length&&f(r.charCodeAt(s))){for(s++;s<r.length&&f(r.charCodeAt(s));)s++;T=s}else M=3;return r.substring(G,T)}function H(){let G="",T=s;for(;;){if(s>=n){G+=r.substring(T,s),M=2;break}const z=r.charCodeAt(s);if(z===34){G+=r.substring(T,s),s++;break}if(z===92){if(G+=r.substring(T,s),s++,s>=n){M=2;break}switch(r.charCodeAt(s++)){case 34:G+='"';break;case 92:G+="\\";break;case 47:G+="/";break;case 98:G+="\b";break;case 102:G+="\f";break;case 110:G+=`
`;break;case 114:G+="\r";break;case 116:G+="	";break;case 117:const U=L(4);U>=0?G+=String.fromCharCode(U):M=4;break;default:M=5}T=s;continue}if(z>=0&&z<=31)if(h(z)){G+=r.substring(T,s),M=2;break}else M=6;s++}return G}function Z(){if(o="",M=0,d=s,s>=n)return d=n,v=17;let G=r.charCodeAt(s);if(I(G)){do s++,o+=String.fromCharCode(G),G=r.charCodeAt(s);while(I(G));return v=15}if(h(G))return s++,o+=String.fromCharCode(G),G===13&&r.charCodeAt(s)===10&&(s++,o+=`
`),v=14;switch(G){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,o=H(),v=10;case 47:const T=s-1;if(r.charCodeAt(s+1)===47){for(s+=2;s<n&&!h(r.charCodeAt(s));)s++;return o=r.substring(T,s),v=12}if(r.charCodeAt(s+1)===42){s+=2;const z=n-1;let q=!1;for(;s<z;){if(r.charCodeAt(s)===42&&r.charCodeAt(s+1)===47){s+=2,q=!0;break}s++}return q||(s++,M=1),o=r.substring(T,s),v=13}return o+=String.fromCharCode(G),s++,v=16;case 45:if(o+=String.fromCharCode(G),s++,s===n||!f(r.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=W(),v=11;default:for(;s<n&&ne(G);)s++,G=r.charCodeAt(s);if(d!==s){switch(o=r.substring(d,s),o){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return o+=String.fromCharCode(G),s++,v=16}}function ne(G){if(I(G)||h(G))return!1;switch(G){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let G;do G=Z();while(G>=12&&G<=15);return G}return{setPosition:A,getPosition:()=>s,scan:a?oe:Z,getToken:()=>v,getTokenValue:()=>o,getTokenOffset:()=>d,getTokenLength:()=>s-d,getTokenError:()=>M}}e.createScanner=i;function I(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function h(r){return r===10||r===13||r===8232||r===8233}function f(r){return r>=48&&r<=57}var y;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(y||(y={}));function b(r,a){const s=[],n=new Object;let o;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function M(L,A,W,H){d.value=L,d.offset=A,d.length=W,d.type=H,d.colonOffset=void 0,o=d}try{l(r,{onObjectBegin:(L,A)=>{if(a<=L)throw n;o=void 0,v=a>L,s.push("")},onObjectProperty:(L,A,W)=>{if(a<A||(M(L,A,W,"property"),s[s.length-1]=L,a<=A+W))throw n},onObjectEnd:(L,A)=>{if(a<=L)throw n;o=void 0,s.pop()},onArrayBegin:(L,A)=>{if(a<=L)throw n;o=void 0,s.push(0)},onArrayEnd:(L,A)=>{if(a<=L)throw n;o=void 0,s.pop()},onLiteralValue:(L,A,W)=>{if(a<A||(M(L,A,W,u(L)),a<=A+W))throw n},onSeparator:(L,A,W)=>{if(a<=A)throw n;if(L===":"&&o&&o.type==="property")o.colonOffset=A,v=!1,o=void 0;else if(L===","){const H=s[s.length-1];typeof H=="number"?s[s.length-1]=H+1:(v=!0,s[s.length-1]=""),o=void 0}}})}catch(L){if(L!==n)throw L}return{path:s,previousNode:o,isAtPropertyKey:v,matches:L=>{let A=0;for(let W=0;A<L.length&&W<s.length;W++)if(L[A]===s[W]||L[A]==="*")A++;else if(L[A]!=="**")return!1;return A===L.length}}}e.getLocation=b;function g(r,a=[],s=k.DEFAULT){let n=null,o=[];const d=[];function v(L){Array.isArray(o)?o.push(L):n!==null&&(o[n]=L)}return l(r,{onObjectBegin:()=>{const L={};v(L),d.push(o),o=L,n=null},onObjectProperty:L=>{n=L},onObjectEnd:()=>{o=d.pop()},onArrayBegin:()=>{const L=[];v(L),d.push(o),o=L,n=null},onArrayEnd:()=>{o=d.pop()},onLiteralValue:v,onError:(L,A,W)=>{a.push({error:L,offset:A,length:W})}},s),o[0]}e.parse=g;function w(r,a=[],s=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(L){n.type==="property"&&(n.length=L-n.offset,n=n.parent)}function d(L){return n.children.push(L),L}l(r,{onObjectBegin:L=>{n=d({type:"object",offset:L,length:-1,parent:n,children:[]})},onObjectProperty:(L,A,W)=>{n=d({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:L,offset:A,length:W,parent:n})},onObjectEnd:(L,A)=>{n.length=L+A-n.offset,n=n.parent,o(L+A)},onArrayBegin:(L,A)=>{n=d({type:"array",offset:L,length:-1,parent:n,children:[]})},onArrayEnd:(L,A)=>{n.length=L+A-n.offset,n=n.parent,o(L+A)},onLiteralValue:(L,A,W)=>{d({type:u(L),offset:A,length:W,parent:n,value:L}),o(A+W)},onSeparator:(L,A,W)=>{n.type==="property"&&(L===":"?n.colonOffset=A:L===","&&o(A))},onError:(L,A,W)=>{a.push({error:L,offset:A,length:W})}},s);const M=n.children[0];return M&&delete M.parent,M}e.parseTree=w;function t(r,a){if(!r)return;let s=r;for(let n of a)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const d of s.children)if(Array.isArray(d.children)&&d.children[0].value===n){s=d.children[1],o=!0;break}if(!o)return}else{const o=n;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=t;function m(r){if(!r.parent||!r.parent.children)return[];const a=m(r.parent);if(r.parent.type==="property"){const s=r.parent.children[0].value;a.push(s)}else if(r.parent.type==="array"){const s=r.parent.children.indexOf(r);s!==-1&&a.push(s)}return a}e.getNodePath=m;function E(r){switch(r.type){case"array":return r.children.map(E);case"object":const a=Object.create(null);for(let s of r.children){const n=s.children[1];n&&(a[s.children[0].value]=E(n))}return a;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=E;function S(r,a,s=!1){return a>=r.offset&&a<r.offset+r.length||s&&a===r.offset+r.length}e.contains=S;function P(r,a,s=!1){if(S(r,a,s)){const n=r.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=a;o++){const d=P(n[o],a,s);if(d)return d}return r}}e.findNodeAtOffset=P;function l(r,a,s=k.DEFAULT){const n=i(r,!1);function o(O){return O?()=>O(n.getTokenOffset(),n.getTokenLength()):()=>!0}function d(O){return O?$=>O($,n.getTokenOffset(),n.getTokenLength()):()=>!0}const v=o(a.onObjectBegin),M=d(a.onObjectProperty),L=o(a.onObjectEnd),A=o(a.onArrayBegin),W=o(a.onArrayEnd),H=d(a.onLiteralValue),Z=d(a.onSeparator),ne=o(a.onComment),oe=d(a.onError),G=s&&s.disallowComments,T=s&&s.allowTrailingComma;function z(){for(;;){const O=n.scan();switch(n.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:G||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(O){case 12:case 13:G?q(10):ne();break;case 16:q(1);break;case 15:case 14:break;default:return O}}}function q(O,$=[],X=[]){if(oe(O),$.length+X.length>0){let V=n.getToken();for(;V!==17;){if($.indexOf(V)!==-1){z();break}else if(X.indexOf(V)!==-1)break;V=z()}}}function U(O){const $=n.getTokenValue();return O?H($):M($),z(),!0}function N(){switch(n.getToken()){case 11:let O=0;try{O=JSON.parse(n.getTokenValue()),typeof O!="number"&&(q(2),O=0)}catch($){q(2)}H(O);break;case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return z(),!0}function _(){return n.getToken()!==10?(q(3,[],[2,5]),!1):(U(!1),n.getToken()===6?(Z(":"),z(),R()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function Y(){v(),z();let O=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(O||q(4,[],[]),Z(","),z(),n.getToken()===2&&T)break}else O&&q(6,[],[]);_()||q(4,[],[2,5]),O=!0}return L(),n.getToken()!==2?q(7,[2],[]):z(),!0}function F(){A(),z();let O=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(O||q(4,[],[]),Z(","),z(),n.getToken()===4&&T)break}else O&&q(6,[],[]);R()||q(4,[],[4,5]),O=!0}return W(),n.getToken()!==4?q(8,[4],[]):z(),!0}function R(){switch(n.getToken()){case 3:return F();case 1:return Y();case 10:return U(!0);default:return N()}}return z(),n.getToken()===17?s.allowEmptyContent?!0:(q(4,[],[]),!1):R()?(n.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=l;function c(r,a){let s=i(r),n=[],o,d=0,v;do switch(v=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:d!==v&&n.push(r.substring(d,v)),a!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,a)),d=s.getPosition();break}while(o!==17);return n.join("")}e.stripComments=c;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Q[105],J([0,1,39]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function D(h,f,y){let b,g,w,t,m;if(f){for(t=f.offset,m=t+f.length,w=t;w>0&&!I(h,w-1);)w--;let d=m;for(;d<h.length&&!I(h,d);)d++;g=h.substring(w,d),b=k(g,y)}else g=h,b=0,w=0,t=0,m=h.length;const E=i(y,h);let S=!1,P=0,l;y.insertSpaces?l=C(" ",y.tabSize||4):l="	";const c=(0,p.createScanner)(g,!1);let u=!1;function r(){return E+C(l,b+P)}function a(){let d=c.scan();for(S=!1;d===15||d===14;)S=S||d===14,d=c.scan();return u=d===16||c.getTokenError()!==0,d}const s=[];function n(d,v,M){!u&&v<m&&M>t&&h.substring(v,M)!==d&&s.push({offset:v,length:M-v,content:d})}let o=a();if(o!==17){const d=c.getTokenOffset()+w,v=C(l,b);n(v,w,d)}for(;o!==17;){let d=c.getTokenOffset()+c.getTokenLength()+w,v=a(),M="";for(;!S&&(v===12||v===13);){const A=c.getTokenOffset()+w;n(" ",d,A),d=c.getTokenOffset()+c.getTokenLength()+w,M=v===12?r():"",v=a()}if(v===2)o!==1&&(P--,M=r());else if(v===4)o!==3&&(P--,M=r());else{switch(o){case 3:case 1:P++,M=r();break;case 5:case 12:M=r();break;case 13:S?M=r():M=" ";break;case 6:M=" ";break;case 10:if(v===6){M="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?M=" ":v!==5&&v!==17&&(u=!0);break;case 16:u=!0;break}S&&(v===12||v===13)&&(M=r())}const L=c.getTokenOffset()+w;n(M,d,L),o=v}return s}e.format=D;function C(h,f){let y="";for(let b=0;b<f;b++)y+=h;return y}function k(h,f){let y=0,b=0;const g=f.tabSize||4;for(;y<h.length;){const w=h.charAt(y);if(w===" ")b++;else if(w==="	")b+=g;else break;y++}return Math.floor(b/g)}function i(h,f){for(let y=0;y<f.length;y++){const b=f.charAt(y);if(b==="\r")return y+1<f.length&&f.charAt(y+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return h&&h.eol||`
`}e.getEOL=i;function I(h,f){return`\r
`.indexOf(h.charAt(f))!==-1}e.isEOL=I}),define(Q[78],J([0,1,39,105]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(f,y,b){return k(f,y,void 0,b)}e.removeProperty=C;function k(f,y,b,g,w){const t=y.slice(),m=[],E=(0,p.parseTree)(f,m);let S,P;for(;t.length>0&&(P=t.pop(),S=(0,p.findNodeAtLocation)(E,t),S===void 0&&b!==void 0);)typeof P=="string"?b={[P]:b}:b=[b];if(S)if(S.type==="object"&&typeof P=="string"&&Array.isArray(S.children)){const l=(0,p.findNodeAtLocation)(S,[P]);if(l!==void 0)if(b===void 0){if(!l.parent)throw new Error("Malformed AST");const c=S.children.indexOf(l.parent);let u,r=l.parent.offset+l.parent.length;if(c>0){const a=S.children[c-1];u=a.offset+a.length}else u=S.offset+1,S.children.length>1&&(r=S.children[1].offset);return i(f,{offset:u,length:r-u,content:""},g)}else return i(f,{offset:l.offset,length:l.length,content:JSON.stringify(b)},g);else{if(b===void 0)return[];const c=`${JSON.stringify(P)}: ${JSON.stringify(b)}`,u=w?w(S.children.map(a=>a.children[0].value)):S.children.length;let r;if(u>0){const a=S.children[u-1];r={offset:a.offset+a.length,length:0,content:","+c}}else S.children.length===0?r={offset:S.offset+1,length:0,content:c}:r={offset:S.offset+1,length:0,content:c+","};return i(f,r,g)}}else if(S.type==="array"&&typeof P=="number"&&Array.isArray(S.children))if(b!==void 0){const l=`${JSON.stringify(b)}`;let c;if(S.children.length===0||P===0)c={offset:S.offset+1,length:0,content:S.children.length===0?l:l+","};else{const u=P===-1||P>S.children.length?S.children.length:P,r=S.children[u-1];c={offset:r.offset+r.length,length:0,content:","+l}}return i(f,c,g)}else{const l=P,c=S.children[l];let u;if(S.children.length===1)u={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===l){const r=S.children[l-1],a=r.offset+r.length,s=S.offset+S.length;u={offset:a,length:s-2-a,content:""}}else u={offset:c.offset,length:S.children[l+1].offset-c.offset,content:""};return i(f,u,g)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${S.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return i(f,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(b)},g)}}e.setProperty=k;function i(f,y,b){let g=I(f,y),w=y.offset,t=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;w>0&&!(0,D.isEOL)(g,w-1);)w--;for(;t<g.length&&!(0,D.isEOL)(g,t);)t++}const m=(0,D.format)(g,{offset:w,length:t-w},b);for(let S=m.length-1;S>=0;S--){const P=m[S];g=I(g,P),w=Math.min(w,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const E=f.length-(g.length-t)-w;return[{offset:w,length:E,content:g.substring(w,t)}]}e.withFormatting=i;function I(f,y){return f.substring(0,y.offset)+y.content+f.substring(y.offset+y.length)}e.applyEdit=I;function h(f,y){let b=y.slice(0).sort((w,t)=>{const m=w.offset-t.offset;return m===0?w.length-t.length:m}),g=f.length;for(let w=b.length-1;w>=0;w--){let t=b[w];if(t.offset+t.length<=g)f=I(f,t);else throw new Error("Overlapping edit");g=t.offset}return f}e.applyEdits=h}),define(Q[79],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var D;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(D=e.ScanCode||(e.ScanCode={}));class C{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,E){this._keyCodeToStr[m]=E,this._strToKeyCode[E.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||0}}const k=new C,i=new C,I=new C;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const h=[],f=Object.create(null),y=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>y[t]||0,toEnum:t=>f[t]||0,toString:t=>h[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",m=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let E=[],S=[];for(const P of m){const[l,c,u,r,a,s,n,o,d,v]=P;if(S[u]||(S[u]=!0,h[u]=r,f[r]=u,y[r.toLowerCase()]=u,c&&(e.IMMUTABLE_CODE_TO_KEY_CODE[u]=a,a!==0&&a!==3&&a!==5&&a!==4&&a!==6&&a!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[a]=u))),!E[a]){if(E[a]=!0,!s)throw new Error(`String representation missing for key code ${a} around scan code ${r}`);k.define(a,s),i.define(a,d||s),I.define(a,v||d||s)}n&&(e.EVENT_KEY_CODE_MAP[n]=a),o&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[o]=a)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var b;(function(t){function m(u){return k.keyCodeToStr(u)}t.toString=m;function E(u){return k.strToKeyCode(u)}t.fromString=E;function S(u){return i.keyCodeToStr(u)}t.toUserSettingsUS=S;function P(u){return I.keyCodeToStr(u)}t.toUserSettingsGeneral=P;function l(u){return i.strToKeyCode(u)||I.strToKeyCode(u)}t.fromUserSettings=l;function c(u){if(u>=93&&u<=108)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return k.keyCodeToStr(u)}t.toElectronAccelerator=c})(b=e.KeyCodeUtils||(e.KeyCodeUtils={}));var g;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(g=e.KeyMod||(e.KeyMod={}));function w(t,m){const E=(m&65535)<<16>>>0;return(t|E)>>>0}e.KeyChord=w}),define(Q[59],J([0,1,16]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var D;(function(b){b[b.CtrlCmd=2048]="CtrlCmd",b[b.Shift=1024]="Shift",b[b.Alt=512]="Alt",b[b.WinCtrl=256]="WinCtrl",b[b.KeyCode=255]="KeyCode"})(D||(D={}));function C(b,g){if(b===0)return null;const w=(b&65535)>>>0,t=(b&4294901760)>>>16;return t!==0?new I([k(w,g),k(t,g)]):new I([k(w,g)])}e.createKeybinding=C;function k(b,g){const w=!!(b&2048),t=!!(b&256),m=g===2?t:w,E=!!(b&1024),S=!!(b&512),P=g===2?w:t,l=b&255;return new i(m,E,S,P,l)}e.createSimpleKeybinding=k;class i{constructor(g,w,t,m,E){this.ctrlKey=g,this.shiftKey=w,this.altKey=t,this.metaKey=m,this.keyCode=E}equals(g){return this.ctrlKey===g.ctrlKey&&this.shiftKey===g.shiftKey&&this.altKey===g.altKey&&this.metaKey===g.metaKey&&this.keyCode===g.keyCode}getHashCode(){const g=this.ctrlKey?"1":"0",w=this.shiftKey?"1":"0",t=this.altKey?"1":"0",m=this.metaKey?"1":"0";return`${g}${w}${t}${m}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new I([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=i;class I{constructor(g){if(g.length===0)throw(0,p.illegalArgument)("parts");this.parts=g}getHashCode(){let g="";for(let w=0,t=this.parts.length;w<t;w++)w!==0&&(g+=";"),g+=this.parts[w].getHashCode();return g}equals(g){if(g===null||this.parts.length!==g.parts.length)return!1;for(let w=0;w<this.parts.length;w++)if(!this.parts[w].equals(g.parts[w]))return!1;return!0}}e.ChordKeybinding=I;class h{constructor(g,w,t,m,E){this.ctrlKey=g,this.shiftKey=w,this.altKey=t,this.metaKey=m,this.scanCode=E}equals(g){return this.ctrlKey===g.ctrlKey&&this.shiftKey===g.shiftKey&&this.altKey===g.altKey&&this.metaKey===g.metaKey&&this.scanCode===g.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=h;class f{constructor(g,w,t,m,E,S){this.ctrlKey=g,this.shiftKey=w,this.altKey=t,this.metaKey=m,this.keyLabel=E,this.keyAriaLabel=S}}e.ResolvedKeybindingPart=f;class y{}e.ResolvedKeybinding=y}),define(Q[106],J([0,1,79,59]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class C{static _readModifiers(i){i=i.toLowerCase().trim();let I=!1,h=!1,f=!1,y=!1,b;do b=!1,/^ctrl(\+|\-)/.test(i)&&(I=!0,i=i.substr("ctrl-".length),b=!0),/^shift(\+|\-)/.test(i)&&(h=!0,i=i.substr("shift-".length),b=!0),/^alt(\+|\-)/.test(i)&&(f=!0,i=i.substr("alt-".length),b=!0),/^meta(\+|\-)/.test(i)&&(y=!0,i=i.substr("meta-".length),b=!0),/^win(\+|\-)/.test(i)&&(y=!0,i=i.substr("win-".length),b=!0),/^cmd(\+|\-)/.test(i)&&(y=!0,i=i.substr("cmd-".length),b=!0);while(b);let g;const w=i.indexOf(" ");return w>0?(g=i.substring(0,w),i=i.substring(w)):(g=i,i=""),{remains:i,ctrl:I,shift:h,alt:f,meta:y,key:g}}static parseSimpleKeybinding(i){const I=this._readModifiers(i),h=p.KeyCodeUtils.fromUserSettings(I.key);return[new D.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,h),I.remains]}static parseKeybinding(i,I){if(!i)return null;const h=[];let f;do[f,i]=this.parseSimpleKeybinding(i),h.push(f);while(i.length>0);return new D.ChordKeybinding(h)}static parseSimpleUserBinding(i){const I=this._readModifiers(i),h=I.key.match(/^\[([^\]]+)\]$/);if(h){const y=h[1],b=p.ScanCodeUtils.lowerCaseToEnum(y);return[new D.ScanCodeBinding(I.ctrl,I.shift,I.alt,I.meta,b),I.remains]}const f=p.KeyCodeUtils.fromUserSettings(I.key);return[new D.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,f),I.remains]}static parseUserBinding(i){if(!i)return[];const I=[];let h;for(;i.length>0;)[h,i]=this.parseSimpleUserBinding(i),I.push(h);return I}}e.KeybindingParser=C}),define(Q[2],J([0,1,42,69]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let k=null;function i(n){k=n}if(e.setDisposableTracker=i,C){const n="__is_disposable_tracked__";i(new class{trackDisposable(o){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[n]||console.log(d)},3e3)}setParent(o,d){if(o&&o!==P.None)try{o[n]=!0}catch{}}markAsDisposed(o){if(o&&o!==P.None)try{o[n]=!0}catch{}}markAsSingleton(o){}})}function I(n){return k?.trackDisposable(n),n}function h(n){k?.markAsDisposed(n)}function f(n,o){k?.setParent(n,o)}function y(n,o){if(!!k)for(const d of n)k.setParent(d,o)}function b(n){return k?.markAsSingleton(n),n}e.markAsSingleton=b;class g extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=g;function w(n){return typeof n.dispose=="function"&&n.dispose.length===0}e.isDisposable=w;function t(n){if(D.Iterable.is(n)){let o=[];for(const d of n)if(d)try{d.dispose()}catch(v){o.push(v)}if(o.length===1)throw o[0];if(o.length>1)throw new g(o);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}e.dispose=t;function m(...n){const o=E(()=>t(n));return y(n,o),o}e.combinedDisposable=m;function E(n){const o=I({dispose:(0,p.once)(()=>{h(o),n()})});return o}e.toDisposable=E;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(h(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return f(o,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new S,I(this),f(this._store,this)}dispose(){h(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class l{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&f(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,h(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&f(o,null),o}}e.MutableDisposable=l;class c{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class u{constructor(){this.references=new Map}acquire(o,...d){let v=this.references.get(o);v||(v={counter:0,object:this.createReferencedObject(o,...d)},this.references.set(o,v));const{object:M}=v,L=(0,p.once)(()=>{--v.counter==0&&(this.destroyReferencedObject(o,v.object),this.references.delete(o))});return v.counter++,{object:M,dispose:L}}}e.ReferenceCollection=u;class r{constructor(o){this.referenceCollection=o}async acquire(o,...d){const v=this.referenceCollection.acquire(o,...d);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(M){throw v.dispose(),M}}}e.AsyncReferenceCollection=r;class a{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=a;function s(n){const o=new S;try{n(o)}finally{o.dispose()}}e.disposeOnReturn=s}),define(Q[107],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(k){this.element=k,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class D{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let k=this._first;for(;k!==p.Undefined;){const i=k.next;k.prev=p.Undefined,k.next=p.Undefined,k=i}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(k){return this._insert(k,!1)}push(k){return this._insert(k,!0)}_insert(k,i){const I=new p(k);if(this._first===p.Undefined)this._first=I,this._last=I;else if(i){const f=this._last;this._last=I,I.prev=f,f.next=I}else{const f=this._first;this._first=I,I.next=f,f.prev=I}this._size+=1;let h=!1;return()=>{h||(h=!0,this._remove(I))}}shift(){if(this._first!==p.Undefined){const k=this._first.element;return this._remove(this._first),k}}pop(){if(this._last!==p.Undefined){const k=this._last.element;return this._remove(this._last),k}}_remove(k){if(k.prev!==p.Undefined&&k.next!==p.Undefined){const i=k.prev;i.next=k.next,k.next.prev=i}else k.prev===p.Undefined&&k.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):k.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):k.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let k=this._first;for(;k!==p.Undefined;)yield k.element,k=k.next}}e.LinkedList=D}),function(){function j(C){const k=[];typeof C=="number"&&k.push("code/timeOrigin",C);function i(h){k.push(h,Date.now())}function I(){const h=[];for(let f=0;f<k.length;f+=2)h.push({name:k[f],startTime:k[f+1]});return h}return{mark:i,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const i of performance.getEntriesByType("mark"))k.push({name:i.name,startTime:Math.round(C+i.startTime)});return k}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function p(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=p(D))}(),define(Q[3],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let D=!1,C=!1,k=!1,i=!1,I=!1,h=!1,f=!1,y,b=p,g,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let t;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?t=e.globals.vscode.process:typeof process!="undefined"&&(t=process);const m=typeof t?.versions?.electron=="string"&&t.type==="renderer";if(e.isElectronSandboxed=m&&t?.sandboxed,typeof navigator=="object"&&!m)w=navigator.userAgent,D=w.indexOf("Windows")>=0,C=w.indexOf("Macintosh")>=0,f=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=w.indexOf("Linux")>=0,h=!0,y=navigator.language,b=y;else if(typeof t=="object"){D=t.platform==="win32",C=t.platform==="darwin",k=t.platform==="linux",i=k&&!!t.env.SNAP&&!!t.env.SNAP_REVISION,y=p,b=p;const s=t.env.VSCODE_NLS_CONFIG;if(s)try{const n=JSON.parse(s),o=n.availableLanguages["*"];y=n.locale,b=o||p,g=n._translationsConfigFile}catch(n){}I=!0}else console.error("Unable to resolve platform.");var E;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function S(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let P=0;C?P=1:D?P=3:k&&(P=2),e.isWindows=D,e.isMacintosh=C,e.isLinux=k,e.isLinuxSnap=i,e.isNative=I,e.isWeb=h,e.isIOS=f,e.platform=P,e.userAgent=w,e.language=b;var l;(function(s){function n(){return e.language}s.value=n;function o(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=o;function d(){return e.language==="en"}s.isDefault=d})(l=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",v=>{if(v.data&&v.data.vscodeSetImmediateId)for(let M=0,L=o.length;M<L;M++){const A=o[M];if(A.id===v.data.vscodeSetImmediateId){o.splice(M,1),A.callback();return}}});let d=0;return v=>{const M=++d;o.push({id:M,callback:v}),e.globals.postMessage({vscodeSetImmediateId:M},"*")}}if(typeof t?.nextTick=="function")return t.nextTick.bind(t);const n=Promise.resolve();return o=>n.then(o)}();var c;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||f?2:D?1:3;let u=!0,r=!1;function a(){if(!r){r=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,u=new Uint16Array(s.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=a}),define(Q[32],J([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let D;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const C=p.globals.vscode.process;D={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()},nextTick(k){return(0,p.setImmediate)(k)}}}else typeof process!="undefined"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:D={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},nextTick(C){return(0,p.setImmediate)(C)},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.nextTick=D.nextTick,e.arch=D.arch}),define(Q[8],J([0,1,32]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,C=97,k=90,i=122,I=46,h=47,f=92,y=58,b=63;class g extends Error{constructor(c,u,r){let a;typeof u=="string"&&u.indexOf("not ")===0?(a="must not be",u=u.replace(/^not /,"")):a="must be";const s=c.indexOf(".")!==-1?"property":"argument";let n=`The "${c}" ${s} ${a} of type ${u}`;n+=`. Received type ${typeof r}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function w(l,c){if(typeof l!="string")throw new g(c,"string",l)}function t(l){return l===h||l===f}function m(l){return l===h}function E(l){return l>=D&&l<=k||l>=C&&l<=i}function S(l,c,u,r){let a="",s=0,n=-1,o=0,d=0;for(let v=0;v<=l.length;++v){if(v<l.length)d=l.charCodeAt(v);else{if(r(d))break;d=h}if(r(d)){if(!(n===v-1||o===1))if(o===2){if(a.length<2||s!==2||a.charCodeAt(a.length-1)!==I||a.charCodeAt(a.length-2)!==I){if(a.length>2){const M=a.lastIndexOf(u);M===-1?(a="",s=0):(a=a.slice(0,M),s=a.length-1-a.lastIndexOf(u)),n=v,o=0;continue}else if(a.length!==0){a="",s=0,n=v,o=0;continue}}c&&(a+=a.length>0?`${u}..`:"..",s=2)}else a.length>0?a+=`${u}${l.slice(n+1,v)}`:a=l.slice(n+1,v),s=v-n-1;n=v,o=0}else d===I&&o!==-1?++o:o=-1}return a}function P(l,c){if(c===null||typeof c!="object")throw new g("pathObject","Object",c);const u=c.dir||c.root,r=c.base||`${c.name||""}${c.ext||""}`;return u?u===c.root?`${u}${r}`:`${u}${l}${r}`:r}e.win32={resolve(...l){let c="",u="",r=!1;for(let a=l.length-1;a>=-1;a--){let s;if(a>=0){if(s=l[a],w(s,"path"),s.length===0)continue}else c.length===0?s=p.cwd():(s=p.env[`=${c}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==c.toLowerCase()&&s.charCodeAt(2)===f)&&(s=`${c}\\`));const n=s.length;let o=0,d="",v=!1;const M=s.charCodeAt(0);if(n===1)t(M)&&(o=1,v=!0);else if(t(M))if(v=!0,t(s.charCodeAt(1))){let L=2,A=L;for(;L<n&&!t(s.charCodeAt(L));)L++;if(L<n&&L!==A){const W=s.slice(A,L);for(A=L;L<n&&t(s.charCodeAt(L));)L++;if(L<n&&L!==A){for(A=L;L<n&&!t(s.charCodeAt(L));)L++;(L===n||L!==A)&&(d=`\\\\${W}\\${s.slice(A,L)}`,o=L)}}}else o=1;else E(M)&&s.charCodeAt(1)===y&&(d=s.slice(0,2),o=2,n>2&&t(s.charCodeAt(2))&&(v=!0,o=3));if(d.length>0)if(c.length>0){if(d.toLowerCase()!==c.toLowerCase())continue}else c=d;if(r){if(c.length>0)break}else if(u=`${s.slice(o)}\\${u}`,r=v,v&&c.length>0)break}return u=S(u,!r,"\\",t),r?`${c}\\${u}`:`${c}${u}`||"."},normalize(l){w(l,"path");const c=l.length;if(c===0)return".";let u=0,r,a=!1;const s=l.charCodeAt(0);if(c===1)return m(s)?"\\":l;if(t(s))if(a=!0,t(l.charCodeAt(1))){let o=2,d=o;for(;o<c&&!t(l.charCodeAt(o));)o++;if(o<c&&o!==d){const v=l.slice(d,o);for(d=o;o<c&&t(l.charCodeAt(o));)o++;if(o<c&&o!==d){for(d=o;o<c&&!t(l.charCodeAt(o));)o++;if(o===c)return`\\\\${v}\\${l.slice(d)}\\`;o!==d&&(r=`\\\\${v}\\${l.slice(d,o)}`,u=o)}}}else u=1;else E(s)&&l.charCodeAt(1)===y&&(r=l.slice(0,2),u=2,c>2&&t(l.charCodeAt(2))&&(a=!0,u=3));let n=u<c?S(l.slice(u),!a,"\\",t):"";return n.length===0&&!a&&(n="."),n.length>0&&t(l.charCodeAt(c-1))&&(n+="\\"),r===void 0?a?`\\${n}`:n:a?`${r}\\${n}`:`${r}${n}`},isAbsolute(l){w(l,"path");const c=l.length;if(c===0)return!1;const u=l.charCodeAt(0);return t(u)||c>2&&E(u)&&l.charCodeAt(1)===y&&t(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let c,u;for(let s=0;s<l.length;++s){const n=l[s];w(n,"path"),n.length>0&&(c===void 0?c=u=n:c+=`\\${n}`)}if(c===void 0)return".";let r=!0,a=0;if(typeof u=="string"&&t(u.charCodeAt(0))){++a;const s=u.length;s>1&&t(u.charCodeAt(1))&&(++a,s>2&&(t(u.charCodeAt(2))?++a:r=!1))}if(r){for(;a<c.length&&t(c.charCodeAt(a));)a++;a>=2&&(c=`\\${c.slice(a)}`)}return e.win32.normalize(c)},relative(l,c){if(w(l,"from"),w(c,"to"),l===c)return"";const u=e.win32.resolve(l),r=e.win32.resolve(c);if(u===r||(l=u.toLowerCase(),c=r.toLowerCase(),l===c))return"";let a=0;for(;a<l.length&&l.charCodeAt(a)===f;)a++;let s=l.length;for(;s-1>a&&l.charCodeAt(s-1)===f;)s--;const n=s-a;let o=0;for(;o<c.length&&c.charCodeAt(o)===f;)o++;let d=c.length;for(;d-1>o&&c.charCodeAt(d-1)===f;)d--;const v=d-o,M=n<v?n:v;let L=-1,A=0;for(;A<M;A++){const H=l.charCodeAt(a+A);if(H!==c.charCodeAt(o+A))break;H===f&&(L=A)}if(A!==M){if(L===-1)return r}else{if(v>M){if(c.charCodeAt(o+A)===f)return r.slice(o+A+1);if(A===2)return r.slice(o+A)}n>M&&(l.charCodeAt(a+A)===f?L=A:A===2&&(L=3)),L===-1&&(L=0)}let W="";for(A=a+L+1;A<=s;++A)(A===s||l.charCodeAt(A)===f)&&(W+=W.length===0?"..":"\\..");return o+=L,W.length>0?`${W}${r.slice(o,d)}`:(r.charCodeAt(o)===f&&++o,r.slice(o,d))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const c=e.win32.resolve(l);if(c.length<=2)return l;if(c.charCodeAt(0)===f){if(c.charCodeAt(1)===f){const u=c.charCodeAt(2);if(u!==b&&u!==I)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(E(c.charCodeAt(0))&&c.charCodeAt(1)===y&&c.charCodeAt(2)===f)return`\\\\?\\${c}`;return l},dirname(l){w(l,"path");const c=l.length;if(c===0)return".";let u=-1,r=0;const a=l.charCodeAt(0);if(c===1)return t(a)?l:".";if(t(a)){if(u=r=1,t(l.charCodeAt(1))){let o=2,d=o;for(;o<c&&!t(l.charCodeAt(o));)o++;if(o<c&&o!==d){for(d=o;o<c&&t(l.charCodeAt(o));)o++;if(o<c&&o!==d){for(d=o;o<c&&!t(l.charCodeAt(o));)o++;if(o===c)return l;o!==d&&(u=r=o+1)}}}}else E(a)&&l.charCodeAt(1)===y&&(u=c>2&&t(l.charCodeAt(2))?3:2,r=u);let s=-1,n=!0;for(let o=c-1;o>=r;--o)if(t(l.charCodeAt(o))){if(!n){s=o;break}}else n=!1;if(s===-1){if(u===-1)return".";s=u}return l.slice(0,s)},basename(l,c){c!==void 0&&w(c,"ext"),w(l,"path");let u=0,r=-1,a=!0,s;if(l.length>=2&&E(l.charCodeAt(0))&&l.charCodeAt(1)===y&&(u=2),c!==void 0&&c.length>0&&c.length<=l.length){if(c===l)return"";let n=c.length-1,o=-1;for(s=l.length-1;s>=u;--s){const d=l.charCodeAt(s);if(t(d)){if(!a){u=s+1;break}}else o===-1&&(a=!1,o=s+1),n>=0&&(d===c.charCodeAt(n)?--n==-1&&(r=s):(n=-1,r=o))}return u===r?r=o:r===-1&&(r=l.length),l.slice(u,r)}for(s=l.length-1;s>=u;--s)if(t(l.charCodeAt(s))){if(!a){u=s+1;break}}else r===-1&&(a=!1,r=s+1);return r===-1?"":l.slice(u,r)},extname(l){w(l,"path");let c=0,u=-1,r=0,a=-1,s=!0,n=0;l.length>=2&&l.charCodeAt(1)===y&&E(l.charCodeAt(0))&&(c=r=2);for(let o=l.length-1;o>=c;--o){const d=l.charCodeAt(o);if(t(d)){if(!s){r=o+1;break}continue}a===-1&&(s=!1,a=o+1),d===I?u===-1?u=o:n!==1&&(n=1):u!==-1&&(n=-1)}return u===-1||a===-1||n===0||n===1&&u===a-1&&u===r+1?"":l.slice(u,a)},format:P.bind(null,"\\"),parse(l){w(l,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return c;const u=l.length;let r=0,a=l.charCodeAt(0);if(u===1)return t(a)?(c.root=c.dir=l,c):(c.base=c.name=l,c);if(t(a)){if(r=1,t(l.charCodeAt(1))){let L=2,A=L;for(;L<u&&!t(l.charCodeAt(L));)L++;if(L<u&&L!==A){for(A=L;L<u&&t(l.charCodeAt(L));)L++;if(L<u&&L!==A){for(A=L;L<u&&!t(l.charCodeAt(L));)L++;L===u?r=L:L!==A&&(r=L+1)}}}}else if(E(a)&&l.charCodeAt(1)===y){if(u<=2)return c.root=c.dir=l,c;if(r=2,t(l.charCodeAt(2))){if(u===3)return c.root=c.dir=l,c;r=3}}r>0&&(c.root=l.slice(0,r));let s=-1,n=r,o=-1,d=!0,v=l.length-1,M=0;for(;v>=r;--v){if(a=l.charCodeAt(v),t(a)){if(!d){n=v+1;break}continue}o===-1&&(d=!1,o=v+1),a===I?s===-1?s=v:M!==1&&(M=1):s!==-1&&(M=-1)}return o!==-1&&(s===-1||M===0||M===1&&s===o-1&&s===n+1?c.base=c.name=l.slice(n,o):(c.name=l.slice(n,s),c.base=l.slice(n,o),c.ext=l.slice(s,o))),n>0&&n!==r?c.dir=l.slice(0,n-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let c="",u=!1;for(let r=l.length-1;r>=-1&&!u;r--){const a=r>=0?l[r]:p.cwd();w(a,"path"),a.length!==0&&(c=`${a}/${c}`,u=a.charCodeAt(0)===h)}return c=S(c,!u,"/",m),u?`/${c}`:c.length>0?c:"."},normalize(l){if(w(l,"path"),l.length===0)return".";const c=l.charCodeAt(0)===h,u=l.charCodeAt(l.length-1)===h;return l=S(l,!c,"/",m),l.length===0?c?"/":u?"./":".":(u&&(l+="/"),c?`/${l}`:l)},isAbsolute(l){return w(l,"path"),l.length>0&&l.charCodeAt(0)===h},join(...l){if(l.length===0)return".";let c;for(let u=0;u<l.length;++u){const r=l[u];w(r,"path"),r.length>0&&(c===void 0?c=r:c+=`/${r}`)}return c===void 0?".":e.posix.normalize(c)},relative(l,c){if(w(l,"from"),w(c,"to"),l===c||(l=e.posix.resolve(l),c=e.posix.resolve(c),l===c))return"";const u=1,r=l.length,a=r-u,s=1,n=c.length-s,o=a<n?a:n;let d=-1,v=0;for(;v<o;v++){const L=l.charCodeAt(u+v);if(L!==c.charCodeAt(s+v))break;L===h&&(d=v)}if(v===o)if(n>o){if(c.charCodeAt(s+v)===h)return c.slice(s+v+1);if(v===0)return c.slice(s+v)}else a>o&&(l.charCodeAt(u+v)===h?d=v:v===0&&(d=0));let M="";for(v=u+d+1;v<=r;++v)(v===r||l.charCodeAt(v)===h)&&(M+=M.length===0?"..":"/..");return`${M}${c.slice(s+d)}`},toNamespacedPath(l){return l},dirname(l){if(w(l,"path"),l.length===0)return".";const c=l.charCodeAt(0)===h;let u=-1,r=!0;for(let a=l.length-1;a>=1;--a)if(l.charCodeAt(a)===h){if(!r){u=a;break}}else r=!1;return u===-1?c?"/":".":c&&u===1?"//":l.slice(0,u)},basename(l,c){c!==void 0&&w(c,"ext"),w(l,"path");let u=0,r=-1,a=!0,s;if(c!==void 0&&c.length>0&&c.length<=l.length){if(c===l)return"";let n=c.length-1,o=-1;for(s=l.length-1;s>=0;--s){const d=l.charCodeAt(s);if(d===h){if(!a){u=s+1;break}}else o===-1&&(a=!1,o=s+1),n>=0&&(d===c.charCodeAt(n)?--n==-1&&(r=s):(n=-1,r=o))}return u===r?r=o:r===-1&&(r=l.length),l.slice(u,r)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===h){if(!a){u=s+1;break}}else r===-1&&(a=!1,r=s+1);return r===-1?"":l.slice(u,r)},extname(l){w(l,"path");let c=-1,u=0,r=-1,a=!0,s=0;for(let n=l.length-1;n>=0;--n){const o=l.charCodeAt(n);if(o===h){if(!a){u=n+1;break}continue}r===-1&&(a=!1,r=n+1),o===I?c===-1?c=n:s!==1&&(s=1):c!==-1&&(s=-1)}return c===-1||r===-1||s===0||s===1&&c===r-1&&c===u+1?"":l.slice(c,r)},format:P.bind(null,"/"),parse(l){w(l,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return c;const u=l.charCodeAt(0)===h;let r;u?(c.root="/",r=1):r=0;let a=-1,s=0,n=-1,o=!0,d=l.length-1,v=0;for(;d>=r;--d){const M=l.charCodeAt(d);if(M===h){if(!o){s=d+1;break}continue}n===-1&&(o=!1,n=d+1),M===I?a===-1?a=d:v!==1&&(v=1):a!==-1&&(v=-1)}if(n!==-1){const M=s===0&&u?1:s;a===-1||v===0||v===1&&a===n-1&&a===s+1?c.base=c.name=l.slice(M,n):(c.name=l.slice(M,a),c.base=l.slice(M,n),c.ext=l.slice(a,n))}return s>0?c.dir=l.slice(0,s-1):u&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[80],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var D;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(k,...i){const I=i.reduce((y,b)=>(y[b]=!0,y),{}),h=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(y=>!I[y]).forEach(y=>{for(let b=0;b<h.length;b++)if(y.search(h[b])!==-1){delete k[y];break}})}e.sanitizeProcessEnvironment=C}),define(Q[108],J([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=p.globals.performance&&typeof p.globals.performance.now=="function";class C{constructor(i){this._highResolution=D&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new C(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=C}),define(Q[4],J([0,1,16,42,2,107,108]),function(j,e,p,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(c){c.None=()=>C.Disposable.None;function u(T){return(z,q=null,U)=>{let N=!1,_;return _=T(Y=>{if(!N)return _?_.dispose():N=!0,z.call(q,Y)},null,U),N&&_.dispose(),_}}c.once=u;function r(T,z){return v((q,U=null,N)=>T(_=>q.call(U,z(_)),null,N))}c.map=r;function a(T,z){return v((q,U=null,N)=>T(_=>{z(_),q.call(U,_)},null,N))}c.forEach=a;function s(T,z){return v((q,U=null,N)=>T(_=>z(_)&&q.call(U,_),null,N))}c.filter=s;function n(T){return T}c.signal=n;function o(...T){return(z,q=null,U)=>(0,C.combinedDisposable)(...T.map(N=>N(_=>z.call(q,_),null,U)))}c.any=o;function d(T,z,q){let U=q;return r(T,N=>(U=z(U,N),U))}c.reduce=d;function v(T){let z;const q=new g({onFirstListenerAdd(){z=T(q.fire,q)},onLastListenerRemove(){z.dispose()}});return q.event}function M(T,z,q=100,U=!1,N){let _,Y,F,R=0;const O=new g({leakWarningThreshold:N,onFirstListenerAdd(){_=T($=>{R++,Y=z(Y,$),U&&!F&&(O.fire(Y),Y=void 0),clearTimeout(F),F=setTimeout(()=>{const X=Y;Y=void 0,F=void 0,(!U||R>1)&&O.fire(X),R=0},q)})},onLastListenerRemove(){_.dispose()}});return O.event}c.debounce=M;function L(T,z=(q,U)=>q===U){let q=!0,U;return s(T,N=>{const _=q||!z(N,U);return q=!1,U=N,_})}c.latch=L;function A(T,z){return[c.filter(T,z),c.filter(T,q=>!z(q))]}c.split=A;function W(T,z=!1,q=[]){let U=q.slice(),N=T(F=>{U?U.push(F):Y.fire(F)});const _=()=>{U&&U.forEach(F=>Y.fire(F)),U=null},Y=new g({onFirstListenerAdd(){N||(N=T(F=>Y.fire(F)))},onFirstListenerDidAdd(){U&&(z?setTimeout(_):_())},onLastListenerRemove(){N&&N.dispose(),N=null}});return Y.event}c.buffer=W;class H{constructor(z){this.event=z}map(z){return new H(r(this.event,z))}forEach(z){return new H(a(this.event,z))}filter(z){return new H(s(this.event,z))}reduce(z,q){return new H(d(this.event,z,q))}latch(){return new H(L(this.event))}debounce(z,q=100,U=!1,N){return new H(M(this.event,z,q,U,N))}on(z,q,U){return this.event(z,q,U)}once(z,q,U){return u(this.event)(z,q,U)}}function Z(T){return new H(T)}c.chain=Z;function ne(T,z,q=U=>U){const U=(...F)=>Y.fire(q(...F)),N=()=>T.on(z,U),_=()=>T.removeListener(z,U),Y=new g({onFirstListenerAdd:N,onLastListenerRemove:_});return Y.event}c.fromNodeEventEmitter=ne;function oe(T,z,q=U=>U){const U=(...F)=>Y.fire(q(...F)),N=()=>T.addEventListener(z,U),_=()=>T.removeEventListener(z,U),Y=new g({onFirstListenerAdd:N,onLastListenerRemove:_});return Y.event}c.fromDOMEventEmitter=oe;function G(T){return new Promise(z=>u(T)(z))}c.toPromise=G})(I=e.Event||(e.Event={}));class h{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${h._idPool++}`}start(u){this._stopWatch=new i.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}h._idPool=0;let f=-1;function y(c){const u=f;return f=c,{dispose(){f=u}}}e.setGlobalLeakWarningThreshold=y;class b{constructor(u,r=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let r=f;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||u<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(a)||0;if(this._stacks.set(a,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let n,o=0;for(const[d,v]of this._stacks)(!n||o<v)&&(n=d,o=v);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${o}):`),console.warn(n)}return()=>{const n=this._stacks.get(a)||0;this._stacks.set(a,n-1)}}}class g{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=f>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new h(this._options._profName):void 0}get event(){return this._event||(this._event=(u,r,a)=>{this._listeners||(this._listeners=new k.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(r?[u,r]:u);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,r);const o=this._leakageMon?.check(this._listeners.size),d=(0,C.toDisposable)(()=>{o&&o(),this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof C.DisposableStore?a.add(d):Array.isArray(a)&&a.push(d),d}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new k.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(s){(0,p.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=g;class w extends g{async fireAsync(u,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,u]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[s,n]=this._asyncDeliveryQueue.shift(),o=[],d={...n,waitUntil:v=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");a&&(v=a(v,typeof s=="function"?s:s[0])),o.push(v)}};try{typeof s=="function"?s.call(void 0,d):s[0].call(s[1],d)}catch(v){(0,p.onUnexpectedError)(v);continue}Object.freeze(o),await Promise.allSettled(o).then(v=>{for(const M of v)M.status==="rejected"&&(0,p.onUnexpectedError)(M.reason)})}}}}e.AsyncEmitter=w;class t extends g{constructor(u){super(u);this._isPaused=0,this._eventQueue=new k.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=t;class m extends t{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=m;class E extends g{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const r={event:u,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const s=this.events.indexOf(r);this.events.splice(s,1)};return(0,C.toDisposable)((0,D.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(r=>this.emitter.fire(r))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class P{constructor(){this.buffers=[]}wrapEvent(u){return(r,a,s)=>u(n=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>r.call(a,n)):r.call(a,n)},void 0,s)}bufferEvents(u){const r=[];this.buffers.push(r);const a=u();return this.buffers.pop(),r.forEach(s=>s()),a}}e.EventBufferer=P;class l{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=C.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=l}),define(Q[23],J([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(I,h){const f=setTimeout(I.bind(h),0);return{dispose(){clearTimeout(f)}}});var C;(function(I){function h(f){return f===I.None||f===I.Cancelled||f instanceof k?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}I.isCancellationToken=h,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(C=e.CancellationToken||(e.CancellationToken={}));class k{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(h){this._token=void 0,this._parentListener=void 0,this._parentListener=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new k),this._token}cancel(){this._token?this._token instanceof k&&this._token.cancel():this._token=C.Cancelled}dispose(h=!1){h&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof k&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=i}),define(Q[109],J([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class D{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(y){const b=this._icons.get(y.id);b?y.description?b.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new D;e.iconRegistry=C;function k(f){return f?f.replace(/\$\((.*?)\)/g,(y,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=k;class i{constructor(y,b,g){this.id=y,this.definition=b,this.description=g,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function I(f,y){const b=["codicon","codicon-"+f];return y&&b.push("codicon-modifier-"+y),b}e.getClassNamesArray=I;var h;(function(f){f.iconNameSegment="[A-Za-z0-9]+",f.iconNameExpression="[A-Za-z0-9\\-]+",f.iconModifierExpression="~[A-Za-z]+",f.iconNameCharacter="[A-Za-z0-9\\-~]";const y=new RegExp(`^(${f.iconNameExpression})(${f.iconModifierExpression})?$`);function b(t){if(t instanceof i)return["codicon","codicon-"+t.id];const m=y.exec(t.id);if(!m)return b(i.error);let[,E,S]=m;const P=["codicon","codicon-"+E];return S&&P.push("codicon-modifier-"+S.substr(1)),P}f.asClassNameArray=b;function g(t){return b(t).join(" ")}f.asClassName=g;function w(t){return"."+b(t).join(".")}f.asCSSSelector=w})(h=e.CSSIcon||(e.CSSIcon={}))}),define(Q[60],J([0,1,16,2]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(l){const c=l;return c?[c.on,c.pause,c.resume,c.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=C;function k(l){const c=l;return c?C(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=k;function i(l,c){return new I(l,c)}e.newWriteableStream=i;class I{constructor(c,u){this.reducer=c,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(u=>u(c))}emitError(c){this.listeners.error.length===0?(0,p.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(u=>u(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,u){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(c,u){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(u);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(l,c){const u=[];let r;for(;(r=l.read())!==null;)u.push(r);return c(u)}e.consumeReadable=h;function f(l,c,u){const r=[];let a;for(;(a=l.read())!==null&&r.length<u;)r.push(a);return a===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const s=a;return a=void 0,s}return l.read()}}}e.peekReadable=f;function y(l,c){return new Promise((u,r)=>{const a=[];b(l,{onData:s=>{c&&a.push(s)},onError:s=>{c?r(s):u(void 0)},onEnd:()=>{u(c?c(a):void 0)}})})}e.consumeStream=y;function b(l,c){l.on("error",u=>c.onError(u)),l.on("end",()=>c.onEnd()),l.on("data",u=>c.onData(u))}e.listenStream=b;function g(l,c){return new Promise((u,r)=>{const a=new D.DisposableStore,s=[],n=v=>{if(s.push(v),s.length>c)return a.dispose(),l.pause(),u({stream:l,buffer:s,ended:!1})},o=v=>r(v),d=()=>u({stream:l,buffer:s,ended:!0});a.add((0,D.toDisposable)(()=>l.removeListener("error",o))),l.on("error",o),a.add((0,D.toDisposable)(()=>l.removeListener("end",d))),l.on("end",d),a.add((0,D.toDisposable)(()=>l.removeListener("data",n))),l.on("data",n)})}e.peekStream=g;function w(l,c){const u=i(c);return u.end(l),u}e.toStream=w;function t(){const l=i(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=t;function m(l){let c=!1;return{read:()=>c?null:(c=!0,l)}}e.toReadable=m;function E(l,c,u){const r=i(u);return b(l,{onData:a=>r.write(c.data(a)),onError:a=>r.error(c.error?c.error(a):a),onEnd:()=>r.end()}),r}e.transform=E;function S(l,c,u){let r=!1;return{read:()=>{const a=c.read();return r?a:(r=!0,a!==null?u([l,a]):l)}}}e.prefixedReadable=S;function P(l,c,u){let r=!1;const a=i(u);return b(c,{onData:s=>r?a.write(s):(r=!0,a.write(u([l,s]))),onError:s=>a.error(s),onEnd:()=>{r||(r=!0,a.write(l)),a.end()}}),a}e.prefixedStream=P}),define(Q[17],J([0,1,60]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined";let C,k;class i{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return D?new i(Buffer.allocUnsafe(n)):new i(new Uint8Array(n))}static wrap(n){return D&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new i(n)}static fromString(n,o){return!(o?.dontUseNodeBuffer||!1)&&D?new i(Buffer.from(n)):(C||(C=new TextEncoder),new i(C.encode(n)))}static concat(n,o){if(typeof o=="undefined"){o=0;for(let M=0,L=n.length;M<L;M++)o+=n[M].byteLength}const d=i.alloc(o);let v=0;for(let M=0,L=n.length;M<L;M++){const A=n[M];d.set(A,v),v+=A.byteLength}return d}toString(){return D?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(n,o){return new i(this.buffer.subarray(n,o))}set(n,o){n instanceof i?this.buffer.set(n.buffer,o):this.buffer.set(n,o)}readUInt32BE(n){return f(this.buffer,n)}writeUInt32BE(n,o){y(this.buffer,n,o)}readUInt32LE(n){return b(this.buffer,n)}writeUInt32LE(n,o){g(this.buffer,n,o)}readUInt8(n){return w(this.buffer,n)}writeUInt8(n,o){t(this.buffer,n,o)}}e.VSBuffer=i;function I(s,n){return s[n+0]<<0>>>0|s[n+1]<<8>>>0}e.readUInt16LE=I;function h(s,n,o){s[o+0]=n&255,n=n>>>8,s[o+1]=n&255}e.writeUInt16LE=h;function f(s,n){return s[n]*2**24+s[n+1]*2**16+s[n+2]*2**8+s[n+3]}e.readUInt32BE=f;function y(s,n,o){s[o+3]=n,n=n>>>8,s[o+2]=n,n=n>>>8,s[o+1]=n,n=n>>>8,s[o]=n}e.writeUInt32BE=y;function b(s,n){return s[n+0]<<0>>>0|s[n+1]<<8>>>0|s[n+2]<<16>>>0|s[n+3]<<24>>>0}e.readUInt32LE=b;function g(s,n,o){s[o+0]=n&255,n=n>>>8,s[o+1]=n&255,n=n>>>8,s[o+2]=n&255,n=n>>>8,s[o+3]=n&255}e.writeUInt32LE=g;function w(s,n){return s[n]}e.readUInt8=w;function t(s,n,o){s[o]=n}e.writeUInt8=t;function m(s){return p.consumeReadable(s,n=>i.concat(n))}e.readableToBuffer=m;function E(s){return p.toReadable(s)}e.bufferToReadable=E;function S(s){return p.consumeStream(s,n=>i.concat(n))}e.streamToBuffer=S;async function P(s){return s.ended?i.concat(s.buffer):i.concat([...s.buffer,await S(s.stream)])}e.bufferedStreamToBuffer=P;function l(s){return p.toStream(s,n=>i.concat(n))}e.bufferToStream=l;function c(s){return p.transform(s,{data:n=>typeof n=="string"?i.fromString(n):i.wrap(n)},n=>i.concat(n))}e.streamToBufferReadableStream=c;function u(s){return p.newWriteableStream(n=>i.concat(n),s)}e.newWriteableBufferStream=u;function r(s,n){return p.prefixedReadable(s,n,o=>i.concat(o))}e.prefixedBufferReadable=r;function a(s,n){return p.prefixedStream(s,n,o=>i.concat(o))}e.prefixedBufferStream=a}),define(Q[25],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=p;const D=/{(\d+)}/g;function C(K,...re){return re.length===0?K:K.replace(D,function(le,we){const Ee=parseInt(we,10);return isNaN(Ee)||Ee<0||Ee>=re.length?le:re[Ee]})}e.format=C;const k=/{([^}]+)}/g;function i(K,re){return K.replace(k,(le,we)=>re[we]??le)}e.format2=i;function I(K){return K.replace(/[<>&]/g,function(re){switch(re){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return re}})}e.escape=I;function h(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=h;function f(K,re){let le=0;const we=re.charCodeAt(0);for(let Ee=K.length-1;Ee>=0;Ee--)K.charCodeAt(Ee)===we&&le++;return le}e.count=f;function y(K,re,le="\u2026"){return K.length<=re?K:`${K.substr(0,re)}${le}`}e.truncate=y;function b(K,re=" "){const le=g(K,re);return w(le,re)}e.trim=b;function g(K,re){if(!K||!re)return K;const le=re.length;if(le===0||K.length===0)return K;let we=0;for(;K.indexOf(re,we)===we;)we=we+le;return K.substring(we)}e.ltrim=g;function w(K,re){if(!K||!re)return K;const le=re.length,we=K.length;if(le===0||we===0)return K;let Ee=we,De=-1;for(;De=K.lastIndexOf(re,Ee-1),!(De===-1||De+le!==Ee);){if(De===0)return"";Ee=De}return K.substring(0,Ee)}e.rtrim=w;function t(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=t;function m(K){return K.replace(/\*/g,"")}e.stripWildcards=m;function E(K,re,le={}){if(!K)throw new Error("Cannot create regex from empty string");re||(K=h(K)),le.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let we="";return le.global&&(we+="g"),le.matchCase||(we+="i"),le.multiline&&(we+="m"),le.unicode&&(we+="u"),new RegExp(K,we)}e.createRegExp=E;function S(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function P(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function l(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=l;function c(K){return K.split(/\r\n|\r|\n/)}e.splitLines=c;function u(K){for(let re=0,le=K.length;re<le;re++){const we=K.charCodeAt(re);if(we!==32&&we!==9)return re}return-1}e.firstNonWhitespaceIndex=u;function r(K,re=0,le=K.length){for(let we=re;we<le;we++){const Ee=K.charCodeAt(we);if(Ee!==32&&Ee!==9)return K.substring(re,we)}return K.substring(re,le)}e.getLeadingWhitespace=r;function a(K,re=K.length-1){for(let le=re;le>=0;le--){const we=K.charCodeAt(le);if(we!==32&&we!==9)return le}return-1}e.lastNonWhitespaceIndex=a;function s(K,re){return K<re?-1:K>re?1:0}e.compare=s;function n(K,re,le=0,we=K.length,Ee=0,De=re.length){for(;le<we&&Ee<De;le++,Ee++){let Ne=K.charCodeAt(le),Be=re.charCodeAt(Ee);if(Ne<Be)return-1;if(Ne>Be)return 1}const Oe=we-le,_e=De-Ee;return Oe<_e?-1:Oe>_e?1:0}e.compareSubstring=n;function o(K,re){return d(K,re,0,K.length,0,re.length)}e.compareIgnoreCase=o;function d(K,re,le=0,we=K.length,Ee=0,De=re.length){for(;le<we&&Ee<De;le++,Ee++){let Ne=K.charCodeAt(le),Be=re.charCodeAt(Ee);if(Ne===Be)continue;if(Ne>=128||Be>=128)return n(K.toLowerCase(),re.toLowerCase(),le,we,Ee,De);v(Ne)&&(Ne-=32),v(Be)&&(Be-=32);const Ve=Ne-Be;if(Ve!==0)return Ve}const Oe=we-le,_e=De-Ee;return Oe<_e?-1:Oe>_e?1:0}e.compareSubstringIgnoreCase=d;function v(K){return K>=97&&K<=122}e.isLowerAsciiLetter=v;function M(K){return K>=65&&K<=90}e.isUpperAsciiLetter=M;function L(K,re){return K.length===re.length&&d(K,re)===0}e.equalsIgnoreCase=L;function A(K,re){const le=re.length;return re.length>K.length?!1:d(K,re,0,le)===0}e.startsWithIgnoreCase=A;function W(K,re){let le,we=Math.min(K.length,re.length);for(le=0;le<we;le++)if(K.charCodeAt(le)!==re.charCodeAt(le))return le;return we}e.commonPrefixLength=W;function H(K,re){let le,we=Math.min(K.length,re.length);const Ee=K.length-1,De=re.length-1;for(le=0;le<we;le++)if(K.charCodeAt(Ee-le)!==re.charCodeAt(De-le))return le;return we}e.commonSuffixLength=H;function Z(K){return 55296<=K&&K<=56319}e.isHighSurrogate=Z;function ne(K){return 56320<=K&&K<=57343}e.isLowSurrogate=ne;function oe(K,re){return(K-55296<<10)+(re-56320)+65536}e.computeCodePoint=oe;function G(K,re,le){const we=K.charCodeAt(le);if(Z(we)&&le+1<re){const Ee=K.charCodeAt(le+1);if(ne(Ee))return oe(we,Ee)}return we}e.getNextCodePoint=G;function T(K,re){const le=K.charCodeAt(re-1);if(ne(le)&&re>1){const we=K.charCodeAt(re-2);if(Z(we))return oe(we,le)}return le}function z(K,re){const le=Fe.getInstance(),we=re,Ee=K.length,De=G(K,Ee,re);re+=De>=65536?2:1;let Oe=le.getGraphemeBreakType(De);for(;re<Ee;){const _e=G(K,Ee,re),Ne=le.getGraphemeBreakType(_e);if(Ae(Oe,Ne))break;re+=_e>=65536?2:1,Oe=Ne}return re-we}e.nextCharLength=z;function q(K,re){const le=Fe.getInstance(),we=re,Ee=T(K,re);re-=Ee>=65536?2:1;let De=le.getGraphemeBreakType(Ee);for(;re>0;){const Oe=T(K,re),_e=le.getGraphemeBreakType(Oe);if(Ae(_e,De))break;re-=Oe>=65536?2:1,De=_e}return we-re}e.prevCharLength=q;function U(K,re){const le=Fe.getInstance(),we=K.length,Ee=re,De=G(K,we,re),Oe=le.getGraphemeBreakType(De);re+=De>=65536?2:1;let _e=Oe;for(;re<we;){const Be=G(K,we,re),Ve=le.getGraphemeBreakType(Be);if(Ae(_e,Ve))break;re+=Be>=65536?2:1,_e=Ve}const Ne=re;for(re=Ee,_e=Oe;re>0;){const Be=T(K,re),Ve=le.getGraphemeBreakType(Be);if(Ae(Ve,_e))break;re-=Be>=65536?2:1,_e=Ve}return[re,Ne]}function N(K,re){return re>0&&ne(K.charCodeAt(re))?U(K,re-1):U(K,re)}e.getCharContainingOffset=N;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(K){return _.test(K)}e.containsRTL=Y;const F=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function R(K){return F.test(K)}e.containsEmoji=R;const O=/^[\t\n\r\x20-\x7E]*$/;function $(K){return O.test(K)}e.isBasicASCII=$,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function X(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=X;function V(K){for(let re=0,le=K.length;re<le;re++)if(B(K.charCodeAt(re)))return!0;return!1}e.containsFullWidthCharacter=V;function B(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=B;function x(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=x;function te(K,re){if(K.length<re)return K;const le=/\b/g;let we=0;for(;le.test(K)&&!(K.length-le.lastIndex<re);)we=le.lastIndex,le.lastIndex+=1;return K.substring(we).replace(/^\s/,"")}e.lcut=te;const ce=/\x1B\x5B[12]?K/g,se=/\x1b\[\d+m/g,ie=/\x1b\[0?m/g;function ae(K){return K&&(K=K.replace(ce,""),K=K.replace(se,""),K=K.replace(ie,"")),K}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function de(K){return ue(K)?K.substr(1):K}e.stripUTF8BOM=de;function ve(K,re){if(!K||!re||K.length<re.length)return!1;const le=re.length,we=K.toLowerCase();let Ee=0,De=-1;for(;Ee<le;){const Oe=we.indexOf(re[Ee],De+1);if(Oe<0)return!1;De=Oe,Ee++}return!0}e.fuzzyContains=ve;function Pe(K,re=!1){return K?(re&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Pe;function pe(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=pe;function ge(K,re=1){if(re===0)return"";let le=-1;do le=K.indexOf(`
`,le+1),re--;while(re>0&&le>=0);return le===-1?K:(K[le-1]==="\r"&&le--,K.substr(0,le))}e.getNLines=ge;function be(K){const re=90-65+1;return K=K%(2*re),K<re?String.fromCharCode(97+K):String.fromCharCode(65+K-re)}e.singleLetterHash=be;function ke(K){return Fe.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=ke;function Ae(K,re){return K===0?re!==5&&re!==7:K===2&&re===3?!1:K===4||K===2||K===3||re===4||re===2||re===3?!0:!(K===8&&(re===8||re===9||re===11||re===12)||(K===11||K===9)&&(re===9||re===10)||(K===12||K===10)&&re===10||re===5||re===13||re===7||K===1||K===13&&re===14||K===6&&re===6)}e.breakBetweenGraphemeBreakType=Ae;var We;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(We=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Fe{constructor(){this._data=et()}static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}getGraphemeBreakType(re){if(re<32)return re===10?3:re===13?2:4;if(re<127)return 0;const le=this._data,we=le.length/3;let Ee=1;for(;Ee<=we;)if(re<le[3*Ee])Ee=2*Ee;else if(re>le[3*Ee+1])Ee=2*Ee+1;else return le[3*Ee+2];return 0}}Fe._INSTANCE=null;function et(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ge(K,re){if(K===0)return 0;const le=He(K,re);if(le!==void 0)return le;const we=T(re,K);return K-=Xe(we),K}e.getLeftDeleteOffset=Ge;function He(K,re){let le=T(re,K);for(K-=Xe(le);at(le)||le===65039||le===8419;){if(K===0)return;le=T(re,K),K-=Xe(le)}if(!!x(le)){if(K>=0){const we=T(re,K);we===8205&&(K-=Xe(we))}return K}}function Xe(K){return K>=65536?2:1}function at(K){return 127995<=K&&K<=127999}var tt;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={})),e.noBreakWhitespace="\xA0"}),define(Q[81],J([0,1,25]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(S){return C(S,0)}e.hash=D;function C(S,P){switch(typeof S){case"object":return S===null?k(349,P):Array.isArray(S)?h(S,P):f(S,P);case"string":return I(S,P);case"boolean":return i(S,P);case"number":return k(S,P);case"undefined":return k(937,P);default:return k(617,P)}}e.doHash=C;function k(S,P){return(P<<5)-P+S|0}e.numberHash=k;function i(S,P){return k(S?433:863,P)}function I(S,P){P=k(149417,P);for(let l=0,c=S.length;l<c;l++)P=k(S.charCodeAt(l),P);return P}e.stringHash=I;function h(S,P){return P=k(104579,P),S.reduce((l,c)=>C(c,l),P)}function f(S,P){return P=k(181387,P),Object.keys(S).sort().reduce((l,c)=>(l=I(c,l),C(S[c],l)),P)}class y{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=C(P,this._value),this._value}}e.Hasher=y;var b;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function g(S,P,l=32){const c=l-P,u=~((1<<c)-1);return(S<<P|(u&S)>>>c)>>>0}function w(S,P=0,l=S.byteLength,c=0){for(let u=0;u<l;u++)S[P+u]=c}function t(S,P,l="0"){for(;S.length<P;)S=l+S;return S}function m(S,P=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(l=>l.toString(16).padStart(2,"0")).join(""):t((S>>>0).toString(16),P/4)}e.toHexString=m;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const l=P.length;if(l===0)return;const c=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,a,s;for(r!==0?(a=r,s=-1,r=0):(a=P.charCodeAt(0),s=0);;){let n=a;if(p.isHighSurrogate(a))if(s+1<l){const o=P.charCodeAt(s+1);p.isLowSurrogate(o)?(s++,n=p.computeCodePoint(a,o)):n=65533}else{r=a;break}else p.isLowSurrogate(a)&&(n=65533);if(u=this._push(c,u,n),s++,s<l)a=P.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(P,l,c){return c<128?P[l++]=c:c<2048?(P[l++]=192|(c&1984)>>>6,P[l++]=128|(c&63)>>>0):c<65536?(P[l++]=224|(c&61440)>>>12,P[l++]=128|(c&4032)>>>6,P[l++]=128|(c&63)>>>0):(P[l++]=240|(c&1835008)>>>18,P[l++]=128|(c&258048)>>>12,P[l++]=128|(c&4032)>>>6,P[l++]=128|(c&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=E._bigBlock32,l=this._buffDV;for(let v=0;v<64;v+=4)P.setUint32(v,l.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)P.setUint32(v,g(P.getUint32(v-12,!1)^P.getUint32(v-32,!1)^P.getUint32(v-56,!1)^P.getUint32(v-64,!1),1),!1);let c=this._h0,u=this._h1,r=this._h2,a=this._h3,s=this._h4,n,o,d;for(let v=0;v<80;v++)v<20?(n=u&r|~u&a,o=1518500249):v<40?(n=u^r^a,o=1859775393):v<60?(n=u&r|u&a|r&a,o=2400959708):(n=u^r^a,o=3395469782),d=g(c,5)+n+s+o+P.getUint32(v*4,!1)&4294967295,s=a,a=r,r=g(u,30),u=c,c=d;this._h0=this._h0+c&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))});var Pt=this&&this.__classPrivateFieldSet||function(j,e,p,D,C){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!C:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?C.call(j,p):C?C.value=p:e.set(j,p),p},qe=this&&this.__classPrivateFieldGet||function(j,e,p,D){if(p==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?D:p==="a"?D.call(j):D?D.value:e.get(j)};define(Q[40],J([0,1,31,25]),function(j,e,p,D){"use strict";var C,k,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(s,n,o){let d=s.get(n);return d===void 0&&(d=o,s.set(n,d)),d}e.getOrSet=I;function h(s){const n=[];return s.forEach((o,d)=>{n.push(`${d} => ${o}`)}),`Map(${s.size}) {${n.join(", ")}}`}e.mapToString=h;function f(s){const n=[];return s.forEach(o=>{n.push(o)}),`Set(${s.size}) {${n.join(", ")}}`}e.setToString=f;class y{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const o=n.charCodeAt(0),d=this._value.charCodeAt(this._pos);return o-d}value(){return this._value[this._pos]}}e.StringIterator=y;class b{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,D.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class g{constructor(n=!0,o=!0){this._splitOnBackslash=n,this._caseSensitive=o}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,D.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var w;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(w||(w={}));class t{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,D.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class m{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(E||(E={}));class S{constructor(n){this._iter=n}static forUris(n=()=>!1){return new S(new t(n))}static forPaths(){return new S(new g)}static forStrings(){return new S(new y)}static forConfigKeys(){return new S(new b)}clear(){this._root=void 0}fill(n,o){if(o){const d=o.slice(0);(0,p.shuffle)(d);for(let v of d)this.set(v,n)}else{const d=n.slice(0);(0,p.shuffle)(d);for(let v of d)this.set(v[0],v[1])}}set(n,o){const d=this._iter.reset(n);let v;this._root||(this._root=new m,this._root.segment=d.value());const M=[];for(v=this._root;;){const A=d.cmp(v.segment);if(A>0)v.left||(v.left=new m,v.left.segment=d.value()),M.push([-1,v]),v=v.left;else if(A<0)v.right||(v.right=new m,v.right.segment=d.value()),M.push([1,v]),v=v.right;else if(d.hasNext())d.next(),v.mid||(v.mid=new m,v.mid.segment=d.value()),M.push([0,v]),v=v.mid;else break}const L=v.value;v.value=o,v.key=n;for(let A=M.length-1;A>=0;A--){const W=M[A][1];W.updateHeight();const H=W.balanceFactor();if(H<-1||H>1){const Z=M[A][0],ne=M[A+1][0];if(Z===1&&ne===1)M[A][1]=W.rotateLeft();else if(Z===-1&&ne===-1)M[A][1]=W.rotateRight();else if(Z===1&&ne===-1)W.right=M[A+1][1]=M[A+1][1].rotateRight(),M[A][1]=W.rotateLeft();else if(Z===-1&&ne===1)W.left=M[A+1][1]=M[A+1][1].rotateLeft(),M[A][1]=W.rotateRight();else throw new Error;if(A>0)switch(M[A-1][0]){case-1:M[A-1][1].left=M[A][1];break;case 1:M[A-1][1].right=M[A][1];break;case 0:M[A-1][1].mid=M[A][1];break}else this._root=M[0][1]}}return L}get(n){return this._getNode(n)?.value}_getNode(n){const o=this._iter.reset(n);let d=this._root;for(;d;){const v=o.cmp(d.segment);if(v>0)d=d.left;else if(v<0)d=d.right;else if(o.hasNext())o.next(),d=d.mid;else break}return d}has(n){const o=this._getNode(n);return!(o?.value===void 0&&o?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,o){const d=this._iter.reset(n),v=[];let M=this._root;for(;M;){const L=d.cmp(M.segment);if(L>0)v.push([-1,M]),M=M.left;else if(L<0)v.push([1,M]),M=M.right;else if(d.hasNext())d.next(),v.push([0,M]),M=M.mid;else break}if(!!M){if(o?(M.left=void 0,M.mid=void 0,M.right=void 0,M.height=1):(M.key=void 0,M.value=void 0),!M.mid&&!M.value)if(M.left&&M.right){const L=this._min(M.right),{key:A,value:W,segment:H}=L;this._delete(L.key,!1),M.key=A,M.value=W,M.segment=H}else{const L=M.left??M.right;if(v.length>0){const[A,W]=v[v.length-1];switch(A){case-1:W.left=L;break;case 0:W.mid=L;break;case 1:W.right=L;break}}else this._root=L}for(let L=v.length-1;L>=0;L--){const A=v[L][1];A.updateHeight();const W=A.balanceFactor();if(W>1?(A.right.balanceFactor()>=0||(A.right=v[L+1][1]=v[L+1][1].rotateRight()),v[L][1]=A.rotateLeft()):W<-1&&(A.left.balanceFactor()<=0||(A.left=v[L+1][1]=v[L+1][1].rotateLeft()),v[L][1]=A.rotateRight()),L>0)switch(v[L-1][0]){case-1:v[L-1][1].left=v[L][1];break;case 1:v[L-1][1].right=v[L][1];break;case 0:v[L-1][1].mid=v[L][1];break}else this._root=v[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const o=this._iter.reset(n);let d=this._root,v;for(;d;){const M=o.cmp(d.segment);if(M>0)d=d.left;else if(M<0)d=d.right;else if(o.hasNext())o.next(),v=d.value||v,d=d.mid;else break}return d&&d.value||v}findSuperstr(n){const o=this._iter.reset(n);let d=this._root;for(;d;){const v=o.cmp(d.segment);if(v>0)d=d.left;else if(v<0)d=d.right;else if(o.hasNext())o.next(),d=d.mid;else return d.mid?this._entries(d.mid):void 0}}forEach(n){for(const[o,d]of this)n(d,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=o=>{if(!o)return!0;const d=o.balanceFactor();return d<-1||d>1?!1:n(o.left)&&n(o.right)};return n(this._root)}}e.TernarySearchTree=S;class P{constructor(n,o){this.uri=n,this.value=o}}class l{constructor(n,o){this[C]="ResourceMap",n instanceof l?(this.map=new Map(n.map),this.toKey=o??l.defaultToKey):(this.map=new Map,this.toKey=n??l.defaultToKey)}set(n,o){return this.map.set(this.toKey(n),new P(n,o)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,o){typeof o!="undefined"&&(n=n.bind(o));for(let[d,v]of this.map)n(v.value,v.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=l,l.defaultToKey=s=>s.toString();var c;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class u{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,o=0){const d=this._map.get(n);if(!!d)return o!==0&&this.touch(d,o),d.value}set(n,o,d=0){let v=this._map.get(n);if(v)v.value=o,d!==0&&this.touch(v,d);else{switch(v={key:n,value:o,next:void 0,previous:void 0},d){case 0:this.addItemLast(v);break;case 1:this.addItemFirst(v);break;case 2:this.addItemLast(v);break;default:this.addItemLast(v);break}this._map.set(n,v),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this._map.get(n);if(!!o)return this._map.delete(n),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,o){const d=this._state;let v=this._head;for(;v;){if(o?n.bind(o)(v.value,v.key,this):n(v.value,v.key,this),this._state!==d)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const n=this,o=this._state;let d=this._head;const v={[Symbol.iterator](){return v},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const M={value:d.key,done:!1};return d=d.next,M}else return{value:void 0,done:!0}}};return v}values(){const n=this,o=this._state;let d=this._head;const v={[Symbol.iterator](){return v},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const M={value:d.value,done:!1};return d=d.next,M}else return{value:void 0,done:!0}}};return v}entries(){const n=this,o=this._state;let d=this._head;const v={[Symbol.iterator](){return v},next(){if(n._state!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const M={value:[d.key,d.value],done:!1};return d=d.next,M}else return{value:void 0,done:!0}}};return v}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this._head,d=this.size;for(;o&&d>n;)this._map.delete(o.key),o=o.next,d--;this._head=o,this._size=d,o&&(o.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const o=n.next,d=n.previous;if(!o||!d)throw new Error("Invalid list");o.previous=d,d.next=o}n.next=void 0,n.previous=void 0,this._state++}touch(n,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this._head)return;const d=n.next,v=n.previous;n===this._tail?(v.next=void 0,this._tail=v):(d.previous=v,v.next=d),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(o===2){if(n===this._tail)return;const d=n.next,v=n.previous;n===this._head?(d.previous=void 0,this._head=d):(d.previous=v,v.next=d),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((o,d)=>{n.push([d,o])}),n}fromJSON(n){this.clear();for(const[o,d]of n)this.set(o,d)}}e.LinkedMap=u;class r extends u{constructor(n,o=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(n){i.set(this,void 0),Pt(this,i,n,"f")}get size(){return qe(this,i,"f").size}forEach(n,o){qe(this,i,"f").forEach(n,o)}get(n){return qe(this,i,"f").get(n)}has(n){return qe(this,i,"f").has(n)}entries(){return qe(this,i,"f").entries()}keys(){return qe(this,i,"f").keys()}values(){return qe(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return qe(this,i,"f").entries()}}e.ReadonlyMapView=a}),define(Q[70],J([0,1,40]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const D=new p.LRUCache(1e4);function C(f){return h(f,"NFC",D)}e.normalizeNFC=C;const k=new p.LRUCache(1e4);function i(f){return h(f,"NFD",k)}e.normalizeNFD=i;const I=/[^\u0000-\u0080]/;function h(f,y,b){if(!f)return f;const g=b.get(f);if(g)return g;let w;return I.test(f)?w=f.normalize(y):w=f,b.set(f,w),w}e.removeAccents=function(){const f=/[\u0300-\u036f]/g;return function(y){return i(y).replace(f,"")}}()}),define(Q[13],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(M){return Array.isArray(M)}e.isArray=p;function D(M){return typeof M=="string"}e.isString=D;function C(M){return Array.isArray(M)&&M.every(L=>D(L))}e.isStringArray=C;function k(M){return typeof M=="object"&&M!==null&&!Array.isArray(M)&&!(M instanceof RegExp)&&!(M instanceof Date)}e.isObject=k;function i(M){return typeof M=="number"&&!isNaN(M)}e.isNumber=i;function I(M){return!!M&&typeof M[Symbol.iterator]=="function"}e.isIterable=I;function h(M){return M===!0||M===!1}e.isBoolean=h;function f(M){return typeof M=="undefined"}e.isUndefined=f;function y(M){return!b(M)}e.isDefined=y;function b(M){return f(M)||M===null}e.isUndefinedOrNull=b;function g(M,L){if(!M)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}e.assertType=g;function w(M){if(b(M))throw new Error("Assertion Failed: argument is undefined or null");return M}e.assertIsDefined=w;function t(...M){const L=[];for(let A=0;A<M.length;A++){const W=M[A];if(b(W))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);L.push(W)}return L}e.assertAllDefined=t;const m=Object.prototype.hasOwnProperty;function E(M){if(!k(M))return!1;for(let L in M)if(m.call(M,L))return!1;return!0}e.isEmptyObject=E;function S(M){return typeof M=="function"}e.isFunction=S;function P(...M){return M.length>0&&M.every(S)}e.areFunctions=P;function l(M,L){const A=Math.min(M.length,L.length);for(let W=0;W<A;W++)c(M[W],L[W])}e.validateConstraints=l;function c(M,L){if(D(L)){if(typeof M!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(S(L)){try{if(M instanceof L)return}catch{}if(!b(M)&&M.constructor===L||L.length===1&&L.call(void 0,M)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function u(M){let L=[],A=Object.getPrototypeOf(M);for(;Object.prototype!==A;)L=L.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return L}e.getAllPropertyNames=u;function r(M){const L=[];for(const A of u(M))typeof M[A]=="function"&&L.push(A);return L}e.getAllMethodNames=r;function a(M,L){const A=H=>function(){const Z=Array.prototype.slice.call(arguments,0);return L(H,Z)};let W={};for(const H of M)W[H]=A(H);return W}e.createProxyObject=a;function s(M){return M===null?void 0:M}e.withNullAsUndefined=s;function n(M){return typeof M=="undefined"?null:M}e.withUndefinedAsNull=n;function o(M){return class{constructor(){return new Proxy({},{get(L,A){if(L[A])return L[A];throw new Error(`Not Implemented: ${M}->${String(A)}`)}})}}}e.NotImplementedProxy=o;function d(M,L="Unreachable"){throw new Error(L)}e.assertNever=d;function v(M){return!!M&&typeof M.then=="function"&&typeof M.catch=="function"}e.isPromise=v}),define(Q[33],J([0,1,8,3,25,13]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(s){return s===47||s===92}e.isPathSeparator=i;function I(s){return s.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=I;function h(s){return s.indexOf("/")===-1&&(s=I(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=h;function f(s,n=p.posix.sep){if(!s)return"";const o=s.length,d=s.charCodeAt(0);if(i(d)){if(i(s.charCodeAt(1))&&!i(s.charCodeAt(2))){let M=3;const L=M;for(;M<o&&!i(s.charCodeAt(M));M++);if(L!==M&&!i(s.charCodeAt(M+1))){for(M+=1;M<o;M++)if(i(s.charCodeAt(M)))return s.slice(0,M+1).replace(/[\\/]/g,n)}}return n}else if(S(d)&&s.charCodeAt(1)===58)return i(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let v=s.indexOf("://");if(v!==-1){for(v+=3;v<o;v++)if(i(s.charCodeAt(v)))return s.slice(0,v+1)}return""}e.getRoot=f;function y(s){if(!D.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let o=2;const d=o;for(;o<s.length&&(n=s.charCodeAt(o),n!==92);o++);return!(d===o||(n=s.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=y;const b=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(s,n=D.isWindows){const o=n?b:g;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||n&&w.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=t;function m(s,n,o){const d=s===n;return!o||d?d:!s||!n?!1:(0,C.equalsIgnoreCase)(s,n)}e.isEqual=m;function E(s,n,o,d=p.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(o){if(!(0,C.startsWithIgnoreCase)(s,n))return!1;if(n.length===s.length)return!0;let M=n.length;return n.charAt(n.length-1)===d&&M--,s.charAt(M)===d}return n.charAt(n.length-1)!==d&&(n+=d),s.indexOf(n)===0}e.isEqualOrParent=E;function S(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=S;function P(s,n){return D.isWindows&&s.endsWith(":")&&(s+=p.sep),(0,p.isAbsolute)(s)||(s=(0,p.join)(n,s)),s=(0,p.normalize)(s),D.isWindows?(s=(0,C.rtrim)(s,p.sep),s.endsWith(":")&&(s+=p.sep)):(s=(0,C.rtrim)(s,p.sep),s||(s=p.sep)),s}e.sanitizeFilePath=P;function l(s){const n=(0,p.normalize)(s);return D.isWindows?s.length>3?!1:c(n)&&(s.length===2||n.charCodeAt(2)===92):n===p.posix.sep}e.isRootOrDriveLetter=l;function c(s,n){return(n!==void 0?n:D.isWindows)?S(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function u(s){return c(s)?s[0]:void 0}e.getDriveLetter=u;function r(s,n,o){return n.length>s.length?-1:s===n?0:(o&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=r;function a(s){const n=s.split(":");let o,d,v;if(n.forEach(M=>{const L=Number(M);(0,k.isNumber)(L)?d===void 0?d=L:v===void 0&&(v=L):o=o?[o,M].join(":"):M}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:d!==void 0?d:void 0,column:v!==void 0?v:d!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(Q[43],J([0,1,13]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const E=Array.isArray(m)?[]:{};return Object.keys(m).forEach(S=>{m[S]&&typeof m[S]=="object"?E[S]=D(m[S]):E[S]=m[S]}),E}e.deepClone=D;function C(m){if(!m||typeof m!="object")return m;const E=[m];for(;E.length>0;){const S=E.shift();Object.freeze(S);for(const P in S)if(k.call(S,P)){const l=S[P];typeof l=="object"&&!Object.isFrozen(l)&&E.push(l)}}return m}e.deepFreeze=C;const k=Object.prototype.hasOwnProperty;function i(m,E){return I(m,E,new Set)}e.cloneAndChange=i;function I(m,E,S){if((0,p.isUndefinedOrNull)(m))return m;const P=E(m);if(typeof P!="undefined")return P;if((0,p.isArray)(m)){const l=[];for(const c of m)l.push(I(c,E,S));return l}if((0,p.isObject)(m)){if(S.has(m))throw new Error("Cannot clone recursive data-structure");S.add(m);const l={};for(let c in m)k.call(m,c)&&(l[c]=I(m[c],E,S));return S.delete(m),l}return m}function h(m,E,S=!0){return(0,p.isObject)(m)?((0,p.isObject)(E)&&Object.keys(E).forEach(P=>{P in m?S&&((0,p.isObject)(m[P])&&(0,p.isObject)(E[P])?h(m[P],E[P],S):m[P]=E[P]):m[P]=E[P]}),m):E}e.mixin=h;function f(m,E){if(m===E)return!0;if(m==null||E===null||E===void 0||typeof m!=typeof E||typeof m!="object"||Array.isArray(m)!==Array.isArray(E))return!1;let S,P;if(Array.isArray(m)){if(m.length!==E.length)return!1;for(S=0;S<m.length;S++)if(!f(m[S],E[S]))return!1}else{const l=[];for(P in m)l.push(P);l.sort();const c=[];for(P in E)c.push(P);if(c.sort(),!f(l,c))return!1;for(S=0;S<l.length;S++)if(!f(m[l[S]],E[l[S]]))return!1}return!0}e.equals=f;function y(m){const E=new Set;return JSON.stringify(m,(S,P)=>{if((0,p.isObject)(P)||Array.isArray(P)){if(E.has(P))return"[Circular]";E.add(P)}return P})}e.safeStringify=y;function b(m,E,S){const P=E(m);return typeof P=="undefined"?S:P}e.getOrDefault=b;function g(m,E){const S=Object.create(null);return!m||!E||Object.keys(E).forEach(l=>{const c=m[l],u=E[l];f(c,u)||(S[l]=u)}),S}e.distinct=g;function w(m,E){const S=E.toLowerCase(),P=Object.keys(m).find(l=>l.toLowerCase()===S);return P?m[P]:m[E]}e.getCaseInsensitive=w;function t(m,E){const S=Object.create(null);for(const[P,l]of Object.entries(m))E(P,l)&&(S[P]=l);return S}e.filter=t}),define(Q[7],J([0,1,8,3]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,k=/^\//,i=/^\/\//;function I(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!k.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(s,n){return!s&&!n?"file":s}function f(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==b&&(n=b+n):n=b;break}return n}const y="",b="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(n,o,d,v,M,L=!1){typeof n=="object"?(this.scheme=n.scheme||y,this.authority=n.authority||y,this.path=n.path||y,this.query=n.query||y,this.fragment=n.fragment||y):(this.scheme=h(n,L),this.authority=o||y,this.path=f(this.scheme,d||y),this.query=v||y,this.fragment=M||y,I(this,L))}static isUri(n){return n instanceof w?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return l(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:d,path:v,query:M,fragment:L}=n;return o===void 0?o=this.scheme:o===null&&(o=y),d===void 0?d=this.authority:d===null&&(d=y),v===void 0?v=this.path:v===null&&(v=y),M===void 0?M=this.query:M===null&&(M=y),L===void 0?L=this.fragment:L===null&&(L=y),o===this.scheme&&d===this.authority&&v===this.path&&M===this.query&&L===this.fragment?this:new m(o,d,v,M,L)}static parse(n,o=!1){const d=g.exec(n);return d?new m(d[2]||y,a(d[4]||y),a(d[5]||y),a(d[7]||y),a(d[9]||y),o):new m(y,y,y,y,y)}static file(n){let o=y;if(D.isWindows&&(n=n.replace(/\\/g,b)),n[0]===b&&n[1]===b){const d=n.indexOf(b,2);d===-1?(o=n.substring(2),n=b):(o=n.substring(2,d),n=n.substring(d)||b)}return new m("file",o,n,y,y)}static from(n){const o=new m(n.scheme,n.authority,n.path,n.query,n.fragment);return I(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let d;return D.isWindows&&n.scheme==="file"?d=w.file(p.win32.join(l(n,!0),...o)).path:d=p.posix.join(n.path,...o),n.with({path:d})}toString(n=!1){return c(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof w)return n;{const o=new m(n);return o._formatted=n.external,o._fsPath=n._sep===t?n.fsPath:null,o}}else return n}}e.URI=w;const t=D.isWindows?1:void 0;class m extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(n=!1){return n?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=t),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(s,n){let o,d=-1;for(let v=0;v<s.length;v++){const M=s.charCodeAt(v);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||n&&M===47)d!==-1&&(o+=encodeURIComponent(s.substring(d,v)),d=-1),o!==void 0&&(o+=s.charAt(v));else{o===void 0&&(o=s.substr(0,v));const L=E[M];L!==void 0?(d!==-1&&(o+=encodeURIComponent(s.substring(d,v)),d=-1),o+=L):d===-1&&(d=v)}}return d!==-1&&(o+=encodeURIComponent(s.substring(d))),o!==void 0?o:s}function P(s){let n;for(let o=0;o<s.length;o++){const d=s.charCodeAt(o);d===35||d===63?(n===void 0&&(n=s.substr(0,o)),n+=E[d]):n!==void 0&&(n+=s[o])}return n!==void 0?n:s}function l(s,n){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,D.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=l;function c(s,n){const o=n?P:S;let d="",{scheme:v,authority:M,path:L,query:A,fragment:W}=s;if(v&&(d+=v,d+=":"),(M||v==="file")&&(d+=b,d+=b),M){let H=M.indexOf("@");if(H!==-1){const Z=M.substr(0,H);M=M.substr(H+1),H=Z.indexOf(":"),H===-1?d+=o(Z,!1):(d+=o(Z.substr(0,H),!1),d+=":",d+=o(Z.substr(H+1),!1)),d+="@"}M=M.toLowerCase(),H=M.indexOf(":"),H===-1?d+=o(M,!1):(d+=o(M.substr(0,H),!1),d+=M.substr(H))}if(L){if(L.length>=3&&L.charCodeAt(0)===47&&L.charCodeAt(2)===58){const H=L.charCodeAt(1);H>=65&&H<=90&&(L=`/${String.fromCharCode(H+32)}:${L.substr(3)}`)}else if(L.length>=2&&L.charCodeAt(1)===58){const H=L.charCodeAt(0);H>=65&&H<=90&&(L=`${String.fromCharCode(H+32)}:${L.substr(2)}`)}d+=o(L,!0)}return A&&(d+="?",d+=o(A,!1)),W&&(d+="#",d+=n?W:S(W,!1)),d}function u(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(s){return s.match(r)?s.replace(r,n=>u(n)):s}}),define(Q[110],J([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(f){const y=f;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.isRemoteConsoleLog=D;function C(f){const y=[];let b;try{const g=JSON.parse(f.arguments),w=g[g.length-1];w&&w.__$stack&&(g.pop(),b=w.__$stack),y.push(...g)}catch(g){y.push("Unable to log remote console arguments",f.arguments)}return{args:y,stack:b}}e.parse=C;function k(f){if(typeof f!="string")return k(C(f).stack);const y=f;if(y){const b=i(y),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(g&&g.length===4)return{uri:p.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=k;function i(f){if(!f)return f;const y=f.indexOf(`
`);return y===-1?f:f.substring(0,y)}function I(f,y){const{args:b,stack:g}=C(f),w=typeof b[0]=="string"&&b.length===1;let t=i(g);t&&(t=`(${t.trim()})`);let m=[];if(typeof b[0]=="string"?t&&w?m=[`%c[${y}] %c${b[0]} %c${t}`,h("blue"),h(""),h("grey")]:m=[`%c[${y}] %c${b[0]}`,h("blue"),h(""),...b.slice(1)]:m=[`%c[${y}]%`,h("blue"),...b],t&&!w&&m.push(t),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,m)}e.log=I;function h(f){return`color: ${f}`}}),define(Q[111],J([0,1,17,25,7]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function k(y){return JSON.stringify(y,h)}e.stringify=k;function i(y){let b=JSON.parse(y);return b=f(b),b}e.parse=i;var I;(function(y){y[y.Uri=1]="Uri",y[y.Regexp=2]="Regexp",y[y.ScmResource=3]="ScmResource",y[y.ScmResourceGroup=4]="ScmResourceGroup",y[y.ScmProvider=5]="ScmProvider",y[y.CommentController=6]="CommentController",y[y.CommentThread=7]="CommentThread",y[y.CommentThreadReply=8]="CommentThreadReply",y[y.CommentNode=9]="CommentNode",y[y.CommentThreadNode=10]="CommentThreadNode",y[y.TimelineActionContext=11]="TimelineActionContext",y[y.NotebookCellActionContext=12]="NotebookCellActionContext",y[y.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function h(y,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,D.regExpFlags)(b)}:b}function f(y,b=0){if(!y||b>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return C.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof p.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let g=0;g<y.length;++g)y[g]=f(y[g],b+1);else for(const g in y)Object.hasOwnProperty.call(y,g)&&(y[g]=f(y[g],b+1))}return y}e.revive=f}),define(Q[10],J([0,1,3,7]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(C=e.Schemas||(e.Schemas={}));class k{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(h){this._preferredWebSchema=h}setDelegate(h){this._delegate=h}set(h,f,y){this._hosts[h]=f,this._ports[h]=y}setConnectionToken(h,f){this._connectionTokens[h]=f}rewrite(h){if(this._delegate)return this._delegate(h);const f=h.authority;let y=this._hosts[f];y&&y.indexOf(":")!==-1&&(y=`[${y}]`);const b=this._ports[f],g=this._connectionTokens[f];let w=`path=${encodeURIComponent(h.path)}`;return typeof g=="string"&&(w+=`&tkn=${encodeURIComponent(g)}`),D.URI.from({scheme:p.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${y}:${b}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new k;class i{asBrowserUri(h,f){const y=this.toUri(h,f);return y.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(y):y.scheme===C.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${C.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?y.with({scheme:C.vscodeFileResource,authority:y.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(h,f){const y=this.toUri(h,f);return y.scheme===C.vscodeFileResource?y.with({scheme:C.file,authority:y.authority!==i.FALLBACK_AUTHORITY?y.authority:null,query:null,fragment:null}):y}toUri(h,f){return D.URI.isUri(h)?h:D.URI.parse(f.toUrl(h))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(Q[15],J([0,1,33,10,8,3,25,7]),function(j,e,p,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(w){return(0,I.uriToFsPath)(w,!0)}e.originalFSPath=h;class f{constructor(t){this._ignorePathCasing=t}compare(t,m,E=!1){return t===m?0:(0,i.compare)(this.getComparisonKey(t,E),this.getComparisonKey(m,E))}isEqual(t,m,E=!1){return t===m?!0:!t||!m?!1:this.getComparisonKey(t,E)===this.getComparisonKey(m,E)}getComparisonKey(t,m=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,m,E=!1){if(t.scheme===m.scheme){if(t.scheme===D.Schemas.file)return p.isEqualOrParent(h(t),h(m),this._ignorePathCasing(t))&&t.query===m.query&&(E||t.fragment===m.fragment);if((0,e.isEqualAuthority)(t.authority,m.authority))return p.isEqualOrParent(t.path,m.path,this._ignorePathCasing(t),"/")&&t.query===m.query&&(E||t.fragment===m.fragment)}return!1}joinPath(t,...m){return I.URI.joinPath(t,...m)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return C.posix.basename(t.path)}extname(t){return C.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let m;return t.scheme===D.Schemas.file?m=I.URI.file(C.dirname(h(t))).path:(m=C.posix.dirname(t.path),t.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),m="/")),t.with({path:m})}normalizePath(t){if(!t.path.length)return t;let m;return t.scheme===D.Schemas.file?m=I.URI.file(C.normalize(h(t))).path:m=C.posix.normalize(t.path),t.with({path:m})}relativePath(t,m){if(t.scheme!==m.scheme||!(0,e.isEqualAuthority)(t.authority,m.authority))return;if(t.scheme===D.Schemas.file){const P=C.relative(h(t),h(m));return k.isWindows?p.toSlashes(P):P}let E=t.path||"/",S=m.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const l=Math.min(E.length,S.length);P<l&&!(E.charCodeAt(P)!==S.charCodeAt(P)&&E.charAt(P).toLowerCase()!==S.charAt(P).toLowerCase());P++);E=S.substr(0,P)+E.substr(P)}return C.posix.relative(E,S)}resolvePath(t,m){if(t.scheme===D.Schemas.file){const E=I.URI.file(C.resolve(h(t),m));return t.with({authority:E.authority,path:E.path})}return m=p.toPosixPath(m),t.with({path:C.posix.resolve(t.path,m)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,m){return t===m||t!==void 0&&m!==void 0&&(0,i.equalsIgnoreCase)(t,m)}hasTrailingPathSeparator(t,m=C.sep){if(t.scheme===D.Schemas.file){const E=h(t);return E.length>p.getRoot(E).length&&E[E.length-1]===m}else{const E=t.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,m=C.sep){return(0,e.hasTrailingPathSeparator)(t,m)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,m=C.sep){let E=!1;if(t.scheme===D.Schemas.file){const S=h(t);E=S!==void 0&&S.length===p.getRoot(S).length&&S[S.length-1]===m}else{m="/";const S=t.path;E=S.length===1&&S.charCodeAt(S.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(t,m)?t.with({path:t.path+"/"}):t}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(w=>w.scheme===D.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new f(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function y(w,t){const m=[];for(let E=0;E<w.length;E++){const S=t(w[E]);w.some((P,l)=>l===E?!1:(0,e.isEqualOrParent)(S,t(P)))||m.push(w[E])}return m}e.distinctParents=y;var b;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function t(m){const E=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(l=>{const[c,u]=l.split(":");c&&u&&E.set(c,u)});const P=m.path.substring(0,m.path.indexOf(";"));return P&&E.set(w.META_DATA_MIME,P),E}w.parseMetaData=t})(b=e.DataUri||(e.DataUri={}));function g(w,t,m){if(t){let E=w.path;return E&&E[0]!==C.posix.sep&&(E=C.posix.sep+E),w.with({scheme:m,authority:t,path:E})}return w.with({scheme:m})}e.toLocalResource=g}),define(Q[9],J([0,1,23,16,4,2,15]),function(j,e,p,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(q){return!!q&&typeof q.then=="function"}e.isThenable=I;function h(q){const U=new p.CancellationTokenSource,N=q(U.token),_=new Promise((Y,F)=>{const R=U.token.onCancellationRequested(()=>{R.dispose(),U.dispose(),F((0,D.canceled)())});Promise.resolve(N).then(O=>{R.dispose(),U.dispose(),Y(O)},O=>{R.dispose(),U.dispose(),F(O)})});return new class{cancel(){U.cancel()}then(Y,F){return _.then(Y,F)}catch(Y){return this.then(void 0,Y)}finally(Y){return _.finally(Y)}}}e.createCancelablePromise=h;function f(q,U,N){return Promise.race([q,new Promise(_=>U.onCancellationRequested(()=>_(N)))])}e.raceCancellation=f;async function y(q){let U=-1;const N=q.map((Y,F)=>Y.then(R=>(U=F,R))),_=await Promise.race(N);return q.forEach((Y,F)=>{F!==U&&Y.cancel()}),_}e.raceCancellablePromises=y;function b(q,U,N){let _;const Y=setTimeout(()=>{_?.(void 0),N?.()},U);return Promise.race([q.finally(()=>clearTimeout(Y)),new Promise(F=>_=F)])}e.raceTimeout=b;function g(q){return new Promise((U,N)=>{const _=q();I(_)?_.then(U,N):U(_)})}e.asPromise=g;class w{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const N=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(N,N).then(_)})}return new Promise((N,_)=>{this.queuedPromise.then(N,_)})}return this.activePromise=U(),new Promise((N,_)=>{this.activePromise.then(Y=>{this.activePromise=null,N(Y)},Y=>{this.activePromise=null,_(Y)})})}}e.Throttler=w;class t{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=t;class m{constructor(){this.promiseMap=new Map}queue(U,N){const Y=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.promiseMap.get(U)===Y&&this.promiseMap.delete(U)});return this.promiseMap.set(U,Y),Y}}e.SequencerByKey=m;class E{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,N=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,Y)=>{this.doResolve=_,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},N),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,D.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=E;class S{constructor(U){this.delayer=new E(U),this.throttler=new w}trigger(U,N){return this.delayer.trigger(()=>this.throttler.queue(U),N)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class P{constructor(){this._isOpen=!1,this._promise=new Promise((U,N)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=P;class l extends P{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function c(q,U){return U?new Promise((N,_)=>{const Y=setTimeout(()=>{F.dispose(),N()},q),F=U.onCancellationRequested(()=>{clearTimeout(Y),F.dispose(),_((0,D.canceled)())})}):h(N=>c(q,N))}e.timeout=c;function u(q,U=0){const N=setTimeout(q,U);return(0,k.toDisposable)(()=>clearTimeout(N))}e.disposableTimeout=u;function r(q){const U=[];let N=0;const _=q.length;function Y(){return N<_?q[N++]():null}function F(R){R!=null&&U.push(R);const O=Y();return O?O.then(F):Promise.resolve(U)}return Promise.resolve(null).then(F)}e.sequence=r;function a(q,U=_=>!!_,N=null){let _=0;const Y=q.length,F=()=>{if(_>=Y)return Promise.resolve(N);const R=q[_++];return Promise.resolve(R()).then($=>U($)?Promise.resolve($):F())};return F()}e.first=a;function s(q,U=_=>!!_,N=null){if(q.length===0)return Promise.resolve(N);let _=q.length;const Y=()=>{_=-1;for(const F of q)F.cancel?.()};return new Promise((F,R)=>{for(const O of q)O.then($=>{--_>=0&&U($)?(Y(),F($)):_===0&&F(N)}).catch($=>{--_>=0&&(Y(),R($))})})}e.firstParallel=s;class n{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((N,_)=>{this.outstandingPromises.push({factory:U,c:N,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const N=U.factory();N.then(U.c,U.e),N.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=n;class o extends n{constructor(){super(1)}}e.Queue=o;class d{constructor(){this.queues=new Map}queueFor(U,N=i.extUri){const _=N.getComparisonKey(U);let Y=this.queues.get(_);return Y||(Y=new o,C.Event.once(Y.onFinished)(()=>{Y?.dispose(),this.queues.delete(_)}),this.queues.set(_,Y)),Y}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=d;class v{constructor(U,N){this._token=-1,typeof U=="function"&&typeof N=="number"&&this.setIfNotSet(U,N)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},N)}setIfNotSet(U,N){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},N))}}e.TimeoutTimer=v;class M{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,N){this.cancel(),this._token=setInterval(()=>{U()},N)}}e.IntervalTimer=M;class L{constructor(U,N){this.timeoutToken=-1,this.runner=U,this.timeout=N,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class A{constructor(U,N){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=N,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class W extends L{constructor(U,N){super(U,N);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=W;class H extends k.Disposable{constructor(U,N,_,Y){super();this.maxWorkChunkSize=U,this.maxPendingWork=N,this.throttleDelay=_,this.handler=Y,this.pendingWork=[],this.throttler=this._register(new k.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{const U=setTimeout(()=>{const _=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0,clearTimeout(U))}}}:e.runWhenIdle=(q,U)=>{const N=requestIdleCallback(q,typeof U=="number"?{timeout:U}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(N))}}}}();class Z{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(N){this._error=N}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=Z;async function ne(q,U,N){let _;for(let Y=0;Y<N;Y++)try{return await q()}catch(F){_=F,await c(U)}throw _}e.retry=ne;class oe{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,N,_){return this._pending={taskId:U,cancel:()=>_?.(),promise:N},N.then(()=>this.donePending(U),()=>this.donePending(U)),N}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let N,_;const Y=new Promise((F,R)=>{N=F,_=R});this._next={run:U,promise:Y,promiseResolve:N,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=oe;class G{constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=G;class T{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,N)=>{this.completeCallback=U,this.errorCallback=N})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(N=>{this.completeCallback(U),this.resolved=!0,N()})}error(U){return new Promise(N=>{this.errorCallback(U),this.rejected=!0,N()})}cancel(){new Promise(U=>{this.errorCallback((0,D.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=T;var z;(function(q){async function U(_){let Y;const F=await Promise.all(_.map(R=>R.then(O=>O,O=>{Y||(Y=O)})));if(typeof Y!="undefined")throw Y;return F}q.settled=U;function N(_){return new Promise(async(Y,F)=>{try{await _(Y,F)}catch(R){F(R)}})}q.withAsyncBody=N})(z=e.Promises||(e.Promises={}))}),define(Q[34],J([0,1,33,10,8,3,15,25,7]),function(j,e,p,D,C,k,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function f(n,o,d){if(typeof n=="string"&&(n=h.URI.file(n)),d){const M=d.getWorkspaceFolder(n);if(M){const L=d.getWorkspace().folders.length>1;let A;if((0,i.isEqual)(M.uri,n)?A="":A=(0,i.relativePath)(M.uri,n),L){const W=M.name?M.name:(0,i.basename)(M.uri);A=A?W+" \u2022 "+A:W}return A}}if(n.scheme!==D.Schemas.file&&n.scheme!==D.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(n.fsPath))return(0,C.normalize)(b(n.fsPath));let v=(0,C.normalize)(n.fsPath);return!k.isWindows&&o?.userHome&&(v=w(v,o.userHome.fsPath)),v}e.getPathLabel=f;function y(n){if(!n)return;typeof n=="string"&&(n=h.URI.file(n));const o=(0,i.basename)(n)||(n.scheme===D.Schemas.file?n.fsPath:n.path);return k.isWindows&&(0,p.isRootOrDriveLetter)(o)?b(o):o}e.getBaseLabel=y;function b(n,o){return(0,p.hasDriveLetter)(n,o)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=b;let g=Object.create(null);function w(n,o){if(k.isWindows||!n||!o)return n;let d=g.original===o?g.normalized:void 0;return d||(d=`${(0,I.rtrim)(o,C.posix.sep)}${C.posix.sep}`,g={original:o,normalized:d}),(k.isLinux?n.startsWith(d):(0,I.startsWithIgnoreCase)(n,d))&&(n=`~/${n.substr(d.length)}`),n}e.tildify=w;function t(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=t;const m="\u2026",E="\\\\",S="~";function P(n,o=C.sep){const d=new Array(n.length);let v=!1;for(let M=0;M<n.length;M++){let L=n[M];if(L===""){d[M]=`.${o}`;continue}if(!L){d[M]=L;continue}v=!0;let A="";L.indexOf(E)===0?(A=L.substr(0,L.indexOf(E)+E.length),L=L.substr(L.indexOf(E)+E.length)):L.indexOf(o)===0?(A=L.substr(0,L.indexOf(o)+o.length),L=L.substr(L.indexOf(o)+o.length)):L.indexOf(S)===0&&(A=L.substr(0,L.indexOf(S)+S.length),L=L.substr(L.indexOf(S)+S.length));const W=L.split(o);for(let H=1;v&&H<=W.length;H++)for(let Z=W.length-H;v&&Z>=0;Z--){v=!1;let ne=W.slice(Z,Z+H).join(o);for(let oe=0;!v&&oe<n.length;oe++)if(oe!==M&&n[oe]&&n[oe].indexOf(ne)>-1){const G=Z+H===W.length,T=Z>0&&n[oe].indexOf(o)>-1?o+ne:ne,z=n[oe].endsWith(T);v=!G||z}if(!v){let oe="";(W[0].endsWith(":")||A!=="")&&(Z===1&&(Z=0,H++,ne=W[0]+o+ne),Z>0&&(oe=W[0]+o),oe=A+oe),Z>0&&(oe=oe+m+o),oe=oe+ne,Z+H<W.length&&(oe=oe+o+m),d[M]=oe}}v&&(d[M]=L)}return d}e.shorten=P;var l;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function c(n,o=Object.create(null)){const d=[];let v=!1,M="";for(const L of n)if(L==="$"||v&&L==="{")M&&d.push({value:M,type:l.TEXT}),M="",v=!0;else if(L==="}"&&v){const A=o[M];if(typeof A=="string")A.length&&d.push({value:A,type:l.VARIABLE});else if(A){const W=d[d.length-1];(!W||W.type!==l.SEPARATOR)&&d.push({value:A.label,type:l.SEPARATOR})}M="",v=!1}else M+=L;return M&&!v&&d.push({value:M,type:l.TEXT}),d.filter((L,A)=>{if(L.type===l.SEPARATOR){const W=d[A-1],H=d[A+1];return[W,H].every(Z=>Z&&(Z.type===l.VARIABLE||Z.type===l.TEXT)&&Z.value.length>0)}return!0}).map(L=>L.value).join("")}e.template=c;function u(n,o){return k.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):n.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function r(n,o){return k.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):k.isWindows?n.replace(/&&|&/g,d=>d==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function a(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=a;function s(n){const o=n.indexOf("/")!==-1?C.posix:C.win32,d=o.basename(n),v=o.dirname(n);return d.length?{name:d,parentPath:v}:{name:v,parentPath:""}}e.splitName=s}),define(Q[112],J([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(y){return y.toJSON()}class C{constructor(b){this._uriTransformer=b}transformIncoming(b){const g=this._uriTransformer.transformIncoming(b);return g===b?b:D(p.URI.from(g))}transformOutgoing(b){const g=this._uriTransformer.transformOutgoing(b);return g===b?b:D(p.URI.from(g))}transformOutgoingURI(b){const g=this._uriTransformer.transformOutgoing(b);return g===b?b:p.URI.from(g)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function k(y,b,g){if(!y||g>200)return null;if(typeof y=="object"){if(y instanceof p.URI)return b.transformOutgoing(y);for(let w in y)if(Object.hasOwnProperty.call(y,w)){const t=k(y[w],b,g+1);t!==null&&(y[w]=t)}}return null}function i(y,b){const g=k(y,b,0);return g===null?y:g}e.transformOutgoingURIs=i;function I(y,b,g,w){if(!y||w>200)return null;if(typeof y=="object"){if(y.$mid===1)return g?p.URI.revive(b.transformIncoming(y)):b.transformIncoming(y);for(let t in y)if(Object.hasOwnProperty.call(y,t)){const m=I(y[t],b,g,w+1);m!==null&&(y[t]=m)}}return null}function h(y,b){const g=I(y,b,!1,0);return g===null?y:g}e.transformIncomingURIs=h;function f(y,b){const g=I(y,b,!0,0);return g===null?y:g}e.transformAndReviveIncomingURIs=f}),define(Q[28],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(h){return p.test(h)}e.isUUID=D;const C=new Uint8Array(16),k=[];for(let h=0;h<256;h++)k.push(h.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(h){for(let f=0;f<h.length;f++)h[f]=Math.floor(Math.random()*256);return h};function I(){i(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let h=0,f="";return f+=k[C[h++]],f+=k[C[h++]],f+=k[C[h++]],f+=k[C[h++]],f+="-",f+=k[C[h++]],f+=k[C[h++]],f+="-",f+=k[C[h++]],f+=k[C[h++]],f+="-",f+=k[C[h++]],f+=k[C[h++]],f+="-",f+=k[C[h++]],f+=k[C[h++]],f+=k[C[h++]],f+=k[C[h++]],f+=k[C[h++]],f+=k[C[h++]],f}e.generateUuid=I}),define(Q[113],J([0,1,16,4,2,3,13,25]),function(j,e,p,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const h="$initialize";let f=!1;function y(s){!k.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(s.message))}e.logOnceWebWorkerWarning=y;var b;(function(s){s[s.Request=0]="Request",s[s.Reply=1]="Reply",s[s.SubscribeEvent=2]="SubscribeEvent",s[s.Event=3]="Event",s[s.UnsubscribeEvent=4]="UnsubscribeEvent"})(b||(b={}));class g{constructor(n,o,d,v){this.vsWorker=n,this.req=o,this.method=d,this.args=v,this.type=0}}class w{constructor(n,o,d,v){this.vsWorker=n,this.seq=o,this.res=d,this.err=v,this.type=1}}class t{constructor(n,o,d,v){this.vsWorker=n,this.req=o,this.eventName=d,this.arg=v,this.type=2}}class m{constructor(n,o,d){this.vsWorker=n,this.req=o,this.event=d,this.type=3}}class E{constructor(n,o){this.vsWorker=n,this.req=o,this.type=4}}class S{constructor(n){this._workerId=-1,this._handler=n,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(n){this._workerId=n}sendMessage(n,o){const d=String(++this._lastSentReq);return new Promise((v,M)=>{this._pendingReplies[d]={resolve:v,reject:M},this._send(new g(this._workerId,d,n,o))})}listen(n,o){let d=null;const v=new D.Emitter({onFirstListenerAdd:()=>{d=String(++this._lastSentReq),this._pendingEmitters.set(d,v),this._send(new t(this._workerId,d,n,o))},onLastListenerRemove:()=>{this._pendingEmitters.delete(d),this._send(new E(this._workerId,d)),d=null}});return v.event}handleMessage(n){!n||!n.vsWorker||this._workerId!==-1&&n.vsWorker!==this._workerId||this._handleMessage(n)}_handleMessage(n){switch(n.type){case 1:return this._handleReplyMessage(n);case 0:return this._handleRequestMessage(n);case 2:return this._handleSubscribeEventMessage(n);case 3:return this._handleEventMessage(n);case 4:return this._handleUnsubscribeEventMessage(n)}}_handleReplyMessage(n){if(!this._pendingReplies[n.seq]){console.warn("Got reply to unknown seq");return}let o=this._pendingReplies[n.seq];if(delete this._pendingReplies[n.seq],n.err){let d=n.err;n.err.$isError&&(d=new Error,d.name=n.err.name,d.message=n.err.message,d.stack=n.err.stack),o.reject(d);return}o.resolve(n.res)}_handleRequestMessage(n){let o=n.req;this._handler.handleMessage(n.method,n.args).then(v=>{this._send(new w(this._workerId,o,v,void 0))},v=>{v.detail instanceof Error&&(v.detail=(0,p.transformErrorForSerialization)(v.detail)),this._send(new w(this._workerId,o,void 0,(0,p.transformErrorForSerialization)(v)))})}_handleSubscribeEventMessage(n){const o=n.req,d=this._handler.handleEvent(n.eventName,n.arg)(v=>{this._send(new m(this._workerId,o,v))});this._pendingEvents.set(o,d)}_handleEventMessage(n){if(!this._pendingEmitters.has(n.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(n.req).fire(n.event)}_handleUnsubscribeEventMessage(n){if(!this._pendingEvents.has(n.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(n.req).dispose(),this._pendingEvents.delete(n.req)}_send(n){let o=[];if(n.type===0)for(let d=0;d<n.args.length;d++)n.args[d]instanceof ArrayBuffer&&o.push(n.args[d]);else n.type===1&&n.res instanceof ArrayBuffer&&o.push(n.res);this._handler.sendMessage(n,o)}}class P extends C.Disposable{constructor(n,o,d){super();let v=null;this._worker=this._register(n.create("vs/base/common/worker/simpleWorker",H=>{this._protocol.handleMessage(H)},H=>{v&&v(H)})),this._protocol=new S({sendMessage:(H,Z)=>{this._worker.postMessage(H,Z)},handleMessage:(H,Z)=>{if(typeof d[H]!="function")return Promise.reject(new Error("Missing method "+H+" on main thread host."));try{return Promise.resolve(d[H].apply(d,Z))}catch(ne){return Promise.reject(ne)}},handleEvent:(H,Z)=>{if(c(H)){const ne=d[H].call(d,Z);if(typeof ne!="function")throw new Error(`Missing dynamic event ${H} on main thread host.`);return ne}if(l(H)){const ne=d[H];if(typeof ne!="function")throw new Error(`Missing event ${H} on main thread host.`);return ne}throw new Error(`Malformed event name ${H}`)}}),this._protocol.setWorkerId(this._worker.getId());let M=null;typeof k.globals.require!="undefined"&&typeof k.globals.require.getConfig=="function"?M=k.globals.require.getConfig():typeof k.globals.requirejs!="undefined"&&(M=k.globals.requirejs.s.contexts._.config);const L=i.getAllMethodNames(d);this._onModuleLoaded=this._protocol.sendMessage(h,[this._worker.getId(),JSON.parse(JSON.stringify(M)),o,L]);const A=(H,Z)=>this._request(H,Z),W=(H,Z)=>this._protocol.listen(H,Z);this._lazyProxy=new Promise((H,Z)=>{v=Z,this._onModuleLoaded.then(ne=>{H(u(ne,A,W))},ne=>{Z(ne),this._onError("Worker failed to load "+o,ne)})})}getProxyObject(){return this._lazyProxy}_request(n,o){return new Promise((d,v)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(n,o).then(d,v)},v)})}_onError(n,o){console.error(n),console.info(o)}}e.SimpleWorkerClient=P;function l(s){return s[0]==="o"&&s[1]==="n"&&I.isUpperAsciiLetter(s.charCodeAt(2))}function c(s){return/^onDynamic/.test(s)&&I.isUpperAsciiLetter(s.charCodeAt(9))}function u(s,n,o){const d=L=>function(){const A=Array.prototype.slice.call(arguments,0);return n(L,A)},v=L=>function(A){return o(L,A)};let M={};for(const L of s){if(c(L)){M[L]=v(L);continue}if(l(L)){M[L]=o(L,void 0);continue}M[L]=d(L)}return M}class r{constructor(n,o){this._requestHandlerFactory=o,this._requestHandler=null,this._protocol=new S({sendMessage:(d,v)=>{n(d,v)},handleMessage:(d,v)=>this._handleMessage(d,v),handleEvent:(d,v)=>this._handleEvent(d,v)})}onmessage(n){this._protocol.handleMessage(n)}_handleMessage(n,o){if(n===h)return this.initialize(o[0],o[1],o[2],o[3]);if(!this._requestHandler||typeof this._requestHandler[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this._requestHandler[n].apply(this._requestHandler,o))}catch(d){return Promise.reject(d)}}_handleEvent(n,o){if(!this._requestHandler)throw new Error("Missing requestHandler");if(c(n)){const d=this._requestHandler[n].call(this._requestHandler,o);if(typeof d!="function")throw new Error(`Missing dynamic event ${n} on request handler.`);return d}if(l(n)){const d=this._requestHandler[n];if(typeof d!="function")throw new Error(`Missing event ${n} on request handler.`);return d}throw new Error(`Malformed event name ${n}`)}initialize(n,o,d,v){this._protocol.setWorkerId(n);const A=u(v,(W,H)=>this._protocol.sendMessage(W,H),(W,H)=>this._protocol.listen(W,H));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(A),Promise.resolve(i.getAllMethodNames(this._requestHandler))):(o&&(typeof o.baseUrl!="undefined"&&delete o.baseUrl,typeof o.paths!="undefined"&&typeof o.paths.vs!="undefined"&&delete o.paths.vs,typeof o.trustedTypesPolicy!==void 0&&delete o.trustedTypesPolicy,o.catchError=!0,k.globals.require.config(o)),new Promise((W,H)=>{(k.globals.require||j)([d],ne=>{if(this._requestHandler=ne.create(A),!this._requestHandler){H(new Error("No RequestHandler!"));return}W(i.getAllMethodNames(this._requestHandler))},H)}))}}e.SimpleWorkerServer=r;function a(s){return new r(s,null)}e.create=a}),define(Q[114],J([0,1,61,29,42]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function k(i,I){if(await new Promise((y,b)=>{const g=D.createReadStream(i),w=p.createHash("sha1");g.pipe(w);const t=(0,C.once)((m,E)=>{g.removeAllListeners(),w.removeAllListeners(),m?b(m):y(E)});g.once("error",t),g.once("end",t),w.once("error",t),w.once("data",m=>t(void 0,m.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=k}),define(Q[115],J([0,1,245]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class D{constructor(k="utf8"){this.stringDecoder=new p.StringDecoder(k),this.remaining=null}write(k){const i=[],I=this.remaining?this.remaining+this.stringDecoder.write(k):this.stringDecoder.write(k);if(I.length<1)return i;let h=0,f,y=h;for(;y<I.length;)if(f=I.charCodeAt(y),f===13||f===10){if(i.push(I.substring(h,y)),y++,y<I.length){const b=f;f=I.charCodeAt(y),(b===13&&f===10||b===10&&f===13)&&y++}h=y}else y++;return this.remaining=h<I.length?I.substr(h):null,i}end(){return this.remaining}}e.LineDecoder=D}),define(Q[116],J([0,1,26]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(i){const I=i.replace(/\-/g,":").toLowerCase();return!D.has(I)}function k(){const i=(0,p.networkInterfaces)();for(let I in i){const h=i[I];if(h){for(const{mac:f}of h)if(C(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(Q[71],J([0,1,26,16,40,28,116]),function(j,e,p,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(y){return this._virtualMachineOUIs||(this._virtualMachineOUIs=C.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(y)}value(){if(this._value===void 0){let y=0,b=0;const g=(0,p.networkInterfaces)();for(let w in g){const t=g[w];if(t)for(const{mac:m,internal:E}of t)E||(b+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(y+=1))}this._value=b>0?y/b:0}return this._value}};let I;async function h(){return I||(I=(async()=>await f()||k.generateUuid())()),I}e.getMachineId=h;async function f(){try{const y=await new Promise((g,w)=>{j(["crypto"],g,w)}),b=(0,i.getMac)();return y.createHash("sha256").update(b,"utf8").digest("hex")}catch(y){D.onUnexpectedError(y);return}}}),define(Q[21],J([0,1,29,26,117,9,33,70,8,3,15,7,28]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function t(T,z=w.UNLINK){if((0,i.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");return z===w.UNLINK?E(T):m(T)}async function m(T){try{const z=(0,h.join)((0,D.tmpdir)(),(0,g.generateUuid)());try{await e.Promises.rename(T,z)}catch(q){return E(T)}E(z).catch(q=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function E(T){return e.Promises.rmdir(T,{recursive:!0,maxRetries:3})}function S(T){if((0,i.isRootOrDriveLetter)(T))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(T,{recursive:!0})}e.rimrafSync=S;async function P(T,z){return u(await(z?l(T):(0,C.promisify)(p.readdir)(T)))}async function l(T){try{return await(0,C.promisify)(p.readdir)(T,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const z=[],q=await P(T);for(const U of q){let N=!1,_=!1,Y=!1;try{const F=await e.Promises.lstat((0,h.join)(T,U));N=F.isFile(),_=F.isDirectory(),Y=F.isSymbolicLink()}catch(F){console.warn("[node.js fs] unexpected error from lstat after readdir: ",F)}z.push({name:U,isFile:()=>N,isDirectory:()=>_,isSymbolicLink:()=>Y})}return z}function c(T){return u(p.readdirSync(T))}e.readdirSync=c;function u(T){return T.map(z=>typeof z=="string"?f.isMacintosh?(0,I.normalizeNFC)(z):z:(z.name=f.isMacintosh?(0,I.normalizeNFC)(z.name):z.name,z))}async function r(T){const z=await P(T),q=[];for(const U of z)await s.existsDirectory((0,h.join)(T,U))&&q.push(U);return q}function a(T,z=1e3){return new Promise(q=>{let U=!1;const N=setInterval(()=>{U||(U=!0,p.access(T,_=>{U=!1,_&&(clearInterval(N),q(void 0))}))},z)})}e.whenDeleted=a;var s;(function(T){async function z(N){let _;try{if(_=await e.Promises.lstat(N),!_.isSymbolicLink())return{stat:_}}catch(Y){}try{return{stat:await e.Promises.stat(N),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(f.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(N)),symbolicLink:{dangling:!1}}}catch(F){if(F.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw F}throw Y}}T.stat=z;async function q(N){try{const{stat:_,symbolicLink:Y}=await T.stat(N);return _.isFile()&&Y?.dangling!==!0}catch(_){}return!1}T.existsFile=q;async function U(N){try{const{stat:_,symbolicLink:Y}=await T.stat(N);return _.isDirectory()&&Y?.dangling!==!0}catch(_){}return!1}T.existsDirectory=U})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new k.ResourceQueue;function o(T,z,q){return n.queueFor(b.URI.file(T),y.extUriBiasedIgnorePathCase).queue(()=>{const U=L(q);return new Promise((N,_)=>v(T,z,U,Y=>Y?_(Y):N()))})}let d=!0;function v(T,z,q,U){if(!d)return p.writeFile(T,z,{mode:q.mode,flag:q.flag},U);p.open(T,q.flag,q.mode,(N,_)=>{if(N)return U(N);p.writeFile(_,z,Y=>{if(Y)return p.close(_,()=>U(Y));p.fdatasync(_,F=>(F&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",F),d=!1),p.close(_,R=>U(R))))})})}function M(T,z,q){const U=L(q);if(!d)return p.writeFileSync(T,z,{mode:U.mode,flag:U.flag});const N=p.openSync(T,U.flag,U.mode);try{p.writeFileSync(N,z);try{p.fdatasyncSync(N)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),d=!1}}finally{p.closeSync(N)}}e.writeFileSync=M;function L(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function A(T,z){if(T===z)return;async function q(U){try{const N=await e.Promises.lstat(U);if(N.isDirectory()||N.isSymbolicLink())return;await e.Promises.utimes(U,N.atime,new Date)}catch(N){}}try{await e.Promises.rename(T,z),await q(z)}catch(U){if(T.toLowerCase()!==z.toLowerCase()&&U.code==="EXDEV"||T.endsWith("."))await W(T,z,{preserveSymlinks:!1}),await t(T,w.MOVE),await q(z);else throw U}}async function W(T,z,q){return Z(T,z,{root:{source:T,target:z},options:q,handledSourcePaths:new Set})}const H=511;async function Z(T,z,q){if(q.handledSourcePaths.has(T))return;q.handledSourcePaths.add(T);const{stat:U,symbolicLink:N}=await s.stat(T);if(N){if(q.options.preserveSymlinks)try{return await G(T,z,q)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(N.dangling)return}return U.isDirectory()?ne(T,z,U.mode&H,q):oe(T,z,U.mode&H)}async function ne(T,z,q,U){await e.Promises.mkdir(z,{recursive:!0,mode:q});const N=await P(T);for(const _ of N)await Z((0,h.join)(T,_),(0,h.join)(z,_),U)}async function oe(T,z,q){await e.Promises.copyFile(T,z),await e.Promises.chmod(z,q)}async function G(T,z,q){let U=await e.Promises.readlink(T);(0,i.isEqualOrParent)(U,q.root.source,!f.isLinux)&&(U=(0,h.join)(q.root.target,U.substr(q.root.source.length+1))),await e.Promises.symlink(U,z)}e.Promises=new class{get access(){return(0,C.promisify)(p.access)}get stat(){return(0,C.promisify)(p.stat)}get lstat(){return(0,C.promisify)(p.lstat)}get utimes(){return(0,C.promisify)(p.utimes)}get read(){return(0,C.promisify)(p.read)}get readFile(){return(0,C.promisify)(p.readFile)}get write(){return(0,C.promisify)(p.write)}get appendFile(){return(0,C.promisify)(p.appendFile)}get fdatasync(){return(0,C.promisify)(p.fdatasync)}get truncate(){return(0,C.promisify)(p.truncate)}get rename(){return(0,C.promisify)(p.rename)}get copyFile(){return(0,C.promisify)(p.copyFile)}get open(){return(0,C.promisify)(p.open)}get close(){return(0,C.promisify)(p.close)}get symlink(){return(0,C.promisify)(p.symlink)}get readlink(){return(0,C.promisify)(p.readlink)}get chmod(){return(0,C.promisify)(p.chmod)}get mkdir(){return(0,C.promisify)(p.mkdir)}get unlink(){return(0,C.promisify)(p.unlink)}get rmdir(){return(0,C.promisify)(p.rmdir)}get realpath(){return(0,C.promisify)(p.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return r}get writeFile(){return o}get rm(){return t}get move(){return A}get copy(){return W}}}),define(Q[82],J([0,1,29,8,25,21]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(y){const b=(0,D.dirname)(y);if(y===b)return y;const g=((0,D.basename)(y)||y).toLowerCase();try{const t=(0,k.readdirSync)(b).filter(m=>m.toLowerCase()===g);if(t.length===1){const m=i(b);if(m)return(0,D.join)(m,t[0])}else if(t.length>1){const m=t.indexOf(g);if(m>=0){const E=i(b);if(E)return(0,D.join)(E,t[m])}}}catch(w){}return null}e.realcaseSync=i;async function I(y){try{return await k.Promises.realpath(y)}catch(b){const g=f(y);return await k.Promises.access(g,p.constants.R_OK),g}}e.realpath=I;function h(y){try{return p.realpathSync(y)}catch(b){const g=f(y);return p.accessSync(g,p.constants.R_OK),g}}e.realpathSync=h;function f(y){return(0,C.rtrim)((0,D.normalize)(y),D.sep)}}),define(Q[118],J([0,1,62]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function D(I,h,f,y=1){let b=!1;return new Promise(g=>{const w=setTimeout(()=>{if(!b)return b=!0,g(0)},f);C(I,h,y,t=>{if(!b)return b=!0,clearTimeout(w),g(t)})})}e.findFreePort=D;function C(I,h,f,y){if(h===0)return y(0);const b=new p.Socket;b.once("connect",()=>(i(b),C(I+f,h-1,f,y))),b.once("data",()=>{}),b.once("error",g=>(i(b),g.code!=="ECONNREFUSED"?C(I+f,h-1,f,y):y(I))),b.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(I,h,f){let y=!1,b,g=1;const w=p.createServer({pauseOnConnect:!0});function t(m,E){y||(y=!0,w.removeAllListeners(),w.close(),b&&clearTimeout(b),E(m))}return new Promise(m=>{b=setTimeout(()=>{t(0,m)},f),w.on("listening",()=>{t(I,m)}),w.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&g<h?(I++,g++,w.listen(I,"127.0.0.1")):t(0,m)}),w.on("close",()=>{t(0,m)}),w.listen(I,"127.0.0.1")})}e.findFreePortFaster=k;function i(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(h){console.error(h)}}}),define(Q[119],J([0,1,26,8,21]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,i=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var h;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(h||(h={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class b{constructor(u,r,a){this.exePath=u,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await C.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:c=!1}={}){return c?f===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:c=!1,findPreview:u=!1}={}){const r=g({useAlternateBitness:c});if(!r)return null;const a=D.join(r,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(a))return null;let s=-1,n=null;for(const v of await C.Promises.readdir(a)){let M=-1;if(u){const A=v.indexOf("-");if(A<0)continue;const W=v.substring(0,A);if(!k.test(W)||v.substring(A+1)!=="preview")continue;M=parseInt(W,10)}else{if(!k.test(v))continue;M=parseInt(v,10)}if(M<=s)continue;const L=D.join(a,v,"pwsh.exe");!await C.SymlinkSupport.existsFile(L)||(n=L,s=M)}if(!n)return null;const o=r.includes("x86")?" (x86)":"",d=u?" Preview":"";return new b(n,`PowerShell${d}${o}`,!0)}async function t({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const u=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=c?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:i,pwshMsixName:"PowerShell (Store)"};for(const s of await C.Promises.readdir(u))if(r.test(s)){const n=D.join(u,s,"pwsh.exe");return new b(n,a)}return null}function m(){const c=D.join(p.homedir(),".dotnet","tools","pwsh.exe");return new b(c,".NET Core PowerShell Global Tool")}function E(){const c=D.join(process.env.windir,f===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(c,"Windows PowerShell",!0)}async function*S(){let c=await w();c&&(yield c),c=await w({useAlternateBitness:!0}),c&&(yield c),c=await t(),c&&(yield c),c=m(),c&&(yield c),c=await w({findPreview:!0}),c&&(yield c),c=await t({findPreview:!0}),c&&(yield c),c=await w({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=E(),c&&(yield c)}async function*P(){for await(const c of S())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=P;async function l(){for await(const c of P())return c;return null}e.getFirstAvailablePowerShellInstallation=l}),define(Q[83],J([0,1,44,10]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function C(i){return new Promise((I,h)=>{let f;const y=new Map;function b(w,t,m,E,S){const P=y.get(t);if(w===i||P){const l={name:g(m),cmd:m,pid:w,ppid:t,load:E,mem:S};y.set(w,l),w===i&&(f=l),P&&(P.children||(P.children=[]),P.children.push(l),P.children.length>1&&(P.children=P.children.sort((c,u)=>c.pid-u.pid)))}}function g(w){const t=/--disable-blink-features=Auxclick/,m=/\\watcher\\win32\\CodeHelper\.exe/,E=/--crashes-directory/,S=/\\pipe\\winpty-control/,P=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(m.exec(w))return"watcherService ";if(E.exec(w))return"electron-crash-reporter";if(S.exec(w))return"winpty-process";if(P.exec(w))return"console-window-host (Windows internal process)";let c=l.exec(w);if(c&&c.length===2)return c[1]==="renderer"?t.exec(w)?"shared-process":"window":c[1];const u=/[a-zA-Z-]+\.js/g;let r="";do c=u.exec(w),c&&(r+=c+" ");while(c);return r&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${r}`:w}if(process.platform==="win32"){const w=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,m)=>{j(["windows-process-tree"],t,m)}).then(t=>{t.getProcessList(i,m=>{t.getProcessCpuUsage(m,E=>{const S=new Map;E.forEach(P=>{const l=w(P.commandLine||"");S.set(P.pid,{name:g(l),cmd:l,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),f=S.get(i),f?(S.forEach(P=>{const l=S.get(P.ppid);l&&(l.children||(l.children=[]),l.children.push(P))}),S.forEach(P=>{P.children&&(P.children=P.children.sort((l,c)=>l.pid-c.pid))}),I(f)):h(new Error(`Root process ${i} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let w=function(){let t=[f];const m=[];for(;t.length;){const S=t.shift();S&&(m.push(S.pid),S.children&&(t=t.concat(S.children)))}let E=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);E+=" "+m.join(" "),(0,p.exec)(E,{},(S,P,l)=>{if(S||l)h(S||new Error(l.toString()));else{const c=P.toString().split(`
`);for(let u=0;u<m.length;u++){const r=y.get(m[u]);r.load=parseFloat(c[u])}if(!f){h(new Error(`Root process ${i} not found`));return}I(f)}})};(0,p.exec)("which ps",{},(t,m,E)=>{if(t||E)if(process.platform!=="linux")h(t||new Error(E.toString()));else{const S=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,p.exec)(S,{},(P,l,c)=>{P||c?h(P||new Error(c.toString())):(k(l,b),w())})}else{const S=m.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${S} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,c,u)=>{l||u&&!u.includes("screen size is bogus")?h(l||new Error(u.toString())):(k(c,b),process.platform==="linux"?w():f?I(f):h(new Error(`Root process ${i} not found`)))})}})}})}e.listProcesses=C;function k(i,I){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=i.toString().split(`
`);for(const y of f){const b=h.exec(y.trim());b&&b.length===6&&I(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(Q[120],J([0,1,29,23,33,2,70,8,3,21]),function(j,e,p,D,C,k,i,I,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(t,m,E){return g({path:t,isDirectory:!1},m,E)}e.watchFile=y;function b(t,m,E){return g({path:t,isDirectory:!0},m,E)}e.watchFolder=b,e.CHANGE_BUFFER_DELAY=100;function g(t,m,E){if(h.isMacintosh&&(0,C.isEqualOrParent)(t.path,"/Volumes/"))return E(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),k.Disposable.None;const S=(0,I.basename)(t.path),P=new Map;let l=!1,c=[(0,k.toDisposable)(()=>{P.forEach(u=>(0,k.dispose)(u)),P.clear()})];try{const u=(0,p.watch)(t.path);c.push((0,k.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const r=new Set;t.isDirectory&&f.Promises.readdir(t.path).then(a=>a.forEach(s=>r.add(s))),u.on("error",(a,s)=>{l||E(`Failed to watch ${t.path} for changes using fs.watch() (${a}, ${s})`)}),u.on("change",(a,s)=>{if(l)return;let n="";if(s&&(n=s.toString(),h.isMacintosh&&(n=(0,i.normalizeNFC)(n))),!n||a!=="change"&&a!=="rename")return;const o=t.isDirectory?(0,I.join)(t.path,n):t.path;if(t.isDirectory)if(a==="rename"){const d=P.get(o);d&&(0,k.dispose)(d);const v=setTimeout(async()=>{P.delete(o);const M=await f.Promises.exists(o);if(l)return;let L;M?r.has(n)?L="changed":(L="added",r.add(n)):(r.delete(n),L="deleted"),m(L,o)},e.CHANGE_BUFFER_DELAY);P.set(o,(0,k.toDisposable)(()=>clearTimeout(v)))}else{let d;r.has(n)?d="changed":(d="added",r.add(n)),m(d,o)}else if(a==="rename"||n!==S){const d=setTimeout(async()=>{const v=await f.Promises.exists(o);l||(v?(m("changed",o),c=[g(t,m,E)]):m("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(c),c=[(0,k.toDisposable)(()=>clearTimeout(d))]}else m("changed",o)})}catch(u){f.Promises.exists(t.path).then(r=>{r&&!l&&E(`Failed to watch ${t.path} for changes using fs.watch() (${u.toString()})`)})}return(0,k.toDisposable)(()=>{l=!0,c=(0,k.dispose)(c)})}async function w(t,m,E,S=512){const P=await f.Promises.open(t,"r"),l=Buffer.allocUnsafe(S),c=new D.CancellationTokenSource(E);let u,r=!1;const a=y(t,async s=>{if(s==="changed"){if(r)return;r=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:n}=await f.Promises.read(P,l,0,S,null);if(!n||c.token.isCancellationRequested)break;m(l.slice(0,n))}}catch(n){u=new Error(n),c.dispose(!0)}finally{r=!1}}},s=>{u=new Error(s),c.dispose(!0)});return new Promise((s,n)=>{c.token.onCancellationRequested(async()=>{a.dispose(),await f.Promises.close(P),u?n(u):s()})})}e.watchFileContents=w}),define(Q[121],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[122],J([0,1,14,13,121]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function k(){p.ipcMain.on(C.CONTEXT_MENU_CHANNEL,(I,h,f,y,b)=>{const g=i(I,y,f);g.popup({window:(0,D.withNullAsUndefined)(p.BrowserWindow.fromWebContents(I.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{g&&I.sender.send(C.CONTEXT_MENU_CLOSE_CHANNEL,h)}})})}e.registerContextMenuListener=k;function i(I,h,f){const y=new p.Menu;return f.forEach(b=>{let g;b.type==="separator"?g=new p.MenuItem({type:b.type}):Array.isArray(b.submenu)?g=new p.MenuItem({submenu:i(I,h,b.submenu),label:b.label}):g=new p.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(w,t,m)=>I.sender.send(h,b.id,m)}),y.append(g)}),y}});var he=this&&this.__decorate||function(j,e,p,D){var C=arguments.length,k=C<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,p):D,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(j,e,p,D);else for(var I=j.length-1;I>=0;I--)(i=j[I])&&(k=(C<3?i(k):C>3?i(e,p,k):i(e,p))||k);return C>3&&k&&Object.defineProperty(e,p,k),k};define(Q[35],J([0,1,31,9,17,23,47,16,4,2,111,25,13]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function t(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function E(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(S||(S={}));class P{constructor(_){this.buffer=_,this.pos=0}read(_){const Y=this.buffer.slice(this.pos,this.pos+_);return this.pos+=Y.byteLength,Y}}class l{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var c;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(c||(c={}));function u(N){const _=C.VSBuffer.alloc(4);return _.writeUInt32BE(N,0),_}function r(N){return N.read(4).readUInt32BE(0)}function a(N){const _=C.VSBuffer.alloc(1);return _.writeUInt8(N,0),_}const s={Undefined:a(c.Undefined),String:a(c.String),Buffer:a(c.Buffer),VSBuffer:a(c.VSBuffer),Array:a(c.Array),Object:a(c.Object)},n=typeof Buffer!="undefined";function o(N,_){if(typeof _=="undefined")N.write(s.Undefined);else if(typeof _=="string"){const Y=C.VSBuffer.fromString(_);N.write(s.String),N.write(u(Y.byteLength)),N.write(Y)}else if(n&&Buffer.isBuffer(_)){const Y=C.VSBuffer.wrap(_);N.write(s.Buffer),N.write(u(Y.byteLength)),N.write(Y)}else if(_ instanceof C.VSBuffer)N.write(s.VSBuffer),N.write(u(_.byteLength)),N.write(_);else if(Array.isArray(_)){N.write(s.Array),N.write(u(_.length));for(const Y of _)o(N,Y)}else{const Y=C.VSBuffer.fromString(JSON.stringify(_));N.write(s.Object),N.write(u(Y.byteLength)),N.write(Y)}}function d(N){switch(N.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return N.read(r(N)).toString();case c.Buffer:return N.read(r(N)).buffer;case c.VSBuffer:return N.read(r(N));case c.Array:{const Y=r(N),F=[];for(let R=0;R<Y;R++)F.push(d(N));return F}case c.Object:return JSON.parse(N.read(r(N)).toString())}}class v{constructor(_,Y,F=null,R=1e3){this.protocol=_,this.ctx=Y,this.logger=F,this.timeoutDelay=R,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(O=>this.onRawMessage(O)),this.sendResponse({type:200})}registerChannel(_,Y){this.channels.set(_,Y),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const Y=this.send([_.type]);this.logger&&this.logger.logOutgoing(Y,0,1,E(_.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([_.type,_.id],_.data);this.logger&&this.logger.logOutgoing(Y,_.id,1,E(_.type),_.data);return}}}send(_,Y=void 0){const F=new l;return o(F,_),o(F,Y),this.sendBuffer(F.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(Y){return 0}}onRawMessage(_){const Y=new P(_),F=d(Y),R=d(Y),O=F[0];switch(O){case 100:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${t(O)}: ${F[2]}.${F[3]}`,R),this.onPromise({type:O,id:F[1],channelName:F[2],name:F[3],arg:R});case 102:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${t(O)}: ${F[2]}.${F[3]}`,R),this.onEventListen({type:O,id:F[1],channelName:F[2],name:F[3],arg:R});case 101:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${t(O)}`),this.disposeActiveRequest({type:O,id:F[1]});case 103:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],1,`${t(O)}`),this.disposeActiveRequest({type:O,id:F[1]})}}onPromise(_){const Y=this.channels.get(_.channelName);if(!Y){this.collectPendingRequest(_);return}const F=new k.CancellationTokenSource;let R;try{R=Y.call(this.ctx,_.name,_.arg,F.token)}catch(X){R=Promise.reject(X)}const O=_.id;R.then(X=>{this.sendResponse({id:O,data:X,type:201}),this.activeRequests.delete(_.id)},X=>{X instanceof Error?this.sendResponse({id:O,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:O,data:X,type:203}),this.activeRequests.delete(_.id)});const $=(0,f.toDisposable)(()=>F.cancel());this.activeRequests.set(_.id,$)}onEventListen(_){const Y=this.channels.get(_.channelName);if(!Y){this.collectPendingRequest(_);return}const F=_.id,O=Y.listen(this.ctx,_.name,_.arg)($=>this.sendResponse({id:F,data:$,type:204}));this.activeRequests.set(_.id,O)}disposeActiveRequest(_){const Y=this.activeRequests.get(_.id);Y&&(Y.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let Y=this.pendingRequests.get(_.channelName);Y||(Y=[],this.pendingRequests.set(_.channelName,Y));const F=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:_,timeoutTimer:F})}flushPendingRequests(_){const Y=this.pendingRequests.get(_);if(Y){for(const F of Y)switch(clearTimeout(F.timeoutTimer),F.request.type){case 100:this.onPromise(F.request);break;case 102:this.onEventListen(F.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelServer=v;var M;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(M=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(_,Y=null){this.protocol=_,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new h.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(F=>this.onBuffer(F)),this.logger=Y}getChannel(_){const Y=this;return{call(F,R,O){return Y.isDisposed?Promise.reject(I.canceled()):Y.requestPromise(_,F,R,O)},listen(F,R){return Y.isDisposed?Promise.reject(I.canceled()):Y.requestEvent(_,F,R)}}}requestPromise(_,Y,F,R=k.CancellationToken.None){const O=this.lastRequestId++,X={id:O,type:100,channelName:_,name:Y,arg:F};if(R.isCancellationRequested)return Promise.reject(I.canceled());let V;return new Promise((x,te)=>{if(R.isCancellationRequested)return te(I.canceled());const ce=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(O),x(de.data);break;case 202:this.handlers.delete(O);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,te(ve);break;case 203:this.handlers.delete(O),te(de.data);break}};this.handlers.set(O,ue),this.sendRequest(X)};let se=null;this.state===S.Idle?ce():(se=(0,D.createCancelablePromise)(ue=>this.whenInitialized()),se.then(()=>{se=null,ce()}));const ie=()=>{se?(se.cancel(),se=null):this.sendRequest({id:O,type:101}),te(I.canceled())},ae=R.onCancellationRequested(ie);V=(0,f.combinedDisposable)((0,f.toDisposable)(ie),ae),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(_,Y,F){const R=this.lastRequestId++,$={id:R,type:102,channelName:_,name:Y,arg:F};let X=null;const V=new h.Emitter({onFirstListenerAdd:()=>{X=(0,D.createCancelablePromise)(x=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(V),this.sendRequest($)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(V),this.sendRequest({id:R,type:103}))}}),B=x=>V.fire(x.data);return this.handlers.set(R,B),V.event}sendRequest(_){switch(_.type){case 100:case 102:{const Y=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger&&this.logger.logOutgoing(Y,_.id,0,`${t(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const Y=this.send([_.type,_.id]);this.logger&&this.logger.logOutgoing(Y,_.id,0,t(_.type));return}}}send(_,Y=void 0){const F=new l;return o(F,_),o(F,Y),this.sendBuffer(F.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(Y){return 0}}onBuffer(_){const Y=new P(_),F=d(Y),R=d(Y),O=F[0];switch(O){case 200:return this.logger&&this.logger.logIncoming(_.byteLength,0,0,E(O)),this.onResponse({type:F[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(_.byteLength,F[1],0,E(O),R),this.onResponse({type:F[0],id:F[1],data:R})}}onResponse(_){if(_.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(_.id);Y&&Y(_)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}he([i.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class A{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new h.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new h.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:Y,onDidClientDisconnect:F})=>{h.Event.once(Y.onMessage)(O=>{const $=new P(O),X=d($),V=new v(Y,X),B=new L(Y);this.channels.forEach((te,ce)=>V.registerChannel(ce,te));const x={channelServer:V,channelClient:B,ctx:X};this._connections.add(x),this._onDidAddConnection.fire(x),F(()=>{V.dispose(),B.dispose(),this._connections.delete(x),this._onDidRemoveConnection.fire(x)})})})}get connections(){const _=[];return this._connections.forEach(Y=>_.push(Y)),_}getChannel(_,Y){const F=this;return{call(R,O,$){let X;if((0,g.isFunction)(Y)){let B=(0,p.getRandomElement)(F.connections.filter(Y));X=B?Promise.resolve(B):h.Event.toPromise(h.Event.filter(F.onDidAddConnection,Y))}else X=Y.routeCall(F,R,O);const V=X.then(B=>B.channelClient.getChannel(_));return H(V).call(R,O,$)},listen(R,O){if((0,g.isFunction)(Y))return F.getMulticastEvent(_,Y,R,O);const $=Y.routeEvent(F,R,O).then(X=>X.channelClient.getChannel(_));return H($).listen(R,O)}}}getMulticastEvent(_,Y,F,R){const O=this;let $=new f.DisposableStore;const X=new h.Emitter({onFirstListenerAdd:()=>{$=new f.DisposableStore;const V=new h.EventMultiplexer,B=new Map,x=ce=>{const ie=ce.channelClient.getChannel(_).listen(F,R),ae=V.add(ie);B.set(ce,ae)},te=ce=>{const se=B.get(ce);!se||(se.dispose(),B.delete(ce))};O.connections.filter(Y).forEach(x),h.Event.filter(O.onDidAddConnection,Y)(x,void 0,$),O.onDidRemoveConnection(te,void 0,$),V.event(X.fire,X,$),$.add(V)},onLastListenerRemove:()=>{$.dispose()}});return X.event}registerChannel(_,Y){this.channels.set(_,Y),this._connections.forEach(F=>{F.channelServer.registerChannel(_,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class W{constructor(_,Y,F=null){const R=new l;o(R,Y),_.send(R.buffer),this.channelClient=new L(_,F),this.channelServer=new v(_,Y,F)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,Y){this.channelServer.registerChannel(_,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=W;function H(N){return{call(_,Y,F){return N.then(R=>R.call(_,Y,F))},listen(_,Y){const F=new h.Relay;return N.then(R=>F.input=R.listen(_,Y)),F.event}}}e.getDelayedChannel=H;function Z(N){let _=!1;return{call(Y,F,R){return _?N.call(Y,F,R):(0,D.timeout)(0).then(()=>_=!0).then(()=>N.call(Y,F,R))},listen(Y,F){if(_)return N.listen(Y,F);const R=new h.Relay;return(0,D.timeout)(0).then(()=>_=!0).then(()=>R.input=N.listen(Y,F)),R.event}}}e.getNextTickChannel=Z;class ne{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const Y of _.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await h.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=ne;var oe;(function(N){function _(O,$){const X=O,V=$&&$.disableMarshalling,B=new Map;for(const x in X)F(x)&&B.set(x,h.Event.buffer(X[x],!0));return new class{listen(x,te,ce){const se=B.get(te);if(se)return se;if(R(te)){const ie=X[te];if(typeof ie=="function")return ie.call(X,ce)}throw new Error(`Event not found: ${te}`)}call(x,te,ce){const se=X[te];if(typeof se=="function"){if(!V&&Array.isArray(ce))for(let ie=0;ie<ce.length;ie++)ce[ie]=(0,y.revive)(ce[ie]);return se.apply(X,ce)}throw new Error(`Method not found: ${te}`)}}}N.fromService=_;function Y(O,$){const X=$&&$.disableMarshalling;return new Proxy({},{get(V,B){if(typeof B=="string")return $?.properties?.has(B)?$.properties.get(B):R(B)?function(x){return O.listen(B,x)}:F(B)?O.listen(B):async function(...x){let te;$&&!(0,g.isUndefinedOrNull)($.context)?te=[$.context,...x]:te=x;const ce=await O.call(B,te);return X?ce:(0,y.revive)(ce)};throw new Error(`Property not found: ${String(B)}`)}})}N.toService=Y;function F(O){return O[0]==="o"&&O[1]==="n"&&b.isUpperAsciiLetter(O.charCodeAt(2))}function R(O){return/^onDynamic/.test(O)&&b.isUpperAsciiLetter(O.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const G=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let _=N.toString();if(_!=="[object Object]")return _}return N}function z(N){return Array.isArray(N)?N.map(T):T(N)}function q(N,_,Y,F,R,O,$){$=z($);const X=G[R],V=X[F%X.length];let B=[`%c[${N}]%c[${String(_).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(F).padStart(5," ")} - ${O}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(O)?(B=B.concat($),B.push(")")):B.push($),console.log.apply(console,B)}e.logWithColors=q;class U{constructor(_,Y){this._outgoingPrefix=_,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,Y,F,R,O){this._totalOutgoing+=_,q(this._outgoingPrefix,this._totalOutgoing,_,Y,F,R,O)}logIncoming(_,Y,F,R,O){this._totalIncoming+=_,q(this._incomingPrefix,this._totalIncoming,_,Y,F,R,O)}}e.IPCLogger=U}),define(Q[123],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(C,k){this.sender=C,this.onMessage=k}send(C){try{this.sender.send("vscode:message",C.buffer)}catch(k){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Q[124],J([0,1,17,4,35]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class k{constructor(h){this.port=h,this.onMessage=D.Event.fromDOMEventEmitter(this.port,"message",f=>p.VSBuffer.wrap(f.data)),h.start()}send(h){this.port.postMessage(h.buffer)}disconnect(){this.port.close()}}e.Protocol=k;class i extends C.IPCClient{constructor(h,f){const y=new k(h);super(y,f);this.protocol=y}dispose(){this.protocol.disconnect()}}e.Client=i}),define(Q[84],J([0,1,17,4,2,3,32,35]),function(j,e,p,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var h;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h=e.SocketCloseEventType||(e.SocketCloseEventType={}));let f=null;function y(){return f||(f=p.VSBuffer.alloc(0)),f}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return y();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const L=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),L}if(this._chunks[0].byteLength>n){const L=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),L}let d=p.VSBuffer.alloc(n),v=0,M=0;for(;n>0;){const L=this._chunks[M];if(L.byteLength>n){const A=L.slice(0,n);d.set(A,v),v+=n,o&&(this._chunks[M]=L.slice(n),this._totalLength-=n),n-=n}else d.set(L,v),v+=L.byteLength,o?(this._chunks.shift(),this._totalLength-=L.byteLength):M++,n-=L.byteLength}return d}}e.ChunkStream=b;var g;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var w;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class t{constructor(n,o,d,v){this.type=n,this.id=o,this.ack=d,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends C.Disposable{constructor(n){super();this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const d=this._state.messageType,v=this._state.id,M=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new t(d,v,M,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class E{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=p.VSBuffer.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._writeSoon(o,n.data)}_bufferAdd(n,o){const d=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,d}_bufferTake(){const n=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends C.Disposable{constructor(n){super();this._onMessage=new D.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new E(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new t(1,0,0,n))}}e.Protocol=S;class P extends I.IPCClient{constructor(n,o,d=null){super(n,o,d);this.protocol=n}static fromSocket(n,o){return new P(new S(n),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=P;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new D.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,i.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class c{constructor(n){this.data=n,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],o=0,d=this._first;for(;d;)n[o++]=d.data,d=d.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new c(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class r{constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<r._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=r._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const n=Date.now(),o=(1+r._HISTORY_LENGTH)*1e3;let d=0;for(let v=0;v<r._HISTORY_LENGTH;v++)n-this.lastRuns[v]<=o&&d++;return 1-d/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class a{constructor(n,o=null,d=r.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=d,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new t(5,0,0,y());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const o=new t(4,0,0,y());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let o=0,d=n.length;o<d;o++)this._socketWriter.write(n[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new t(6,0,0,y())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const o=this._outgoingUnackMsg.toArray();for(let d=0,v=o.length;d<v;d++)this._socketWriter.write(o[d]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const d=new t(1,o,this._incomingAckId,n);this._outgoingUnackMsg.push(d),this._isReconnecting||(this._socketWriter.write(d),this._recvAckCheck())}sendControl(n){const o=new t(2,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new t(3,0,this._incomingAckId,y());this._socketWriter.write(n)}}e.PersistentProtocol=a}),define(Q[125],J([0,1,14,17,4,2,35,123]),function(j,e,p,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(y,b){const g=C.Event.fromNodeEventEmitter(p.ipcMain,b,(t,m)=>({event:t,message:m})),w=C.Event.filter(g,({event:t})=>t.sender.id===y);return C.Event.map(w,({message:t})=>t&&D.VSBuffer.wrap(t))}class f extends i.IPCServer{constructor(){super(f.getOnDidClientConnect())}static getOnDidClientConnect(){const b=C.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:g})=>g);return C.Event.map(b,g=>{const w=g.id,t=f.Clients.get(w);t&&t.dispose();const m=new C.Emitter;f.Clients.set(w,(0,k.toDisposable)(()=>m.fire()));const E=h(w,"vscode:message"),S=C.Event.any(C.Event.signal(h(w,"vscode:disconnect")),m.event);return{protocol:new I.Protocol(g,E),onDidClientDisconnect:S}})}}e.Server=f,f.Clients=new Map}),define(Q[85],J([0,1,14,4,28,124]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class i extends k.Client{constructor(f,y){super({addEventListener:(b,g)=>f.addListener(b,g),removeEventListener:(b,g)=>f.removeListener(b,g),postMessage:b=>f.postMessage(b),start:()=>f.start(),close:()=>f.close()},y)}}e.Client=i;async function I(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const f=(0,C.generateUuid)();h.webContents.send("vscode:createMessageChannel",f);const y=D.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(g,w)=>({nonce:w,port:g.ports[0]})),{port:b}=await D.Event.toPromise(D.Event.once(D.Event.filter(y,g=>g.nonce===f)));return b}e.connect=I}),define(Q[86],J([0,1,9,4,2,13]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var i;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(i=e.StorageHint||(e.StorageHint={}));function I(b){const g=b;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var h;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(h||(h={}));class f extends C.Disposable{constructor(g,w=Object.create(null)){super();this.database=g,this.options=w,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=h.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((w,t)=>this.accept(t,w)),g.deleted?.forEach(w=>this.accept(w,void 0))}accept(g,w){if(this.state===h.Closed)return;let t=!1;(0,k.isUndefinedOrNull)(w)?t=this.cache.delete(g):this.cache.get(g)!==w&&(this.cache.set(g,w),t=!0),t&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===h.None&&(this.state=h.Initialized,this.options.hint!==i.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,w){const t=this.cache.get(g);return(0,k.isUndefinedOrNull)(t)?w:t}getBoolean(g,w){const t=this.get(g);return(0,k.isUndefinedOrNull)(t)?w:t==="true"}getNumber(g,w){const t=this.get(g);return(0,k.isUndefinedOrNull)(t)?w:parseInt(t,10)}async set(g,w){if(this.state===h.Closed)return;if((0,k.isUndefinedOrNull)(w))return this.delete(g);const t=String(w);if(this.cache.get(g)!==t)return this.cache.set(g,t),this.pendingInserts.set(g,t),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async delete(g){if(!(this.state===h.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=h.Closed;try{await this.doFlush(0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(g){if(!!this.hasPending)return this.doFlush(g)}async doFlush(g){return this.flushDelayer.trigger(()=>this.flushPending(),g)}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((w,t)=>this.items.set(t,w)),g.delete&&g.delete.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=y}),define(Q[126],J([0,1,9,4,40,8,21]),function(j,e,p,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{constructor(y,b=Object.create(null)){this.path=y,this.options=b,this.name=(0,k.basename)(this.path),this.logger=new h(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return D.Event.None}async getItems(){const y=await this.whenConnected,b=new Map;return(await this.all(y,"SELECT * FROM ItemTable")).forEach(w=>b.set(w.key,w.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(y){const b=await this.whenConnected;return this.doUpdateItems(b,y)}doUpdateItems(y,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,C.mapToString)(b.insert):"0"}), delete(${b.delete?(0,C.setToString)(b.delete):"0"})`),this.transaction(y,()=>{const g=b.insert,w=b.delete;if(g&&g.size>0){const t=[];t.push([]);let m=0;g.forEach((E,S)=>{let P=t[m];P.length>I.MAX_HOST_PARAMETERS&&(m++,P=[],t.push(P)),P.push(S,E)}),t.forEach(E=>{this.prepare(y,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,S=>S.run(E),()=>{const S=[];let P=0;return g.forEach((l,c)=>{S.push(c),P+=l.length}),`Keys: ${S.join(", ")} Length: ${P}`})})}if(w&&w.size){const t=[];t.push([]);let m=0;w.forEach(E=>{let S=t[m];S.length>I.MAX_HOST_PARAMETERS&&(m++,S=[],t.push(S)),S.push(E)}),t.forEach(E=>{this.prepare(y,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,S=>S.run(E),()=>{const S=[];return w.forEach(P=>{S.push(P)}),`Keys: ${S.join(", ")}`})})}})}async close(y){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,y)}doClose(y,b){return new Promise((g,w)=>{y.db.close(t=>(t&&this.handleSQLiteError(y,`[storage ${this.name}] close(): ${t}`),this.path===I.IN_MEMORY_PATH?g():!y.isErroneous&&!y.isInMemory?this.backup().then(g,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),g())):typeof b=="function"?i.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const E=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:b()}).then(()=>E(),S=>(E(),Promise.reject(S)))})).then(g,w):w(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const y=this.toBackupPath(this.path);return i.Promises.copy(this.path,y,{preserveSymlinks:!1})}toBackupPath(y){return`${y}.backup`}async checkIntegrity(y){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${y})`);const b=await this.whenConnected,g=await this.get(b,y?"PRAGMA integrity_check":"PRAGMA quick_check"),w=y?g.integrity_check:g.quick_check;return b.isErroneous?`${w} (last error: ${b.lastError})`:b.isInMemory?`${w} (in-memory!)`:w}async connect(y,b=!0){this.logger.trace(`[storage ${this.name}] open(${y}, retryOnBusy: ${b})`);try{return await this.doConnect(y)}catch(g){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${g}`),g.code==="SQLITE_BUSY"&&b)return await(0,p.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(y,!1);try{await i.Promises.unlink(y);try{await i.Promises.rename(this.toBackupPath(y),y)}catch(w){}return await this.doConnect(y)}catch(w){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${w}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(y,b){y.isErroneous=!0,y.lastError=b,this.logger.error(b)}doConnect(y){return new Promise((b,g)=>{new Promise((w,t)=>{j(["@vscode/sqlite3"],w,t)}).then(w=>{const t={db:new(this.logger.isTracing?w.verbose().Database:w.Database)(y,m=>m?t.db?t.db.close(()=>g(m)):g(m):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(t),E=>t.db.close(()=>g(E)))),isInMemory:y===I.IN_MEMORY_PATH};t.db.on("error",m=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&t.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},g)})}exec(y,b){return new Promise((g,w)=>{y.db.exec(b,t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] exec(): ${t}`),w(t)):g())})}get(y,b){return new Promise((g,w)=>{y.db.get(b,(t,m)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] get(): ${t}`),w(t)):g(m))})}all(y,b){return new Promise((g,w)=>{y.db.all(b,(t,m)=>t?(this.handleSQLiteError(y,`[storage ${this.name}] all(): ${t}`),w(t)):g(m))})}transaction(y,b){return new Promise((g,w)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),b(),y.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(y,`[storage ${this.name}] transaction(): ${t}`),w(t)):g())})})}prepare(y,b,g,w){const t=y.db.prepare(b),m=E=>{this.handleSQLiteError(y,`[storage ${this.name}] prepare(): ${E} (${b}). Details: ${w()}`)};t.on("error",m),g(t),t.finalize(E=>{E&&m(E),t.removeListener("error",m)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class h{constructor(y){y&&typeof y.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.logTrace=y.logTrace),y&&typeof y.logError=="function"&&(this.logError=y.logError)}get isTracing(){return!!this.logTrace}trace(y){this.logTrace&&this.logTrace(y)}error(y){this.logError&&this.logError(y)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[127],J([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(Q[128],J([0,1,127]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,C=D*60,k=C*24,i=k*7,I=k*30,h=k*365;function f(b,g){typeof b!="number"&&(b=b.getTime());const w=Math.round((new Date().getTime()-b)/1e3);if(w<-30)return(0,p.localize)(0,null,f(new Date().getTime()+w*1e3,!1));if(w<30)return(0,p.localize)(1,null);let t;return w<D?(t=w,g?t===1?(0,p.localize)(2,null,t):(0,p.localize)(3,null,t):t===1?(0,p.localize)(4,null,t):(0,p.localize)(5,null,t)):w<C?(t=Math.floor(w/D),g?t===1?(0,p.localize)(6,null,t):(0,p.localize)(7,null,t):t===1?(0,p.localize)(8,null,t):(0,p.localize)(9,null,t)):w<k?(t=Math.floor(w/C),g?t===1?(0,p.localize)(10,null,t):(0,p.localize)(11,null,t):t===1?(0,p.localize)(12,null,t):(0,p.localize)(13,null,t)):w<i?(t=Math.floor(w/k),g?t===1?(0,p.localize)(14,null,t):(0,p.localize)(15,null,t):t===1?(0,p.localize)(16,null,t):(0,p.localize)(17,null,t)):w<I?(t=Math.floor(w/i),g?t===1?(0,p.localize)(18,null,t):(0,p.localize)(19,null,t):t===1?(0,p.localize)(20,null,t):(0,p.localize)(21,null,t)):w<h?(t=Math.floor(w/I),g?t===1?(0,p.localize)(22,null,t):(0,p.localize)(23,null,t):t===1?(0,p.localize)(24,null,t):(0,p.localize)(25,null,t)):(t=Math.floor(w/h),g?t===1?(0,p.localize)(26,null,t):(0,p.localize)(27,null,t):t===1?(0,p.localize)(28,null,t):(0,p.localize)(29,null,t))}e.fromNow=f;function y(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=y}),define(Q[129],J([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Q[45],J([0,1,31,13,129]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function k(f,y){return y&&(f.stack||f.stacktrace)?C.localize(0,null,I(f),i(f.stack)||i(f.stacktrace)):I(f)}function i(f){return Array.isArray(f)?f.join(`
`):f}function I(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?C.localize(1,null,f.message):f.message||C.localize(2,null)}function h(f=null,y=!1){if(!f)return C.localize(3,null);if(Array.isArray(f)){const b=p.coalesce(f),g=h(b[0],y);return b.length>1?C.localize(4,null,g,b.length):g}if(D.isString(f))return f;if(f.detail){const b=f.detail;if(b.error)return k(b.error,y);if(b.exception)return k(b.exception,y)}return f.stack?k(f,y):f.message?f.message:C.localize(5,null)}e.toErrorMessage=h}),define(Q[130],J([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(Q[131],J([0,1,130]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class D{constructor(i,I,h=I){this.modifierLabels=[null],this.modifierLabels[2]=i,this.modifierLabels[1]=I,this.modifierLabels[3]=h}toLabel(i,I,h){if(I.length===0)return null;const f=[];for(let y=0,b=I.length;y<b;y++){const g=I[y],w=h(g);if(w===null)return null;f[y]=C(g,w,this.modifierLabels[i])}return f.join(" ")}}e.ModifierLabelProvider=D,e.UILabelProvider=new D({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new D({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new D({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new D({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function C(k,i,I){if(i===null)return"";const h=[];return k.ctrlKey&&h.push(I.ctrlKey),k.shiftKey&&h.push(I.shiftKey),k.altKey&&h.push(I.altKey),k.metaKey&&h.push(I.metaKey),i!==""&&h.push(i),h.join(I.separator)}}),define(Q[132],J([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Q[72],J([0,1,44,33,10,43,8,3,32,80,13,115,21,132]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return f.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return f.TerminateResponseCode}});function t(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(r,a){if(I.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};a&&(s.cwd=a);const n=p.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],s);return new Promise(o=>{n.once("error",d=>{o({success:!1,error:d})}),n.once("exit",(d,v)=>{o(d===0?{success:!0}:{success:!1,code:d!==null?d:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(I.isLinux||I.isMacintosh)try{const s=C.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(n=>{p.execFile(s,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,d,v)=>{n(o?{success:!1,error:o}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function E(r){!r||(delete r.DEBUG,I.isMacintosh&&delete r.DYLD_LIBRARY_PATH,I.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=E;function S(r=h.env){return r.comspec||"cmd.exe"}e.getWindowsShell=S;class P{constructor(a,s,n,o){if(s!==void 0&&n!==void 0&&o!==void 0)this.cmd=a,this.args=s,this.shell=n,this.options=o;else{const d=a;this.cmd=d.command,this.shell=d.isShellCommand,this.args=d.args.slice(0),this.options=d.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const d=Object.create(null);Object.keys(h.env).forEach(v=>{d[v]=h.env[v]}),Object.keys(this.options.env).forEach(v=>{d[v]=this.options.env[v]}),this.options.env=d}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const s=a.lastIndexOf(i.sep);return s!==-1&&(a=a.substring(s+1)),P.WellKnowCommands[a]?a:"other"}start(a){return I.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(h.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(s=>{let n,o;const d=new Promise((v,M)=>{n=v,o=M});if(s){let v=this.cmd;this.args&&(v=v+" "+this.args.join(" ")),this.childProcess=p.exec(v,this.options,(M,L,A)=>{this.childProcess=null;const W=M;W&&W.killed?o({killed:this.terminateRequested,stdout:L.toString(),stderr:A.toString()}):this.handleExec(n,a,M,L,A)})}else{let v=null;const M=L=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(L,n,a,o);const A={terminated:this.terminateRequested};y.isNumber(L)&&(A.cmdCode=L),n(A)};if(this.shell&&I.isWindows){const L=k.deepClone(this.options);L.windowsVerbatimArguments=!0,L.detached=!1;let A=!1,W=!1;const H=[];let Z=this.ensureQuotes(this.cmd);H.push(Z.value),A=Z.quoted,this.args&&this.args.forEach(oe=>{Z=this.ensureQuotes(oe),H.push(Z.value),W=W&&Z.quoted});const ne=["/s","/c"];A?W?ne.push('"'+H.join(" ")+'"'):H.length>1?ne.push('"'+H[0]+'" '+H.slice(1).join(" ")):ne.push('"'+H[0]+'"'):ne.push(H.join(" ")),v=p.spawn(S(),ne,L)}else this.cmd&&(v=p.spawn(this.cmd,this.args,this.options));v&&(this.childProcess=v,this.childProcessPromise=Promise.resolve(v),this.pidResolve&&(this.pidResolve(y.isNumber(v.pid)?v.pid:-1),this.pidResolve=void 0),v.on("error",L=>{this.childProcess=null,o({terminated:this.terminateRequested,error:L})}),v.pid&&(this.childProcess.on("close",M),this.handleSpawn(v,n,a,o,!0)))}return d})}handleClose(a,s,n,o){}ensureQuotes(a){return P.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,m(a,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!I.isWindows)return a(!1);const s=p.spawn(S(),["/s","/c"]);s.on("error",n=>a(!0)),s.on("exit",n=>a(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class l extends P{constructor(a,s,n,o){super(a,s,n,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,s,n,o,d){[o,d].forEach((v,M)=>{const L=new b.LineDecoder;L.write(v).forEach(H=>{s({line:H,source:M===0?0:1})});const W=L.end();W&&s({line:W,source:M===0?0:1})}),a({terminated:this.terminateRequested,error:n})}handleSpawn(a,s,n,o,d){const v=new b.LineDecoder,M=new b.LineDecoder;a.stdout.on("data",L=>{v.write(L).forEach(W=>n({line:W,source:0}))}),a.stderr.on("data",L=>{M.write(L).forEach(W=>n({line:W,source:1}))}),this.stdoutLineDecoder=v,this.stderrLineDecoder=M}handleClose(a,s,n,o){const d=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;d&&n({line:d,source:0});const v=this.stderrLineDecoder?this.stderrLineDecoder.end():null;v&&n({line:v,source:1})}}e.LineProcess=l;function c(r){let a=[],s=!1;const n=function(o){if(s){a.push(o);return}(!r.send(o,v=>{if(v&&console.error(v),s=!1,a.length>0){const M=a.slice(0);a=[],M.forEach(L=>n(L))}})||I.isWindows)&&(s=!0)};return{send:n}}e.createQueuedSender=c;var u;(function(r){async function a(s,n,o){if(i.isAbsolute(s))return s;if(n===void 0&&(n=h.cwd()),i.dirname(s)!=="."||(o===void 0&&y.isString(h.env.PATH)&&(o=h.env.PATH.split(i.delimiter)),o===void 0||o.length===0))return i.join(n,s);async function v(M){if(await g.Promises.exists(M)){let L;try{L=await g.Promises.stat(M)}catch(A){A.message.startsWith("EACCES")&&(L=await g.Promises.lstat(M))}return L?!L.isDirectory():!1}return!1}for(let M of o){let L;if(i.isAbsolute(M)?L=i.join(M,s):L=i.join(n,M,s),await v(L))return L;let A=L+".com";if(await v(A)||(A=L+".exe",await v(A)))return A}return i.join(n,s)}r.findExecutable=a})(u=e.win32||(e.win32={}))}),define(Q[133],J([0,1,26,3,119,72]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function i(w,t){return w===1?D.isWindows?b():k.getWindowsShell(t):f(w,t)}e.getSystemShell=i;function I(w,t){return w===1?D.isWindows?g(t):k.getWindowsShell(t):f(w,t)}e.getSystemShellSync=I;let h=null;function f(w,t){if(D.isLinux&&w===2||D.isMacintosh&&w===3)return"/bin/bash";if(!h){let m;if(D.isWindows)m="/bin/bash";else{if(m=t.SHELL,!m)try{m=(0,p.userInfo)().shell}catch(E){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}h=m}return h}let y=null;async function b(){return y||(y=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),y}function g(w){if(y)return y;const t=D.isWindows&&parseFloat((0,p.release)())>=10,m=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${w.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?E:k.getWindowsShell(w)}}),define(Q[87],J([0,1,44,9,17,23,110,16,4,2,43,72,35]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends g.ChannelServer{constructor(E){super({send:S=>{try{process.send&&process.send(S.buffer.toString("base64"))}catch(P){}},onMessage:h.Event.fromNodeEventEmitter(process,"message",S=>C.VSBuffer.wrap(Buffer.from(S,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=w;class t{constructor(E,S){this.modulePath=E,this.options=S,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new h.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=S&&S.timeout?S.timeout:6e4;this.disposeDelayer=new D.Delayer(P),this.child=null,this._client=null}getChannel(E){const S=this;return{call(P,l,c){return S.requestPromise(E,P,l,c)},listen(P,l){return S.requestEvent(E,P,l)}}}requestPromise(E,S,P,l=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(E),u=(0,D.createCancelablePromise)(s=>c.call(S,P,s)),r=l.onCancellationRequested(()=>u.cancel()),a=(0,f.toDisposable)(()=>u.cancel());return this.activeRequests.add(a),u.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(E,S,P){if(!this.disposeDelayer)return h.Event.None;this.disposeDelayer.cancel();let l;const c=new h.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(E).listen(S,P)(c.fire,c),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],S=Object.create(null);S.env={...(0,y.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(S.env={...S.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(S.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(S.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(S.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),S.execArgv===void 0&&(S.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,b.removeDangerousEnvVariables)(S.env),this.child=(0,p.fork)(this.modulePath,E,S);const P=new h.Emitter;h.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,i.isRemoteConsoleLog)(n)){(0,i.log)(n,`IPC Library: ${this.options.serverName}`);return}P.fire(C.VSBuffer.wrap(Buffer.from(n,"base64")))});const c=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,u=n=>this.child&&this.child.connected&&c.send(n.buffer.toString("base64")),r=P.event,a={send:u,onMessage:r};this._client=new g.ChannelClient(a);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,o)=>{process.removeListener("exit",s),this.activeRequests.forEach(d=>(0,f.dispose)(d)),this.activeRequests.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:o})})}return this._client}getCachedChannel(E){let S=this.channels.get(E);return S||(S=this.client.getChannel(E),this.channels.set(E,S)),S}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Q[134],J([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Q[135],J([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[136],J([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[137],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Q[138],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Q[139],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/shellEnv",e)}),define(Q[140],J([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[141],J([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[142],J([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[143],J([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Q[144],J([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Q[145],J([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Q[146],J([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(Q[147],J([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[148],J([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[149],J([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[150],J([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Q[151],J([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Q[152],J([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[153],J([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[154],J([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Q[155],J([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[156],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[157],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[158],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[159],J([0,1,4,2]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class C{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(I,h,f){switch(h){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:f[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:f[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:f[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:f[0],port:f[1],subId:f[2]}))}throw new Error("Method not implemented.")}listen(I,h,f){switch(h){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=C,C.ChannelName="extensionhostdebugservice";class k extends D.Disposable{constructor(I){super();this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,h,f){this.channel.call("attach",[I,h,f])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,h){this.channel.call("terminate",[I,h])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,h){return this.channel.call("openExtensionDevelopmentHostWindow",[I,h])}}e.ExtensionHostDebugChannelClient=k}),define(Q[160],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(i){this.driver=i}listen(i,I){throw new Error(`No event found: ${I}`)}call(i,I,h){switch(I){case"click":return this.driver.click(h[0],h[1],h[2]);case"doubleClick":return this.driver.doubleClick(h);case"setValue":return this.driver.setValue(h[0],h[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(h);case"getElements":return this.driver.getElements(h[0],h[1]);case"getElementXY":return this.driver.getElementXY(h[0],h[1],h[2]);case"typeInEditor":return this.driver.typeInEditor(h[0],h[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(h);case"writeInTerminal":return this.driver.writeInTerminal(h[0],h[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${I}`)}}e.WindowDriverChannel=p;class D{constructor(i){this.channel=i}click(i,I,h){return this.channel.call("click",[i,I,h])}doubleClick(i){return this.channel.call("doubleClick",i)}setValue(i,I){return this.channel.call("setValue",[i,I])}getTitle(){return this.channel.call("getTitle")}isActiveElement(i){return this.channel.call("isActiveElement",i)}getElements(i,I){return this.channel.call("getElements",[i,I])}getElementXY(i,I,h){return this.channel.call("getElementXY",[i,I,h])}typeInEditor(i,I){return this.channel.call("typeInEditor",[i,I])}getTerminalBuffer(i){return this.channel.call("getTerminalBuffer",i)}writeInTerminal(i,I){return this.channel.call("writeInTerminal",[i,I])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=D;class C{constructor(i){this.channel=i}registerWindowDriver(i){return this.channel.call("registerWindowDriver",i)}reloadWindowDriver(i){return this.channel.call("reloadWindowDriver",i)}}e.WindowDriverRegistryChannelClient=C}),define(Q[161],J([0,1,128,47,10,8,32,15,7]),function(j,e,p,D,C,k,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class f{constructor(m,E,S){this._args=m,this.paths=E,this.productService=S}get appRoot(){return(0,k.dirname)(C.FileAccess.asFileUri("",j).fsPath)}get userHome(){return h.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return h.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return h.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(h.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return h.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return h.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=i.env.VSCODE_PORTABLE;return m?h.URI.file((0,k.join)(m,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,k.resolve)(m):(0,k.normalize)((0,k.join)(C.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,k.resolve)(m):(0,k.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,k.resolve)(m);const E=i.env.VSCODE_EXTENSIONS;if(E)return E;const S=i.env.VSCODE_PORTABLE;return S?(0,k.join)(S,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(E=>/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,k.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?h.URI.parse(m):h.URI.file((0,k.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!i.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return h.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([D.memoize],f.prototype,"appRoot",null),he([D.memoize],f.prototype,"userHome",null),he([D.memoize],f.prototype,"userDataPath",null),he([D.memoize],f.prototype,"appSettingsHome",null),he([D.memoize],f.prototype,"tmpDir",null),he([D.memoize],f.prototype,"userRoamingDataHome",null),he([D.memoize],f.prototype,"settingsResource",null),he([D.memoize],f.prototype,"userDataSyncHome",null),he([D.memoize],f.prototype,"userDataSyncLogResource",null),he([D.memoize],f.prototype,"sync",null),he([D.memoize],f.prototype,"machineSettingsResource",null),he([D.memoize],f.prototype,"globalStorageHome",null),he([D.memoize],f.prototype,"workspaceStorageHome",null),he([D.memoize],f.prototype,"keybindingsResource",null),he([D.memoize],f.prototype,"keyboardLayoutResource",null),he([D.memoize],f.prototype,"argvResource",null),he([D.memoize],f.prototype,"snippetsHome",null),he([D.memoize],f.prototype,"isExtensionDevelopment",null),he([D.memoize],f.prototype,"untitledWorkspacesHome",null),he([D.memoize],f.prototype,"installSourcePath",null),he([D.memoize],f.prototype,"builtinExtensionsPath",null),he([D.memoize],f.prototype,"extensionsPath",null),he([D.memoize],f.prototype,"extensionDevelopmentLocationURI",null),he([D.memoize],f.prototype,"extensionDevelopmentKind",null),he([D.memoize],f.prototype,"extensionTestsLocationURI",null),he([D.memoize],f.prototype,"debugExtensionHost",null),he([D.memoize],f.prototype,"serviceMachineIdResource",null),he([D.memoize],f.prototype,"telemetryLogResource",null),he([D.memoize],f.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=f;function y(t,m){return w(t["inspect-extensions"],t["inspect-brk-extensions"],5870,m,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=y;function b(t,m){return w(t["inspect-search"],t["inspect-brk-search"],5876,m,t.extensionEnvironment)}e.parseSearchPort=b;function g(t,m){return w(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,m,t.extensionEnvironment)}e.parsePtyHostPort=g;function w(t,m,E,S,P,l){const u=Number(m||t)||(S?null:E),r=u?Boolean(!!m):!1;let a;if(l)try{a=JSON.parse(l)}catch{}return{port:u,break:r,debugId:P,env:a}}}),define(Q[88],J([0,1,246,3,137]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const k={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,C.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(14,null)},category:{type:"string",cat:"e",description:(0,C.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,C.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,C.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,C.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,C.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,C.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,C.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,C.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,C.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,C.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(29,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,C.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const i={onUnknownOption:()=>{},onMultipleValues:()=>{}};function I(t,m,E=i){const S={},P=[],l=[];for(let a in m){const s=m[a];s.alias&&(S[a]=s.alias),s.type==="string"||s.type==="string[]"?(P.push(a),s.deprecates&&P.push(s.deprecates)):s.type==="boolean"&&(l.push(a),s.deprecates&&l.push(s.deprecates))}const c=p(t,{string:P,boolean:l,alias:S}),u={},r=c;u._=c._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in m){const s=m[a];s.alias&&delete r[s.alias];let n=r[a];s.deprecates&&r.hasOwnProperty(s.deprecates)&&(n||(n=r[s.deprecates]),delete r[s.deprecates]),typeof n!="undefined"&&(s.type==="string[]"?n&&!Array.isArray(n)&&(n=[n]):s.type==="string"&&Array.isArray(n)&&(n=n.pop(),E.onMultipleValues(a,n)),u[a]=n),delete r[a]}for(let a in r)E.onUnknownOption(a);return u}e.parseArgs=I;function h(t,m){let E="";return m.args&&(Array.isArray(m.args)?E=` <${m.args.join("> <")}>`:E=` <${m.args}>`),m.alias?`-${m.alias} --${t}${E}`:`--${t}${E}`}function f(t,m){let E=0,S=[];for(const u in t){const r=t[u],a=h(u,r);E=Math.max(E,a.length),S.push([a,r.description])}let P=E+2+1;if(m-P<25)return S.reduce((u,r)=>u.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let l=m-P-1,c=[];for(const u of S){let r=u[0],a=b(u[1],l),s=y(P-r.length-2);c.push("  "+r+s+a[0]);for(let n=1;n<a.length;n++)c.push(y(P)+a[n])}return c}e.formatOptions=f;function y(t){return" ".repeat(t)}function b(t,m){let E=[];for(;t.length;){let S=t.length<m?t.length:t.lastIndexOf(" ",m),P=t.slice(0,S).trim();t=t.slice(S),E.push(P)}return E}function g(t,m,E,S,P=!0){const l=process.stdout.isTTY&&process.stdout.columns||80;let c=[`${t} ${E}`];c.push(""),c.push(`${(0,C.localize)(32,null)}: ${m} [${(0,C.localize)(33,null)}][${(0,C.localize)(34,null)}...]`),c.push(""),P&&(D.isWindows?c.push((0,C.localize)(35,null,m)):c.push((0,C.localize)(36,null,m)),c.push(""));const u={};for(const r in S){const a=S[r];if(a.description&&a.cat){let s=u[a.cat];s||(u[a.cat]=s={}),s[r]=a}}for(let r in u){const a=r;let s=u[a];s&&(c.push(k[a]),c.push(...f(s,l)),c.push(""))}return c.join(`
`)}e.buildHelpMessage=g;function w(t,m){return`${t||(0,C.localize)(37,null)}
${m||(0,C.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=w}),define(Q[162],J([0,1,62,159,88]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class k extends D.ExtensionHostDebugBroadcastChannel{constructor(I){super();this.windowsMainService=I}call(I,h,f){return h==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(f[0],f[1]):super.call(I,h,f)}async openExtensionDevelopmentHostWindow(I,h){const f=(0,C.parseArgs)(I,C.OPTIONS);f.debugRenderer=h;const y=f.extensionDevelopmentPath;if(!y)return{success:!1};const[b]=this.windowsMainService.openExtensionDevelopmentHostWindow(y,{context:5,cli:f});if(!h)return{success:!0};const g=b.win;if(!g)return{success:!0};const w=g.webContents.debugger;let t=w.isAttached()?Infinity:0;const m=(0,p.createServer)(E=>{t++==0&&w.attach();let S=!1;const P=u=>{S||E.write(JSON.stringify(u)+"\0")},l=(u,r,a,s)=>P({method:r,params:a,sessionId:s});g.on("close",()=>{w.removeListener("message",l),E.end(),S=!0}),w.addListener("message",l);let c=Buffer.alloc(0);E.on("data",u=>{c=Buffer.concat([c,u]);for(let r=c.indexOf(0);r!==-1;r=c.indexOf(0)){let a;try{const s=c.slice(0,r).toString("utf8");c=c.slice(r+1),a=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}w.sendCommand(a.method,a.params,a.sessionId).then(s=>P({id:a.id,sessionId:a.sessionId,result:s})).catch(s=>P({id:a.id,sessionId:a.sessionId,error:{code:0,message:s.message}}))}}),E.on("error",u=>{console.error("error on cdp pipe:",u)}),E.on("close",()=>{S=!0,--t==0&&w.detach()})});return await new Promise(E=>m.listen(0,E)),g.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=k}),function(){"use strict";function j(e,p,D,C){function k(I){const h=i(I),f=[h];return e.isAbsolute(h)||f.unshift(C),e.resolve(...f)}function i(I){const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,D);const y=I["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(b,"AppData","Roaming")}break;case"darwin":f=e.join(p.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,D)}return{getUserDataPath:k}}if(typeof define=="function")define(Q[163],J([0,247,26,10,15,32]),function(e,p,D,C,k,i){const I=k.dirname(C.FileAccess.asFileUri("",e)),h=e.__$__nodeRequire(k.joinPath(I,"package.json").fsPath);return j(p,D,h.name,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),D=require("os");module.exports=j(p,D,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[164],J([0,1,26,161,163]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends D.AbstractNativeEnvironmentService{constructor(I,h){super(I,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,C.getUserDataPath)(I)},h)}}e.NativeEnvironmentService=k}),define(Q[165],J([0,1,29,26,8]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function k(i){const I=(0,C.join)((0,D.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(I,""),i&&console.log(`Marker file for --wait created: ${I}`),I}catch(h){i&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFile=k}),define(Q[166],J([0,1,141]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function k(g){return g=g.trim(),g==="*"||D.test(g)}e.isValidVersionStr=k;function i(g){if(!k(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=g.match(D);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=i;function I(g){if(!g)return null;let w=g.majorBase,t=g.majorMustEqual,m=g.minorBase,E=g.minorMustEqual,S=g.patchBase,P=g.patchMustEqual;g.hasCaret&&(w===0||(E=!1),P=!1);let l=0;if(g.preRelease){const c=C.exec(g.preRelease);if(c){const[,u,r,a]=c;l=Date.UTC(Number(u),Number(r)-1,Number(a))}}return{majorBase:w,majorMustEqual:t,minorBase:m,minorMustEqual:E,patchBase:S,patchMustEqual:P,isMinimum:g.hasGreaterEquals,notBefore:l}}e.normalizeVersion=I;function h(g,w,t){let m;typeof g=="string"?m=I(i(g)):m=g;let E;w instanceof Date?E=w.getTime():typeof w=="string"&&(E=new Date(w).getTime());let S;if(typeof t=="string"?S=I(i(t)):S=t,!m||!S)return!1;let P=m.majorBase,l=m.minorBase,c=m.patchBase,u=S.majorBase,r=S.minorBase,a=S.patchBase,s=S.notBefore,n=S.majorMustEqual,o=S.minorMustEqual,d=S.patchMustEqual;return S.isMinimum?P>u?!0:P<u?!1:l>r?!0:l<r||E&&E<s?!1:c>=a:(P===1&&u===0&&(!n||!o||!d)&&(u=1,r=0,a=0,n=!0,o=!1,d=!1),P<u?!1:P>u?!n:l<r?!1:l>r?!o:c<a?!1:c>a?!d:!(E&&E<s))}e.isValidVersion=h;function f(g,w,t,m){return t.isBuiltin||typeof t.main=="undefined"?!0:b(g,w,t.engines.vscode,m)}e.isValidExtensionVersion=f;function y(g,w,t){return g==="*"||b(w,t,g)}e.isEngineValid=y;function b(g,w,t,m=[]){let E=I(i(t));if(!E)return m.push(p.localize(0,null,t)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return m.push(p.localize(1,null,t)),!1}else if(!E.majorMustEqual)return m.push(p.localize(2,null,t)),!1;return h(g,w,E)?!0:(m.push(p.localize(3,null,g,t)),!1)}}),define(Q[167],J([0,1,4,2,17,60,23]),function(j,e,p,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class I extends D.Disposable{constructor(f,y){super();this.provider=f,this.logService=y,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,y,b){const g=this.getUriTransformer(f);switch(y){case"stat":return this.stat(g,b[0]);case"readdir":return this.readdir(g,b[0]);case"open":return this.open(g,b[0],b[1]);case"close":return this.close(b[0]);case"read":return this.read(b[0],b[1],b[2]);case"readFile":return this.readFile(g,b[0]);case"write":return this.write(b[0],b[1],b[2],b[3],b[4]);case"writeFile":return this.writeFile(g,b[0],b[1],b[2]);case"rename":return this.rename(g,b[0],b[1],b[2]);case"copy":return this.copy(g,b[0],b[1],b[2]);case"mkdir":return this.mkdir(g,b[0]);case"delete":return this.delete(g,b[0],b[1]);case"watch":return this.watch(g,b[0],b[1],b[2],b[3]);case"unwatch":return this.unwatch(b[0],b[1])}throw new Error(`IPC Command ${y} not found`)}listen(f,y,b){const g=this.getUriTransformer(f);switch(y){case"fileChange":return this.onFileChange(g,b[0]);case"readFileStream":return this.onReadFileStream(g,b[0],b[1])}throw new Error(`Unknown event ${y}`)}stat(f,y){const b=this.transformIncoming(f,y,!0);return this.provider.stat(b)}readdir(f,y){const b=this.transformIncoming(f,y);return this.provider.readdir(b)}async readFile(f,y){const b=this.transformIncoming(f,y,!0),g=await this.provider.readFile(b);return C.VSBuffer.wrap(g)}onReadFileStream(f,y,b){const g=this.transformIncoming(f,y,!0),w=new i.CancellationTokenSource,t=new p.Emitter({onLastListenerRemove:()=>{w.cancel()}}),m=this.provider.readFileStream(g,b,w.token);return(0,k.listenStream)(m,{onData:E=>t.fire(C.VSBuffer.wrap(E)),onError:E=>t.fire(E),onEnd:()=>{t.fire("end"),t.dispose(),w.dispose()}}),t.event}writeFile(f,y,b,g){const w=this.transformIncoming(f,y);return this.provider.writeFile(w,b.buffer,g)}open(f,y,b){const g=this.transformIncoming(f,y,!0);return this.provider.open(g,b)}close(f){return this.provider.close(f)}async read(f,y,b){const g=C.VSBuffer.alloc(b),w=0,t=await this.provider.read(f,y,g.buffer,w,b);return[g,t]}write(f,y,b,g,w){return this.provider.write(f,y,b.buffer,g,w)}mkdir(f,y){const b=this.transformIncoming(f,y);return this.provider.mkdir(b)}delete(f,y,b){const g=this.transformIncoming(f,y);return this.provider.delete(g,b)}rename(f,y,b,g){const w=this.transformIncoming(f,y),t=this.transformIncoming(f,b);return this.provider.rename(w,t,g)}copy(f,y,b,g){const w=this.transformIncoming(f,y),t=this.transformIncoming(f,b);return this.provider.copy(w,t,g)}onFileChange(f,y){const b=new p.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(y,this.createSessionFileWatcher(f,b))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(y)),this.sessionToWatcher.delete(y)}});return b.event}async watch(f,y,b,g,w){const t=this.sessionToWatcher.get(y);if(t){const m=this.transformIncoming(f,g),E=t.watch(b,m,w);this.watchRequests.set(y+b,E)}}async unwatch(f,y){const b=f+y,g=this.watchRequests.get(b);g&&((0,D.dispose)(g),this.watchRequests.delete(b))}dispose(){super.dispose(),this.watchRequests.forEach(f=>(0,D.dispose)(f)),this.watchRequests.clear(),this.sessionToWatcher.forEach(f=>(0,D.dispose)(f)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=I}),define(Q[73],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(C,k=[],i=!1){this.ctor=C,this.staticArguments=k,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=p}),define(Q[168],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(k){this.incoming=new Map,this.outgoing=new Map,this.data=k}}e.Node=p;class D{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(let i of this._nodes.values())i.outgoing.size===0&&k.push(i);return k}insertEdge(k,i){const I=this.lookupOrInsertNode(k),h=this.lookupOrInsertNode(i);I.outgoing.set(this._hashFn(i),h),h.incoming.set(this._hashFn(k),I)}removeNode(k){const i=this._hashFn(k);this._nodes.delete(i);for(let I of this._nodes.values())I.outgoing.delete(i),I.incoming.delete(i)}lookupOrInsertNode(k){const i=this._hashFn(k);let I=this._nodes.get(i);return I||(I=new p(k),this._nodes.set(i,I)),I}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){let k=[];for(let[i,I]of this._nodes)k.push(`${i}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return k.join(`
`)}findCycleSlow(){for(let[k,i]of this._nodes){const I=new Set([k]),h=this._findCycle(i,I);if(h)return h}}_findCycle(k,i){for(let[I,h]of k.outgoing){if(i.has(I))return[...i,I].join(" -> ");i.add(I);const f=this._findCycle(h,i);if(f)return f;i.delete(I)}}}e.Graph=D}),define(Q[5],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function I(h){return h[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=I})(p=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function D(i,I,h,f){I[p.DI_TARGET]===I?I[p.DI_DEPENDENCIES].push({id:i,index:h,optional:f}):(I[p.DI_DEPENDENCIES]=[{id:i,index:h,optional:f}],I[p.DI_TARGET]=I)}function C(i){if(p.serviceIds.has(i))return p.serviceIds.get(i);const I=function(h,f,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(I,h,y,!1)};return I.toString=()=>i,p.serviceIds.set(i,I),I}e.createDecorator=C;function k(i){return i}e.refineServiceDecorator=k}),define(Q[74],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function D(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=D}),define(Q[89],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class D{constructor(k){this.machineId=k}encryption(){return new Promise((k,i)=>j(["vscode-encrypt"],k,i))}async encrypt(k){try{return(await this.encryption()).encrypt(this.machineId,k)}catch(i){return k}}async decrypt(k){try{return(await this.encryption()).decrypt(this.machineId,k)}catch(i){return k}}}e.EncryptionMainService=D}),define(Q[48],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[169],J([0,1,10,140,5]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var k;(function(l){l.WIN32_X64="win32-x64",l.WIN32_IA32="win32-ia32",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));function i(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function I(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function h(l,c){switch(l){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=h;function f(l,c){return c==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function y(l,c,u){return f(c,u)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===u?!0:b(u).includes(l)}e.isTargetPlatformCompatible=y;function b(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function g(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=g;var w;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var t;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var m;(function(l){l.Install="install",l.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var E;(function(l){l[l.None=0]="None",l[l.Install=1]="Install",l[l.Update=2]="Update"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var S;(function(l){l.Unsupported="Unsupported",l.Malicious="Malicious",l.Incompatible="Incompatible",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class P extends Error{constructor(c,u){super(c);this.code=u,this.name=u}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(Q[170],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Q[171],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,p.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Q[90],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(Q[172],J([0,1,44,10,8,3,80,21,72,142,90]),function(j,e,p,D,C,k,i,I,h,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=f.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends g{openTerminal(c,u){return this.spawnTerminal(p,c,h.getWindowsShell(),u)}spawnTerminal(c,u,r,a){const s=u.windowsExec||w.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const n=C.basename(s).toLowerCase();if(n==="cmder"||n==="cmder.exe")return c.spawn(s,a?[a]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return s.indexOf(" ")>=0&&o.push('""'),o.push(s),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((d,v)=>{const M=E(process),L=c.spawn(r,o,{cwd:a,env:M});L.on("error",v),L.on("exit",()=>d())})}runInTerminal(c,u,r,a,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:w.getDefaultTerminalWindows();return new Promise((o,d)=>{const v=`"${u} - ${b}"`,M=`""${r.join('" "')}" & pause"`,L=["/c","start",v,"/wait",n,"/c",M],A=Object.assign({},E(process),a);Object.keys(A).filter(Z=>A[Z]===null).forEach(Z=>delete A[Z]);const W={cwd:u,env:A,windowsVerbatimArguments:!0};p.spawn(w.CMD,L,W).on("error",Z=>{d(S(Z))}),o(void 0)})}static getDefaultTerminalWindows(){if(!w._DEFAULT_TERMINAL_WINDOWS){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return w._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=w,w.CMD="cmd.exe";class t extends g{openTerminal(c,u){return this.spawnTerminal(p,c,u)}runInTerminal(c,u,r,a,s){const n=s.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((o,d)=>{if(n===y.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const v=n===y.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",L=[D.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`,j).fsPath,"-t",c||b,"-w",u];for(let H of r)L.push("-a"),L.push(H);if(a){const H=Object.assign({},E(process),a);for(let Z in H){const ne=H[Z];ne===null?(L.push("-u"),L.push(Z)):(L.push("-e"),L.push(`${Z}=${ne}`))}}let A="";const W=p.spawn(t.OSASCRIPT,L);W.on("error",H=>{d(S(H))}),W.stderr.on("data",H=>{A+=H.toString()}),W.on("exit",H=>{if(H===0)o(void 0);else if(A){const Z=A.split(`
`,1);d(new Error(Z[0]))}else d(new Error(f.localize(1,null,v,H)))})}else d(new Error(f.localize(2,null,n)))})}spawnTerminal(c,u,r){const a=u.osxExec||y.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{const o=["-a",a];r&&o.push(r);const d=E(process),v=c.spawn("/usr/bin/open",o,{cwd:r,env:d});v.on("error",n),v.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class m extends g{openTerminal(c,u){return this.spawnTerminal(p,c,u)}runInTerminal(c,u,r,a,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((o,d)=>{let v=[];n.then(M=>{M.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const L=`${P(r)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;v.push(`''${L}''`);const A=Object.assign({},E(process),a);Object.keys(A).filter(ne=>A[ne]===null).forEach(ne=>delete A[ne]);const W={cwd:u,env:A};let H="";const Z=p.spawn(M,v,W);Z.on("error",ne=>{d(S(ne))}),Z.stderr.on("data",ne=>{H+=ne.toString()}),Z.on("exit",ne=>{if(ne===0)o(void 0);else if(H){const oe=H.split(`
`,1);d(new Error(oe[0]))}else d(new Error(f.localize(4,null,M,ne)))})})})}static async getDefaultTerminalLinuxReady(){if(!m._DEFAULT_TERMINAL_LINUX_READY)if(!k.isLinux)m._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const c=await I.Promises.exists("/etc/debian_version");m._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{c?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(c,u,r){const a=u.linuxExec?Promise.resolve(u.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{a.then(o=>{const d=E(process),v=c.spawn(o,[],{cwd:r,env:d});v.on("error",n),v.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=f.localize(3,null);function E(l){const c={...l.env};return(0,i.sanitizeProcessEnvironment)(c),c}function S(l){return"errno"in l&&l.errno==="ENOENT"&&"path"in l&&typeof l.path=="string"?new Error(f.localize(5,null,l.path)):l}function P(l){let c="";for(let u of l)u.indexOf(" ")>=0?c+='"'+u+'"':c+=u,c+=" ";return c}}),define(Q[18],J([0,1,40,8,25,13,7,144,5]),function(j,e,p,D,C,k,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function f(T){return T.create===!0}e.isFileOpenForWriteOptions=f;var y;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var b;(function(T){T[T.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var g;(function(T){T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(T){return!!(T.capabilities&2)}e.hasReadWriteCapability=w;function t(T){return!!(T.capabilities&8)}e.hasFileFolderCopyCapability=t;function m(T){return!!(T.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function E(T){return!!(T.capabilities&16)}e.hasFileReadStreamCapability=E;var S;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(z,q){super(z);this.code=q}}e.FileSystemProviderError=P;function l(T,z){const q=new P(T.toString(),z);return u(q,z),q}e.createFileSystemProviderError=l;function c(T){return T||l((0,I.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=c;function u(T,z){return T.name=z?`${z} (FileSystemError)`:"FileSystemError",T}e.markAsFileSystemProviderError=u;function r(T){if(!T)return S.Unknown;if(T instanceof P)return T.code;const z=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!z)return S.Unknown;switch(z[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=r;function a(T){if(T instanceof M)return T.fileOperationResult;switch(r(T)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var s;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class n{constructor(z,q,U){this.resource=z,this.operation=q,this.target=U}isOperation(z){return this.operation===z}}e.FileOperationEvent=n;var o;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class d{constructor(z,q){this.added=void 0,this.updated=void 0,this.deleted=void 0;const U=new Map;for(const N of z){const _=U.get(N.type);_?_.push([N.resource,N]):U.set(N.type,[[N.resource,N]])}for(const[N,_]of U)switch(N){case 1:this.added=p.TernarySearchTree.forUris(()=>q),this.added.fill(_);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>q),this.updated.fill(_);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>q),this.deleted.fill(_);break}}contains(z,...q){return this.doContains(z,{includeChildren:!1},...q)}affects(z,...q){return this.doContains(z,{includeChildren:!0},...q)}doContains(z,q,...U){if(!z)return!1;const N=U.length>0;return!!((!N||U.includes(1))&&(this.added?.get(z)||q.includeChildren&&this.added?.findSuperstr(z))||(!N||U.includes(0))&&(this.updated?.get(z)||q.includeChildren&&this.updated?.findSuperstr(z))||(!N||U.includes(2))&&(this.deleted?.findSubstr(z)||q.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=d;function v(T,z,q){return!T||!z||T===z||z.length>T.length?!1:(z.charAt(z.length-1)!==D.sep&&(z+=D.sep),q?(0,C.startsWithIgnoreCase)(T,z):T.indexOf(z)===0)}e.isParent=v;class M extends Error{constructor(z,q,U){super(z);this.fileOperationResult=q,this.options=U}}e.FileOperationError=M;class L extends M{constructor(z,q,U){super(z,2,U);this.stat=q}}e.NotModifiedSinceFileOperationError=L;var A;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",T[T.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var W;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(W=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function H(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.etag=H;async function Z(T,z){if(!z.hasProvider(i.URI.from({scheme:T.scheme})))return new Promise(q=>{const U=z.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===T.scheme&&N.added&&(U.dispose(),q())})})}e.whenProviderRegistered=Z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ne{static formatSize(z){return(0,k.isNumber)(z)||(z=0),z<ne.KB?(0,I.localize)(1,null,z.toFixed(0)):z<ne.MB?(0,I.localize)(2,null,(z/ne.KB).toFixed(2)):z<ne.GB?(0,I.localize)(3,null,(z/ne.MB).toFixed(2)):z<ne.TB?(0,I.localize)(4,null,(z/ne.GB).toFixed(2)):(0,I.localize)(5,null,(z/ne.TB).toFixed(2))}}e.ByteSize=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;var oe;(function(T){T[T.IA32=0]="IA32",T[T.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function G(T){return{maxFileSize:T===0?300*ne.MB:16*ne.GB,maxHeapSize:T===0?700*ne.MB:2*700*ne.MB}}e.getPlatformLimits=G}),define(Q[54],J([0,1,248,138,88,18]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function i(g,w){const t={onUnknownOption:E=>{console.warn((0,D.localize)(0,null,E))},onMultipleValues:(E,S)=>{console.warn((0,D.localize)(1,null,E,S))}},m=(0,C.parseArgs)(g,C.OPTIONS,w?t:void 0);return m.goto&&m._.forEach(E=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,D.localize)(2,null))),m["max-memory"]&&p(parseInt(m["max-memory"])>=k.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${k.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function I(g){const w=g.findIndex(t=>!/^-/.test(t));if(w>-1)return[...g.slice(0,w),...g.slice(w+1)]}function h(g){let[,...w]=g;process.env.VSCODE_DEV&&(w=I(w)||[]);const t=!b(process.env);return i(w,t)}e.parseMainProcessArgv=h;function f(g){const[,,...w]=g;return i(w,!0)}e.parseCLIProcessArgv=f;function y(g,...w){const t=g.indexOf("--");return t===-1?g.push(...w):g.splice(t,0,...w),g}e.addArg=y;function b(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(Q[91],J([0,1,44,8,139,23,45,16,3,28,133,54,9]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const w=1e4;let t;async function m(S,P,l){return P["force-disable-user-env"]?(S.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(S.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(l)&&!P["force-user-env"]?(S.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(l)?S.trace("resolveShellEnv(): running (--force-user-env)"):S.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=g.Promises.withAsyncBody(async(c,u)=>{const r=new k.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),u(new Error((0,C.localize)(0,null)))},w);try{c(await E(S,r.token))}catch(s){!(0,I.isPromiseCanceledError)(s)&&!r.token.isCancellationRequested?u(new Error((0,C.localize)(1,null,(0,i.toErrorMessage)(s)))):c({})}finally{clearTimeout(a),r.dispose()}})),t)}e.resolveShellEnv=m;async function E(S,P){const l=process.env.ELECTRON_RUN_AS_NODE;S.trace("getUnixShellEnvironment#runAsNode",l);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;S.trace("getUnixShellEnvironment#noAttach",c);const u=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(u+"(.*)"+u),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};S.trace("getUnixShellEnvironment#env",a);const s=await(0,y.getSystemShell)(h.OS,a);return S.trace("getUnixShellEnvironment#shell",s),new Promise((n,o)=>{if(P.isCancellationRequested)return o((0,I.canceled)());const d=(0,D.basename)(s);let v,M;const L=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(d)?(v=`& '${process.execPath}' ${L} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,M=["-Login","-Command"]):(v=`'${process.execPath}' ${L} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,d==="tcsh"?M=["-ic"]:M=["-ilc"]),S.trace("getUnixShellEnvironment#spawn",JSON.stringify(M),v);const A=(0,p.spawn)(s,[...M,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});P.onCancellationRequested(()=>(A.kill(),o((0,I.canceled)()))),A.on("error",Z=>{S.error("getUnixShellEnvironment#errorChildProcess",(0,i.toErrorMessage)(Z)),o(Z)});const W=[];A.stdout.on("data",Z=>W.push(Z));const H=[];A.stderr.on("data",Z=>H.push(Z)),A.on("close",(Z,ne)=>{const oe=Buffer.concat(W).toString("utf8");S.trace("getUnixShellEnvironment#raw",oe);const G=Buffer.concat(H).toString("utf8");if(G.trim()&&S.trace("getUnixShellEnvironment#stderr",G),Z||ne)return o(new Error((0,C.localize)(2,null,Z,ne)));const T=r.exec(oe),z=T?T[1]:"{}";try{const q=JSON.parse(z);l?q.ELECTRON_RUN_AS_NODE=l:delete q.ELECTRON_RUN_AS_NODE,c?q.ELECTRON_NO_ATTACH_CONSOLE=c:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,S.trace("getUnixShellEnvironment#result",q),n(q)}catch(q){S.error("getUnixShellEnvironment#errorCaught",(0,i.toErrorMessage)(q)),o(q)}})})}}),define(Q[92],J([0,1,17,16,145,18]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function i(y,b,g,w,t,m){let E;try{await I(y,b,g,w,t,m)}catch(S){E=S}finally{E&&t.errorTransformer&&(E=t.errorTransformer(E)),typeof E!="undefined"&&g.error(E),g.end()}}e.readFileIntoStream=i;async function I(y,b,g,w,t,m){h(m);const E=await y.open(b,{create:!1});try{h(m);let S=0,P=0,l=t&&typeof t.length=="number"?t.length:void 0,c=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof l=="number"?l:t.bufferSize)),u=t&&typeof t.position=="number"?t.position:0,r=0;do P=await y.read(E,u,c.buffer,r,c.byteLength-r),u+=P,r+=P,S+=P,typeof l=="number"&&(l-=P),r===c.byteLength&&(await g.write(w(c)),c=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof l=="number"?l:t.bufferSize)),r=0);while(P>0&&(typeof l!="number"||l>0)&&h(m)&&f(S,t));if(r>0){let a=r;typeof l=="number"&&(a=Math.min(r,l)),g.write(w(c.slice(0,a)))}}catch(S){throw(0,k.ensureFileSystemProviderError)(S)}finally{await y.close(E)}}function h(y){if(y.isCancellationRequested)throw(0,D.canceled)();return!0}function f(y,b){if(b?.limits){if(typeof b.limits.memory=="number"&&y>b.limits.memory)throw(0,k.createFileSystemProviderError)((0,C.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&y>b.limits.size)throw(0,k.createFileSystemProviderError)((0,C.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[55],J([0,1,2,3,7,18]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.WatcherService=e.AbstractWatcherService=void 0;class i extends p.Disposable{constructor(g,w,t){super();this.onFileChanges=g,this.onLogMessage=w,this.verboseLogging=t,this.serviceDisposables=this._register(new p.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new p.DisposableStore;this.serviceDisposables.value=g,this.service=this.createService(g),this.service.setVerboseLogging(this.verboseLogging),g.add(this.service.onDidChangeFile(w=>this.onFileChanges(w))),g.add(this.service.onDidLogMessage(w=>this.onLogMessage(w))),g.add(this.service.onDidError(w=>this.onError(w)))}onError(g){this.restartCounter<i.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.service?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.service?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${g}`})}dispose(){return this.service=void 0,super.dispose()}}e.AbstractWatcherService=i,i.MAX_RESTARTS=5;class I extends p.Disposable{}e.WatcherService=I;function h(b){return b.map(g=>({type:g.type,resource:C.URI.file(g.path)}))}e.toFileChanges=h;function f(b){const g=new y;for(const w of b)g.processEvent(w);return g.coalesce()}e.coalesceEvents=f;class y{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return D.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const w=this.mapPathToChange.get(this.toKey(g));let t=!1;if(w){const m=w.type,E=g.type;w.path!==g.path&&g.type===2?t=!0:m===1&&E===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(w)):m===2&&E===1?w.type=0:m===1&&E===0||(w.type=E)}else t=!0;t&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],w=[];return Array.from(this.coalesced).filter(t=>t.type!==2?(g.push(t),!1):!0).sort((t,m)=>t.path.length-m.path.length).filter(t=>w.some(m=>(0,k.isParent)(t.path,m,!D.isLinux))?!1:(w.push(t.path),!0)).concat(g)}}}),define(Q[93],J([0,1,9,2,8,82,21,120,55]),function(j,e,p,D,C,k,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class f extends D.Disposable{constructor(b,g,w,t){super();this.path=b,this.onDidFilesChange=g,this.onLogMessage=w,this.verboseLogging=t,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:g}=await i.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let w=this.path;if(g)try{w=await(0,k.realpath)(w)}catch(t){if(this.onError(t),g.dangling)return}b.isDirectory()?this._register((0,I.watchFolder)(w,(t,m)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,C.join)(this.path,(0,C.basename)(m))})},t=>this.onError(t))):this._register((0,I.watchFile)(w,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,h.coalesceEvents)(g);if(this.verboseLogging)for(const t of w)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);w.length>0&&this.onDidFilesChange(w)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=f}),define(Q[173],J([0,1,10,35,87,55]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends k.WatcherService{constructor(h,f,y){super();this.onDidFilesChange=h,this.onLogMessage=f,this.verboseLogging=y,this.isDisposed=!1,this.startWatching()}startWatching(){const h=this._register(new C.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=D.ProxyChannel.toService((0,D.getNextTickChannel)(h.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(f=>!this.isDisposed&&this.onDidFilesChange(f))),this._register(this.service.onDidLogMessage(f=>this.onLogMessage(f)))}async setVerboseLogging(h){this.verboseLogging=h,this.isDisposed||await this.service?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${h}`})}async watch(h){this.isDisposed||await this.service?.watch(h)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(Q[174],J([0,1,10,35,87,55]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends k.AbstractWatcherService{constructor(h,f,y){super(h,f,y);this.init()}createService(h){const f=h.add(new C.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(f.onDidProcessExit(({code:y,signal:b})=>this.onError(`terminated by itself with code ${y}, signal: ${b}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(f.getChannel("watcher")))}}e.FileWatcher=i}),define(Q[75],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...C){this._entries=new Map;for(let[k,i]of C)this.set(k,i)}set(C,k){const i=this._entries.get(C);return this._entries.set(C,k),i}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=p}),define(Q[175],J([0,1,9,16,73,168,5,75]),function(j,e,p,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const h=!1;class f extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class y{constructor(t=new I.ServiceCollection,m=!1,E){this._activeInstantiations=new Set,this._services=t,this._strict=m,this._parent=E,this._services.set(i.IInstantiationService,this)}createChild(t){return new y(t,this._strict,this)}invokeFunction(t,...m){let E=g.traceInvocation(t),S=!1;try{return t({get:l=>{if(S)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(l,E);if(!c)throw new Error(`[invokeFunction] unknown service '${l}'`);return c}},...m)}finally{S=!0,E.stop()}}createInstance(t,...m){let E,S;return t instanceof C.SyncDescriptor?(E=g.traceCreation(t.ctor),S=this._createInstance(t.ctor,t.staticArguments.concat(m),E)):(E=g.traceCreation(t),S=this._createInstance(t,m,E)),E.stop(),S}_createInstance(t,m=[],E){let S=i._util.getServiceDependencies(t).sort((c,u)=>c.index-u.index),P=[];for(const c of S){let u=this._getOrCreateServiceInstance(c.id,E);if(!u&&this._strict&&!c.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${c.id}.`);P.push(u)}let l=S.length>0?S[0].index:m.length;if(m.length!==l){console.warn(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${m.length} static arguments`);let c=l-m.length;c>0?m=m.concat(new Array(c)):m=m.slice(0,l)}return new t(...[...m,...P])}_setServiceInstance(t,m){if(this._services.get(t)instanceof C.SyncDescriptor)this._services.set(t,m);else if(this._parent)this._parent._setServiceInstance(t,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let m=this._services.get(t);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):m}_getOrCreateServiceInstance(t,m){let E=this._getServiceInstanceOrDescriptor(t);return E instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,E,m.branch(t,!0)):(m.branch(t,!1),E)}_safeCreateAndCacheServiceInstance(t,m,E){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,m,E)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,m,E){const S=new k.Graph(c=>c.id.toString());let P=0;const l=[{id:t,desc:m,_trace:E}];for(;l.length;){const c=l.pop();if(S.lookupOrInsertNode(c),P++>1e3)throw new f(S);for(let u of i._util.getServiceDependencies(c.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(u.id);if(!r&&!u.optional&&console.warn(`[createInstance] ${t} depends on ${u.id} which is NOT registered.`),r instanceof C.SyncDescriptor){const a={id:u.id,desc:r,_trace:c._trace.branch(u.id,!0)};S.insertEdge(c,a),l.push(a)}}}for(;;){const c=S.roots();if(c.length===0){if(!S.isEmpty())throw new f(S);break}for(const{data:u}of c){if(this._getServiceInstanceOrDescriptor(u.id)instanceof C.SyncDescriptor){const a=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,a)}S.removeNode(u)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,m,E=[],S,P){if(this._services.get(t)instanceof C.SyncDescriptor)return this._createServiceInstance(m,E,S,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,m,E,S,P);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(t,m=[],E,S){if(E){const P=new p.IdleValue(()=>this._createInstance(t,m,S));return new Proxy(Object.create(null),{get(l,c){if(c in l)return l[c];let u=P.value,r=u[c];return typeof r!="function"||(r=r.bind(u),l[c]=r),r},set(l,c,u){return P.value[c]=u,!0}})}else return this._createInstance(t,m,S)}}e.InstantiationService=y;var b;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(b||(b={}));class g{constructor(t,m){this.type=t,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return h?new g(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(t){return h?new g(0,t.name):g._None}branch(t,m){let E=new g(2,t.toString());return this._dep.push([t,m,E]),E}stop(){let t=Date.now()-this._start;g._totals+=t;let m=!1;function E(P,l){let c=[],u=new Array(P+1).join("	");for(const[r,a,s]of l._dep)if(a&&s){m=!0,c.push(`${u}CREATES -> ${r}`);let n=E(P+1,s);n&&c.push(n)}else c.push(`${u}uses -> ${r}`);return c.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(t>2||m)&&console.log(S.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Q[176],J([0,1,16,131,59]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class k extends C.ResolvedKeybinding{constructor(I,h){super();if(h.length===0)throw(0,p.illegalArgument)("parts");this._os=I,this._parts=h}getLabel(){return D.UILabelProvider.toLabel(this._os,this._parts,I=>this._getLabel(I))}getAriaLabel(){return D.AriaLabelProvider.toLabel(this._os,this._parts,I=>this._getAriaLabel(I))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:D.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,I=>this._getElectronAccelerator(I))}getUserSettingsLabel(){return D.UserSettingsLabelProvider.toLabel(this._os,this._parts,I=>this._getUserSettingsLabel(I))}isWYSIWYG(){return this._parts.every(I=>this._isWYSIWYG(I))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(I=>this._getPart(I))}_getPart(I){return new C.ResolvedKeybindingPart(I.ctrlKey,I.shiftKey,I.altKey,I.metaKey,this._getLabel(I),this._getAriaLabel(I))}getDispatchParts(){return this._parts.map(I=>this._getDispatchPart(I))}getSingleModifierDispatchParts(){return this._parts.map(I=>this._getSingleModifierDispatchPart(I))}}e.BaseResolvedKeybinding=k}),define(Q[177],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(k,i,I,h,f,y,b){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=k,this.keypressParts=k?D(k.getDispatchParts()):[],k&&this.keypressParts.length===0&&(this.keypressParts=D(k.getSingleModifierDispatchParts())),this.bubble=i?i.charCodeAt(0)===94:!1,this.command=this.bubble?i.substr(1):i,this.commandArgs=I,this.when=h,this.isDefault=f,this.extensionId=y,this.isBuiltinExtension=b}}e.ResolvedKeybindingItem=p;function D(C){let k=[];for(let i=0,I=C.length;i<I;i++){const h=C[i];if(!h)return k;k.push(h)}return k}e.removeElementsAfterNulls=D}),define(Q[178],J([0,1,79,59,176,177]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class i extends C.BaseResolvedKeybinding{constructor(h,f){super(f,h.parts)}_keyCodeToUILabel(h){if(this._os===2)switch(h){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(h)}_getLabel(h){return h.isDuplicateModifierCase()?"":this._keyCodeToUILabel(h.keyCode)}_getAriaLabel(h){return h.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(h.keyCode)}_getElectronAccelerator(h){return p.KeyCodeUtils.toElectronAccelerator(h.keyCode)}_getUserSettingsLabel(h){if(h.isDuplicateModifierCase())return"";const f=p.KeyCodeUtils.toUserSettingsUS(h.keyCode);return f&&f.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(h){return i.getDispatchStr(h)}static getDispatchStr(h){if(h.isModifierKey())return null;let f="";return h.ctrlKey&&(f+="ctrl+"),h.shiftKey&&(f+="shift+"),h.altKey&&(f+="alt+"),h.metaKey&&(f+="meta+"),f+=p.KeyCodeUtils.toString(h.keyCode),f}_getSingleModifierDispatchPart(h){return h.keyCode===5&&!h.shiftKey&&!h.altKey&&!h.metaKey?"ctrl":h.keyCode===4&&!h.ctrlKey&&!h.altKey&&!h.metaKey?"shift":h.keyCode===6&&!h.ctrlKey&&!h.shiftKey&&!h.metaKey?"alt":h.keyCode===57&&!h.ctrlKey&&!h.shiftKey&&!h.altKey?"meta":null}static _scanCodeToKeyCode(h){const f=p.IMMUTABLE_CODE_TO_KEY_CODE[h];if(f!==-1)return f;switch(h){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(h){if(!h)return null;if(h instanceof D.SimpleKeybinding)return h;const f=this._scanCodeToKeyCode(h.scanCode);return f===0?null:new D.SimpleKeybinding(h.ctrlKey,h.shiftKey,h.altKey,h.metaKey,f)}static resolveUserBinding(h,f){const y=(0,k.removeElementsAfterNulls)(h.map(b=>this._resolveSimpleUserBinding(b)));return y.length>0?[new i(new D.ChordKeybinding(y),f)]:[]}}e.USLayoutResolvedKeybinding=i}),define(Q[179],J([0,1,9]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function D(C,k){if(C.length===0)return Promise.resolve(!1);const i=[];let I=!1;for(let h of C){if(h===!0)return Promise.resolve(!0);(0,p.isThenable)(h)&&i.push(h.then(f=>{f&&(I=!0)},f=>{k(f),I=!0}))}return p.Promises.settled(i).then(()=>I)}e.handleVetos=D}),define(Q[6],J([0,1,45,4,2,3,5]),function(j,e,p,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function I(){return new Date().toISOString()}var h;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(h=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=h.Info;function f(a,s,n){switch(s){case h.Trace:a.trace(n);break;case h.Debug:a.debug(n);break;case h.Info:a.info(n);break;case h.Warning:a.warn(n);break;case h.Error:a.error(n);break;case h.Critical:a.critical(n);break;default:throw new Error("Invalid log level")}}e.log=f;function y(a){let s="";for(let n=0;n<a.length;n++){let o=a[n];if(typeof o=="object")try{o=JSON.stringify(o)}catch(d){}s+=(n>0?" ":"")+o}return s}e.format=y;class b extends C.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class g extends b{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...n){this.checkLogLevel(h.Trace)&&this.log(h.Trace,y([s,...n]))}debug(s,...n){this.checkLogLevel(h.Debug)&&this.log(h.Debug,y([s,...n]))}info(s,...n){this.checkLogLevel(h.Info)&&this.log(h.Info,y([s,...n]))}warn(s,...n){this.checkLogLevel(h.Warning)&&this.log(h.Warning,y([s,...n]))}error(s,...n){if(this.checkLogLevel(h.Error))if(s instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=s.stack,this.log(h.Error,y(o))}else this.log(h.Error,y([s,...n]))}critical(s,...n){this.checkLogLevel(h.Critical)&&this.log(h.Critical,y([s,...n]))}flush(){}}e.AbstractMessageLogger=g;class w extends b{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!k.isWindows}trace(s,...n){this.getLevel()<=h.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...n):console.log(`[main ${I()}]`,s,...n))}debug(s,...n){this.getLevel()<=h.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...n):console.log(`[main ${I()}]`,s,...n))}info(s,...n){this.getLevel()<=h.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,s,...n):console.log(`[main ${I()}]`,s,...n))}warn(s,...n){this.getLevel()<=h.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,s,...n):console.warn(`[main ${I()}]`,s,...n))}error(s,...n){this.getLevel()<=h.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,s,...n):console.error(`[main ${I()}]`,s,...n))}critical(s,...n){this.getLevel()<=h.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,s,...n):console.error(`[main ${I()}]`,s,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class t extends b{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...n){this.getLevel()<=h.Trace&&console.log("%cTRACE","color: #888",s,...n)}debug(s,...n){this.getLevel()<=h.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...n)}info(s,...n){this.getLevel()<=h.Info&&console.log("%c INFO","color: #33f",s,...n)}warn(s,...n){this.getLevel()<=h.Warning&&console.log("%c WARN","color: #993",s,...n)}error(s,...n){this.getLevel()<=h.Error&&console.log("%c  ERR","color: #f33",s,...n)}critical(s,...n){this.getLevel()<=h.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...n)}dispose(){}flush(){}}e.ConsoleLogger=t;class m extends b{constructor(s,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(n)}trace(s,...n){this.getLevel()<=h.Trace&&this.adapter.log(h.Trace,[this.extractMessage(s),...n])}debug(s,...n){this.getLevel()<=h.Debug&&this.adapter.log(h.Debug,[this.extractMessage(s),...n])}info(s,...n){this.getLevel()<=h.Info&&this.adapter.log(h.Info,[this.extractMessage(s),...n])}warn(s,...n){this.getLevel()<=h.Warning&&this.adapter.log(h.Warning,[this.extractMessage(s),...n])}error(s,...n){this.getLevel()<=h.Error&&this.adapter.log(h.Error,[this.extractMessage(s),...n])}critical(s,...n){this.getLevel()<=h.Critical&&this.adapter.log(h.Critical,[this.extractMessage(s),...n])}extractMessage(s){return typeof s=="string"?s:(0,p.toErrorMessage)(s,this.getLevel()<=h.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class E extends b{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const n of this.logServices)n.setLevel(s);super.setLevel(s)}trace(s,...n){for(const o of this.logServices)o.trace(s,...n)}debug(s,...n){for(const o of this.logServices)o.debug(s,...n)}info(s,...n){for(const o of this.logServices)o.info(s,...n)}warn(s,...n){for(const o of this.logServices)o.warn(s,...n)}error(s,...n){for(const o of this.logServices)o.error(s,...n)}critical(s,...n){for(const o of this.logServices)o.critical(s,...n)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=E;class S extends C.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...n){this.logger.trace(s,...n)}debug(s,...n){this.logger.debug(s,...n)}info(s,...n){this.logger.info(s,...n)}warn(s,...n){this.logger.warn(s,...n)}error(s,...n){this.logger.error(s,...n)}critical(s,...n){this.logger.critical(s,...n)}flush(){this.logger.flush()}}e.LogService=S;class P extends C.Disposable{constructor(s,n){super();this.logLevel=s,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(d=>d.setLevel(o))}))}getLogger(s){return this.loggers.get(s.toString())}createLogger(s,n){let o=this.loggers.get(s.toString());return o||(o=this.doCreateLogger(s,n?.always?h.Trace:this.logLevel,n),this.loggers.set(s.toString(),o),n?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(s=>s.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class l{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(s){}getLevel(){return h.Info}trace(s,...n){}debug(s,...n){}info(s,...n){}warn(s,...n){}error(s,...n){}critical(s,...n){}dispose(){}flush(){}}e.NullLogService=l;function c(a){if(a.verbose)return h.Trace;if(typeof a.logLevel=="string"){const s=u(a.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function u(a){switch(a){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Critical;case"off":return h.Off}}e.parseLogLevel=u;function r(a){switch(a){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Critical:return"critical";case h.Off:return"off"}}e.LogLevelToString=r});var ee=this&&this.__param||function(j,e){return function(p,D){e(p,D,j)}};define(Q[180],J([0,1,9,17,39,78,48,18,5,6]),function(j,e,p,D,C,k,i,I,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var y;(function(g){g.ERROR_INVALID_FILE="ERROR_INVALID_FILE",g.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(y=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,h.createDecorator)(e.UserConfigurationFileServiceId);let b=class{constructor(w,t,m){this.environmentService=w,this.fileService=t,this.logService=m,this.queue=new p.Queue}async updateSettings(w,t){return this.queue.queue(()=>this.doWrite(w,t))}async doWrite(w,t){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),w);const{value:m,mtime:E,etag:S}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let P=m.toString();const l=[];if((0,C.parse)(P,l,{allowTrailingComma:!0,allowEmptyContent:!0}),l.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(w,P,t)[0];if(c){P=P.substring(0,c.offset)+c.content+P.substring(c.offset+c.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(P),{etag:S,mtime:E})}catch(u){if(u.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(w,t){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,w,t)})}getEdits({value:w,path:t},m,E){return t.length?(0,k.setProperty)(m,t,w,E):[{content:JSON.stringify(w,null,E.insertSpaces&&E.tabSize?" ".repeat(E.tabSize):"	"),length:m.length,offset:0}]}};b=he([ee(0,i.IEnvironmentService),ee(1,I.IFileService),ee(2,f.ILogService)],b),e.UserConfigurationFileService=b}),define(Q[181],J([0,1,31,9,16,4,2,8,55,6]),function(j,e,p,D,C,k,i,I,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class y extends i.Disposable{constructor(g){super();this.logService=g,this._onDidErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(g,w){return w.recursive?this.watchRecursive(g,w):this.watchNonRecursive(g)}watchRecursive(g,w){const t={path:this.toFilePath(g),excludes:w.excludes},m=(0,p.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,i.toDisposable)(()=>{m(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(g=>(0,C.onUnexpectedError)(g))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(g=>this._onDidChangeFile.fire((0,h.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(g,w){return g.watch(w)}watchNonRecursive(g){const w=this.createNonRecursiveWatcher(this.toFilePath(g),m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===f.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{w.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return(0,i.combinedDisposable)(w,t)}onWatcherLogMessage(g){g.type==="error"&&this._onDidErrorOccur.fire(g.message),this.logService[g.type](g.message)}toFilePath(g){return(0,I.normalize)(g.fsPath)}}e.AbstractDiskFileSystemProvider=y}),define(Q[182],J([0,1,31,9,17,23,4,69,2,40,10,63,15,60,143,18,92,6]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let P=class Ke extends h.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new i.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new i.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new i.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new i.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new i.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new i.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new m.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new m.FileChangesEvent(u,!0)))),this.watchedResources=f.TernarySearchTree.forUris(u=>{const r=this.getProvider(u.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(c,u){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:u});const r=new h.DisposableStore;return r.add(u.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(u)))),r.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:c}))),typeof u.onDidErrorOccur=="function"&&r.add(u.onDidErrorOccur(a=>this._onError.fire(new Error(a)))),(0,h.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:u}),this.provider.delete(c),(0,h.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){u.push(r)}}),!this.provider.has(c)&&await D.Promises.settled(u)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,u){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&u)}listCapabilities(){return I.Iterable.map(this.provider,([c,u])=>({scheme:c,capabilities:u.capabilities}))}async withProvider(c){if(!(0,g.isAbsolutePath)(c))throw new m.FileOperationError((0,t.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const u=this.provider.get(c.scheme);if(!u){const r=new Error;throw r.name="ENOPRO",r.message=(0,t.localize)(1,null,c.toString()),r}return u}async withReadProvider(c){const u=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(u)||(0,m.hasReadWriteCapability)(u)||(0,m.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const u=await this.withProvider(c);if((0,m.hasOpenReadWriteCloseCapability)(u)||(0,m.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,u){try{return await this.doResolveFile(c,u)}catch(r){throw(0,m.toFileSystemProviderErrorCode)(r)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,t.localize)(2,null,this.resourceForError(c)),1):(0,m.ensureFileSystemProviderError)(r)}}async doResolveFile(c,u){const r=await this.withProvider(c),a=this.isPathCaseSensitive(r),s=u?.resolveTo,n=u?.resolveSingleChildDescendants,o=u?.resolveMetadata,d=await r.stat(c);let v;return this.toFileStat(r,c,d,void 0,!!o,(M,L)=>(v||(v=f.TernarySearchTree.forUris(()=>!a),v.set(c,!0),s&&v.fill(!0,s)),v.get(M.resource)||v.findSuperstr(M.resource.with({query:null,fragment:null}))?!0:M.isDirectory&&n?L===1:!1))}async toFileStat(c,u,r,a,s,n){const{providerExtUri:o}=this.getExtUri(c),d={resource:u,name:o.basename(u),isFile:(r.type&m.FileType.File)!=0,isDirectory:(r.type&m.FileType.Directory)!=0,isSymbolicLink:(r.type&m.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&m.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,m.etag)({mtime:r.mtime,size:r.size})};if(d.isDirectory&&n(d,a)){try{const v=await c.readdir(u),M=await D.Promises.settled(v.map(async([L,A])=>{try{const W=o.joinPath(u,L),H=s?await c.stat(W):{type:A};return await this.toFileStat(c,W,H,v.length,s,n)}catch(W){return this.logService.trace(W),null}}));d.children=(0,p.coalesce)(M)}catch(v){this.logService.trace(v),d.children=[]}return d}return d}async resolveAll(c){return D.Promises.settled(c.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(c){const u=await this.withProvider(c);try{return!!await u.stat(c)}catch(r){return!1}}async canCreateFile(c,u){try{await this.doValidateCreateFile(c,u)}catch(r){return r}return!0}async doValidateCreateFile(c,u){if(!u?.overwrite&&await this.exists(c))throw new m.FileOperationError((0,t.localize)(3,null,this.resourceForError(c)),3,u)}async createFile(c,u=C.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const a=await this.writeFile(c,u);return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,a)),a}async writeFile(c,u,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:s}=this.getExtUri(a);try{await this.validateWriteFile(a,c,r)||await this.mkdirp(a,s.dirname(c));let o;if((0,m.hasReadWriteCapability)(a)&&!(u instanceof C.VSBuffer))if((0,w.isReadableStream)(u)){const d=await(0,w.peekStream)(u,3);d.ended?o=C.VSBuffer.concat(d.buffer):o=d}else o=(0,w.peekReadable)(u,d=>C.VSBuffer.concat(d),3);else o=u;!(0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasReadWriteCapability)(a)&&o instanceof C.VSBuffer?await this.doWriteUnbuffered(a,c,r,o):await this.doWriteBuffered(a,c,r,o instanceof C.VSBuffer?(0,C.bufferToReadable)(o):o)}catch(n){throw new m.FileOperationError((0,t.localize)(4,null,this.resourceForError(c),(0,m.ensureFileSystemProviderError)(n).toString()),(0,m.toFileOperationResult)(n),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,u,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(u)));let s;try{s=await c.stat(u)}catch(n){return}if((s.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,t.localize)(6,null,this.resourceForError(u)),0,r);if(this.throwIfFileIsReadonly(u,s),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==m.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&r.mtime<s.mtime&&r.etag!==(0,m.etag)({mtime:r.mtime,size:s.size}))throw new m.FileOperationError((0,t.localize)(7,null),3,r);return s}async readFile(c,u){const r=await this.withReadProvider(c);return u?.atomic?this.doReadFileAtomic(r,c,u):this.doReadFile(r,c,u)}async doReadFileAtomic(c,u,r){return new Promise((a,s)=>{this.writeQueue.queueFor(u,this.getExtUri(c).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(c,u,r);a(n)}catch(n){s(n)}})})}async doReadFile(c,u,r){const a=await this.doReadFileStream(c,u,{...r,preferUnbuffered:!0});return{...a,value:await(0,C.streamToBuffer)(a.value)}}async readFileStream(c,u){const r=await this.withReadProvider(c);return this.doReadFileStream(r,c,u)}async doReadFileStream(c,u,r){const a=new k.CancellationTokenSource,s=this.validateReadFile(u,r).then(o=>o,o=>{throw a.cancel(),o});let n;try{return typeof r?.etag=="string"&&r.etag!==m.ETAG_DISABLED&&await s,!((0,m.hasOpenReadWriteCloseCapability)(c)||(0,m.hasFileReadStreamCapability)(c))||(0,m.hasReadWriteCapability)(c)&&r?.preferUnbuffered?n=this.readFileUnbuffered(c,u,r):(0,m.hasFileReadStreamCapability)(c)?n=this.readFileStreamed(c,u,a.token,r):n=this.readFileBuffered(c,u,a.token,r),{...await s,value:n}}catch(o){n&&await(0,w.consumeStream)(n);const d=(0,t.localize)(8,null,this.resourceForError(u),(0,m.ensureFileSystemProviderError)(o).toString());throw o instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(d,o.stat,r):new m.FileOperationError(d,(0,m.toFileOperationResult)(o),r)}}readFileStreamed(c,u,r,a=Object.create(null)){const s=c.readFileStream(u,a,r);return(0,w.transform)(s,{data:n=>n instanceof C.VSBuffer?n:C.VSBuffer.wrap(n),error:n=>new m.FileOperationError((0,t.localize)(9,null,this.resourceForError(u),(0,m.ensureFileSystemProviderError)(n).toString()),(0,m.toFileOperationResult)(n),a)},n=>C.VSBuffer.concat(n))}readFileBuffered(c,u,r,a=Object.create(null)){const s=(0,C.newWriteableBufferStream)();return(0,E.readFileIntoStream)(c,u,s,n=>n,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new m.FileOperationError((0,t.localize)(10,null,this.resourceForError(u),(0,m.ensureFileSystemProviderError)(n).toString()),(0,m.toFileOperationResult)(n),a)},r),s}readFileUnbuffered(c,u,r){const a=(0,w.newWriteableStream)(s=>C.VSBuffer.concat(s));return(async()=>{try{let s=await c.readFile(u);typeof r?.position=="number"&&(s=s.slice(r.position)),typeof r?.length=="number"&&(s=s.slice(0,r.length)),this.validateReadFileLimits(u,s.byteLength,r),a.end(C.VSBuffer.wrap(s))}catch(s){a.error(s),a.end()}})(),a}async validateReadFile(c,u){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new m.FileOperationError((0,t.localize)(11,null,this.resourceForError(c)),0,u);if(typeof u?.etag=="string"&&u.etag!==m.ETAG_DISABLED&&u.etag===r.etag)throw new m.NotModifiedSinceFileOperationError((0,t.localize)(12,null),r,u);return this.validateReadFileLimits(c,r.size,u),r}validateReadFileLimits(c,u,r){if(r?.limits){let a;if(typeof r.limits.memory=="number"&&u>r.limits.memory&&(a=9),typeof r.limits.size=="number"&&u>r.limits.size&&(a=7),typeof a=="number")throw new m.FileOperationError((0,t.localize)(13,null,this.resourceForError(c)),a)}}async canMove(c,u,r){return this.doCanMoveCopy(c,u,"move",r)}async canCopy(c,u,r){return this.doCanMoveCopy(c,u,"copy",r)}async doCanMoveCopy(c,u,r,a){if(c.toString()!==u.toString())try{const s=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(s,c,n,u,r,a)}catch(s){return s}return!0}async move(c,u,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),n=await this.doMoveCopy(a,c,s,u,"move",!!r),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,n==="move"?2:3,o)),o}async copy(c,u,r){const a=await this.withReadProvider(c),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),n=await this.doMoveCopy(a,c,s,u,"copy",!!r),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,n==="copy"?3:2,o)),o}async doMoveCopy(c,u,r,a,s,n){if(u.toString()===a.toString())return s;const{exists:o,isSameResourceWithDifferentPathCase:d}=await this.doValidateMoveCopy(c,u,r,a,s,n);if(o&&!d&&n&&await this.del(a,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(a)),s==="copy"){if(c===r&&(0,m.hasFileFolderCopyCapability)(c))await c.copy(u,a,{overwrite:n});else{const v=await this.resolve(u);v.isDirectory?await this.doCopyFolder(c,v,r,a):await this.doCopyFile(c,u,r,a)}return s}else return c===r?(await c.rename(u,a,{overwrite:n}),s):(await this.doMoveCopy(c,u,r,a,"copy",n),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(c,u,r,a){if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,u,r,a);if((0,m.hasOpenReadWriteCloseCapability)(c)&&(0,m.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,u,r,a);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,u,r,a);if((0,m.hasReadWriteCapability)(c)&&(0,m.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,u,r,a)}async doCopyFolder(c,u,r,a){await r.mkdir(a),Array.isArray(u.children)&&await D.Promises.settled(u.children.map(async s=>{const n=this.getExtUri(r).providerExtUri.joinPath(a,s.name);return s.isDirectory?this.doCopyFolder(c,await this.resolve(s.resource),r,n):this.doCopyFile(c,s.resource,r,n)}))}async doValidateMoveCopy(c,u,r,a,s,n){let o=!1;if(c===r){const{providerExtUri:v,isPathCaseSensitive:M}=this.getExtUri(c);if(M||(o=v.isEqual(u,a)),o&&s==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(u),this.resourceForError(a)));if(!o&&v.isEqualOrParent(a,u))throw new Error((0,t.localize)(15,null,this.resourceForError(u),this.resourceForError(a)))}const d=await this.exists(a);if(d&&!o){if(!n)throw new m.FileOperationError((0,t.localize)(16,null,this.resourceForError(u),this.resourceForError(a)),4);if(c===r){const{providerExtUri:v}=this.getExtUri(c);if(v.isEqualOrParent(u,a))throw new Error((0,t.localize)(17,null,this.resourceForError(u),this.resourceForError(a)))}}return{exists:d,isSameResourceWithDifferentPathCase:o}}getExtUri(c){const u=this.isPathCaseSensitive(c);return{providerExtUri:u?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(u,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(c,0,r)),r}async mkdirp(c,u){const r=[],{providerExtUri:a}=this.getExtUri(c);for(;!a.isEqual(u,a.dirname(u));)try{if(((await c.stat(u)).type&m.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(u)));break}catch(s){if((0,m.toFileSystemProviderErrorCode)(s)!==m.FileSystemProviderErrorCode.FileNotFound)throw s;r.push(a.basename(u)),u=a.dirname(u)}for(let s=r.length-1;s>=0;s--){u=a.joinPath(u,r[s]);try{await c.mkdir(u)}catch(n){if((0,m.toFileSystemProviderErrorCode)(n)!==m.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(c,u){try{await this.doValidateDelete(c,u)}catch(r){return r}return!0}async doValidateDelete(c,u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!u?.useTrash&&!(r.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(c)));let s;try{s=await r.stat(c)}catch(o){}if(s)this.throwIfFileIsReadonly(c,s);else throw new m.FileOperationError((0,t.localize)(20,null,this.resourceForError(c)),1);if(!!!u?.recursive){const o=await this.resolve(c);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(c)))}return r}async del(c,u){const r=await this.doValidateDelete(c,u),a=!!u?.useTrash,s=!!u?.recursive;await r.delete(c,{recursive:s,useTrash:a}),this._onDidRunOperation.fire(new m.FileOperationEvent(c,1))}onDidChangeFile(c,u){this._onDidChangeFilesRaw.fire({changes:c});let r,a;{for(const s of c)this.watchedResources.has(s.resource)?(r||(r=[]),r.push(s)):(a||(a=[]),a.push(s));r&&this._onDidFilesChange.fire(new m.FileChangesEvent(r,!u))}if(a){const s=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!s.work(a)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),s.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${s.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,u={recursive:!1,excludes:[]}){const r=new h.DisposableStore;let a=!1,s=()=>{a=!0};return r.add((0,h.toDisposable)(()=>s())),this.doWatch(c,u).then(n=>{a?(0,h.dispose)(n):s=()=>(0,h.dispose)(n)},n=>this.logService.error(n)),u.recursive||(this.watchedResources.set(c,(this.watchedResources.get(c)??0)+1),r.add((0,h.toDisposable)(()=>{const n=this.watchedResources.get(c);typeof n=="number"&&(n<=1?this.watchedResources.delete(c):this.watchedResources.set(c,n-1))}))),r}async doWatch(c,u){const r=await this.withProvider(c),a=this.toWatchKey(r,c,u);let s=this.activeWatchers.get(a);return s||(s={count:0,disposable:r.watch(c,u)},this.activeWatchers.set(a,s)),s.count+=1,(0,h.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,h.dispose)(s.disposable),this.activeWatchers.delete(a)))})}toWatchKey(c,u,r){const{providerExtUri:a}=this.getExtUri(c);return[a.getComparisonKey(u),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,h.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,u,r,a){return this.writeQueue.queueFor(u,this.getExtUri(c).providerExtUri).queue(async()=>{const s=await c.open(u,{create:!0,unlock:r?.unlock??!1});try{(0,w.isReadableStream)(a)||(0,w.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(c,s,a):await this.doWriteReadableBufferedQueued(c,s,a)}catch(n){throw(0,m.ensureFileSystemProviderError)(n)}finally{await c.close(s)}})}async doWriteStreamBufferedQueued(c,u,r){let a=0,s;if((0,w.isReadableBufferedStream)(r)){if(r.buffer.length>0){const n=C.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,u,n,n.byteLength,a,0),a+=n.byteLength}if(r.ended)return;s=r.stream}else s=r;return new Promise((n,o)=>{(0,w.listenStream)(s,{onData:async d=>{s.pause();try{await this.doWriteBuffer(c,u,d,d.byteLength,a,0)}catch(v){return o(v)}a+=d.byteLength,setTimeout(()=>s.resume())},onError:d=>o(d),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(c,u,r){let a=0,s;for(;(s=r.read())!==null;)await this.doWriteBuffer(c,u,s,s.byteLength,a,0),a+=s.byteLength}async doWriteBuffer(c,u,r,a,s,n){let o=0;for(;o<a;)o+=await c.write(u,s+o,r.buffer,n+o,a-o)}async doWriteUnbuffered(c,u,r,a){return this.writeQueue.queueFor(u,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,u,r,a))}async doWriteUnbufferedQueued(c,u,r,a){let s;a instanceof C.VSBuffer?s=a:(0,w.isReadableStream)(a)?s=await(0,C.streamToBuffer)(a):(0,w.isReadableBufferedStream)(a)?s=await(0,C.bufferedStreamToBuffer)(a):s=(0,C.readableToBuffer)(a),await c.writeFile(u,s.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,u,r,a))}async doPipeBufferedQueued(c,u,r,a){let s,n;try{s=await c.open(u,{create:!1}),n=await r.open(a,{create:!0,unlock:!1});const o=C.VSBuffer.alloc(this.BUFFER_SIZE);let d=0,v=0,M=0;do M=await c.read(s,d,o.buffer,v,o.byteLength-v),await this.doWriteBuffer(r,n,o,M,d,v),d+=M,v+=M,v===o.byteLength&&(v=0);while(M>0)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await D.Promises.settled([typeof s=="number"?c.close(s):Promise.resolve(),typeof n=="number"?r.close(n):Promise.resolve()])}}async doPipeUnbuffered(c,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,u,r,a))}async doPipeUnbufferedQueued(c,u,r,a){return r.writeFile(a,await c.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,u,r,a))}async doPipeUnbufferedToBufferedQueued(c,u,r,a){const s=await r.open(a,{create:!0,unlock:!1});try{const n=await c.readFile(u);await this.doWriteBuffer(r,s,C.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,m.ensureFileSystemProviderError)(n)}finally{await r.close(s)}}async doPipeBufferedToUnbuffered(c,u,r,a){const s=await(0,C.streamToBuffer)(this.readFileBuffered(c,u,k.CancellationToken.None));await this.doWriteUnbuffered(r,a,void 0,s)}throwIfFileSystemIsReadonly(c,u){if(c.capabilities&2048)throw new m.FileOperationError((0,t.localize)(22,null,this.resourceForError(u)),6);return c}throwIfFileIsReadonly(c,u){if((u.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,t.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===y.Schemas.file?c.fsPath:c.toString(!0)}};P.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},P=he([ee(0,S.ILogService)],P),e.FileService=P}),define(Q[183],J([0,1,14,146,3,7,18,93,8,2,55,6,167,112]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends g.AbstractDiskFileSystemProviderChannel{constructor(S,P){super(S,P)}getUriTransformer(S){return w.DefaultURITransformer}transformIncoming(S,P){return k.URI.revive(P)}async delete(S,P,l){if(!l.useTrash)return super.delete(S,P,l);const c=this.transformIncoming(S,P),u=(0,h.normalize)(c.fsPath);try{await p.shell.trashItem(u)}catch(r){throw(0,i.createFileSystemProviderError)(C.isWindows?(0,D.localize)(0,null,(0,h.basename)(u)):(0,D.localize)(1,null,(0,h.basename)(u)),i.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(S,P){return new m(P,this.logService)}}e.DiskFileSystemProviderChannel=t;class m extends f.Disposable{constructor(S,P){super();this.sessionEmitter=S,this.logService=P,this.watcherRequests=new Map}watch(S,P,l){if(l.recursive)throw(0,i.createFileSystemProviderError)("Recursive watcher is not supported from main process",i.FileSystemProviderErrorCode.Unavailable);const c=new f.DisposableStore;this.watcherRequests.set(S,c),c.add((0,f.toDisposable)(()=>this.watcherRequests.delete(S)));const u=c.add(new I.FileWatcher((0,h.normalize)(P.fsPath),r=>this.sessionEmitter.fire((0,y.toFileChanges)(r)),r=>this.onWatcherLogMessage(r),this.logService.getLevel()===b.LogLevel.Trace));return c.add(this.logService.onDidChangeLogLevel(()=>{u.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})),c}onWatcherLogMessage(S){S.type==="error"&&this.sessionEmitter.fire(S.message),this.logService[S.type](S.message)}dispose(){super.dispose(),this.watcherRequests.forEach(S=>(0,f.dispose)(S)),this.watcherRequests.clear()}}}),define(Q[94],J([0,1,29,249,9,17,4,33,8,3,15,60,21,147,18,92,93,173,174,181,45]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(p)}catch(r){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(r)}`)}})();class u extends l.AbstractDiskFileSystemProvider{constructor(a,s){super(a);this.options=s,this.onDidChangeCapabilities=i.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,f.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(a){try{const{stat:s,symbolicLink:n}=await g.SymlinkSupport.stat(this.toFilePath(a));return{type:this.toType(s,n),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(a){try{const s=await g.Promises.readdir(this.toFilePath(a),{withFileTypes:!0}),n=[];return await Promise.all(s.map(async o=>{try{let d;o.isSymbolicLink()?d=(await this.stat((0,y.joinPath)(a,o.name))).type:d=this.toType(o),n.push([o.name,d])}catch(d){this.logService.trace(d)}})),n}catch(s){throw this.toFileSystemProviderError(s)}}toType(a,s){let n;return s?.dangling?n=t.FileType.Unknown:a.isFile()?n=t.FileType.File:a.isDirectory()?n=t.FileType.Directory:n=t.FileType.Unknown,s&&(n|=t.FileType.SymbolicLink),n}async readFile(a){try{const s=this.toFilePath(a);return await g.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(a,s,n){const o=(0,b.newWriteableStream)(d=>k.VSBuffer.concat(d.map(v=>k.VSBuffer.wrap(v))).buffer);return(0,m.readFileIntoStream)(this,a,o,d=>d.buffer,{...s,bufferSize:256*1024},n),o}async writeFile(a,s,n){let o;try{const d=this.toFilePath(a);if(!n.create||!n.overwrite){if(await g.Promises.exists(d)){if(!n.overwrite)throw(0,t.createFileSystemProviderError)((0,w.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,t.createFileSystemProviderError)((0,w.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(a,{create:!0,unlock:n.unlock}),await this.write(o,0,s,0,s.byteLength)}catch(d){throw await this.toFileSystemProviderWriteError(a,d)}finally{typeof o=="number"&&await this.close(o)}}async open(a,s){try{const n=this.toFilePath(a);if((0,t.isFileOpenForWriteOptions)(s)&&s.unlock)try{const{stat:v}=await g.SymlinkSupport.stat(n);v.mode&128||await g.Promises.chmod(n,v.mode|128)}catch(v){this.logService.trace(v)}let o;if((0,t.isFileOpenForWriteOptions)(s)){if(f.isWindows)try{await g.Promises.truncate(n,0),o="r+"}catch(v){v.code!=="ENOENT"&&this.logService.trace(v)}o||(o="w")}else o="r";const d=await g.Promises.open(n,o);return this.mapHandleToPos.set(d,0),(0,t.isFileOpenForWriteOptions)(s)&&this.writeHandles.set(d,a),d}catch(n){throw(0,t.isFileOpenForWriteOptions)(s)?await this.toFileSystemProviderWriteError(a,n):this.toFileSystemProviderError(n)}}async close(a){try{if(this.mapHandleToPos.delete(a),this.writeHandles.delete(a)&&this.canFlush)try{await g.Promises.fdatasync(a)}catch(s){this.canFlush=!1,this.logService.error(s)}return await g.Promises.close(a)}catch(s){throw this.toFileSystemProviderError(s)}}async read(a,s,n,o,d){const v=this.normalizePos(a,s);let M=null;try{const L=await g.Promises.read(a,n,o,d,v);return typeof L=="number"?M=L:M=L.bytesRead,M}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(a,v,M)}}normalizePos(a,s){return s===this.mapHandleToPos.get(a)?null:s}updatePos(a,s,n){const o=this.mapHandleToPos.get(a);typeof o=="number"&&(typeof s=="number"||(typeof n=="number"?this.mapHandleToPos.set(a,o+n):this.mapHandleToPos.delete(a)))}async write(a,s,n,o,d){return(0,C.retry)(()=>this.doWrite(a,s,n,o,d),100,3)}async doWrite(a,s,n,o,d){const v=this.normalizePos(a,s);let M=null;try{const L=await g.Promises.write(a,n,o,d,v);return typeof L=="number"?M=L:M=L.bytesWritten,M}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(a),L)}finally{this.updatePos(a,v,M)}}async mkdir(a){try{await g.Promises.mkdir(this.toFilePath(a))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(a,s){try{const n=this.toFilePath(a);await this.doDelete(n,s)}catch(n){throw this.toFileSystemProviderError(n)}}async doDelete(a,s){s.recursive?await g.Promises.rm(a,g.RimRafMode.MOVE):await g.Promises.unlink(a)}async rename(a,s,n){const o=this.toFilePath(a),d=this.toFilePath(s);if(o!==d)try{await this.validateTargetDeleted(a,s,"move",n.overwrite),await g.Promises.move(o,d)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,w.localize)(2,null,(0,h.basename)(o),(0,h.basename)((0,h.dirname)(d)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(a,s,n){const o=this.toFilePath(a),d=this.toFilePath(s);if(o!==d)try{await this.validateTargetDeleted(a,s,"copy",n.overwrite),await g.Promises.copy(o,d,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,w.localize)(3,null,(0,h.basename)(o),(0,h.basename)((0,h.dirname)(d)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(a,s,n,o){const d=this.toFilePath(a),v=this.toFilePath(s);let M=!1;if(!!(this.capabilities&1024)||(M=(0,I.isEqual)(d,v,!0)),M&&n==="copy")throw(0,t.createFileSystemProviderError)((0,w.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!M&&await g.Promises.exists(v)){if(!o)throw(0,t.createFileSystemProviderError)((0,w.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(a,s,n){let o,d=!1;return this.options?.watcher?.usePolling?d=!1:d=this.options?.legacyWatcher==="on",d?o=S.FileWatcher:o=P.FileWatcher,new o(v=>a(v),v=>s(v),n,this.options?.watcher)}doWatch(a,s){const n=this.options?.watcher?.usePolling;if(n===!0)for(const o of s)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const o of s)n.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(a,s)}createNonRecursiveWatcher(a,s,n,o){return new E.FileWatcher(a,d=>s(d),d=>n(d),o)}toFileSystemProviderError(a){if(a instanceof t.FileSystemProviderError)return a;let s;switch(a.code){case"ENOENT":s=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=t.FileSystemProviderErrorCode.NoPermissions;break;default:s=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(a,s)}async toFileSystemProviderWriteError(a,s){let n=this.toFileSystemProviderError(s);if(a&&n.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await g.SymlinkSupport.stat(this.toFilePath(a));o.mode&128||(n=(0,t.createFileSystemProviderError)(s,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return n}}e.DiskFileSystemProvider=u}),define(Q[95],J([0,1,6]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function D(k,i){switch(i){case p.LogLevel.Trace:return k.trace;case p.LogLevel.Debug:return k.debug;case p.LogLevel.Info:return k.info;case p.LogLevel.Warning:return k.warn;case p.LogLevel.Error:return k.error;case p.LogLevel.Critical:return k.critical;default:throw new Error("Invalid log level")}}class C extends p.AbstractLogger{constructor(i=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(i),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}set logger(i){this._logger=i;for(const{level:I,args:h}of this.buffer)D(i,I).apply(i,h);this.buffer=[]}_log(i,...I){this._logger?D(this._logger,i).apply(this._logger,I):this.getLevel()<=i&&this.buffer.push({level:i,args:I})}trace(i,...I){this._log(p.LogLevel.Trace,i,...I)}debug(i,...I){this._log(p.LogLevel.Debug,i,...I)}info(i,...I){this._log(p.LogLevel.Info,i,...I)}warn(i,...I){this._log(p.LogLevel.Warning,i,...I)}error(i,...I){this._log(p.LogLevel.Error,i,...I)}critical(i,...I){this._log(p.LogLevel.Critical,i,...I)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=C}),define(Q[184],J([0,1,9,17,15,18,5,95,6]),function(j,e,p,D,C,k,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const f=5*k.ByteSize.MB;let y=class extends h.AbstractLogger{constructor(w,t,m,E,S){super();this.name=w,this.resource=t,this.donotUseFormatters=E,this.fileService=S,this.backupIndex=1,this.setLevel(m),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=h.LogLevel.Trace&&this._log(h.LogLevel.Trace,(0,h.format)(arguments))}debug(){this.getLevel()<=h.LogLevel.Debug&&this._log(h.LogLevel.Debug,(0,h.format)(arguments))}info(){this.getLevel()<=h.LogLevel.Info&&this._log(h.LogLevel.Info,(0,h.format)(arguments))}warn(){this.getLevel()<=h.LogLevel.Warning&&this._log(h.LogLevel.Warning,(0,h.format)(arguments))}error(){if(this.getLevel()<=h.LogLevel.Error){const w=arguments[0];if(w instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=w.stack,this._log(h.LogLevel.Error,(0,h.format)(t))}else this._log(h.LogLevel.Error,(0,h.format)(arguments))}}critical(){this.getLevel()<=h.LogLevel.Critical&&this._log(h.LogLevel.Critical,(0,h.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(w){if(w.fileOperationResult!==3)throw w}}_log(w,t){this.queue.queue(async()=>{await this.initializePromise;let m=await this.loadContent();m.length>f&&(await this.fileService.writeFile(this.getBackupResource(),D.VSBuffer.fromString(m)),m=""),this.donotUseFormatters?m+=t:m+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(w)}] ${t}
`,await this.fileService.writeFile(this.resource,D.VSBuffer.fromString(m))})}getCurrentTimestamp(){const w=E=>E<10?`0${E}`:E,t=E=>E<10?`00${E}`:E<100?`0${E}`:E,m=new Date;return`${m.getFullYear()}-${w(m.getMonth()+1)}-${w(m.getDate())} ${w(m.getHours())}:${w(m.getMinutes())}:${w(m.getSeconds())}.${t(m.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,C.joinPath)((0,C.dirname)(this.resource),`${(0,C.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(w){return""}}stringifyLogLevel(w){switch(w){case h.LogLevel.Critical:return"critical";case h.LogLevel.Debug:return"debug";case h.LogLevel.Error:return"error";case h.LogLevel.Info:return"info";case h.LogLevel.Trace:return"trace";case h.LogLevel.Warning:return"warning"}return""}};y=he([ee(4,k.IFileService)],y),e.FileLogger=y;let b=class extends h.AbstractLoggerService{constructor(w,t,m){super(w.getLevel(),w.onDidChangeLogLevel);this.instantiationService=t,this.fileService=m}doCreateLogger(w,t,m){const E=new I.BufferLogService(t);return(0,k.whenProviderRegistered)(w,this.fileService).then(()=>E.logger=this.instantiationService.createInstance(y,m?.name||(0,C.basename)(w),w,E.getLevel(),!!m?.donotUseFormatters)),E}};b=he([ee(0,h.ILogService),ee(1,i.IInstantiationService),ee(2,k.IFileService)],b),e.FileLoggerService=b}),define(Q[185],J([0,1,4,7,6]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class k{constructor(g){this.service=g,this.onDidChangeLogLevel=p.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(g,w,t){switch(w){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=k;class i{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){i.setLevel(this.channel,g)}static setLevel(g,w){return g.call("setLevel",w)}}e.LogLevelChannelClient=i;class I{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,w){throw new Error(`Event not found: ${w}`)}async call(g,w,t){switch(w){case"createLogger":this.createLogger(D.URI.revive(t[0]),t[1]);return;case"log":return this.log(D.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${w}`)}createLogger(g,w){this.loggers.set(g.toString(),this.loggerService.createLogger(g,w))}consoleLog(g,w){let t=console.log;switch(g){case C.LogLevel.Error:t=console.error;break;case C.LogLevel.Warning:t=console.warn;break;case C.LogLevel.Info:t=console.info;break}t.call(console,...w)}log(g,w){const t=this.loggers.get(g.toString());if(!t)throw new Error("Create the logger before logging");for(const[m,E]of w)(0,C.log)(t,m,E)}}e.LoggerChannel=I;class h extends C.AbstractLoggerService{constructor(g,w,t){super(g,w);this.channel=t}createConsoleMainLogger(){return new C.AdapterLogger({log:(g,w)=>{this.channel.call("consoleLog",[g,w])}})}doCreateLogger(g,w,t){return new f(this.channel,g,w,t)}}e.LoggerChannelClient=h;class f extends C.AbstractMessageLogger{constructor(g,w,t,m){super(m?.always);this.channel=g,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[w,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,w){const t=[[g,w]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(g){this.channel.call("log",[this.file,g])}}class y extends C.LogService{constructor(g,w){super(w);this.parent=g,this._register(g.onDidChangeLogLevel(t=>w.setLevel(t)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=y}),define(Q[96],J([0,1,18,6]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(h,f,y,b,g){try{const w=await new Promise((m,E)=>{j(["spdlog"],m,E)});w.setFlushOn(D.LogLevel.Trace);const t=await w.createAsyncRotatingLogger(h,f,y,b);return g&&t.clearFormatters(),t}catch(w){console.error(w)}return null}function k(h,f,y,b){const g=j.__$__nodeRequire("spdlog");return g.setFlushOn(D.LogLevel.Trace),g.createRotatingLogger(h,f,y,b)}e.createRotatingLogger=k;function i(h,f,y){switch(f){case D.LogLevel.Trace:h.trace(y);break;case D.LogLevel.Debug:h.debug(y);break;case D.LogLevel.Info:h.info(y);break;case D.LogLevel.Warning:h.warn(y);break;case D.LogLevel.Error:h.error(y);break;case D.LogLevel.Critical:h.critical(y);break;default:throw new Error("Invalid log level")}}class I extends D.AbstractMessageLogger{constructor(f,y,b,g,w){super();this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(f,y,b,g),this._register(this.onDidChangeLogLevel(t=>{this._logger&&this._logger.setLevel(t)}))}async _createSpdLogLogger(f,y,b,g){const w=b?6:1,t=30/w*p.ByteSize.MB,m=await C(f,y,t,w,g);if(m){this._logger=m,this._logger.setLevel(this.getLevel());for(const{level:E,message:S}of this.buffer)i(this._logger,E,S);this.buffer=[]}}log(f,y){this._logger?i(this._logger,f,y):this.getLevel()<=f&&this.buffer.push({level:f,message:y})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=I}),define(Q[186],J([0,1,10,15,28,18,184,6,96]),function(j,e,p,D,C,k,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let f=class extends I.AbstractLoggerService{constructor(b,g){super(b.getLevel(),b.onDidChangeLogLevel);this.fileService=g}doCreateLogger(b,g,w){return b.scheme===p.Schemas.file?new h.SpdLogLogger(w?.name||(0,C.generateUuid)(),b.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,g):new i.FileLogger(w?.name??(0,D.basename)(b),b,g,!!w?.donotUseFormatters,this.fileService)}};f=he([ee(0,I.ILogService),ee(1,k.IFileService)],f),e.LoggerService=f}),define(Q[187],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(i){return i.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function D(i){return i.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=D;function C(i){return i.uri!==void 0}e.isMenubarMenuItemRecentAction=C;function k(i){return!p(i)&&!D(i)&&!C(i)}e.isMenubarMenuItemAction=k}),define(Q[56],J([0,1,10,3,32,15]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.context!="undefined"){const I=D.globals.vscode.context.configuration();if(I)i=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const I=(0,k.dirname)(p.FileAccess.asFileUri("",j));i=j.__$__nodeRequire((0,k.joinPath)(I,"product.json").fsPath);const h=j.__$__nodeRequire((0,k.joinPath)(I,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:h.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i}),define(Q[22],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Q[188],J([0,1,61,6,22]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let k=class{constructor(I,h){this.productService=I,this.logService=h,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,h){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const f=/^(.*)#([^#]+)$/.exec(h);if(!f)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,y,b]=f;let g=this.trustedExtensionUrlPublicKeys.get(I);if(!g){if(g=this.productService.trustedExtensionUrlPublicKeys[I],!g||g.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...g])}const w=Buffer.from(decodeURIComponent(b),"base64");if(w.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const t=w.slice(0,6),m=w.readUIntBE(0,6),E=Date.now()-m;if(E<0||E>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const S=w.slice(6),P=p.createVerify("SHA256");P.write(t),P.write(Buffer.from(y)),P.end();for(let l=0;l<g.length;l++){let c=g[l];if(c!==null){if(typeof c=="string")try{c=p.createPublicKey({key:Buffer.from(c,"base64"),format:"der",type:"spki"}),g[l]=c}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${l+1} for ${I}:`,u),g[l]=null;continue}if(P.verify(c,S))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};k=he([ee(0,C.IProductService),ee(1,D.ILogService)],k),e.ExtensionUrlTrustService=k}),define(Q[57],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(Q[189],J([0,1,14,2,40,10,3,15,7,28,48,6]),function(j,e,p,D,C,k,i,I,h,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let g=class extends D.Disposable{constructor(t,m){super();this.logService=m,this.validRoots=C.TernarySearchTree.forUris(()=>!i.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(h.URI.file(t.appRoot)),this.addValidFileRoot(h.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(m,E)=>this.handleResourceRequest(m,E)),t.protocol.interceptFileProtocol(k.Schemas.file,(m,E)=>this.handleFileRequest(m,E)),this._register((0,D.toDisposable)(()=>{t.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?D.Disposable.None:(this.validRoots.set(t,!0),(0,D.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,m){const E=h.URI.parse(t.url);return this.logService.error(`Refused to load resource ${E.fsPath} from ${k.Schemas.file}: protocol (original URL: ${t.url})`),m({error:-3})}handleResourceRequest(t,m){const E=h.URI.parse(t.url),S=k.FileAccess.asFileUri(E);return this.validRoots.findSubstr(S)?m({path:S.fsPath}):this.validExtensions.has((0,I.extname)(S))?m({path:S.fsPath}):(this.logService.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${S.fsPath} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),m({error:-3}))}createIPCObjectUrl(){let t;const m=h.URI.from({scheme:"vscode",path:(0,f.generateUuid)()}),E=m.toString(),S=async()=>t;return p.ipcMain.handle(E,S),this.logService.trace(`IPC Object URL: Registered new channel ${E}.`),{resource:m,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${E}.`),p.ipcMain.removeHandler(E)}}}};g=he([ee(0,y.INativeEnvironmentService),ee(1,b.ILogService)],g),e.ProtocolMainService=g}),define(Q[37],J([0,1,104,13]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(i,I){p.ok(D.isString(i)),p.ok(D.isObject(I)),p.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,I)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new C}),define(Q[190],J([0,1,4,37]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class k{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(h,f){this.schemasById[C(h)]=f,this._onDidChangeSchema.fire(h)}notifySchemaChanged(h){this._onDidChangeSchema.fire(h)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new k;D.Registry.add(e.Extensions.JSONContribution,i)}),define(Q[49],J([0,1,31,4,13,135,190,37]),function(j,e,p,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(P){P.Multiline="multilineText",P.Singleline="singlelineText"})(h=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=I.Registry.as(i.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(l,c=!0){this.registerConfigurations([l],c)}registerConfigurations(l,c=!0){const u=this.doRegisterConfigurations(l,c);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(l){const c=this.doDeregisterConfigurations(l);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}updateConfigurations({add:l,remove:c}){const u=[];u.push(...this.doDeregisterConfigurations(c)),u.push(...this.doRegisterConfigurations(l,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,p.distinct)(u))}registerDefaultConfigurations(l){const c=[],u=[];for(const r of l)for(const a in r)if(c.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]={...this.defaultValues[a]||{},...r[a]};const s={type:"object",default:this.defaultValues[a],description:k.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};u.push(w(a)),this.configurationProperties[a]=s,this.defaultLanguageConfigurationOverridesNode.properties[a]=s}else{this.defaultValues[a]=r[a];const s=this.configurationProperties[a];s&&(this.updatePropertyDefaultValue(a,s),this.updateSchema(a,s))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(l){const c=[];for(const u of l)for(const r in u)if(c.push(r),delete this.defaultValues[r],e.OVERRIDE_PROPERTY_PATTERN.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const a=this.configurationProperties[r];a&&(this.updatePropertyDefaultValue(r,a),this.updateSchema(r,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const c of l)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,c){const u=[];return l.forEach(r=>{u.push(...this.validateAndRegisterProperties(r,c,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),u}doDeregisterConfigurations(l){const c=[],u=r=>{if(r.properties)for(const a in r.properties)c.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,r.properties[a]);r.allOf&&r.allOf.forEach(a=>u(a))};for(const r of l){u(r);const a=this.configurationContributors.indexOf(r);a!==-1&&this.configurationContributors.splice(a,1)}return c}validateAndRegisterProperties(l,c=!0,u,r=3){r=C.isUndefinedOrNull(l.scope)?r:l.scope;let a=[],s=l.properties;if(s)for(let o in s){if(c&&E(o)){delete s[o];continue}const d=s[o];if(this.updatePropertyDefaultValue(o,d),e.OVERRIDE_PROPERTY_PATTERN.test(o)?d.scope=void 0:(d.scope=C.isUndefinedOrNull(d.scope)?r:d.scope,d.restricted=C.isUndefinedOrNull(d.restricted)?!!u?.restrictedConfigurations?.includes(o):d.restricted),s[o].hasOwnProperty("included")&&!s[o].included){this.excludedConfigurationProperties[o]=s[o],delete s[o];continue}else this.configurationProperties[o]=s[o];!s[o].deprecationMessage&&s[o].markdownDeprecationMessage&&(s[o].deprecationMessage=s[o].markdownDeprecationMessage),a.push(o)}let n=l.allOf;if(n)for(let o of n)a.push(...this.validateAndRegisterProperties(o,c,u,r));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(l){const c=u=>{let r=u.properties;if(r)for(const s in r)this.updateSchema(s,r[s]);let a=u.allOf;a&&a.forEach(c)};c(l)}updateSchema(l,c){switch(e.allSettings.properties[l]=c,c.scope){case 1:e.applicationSettings.properties[l]=c;break;case 2:e.machineSettings.properties[l]=c;break;case 6:e.machineOverridableSettings.properties[l]=c;break;case 3:e.windowSettings.properties[l]=c;break;case 4:e.resourceSettings.properties[l]=c;break;case 5:e.resourceSettings.properties[l]=c,this.resourceLanguageSettingsSchema.properties[l]=c;break}}removeFromSchema(l,c){switch(delete e.allSettings.properties[l],c.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const c=`[${l}]`,u={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,u),e.allSettings.properties[c]=u,e.applicationSettings.properties[c]=u,e.machineSettings.properties[c]=u,e.machineOverridableSettings.properties[c]=u,e.windowSettings.properties[c]=u,e.resourceSettings.properties[c]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,c){let u=this.defaultValues[l];C.isUndefined(u)&&(u=c.default),C.isUndefined(u)&&(u=t(c.type)),c.default=u}}const g="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function w(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=w;function t(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=t;const m=new b;I.Registry.add(e.Extensions.Configuration,m);function E(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?k.localize(5,null,P):m.getConfigurationProperties()[P]!==void 0?k.localize(6,null,P):null:k.localize(4,null)}e.validateProperty=E;function S(){const P=[],l=m.getConfigurationProperties();for(const c of Object.keys(l))P.push([c,l[c].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=S}),define(Q[19],J([0,1,43,13,7,49,5,37]),function(j,e,p,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,i.createDecorator)("configurationService");function h(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof C.URI)}e.isConfigurationOverrides=h;var f;(function(a){a[a.USER=1]="USER",a[a.USER_LOCAL=2]="USER_LOCAL",a[a.USER_REMOTE=3]="USER_REMOTE",a[a.WORKSPACE=4]="WORKSPACE",a[a.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",a[a.DEFAULT=6]="DEFAULT",a[a.MEMORY=7]="MEMORY"})(f=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(a){switch(a){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=y;function b(a,s){const n=s?a?s.keys.filter(W=>a.keys.indexOf(W)===-1):[...s.keys]:[],o=a?s?a.keys.filter(W=>s.keys.indexOf(W)===-1):[...a.keys]:[],d=[];if(s&&a){for(const W of a.keys)if(s.keys.indexOf(W)!==-1){const H=S(a.contents,W),Z=S(s.contents,W);p.equals(H,Z)||d.push(W)}}const v=[],M=W=>{const H={};for(const Z of W)for(const ne of Z.identifiers)H[u(ne)]=Z;return H},L=s?M(s.overrides):{},A=a?M(a.overrides):{};if(Object.keys(L).length)for(const W of n){const H=L[W];H&&v.push([(0,k.overrideIdentifierFromKey)(W),H.keys])}if(Object.keys(A).length)for(const W of o){const H=A[W];H&&v.push([(0,k.overrideIdentifierFromKey)(W),H.keys])}if(Object.keys(L).length&&Object.keys(A).length)for(const W of d){const H=A[W],Z=L[W];if(H&&Z){const ne=b({contents:H.contents,keys:H.keys,overrides:[]},{contents:Z.contents,keys:Z.keys,overrides:[]});v.push([(0,k.overrideIdentifierFromKey)(W),[...ne.added,...ne.removed,...ne.updated]])}}return{added:n,removed:o,updated:d,overrides:v}}e.compare=b;function g(a,s){const n=[];for(const o of Object.keys(a))if(k.OVERRIDE_PROPERTY_PATTERN.test(o)){const d={};for(const v in a[o])d[v]=a[o][v];n.push({identifiers:[(0,k.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(d),contents:w(d,s)})}return n}e.toOverrides=g;function w(a,s){const n=Object.create(null);for(let o in a)t(n,o,a[o],s);return n}e.toValuesTree=w;function t(a,s,n,o){const d=s.split("."),v=d.pop();let M=a;for(let L=0;L<d.length;L++){let A=d[L],W=M[A];switch(typeof W){case"undefined":W=M[A]=Object.create(null);break;case"object":break;default:o(`Ignoring ${s} as ${d.slice(0,L+1).join(".")} is ${JSON.stringify(W)}`);return}M=W}if(typeof M=="object"&&M!==null)try{M[v]=n}catch(L){o(`Ignoring ${s} as ${d.join(".")} is ${JSON.stringify(M)}`)}else o(`Ignoring ${s} as ${d.join(".")} is ${JSON.stringify(M)}`)}e.addToValueTree=t;function m(a,s){const n=s.split(".");E(a,n)}e.removeFromValueTree=m;function E(a,s){const n=s.shift();if(s.length===0){delete a[n];return}if(Object.keys(a).indexOf(n)!==-1){const o=a[n];typeof o=="object"&&!Array.isArray(o)&&(E(o,s),Object.keys(o).length===0&&delete a[n])}}function S(a,s,n){function o(M,L){let A=M;for(const W of L){if(typeof A!="object"||A===null)return;A=A[W]}return A}const d=s.split("."),v=o(a,d);return typeof v=="undefined"?n:v}e.getConfigurationValue=S;function P(a,s,n){Object.keys(s).forEach(o=>{o!=="__proto__"&&(o in a?D.isObject(a[o])&&D.isObject(s[o])?P(a[o],s[o],n):n&&(a[o]=s[o]):a[o]=s[o])})}e.merge=P;function l(){const a=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(a)}e.getConfigurationKeys=l;function c(){const a=Object.create(null),s=I.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let n in s){let o=s[n].default;t(a,n,o,d=>console.error(`Conflict in default settings: ${d}`))}return a}e.getDefaultValues=c;function u(a){return`[${a}]`}e.keyFromOverrideIdentifier=u;function r(a,s,n){const o=a.inspect(s),d=a.inspect(n);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:o.defaultValue}e.getMigratedSettingValue=r}),define(Q[191],J([0,1,31,4,39,2,40,43,13,7,19,49,37]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(r={},a=[],s=[]){this._contents=r,this._keys=a,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,y.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,a){const s=this.getContentsForOverrideIdentifer(a);return s?r?(0,y.getConfigurationValue)(s,r):s:void 0}getKeysForOverrideIdentifier(r){for(const a of this.overrides)if(a.identifiers.indexOf(r)!==-1)return a.keys;return[]}override(r){let a=this.overrideConfigurations.get(r);return a||(a=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,a)),a}merge(...r){const a=I.deepClone(this.contents),s=I.deepClone(this.overrides),n=[...this.keys];for(const o of r){this.mergeContents(a,o.contents);for(const d of o.overrides){const[v]=s.filter(M=>p.equals(M.identifiers,d.identifiers));v?this.mergeContents(v.contents,d.contents):s.push(I.deepClone(d))}for(const d of o.keys)n.indexOf(d)===-1&&n.push(d)}return new w(a,n,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const a=this.getContentsForOverrideIdentifer(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;let s={};for(const n of p.distinct([...Object.keys(this.contents),...Object.keys(a)])){let o=this.contents[n],d=a[n];d&&(typeof o=="object"&&typeof d=="object"?(o=I.deepClone(o),this.mergeContents(o,d)):o=d),s[n]=o}return new w(s,this.keys,this.overrides)}mergeContents(r,a){for(const s of Object.keys(a)){if(s in r&&h.isObject(r[s])&&h.isObject(a[s])){this.mergeContents(r[s],a[s]);continue}r[s]=I.deepClone(a[s])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){for(const a of this.overrides)if(a.identifiers.indexOf(r)!==-1)return a.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,a){this.addKey(r),(0,y.addToValueTree)(this.contents,r,a,s=>{throw new Error(s)})}removeValue(r){this.removeKey(r)&&(0,y.removeFromValueTree)(this.contents,r)}addKey(r){let a=this.keys.length;for(let s=0;s<a;s++)r.indexOf(this.keys[s])===0&&(a=s);this.keys.splice(a,1,r)}removeKey(r){let a=this.keys.indexOf(r);return a!==-1?(this.keys.splice(a,1),!0):!1}}e.ConfigurationModel=w;class t extends w{constructor(){const r=(0,y.getDefaultValues)(),a=(0,y.getConfigurationKeys)(),s=[];for(const n of Object.keys(r))b.OVERRIDE_PROPERTY_PATTERN.test(n)&&s.push({identifiers:[(0,b.overrideIdentifierFromKey)(n).trim()],keys:Object.keys(r[n]),contents:(0,y.toValuesTree)(r[n],o=>console.error(`Conflict in default settings file: ${o}`))});super(r,a,s)}}e.DefaultConfigurationModel=t;class m{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,a){if(!h.isUndefinedOrNull(r)){const s=this.doParseContent(r);this.parseRaw(s,a)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,a){this._raw=r;const{contents:s,keys:n,overrides:o,restricted:d}=this.doParseRaw(r,a);this._configurationModel=new w(s,n,o),this._restrictedConfigurations=d||[]}doParseContent(r){let a={},s=null,n=[],o=[],d=[];function v(L){Array.isArray(n)?n.push(L):s!==null&&(n[s]=L)}let M={onObjectBegin:()=>{let L={};v(L),o.push(n),n=L,s=null},onObjectProperty:L=>{s=L},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{let L=[];v(L),o.push(n),n=L,s=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:v,onError:(L,A,W)=>{d.push({error:L,offset:A,length:W})}};if(r)try{C.visit(r,M),a=n[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return a}doParseRaw(r,a){const s=g.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),n=this.filter(r,s,!0,a);r=n.raw;const o=(0,y.toValuesTree)(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`)),d=Object.keys(r),v=(0,y.toOverrides)(r,M=>console.error(`Conflict in settings file ${this._name}: ${M}`));return{contents:o,keys:d,overrides:v,restricted:n.restricted}}filter(r,a,s,n){if(!n?.scopes&&!n?.skipRestricted)return{raw:r,restricted:[]};const o={},d=[];for(let v in r)if(b.OVERRIDE_PROPERTY_PATTERN.test(v)&&s){const M=this.filter(r[v],a,!1,n);o[v]=M.raw,d.push(...M.restricted)}else{const M=a[v],L=M?typeof M.scope!="undefined"?M.scope:3:void 0;M?.restricted&&d.push(v),(L===void 0||n.scopes===void 0||n.scopes.includes(L))&&(n.skipRestricted&&M?.restricted||(o[v]=r[v]))}return{raw:o,restricted:d}}}e.ConfigurationModelParser=m;class E extends k.Disposable{constructor(r,a,s,n){super();this.userSettingsResource=r,this.scopes=a,this.fileService=n,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class S{constructor(r,a,s=new w,n=new w,o=new i.ResourceMap,d=new w,v=new i.ResourceMap,M=!0){this._defaultConfiguration=r,this._localUserConfiguration=a,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=o,this._memoryConfiguration=d,this._memoryConfigurationByResource=v,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(r,a,s){return this.getConsolidateConfigurationModel(a,s).getValue(r)}updateValue(r,a,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new w,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,a===void 0?n.removeValue(r):n.setValue(r,a),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,a,s){const n=this.getConsolidateConfigurationModel(a,s),o=this.getFolderConfigurationModelForResource(a.resource,s),d=a.resource?this._memoryConfigurationByResource.get(a.resource)||this._memoryConfiguration:this._memoryConfiguration,v=a.overrideIdentifier?this._defaultConfiguration.freeze().override(a.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),M=a.overrideIdentifier?this.userConfiguration.freeze().override(a.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),L=a.overrideIdentifier?this.localUserConfiguration.freeze().override(a.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),A=a.overrideIdentifier?this.remoteUserConfiguration.freeze().override(a.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),W=s?a.overrideIdentifier?this._workspaceConfiguration.freeze().override(a.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,H=o?a.overrideIdentifier?o.freeze().override(a.overrideIdentifier).getValue(r):o.freeze().getValue(r):void 0,Z=a.overrideIdentifier?d.override(a.overrideIdentifier).getValue(r):d.getValue(r),ne=n.getValue(r),oe=p.distinct(p.flatten(n.overrides.map(G=>G.identifiers))).filter(G=>n.getOverrideValue(r,G)!==void 0);return{defaultValue:v,userValue:M,userLocalValue:L,userRemoteValue:A,workspaceValue:W,workspaceFolderValue:H,memoryValue:Z,value:ne,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:a.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,a.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:a.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,a.overrideIdentifier):void 0}:void 0,userLocal:L!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:a.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,a.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:a.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,a.overrideIdentifier):void 0}:void 0,workspace:W!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:a.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,a.overrideIdentifier):void 0}:void 0,workspaceFolder:H!==void 0?{value:o?.freeze().getValue(r),override:a.overrideIdentifier?o?.freeze().getOverrideValue(r,a.overrideIdentifier):void 0}:void 0,memory:Z!==void 0?{value:d.getValue(r),override:a.overrideIdentifier?d.getOverrideValue(r,a.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(r){const a=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:a?a.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,a){this._folderConfigurations.set(r,a),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const s=a.filter(n=>b.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const o=(0,b.overrideIdentifierFromKey)(n),d=this._defaultConfiguration.getKeysForOverrideIdentifier(o),v=r.getKeysForOverrideIdentifier(o),M=[...v.filter(L=>d.indexOf(L)===-1),...d.filter(L=>v.indexOf(L)===-1),...d.filter(L=>!I.equals(this._defaultConfiguration.override(o).getValue(L),r.override(o).getValue(L)))];return[o,M]});return this.updateDefaultConfiguration(r),{keys:a,overrides:s}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:s,removed:n,overrides:o}=(0,y.compare)(this.localUserConfiguration,r),d=[...a,...s,...n];return d.length&&this.updateLocalUserConfiguration(r),{keys:d,overrides:o}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:s,removed:n,overrides:o}=(0,y.compare)(this.remoteUserConfiguration,r);let d=[...a,...s,...n];return d.length&&this.updateRemoteUserConfiguration(r),{keys:d,overrides:o}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:s,removed:n,overrides:o}=(0,y.compare)(this.workspaceConfiguration,r);let d=[...a,...s,...n];return d.length&&this.updateWorkspaceConfiguration(r),{keys:d,overrides:o}}compareAndUpdateFolderConfiguration(r,a){const s=this.folderConfigurations.get(r),{added:n,updated:o,removed:d,overrides:v}=(0,y.compare)(s,a);let M=[...n,...o,...d];return(M.length||!s)&&this.updateFolderConfiguration(r,a),{keys:M,overrides:v}}compareAndDeleteFolderConfiguration(r){const a=this.folderConfigurations.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:n,removed:o,overrides:d}=(0,y.compare)(a,void 0);return{keys:[...s,...n,...o],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,a){let s=this.getConsolidatedConfigurationModelForResource(r,a);return r.overrideIdentifier?s.override(r.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:r},a){let s=this.getWorkspaceConsolidatedConfiguration();if(a&&r){const n=a.getFolder(r);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const o=this._memoryConfigurationByResource.get(r);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let a=this._foldersConsolidatedConfigurations.get(r);if(!a){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(r);n?(a=s.merge(n),this._freeze&&(a=a.freeze()),this._foldersConsolidatedConfigurations.set(r,a)):a=s}return a}getFolderConfigurationModelForResource(r,a){if(a&&r){const s=a.getFolder(r);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,a)=>{const{contents:s,overrides:n,keys:o}=this._folderConfigurations.get(a);return r.push([a,{contents:s,overrides:n,keys:o}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(a=>r.add(a)),this.userConfiguration.freeze().keys.forEach(a=>r.add(a)),this._workspaceConfiguration.freeze().keys.forEach(a=>r.add(a)),this._folderConfigurations.forEach(a=>a.freeze().keys.forEach(s=>r.add(s))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const a=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>a.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>a.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>a.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(n=>a.add(n))),[...a.values()]}static parse(r){const a=this.parseConfigurationModel(r.defaults),s=this.parseConfigurationModel(r.user),n=this.parseConfigurationModel(r.workspace),o=r.folders.reduce((d,v)=>(d.set(f.URI.revive(v[0]),this.parseConfigurationModel(v[1])),d),new i.ResourceMap);return new S(a,s,new w,n,o,new w,new i.ResourceMap,!1)}static parseConfigurationModel(r){return new w(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=S;function P(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,a=new Map;for(const n of u)n.keys.forEach(o=>r.add(o)),n.overrides.forEach(([o,d])=>{const v=(0,i.getOrSet)(a,o,new Set);d.forEach(M=>v.add(M))});const s=[];return a.forEach((n,o)=>s.push([o,[...n.values()]])),{keys:[...r.values()],overrides:s}}e.mergeChanges=P;class l{constructor(r,a,s,n){this.change=r,this.previous=a,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;r.keys.forEach(v=>o.add(v)),r.overrides.forEach(([,v])=>v.forEach(M=>o.add(M))),this.affectedKeys=[...o.values()];const d=new w;this.affectedKeys.forEach(v=>d.setValue(v,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,a){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(a){const s=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.previous?.workspace):void 0,n=this.currentConfiguraiton.getValue(r,a,this.currentWorkspace);return!I.equals(s,n)}return!0}return!1}doesAffectedKeysTreeContains(r,a){let s=(0,y.toValuesTree)({[a]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(r=r[n],!r)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=l;class c extends l{constructor(r,a,s,n){super({keys:r.allKeys(),overrides:[]},void 0,r,a);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=c}),define(Q[192],J([0,1,9,4,2,15,19,191,49,37]),function(j,e,p,D,C,k,i,I,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class y extends C.Disposable{constructor(g,w){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,w)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(f.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(t=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,w){const t=typeof g=="string"?g:void 0,m=(0,i.isConfigurationOverrides)(g)?g:(0,i.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(t,m,void 0)}updateValue(g,w,t,m){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const w=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(t,w,1)}onDidDefaultConfigurationChange(g){const w=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,g);this.trigger(t,w,6)}trigger(g,w,t){const m=new I.ConfigurationChangeEvent(g,{data:w},this.configuration);m.source=t,m.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=y}),define(Q[193],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var D;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(i,I=D.Unknown,h){super(i);this._message=i,this._code=I,this._detail=h,this.isHandled=I===D.NotAvailable&&h===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(i){return i instanceof C&&i._code===D.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof C&&i._code===D.NoResolverFound}static isHandled(i){return i instanceof C&&i.isHandled}}e.RemoteAuthorityResolverError=C}),define(Q[194],J([0,1,9,17,23,16,4,2,28,84,193]),function(j,e,p,D,C,k,i,I,h,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var g;(function(F){F[F.Management=1]="Management",F[F.ExtensionHost=2]="ExtensionHost",F[F.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function w(F){switch(F){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(F){const R=new C.CancellationTokenSource;return setTimeout(()=>R.cancel(),F),R.token}function m(F,R){if(F.isCancellationRequested||R.isCancellationRequested)return C.CancellationToken.Cancelled;const O=new C.CancellationTokenSource;return F.onCancellationRequested(()=>O.cancel()),R.onCancellationRequested(()=>O.cancel()),O.token}class E{constructor(R){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((O,$)=>{this._resolvePromise=O,this._rejectPromise=$}),R.isCancellationRequested?this._timeout():this._disposables.add(R.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(R){this._state==="pending"?this._disposables.add(R):R.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(R))}reject(R){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(R))}}function S(F,R){const O=new E(R);return O.registerDisposable(F.onControlMessage($=>{const X=JSON.parse($.toString()),V=q(X);V?O.reject(V):O.resolve(X)})),O.promise}function P(F,R,O,$,X,V){const B=new E(V);return R.connect(O,$,X,(x,te)=>{B.didTimeout?(x&&F.error(x),te?.dispose()):x||!te?B.reject(x):B.resolve(te)}),B.promise}function l(F,R){const O=new E(R);return F.then($=>{O.didTimeout||O.resolve($)},$=>{O.didTimeout||O.reject($)}),O.promise}async function c(F,R,O,$){const X=_(F,R);F.logService.trace(`${X} 1/6. invoking socketFactory.connect().`);let V;try{V=await P(F.logService,F.socketFactory,F.host,F.port,`reconnectionToken=${F.reconnectionToken}&reconnection=${F.reconnectionProtocol?"true":"false"}`,$)}catch(se){throw F.logService.error(`${X} socketFactory.connect() failed or timed out. Error:`),F.logService.error(se),se}F.logService.trace(`${X} 2/6. socketFactory.connect() was successful.`);let B,x;F.reconnectionProtocol?(F.reconnectionProtocol.beginAcceptReconnection(V,null),B=F.reconnectionProtocol,x=!1):(B=new f.PersistentProtocol(V,null),x=!0),F.logService.trace(`${X} 3/6. sending AuthRequest control message.`);const te=await l(F.signService.createNewMessage((0,h.generateUuid)()),$),ce={type:"auth",auth:F.connectionToken||"00000000000000000000",data:te.data};B.sendControl(D.VSBuffer.fromString(JSON.stringify(ce)));try{const se=await S(B,m($,t(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const de=new Error("Unexpected handshake message");throw de.code="VSCODE_CONNECTION_ERROR",de}if(F.logService.trace(`${X} 4/6. received SignRequest control message.`),!await l(F.signService.validate(te,se.signedData),$)){const de=new Error("Refused to connect to unsupported server");throw de.code="VSCODE_CONNECTION_ERROR",de}const ae=await l(F.signService.sign(se.data),$),ue={type:"connectionType",commit:F.commit,signedData:ae,desiredConnectionType:R};return O&&(ue.args=O),F.logService.trace(`${X} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(D.VSBuffer.fromString(JSON.stringify(ue))),{protocol:B,ownsProtocol:x}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(F.logService.error(`${X} the handshake timed out. Error:`),F.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(F.logService.error(`${X} received error control message when negotiating connection. Error:`),F.logService.error(se)),x&&z(B),se}}async function u(F,R,O,$){const X=Date.now(),V=_(F,R),{protocol:B,ownsProtocol:x}=await c(F,R,O,$),te=new E($);return te.registerDisposable(B.onControlMessage(ce=>{const se=JSON.parse(ce.toString()),ie=q(se);ie?(F.logService.error(`${V} received error control message when negotiating connection. Error:`),F.logService.error(ie),x&&z(B),te.reject(ie)):(F.reconnectionProtocol&&F.reconnectionProtocol.endAcceptReconnection(),F.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${Y(X)}!`),te.resolve({protocol:B,firstMessage:se}))})),te.promise}async function r(F,R){const{protocol:O}=await u(F,1,void 0,R);return{protocol:O}}async function a(F,R,O){const{protocol:$,firstMessage:X}=await u(F,2,R,O),V=X&&X.debugPort;return{protocol:$,debugPort:V}}async function s(F,R,O){const $=Date.now(),X=_(F,3),{protocol:V}=await c(F,3,R,O);return F.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${Y($)}!`),V}async function n(F,R,O){const{host:$,port:X,connectionToken:V}=await F.addressProvider.getAddress();return{commit:F.commit,host:$,port:X,connectionToken:V,reconnectionToken:R,reconnectionProtocol:O,socketFactory:F.socketFactory,signService:F.signService,logService:F.logService}}async function o(F,R,O){try{const $=(0,h.generateUuid)(),X=await n(F,$,null),{protocol:V}=await r(X,C.CancellationToken.None);return new G(F,R,O,$,V)}catch($){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error($),oe.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled($)),$}}e.connectRemoteAgentManagement=o;async function d(F,R){try{const O=(0,h.generateUuid)(),$=await n(F,O,null),{protocol:X,debugPort:V}=await a($,R,C.CancellationToken.None);return new T(F,R,O,X,V)}catch(O){throw F.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),F.logService.error(O),oe.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(O)),O}}e.connectRemoteAgentExtensionHost=d;async function v(F,R,O){const $=await n(F,(0,h.generateUuid)(),null);return await s($,{host:R,port:O},C.CancellationToken.None)}e.connectRemoteAgentTunnel=v;function M(F){return(0,p.createCancelablePromise)(R=>new Promise((O,$)=>{const X=setTimeout(O,F*1e3);R.onCancellationRequested(()=>{clearTimeout(X),O()})}))}var L;(function(F){F[F.ConnectionLost=0]="ConnectionLost",F[F.ReconnectionWait=1]="ReconnectionWait",F[F.ReconnectionRunning=2]="ReconnectionRunning",F[F.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",F[F.ConnectionGain=4]="ConnectionGain"})(L=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(R,O){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.type=0}}e.ConnectionLostEvent=A;class W{constructor(R,O,$,X){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.durationSeconds=$,this.cancellableTimer=X,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=W;class H{constructor(R,O,$){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=$,this.type=2}}e.ReconnectionRunningEvent=H;class Z{constructor(R,O,$){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=$,this.type=4}}e.ConnectionGainEvent=Z;class ne{constructor(R,O,$,X){this.reconnectionToken=R,this.millisSinceLastIncomingData=O,this.attempt=$,this.handled=X,this.type=3}}e.ReconnectionPermanentFailureEvent=ne;class oe extends I.Disposable{constructor(R,O,$,X){super();this._connectionType=R,this._onDidStateChange=this._register(new i.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=O,this.reconnectionToken=$,this.protocol=X,this._isReconnecting=!1,this._onDidStateChange.fire(new Z(this.reconnectionToken,0,0)),this._register(X.onSocketClose(V=>{const B=N(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${B} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${B} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${B} received socket close event.`),this._beginReconnecting()})),this._register(X.onSocketTimeout(()=>{const V=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${V} received socket timeout event.`),this._beginReconnecting()})),oe._instances.push(this),oe._permanentFailure&&this._gotoPermanentFailure(oe._permanentFailureMillisSinceLastIncomingData,oe._permanentFailureAttempt,oe._permanentFailureHandled)}static triggerPermanentFailure(R,O,$){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=R,this._permanentFailureAttempt=O,this._permanentFailureHandled=$,this._instances.forEach(X=>X._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(oe._permanentFailure)return;const R=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let $=-1;do{$++;const X=$<O.length?O[$]:O[O.length-1];try{if(X>0){const B=M(X);this._onDidStateChange.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X,B)),this._options.logService.info(`${R} waiting for ${X} seconds before reconnecting...`);try{await B}catch{}}if(oe._permanentFailure){this._options.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1)),this._options.logService.info(`${R} resolving connection...`);const V=await n(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${R} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,t(b)),this._options.logService.info(`${R} reconnected!`),this._onDidStateChange.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),$+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if($>360){this._options.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,k.isPromiseCanceledError)(V)){this._options.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof y.RemoteAuthorityResolverError){this._options.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,y.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),$+1,!1);break}}while(!oe._permanentFailure)}_gotoPermanentFailure(R,O,$){this._onDidStateChange.fire(new ne(this.reconnectionToken,R,O,$)),z(this.protocol)}}oe._permanentFailure=!1,oe._permanentFailureMillisSinceLastIncomingData=0,oe._permanentFailureAttempt=0,oe._permanentFailureHandled=!1,oe._instances=[];class G extends oe{constructor(R,O,$,X,V){super(1,R,X,V);this.client=this._register(new f.Client(V,{remoteAuthority:O,clientId:$},R.ipcLogger))}async _reconnect(R,O){await r(R,O)}}e.ManagementPersistentConnection=G;class T extends oe{constructor(R,O,$,X,V){super(2,R,$,X);this._startArguments=O,this.debugPort=V}async _reconnect(R,O){await a(R,this._startArguments,O)}}e.ExtensionHostPersistentConnection=T;function z(F){try{F.acceptDisconnect();const R=F.getSocket();F.dispose(),R.dispose()}catch(R){(0,k.onUnexpectedError)(R)}}function q(F){if(F&&F.type==="error"){const R=new Error(`Connection error: ${F.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function U(F,R){for(;F.length<R;)F+=" ";return F}function N(F,R,O){return`[remote-connection][${U(w(F),13)}][${R.substr(0,5)}\u2026][${O?"reconnect":"initial"}]`}function _(F,R){return`${N(R,F.reconnectionToken,!!F.reconnectionProtocol)}[${F.host}:${F.port}]`}function Y(F){return`${Date.now()-F} ms`}}),define(Q[64],J([0,1,10]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function D(f){return f.scheme===p.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=D;function C(f){if(!f)return;const y=f.indexOf("+");return y<0?f:f.substr(0,y)}e.getRemoteName=C;function k(f){return f.scheme!==p.Schemas.file&&f.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=k;function i(f){if(f.folders.length)return f.folders.every(y=>k(y.uri))?f.folders[0].uri:void 0;if(f.configuration&&k(f.configuration))return f.configuration}e.getVirtualWorkspaceLocation=i;function I(f){return i(f)?.scheme}e.getVirtualWorkspaceScheme=I;function h(f){return i(f)!==void 0}e.isVirtualWorkspace=h}),define(Q[195],J([0,1,25,5,64]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=k;function i(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class h{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,t){if(typeof w=="undefined"||w===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof w=="string"||typeof t=="string"){let m=typeof w=="string"?w:w.value,E=typeof t=="string"?t:t.value;return p.equalsIgnoreCase(m,E)}return w._lower===t._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=h;function f(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function y(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=y;function b(g,w){if(w){const t=`onResolveRemoteAuthority:${(0,C.getRemoteName)(w)}`;return g.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[196],J([0,1,25,195]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(t,m){return t.uuid&&m.uuid?t.uuid===m.uuid:t.id===m.id?!0:(0,p.compareIgnoreCase)(t.id,m.id)===0}e.areSameExtensions=C;class k{constructor(m,E){this.version=E,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof k?C(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=k;function i(t,m){return`${t}.${m}`}e.getExtensionId=i;function I(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function h(t,m){return I(i(t,m))}e.getGalleryExtensionId=h;function f(t,m){const E=[],S=P=>{for(const l of E)if(l.some(c=>C(m(c),m(P))))return l;return null};for(const P of t){const l=S(P);l?l.push(P):E.push([P])}return E}e.groupByExtension=f;function y(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function b(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function g(t){const m=new Set;for(const E of t)E.malicious&&m.add(E.id.id);return m}e.getMaliciousExtensionsSet=g;function w(t,m){const E=[],S=m.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const P=S.shift();if(P&&E.every(l=>!C(l.identifier,{id:P}))){const l=t.filter(c=>C(c.identifier,{id:P}));l.length===1&&(E.push(l[0]),S.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=w}),define(Q[97],J([0,1,4,3,5,6]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var i;(function(t){t.Http="http",t.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var h;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(h=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=b;function g(t,m){return m?m!==1&&t<1024:!D.isWindows&&t<1024}e.isPortPrivileged=g;let w=class{constructor(m){this.logService=m,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m,E){return this._tunnelProvider=m,m?(this._canElevate=E.elevation,this._privacyOptions=E.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],E=Array.from(this._tunnels.values());for(let S of E){const P=Array.from(S.values());for(let l of P){const c=await l.value;c&&m.push(c)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:E}of m.values())await E.then(S=>S?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,E,S,P,l=!1,c=I.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${S} on local port ${P}.`),!m)return;E||(E="localhost");const r=this.retainOrCreateTunnel(m,E,S,P,l,c,u);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(a);return(a.tunnelRemoteHost!==E||a.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const E=this._tunnels.get(m.tunnelRemoteHost);if(E){const S=E.get(m.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,S))}}}}async tryDisposeTunnel(m,E,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${E}.`);const P=S.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(E),P}}async closeTunnel(m,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${E} `);const S=this._tunnels.get(m);if(S&&S.has(E)){const P=S.get(E);P.refcount=0,await this.tryDisposeTunnel(m,E,P)}}addTunnelToMap(m,E,S){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(E,{refcount:1,value:S})}async removeEmptyTunnelFromMap(m,E){const S=this._tunnels.get(m);S&&(await S.get(E)||S.delete(E),S.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,E){let S=[m];y(m)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):b(m)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const P=S.map(l=>this._tunnels.get(l));for(const l of P){const c=l?.get(E);if(c)return c}}canTunnel(m){return!!f(m)}createWithProvider(m,E,S,P,l,c,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${S} on local port ${P}.`);const a={elevationRequired:l?g(P===void 0?S:P):!1},s={remoteAddress:{host:E,port:S},localAddressPort:P,privacy:c,public:c!==I.Private,protocol:u},n=m.forwardPort(s,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(E,S,n),n}};w=he([ee(0,k.ILogService)],w),e.AbstractTunnelService=w}),define(Q[50],J([0,1,17,151,49,5,37]),function(j,e,p,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function I(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=I;function h(t){return t.res.statusCode===204}async function f(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);return h(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=f;async function y(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);if(h(t))return null;const E=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(E)}catch(S){throw S.message+=`:
`+E,S}}e.asJson=y;function b(t){w(t)}e.updateProxyConfigurationsScope=b;let g;function w(t){const m=i.Registry.as(C.Extensions.Configuration),E=g;g={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[g],remove:E?[E]:[]})}w(2)}),define(Q[197],J([0,1,198,13]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function C(i,I){return i.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:i.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function k(i,I,h={}){const f=(0,p.parse)(i),y=h.proxyUrl||C(f,I);if(!y)return null;const b=(0,p.parse)(y);if(!/^https?:$/.test(b.protocol||""))return null;const g={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,D.isBoolean)(h.strictSSL)?h.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((w,t)=>{j(["http-proxy-agent"],w,t)}))(g):new(await new Promise((w,t)=>{j(["https-proxy-agent"],w,t)}))(g)}e.getProxyAgent=k}),define(Q[199],J([0,1,17,28]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function C(k,i,I){let h=I&&I.get("storage.serviceMachineId",0)||null;if(h)return h;try{const y=(await i.readFile(k.serviceMachineIdResource)).value.toString();h=(0,D.isUUID)(y)?y:null}catch(f){h=null}if(!h){h=(0,D.generateUuid)();try{await i.writeFile(k.serviceMachineIdResource,p.VSBuffer.fromString(h))}catch(f){}}return I&&I.store("storage.serviceMachineId",h,0,1),h}e.getServiceMachineId=C}),define(Q[76],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[200],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{constructor(){this.validators=new Map}vsda(){return new Promise((C,k)=>j(["vsda"],C,k))}async createNewMessage(C){try{const k=await this.vsda(),i=new k.validator;if(i){const I=String(p._nextId++);return this.validators.set(I,i),{id:I,data:i.createNewMessage(C)}}}catch(k){}return{id:"",data:C}}async validate(C,k){if(!C.id)return!0;const i=this.validators.get(C.id);if(!i)return!1;this.validators.delete(C.id);try{return i.validate(k)==="ok"}catch(I){return!1}}async sign(C){try{const k=await this.vsda(),i=new k.signer;if(i)return i.sign(C)}catch(k){}return C}}e.SignService=p,p._nextId=1}),define(Q[38],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(Q[20],J([0,1,14,9,4,2,3,32,13,5,179,6,38]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,f.createDecorator)("lifecycleMainService");var w;(function(m){m[m.Starting=1]="Starting",m[m.Ready=2]="Ready",m[m.AfterWindowOpen=3]="AfterWindowOpen"})(w=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class ht extends k.Disposable{constructor(E,S){super();this.logService=E,this.stateMainService=S,this._onBeforeShutdown=this._register(new C.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new C.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new C.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new C.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new C.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._onWillKill=this._register(new C.Emitter),this.onWillKill=this._onWillKill.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ht.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ht.QUIT_AND_RESTART_KEY)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),i.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};p.app.addListener("before-quit",E);const S=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!i.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",S),p.app.once("will-quit",P=>{this.logService.trace("Lifecycle#app.on(will-quit)"),P.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",E),p.app.removeListener("window-all-closed",S),p.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(S){E.push(S)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(E)}catch(S){this.logService.error(S)}try{await this.stateMainService.close()}catch(S){this.logService.error(S)}})(),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===E)return;this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const S=this.phaseWhen.get(this._phase);S&&(S.open(),this.phaseWhen.delete(this._phase))}async when(E){if(E<=this._phase)return;let S=this.phaseWhen.get(E);S||(S=new D.Barrier,this.phaseWhen.set(E,S)),await S.wait()}registerWindow(E){const S=new k.DisposableStore;this.windowCounter++,S.add(E.onWillLoad(l=>this._onWillLoadWindow.fire({window:E,workspace:l.workspace,reason:l.reason})));const P=(0,h.assertIsDefined)(E.win);P.on("close",l=>{const c=E.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),l.preventDefault(),this.unload(E,1).then(u=>{if(u){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(E),E.close()})}),P.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,S.dispose(),this.windowCounter===0&&(!i.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(E,S){await this.unload(E,3)||E.reload(S)}async unload(E,S){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const P=this._quitRequested?2:S;let l=await this.onBeforeUnloadWindowInRenderer(E,P);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(E,P),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${E.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${E.id})`),await this.onWillUnloadWindowInRenderer(E,P),!1))}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(E,S){return new Promise(P=>{const l=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${l}`,u=`vscode:cancel${l}`;p.ipcMain.once(c,()=>{P(!1)}),p.ipcMain.once(u,()=>{P(!0)}),E.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:u,reason:S})})}onBeforeUnloadWindowInMain(E,S){const P=[];return this._onBeforeUnloadWindow.fire({reason:S,window:E,veto(l){P.push(l)}}),(0,y.handleVetos)(P,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(E,S){return new Promise(P=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(c,()=>P()),E.send("vscode:onWillUnload",{replyChannel:c,reason:S})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${E}`),E&&this.stateMainService.setItem(ht.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(S=>{this.pendingQuitPromiseResolve=S,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(E){this.logService.trace("Lifecycle#relaunch()");const S=process.argv.slice(1);if(E?.addArgs&&S.push(...E.addArgs),E?.removeArgs)for(const c of E.removeArgs){const u=S.indexOf(c);u>=0&&S.splice(u,1)}const P=()=>{try{if(i.isWindows){const c=(0,I.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.logService.error(c)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:S})};p.app.once("quit",P),await this.quit(!0)&&p.app.removeListener("quit",P)}async kill(E){this.logService.trace("Lifecycle#kill()"),this._onWillKill.fire(),await Promise.race([(0,D.timeout)(1e3),(async()=>{for(const S of p.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let P;S.webContents&&!S.webContents.isDestroyed()?P=new Promise(l=>S.once("closed",l)):P=Promise.resolve(),S.destroy(),await P}})()]),p.app.exit(E)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=he([ee(0,b.ILogService),ee(1,g.IStateMainService)],t),e.LifecycleMainService=t}),define(Q[201],J([0,1,4,2,5,20]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,C.createDecorator)("keyboardLayoutMainService");let i=class extends D.Disposable{constructor(f){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,f.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const f=await new Promise((y,b)=>{j(["native-keymap"],y,b)});this._keyboardLayoutData=I(f),f.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=I(f),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};i=he([ee(0,k.ILifecycleMainService)],i),e.KeyboardLayoutMainService=i;function I(h){const f=h.getKeyMap(),y=h.getCurrentKeyboardLayout();return{keyboardMapping:f,keyboardLayoutInfo:y}}}),define(Q[98],J([0,1,9,4,2,63,13,86,5]),function(j,e,p,D,C,k,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,h.createDecorator)("storageService");var y;(function(E){E[E.NONE=0]="NONE",E[E.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(E){E[E.GLOBAL=0]="GLOBAL",E[E.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var g;(function(E){E[E.USER=0]="USER",E[E.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class w extends C.Disposable{constructor(S={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new C.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,C.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,P){P===f?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:P,target:this.getKeyTargets(S)[P]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,P,l){return this.getStorage(P)?.get(S,l)}getBoolean(S,P,l){return this.getStorage(P)?.getBoolean(S,l)}getNumber(S,P,l){return this.getStorage(P)?.getNumber(S,l)}store(S,P,l,c){if((0,i.isUndefinedOrNull)(P)){this.remove(S,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,l,c),this.getStorage(l)?.set(S,P)})}remove(S,P){this.withPausedEmitters(()=>{this.updateKeyTarget(S,P,void 0),this.getStorage(P)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,P){const l=[],c=this.getKeyTargets(S);for(const u of Object.keys(c))c[u]===P&&l.push(u);return l}updateKeyTarget(S,P,l){const c=this.getKeyTargets(P);typeof l=="number"?c[S]!==l&&(c[S]=l,this.getStorage(P)?.set(f,JSON.stringify(c))):typeof c[S]=="number"&&(delete c[S],this.getStorage(P)?.set(f,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const P=this.get(f,S);if(P)try{return JSON.parse(P)}catch(l){}return Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(S=y.NONE){this._onWillSaveState.fire({reason:S});const P=this.getStorage(0),l=this.getStorage(1);switch(S){case y.NONE:await p.Promises.settled([P?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await p.Promises.settled([P?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async logStorage(){const S=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return m(S,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends w{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}e.InMemoryStorageService=t;async function m(E,S,P,l){const c=d=>{try{return JSON.parse(d)}catch(v){return d}},u=new Map,r=new Map;E.forEach((d,v)=>{u.set(v,d),r.set(v,c(d))});const a=new Map,s=new Map;S.forEach((d,v)=>{a.set(v,d),s.set(v,c(d))}),console.group(`Storage: Global (path: ${P})`);let n=[];u.forEach((d,v)=>{n.push({key:v,value:d})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${l})`);let o=[];a.forEach((d,v)=>{o.push({key:v,value:d})}),console.table(o),console.groupEnd(),console.log(s)}e.logStorage=m}),define(Q[202],J([0,1,3,32,7,28]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function i(f){if(p.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function I(f,y,b,g,w,t,m,E,S,P){const l=Object.create(null);l["common.machineId"]=m,l.sessionID=(0,k.generateUuid)()+Date.now(),l.commitHash=w,l.version=t,l["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,p.PlatformToString)(p.platform),l["common.nodePlatform"]=D.platform,l["common.nodeArch"]=g,l["common.product"]=P||"desktop";const c=h(E||[]);c&&(l["common.msftInternal"]=c);let u=0;const r=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),p.isLinuxSnap&&(l["common.snap"]="true");const a=i(b);a&&(l["common.platformDetail"]=a);try{const s=await f.readFile(C.URI.file(S));l["common.source"]=s.value.toString().slice(0,30)}catch(s){}return l}e.resolveCommonProperties=I;function h(f){const y=D.env.USERDNSDOMAIN;if(!y)return!1;const b=y.toLowerCase();return f.some(g=>b===g)}e.verifyMicrosoftInternalDomain=h}),define(Q[30],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[203],J([0,1,26,69,9,39,10,8,3,7,71,21,83,74,18,22,30]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function S(r,a){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],n=new Map,o=new Map,d=2e4;function v(A,W,H,Z){const ne=W.substring(A.length+1);return C.Promises.withAsyncBody(async oe=>{let G;try{G=await b.Promises.readdir(W,{withFileTypes:!0})}catch(q){oe();return}if(Z.count>=d){Z.count+=G.length,Z.maxReached=!0,oe();return}let T=G.length;if(T===0){oe();return}let z=G;Z.count+G.length>d&&(Z.maxReached=!0,T=d-Z.count,z=G.slice(0,T)),Z.count+=G.length;for(const q of z)if(q.isDirectory()){if(H.includes(q.name)||await v(A,(0,I.join)(W,q.name),H,Z),--T==0){oe();return}}else{const U=q.name.lastIndexOf(".");if(U>=0){const N=q.name.substring(U+1);N&&n.set(N,(n.get(N)??0)+1)}for(const N of s)N.relativePathPattern?.test(ne)!==!1&&N.filePattern.test(q.name)&&o.set(N.tag,(o.get(N.tag)??0)+1);if(--T==0){oe();return}}})}const M={count:0,maxReached:!1};await v(r,r,a,M);const L=await c(r);return{configFiles:P(o),fileTypes:P(n),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:L}}e.collectWorkspaceStats=S;function P(r){return[...D.Iterable.map(r.entries(),([a,s])=>({name:a,count:s}))].sort((a,s)=>s.count-a.count)}function l(){const r={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},a=p.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=l;async function c(r){try{const a=new Map,s=(0,I.join)(r,".vscode","launch.json"),n=await b.Promises.readFile(s),o=[],d=(0,k.parse)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,k.getNodeType)(d)==="object"&&d.configurations)for(const v of d.configurations){const M=v.type;M&&(a.has(M)?a.set(M,a.get(M)+1):a.set(M,1))}return P(a)}catch(a){return[]}}e.collectLaunchConfigs=c;let u=class{constructor(a,s){this.telemetryService=a,this.productService=s}formatMachineInfo(a){const s=[];return s.push(`OS Version:       ${a.os}`),s.push(`CPUs:             ${a.cpus}`),s.push(`Memory (System):  ${a.memory}`),s.push(`VM:               ${a.vmHint}`),s.join(`
`)}formatEnvironment(a){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const n=p.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),h.isWindows||s.push(`Load (avg):       ${p.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${a.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(a,s){return Promise.all([(0,g.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async n=>{let[o,d]=n,v=this.formatProcessList(a,o);return s.forEach(M=>{if((0,w.isRemoteDiagnosticError)(M))v+=`
${M.errorMessage}`,d+=`
${M.errorMessage}`;else if(v+=`

Remote: ${M.hostName}`,M.processes&&(v+=`
${this.formatProcessList(a,M.processes)}`),M.workspaceMetadata){d+=`
|  Remote: ${M.hostName}`;for(const L of Object.keys(M.workspaceMetadata)){const A=M.workspaceMetadata[L];let W=`${A.fileCount} files`;A.maxFilesReached&&(W=`more than ${W}`),d+=`|    Folder (${L}): ${W}`,d+=this.formatWorkspaceStats(A)}}}),{processInfo:v,workspaceInfo:d}})}async getSystemInfo(a,s){const{memory:n,vmHint:o,os:d,cpus:v}=l(),M={os:d,memory:n,cpus:v,vmHint:o,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:s};return h.isWindows||(M.load=`${p.loadavg().map(L=>Math.round(L)).join(", ")}`),h.isLinux&&(M.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(M)}async getDiagnostics(a,s){const n=[];return(0,g.listProcesses)(a.mainPID).then(async o=>(n.push(""),n.push(this.formatEnvironment(a)),n.push(""),n.push(this.formatProcessList(a,o)),a.windows.some(d=>d.folderURIs&&d.folderURIs.length>0&&!d.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(a))),s.forEach(d=>{if((0,w.isRemoteDiagnosticError)(d))n.push(`
${d.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${d.hostName}`),n.push(this.formatMachineInfo(d.machineInfo)),d.processes&&n.push(this.formatProcessList(a,d.processes)),d.workspaceMetadata)for(const v of Object.keys(d.workspaceMetadata)){const M=d.workspaceMetadata[v];let L=`${M.fileCount} files`;M.maxFilesReached&&(L=`more than ${L}`),n.push(`Folder (${v}): ${L}`),n.push(this.formatWorkspaceStats(M))}}),n.push(""),n.push(""),n.join(`
`)))}formatWorkspaceStats(a){const s=[],n=60;let o=0;const d=(A,W)=>{const H=` ${A}(${W})`;o+H.length>n?(s.push(v),v="|                 ",o=v.length):o+=H.length,v+=H};let v="|      File types:";const M=10;let L=a.fileTypes.length>M?M:a.fileTypes.length;for(let A=0;A<L;A++){const W=a.fileTypes[A];d(W.name,W.count)}if(s.push(v),a.configFiles.length>=0&&(v="|      Conf files:",o=0,a.configFiles.forEach(A=>{d(A.name,A.count)}),s.push(v)),a.launchConfigFiles.length>0){let A="|      Launch Configs:";a.launchConfigFiles.forEach(W=>{A+=W.count>1?` ${W.name}(${W.count})`:` ${W.name}`}),s.push(A)}return s.join(`
`)}expandGPUFeatures(a){const s=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${a[n]}`).join(`
                  `)}formatWorkspaceMetadata(a){const s=[],n=[];return a.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(d=>{const v=f.URI.revive(d);if(v.scheme===i.Schemas.file){const M=v.fsPath;n.push(S(M,["node_modules",".git"]).then(L=>{let A=`${L.fileCount} files`;L.maxFilesReached&&(A=`more than ${A}`),s.push(`|    Folder (${(0,I.basename)(M)}): ${A}`),s.push(this.formatWorkspaceStats(L))}).catch(L=>{s.push(`|      Error: Unable to collect workspace stats for folder ${M} (${L.toString()})`)}))}else s.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(a,s){const n=new Map;a.windows.forEach(d=>n.set(d.pid,d.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(a.mainPID,n,o,s,0),o.join(`
`)}formatProcessItem(a,s,n,o,d){const v=d===0;let M;v?M=o.pid===a?`${this.productService.applicationName} main`:"remote agent":(M=`${"  ".repeat(d)} ${o.name}`,o.name==="window"&&(M=`${M} (${s.get(o.pid)})`));const L=process.platform==="win32"?o.mem:p.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(L/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${M}`),Array.isArray(o.children)&&o.children.forEach(A=>this.formatProcessItem(a,s,n,A,d+1))}async reportWorkspaceStats(a){for(const{uri:s}of a.folders){const n=f.URI.revive(s);if(n.scheme!==i.Schemas.file)continue;const o=n.fsPath;try{const d=await S(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),d.fileTypes.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:v.name,count:v.count})}),d.launchConfigFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:v.name,count:v.count})}),d.configFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:v.name,count:v.count})})}catch{}}}};u=he([ee(0,E.ITelemetryService),ee(1,m.IProductService)],u),e.DiagnosticsService=u}),define(Q[204],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(k){this.appenders=k}listen(k,i){throw new Error(`Event not found: ${i}`)}call(k,i,{eventName:I,data:h}){return this.appenders.forEach(f=>f.log(I,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class D{constructor(k){this.channel=k}log(k,i){return this.channel.call("log",{eventName:k,data:i}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=D}),define(Q[65],J([0,1,43,13,19,30]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class i{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(S,P){return Promise.resolve(void 0)}publicLog2(S,P){return this.publicLog(S,P)}publicLogError(S,P){return Promise.resolve(void 0)}publicLogError2(S,P){return this.publicLogError(S,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=i,e.NullTelemetryService=new i;class I{async publicLog(S,P,l){}async publicLogError(S,P,l){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function h(E,S){return S.onDidChangeConfiguration(P=>{P.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(P.source),configurationKeys:t(P.sourceConfig)})})}e.configurationTelemetry=h;function f(E,S){return!(S.disableTelemetry||!E.enableTelemetry)}e.supportsTelemetry=f;function y(E){const S=E.getValue(k.TELEMETRY_SETTING_ID),P=E.getValue("telemetry.enableCrashReporter");if(E.getValue(k.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(S??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=y;function b(E){const S=Object.create(null),P=Object.create(null),l=Object.create(null);w(E,l);for(let c in l){c=c.length>150?c.substr(c.length-149):c;const u=l[c];typeof u=="number"?P[c]=u:typeof u=="boolean"?P[c]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${u.length}`),S[c]=u.substring(0,8191)):typeof u!="undefined"&&u!==null&&(S[c]=u)}return{properties:S,measurements:P}}e.validateTelemetryData=b;function g(E){if(!E)return"none";let S="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(l=>{E.indexOf(`${l}+`)===0&&(S=l)}),S}e.cleanRemoteAuthority=g;function w(E,S,P=0,l){if(!!E)for(let c of Object.getOwnPropertyNames(E)){const u=E[c],r=l?l+c:c;Array.isArray(u)?S[r]=(0,p.safeStringify)(u):u instanceof Date?S[r]=u.toISOString():(0,D.isObject)(u)?P<2?w(u,S,P+1,r+"."):S[r]=(0,p.safeStringify)(u):S[r]=u}}function t(E){if(!E)return[];const S=[];return m(S,"",E),S}function m(E,S,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(l=>m(E,S?`${S}.${l}`:l,P[l])):E.push(S)}}),define(Q[205],J([0,1,31,23,16,43,3,32,7,19,48,169,196,166,18,6,22,50,199,98,30,65]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const r=i.isWeb?"web":(0,b.getTargetPlatform)(i.platform,I.arch);var a;(function(V){V[V.None=0]="None",V[V.IncludeVersions=1]="IncludeVersions",V[V.IncludeFiles=2]="IncludeFiles",V[V.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",V[V.IncludeSharedAccounts=8]="IncludeSharedAccounts",V[V.IncludeVersionProperties=16]="IncludeVersionProperties",V[V.ExcludeNonValidated=32]="ExcludeNonValidated",V[V.IncludeInstallationTargets=64]="IncludeInstallationTargets",V[V.IncludeAssetUri=128]="IncludeAssetUri",V[V.IncludeStatistics=256]="IncludeStatistics",V[V.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",V[V.Unpublished=4096]="Unpublished"})(a||(a={}));function s(...V){return String(V.reduce((B,x)=>B|x,0))}var n;(function(V){V[V.Tag=1]="Tag",V[V.ExtensionId=4]="ExtensionId",V[V.Category=5]="Category",V[V.ExtensionName=7]="ExtensionName",V[V.Target=8]="Target",V[V.Featured=9]="Featured",V[V.SearchText=10]="SearchText",V[V.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},d={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},M={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class L{constructor(B=M){this.state=B}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(B,x=this.state.pageSize){return new L({...this.state,pageNumber:B,pageSize:x})}withFilter(B,...x){const te=[...this.state.criteria,...x.length?x.map(ce=>({filterType:B,value:ce})):[{filterType:B}]];return new L({...this.state,criteria:te})}withSortBy(B){return new L({...this.state,sortBy:B})}withSortOrder(B){return new L({...this.state,sortOrder:B})}withFlags(...B){return new L({...this.state,flags:B.reduce((x,te)=>x|te,0)})}withAssetTypes(...B){return new L({...this.state,assetTypes:B})}get raw(){const{criteria:B,pageNumber:x,pageSize:te,sortBy:ce,sortOrder:se,flags:ie,assetTypes:ae}=this.state;return{filters:[{criteria:B,pageNumber:x,pageSize:te,sortBy:ce,sortOrder:se}],assetTypes:ae,flags:ie}}get searchText(){const B=this.state.criteria.filter(x=>x.filterType===n.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(B=>String(B.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(V,B){const x=(V||[]).filter(te=>te.statisticName===B)[0];return x?x.value:0}function W(V){const B="Microsoft.VisualStudio.Code.Translation.";return V.files.filter(te=>te.assetType.indexOf(B)===0).reduce((te,ce)=>{const se=oe(V,ce.assetType);return se&&te.push([ce.assetType.substring(B.length),se]),te},[])}function H(V){if(V.properties){const B=V.properties.filter(ce=>ce.key===o.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=B.filter(ce=>x.test(ce.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return oe(V,o.Repository)}function Z(V){return{uri:`${V.fallbackAssetUri}/${o.VSIX}?redirect=true${V.targetPlatform?`&targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${o.VSIX}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}}function ne(V){const B=oe(V,o.Icon);if(B)return B;const x=b.DefaultIconPath;return{uri:x,fallbackUri:x}}function oe(V,B){return V.files.filter(te=>te.assetType===B)[0]?{uri:`${V.assetUri}/${B}`,fallbackUri:`${V.fallbackAssetUri}/${B}`}:null}function G(V,B){const x=V.properties?V.properties.filter(ce=>ce.key===B):[],te=x.length>0&&x[0].value;return te?te.split(",").map(ce=>(0,g.adoptToGalleryExtensionId)(ce)):[]}function T(V){const B=V.properties?V.properties.filter(x=>x.key===d.Engine):[];return B.length>0&&B[0].value||""}function z(V){const B=V.properties?V.properties.filter(te=>te.key===d.LocalizedLanguages):[],x=B.length>0&&B[0].value||"";return x?x.split(","):[]}function q(V){return V.indexOf("preview")!==-1}function U(V){return V.targetPlatform?(0,b.toTargetPlatform)(V.targetPlatform):"undefined"}function N(V){const B=(0,p.distinct)(V.versions.map(U)),x=!!V.tags?.includes(b.WEB_EXTENSION_TAG),te=B.indexOf("web");return x?te===-1&&B.push("web"):te!==-1&&B.splice(te,1),B}function _(V,B){const x=(0,b.getFallbackTargetPlarforms)(B);for(let te=0;te<V.length;te++){const ce=V[te];if(ce.version===V[te-1]?.version){let se=te;const ie=U(ce);if(ie===B)for(;se>0&&V[se-1].version===ce.version;)se--;else if(x.includes(ie))for(;se>0&&V[se-1].version===ce.version&&U(V[se-1])!==B;)se--;se!==te&&(V.splice(te,1),V.splice(se,0,ce))}}return V}e.sortExtensionVersions=_;function Y(V,B,x,te,ce){const se=N(V);let ie=V.versions[0];return ie=V.versions.find(ae=>ae.version===ie.version&&(0,b.isTargetPlatformCompatible)(U(ae),se,ce))||ie,F(V,ie,se,B,x,te)}function F(V,B,x,te,ce,se){const ie={manifest:oe(B,o.Manifest),readme:oe(B,o.Details),changelog:oe(B,o.Changelog),license:oe(B,o.License),repository:H(B),download:Z(B),icon:ne(B),coreTranslations:W(B)};return{identifier:{id:(0,g.getGalleryExtensionId)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},name:V.extensionName,version:B.version,displayName:V.displayName,publisherId:V.publisher.publisherId,publisher:V.publisher.publisherName,publisherDisplayName:V.publisher.displayName,publisherDomain:V.publisher.domain?{link:V.publisher.domain,verified:!!V.publisher.isDomainVerified}:void 0,description:V.shortDescription||"",installCount:A(V.statistics,"install"),rating:A(V.statistics,"averagerating"),ratingCount:A(V.statistics,"ratingcount"),categories:V.categories||[],tags:V.tags||[],releaseDate:Date.parse(V.releaseDate),lastUpdated:Date.parse(V.lastUpdated),allTargetPlatforms:x,assets:ie,properties:{dependencies:G(B,d.Dependency),extensionPack:G(B,d.ExtensionPack),engine:T(B),localizedLanguages:z(B),targetPlatform:U(B)},preview:q(V.flags),telemetryData:{index:(ce.pageNumber-1)*ce.pageSize+te,querySource:se}}}let R=class{constructor(B,x,te,ce,se,ie,ae,ue){this.requestService=x,this.logService=te,this.environmentService=ce,this.telemetryService=se,this.fileService=ie,this.productService=ae,this.configurationService=ue;const de=ae.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=X(ae.version,ae,this.environmentService,this.configurationService,this.fileService,B)}api(B=""){return`${this.extensionsGalleryUrl}${B}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(B,x){const te=[];let ce=new L().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,B.length).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExtensionName,...B.map(({id:ie})=>ie.toLowerCase()));B.every(ie=>!ie.version)&&(ce=ce.withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties,a.IncludeLatestVersionOnly));const{galleryExtensions:se}=await this.queryGallery(ce,r,D.CancellationToken.None);for(let ie=0;ie<se.length;ie++){const ae=se[ie];if(!ae.versions.length)continue;const ue=(0,g.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),de=B.find(ve=>(0,g.areSameExtensions)(ve,{id:ue}))?.version;if(de){const ve=ae.versions.find(Pe=>Pe.version===de);ve&&te.push(F(ae,ve,N(ae),ie,ce))}else te.push(Y(ae,ie,ce,void 0,r))}return te}async getCompatibleExtension(B,x){const te=(0,b.isIExtensionIdentifier)(B)?null:B;if(te){if((0,b.isNotWebExtensionInWebTargetPlatform)(te.allTargetPlatforms,x))return null;if(await this.isExtensionCompatible(te,x))return te}const{id:ce,uuid:se}=te?te.identifier:B;let ie=new L().withFlags(a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");se?ie=ie.withFilter(n.ExtensionId,se):ie=ie.withFilter(n.ExtensionName,ce);const{galleryExtensions:ae}=await this.queryGallery(ie,x,D.CancellationToken.None),[ue]=ae;if(!ue||!ue.versions.length)return null;const de=N(ue);if((0,b.isNotWebExtensionInWebTargetPlatform)(de,x))return null;for(let ve of ue.versions){if(!T(ve)){const Pe=await this.getEngine(ve);ve={...ve,properties:[...ve.properties||[],{key:d.Engine,value:Pe}]}}if(await this.isRawExtensionVersionCompatible(ve,de,x))return F(ue,ve,de,0,ie)}return null}async isExtensionCompatible(B,x){if(!(0,b.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,x))return!1;let te=B.properties.engine;if(!te){const ce=await this.getManifest(B,D.CancellationToken.None);if(!ce)throw new Error("Manifest was not found");te=ce.engines.vscode}return(0,w.isEngineValid)(te,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(B,x,te){if(!(0,b.isTargetPlatformCompatible)(U(B),x,te))return!1;const ce=await this.getEngine(B);return(0,w.isEngineValid)(ce,this.productService.version,this.productService.date)}async query(B,x){const te=D.CancellationToken.isCancellationToken(B)?{}:B,ce=D.CancellationToken.isCancellationToken(B)?B:x;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=te.text||"";const ie=(0,k.getOrDefault)(te,pe=>pe.pageSize,50);let ae=new L().withFlags(a.IncludeLatestVersionOnly,a.IncludeAssetUri,a.IncludeStatistics,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,ie).withFilter(n.Target,"Microsoft.VisualStudio.Code");se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,ge,be)=>(ae=ae.withFilter(n.Category,be||ge),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,ge,be)=>(ae=ae.withFilter(n.Tag,be||ge),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(n.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),ae=ae.withFilter(n.SearchText,se)),ae=ae.withSortBy(0)):te.ids?ae=ae.withFilter(n.ExtensionId,...te.ids):te.names?ae=ae.withFilter(n.ExtensionName,...te.names):ae=ae.withSortBy(4),typeof te.sortBy=="number"&&(ae=ae.withSortBy(te.sortBy)),typeof te.sortOrder=="number"&&(ae=ae.withSortOrder(te.sortOrder));const{galleryExtensions:ue,total:de}=await this.queryGallery(ae,r,ce),ve=ue.map((pe,ge)=>Y(pe,ge,ae,te.source,r)),Pe=async(pe,ge)=>{if(ge.isCancellationRequested)throw(0,C.canceled)();const be=ae.withPage(pe+1),{galleryExtensions:ke}=await this.queryGallery(be,r,ge);return ke.map((Ae,We)=>Y(Ae,We,be,te.source,r))};return{firstPage:ve,total:de,pageSize:ae.pageSize,getPage:Pe}}async queryGallery(B,x,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,a.ExcludeNonValidated).withFilter(n.ExcludeWithFlags,s(a.Unpublished));const ce=await this.commonHeadersPromise,se=JSON.stringify(B.raw),ie={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(se.length)},ae=new Date().getTime();let ue,de,ve=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:se,headers:ie},te),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ve};const Pe=await(0,S.asJson)(ue);if(Pe){const pe=Pe.results[0],ge=pe.extensions;ge.forEach(ke=>_(ke.versions,x));const be=pe.resultMetadata&&pe.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return ve=be&&be.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ve}}return{galleryExtensions:[],total:ve}}catch(Pe){throw de=Pe,Pe}finally{this.telemetryService.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(se.length),duration:new Date().getTime()-ae,success:!!ue&&(0,S.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:de?(0,C.isPromiseCanceledError)(de)?"canceled":(0,C.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(B,x,te,ce){if(!this.isEnabled())return;const se=i.isWeb?this.api(`/itemName/${B}.${x}/version/${te}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${B}/extensions/${x}/${te}/stats?statType=${ce}`),ie=i.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ie};try{await this.requestService.request({type:"POST",url:se,headers:ue},D.CancellationToken.None)}catch(de){}}async download(B,x,te){this.logService.trace("ExtensionGalleryService#download",B.identifier.id);const ce=(0,g.getGalleryExtensionTelemetryData)(B),se=new Date().getTime(),ie=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:ve}),ae=te===1?"install":te===2?"update":"",ue=ae?{uri:`${B.assets.download.uri}${h.URI.parse(B.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${B.assets.download.fallbackUri}${h.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:B.assets.download,de=await this.getAsset(ue);await this.fileService.writeFile(x,de.stream),ie(new Date().getTime()-se)}async getReadme(B,x){if(B.assets.readme){const te=await this.getAsset(B.assets.readme,{},x);return await(0,S.asText)(te)||""}return""}async getManifest(B,x){if(B.assets.manifest){const te=await this.getAsset(B.assets.manifest,{},x),ce=await(0,S.asText)(te);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(B,x){const te=oe(B,o.Manifest);if(!te)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},se=await this.getAsset(te,{headers:ce});return await(0,S.asJson)(se)}async getCoreTranslation(B,x){const te=B.assets.coreTranslations.filter(ce=>ce[0]===x.toUpperCase())[0];if(te){const ce=await this.getAsset(te[1]),se=await(0,S.asText)(ce);return se?JSON.parse(se):null}return null}async getChangelog(B,x){if(B.assets.changelog){const te=await this.getAsset(B.assets.changelog,{},x);return await(0,S.asText)(te)||""}return""}async getAllCompatibleVersions(B,x){let te=new L().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1).withFilter(n.Target,"Microsoft.VisualStudio.Code");B.identifier.uuid?te=te.withFilter(n.ExtensionId,B.identifier.uuid):te=te.withFilter(n.ExtensionName,B.identifier.id);const{galleryExtensions:ce}=await this.queryGallery(te,x,D.CancellationToken.None);if(!ce.length)return[];const se=N(ce[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(se,x))return[];const ie=[];for(const ae of ce[0].versions)try{ie[ie.length-1]?.version!==ae.version&&await this.isRawExtensionVersionCompatible(ae,se,x)&&ie.push({version:ae.version,date:ae.lastUpdated})}catch(ue){}return ie}async getAsset(B,x={},te=D.CancellationToken.None){const ce=await this.commonHeadersPromise,se={type:"GET"},ie={...ce,...x.headers||{}};x={...x,...se,headers:ie};const ae=B.uri,ue=B.fallbackUri,de={...x,url:ae};try{const ve=await this.requestService.request(de,te);if(ve.res.statusCode===200)return ve;const Pe=await(0,S.asText)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${Pe}`)}catch(ve){if((0,C.isPromiseCanceledError)(ve))throw ve;const Pe=(0,C.getErrorMessage)(ve);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:Pe});const pe={...x,url:ue};return this.requestService.request(pe,te)}}async getEngine(B){let x=T(B);if(!x){const te=await this.getManifestFromRawExtensionVersion(B,D.CancellationToken.None);if(!te)throw new Error("Manifest was not found");x=te.engines.vscode}return x}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const B=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,S.asJson)(B),te=new Map;if(x)for(const ce of x.malicious){const se=te.get(ce)||{id:{id:ce},malicious:!0,slow:!1};se.malicious=!0,te.set(ce,se)}return[...te.values()]}};R=he([ee(1,S.IRequestService),ee(2,m.ILogService),ee(3,y.IEnvironmentService),ee(4,c.ITelemetryService),ee(5,t.IFileService),ee(6,E.IProductService),ee(7,f.IConfigurationService)],R);let O=class extends R{constructor(B,x,te,ce,se,ie,ae,ue){super(B,x,te,ce,se,ie,ae,ue)}};O=he([ee(0,l.IStorageService),ee(1,S.IRequestService),ee(2,m.ILogService),ee(3,y.IEnvironmentService),ee(4,c.ITelemetryService),ee(5,t.IFileService),ee(6,E.IProductService),ee(7,f.IConfigurationService)],O),e.ExtensionGalleryService=O;let $=class extends R{constructor(B,x,te,ce,se,ie,ae){super(void 0,B,x,te,ce,se,ie,ae)}};$=he([ee(0,S.IRequestService),ee(1,m.ILogService),ee(2,y.IEnvironmentService),ee(3,c.ITelemetryService),ee(4,t.IFileService),ee(5,E.IProductService),ee(6,f.IConfigurationService)],$),e.ExtensionGalleryServiceWithNoStorageService=$;async function X(V,B,x,te,ce,se){const ie={"X-Market-Client-Id":`VSCode ${V}`,"User-Agent":`VSCode ${V}`},ae=await(0,P.getServiceMachineId)(x,ce,se);return(0,u.supportsTelemetry)(B,x)&&(0,u.getTelemetryLevel)(te)===3&&(ie["X-Market-User-Id"]=ae),ie}e.resolveMarketplaceHeaders=X}),define(Q[206],J([0,1,2,43,3,25,152,19,49,56,37,30,65]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(E,S){this._configurationService=S,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=E.appenders,this._commonProperties=E.commonProperties||Promise.resolve({}),this._piiPaths=E.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!E.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,k.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(P=>{const l=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!l})})}setExperimentProperty(E,S){this._experimentProperties[E]=S}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const E=await this._commonProperties;let S=E.sessionID,P=E["common.instanceId"],l=E["common.machineId"],c=E["common.firstSessionDate"],u=E["common.msftInternal"];return{sessionId:S,instanceId:P,machineId:l,firstSessionDate:c,msftInternal:u}}dispose(){this._disposables.dispose()}_log(E,S,P,l){return this.telemetryLevel<S?Promise.resolve(void 0):this._commonProperties.then(c=>{P=(0,D.mixin)(P,c),P=(0,D.mixin)(P,this._experimentProperties),P=(0,D.cloneAndChange)(P,u=>{if(typeof u=="string")return this._cleanupInfo(u,l)}),this._appenders.forEach(u=>u.log(E,P))},c=>{console.error(c)})}publicLog(E,S,P){return this._log(E,3,S,P)}publicLog2(E,S,P){return this.publicLog(E,S,P)}publicLogError(E,S){return this.sendErrorTelemetry?this._log(E,2,S,!0):Promise.resolve(void 0)}publicLogError2(E,S){return this.publicLogError(E,S)}_anonymizeFilePaths(E){let S=E;const P=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(E);if(!a)break;P.push([a.index,r.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(S="";;){const r=c.exec(E);if(!r)break;!l.test(r[0])&&P.every(([a,s])=>r.index<a||r.index>=s)&&(S+=E.substring(u,r.index)+"<REDACTED: user-file-path>",u=c.lastIndex)}return u<E.length&&(S+=E.substr(u)),S}_removePropertiesWithPossibleUserInfo(E){if(!E)return E;const S=E.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(S)?"<REDACTED: secret>":P.test(S)?"<REDACTED: email>":E}_cleanupInfo(E,S){let P=E;S&&(P=this._anonymizeFilePaths(P));for(let l of this._cleanupPatterns)P=P.replace(l,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=he([ee(1,I.IConfigurationService)],w),e.TelemetryService=w;function t(){const m=(0,i.localize)(0,null,f.default.nameLong),E=f.default.privacyStatementUrl?(0,i.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,i.localize)(1,null,"https://aka.ms/vscode-telemetry"),S=C.isWeb?"":(0,i.localize)(3,null),P=(0,i.localize)(4,null),l=(0,i.localize)(5,null),c=(0,i.localize)(6,null),u=(0,i.localize)(7,null),r=`
|       | ${P} | ${l} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,i.localize)(8,null);return`
${m} ${E} ${S}

&nbsp;

${u}
${r}

&nbsp;

${a}
`}y.Registry.as(h.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,i.localize)(10,null),(0,i.localize)(11,null),(0,i.localize)(12,null),(0,i.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.Registry.as(h.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,i.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,i.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,i.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[207],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Q[208],J([0,1,109,4,2,5,37,207]),function(j,e,p,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,k.createDecorator)("themeService");var h;(function(E){function S(P){return P&&typeof P=="object"&&typeof P.id=="string"}E.isThemeColor=S})(h=e.ThemeColor||(e.ThemeColor={}));function f(E){return{id:E}}e.themeColorFromId=f;var y;(function(E){function S(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||h.isThemeColor(s.color))}E.isThemeIcon=S;const P=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function l(s){const n=P.exec(s);if(!n)return;let[,o]=n;return{id:o}}E.fromString=l;function c(s,n){let o=s.id;const d=o.lastIndexOf("~");return d!==-1&&(o=o.substring(0,d)),n&&(o=`${o}~${n}`),{id:o}}E.modify=c;function u(s){const n=s.id.lastIndexOf("~");if(n!==-1)return s.id.substring(n+1)}E.getModifier=u;function r(s,n){return s.id===n.id&&s.color?.id===n.color?.id}E.isEqual=r;function a(s,n){return{id:s.id,color:n?f(n):void 0}}E.asThemeIcon=a,E.asClassNameArray=p.CSSIcon.asClassNameArray,E.asClassName=p.CSSIcon.asClassName,E.asCSSSelector=p.CSSIcon.asCSSSelector})(y=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function b(E){switch(E){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new D.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,C.toDisposable)(()=>{const P=this.themingParticipants.indexOf(S);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new g;i.Registry.add(e.Extensions.ThemingContribution,w);function t(E){return w.onColorThemeChange(E)}e.registerThemingParticipant=t;class m extends C.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,P){let l=this.theme.getColor(S);return l&&P&&(l=P(l,this.theme)),l?l.toString():null}}e.Themable=m}),define(Q[66],J([0,1,14,3,5,38]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const i="#FFFFFF",I="#1E1E1E",h="#000000",f="theme",y="themeBackground",b="windowSplash";e.IThemeMainService=(0,C.createDecorator)("themeMainService");let g=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((D.isWindows||D.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return h;let t=this.stateMainService.getItem(y,null);if(!t){let m;(D.isWindows||D.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?m="hc-black":m=this.stateMainService.getItem(f,"vs-dark").split(" ")[0],t=m==="hc-black"?h:m==="vs"?i:I}return D.isMacintosh&&t.toUpperCase()===I&&(t="#171717"),t}saveWindowSplash(t,m){this.stateMainService.setItems([{key:f,data:m.baseTheme},{key:y,data:m.colorInfo.background},{key:b,data:m}]),typeof t=="number"&&this.updateBackgroundColor(t,m)}updateBackgroundColor(t,m){for(const E of p.BrowserWindow.getAllWindows())if(E.id===t){E.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};g=he([ee(0,k.IStateMainService)],g),e.ThemeMainService=g}),define(Q[41],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var D;(function(k){k.Uninitialized="uninitialized",k.Idle="idle",k.CheckingForUpdates="checking for updates",k.AvailableForDownload="available for download",k.Downloading="downloading",k.Downloaded="downloaded",k.Updating="updating",k.Ready="ready"})(D=e.StateType||(e.StateType={}));var C;(function(k){k[k.Setup=0]="Setup",k[k.Archive=1]="Archive",k[k.Snap=2]="Snap"})(C=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(k,i)=>({type:"idle",updateType:k,error:i}),CheckingForUpdates:k=>({type:"checking for updates",explicit:k}),AvailableForDownload:k=>({type:"available for download",update:k}),Downloading:k=>({type:"downloading",update:k}),Downloaded:k=>({type:"downloaded",update:k}),Updating:k=>({type:"updating",update:k}),Ready:k=>({type:"ready",update:k})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Q[209],J([0,1,3,153,49,37]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),k.Registry.as(C.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[210],J([0,1,4,41]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class C{constructor(I){this.service=I}listen(I,h){switch(h){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${h}`)}call(I,h,f){switch(h){case"checkForUpdates":return this.service.checkForUpdates(f);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=C;class k{constructor(I){this.channel=I,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=D.State.Uninitialized,this.channel.listen("onStateChange")(h=>this.state=h),this.channel.call("_getInitialState").then(h=>this.state=h)}get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=k}),define(Q[99],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Q[211],J([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class D{constructor(I){this.handler=I}listen(I,h){throw new Error(`Event not found: ${h}`)}call(I,h,f){switch(h){case"handleURL":return this.handler.handleURL(p.URI.revive(f[0]),f[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=D;class C{constructor(I){this.channel=I}handleURL(I,h){return this.channel.call("handleURL",[I.toJSON(),h])}}e.URLHandlerChannelClient=C;class k{constructor(I){this.next=I}async routeCall(I,h,f,y){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(f){const b=p.URI.revive(f);if(b&&b.query){const g=/\bwindowId=(\d+)/.exec(b.query);if(g){const w=g[1],t=new RegExp(`window:${w}`),m=I.connections.find(E=>t.test(E.ctx));if(m)return m}}}return this.next.routeCall(I,h,f,y)}routeEvent(I,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=k}),define(Q[212],J([0,1,9,2,7,22]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class i extends D.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(f,y){const b=[...this.handlers.values()];return(0,p.first)(b.map(g=>()=>g.handleURL(f,y)),void 0,!1).then(g=>g||!1)}registerHandler(f){return this.handlers.add(f),(0,D.toDisposable)(()=>this.handlers.delete(f))}}e.AbstractURLService=i;let I=class extends i{constructor(f){super();this.productService=f}create(f){let{authority:y,path:b,query:g,fragment:w}=f||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&b&&b.indexOf("/")!==0&&(b=`/${b}`),C.URI.from({scheme:this.productService.urlProtocol,authority:y,path:b,query:g,fragment:w})}};I=he([ee(0,k.IProductService)],I),e.NativeURLService=I}),define(Q[213],J([0,1,14,9,4,2,3,7]),function(j,e,p,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function h(y){try{return I.URI.parse(y)}catch(b){return null}}class f{constructor(b,g,w,t,m){if(this.urlService=g,this.uris=[],this.retryCount=0,this.flushDisposable=k.Disposable.None,this.disposables=new k.DisposableStore,this.uris=b,i.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),p.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,P)}const E=C.Event.map(C.Event.fromNodeEventEmitter(p.app,"open-url",(P,l)=>({event:P,url:l})),({event:P,url:l})=>(P.preventDefault(),l));this.disposables.add(E(P=>{const l=h(P);!l||this.urlService.open(l,{originalUrl:P})})),w.getWindows().filter(P=>P.isReady).length>0?this.flush():C.Event.once(w.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const b=[];for(const g of this.uris)await this.urlService.open(g.uri,{originalUrl:g.url})||b.push(g);b.length!==0&&(this.uris=b,this.flushDisposable=(0,D.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=f}),define(Q[214],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Q[215],J([0,1,14,2,10,7]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class i extends D.Disposable{constructor(){super();const h=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(C.Schemas.vscodeWebview,h)}handleWebviewRequest(h,f){try{const y=k.URI.parse(h.url),b=i.validWebviewFilePaths.get(y.path);if(typeof b=="string"){const g=`vs/workbench/contrib/webview/browser/pre/${b}`,w=C.FileAccess.asFileUri(g,j);return f(decodeURIComponent(w.fsPath))}else return f({error:-10})}catch{}return f({error:-2})}}e.WebviewProtocolProvider=i,i.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Q[67],J([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(f){return!!f.workspaceUri}e.isWorkspaceToOpen=D;function C(f){return!!f.folderUri}e.isFolderToOpen=C;function k(f){return!!f.fileUri}e.isFileToOpen=k;function i(f){const y=I(f),b=f.getValue("window.menuBarVisibility");return b==="default"||y==="native"&&b==="compact"||p.isMacintosh&&p.isNative?"classic":b}e.getMenuBarVisibility=i;function I(f){if(p.isWeb)return"custom";const y=f.getValue("window");if(y){if(p.isMacintosh&&y.nativeTabs===!0||p.isMacintosh&&y.nativeFullScreen===!1)return"native";const w=f.getValue("workbench.colorCustomizations");if(w?.["window.activeBorder"]||w?.["window.inactiveBorder"])return"custom";const t=y.titleBarStyle;if(t==="native"||t==="custom")return t}return p.isLinux?"native":"custom"}e.getTitleBarStyle=I;function h(f=0){return Math.pow(1.2,f)}e.zoomLevelToZoomFactor=h}),define(Q[36],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var D;(function(f){f[f.INITIAL=1]="INITIAL",f[f.LOAD=2]="LOAD",f[f.RELOAD=3]="RELOAD"})(D=e.LoadReason||(e.LoadReason={}));var C;(function(f){f[f.CLOSE=1]="CLOSE",f[f.QUIT=2]="QUIT",f[f.RELOAD=3]="RELOAD",f[f.LOAD=4]="LOAD"})(C=e.UnloadReason||(e.UnloadReason={}));var k;(function(f){f[f.CLI=0]="CLI",f[f.DOCK=1]="DOCK",f[f.MENU=2]="MENU",f[f.DIALOG=3]="DIALOG",f[f.DESKTOP=4]="DESKTOP",f[f.API=5]="API"})(k=e.OpenContext||(e.OpenContext={}));const i=function(f=1){return{width:1024,height:768,mode:f}};e.defaultWindowState=i;var I;(function(f){f[f.Maximized=0]="Maximized",f[f.Normal=1]="Normal",f[f.Minimized=2]="Minimized",f[f.Fullscreen=3]="Fullscreen"})(I=e.WindowMode||(e.WindowMode={}));var h;(function(f){f[f.UNRESPONSIVE=1]="UNRESPONSIVE",f[f.CRASHED=2]="CRASHED",f[f.LOAD=3]="LOAD"})(h=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Q[216],J([0,1,14,4,2,215,36]),function(j,e,p,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends C.Disposable{constructor(f){super();this.windowsMainService=f,this._onFoundInFrame=this._register(new D.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new k.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(f,y){let b;if(typeof f.windowId=="number"){const{windowId:g}=f,w=this.windowsMainService.getWindowById(g);if(!w?.win)throw new Error(`Invalid windowId: ${g}`);b=w.win.webContents}else{const{webContentsId:g}=f;if(b=p.webContents.fromId(g),!b)throw new Error(`Invalid webContentsId: ${g}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(y)}async findInFrame(f,y,b,g){const w=this.getFrameByName(f,y),t=w;if(typeof t.findInFrame=="function"){t.findInFrame(b,{findNext:g.findNext,forward:g.forward});const m=(E,S)=>{S.finalUpdate&&(this._onFoundInFrame.fire(S),w.removeListener("found-in-frame",m))};w.on("found-in-frame",m)}}async stopFindInFrame(f,y,b){const w=this.getFrameByName(f,y);typeof w.stopFindInFrame=="function"&&w.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}getFrameByName(f,y){const b=this.windowsMainService.getWindowById(f.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${f}`);const g=b.win.webContents.mainFrame.framesInSubtree.find(w=>w.name===y);if(!g)throw new Error(`Unknown frame: ${y}`);return g}};I=he([ee(0,i.IWindowsMainService)],I),e.WebviewMainService=I}),define(Q[217],J([0,1,9,4,2]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class k extends C.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:h,getActiveWindowId:f}){super();this.disposables=this._register(new C.DisposableStore),D.Event.latch(D.Event.any(I,h))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>f()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch(b){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=k}),define(Q[218],J([0,1,40,15,7,5]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");var i;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(i=e.WorkbenchState||(e.WorkbenchState={}));function I(g){const w=g;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.isWorkspace=I;function h(g){const w=g;return!!(w&&typeof w=="object"&&C.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.isWorkspaceFolder=h;class f{constructor(w,t,m,E,S){this._id=w,this._transient=m,this._configuration=E,this._ignorePathCasing=S,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(w){this._id=w.id,this._configuration=w.configuration,this._transient=w.transient,this._ignorePathCasing=w._ignorePathCasing,this.folders=w.folders}get folders(){return this._folders}set folders(w){this._folders=w,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(w){this._configuration=w}getFolder(w){return w&&this._foldersMap.findSubstr(w.with({scheme:w.scheme,authority:w.authority,path:w.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const w of this.folders)this._foldersMap.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class y{constructor(w,t){this.raw=t,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,D.joinPath)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function b(g){return new y({uri:g,index:0,name:(0,D.basenameOrAuthority)(g)},{uri:g.toString()})}e.toWorkspaceFolder=b}),define(Q[27],J([0,1,33,39,78,34,10,8,3,15,7,156,5,64,218]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,b.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(T){return(typeof T=="string"?(0,I.extname)(T):(0,f.extname)(T))===m}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,g.createDecorator)("workspacesService");function S(T){return T.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function P(T){return T.hasOwnProperty("folderUri")}e.isRecentFolder=P;function l(T){return T.hasOwnProperty("fileUri")}e.isRecentFile=l;function c(T){const z=T;return typeof z?.id=="string"&&y.URI.isUri(z.uri)}e.isSingleFolderWorkspaceIdentifier=c;function u(T){if(T.configuration)return{id:T.id,configPath:T.configuration};if(T.folders.length===1)return{id:T.id,uri:T.folders[0].uri}}e.toWorkspaceIdentifier=u;function r(T){const z=T;return typeof z?.id=="string"&&y.URI.isUri(z.configPath)}e.isWorkspaceIdentifier=r;function a(T){const z=T;if(z?.uri)return{id:z.id,uri:y.URI.revive(z.uri)};const q=T;if(q?.configPath)return{id:q.id,configPath:y.URI.revive(q.configPath)};if(T?.id)return{id:T.id}}e.reviveIdentifier=a;function s(T,z){return f.extUriBiasedIgnorePathCase.isEqualOrParent(T,z.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function n(T){return o(T)||d(T)}e.isStoredWorkspaceFolder=n;function o(T){const z=T;return typeof z?.path=="string"&&(!z.name||typeof z.name=="string")}e.isRawFileWorkspaceFolder=o;function d(T){const z=T;return typeof z?.uri=="string"&&(!z.name||typeof z.name=="string")}e.isRawUriWorkspaceFolder=d;function v(T,z,q,U,N=!h.isWindows,_){if(T.scheme!==U.scheme)return{name:q,uri:T.toString(!0)};let Y=z?void 0:_.relativePath(U,T);if(Y!==void 0)Y.length===0?Y=".":h.isWindows&&T.scheme===i.Schemas.file&&!N&&(Y=Y.replace(/\//g,"\\"));else if(T.scheme===i.Schemas.file)Y=T.fsPath,h.isWindows&&(Y=(0,k.normalizeDriveLetter)(Y),N&&(Y=(0,p.toSlashes)(Y)));else{if(!_.isEqualAuthority(T.authority,U.authority))return{name:q,uri:T.toString(!0)};Y=T.path}return{name:q,path:Y}}e.getStoredWorkspaceFolder=v;function M(T,z,q){let U=[],N=new Set;const _=q.dirname(z);for(let Y of T){let F;if(o(Y))Y.path&&(F=q.resolvePath(_,Y.path));else if(d(Y))try{F=y.URI.parse(Y.uri),F.path[0]!=="/"&&(F=F.with({path:"/"+F.path}))}catch(R){console.warn(R)}if(F){let R=q.getComparisonKey(F);if(!N.has(R)){N.add(R);const O=Y.name||q.basenameOrAuthority(F);U.push(new t.WorkspaceFolder({uri:F,name:O,index:U.length},Y))}}}return U}e.toWorkspaceFolders=M;function L(T,z,q,U,N){let _=A(z,T);const Y=N.dirname(z),F=N.dirname(U),R=[],O=W(_.folders);for(const B of _.folders){const x=o(B)?N.resolvePath(Y,B.path):y.URI.parse(B.uri);let te;q?te=!1:te=!o(B)||(0,I.isAbsolute)(B.path),R.push(v(x,te,B.name,F,O,N))}const $={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},X=C.setProperty(T,["folders"],R,$);let V=C.applyEdits(T,X);return(0,f.isEqualAuthority)(_.remoteAuthority,(0,w.getRemoteAuthority)(U))&&(V=C.applyEdits(V,C.removeProperty(V,["remoteAuthority"],$))),V}e.rewriteWorkspaceFileForNewLocation=L;function A(T,z){let q=D.parse(z);if(q&&Array.isArray(q.folders))q.folders=q.folders.filter(U=>n(U));else throw new Error(`${T} looks like an invalid workspace file.`);return q}function W(T){return h.isWindows?T.some(z=>o(z)&&z.path.indexOf("/")>=0):!0}e.useSlashForPath=W;function H(T){return T.workspace&&typeof T.workspace=="object"&&typeof T.workspace.id=="string"&&typeof T.workspace.configPath=="string"}function Z(T){return typeof T.folderUri=="string"}function ne(T){return typeof T.fileUri=="string"}function oe(T,z){const q={workspaces:[],files:[]};if(T){const U=function(_,Y){for(let F=0;F<_.length;F++)try{Y(_[F],F)}catch(R){z.warn(`Error restoring recent entry ${JSON.stringify(_[F])}: ${R.toString()}. Skip entry.`)}},N=T;if(Array.isArray(N.entries))U(N.entries,_=>{const Y=_.label,F=_.remoteAuthority;H(_)?q.workspaces.push({label:Y,remoteAuthority:F,workspace:{id:_.workspace.id,configPath:y.URI.parse(_.workspace.configPath)}}):Z(_)?q.workspaces.push({label:Y,remoteAuthority:F,folderUri:y.URI.parse(_.folderUri)}):ne(_)&&q.files.push({label:Y,remoteAuthority:F,fileUri:y.URI.parse(_.fileUri)})});else{const _=T;Array.isArray(_.workspaces3)&&U(_.workspaces3,(Y,F)=>{const R=Array.isArray(_.workspaceLabels)&&_.workspaceLabels[F]||void 0;typeof Y=="object"&&typeof Y.id=="string"&&typeof Y.configURIPath=="string"?q.workspaces.push({label:R,workspace:{id:Y.id,configPath:y.URI.parse(Y.configURIPath)}}):typeof Y=="string"&&q.workspaces.push({label:R,folderUri:y.URI.parse(Y)})}),Array.isArray(_.files2)&&U(_.files2,(Y,F)=>{const R=Array.isArray(_.fileLabels)&&_.fileLabels[F]||void 0;typeof Y=="string"&&q.files.push({label:R,fileUri:y.URI.parse(Y)})})}}return q}e.restoreRecentlyOpened=oe;function G(T){const z={entries:[]};for(const q of T.workspaces)P(q)?z.entries.push({folderUri:q.folderUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority}):z.entries.push({workspace:{id:q.workspace.id,configPath:q.workspace.configPath.toString()},label:q.label,remoteAuthority:q.remoteAuthority});for(const q of T.files)z.entries.push({fileUri:q.fileUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority});return z}e.toStoreData=G}),define(Q[51],J([0,1,5,27]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService");function C(k){const i=k;return i&&(0,D.isWorkspaceIdentifier)(i.workspace)}e.isWorkspaceBackupInfo=C}),define(Q[52],J([0,1,14,9,81,34,2,70,8,3,13,21,136,5,6,38,27]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,w.createDecorator)("dialogMainService");let S=class wt{constructor(l,c){this.stateMainService=l,this.logService=c,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(l,c){return this.doPick({...l,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},c)}pickFolder(l,c){return this.doPick({...l,pickFolders:!0,title:(0,g.localize)(1,null)},c)}pickFile(l,c){return this.doPick({...l,pickFiles:!0,title:(0,g.localize)(2,null)},c)}pickWorkspace(l,c){const u=(0,g.localize)(3,null),r=(0,k.mnemonicButtonLabel)((0,g.localize)(4,null)),a=E.WORKSPACE_FILTER;return this.doPick({...l,pickFiles:!0,title:u,filters:a,buttonLabel:r},c)}async doPick(l,c){const u={title:l.title,buttonLabel:l.buttonLabel,filters:l.filters};u.defaultPath=l.defaultPath||this.stateMainService.getItem(wt.workingDirPickerStorageKey),(typeof l.pickFiles=="boolean"||typeof l.pickFolders=="boolean")&&(u.properties=void 0,l.pickFiles&&l.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",l.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&u.properties.push("treatPackageAsDirectory");const r=c||p.BrowserWindow.getFocusedWindow(),a=await this.showOpenDialog(u,(0,y.withNullAsUndefined)(r));if(a&&a.filePaths&&a.filePaths.length>0)return this.stateMainService.setItem(wt.workingDirPickerStorageKey,(0,h.dirname)(a.filePaths[0])),a.filePaths}getWindowDialogQueue(l){if(l){let c=this.windowDialogQueues.get(l.id);return c||(c=new D.Queue,this.windowDialogQueues.set(l.id,c)),c}else return this.noWindowDialogueQueue}showMessageBox(l,c){return this.getWindowDialogQueue(c).queue(async()=>c?p.dialog.showMessageBox(c,l):p.dialog.showMessageBox(l))}async showSaveDialog(l,c){const u=this.acquireFileDialogLock(l,c);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(c).queue(async()=>{let r;return c?r=await p.dialog.showSaveDialog(c,l):r=await p.dialog.showSaveDialog(l),r.filePath=this.normalizePath(r.filePath),r})}finally{(0,i.dispose)(u)}}normalizePath(l){return l&&f.isMacintosh&&(l=(0,I.normalizeNFC)(l)),l}normalizePaths(l){return l.map(c=>this.normalizePath(c))}async showOpenDialog(l,c){l.defaultPath&&(await b.Promises.exists(l.defaultPath)||(l.defaultPath=void 0));const u=this.acquireFileDialogLock(l,c);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(c).queue(async()=>{let r;return c?r=await p.dialog.showOpenDialog(c,l):r=await p.dialog.showOpenDialog(l),r.filePaths=this.normalizePaths(r.filePaths),r})}finally{(0,i.dispose)(u)}}acquireFileDialogLock(l,c){if(!c)return i.Disposable.None;let u=this.windowFileDialogLocks.get(c.id);u||(u=new Set,this.windowFileDialogLocks.set(c.id,u));const r=(0,C.hash)(l);if(!u.has(r))return u.add(r),(0,i.toDisposable)(()=>{u?.delete(r),u?.size===0&&this.windowFileDialogLocks.delete(c.id)})}};S.workingDirPickerStorageKey="pickerWorkingDir",S=he([ee(0,m.IStateMainService),ee(1,t.ILogService)],S),e.DialogMainService=S}),define(Q[219],J([0,1,4,2,27]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class k extends D.Disposable{constructor(I,h){super();this.logService=I,this.storageMainService=h,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(I,h)=>(I?I.push(h):I=[h],I),k.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(I))}))}serializeGlobalStorageEvents(I){const h=new Map,f=new Set;return I.forEach(y=>{const b=this.storageMainService.globalStorage.get(y.key);typeof b=="string"?h.set(y.key,b):f.add(y.key)}),{changed:Array.from(h.entries()),deleted:Array.from(f.values())}}listen(I,h){switch(h){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${h}`)}async call(I,h,f){const y=(0,C.reviveIdentifier)(f.workspace),b=await this.withStorageInitialized(y);switch(h){case"getItems":return Array.from(b.items.entries());case"updateItems":{const g=f;if(g.insert)for(const[w,t]of g.insert)b.set(w,t);g.delete&&g.delete.forEach(w=>b.delete(w));break}case"close":{if(y)return b.close();break}default:throw new Error(`Call not found: ${h}`)}}async withStorageInitialized(I){const h=I?this.storageMainService.workspaceStorage(I):this.storageMainService.globalStorage;try{await h.init()}catch(f){this.logService.error(`StorageIPC#init: Unable to init ${I?"workspace":"global"} storage due to ${f}`)}return h}}e.StorageDatabaseChannel=k,k.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[220],J([0,1,4,2,8,28,21,86,126,6,98,30,27]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class w extends D.Disposable{constructor(S){super();this.logService=S,this._onDidChangeStorage=this._register(new p.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new p.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const S=await this.doCreate();this.storage.dispose(),this.storage=S,this._register(S.onDidChangeStorage(l=>this._onDidChangeStorage.fire({key:l}))),await this.doInit(S);const P=S.getBoolean(y.IS_NEW_KEY);P===void 0?S.set(y.IS_NEW_KEY,!0):P&&S.set(y.IS_NEW_KEY,!1)}catch(S){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${S}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===f.LogLevel.Trace?S=>this.logService.trace(S):void 0,logError:S=>this.logService.error(S)}}doInit(S){return S.init()}get items(){return this.storage.items}get(S,P){return this.storage.get(S,P)}set(S,P){return this.storage.set(S,P)}delete(S){return this.storage.delete(S)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class t extends w{constructor(S,P,l){super(P);this.options=S,this.environmentService=l}async doCreate(){let S;return this.options.useInMemoryStorage?S=h.SQLiteStorageDatabase.IN_MEMORY_PATH:S=(0,C.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new I.Storage(new h.SQLiteStorageDatabase(S,{logging:this.createLoggingOptions()}))}async doInit(S){await super.doInit(S),this.updateTelemetryState(S)}updateTelemetryState(S){S.get(b.instanceStorageKey,void 0)===void 0&&S.set(b.instanceStorageKey,(0,k.generateUuid)()),S.get(b.firstSessionDateStorageKey,void 0)===void 0&&S.set(b.firstSessionDateStorageKey,new Date().toUTCString());const c=S.get(b.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();S.set(b.lastSessionDateStorageKey,typeof c=="undefined"?null:c),S.set(b.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class m extends w{constructor(S,P,l,c){super(l);this.workspace=S,this.options=P,this.environmentService=c}async doCreate(){const{storageFilePath:S,wasCreated:P}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new h.SQLiteStorageDatabase(S,{logging:this.createLoggingOptions()}),{hint:P?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:h.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const S=(0,C.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),P=(0,C.join)(S,m.WORKSPACE_STORAGE_NAME);return await i.Promises.exists(S)?{storageFilePath:P,wasCreated:!1}:(await i.Promises.mkdir(S,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(S),{storageFilePath:P,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(S){let P;if((0,g.isSingleFolderWorkspaceIdentifier)(this.workspace)?P={folder:this.workspace.uri.toString()}:(0,g.isWorkspaceIdentifier)(this.workspace)&&(P={workspace:this.workspace.configPath.toString()}),P)try{const l=(0,C.join)(S,m.WORKSPACE_META_NAME);await i.Promises.exists(l)||await i.Promises.writeFile(l,JSON.stringify(P,void 0,2))}catch(l){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=m,m.WORKSPACE_STORAGE_NAME="state.vscdb",m.WORKSPACE_META_NAME="workspace.json"}),define(Q[100],J([0,1,42,2,48,5,20,6,220]),function(j,e,p,D,C,k,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,k.createDecorator)("storageMainService");let f=class extends D.Disposable{constructor(b,g,w){super();this.logService=b,this.environmentService=g,this.lifecycleMainService=w,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async b=>{b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{b.join(this.globalStorage.close());for(const[,g]of this.mapWorkspaceToStorage)b.join(g.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const b=new h.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),b}createWorkspaceStorage(b){return new h.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(b){let g=this.mapWorkspaceToStorage.get(b.id);return g||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),g=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,g),(0,p.once)(g.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),g}};f=he([ee(0,I.ILogService),ee(1,C.IEnvironmentService),ee(2,i.ILifecycleMainService)],f),e.StorageMainService=f}),define(Q[101],J([0,1,15,7,27]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function k(h,f,y){for(const g of h){const w=g.openedWorkspace;if((0,C.isWorkspaceIdentifier)(w)){const t=y(w);if(t){if(t.folders.some(m=>p.extUriBiasedIgnorePathCase.isEqualOrParent(f,m.uri)))return g}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(f,w.configPath))return g}}const b=h.filter(g=>(0,C.isSingleFolderWorkspaceIdentifier)(g.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(f,g.openedWorkspace.uri));if(b.length)return b.sort((g,w)=>-(g.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=k;function i(h,f){for(const y of h)if((0,C.isWorkspaceIdentifier)(y.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.configPath,f)||(0,C.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(y.openedWorkspace.uri,f))return y}e.findWindowOnWorkspaceOrFolder=i;function I(h,f){const y=b=>f.some(g=>p.extUriBiasedIgnorePathCase.isEqual(D.URI.file(g),D.URI.file(b)));for(const b of h)if(b.config?.extensionDevelopmentPath?.some(g=>y(g)))return b}e.findWindowOnExtensionDevelopmentPath=I}),define(Q[221],J([0,1,14,2,3,15,7,19,20,6,38,36,27]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class pt extends D.Disposable{constructor(l,c,u,r,a){super();this.windowsMainService=l,this.stateMainService=c,this.lifecycleMainService=u,this.logService=r,this.configurationService=a,this._state=t(this.stateMainService.getItem(pt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(l=>this.onBeforeCloseWindow(l)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(l=>{l.newCount-l.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(l=>this.onBeforeCloseWindow(l))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(a=>!a.isExtensionDevelopmentHost)),r&&(l.lastActiveWindow=this.toWindowState(r))}const c=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);c&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(c)),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>this.toWindowState(r)));const u=E(l);this.stateMainService.setItem(pt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(l){if(this.lifecycleMainService.quitRequested)return;const c=this.toWindowState(l);l.isExtensionDevelopmentHost&&!l.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=c:!l.isExtensionDevelopmentHost&&l.openedWorkspace&&this._state.openedWindows.forEach(u=>{const r=(0,g.isWorkspaceIdentifier)(l.openedWorkspace)&&u.workspace?.id===l.openedWorkspace.id,a=(0,g.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)&&u.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(u.folderUri,l.openedWorkspace.uri);(r||a)&&(u.uiState=c.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=c)}toWindowState(l){return{workspace:(0,g.isWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace:void 0,folderUri:(0,g.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace.uri:void 0,backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.serializeWindowState()}}getNewWindowState(l){const c=this.doGetNewWindowState(l),u=this.configurationService.getValue("window");let r;return c.hasDefaultState?r=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(r=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),r&&C.isMacintosh&&this.windowsMainService.getWindows().some(a=>a.isFullScreen)&&(r=!1)),c.mode===3&&!r&&(c.mode=1),c}doGetNewWindowState(l){const c=this.windowsMainService.getLastActiveWindow();if(!l.extensionTestsPath){if(!!l.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=l.workspace;if((0,g.isWorkspaceIdentifier)(o)){const v=this.state.openedWindows.filter(M=>M.workspace&&M.workspace.id===o.id).map(M=>M.uiState);if(v.length)return v[0]}if((0,g.isSingleFolderWorkspaceIdentifier)(o)){const v=this.state.openedWindows.filter(M=>M.folderUri&&k.extUriBiasedIgnorePathCase.isEqual(M.folderUri,o.uri)).map(M=>M.uiState);if(v.length)return v[0]}else if(l.backupPath){const v=this.state.openedWindows.filter(M=>M.backupPath===l.backupPath).map(M=>M.uiState);if(v.length)return v[0]}const d=this.lastClosedState||this.state.lastActiveWindow;if(!c&&d)return d.uiState}let u;const r=p.screen.getAllDisplays();if(r.length===1)u=r[0];else{if(C.isMacintosh){const o=p.screen.getCursorScreenPoint();u=p.screen.getDisplayNearestPoint(o)}!u&&c&&(u=p.screen.getDisplayMatching(c.getBounds())),u||(u=p.screen.getPrimaryDisplay()||r[0])}let a=(0,b.defaultWindowState)();a.x=Math.round(u.bounds.x+u.bounds.width/2-a.width/2),a.y=Math.round(u.bounds.y+u.bounds.height/2-a.height/2);const s=this.configurationService.getValue("window");let n=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")a.mode=0,n=!1;else if(s.newWindowDimensions==="fullscreen")a.mode=3,n=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&c){const o=c.serializeWindowState();o.mode===3?a.mode=3:a=o,n=a.mode!==3&&s.newWindowDimensions==="offset"}}return n&&(a=this.ensureNoOverlap(a)),a.hasDefaultState=!0,a}ensureNoOverlap(l){if(this.windowsMainService.getWindows().length===0)return l;l.x=typeof l.x=="number"?l.x:0,l.y=typeof l.y=="number"?l.y:0;const c=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;c.some(u=>u.x===l.x||u.y===l.y);)l.x+=30,l.y+=30;return l}};w.windowsStateStorageKey="windowsState",w=he([ee(0,b.IWindowsMainService),ee(1,y.IStateMainService),ee(2,h.ILifecycleMainService),ee(3,f.ILogService),ee(4,I.IConfigurationService)],w),e.WindowsStateHandler=w;function t(P){const l={openedWindows:[]},c=P||{openedWindows:[]};return c.lastActiveWindow&&(l.lastActiveWindow=m(c.lastActiveWindow)),c.lastPluginDevelopmentHostWindow&&(l.lastPluginDevelopmentHostWindow=m(c.lastPluginDevelopmentHostWindow)),Array.isArray(c.openedWindows)&&(l.openedWindows=c.openedWindows.map(u=>m(u))),l}e.restoreWindowsState=t;function m(P){const l={uiState:P.uiState};return P.backupPath&&(l.backupPath=P.backupPath),P.remoteAuthority&&(l.remoteAuthority=P.remoteAuthority),P.folder&&(l.folderUri=i.URI.parse(P.folder)),P.workspaceIdentifier&&(l.workspace={id:P.workspaceIdentifier.id,configPath:i.URI.parse(P.workspaceIdentifier.configURIPath)}),l}function E(P){return{lastActiveWindow:P.lastActiveWindow&&S(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&S(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(l=>S(l))}}e.getWindowsStateStoreData=E;function S(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(Q[102],J([0,1,61,29,10,3,15]),function(j,e,p,D,C,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function I(f){function y(){let b=f.scheme===C.Schemas.file?(0,i.originalFSPath)(f):f.toString();return k.isLinux||(b=b.toLowerCase()),(0,p.createHash)("md5").update(b).digest("hex")}return{id:y(),configPath:f}}e.getWorkspaceIdentifier=I;function h(f,y){function b(){if(f.scheme!==C.Schemas.file)return(0,p.createHash)("md5").update(f.toString()).digest("hex");if(!y)try{y=(0,D.statSync)(f.fsPath)}catch(t){return}let w;return k.isLinux?w=y.ino:k.isMacintosh?w=y.birthtime.getTime():k.isWindows&&(typeof y.birthtimeMs=="number"?w=Math.floor(y.birthtimeMs):w=y.birthtime.getTime()),(0,p.createHash)("md5").update(f.fsPath).update(w?String(w):"").digest("hex")}const g=b();if(typeof g=="string")return{id:g,uri:f}}e.getSingleFolderWorkspaceIdentifier=h}),define(Q[222],J([0,1,16,10,6,250,113,20]),function(j,e,p,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class h{constructor(g,w){this._worker=new k.Worker(D.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",j).fsPath),this._worker.on("message",g),this._worker.on("error",w)}getId(){return 1}postMessage(g,w){this._worker.postMessage(g,w)}dispose(){this._worker.terminate()}}let f=class{constructor(g){this._logService=g}async logInfo(g){this._logService.info(g)}};f=he([ee(0,C.ILogService)],f);let y=class{constructor(g,w){this._logService=g,this._shutdown=!1,this._proxy=null;const t={create:(m,E,S)=>{const P=new h(E,S);return P.postMessage(m,[]),P}};this._worker=new i.SimpleWorkerClient(t,"vs/platform/extensions/node/extensionHostStarterWorker",new f(this._logService)),this._initialize(),w.onWillShutdown(m=>{this._shutdown=!0,this._proxy&&m.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(g){return this._proxy.onDynamicStdout(g)}onDynamicStderr(g){return this._proxy.onDynamicStderr(g)}onDynamicMessage(g){return this._proxy.onDynamicMessage(g)}onDynamicError(g){return this._proxy.onDynamicError(g)}onDynamicExit(g){return this._proxy.onDynamicExit(g)}async createExtensionHost(){const g=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return g.createExtensionHost()}async start(g,w){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return t.start(g,w)}async enableInspectPort(g){const w=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return w.enableInspectPort(g)}async kill(g){const w=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return w.kill(g)}};y=he([ee(0,C.ILogService),ee(1,I.ILifecycleMainService)],y),e.WorkerMainProcessExtensionHostStarter=y}),define(Q[58],J([0,1,61,62,26,17,16,4,2,8,3,28,35,84,223]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(v){this.socket=v,this._errorListener=M=>{if(M){if(M.code==="EPIPE")return;(0,i.onUnexpectedError)(M)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(v){const M=L=>v(k.VSBuffer.wrap(L));return this.socket.on("data",M),{dispose:()=>this.socket.off("data",M)}}onClose(v){const M=L=>{v({type:0,hadError:L,error:void 0})};return this.socket.on("close",M),{dispose:()=>this.socket.off("close",M)}}onEnd(v){return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(v){if(!this.socket.destroyed)try{this.socket.write(v.buffer,M=>{if(M){if(M.code==="EPIPE")return;(0,i.onUnexpectedError)(M)}})}catch(M){if(M.code==="EPIPE")return;(0,i.onUnexpectedError)(M)}}end(){this.socket.end()}drain(){return new Promise((v,M)=>{if(this.socket.bufferSize===0){v();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),v()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.NodeSocket=m;var E;(function(d){d[d.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var S;(function(d){d[d.PeekHeader=1]="PeekHeader",d[d.ReadHeader=2]="ReadHeader",d[d.ReadBody=3]="ReadBody",d[d.Fin=4]="Fin"})(S||(S={}));class P extends h.Disposable{constructor(v,M,L,A){super();this._onDidZlibFlush=this._register(new I.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=v,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=M,this._recordInflateBytes=A,M?(this._zlibInflate=t.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",W=>{console.error(W),(0,i.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})}),this._zlibInflate.on("data",W=>{this._pendingInflateData.push(W)}),L&&(this._zlibInflate.write(L.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",W=>{console.error(W),(0,i.onUnexpectedError)(W),this._onClose.fire({type:0,hadError:!0,error:W})}),this._zlibDeflate.on("data",W=>{this._pendingDeflateData.push(W)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new w.ChunkStream,this._register(this.socket.onData(W=>this._acceptChunk(W))),this._register(this.socket.onClose(W=>this._onClose.fire(W)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._totalOutgoingDataBytes+=v.byteLength,this._zlibDeflate?(this._zlibDeflate.write(v.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let M=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,M=M.slice(0,M.length-4),this._isEnded||this._write(k.VSBuffer.wrap(M),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(v,!1)}_write(v,M){let L=2;v.byteLength<126?L+=0:v.byteLength<2**16?L+=2:L+=8;const A=k.VSBuffer.alloc(L);if(M?A.writeUInt8(194,0):A.writeUInt8(130,0),v.byteLength<126)A.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){A.writeUInt8(126,1);let W=1;A.writeUInt8(v.byteLength>>>8&255,++W),A.writeUInt8(v.byteLength>>>0&255,++W)}else{A.writeUInt8(127,1);let W=1;A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(0,++W),A.writeUInt8(v.byteLength>>>24&255,++W),A.writeUInt8(v.byteLength>>>16&255,++W),A.writeUInt8(v.byteLength>>>8&255,++W),A.writeUInt8(v.byteLength>>>0&255,++W)}this._totalOutgoingWireBytes+=A.byteLength+v.byteLength,this.socket.write(k.VSBuffer.concat([A,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._totalIncomingWireBytes+=v.byteLength,this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const M=this._incomingData.peek(this._state.readLen),L=M.readUInt8(0),A=(L&128)>>>7,W=(L&64)>>>6,H=M.readUInt8(1),Z=(H&128)>>>7,ne=H&127;this._state.state=2,this._state.readLen=2+(Z?4:0)+(ne===126?2:0)+(ne===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(W)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const M=this._incomingData.read(this._state.readLen),L=M.readUInt8(1),A=(L&128)>>>7;let W=L&127,H=1;W===126?W=M.readUInt8(++H)*2**8+M.readUInt8(++H):W===127&&(W=M.readUInt8(++H)*0+M.readUInt8(++H)*0+M.readUInt8(++H)*0+M.readUInt8(++H)*0+M.readUInt8(++H)*2**24+M.readUInt8(++H)*2**16+M.readUInt8(++H)*2**8+M.readUInt8(++H));let Z=0;A&&(Z=M.readUInt8(++H)*2**24+M.readUInt8(++H)*2**16+M.readUInt8(++H)*2**8+M.readUInt8(++H)),this._state.state=3,this._state.readLen=W,this._state.mask=Z}else if(this._state.state===3){const M=this._incomingData.read(this._state.readLen);l(M,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(M.buffer)),this._zlibInflate.write(M.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const L=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=L.length,this._onData.fire(k.VSBuffer.wrap(L))})):(this._totalIncomingDataBytes+=M.byteLength,this._onData.fire(M))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await I.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=P;function l(d,v){if(v===0)return;let M=d.byteLength>>>2;for(let ne=0;ne<M;ne++){const oe=d.readUInt32BE(ne*4);d.writeUInt32BE(oe^v,ne*4)}let L=M*4,A=d.byteLength-L;const W=v>>>24&255,H=v>>>16&255,Z=v>>>8&255;A>=1&&d.writeUInt8(d.readUInt8(L)^W,L),A>=2&&d.writeUInt8(d.readUInt8(L+1)^H,L+1),A>=3&&d.writeUInt8(d.readUInt8(L+2)^Z,L+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function u(){const d=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${d}-sock`;let v;return e.XDG_RUNTIME_DIR?v=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${d}.sock`):v=(0,f.join)((0,C.tmpdir)(),`vscode-ipc-${d}.sock`),a(v),v}e.createRandomIPCHandle=u;function r(d,v,M){const L=(0,p.createHash)("md5").update(d).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${M}-${v}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-${L.substr(0,8)}-${M}-${v}.sock`):A=(0,f.join)(d,`${M}-${v}.sock`),a(A),A}e.createStaticIPCHandle=r;function a(d){const v=c[y.platform];typeof v=="number"&&d.length>=v&&console.warn(`WARNING: IPC handle "${d}" is longer than ${v} chars, try a shorter --user-data-dir`)}class s extends g.IPCServer{constructor(v){super(s.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const M=I.Event.fromNodeEventEmitter(v,"connection");return I.Event.map(M,L=>({protocol:new w.Protocol(new m(L)),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(L,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function n(d){return new Promise((v,M)=>{const L=(0,D.createServer)();L.on("error",M),L.listen(d,()=>{L.removeListener("error",M),v(new s(L))})})}e.serve=n;function o(d,v){return new Promise((M,L)=>{const A=(0,D.createConnection)(d,()=>{A.removeListener("error",L),M(w.Client.fromSocket(new m(A),v))});A.once("error",L)})}e.connect=o}),define(Q[224],J([0,1,58]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class D{constructor(h){this.driver=h}listen(h,f){throw new Error("No event found")}call(h,f,y){switch(f){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(y);case"reloadWindow":return this.driver.reloadWindow(y);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(y[0],y[1]);case"click":return this.driver.click(y[0],y[1],y[2],y[3]);case"doubleClick":return this.driver.doubleClick(y[0],y[1]);case"setValue":return this.driver.setValue(y[0],y[1],y[2]);case"getTitle":return this.driver.getTitle(y[0]);case"isActiveElement":return this.driver.isActiveElement(y[0],y[1]);case"getElements":return this.driver.getElements(y[0],y[1],y[2]);case"getElementXY":return this.driver.getElementXY(y[0],y[1],y[2]);case"typeInEditor":return this.driver.typeInEditor(y[0],y[1],y[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(y[0],y[1]);case"writeInTerminal":return this.driver.writeInTerminal(y[0],y[1],y[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(y);case"getLocalizedStrings":return this.driver.getLocalizedStrings(y)}throw new Error(`Call not found: ${f}`)}}e.DriverChannel=D;class C{constructor(h){this.channel=h}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(h){return this.channel.call("capturePage",h)}reloadWindow(h){return this.channel.call("reloadWindow",h)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(h,f){return this.channel.call("dispatchKeybinding",[h,f])}click(h,f,y,b){return this.channel.call("click",[h,f,y,b])}doubleClick(h,f){return this.channel.call("doubleClick",[h,f])}setValue(h,f,y){return this.channel.call("setValue",[h,f,y])}getTitle(h){return this.channel.call("getTitle",[h])}isActiveElement(h,f){return this.channel.call("isActiveElement",[h,f])}getElements(h,f,y){return this.channel.call("getElements",[h,f,y])}getElementXY(h,f,y,b){return this.channel.call("getElementXY",[h,f,y,b])}typeInEditor(h,f,y){return this.channel.call("typeInEditor",[h,f,y])}getTerminalBuffer(h,f){return this.channel.call("getTerminalBuffer",[h,f])}writeInTerminal(h,f,y){return this.channel.call("writeInTerminal",[h,f,y])}getLocaleInfo(h){return this.channel.call("getLocaleInfo",h)}getLocalizedStrings(h){return this.channel.call("getLocalizedStrings",h)}}e.DriverChannelClient=C;class k{constructor(h){this.registry=h}listen(h,f){throw new Error(`Event not found: ${f}`)}call(h,f,y){switch(f){case"registerWindowDriver":return this.registry.registerWindowDriver(y);case"reloadWindowDriver":return this.registry.reloadWindowDriver(y)}throw new Error(`Call not found: ${f}`)}}e.WindowDriverRegistryChannel=k;async function i(I){const h=await(0,p.connect)(I,"driverClient"),f=h.getChannel("driver"),y=new C(f);return{client:h,driver:y}}e.connect=i}),define(Q[225],J([0,1,9,4,106,59,2,3,35,58,160,224,178,20,36]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function m(P){return P<21}let E=class{constructor(l,c,u,r){this.windowServer=l,this.options=c,this.windowsMainService=u,this.lifecycleMainService=r,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new D.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const c=this.windowsMainService.getWindowById(l);if(!c?.win)throw new Error("Invalid window");return(await c.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const c=this.windowsMainService.getWindowById(l);if(!c)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(c)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(l,c){await this.whenUnfrozen(l);const u=C.KeybindingParser.parseUserBinding(c);for(let r of u)await this._dispatchKeybinding(l,r)}async _dispatchKeybinding(l,c){if(c instanceof k.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const u=this.windowsMainService.getWindowById(l);if(!u?.win)throw new Error("Invalid window");const r=u.win.webContents,a=new k.SimpleKeybinding(!1,!1,!1,!1,c.keyCode),n=new g.USLayoutResolvedKeybinding(a.toChord(),I.OS).getElectronAccelerator(),o=[];c.ctrlKey&&o.push("ctrl"),c.metaKey&&o.push("meta"),c.shiftKey&&o.push("shift"),c.altKey&&o.push("alt"),r.sendInputEvent({type:"keyDown",keyCode:n,modifiers:o}),m(c.keyCode)||r.sendInputEvent({type:"char",keyCode:n,modifiers:o}),r.sendInputEvent({type:"keyUp",keyCode:n,modifiers:o}),await(0,p.timeout)(100)}async click(l,c,u,r){await(await this.getWindowDriver(l)).click(c,u,r)}async doubleClick(l,c){await(await this.getWindowDriver(l)).doubleClick(c)}async setValue(l,c,u){await(await this.getWindowDriver(l)).setValue(c,u)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,c){return await(await this.getWindowDriver(l)).isActiveElement(c)}async getElements(l,c,u){return await(await this.getWindowDriver(l)).getElements(c,u)}async getElementXY(l,c,u,r){return await(await this.getWindowDriver(l)).getElementXY(c,u,r)}async typeInEditor(l,c,u){await(await this.getWindowDriver(l)).typeInEditor(c,u)}async getTerminalBuffer(l,c){return await(await this.getWindowDriver(l)).getTerminalBuffer(c)}async writeInTerminal(l,c,u){await(await this.getWindowDriver(l)).writeInTerminal(c,u)}async getLocaleInfo(l){return await(await this.getWindowDriver(l)).getLocaleInfo()}async getLocalizedStrings(l){return await(await this.getWindowDriver(l)).getLocalizedStrings()}async getWindowDriver(l){await this.whenUnfrozen(l);const c=`window:${l}`,u=new h.StaticRouter(a=>a===c),r=this.windowServer.getChannel("windowDriver",u);return new y.WindowDriverChannelClient(r)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await D.Event.toPromise(this.onDidReloadingChange.event)}};E=he([ee(2,t.IWindowsMainService),ee(3,w.ILifecycleMainService)],E),e.Driver=E;async function S(P,l,c,u){const r=c.driverVerbose,a=u.createInstance(E,P,{verbose:r}),s=new b.WindowDriverRegistryChannel(a);P.registerChannel("windowDriverRegistry",s);const n=await(0,f.serve)(l),o=new b.DriverChannel(a);return n.registerChannel("driver",o),(0,i.combinedDisposable)(n,P)}e.serve=S}),define(Q[24],J([0,1,47,8,58,48,164,5]),function(j,e,p,D,C,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(k.IEnvironmentService);class h extends i.NativeEnvironmentService{get cachedLanguagesPath(){return(0,D.join)(this.userDataPath,"clp")}get backupHome(){return(0,D.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,D.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,C.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,D.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([p.memoize],h.prototype,"cachedLanguagesPath",null),he([p.memoize],h.prototype,"backupHome",null),he([p.memoize],h.prototype,"backupWorkspacesPath",null),he([p.memoize],h.prototype,"mainIPCHandle",null),he([p.memoize],h.prototype,"mainLockfile",null),he([p.memoize],h.prototype,"sandbox",null),he([p.memoize],h.prototype,"driverVerbose",null),he([p.memoize],h.prototype,"disableUpdates",null),he([p.memoize],h.prototype,"disableKeytar",null),he([p.memoize],h.prototype,"codeCachePath",null),he([p.memoize],h.prototype,"useCodeCache",null),e.EnvironmentMainService=h}),define(Q[226],J([0,1,61,29,33,10,8,3,15,7,21,51,19,24,18,6,27]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class{constructor(l,c,u){this.configurationService=c,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=h.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,a)=>(0,C.isEqual)(r,a,!I.isLinux)},this.backupHome=l.backupHome,this.workspacesJsonPath=l.backupWorkspacesPath}async initialize(){let l;try{l=JSON.parse(await y.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(r){l=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(l.emptyWorkspaceInfos);let c=[];try{Array.isArray(l.rootURIWorkspaces)&&(c=l.rootURIWorkspaces.map(r=>({workspace:{id:r.id,configPath:f.URI.parse(r.configURIPath)},remoteAuthority:r.remoteAuthority})))}catch(r){}this.workspaces=await this.validateWorkspaces(c);let u=[];try{Array.isArray(l.folderURIWorkspaces)&&(u=l.folderURIWorkspaces.map(r=>f.URI.parse(r)))}catch(r){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(l,c){this.workspaces.some(r=>l.workspace.id===r.workspace.id)||(this.workspaces.push(l),this.saveSync());const u=this.getBackupPath(l.workspace.id);return c&&this.moveBackupFolderSync(u,c),u}moveBackupFolderSync(l,c){if(D.existsSync(l)&&this.convertToEmptyWindowBackupSync(l),D.existsSync(c))try{D.renameSync(c,l)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(l){const c=l.id,u=this.workspaces.findIndex(r=>r.workspace.id===c);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(l){return this.folders.some(c=>this.backupUriComparer.isEqual(l,c))||(this.folders.push(l),this.saveSync()),this.getBackupPath(this.getFolderHash(l))}unregisterFolderBackupSync(l){const c=this.folders.findIndex(u=>this.backupUriComparer.isEqual(l,u));c!==-1&&(this.folders.splice(c,1),this.saveSync())}registerEmptyWindowBackupSync(l,c){const u=l||this.getRandomEmptyWindowId();return this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:c}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(l){const c=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,l));c!==-1&&(this.emptyWindows.splice(c,1),this.saveSync())}getBackupPath(l){return(0,i.join)(this.backupHome,l)}async validateWorkspaces(l){if(!Array.isArray(l))return[];const c=new Set,u=[];for(let r of l){const a=r.workspace;if(!(0,E.isWorkspaceIdentifier)(a))return[];if(!c.has(a.id)){c.add(a.id);const s=this.getBackupPath(a.id);await this.doHasBackups(s)?a.configPath.scheme!==k.Schemas.file||await y.Promises.exists(a.configPath.fsPath)?u.push(r):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return u}async validateFolders(l){if(!Array.isArray(l))return[];const c=[],u=new Set;for(let r of l){const a=this.backupUriComparer.getComparisonKey(r);if(!u.has(a)){u.add(a);const s=this.getBackupPath(this.getFolderHash(r));await this.doHasBackups(s)?r.scheme!==k.Schemas.file||await y.Promises.exists(r.fsPath)?c.push(r):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateEmptyWorkspaces(l){if(!Array.isArray(l))return[];const c=[],u=new Set;for(let r of l){const a=r.backupFolder;if(typeof a!="string")return[];if(!u.has(a)){u.add(a);const s=this.getBackupPath(a);await this.doHasBackups(s)?c.push(r):await this.deleteStaleBackup(s)}}return c}async deleteStaleBackup(l){try{await y.Promises.exists(l)&&await y.Promises.rm(l,y.RimRafMode.MOVE)}catch(c){this.logService.error(`Backup: Could not delete stale backup: ${c.toString()}`)}}async convertToEmptyWindowBackup(l){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,c));)c=this.getRandomEmptyWindowId();const u=this.getBackupPath(c);try{await y.Promises.rename(l,u)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}convertToEmptyWindowBackupSync(l){let c=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,c));)c=this.getRandomEmptyWindowId();const u=this.getBackupPath(c);try{D.renameSync(l,u)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:c}),!0}async getDirtyWorkspaces(){const l=[];for(const c of this.workspaces)await this.hasBackups(c)&&l.push(c.workspace);for(const c of this.folders)await this.hasBackups(c)&&l.push(c);return l}hasBackups(l){let c;return f.URI.isUri(l)?c=this.getBackupPath(this.getFolderHash(l)):(0,b.isWorkspaceBackupInfo)(l)?c=this.getBackupPath(l.workspace.id):c=l.backupFolder,this.doHasBackups(c)}async doHasBackups(l){try{const c=await y.Promises.readdir(l);for(const u of c)try{if((await y.Promises.readdir((0,i.join)(l,u))).length>0)return!0}catch(r){}}catch(c){}return!1}saveSync(){try{(0,y.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}async save(){try{await y.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(l=>({id:l.workspace.id,configURIPath:l.workspace.configPath.toString(),remoteAuthority:l.remoteAuthority})),folderURIWorkspaces:this.folders.map(l=>l.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(l){let c;return l.scheme===k.Schemas.file?c=I.isLinux?l.fsPath:l.fsPath.toLowerCase():c=l.toString().toLowerCase(),(0,p.createHash)("md5").update(c).digest("hex")}};S=he([ee(0,w.IEnvironmentMainService),ee(1,g.IConfigurationService),ee(2,m.ILogService)],S),e.BackupMainService=S}),define(Q[227],J([0,1,62,58]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(C,k,i,I){const h=y=>I(y,void 0),f=p.createConnection({host:C,port:k},()=>{f.removeListener("error",h);const y=Buffer.alloc(16);for(let t=0;t<16;t++)y[t]=Math.round(Math.random()*256);const b=y.toString("base64");let g=[`GET ws://${/:/.test(C)?`[${C}]`:C}:${k}/?${i}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${b}`];f.write(g.join(`\r
`)+`\r
\r
`);const w=t=>{t.toString().indexOf(`\r
\r
`)>=0&&(f.off("data",w),I(void 0,new D.NodeSocket(f)))};f.on("data",w)});f.once("error",h)}}}),define(Q[228],J([0,1,62,118,227,9,2,19,6,22,194,97,76]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(P,l,c,u,r){let a;for(let s=3;s&&(a&&a.dispose(),a=await new t(P,l,c,u,r).waitForReady(),!(r&&D.BROWSER_RESTRICTED_PORTS[r]||!D.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));s--);return a}class t extends i.Disposable{constructor(l,c,u,r,a){super();this.defaultTunnelHost=c,this.suggestedLocalPort=a,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=l,this._server=p.createServer(),this._barrier=new k.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){let l=await(0,D.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(l=0,this._server.listen(l,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(l){l.pause();const c=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,y.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),r=u.getSocket().socket,a=u.readEntireBuffer();u.dispose(),a.byteLength>0&&l.write(a.buffer),l.on("end",()=>{this._socketsDispose.delete(l.localAddress),r.end()}),l.on("close",()=>r.end()),l.on("error",()=>{this._socketsDispose.delete(l.localAddress),r.destroy()}),r.on("end",()=>l.end()),r.on("close",()=>l.end()),r.on("error",()=>{l.destroy()}),l.pipe(r),r.pipe(l),this._socketsDispose.set(l.localAddress,()=>{l.end(),r.end()})}}let m=class extends b.AbstractTunnelService{constructor(l,c,u,r,a){super(c);this.socketFactory=l,this.signService=u,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const l=this.configurationService.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(l,c,u,r,a,s,n){const o=this.getTunnelFromMap(c,u);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,c,u,r,a,s,n);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${u} on local port ${r}.`);const d={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:l,signService:this.signService,logService:this.logService,ipcLogger:null},v=w(d,this.defaultTunnelHost,c,u,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,u,v),v}}};m=he([ee(1,h.ILogService),ee(2,g.ISignService),ee(3,f.IProductService),ee(4,I.IConfigurationService)],m),e.BaseTunnelService=m;let E=class extends m{constructor(l,c,u,r){super(C.nodeSocketFactory,l,c,u,r)}};E=he([ee(0,h.ILogService),ee(1,g.ISignService),ee(2,f.IProductService),ee(3,I.IConfigurationService)],E),e.TunnelService=E;let S=class extends i.Disposable{constructor(l,c,u,r){super();this.logService=l,this.productService=c,this.signService=u,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(l,c,u,r,a,s,n,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${r} on local port ${a}.`),!this._tunnelServices.has(l)){const d=new E(this.logService,this.signService,this.productService,this.configurationService);this._register(d),this._tunnelServices.set(l,d),d.onTunnelClosed(async()=>{(await d.tunnels).length===0&&(d.dispose(),this._tunnelServices.delete(l))})}return this._tunnelServices.get(l).openTunnel(c,u,r,a,s,n,o)}};S=he([ee(0,h.ILogService),ee(1,f.IProductService),ee(2,g.ISignService),ee(3,I.IConfigurationService)],S),e.SharedTunnelsService=S}),define(Q[229],J([0,1,198,9,17,16,2,13,19,48,91,6,197,223]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends i.Disposable{constructor(E,S,P){super();this.environmentService=S,this.logService=P,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,S){this.logService.trace("RequestService#request",E.url);const{proxyUrl:P,strictSSL:l}=this;let c;try{c=await(0,y.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(a){this.logService.error("RequestService#request resolving shell environment failed",a)}const u={...process.env,...c},r=E.agent?E.agent:await(0,g.getProxyAgent)(E.url||"",u,{proxyUrl:P,strictSSL:l});return E.agent=r,E.strictSSL=l,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization}),this._request(E,S)}async getNodeRequest(E){return((0,p.parse)(E.url).protocol==="https:"?await new Promise((l,c)=>{j(["https"],l,c)}):await new Promise((l,c)=>{j(["http"],l,c)})).request}_request(E,S){return D.Promises.withAsyncBody(async(P,l)=>{let c;const u=(0,p.parse)(E.url),r=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),a={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,I.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(a.auth=E.user+":"+E.password),c=r(a,s=>{const n=(0,I.isNumber)(E.followRedirects)?E.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&n>0&&s.headers.location)this._request({...E,url:s.headers.location,followRedirects:n-1},S).then(P,l);else{let o=s;s.headers["content-encoding"]==="gzip"&&(o=s.pipe((0,w.createGunzip)())),P({res:s,stream:(0,C.streamToBufferReadableStream)(o)})}}),c.on("error",l),E.timeout&&c.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&c.write(E.data),c.end(),S.onCancellationRequested(()=>{c.abort(),l((0,k.canceled)())})})}async resolveProxy(E){}};t=he([ee(0,h.IConfigurationService),ee(1,f.INativeEnvironmentService),ee(2,b.ILogService)],t),e.RequestService=t}),define(Q[230],J([0,1,14,229]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function C(i){return p.net.request}class k extends D.RequestService{request(I,h){return super.request({...I||{},getRawRequest:C},h)}}e.RequestMainService=k}),define(Q[231],J([0,1,14,9,4,2,10,13,85,24,20,6,56,57,66,45]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let E=class extends k.Disposable{constructor(P,l,c,u,r,a,s){super();this.machineId=P,this.userEnv=l,this.environmentMainService=c,this.lifecycleMainService=u,this.logService=r,this.themeMainService=a,this.protocolMainService=s,this.firstWindowConnectionBarrier=new D.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new C.Emitter),this.onDidError=C.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,l)=>this.onWindowConnection(P,l)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,l)=>this.onWorkerConnection(P,l)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,l){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const c=await this.connect();if(P.sender.isDestroyed())return c.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",l,[c])}onWorkerConnection(P,l){this.logService.trace("SharedProcess: onWorkerConnection",l);const c=new k.DisposableStore,u=a=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${a}')`,l),c.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",l))},r=p.BrowserWindow.fromId(l.reply.windowId);if(!r||r.isDestroyed()||r.webContents.isDestroyed()||!l.reply.channel){u("unavailable");return}c.add(C.Event.filter(this.lifecycleMainService.onWillLoadWindow,a=>a.window.win===r)(()=>u("load"))),c.add(C.Event.fromNodeEventEmitter(r,"closed")(()=>u("closed"))),r.webContents.postMessage(l.reply.channel,l.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch(l){}this.window=void 0},0))}send(P,...l){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...l)}catch(c){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,m.toErrorMessage)(c)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:i.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:g.default}),this.window.loadURL(i.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,l)=>this._onDidError.fire({type:2,details:l})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,l,c)=>this._onDidError.fire({type:3,details:{reason:c,exitCode:l}})))}async connect(){await this.whenIpcReady;const P=(0,I.assertIsDefined)(this.window);return(0,h.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};E=he([ee(2,f.IEnvironmentMainService),ee(3,y.ILifecycleMainService),ee(4,b.ILogService),ee(5,t.IThemeMainService),ee(6,w.IProtocolMainService)],E),e.SharedProcess=E}),define(Q[232],J([0,1,9,17,8,13,7,24,18,6]),function(j,e,p,D,C,k,i,I,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class y{constructor(w,t,m){this.storagePath=w,this.logService=t,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}}getItem(w,t){const m=this.storage[w];return(0,k.isUndefinedOrNull)(m)?t:m}setItem(w,t){this.setItems([{key:w,data:t}])}setItems(w){let t=!1;for(const{key:m,data:E}of w)this.storage[m]!==E&&((0,k.isUndefinedOrNull)(E)?(0,k.isUndefined)(this.storage[m])||(this.storage[m]=void 0,t=!0):(this.storage[m]=E,t=!0));t&&this.save()}removeItem(w){(0,k.isUndefined)(this.storage[w])||(this.storage[w]=void 0,this.save())}async save(w){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),w)}async doSave(){if(!this.initializing)return;await this.initializing;const w=JSON.stringify(this.storage,null,4);if(w!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,D.VSBuffer.fromString(w)),this.lastSavedStorageContents=w}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=y;let b=class Et{constructor(w,t,m){this.fileStorage=new y(i.URI.file((0,C.join)(w.userDataPath,Et.STATE_FILE)),t,m)}async init(){return this.fileStorage.init()}getItem(w,t){return this.fileStorage.getItem(w,t)}setItem(w,t){this.fileStorage.setItem(w,t)}setItems(w){this.fileStorage.setItems(w)}removeItem(w){this.fileStorage.removeItem(w)}close(){return this.fileStorage.close()}};b.STATE_FILE="storage.json",b=he([ee(0,I.IEnvironmentMainService),ee(1,f.ILogService),ee(2,h.IFileService)],b),e.StateMainService=b}),define(Q[77],J([0,1,9,23,4,19,24,20,6,22,50,41]),function(j,e,p,D,C,k,i,I,h,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function g(t,m,E){return`${E.updateUrl}/api/update/${t}/${m}/${E.commit}`}e.createUpdateURL=g;let w=class{constructor(m,E,S,P,l,c){this.lifecycleMainService=m,this.configurationService=E,this.environmentMainService=S,this.requestService=P,this.logService=l,this.productService=c,this._state=b.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.getUpdateMode(),E=this.getProductQuality(m);if(!E){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(b.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}getUpdateMode(){return(0,k.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,p.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},D.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};w=he([ee(0,I.ILifecycleMainService),ee(1,k.IConfigurationService),ee(2,i.IEnvironmentMainService),ee(3,y.IRequestService),ee(4,h.ILogService),ee(5,f.IProductService)],w),e.AbstractUpdateService=w}),define(Q[233],J([0,1,14,47,4,2,19,24,20,6,22,50,30,41,77]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends t.AbstractUpdateService{constructor(S,P,l,c,u,r,a){super(S,P,c,u,r,a);this.telemetryService=l,this.disposables=new k.DisposableStore}get onRawError(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"error",(S,P)=>P)}get onRawUpdateNotAvailable(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(S,P,l)=>({url:P,version:l,productVersion:l}))}get onRawUpdateDownloaded(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(S,P,l,c)=>({releaseNotes:P,version:l,productVersion:l,date:c}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(S){this.logService.error("UpdateService error:",S);const l=(this.state.type==="checking for updates"?this.state.explicit:!0)?S:void 0;this.setState(w.State.Idle(1,l))}buildUpdateFeedUrl(S){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const l=(0,t.createUpdateURL)(P,S,this.productService);try{p.autoUpdater.setFeedURL({url:l})}catch(c){this.logService.error("Failed to set update feed URL",c);return}return l}doCheckForUpdates(S){this.setState(w.State.CheckingForUpdates(S)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(S){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(S))}onUpdateDownloaded(S){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:S.version}),this.setState(w.State.Ready(S)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([D.memoize],m.prototype,"onRawError",null),he([D.memoize],m.prototype,"onRawUpdateNotAvailable",null),he([D.memoize],m.prototype,"onRawUpdateAvailable",null),he([D.memoize],m.prototype,"onRawUpdateDownloaded",null),m=he([ee(0,h.ILifecycleMainService),ee(1,i.IConfigurationService),ee(2,g.ITelemetryService),ee(3,I.IEnvironmentMainService),ee(4,b.IRequestService),ee(5,f.ILogService),ee(6,y.IProductService)],m),e.DarwinUpdateService=m}),define(Q[234],J([0,1,44,29,9,4,8,24,20,6,30,41]),function(j,e,p,D,C,k,i,I,h,f,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let g=class{constructor(m,E,S){if(this.lifecycleMainService=m,this.logService=S,this._state=b.State.Uninitialized,this._onStateChange=new k.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return(0,C.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};g=he([ee(0,h.ILifecycleMainService),ee(1,I.IEnvironmentMainService),ee(2,f.ILogService)],g);let w=class extends g{constructor(m,E,S,P,l,c){super(S,P,l);this.snap=m,this.snapRevision=E,this.telemetryService=c;const u=(0,D.watch)(i.dirname(this.snap)),r=k.Event.fromNodeEventEmitter(u,"change",(o,d)=>d),a=k.Event.filter(r,o=>o==="current"),n=k.Event.debounce(a,(o,d)=>d,2e3)(()=>this.checkForUpdates(!1));S.onWillShutdown(()=>{n.dispose(),u.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+i.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((S,P)=>(0,D.realpath)(`${i.dirname(this.snap)}/current`,(l,c)=>l?P(l):S(c))),E=i.basename(m);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};w=he([ee(2,h.ILifecycleMainService),ee(3,I.IEnvironmentMainService),ee(4,f.ILogService),ee(5,y.ITelemetryService)],w),e.SnapUpdateService=w}),define(Q[46],J([0,1,14,29,4,39,34,2,10,8,3,15,13,21,158,51,52,24,5,6,22,101,27,102]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l,c,u,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let s=class extends I.Disposable{constructor(o,d,v,M,L){super();this.environmentMainService=o,this.logService=d,this.backupMainService=v,this.dialogMainService=M,this.productService=L,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new C.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new C.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,d=>(0,D.readFileSync)(d,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,d=>w.Promises.readFile(d,"utf8"))}doResolveLocalWorkspace(o,d){if(!!this.isWorkspacePath(o)&&o.scheme===h.Schemas.file)try{const v=d(o.fsPath);return v instanceof Promise?v.then(M=>this.doResolveWorkspace(o,M),M=>{}):this.doResolveWorkspace(o,v)}catch{return}}isWorkspacePath(o){return(0,r.isUntitledWorkspace)(o,this.environmentMainService)||(0,r.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,d){try{const v=this.doParseStoredWorkspace(o,d),M=(0,a.getWorkspaceIdentifier)(o);return{id:M.id,configPath:M.configPath,folders:(0,r.toWorkspaceFolders)(v.folders,M.configPath,b.extUriBiasedIgnorePathCase),remoteAuthority:v.remoteAuthority,transient:v.transient}}catch(v){this.logService.warn(v.toString())}}doParseStoredWorkspace(o,d){const v=(0,k.parse)(d);if(v&&Array.isArray(v.folders))v.folders=v.folders.filter(M=>(0,r.isStoredWorkspaceFolder)(M));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return v}async createUntitledWorkspace(o,d){const{workspace:v,storedWorkspace:M}=this.newUntitledWorkspace(o,d),L=v.configPath.fsPath;return await w.Promises.mkdir((0,f.dirname)(L),{recursive:!0}),await w.Promises.writeFile(L,JSON.stringify(M,null,"	")),v}createUntitledWorkspaceSync(o,d){const{workspace:v,storedWorkspace:M}=this.newUntitledWorkspace(o,d),L=v.configPath.fsPath;return(0,D.mkdirSync)((0,f.dirname)(L),{recursive:!0}),(0,w.writeFileSync)(L,JSON.stringify(M,null,"	")),v}newUntitledWorkspace(o=[],d){const v=(Date.now()+Math.round(Math.random()*1e3)).toString(),M=(0,b.joinPath)(this.untitledWorkspacesHome,v),L=(0,b.joinPath)(M,r.UNTITLED_WORKSPACE_NAME),A=[];for(const W of o)A.push((0,r.getStoredWorkspaceFolder)(W.uri,!0,W.name,M,!y.isWindows,b.extUriBiasedIgnorePathCase));return{workspace:(0,a.getWorkspaceIdentifier)(L),storedWorkspace:{folders:A,remoteAuthority:d}}}async getWorkspaceIdentifier(o){return(0,a.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,r.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const d=(0,b.originalFSPath)(o.configPath);try{(0,w.rimrafSync)((0,f.dirname)(d));const v=(0,f.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,D.existsSync)(v)&&(0,w.writeFileSync)((0,f.join)(v,"obsolete"),"")}catch(v){this.logService.warn(`Unable to delete untitled workspace ${d} (${v}).`)}}getUntitledWorkspacesSync(){const o=[];try{const d=(0,w.readdirSync)(this.untitledWorkspacesHome.fsPath).map(v=>(0,b.joinPath)(this.untitledWorkspacesHome,v,r.UNTITLED_WORKSPACE_NAME));for(const v of d){const M=(0,a.getWorkspaceIdentifier)(v),L=this.resolveLocalWorkspaceSync(v);L?o.push({workspace:M,remoteAuthority:L.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(M)}}catch(d){d.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${d}).`)}return o}async enterWorkspace(o,d,v){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,d,v))return;const L=this.doEnterWorkspace(o,(0,a.getWorkspaceIdentifier)(v));if(!!L)return this._onDidEnterWorkspace.fire({window:o,workspace:L.workspace}),L}async isValidTargetWorkspacePath(o,d,v){if(!v)return!0;if((0,r.isWorkspaceIdentifier)(o.openedWorkspace)&&b.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,v))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(d,v)){const M={title:this.productService.nameLong,type:"info",buttons:[(0,i.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,b.basename)(v)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(M,(0,g.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,d){if(!o.config)return;o.focus();let v;return o.config.extensionDevelopmentPath||(v=this.backupMainService.registerWorkspaceBackupSync({workspace:d,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,r.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=d,o.config.backupPath=v,{workspace:d,backupPath:v}}};s=he([ee(0,S.IEnvironmentMainService),ee(1,l.ILogService),ee(2,m.IBackupMainService),ee(3,E.IDialogMainService),ee(4,c.IProductService)],s),e.WorkspacesManagementMainService=s}),define(Q[103],J([0,1,14,31,23,3,13,7,21,19,54,5,6,99,36,27,46]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let S=class{constructor(l,c,u,r,a){this.logService=l,this.windowsMainService=c,this.urlService=u,this.workspacesManagementMainService=r,this.configurationService=a}async start(l,c){this.logService.trace("Received data from other instance: ",l,c),k.isMacintosh&&p.app.focus({steal:!0});const u=this.parseOpenUrl(l);if(u.length){let r=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(r=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),r.then(()=>{for(const{uri:a,url:s}of u)this.urlService.open(a,{originalUrl:s})})}else return this.startOpenWindow(l,c)}parseOpenUrl(l){return l["open-url"]&&l._urls&&l._urls.length>0?(0,D.coalesce)(l._urls.map(c=>{try{return{uri:I.URI.parse(c),url:c}}catch(u){return null}})):[]}async startOpenWindow(l,c){const u=(0,y.isLaunchedFromCli)(c)?0:4;let r=[];const a=l.wait&&l.waitMarkerFilePath?I.URI.file(l.waitMarkerFilePath):void 0,s=l.remote||void 0,n={context:u,cli:l,userEnv:c,waitMarkerFileURI:a,remoteAuthority:s};if(l.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(l.extensionDevelopmentPath,n);else if(!l._.length&&!l["folder-uri"]&&!l["file-uri"]){let o=!1;if(l["new-window"]||l["unity-launch"])o=!0;else if(l["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!k.isMacintosh}if(o)r=this.windowsMainService.open({...n,forceNewWindow:!0,forceEmpty:!0});else{const d=this.windowsMainService.getLastActiveWindow();d?(this.windowsMainService.openExistingWindow(d,n),r=[d]):r=this.windowsMainService.open({...n,forceEmpty:!0})}}else r=this.windowsMainService.open({...n,forceNewWindow:l["new-window"],preferNewWindow:!l["reuse-window"]&&!l.wait,forceReuseWindow:l["reuse-window"],diffMode:l.diff,addMode:l.add,noRecentEntry:!!l["skip-add-to-recently-opened"],gotoLineMode:l.goto});if(a&&r.length===1&&r[0])return Promise.race([r[0].whenClosedOrLoaded,(0,h.whenDeleted)(a.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const l=[];return p.BrowserWindow.getAllWindows().forEach(c=>{const u=this.windowsMainService.getWindowById(c.id);u?l.push(this.codeWindowToInfo(u)):l.push(this.browserWindowToInfo(c))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:l,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(l){const c=this.windowsMainService.getWindows();return(await Promise.all(c.map(r=>new Promise(a=>{const s=r.remoteAuthority;if(s){const n=`vscode:getDiagnosticInfoResponse${r.id}`,o={includeProcesses:l.includeProcesses,folders:l.includeWorkspaceMetadata?this.getFolderURIs(r):void 0};r.sendWhenReady("vscode:getDiagnosticInfo",C.CancellationToken.None,{replyChannel:n,args:o}),p.ipcMain.once(n,(d,v)=>{v||a({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),a(v)}),setTimeout(()=>{a({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else a(void 0)})))).filter(r=>!!r)}getFolderURIs(l){const c=[],u=l.openedWorkspace;if((0,m.isSingleFolderWorkspaceIdentifier)(u))c.push(u.uri);else if((0,m.isWorkspaceIdentifier)(u)){const r=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);r&&r.folders.forEach(s=>{c.push(s.uri)})}return c}codeWindowToInfo(l){const c=this.getFolderURIs(l),u=(0,i.assertIsDefined)(l.win);return this.browserWindowToInfo(u,c,l.remoteAuthority)}browserWindowToInfo(l,c=[],u){return{pid:l.webContents.getOSProcessId(),title:l.getTitle(),folderURIs:c,remoteAuthority:u}}};S=he([ee(0,g.ILogService),ee(1,t.IWindowsMainService),ee(2,w.IURLService),ee(3,E.IWorkspacesManagementMainService),ee(4,f.IConfigurationService)],S),e.LaunchMainService=S}),define(Q[53],J([0,1,44,14,26,117,47,4,34,2,10,8,3,7,82,71,21,150,52,24,5,20,6,22,30,66,36,27,46]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l,c,u,r,a,s,n,o,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,c.createDecorator)("nativeHostMainService");let M=class dt extends f.Disposable{constructor(A,W,H,Z,ne,oe,G,T,z,q){super();this.sharedProcess=A,this.windowsMainService=W,this.dialogMainService=H,this.lifecycleMainService=Z,this.environmentMainService=ne,this.telemetryService=oe,this.logService=G,this.productService=T,this.themeMainService=z,this.workspacesManagementMainService=q,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,U=>U.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(U,N)=>N.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(U,N)=>N.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(U,N)=>N.id),U=>!!this.windowsMainService.getWindowById(U)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),U=>!!U),U=>U.id),I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(U,N)=>N.id),U=>!!this.windowsMainService.getWindowById(U))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(U,N,_)=>_),U=>!(Array.isArray(U)&&U.length===1&&U[0]==="workArea")),I.Event.fromNodeEventEmitter(D.screen,"display-added"),I.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){D.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(W=>({id:W.id,workspace:W.openedWorkspace,title:W.win?.getTitle()??"",filename:W.getRepresentedFilename(),dirty:W.isDocumentEdited()}))}async getWindowCount(A){return this.windowsMainService.getWindowCount()}async getActiveWindowId(A){const W=D.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(W)return W.id}openWindow(A,W,H){return Array.isArray(W)?this.doOpenWindow(A,W,H):this.doOpenEmptyWindow(A,W)}async doOpenWindow(A,W,H=Object.create(null)){W.length>0&&this.windowsMainService.open({context:5,contextWindowId:A,urisToOpen:W,cli:this.environmentMainService.args,forceNewWindow:H.forceNewWindow,forceReuseWindow:H.forceReuseWindow,preferNewWindow:H.preferNewWindow,diffMode:H.diffMode,addMode:H.addMode,gotoLineMode:H.gotoLineMode,noRecentEntry:H.noRecentEntry,waitMarkerFileURI:H.waitMarkerFileURI,remoteAuthority:H.remoteAuthority||void 0})}async doOpenEmptyWindow(A,W){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:A},W)}async toggleFullScreen(A){const W=this.windowById(A);W&&W.toggleFullScreen()}async handleTitleDoubleClick(A){const W=this.windowById(A);W&&W.handleTitleDoubleClick()}async isMaximized(A){const W=this.windowById(A);return W?.win?W.win.isMaximized():!1}async maximizeWindow(A){const W=this.windowById(A);W?.win&&W.win.maximize()}async unmaximizeWindow(A){const W=this.windowById(A);W?.win&&W.win.unmaximize()}async minimizeWindow(A){const W=this.windowById(A);W?.win&&W.win.minimize()}async focusWindow(A,W){W&&typeof W.windowId=="number"&&(A=W.windowId);const H=this.windowById(A);H&&H.focus({force:W?.force??!1})}async setMinimumSize(A,W,H){const Z=this.windowById(A);if(Z?.win){const[ne,oe]=Z.win.getSize(),[G,T]=Z.win.getMinimumSize(),[z,q]=[W??G,H??T],[U,N]=[Math.max(ne,z),Math.max(oe,q)];(G!==z||T!==q)&&Z.win.setMinimumSize(z,q),(ne!==U||oe!==N)&&Z.win.setSize(U,N)}}async saveWindowSplash(A,W){this.themeMainService.saveWindowSplash(A,W)}async installShellCommand(A){const{source:W,target:H}=await this.getShellCommandLink();try{const{symbolicLink:Z}=await E.SymlinkSupport.stat(W);if(Z&&!Z.dangling){const ne=await(0,t.realpath)(W);if(H===ne)return}await E.Promises.unlink(W)}catch(Z){if(Z.code!=="ENOENT")throw Z}try{await E.Promises.symlink(H,W)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="ENOENT")throw Z;const{response:ne}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,h.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const oe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${H}' '${W}'\\" with administrator privileges"`;await(0,k.promisify)(p.exec)(oe)}catch(oe){throw new Error((0,S.localize)(3,null,W))}}}async uninstallShellCommand(A){const{source:W}=await this.getShellCommandLink();try{await E.Promises.unlink(W)}catch(H){switch(H.code){case"EACCES":const{response:Z}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,h.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,h.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Z===0)try{const ne=`osascript -e "do shell script \\"rm '${W}'\\" with administrator privileges"`;await(0,k.promisify)(p.exec)(ne)}catch(ne){throw new Error((0,S.localize)(7,null,W))}break;case"ENOENT":break;default:throw H}}}async getShellCommandLink(){const A=(0,b.resolve)(this.environmentMainService.appRoot,"bin","code"),W=`/usr/local/bin/${this.productService.applicationName}`;if(!await E.Promises.exists(A))throw new Error((0,S.localize)(8,null,A));return{source:W,target:A}}async showMessageBox(A,W){return this.dialogMainService.showMessageBox(W,this.toBrowserWindow(A))}async showSaveDialog(A,W){return this.dialogMainService.showSaveDialog(W,this.toBrowserWindow(A))}async showOpenDialog(A,W){return this.dialogMainService.showOpenDialog(W,this.toBrowserWindow(A))}toBrowserWindow(A){const W=this.windowById(A);if(W?.win)return W.win}async pickFileFolderAndOpen(A,W){const H=await this.dialogMainService.pickFileFolder(W);H&&(this.sendPickerTelemetry(H,W.telemetryEventName||"openFileFolder",W.telemetryExtraData),this.doOpenPicked(await Promise.all(H.map(async Z=>await E.SymlinkSupport.existsDirectory(Z)?{folderUri:w.URI.file(Z)}:{fileUri:w.URI.file(Z)})),W,A))}async pickFolderAndOpen(A,W){const H=await this.dialogMainService.pickFolder(W);H&&(this.sendPickerTelemetry(H,W.telemetryEventName||"openFolder",W.telemetryExtraData),this.doOpenPicked(H.map(Z=>({folderUri:w.URI.file(Z)})),W,A))}async pickFileAndOpen(A,W){const H=await this.dialogMainService.pickFile(W);H&&(this.sendPickerTelemetry(H,W.telemetryEventName||"openFile",W.telemetryExtraData),this.doOpenPicked(H.map(Z=>({fileUri:w.URI.file(Z)})),W,A))}async pickWorkspaceAndOpen(A,W){const H=await this.dialogMainService.pickWorkspace(W);H&&(this.sendPickerTelemetry(H,W.telemetryEventName||"openWorkspace",W.telemetryExtraData),this.doOpenPicked(H.map(Z=>({workspaceUri:w.URI.file(Z)})),W,A))}doOpenPicked(A,W,H){this.windowsMainService.open({context:3,contextWindowId:H,cli:this.environmentMainService.args,urisToOpen:A,forceNewWindow:W.forceNewWindow})}sendPickerTelemetry(A,W,H){const Z=A?A.length:0;this.telemetryService.publicLog(W,{...H,outcome:Z?"success":"canceled",numberOfPaths:Z})}async showItemInFolder(A,W){D.shell.showItemInFolder(W)}async setRepresentedFilename(A,W){const H=this.windowById(A);H&&H.setRepresentedFilename(W)}async setDocumentEdited(A,W){const H=this.windowById(A);H&&H.setDocumentEdited(W)}async openExternal(A,W){return g.isLinuxSnap?this.safeSnapOpenExternal(W):D.shell.openExternal(W),!0}safeSnapOpenExternal(A){const W=process.env.GDK_PIXBUF_MODULE_FILE,H=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,D.shell.openExternal(A),process.env.GDK_PIXBUF_MODULE_FILE=W,process.env.GDK_PIXBUF_MODULEDIR=H}moveItemToTrash(A,W){return D.shell.trashItem(W)}async isAdmin(){let A;return g.isWindows?A=(await new Promise((W,H)=>{j(["native-is-elevated"],W,H)}))():A=process.getuid()===0,A}async writeElevated(A,W,H,Z){const ne=await new Promise((oe,G)=>{j(["sudo-prompt"],oe,G)});return new Promise((oe,G)=>{const T=[`"${this.cliPath}"`];Z?.unlock&&T.push("--file-chmod"),T.push("--file-write",`"${W.fsPath}"`,`"${H.fsPath}"`);const z={name:this.productService.nameLong.replace("-",""),icns:g.isMacintosh&&this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ne.exec(T.join(" "),z,(q,U,N)=>{U&&this.logService.trace(`[sudo-prompt] received stdout: ${U}`),N&&this.logService.trace(`[sudo-prompt] received stderr: ${N}`),q?G(q):oe(void 0)})})}get cliPath(){return g.isWindows?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):g.isLinux?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,b.join)(this.environmentMainService.appRoot,"bin","code"):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,C.totalmem)(),freemem:(0,C.freemem)(),loadavg:(0,C.loadavg)()}}async getOSProperties(){return{arch:(0,C.arch)(),platform:(0,C.platform)(),release:(0,C.release)(),type:(0,C.type)(),cpus:(0,C.cpus)()}}async getOSVirtualMachineHint(){return m.virtualMachineHint.value()}get osColorScheme(){return{highContrast:D.nativeTheme.shouldUseInvertedColorScheme||D.nativeTheme.shouldUseHighContrastColors,dark:D.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(A,W,H){process.kill(W,H)}async readClipboardText(A,W){return D.clipboard.readText(W)}async writeClipboardText(A,W,H){return D.clipboard.writeText(W,H)}async readClipboardFindText(A){return D.clipboard.readFindText()}async writeClipboardFindText(A,W){return D.clipboard.writeFindText(W)}async writeClipboardBuffer(A,W,H,Z){return D.clipboard.writeBuffer(W,Buffer.from(H),Z)}async readClipboardBuffer(A,W){return D.clipboard.readBuffer(W)}async hasClipboard(A,W,H){return D.clipboard.has(W,H)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(A,W){const H=this.windowById(A);H&&H.updateTouchBar(W)}async notifyReady(A){const W=this.windowById(A);W&&W.setReady()}async relaunch(A,W){return this.lifecycleMainService.relaunch(W)}async reload(A,W){const H=this.windowById(A);if(H){if((0,d.isWorkspaceIdentifier)(H.openedWorkspace)){const Z=H.openedWorkspace.configPath;if(Z.scheme===y.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Z))?.transient)return this.openWindow(H.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(H,W?.disableExtensions!==void 0?{_:[],"disable-extensions":W.disableExtensions}:void 0)}}async closeWindow(A){this.closeWindowById(A,A)}async closeWindowById(A,W){const H=this.windowById(W);if(H?.win)return H.win.close()}async quit(A){const W=this.windowsMainService.getLastActiveWindow();W?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&W.win?W.win.close():this.lifecycleMainService.quit()}async exit(A,W){await this.lifecycleMainService.kill(W)}async resolveProxy(A,W){const Z=this.windowById(A)?.win?.webContents?.session;if(Z)return Z.resolveProxy(W)}async openDevTools(A,W){const H=this.windowById(A);H?.win&&H.win.webContents.openDevTools(W)}async toggleDevTools(A){const W=this.windowById(A);W?.win&&W.win.webContents.toggleDevTools()}async sendInputEvent(A,W){const H=this.windowById(A);H?.win&&(W.type==="mouseDown"||W.type==="mouseUp")&&H.win.webContents.sendInputEvent(W)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(A,W,H,Z){if(!g.isWindows)return;const ne=await new Promise((oe,G)=>{j(["vscode-windows-registry"],oe,G)});try{return ne.GetStringRegKey(W,H,Z)}catch{return}}async getPassword(A,W,H){const Z=await this.withKeytar(),ne=await Z.getPassword(W,H);if(ne)try{let{content:oe,hasNextChunk:G}=JSON.parse(ne);if(!oe||!G)return ne;let T=1;for(;G;){const z=await Z.getPassword(W,`${H}-${T}`),q=JSON.parse(z);oe+=q.content,G=q.hasNextChunk,T++}return oe}catch{return ne}return ne}async setPassword(A,W,H,Z){const ne=await this.withKeytar(),oe=3,G=async(T,z,q)=>{let U=0,N;for(;U<oe;)try{await ne.setPassword(T,z,q);return}catch(_){N=_,this.logService.warn("Error attempting to set a password: ",_),U++,await new Promise(Y=>setTimeout(Y,200))}throw N};if(g.isWindows&&Z.length>dt.MAX_PASSWORD_LENGTH){let T=0,z=0,q=!0;for(;q;){const U=Z.substring(T,T+dt.PASSWORD_CHUNK_SIZE);T+=dt.PASSWORD_CHUNK_SIZE,q=Z.length-T>0;const N={content:U,hasNextChunk:q};await G(W,z?`${H}-${z}`:H,JSON.stringify(N)),z++}}else await G(W,H,Z);this._onDidChangePassword.fire({service:W,account:H})}async deletePassword(A,W,H){const ne=await(await this.withKeytar()).deletePassword(W,H);return ne&&this._onDidChangePassword.fire({service:W,account:H}),ne}async findPassword(A,W){return(await this.withKeytar()).findPassword(W)}async findCredentials(A,W){return(await this.withKeytar()).findCredentials(W)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((A,W)=>{j(["keytar"],A,W)})}windowById(A){if(typeof A=="number")return this.windowsMainService.getWindowById(A)}};M.MAX_PASSWORD_LENGTH=2500,M.PASSWORD_CHUNK_SIZE=M.MAX_PASSWORD_LENGTH-100,he([i.memoize],M.prototype,"cliPath",null),M=he([ee(1,o.IWindowsMainService),ee(2,P.IDialogMainService),ee(3,u.ILifecycleMainService),ee(4,l.IEnvironmentMainService),ee(5,s.ITelemetryService),ee(6,r.ILogService),ee(7,a.IProductService),ee(8,n.IThemeMainService),ee(9,v.IWorkspacesManagementMainService)],M),e.NativeHostMainService=M}),define(Q[235],J([0,1,14,23,4,81,2,28,89,6,53,22,36]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var w;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let t=class extends i.Disposable{constructor(E,S,P,l,c){super();this.logService=E,this.windowsMainService=S,this.nativeHostMainService=P,this.encryptionMainService=l,this.productService=c,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=w.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const E=C.Event.fromNodeEventEmitter(p.app,"login",(S,P,l,c,u)=>({event:S,webContents:P,req:l,authInfo:c,callback:u}));this._register(E(this.onLogin,this))}async onLogin({event:E,authInfo:S,req:P,callback:l}){if(!S.isProxy)return;if(!this.pendingProxyResolve&&this.state===w.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}E.preventDefault();let c;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),c=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(S);try{c=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}l(c?.username,c?.password)}async resolveProxyCredentials(E){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const S=await this.doResolveProxyCredentials(E);if(S)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),S;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(E){this.logService.trace("auth#doResolveProxyCredentials - enter",E);const S=String((0,k.hash)({scheme:E.scheme,host:E.host,port:E.port}));let P,l;try{const a=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S);if(a){const s=JSON.parse(await this.encryptionMainService.decrypt(a));P=s.username,l=s.password}}catch(a){this.logService.error(a)}if(this.state!==w.StoredCredentialsUsed&&typeof P=="string"&&typeof l=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=w.StoredCredentialsUsed,{username:P,password:l};const c=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!c){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${c.id} to handle proxy login`);const u={authInfo:E,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??l,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};c.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,u),this.state=w.LoginDialogShown;const r=await new Promise(a=>{const s=async(n,o,d)=>{if(o===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${c.id}`),c.win?.webContents.off("ipc-message",s),d){const v={username:d.username,password:d.password};try{if(d.remember){const M=await this.encryptionMainService.encrypt(JSON.stringify(v));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S,M)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S)}catch(M){this.logService.error(M)}a({username:v.username,password:v.password})}else a(void 0)};c.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=r,r}};t=he([ee(0,f.ILogService),ee(1,g.IWindowsMainService),ee(2,y.INativeHostMainService),ee(3,h.IEncryptionMainService),ee(4,b.IProductService)],t),e.ProxyAuthHandler=t}),define(Q[236],J([0,1,14,26,34,2,10,3,83,148,74,52,24,5,103,6,53,56,22,57,67]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,w.createDecorator)("issueMainService");let u=class It{constructor(a,s,n,o,d,v,M,L,A){this.userEnv=a,this.environmentMainService=s,this.launchMainService=n,this.logService=o,this.diagnosticsService=d,this.dialogMainService=v,this.nativeHostMainService=M,this.protocolMainService=L,this.productService=A,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async a=>{const[s,n]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(s,n);this.safeSend(a,"vscode:issueSystemInfoResponse",o)}),p.ipcMain.on("vscode:listProcesses",async a=>{const s=[];try{const n=await this.launchMainService.getMainProcessId();s.push({name:(0,f.localize)(0,null),rootProcess:await(0,h.listProcesses)(n)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(d=>{(0,y.isRemoteDiagnosticError)(d)?s.push({name:d.hostName,rootProcess:d}):d.processes&&s.push({name:d.hostName,rootProcess:d.processes})})}catch(n){this.logService.error(`Listing processes failed: ${n}`)}this.safeSend(a,"vscode:listProcessesResponse",s)}),p.ipcMain.on("vscode:issueReporterClipboard",async a=>{const s={title:this.productService.nameLong,message:(0,f.localize)(1,null),type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,f.localize)(2,null)),(0,C.mnemonicButtonLabel)((0,f.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const n=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(a,"vscode:issueReporterClipboardResponse",n.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async a=>{const s=await this.getPerformanceInfo();this.safeSend(a,"vscode:issuePerformanceInfoResponse",s)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const a={title:this.productService.nameLong,message:(0,f.localize)(4,null),type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,f.localize)(5,null)),(0,C.mnemonicButtonLabel)((0,f.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(a,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(a,s)=>{const{id:n,from:o,args:d}=s;let v;switch(o){case"issueReporter":v=this.issueReporterParentWindow;break;case"processExplorer":v=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}v&&v.webContents.send("vscode:runAction",{id:n,from:o,args:d})}),p.ipcMain.on("vscode:openExternal",(a,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),p.ipcMain.on("vscode:closeIssueReporter",a=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",a=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async a=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(a,"vscode:windowsInfoResponse",s.windows)})}safeSend(a,s,...n){a.sender.isDestroyed()||a.sender.send(s,...n)}async openReporter(a){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new k.DisposableStore,n=s.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,n,{backgroundColor:a.styles.backgroundColor,title:(0,f.localize)(7,null),zoomLevel:a.zoomLevel,alwaysOnTop:!1}),n.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:a,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:S.default}),this.issueReporterWindow.loadURL(i.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(a){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new k.DisposableStore,n=s.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,n,{backgroundColor:a.styles.backgroundColor,title:(0,f.localize)(8,null),zoomLevel:a.zoomLevel,alwaysOnTop:!0}),n.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:a,product:S.default}),this.processExplorerWindow.loadURL(i.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(a,s,n){const o=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:a.width,height:a.height,minWidth:300,minHeight:200,x:a.x,y:a.y,title:n.title,backgroundColor:n.backgroundColor||It.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:i.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,c.zoomLevelToZoomFactor)(n.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:n.alwaysOnTop});return o.setMenuBarVisibility(!1),o}async getSystemStatus(){const[a,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(a,s)}getWindowPosition(a,s,n){let o;const d=p.screen.getAllDisplays();if(d.length===1)o=d[0];else{if(I.isMacintosh){const L=p.screen.getCursorScreenPoint();o=p.screen.getDisplayNearestPoint(L)}!o&&a&&(o=p.screen.getDisplayMatching(a.getBounds())),o||(o=p.screen.getPrimaryDisplay()||d[0])}const v={width:s,height:n},M=o.bounds;return v.x=M.x+M.width/2-v.width/2,v.y=M.y+M.height/2-v.height/2,M.width>0&&M.height>0&&(v.x<M.x&&(v.x=M.x),v.y<M.y&&(v.y=M.y),v.x>M.x+M.width&&(v.x=M.x),v.y>M.y+M.height&&(v.y=M.y),v.width>M.width&&(v.width=M.width),v.height>M.height&&(v.height=M.height)),v}async getPerformanceInfo(){try{const[a,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(a,s)}catch(a){throw this.logService.warn("issueService#getPerformanceInfo ",a.message),a}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([ee(1,g.IEnvironmentMainService),ee(2,t.ILaunchMainService),ee(3,m.ILogService),ee(4,y.IDiagnosticsService),ee(5,b.IDialogMainService),ee(6,E.INativeHostMainService),ee(7,l.IProtocolMainService),ee(8,P.IProductService)],u),e.IssueMainService=u}),define(Q[237],J([0,1,23,19,24,20,6,53,22,50,30,41,77]),function(j,e,p,D,C,k,i,I,h,f,y,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let w=class extends g.AbstractUpdateService{constructor(m,E,S,P,l,c,u,r){super(m,E,P,l,c,r);this.telemetryService=S,this.nativeHostMainService=u}buildUpdateFeedUrl(m){return(0,g.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(b.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},p.CancellationToken.None).then(f.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const S=m?E.message||E:void 0;this.setState(b.State.Idle(1,S))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(b.State.Idle(1))}};w=he([ee(0,k.ILifecycleMainService),ee(1,D.IConfigurationService),ee(2,y.ITelemetryService),ee(3,C.IEnvironmentMainService),ee(4,f.IRequestService),ee(5,i.ILogService),ee(6,I.INativeHostMainService),ee(7,h.IProductService)],w),e.LinuxUpdateService=w}),define(Q[238],J([0,1,44,29,26,9,23,47,8,7,114,21,19,24,18,20,6,53,22,50,30,41,77]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l,c,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(d,v=1e3){for(;!d();)await(0,k.timeout)(v)}let s;function n(){return typeof s=="undefined"&&(s=D.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),s}let o=class extends r.AbstractUpdateService{constructor(v,M,L,A,W,H,Z,ne,oe){super(v,M,A,W,H,oe);this.telemetryService=L,this.fileService=Z,this.nativeHostMainService=ne}get cachePath(){const v=h.join((0,C.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return b.Promises.mkdir(v,{recursive:!0}).then(()=>v)}initialize(){super.initialize(),n()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(v){let M="win32";return process.arch!=="ia32"&&(M+=`-${process.arch}`),n()===1?M+="-archive":this.productService.target==="user"&&(M+="-user"),(0,r.createUpdateURL)(M,v,this.productService)}doCheckForUpdates(v){!this.url||(this.setState(u.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},i.CancellationToken.None).then(l.asJson).then(M=>{const L=n();return!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(u.State.Idle(L)),Promise.resolve(null)):L===1?(this.setState(u.State.AvailableForDownload(M)),Promise.resolve(null)):(this.setState(u.State.Downloading(M)),this.cleanup(M.version).then(()=>this.getUpdatePackagePath(M.version).then(A=>b.Promises.exists(A).then(W=>{if(W)return Promise.resolve(A);const H=M.url,Z=M.hash,ne=`${A}.tmp`;return this.requestService.request({url:H},i.CancellationToken.None).then(oe=>this.fileService.writeFile(f.URI.file(ne),oe.stream)).then(Z?()=>(0,y.checksum)(ne,M.hash):()=>{}).then(()=>b.Promises.rename(ne,A)).then(()=>A)})).then(A=>{const W=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},W&&M.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(M)):this.setState(u.State.Ready(M))})))}).then(void 0,M=>{this.logService.error(M),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const L=v?M.message||M:void 0;this.setState(u.State.Idle(n(),L))}))}async doDownloadUpdate(v){v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(u.State.Idle(n()))}async getUpdatePackagePath(v){const M=await this.cachePath;return h.join(M,`CodeSetup-${this.productService.quality}-${v}.exe`)}async cleanup(v=null){const M=v?H=>!new RegExp(`${this.productService.quality}-${v}\\.exe$`).test(H):()=>!0,L=await this.cachePath,W=(await b.Promises.readdir(L)).filter(M).map(async H=>{try{await b.Promises.unlink(h.join(L,H))}catch(Z){}});await Promise.all(W)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const v=this.state.update;this.setState(u.State.Updating(v));const M=await this.cachePath;this.availableUpdate.updateFilePath=h.join(M,`CodeSetup-${this.productService.quality}-${v.version}.flag`),await b.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(n()))});const A=`${this.productService.win32MutexName}-ready`,W=await new Promise((H,Z)=>{j(["windows-mutex"],H,Z)});a(()=>W.isActive(A)).then(()=>this.setState(u.State.Ready(v)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?D.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return n()}};he([I.memoize],o.prototype,"cachePath",null),o=he([ee(0,m.ILifecycleMainService),ee(1,g.IConfigurationService),ee(2,c.ITelemetryService),ee(3,w.IEnvironmentMainService),ee(4,l.IRequestService),ee(5,E.ILogService),ee(6,t.IFileService),ee(7,S.INativeHostMainService),ee(8,P.IProductService)],o),e.Win32UpdateService=o}),define(Q[239],J([0,1,14,9,23,45,4,34,2,10,8,63,3,7,154,51,19,52,24,54,205,18,20,6,22,57,100,30,208,66,67,36,27,46]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l,c,u,r,a,s,n,o,d,v,M,L,A,W,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Z;(function(oe){oe[oe.NONE=0]="NONE",oe[oe.LOADING=1]="LOADING",oe[oe.NAVIGATING=2]="NAVIGATING",oe[oe.READY=3]="READY"})(Z||(Z={}));let ne=class extends h.Disposable{constructor(G,T,z,q,U,N,_,Y,F,R,O,$,X,V,B){super();this.logService=T,this.environmentMainService=z,this.fileService=q,this.configurationService=N,this.themeMainService=_,this.workspacesManagementMainService=Y,this.backupMainService=F,this.telemetryService=R,this.dialogMainService=O,this.lifecycleMainService=$,this.productService=X,this.protocolMainService=V,this.windowsMainService=B,this._onWillLoad=this._register(new i.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new i.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new i.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new i.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[x,te]=this.restoreWindowState(G.state);this.windowState=x,this.logService.trace("window#ctor: using window state",x);const ce=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),ie={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:L.WindowMinimumSize.WIDTH,minHeight:L.WindowMinimumSize.HEIGHT,show:!ce,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,L.zoomLevelToZoomFactor)(se?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};g.isLinux?ie.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):g.isWindows&&!this.environmentMainService.isBuilt&&(ie.icon=(0,y.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),g.isMacintosh&&!this.useNativeFullScreen()&&(ie.fullscreenable=!1),g.isMacintosh&&(ie.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(ie.acceptFirstMouse=!1));const ae=g.isMacintosh&&se?.nativeTabs===!0;ae&&(ie.tabbingIdentifier=this.productService.nameShort);const ue=(0,L.getTitleBarStyle)(this.configurationService)==="custom";if(ue&&(ie.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,g.isMacintosh||(ie.frame=!1)),(0,b.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(ie),(0,b.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),g.isMacintosh&&ue&&this._win.setSheetOffset(22),g.isMacintosh&&te&&(!ae||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(de=>typeof de=="number")){const de=this.windowState;this._win.setBounds({width:de.width,height:de.height,x:de.x,y:de.y})}ce&&((0,b.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,c.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:x=>U.globalStorage.get(x),store:(x,te)=>U.globalStorage.set(x,te)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){g.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return g.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){g.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return g.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){g.isMacintosh&&G?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function T(){z.dispose(),q.dispose(),G()}const z=this.onDidClose(()=>T()),q=this.onWillLoad(()=>T())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(U,N)=>this.onWindowError(2,N)),this._win.webContents.on("did-fail-load",(U,N,_)=>this.onWindowError(3,{reason:_,exitCode:N})),this._win.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),T=U=>{for(let N=U;N;N=N.parent)if(N.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},z=U=>U.resourceType==="xhr"||T(U.frame);this._win.webContents.session.webRequest.onBeforeRequest((U,N)=>{const _=w.URI.parse(U.url);return _.path.endsWith(".svg")&&!G.has(_.scheme)?N({cancel:!z(U)}):N({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((U,N)=>{const _=U.responseHeaders,Y=_["content-type"]||_["Content-Type"];if(Y&&Array.isArray(Y)){const F=w.URI.parse(U.url);if(F.path.endsWith(".svg")&&G.has(F.scheme))return _["Content-Type"]=["image/svg+xml"],N({cancel:!1,responseHeaders:_});if(!F.path.includes(f.Schemas.vscodeRemoteResource)&&Y.some(R=>R.toLowerCase().includes("image/svg")))return N({cancel:!z(U)})}return N({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",U,this._win)}),this._win.on("unmaximize",U=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",U,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",C.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",C.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(U=>this.onDidDeleteUntitledWorkspace(U)));const q=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:q},async(U,N)=>{const _=await this.marketplaceHeadersPromise;N({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,_)})})}async onWindowError(G,T){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:T?.reason,code:T?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const z=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(z.response!==1){const q=z.response===0;this.destroyWindow(q)}}else if(G===2){let z;T?z=(0,t.localize)(6,null,T.reason,T.exitCode??"<unknown>"):z=(0,t.localize)(5,null);const U=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(8,null))],message:z,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(U)}break}}destroyWindow(G){if(this._onDidDestroy.fire(),this._win?.destroy(),G&&this.config){let T,z;(0,W.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?T={folderUri:this.openedWorkspace.uri}:(0,W.isWorkspaceIdentifier)(this.openedWorkspace)?T={workspaceUri:this.openedWorkspace.configPath}:z=!0;const[q]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:T?[T]:void 0,forceEmpty:z,forceNewWindow:!0});q.focus()}}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let T=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const z=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.currentHttpProxy||z!==this.currentNoProxy)){this.currentHttpProxy=T,this.currentNoProxy=z;const q=T||"",U=z?`${z},<local>`:"<local>";this.logService.trace(`Setting proxy to '${q}', bypassing '${U}'`),this._win.webContents.session.setProxy({proxyRules:q,proxyBypassRules:U,pacScript:""})}}addTabbedWindow(G){g.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,T=Object.create(null)){this.isDocumentEdited()&&(!T.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,T),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const z=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new D.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:T.isReload?3:z?2:1})}updateConfiguration(G,T){const z=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(z){const q=(0,l.isLaunchedFromCli)(z)&&!(0,l.isLaunchedFromCli)(G.userEnv),U=this.isExtensionDevelopmentHost;(q||U)&&(G.userEnv={...z,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(G["disable-extensions"]=T.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),G.perfMarks=(0,b.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const T=Object.assign({},this.currentConfig);T.workspace=await this.validateWorkspaceBeforeReload(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToWait,this.isExtensionDevelopmentHost&&G&&(T.verbose=G.verbose,T.debugId=G.debugId,T.extensionEnvironment=G.extensionEnvironment,T["inspect-extensions"]=G["inspect-extensions"],T["inspect-brk-extensions"]=G["inspect-brk-extensions"],T["extensions-dir"]=G["extensions-dir"]),T.isInitialStartup=!1,this.load(T,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,W.isWorkspaceIdentifier)(G.workspace)){const T=G.workspace.configPath;if(T.scheme===f.Schemas.file&&!await this.fileService.exists(T))return}else if((0,W.isSingleFolderWorkspaceIdentifier)(G.workspace)){const T=G.workspace.uri;if(T.scheme===f.Schemas.file&&!await this.fileService.exists(T))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,A.defaultWindowState)();if(this.isFullScreen){let z;try{z=p.screen.getDisplayMatching(this.getBounds())}catch(N){}const q=(0,A.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||q.width,height:this.windowState.height||q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let T;if(!g.isMacintosh&&this._win.isMaximized()?T=0:T=1,T===0?G.mode=0:G.mode=1,T===1||T===0){let z;T===1?z=this.getBounds():z=this._win.getNormalBounds(),G.x=z.x,G.y=z.y,G.width=z.width,G.height=z.height}return G}restoreWindowState(G){(0,b.mark)("code/willRestoreCodeWindowState");let T=!1;if(G)try{const z=p.screen.getAllDisplays();T=z.length>1,G=this.validateWindowState(G,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[G||(0,A.defaultWindowState)(),T]}validateWindowState(G,T){if(this.logService.trace(`window#validateWindowState: validating window state on ${T.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(T.length===1){const U=this.getWorkingArea(T[0]);if(U){let N=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!U||(G.x<U.x&&(G.x=U.x),G.y<U.y&&(G.y=U.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",U),N(),G.width>U.width&&(G.width=U.width),G.height>U.height&&(G.height=U.height),G.x>U.x+U.width-128&&(G.x=U.x+U.width-G.width),G.y>U.y+U.height-128&&(G.y=U.y+U.height-G.height),N()}return G}if(G.display&&G.mode===3){const U=T.find(N=>N.id===G.display);if(U&&typeof U.bounds?.x=="number"&&typeof U.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const N=(0,A.defaultWindowState)(3);return N.x=U.bounds.x,N.y=U.bounds.y,N}}let z,q;try{z=p.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),q=this.getWorkingArea(z)}catch(U){}if(z&&q&&G.x+G.width>q.x&&G.y+G.height>q.y&&G.x<q.x+q.width&&G.y<q.y+q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",q),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,T]=this._win.getPosition(),[z,q]=this._win.getSize();return{x:G,y:T,width:z,height:q}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",C.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,L.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,T=!0){g.isMacintosh||(G==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const T=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!T),this._win.autoHideMenuBar=T;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(g.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,T,...z){this.isReady?this.send(G,...z):this.ready().then(()=>{T.isCancellationRequested||this.send(G,...z)})}send(G,...T){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${G}' for window that is destroyed`);return}try{this._win.webContents.send(G,...T)}catch(z){this.logService.warn(`Error sending IPC message to channel '${G}' of window ${this._id}: ${(0,k.toErrorMessage)(z)}`)}}}updateTouchBar(G){!g.isMacintosh||this.touchBarGroups.forEach((T,z)=>{const q=G[z];T.segments=this.createTouchBarGroupSegments(q)})}createTouchBar(){if(!!g.isMacintosh){for(let G=0;G<10;G++){const T=this.createTouchBarGroup();this.touchBarGroups.push(T)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const T=this.createTouchBarGroupSegments(G),z=new p.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",C.CancellationToken.None,{id:z.segments[q].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(G=[]){return G.map(z=>{let q;z.icon&&!v.ThemeIcon.isThemeIcon(z.icon)&&z.icon?.dark?.scheme===f.Schemas.file&&(q=p.nativeImage.createFromPath(w.URI.revive(z.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let U;return typeof z.title=="string"?U=z.title:U=z.title.value,{id:z.id,label:q?void 0:U,icon:q}})}dispose(){super.dispose(),this._win=null}};ne=he([ee(1,a.ILogService),ee(2,P.IEnvironmentMainService),ee(3,u.IFileService),ee(4,o.IStorageMainService),ee(5,E.IConfigurationService),ee(6,M.IThemeMainService),ee(7,H.IWorkspacesManagementMainService),ee(8,m.IBackupMainService),ee(9,d.ITelemetryService),ee(10,S.IDialogMainService),ee(11,r.ILifecycleMainService),ee(12,s.IProductService),ee(13,n.IProtocolMainService),ee(14,A.IWindowsMainService)],ne),e.CodeWindow=ne}),define(Q[68],J([0,1,14,31,9,4,34,2,10,3,15,7,21,157,5,20,6,38,27,46]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let c=class $e extends I.Disposable{constructor(r,a,s,n){super();this.stateMainService=r,this.logService=a,this.workspacesManagementMainService=s,this.lifecycleMainService=n,this._onDidChangeRecentlyOpened=this._register(new k.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new C.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace}])))}handleWindowsJumpList(){!f.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(r){const a=[],s=[];for(let n of r)if((0,P.isRecentWorkspace)(n))!this.workspacesManagementMainService.isUntitledWorkspace(n.workspace)&&this.indexOfWorkspace(a,n.workspace)===-1&&a.push(n);else if((0,P.isRecentFolder)(n))this.indexOfFolder(a,n.folderUri)===-1&&a.push(n);else{const o=this.indexOfFile(s,n.fileUri)>=0,d=n.fileUri.scheme===h.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,y.basename)(n.fileUri))>=0;!o&&!d&&(s.push(n),f.isWindows&&n.fileUri.scheme===h.Schemas.file&&p.app.addRecentDocument(n.fileUri.fsPath))}this.addEntriesFromStorage(a,s),a.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(a.length=$e.MAX_TOTAL_RECENT_ENTRIES),s.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(s.length=$e.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:a,files:s}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(r){const a=d=>{const v=this.location(d);for(const M of r)if(y.extUriBiasedIgnorePathCase.isEqual(M,v))return!1;return!0},s=this.getRecentlyOpened(),n=s.workspaces.filter(a),o=s.files.filter(a);(n.length!==s.workspaces.length||o.length!==s.files.length)&&(this.saveRecentlyOpened({files:o,workspaces:n}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!f.isMacintosh)return;p.app.clearRecentDocuments();const r=this.getRecentlyOpened(),a=[];let s=0;for(let o=0;o<r.workspaces.length&&s<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;o++){const d=this.location(r.workspaces[o]);if(d.scheme===h.Schemas.file){const v=(0,y.originalFSPath)(d);await g.Promises.exists(v)&&(a.push(v),s++)}}const n=[];for(let o=0;o<r.files.length&&s<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;o++){const d=this.location(r.files[o]);if(d.scheme===h.Schemas.file){const v=(0,y.originalFSPath)(d);if($e.COMMON_FILES_FILTER.includes((0,y.basename)(d))||a.includes(v))continue;await g.Promises.exists(v)&&(n.push(v),s++)}}n.reverse().forEach(o=>p.app.addRecentDocument(o)),a.reverse().forEach(o=>p.app.addRecentDocument(o))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(r){const a=[],s=[],n=r?.config?.workspace;(0,P.isWorkspaceIdentifier)(n)&&!this.workspacesManagementMainService.isUntitledWorkspace(n)?a.push({workspace:n}):(0,P.isSingleFolderWorkspaceIdentifier)(n)&&a.push({folderUri:n.uri});const o=r?.config?.filesToOpenOrCreate;if(o)for(let d of o){const v=d.fileUri;v&&this.indexOfFile(s,v)===-1&&s.push({fileUri:v})}return this.addEntriesFromStorage(a,s),{workspaces:a,files:s}}addEntriesFromStorage(r,a){let s=this.getRecentlyOpenedFromStorage();for(let n of s.workspaces){let o=(0,P.isRecentFolder)(n)?this.indexOfFolder(r,n.folderUri):this.indexOfWorkspace(r,n.workspace);o>=0?r[o].label=r[o].label||n.label:r.push(n)}for(let n of s.files){let o=this.indexOfFile(a,n.fileUri);o>=0?a[o].label=a[o].label||n.label:a.push(n)}}getRecentlyOpenedFromStorage(){const r=this.stateMainService.getItem($e.recentlyOpenedStorageKey);return(0,P.restoreRecentlyOpened)(r,this.logService)}saveRecentlyOpened(r){const a=(0,P.toStoreData)(r);this.stateMainService.setItem($e.recentlyOpenedStorageKey,a)}updateWindowsJumpList(){if(!f.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,w.localize)(0,null),description:(0,w.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let a=[];for(let o of p.app.getJumpListSettings().removedItems){const d=o.args;if(d){const v=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(d);v&&a.push(b.URI.parse(v[2]))}}this.removeRecentlyOpened(a);let s=!1;const n=(0,D.coalesce)(this.getRecentlyOpened().workspaces.slice(0,$e.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(o=>{const d=(0,P.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:v,description:M}=this.getWindowsJumpListLabel(d,o.label);let L;return b.URI.isUri(d)?L=`--folder-uri "${d.toString()}"`:(s=!0,L=`--file-uri "${d.configPath.toString()}"`),{type:"task",title:v.substr(0,255),description:M.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));n.length>0&&r.push({type:"custom",name:s?(0,w.localize)(2,null):(0,w.localize)(3,null),items:n})}r.push({type:"recent"});try{p.app.setJumpList(r)}catch(a){this.logService.warn("updateWindowsJumpList#setJumpList",a)}}getWindowsJumpListLabel(r,a){if(a)return{title:(0,i.splitName)(a).name,description:a};if(b.URI.isUri(r))return{title:(0,y.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,w.localize)(4,null),description:""};let s=(0,y.basename)(r.configPath);return s.endsWith(P.WORKSPACE_EXTENSION)&&(s=s.substr(0,s.length-P.WORKSPACE_EXTENSION.length-1)),{title:(0,w.localize)(5,null,s),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,i.normalizeDriveLetter)(r.fsPath):r.toString()}location(r){return(0,P.isRecentFolder)(r)?r.folderUri:(0,P.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,a){return r.findIndex(s=>(0,P.isRecentWorkspace)(s)&&s.workspace.id===a.id)}indexOfFolder(r,a){return r.findIndex(s=>(0,P.isRecentFolder)(s)&&y.extUriBiasedIgnorePathCase.isEqual(s.folderUri,a))}indexOfFile(r,a){return r.findIndex(s=>y.extUriBiasedIgnorePathCase.isEqual(s.fileUri,a))}};c.MAX_TOTAL_RECENT_ENTRIES=500,c.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,c.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,c.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,c.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],c.recentlyOpenedStorageKey="openedPathsList",c=he([ee(0,S.IStateMainService),ee(1,E.ILogService),ee(2,l.IWorkspacesManagementMainService),ee(3,m.ILifecycleMainService)],c),e.WorkspacesHistoryMainService=c}),define(Q[240],J([0,1,14,9,23,34,3,7,149,19,24,20,6,187,53,22,38,30,41,67,36,68]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const r="menu";let a=class vt{constructor(o,d,v,M,L,A,W,H,Z,ne,oe){this.updateService=o,this.configurationService=d,this.windowsMainService=v,this.environmentMainService=M,this.telemetryService=L,this.workspacesHistoryMainService=A,this.stateMainService=W,this.lifecycleMainService=H,this.logService=Z,this.nativeHostMainService=ne,this.productService=oe,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new D.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new D.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(i.isMacintosh||(0,l.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(vt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,W,H)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,W,H)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:W?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,W,H)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(H),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,W,H)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(H),telemetryExtraData:{from:r}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const d=this.productService.requestFeatureUrl;d&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(d,"openUserVoiceUrl"));const v=this.productService.reportIssueUrl;v&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(v,"openReportIssues"));const M=this.productService.licenseUrl;M&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(i.language){const A=M.indexOf("?")>0?"&":"?";this.openUrl(`${M}${A}lang=${i.language}`,"openLicenseUrl")}else this.openUrl(M,"openLicenseUrl")});const L=this.productService.privacyStatementUrl;L&&M&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(L,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!i.isMacintosh)return!1;let o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,d){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(vt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!i.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!i.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=p.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(i.isMacintosh?new p.Menu:null);return}const d=new p.Menu;let v;if(i.isMacintosh){const L=new p.Menu;v=new p.MenuItem({label:this.productService.nameShort,submenu:L}),this.setMacApplicationMenu(L),d.append(v)}if(i.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const L=new p.Menu;L.append(new p.MenuItem({label:this.mnemonicLabel(h.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(L)}if(this.shouldDrawMenu("File")){const L=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(1,null)),submenu:L});this.setMenuById(L,"File"),d.append(A)}if(this.shouldDrawMenu("Edit")){const L=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(2,null)),submenu:L});this.setMenuById(L,"Edit"),d.append(A)}if(this.shouldDrawMenu("Selection")){const L=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(3,null)),submenu:L});this.setMenuById(L,"Selection"),d.append(A)}if(this.shouldDrawMenu("View")){const L=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(4,null)),submenu:L});this.setMenuById(L,"View"),d.append(A)}if(this.shouldDrawMenu("Go")){const L=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(5,null)),submenu:L});this.setMenuById(L,"Go"),d.append(A)}if(this.shouldDrawMenu("Run")){const L=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(6,null)),submenu:L});this.setMenuById(L,"Run"),d.append(A)}if(this.shouldDrawMenu("Terminal")){const L=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(7,null)),submenu:L});this.setMenuById(L,"Terminal"),d.append(A)}let M;if(this.shouldDrawMenu("Window")){const L=new p.Menu;M=new p.MenuItem({label:this.mnemonicLabel(h.localize(8,null)),submenu:L,role:"window"}),this.setMacWindowMenu(L)}if(M&&d.append(M),this.shouldDrawMenu("Help")){const L=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(h.localize(9,null)),submenu:L,role:"help"});this.setMenuById(L,"Help"),d.append(A)}d.items&&d.items.length>0?p.Menu.setApplicationMenu(d):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const d=this.createMenuItem(h.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),v=this.getUpdateMenuItems();let M;if(this.shouldDrawMenu("Preferences")){const G=new p.Menu;this.setMenuById(G,"Preferences"),M=new p.MenuItem({label:this.mnemonicLabel(h.localize(11,null)),submenu:G})}const L=new p.Menu,A=new p.MenuItem({label:h.localize(12,null),role:"services",submenu:L}),W=new p.MenuItem({label:h.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),H=new p.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Z=new p.MenuItem({label:h.localize(15,null),role:"unhide"}),ne=new p.MenuItem(this.likeAction("workbench.action.quit",{label:h.localize(16,null,this.productService.nameLong),click:()=>{const G=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),oe=[d];oe.push(...v),M&&oe.push(s(),M),oe.push(s(),A,s(),W,H,Z,s(),ne),oe.forEach(G=>o.append(G))}shouldDrawMenu(o){if(!i.isMacintosh&&(0,l.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(i.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(i.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,d){d.forEach(v=>{if((0,w.isMenubarMenuItemSeparator)(v))o.append(s());else if((0,w.isMenubarMenuItemSubmenu)(v)){const M=new p.Menu,L=new p.MenuItem({label:this.mnemonicLabel(v.label),submenu:M});this.setMenu(M,v.submenu.items),o.append(L)}else(0,w.isMenubarMenuItemRecentAction)(v)?o.append(this.createOpenRecentMenuItem(v)):(0,w.isMenubarMenuItemAction)(v)&&(v.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),i.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[v.id]?o.append(new p.MenuItem(this.likeAction(v.id,{label:this.mnemonicLabel(v.label),click:this.fallbackMenuHandlers[v.id]}))):o.append(this.createMenuItem(v.label,v.id,!1,v.checked)):o.append(this.createMenuItem(v.label,v.id,v.enabled!==!1,!!v.checked)):o.append(this.createMenuItem(v.label,v.id,v.enabled!==!1,!!v.checked)))})}setMenuById(o,d){this.menubarMenus&&this.menubarMenus[d]&&this.setMenu(o,this.menubarMenus[d].items)}insertCheckForUpdatesItems(o){const d=this.getUpdateMenuItems();d.length&&(d.forEach(v=>o.append(v)),o.append(s()))}createOpenRecentMenuItem(o){const d=I.URI.revive(o.uri),v=o.id,M=v==="openRecentFile"?{fileUri:d}:v==="openRecentWorkspace"?{workspaceUri:d}:{folderUri:d};return new p.MenuItem(this.likeAction(v,{label:o.label,click:(L,A,W)=>{const H=this.isOptionClick(W);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[M],forceNewWindow:H,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([d])}},!1))}isOptionClick(o){return!!(o&&(!i.isMacintosh&&(o.ctrlKey||o.shiftKey)||i.isMacintosh&&(o.metaKey||o.altKey)))}createRoleMenuItem(o,d,v){const M={label:this.mnemonicLabel(o),role:v,enabled:!0};return new p.MenuItem(this.withKeybinding(d,M))}setMacWindowMenu(o){const d=new p.MenuItem({label:h.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),v=new p.MenuItem({label:h.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),M=new p.MenuItem({label:h.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),L=this.createMenuItem(h.localize(20,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(s()),A.push(this.createMenuItem(h.localize(21,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(h.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(h.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(h.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(h.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[d,v,s(),L,...A,s(),M].forEach(W=>o.append(W))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:h.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:h.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:h.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(h.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,d,v,M){const L=this.mnemonicLabel(o),A=typeof d=="function"?d:(oe,G,T)=>{const z=oe?oe.userSettingsLabel:null;let q=d;Array.isArray(d)&&(q=this.isOptionClick(T)?d[1]:d[0]),z&&T.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:z}):this.runActionInRenderer({type:"commandId",commandId:q})},W=typeof v=="boolean"?v:this.windowsMainService.getWindowCount()>0,H=typeof M=="boolean"?M:!1,Z={label:L,click:A,enabled:W};H&&(Z.type="checkbox",Z.checked=H);let ne;return typeof d=="string"?ne=d:Array.isArray(d)&&(ne=d[0]),i.isMacintosh&&(ne==="editor.action.clipboardCutAction"?Z.role="cut":ne==="editor.action.clipboardCopyAction"?Z.role="copy":ne==="editor.action.clipboardPasteAction"&&(Z.role="paste"),ne==="undo"?Z.click=this.makeContextAwareClickHandler(A,{inDevTools:oe=>oe.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?Z.click=this.makeContextAwareClickHandler(A,{inDevTools:oe=>oe.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(Z.click=this.makeContextAwareClickHandler(A,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(ne,Z))}makeContextAwareClickHandler(o,d){return(v,M,L)=>{const A=p.BrowserWindow.getFocusedWindow();if(!A)return d.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return d.inDevTools(A.webContents.devToolsWebContents);o(v,M||A,L)}}runActionInRenderer(o){let d=p.BrowserWindow.getFocusedWindow();if(!d){const M=this.windowsMainService.getLastActiveWindow();M?.isMinimized()&&(d=M.win)}const v=d?this.windowsMainService.getWindowById(d.id):void 0;if(v){if(this.logService.trace("menubar#runActionInRenderer",o),i.isMacintosh&&!this.environmentMainService.isBuilt&&!v.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const M={id:o.commandId,from:"menu"};v.sendWhenReady("vscode:runAction",C.CancellationToken.None,M)}else{const M={userSettingsLabel:o.userSettingsLabel};v.sendWhenReady("vscode:runKeybinding",C.CancellationToken.None,M)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,d){const v=typeof o=="string"?this.keybindings[o]:void 0;if(v?.label){if(v.isNative!==!1)d.accelerator=v.label,d.userSettingsLabel=v.userSettingsLabel;else if(typeof d.label=="string"){const M=d.label.indexOf("[");M>=0?d.label=`${d.label.substr(0,M)} [${v.label}]`:d.label=`${d.label} [${v.label}]`}}else d.accelerator=void 0;return d}likeAction(o,d,v=!d.accelerator){v&&(d=this.withKeybinding(o,d));const M=d.click;return d.click=(L,A,W)=>{this.reportMenuActionTelemetry(o),M&&M(L,A,W)},d}openUrl(o,d){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(d)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:r})}mnemonicLabel(o){return(0,k.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};a.lastKnownMenubarStorageKey="lastKnownMenubarData",a=he([ee(0,P.IUpdateService),ee(1,f.IConfigurationService),ee(2,c.IWindowsMainService),ee(3,y.IEnvironmentMainService),ee(4,S.ITelemetryService),ee(5,u.IWorkspacesHistoryMainService),ee(6,E.IStateMainService),ee(7,b.ILifecycleMainService),ee(8,g.ILogService),ee(9,t.INativeHostMainService),ee(10,m.IProductService)],a),e.Menubar=a;function s(){return new p.MenuItem({type:"separator"})}}),define(Q[241],J([0,1,5,20,6,240]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let i=class{constructor(h,f,y){this.instantiationService=h,this.lifecycleMainService=f,this.logService=y,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(k.Menubar)}async updateMenubar(h,f){this.logService.trace("menubarService#updateMenubar",h),(await this.menubar).updateMenu(f,h)}};i=he([ee(0,p.IInstantiationService),ee(1,D.ILifecycleMainService),ee(2,C.ILogService)],i),e.MenubarMainService=i}),define(Q[242],J([0,1,14,29,26,31,23,4,33,42,34,2,10,8,63,3,32,15,13,7,155,51,19,52,24,18,5,20,6,56,22,57,64,38,67,239,101,221,27,102,68,46]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l,c,u,r,a,s,n,o,d,v,M,L,A,W,H,Z,ne,oe,G,T,z,q,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(F){return(0,T.isWorkspaceIdentifier)(F?.workspace)}function _(F){return(0,T.isSingleFolderWorkspaceIdentifier)(F?.workspace)}let Y=class xe extends b.Disposable{constructor(R,O,$,X,V,B,x,te,ce,se,ie,ae,ue,de,ve){super();this.machineId=R,this.initialUserEnv=O,this.logService=$,this.stateMainService=X,this.environmentMainService=V,this.lifecycleMainService=B,this.backupMainService=x,this.configurationService=te,this.workspacesHistoryMainService=ce,this.workspacesManagementMainService=se,this.instantiationService=ie,this.dialogMainService=ae,this.fileService=ue,this.productService=de,this.protocolMainService=ve,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new G.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(R=>this._onDidSignalReadyWindow.fire(R.window))),this._register(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const O=new b.DisposableStore;if(O.add(I.Event.any(R.onDidClose,R.onDidDestroy)(()=>O.dispose())),R.config.extensionDevelopmentPath)for(const $ of R.config.extensionDevelopmentPath)O.add(this.protocolMainService.addValidFileRoot(l.URI.file($)));R.config.extensionTestsPath&&O.add(this.protocolMainService.addValidFileRoot(l.URI.file(R.config.extensionTestsPath)))}}))}openEmptyWindow(R,O){let $=this.environmentMainService.args;const X=O?.remoteAuthority||void 0,V=!0,B=O?.forceReuseWindow,x=!B;return this.open({...R,cli:$,forceEmpty:V,forceNewWindow:x,forceReuseWindow:B,remoteAuthority:X})}openExistingWindow(R,O){R.focus(),this.handleWaitMarkerFile(O,[R])}open(R){this.logService.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const O=[],$=[],X=[],V=[],B=[];let x,te=0;const ce=this.getPathsToOpen(R);this.logService.trace("windowsManager#open pathsToOpen",ce);for(const ue of ce)_(ue)?R.addMode?O.push(ue):$.push(ue):N(ue)?X.push(ue):ue.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ue.remoteAuthority}),x.filesToOpenOrCreate.push(ue)):ue.backupPath?B.push({backupFolder:(0,w.basename)(ue.backupPath),remoteAuthority:ue.remoteAuthority}):te++;R.diffMode&&x&&x.filesToOpenOrCreate.length>=2&&(x.filesToDiff=x.filesToOpenOrCreate.slice(0,2),x.filesToOpenOrCreate=[]),x&&R.waitMarkerFileURI&&(x.filesToWait={paths:[...x.filesToDiff,...x.filesToOpenOrCreate],waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(V.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),X.push(...V),B.push(...this.backupMainService.getEmptyWindowBackupPaths())):B.length=0;const{windows:se,filesOpenedInWindow:ie}=this.doOpen(R,X,$,B,te,x,O);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${X.length}, foldersToOpen: ${$.length}, emptyToRestore: ${B.length}, emptyToOpen: ${te})`),se.length>1)if(ie)ie.focus();else{const ue=this.windowsStateHandler.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let de=!0,ve=!0;if(ue){const Pe=se.filter(pe=>this.windowsStateHandler.state.lastActiveWindow&&pe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Pe.length&&(Pe[0].focus(),de=!1,ve=!1)}if(de)for(let Pe=se.length-1;Pe>=0;Pe--){const pe=se[Pe];if(!(pe.openedWorkspace&&V.some(ge=>pe.openedWorkspace&&ge.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&B.some(ge=>pe.backupPath&&ge.backupFolder===(0,w.basename)(pe.backupPath)))){pe.focus(),ve=!1;break}}ve&&se[se.length-1].focus()}const ae=x&&x.filesToDiff.length>0;if(!se.some(ue=>ue.isExtensionDevelopmentHost)&&!ae&&!R.noRecentEntry){const ue=[];for(const de of ce)N(de)&&!de.transient?ue.push({label:de.label,workspace:de.workspace,remoteAuthority:de.remoteAuthority}):_(de)?ue.push({label:de.label,folderUri:de.workspace.uri,remoteAuthority:de.remoteAuthority}):de.fileUri&&ue.push({label:de.label,fileUri:de.fileUri,remoteAuthority:de.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ue)}return this.handleWaitMarkerFile(R,se),se}handleWaitMarkerFile(R,O){const $=R.waitMarkerFileURI;R.context===0&&$&&O.length===1&&O[0]&&(async()=>{await O[0].whenClosedOrLoaded;try{await this.fileService.del($)}catch(X){}})()}doOpen(R,O,$,X,V,B,x){const te=[];let ce;function se(pe,ge){te.push(pe),ge&&(ce=pe,B=void 0)}let{openFolderInNewWindow:ie,openFilesInNewWindow:ae}=this.shouldOpenNewWindow(R);if(!R.initialStartup&&x.length>0){const pe=x[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(pe);ge&&se(this.doAddFoldersToExistingWindow(ge,x.map(be=>be.workspace.uri)))}const ue=$.length+O.length+X.length;if(B&&ue===0){const pe=B.filesToOpenOrCreate[0]||B.filesToDiff[0],ge=this.getWindows().filter(ke=>B&&(0,S.isEqualAuthority)(ke.remoteAuthority,B.remoteAuthority));let be;pe?.fileUri&&!ae&&((R.context===4||R.context===0||R.context===1)&&(be=(0,oe.findWindowOnFile)(ge,pe.fileUri,ke=>ke.configPath.scheme===g.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),be||(be=this.doGetLastActiveWindow(ge))),be?(0,T.isWorkspaceIdentifier)(be.openedWorkspace)?O.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,T.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?$.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):se(this.doOpenFilesInExistingWindow(R,be,B),!0):se(this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow}),!0)}const de=(0,k.distinct)(O,pe=>pe.workspace.id);if(de.length>0){const pe=(0,k.coalesce)(de.map(ge=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(pe.length>0){const ge=pe[0],be=(0,S.isEqualAuthority)(B?.remoteAuthority,ge.remoteAuthority)?B:void 0;se(this.doOpenFilesInExistingWindow(R,ge,be),!!be),ie=!0}de.forEach(ge=>{if(pe.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===ge.workspace.id))return;const be=ge.remoteAuthority,ke=(0,S.isEqualAuthority)(B?.remoteAuthority,be)?B:void 0;se(this.doOpenFolderOrWorkspace(R,ge,ie,ke),!!ke),ie=!0})}const ve=(0,k.distinct)($,pe=>S.extUriBiasedIgnorePathCase.getComparisonKey(pe.workspace.uri));if(ve.length>0){const pe=(0,k.coalesce)(ve.map(ge=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(pe.length>0){const ge=pe[0],be=(0,S.isEqualAuthority)(B?.remoteAuthority,ge.remoteAuthority)?B:void 0;se(this.doOpenFilesInExistingWindow(R,ge,be),!!be),ie=!0}ve.forEach(ge=>{if(pe.some(Ae=>(0,T.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,ge.workspace.uri)))return;const be=ge.remoteAuthority,ke=(0,S.isEqualAuthority)(B?.remoteAuthority,be)?B:void 0;se(this.doOpenFolderOrWorkspace(R,ge,ie,ke),!!ke),ie=!0})}const Pe=(0,k.distinct)(X,pe=>pe.backupFolder);if(Pe.length>0&&Pe.forEach(pe=>{const ge=pe.remoteAuthority,be=(0,S.isEqualAuthority)(B?.remoteAuthority,ge)?B:void 0;se(this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:be,remoteAuthority:ge,forceNewWindow:!0,forceNewTabbedWindow:R.forceNewTabbedWindow,emptyWindowBackupInfo:pe}),!!be),ie=!0}),te.length===0||B){B&&!V&&V++;const pe=B?B.remoteAuthority:R.remoteAuthority;for(let ge=0;ge<V;ge++)se(this.doOpenEmpty(R,ie,pe,B),!!B),ie=!0}return{windows:(0,k.distinct)(te),filesOpenedInWindow:ce}}doOpenFilesInExistingWindow(R,O,$){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),O.focus();const X={filesToOpenOrCreate:$?.filesToOpenOrCreate,filesToDiff:$?.filesToDiff,filesToWait:$?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return O.sendWhenReady("vscode:openFiles",i.CancellationToken.None,X),O}doAddFoldersToExistingWindow(R,O){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),R.focus();const $={foldersToAdd:O};return R.sendWhenReady("vscode:addFolders",i.CancellationToken.None,$),R}doOpenEmpty(R,O,$,X,V){return!O&&!V&&typeof R.contextWindowId=="number"&&(V=this.getWindowById(R.contextWindowId)),this.openInBrowserWindow({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:$,forceNewWindow:O,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:X,windowToUse:V})}doOpenFolderOrWorkspace(R,O,$,X,V){return!$&&!V&&typeof R.contextWindowId=="number"&&(V=this.getWindowById(R.contextWindowId)),this.openInBrowserWindow({workspace:O.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:O.remoteAuthority,forceNewWindow:$,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:X,windowToUse:V})}getPathsToOpen(R){let O,$=!1,X=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(O=this.doExtractPathsFromAPI(R),$=!0):R.forceEmpty?O=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(O=this.doExtractPathsFromCLI(R.cli),O.length===0&&O.push(Object.create(null)),$=!0):(O=this.doGetPathsFromLastSession(),O.length===0&&O.push(Object.create(null)),X=!0),!R.addMode&&$){const V=O.filter(B=>_(B));if(V.length>1){const B=V[0].remoteAuthority;if(V.every(x=>(0,S.isEqualAuthority)(x.remoteAuthority,B))){const x=this.workspacesManagementMainService.createUntitledWorkspaceSync(V.map(te=>({uri:te.workspace.uri})));O.push({workspace:x,remoteAuthority:B}),O=O.filter(te=>!_(te))}}}return R.initialStartup&&!X&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&O.unshift(...this.doGetPathsFromLastSession().filter(V=>N(V)||_(V)||V.backupPath)),O}doExtractPathsFromAPI(R){const O=[],$={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority};for(const X of(0,k.coalesce)(R.urisToOpen||[])){const V=this.resolveOpenable(X,$);if(V)V.label=X.label,O.push(V);else{const B=this.resourceFromOpenable(X),x={title:this.productService.nameLong,type:"info",buttons:[(0,y.mnemonicButtonLabel)((0,c.localize)(0,null))],defaultId:0,message:B.scheme===g.Schemas.file?(0,c.localize)(1,null):(0,c.localize)(2,null),detail:B.scheme===g.Schemas.file?(0,c.localize)(3,null,(0,y.getPathLabel)(B.fsPath,this.environmentMainService)):(0,c.localize)(4,null,B.toString()),noLink:!0};this.dialogMainService.showMessageBox(x,(0,P.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return O}doExtractPathsFromCLI(R){const O=[],$={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:!1},X=R["folder-uri"];if(X)for(const x of X){const te=this.cliArgToUri(x);if(te){const ce=this.resolveOpenable({folderUri:te},$);ce&&O.push(ce)}}const V=R["file-uri"];if(V)for(const x of V){const te=this.cliArgToUri(x);if(te){const ce=this.resolveOpenable((0,T.hasWorkspaceFileExtension)(x)?{workspaceUri:te}:{fileUri:te},$);ce&&O.push(ce)}}const B=R._;for(const x of B){const te=$.remoteAuthority?this.doResolvePathRemote(x,$):this.doResolveFilePath(x,$);te&&O.push(te)}return O}cliArgToUri(R){try{const O=l.URI.parse(R);if(!O.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${R}`);return}return O}catch(O){this.logService.error(`Invalid URI input string: ${R}, ${O.message}`)}}doGetPathsFromLastSession(){const R=this.getRestoreWindowsSetting();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":const O=[];R!=="one"&&O.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&O.push(this.windowsStateHandler.state.lastActiveWindow);const $=[];for(const X of O)if(X.workspace){const V=this.resolveOpenable({workspaceUri:X.workspace.configPath},{remoteAuthority:X.remoteAuthority,rejectTransientWorkspaces:!0});N(V)&&$.push(V)}else if(X.folderUri){const V=this.resolveOpenable({folderUri:X.folderUri},{remoteAuthority:X.remoteAuthority});_(V)&&$.push(V)}else R!=="folders"&&X.backupPath&&$.push({backupPath:X.backupPath,remoteAuthority:X.remoteAuthority});return $}}getRestoreWindowsSetting(){let R;return this.lifecycleMainService.wasRestarted?R="all":(R=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}resolveOpenable(R,O=Object.create(null)){let $=this.resourceFromOpenable(R);return $.scheme===g.Schemas.file?((0,Z.isFileToOpen)(R)&&(O={...O,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath($.fsPath,O)):this.doResolveRemoteOpenable(R,O)}doResolveRemoteOpenable(R,O){let $=this.resourceFromOpenable(R);const X=(0,W.getRemoteAuthority)($)||O.remoteAuthority;if($=(0,S.removeTrailingPathSeparator)((0,S.normalizePath)($)),(0,Z.isFileToOpen)(R)){if(O.gotoLineMode){const{path:V,line:B,column:x}=(0,h.parseLineAndColumnAware)($.path);return{fileUri:$.with({path:V}),selection:B?{startLineNumber:B,startColumn:x||1}:void 0,remoteAuthority:X}}return{fileUri:$,remoteAuthority:X}}else if((0,Z.isWorkspaceToOpen)(R))return{workspace:(0,z.getWorkspaceIdentifier)($),remoteAuthority:X};return{workspace:(0,z.getSingleFolderWorkspaceIdentifier)($),remoteAuthority:X}}resourceFromOpenable(R){return(0,Z.isWorkspaceToOpen)(R)?R.workspaceUri:(0,Z.isFolderToOpen)(R)?R.folderUri:R.fileUri}doResolveFilePath(R,O){let $,X;O.gotoLineMode&&({path:R,line:$,column:X}=(0,h.parseLineAndColumnAware)(R)),R=(0,h.sanitizeFilePath)((0,w.normalize)(R),(0,E.cwd)());try{const V=(0,D.statSync)(R);if(V.isFile()){if(!O.forceOpenWorkspaceAsFile){const B=this.workspacesManagementMainService.resolveLocalWorkspaceSync(l.URI.file(R));if(B)return B.transient&&O.rejectTransientWorkspaces?void 0:{workspace:{id:B.id,configPath:B.configPath},type:n.FileType.File,exists:!0,remoteAuthority:B.remoteAuthority,transient:B.transient}}return{fileUri:l.URI.file(R),type:n.FileType.File,exists:!0,selection:$?{startLineNumber:$,startColumn:X||1}:void 0}}else{if(V.isDirectory())return{workspace:(0,z.getSingleFolderWorkspaceIdentifier)(l.URI.file(R),V),type:n.FileType.Directory,exists:!0};if(!m.isWindows&&R==="/dev/null")return{fileUri:l.URI.file(R),type:n.FileType.File,exists:!0}}}catch(V){const B=l.URI.file(R);if(this.workspacesHistoryMainService.removeRecentlyOpened([B]),O.ignoreFileNotFound)return{fileUri:B,type:n.FileType.File,exists:!1}}}doResolvePathRemote(R,O){const $=R.charCodeAt(0),X=O.remoteAuthority;let V,B;O.gotoLineMode&&({path:R,line:V,column:B}=(0,h.parseLineAndColumnAware)(R)),$!==47&&((0,h.isWindowsDriveLetter)($)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,h.toSlashes)(R)),R=`/${R}`);const x=l.URI.from({scheme:g.Schemas.vscodeRemote,authority:X,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,T.hasWorkspaceFileExtension)(R))return O.forceOpenWorkspaceAsFile?{fileUri:x,selection:V?{startLineNumber:V,startColumn:B||1}:void 0,remoteAuthority:O.remoteAuthority}:{workspace:(0,z.getWorkspaceIdentifier)(x),remoteAuthority:X};if(O.gotoLineMode||w.posix.basename(R).indexOf(".")!==-1)return{fileUri:x,selection:V?{startLineNumber:V,startColumn:B||1}:void 0,remoteAuthority:X}}return{workspace:(0,z.getSingleFolderWorkspaceIdentifier)(x),remoteAuthority:X}}shouldOpenNewWindow(R){const O=this.configurationService.getValue("window"),$=O?.openFoldersInNewWindow||"default",X=O?.openFilesInNewWindow||"off";let V=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&($==="on"||$==="off")&&(V=$==="on");let B=!1;return R.forceNewWindow||R.forceReuseWindow?B=!!R.forceNewWindow&&!R.forceReuseWindow:(m.isMacintosh?R.context===1&&(B=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!R.cli.extensionDevelopmentPath&&(X==="on"||X==="off")&&(B=X==="on")),{openFolderInNewWindow:!!V,openFilesInNewWindow:B}}openExtensionDevelopmentHostWindow(R,O){const $=(0,oe.findWindowOnExtensionDevelopmentPath)(this.getWindows(),R);if($)return this.lifecycleMainService.reload($,O.cli),$.focus(),[$];let X=O.cli["folder-uri"]||[],V=O.cli["file-uri"]||[],B=O.cli._;if(!B.length&&!X.length&&!V.length&&!O.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ie=se&&(se.workspace||se.folderUri);ie&&(l.URI.isUri(ie)?ie.scheme===g.Schemas.file?B=[ie.fsPath]:X=[ie.toString()]:ie.configPath.scheme===g.Schemas.file?B=[(0,S.originalFSPath)(ie.configPath)]:V=[ie.configPath.toString()])}let x=O.remoteAuthority;for(const se of R)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ie=l.URI.parse(se),ae=(0,W.getRemoteAuthority)(ie);ae&&(x?ae!==x&&this.logService.error("more than one extension development path authority"):x=ae)}B=B.filter(se=>{const ie=l.URI.file(se);return(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:(0,S.isEqualAuthority)((0,W.getRemoteAuthority)(ie),x)}),X=X.filter(se=>{const ie=this.cliArgToUri(se);return ie&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,S.isEqualAuthority)((0,W.getRemoteAuthority)(ie),x):!1}),V=V.filter(se=>{const ie=this.cliArgToUri(se);return ie&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),ie)?!1:ie?(0,S.isEqualAuthority)((0,W.getRemoteAuthority)(ie),x):!1}),O.cli._=B,O.cli["folder-uri"]=X,O.cli["file-uri"]=V;const te=!B.length&&!X.length&&!V.length,ce={context:O.context,cli:O.cli,forceNewWindow:!0,forceEmpty:te,userEnv:O.userEnv,noRecentEntry:!0,waitMarkerFileURI:O.waitMarkerFileURI,remoteAuthority:x};return this.open(ce)}openInBrowserWindow(R){const O=this.configurationService.getValue("window"),$={...this.environmentMainService.args,...R.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,w.join)(this.environmentMainService.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.initialUserEnv,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:M.default,isInitialStartup:R.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,C.release)(),hostname:(0,C.hostname)()},zoomLevel:typeof O?.zoomLevel=="number"?O.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),experimentalSandboxedFileService:this.configurationService.getValue("files.experimentalSandboxedFileService"),autoDetectHighContrast:O?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let X;if(!R.forceNewWindow&&!R.forceNewTabbedWindow&&(X=R.windowToUse||this.getLastActiveWindow(),X&&X.focus()),X){const V=X.config;!$.extensionDevelopmentPath&&V&&!!V.extensionDevelopmentPath&&($.extensionDevelopmentPath=V.extensionDevelopmentPath,$.verbose=V.verbose,$["inspect-brk-extensions"]=V["inspect-brk-extensions"],$.debugId=V.debugId,$.extensionEnvironment=V.extensionEnvironment,$["inspect-extensions"]=V["inspect-extensions"],$["extensions-dir"]=V["extensions-dir"])}else{const V=this.windowsStateHandler.getNewWindowState($);(0,t.mark)("code/willCreateCodeWindow");const B=X=this.instantiationService.createInstance(ne.CodeWindow,{state:V,extensionDevelopmentPath:$.extensionDevelopmentPath,isExtensionTestHost:!!$.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow){const te=this.getLastActiveWindow();te&&te.addTabbedWindow(B)}xe.WINDOWS.push(B),this._onDidOpenWindow.fire(B),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,f.once)(B.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(B)),(0,f.once)(B.onDidClose)(()=>this.onWindowClosed(B)),(0,f.once)(B.onDidDestroy)(()=>this._onDidDestroyWindow.fire(B));const x=(0,P.assertIsDefined)(B.win?.webContents);x.removeAllListeners("devtools-reload-page"),x.on("devtools-reload-page",()=>this.lifecycleMainService.reload(B)),this.lifecycleMainService.registerWindow(B)}return $.windowId=X.id,X.isReady?this.lifecycleMainService.unload(X,4).then(V=>{V||this.doOpenInBrowserWindow(X,$,R)}):this.doOpenInBrowserWindow(X,$,R),X}doOpenInBrowserWindow(R,O,$){if(!O.extensionDevelopmentPath)if((0,T.isWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:O.workspace,remoteAuthority:O.remoteAuthority});else if((0,T.isSingleFolderWorkspaceIdentifier)(O.workspace))O.backupPath=this.backupMainService.registerFolderBackupSync(O.workspace.uri);else{const X=$.emptyWindowBackupInfo&&$.emptyWindowBackupInfo.backupFolder;O.backupPath=this.backupMainService.registerEmptyWindowBackupSync(X,O.remoteAuthority)}R.load(O)}onWindowClosed(R){const O=xe.WINDOWS.indexOf(R);xe.WINDOWS.splice(O,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=p.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(R){return this.doGetLastActiveWindow(this.getWindows().filter(O=>(0,S.isEqualAuthority)(O.remoteAuthority,R)))}doGetLastActiveWindow(R){const O=Math.max.apply(Math,R.map($=>$.lastFocusTime));return R.find($=>$.lastFocusTime===O)}sendToFocused(R,...O){const $=this.getFocusedWindow()||this.getLastActiveWindow();$&&$.sendWhenReady(R,i.CancellationToken.None,...O)}sendToAll(R,O,$){for(const X of this.getWindows())$&&$.indexOf(X.id)>=0||X.sendWhenReady(R,i.CancellationToken.None,O)}getWindows(){return xe.WINDOWS}getWindowCount(){return xe.WINDOWS.length}getWindowById(R){const O=this.getWindows().filter($=>$.id===R);return(0,k.firstOrDefault)(O)}getWindowByWebContents(R){const O=p.BrowserWindow.fromWebContents(R);if(!!O)return this.getWindowById(O.id)}};Y.WINDOWS=[],Y=he([ee(2,v.ILogService),ee(3,H.IStateMainService),ee(4,s.IEnvironmentMainService),ee(5,d.ILifecycleMainService),ee(6,u.IBackupMainService),ee(7,r.IConfigurationService),ee(8,q.IWorkspacesHistoryMainService),ee(9,U.IWorkspacesManagementMainService),ee(10,o.IInstantiationService),ee(11,a.IDialogMainService),ee(12,n.IFileService),ee(13,L.IProductService),ee(14,A.IProtocolMainService)],Y),e.WindowsMainService=Y}),define(Q[243],J([0,1,51,36,68,46]),function(j,e,p,D,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let i=class{constructor(h,f,y,b){this.workspacesManagementMainService=h,this.windowsMainService=f,this.workspacesHistoryMainService=y,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(h,f){const y=this.windowsMainService.getWindowById(h);if(y)return this.workspacesManagementMainService.enterWorkspace(y,this.windowsMainService.getWindows(),f)}createUntitledWorkspace(h,f,y){return this.workspacesManagementMainService.createUntitledWorkspace(f,y)}deleteUntitledWorkspace(h,f){return this.workspacesManagementMainService.deleteUntitledWorkspace(f)}getWorkspaceIdentifier(h,f){return this.workspacesManagementMainService.getWorkspaceIdentifier(f)}async getRecentlyOpened(h){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(h))}async addRecentlyOpened(h,f){return this.workspacesHistoryMainService.addRecentlyOpened(f)}async removeRecentlyOpened(h,f){return this.workspacesHistoryMainService.removeRecentlyOpened(f)}async clearRecentlyOpened(h){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};i=he([ee(0,k.IWorkspacesManagementMainService),ee(1,D.IWindowsMainService),ee(2,C.IWorkspacesHistoryMainService),ee(3,p.IBackupMainService)],i),e.WorkspacesMainService=i}),define(Q[244],J([0,1,14,29,26,17,45,16,33,42,39,34,2,10,8,3,15,13,7,28,71,122,35,125,85,235,134,51,226,19,180,162,74,52,225,89,24,54,91,170,188,171,222,90,172,18,183,94,73,5,75,236,201,103,20,6,185,241,53,22,64,231,76,38,219,100,202,30,204,206,65,41,210,233,237,234,238,99,211,212,213,214,216,36,242,217,27,68,243,46]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l,c,u,r,a,s,n,o,d,v,M,L,A,W,H,Z,ne,oe,G,T,z,q,U,N,_,Y,F,R,O,$,X,V,B,x,te,ce,se,ie,ae,ue,de,ve,Pe,pe,ge,be,ke,Ae,We,Fe,et,Ge,He,Xe,at,tt,K,re,le,we,Ee,De,Oe,_e,Ne,Be,Ve,it,yt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ft=class extends g.Disposable{constructor(fe,ye,Se,me,Ie,Me,Ce,Le,Re,je){super();this.mainProcessNodeIpcServer=fe,this.userEnv=ye,this.mainInstantiationService=Se,this.logService=me,this.environmentMainService=Ie,this.lifecycleMainService=Me,this.configurationService=Ce,this.stateMainService=Le,this.fileService=Re,this.productService=je,this.configureSession(),this.registerListeners()}configureSession(){const fe=me=>me?.startsWith(`${w.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((me,Ie,Me,Ce)=>fe(Ce.requestingUrl)?Me(ye.has(Ie)):Me(!1)),p.session.defaultSession.setPermissionCheckHandler((me,Ie,Me,Ce)=>fe(Ce.requestingUrl)?ye.has(Ie):!1);const Se=p.session.defaultSession;typeof Se.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Se.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,I.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,I.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(Se,me)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",me)}),p.app.on("activate",(Se,me)=>{this.logService.trace("app#activate"),me||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(Se,me)=>{me.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),me.setWindowOpenHandler(({url:Ie})=>(this.nativeHostMainService?.openExternal(void 0,Ie),{action:"deny"}))});let fe=[],ye;p.app.on("open-file",(Se,me)=>{this.logService.trace("app#open-file: ",me),Se.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(me)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],ye=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",Se=>{const me=this.windowsMainService?.getWindowByWebContents(Se.sender);let Ie,Me;return me?.config?(Ie=me.config,Me={...process.env,...me.config.userEnv}):(Ie=this.environmentMainService.args,Me=process.env),this.resolveShellEnvironment(Ie,Me,!1)}),p.ipcMain.handle("vscode:writeNlsFile",(Se,me,Ie)=>{const Me=this.validateNlsPath([me]);if(!Me||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Me,k.VSBuffer.fromString(Ie))}),p.ipcMain.handle("vscode:readNlsFile",async(Se,...me)=>{const Ie=this.validateNlsPath(me);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Ie)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(fe){let ye;for(const Se of fe)typeof Se=="string"&&(typeof ye!="string"?ye=Se:ye=(0,t.join)(ye,Se));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,h.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!m.isLinux)))return P.URI.file(ye)}onUnexpectedError(fe){if(fe){const ye={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;m.isWindows&&fe&&p.app.setAppUserModelId(fe);try{m.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Re){this.logService.error(Re)}const ye=new a.Server;this.logService.trace("Resolving machine identifier...");const Se=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:me,sharedProcessReady:Ie,sharedProcessClient:Me}=this.setupSharedProcess(Se),Ce=await this.initServices(Se,me,Ie);if(this.environmentMainService.driverHandle){const Re=await(0,Z.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Ce);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Re)}this._register(Ce.createInstance(n.ProxyAuthHandler)),Ce.invokeFunction(Re=>this.initChannels(Re,ye,Me));const Le=Ce.invokeFunction(Re=>this.openFirstWindow(Re,ye));Ce.invokeFunction(Re=>this.afterWindowOpen(Re,me)),this.environmentMainService.args.trace&&Ce.invokeFunction(Re=>this.stopTracingEventually(Re,Le))}async resolveMachineId(){let fe=this.stateMainService.getItem(We.machineIdKey);return(!fe||m.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,c.getMachineId)(),this.stateMainService.setItem(We.machineIdKey,fe)),fe}setupSharedProcess(fe){const ye=this._register(this.mainInstantiationService.createInstance(Pe.SharedProcess,fe,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ie=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(Ie,"main")})(),me=(async()=>(await ye.whenReady(),Se))();return{sharedProcess:ye,sharedProcessReady:me,sharedProcessClient:Se}}async initServices(fe,ye,Se){const me=new V.ServiceCollection;switch(process.platform){case"win32":me.set(He.IUpdateService,new $.SyncDescriptor(re.Win32UpdateService));break;case"linux":m.isLinuxSnap?me.set(He.IUpdateService,new $.SyncDescriptor(K.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(He.IUpdateService,new $.SyncDescriptor(tt.LinuxUpdateService));break;case"darwin":me.set(He.IUpdateService,new $.SyncDescriptor(at.DarwinUpdateService));break}me.set(Ne.IWindowsMainService,new $.SyncDescriptor(Be.WindowsMainService,[fe,this.userEnv])),me.set(H.IDialogMainService,new $.SyncDescriptor(H.DialogMainService)),me.set(te.ILaunchMainService,new $.SyncDescriptor(te.LaunchMainService)),me.set(W.IDiagnosticsService,r.ProxyChannel.toService((0,r.getDelayedChannel)(Se.then(Me=>Me.getChannel("diagnostics"))))),me.set(B.IIssueMainService,new $.SyncDescriptor(B.IssueMainService,[this.userEnv])),me.set(ne.IEncryptionMainService,new $.SyncDescriptor(ne.EncryptionMainService,[fe])),me.set(x.IKeyboardLayoutMainService,new $.SyncDescriptor(x.KeyboardLayoutMainService)),me.set(ue.INativeHostMainService,new $.SyncDescriptor(ue.NativeHostMainService,[ye])),me.set(Oe.IWebviewManagerService,new $.SyncDescriptor(_e.WebviewMainService)),me.set(it.IWorkspacesService,new $.SyncDescriptor(kt.WorkspacesMainService)),me.set(St.IWorkspacesManagementMainService,new $.SyncDescriptor(St.WorkspacesManagementMainService)),me.set(yt.IWorkspacesHistoryMainService,new $.SyncDescriptor(yt.WorkspacesHistoryMainService)),me.set(ae.IMenubarMainService,new $.SyncDescriptor(ae.MenubarMainService)),me.set(z.IExtensionUrlTrustService,new $.SyncDescriptor(q.ExtensionUrlTrustService)),me.set(U.IExtensionHostStarter,new $.SyncDescriptor(N.WorkerMainProcessExtensionHostStarter)),me.set(ke.IStorageMainService,new $.SyncDescriptor(ke.StorageMainService)),m.isWindows?me.set(_.IExternalTerminalMainService,new $.SyncDescriptor(Y.WindowsExternalTerminalService)):m.isMacintosh?me.set(_.IExternalTerminalMainService,new $.SyncDescriptor(Y.MacExternalTerminalService)):m.isLinux&&me.set(_.IExternalTerminalMainService,new $.SyncDescriptor(Y.LinuxExternalTerminalService));const Ie=new v.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(me.set(d.IBackupMainService,Ie),me.set(le.IURLService,new $.SyncDescriptor(Ee.NativeURLService)),(0,Ge.supportsTelemetry)(this.productService,this.environmentMainService)){const Me=(0,r.getDelayedChannel)(Se.then(Ye=>Ye.getChannel("telemetryAppender"))),Ce=new Fe.TelemetryAppenderClient(Me),Le=(0,Ae.resolveCommonProperties)(this.fileService,(0,C.release)(),(0,C.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Re=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],je={appenders:[Ce],commonProperties:Le,piiPaths:Re,sendErrorTelemetry:!0};me.set(We.ITelemetryService,new $.SyncDescriptor(et.TelemetryService,[je]))}else me.set(We.ITelemetryService,Ge.NullTelemetryService);return await Ie.initialize(),this.mainInstantiationService.createChild(me)}initChannels(fe,ye,Se){const me=r.ProxyChannel.fromService(fe.get(te.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",me);const Ie=this.fileService.getProvider(w.Schemas.file);(0,S.assertType)(Ie instanceof O.DiskFileSystemProvider);const Me=new R.DiskFileSystemProviderChannel(Ie,this.logService);ye.registerChannel("localFilesystem",Me);const Ce=new L.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService);ye.registerChannel(L.UserConfigurationFileServiceId,r.ProxyChannel.fromService(Ce)),Se.then(ze=>ze.registerChannel(L.UserConfigurationFileServiceId,r.ProxyChannel.fromService(Ce)));const Le=new Xe.UpdateChannel(fe.get(He.IUpdateService));ye.registerChannel("update",Le);const Re=r.ProxyChannel.fromService(fe.get(B.IIssueMainService));ye.registerChannel("issue",Re);const je=r.ProxyChannel.fromService(fe.get(ne.IEncryptionMainService));ye.registerChannel("encryption",je);const Ye=r.ProxyChannel.fromService(fe.get(pe.ISignService));ye.registerChannel("sign",Ye);const nt=r.ProxyChannel.fromService(fe.get(x.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",nt),this.nativeHostMainService=fe.get(ue.INativeHostMainService);const Qe=r.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",Qe),Se.then(ze=>ze.registerChannel("nativeHost",Qe));const gt=r.ProxyChannel.fromService(fe.get(it.IWorkspacesService));ye.registerChannel("workspaces",gt);const Ue=r.ProxyChannel.fromService(fe.get(ae.IMenubarMainService));ye.registerChannel("menubar",Ue);const ct=r.ProxyChannel.fromService(fe.get(le.IURLService));ye.registerChannel("url",ct);const rt=r.ProxyChannel.fromService(fe.get(z.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",rt);const st=r.ProxyChannel.fromService(fe.get(Oe.IWebviewManagerService));ye.registerChannel("webview",st);const ot=this._register(new be.StorageDatabaseChannel(this.logService,fe.get(ke.IStorageMainService)));ye.registerChannel("storage",ot),Se.then(ze=>ze.registerChannel("storage",ot));const lt=r.ProxyChannel.fromService(fe.get(_.IExternalTerminalMainService));ye.registerChannel("externalTerminal",lt);const Je=new ie.LogLevelChannel(fe.get(se.ILogService));ye.registerChannel("logLevel",Je),Se.then(ze=>ze.registerChannel("logLevel",Je));const Ze=new ie.LoggerChannel(fe.get(se.ILoggerService));ye.registerChannel("logger",Ze),Se.then(ze=>ze.registerChannel("logger",Ze));const ut=new A.ElectronExtensionHostDebugBroadcastChannel(fe.get(Ne.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",ut);const Te=r.ProxyChannel.fromService(fe.get(U.IExtensionHostStarter));ye.registerChannel(U.ipcExtensionHostStarterChannelName,Te)}openFirstWindow(fe,ye){const Se=this.windowsMainService=fe.get(Ne.IWindowsMainService),me=fe.get(le.IURLService),Ie=fe.get(ue.INativeHostMainService);this.lifecycleMainService.phase=2;const Me=[],Ce=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Te=>{try{return{uri:P.URI.parse(Te),url:Te}}catch{return}}).filter(Te=>{if(!Te||this.shouldBlockURI(Te.uri))return!1;const ze=this.getWindowOpenableFromProtocolLink(Te.uri);return ze?(Me.push(ze),!1):!0}),Le=this,Re=this.environmentMainService,je=this.productService;me.registerHandler({async handleURL(Te,ze){if(Te.scheme===je.urlProtocol&&Te.path==="workspace"&&(Te=Te.with({authority:"file",path:P.URI.parse(Te.query).path,query:""})),Le.shouldBlockURI(Te))return!0;const bt=Le.getWindowOpenableFromProtocolLink(Te);if(bt){const[mt]=Se.open({context:5,cli:{...Re.args},urisToOpen:[bt],gotoLineMode:!0});return mt.focus(),!0}if(m.isMacintosh&&Se.getWindowCount()===0){const[mt]=Se.open({context:5,cli:{...Re.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ve.getRemoteAuthority)(Te)});return await mt.ready(),me.open(Te,ze)}return!1}});const Ye=this._register(new Ve.ActiveWindowManager({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),nt=new r.StaticRouter(Te=>Ye.getActiveClientId().then(ze=>Te===ze)),Qe=new we.URLHandlerRouter(nt),gt=ye.getChannel("urlHandler",Qe);me.registerHandler(new we.URLHandlerChannelClient(gt)),this._register(new De.ElectronURLListener(Ce,me,Se,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,ct=global.macOpenFiles,rt=(0,G.isLaunchedFromCli)(process.env)?0:4,st=Ue._.length,ot=!!Ue["folder-uri"],lt=!!Ue["file-uri"],Je=Ue["skip-add-to-recently-opened"]===!0,Ze=Ue.wait&&Ue.waitMarkerFilePath?P.URI.file(Ue.waitMarkerFilePath):void 0,ut=Ue.remote||void 0;return Me.length>0?Se.open({context:rt,cli:Ue,urisToOpen:Me,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!st&&!ot&&!lt?Se.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Je,waitMarkerFileURI:Ze,initialStartup:!0,remoteAuthority:ut}):ct.length&&!st&&!ot&&!lt?Se.open({context:1,cli:Ue,urisToOpen:ct.map(Te=>this.getWindowOpenableFromPathSync(Te)),noRecentEntry:Je,waitMarkerFileURI:Ze,initialStartup:!0}):Se.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!st&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:Je,waitMarkerFileURI:Ze,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ut})}shouldBlockURI(fe){return!!(fe.authority===w.Schemas.file&&m.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,b.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,b.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===w.Schemas.file){const ye=P.URI.file(fe.fsPath);return(0,it.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(fe.authority===w.Schemas.vscodeRemote){const ye=fe.path.indexOf(t.posix.sep,1);if(ye!==-1){const Se=fe.path.substring(1,ye),me=fe.path.substring(ye),Ie=P.URI.from({scheme:w.Schemas.vscodeRemote,authority:Se,path:me,query:fe.query,fragment:fe.fragment});return(0,it.hasWorkspaceFileExtension)(me)?{workspaceUri:Ie}:/:[\d]+$/.test(me)?{fileUri:Ie}:{folderUri:Ie}}}}}getWindowOpenableFromPathSync(fe){try{if((0,D.statSync)(fe).isDirectory())return{folderUri:P.URI.file(fe)};if((0,it.hasWorkspaceFileExtension)(fe))return{workspaceUri:P.URI.file(fe)}}catch(ye){}return{fileUri:P.URI.file(fe)}}async afterWindowOpen(fe,ye){this.lifecycleMainService.phase=3;let Se=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0);const me=fe.get(We.ITelemetryService);this._register(ye.onDidError(({type:Ce,details:Le})=>{let Re;switch(Ce){case 1:Re="SharedProcess: detected unresponsive window";break;case 2:Re=`SharedProcess: crashed (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break;case 3:Re=`SharedProcess: failed to load (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Re)),me.publicLog2("sharedprocesserror",{type:Ce,reason:Le?.reason,code:Le?.exitCode,visible:ye.isVisible(),shuttingdown:Se})}));const Ie=this.productService.win32MutexName;if(m.isWindows&&Ie)try{const Ce=j.__$__nodeRequire("windows-mutex").Mutex,Le=new Ce(Ie);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Ce){this.logService.error(Ce)}p.protocol.registerHttpProtocol(w.Schemas.vscodeRemoteResource,(Ce,Le)=>{Le({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})});const Me=fe.get(He.IUpdateService);(Me instanceof re.Win32UpdateService||Me instanceof tt.LinuxUpdateService||Me instanceof at.DarwinUpdateService)&&Me.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Le=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,y.stripComments)(Le))["enable-crash-reporter"]===void 0){const Ye=(0,Ge.getTelemetryLevel)(this.configurationService)>=1,nt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ye},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.generateUuid)()}"`,"}"],Qe=Le.substring(0,Le.length-2).concat(`,
`,nt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,k.VSBuffer.fromString(Qe))}}catch(Ce){this.logService.error(Ce)}}async resolveShellEnvironment(fe,ye,Se){try{return await(0,T.resolveShellEnv)(this.logService,fe,ye)}catch(me){const Ie=(0,i.toErrorMessage)(me);Se?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",Ie):this.logService.error(Ie)}return{}}stopTracingEventually(fe,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Se=fe.get(H.IDialogMainService);let me=!1;const Ie=async Ce=>{if(me)return;me=!0;const Le=await p.contentTracing.stopRecording((0,E.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Ce?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Le}`):Se.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Le),buttons:[(0,b.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,S.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},Me=setTimeout(()=>Ie(!0),3e4);Promise.all(ye.map(Ce=>Ce.ready())).then(()=>{clearTimeout(Me),Ie(!1)})}};ft=he([ee(2,X.IInstantiationService),ee(3,se.ILogService),ee(4,oe.IEnvironmentMainService),ee(5,ce.ILifecycleMainService),ee(6,M.IConfigurationService),ee(7,ge.IStateMainService),ee(8,F.IFileService),ee(9,de.IProductService)],ft),e.CodeApplication=ft}),define(Q[251],J([0,1,14,29,31,9,45,16,33,42,34,10,8,63,3,32,25,21,35,58,244,11,19,192,203,24,54,165,18,182,94,73,175,75,20,95,6,186,96,56,22,57,189,97,228,50,230,76,200,38,232,65,66,209]),function(j,e,p,D,C,k,i,I,h,f,y,b,g,w,t,m,E,S,P,l,c,u,r,a,s,n,o,d,v,M,L,A,W,H,Z,ne,oe,G,T,z,q,U,N,_,Y,F,R,O,$,X,V,B,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class te{main(){try{this.startup()}catch(ie){console.error(ie.message),p.app.exit(1)}}async startup(){(0,I.setUnexpectedErrorHandler)(ge=>console.error(ge));const[ie,ae,ue,de,ve,Pe,pe]=this.createServices();try{try{await this.initServices(ue,de,ve)}catch(ge){throw this.handleStartupDataDirError(ue,pe.nameLong,ge),ge}await ie.invokeFunction(async ge=>{const be=ge.get(oe.ILogService),ke=ge.get(Z.ILifecycleMainService),Ae=ge.get(v.IFileService),We=await this.claimInstance(be,ue,ke,ie,pe,!0);return S.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Fe=>{be.warn(`Error writing main lockfile: ${Fe.stack}`)}),Pe.logger=new T.SpdLogLogger("main",(0,g.join)(ue.logsPath,"main.log"),!0,!1,Pe.getLevel()),(0,f.once)(ke.onWillShutdown)(Fe=>{Ae.dispose(),de.dispose(),Fe.join(S.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),ie.createInstance(c.CodeApplication,We,ae).startup()})}catch(ge){ie.invokeFunction(this.quit,ge)}}createServices(){const ie=new H.ServiceCollection,ae={_serviceBrand:void 0,...z.default};ie.set(q.IProductService,ae);const ue=new n.EnvironmentMainService(this.resolveArgs(),ae),de=this.patchEnvironment(ue);ie.set(n.IEnvironmentMainService,ue);const ve=new ne.BufferLogService,Pe=new oe.MultiplexLogService([new oe.ConsoleMainLogger((0,oe.getLogLevel)(ue)),ve]);process.once("exit",()=>Pe.dispose()),ie.set(oe.ILogService,Pe);const pe=new M.FileService(Pe);ie.set(v.IFileService,pe);const ge=new L.DiskFileSystemProvider(Pe);pe.registerProvider(b.Schemas.file,ge),ie.set(oe.ILoggerService,new G.LoggerService(Pe,pe));const be=new a.ConfigurationService(ue.settingsResource,pe);ie.set(r.IConfigurationService,be),ie.set(Z.ILifecycleMainService,new A.SyncDescriptor(Z.LifecycleMainService));const ke=new V.StateMainService(ue,Pe,pe);return ie.set(X.IStateMainService,ke),ie.set(F.IRequestService,new A.SyncDescriptor(R.RequestMainService)),ie.set(x.IThemeMainService,new A.SyncDescriptor(x.ThemeMainService)),ie.set(O.ISignService,new A.SyncDescriptor($.SignService)),ie.set(_.ITunnelService,new A.SyncDescriptor(Y.TunnelService)),ie.set(U.IProtocolMainService,new A.SyncDescriptor(N.ProtocolMainService)),[new W.InstantiationService(ie,!0),de,ue,be,ke,ve,ae]}patchEnvironment(ie){const ae={VSCODE_IPC_HOOK:ie.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const de=process.env[ue];typeof de=="string"&&(ae[ue]=de)}),Object.assign(process.env,ae),ae}initServices(ie,ae,ue){return k.Promises.settled([Promise.all([ie.extensionsPath,ie.codeCachePath,ie.logsPath,ie.globalStorageHome.fsPath,ie.workspaceStorageHome.fsPath,ie.backupHome].map(de=>de?S.Promises.mkdir(de,{recursive:!0}):void 0)),ae.initialize(),ue.init()])}async claimInstance(ie,ae,ue,de,ve,Pe){let pe;try{(0,w.mark)("code/willStartMainServer"),pe=await(0,l.serve)(ae.mainIPCHandle),(0,w.mark)("code/didStartMainServer"),(0,f.once)(ue.onWillShutdown)(()=>pe.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ae,ve.nameLong,ge),ge;let be;try{be=await(0,l.connect)(ae.mainIPCHandle,"main")}catch(We){if(!Pe||t.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,ve.nameShort),(0,u.localize)(1,null),ve.nameLong),We;try{(0,D.unlinkSync)(ae.mainIPCHandle)}catch(Fe){throw ie.warn("Could not delete obsolete instance handle",Fe),Fe}return this.claimInstance(ie,ae,ue,de,ve,!1)}if(ae.extensionTestsLocationURI&&!ae.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ie.error(We),be.dispose(),new Error(We)}let ke;!ae.args.wait&&!ae.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,ve.nameShort),(0,u.localize)(3,null),ve.nameLong)},1e4));const Ae=P.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0});if(ae.args.status)return de.invokeFunction(async()=>{const We=new s.DiagnosticsService(B.NullTelemetryService,ve),Fe=await Ae.getMainProcessInfo(),et=await Ae.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ge=await We.getDiagnostics(Fe,et);throw console.log(Ge),new I.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Ae,ie),ie.trace("Sending env to running instance..."),await Ae.start(ae.args,process.env),be.dispose(),ke&&clearTimeout(ke),new I.ExpectedError("Sent env to running instance. Terminating...")}if(ae.args.status)throw ie.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new I.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),pe}handleStartupDataDirError(ie,ae,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const de=(0,C.coalesce)([ie.userDataPath,ie.extensionsPath,l.XDG_RUNTIME_DIR]).map(ve=>(0,y.getPathLabel)(ve,ie));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,i.toErrorMessage)(ue),de.join(`
`)),ae)}}showStartupWarningDialog(ie,ae,ue){p.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,y.mnemonicButtonLabel)((0,u.localize)(6,null))],message:ie,detail:ae,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ie,ae){if(t.isWindows){const ue=await ie.getMainProcessId();ae.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((de,ve)=>{j(["windows-foreground-love"],de,ve)})).allowSetForegroundWindow(ue)}catch(de){ae.error(de)}}}quit(ie,ae){const ue=ie.get(oe.ILogService),de=ie.get(Z.ILifecycleMainService);let ve=0;ae&&(ae.isExpected?ae.message&&ue.trace(ae.message):(ve=1,ae.stack?ue.error(ae.stack):ue.error(`Startup error: ${ae.toString()}`))),de.kill(ve)}resolveArgs(){const ie=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(ie.wait&&!ie.waitMarkerFilePath){const ae=(0,d.createWaitMarkerFile)(ie.verbose);ae&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",ae),ie.waitMarkerFilePath=ae)}return ie}validatePaths(ie){if(ie["open-url"]&&(ie._urls=ie._,ie._=[]),!ie.remote){const ae=this.doValidatePaths(ie._,ie.goto);ie._=ae}return ie}doValidatePaths(ie,ae){const ue=(0,m.cwd)(),de=ie.map(pe=>{let ge=String(pe),be;ae&&(be=(0,h.parseLineAndColumnAware)(ge),ge=be.path),ge&&(ge=this.preparePath(ue,ge));const ke=(0,h.sanitizeFilePath)(ge,ue),Ae=(0,g.basename)(ke);return Ae&&!(0,h.isValidBasename)(Ae)?null:ae&&be?(be.path=ke,this.toPath(be)):ke}),ve=t.isWindows||t.isMacintosh,Pe=(0,C.distinct)(de,pe=>pe&&ve?pe.toLowerCase():pe||"");return(0,C.coalesce)(Pe)}preparePath(ie,ae){return t.isWindows&&(ae=(0,E.rtrim)(ae,'"')),ae=(0,E.trim)((0,E.trim)(ae," "),"	"),t.isWindows&&(ae=(0,g.resolve)(ie,ae),ae=(0,E.rtrim)(ae,".")),ae}toPath(ie){const ae=[ie.path];return typeof ie.line=="number"&&ae.push(String(ie.line)),typeof ie.column=="number"&&ae.push(String(ie.column)),ae.join(":")}}new te().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3bd29c1d6c6ef5b6265614def99b7257b671ae19/core/vs/code/electron-main/main.js.map
