/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/platform/log/common/log","vs/base/common/platform","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/map","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/platform/extensions/common/extensions","vs/base/node/pfs","vs/workbench/services/extensions/common/extensions","vs/base/common/extpath","vs/base/common/glob","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostTerminalService","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/hash","vs/base/common/severity","vs/editor/common/core/position","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/json","vs/base/common/marshalling","fs","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/normalization","vs/base/common/labels","os","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/uint","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/tunnel","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],me=function(Y){for(var e=[],g=0,L=Y.length;g<L;g++)e[g]=fe[Y[g]];return e};define(fe[58],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(L,y){if(!L)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=g}),define(fe[59],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function L(P){const I=[];for(let c in P)g.call(P,c)&&I.push(P[c]);return I}e.values=L;function y(P,I){for(let c in P)if(g.call(P,c)&&I({key:c,value:P[c]},function(){delete P[c]})===!1)return}e.forEach=y;function C(P,I){const c=Object.create(null);for(const v of P){const h=I(v);let w=c[h];w||(w=c[h]=[]),w.push(v)}return c}e.groupBy=C;function n(P){const I=Object.create(null);return P&&P.forEach((c,v)=>{I[v]=c}),I}e.fromMap=n;function k(P,I){const c=[],v=[];for(let h of P)I.has(h)||c.push(h);for(let h of I)P.has(h)||v.push(h);return{removed:c,added:v}}e.diffSets=k;function _(P,I){const c=[],v=[];for(let[h,w]of P)I.has(h)||c.push(w);for(let[h,w]of I)P.has(h)||v.push(w);return{removed:c,added:v}}e.diffMaps=_;class D{constructor(){this.map=new Map}add(I,c){let v=this.map.get(I);v||(v=new Set,this.map.set(I,v)),v.add(c)}delete(I,c){const v=this.map.get(I);!v||(v.delete(c),v.size===0&&this.map.delete(I))}forEach(I,c){const v=this.map.get(I);!v||v.forEach(c)}}e.SetMap=D}),define(fe[60],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(n){return(k,_,D)=>{let P=null,I=null;if(typeof D.value=="function"?(P="value",I=D.value):typeof D.get=="function"&&(P="get",I=D.get),!I)throw new Error("not supported");D[P]=n(I,_)}}e.createDecorator=g;function L(n,k,_){let D=null,P=null;if(typeof _.value=="function"?(D="value",P=_.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(D="get",P=_.get),!P)throw new Error("not supported");const I=`$memoize$${k}`;_[D]=function(...c){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,c)}),this[I]}}e.memoize=L;function y(n,k,_){return g((D,P)=>{const I=`$debounce$${P}`,c=`$debounce$result$${P}`;return function(...v){this[c]||(this[c]=_?_():void 0),clearTimeout(this[I]),k&&(this[c]=k(this[c],...v),v=[this[c]]),this[I]=setTimeout(()=>{D.apply(this,v),this[c]=_?_():void 0},n)}})}e.debounce=y;function C(n,k,_){return g((D,P)=>{const I=`$throttle$timer$${P}`,c=`$throttle$result$${P}`,v=`$throttle$lastRun$${P}`,h=`$throttle$pending$${P}`;return function(...w){if(this[c]||(this[c]=_?_():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),k&&(this[c]=k(this[c],...w)),this[h])return;const E=this[v]+n;E<=Date.now()?(this[v]=Date.now(),D.apply(this,[this[c]]),this[c]=_?_():void 0):(this[h]=!0,this[I]=setTimeout(()=>{this[h]=!1,this[v]=Date.now(),D.apply(this,[this[c]]),this[c]=_?_():void 0},E-Date.now()))}})}e.throttle=C}),define(fe[18],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(m=>{m(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=g,e.errorHandler=new g;function L(p){e.errorHandler.setUnexpectedErrorHandler(p)}e.setUnexpectedErrorHandler=L;function y(p){_(p)||e.errorHandler.onUnexpectedError(p)}e.onUnexpectedError=y;function C(p){_(p)||e.errorHandler.onUnexpectedExternalError(p)}e.onUnexpectedExternalError=C;function n(p){if(p instanceof Error){let{name:r,message:m}=p;const i=p.stacktrace||p.stack;return{$isError:!0,name:r,message:m,stack:i}}return p}e.transformErrorForSerialization=n;const k="Canceled";function _(p){return p instanceof Error&&p.name===k&&p.message===k}e.isPromiseCanceledError=_;class D extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=D;function P(){const p=new Error(k);return p.name=p.message,p}e.canceled=P;function I(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}e.illegalArgument=I;function c(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}e.illegalState=c;function v(p){return p?new Error(`readonly property '${p} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=v;function h(p){const r=new Error(`${p} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function w(p){return p?p.message?p.message:p.stack?p.stack.split(`
`)[0]:String(p):"Error"}e.getErrorMessage=w;class E extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=E;class T extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=T;class b extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=b;function o(p){const r=p;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=o;function s(p,r=Object.create(null)){const m=new Error(p);return r.actions&&(m.actions=r.actions),m}e.createErrorWithActions=s}),define(fe[15],me([0,1,18]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(j,X=0){return j[j.length-(1+X)]}e.tail=L;function y(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=y;function C(j,X,Q=(de,Se)=>de===Se){if(j===X)return!0;if(!j||!X||j.length!==X.length)return!1;for(let de=0,Se=j.length;de<Se;de++)if(!Q(j[de],X[de]))return!1;return!0}e.equals=C;function n(j,X,Q){let de=0,Se=j.length-1;for(;de<=Se;){const De=(de+Se)/2|0,Pe=Q(j[De],X);if(Pe<0)de=De+1;else if(Pe>0)Se=De-1;else return De}return-(de+1)}e.binarySearch=n;function k(j,X){let Q=0,de=j.length;if(de===0)return 0;for(;Q<de;){const Se=Math.floor((Q+de)/2);X(j[Se])?de=Se:Q=Se+1}return Q}e.findFirstInSorted=k;function _(j,X,Q){if(j=j|0,j>=X.length)throw new TypeError("invalid index");let de=X[Math.floor(X.length*Math.random())],Se=[],De=[],Pe=[];for(let Be of X){const We=Q(Be,de);We<0?Se.push(Be):We>0?De.push(Be):Pe.push(Be)}return j<Se.length?_(j,Se,Q):j<Se.length+Pe.length?Pe[0]:_(j-(Se.length+Pe.length),De,Q)}e.quickSelect=_;function D(j,X){const Q=[];let de;for(const Se of j.slice(0).sort(X))!de||X(de[0],Se)!==0?(de=[Se],Q.push(de)):de.push(Se);return Q}e.groupBy=D;function P(j,X,Q){const de=[];function Se(Be,We,He){if(We===0&&He.length===0)return;const G=de[de.length-1];G&&G.start+G.deleteCount===Be?(G.deleteCount+=We,G.toInsert.push(...He)):de.push({start:Be,deleteCount:We,toInsert:He})}let De=0,Pe=0;for(;;){if(De===j.length){Se(De,0,X.slice(Pe));break}if(Pe===X.length){Se(De,j.length-De,[]);break}const Be=j[De],We=X[Pe],He=Q(Be,We);He===0?(De+=1,Pe+=1):He<0?(Se(De,1,[]),De+=1):He>0&&(Se(De,0,[We]),Pe+=1)}return de}e.sortedDiff=P;function I(j,X,Q){const de=P(j,X,Q),Se=[],De=[];for(const Pe of de)Se.push(...j.slice(Pe.start,Pe.start+Pe.deleteCount)),De.push(...Pe.toInsert);return{removed:Se,added:De}}e.delta=I;function c(j,X,Q){if(Q===0)return[];const de=j.slice(0,Q).sort(X);return h(j,X,de,Q,j.length),de}e.top=c;function v(j,X,Q,de,Se){return Q===0?Promise.resolve([]):new Promise((De,Pe)=>{(async()=>{const Be=j.length,We=j.slice(0,Q).sort(X);for(let He=Q,G=Math.min(Q+de,Be);He<Be;He=G,G=Math.min(G+de,Be)){if(He>Q&&await new Promise(ee=>setTimeout(ee)),Se&&Se.isCancellationRequested)throw(0,g.canceled)();h(j,X,We,He,G)}return We})().then(De,Pe)})}e.topAsync=v;function h(j,X,Q,de,Se){for(const De=Q.length;de<Se;de++){const Pe=j[de];if(X(Pe,Q[De-1])<0){Q.pop();const Be=k(Q,We=>X(Pe,We)<0);Q.splice(Be,0,Pe)}}}function w(j){return j.filter(X=>!!X)}e.coalesce=w;function E(j){let X=0;for(let Q=0;Q<j.length;Q++)j[Q]&&(j[X]=j[Q],X+=1);j.length=X}e.coalesceInPlace=E;function T(j,X,Q){j.splice(Q,0,j.splice(X,1)[0])}e.move=T;function b(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=b;function o(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=o;function s(j,X=Q=>Q){const Q=new Set;return j.filter(de=>{const Se=X(de);return Q.has(Se)?!1:(Q.add(Se),!0)})}e.distinct=s;function p(j){const X=Object.create(null);return Q=>{const de=j(Q);return X[de]?!1:(X[de]=!0,!0)}}e.uniqueFilter=p;function r(j,X){const Q=m(j,X);if(Q!==-1)return j[Q]}e.findLast=r;function m(j,X){for(let Q=j.length-1;Q>=0;Q--){const de=j[Q];if(X(de))return Q}return-1}e.lastIndex=m;function i(j,X){return j.length>0?j[0]:X}e.firstOrDefault=i;function t(j,X,Q=(de,Se)=>de===Se){let de=0;for(let Se=0,De=Math.min(j.length,X.length);Se<De&&Q(j[Se],X[Se]);Se++)de++;return de}e.commonPrefixLength=t;function u(j){return[].concat(...j)}e.flatten=u;function a(j,X){let Q=typeof X=="number"?j:0;typeof X=="number"?Q=j:(Q=0,X=j);const de=[];if(Q<=X)for(let Se=Q;Se<X;Se++)de.push(Se);else for(let Se=Q;Se>X;Se--)de.push(Se);return de}e.range=a;function l(j,X,Q){return j.reduce((de,Se)=>(de[X(Se)]=Q?Q(Se):Se,de),Object.create(null))}e.index=l;function f(j,X){return j.push(X),()=>d(j,X)}e.insert=f;function d(j,X){const Q=j.indexOf(X);if(Q>-1)return j.splice(Q,1),X}e.remove=d;function S(j,X,Q){const de=j.slice(0,X),Se=j.slice(X);return de.concat(Q,Se)}e.arrayInsert=S;function A(j,X){let Q;if(typeof X=="number"){let de=X;Q=()=>{const Se=Math.sin(de++)*179426549;return Se-Math.floor(Se)}}else Q=Math.random;for(let de=j.length-1;de>0;de-=1){const Se=Math.floor(Q()*(de+1)),De=j[de];j[de]=j[Se],j[Se]=De}}e.shuffle=A;function R(j,X){const Q=j.indexOf(X);Q>-1&&(j.splice(Q,1),j.unshift(X))}e.pushToStart=R;function B(j,X){const Q=j.indexOf(X);Q>-1&&(j.splice(Q,1),j.push(X))}e.pushToEnd=B;function x(j,X){return Array.isArray(j)?j.map(X):X(j)}e.mapArrayOrNot=x;function F(j){return Array.isArray(j)?j:[j]}e.asArray=F;function $(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=$;function M(j,X){for(const Q of j){const de=X(Q);if(de!==void 0)return de}}e.mapFind=M;function H(j,X,Q){const de=U(j,X),Se=j.length,De=Q.length;j.length=Se+De;for(let Pe=Se-1;Pe>=de;Pe--)j[Pe+De]=j[Pe];for(let Pe=0;Pe<De;Pe++)j[Pe+de]=Q[Pe]}e.insertInto=H;function N(j,X,Q,de){const Se=U(j,X),De=j.splice(Se,Q);return H(j,Se,de),De}e.splice=N;function U(j,X){return X<0?Math.max(X+j.length,0):Math.min(X,j.length)}function V(j,X){let Q=Number.MAX_SAFE_INTEGER,de=0;return j.forEach((Se,De)=>{const Pe=X(Se);Pe<Q&&(Q=Pe,de=De)}),de}e.minIndex=V;function O(j,X){let Q=Number.MIN_SAFE_INTEGER,de=0;return j.forEach((Se,De)=>{const Pe=X(Se);Pe>Q&&(Q=Pe,de=De)}),de}e.maxIndex=O;class W{constructor(X){this.items=X,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(X){let Q=this.firstIdx;for(;Q<this.items.length&&X(this.items[Q]);)Q++;const de=Q===this.firstIdx?null:this.items.slice(this.firstIdx,Q);return this.firstIdx=Q,de}takeFromEndWhile(X){let Q=this.lastIdx;for(;Q>=0&&X(this.items[Q]);)Q--;const de=Q===this.lastIdx?null:this.items.slice(Q+1,this.lastIdx+1);return this.lastIdx=Q,de}peek(){return this.items[this.firstIdx]}dequeue(){const X=this.items[this.firstIdx];return this.firstIdx++,X}takeCount(X){const Q=this.items.slice(this.firstIdx,this.firstIdx+X);return this.firstIdx+=X,Q}}e.ArrayQueue=W}),define(fe[76],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(L){const y=this;let C=!1,n;return function(){return C||(C=!0,n=L.apply(y,arguments)),n}}e.once=g}),define(fe[77],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(y){this._prefix=y,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(fe[78],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(L){function y(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}L.is=y;const C=Object.freeze([]);function n(){return C}L.empty=n;function*k(p){yield p}L.single=k;function _(p){return p||C}L.from=_;function D(p){return!p||p[Symbol.iterator]().next().done===!0}L.isEmpty=D;function P(p){return p[Symbol.iterator]().next().value}L.first=P;function I(p,r){for(const m of p)if(r(m))return!0;return!1}L.some=I;function c(p,r){for(const m of p)if(r(m))return m}L.find=c;function*v(p,r){for(const m of p)r(m)&&(yield m)}L.filter=v;function*h(p,r){let m=0;for(const i of p)yield r(i,m++)}L.map=h;function*w(...p){for(const r of p)for(const m of r)yield m}L.concat=w;function*E(p){for(const r of p)for(const m of r)yield m}L.concatNested=E;function T(p,r,m){let i=m;for(const t of p)i=r(i,t);return i}L.reduce=T;function*b(p,r,m=p.length){for(r<0&&(r+=p.length),m<0?m+=p.length:m>p.length&&(m=p.length);r<m;r++)yield p[r]}L.slice=b;function o(p,r=Number.POSITIVE_INFINITY){const m=[];if(r===0)return[m,p];const i=p[Symbol.iterator]();for(let t=0;t<r;t++){const u=i.next();if(u.done)return[m,L.empty()];m.push(u.value)}return[m,{[Symbol.iterator](){return i}}]}L.consume=o;function s(p,r,m=(i,t)=>i===t){const i=p[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const u=i.next(),a=t.next();if(u.done!==a.done)return!1;if(u.done)return!0;if(!m(u.value,a.value))return!1}}L.equals=s})(g=e.Iterable||(e.Iterable={}))}),define(fe[61],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var L;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var y;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(y=e.ParseErrorCode||(e.ParseErrorCode={}));var C;(function(r){r.DEFAULT={allowTrailingComma:!0}})(C=e.ParseOptions||(e.ParseOptions={}));function n(r,m=!1){let i=0,t=r.length,u="",a=0,l=16,f=0;function d($){let M=0,H=0;for(;M<$;){const N=r.charCodeAt(i);if(N>=48&&N<=57)H=H*16+N-48;else if(N>=65&&N<=70)H=H*16+N-65+10;else if(N>=97&&N<=102)H=H*16+N-97+10;else break;i++,M++}return M<$&&(H=-1),H}function S($){i=$,u="",a=0,l=16,f=0}function A(){const $=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&D(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&D(r.charCodeAt(i)))for(i++;i<r.length&&D(r.charCodeAt(i));)i++;else return f=3,r.substring($,i);let M=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&D(r.charCodeAt(i))){for(i++;i<r.length&&D(r.charCodeAt(i));)i++;M=i}else f=3;return r.substring($,M)}function R(){let $="",M=i;for(;;){if(i>=t){$+=r.substring(M,i),f=2;break}const H=r.charCodeAt(i);if(H===34){$+=r.substring(M,i),i++;break}if(H===92){if($+=r.substring(M,i),i++,i>=t){f=2;break}switch(r.charCodeAt(i++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const U=d(4);U>=0?$+=String.fromCharCode(U):f=4;break;default:f=5}M=i;continue}if(H>=0&&H<=31)if(_(H)){$+=r.substring(M,i),f=2;break}else f=6;i++}return $}function B(){if(u="",f=0,a=i,i>=t)return a=t,l=17;let $=r.charCodeAt(i);if(k($)){do i++,u+=String.fromCharCode($),$=r.charCodeAt(i);while(k($));return l=15}if(_($))return i++,u+=String.fromCharCode($),$===13&&r.charCodeAt(i)===10&&(i++,u+=`
`),l=14;switch($){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,u=R(),l=10;case 47:const M=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<t&&!_(r.charCodeAt(i));)i++;return u=r.substring(M,i),l=12}if(r.charCodeAt(i+1)===42){i+=2;const H=t-1;let N=!1;for(;i<H;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,N=!0;break}i++}return N||(i++,f=1),u=r.substring(M,i),l=13}return u+=String.fromCharCode($),i++,l=16;case 45:if(u+=String.fromCharCode($),i++,i===t||!D(r.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=A(),l=11;default:for(;i<t&&x($);)i++,$=r.charCodeAt(i);if(a!==i){switch(u=r.substring(a,i),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode($),i++,l=16}}function x($){if(k($)||_($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let $;do $=B();while($>=12&&$<=15);return $}return{setPosition:S,getPosition:()=>i,scan:m?F:B,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>a,getTokenLength:()=>i-a,getTokenError:()=>f}}e.createScanner=n;function k(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function _(r){return r===10||r===13||r===8232||r===8233}function D(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function I(r,m){const i=[],t=new Object;let u;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function f(d,S,A,R){a.value=d,a.offset=S,a.length=A,a.type=R,a.colonOffset=void 0,u=a}try{o(r,{onObjectBegin:(d,S)=>{if(m<=d)throw t;u=void 0,l=m>d,i.push("")},onObjectProperty:(d,S,A)=>{if(m<S||(f(d,S,A,"property"),i[i.length-1]=d,m<=S+A))throw t},onObjectEnd:(d,S)=>{if(m<=d)throw t;u=void 0,i.pop()},onArrayBegin:(d,S)=>{if(m<=d)throw t;u=void 0,i.push(0)},onArrayEnd:(d,S)=>{if(m<=d)throw t;u=void 0,i.pop()},onLiteralValue:(d,S,A)=>{if(m<S||(f(d,S,A,p(d)),m<=S+A))throw t},onSeparator:(d,S,A)=>{if(m<=S)throw t;if(d===":"&&u&&u.type==="property")u.colonOffset=S,l=!1,u=void 0;else if(d===","){const R=i[i.length-1];typeof R=="number"?i[i.length-1]=R+1:(l=!0,i[i.length-1]=""),u=void 0}}})}catch(d){if(d!==t)throw d}return{path:i,previousNode:u,isAtPropertyKey:l,matches:d=>{let S=0;for(let A=0;S<d.length&&A<i.length;A++)if(d[S]===i[A]||d[S]==="*")S++;else if(d[S]!=="**")return!1;return S===d.length}}}e.getLocation=I;function c(r,m=[],i=C.DEFAULT){let t=null,u=[];const a=[];function l(d){Array.isArray(u)?u.push(d):t!==null&&(u[t]=d)}return o(r,{onObjectBegin:()=>{const d={};l(d),a.push(u),u=d,t=null},onObjectProperty:d=>{t=d},onObjectEnd:()=>{u=a.pop()},onArrayBegin:()=>{const d=[];l(d),a.push(u),u=d,t=null},onArrayEnd:()=>{u=a.pop()},onLiteralValue:l,onError:(d,S,A)=>{m.push({error:d,offset:S,length:A})}},i),u[0]}e.parse=c;function v(r,m=[],i=C.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(d){t.type==="property"&&(t.length=d-t.offset,t=t.parent)}function a(d){return t.children.push(d),d}o(r,{onObjectBegin:d=>{t=a({type:"object",offset:d,length:-1,parent:t,children:[]})},onObjectProperty:(d,S,A)=>{t=a({type:"property",offset:S,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:d,offset:S,length:A,parent:t})},onObjectEnd:(d,S)=>{t.length=d+S-t.offset,t=t.parent,u(d+S)},onArrayBegin:(d,S)=>{t=a({type:"array",offset:d,length:-1,parent:t,children:[]})},onArrayEnd:(d,S)=>{t.length=d+S-t.offset,t=t.parent,u(d+S)},onLiteralValue:(d,S,A)=>{a({type:p(d),offset:S,length:A,parent:t,value:d}),u(S+A)},onSeparator:(d,S,A)=>{t.type==="property"&&(d===":"?t.colonOffset=S:d===","&&u(S))},onError:(d,S,A)=>{m.push({error:d,offset:S,length:A})}},i);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=v;function h(r,m){if(!r)return;let i=r;for(let t of m)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let u=!1;for(const a of i.children)if(Array.isArray(a.children)&&a.children[0].value===t){i=a.children[1],u=!0;break}if(!u)return}else{const u=t;if(i.type!=="array"||u<0||!Array.isArray(i.children)||u>=i.children.length)return;i=i.children[u]}return i}e.findNodeAtLocation=h;function w(r){if(!r.parent||!r.parent.children)return[];const m=w(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;m.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&m.push(i)}return m}e.getNodePath=w;function E(r){switch(r.type){case"array":return r.children.map(E);case"object":const m=Object.create(null);for(let i of r.children){const t=i.children[1];t&&(m[i.children[0].value]=E(t))}return m;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=E;function T(r,m,i=!1){return m>=r.offset&&m<r.offset+r.length||i&&m===r.offset+r.length}e.contains=T;function b(r,m,i=!1){if(T(r,m,i)){const t=r.children;if(Array.isArray(t))for(let u=0;u<t.length&&t[u].offset<=m;u++){const a=b(t[u],m,i);if(a)return a}return r}}e.findNodeAtOffset=b;function o(r,m,i=C.DEFAULT){const t=n(r,!1);function u(Q){return Q?()=>Q(t.getTokenOffset(),t.getTokenLength()):()=>!0}function a(Q){return Q?de=>Q(de,t.getTokenOffset(),t.getTokenLength()):()=>!0}const l=u(m.onObjectBegin),f=a(m.onObjectProperty),d=u(m.onObjectEnd),S=u(m.onArrayBegin),A=u(m.onArrayEnd),R=a(m.onLiteralValue),B=a(m.onSeparator),x=u(m.onComment),F=a(m.onError),$=i&&i.disallowComments,M=i&&i.allowTrailingComma;function H(){for(;;){const Q=t.scan();switch(t.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:$||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(Q){case 12:case 13:$?N(10):x();break;case 16:N(1);break;case 15:case 14:break;default:return Q}}}function N(Q,de=[],Se=[]){if(F(Q),de.length+Se.length>0){let De=t.getToken();for(;De!==17;){if(de.indexOf(De)!==-1){H();break}else if(Se.indexOf(De)!==-1)break;De=H()}}}function U(Q){const de=t.getTokenValue();return Q?R(de):f(de),H(),!0}function V(){switch(t.getToken()){case 11:let Q=0;try{Q=JSON.parse(t.getTokenValue()),typeof Q!="number"&&(N(2),Q=0)}catch(de){N(2)}R(Q);break;case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return H(),!0}function O(){return t.getToken()!==10?(N(3,[],[2,5]),!1):(U(!1),t.getToken()===6?(B(":"),H(),X()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function W(){l(),H();let Q=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Q||N(4,[],[]),B(","),H(),t.getToken()===2&&M)break}else Q&&N(6,[],[]);O()||N(4,[],[2,5]),Q=!0}return d(),t.getToken()!==2?N(7,[2],[]):H(),!0}function j(){S(),H();let Q=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Q||N(4,[],[]),B(","),H(),t.getToken()===4&&M)break}else Q&&N(6,[],[]);X()||N(4,[],[4,5]),Q=!0}return A(),t.getToken()!==4?N(8,[4],[]):H(),!0}function X(){switch(t.getToken()){case 3:return j();case 1:return W();case 10:return U(!0);default:return V()}}return H(),t.getToken()===17?i.allowEmptyContent?!0:(N(4,[],[]),!1):X()?(t.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=o;function s(r,m){let i=n(r),t=[],u,a=0,l;do switch(l=i.getPosition(),u=i.scan(),u){case 12:case 13:case 17:a!==l&&t.push(r.substring(a,l)),m!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,m)),a=i.getPosition();break}while(u!==17);return t.join("")}e.stripComments=s;function p(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=p}),define(fe[139],me([0,1,61]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(_,D,P){let I,c,v,h,w;if(D){for(h=D.offset,w=h+D.length,v=h;v>0&&!k(_,v-1);)v--;let a=w;for(;a<_.length&&!k(_,a);)a++;c=_.substring(v,a),I=C(c,P)}else c=_,I=0,v=0,h=0,w=_.length;const E=n(P,_);let T=!1,b=0,o;P.insertSpaces?o=y(" ",P.tabSize||4):o="	";const s=(0,g.createScanner)(c,!1);let p=!1;function r(){return E+y(o,I+b)}function m(){let a=s.scan();for(T=!1;a===15||a===14;)T=T||a===14,a=s.scan();return p=a===16||s.getTokenError()!==0,a}const i=[];function t(a,l,f){!p&&l<w&&f>h&&_.substring(l,f)!==a&&i.push({offset:l,length:f-l,content:a})}let u=m();if(u!==17){const a=s.getTokenOffset()+v,l=y(o,I);t(l,v,a)}for(;u!==17;){let a=s.getTokenOffset()+s.getTokenLength()+v,l=m(),f="";for(;!T&&(l===12||l===13);){const S=s.getTokenOffset()+v;t(" ",a,S),a=s.getTokenOffset()+s.getTokenLength()+v,f=l===12?r():"",l=m()}if(l===2)u!==1&&(b--,f=r());else if(l===4)u!==3&&(b--,f=r());else{switch(u){case 3:case 1:b++,f=r();break;case 5:case 12:f=r();break;case 13:T?f=r():f=" ";break;case 6:f=" ";break;case 10:if(l===6){f="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?f=" ":l!==5&&l!==17&&(p=!0);break;case 16:p=!0;break}T&&(l===12||l===13)&&(f=r())}const d=s.getTokenOffset()+v;t(f,a,d),u=l}return i}e.format=L;function y(_,D){let P="";for(let I=0;I<D;I++)P+=_;return P}function C(_,D){let P=0,I=0;const c=D.tabSize||4;for(;P<_.length;){const v=_.charAt(P);if(v===" ")I++;else if(v==="	")I+=c;else break;P++}return Math.floor(I/c)}function n(_,D){for(let P=0;P<D.length;P++){const I=D.charAt(P);if(I==="\r")return P+1<D.length&&D.charAt(P+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return _&&_.eol||`
`}e.getEOL=n;function k(_,D){return`\r
`.indexOf(_.charAt(D))!==-1}e.isEOL=k}),define(fe[140],me([0,1,61,139]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function y(D,P,I){return C(D,P,void 0,I)}e.removeProperty=y;function C(D,P,I,c,v){const h=P.slice(),w=[],E=(0,g.parseTree)(D,w);let T,b;for(;h.length>0&&(b=h.pop(),T=(0,g.findNodeAtLocation)(E,h),T===void 0&&I!==void 0);)typeof b=="string"?I={[b]:I}:I=[I];if(T)if(T.type==="object"&&typeof b=="string"&&Array.isArray(T.children)){const o=(0,g.findNodeAtLocation)(T,[b]);if(o!==void 0)if(I===void 0){if(!o.parent)throw new Error("Malformed AST");const s=T.children.indexOf(o.parent);let p,r=o.parent.offset+o.parent.length;if(s>0){const m=T.children[s-1];p=m.offset+m.length}else p=T.offset+1,T.children.length>1&&(r=T.children[1].offset);return n(D,{offset:p,length:r-p,content:""},c)}else return n(D,{offset:o.offset,length:o.length,content:JSON.stringify(I)},c);else{if(I===void 0)return[];const s=`${JSON.stringify(b)}: ${JSON.stringify(I)}`,p=v?v(T.children.map(m=>m.children[0].value)):T.children.length;let r;if(p>0){const m=T.children[p-1];r={offset:m.offset+m.length,length:0,content:","+s}}else T.children.length===0?r={offset:T.offset+1,length:0,content:s}:r={offset:T.offset+1,length:0,content:s+","};return n(D,r,c)}}else if(T.type==="array"&&typeof b=="number"&&Array.isArray(T.children))if(I!==void 0){const o=`${JSON.stringify(I)}`;let s;if(T.children.length===0||b===0)s={offset:T.offset+1,length:0,content:T.children.length===0?o:o+","};else{const p=b===-1||b>T.children.length?T.children.length:b,r=T.children[p-1];s={offset:r.offset+r.length,length:0,content:","+o}}return n(D,s,c)}else{const o=b,s=T.children[o];let p;if(T.children.length===1)p={offset:T.offset+1,length:T.length-2,content:""};else if(T.children.length-1===o){const r=T.children[o-1],m=r.offset+r.length,i=T.offset+T.length;p={offset:m,length:i-2-m,content:""}}else p={offset:s.offset,length:T.children[o+1].offset-s.offset,content:""};return n(D,p,c)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${T.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return n(D,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(I)},c)}}e.setProperty=C;function n(D,P,I){let c=k(D,P),v=P.offset,h=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;v>0&&!(0,L.isEOL)(c,v-1);)v--;for(;h<c.length&&!(0,L.isEOL)(c,h);)h++}const w=(0,L.format)(c,{offset:v,length:h-v},I);for(let T=w.length-1;T>=0;T--){const b=w[T];c=k(c,b),v=Math.min(v,b.offset),h=Math.max(h,b.offset+b.length),h+=b.content.length-b.length}const E=D.length-(c.length-h)-v;return[{offset:v,length:E,content:c.substring(v,h)}]}e.withFormatting=n;function k(D,P){return D.substring(0,P.offset)+P.content+D.substring(P.offset+P.length)}e.applyEdit=k;function _(D,P){let I=P.slice(0).sort((v,h)=>{const w=v.offset-h.offset;return w===0?v.length-h.length:w}),c=D.length;for(let v=I.length-1;v>=0;v--){let h=I[v];if(h.offset+h.length<=c)D=k(D,h);else throw new Error("Overlapping edit");c=h.offset}return D}e.applyEdits=_}),define(fe[141],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(y){this.executor=y,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(y){this._error=y}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(y){return new g(()=>y(this.getValue()))}}e.Lazy=g}),define(fe[6],me([0,1,76,78]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const y=!1;let C=null;function n(t){C=t}if(e.setDisposableTracker=n,y){const t="__is_disposable_tracked__";n(new class{trackDisposable(u){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[t]||console.log(a)},3e3)}setParent(u,a){if(u&&u!==b.None)try{u[t]=!0}catch{}}markAsDisposed(u){if(u&&u!==b.None)try{u[t]=!0}catch{}}markAsSingleton(u){}})}function k(t){return C?.trackDisposable(t),t}function _(t){C?.markAsDisposed(t)}function D(t,u){C?.setParent(t,u)}function P(t,u){if(!!C)for(const a of t)C.setParent(a,u)}function I(t){return C?.markAsSingleton(t),t}e.markAsSingleton=I;class c extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=c;function v(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=v;function h(t){if(L.Iterable.is(t)){let u=[];for(const a of t)if(a)try{a.dispose()}catch(l){u.push(l)}if(u.length===1)throw u[0];if(u.length>1)throw new c(u);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function w(...t){const u=E(()=>h(t));return P(t,u),u}e.combinedDisposable=w;function E(t){const u=k({dispose:(0,g.once)(()=>{_(u),t()})});return u}e.toDisposable=E;class T{constructor(){this._toDispose=new Set,this._isDisposed=!1,k(this)}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return D(u,this),this._isDisposed?T.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=T,T.DISABLE_DISPOSED_WARNING=!1;class b{constructor(){this._store=new T,k(this),D(this._store,this)}dispose(){_(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=b,b.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,k(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){this._isDisposed||u===this._value||(this._value?.dispose(),u&&D(u,this),this._value=u)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,_(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const u=this._value;return this._value=void 0,u&&D(u,null),u}}e.MutableDisposable=o;class s{constructor(u){this._disposable=u,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=s;class p{constructor(){this.references=new Map}acquire(u,...a){let l=this.references.get(u);l||(l={counter:0,object:this.createReferencedObject(u,...a)},this.references.set(u,l));const{object:f}=l,d=(0,g.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(u,l.object),this.references.delete(u))});return l.counter++,{object:f,dispose:d}}}e.ReferenceCollection=p;class r{constructor(u){this.referenceCollection=u}async acquire(u,...a){const l=this.referenceCollection.acquire(u,...a);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(f){throw l.dispose(),f}}}e.AsyncReferenceCollection=r;class m{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=m;function i(t){const u=new T;try{t(u)}finally{u.dispose()}}e.disposeOnReturn=i}),define(fe[94],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(C){this.element=C,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class L{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let C=this._first;for(;C!==g.Undefined;){const n=C.next;C.prev=g.Undefined,C.next=g.Undefined,C=n}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(C){return this._insert(C,!1)}push(C){return this._insert(C,!0)}_insert(C,n){const k=new g(C);if(this._first===g.Undefined)this._first=k,this._last=k;else if(n){const D=this._last;this._last=k,k.prev=D,D.next=k}else{const D=this._first;this._first=k,k.next=D,D.prev=k}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(k))}}shift(){if(this._first!==g.Undefined){const C=this._first.element;return this._remove(this._first),C}}pop(){if(this._last!==g.Undefined){const C=this._last.element;return this._remove(this._last),C}}_remove(C){if(C.prev!==g.Undefined&&C.next!==g.Undefined){const n=C.prev;n.next=C.next,C.next.prev=n}else C.prev===g.Undefined&&C.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):C.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):C.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let C=this._first;for(;C!==g.Undefined;)yield C.element,C=C.next}}e.LinkedList=L}),function(Y,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Y=typeof globalThis!="undefined"?globalThis:Y||self,Y.marked=e())}(this,function(){"use strict";function Y(Re,ve){for(var Te=0;Te<ve.length;Te++){var se=ve[Te];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Re,se.key,se)}}function e(Re,ve,Te){return ve&&Y(Re.prototype,ve),Te&&Y(Re,Te),Re}function g(Re,ve){if(!!Re){if(typeof Re=="string")return L(Re,ve);var Te=Object.prototype.toString.call(Re).slice(8,-1);if(Te==="Object"&&Re.constructor&&(Te=Re.constructor.name),Te==="Map"||Te==="Set")return Array.from(Re);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return L(Re,ve)}}function L(Re,ve){(ve==null||ve>Re.length)&&(ve=Re.length);for(var Te=0,se=new Array(ve);Te<ve;Te++)se[Te]=Re[Te];return se}function y(Re,ve){var Te=typeof Symbol!="undefined"&&Re[Symbol.iterator]||Re["@@iterator"];if(Te)return(Te=Te.call(Re)).next.bind(Te);if(Array.isArray(Re)||(Te=g(Re))||ve&&Re&&typeof Re.length=="number"){Te&&(Re=Te);var se=0;return function(){return se>=Re.length?{done:!0}:{done:!1,value:Re[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var C={exports:{}};function n(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function k(Re){C.exports.defaults=Re}C.exports={defaults:n(),getDefaults:n,changeDefaults:k};var _=/[&<>"']/,D=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(ve){return c[ve]};function h(Re,ve){if(ve){if(_.test(Re))return Re.replace(D,v)}else if(P.test(Re))return Re.replace(I,v);return Re}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function E(Re){return Re.replace(w,function(ve,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var T=/(^|[^\[])\^/g;function b(Re,ve){Re=Re.source||Re,ve=ve||"";var Te={replace:function(ue,be){return be=be.source||be,be=be.replace(T,"$1"),Re=Re.replace(ue,be),Te},getRegex:function(){return new RegExp(Re,ve)}};return Te}var o=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function p(Re,ve,Te){if(Re){var se;try{se=decodeURIComponent(E(Te)).replace(o,"").toLowerCase()}catch(ue){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ve&&!s.test(Te)&&(Te=u(ve,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch(ue){return null}return Te}var r={},m=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(Re,ve){r[" "+Re]||(m.test(Re)?r[" "+Re]=Re+"/":r[" "+Re]=d(Re,"/",!0)),Re=r[" "+Re];var Te=Re.indexOf(":")===-1;return ve.substring(0,2)==="//"?Te?ve:Re.replace(i,"$1")+ve:ve.charAt(0)==="/"?Te?ve:Re.replace(t,"$1")+ve:Re+ve}var a={exec:function(){}};function l(Re){for(var ve=1,Te,se;ve<arguments.length;ve++){Te=arguments[ve];for(se in Te)Object.prototype.hasOwnProperty.call(Te,se)&&(Re[se]=Te[se])}return Re}function f(Re,ve){var Te=Re.replace(/\|/g,function(be,we,Fe){for(var qe=!1,ze=we;--ze>=0&&Fe[ze]==="\\";)qe=!qe;return qe?"|":" |"}),se=Te.split(/ \|/),ue=0;if(se[0].trim()||se.shift(),se[se.length-1].trim()||se.pop(),se.length>ve)se.splice(ve);else for(;se.length<ve;)se.push("");for(;ue<se.length;ue++)se[ue]=se[ue].trim().replace(/\\\|/g,"|");return se}function d(Re,ve,Te){var se=Re.length;if(se===0)return"";for(var ue=0;ue<se;){var be=Re.charAt(se-ue-1);if(be===ve&&!Te)ue++;else if(be!==ve&&Te)ue++;else break}return Re.substr(0,se-ue)}function S(Re,ve){if(Re.indexOf(ve[1])===-1)return-1;for(var Te=Re.length,se=0,ue=0;ue<Te;ue++)if(Re[ue]==="\\")ue++;else if(Re[ue]===ve[0])se++;else if(Re[ue]===ve[1]&&(se--,se<0))return ue;return-1}function A(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Re,ve){if(ve<1)return"";for(var Te="";ve>1;)ve&1&&(Te+=Re),ve>>=1,Re+=Re;return Te+Re}var B={escape:h,unescape:E,edit:b,cleanUrl:p,resolveUrl:u,noopTest:a,merge:l,splitCells:f,rtrim:d,findClosingBracket:S,checkSanitizeDeprecation:A,repeatString:R},x=C.exports.defaults,F=B.rtrim,$=B.splitCells,M=B.escape,H=B.findClosingBracket;function N(Re,ve,Te,se){var ue=ve.href,be=ve.title?M(ve.title):null,we=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){se.state.inLink=!0;var Fe={type:"link",raw:Te,href:ue,title:be,text:we,tokens:se.inlineTokens(we,[])};return se.state.inLink=!1,Fe}else return{type:"image",raw:Te,href:ue,title:be,text:M(we)}}function U(Re,ve){var Te=Re.match(/^(\s+)(?:```)/);if(Te===null)return ve;var se=Te[1];return ve.split(`
`).map(function(ue){var be=ue.match(/^\s+/);if(be===null)return ue;var we=be[0];return we.length>=se.length?ue.slice(se.length):ue}).join(`
`)}var V=function(){function Re(Te){this.options=Te||x}var ve=Re.prototype;return ve.space=function(se){var ue=this.rules.block.newline.exec(se);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ve.code=function(se){var ue=this.rules.block.code.exec(se);if(ue){var be=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?be:F(be,`
`)}}},ve.fences=function(se){var ue=this.rules.block.fences.exec(se);if(ue){var be=ue[0],we=U(be,ue[3]||"");return{type:"code",raw:be,lang:ue[2]?ue[2].trim():ue[2],text:we}}},ve.heading=function(se){var ue=this.rules.block.heading.exec(se);if(ue){var be=ue[2].trim();if(/#$/.test(be)){var we=F(be,"#");(this.options.pedantic||!we||/ $/.test(we))&&(be=we.trim())}var Fe={type:"heading",raw:ue[0],depth:ue[1].length,text:be,tokens:[]};return this.lexer.inline(Fe.text,Fe.tokens),Fe}},ve.hr=function(se){var ue=this.rules.block.hr.exec(se);if(ue)return{type:"hr",raw:ue[0]}},ve.blockquote=function(se){var ue=this.rules.block.blockquote.exec(se);if(ue){var be=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(be,[]),text:be}}},ve.list=function(se){var ue=this.rules.block.list.exec(se);if(ue){var be,we,Fe,qe,ze,Ye,ct,xe,ge,Ee,ae=ue[1].trim(),K=ae.length>1,Ce={type:"list",raw:"",ordered:K,start:K?+ae.slice(0,-1):"",loose:!1,items:[]};ae=K?"\\d{1,9}\\"+ae.slice(-1):"\\"+ae,this.options.pedantic&&(ae=K?ae:"[*+-]");for(var Le=new RegExp("^( {0,3}"+ae+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");se&&!(this.rules.block.hr.test(se)||!(ue=Le.exec(se)));){ge=ue[2].split(`
`),this.options.pedantic?(qe=2,Ee=ge[0].trimLeft()):(qe=ue[2].search(/[^ ]/),qe=ue[1].length+(qe>4?1:qe),Ee=ge[0].slice(qe-ue[1].length)),Ye=!1,be=ue[0],!ge[0]&&/^ *$/.test(ge[1])&&(be=ue[1]+ge.slice(0,2).join(`
`)+`
`,Ce.loose=!0,ge=[]);var nt=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(ze=1;ze<ge.length;ze++){if(xe=ge[ze],this.options.pedantic&&(xe=xe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),nt.test(xe)){be=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}if(!Ye){xe.trim()||(Ye=!0),xe.search(/[^ ]/)>=qe?Ee+=`
`+xe.slice(qe):Ee+=`
`+xe;continue}if(xe.search(/[^ ]/)>=qe||!xe.trim()){Ee+=`
`+xe.slice(qe);continue}else{be=ue[1]+ge.slice(0,ze).join(`
`)+`
`;break}}Ce.loose||(ct?Ce.loose=!0:/\n *\n *$/.test(be)&&(ct=!0)),this.options.gfm&&(we=/^\[[ xX]\] /.exec(Ee),we&&(Fe=we[0]!=="[ ] ",Ee=Ee.replace(/^\[[ xX]\] +/,""))),Ce.items.push({type:"list_item",raw:be,task:!!we,checked:Fe,loose:!1,text:Ee}),Ce.raw+=be,se=se.slice(be.length)}Ce.items[Ce.items.length-1].raw=be.trimRight(),Ce.items[Ce.items.length-1].text=Ee.trimRight(),Ce.raw=Ce.raw.trimRight();var Ge=Ce.items.length;for(ze=0;ze<Ge;ze++)this.lexer.state.top=!1,Ce.items[ze].tokens=this.lexer.blockTokens(Ce.items[ze].text,[]),Ce.items[ze].tokens.some(function(mt){return mt.type==="space"})&&(Ce.loose=!0,Ce.items[ze].loose=!0);return Ce}},ve.html=function(se){var ue=this.rules.block.html.exec(se);if(ue){var be={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(be.type="paragraph",be.text=this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]),be.tokens=[],this.lexer.inline(be.text,be.tokens)),be}},ve.def=function(se){var ue=this.rules.block.def.exec(se);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var be=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:be,raw:ue[0],href:ue[2],title:ue[3]}}},ve.table=function(se){var ue=this.rules.block.table.exec(se);if(ue){var be={type:"table",header:$(ue[1]).map(function(ct){return{text:ct}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(be.header.length===be.align.length){be.raw=ue[0];var we=be.align.length,Fe,qe,ze,Ye;for(Fe=0;Fe<we;Fe++)/^ *-+: *$/.test(be.align[Fe])?be.align[Fe]="right":/^ *:-+: *$/.test(be.align[Fe])?be.align[Fe]="center":/^ *:-+ *$/.test(be.align[Fe])?be.align[Fe]="left":be.align[Fe]=null;for(we=be.rows.length,Fe=0;Fe<we;Fe++)be.rows[Fe]=$(be.rows[Fe],be.header.length).map(function(ct){return{text:ct}});for(we=be.header.length,qe=0;qe<we;qe++)be.header[qe].tokens=[],this.lexer.inlineTokens(be.header[qe].text,be.header[qe].tokens);for(we=be.rows.length,qe=0;qe<we;qe++)for(Ye=be.rows[qe],ze=0;ze<Ye.length;ze++)Ye[ze].tokens=[],this.lexer.inlineTokens(Ye[ze].text,Ye[ze].tokens);return be}}},ve.lheading=function(se){var ue=this.rules.block.lheading.exec(se);if(ue){var be={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ve.paragraph=function(se){var ue=this.rules.block.paragraph.exec(se);if(ue){var be={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ve.text=function(se){var ue=this.rules.block.text.exec(se);if(ue){var be={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(be.text,be.tokens),be}},ve.escape=function(se){var ue=this.rules.inline.escape.exec(se);if(ue)return{type:"escape",raw:ue[0],text:M(ue[1])}},ve.tag=function(se){var ue=this.rules.inline.tag.exec(se);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):M(ue[0]):ue[0]}},ve.link=function(se){var ue=this.rules.inline.link.exec(se);if(ue){var be=ue[2].trim();if(!this.options.pedantic&&/^</.test(be)){if(!/>$/.test(be))return;var we=F(be.slice(0,-1),"\\");if((be.length-we.length)%2==0)return}else{var Fe=H(ue[2],"()");if(Fe>-1){var qe=ue[0].indexOf("!")===0?5:4,ze=qe+ue[1].length+Fe;ue[2]=ue[2].substring(0,Fe),ue[0]=ue[0].substring(0,ze).trim(),ue[3]=""}}var Ye=ue[2],ct="";if(this.options.pedantic){var xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ye);xe&&(Ye=xe[1],ct=xe[3])}else ct=ue[3]?ue[3].slice(1,-1):"";return Ye=Ye.trim(),/^</.test(Ye)&&(this.options.pedantic&&!/>$/.test(be)?Ye=Ye.slice(1):Ye=Ye.slice(1,-1)),N(ue,{href:Ye&&Ye.replace(this.rules.inline._escapes,"$1"),title:ct&&ct.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ve.reflink=function(se,ue){var be;if((be=this.rules.inline.reflink.exec(se))||(be=this.rules.inline.nolink.exec(se))){var we=(be[2]||be[1]).replace(/\s+/g," ");if(we=ue[we.toLowerCase()],!we||!we.href){var Fe=be[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return N(be,we,be[0],this.lexer)}},ve.emStrong=function(se,ue,be){be===void 0&&(be="");var we=this.rules.inline.emStrong.lDelim.exec(se);if(!!we&&!(we[3]&&be.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=we[1]||we[2]||"";if(!Fe||Fe&&(be===""||this.rules.inline.punctuation.exec(be))){var qe=we[0].length-1,ze,Ye,ct=qe,xe=0,ge=we[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,ue=ue.slice(-1*se.length+qe);(we=ge.exec(ue))!=null;)if(ze=we[1]||we[2]||we[3]||we[4]||we[5]||we[6],!!ze){if(Ye=ze.length,we[3]||we[4]){ct+=Ye;continue}else if((we[5]||we[6])&&qe%3&&!((qe+Ye)%3)){xe+=Ye;continue}if(ct-=Ye,!(ct>0)){if(Ye=Math.min(Ye,Ye+ct+xe),Math.min(qe,Ye)%2){var Ee=se.slice(1,qe+we.index+Ye);return{type:"em",raw:se.slice(0,qe+we.index+Ye+1),text:Ee,tokens:this.lexer.inlineTokens(Ee,[])}}var ae=se.slice(2,qe+we.index+Ye-1);return{type:"strong",raw:se.slice(0,qe+we.index+Ye+1),text:ae,tokens:this.lexer.inlineTokens(ae,[])}}}}}},ve.codespan=function(se){var ue=this.rules.inline.code.exec(se);if(ue){var be=ue[2].replace(/\n/g," "),we=/[^ ]/.test(be),Fe=/^ /.test(be)&&/ $/.test(be);return we&&Fe&&(be=be.substring(1,be.length-1)),be=M(be,!0),{type:"codespan",raw:ue[0],text:be}}},ve.br=function(se){var ue=this.rules.inline.br.exec(se);if(ue)return{type:"br",raw:ue[0]}},ve.del=function(se){var ue=this.rules.inline.del.exec(se);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},ve.autolink=function(se,ue){var be=this.rules.inline.autolink.exec(se);if(be){var we,Fe;return be[2]==="@"?(we=M(this.options.mangle?ue(be[1]):be[1]),Fe="mailto:"+we):(we=M(be[1]),Fe=we),{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ve.url=function(se,ue){var be;if(be=this.rules.inline.url.exec(se)){var we,Fe;if(be[2]==="@")we=M(this.options.mangle?ue(be[0]):be[0]),Fe="mailto:"+we;else{var qe;do qe=be[0],be[0]=this.rules.inline._backpedal.exec(be[0])[0];while(qe!==be[0]);we=M(be[0]),be[1]==="www."?Fe="http://"+we:Fe=we}return{type:"link",raw:be[0],text:we,href:Fe,tokens:[{type:"text",raw:we,text:we}]}}},ve.inlineText=function(se,ue){var be=this.rules.inline.text.exec(se);if(be){var we;return this.lexer.state.inRawBlock?we=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(be[0]):M(be[0]):be[0]:we=M(this.options.smartypants?ue(be[0]):be[0]),{type:"text",raw:be[0],text:we}}},Re}(),O=B.noopTest,W=B.edit,j=B.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:O,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=W(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.listItemStart=W(/^( *)(bull) */).replace("bull",X.bullet).getRegex(),X.list=W(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=W(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=W(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.blockquote=W(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=j({},X),X.gfm=j({},X.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.table=W(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",X._tag).getRegex(),X.pedantic=j({},X.normal,{html:W(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:O,paragraph:W(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:O,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:O,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=W(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=W(X._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=W(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=W(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=W(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=W(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=W(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=W(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=W(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=W(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=j({},Q),Q.pedantic=j({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:W(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:W(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=j({},Q.normal,{escape:W(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=W(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=j({},Q.gfm,{br:W(Q.br).replace("{2,}","*").getRegex(),text:W(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var de={block:X,inline:Q},Se=V,De=C.exports.defaults,Pe=de.block,Be=de.inline,We=B.repeatString;function He(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(Re){var ve="",Te,se,ue=Re.length;for(Te=0;Te<ue;Te++)se=Re.charCodeAt(Te),Math.random()>.5&&(se="x"+se.toString(16)),ve+="&#"+se+";";return ve}var ee=function(){function Re(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||De,this.options.tokenizer=this.options.tokenizer||new Se,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:Pe.normal,inline:Be.normal};this.options.pedantic?(se.block=Pe.pedantic,se.inline=Be.pedantic):this.options.gfm&&(se.block=Pe.gfm,this.options.breaks?se.inline=Be.breaks:se.inline=Be.gfm),this.tokenizer.rules=se}Re.lex=function(se,ue){var be=new Re(ue);return be.lex(se)},Re.lexInline=function(se,ue){var be=new Re(ue);return be.inlineTokens(se)};var ve=Re.prototype;return ve.lex=function(se){se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ve.blockTokens=function(se,ue){var be=this;ue===void 0&&(ue=[]),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var we,Fe,qe,ze;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ct){return(we=ct.call({lexer:be},se,ue))?(se=se.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.space(se)){se=se.substring(we.raw.length),we.type&&ue.push(we);continue}if(we=this.tokenizer.code(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(we=this.tokenizer.fences(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.heading(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.hr(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.blockquote(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.list(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.html(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.def(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[we.tag]||(this.tokens.links[we.tag]={href:we.href,title:we.title});continue}if(we=this.tokenizer.table(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.lheading(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(qe=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var ct=Infinity,xe=se.slice(1),ge=void 0;be.options.extensions.startBlock.forEach(function(Ee){ge=Ee.call({lexer:this},xe),typeof ge=="number"&&ge>=0&&(ct=Math.min(ct,ge))}),ct<Infinity&&ct>=0&&(qe=se.substring(0,ct+1))}(),this.state.top&&(we=this.tokenizer.paragraph(qe))){Fe=ue[ue.length-1],ze&&Fe.type==="paragraph"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we),ze=qe.length!==se.length,se=se.substring(we.raw.length);continue}if(we=this.tokenizer.text(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+we.raw,Fe.text+=`
`+we.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ue.push(we);continue}if(se){var Ye="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ye);break}else throw new Error(Ye)}}return this.state.top=!0,ue},ve.inline=function(se,ue){this.inlineQueue.push({src:se,tokens:ue})},ve.inlineTokens=function(se,ue){var be=this;ue===void 0&&(ue=[]);var we,Fe,qe,ze=se,Ye,ct,xe;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(Ye=this.tokenizer.rules.inline.reflinkSearch.exec(ze))!=null;)ge.includes(Ye[0].slice(Ye[0].lastIndexOf("[")+1,-1))&&(ze=ze.slice(0,Ye.index)+"["+We("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ye=this.tokenizer.rules.inline.blockSkip.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"["+We("a",Ye[0].length-2)+"]"+ze.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ye=this.tokenizer.rules.inline.escapedEmSt.exec(ze))!=null;)ze=ze.slice(0,Ye.index)+"++"+ze.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(ct||(xe=""),ct=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(we=ae.call({lexer:be},se,ue))?(se=se.substring(we.raw.length),ue.push(we),!0):!1}))){if(we=this.tokenizer.escape(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.tag(se)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.link(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(we.raw.length),Fe=ue[ue.length-1],Fe&&we.type==="text"&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(we=this.tokenizer.emStrong(se,ze,xe)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.codespan(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.br(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.del(se)){se=se.substring(we.raw.length),ue.push(we);continue}if(we=this.tokenizer.autolink(se,G)){se=se.substring(we.raw.length),ue.push(we);continue}if(!this.state.inLink&&(we=this.tokenizer.url(se,G))){se=se.substring(we.raw.length),ue.push(we);continue}if(qe=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=Infinity,K=se.slice(1),Ce=void 0;be.options.extensions.startInline.forEach(function(Le){Ce=Le.call({lexer:this},K),typeof Ce=="number"&&Ce>=0&&(ae=Math.min(ae,Ce))}),ae<Infinity&&ae>=0&&(qe=se.substring(0,ae+1))}(),we=this.tokenizer.inlineText(qe,He)){se=se.substring(we.raw.length),we.raw.slice(-1)!=="_"&&(xe=we.raw.slice(-1)),ct=!0,Fe=ue[ue.length-1],Fe&&Fe.type==="text"?(Fe.raw+=we.raw,Fe.text+=we.text):ue.push(we);continue}if(se){var Ee="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return ue},e(Re,null,[{key:"rules",get:function(){return{block:Pe,inline:Be}}}]),Re}(),ne=C.exports.defaults,le=B.cleanUrl,Z=B.escape,re=function(){function Re(Te){this.options=Te||ne}var ve=Re.prototype;return ve.code=function(se,ue,be){var we=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(se,we);Fe!=null&&Fe!==se&&(be=!0,se=Fe)}return se=se.replace(/\n$/,"")+`
`,we?'<pre><code class="'+this.options.langPrefix+Z(we,!0)+'">'+(be?se:Z(se,!0))+`</code></pre>
`:"<pre><code>"+(be?se:Z(se,!0))+`</code></pre>
`},ve.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ve.html=function(se){return se},ve.heading=function(se,ue,be,we){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+we.slug(be)+'">'+se+"</h"+ue+`>
`:"<h"+ue+">"+se+"</h"+ue+`>
`},ve.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ve.list=function(se,ue,be){var we=ue?"ol":"ul",Fe=ue&&be!==1?' start="'+be+'"':"";return"<"+we+Fe+`>
`+se+"</"+we+`>
`},ve.listitem=function(se){return"<li>"+se+`</li>
`},ve.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ve.paragraph=function(se){return"<p>"+se+`</p>
`},ve.table=function(se,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ue+`</table>
`},ve.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ve.tablecell=function(se,ue){var be=ue.header?"th":"td",we=ue.align?"<"+be+' align="'+ue.align+'">':"<"+be+">";return we+se+"</"+be+`>
`},ve.strong=function(se){return"<strong>"+se+"</strong>"},ve.em=function(se){return"<em>"+se+"</em>"},ve.codespan=function(se){return"<code>"+se+"</code>"},ve.br=function(){return this.options.xhtml?"<br/>":"<br>"},ve.del=function(se){return"<del>"+se+"</del>"},ve.link=function(se,ue,be){if(se=le(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var we='<a href="'+Z(se)+'"';return ue&&(we+=' title="'+ue+'"'),we+=">"+be+"</a>",we},ve.image=function(se,ue,be){if(se=le(this.options.sanitize,this.options.baseUrl,se),se===null)return be;var we='<img src="'+se+'" alt="'+be+'"';return ue&&(we+=' title="'+ue+'"'),we+=this.options.xhtml?"/>":">",we},ve.text=function(se){return se},Re}(),pe=function(){function Re(){}var ve=Re.prototype;return ve.strong=function(se){return se},ve.em=function(se){return se},ve.codespan=function(se){return se},ve.del=function(se){return se},ve.html=function(se){return se},ve.text=function(se){return se},ve.link=function(se,ue,be){return""+be},ve.image=function(se,ue,be){return""+be},ve.br=function(){return""},Re}(),Me=function(){function Re(){this.seen={}}var ve=Re.prototype;return ve.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ve.getNextSafeSlug=function(se,ue){var be=se,we=0;if(this.seen.hasOwnProperty(be)){we=this.seen[se];do we++,be=se+"-"+we;while(this.seen.hasOwnProperty(be))}return ue||(this.seen[se]=we,this.seen[be]=0),be},ve.slug=function(se,ue){ue===void 0&&(ue={});var be=this.serialize(se);return this.getNextSafeSlug(be,ue.dryrun)},Re}(),je=re,Ke=pe,Ze=Me,rt=C.exports.defaults,lt=B.unescape,ye=function(){function Re(Te){this.options=Te||rt,this.options.renderer=this.options.renderer||new je,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ke,this.slugger=new Ze}Re.parse=function(se,ue){var be=new Re(ue);return be.parse(se)},Re.parseInline=function(se,ue){var be=new Re(ue);return be.parseInline(se)};var ve=Re.prototype;return ve.parse=function(se,ue){ue===void 0&&(ue=!0);var be="",we,Fe,qe,ze,Ye,ct,xe,ge,Ee,ae,K,Ce,Le,nt,Ge,mt,Ct,Et,gt,bt=se.length;for(we=0;we<bt;we++){if(ae=se[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(gt=this.options.extensions.renderers[ae.type].call({parser:this},ae),gt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){be+=gt||"";continue}switch(ae.type){case"space":continue;case"hr":{be+=this.renderer.hr();continue}case"heading":{be+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,lt(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{be+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(ge="",xe="",ze=ae.header.length,Fe=0;Fe<ze;Fe++)xe+=this.renderer.tablecell(this.parseInline(ae.header[Fe].tokens),{header:!0,align:ae.align[Fe]});for(ge+=this.renderer.tablerow(xe),Ee="",ze=ae.rows.length,Fe=0;Fe<ze;Fe++){for(ct=ae.rows[Fe],xe="",Ye=ct.length,qe=0;qe<Ye;qe++)xe+=this.renderer.tablecell(this.parseInline(ct[qe].tokens),{header:!1,align:ae.align[qe]});Ee+=this.renderer.tablerow(xe)}be+=this.renderer.table(ge,Ee);continue}case"blockquote":{Ee=this.parse(ae.tokens),be+=this.renderer.blockquote(Ee);continue}case"list":{for(K=ae.ordered,Ce=ae.start,Le=ae.loose,ze=ae.items.length,Ee="",Fe=0;Fe<ze;Fe++)Ge=ae.items[Fe],mt=Ge.checked,Ct=Ge.task,nt="",Ge.task&&(Et=this.renderer.checkbox(mt),Le?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=Et+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=Et+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:Et}):nt+=Et),nt+=this.parse(Ge.tokens,Le),Ee+=this.renderer.listitem(nt,Ct,mt);be+=this.renderer.list(Ee,K,Ce);continue}case"html":{be+=this.renderer.html(ae.text);continue}case"paragraph":{be+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(Ee=ae.tokens?this.parseInline(ae.tokens):ae.text;we+1<bt&&se[we+1].type==="text";)ae=se[++we],Ee+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);be+=ue?this.renderer.paragraph(Ee):Ee;continue}default:{var vt='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return be},ve.parseInline=function(se,ue){ue=ue||this.renderer;var be="",we,Fe,qe,ze=se.length;for(we=0;we<ze;we++){if(Fe=se[we],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(qe=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){be+=qe||"";continue}switch(Fe.type){case"escape":{be+=ue.text(Fe.text);break}case"html":{be+=ue.html(Fe.text);break}case"link":{be+=ue.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ue));break}case"image":{be+=ue.image(Fe.href,Fe.title,Fe.text);break}case"strong":{be+=ue.strong(this.parseInline(Fe.tokens,ue));break}case"em":{be+=ue.em(this.parseInline(Fe.tokens,ue));break}case"codespan":{be+=ue.codespan(Fe.text);break}case"br":{be+=ue.br();break}case"del":{be+=ue.del(this.parseInline(Fe.tokens,ue));break}case"text":{be+=ue.text(Fe.text);break}default:{var Ye='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ye);return}else throw new Error(Ye)}}}return be},Re}(),at=ee,J=ye,ie=V,_e=re,Qe=pe,et=Me,ce=B.merge,Ie=B.checkSanitizeDeprecation,Ne=B.escape,Xe=C.exports.getDefaults,it=C.exports.changeDefaults,ft=C.exports.defaults;function tt(Re,ve,Te){if(typeof Re=="undefined"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof ve=="function"&&(Te=ve,ve=null),ve=ce({},tt.defaults,ve||{}),Ie(ve),Te){var se=ve.highlight,ue;try{ue=at.lex(Re,ve)}catch(qe){return Te(qe)}var be=function(ze){var Ye;if(!ze)try{ve.walkTokens&&tt.walkTokens(ue,ve.walkTokens),Ye=J.parse(ue,ve)}catch(ct){ze=ct}return ve.highlight=se,ze?Te(ze):Te(null,Ye)};if(!se||se.length<3||(delete ve.highlight,!ue.length))return be();var we=0;tt.walkTokens(ue,function(qe){qe.type==="code"&&(we++,setTimeout(function(){se(qe.text,qe.lang,function(ze,Ye){if(ze)return be(ze);Ye!=null&&Ye!==qe.text&&(qe.text=Ye,qe.escaped=!0),we--,we===0&&be()})},0))}),we===0&&be();return}try{var Fe=at.lex(Re,ve);return ve.walkTokens&&tt.walkTokens(Fe,ve.walkTokens),J.parse(Fe,ve)}catch(qe){if(qe.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+Ne(qe.message+"",!0)+"</pre>";throw qe}}tt.options=tt.setOptions=function(Re){return ce(tt.defaults,Re),it(tt.defaults),tt},tt.getDefaults=Xe,tt.defaults=ft,tt.use=function(){for(var Re=this,ve=arguments.length,Te=new Array(ve),se=0;se<ve;se++)Te[se]=arguments[se];var ue=ce.apply(void 0,[{}].concat(Te)),be=tt.defaults.extensions||{renderers:{},childTokens:{}},we;Te.forEach(function(Fe){if(Fe.extensions&&(we=!0,Fe.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var Ye=be.renderers?be.renderers[ze.name]:null;Ye?be.renderers[ze.name]=function(){for(var ct=arguments.length,xe=new Array(ct),ge=0;ge<ct;ge++)xe[ge]=arguments[ge];var Ee=ze.renderer.apply(this,xe);return Ee===!1&&(Ee=Ye.apply(this,xe)),Ee}:be.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");be[ze.level]?be[ze.level].unshift(ze.tokenizer):be[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?be.startBlock?be.startBlock.push(ze.start):be.startBlock=[ze.start]:ze.level==="inline"&&(be.startInline?be.startInline.push(ze.start):be.startInline=[ze.start]))}ze.childTokens&&(be.childTokens[ze.name]=ze.childTokens)})),Fe.renderer&&function(){var ze=tt.defaults.renderer||new _e,Ye=function(ge){var Ee=ze[ge];ze[ge]=function(){for(var ae=arguments.length,K=new Array(ae),Ce=0;Ce<ae;Ce++)K[Ce]=arguments[Ce];var Le=Fe.renderer[ge].apply(ze,K);return Le===!1&&(Le=Ee.apply(ze,K)),Le}};for(var ct in Fe.renderer)Ye(ct);ue.renderer=ze}(),Fe.tokenizer&&function(){var ze=tt.defaults.tokenizer||new ie,Ye=function(ge){var Ee=ze[ge];ze[ge]=function(){for(var ae=arguments.length,K=new Array(ae),Ce=0;Ce<ae;Ce++)K[Ce]=arguments[Ce];var Le=Fe.tokenizer[ge].apply(ze,K);return Le===!1&&(Le=Ee.apply(ze,K)),Le}};for(var ct in Fe.tokenizer)Ye(ct);ue.tokenizer=ze}(),Fe.walkTokens){var qe=tt.defaults.walkTokens;ue.walkTokens=function(ze){Fe.walkTokens.call(Re,ze),qe&&qe(ze)}}we&&(ue.extensions=be),tt.setOptions(ue)})},tt.walkTokens=function(Re,ve){for(var Te=function(){var we=ue.value;switch(ve(we),we.type){case"table":{for(var Fe=y(we.header),qe;!(qe=Fe()).done;){var ze=qe.value;tt.walkTokens(ze.tokens,ve)}for(var Ye=y(we.rows),ct;!(ct=Ye()).done;)for(var xe=ct.value,ge=y(xe),Ee;!(Ee=ge()).done;){var ae=Ee.value;tt.walkTokens(ae.tokens,ve)}break}case"list":{tt.walkTokens(we.items,ve);break}default:tt.defaults.extensions&&tt.defaults.extensions.childTokens&&tt.defaults.extensions.childTokens[we.type]?tt.defaults.extensions.childTokens[we.type].forEach(function(K){tt.walkTokens(we[K],ve)}):we.tokens&&tt.walkTokens(we.tokens,ve)}},se=y(Re),ue;!(ue=se()).done;)Te()},tt.parseInline=function(Re,ve){if(typeof Re=="undefined"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");ve=ce({},tt.defaults,ve||{}),Ie(ve);try{var Te=at.lexInline(Re,ve);return ve.walkTokens&&tt.walkTokens(Te,ve.walkTokens),J.parseInline(Te,ve)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ve.silent)return"<p>An error occurred:</p><pre>"+Ne(se.message+"",!0)+"</pre>";throw se}},tt.Parser=J,tt.parser=J.parse,tt.Renderer=_e,tt.TextRenderer=Qe,tt.Lexer=at,tt.lexer=at.lex,tt.Tokenizer=ie,tt.Slugger=et,tt.parse=tt;var ut=tt;return ut}),define(fe[79],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(n,k,_){return Math.min(Math.max(n,k),_)}e.clamp=g;function L(n,k){return(k+n%k)%k}e.rot=L;class y{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=y;class C{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=C}),function(){function Y(y){const C=[];typeof y=="number"&&C.push("code/timeOrigin",y);function n(_){C.push(_,Date.now())}function k(){const _=[];for(let D=0;D<C.length;D+=2)_.push({name:C[D],startTime:C[D+1]});return _}return{mark:n,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const C=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const n of performance.getEntriesByType("mark"))C.push({name:n.name,startTime:Math.round(y+n.startTime)});return C}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function g(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=g(L))}(),define(fe[12],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const g="en";let L=!1,y=!1,C=!1,n=!1,k=!1,_=!1,D=!1,P,I=g,c,v;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const w=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=w&&h?.sandboxed,typeof navigator=="object"&&!w)v=navigator.userAgent,L=v.indexOf("Windows")>=0,y=v.indexOf("Macintosh")>=0,D=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,C=v.indexOf("Linux")>=0,_=!0,P=navigator.language,I=P;else if(typeof h=="object"){L=h.platform==="win32",y=h.platform==="darwin",C=h.platform==="linux",n=C&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,P=g,I=g;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const t=JSON.parse(i),u=t.availableLanguages["*"];P=t.locale,I=u||g,c=t._translationsConfigFile}catch(t){}k=!0}else console.error("Unable to resolve platform.");var E;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function T(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=T;let b=0;y?b=1:L?b=3:C&&(b=2),e.isWindows=L,e.isMacintosh=y,e.isLinux=C,e.isLinuxSnap=n,e.isNative=k,e.isWeb=_,e.isIOS=D,e.platform=b,e.userAgent=v,e.language=I;var o;(function(i){function t(){return e.language}i.value=t;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=u;function a(){return e.language==="en"}i.isDefault=a})(o=e.Language||(e.Language={})),e.locale=P,e.translationsConfigFile=c,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeSetImmediateId)for(let f=0,d=u.length;f<d;f++){const S=u[f];if(S.id===l.data.vscodeSetImmediateId){u.splice(f,1),S.callback();return}}});let a=0;return l=>{const f=++a;u.push({id:f,callback:l}),e.globals.postMessage({vscodeSetImmediateId:f},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const t=Promise.resolve();return u=>t.then(u)}();var s;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||D?2:L?1:3;let p=!0,r=!1;function m(){if(!r){r=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,p=new Uint16Array(i.buffer)[0]===(2<<8)+1}return p}e.isLittleEndian=m}),define(fe[38],me([0,1,12]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const y=g.globals.vscode.process;L={get platform(){return y.platform},get arch(){return y.arch},get env(){return y.env},cwd(){return y.cwd()},nextTick(C){return(0,g.setImmediate)(C)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(y){return process.nextTick(y)}}:L={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},get arch(){},nextTick(y){return(0,g.setImmediate)(y)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(fe[9],me([0,1,38]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,y=97,C=90,n=122,k=46,_=47,D=92,P=58,I=63;class c extends Error{constructor(s,p,r){let m;typeof p=="string"&&p.indexOf("not ")===0?(m="must not be",p=p.replace(/^not /,"")):m="must be";const i=s.indexOf(".")!==-1?"property":"argument";let t=`The "${s}" ${i} ${m} of type ${p}`;t+=`. Received type ${typeof r}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function v(o,s){if(typeof o!="string")throw new c(s,"string",o)}function h(o){return o===_||o===D}function w(o){return o===_}function E(o){return o>=L&&o<=C||o>=y&&o<=n}function T(o,s,p,r){let m="",i=0,t=-1,u=0,a=0;for(let l=0;l<=o.length;++l){if(l<o.length)a=o.charCodeAt(l);else{if(r(a))break;a=_}if(r(a)){if(!(t===l-1||u===1))if(u===2){if(m.length<2||i!==2||m.charCodeAt(m.length-1)!==k||m.charCodeAt(m.length-2)!==k){if(m.length>2){const f=m.lastIndexOf(p);f===-1?(m="",i=0):(m=m.slice(0,f),i=m.length-1-m.lastIndexOf(p)),t=l,u=0;continue}else if(m.length!==0){m="",i=0,t=l,u=0;continue}}s&&(m+=m.length>0?`${p}..`:"..",i=2)}else m.length>0?m+=`${p}${o.slice(t+1,l)}`:m=o.slice(t+1,l),i=l-t-1;t=l,u=0}else a===k&&u!==-1?++u:u=-1}return m}function b(o,s){if(s===null||typeof s!="object")throw new c("pathObject","Object",s);const p=s.dir||s.root,r=s.base||`${s.name||""}${s.ext||""}`;return p?p===s.root?`${p}${r}`:`${p}${o}${r}`:r}e.win32={resolve(...o){let s="",p="",r=!1;for(let m=o.length-1;m>=-1;m--){let i;if(m>=0){if(i=o[m],v(i,"path"),i.length===0)continue}else s.length===0?i=g.cwd():(i=g.env[`=${s}`]||g.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==s.toLowerCase()&&i.charCodeAt(2)===D)&&(i=`${s}\\`));const t=i.length;let u=0,a="",l=!1;const f=i.charCodeAt(0);if(t===1)h(f)&&(u=1,l=!0);else if(h(f))if(l=!0,h(i.charCodeAt(1))){let d=2,S=d;for(;d<t&&!h(i.charCodeAt(d));)d++;if(d<t&&d!==S){const A=i.slice(S,d);for(S=d;d<t&&h(i.charCodeAt(d));)d++;if(d<t&&d!==S){for(S=d;d<t&&!h(i.charCodeAt(d));)d++;(d===t||d!==S)&&(a=`\\\\${A}\\${i.slice(S,d)}`,u=d)}}}else u=1;else E(f)&&i.charCodeAt(1)===P&&(a=i.slice(0,2),u=2,t>2&&h(i.charCodeAt(2))&&(l=!0,u=3));if(a.length>0)if(s.length>0){if(a.toLowerCase()!==s.toLowerCase())continue}else s=a;if(r){if(s.length>0)break}else if(p=`${i.slice(u)}\\${p}`,r=l,l&&s.length>0)break}return p=T(p,!r,"\\",h),r?`${s}\\${p}`:`${s}${p}`||"."},normalize(o){v(o,"path");const s=o.length;if(s===0)return".";let p=0,r,m=!1;const i=o.charCodeAt(0);if(s===1)return w(i)?"\\":o;if(h(i))if(m=!0,h(o.charCodeAt(1))){let u=2,a=u;for(;u<s&&!h(o.charCodeAt(u));)u++;if(u<s&&u!==a){const l=o.slice(a,u);for(a=u;u<s&&h(o.charCodeAt(u));)u++;if(u<s&&u!==a){for(a=u;u<s&&!h(o.charCodeAt(u));)u++;if(u===s)return`\\\\${l}\\${o.slice(a)}\\`;u!==a&&(r=`\\\\${l}\\${o.slice(a,u)}`,p=u)}}}else p=1;else E(i)&&o.charCodeAt(1)===P&&(r=o.slice(0,2),p=2,s>2&&h(o.charCodeAt(2))&&(m=!0,p=3));let t=p<s?T(o.slice(p),!m,"\\",h):"";return t.length===0&&!m&&(t="."),t.length>0&&h(o.charCodeAt(s-1))&&(t+="\\"),r===void 0?m?`\\${t}`:t:m?`${r}\\${t}`:`${r}${t}`},isAbsolute(o){v(o,"path");const s=o.length;if(s===0)return!1;const p=o.charCodeAt(0);return h(p)||s>2&&E(p)&&o.charCodeAt(1)===P&&h(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let s,p;for(let i=0;i<o.length;++i){const t=o[i];v(t,"path"),t.length>0&&(s===void 0?s=p=t:s+=`\\${t}`)}if(s===void 0)return".";let r=!0,m=0;if(typeof p=="string"&&h(p.charCodeAt(0))){++m;const i=p.length;i>1&&h(p.charCodeAt(1))&&(++m,i>2&&(h(p.charCodeAt(2))?++m:r=!1))}if(r){for(;m<s.length&&h(s.charCodeAt(m));)m++;m>=2&&(s=`\\${s.slice(m)}`)}return e.win32.normalize(s)},relative(o,s){if(v(o,"from"),v(s,"to"),o===s)return"";const p=e.win32.resolve(o),r=e.win32.resolve(s);if(p===r||(o=p.toLowerCase(),s=r.toLowerCase(),o===s))return"";let m=0;for(;m<o.length&&o.charCodeAt(m)===D;)m++;let i=o.length;for(;i-1>m&&o.charCodeAt(i-1)===D;)i--;const t=i-m;let u=0;for(;u<s.length&&s.charCodeAt(u)===D;)u++;let a=s.length;for(;a-1>u&&s.charCodeAt(a-1)===D;)a--;const l=a-u,f=t<l?t:l;let d=-1,S=0;for(;S<f;S++){const R=o.charCodeAt(m+S);if(R!==s.charCodeAt(u+S))break;R===D&&(d=S)}if(S!==f){if(d===-1)return r}else{if(l>f){if(s.charCodeAt(u+S)===D)return r.slice(u+S+1);if(S===2)return r.slice(u+S)}t>f&&(o.charCodeAt(m+S)===D?d=S:S===2&&(d=3)),d===-1&&(d=0)}let A="";for(S=m+d+1;S<=i;++S)(S===i||o.charCodeAt(S)===D)&&(A+=A.length===0?"..":"\\..");return u+=d,A.length>0?`${A}${r.slice(u,a)}`:(r.charCodeAt(u)===D&&++u,r.slice(u,a))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const s=e.win32.resolve(o);if(s.length<=2)return o;if(s.charCodeAt(0)===D){if(s.charCodeAt(1)===D){const p=s.charCodeAt(2);if(p!==I&&p!==k)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(E(s.charCodeAt(0))&&s.charCodeAt(1)===P&&s.charCodeAt(2)===D)return`\\\\?\\${s}`;return o},dirname(o){v(o,"path");const s=o.length;if(s===0)return".";let p=-1,r=0;const m=o.charCodeAt(0);if(s===1)return h(m)?o:".";if(h(m)){if(p=r=1,h(o.charCodeAt(1))){let u=2,a=u;for(;u<s&&!h(o.charCodeAt(u));)u++;if(u<s&&u!==a){for(a=u;u<s&&h(o.charCodeAt(u));)u++;if(u<s&&u!==a){for(a=u;u<s&&!h(o.charCodeAt(u));)u++;if(u===s)return o;u!==a&&(p=r=u+1)}}}}else E(m)&&o.charCodeAt(1)===P&&(p=s>2&&h(o.charCodeAt(2))?3:2,r=p);let i=-1,t=!0;for(let u=s-1;u>=r;--u)if(h(o.charCodeAt(u))){if(!t){i=u;break}}else t=!1;if(i===-1){if(p===-1)return".";i=p}return o.slice(0,i)},basename(o,s){s!==void 0&&v(s,"ext"),v(o,"path");let p=0,r=-1,m=!0,i;if(o.length>=2&&E(o.charCodeAt(0))&&o.charCodeAt(1)===P&&(p=2),s!==void 0&&s.length>0&&s.length<=o.length){if(s===o)return"";let t=s.length-1,u=-1;for(i=o.length-1;i>=p;--i){const a=o.charCodeAt(i);if(h(a)){if(!m){p=i+1;break}}else u===-1&&(m=!1,u=i+1),t>=0&&(a===s.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=u))}return p===r?r=u:r===-1&&(r=o.length),o.slice(p,r)}for(i=o.length-1;i>=p;--i)if(h(o.charCodeAt(i))){if(!m){p=i+1;break}}else r===-1&&(m=!1,r=i+1);return r===-1?"":o.slice(p,r)},extname(o){v(o,"path");let s=0,p=-1,r=0,m=-1,i=!0,t=0;o.length>=2&&o.charCodeAt(1)===P&&E(o.charCodeAt(0))&&(s=r=2);for(let u=o.length-1;u>=s;--u){const a=o.charCodeAt(u);if(h(a)){if(!i){r=u+1;break}continue}m===-1&&(i=!1,m=u+1),a===k?p===-1?p=u:t!==1&&(t=1):p!==-1&&(t=-1)}return p===-1||m===-1||t===0||t===1&&p===m-1&&p===r+1?"":o.slice(p,m)},format:b.bind(null,"\\"),parse(o){v(o,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return s;const p=o.length;let r=0,m=o.charCodeAt(0);if(p===1)return h(m)?(s.root=s.dir=o,s):(s.base=s.name=o,s);if(h(m)){if(r=1,h(o.charCodeAt(1))){let d=2,S=d;for(;d<p&&!h(o.charCodeAt(d));)d++;if(d<p&&d!==S){for(S=d;d<p&&h(o.charCodeAt(d));)d++;if(d<p&&d!==S){for(S=d;d<p&&!h(o.charCodeAt(d));)d++;d===p?r=d:d!==S&&(r=d+1)}}}}else if(E(m)&&o.charCodeAt(1)===P){if(p<=2)return s.root=s.dir=o,s;if(r=2,h(o.charCodeAt(2))){if(p===3)return s.root=s.dir=o,s;r=3}}r>0&&(s.root=o.slice(0,r));let i=-1,t=r,u=-1,a=!0,l=o.length-1,f=0;for(;l>=r;--l){if(m=o.charCodeAt(l),h(m)){if(!a){t=l+1;break}continue}u===-1&&(a=!1,u=l+1),m===k?i===-1?i=l:f!==1&&(f=1):i!==-1&&(f=-1)}return u!==-1&&(i===-1||f===0||f===1&&i===u-1&&i===t+1?s.base=s.name=o.slice(t,u):(s.name=o.slice(t,i),s.base=o.slice(t,u),s.ext=o.slice(i,u))),t>0&&t!==r?s.dir=o.slice(0,t-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...o){let s="",p=!1;for(let r=o.length-1;r>=-1&&!p;r--){const m=r>=0?o[r]:g.cwd();v(m,"path"),m.length!==0&&(s=`${m}/${s}`,p=m.charCodeAt(0)===_)}return s=T(s,!p,"/",w),p?`/${s}`:s.length>0?s:"."},normalize(o){if(v(o,"path"),o.length===0)return".";const s=o.charCodeAt(0)===_,p=o.charCodeAt(o.length-1)===_;return o=T(o,!s,"/",w),o.length===0?s?"/":p?"./":".":(p&&(o+="/"),s?`/${o}`:o)},isAbsolute(o){return v(o,"path"),o.length>0&&o.charCodeAt(0)===_},join(...o){if(o.length===0)return".";let s;for(let p=0;p<o.length;++p){const r=o[p];v(r,"path"),r.length>0&&(s===void 0?s=r:s+=`/${r}`)}return s===void 0?".":e.posix.normalize(s)},relative(o,s){if(v(o,"from"),v(s,"to"),o===s||(o=e.posix.resolve(o),s=e.posix.resolve(s),o===s))return"";const p=1,r=o.length,m=r-p,i=1,t=s.length-i,u=m<t?m:t;let a=-1,l=0;for(;l<u;l++){const d=o.charCodeAt(p+l);if(d!==s.charCodeAt(i+l))break;d===_&&(a=l)}if(l===u)if(t>u){if(s.charCodeAt(i+l)===_)return s.slice(i+l+1);if(l===0)return s.slice(i+l)}else m>u&&(o.charCodeAt(p+l)===_?a=l:l===0&&(a=0));let f="";for(l=p+a+1;l<=r;++l)(l===r||o.charCodeAt(l)===_)&&(f+=f.length===0?"..":"/..");return`${f}${s.slice(i+a)}`},toNamespacedPath(o){return o},dirname(o){if(v(o,"path"),o.length===0)return".";const s=o.charCodeAt(0)===_;let p=-1,r=!0;for(let m=o.length-1;m>=1;--m)if(o.charCodeAt(m)===_){if(!r){p=m;break}}else r=!1;return p===-1?s?"/":".":s&&p===1?"//":o.slice(0,p)},basename(o,s){s!==void 0&&v(s,"ext"),v(o,"path");let p=0,r=-1,m=!0,i;if(s!==void 0&&s.length>0&&s.length<=o.length){if(s===o)return"";let t=s.length-1,u=-1;for(i=o.length-1;i>=0;--i){const a=o.charCodeAt(i);if(a===_){if(!m){p=i+1;break}}else u===-1&&(m=!1,u=i+1),t>=0&&(a===s.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=u))}return p===r?r=u:r===-1&&(r=o.length),o.slice(p,r)}for(i=o.length-1;i>=0;--i)if(o.charCodeAt(i)===_){if(!m){p=i+1;break}}else r===-1&&(m=!1,r=i+1);return r===-1?"":o.slice(p,r)},extname(o){v(o,"path");let s=-1,p=0,r=-1,m=!0,i=0;for(let t=o.length-1;t>=0;--t){const u=o.charCodeAt(t);if(u===_){if(!m){p=t+1;break}continue}r===-1&&(m=!1,r=t+1),u===k?s===-1?s=t:i!==1&&(i=1):s!==-1&&(i=-1)}return s===-1||r===-1||i===0||i===1&&s===r-1&&s===p+1?"":o.slice(s,r)},format:b.bind(null,"/"),parse(o){v(o,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return s;const p=o.charCodeAt(0)===_;let r;p?(s.root="/",r=1):r=0;let m=-1,i=0,t=-1,u=!0,a=o.length-1,l=0;for(;a>=r;--a){const f=o.charCodeAt(a);if(f===_){if(!u){i=a+1;break}continue}t===-1&&(u=!1,t=a+1),f===k?m===-1?m=a:l!==1&&(l=1):m!==-1&&(l=-1)}if(t!==-1){const f=i===0&&p?1:i;m===-1||l===0||l===1&&m===t-1&&m===i+1?s.base=s.name=o.slice(f,t):(s.name=o.slice(f,m),s.base=o.slice(f,t),s.ext=o.slice(m,t))}return i>0?s.dir=o.slice(0,i-1):p&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(fe[95],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var g;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(g=e.Source||(e.Source={}));var L;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function y(C,...n){const k=n.reduce((P,I)=>(P[I]=!0,P),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(P=>!k[P]).forEach(P=>{for(let I=0;I<_.length;I++)if(P.search(_[I])!==-1){delete C[P];break}})}e.sanitizeProcessEnvironment=y}),define(fe[47],me([0,1,12]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=g.globals.performance&&typeof g.globals.performance.now=="function";class y{constructor(n){this._highResolution=L&&n,this._startTime=this._now(),this._stopTime=-1}static create(n=!0){return new y(n)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=y}),define(fe[3],me([0,1,18,76,6,94,47]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(s){s.None=()=>y.Disposable.None;function p(M){return(H,N=null,U)=>{let V=!1,O;return O=M(W=>{if(!V)return O?O.dispose():V=!0,H.call(N,W)},null,U),V&&O.dispose(),O}}s.once=p;function r(M,H){return l((N,U=null,V)=>M(O=>N.call(U,H(O)),null,V))}s.map=r;function m(M,H){return l((N,U=null,V)=>M(O=>{H(O),N.call(U,O)},null,V))}s.forEach=m;function i(M,H){return l((N,U=null,V)=>M(O=>H(O)&&N.call(U,O),null,V))}s.filter=i;function t(M){return M}s.signal=t;function u(...M){return(H,N=null,U)=>(0,y.combinedDisposable)(...M.map(V=>V(O=>H.call(N,O),null,U)))}s.any=u;function a(M,H,N){let U=N;return r(M,V=>(U=H(U,V),U))}s.reduce=a;function l(M){let H;const N=new c({onFirstListenerAdd(){H=M(N.fire,N)},onLastListenerRemove(){H.dispose()}});return N.event}function f(M,H,N=100,U=!1,V){let O,W,j,X=0;const Q=new c({leakWarningThreshold:V,onFirstListenerAdd(){O=M(de=>{X++,W=H(W,de),U&&!j&&(Q.fire(W),W=void 0),clearTimeout(j),j=setTimeout(()=>{const Se=W;W=void 0,j=void 0,(!U||X>1)&&Q.fire(Se),X=0},N)})},onLastListenerRemove(){O.dispose()}});return Q.event}s.debounce=f;function d(M,H=(N,U)=>N===U){let N=!0,U;return i(M,V=>{const O=N||!H(V,U);return N=!1,U=V,O})}s.latch=d;function S(M,H){return[s.filter(M,H),s.filter(M,N=>!H(N))]}s.split=S;function A(M,H=!1,N=[]){let U=N.slice(),V=M(j=>{U?U.push(j):W.fire(j)});const O=()=>{U&&U.forEach(j=>W.fire(j)),U=null},W=new c({onFirstListenerAdd(){V||(V=M(j=>W.fire(j)))},onFirstListenerDidAdd(){U&&(H?setTimeout(O):O())},onLastListenerRemove(){V&&V.dispose(),V=null}});return W.event}s.buffer=A;class R{constructor(H){this.event=H}map(H){return new R(r(this.event,H))}forEach(H){return new R(m(this.event,H))}filter(H){return new R(i(this.event,H))}reduce(H,N){return new R(a(this.event,H,N))}latch(){return new R(d(this.event))}debounce(H,N=100,U=!1,V){return new R(f(this.event,H,N,U,V))}on(H,N,U){return this.event(H,N,U)}once(H,N,U){return p(this.event)(H,N,U)}}function B(M){return new R(M)}s.chain=B;function x(M,H,N=U=>U){const U=(...j)=>W.fire(N(...j)),V=()=>M.on(H,U),O=()=>M.removeListener(H,U),W=new c({onFirstListenerAdd:V,onLastListenerRemove:O});return W.event}s.fromNodeEventEmitter=x;function F(M,H,N=U=>U){const U=(...j)=>W.fire(N(...j)),V=()=>M.addEventListener(H,U),O=()=>M.removeEventListener(H,U),W=new c({onFirstListenerAdd:V,onLastListenerRemove:O});return W.event}s.fromDOMEventEmitter=F;function $(M){return new Promise(H=>p(M)(H))}s.toPromise=$})(k=e.Event||(e.Event={}));class _{constructor(p){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${p}_${_._idPool++}`}start(p){this._stopWatch=new n.StopWatch(!0),this._listenerCount=p}stop(){if(this._stopWatch){const p=this._stopWatch.elapsed();this._elapsedOverall+=p,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${p.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let D=-1;function P(s){const p=D;return D=s,{dispose(){D=p}}}e.setGlobalLeakWarningThreshold=P;class I{constructor(p,r=Math.random().toString(18).slice(2,5)){this.customThreshold=p,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(p){let r=D;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||p<r)return;this._stacks||(this._stacks=new Map);const m=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(m)||0;if(this._stacks.set(m,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,u=0;for(const[a,l]of this._stacks)(!t||u<l)&&(t=a,u=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${u}):`),console.warn(t)}return()=>{const t=this._stacks.get(m)||0;this._stacks.set(m,t-1)}}}class c{constructor(p){this._disposed=!1,this._options=p,this._leakageMon=D>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(p,r,m)=>{this._listeners||(this._listeners=new C.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[p,r]:p);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,p,r);const u=this._leakageMon?.check(this._listeners.size),a=(0,y.toDisposable)(()=>{u&&u(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return m instanceof y.DisposableStore?m.add(a):Array.isArray(m)&&m.push(a),a}),this._event}fire(p){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new C.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,p]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,m]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,m):r[0].call(r[1],m)}catch(i){(0,g.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=c;class v extends c{async fireAsync(p,r,m){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new C.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,p]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),u=[],a={...t,waitUntil:l=>{if(Object.isFrozen(u))throw new Error("waitUntil can NOT be called asynchronous");m&&(l=m(l,typeof i=="function"?i:i[0])),u.push(l)}};try{typeof i=="function"?i.call(void 0,a):i[0].call(i[1],a)}catch(l){(0,g.onUnexpectedError)(l);continue}Object.freeze(u),await Promise.allSettled(u).then(l=>{for(const f of l)f.status==="rejected"&&(0,g.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=v;class h extends c{constructor(p){super(p);this._isPaused=0,this._eventQueue=new C.LinkedList,this._mergeFn=p?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const p=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(p))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(p){this._listeners&&(this._isPaused!==0?this._eventQueue.push(p):super.fire(p))}}e.PauseableEmitter=h;class w extends h{constructor(p){super(p);this._delay=p.delay??100}fire(p){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(p)}}e.DebounceEmitter=w;class E extends c{constructor(p){super(p);this._queuedEvents=[],this._mergeFn=p?.merge}fire(p){this._queuedEvents.push(p),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class T{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new c({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(p){const r={event:p,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const m=()=>{this.hasListeners&&this.unhook(r);const i=this.events.indexOf(r);this.events.splice(i,1)};return(0,y.toDisposable)((0,L.once)(m))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(p=>this.hook(p))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(p=>this.unhook(p))}hook(p){p.listener=p.event(r=>this.emitter.fire(r))}unhook(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=T;class b{constructor(){this.buffers=[]}wrapEvent(p){return(r,m,i)=>p(t=>{const u=this.buffers[this.buffers.length-1];u?u.push(()=>r.call(m,t)):r.call(m,t)},void 0,i)}bufferEvents(p){const r=[];this.buffers.push(r);const m=p();return this.buffers.pop(),r.forEach(i=>i()),m}}e.EventBufferer=b;class o{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=y.Disposable.None,this.emitter=new c({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(p){this.inputEvent=p,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=p(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(fe[21],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(k,_){const D=setTimeout(k.bind(_),0);return{dispose(){clearTimeout(D)}}});var y;(function(k){function _(D){return D===k.None||D===k.Cancelled||D instanceof C?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}k.isCancellationToken=_,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(y=e.CancellationToken||(e.CancellationToken={}));class C{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class n{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new C),this._token}cancel(){this._token?this._token instanceof C&&this._token.cancel():this._token=y.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof C&&this._token.dispose():this._token=y.None}}e.CancellationTokenSource=n}),define(fe[48],me([0,1,3]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(P){const I=this._icons.get(P.id);I?P.description?I.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const y=new L;e.iconRegistry=y;function C(D){return D?D.replace(/\$\((.*?)\)/g,(P,I)=>` ${I} `).trim():""}e.getCodiconAriaLabel=C;class n{constructor(P,I,c){this.id=P,this.definition=I,this.description=c,y.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n,n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function k(D,P){const I=["codicon","codicon-"+D];return P&&I.push("codicon-modifier-"+P),I}e.getClassNamesArray=k;var _;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9\\-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9\\-~]";const P=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function I(h){if(h instanceof n)return["codicon","codicon-"+h.id];const w=P.exec(h.id);if(!w)return I(n.error);let[,E,T]=w;const b=["codicon","codicon-"+E];return T&&b.push("codicon-modifier-"+T.substr(1)),b}D.asClassNameArray=I;function c(h){return I(h).join(" ")}D.asClassName=c;function v(h){return"."+I(h).join(".")}D.asCSSSelector=v})(_=e.CSSIcon||(e.CSSIcon={}))}),define(fe[96],me([0,1,18,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function y(o){const s=o;return s?[s.on,s.pause,s.resume,s.destroy].every(p=>typeof p=="function"):!1}e.isReadableStream=y;function C(o){const s=o;return s?y(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=C;function n(o,s){return new k(o,s)}e.newWriteableStream=n;class k{constructor(s,p){this.reducer=s,this.options=p,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(p=>this.pendingWritePromises.push(p))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(p=>p(s))}emitError(s){this.listeners.error.length===0?(0,g.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(p=>p(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,p){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(p),this.resume();break;case"end":this.listeners.end.push(p),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(p),this.state.flowing&&this.flowErrors();break}}removeListener(s,p){if(this.state.destroyed)return;let r;switch(s){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const m=r.indexOf(p);m>=0&&r.splice(m,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const p=[...this.pendingWritePromises];this.pendingWritePromises.length=0,p.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(o,s){const p=[];let r;for(;(r=o.read())!==null;)p.push(r);return s(p)}e.consumeReadable=_;function D(o,s,p){const r=[];let m;for(;(m=o.read())!==null&&r.length<p;)r.push(m);return m===null&&r.length>0?s(r):{read:()=>{if(r.length>0)return r.shift();if(typeof m!="undefined"){const i=m;return m=void 0,i}return o.read()}}}e.peekReadable=D;function P(o,s){return new Promise((p,r)=>{const m=[];I(o,{onData:i=>{s&&m.push(i)},onError:i=>{s?r(i):p(void 0)},onEnd:()=>{p(s?s(m):void 0)}})})}e.consumeStream=P;function I(o,s){o.on("error",p=>s.onError(p)),o.on("end",()=>s.onEnd()),o.on("data",p=>s.onData(p))}e.listenStream=I;function c(o,s){return new Promise((p,r)=>{const m=new L.DisposableStore,i=[],t=l=>{if(i.push(l),i.length>s)return m.dispose(),o.pause(),p({stream:o,buffer:i,ended:!1})},u=l=>r(l),a=()=>p({stream:o,buffer:i,ended:!0});m.add((0,L.toDisposable)(()=>o.removeListener("error",u))),o.on("error",u),m.add((0,L.toDisposable)(()=>o.removeListener("end",a))),o.on("end",a),m.add((0,L.toDisposable)(()=>o.removeListener("data",t))),o.on("data",t)})}e.peekStream=c;function v(o,s){const p=n(s);return p.end(o),p}e.toStream=v;function h(){const o=n(()=>{throw new Error("not supported")});return o.end(),o}e.emptyStream=h;function w(o){let s=!1;return{read:()=>s?null:(s=!0,o)}}e.toReadable=w;function E(o,s,p){const r=n(p);return I(o,{onData:m=>r.write(s.data(m)),onError:m=>r.error(s.error?s.error(m):m),onEnd:()=>r.end()}),r}e.transform=E;function T(o,s,p){let r=!1;return{read:()=>{const m=s.read();return r?m:(r=!0,m!==null?p([o,m]):o)}}}e.prefixedReadable=T;function b(o,s,p){let r=!1;const m=n(p);return I(s,{onData:i=>r?m.write(i):(r=!0,m.write(p([o,i]))),onError:i=>m.error(i),onEnd:()=>{r||(r=!0,m.write(o)),m.end()}}),m}e.prefixedStream=b}),define(fe[22],me([0,1,96]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let y,C;class n{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return L?new n(Buffer.allocUnsafe(t)):new n(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new n(t)}static fromString(t,u){return!(u?.dontUseNodeBuffer||!1)&&L?new n(Buffer.from(t)):(y||(y=new TextEncoder),new n(y.encode(t)))}static concat(t,u){if(typeof u=="undefined"){u=0;for(let f=0,d=t.length;f<d;f++)u+=t[f].byteLength}const a=n.alloc(u);let l=0;for(let f=0,d=t.length;f<d;f++){const S=t[f];a.set(S,l),l+=S.byteLength}return a}toString(){return L?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(t,u){return new n(this.buffer.subarray(t,u))}set(t,u){t instanceof n?this.buffer.set(t.buffer,u):this.buffer.set(t,u)}readUInt32BE(t){return D(this.buffer,t)}writeUInt32BE(t,u){P(this.buffer,t,u)}readUInt32LE(t){return I(this.buffer,t)}writeUInt32LE(t,u){c(this.buffer,t,u)}readUInt8(t){return v(this.buffer,t)}writeUInt8(t,u){h(this.buffer,t,u)}}e.VSBuffer=n;function k(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0}e.readUInt16LE=k;function _(i,t,u){i[u+0]=t&255,t=t>>>8,i[u+1]=t&255}e.writeUInt16LE=_;function D(i,t){return i[t]*2**24+i[t+1]*2**16+i[t+2]*2**8+i[t+3]}e.readUInt32BE=D;function P(i,t,u){i[u+3]=t,t=t>>>8,i[u+2]=t,t=t>>>8,i[u+1]=t,t=t>>>8,i[u]=t}e.writeUInt32BE=P;function I(i,t){return i[t+0]<<0>>>0|i[t+1]<<8>>>0|i[t+2]<<16>>>0|i[t+3]<<24>>>0}e.readUInt32LE=I;function c(i,t,u){i[u+0]=t&255,t=t>>>8,i[u+1]=t&255,t=t>>>8,i[u+2]=t&255,t=t>>>8,i[u+3]=t&255}e.writeUInt32LE=c;function v(i,t){return i[t]}e.readUInt8=v;function h(i,t,u){i[u]=t}e.writeUInt8=h;function w(i){return g.consumeReadable(i,t=>n.concat(t))}e.readableToBuffer=w;function E(i){return g.toReadable(i)}e.bufferToReadable=E;function T(i){return g.consumeStream(i,t=>n.concat(t))}e.streamToBuffer=T;async function b(i){return i.ended?n.concat(i.buffer):n.concat([...i.buffer,await T(i.stream)])}e.bufferedStreamToBuffer=b;function o(i){return g.toStream(i,t=>n.concat(t))}e.bufferToStream=o;function s(i){return g.transform(i,{data:t=>typeof t=="string"?n.fromString(t):n.wrap(t)},t=>n.concat(t))}e.streamToBufferReadableStream=s;function p(i){return g.newWriteableStream(t=>n.concat(t),i)}e.newWriteableBufferStream=p;function r(i,t){return g.prefixedReadable(i,t,u=>n.concat(u))}e.prefixedBufferReadable=r;function m(i,t){return g.prefixedStream(i,t,u=>n.concat(u))}e.prefixedBufferStream=m}),define(fe[8],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function g(ce){return!ce||typeof ce!="string"?!0:ce.trim().length===0}e.isFalsyOrWhitespace=g;const L=/{(\d+)}/g;function y(ce,...Ie){return Ie.length===0?ce:ce.replace(L,function(Ne,Xe){const it=parseInt(Xe,10);return isNaN(it)||it<0||it>=Ie.length?Ne:Ie[it]})}e.format=y;const C=/{([^}]+)}/g;function n(ce,Ie){return ce.replace(C,(Ne,Xe)=>Ie[Xe]??Ne)}e.format2=n;function k(ce){return ce.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=k;function _(ce){return ce.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function D(ce,Ie){let Ne=0;const Xe=Ie.charCodeAt(0);for(let it=ce.length-1;it>=0;it--)ce.charCodeAt(it)===Xe&&Ne++;return Ne}e.count=D;function P(ce,Ie,Ne="\u2026"){return ce.length<=Ie?ce:`${ce.substr(0,Ie)}${Ne}`}e.truncate=P;function I(ce,Ie=" "){const Ne=c(ce,Ie);return v(Ne,Ie)}e.trim=I;function c(ce,Ie){if(!ce||!Ie)return ce;const Ne=Ie.length;if(Ne===0||ce.length===0)return ce;let Xe=0;for(;ce.indexOf(Ie,Xe)===Xe;)Xe=Xe+Ne;return ce.substring(Xe)}e.ltrim=c;function v(ce,Ie){if(!ce||!Ie)return ce;const Ne=Ie.length,Xe=ce.length;if(Ne===0||Xe===0)return ce;let it=Xe,ft=-1;for(;ft=ce.lastIndexOf(Ie,it-1),!(ft===-1||ft+Ne!==it);){if(ft===0)return"";it=ft}return ce.substring(0,it)}e.rtrim=v;function h(ce){return ce.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function w(ce){return ce.replace(/\*/g,"")}e.stripWildcards=w;function E(ce,Ie,Ne={}){if(!ce)throw new Error("Cannot create regex from empty string");Ie||(ce=_(ce)),Ne.wholeWord&&(/\B/.test(ce.charAt(0))||(ce="\\b"+ce),/\B/.test(ce.charAt(ce.length-1))||(ce=ce+"\\b"));let Xe="";return Ne.global&&(Xe+="g"),Ne.matchCase||(Xe+="i"),Ne.multiline&&(Xe+="m"),Ne.unicode&&(Xe+="u"),new RegExp(ce,Xe)}e.createRegExp=E;function T(ce){return ce.source==="^"||ce.source==="^$"||ce.source==="$"||ce.source==="^\\s*$"?!1:!!(ce.exec("")&&ce.lastIndex===0)}e.regExpLeadsToEndlessLoop=T;function b(ce){return!!ce.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function o(ce){return(ce.global?"g":"")+(ce.ignoreCase?"i":"")+(ce.multiline?"m":"")+(ce.unicode?"u":"")}e.regExpFlags=o;function s(ce){return ce.split(/\r\n|\r|\n/)}e.splitLines=s;function p(ce){for(let Ie=0,Ne=ce.length;Ie<Ne;Ie++){const Xe=ce.charCodeAt(Ie);if(Xe!==32&&Xe!==9)return Ie}return-1}e.firstNonWhitespaceIndex=p;function r(ce,Ie=0,Ne=ce.length){for(let Xe=Ie;Xe<Ne;Xe++){const it=ce.charCodeAt(Xe);if(it!==32&&it!==9)return ce.substring(Ie,Xe)}return ce.substring(Ie,Ne)}e.getLeadingWhitespace=r;function m(ce,Ie=ce.length-1){for(let Ne=Ie;Ne>=0;Ne--){const Xe=ce.charCodeAt(Ne);if(Xe!==32&&Xe!==9)return Ne}return-1}e.lastNonWhitespaceIndex=m;function i(ce,Ie){return ce<Ie?-1:ce>Ie?1:0}e.compare=i;function t(ce,Ie,Ne=0,Xe=ce.length,it=0,ft=Ie.length){for(;Ne<Xe&&it<ft;Ne++,it++){let Re=ce.charCodeAt(Ne),ve=Ie.charCodeAt(it);if(Re<ve)return-1;if(Re>ve)return 1}const tt=Xe-Ne,ut=ft-it;return tt<ut?-1:tt>ut?1:0}e.compareSubstring=t;function u(ce,Ie){return a(ce,Ie,0,ce.length,0,Ie.length)}e.compareIgnoreCase=u;function a(ce,Ie,Ne=0,Xe=ce.length,it=0,ft=Ie.length){for(;Ne<Xe&&it<ft;Ne++,it++){let Re=ce.charCodeAt(Ne),ve=Ie.charCodeAt(it);if(Re===ve)continue;if(Re>=128||ve>=128)return t(ce.toLowerCase(),Ie.toLowerCase(),Ne,Xe,it,ft);l(Re)&&(Re-=32),l(ve)&&(ve-=32);const Te=Re-ve;if(Te!==0)return Te}const tt=Xe-Ne,ut=ft-it;return tt<ut?-1:tt>ut?1:0}e.compareSubstringIgnoreCase=a;function l(ce){return ce>=97&&ce<=122}e.isLowerAsciiLetter=l;function f(ce){return ce>=65&&ce<=90}e.isUpperAsciiLetter=f;function d(ce,Ie){return ce.length===Ie.length&&a(ce,Ie)===0}e.equalsIgnoreCase=d;function S(ce,Ie){const Ne=Ie.length;return Ie.length>ce.length?!1:a(ce,Ie,0,Ne)===0}e.startsWithIgnoreCase=S;function A(ce,Ie){let Ne,Xe=Math.min(ce.length,Ie.length);for(Ne=0;Ne<Xe;Ne++)if(ce.charCodeAt(Ne)!==Ie.charCodeAt(Ne))return Ne;return Xe}e.commonPrefixLength=A;function R(ce,Ie){let Ne,Xe=Math.min(ce.length,Ie.length);const it=ce.length-1,ft=Ie.length-1;for(Ne=0;Ne<Xe;Ne++)if(ce.charCodeAt(it-Ne)!==Ie.charCodeAt(ft-Ne))return Ne;return Xe}e.commonSuffixLength=R;function B(ce){return 55296<=ce&&ce<=56319}e.isHighSurrogate=B;function x(ce){return 56320<=ce&&ce<=57343}e.isLowSurrogate=x;function F(ce,Ie){return(ce-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=F;function $(ce,Ie,Ne){const Xe=ce.charCodeAt(Ne);if(B(Xe)&&Ne+1<Ie){const it=ce.charCodeAt(Ne+1);if(x(it))return F(Xe,it)}return Xe}e.getNextCodePoint=$;function M(ce,Ie){const Ne=ce.charCodeAt(Ie-1);if(x(Ne)&&Ie>1){const Xe=ce.charCodeAt(Ie-2);if(B(Xe))return F(Xe,Ne)}return Ne}function H(ce,Ie){const Ne=ye.getInstance(),Xe=Ie,it=ce.length,ft=$(ce,it,Ie);Ie+=ft>=65536?2:1;let tt=Ne.getGraphemeBreakType(ft);for(;Ie<it;){const ut=$(ce,it,Ie),Re=Ne.getGraphemeBreakType(ut);if(rt(tt,Re))break;Ie+=ut>=65536?2:1,tt=Re}return Ie-Xe}e.nextCharLength=H;function N(ce,Ie){const Ne=ye.getInstance(),Xe=Ie,it=M(ce,Ie);Ie-=it>=65536?2:1;let ft=Ne.getGraphemeBreakType(it);for(;Ie>0;){const tt=M(ce,Ie),ut=Ne.getGraphemeBreakType(tt);if(rt(ut,ft))break;Ie-=tt>=65536?2:1,ft=ut}return Xe-Ie}e.prevCharLength=N;function U(ce,Ie){const Ne=ye.getInstance(),Xe=ce.length,it=Ie,ft=$(ce,Xe,Ie),tt=Ne.getGraphemeBreakType(ft);Ie+=ft>=65536?2:1;let ut=tt;for(;Ie<Xe;){const ve=$(ce,Xe,Ie),Te=Ne.getGraphemeBreakType(ve);if(rt(ut,Te))break;Ie+=ve>=65536?2:1,ut=Te}const Re=Ie;for(Ie=it,ut=tt;Ie>0;){const ve=M(ce,Ie),Te=Ne.getGraphemeBreakType(ve);if(rt(Te,ut))break;Ie-=ve>=65536?2:1,ut=Te}return[Ie,Re]}function V(ce,Ie){return Ie>0&&x(ce.charCodeAt(Ie))?U(ce,Ie-1):U(ce,Ie)}e.getCharContainingOffset=V;const O=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(ce){return O.test(ce)}e.containsRTL=W;const j=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(ce){return j.test(ce)}e.containsEmoji=X;const Q=/^[\t\n\r\x20-\x7E]*$/;function de(ce){return Q.test(ce)}e.isBasicASCII=de,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Se(ce){return e.UNUSUAL_LINE_TERMINATORS.test(ce)}e.containsUnusualLineTerminators=Se;function De(ce){for(let Ie=0,Ne=ce.length;Ie<Ne;Ie++)if(Pe(ce.charCodeAt(Ie)))return!0;return!1}e.containsFullWidthCharacter=De;function Pe(ce){return ce>=11904&&ce<=55215||ce>=63744&&ce<=64255||ce>=65281&&ce<=65374}e.isFullWidthCharacter=Pe;function Be(ce){return ce>=127462&&ce<=127487||ce===8986||ce===8987||ce===9200||ce===9203||ce>=9728&&ce<=10175||ce===11088||ce===11093||ce>=127744&&ce<=128591||ce>=128640&&ce<=128764||ce>=128992&&ce<=129003||ce>=129280&&ce<=129535||ce>=129648&&ce<=129750}e.isEmojiImprecise=Be;function We(ce,Ie){if(ce.length<Ie)return ce;const Ne=/\b/g;let Xe=0;for(;Ne.test(ce)&&!(ce.length-Ne.lastIndex<Ie);)Xe=Ne.lastIndex,Ne.lastIndex+=1;return ce.substring(Xe).replace(/^\s/,"")}e.lcut=We;const He=/\x1B\x5B[12]?K/g,G=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function ne(ce){return ce&&(ce=ce.replace(He,""),ce=ce.replace(G,""),ce=ce.replace(ee,"")),ce}e.removeAnsiEscapeCodes=ne,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function le(ce){return!!(ce&&ce.length>0&&ce.charCodeAt(0)===65279)}e.startsWithUTF8BOM=le;function Z(ce){return le(ce)?ce.substr(1):ce}e.stripUTF8BOM=Z;function re(ce,Ie){if(!ce||!Ie||ce.length<Ie.length)return!1;const Ne=Ie.length,Xe=ce.toLowerCase();let it=0,ft=-1;for(;it<Ne;){const tt=Xe.indexOf(Ie[it],ft+1);if(tt<0)return!1;ft=tt,it++}return!0}e.fuzzyContains=re;function pe(ce,Ie=!1){return ce?(Ie&&(ce=ce.replace(/\\./g,"")),ce.toLowerCase()!==ce):!1}e.containsUppercaseCharacter=pe;function Me(ce){return ce.charAt(0).toUpperCase()+ce.slice(1)}e.uppercaseFirstLetter=Me;function je(ce,Ie=1){if(Ie===0)return"";let Ne=-1;do Ne=ce.indexOf(`
`,Ne+1),Ie--;while(Ie>0&&Ne>=0);return Ne===-1?ce:(ce[Ne-1]==="\r"&&Ne--,ce.substr(0,Ne))}e.getNLines=je;function Ke(ce){const Ie=90-65+1;return ce=ce%(2*Ie),ce<Ie?String.fromCharCode(97+ce):String.fromCharCode(65+ce-Ie)}e.singleLetterHash=Ke;function Ze(ce){return ye.getInstance().getGraphemeBreakType(ce)}e.getGraphemeBreakType=Ze;function rt(ce,Ie){return ce===0?Ie!==5&&Ie!==7:ce===2&&Ie===3?!1:ce===4||ce===2||ce===3||Ie===4||Ie===2||Ie===3?!0:!(ce===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ce===11||ce===9)&&(Ie===9||Ie===10)||(ce===12||ce===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ce===1||ce===13&&Ie===14||ce===6&&Ie===6)}e.breakBetweenGraphemeBreakType=rt;var lt;(function(ce){ce[ce.Other=0]="Other",ce[ce.Prepend=1]="Prepend",ce[ce.CR=2]="CR",ce[ce.LF=3]="LF",ce[ce.Control=4]="Control",ce[ce.Extend=5]="Extend",ce[ce.Regional_Indicator=6]="Regional_Indicator",ce[ce.SpacingMark=7]="SpacingMark",ce[ce.L=8]="L",ce[ce.V=9]="V",ce[ce.T=10]="T",ce[ce.LV=11]="LV",ce[ce.LVT=12]="LVT",ce[ce.ZWJ=13]="ZWJ",ce[ce.Extended_Pictographic=14]="Extended_Pictographic"})(lt=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ye{constructor(){this._data=at()}static getInstance(){return ye._INSTANCE||(ye._INSTANCE=new ye),ye._INSTANCE}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ne=this._data,Xe=Ne.length/3;let it=1;for(;it<=Xe;)if(Ie<Ne[3*it])it=2*it;else if(Ie>Ne[3*it+1])it=2*it+1;else return Ne[3*it+2];return 0}}ye._INSTANCE=null;function at(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function J(ce,Ie){if(ce===0)return 0;const Ne=ie(ce,Ie);if(Ne!==void 0)return Ne;const Xe=M(Ie,ce);return ce-=_e(Xe),ce}e.getLeftDeleteOffset=J;function ie(ce,Ie){let Ne=M(Ie,ce);for(ce-=_e(Ne);Qe(Ne)||Ne===65039||Ne===8419;){if(ce===0)return;Ne=M(Ie,ce),ce-=_e(Ne)}if(!!Be(Ne)){if(ce>=0){const Xe=M(Ie,ce);Xe===8205&&(ce-=_e(Xe))}return ce}}function _e(ce){return ce>=65536?2:1}function Qe(ce){return 127995<=ce&&ce<=127999}var et;(function(ce){ce[ce.zwj=8205]="zwj",ce[ce.emojiVariantSelector=65039]="emojiVariantSelector",ce[ce.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={})),e.noBreakWhitespace="\xA0"}),define(fe[49],me([0,1,8]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(T){return y(T,0)}e.hash=L;function y(T,b){switch(typeof T){case"object":return T===null?C(349,b):Array.isArray(T)?_(T,b):D(T,b);case"string":return k(T,b);case"boolean":return n(T,b);case"number":return C(T,b);case"undefined":return C(937,b);default:return C(617,b)}}e.doHash=y;function C(T,b){return(b<<5)-b+T|0}e.numberHash=C;function n(T,b){return C(T?433:863,b)}function k(T,b){b=C(149417,b);for(let o=0,s=T.length;o<s;o++)b=C(T.charCodeAt(o),b);return b}e.stringHash=k;function _(T,b){return b=C(104579,b),T.reduce((o,s)=>y(s,o),b)}function D(T,b){return b=C(181387,b),Object.keys(T).sort().reduce((o,s)=>(o=k(s,o),y(T[s],o)),b)}class P{constructor(){this._value=0}get value(){return this._value}hash(b){return this._value=y(b,this._value),this._value}}e.Hasher=P;var I;(function(T){T[T.BLOCK_SIZE=64]="BLOCK_SIZE",T[T.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function c(T,b,o=32){const s=o-b,p=~((1<<s)-1);return(T<<b|(p&T)>>>s)>>>0}function v(T,b=0,o=T.byteLength,s=0){for(let p=0;p<o;p++)T[b+p]=s}function h(T,b,o="0"){for(;T.length<b;)T=o+T;return T}function w(T,b=32){return T instanceof ArrayBuffer?Array.from(new Uint8Array(T)).map(o=>o.toString(16).padStart(2,"0")).join(""):h((T>>>0).toString(16),b/4)}e.toHexString=w;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(b){const o=b.length;if(o===0)return;const s=this._buff;let p=this._buffLen,r=this._leftoverHighSurrogate,m,i;for(r!==0?(m=r,i=-1,r=0):(m=b.charCodeAt(0),i=0);;){let t=m;if(g.isHighSurrogate(m))if(i+1<o){const u=b.charCodeAt(i+1);g.isLowSurrogate(u)?(i++,t=g.computeCodePoint(m,u)):t=65533}else{r=m;break}else g.isLowSurrogate(m)&&(t=65533);if(p=this._push(s,p,t),i++,i<o)m=b.charCodeAt(i);else break}this._buffLen=p,this._leftoverHighSurrogate=r}_push(b,o,s){return s<128?b[o++]=s:s<2048?(b[o++]=192|(s&1984)>>>6,b[o++]=128|(s&63)>>>0):s<65536?(b[o++]=224|(s&61440)>>>12,b[o++]=128|(s&4032)>>>6,b[o++]=128|(s&63)>>>0):(b[o++]=240|(s&1835008)>>>18,b[o++]=128|(s&258048)>>>12,b[o++]=128|(s&4032)>>>6,b[o++]=128|(s&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),w(this._h0)+w(this._h1)+w(this._h2)+w(this._h3)+w(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const b=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(b/4294967296),!1),this._buffDV.setUint32(60,b%4294967296,!1),this._step()}_step(){const b=E._bigBlock32,o=this._buffDV;for(let l=0;l<64;l+=4)b.setUint32(l,o.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)b.setUint32(l,c(b.getUint32(l-12,!1)^b.getUint32(l-32,!1)^b.getUint32(l-56,!1)^b.getUint32(l-64,!1),1),!1);let s=this._h0,p=this._h1,r=this._h2,m=this._h3,i=this._h4,t,u,a;for(let l=0;l<80;l++)l<20?(t=p&r|~p&m,u=1518500249):l<40?(t=p^r^m,u=1859775393):l<60?(t=p&r|p&m|r&m,u=2400959708):(t=p^r^m,u=3395469782),a=c(s,5)+t+i+u+b.getUint32(l*4,!1)&4294967295,i=m,m=r,r=c(p,30),p=s,s=a;this._h0=this._h0+s&4294967295,this._h1=this._h1+p&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+m&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[24],me([0,1,15,8]),function(Y,e,g,L){"use strict";var y,C,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(i,t,u){let a=i.get(t);return a===void 0&&(a=u,i.set(t,a)),a}e.getOrSet=k;function _(i){const t=[];return i.forEach((u,a)=>{t.push(`${a} => ${u}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=_;function D(i){const t=[];return i.forEach(u=>{t.push(u)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=D;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const u=t.charCodeAt(0),a=this._value.charCodeAt(this._pos);return u-a}value(){return this._value[this._pos]}}e.StringIterator=P;class I{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class c{constructor(t=!0,u=!0){this._splitOnBackslash=t,this._caseSensitive=u}reset(t){return this._value=t.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,L.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var v;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(v||(v={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,L.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(E||(E={}));class T{constructor(t){this._iter=t}static forUris(t=()=>!1){return new T(new h(t))}static forPaths(){return new T(new c)}static forStrings(){return new T(new P)}static forConfigKeys(){return new T(new I)}clear(){this._root=void 0}fill(t,u){if(u){const a=u.slice(0);(0,g.shuffle)(a);for(let l of a)this.set(l,t)}else{const a=t.slice(0);(0,g.shuffle)(a);for(let l of a)this.set(l[0],l[1])}}set(t,u){const a=this._iter.reset(t);let l;this._root||(this._root=new w,this._root.segment=a.value());const f=[];for(l=this._root;;){const S=a.cmp(l.segment);if(S>0)l.left||(l.left=new w,l.left.segment=a.value()),f.push([-1,l]),l=l.left;else if(S<0)l.right||(l.right=new w,l.right.segment=a.value()),f.push([1,l]),l=l.right;else if(a.hasNext())a.next(),l.mid||(l.mid=new w,l.mid.segment=a.value()),f.push([0,l]),l=l.mid;else break}const d=l.value;l.value=u,l.key=t;for(let S=f.length-1;S>=0;S--){const A=f[S][1];A.updateHeight();const R=A.balanceFactor();if(R<-1||R>1){const B=f[S][0],x=f[S+1][0];if(B===1&&x===1)f[S][1]=A.rotateLeft();else if(B===-1&&x===-1)f[S][1]=A.rotateRight();else if(B===1&&x===-1)A.right=f[S+1][1]=f[S+1][1].rotateRight(),f[S][1]=A.rotateLeft();else if(B===-1&&x===1)A.left=f[S+1][1]=f[S+1][1].rotateLeft(),f[S][1]=A.rotateRight();else throw new Error;if(S>0)switch(f[S-1][0]){case-1:f[S-1][1].left=f[S][1];break;case 1:f[S-1][1].right=f[S][1];break;case 0:f[S-1][1].mid=f[S][1];break}else this._root=f[0][1]}}return d}get(t){return this._getNode(t)?.value}_getNode(t){const u=this._iter.reset(t);let a=this._root;for(;a;){const l=u.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(u.hasNext())u.next(),a=a.mid;else break}return a}has(t){const u=this._getNode(t);return!(u?.value===void 0&&u?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,u){const a=this._iter.reset(t),l=[];let f=this._root;for(;f;){const d=a.cmp(f.segment);if(d>0)l.push([-1,f]),f=f.left;else if(d<0)l.push([1,f]),f=f.right;else if(a.hasNext())a.next(),l.push([0,f]),f=f.mid;else break}if(!!f){if(u?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const d=this._min(f.right),{key:S,value:A,segment:R}=d;this._delete(d.key,!1),f.key=S,f.value=A,f.segment=R}else{const d=f.left??f.right;if(l.length>0){const[S,A]=l[l.length-1];switch(S){case-1:A.left=d;break;case 0:A.mid=d;break;case 1:A.right=d;break}}else this._root=d}for(let d=l.length-1;d>=0;d--){const S=l[d][1];S.updateHeight();const A=S.balanceFactor();if(A>1?(S.right.balanceFactor()>=0||(S.right=l[d+1][1]=l[d+1][1].rotateRight()),l[d][1]=S.rotateLeft()):A<-1&&(S.left.balanceFactor()<=0||(S.left=l[d+1][1]=l[d+1][1].rotateLeft()),l[d][1]=S.rotateRight()),d>0)switch(l[d-1][0]){case-1:l[d-1][1].left=l[d][1];break;case 1:l[d-1][1].right=l[d][1];break;case 0:l[d-1][1].mid=l[d][1];break}else this._root=l[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const u=this._iter.reset(t);let a=this._root,l;for(;a;){const f=u.cmp(a.segment);if(f>0)a=a.left;else if(f<0)a=a.right;else if(u.hasNext())u.next(),l=a.value||l,a=a.mid;else break}return a&&a.value||l}findSuperstr(t){const u=this._iter.reset(t);let a=this._root;for(;a;){const l=u.cmp(a.segment);if(l>0)a=a.left;else if(l<0)a=a.right;else if(u.hasNext())u.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(t){for(const[u,a]of this)t(a,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=u=>{if(!u)return!0;const a=u.balanceFactor();return a<-1||a>1?!1:t(u.left)&&t(u.right)};return t(this._root)}}e.TernarySearchTree=T;class b{constructor(t,u){this.uri=t,this.value=u}}class o{constructor(t,u){this[y]="ResourceMap",t instanceof o?(this.map=new Map(t.map),this.toKey=u??o.defaultToKey):(this.map=new Map,this.toKey=t??o.defaultToKey)}set(t,u){return this.map.set(this.toKey(t),new b(t,u)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,u){typeof u!="undefined"&&(t=t.bind(u));for(let[a,l]of this.map)t(l.value,l.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=o,o.defaultToKey=i=>i.toString();var s;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(s=e.Touch||(e.Touch={}));class p{constructor(){this[C]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,u=0){const a=this._map.get(t);if(!!a)return u!==0&&this.touch(a,u),a.value}set(t,u,a=0){let l=this._map.get(t);if(l)l.value=u,a!==0&&this.touch(l,a);else{switch(l={key:t,value:u,next:void 0,previous:void 0},a){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(t,l),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const u=this._map.get(t);if(!!u)return this._map.delete(t),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,u){const a=this._state;let l=this._head;for(;l;){if(u?t.bind(u)(l.value,l.key,this):t(l.value,l.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const t=this,u=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:a.key,done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return l}values(){const t=this,u=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:a.value,done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return l}entries(){const t=this,u=this._state;let a=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==u)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:[a.key,a.value],done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return l}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let u=this._head,a=this.size;for(;u&&a>t;)this._map.delete(u.key),u=u.next,a--;this._head=u,this._size=a,u&&(u.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const u=t.next,a=t.previous;if(!u||!a)throw new Error("Invalid list");u.previous=a,a.next=u}t.next=void 0,t.previous=void 0,this._state++}touch(t,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(t===this._head)return;const a=t.next,l=t.previous;t===this._tail?(l.next=void 0,this._tail=l):(a.previous=l,l.next=a),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(u===2){if(t===this._tail)return;const a=t.next,l=t.previous;t===this._head?(a.previous=void 0,this._head=a):(a.previous=l,l.next=a),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((u,a)=>{t.push([a,u])}),t}fromJSON(t){this.clear();for(const[u,a]of t)this.set(u,a)}}e.LinkedMap=p;class r extends p{constructor(t,u=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,u=2){return super.get(t,u)}peek(t){return super.get(t,0)}set(t,u){return super.set(t,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class m{constructor(t){n.set(this,void 0),st(this,n,t,"f")}get size(){return Oe(this,n,"f").size}forEach(t,u){Oe(this,n,"f").forEach(t,u)}get(t){return Oe(this,n,"f").get(t)}has(t){return Oe(this,n,"f").has(t)}entries(){return Oe(this,n,"f").entries()}keys(){return Oe(this,n,"f").keys()}values(){return Oe(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return Oe(this,n,"f").entries()}}e.ReadonlyMapView=m}),define(fe[97],me([0,1,24,8]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function y(...Z){return function(re,pe){for(let Me=0,je=Z.length;Me<je;Me++){const Ke=Z[Me](re,pe);if(Ke)return Ke}return null}}e.or=y,e.matchesStrictPrefix=C.bind(void 0,!1),e.matchesPrefix=C.bind(void 0,!0);function C(Z,re,pe){if(!pe||pe.length<re.length)return null;let Me;return Z?Me=L.startsWithIgnoreCase(pe,re):Me=pe.indexOf(re)===0,Me?re.length>0?[{start:0,end:re.length}]:[]:null}function n(Z,re){const pe=re.toLowerCase().indexOf(Z.toLowerCase());return pe===-1?null:[{start:pe,end:pe+Z.length}]}e.matchesContiguousSubString=n;function k(Z,re){return _(Z.toLowerCase(),re.toLowerCase(),0,0)}e.matchesSubString=k;function _(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]===re[Me]){let je=null;return(je=_(Z,re,pe+1,Me+1))?T({start:Me,end:Me+1},je):null}return _(Z,re,pe,Me+1)}function D(Z){return 97<=Z&&Z<=122}function P(Z){return 65<=Z&&Z<=90}e.isUpper=P;function I(Z){return 48<=Z&&Z<=57}function c(Z){return Z===32||Z===9||Z===10||Z===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Z=>v.add(Z.charCodeAt(0)));function h(Z){return c(Z)||v.has(Z)}function w(Z,re){return Z===re||h(Z)&&h(re)}function E(Z){return D(Z)||P(Z)||I(Z)}function T(Z,re){return re.length===0?re=[Z]:Z.end===re[0].start?re[0].start=Z.start:re.unshift(Z),re}function b(Z,re){for(let pe=re;pe<Z.length;pe++){const Me=Z.charCodeAt(pe);if(P(Me)||I(Me)||pe>0&&!E(Z.charCodeAt(pe-1)))return pe}return Z.length}function o(Z,re,pe,Me){if(pe===Z.length)return[];if(Me===re.length)return null;if(Z[pe]!==re[Me].toLowerCase())return null;{let je=null,Ke=Me+1;for(je=o(Z,re,pe+1,Me+1);!je&&(Ke=b(re,Ke))<re.length;)je=o(Z,re,pe+1,Ke),Ke++;return je===null?null:T({start:Me,end:Me+1},je)}}function s(Z){let re=0,pe=0,Me=0,je=0,Ke=0;for(let at=0;at<Z.length;at++)Ke=Z.charCodeAt(at),P(Ke)&&re++,D(Ke)&&pe++,E(Ke)&&Me++,I(Ke)&&je++;const Ze=re/Z.length,rt=pe/Z.length,lt=Me/Z.length,ye=je/Z.length;return{upperPercent:Ze,lowerPercent:rt,alphaPercent:lt,numericPercent:ye}}function p(Z){const{upperPercent:re,lowerPercent:pe}=Z;return pe===0&&re>.6}function r(Z){const{upperPercent:re,lowerPercent:pe,alphaPercent:Me,numericPercent:je}=Z;return pe>.2&&re<.8&&Me>.6&&je<.2}function m(Z){let re=0,pe=0,Me=0,je=0;for(let Ke=0;Ke<Z.length;Ke++)Me=Z.charCodeAt(Ke),P(Me)&&re++,D(Me)&&pe++,c(Me)&&je++;return(re===0||pe===0)&&je===0?Z.length<=30:re<=5}function i(Z,re){if(!re||(re=re.trim(),re.length===0)||!m(Z)||re.length>60)return null;const pe=s(re);if(!r(pe)){if(!p(pe))return null;re=re.toLowerCase()}let Me=null,je=0;for(Z=Z.toLowerCase();je<re.length&&(Me=o(Z,re,0,je))===null;)je=b(re,je+1);return Me}e.matchesCamelCase=i;function t(Z,re,pe=!1){if(!re||re.length===0)return null;let Me=null,je=0;for(Z=Z.toLowerCase(),re=re.toLowerCase();je<re.length&&(Me=u(Z,re,0,je,pe))===null;)je=a(re,je+1);return Me}e.matchesWords=t;function u(Z,re,pe,Me,je){if(pe===Z.length)return[];if(Me===re.length)return null;if(w(Z.charCodeAt(pe),re.charCodeAt(Me))){let Ke=null,Ze=Me+1;if(Ke=u(Z,re,pe+1,Me+1,je),!je)for(;!Ke&&(Ze=a(re,Ze))<re.length;)Ke=u(Z,re,pe+1,Ze,je),Ze++;return Ke===null?null:T({start:Me,end:Me+1},Ke)}else return null}function a(Z,re){for(let pe=re;pe<Z.length;pe++)if(h(Z.charCodeAt(pe))||pe>0&&h(Z.charCodeAt(pe-1)))return pe;return Z.length}const l=y(e.matchesPrefix,i,n),f=y(e.matchesPrefix,i,k),d=new g.LRUCache(1e4);function S(Z,re,pe=!1){if(typeof Z!="string"||typeof re!="string")return null;let Me=d.get(Z);Me||(Me=new RegExp(L.convertSimple2RegExpPattern(Z),"i"),d.set(Z,Me));const je=Me.exec(re);return je?[{start:je.index,end:je.index+je[0].length}]:pe?f(Z,re):l(Z,re)}e.matchesFuzzy=S;function A(Z,re){const pe=Be(Z,Z.toLowerCase(),0,re,re.toLowerCase(),0,!0);return pe?B(pe):null}e.matchesFuzzy2=A;function R(Z,re,pe,Me,je,Ke){const Ze=Math.min(13,Z.length);for(;pe<Ze;pe++){const rt=Be(Z,re,pe,Me,je,Ke,!1);if(rt)return rt}return[0,Ke]}e.anyScore=R;function B(Z){if(typeof Z=="undefined")return[];const re=[],pe=Z[1];for(let Me=Z.length-1;Me>1;Me--){const je=Z[Me]+pe,Ke=re[re.length-1];Ke&&Ke.end===je?Ke.end=je+1:re.push({start:je,end:je+1})}return re}e.createMatches=B;const x=128;function F(){const Z=[],re=[];for(let pe=0;pe<=x;pe++)re[pe]=0;for(let pe=0;pe<=x;pe++)Z.push(re.slice(0));return Z}function $(Z){const re=[];for(let pe=0;pe<=Z;pe++)re[pe]=0;return re}const M=$(2*x),H=$(2*x),N=F(),U=F(),V=F(),O=!1;function W(Z,re,pe,Me,je){function Ke(rt,lt,ye=" "){for(;rt.length<lt;)rt=ye+rt;return rt}let Ze=` |   |${Me.split("").map(rt=>Ke(rt,3)).join("|")}
`;for(let rt=0;rt<=pe;rt++)rt===0?Ze+=" |":Ze+=`${re[rt-1]}|`,Ze+=Z[rt].slice(0,je+1).map(lt=>Ke(lt.toString(),3)).join("|")+`
`;return Ze}function j(Z,re,pe,Me){Z=Z.substr(re),pe=pe.substr(Me),console.log(W(U,Z,Z.length,pe,pe.length)),console.log(W(V,Z,Z.length,pe,pe.length)),console.log(W(N,Z,Z.length,pe,pe.length))}function X(Z,re){if(re<0||re>=Z.length)return!1;const pe=Z.codePointAt(re);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(pe)}}function Q(Z,re){if(re<0||re>=Z.length)return!1;switch(Z.charCodeAt(re)){case 32:case 9:return!0;default:return!1}}function de(Z,re,pe){return re[Z]!==pe[Z]}function Se(Z,re,pe,Me,je,Ke,Ze=!1){for(;re<pe&&je<Ke;)Z[re]===Me[je]&&(Ze&&(M[re]=je),re+=1),je+=1;return re===pe}e.isPatternInWord=Se;var De;(function(Z){Z[Z.Diag=1]="Diag",Z[Z.Left=2]="Left",Z[Z.LeftLeft=3]="LeftLeft"})(De||(De={}));var Pe;(function(Z){Z.Default=[-100,0];function re(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}Z.isDefault=re})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Be(Z,re,pe,Me,je,Ke,Ze){const rt=Z.length>x?x:Z.length,lt=Me.length>x?x:Me.length;if(pe>=rt||Ke>=lt||rt-pe>lt-Ke||!Se(re,pe,rt,je,Ke,lt,!0))return;We(rt,lt,pe,Ke,re,je);let ye=1,at=1,J=pe,ie=Ke;const _e=[!1];for(ye=1,J=pe;J<rt;ye++,J++){const Ne=M[J],Xe=H[J],it=J+1<rt?H[J+1]:lt;for(at=Ne-Ke+1,ie=Ne;ie<it;at++,ie++){let ft=Number.MIN_SAFE_INTEGER,tt=!1;ie<=Xe&&(ft=He(Z,re,J,pe,Me,je,ie,lt,Ke,N[ye-1][at-1]===0,_e));let ut=0;ft!==Number.MAX_SAFE_INTEGER&&(tt=!0,ut=ft+U[ye-1][at-1]);const Re=ie>Ne,ve=Re?U[ye][at-1]+(N[ye][at-1]>0?-5:0):0,Te=ie>Ne+1&&N[ye][at-1]>0,se=Te?U[ye][at-2]+(N[ye][at-2]>0?-5:0):0;if(Te&&(!Re||se>=ve)&&(!tt||se>=ut))U[ye][at]=se,V[ye][at]=3,N[ye][at]=0;else if(Re&&(!tt||ve>=ut))U[ye][at]=ve,V[ye][at]=2,N[ye][at]=0;else if(tt)U[ye][at]=ut,V[ye][at]=1,N[ye][at]=N[ye-1][at-1]+1;else throw new Error("not possible")}}if(O&&j(Z,pe,Me,Ke),!_e[0]&&!Ze)return;ye--,at--;const Qe=[U[ye][at],Ke];let et=0,ce=0;for(;ye>=1;){let Ne=at;do{const Xe=V[ye][Ne];if(Xe===3)Ne=Ne-2;else if(Xe===2)Ne=Ne-1;else break}while(Ne>=1);et>1&&re[pe+ye-1]===je[Ke+at-1]&&!de(Ne+Ke-1,Me,je)&&et+1>N[ye][Ne]&&(Ne=at),Ne===at?et++:et=1,ce||(ce=Ne),ye--,at=Ne-1,Qe.push(at)}lt===rt&&(Qe[0]+=2);const Ie=ce-rt;return Qe[0]-=Ie,Qe}e.fuzzyScore=Be;function We(Z,re,pe,Me,je,Ke){let Ze=Z-1,rt=re-1;for(;Ze>=pe&&rt>=Me;)je[Ze]===Ke[rt]&&(H[Ze]=rt,Ze--),rt--}function He(Z,re,pe,Me,je,Ke,Ze,rt,lt,ye,at){if(re[pe]!==Ke[Ze])return Number.MIN_SAFE_INTEGER;let J=1,ie=!1;return Ze===pe-Me?J=Z[pe]===je[Ze]?7:5:de(Ze,je,Ke)&&(Ze===0||!de(Ze-1,je,Ke))?(J=Z[pe]===je[Ze]?7:5,ie=!0):X(Ke,Ze)&&(Ze===0||!X(Ke,Ze-1))?J=5:(X(Ke,Ze-1)||Q(Ke,Ze-1))&&(J=5,ie=!0),J>1&&pe===Me&&(at[0]=!0),ie||(ie=de(Ze,je,Ke)||X(Ke,Ze-1)||Q(Ke,Ze-1)),pe===Me?Ze>lt&&(J-=ie?3:5):ye?J+=ie?2:0:J+=ie?0:1,Ze+1===rt&&(J-=ie?3:5),J}function G(Z,re,pe,Me,je,Ke,Ze){return ne(Z,re,pe,Me,je,Ke,!0,Ze)}e.fuzzyScoreGracefulAggressive=G;function ee(Z,re,pe,Me,je,Ke,Ze){return ne(Z,re,pe,Me,je,Ke,!1,Ze)}e.fuzzyScoreGraceful=ee;function ne(Z,re,pe,Me,je,Ke,Ze,rt){let lt=Be(Z,re,pe,Me,je,Ke,rt);if(lt&&!Ze)return lt;if(Z.length>=3){const ye=Math.min(7,Z.length-1);for(let at=pe+1;at<ye;at++){const J=le(Z,at);if(J){const ie=Be(J,J.toLowerCase(),pe,Me,je,Ke,rt);ie&&(ie[0]-=3,(!lt||ie[0]>lt[0])&&(lt=ie))}}}return lt}function le(Z,re){if(re+1>=Z.length)return;const pe=Z[re],Me=Z[re+1];if(pe!==Me)return Z.slice(0,re)+Me+pe+Z.slice(re+2)}}),define(fe[142],me([0,1,48,97,8]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const C=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),n=new RegExp(g.CSSIcon.iconNameCharacter),k=new RegExp(`(\\\\)?${C.source}`,"g");function _(E){return E.replace(k,(T,b)=>b?T:`\\${T}`)}e.escapeIcons=_;const D=new RegExp(`\\\\${C.source}`,"g");function P(E){return E.replace(D,T=>`\\${T}`)}e.markdownEscapeEscapedIcons=P;const I=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function c(E){return E.indexOf(e.iconStartMarker)===-1?E:E.replace(I,(T,b,o,s)=>o?T:b||s||"")}e.stripIcons=c;function v(E){const T=E.indexOf(e.iconStartMarker);return T===-1?{text:E}:h(E,T)}e.parseLabelWithIcons=v;function h(E,T){const b=[];let o="";function s(l){if(l){o+=l;for(const f of l)b.push(m)}}let p=-1,r="",m=0,i,t,u=T;const a=E.length;for(s(E.substr(0,T));u<a;)i=E[u],t=E[u+1],i===e.iconStartMarker[0]&&t===e.iconStartMarker[1]?(p=u,s(r),r=e.iconStartMarker,u++):i===")"&&p!==-1?(m+=u-p+1,p=-1,r=""):p!==-1?n.test(i)?r+=i:(s(r),p=-1,r=""):s(i),u++;return s(r),{text:o,iconOffsets:b}}function w(E,T,b=!1){const{text:o,iconOffsets:s}=T;if(!s||s.length===0)return(0,L.matchesFuzzy)(E,o,b);const p=(0,y.ltrim)(o," "),r=o.length-p.length,m=(0,L.matchesFuzzy)(E,p,b);if(m)for(const i of m){const t=s[i.start+r]+r;i.start+=t,i.end+=t}return m}e.matchesFuzzyIconAware=w}),define(fe[98],me([0,1,18,142]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(y=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class C{constructor(v="",h=!1){if(this.value=v,typeof this.value!="string")throw(0,g.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(v,h=0){return this.value+=D(this.supportThemeIcons?(0,L.escapeIcons)(v):v).replace(/([ \t]+)/g,(w,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(v){return this.value+=v,this}appendCodeblock(v,h){return this.value+="\n```",this.value+=v,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}}e.MarkdownString=C;function n(c){return k(c)?!c.value:Array.isArray(c)?c.every(n):!0}e.isEmptyMarkdownString=n;function k(c){return c instanceof C?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function _(c,v){return c===v?!0:!c||!v?!1:c.value===v.value&&c.isTrusted===v.isTrusted&&c.supportThemeIcons===v.supportThemeIcons}e.markdownStringEqual=_;function D(c){return c.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function P(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=P;function I(c){const v=[],h=c.split("|").map(E=>E.trim());c=h[0];const w=h[1];if(w){const E=/height=(\d+)/.exec(w),T=/width=(\d+)/.exec(w),b=E?E[1]:"",o=T?T[1]:"",s=isFinite(parseInt(o)),p=isFinite(parseInt(b));s&&v.push(`width="${o}"`),p&&v.push(`height="${b}"`)}return{href:c,dimensions:v}}e.parseHrefAndDimensions=I}),define(fe[80],me([0,1,24]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new g.LRUCache(1e4);function y(D){return _(D,"NFC",L)}e.normalizeNFC=y;const C=new g.LRUCache(1e4);function n(D){return _(D,"NFD",C)}e.normalizeNFD=n;const k=/[^\u0000-\u0080]/;function _(D,P,I){if(!D)return D;const c=I.get(D);if(c)return c;let v;return k.test(D)?v=D.normalize(P):v=D,I.set(D,v),v}e.removeAccents=function(){const D=/[\u0300-\u036f]/g;return function(P){return n(P).replace(D,"")}}()}),define(fe[50],me([0,1,8]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(L||(L={})),function(y){const C="error",n="warning",k="warn",_="info",D="ignore";function P(c){return c?g.equalsIgnoreCase(C,c)?y.Error:g.equalsIgnoreCase(n,c)||g.equalsIgnoreCase(k,c)?y.Warning:g.equalsIgnoreCase(_,c)?y.Info:y.Ignore:y.Ignore}y.fromValue=P;function I(c){switch(c){case y.Error:return C;case y.Warning:return n;case y.Info:return _;default:return D}}y.toString=I}(L||(L={})),e.default=L}),define(fe[13],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(f){return Array.isArray(f)}e.isArray=g;function L(f){return typeof f=="string"}e.isString=L;function y(f){return Array.isArray(f)&&f.every(d=>L(d))}e.isStringArray=y;function C(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=C;function n(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=n;function k(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=k;function _(f){return f===!0||f===!1}e.isBoolean=_;function D(f){return typeof f=="undefined"}e.isUndefined=D;function P(f){return!I(f)}e.isDefined=P;function I(f){return D(f)||f===null}e.isUndefinedOrNull=I;function c(f,d){if(!f)throw new Error(d?`Unexpected type, expected '${d}'`:"Unexpected type")}e.assertType=c;function v(f){if(I(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=v;function h(...f){const d=[];for(let S=0;S<f.length;S++){const A=f[S];if(I(A))throw new Error(`Assertion Failed: argument at index ${S} is undefined or null`);d.push(A)}return d}e.assertAllDefined=h;const w=Object.prototype.hasOwnProperty;function E(f){if(!C(f))return!1;for(let d in f)if(w.call(f,d))return!1;return!0}e.isEmptyObject=E;function T(f){return typeof f=="function"}e.isFunction=T;function b(...f){return f.length>0&&f.every(T)}e.areFunctions=b;function o(f,d){const S=Math.min(f.length,d.length);for(let A=0;A<S;A++)s(f[A],d[A])}e.validateConstraints=o;function s(f,d){if(L(d)){if(typeof f!==d)throw new Error(`argument does not match constraint: typeof ${d}`)}else if(T(d)){try{if(f instanceof d)return}catch{}if(!I(f)&&f.constructor===d||d.length===1&&d.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function p(f){let d=[],S=Object.getPrototypeOf(f);for(;Object.prototype!==S;)d=d.concat(Object.getOwnPropertyNames(S)),S=Object.getPrototypeOf(S);return d}e.getAllPropertyNames=p;function r(f){const d=[];for(const S of p(f))typeof f[S]=="function"&&d.push(S);return d}e.getAllMethodNames=r;function m(f,d){const S=R=>function(){const B=Array.prototype.slice.call(arguments,0);return d(R,B)};let A={};for(const R of f)A[R]=S(R);return A}e.createProxyObject=m;function i(f){return f===null?void 0:f}e.withNullAsUndefined=i;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function u(f){return class{constructor(){return new Proxy({},{get(d,S){if(d[S])return d[S];throw new Error(`Not Implemented: ${f}->${String(S)}`)}})}}}e.NotImplementedProxy=u;function a(f,d="Unreachable"){throw new Error(d)}e.assertNever=a;function l(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=l}),define(fe[30],me([0,1,9,12,8,13]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(i){return i===47||i===92}e.isPathSeparator=n;function k(i){return i.replace(/[\\/]/g,g.posix.sep)}e.toSlashes=k;function _(i){return i.indexOf("/")===-1&&(i=k(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=_;function D(i,t=g.posix.sep){if(!i)return"";const u=i.length,a=i.charCodeAt(0);if(n(a)){if(n(i.charCodeAt(1))&&!n(i.charCodeAt(2))){let f=3;const d=f;for(;f<u&&!n(i.charCodeAt(f));f++);if(d!==f&&!n(i.charCodeAt(f+1))){for(f+=1;f<u;f++)if(n(i.charCodeAt(f)))return i.slice(0,f+1).replace(/[\\/]/g,t)}}return t}else if(T(a)&&i.charCodeAt(1)===58)return n(i.charCodeAt(2))?i.slice(0,2)+t:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<u;l++)if(n(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=D;function P(i){if(!L.isWindows||!i||i.length<5)return!1;let t=i.charCodeAt(0);if(t!==92||(t=i.charCodeAt(1),t!==92))return!1;let u=2;const a=u;for(;u<i.length&&(t=i.charCodeAt(u),t!==92);u++);return!(a===u||(t=i.charCodeAt(u+1),isNaN(t)||t===92))}e.isUNC=P;const I=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,t=L.isWindows){const u=t?I:c;return!(!i||i.length===0||/^\s+$/.test(i)||(u.lastIndex=0,u.test(i))||t&&v.test(i)||i==="."||i===".."||t&&i[i.length-1]==="."||t&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function w(i,t,u){const a=i===t;return!u||a?a:!i||!t?!1:(0,y.equalsIgnoreCase)(i,t)}e.isEqual=w;function E(i,t,u,a=g.sep){if(i===t)return!0;if(!i||!t||t.length>i.length)return!1;if(u){if(!(0,y.startsWithIgnoreCase)(i,t))return!1;if(t.length===i.length)return!0;let f=t.length;return t.charAt(t.length-1)===a&&f--,i.charAt(f)===a}return t.charAt(t.length-1)!==a&&(t+=a),i.indexOf(t)===0}e.isEqualOrParent=E;function T(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=T;function b(i,t){return L.isWindows&&i.endsWith(":")&&(i+=g.sep),(0,g.isAbsolute)(i)||(i=(0,g.join)(t,i)),i=(0,g.normalize)(i),L.isWindows?(i=(0,y.rtrim)(i,g.sep),i.endsWith(":")&&(i+=g.sep)):(i=(0,y.rtrim)(i,g.sep),i||(i=g.sep)),i}e.sanitizeFilePath=b;function o(i){const t=(0,g.normalize)(i);return L.isWindows?i.length>3?!1:s(t)&&(i.length===2||t.charCodeAt(2)===92):t===g.posix.sep}e.isRootOrDriveLetter=o;function s(i,t){return(t!==void 0?t:L.isWindows)?T(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function p(i){return s(i)?i[0]:void 0}e.getDriveLetter=p;function r(i,t,u){return t.length>i.length?-1:i===t?0:(u&&(i=i.toLowerCase(),t=t.toLowerCase()),i.indexOf(t))}e.indexOfPath=r;function m(i){const t=i.split(":");let u,a,l;if(t.forEach(f=>{const d=Number(f);(0,C.isNumber)(d)?a===void 0?a=d:l===void 0&&(l=d):u=u?[u,f].join(":"):f}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:a!==void 0?a:void 0,column:l!==void 0?l:a!==void 0?1:void 0}}e.parseLineAndColumnAware=m}),define(fe[25],me([0,1,13]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const E=Array.isArray(w)?[]:{};return Object.keys(w).forEach(T=>{w[T]&&typeof w[T]=="object"?E[T]=L(w[T]):E[T]=w[T]}),E}e.deepClone=L;function y(w){if(!w||typeof w!="object")return w;const E=[w];for(;E.length>0;){const T=E.shift();Object.freeze(T);for(const b in T)if(C.call(T,b)){const o=T[b];typeof o=="object"&&!Object.isFrozen(o)&&E.push(o)}}return w}e.deepFreeze=y;const C=Object.prototype.hasOwnProperty;function n(w,E){return k(w,E,new Set)}e.cloneAndChange=n;function k(w,E,T){if((0,g.isUndefinedOrNull)(w))return w;const b=E(w);if(typeof b!="undefined")return b;if((0,g.isArray)(w)){const o=[];for(const s of w)o.push(k(s,E,T));return o}if((0,g.isObject)(w)){if(T.has(w))throw new Error("Cannot clone recursive data-structure");T.add(w);const o={};for(let s in w)C.call(w,s)&&(o[s]=k(w[s],E,T));return T.delete(w),o}return w}function _(w,E,T=!0){return(0,g.isObject)(w)?((0,g.isObject)(E)&&Object.keys(E).forEach(b=>{b in w?T&&((0,g.isObject)(w[b])&&(0,g.isObject)(E[b])?_(w[b],E[b],T):w[b]=E[b]):w[b]=E[b]}),w):E}e.mixin=_;function D(w,E){if(w===E)return!0;if(w==null||E===null||E===void 0||typeof w!=typeof E||typeof w!="object"||Array.isArray(w)!==Array.isArray(E))return!1;let T,b;if(Array.isArray(w)){if(w.length!==E.length)return!1;for(T=0;T<w.length;T++)if(!D(w[T],E[T]))return!1}else{const o=[];for(b in w)o.push(b);o.sort();const s=[];for(b in E)s.push(b);if(s.sort(),!D(o,s))return!1;for(T=0;T<o.length;T++)if(!D(w[o[T]],E[o[T]]))return!1}return!0}e.equals=D;function P(w){const E=new Set;return JSON.stringify(w,(T,b)=>{if((0,g.isObject)(b)||Array.isArray(b)){if(E.has(b))return"[Circular]";E.add(b)}return b})}e.safeStringify=P;function I(w,E,T){const b=E(w);return typeof b=="undefined"?T:b}e.getOrDefault=I;function c(w,E){const T=Object.create(null);return!w||!E||Object.keys(E).forEach(o=>{const s=w[o],p=E[o];D(s,p)||(T[o]=p)}),T}e.distinct=c;function v(w,E){const T=E.toLowerCase(),b=Object.keys(w).find(o=>o.toLowerCase()===T);return b?w[b]:w[E]}e.getCaseInsensitive=v;function h(w,E){const T=Object.create(null);for(const[b,o]of Object.entries(w))E(b,o)&&(T[b]=o);return T}e.filter=h}),define(fe[99],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(C){C[C.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",C[C.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",C[C.MAX_UINT_8=255]="MAX_UINT_8",C[C.MAX_UINT_16=65535]="MAX_UINT_16",C[C.MAX_UINT_32=4294967295]="MAX_UINT_32",C[C.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function L(C){return C<0?0:C>255?255:C|0}e.toUint8=L;function y(C){return C<0?0:C>4294967295?4294967295:C|0}e.toUint32=y}),define(fe[2],me([0,1,9,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const y=/^\w[\w\d+.-]*$/,C=/^\//,n=/^\/\//;function k(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!y.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!C.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(n.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(i,t){return!i&&!t?"file":i}function D(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==I&&(t=I+t):t=I;break}return t}const P="",I="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{constructor(t,u,a,l,f,d=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=_(t,d),this.authority=u||P,this.path=D(this.scheme,a||P),this.query=l||P,this.fragment=f||P,k(this,d))}static isUri(t){return t instanceof v?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return o(this,!1)}with(t){if(!t)return this;let{scheme:u,authority:a,path:l,query:f,fragment:d}=t;return u===void 0?u=this.scheme:u===null&&(u=P),a===void 0?a=this.authority:a===null&&(a=P),l===void 0?l=this.path:l===null&&(l=P),f===void 0?f=this.query:f===null&&(f=P),d===void 0?d=this.fragment:d===null&&(d=P),u===this.scheme&&a===this.authority&&l===this.path&&f===this.query&&d===this.fragment?this:new w(u,a,l,f,d)}static parse(t,u=!1){const a=c.exec(t);return a?new w(a[2]||P,m(a[4]||P),m(a[5]||P),m(a[7]||P),m(a[9]||P),u):new w(P,P,P,P,P)}static file(t){let u=P;if(L.isWindows&&(t=t.replace(/\\/g,I)),t[0]===I&&t[1]===I){const a=t.indexOf(I,2);a===-1?(u=t.substring(2),t=I):(u=t.substring(2,a),t=t.substring(a)||I)}return new w("file",u,t,P,P)}static from(t){const u=new w(t.scheme,t.authority,t.path,t.query,t.fragment);return k(u,!0),u}static joinPath(t,...u){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return L.isWindows&&t.scheme==="file"?a=v.file(g.win32.join(o(t,!0),...u)).path:a=g.posix.join(t.path,...u),t.with({path:a})}toString(t=!1){return s(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof v)return t;{const u=new w(t);return u._formatted=t.external,u._fsPath=t._sep===h?t.fsPath:null,u}}else return t}}e.URI=v;const h=L.isWindows?1:void 0;class w extends v{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(t=!1){return t?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function T(i,t){let u,a=-1;for(let l=0;l<i.length;l++){const f=i.charCodeAt(l);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)a!==-1&&(u+=encodeURIComponent(i.substring(a,l)),a=-1),u!==void 0&&(u+=i.charAt(l));else{u===void 0&&(u=i.substr(0,l));const d=E[f];d!==void 0?(a!==-1&&(u+=encodeURIComponent(i.substring(a,l)),a=-1),u+=d):a===-1&&(a=l)}}return a!==-1&&(u+=encodeURIComponent(i.substring(a))),u!==void 0?u:i}function b(i){let t;for(let u=0;u<i.length;u++){const a=i.charCodeAt(u);a===35||a===63?(t===void 0&&(t=i.substr(0,u)),t+=E[a]):t!==void 0&&(t+=i[u])}return t!==void 0?t:i}function o(i,t){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,L.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=o;function s(i,t){const u=t?b:T;let a="",{scheme:l,authority:f,path:d,query:S,fragment:A}=i;if(l&&(a+=l,a+=":"),(f||l==="file")&&(a+=I,a+=I),f){let R=f.indexOf("@");if(R!==-1){const B=f.substr(0,R);f=f.substr(R+1),R=B.indexOf(":"),R===-1?a+=u(B,!1):(a+=u(B.substr(0,R),!1),a+=":",a+=u(B.substr(R+1),!1)),a+="@"}f=f.toLowerCase(),R=f.indexOf(":"),R===-1?a+=u(f,!1):(a+=u(f.substr(0,R),!1),a+=f.substr(R))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const R=d.charCodeAt(1);R>=65&&R<=90&&(d=`/${String.fromCharCode(R+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const R=d.charCodeAt(0);R>=65&&R<=90&&(d=`${String.fromCharCode(R+32)}:${d.substr(2)}`)}a+=u(d,!0)}return S&&(a+="?",a+=u(S,!1)),A&&(a+="#",a+=t?A:T(A,!1)),a}function p(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+p(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function m(i){return i.match(r)?i.replace(r,t=>p(t)):i}}),define(fe[62],me([0,1,22,8,2]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function C(P){return JSON.stringify(P,_)}e.stringify=C;function n(P){let I=JSON.parse(P);return I=D(I),I}e.parse=n;var k;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext"})(k=e.MarshalledId||(e.MarshalledId={}));function _(P,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function D(P,I=0){if(!P||I>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return y.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof g.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let c=0;c<P.length;++c)P[c]=D(P[c],I+1);else for(const c in P)Object.hasOwnProperty.call(P,c)&&(P[c]=D(P[c],I+1))}return P}e.revive=D}),define(fe[10],me([0,1,12,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var y;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeInteractive="vscode-interactive",k.vscodeInteractiveInput="vscode-interactive-input",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp",k.vsls="vsls"})(y=e.Schemas||(e.Schemas={}));class C{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,D,P){this._hosts[_]=D,this._ports[_]=P}setConnectionToken(_,D){this._connectionTokens[_]=D}rewrite(_){if(this._delegate)return this._delegate(_);const D=_.authority;let P=this._hosts[D];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const I=this._ports[D],c=this._connectionTokens[D];let v=`path=${encodeURIComponent(_.path)}`;return typeof c=="string"&&(v+=`&tkn=${encodeURIComponent(c)}`),L.URI.from({scheme:g.isWeb?this._preferredWebSchema:y.vscodeRemoteResource,authority:`${P}:${I}`,path:"/vscode-remote-resource",query:v})}}e.RemoteAuthorities=new C;class n{asBrowserUri(_,D){const P=this.toUri(_,D);return P.scheme===y.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===y.file&&(g.isNative||typeof g.globals.importScripts=="function"&&g.globals.origin===`${y.vscodeFileResource}://${n.FALLBACK_AUTHORITY}`)?P.with({scheme:y.vscodeFileResource,authority:P.authority||n.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(_,D){const P=this.toUri(_,D);return P.scheme===y.vscodeFileResource?P.with({scheme:y.file,authority:P.authority!==n.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(_,D){return L.URI.isUri(_)?_:L.URI.parse(D.toUrl(_))}}n.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new n}),define(fe[23],me([0,1,30,10,9,12,8,2]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(v){return(0,k.uriToFsPath)(v,!0)}e.originalFSPath=_;class D{constructor(h){this._ignorePathCasing=h}compare(h,w,E=!1){return h===w?0:(0,n.compare)(this.getComparisonKey(h,E),this.getComparisonKey(w,E))}isEqual(h,w,E=!1){return h===w?!0:!h||!w?!1:this.getComparisonKey(h,E)===this.getComparisonKey(w,E)}getComparisonKey(h,w=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,w,E=!1){if(h.scheme===w.scheme){if(h.scheme===L.Schemas.file)return g.isEqualOrParent(_(h),_(w),this._ignorePathCasing(h))&&h.query===w.query&&(E||h.fragment===w.fragment);if((0,e.isEqualAuthority)(h.authority,w.authority))return g.isEqualOrParent(h.path,w.path,this._ignorePathCasing(h),"/")&&h.query===w.query&&(E||h.fragment===w.fragment)}return!1}joinPath(h,...w){return k.URI.joinPath(h,...w)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return y.posix.basename(h.path)}extname(h){return y.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let w;return h.scheme===L.Schemas.file?w=k.URI.file(y.dirname(_(h))).path:(w=y.posix.dirname(h.path),h.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),w="/")),h.with({path:w})}normalizePath(h){if(!h.path.length)return h;let w;return h.scheme===L.Schemas.file?w=k.URI.file(y.normalize(_(h))).path:w=y.posix.normalize(h.path),h.with({path:w})}relativePath(h,w){if(h.scheme!==w.scheme||!(0,e.isEqualAuthority)(h.authority,w.authority))return;if(h.scheme===L.Schemas.file){const b=y.relative(_(h),_(w));return C.isWindows?g.toSlashes(b):b}let E=h.path||"/",T=w.path||"/";if(this._ignorePathCasing(h)){let b=0;for(const o=Math.min(E.length,T.length);b<o&&!(E.charCodeAt(b)!==T.charCodeAt(b)&&E.charAt(b).toLowerCase()!==T.charAt(b).toLowerCase());b++);E=T.substr(0,b)+E.substr(b)}return y.posix.relative(E,T)}resolvePath(h,w){if(h.scheme===L.Schemas.file){const E=k.URI.file(y.resolve(_(h),w));return h.with({authority:E.authority,path:E.path})}return w=g.toPosixPath(w),h.with({path:y.posix.resolve(h.path,w)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,w){return h===w||h!==void 0&&w!==void 0&&(0,n.equalsIgnoreCase)(h,w)}hasTrailingPathSeparator(h,w=y.sep){if(h.scheme===L.Schemas.file){const E=_(h);return E.length>g.getRoot(E).length&&E[E.length-1]===w}else{const E=h.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,w=y.sep){return(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,w=y.sep){let E=!1;if(h.scheme===L.Schemas.file){const T=_(h);E=T!==void 0&&T.length===g.getRoot(T).length&&T[T.length-1]===w}else{w="/";const T=h.path;E=T.length===1&&T.charCodeAt(T.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(h,w)?h.with({path:h.path+"/"}):h}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(v=>v.scheme===L.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new D(v=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(v,h){const w=[];for(let E=0;E<v.length;E++){const T=h(v[E]);v.some((b,o)=>o===E?!1:(0,e.isEqualOrParent)(T,h(b)))||w.push(v[E])}return w}e.distinctParents=P;var I;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function h(w){const E=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(o=>{const[s,p]=o.split(":");s&&p&&E.set(s,p)});const b=w.path.substring(0,w.path.indexOf(";"));return b&&E.set(v.META_DATA_MIME,b),E}v.parseMetaData=h})(I=e.DataUri||(e.DataUri={}));function c(v,h,w){if(h){let E=v.path;return E&&E[0]!==y.posix.sep&&(E=y.posix.sep+E),v.with({scheme:w,authority:h,path:E})}return v.with({scheme:w})}e.toLocalResource=c}),define(fe[16],me([0,1,21,18,3,6,23]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function k(N){return!!N&&typeof N.then=="function"}e.isThenable=k;function _(N){const U=new g.CancellationTokenSource,V=N(U.token),O=new Promise((W,j)=>{const X=U.token.onCancellationRequested(()=>{X.dispose(),U.dispose(),j((0,L.canceled)())});Promise.resolve(V).then(Q=>{X.dispose(),U.dispose(),W(Q)},Q=>{X.dispose(),U.dispose(),j(Q)})});return new class{cancel(){U.cancel()}then(W,j){return O.then(W,j)}catch(W){return this.then(void 0,W)}finally(W){return O.finally(W)}}}e.createCancelablePromise=_;function D(N,U,V){return Promise.race([N,new Promise(O=>U.onCancellationRequested(()=>O(V)))])}e.raceCancellation=D;async function P(N){let U=-1;const V=N.map((W,j)=>W.then(X=>(U=j,X))),O=await Promise.race(V);return N.forEach((W,j)=>{j!==U&&W.cancel()}),O}e.raceCancellablePromises=P;function I(N,U,V){let O;const W=setTimeout(()=>{O?.(void 0),V?.()},U);return Promise.race([N.finally(()=>clearTimeout(W)),new Promise(j=>O=j)])}e.raceTimeout=I;function c(N){return new Promise((U,V)=>{const O=N();k(O)?O.then(U,V):U(O)})}e.asPromise=c;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(U){if(this.activePromise){if(this.queuedPromiseFactory=U,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(V,V).then(O)})}return new Promise((V,O)=>{this.queuedPromise.then(V,O)})}return this.activePromise=U(),new Promise((V,O)=>{this.activePromise.then(W=>{this.activePromise=null,V(W)},W=>{this.activePromise=null,O(W)})})}}e.Throttler=v;class h{constructor(){this.current=Promise.resolve(null)}queue(U){return this.current=this.current.then(()=>U(),()=>U())}}e.Sequencer=h;class w{constructor(){this.promiseMap=new Map}queue(U,V){const W=(this.promiseMap.get(U)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(U)===W&&this.promiseMap.delete(U)});return this.promiseMap.set(U,W),W}}e.SequencerByKey=w;class E{constructor(U){this.defaultDelay=U,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(U,V=this.defaultDelay){return this.task=U,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,W)=>{this.doResolve=O,this.doReject=W}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},V),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=E;class T{constructor(U){this.delayer=new E(U),this.throttler=new v}trigger(U,V){return this.delayer.trigger(()=>this.throttler.queue(U),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=T;class b{constructor(){this._isOpen=!1,this._promise=new Promise((U,V)=>{this._completePromise=U})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class o extends b{constructor(U){super();this._timeout=setTimeout(()=>this.open(),U)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function s(N,U){return U?new Promise((V,O)=>{const W=setTimeout(()=>{j.dispose(),V()},N),j=U.onCancellationRequested(()=>{clearTimeout(W),j.dispose(),O((0,L.canceled)())})}):_(V=>s(N,V))}e.timeout=s;function p(N,U=0){const V=setTimeout(N,U);return(0,C.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=p;function r(N){const U=[];let V=0;const O=N.length;function W(){return V<O?N[V++]():null}function j(X){X!=null&&U.push(X);const Q=W();return Q?Q.then(j):Promise.resolve(U)}return Promise.resolve(null).then(j)}e.sequence=r;function m(N,U=O=>!!O,V=null){let O=0;const W=N.length,j=()=>{if(O>=W)return Promise.resolve(V);const X=N[O++];return Promise.resolve(X()).then(de=>U(de)?Promise.resolve(de):j())};return j()}e.first=m;function i(N,U=O=>!!O,V=null){if(N.length===0)return Promise.resolve(V);let O=N.length;const W=()=>{O=-1;for(const j of N)j.cancel?.()};return new Promise((j,X)=>{for(const Q of N)Q.then(de=>{--O>=0&&U(de)?(W(),j(de)):O===0&&j(V)}).catch(de=>{--O>=0&&(W(),X(de))})})}e.firstParallel=i;class t{constructor(U){this._size=0,this.maxDegreeOfParalellism=U,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new y.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(U){return this._size++,new Promise((V,O)=>{this.outstandingPromises.push({factory:U,c:V,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const U=this.outstandingPromises.shift();this.runningPromises++;const V=U.factory();V.then(U.c,U.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=t;class u extends t{constructor(){super(1)}}e.Queue=u;class a{constructor(){this.queues=new Map}queueFor(U,V=n.extUri){const O=V.getComparisonKey(U);let W=this.queues.get(O);return W||(W=new u,y.Event.once(W.onFinished)(()=>{W?.dispose(),this.queues.delete(O)}),this.queues.set(O,W)),W}dispose(){this.queues.forEach(U=>U.dispose()),this.queues.clear()}}e.ResourceQueue=a;class l{constructor(U,V){this._token=-1,typeof U=="function"&&typeof V=="number"&&this.setIfNotSet(U,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(U,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,U()},V)}setIfNotSet(U,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,U()},V))}}e.TimeoutTimer=l;class f{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(U,V){this.cancel(),this._token=setInterval(()=>{U()},V)}}e.IntervalTimer=f;class d{constructor(U,V){this.timeoutToken=-1,this.runner=U,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(U=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,U)}get delay(){return this.timeout}set delay(U){this.timeout=U}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=d;class S{constructor(U,V){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=U,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(U=this.timeout){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(U/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=S;class A extends d{constructor(U,V){super(U,V);this.units=[]}work(U){this.units.push(U),this.isScheduled()||this.schedule()}doRun(){const U=this.units;this.units=[],this.runner&&this.runner(U)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class R extends C.Disposable{constructor(U,V,O,W){super();this.maxWorkChunkSize=U,this.maxPendingWork=V,this.throttleDelay=O,this.handler=W,this.pendingWork=[],this.throttler=this._register(new C.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(U){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+U.length>this.maxPendingWork)return!1}else if(this.pending+U.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...U),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new d(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=R,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=N=>{const U=setTimeout(()=>{const O=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0,clearTimeout(U))}}}:e.runWhenIdle=(N,U)=>{const V=requestIdleCallback(N,typeof U=="number"?{timeout:U}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(V))}}}}();class B{constructor(U){this._didRun=!1,this._executor=()=>{try{this._value=U()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function x(N,U,V){let O;for(let W=0;W<V;W++)try{return await N()}catch(j){O=j,await s(U)}throw O}e.retry=x;class F{hasPending(U){return this._pending?typeof U=="number"?this._pending.taskId===U:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(U,V,O){return this._pending={taskId:U,cancel:()=>O?.(),promise:V},V.then(()=>this.donePending(U),()=>this.donePending(U)),V}donePending(U){this._pending&&U===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const U=this._next;this._next=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}setNext(U){if(this._next)this._next.run=U;else{let V,O;const W=new Promise((j,X)=>{V=j,O=X});this._next={run:U,promise:W,promiseResolve:V,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=F;class ${constructor(U){this.interval=U,this.lastIncrementTime=0,this.value=0}increment(){const U=Date.now();return U-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=U,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class M{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((U,V)=>{this.completeCallback=U,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(U){return new Promise(V=>{this.completeCallback(U),this.resolved=!0,V()})}error(U){return new Promise(V=>{this.errorCallback(U),this.rejected=!0,V()})}cancel(){new Promise(U=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,U()})}}e.DeferredPromise=M;var H;(function(N){async function U(O){let W;const j=await Promise.all(O.map(X=>X.then(Q=>Q,Q=>{W||(W=Q)})));if(typeof W!="undefined")throw W;return j}N.settled=U;function V(O){return new Promise(async(W,j)=>{try{await O(W,j)}catch(X){j(X)}})}N.withAsyncBody=V})(H=e.Promises||(e.Promises={}))}),define(fe[100],me([0,1,16,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const y=new g.IdleValue(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),C=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),n=new g.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(d,S,A=!1){const R=d||"",B=S||"",x=y.value.collator.compare(R,B);return y.value.collatorIsNumeric&&x===0&&R!==B?R<B?-1:1:x}e.compareFileNames=k;function _(d,S){const A=C.value.collator;return d=d||"",S=S||"",p(A,d,S)}e.compareFileNamesDefault=_;function D(d,S){const A=C.value.collator;return d=d||"",S=S||"",t(d,S)||p(A,d,S)}e.compareFileNamesUpper=D;function P(d,S){const A=C.value.collator;return d=d||"",S=S||"",i(d,S)||p(A,d,S)}e.compareFileNamesLower=P;function I(d,S){return d=d||"",S=S||"",d===S?0:d<S?-1:1}e.compareFileNamesUnicode=I;function c(d,S,A=!1){A||(d=d&&d.toLowerCase(),S=S&&S.toLowerCase());const[R,B]=o(d),[x,F]=o(S);return R!==x?R<x?-1:1:B===F?0:B<F?-1:1}e.noIntlCompareFileNames=c;function v(d,S){const[A,R]=o(d),[B,x]=o(S);let F=y.value.collator.compare(R,x);if(F===0){if(y.value.collatorIsNumeric&&R!==x)return R<x?-1:1;if(F=y.value.collator.compare(A,B),y.value.collatorIsNumeric&&F===0&&A!==B)return A<B?-1:1}return F}e.compareFileExtensions=v;function h(d,S){d=d||"",S=S||"";const A=s(d),R=s(S),B=C.value.collator,x=n.value.collator;return p(x,A,R)||p(B,d,S)}e.compareFileExtensionsDefault=h;function w(d,S){d=d||"",S=S||"";const A=s(d),R=s(S),B=C.value.collator,x=n.value.collator;return p(x,A,R)||t(d,S)||p(B,d,S)}e.compareFileExtensionsUpper=w;function E(d,S){d=d||"",S=S||"";const A=s(d),R=s(S),B=C.value.collator,x=n.value.collator;return p(x,A,R)||i(d,S)||p(B,d,S)}e.compareFileExtensionsLower=E;function T(d,S){d=d||"",S=S||"";const A=s(d).toLowerCase(),R=s(S).toLowerCase();return A!==R?A<R?-1:1:d!==S?d<S?-1:1:0}e.compareFileExtensionsUnicode=T;const b=/^(.*?)(\.([^.]*))?$/;function o(d,S=!1){const A=d?b.exec(d):[];let R=[A&&A[1]||"",A&&A[3]||""];return S&&(!R[0]&&R[1]||R[0]&&R[0].charAt(0)===".")&&(R=[R[0]+"."+R[1],""]),R}function s(d){const S=d?b.exec(d):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function p(d,S,A){let R=d.compare(S,A);return R!==0?R:S.length!==A.length?S.length<A.length?-1:1:0}function r(d){const S=d.charAt(0);return S.toLocaleUpperCase()!==S}function m(d){const S=d.charAt(0);return S.toLocaleLowerCase()!==S}function i(d,S){return r(d)&&m(S)?-1:m(d)&&r(S)?1:0}function t(d,S){return m(d)&&r(S)?-1:r(d)&&m(S)?1:0}function u(d,S,A=!1){return A||(d=d&&d.toLowerCase(),S=S&&S.toLowerCase()),d===S?0:d<S?-1:1}function a(d,S,A=!1){const R=d.split(L.sep),B=S.split(L.sep),x=R.length-1,F=B.length-1;let $,M;for(let H=0;;H++){if($=x===H,M=F===H,$&&M)return k(R[H],B[H],A);if($)return-1;if(M)return 1;const N=u(R[H],B[H],A);if(N!==0)return N}}e.comparePaths=a;function l(d,S,A){const R=d.toLowerCase(),B=S.toLowerCase(),x=f(d,S,A);if(x)return x;const F=R.endsWith(A),$=B.endsWith(A);if(F!==$)return F?-1:1;const M=k(R,B);return M!==0?M:R.localeCompare(B)}e.compareAnything=l;function f(d,S,A){const R=d.toLowerCase(),B=S.toLowerCase(),x=R.startsWith(A),F=B.startsWith(A);if(x!==F)return x?-1:1;if(x&&F){if(R.length<B.length)return-1;if(R.length>B.length)return 1}return 0}e.compareByPrefix=f}),define(fe[101],me([0,1,100,97,49,9,12,8]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const _=0,D=[_,[]];function P(N,U,V,O){if(!N||!U)return D;const W=N.length,j=U.length;if(W<j)return D;const X=N.toLowerCase();return I(U,V,j,N,X,W,O)}e.scoreFuzzy=P;function I(N,U,V,O,W,j,X){const Q=[],de=[];for(let Be=0;Be<V;Be++){const We=Be*j,He=We-j,G=Be>0,ee=N[Be],ne=U[Be];for(let le=0;le<j;le++){const Z=le>0,re=We+le,pe=re-1,Me=He+le-1,je=Z?Q[pe]:0,Ke=G&&Z?Q[Me]:0,Ze=G&&Z?de[Me]:0;let rt;!Ke&&G?rt=0:rt=c(ee,ne,O,W,le,Ze),rt&&Ke+rt>=je&&(X||G||W.startsWith(U,le))?(de[re]=Ze+1,Q[re]=Ke+rt):(de[re]=_,Q[re]=je)}}const Se=[];let De=V-1,Pe=j-1;for(;De>=0&&Pe>=0;){const Be=De*j+Pe;de[Be]===_||(Se.push(Pe),De--),Pe--}return[Q[V*j-1],Se.reverse()]}function c(N,U,V,O,W,j){let X=0;if(!v(U,O[W]))return X;if(X+=1,j>0&&(X+=j*5),N===V[W]&&(X+=1),W===0)X+=8;else{const Q=h(V.charCodeAt(W-1));Q?X+=Q:(0,L.isUpper)(V.charCodeAt(W))&&j===0&&(X+=2)}return X}function v(N,U){return N===U?!0:N==="/"||N==="\\"?U==="/"||U==="\\":!1}function h(N){switch(N){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function E(N,U,V=0,O=0){const W=U;return W.values&&W.values.length>1?T(N,W.values,V,O):b(N,U,V,O)}e.scoreFuzzy2=E;function T(N,U,V,O){let W=0;const j=[];for(const X of U){const[Q,de]=b(N,X,V,O);if(typeof Q!="number")return w;W+=Q,j.push(...de)}return[W,f(j)]}function b(N,U,V,O){const W=(0,L.fuzzyScore)(U.original,U.originalLowercase,V,N,N.toLowerCase(),O,!0);return W?[W[0],(0,L.createMatches)(W)]:w}const o=Object.freeze({score:0}),s=1<<18,p=1<<17,r=1<<16;function m(N,U,V,O){const W=O.values?O.values:[O];return(0,y.hash)({[O.normalized]:{values:W.map(X=>({value:X.normalized,expectContiguousMatch:X.expectContiguousMatch})),label:N,description:U,allowNonContiguousMatches:V}})}function i(N,U,V,O,W){if(!N||!U.normalized)return o;const j=O.getItemLabel(N);if(!j)return o;const X=O.getItemDescription(N),Q=m(j,X,V,U),de=W[Q];if(de)return de;const Se=t(j,X,O.getItemPath(N),U,V);return W[Q]=Se,Se}e.scoreItemFuzzy=i;function t(N,U,V,O,W){const j=!V||!O.containsPathSeparator;return V&&(n.isLinux?O.pathNormalized===V:(0,k.equalsIgnoreCase)(O.pathNormalized,V))?{score:s,labelMatch:[{start:0,end:N.length}],descriptionMatch:U?[{start:0,end:U.length}]:void 0}:O.values&&O.values.length>1?u(N,U,V,O.values,j,W):a(N,U,V,O,j,W)}function u(N,U,V,O,W,j){let X=0;const Q=[],de=[];for(const Se of O){const{score:De,labelMatch:Pe,descriptionMatch:Be}=a(N,U,V,Se,W,j);if(De===_)return o;X+=De,Pe&&Q.push(...Pe),Be&&de.push(...Be)}return{score:X,labelMatch:f(Q),descriptionMatch:f(de)}}function a(N,U,V,O,W,j){if(W||!U){const[X,Q]=P(N,O.normalized,O.normalizedLowercase,j&&!O.expectContiguousMatch);if(X){const de=(0,L.matchesPrefix)(O.normalized,N);let Se;return de?(Se=p,Se+=Math.round(O.normalized.length/N.length*100)):Se=r,{score:Se+X,labelMatch:de||l(Q)}}}if(U){let X=U;V&&(X=`${U}${C.sep}`);const Q=X.length,de=`${X}${N}`,[Se,De]=P(de,O.normalized,O.normalizedLowercase,j&&!O.expectContiguousMatch);if(Se){const Pe=l(De),Be=[],We=[];return Pe.forEach(He=>{He.start<Q&&He.end>Q?(Be.push({start:0,end:He.end-Q}),We.push({start:He.start,end:Q})):He.start>=Q?Be.push({start:He.start-Q,end:He.end-Q}):We.push(He)}),{score:Se,labelMatch:Be,descriptionMatch:We}}}return o}function l(N){const U=[];if(!N)return U;let V;for(const O of N)V&&V.end===O?V.end+=1:(V={start:O,end:O+1},U.push(V));return U}function f(N){const U=N.sort((W,j)=>W.start-j.start),V=[];let O;for(const W of U)!O||!d(O,W)?(O=W,V.push(W)):(O.start=Math.min(O.start,W.start),O.end=Math.max(O.end,W.end));return V}function d(N,U){return!(N.end<U.start||U.end<N.start)}function S(N,U,V,O,W,j){const X=i(N,V,O,W,j),Q=i(U,V,O,W,j),de=X.score,Se=Q.score;if((de===s||Se===s)&&de!==Se)return de===s?-1:1;if(de>r||Se>r){if(de!==Se)return de>Se?-1:1;if(de<p&&Se<p){const ee=R(X.labelMatch,Q.labelMatch);if(ee!==0)return ee}const He=W.getItemLabel(N)||"",G=W.getItemLabel(U)||"";if(He.length!==G.length)return He.length-G.length}if(de!==Se)return de>Se?-1:1;const De=Array.isArray(X.labelMatch)&&X.labelMatch.length>0,Pe=Array.isArray(Q.labelMatch)&&Q.labelMatch.length>0;if(De&&!Pe)return-1;if(Pe&&!De)return 1;const Be=A(N,X,W),We=A(U,Q,W);return Be&&We&&Be!==We?We>Be?-1:1:B(N,U,V,W)}e.compareItemsByFuzzyScore=S;function A(N,U,V){let O=-1,W=-1;if(U.descriptionMatch&&U.descriptionMatch.length?O=U.descriptionMatch[0].start:U.labelMatch&&U.labelMatch.length&&(O=U.labelMatch[0].start),U.labelMatch&&U.labelMatch.length){if(W=U.labelMatch[U.labelMatch.length-1].end,U.descriptionMatch&&U.descriptionMatch.length){const j=V.getItemDescription(N);j&&(W+=j.length)}}else U.descriptionMatch&&U.descriptionMatch.length&&(W=U.descriptionMatch[U.descriptionMatch.length-1].end);return W-O}function R(N,U){if(!N&&!U||(!N||!N.length)&&(!U||!U.length))return 0;if(!U||!U.length)return-1;if(!N||!N.length)return 1;const V=N[0].start,W=N[N.length-1].end-V,j=U[0].start,Q=U[U.length-1].end-j;return W===Q?0:Q<W?1:-1}function B(N,U,V,O){const W=O.getItemLabel(N)||"",j=O.getItemLabel(U)||"",X=O.getItemDescription(N),Q=O.getItemDescription(U),de=W.length+(X?X.length:0),Se=j.length+(Q?Q.length:0);if(de!==Se)return de-Se;const De=O.getItemPath(N),Pe=O.getItemPath(U);return De&&Pe&&De.length!==Pe.length?De.length-Pe.length:W!==j?(0,g.compareAnything)(W,j,V.normalized):X&&Q&&X!==Q?(0,g.compareAnything)(X,Q,V.normalized):De&&Pe&&De!==Pe?(0,g.compareAnything)(De,Pe,V.normalized):0}function x(N){return N.startsWith('"')&&N.endsWith('"')}const F=" ";function $(N){typeof N!="string"&&(N="");const U=N.toLowerCase(),{pathNormalized:V,normalized:O,normalizedLowercase:W}=M(N),j=V.indexOf(C.sep)>=0,X=x(N);let Q;const de=N.split(F);if(de.length>1)for(const Se of de){const De=x(Se),{pathNormalized:Pe,normalized:Be,normalizedLowercase:We}=M(Se);Be&&(Q||(Q=[]),Q.push({original:Se,originalLowercase:Se.toLowerCase(),pathNormalized:Pe,normalized:Be,normalizedLowercase:We,expectContiguousMatch:De}))}return{original:N,originalLowercase:U,pathNormalized:V,normalized:O,normalizedLowercase:W,values:Q,containsPathSeparator:j,expectContiguousMatch:X}}e.prepareQuery=$;function M(N){let U;n.isWindows?U=N.replace(/\//g,C.sep):U=N.replace(/\\/g,C.sep);const V=(0,k.stripWildcards)(U).replace(/\s|"/g,"");return{pathNormalized:U,normalized:V,normalizedLowercase:V.toLowerCase()}}function H(N){return Array.isArray(N)?$(N.map(U=>U.original).join(F)):$(N.original)}e.pieceToQuery=H}),define(fe[31],me([0,1,16,30,24,9,8]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const _="**",D="/",P="[/\\\\]",I="[^/\\\\]",c=/\//g;function v(O){switch(O){case 0:return"";case 1:return`${I}*?`;default:return`(?:${P}|${I}+${P}|${P}${I}+)*?`}}function h(O,W){if(!O)return[];const j=[];let X=!1,Q=!1,de="";for(const Se of O){switch(Se){case W:if(!X&&!Q){j.push(de),de="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}de+=Se}return de&&j.push(de),j}e.splitGlobAware=h;function w(O){if(!O)return"";let W="";const j=h(O,D);if(j.every(X=>X===_))W=".*";else{let X=!1;j.forEach((Q,de)=>{if(Q===_){X||(W+=v(2),X=!0);return}let Se=!1,De="",Pe=!1,Be="";for(const We of Q){if(We!=="}"&&Se){De+=We;continue}if(Pe&&(We!=="]"||!Be)){let He;We==="-"?He=We:(We==="^"||We==="!")&&!Be?He="^":We===D?He="":He=n.escapeRegExpCharacters(We),Be+=He;continue}switch(We){case"{":Se=!0;continue;case"[":Pe=!0;continue;case"}":W+=`(?:${h(De,",").map(ee=>w(ee)).join("|")})`,Se=!1,De="";break;case"]":W+="["+Be+"]",Pe=!1,Be="";break;case"?":W+=I;continue;case"*":W+=v(1);continue;default:W+=n.escapeRegExpCharacters(We)}}de<j.length-1&&(j[de+1]!==_||de+2<j.length)&&(W+=P),X=!1})}return W}const E=/^\*\*\/\*\.[\w\.-]+$/,T=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,o=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new y.LRUCache(1e4),m=function(){return!1},i=function(){return null};function t(O,W){if(!O)return i;let j;typeof O!="string"?j=O.pattern:j=O,j=j.trim();const X=`${j}_${!!W.trimForExclusions}`;let Q=r.get(X);if(Q)return u(Q,O);let de;if(E.test(j)){const Se=j.substr(4);Q=function(De,Pe){return typeof De=="string"&&De.endsWith(Se)?j:null}}else(de=T.exec(a(j,W)))?Q=l(de[1],j):(W.trimForExclusions?o:b).test(j)?Q=f(j,W):(de=s.exec(a(j,W)))?Q=d(de[1].substr(1),j,!0):(de=p.exec(a(j,W)))?Q=d(de[1],j,!1):Q=S(j);return r.set(X,Q),u(Q,O)}function u(O,W){return typeof W=="string"?O:function(j,X){return L.isEqualOrParent(j,W.base)?O(C.relative(W.base,j),X):null}}function a(O,W){return W.trimForExclusions&&O.endsWith("/**")?O.substr(0,O.length-2):O}function l(O,W){const j=`/${O}`,X=`\\${O}`,Q=function(Se,De){return typeof Se!="string"?null:De?De===O?W:null:Se===O||Se.endsWith(j)||Se.endsWith(X)?W:null},de=[O];return Q.basenames=de,Q.patterns=[W],Q.allBasenames=de,Q}function f(O,W){const j=V(O.slice(1,-1).split(",").map(De=>t(De,W)).filter(De=>De!==i),O),X=j.length;if(!X)return i;if(X===1)return j[0];const Q=function(De,Pe){for(let Be=0,We=j.length;Be<We;Be++)if(j[Be](De,Pe))return O;return null},de=j.find(De=>!!De.allBasenames);de&&(Q.allBasenames=de.allBasenames);const Se=j.reduce((De,Pe)=>Pe.allPaths?De.concat(Pe.allPaths):De,[]);return Se.length&&(Q.allPaths=Se),Q}function d(O,W,j){const X=C.sep===C.posix.sep,Q=X?O:O.replace(c,C.sep),de=C.sep+Q,Se=C.posix.sep+O,De=j?function(Pe,Be){return typeof Pe=="string"&&(Pe===Q||Pe.endsWith(de)||!X&&(Pe===O||Pe.endsWith(Se)))?W:null}:function(Pe,Be){return typeof Pe=="string"&&(Pe===Q||!X&&Pe===O)?W:null};return De.allPaths=[(j?"*/":"./")+O],De}function S(O){try{const W=new RegExp(`^${w(O)}$`);return function(j){return W.lastIndex=0,typeof j=="string"&&W.test(j)?O:null}}catch(W){return i}}function A(O,W,j){return!O||typeof W!="string"?!1:R(O)(W,void 0,j)}e.match=A;function R(O,W={}){if(!O)return m;if(typeof O=="string"||$(O)){const j=t(O,W);if(j===i)return m;const X=function(Q,de){return!!j(Q,de)};return j.allBasenames&&(X.allBasenames=j.allBasenames),j.allPaths&&(X.allPaths=j.allPaths),X}return N(O,W)}e.parse=R;function B(O){if(!O)return;let W;return j=>(W||(W=(O()||Promise.resolve([])).then(X=>X?F(X):{})),W.then(X=>!!X[j]))}e.hasSiblingPromiseFn=B;function x(O){if(!O)return;let W;return j=>{if(!W){const X=O();W=X?F(X):{}}return!!W[j]}}e.hasSiblingFn=x;function F(O){const W={};for(const j of O)W[j]=!0;return W}function $(O){const W=O;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=$;function M(O){return O.allBasenames||[]}e.getBasenameTerms=M;function H(O){return O.allPaths||[]}e.getPathTerms=H;function N(O,W){const j=V(Object.getOwnPropertyNames(O).map(De=>U(De,O[De],W)).filter(De=>De!==i)),X=j.length;if(!X)return i;if(!j.some(De=>!!De.requiresSiblings)){if(X===1)return j[0];const De=function(We,He){for(let G=0,ee=j.length;G<ee;G++){const ne=j[G](We,He);if(ne)return ne}return null},Pe=j.find(We=>!!We.allBasenames);Pe&&(De.allBasenames=Pe.allBasenames);const Be=j.reduce((We,He)=>He.allPaths?We.concat(He.allPaths):We,[]);return Be.length&&(De.allPaths=Be),De}const Q=function(De,Pe,Be){let We;for(let He=0,G=j.length;He<G;He++){const ee=j[He];ee.requiresSiblings&&Be&&(Pe||(Pe=C.basename(De)),We||(We=Pe.substr(0,Pe.length-C.extname(De).length)));const ne=ee(De,Pe,We,Be);if(ne)return ne}return null},de=j.find(De=>!!De.allBasenames);de&&(Q.allBasenames=de.allBasenames);const Se=j.reduce((De,Pe)=>Pe.allPaths?De.concat(Pe.allPaths):De,[]);return Se.length&&(Q.allPaths=Se),Q}function U(O,W,j){if(W===!1)return i;const X=t(O,j);if(X===i)return i;if(typeof W=="boolean")return X;if(W){const Q=W.when;if(typeof Q=="string"){const de=(Se,De,Pe,Be)=>{if(!Be||!X(Se,De))return null;const We=Q.replace("$(basename)",Pe),He=Be(We);return(0,g.isThenable)(He)?He.then(G=>G?O:null):He?O:null};return de.requiresSiblings=!0,de}}return X}function V(O,W){const j=O.filter(De=>!!De.basenames);if(j.length<2)return O;const X=j.reduce((De,Pe)=>{const Be=Pe.basenames;return Be?De.concat(Be):De},[]);let Q;if(W){Q=[];for(let De=0,Pe=X.length;De<Pe;De++)Q.push(W)}else Q=j.reduce((De,Pe)=>{const Be=Pe.patterns;return Be?De.concat(Be):De},[]);const de=function(De,Pe){if(typeof De!="string")return null;if(!Pe){let We;for(We=De.length;We>0;We--){const He=De.charCodeAt(We-1);if(He===47||He===92)break}Pe=De.substr(We)}const Be=X.indexOf(Pe);return Be!==-1?Q[Be]:null};de.basenames=X,de.patterns=Q,de.allBasenames=X;const Se=O.filter(De=>!De.basenames);return Se.push(de),Se}}),define(fe[81],me([0,1,30,10,9,12,23,8,2]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function D(t,u,a){if(typeof t=="string"&&(t=_.URI.file(t)),a){const f=a.getWorkspaceFolder(t);if(f){const d=a.getWorkspace().folders.length>1;let S;if((0,n.isEqual)(f.uri,t)?S="":S=(0,n.relativePath)(f.uri,t),d){const A=f.name?f.name:(0,n.basename)(f.uri);S=S?A+" \u2022 "+S:A}return S}}if(t.scheme!==L.Schemas.file&&t.scheme!==L.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,g.hasDriveLetter)(t.fsPath))return(0,y.normalize)(I(t.fsPath));let l=(0,y.normalize)(t.fsPath);return!C.isWindows&&u?.userHome&&(l=v(l,u.userHome.fsPath)),l}e.getPathLabel=D;function P(t){if(!t)return;typeof t=="string"&&(t=_.URI.file(t));const u=(0,n.basename)(t)||(t.scheme===L.Schemas.file?t.fsPath:t.path);return C.isWindows&&(0,g.isRootOrDriveLetter)(u)?I(u):u}e.getBaseLabel=P;function I(t,u){return(0,g.hasDriveLetter)(t,u)?t.charAt(0).toUpperCase()+t.slice(1):t}e.normalizeDriveLetter=I;let c=Object.create(null);function v(t,u){if(C.isWindows||!t||!u)return t;let a=c.original===u?c.normalized:void 0;return a||(a=`${(0,k.rtrim)(u,y.posix.sep)}${y.posix.sep}`,c={original:u,normalized:a}),(C.isLinux?t.startsWith(a):(0,k.startsWithIgnoreCase)(t,a))&&(t=`~/${t.substr(a.length)}`),t}e.tildify=v;function h(t,u){return t.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=h;const w="\u2026",E="\\\\",T="~";function b(t,u=y.sep){const a=new Array(t.length);let l=!1;for(let f=0;f<t.length;f++){let d=t[f];if(d===""){a[f]=`.${u}`;continue}if(!d){a[f]=d;continue}l=!0;let S="";d.indexOf(E)===0?(S=d.substr(0,d.indexOf(E)+E.length),d=d.substr(d.indexOf(E)+E.length)):d.indexOf(u)===0?(S=d.substr(0,d.indexOf(u)+u.length),d=d.substr(d.indexOf(u)+u.length)):d.indexOf(T)===0&&(S=d.substr(0,d.indexOf(T)+T.length),d=d.substr(d.indexOf(T)+T.length));const A=d.split(u);for(let R=1;l&&R<=A.length;R++)for(let B=A.length-R;l&&B>=0;B--){l=!1;let x=A.slice(B,B+R).join(u);for(let F=0;!l&&F<t.length;F++)if(F!==f&&t[F]&&t[F].indexOf(x)>-1){const $=B+R===A.length,M=B>0&&t[F].indexOf(u)>-1?u+x:x,H=t[F].endsWith(M);l=!$||H}if(!l){let F="";(A[0].endsWith(":")||S!=="")&&(B===1&&(B=0,R++,x=A[0]+u+x),B>0&&(F=A[0]+u),F=S+F),B>0&&(F=F+w+u),F=F+x,B+R<A.length&&(F=F+u+w),a[f]=F}}l&&(a[f]=d)}return a}e.shorten=b;var o;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(o||(o={}));function s(t,u=Object.create(null)){const a=[];let l=!1,f="";for(const d of t)if(d==="$"||l&&d==="{")f&&a.push({value:f,type:o.TEXT}),f="",l=!0;else if(d==="}"&&l){const S=u[f];if(typeof S=="string")S.length&&a.push({value:S,type:o.VARIABLE});else if(S){const A=a[a.length-1];(!A||A.type!==o.SEPARATOR)&&a.push({value:S.label,type:o.SEPARATOR})}f="",l=!1}else f+=d;return f&&!l&&a.push({value:f,type:o.TEXT}),a.filter((d,S)=>{if(d.type===o.SEPARATOR){const A=a[S-1],R=a[S+1];return[A,R].every(B=>B&&(B.type===o.VARIABLE||B.type===o.TEXT)&&B.value.length>0)}return!0}).map(d=>d.value).join("")}e.template=s;function p(t,u){return C.isMacintosh||u?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,C.isMacintosh?"&":"&&"):t.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.mnemonicMenuLabel=p;function r(t,u){return C.isMacintosh||u?t.replace(/\(&&\w\)|&&/g,""):C.isWindows?t.replace(/&&|&/g,a=>a==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function m(t){return t.replace(/&/g,"&&")}e.unmnemonicLabel=m;function i(t){const u=t.indexOf("/")!==-1?y.posix:y.win32,a=u.basename(t),l=u.dirname(t);return a.length?{name:a,parentPath:l}:{name:l,parentPath:""}}e.splitName=i}),define(fe[102],me([0,1,31,10,9,23,8]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var k;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(k=e.Mimes||(e.Mimes={}));let _=[],D=[],P=[];function I(t,u=!1){const a=c(t);_.push(a),a.userConfigured?P.push(a):D.push(a),u&&!a.userConfigured&&_.forEach(l=>{l.mime===a.mime||l.userConfigured||(a.extension&&l.extension===a.extension&&console.warn(`Overwriting extension <<${a.extension}>> to now point to mime <<${a.mime}>>`),a.filename&&l.filename===a.filename&&console.warn(`Overwriting filename <<${a.filename}>> to now point to mime <<${a.mime}>>`),a.filepattern&&l.filepattern===a.filepattern&&console.warn(`Overwriting filepattern <<${a.filepattern}>> to now point to mime <<${a.mime}>>`),a.firstline&&l.firstline===a.firstline&&console.warn(`Overwriting firstline <<${a.firstline}>> to now point to mime <<${a.mime}>>`))})}e.registerTextMime=I;function c(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,g.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(y.posix.sep)>=0:!1}}function v(t){t?(_=_.filter(u=>!u.userConfigured),P=[]):(_=[],D=[],P=[])}e.clearTextMimes=v;function h(t,u){let a;if(t)switch(t.scheme){case L.Schemas.file:a=t.fsPath;break;case L.Schemas.data:a=C.DataUri.parseMetaData(t).get(C.DataUri.META_DATA_LABEL);break;default:a=t.path}if(!a)return[k.unknown];a=a.toLowerCase();const l=(0,y.basename)(a),f=w(a,l,P);if(f)return[f,k.text];const d=w(a,l,D);if(d)return[d,k.text];if(u){const S=E(u);if(S)return[S,k.text]}return[k.unknown]}e.guessMimeTypes=h;function w(t,u,a){let l=null,f=null,d=null;for(let S=a.length-1;S>=0;S--){const A=a[S];if(u===A.filenameLowercase){l=A;break}if(A.filepattern&&(!f||A.filepattern.length>f.filepattern.length)){const R=A.filepatternOnPath?t:u;A.filepatternLowercase?.(R)&&(f=A)}A.extension&&(!d||A.extension.length>d.extension.length)&&u.endsWith(A.extensionLowercase)&&(d=A)}return l?l.mime:f?f.mime:d?d.mime:null}function E(t){if((0,n.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let u=_.length-1;u>=0;u--){const a=_[u];if(!a.firstline)continue;const l=t.match(a.firstline);if(l&&l.length>0)return a.mime}return null}function T(t){return t?typeof t=="string"?t===k.binary||t===k.text||t===k.unknown:t.length===1&&T(t[0]):!0}e.isUnspecific=T;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},o={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function s(t){const u=(0,y.extname)(t),a=b[u.toLowerCase()];return a!==void 0?a:p(t)}e.getMediaOrTextMime=s;function p(t){const u=(0,y.extname)(t);return o[u.toLowerCase()]}e.getMediaMime=p;function r(t){for(const u in o)if(o[u]===t)return u}e.getExtensionForMimeType=r;const m=/^(.+)\/(.+?)(;.+)?$/;function i(t,u){const a=m.exec(t);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:u?void 0:t}e.normalizeMimeType=i}),define(fe[103],me([0,1,2]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(P){return P.toJSON()}class y{constructor(I){this._uriTransformer=I}transformIncoming(I){const c=this._uriTransformer.transformIncoming(I);return c===I?I:L(g.URI.from(c))}transformOutgoing(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:L(g.URI.from(c))}transformOutgoingURI(I){const c=this._uriTransformer.transformOutgoing(I);return c===I?I:g.URI.from(c)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=y,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function C(P,I,c){if(!P||c>200)return null;if(typeof P=="object"){if(P instanceof g.URI)return I.transformOutgoing(P);for(let v in P)if(Object.hasOwnProperty.call(P,v)){const h=C(P[v],I,c+1);h!==null&&(P[v]=h)}}return null}function n(P,I){const c=C(P,I,0);return c===null?P:c}e.transformOutgoingURIs=n;function k(P,I,c,v){if(!P||v>200)return null;if(typeof P=="object"){if(P.$mid===1)return c?g.URI.revive(I.transformIncoming(P)):I.transformIncoming(P);for(let h in P)if(Object.hasOwnProperty.call(P,h)){const w=k(P[h],I,c,v+1);w!==null&&(P[h]=w)}}return null}function _(P,I){const c=k(P,I,!1,0);return c===null?P:c}e.transformIncomingURIs=_;function D(P,I){const c=k(P,I,!0,0);return c===null?P:c}e.transformAndReviveIncomingURIs=D}),define(fe[32],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(_){return g.test(_)}e.isUUID=L;const y=new Uint8Array(16),C=[];for(let _=0;_<256;_++)C.push(_.toString(16).padStart(2,"0"));let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(_){for(let D=0;D<_.length;D++)_[D]=Math.floor(Math.random()*256);return _};function k(){n(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let _=0,D="";return D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+="-",D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D+=C[y[_++]],D}e.generateUuid=k}),define(fe[143],me([0,1,104]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(C="utf8"){this.stringDecoder=new g.StringDecoder(C),this.remaining=null}write(C){const n=[],k=this.remaining?this.remaining+this.stringDecoder.write(C):this.stringDecoder.write(C);if(k.length<1)return n;let _=0,D,P=_;for(;P<k.length;)if(D=k.charCodeAt(P),D===13||D===10){if(n.push(k.substring(_,P)),P++,P<k.length){const I=D;D=k.charCodeAt(P),(I===13&&D===10||I===10&&D===13)&&P++}_=P}else P++;return this.remaining=_<k.length?k.substr(_):null,n}end(){return this.remaining}}e.LineDecoder=L}),define(fe[28],me([0,1,63,82,293,16,30,80,9,12,23,2,32]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function h(M,H=v.UNLINK){if((0,n.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return H===v.UNLINK?E(M):w(M)}async function w(M){try{const H=(0,_.join)((0,L.tmpdir)(),(0,c.generateUuid)());try{await e.Promises.rename(M,H)}catch(N){return E(M)}E(H).catch(N=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function E(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function T(M){if((0,n.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");g.rmdirSync(M,{recursive:!0})}e.rimrafSync=T;async function b(M,H){return p(await(H?o(M):(0,y.promisify)(g.readdir)(M)))}async function o(M){try{return await(0,y.promisify)(g.readdir)(M,{withFileTypes:!0})}catch(U){console.warn("[node.js fs] readdir with filetypes failed with error: ",U)}const H=[],N=await b(M);for(const U of N){let V=!1,O=!1,W=!1;try{const j=await e.Promises.lstat((0,_.join)(M,U));V=j.isFile(),O=j.isDirectory(),W=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}H.push({name:U,isFile:()=>V,isDirectory:()=>O,isSymbolicLink:()=>W})}return H}function s(M){return p(g.readdirSync(M))}e.readdirSync=s;function p(M){return M.map(H=>typeof H=="string"?D.isMacintosh?(0,k.normalizeNFC)(H):H:(H.name=D.isMacintosh?(0,k.normalizeNFC)(H.name):H.name,H))}async function r(M){const H=await b(M),N=[];for(const U of H)await i.existsDirectory((0,_.join)(M,U))&&N.push(U);return N}function m(M,H=1e3){return new Promise(N=>{let U=!1;const V=setInterval(()=>{U||(U=!0,g.access(M,O=>{U=!1,O&&(clearInterval(V),N(void 0))}))},H)})}e.whenDeleted=m;var i;(function(M){async function H(V){let O;try{if(O=await e.Promises.lstat(V),!O.isSymbolicLink())return{stat:O}}catch(W){}try{return{stat:await e.Promises.stat(V),symbolicLink:O?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};if(D.isWindows&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&O)return{stat:O,symbolicLink:{dangling:!0}};throw j}throw W}}M.stat=H;async function N(V){try{const{stat:O,symbolicLink:W}=await M.stat(V);return O.isFile()&&W?.dangling!==!0}catch(O){}return!1}M.existsFile=N;async function U(V){try{const{stat:O,symbolicLink:W}=await M.stat(V);return O.isDirectory()&&W?.dangling!==!0}catch(O){}return!1}M.existsDirectory=U})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new C.ResourceQueue;function u(M,H,N){return t.queueFor(I.URI.file(M),P.extUriBiasedIgnorePathCase).queue(()=>{const U=d(N);return new Promise((V,O)=>l(M,H,U,W=>W?O(W):V()))})}let a=!0;function l(M,H,N,U){if(!a)return g.writeFile(M,H,{mode:N.mode,flag:N.flag},U);g.open(M,N.flag,N.mode,(V,O)=>{if(V)return U(V);g.writeFile(O,H,W=>{if(W)return g.close(O,()=>U(W));g.fdatasync(O,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),a=!1),g.close(O,X=>U(X))))})})}function f(M,H,N){const U=d(N);if(!a)return g.writeFileSync(M,H,{mode:U.mode,flag:U.flag});const V=g.openSync(M,U.flag,U.mode);try{g.writeFileSync(V,H);try{g.fdatasyncSync(V)}catch(O){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",O),a=!1}}finally{g.closeSync(V)}}e.writeFileSync=f;function d(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function S(M,H){if(M===H)return;async function N(U){try{const V=await e.Promises.lstat(U);if(V.isDirectory()||V.isSymbolicLink())return;await e.Promises.utimes(U,V.atime,new Date)}catch(V){}}try{await e.Promises.rename(M,H),await N(H)}catch(U){if(M.toLowerCase()!==H.toLowerCase()&&U.code==="EXDEV"||M.endsWith("."))await A(M,H,{preserveSymlinks:!1}),await h(M,v.MOVE),await N(H);else throw U}}async function A(M,H,N){return B(M,H,{root:{source:M,target:H},options:N,handledSourcePaths:new Set})}const R=511;async function B(M,H,N){if(N.handledSourcePaths.has(M))return;N.handledSourcePaths.add(M);const{stat:U,symbolicLink:V}=await i.stat(M);if(V){if(N.options.preserveSymlinks)try{return await $(M,H,N)}catch(O){console.warn("[node.js fs] copy of symlink failed: ",O)}if(V.dangling)return}return U.isDirectory()?x(M,H,U.mode&R,N):F(M,H,U.mode&R)}async function x(M,H,N,U){await e.Promises.mkdir(H,{recursive:!0,mode:N});const V=await b(M);for(const O of V)await B((0,_.join)(M,O),(0,_.join)(H,O),U)}async function F(M,H,N){await e.Promises.copyFile(M,H),await e.Promises.chmod(H,N)}async function $(M,H,N){let U=await e.Promises.readlink(M);(0,n.isEqualOrParent)(U,N.root.source,!D.isLinux)&&(U=(0,_.join)(N.root.target,U.substr(N.root.source.length+1))),await e.Promises.symlink(U,H)}e.Promises=new class{get access(){return(0,y.promisify)(g.access)}get stat(){return(0,y.promisify)(g.stat)}get lstat(){return(0,y.promisify)(g.lstat)}get utimes(){return(0,y.promisify)(g.utimes)}get read(){return(0,y.promisify)(g.read)}get readFile(){return(0,y.promisify)(g.readFile)}get write(){return(0,y.promisify)(g.write)}get appendFile(){return(0,y.promisify)(g.appendFile)}get fdatasync(){return(0,y.promisify)(g.fdatasync)}get truncate(){return(0,y.promisify)(g.truncate)}get rename(){return(0,y.promisify)(g.rename)}get copyFile(){return(0,y.promisify)(g.copyFile)}get open(){return(0,y.promisify)(g.open)}get close(){return(0,y.promisify)(g.close)}get symlink(){return(0,y.promisify)(g.symlink)}get readlink(){return(0,y.promisify)(g.readlink)}get chmod(){return(0,y.promisify)(g.chmod)}get mkdir(){return(0,y.promisify)(g.mkdir)}get unlink(){return(0,y.promisify)(g.unlink)}get rmdir(){return(0,y.promisify)(g.rmdir)}get realpath(){return(0,y.promisify)(g.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return r}get writeFile(){return u}get rm(){return h}get move(){return S}get copy(){return A}}}),define(fe[105],me([0,1,63,9,8,28]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(P){const I=(0,L.dirname)(P);if(P===I)return P;const c=((0,L.basename)(P)||P).toLowerCase();try{const h=(0,C.readdirSync)(I).filter(w=>w.toLowerCase()===c);if(h.length===1){const w=n(I);if(w)return(0,L.join)(w,h[0])}else if(h.length>1){const w=h.indexOf(c);if(w>=0){const E=n(I);if(E)return(0,L.join)(E,h[w])}}}catch(v){}return null}e.realcaseSync=n;async function k(P){try{return await C.Promises.realpath(P)}catch(I){const c=D(P);return await C.Promises.access(c,g.constants.R_OK),c}}e.realpath=k;function _(P){try{return g.realpathSync(P)}catch(I){const c=D(P);return g.accessSync(c,g.constants.R_OK),c}}e.realpathSync=_;function D(P){return(0,y.rtrim)((0,L.normalize)(P),L.sep)}});var Ve=this&&this.__decorate||function(Y,e,g,L){var y=arguments.length,C=y<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,g):L,n;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")C=Reflect.decorate(Y,e,g,L);else for(var k=Y.length-1;k>=0;k--)(n=Y[k])&&(C=(y<3?n(C):y>3?n(e,g,C):n(e,g))||C);return y>3&&C&&Object.defineProperty(e,g,C),C};define(fe[106],me([0,1,15,16,22,21,60,18,3,6,62,8,13]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var v;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(v=e.RequestType||(e.RequestType={}));function h(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function E(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var T;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(T||(T={}));class b{constructor(O){this.buffer=O,this.pos=0}read(O){const W=this.buffer.slice(this.pos,this.pos+O);return this.pos+=W.byteLength,W}}class o{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(O){this.buffers.push(O)}}var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(s||(s={}));function p(V){const O=y.VSBuffer.alloc(4);return O.writeUInt32BE(V,0),O}function r(V){return V.read(4).readUInt32BE(0)}function m(V){const O=y.VSBuffer.alloc(1);return O.writeUInt8(V,0),O}const i={Undefined:m(s.Undefined),String:m(s.String),Buffer:m(s.Buffer),VSBuffer:m(s.VSBuffer),Array:m(s.Array),Object:m(s.Object)},t=typeof Buffer!="undefined";function u(V,O){if(typeof O=="undefined")V.write(i.Undefined);else if(typeof O=="string"){const W=y.VSBuffer.fromString(O);V.write(i.String),V.write(p(W.byteLength)),V.write(W)}else if(t&&Buffer.isBuffer(O)){const W=y.VSBuffer.wrap(O);V.write(i.Buffer),V.write(p(W.byteLength)),V.write(W)}else if(O instanceof y.VSBuffer)V.write(i.VSBuffer),V.write(p(O.byteLength)),V.write(O);else if(Array.isArray(O)){V.write(i.Array),V.write(p(O.length));for(const W of O)u(V,W)}else{const W=y.VSBuffer.fromString(JSON.stringify(O));V.write(i.Object),V.write(p(W.byteLength)),V.write(W)}}function a(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(r(V)).toString();case s.Buffer:return V.read(r(V)).buffer;case s.VSBuffer:return V.read(r(V));case s.Array:{const W=r(V),j=[];for(let X=0;X<W;X++)j.push(a(V));return j}case s.Object:return JSON.parse(V.read(r(V)).toString())}}class l{constructor(O,W,j=null,X=1e3){this.protocol=O,this.ctx=W,this.logger=j,this.timeoutDelay=X,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(Q=>this.onRawMessage(Q)),this.sendResponse({type:200})}registerChannel(O,W){this.channels.set(O,W),setTimeout(()=>this.flushPendingRequests(O),0)}sendResponse(O){switch(O.type){case 200:{const W=this.send([O.type]);this.logger&&this.logger.logOutgoing(W,0,1,E(O.type));return}case 201:case 202:case 204:case 203:{const W=this.send([O.type,O.id],O.data);this.logger&&this.logger.logOutgoing(W,O.id,1,E(O.type),O.data);return}}}send(O,W=void 0){const j=new o;return u(j,O),u(j,W),this.sendBuffer(j.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(W){return 0}}onRawMessage(O){const W=new b(O),j=a(W),X=a(W),Q=j[0];switch(Q){case 100:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${h(Q)}: ${j[2]}.${j[3]}`,X),this.onPromise({type:Q,id:j[1],channelName:j[2],name:j[3],arg:X});case 102:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${h(Q)}: ${j[2]}.${j[3]}`,X),this.onEventListen({type:Q,id:j[1],channelName:j[2],name:j[3],arg:X});case 101:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:j[1]});case 103:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],1,`${h(Q)}`),this.disposeActiveRequest({type:Q,id:j[1]})}}onPromise(O){const W=this.channels.get(O.channelName);if(!W){this.collectPendingRequest(O);return}const j=new C.CancellationTokenSource;let X;try{X=W.call(this.ctx,O.name,O.arg,j.token)}catch(Se){X=Promise.reject(Se)}const Q=O.id;X.then(Se=>{this.sendResponse({id:Q,data:Se,type:201}),this.activeRequests.delete(O.id)},Se=>{Se instanceof Error?this.sendResponse({id:Q,data:{message:Se.message,name:Se.name,stack:Se.stack?Se.stack.split?Se.stack.split(`
`):Se.stack:void 0},type:202}):this.sendResponse({id:Q,data:Se,type:203}),this.activeRequests.delete(O.id)});const de=(0,D.toDisposable)(()=>j.cancel());this.activeRequests.set(O.id,de)}onEventListen(O){const W=this.channels.get(O.channelName);if(!W){this.collectPendingRequest(O);return}const j=O.id,Q=W.listen(this.ctx,O.name,O.arg)(de=>this.sendResponse({id:j,data:de,type:204}));this.activeRequests.set(O.id,Q)}disposeActiveRequest(O){const W=this.activeRequests.get(O.id);W&&(W.dispose(),this.activeRequests.delete(O.id))}collectPendingRequest(O){let W=this.pendingRequests.get(O.channelName);W||(W=[],this.pendingRequests.set(O.channelName,W));const j=setTimeout(()=>{console.error(`Unknown channel: ${O.channelName}`),O.type===100&&this.sendResponse({id:O.id,data:{name:"Unknown channel",message:`Channel name '${O.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:O,timeoutTimer:j})}flushPendingRequests(O){const W=this.pendingRequests.get(O);if(W){for(const j of W)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(O)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var f;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class d{constructor(O,W=null){this.protocol=O,this.isDisposed=!1,this.state=T.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new _.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=W}getChannel(O){const W=this;return{call(j,X,Q){return W.isDisposed?Promise.reject(k.canceled()):W.requestPromise(O,j,X,Q)},listen(j,X){return W.isDisposed?Promise.reject(k.canceled()):W.requestEvent(O,j,X)}}}requestPromise(O,W,j,X=C.CancellationToken.None){const Q=this.lastRequestId++,Se={id:Q,type:100,channelName:O,name:W,arg:j};if(X.isCancellationRequested)return Promise.reject(k.canceled());let De;return new Promise((Be,We)=>{if(X.isCancellationRequested)return We(k.canceled());const He=()=>{const le=Z=>{switch(Z.type){case 201:this.handlers.delete(Q),Be(Z.data);break;case 202:this.handlers.delete(Q);const re=new Error(Z.data.message);re.stack=Z.data.stack,re.name=Z.data.name,We(re);break;case 203:this.handlers.delete(Q),We(Z.data);break}};this.handlers.set(Q,le),this.sendRequest(Se)};let G=null;this.state===T.Idle?He():(G=(0,L.createCancelablePromise)(le=>this.whenInitialized()),G.then(()=>{G=null,He()}));const ee=()=>{G?(G.cancel(),G=null):this.sendRequest({id:Q,type:101}),We(k.canceled())},ne=X.onCancellationRequested(ee);De=(0,D.combinedDisposable)((0,D.toDisposable)(ee),ne),this.activeRequests.add(De)}).finally(()=>{this.activeRequests.delete(De)})}requestEvent(O,W,j){const X=this.lastRequestId++,de={id:X,type:102,channelName:O,name:W,arg:j};let Se=null;const De=new _.Emitter({onFirstListenerAdd:()=>{Se=(0,L.createCancelablePromise)(Be=>this.whenInitialized()),Se.then(()=>{Se=null,this.activeRequests.add(De),this.sendRequest(de)})},onLastListenerRemove:()=>{Se?(Se.cancel(),Se=null):(this.activeRequests.delete(De),this.sendRequest({id:X,type:103}))}}),Pe=Be=>De.fire(Be.data);return this.handlers.set(X,Pe),De.event}sendRequest(O){switch(O.type){case 100:case 102:{const W=this.send([O.type,O.id,O.channelName,O.name],O.arg);this.logger&&this.logger.logOutgoing(W,O.id,0,`${h(O.type)}: ${O.channelName}.${O.name}`,O.arg);return}case 101:case 103:{const W=this.send([O.type,O.id]);this.logger&&this.logger.logOutgoing(W,O.id,0,h(O.type));return}}}send(O,W=void 0){const j=new o;return u(j,O),u(j,W),this.sendBuffer(j.buffer)}sendBuffer(O){try{return this.protocol.send(O),O.byteLength}catch(W){return 0}}onBuffer(O){const W=new b(O),j=a(W),X=a(W),Q=j[0];switch(Q){case 200:return this.logger&&this.logger.logIncoming(O.byteLength,0,0,E(Q)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(O.byteLength,j[1],0,E(Q),X),this.onResponse({type:j[0],id:j[1],data:X})}}onResponse(O){if(O.type===200){this.state=T.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(O.id);W&&W(O)}get onDidInitializePromise(){return _.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===T.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(O=>O.dispose()),this.activeRequests.clear()}}Ve([n.memoize],d.prototype,"onDidInitializePromise",null),e.ChannelClient=d;class S{constructor(O){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new _.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new _.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,O(({protocol:W,onDidClientDisconnect:j})=>{_.Event.once(W.onMessage)(Q=>{const de=new b(Q),Se=a(de),De=new l(W,Se),Pe=new d(W);this.channels.forEach((We,He)=>De.registerChannel(He,We));const Be={channelServer:De,channelClient:Pe,ctx:Se};this._connections.add(Be),this._onDidAddConnection.fire(Be),j(()=>{De.dispose(),Pe.dispose(),this._connections.delete(Be),this._onDidRemoveConnection.fire(Be)})})})}get connections(){const O=[];return this._connections.forEach(W=>O.push(W)),O}getChannel(O,W){const j=this;return{call(X,Q,de){let Se;if((0,c.isFunction)(W)){let Pe=(0,g.getRandomElement)(j.connections.filter(W));Se=Pe?Promise.resolve(Pe):_.Event.toPromise(_.Event.filter(j.onDidAddConnection,W))}else Se=W.routeCall(j,X,Q);const De=Se.then(Pe=>Pe.channelClient.getChannel(O));return R(De).call(X,Q,de)},listen(X,Q){if((0,c.isFunction)(W))return j.getMulticastEvent(O,W,X,Q);const de=W.routeEvent(j,X,Q).then(Se=>Se.channelClient.getChannel(O));return R(de).listen(X,Q)}}}getMulticastEvent(O,W,j,X){const Q=this;let de=new D.DisposableStore;const Se=new _.Emitter({onFirstListenerAdd:()=>{de=new D.DisposableStore;const De=new _.EventMultiplexer,Pe=new Map,Be=He=>{const ee=He.channelClient.getChannel(O).listen(j,X),ne=De.add(ee);Pe.set(He,ne)},We=He=>{const G=Pe.get(He);!G||(G.dispose(),Pe.delete(He))};Q.connections.filter(W).forEach(Be),_.Event.filter(Q.onDidAddConnection,W)(Be,void 0,de),Q.onDidRemoveConnection(We,void 0,de),De.event(Se.fire,Se,de),de.add(De)},onLastListenerRemove:()=>{de.dispose()}});return Se.event}registerChannel(O,W){this.channels.set(O,W),this._connections.forEach(j=>{j.channelServer.registerChannel(O,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=S;class A{constructor(O,W,j=null){const X=new o;u(X,W),O.send(X.buffer),this.channelClient=new d(O,j),this.channelServer=new l(O,W,j)}getChannel(O){return this.channelClient.getChannel(O)}registerChannel(O,W){this.channelServer.registerChannel(O,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=A;function R(V){return{call(O,W,j){return V.then(X=>X.call(O,W,j))},listen(O,W){const j=new _.Relay;return V.then(X=>j.input=X.listen(O,W)),j.event}}}e.getDelayedChannel=R;function B(V){let O=!1;return{call(W,j,X){return O?V.call(W,j,X):(0,L.timeout)(0).then(()=>O=!0).then(()=>V.call(W,j,X))},listen(W,j){if(O)return V.listen(W,j);const X=new _.Relay;return(0,L.timeout)(0).then(()=>O=!0).then(()=>X.input=V.listen(W,j)),X.event}}}e.getNextTickChannel=B;class x{constructor(O){this.fn=O}routeCall(O){return this.route(O)}routeEvent(O){return this.route(O)}async route(O){for(const W of O.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await _.Event.toPromise(O.onDidAddConnection),await this.route(O)}}e.StaticRouter=x;var F;(function(V){function O(Q,de){const Se=Q,De=de&&de.disableMarshalling,Pe=new Map;for(const Be in Se)j(Be)&&Pe.set(Be,_.Event.buffer(Se[Be],!0));return new class{listen(Be,We,He){const G=Pe.get(We);if(G)return G;if(X(We)){const ee=Se[We];if(typeof ee=="function")return ee.call(Se,He)}throw new Error(`Event not found: ${We}`)}call(Be,We,He){const G=Se[We];if(typeof G=="function"){if(!De&&Array.isArray(He))for(let ee=0;ee<He.length;ee++)He[ee]=(0,P.revive)(He[ee]);return G.apply(Se,He)}throw new Error(`Method not found: ${We}`)}}}V.fromService=O;function W(Q,de){const Se=de&&de.disableMarshalling;return new Proxy({},{get(De,Pe){if(typeof Pe=="string")return de?.properties?.has(Pe)?de.properties.get(Pe):X(Pe)?function(Be){return Q.listen(Pe,Be)}:j(Pe)?Q.listen(Pe):async function(...Be){let We;de&&!(0,c.isUndefinedOrNull)(de.context)?We=[de.context,...Be]:We=Be;const He=await Q.call(Pe,We);return Se?He:(0,P.revive)(He)};throw new Error(`Property not found: ${String(Pe)}`)}})}V.toService=W;function j(Q){return Q[0]==="o"&&Q[1]==="n"&&I.isUpperAsciiLetter(Q.charCodeAt(2))}function X(Q){return/^onDynamic/.test(Q)&&I.isUpperAsciiLetter(Q.charCodeAt(9))}})(F=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let O=V.toString();if(O!=="[object Object]")return O}return V}function H(V){return Array.isArray(V)?V.map(M):M(V)}function N(V,O,W,j,X,Q,de){de=H(de);const Se=$[X],De=Se[j%Se.length];let Pe=[`%c[${V}]%c[${String(O).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${Q}`,"color: darkgreen","color: grey","color: grey",`color: ${De}`];/\($/.test(Q)?(Pe=Pe.concat(de),Pe.push(")")):Pe.push(de),console.log.apply(console,Pe)}e.logWithColors=N;class U{constructor(O,W){this._outgoingPrefix=O,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(O,W,j,X,Q){this._totalOutgoing+=O,N(this._outgoingPrefix,this._totalOutgoing,O,W,j,X,Q)}logIncoming(O,W,j,X,Q){this._totalIncoming+=O,N(this._incomingPrefix,this._totalIncoming,O,W,j,X,Q)}}e.IPCLogger=U}),define(fe[107],me([0,1,22,3,6,12,38,106]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var _;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function P(){return D||(D=g.VSBuffer.alloc(0)),D}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(t){this._chunks.push(t),this._totalLength+=t.byteLength}read(t){return this._read(t,!0)}peek(t){return this._read(t,!1)}_read(t,u){if(t===0)return P();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){const d=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=t),d}if(this._chunks[0].byteLength>t){const d=this._chunks[0].slice(0,t);return u&&(this._chunks[0]=this._chunks[0].slice(t),this._totalLength-=t),d}let a=g.VSBuffer.alloc(t),l=0,f=0;for(;t>0;){const d=this._chunks[f];if(d.byteLength>t){const S=d.slice(0,t);a.set(S,l),l+=t,u&&(this._chunks[f]=d.slice(t),this._totalLength-=t),t-=t}else a.set(d,l),l+=d.byteLength,u?(this._chunks.shift(),this._totalLength-=d.byteLength):f++,t-=d.byteLength}return a}}e.ChunkStream=I;var c;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(c||(c={}));var v;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(v=e.ProtocolConstants||(e.ProtocolConstants={}));class h{constructor(t,u,a,l){this.type=t,this.id=u,this.ack=a,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends y.Disposable{constructor(t){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=t,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(t);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const a=this._state.messageType,l=this._state.id,f=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(a,l,f,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class E{constructor(t){this._isDisposed=!1,this._socket=t,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(t){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(t){if(this._isDisposed)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=g.VSBuffer.alloc(13);u.writeUInt8(t.type,0),u.writeUInt32BE(t.id,1),u.writeUInt32BE(t.ack,5),u.writeUInt32BE(t.data.byteLength,9),this._writeSoon(u,t.data)}_bufferAdd(t,u){const a=this._totalLength===0;return this._data.push(t,u),this._totalLength+=t.byteLength+u.byteLength,a}_bufferTake(){const t=g.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,t}_writeSoon(t,u){this._bufferAdd(t,u)&&C.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class T extends y.Disposable{constructor(t){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=t,this._socketWriter=this._register(new E(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(t){this._socketWriter.write(new h(1,0,0,t))}}e.Protocol=T;class b extends k.IPCClient{constructor(t,u,a=null){super(t,u,a);this.protocol=t}static fromSocket(t,u){return new b(new T(t),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const t=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),t.end()}}e.Client=b;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(t){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(t):this._emitter.fire(t):this._bufferedMessages.push(t)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class s{constructor(t){this.data=t,this.next=null}}class p{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let t=[],u=0,a=this._first;for(;a;)t[u++]=a.data,a=a.next;return t}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(t){const u=new s(t);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class r{constructor(){this.lastRuns=[];const t=Date.now();for(let u=0;u<r._HISTORY_LENGTH;u++)this.lastRuns[u]=t-1e3*u;setInterval(()=>{for(let u=r._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const t=Date.now(),u=(1+r._HISTORY_LENGTH)*1e3;let a=0;for(let l=0;l<r._HISTORY_LENGTH;l++)t-this.lastRuns[l]<=u&&a++;return 1-a/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class m{constructor(t,u=null,a=r.getInstance()){this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new p,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=t,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,y.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const t=new h(5,0,0,P());this._socketWriter.write(t),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const t=Date.now()-this._socketWriter.lastWriteTime;if(t>=5e3){const u=new h(4,0,0,P());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-t+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const t=Date.now()-this._socketReader.lastReadTime;if(t>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-t,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(t,u){this._isReconnecting=!0,this._socketDisposables=(0,y.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=t,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const t=this._outgoingUnackMsg.toArray();for(let u=0,a=t.length;u<a;u++)this._socketWriter.write(t[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(t){if(t.ack>this._outgoingAckId){this._outgoingAckId=t.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=t.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(t.type===1){if(t.id>this._incomingMsgId)if(t.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new h(6,0,0,P())))}else this._incomingMsgId=t.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(t.data)}else if(t.type===2)this._onControlMessage.fire(t.data);else if(t.type===5)this._onDidDispose.fire();else if(t.type===6){const u=this._outgoingUnackMsg.toArray();for(let a=0,l=u.length;a<l;a++)this._socketWriter.write(u[a]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(t){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new h(1,u,this._incomingAckId,t);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(t){const u=new h(2,0,0,t);this._socketWriter.write(u)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const t=Date.now()-this._incomingMsgLastTime;if(t>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-t+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const t=this._outgoingUnackMsg.peek(),u=Date.now()-t.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const t=new h(3,0,this._incomingAckId,P());this._socketWriter.write(t)}}e.PersistentProtocol=m}),define(fe[108],me([0,1,99]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(k){let _=(0,g.toUint8)(k);this._defaultValue=_,this._asciiMap=L._createAsciiMap(_),this._map=new Map}static _createAsciiMap(k){let _=new Uint8Array(256);for(let D=0;D<256;D++)_[D]=k;return _}set(k,_){let D=(0,g.toUint8)(_);k>=0&&k<256?this._asciiMap[k]=D:this._map.set(k,D)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=L;var y;(function(n){n[n.False=0]="False",n[n.True=1]="True"})(y||(y={}));class C{constructor(){this._actual=new L(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=C}),define(fe[144],me([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(n){n[n.Regular=0]="Regular",n[n.Whitespace=1]="Whitespace",n[n.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class y extends g.CharacterClassifier{constructor(k){super(0);for(let _=0,D=k.length;_<D;_++)this.set(k.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=y;function C(n){let k={};return _=>(k.hasOwnProperty(_)||(k[_]=n(_)),k[_])}e.getMapForWordSeparators=C(n=>new y(n))}),define(fe[51],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(y,C){this.lineNumber=y,this.column=C}with(y=this.lineNumber,C=this.column){return y===this.lineNumber&&C===this.column?this:new g(y,C)}delta(y=0,C=0){return this.with(this.lineNumber+y,this.column+C)}equals(y){return g.equals(this,y)}static equals(y,C){return!y&&!C?!0:!!y&&!!C&&y.lineNumber===C.lineNumber&&y.column===C.column}isBefore(y){return g.isBefore(this,y)}static isBefore(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<C.column}isBeforeOrEqual(y){return g.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,C){return y.lineNumber<C.lineNumber?!0:C.lineNumber<y.lineNumber?!1:y.column<=C.column}static compare(y,C){let n=y.lineNumber|0,k=C.lineNumber|0;if(n===k){let _=y.column|0,D=C.column|0;return _-D}return n-k}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new g(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}}e.Position=g}),define(fe[42],me([0,1,51]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(C,n,k,_){C>k||C===k&&n>_?(this.startLineNumber=k,this.startColumn=_,this.endLineNumber=C,this.endColumn=n):(this.startLineNumber=C,this.startColumn=n,this.endLineNumber=k,this.endColumn=_)}isEmpty(){return L.isEmpty(this)}static isEmpty(C){return C.startLineNumber===C.endLineNumber&&C.startColumn===C.endColumn}containsPosition(C){return L.containsPosition(this,C)}static containsPosition(C,n){return!(n.lineNumber<C.startLineNumber||n.lineNumber>C.endLineNumber||n.lineNumber===C.startLineNumber&&n.column<C.startColumn||n.lineNumber===C.endLineNumber&&n.column>C.endColumn)}containsRange(C){return L.containsRange(this,C)}static containsRange(C,n){return!(n.startLineNumber<C.startLineNumber||n.endLineNumber<C.startLineNumber||n.startLineNumber>C.endLineNumber||n.endLineNumber>C.endLineNumber||n.startLineNumber===C.startLineNumber&&n.startColumn<C.startColumn||n.endLineNumber===C.endLineNumber&&n.endColumn>C.endColumn)}strictContainsRange(C){return L.strictContainsRange(this,C)}static strictContainsRange(C,n){return!(n.startLineNumber<C.startLineNumber||n.endLineNumber<C.startLineNumber||n.startLineNumber>C.endLineNumber||n.endLineNumber>C.endLineNumber||n.startLineNumber===C.startLineNumber&&n.startColumn<=C.startColumn||n.endLineNumber===C.endLineNumber&&n.endColumn>=C.endColumn)}plusRange(C){return L.plusRange(this,C)}static plusRange(C,n){let k,_,D,P;return n.startLineNumber<C.startLineNumber?(k=n.startLineNumber,_=n.startColumn):n.startLineNumber===C.startLineNumber?(k=n.startLineNumber,_=Math.min(n.startColumn,C.startColumn)):(k=C.startLineNumber,_=C.startColumn),n.endLineNumber>C.endLineNumber?(D=n.endLineNumber,P=n.endColumn):n.endLineNumber===C.endLineNumber?(D=n.endLineNumber,P=Math.max(n.endColumn,C.endColumn)):(D=C.endLineNumber,P=C.endColumn),new L(k,_,D,P)}intersectRanges(C){return L.intersectRanges(this,C)}static intersectRanges(C,n){let k=C.startLineNumber,_=C.startColumn,D=C.endLineNumber,P=C.endColumn,I=n.startLineNumber,c=n.startColumn,v=n.endLineNumber,h=n.endColumn;return k<I?(k=I,_=c):k===I&&(_=Math.max(_,c)),D>v?(D=v,P=h):D===v&&(P=Math.min(P,h)),k>D||k===D&&_>P?null:new L(k,_,D,P)}equalsRange(C){return L.equalsRange(this,C)}static equalsRange(C,n){return!!C&&!!n&&C.startLineNumber===n.startLineNumber&&C.startColumn===n.startColumn&&C.endLineNumber===n.endLineNumber&&C.endColumn===n.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(C){return new g.Position(C.endLineNumber,C.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(C){return new g.Position(C.startLineNumber,C.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(C,n){return new L(this.startLineNumber,this.startColumn,C,n)}setStartPosition(C,n){return new L(C,n,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(C){return new L(C.startLineNumber,C.startColumn,C.startLineNumber,C.startColumn)}static fromPositions(C,n=C){return new L(C.lineNumber,C.column,n.lineNumber,n.column)}static lift(C){return C?new L(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn):null}static isIRange(C){return C&&typeof C.startLineNumber=="number"&&typeof C.startColumn=="number"&&typeof C.endLineNumber=="number"&&typeof C.endColumn=="number"}static areIntersectingOrTouching(C,n){return!(C.endLineNumber<n.startLineNumber||C.endLineNumber===n.startLineNumber&&C.endColumn<n.startColumn||n.endLineNumber<C.startLineNumber||n.endLineNumber===C.startLineNumber&&n.endColumn<C.startColumn)}static areIntersecting(C,n){return!(C.endLineNumber<n.startLineNumber||C.endLineNumber===n.startLineNumber&&C.endColumn<=n.startColumn||n.endLineNumber<C.startLineNumber||n.endLineNumber===C.startLineNumber&&n.endColumn<=C.startColumn)}static compareRangesUsingStarts(C,n){if(C&&n){const D=C.startLineNumber|0,P=n.startLineNumber|0;if(D===P){const I=C.startColumn|0,c=n.startColumn|0;if(I===c){const v=C.endLineNumber|0,h=n.endLineNumber|0;if(v===h){const w=C.endColumn|0,E=n.endColumn|0;return w-E}return v-h}return I-c}return D-P}return(C?1:0)-(n?1:0)}static compareRangesUsingEnds(C,n){return C.endLineNumber===n.endLineNumber?C.endColumn===n.endColumn?C.startLineNumber===n.startLineNumber?C.startColumn-n.startColumn:C.startLineNumber-n.startLineNumber:C.endColumn-n.endColumn:C.endLineNumber-n.endLineNumber}static spansMultipleLines(C){return C.endLineNumber>C.startLineNumber}}e.Range=L}),define(fe[145],me([0,1,51,42]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var y;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(y=e.SelectionDirection||(e.SelectionDirection={}));class C extends L.Range{constructor(k,_,D,P){super(k,_,D,P);this.selectionStartLineNumber=k,this.selectionStartColumn=_,this.positionLineNumber=D,this.positionColumn=P}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return C.selectionsEqual(this,k)}static selectionsEqual(k,_){return k.selectionStartLineNumber===_.selectionStartLineNumber&&k.selectionStartColumn===_.selectionStartColumn&&k.positionLineNumber===_.positionLineNumber&&k.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,_){return this.getDirection()===0?new C(this.startLineNumber,this.startColumn,k,_):new C(k,_,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new g.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(k,_){return this.getDirection()===0?new C(k,_,this.endLineNumber,this.endColumn):new C(this.endLineNumber,this.endColumn,k,_)}static fromPositions(k,_=k){return new C(k.lineNumber,k.column,_.lineNumber,_.column)}static fromRange(k,_){return _===0?new C(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):new C(k.endLineNumber,k.endColumn,k.startLineNumber,k.startColumn)}static liftSelection(k){return new C(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,_){if(k&&!_||!k&&_)return!1;if(!k&&!_)return!0;if(k.length!==_.length)return!1;for(let D=0,P=k.length;D<P;D++)if(!this.selectionsEqual(k[D],_[D]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,_,D,P,I){return I===0?new C(k,_,D,P):new C(D,P,k,_)}}e.Selection=C}),define(fe[109],me([0,1,25]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var y;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(y=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var n;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(n=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class _{constructor(o){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,o.tabSize|0),this.indentSize=o.tabSize|0,this.insertSpaces=Boolean(o.insertSpaces),this.defaultEOL=o.defaultEOL|0,this.trimAutoWhitespace=Boolean(o.trimAutoWhitespace),this.bracketPairColorizationOptions=o.bracketPairColorizationOptions}equals(o){return this.tabSize===o.tabSize&&this.indentSize===o.indentSize&&this.insertSpaces===o.insertSpaces&&this.defaultEOL===o.defaultEOL&&this.trimAutoWhitespace===o.trimAutoWhitespace&&(0,g.equals)(this.bracketPairColorizationOptions,o.bracketPairColorizationOptions)}createChangeEvent(o){return{tabSize:this.tabSize!==o.tabSize,indentSize:this.indentSize!==o.indentSize,insertSpaces:this.insertSpaces!==o.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==o.trimAutoWhitespace}}}e.TextModelResolvedOptions=_;class D{constructor(o,s){this._findMatchBrand=void 0,this.range=o,this.matches=s}}e.FindMatch=D;var P;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var I;(function(b){b[b.Disabled=0]="Disabled",b[b.EnabledForActive=1]="EnabledForActive",b[b.Enabled=2]="Enabled"})(I=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class c{constructor(o,s,p){this.visibleColumn=o,this.className=s,this.horizontalLine=p}}e.IndentGuide=c;class v{constructor(o,s){this.top=o,this.endColumn=s}}e.IndentGuideHorizontalLine=v;var h;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None"})(h=e.PositionAffinity||(e.PositionAffinity={}));var w;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w=e.ModelConstants||(e.ModelConstants={}));class E{constructor(o,s,p,r,m,i){this.identifier=o,this.range=s,this.text=p,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=m,this._isTracked=i}}e.ValidAnnotatedEditOperation=E;class T{constructor(o,s,p){this.reverseEdits=o,this.changes=s,this.trimAutoWhitespaceLineNumbers=p}}e.ApplyEditsResult=T}),define(fe[146],me([0,1,8,144,51,42,109]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class _{constructor(o,s,p,r){this.searchString=o,this.isRegex=s,this.matchCase=p,this.wordSeparators=r}parseSearchRequest(){if(this.searchString==="")return null;let o;this.isRegex?o=D(this.searchString):o=this.searchString.indexOf(`
`)>=0;let s=null;try{s=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:o,global:!0,unicode:!0})}catch(r){return null}if(!s)return null;let p=!this.isRegex&&!o;return p&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(p=this.matchCase),new P(s,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,p?this.searchString:null)}}e.SearchParams=_;function D(b){if(!b||b.length===0)return!1;for(let o=0,s=b.length;o<s;o++)if(b.charCodeAt(o)===92){if(o++,o>=s)break;const r=b.charCodeAt(o);if(r===110||r===114||r===87)return!0}return!1}e.isMultilineRegexSource=D;class P{constructor(o,s,p){this.regex=o,this.wordSeparators=s,this.simpleSearch=p}}e.SearchData=P;function I(b,o,s){if(!s)return new n.FindMatch(b,null);let p=[];for(let r=0,m=o.length;r<m;r++)p[r]=o[r];return new n.FindMatch(b,p)}e.createFindMatch=I;class c{constructor(o){let s=[],p=0;for(let r=0,m=o.length;r<m;r++)o.charCodeAt(r)===10&&(s[p++]=r);this._lineFeedsOffsets=s}findLineFeedCountBeforeOffset(o){const s=this._lineFeedsOffsets;let p=0,r=s.length-1;if(r===-1||o<=s[0])return 0;for(;p<r;){const m=p+((r-p)/2>>0);s[m]>=o?r=m-1:s[m+1]>=o?(p=m,r=m):p=m+1}return p+1}}class v{static findMatches(o,s,p,r,m){const i=s.parseSearchRequest();return i?i.regex.multiline?this._doFindMatchesMultiline(o,p,new T(i.wordSeparators,i.regex),r,m):this._doFindMatchesLineByLine(o,p,i,r,m):[]}static _getMultilineMatchRange(o,s,p,r,m,i){let t,u=0;r?(u=r.findLineFeedCountBeforeOffset(m),t=s+m+u):t=s+m;let a;if(r){let S=r.findLineFeedCountBeforeOffset(m+i.length)-u;a=t+i.length+S}else a=t+i.length;const l=o.getPositionAt(t),f=o.getPositionAt(a);return new C.Range(l.lineNumber,l.column,f.lineNumber,f.column)}static _doFindMatchesMultiline(o,s,p,r,m){const i=o.getOffsetAt(s.getStartPosition()),t=o.getValueInRange(s,1),u=o.getEOL()===`\r
`?new c(t):null,a=[];let l=0,f;for(p.reset(0);f=p.next(t);)if(a[l++]=I(this._getMultilineMatchRange(o,i,t,u,f.index,f[0]),f,r),l>=m)return a;return a}static _doFindMatchesLineByLine(o,s,p,r,m){const i=[];let t=0;if(s.startLineNumber===s.endLineNumber){const a=o.getLineContent(s.startLineNumber).substring(s.startColumn-1,s.endColumn-1);return t=this._findMatchesInLine(p,a,s.startLineNumber,s.startColumn-1,t,i,r,m),i}const u=o.getLineContent(s.startLineNumber).substring(s.startColumn-1);t=this._findMatchesInLine(p,u,s.startLineNumber,s.startColumn-1,t,i,r,m);for(let a=s.startLineNumber+1;a<s.endLineNumber&&t<m;a++)t=this._findMatchesInLine(p,o.getLineContent(a),a,0,t,i,r,m);if(t<m){const a=o.getLineContent(s.endLineNumber).substring(0,s.endColumn-1);t=this._findMatchesInLine(p,a,s.endLineNumber,0,t,i,r,m)}return i}static _findMatchesInLine(o,s,p,r,m,i,t,u){const a=o.wordSeparators;if(!t&&o.simpleSearch){const d=o.simpleSearch,S=d.length,A=s.length;let R=-S;for(;(R=s.indexOf(d,R+S))!==-1;)if((!a||E(a,s,A,R,S))&&(i[m++]=new n.FindMatch(new C.Range(p,R+1+r,p,R+1+S+r),null),m>=u))return m;return m}const l=new T(o.wordSeparators,o.regex);let f;l.reset(0);do if(f=l.next(s),f&&(i[m++]=I(new C.Range(p,f.index+1+r,p,f.index+1+f[0].length+r),f,t),m>=u))return m;while(f);return m}static findNextMatch(o,s,p,r){const m=s.parseSearchRequest();if(!m)return null;const i=new T(m.wordSeparators,m.regex);return m.regex.multiline?this._doFindNextMatchMultiline(o,p,i,r):this._doFindNextMatchLineByLine(o,p,i,r)}static _doFindNextMatchMultiline(o,s,p,r){const m=new y.Position(s.lineNumber,1),i=o.getOffsetAt(m),t=o.getLineCount(),u=o.getValueInRange(new C.Range(m.lineNumber,m.column,t,o.getLineMaxColumn(t)),1),a=o.getEOL()===`\r
`?new c(u):null;p.reset(s.column-1);let l=p.next(u);return l?I(this._getMultilineMatchRange(o,i,u,a,l.index,l[0]),l,r):s.lineNumber!==1||s.column!==1?this._doFindNextMatchMultiline(o,new y.Position(1,1),p,r):null}static _doFindNextMatchLineByLine(o,s,p,r){const m=o.getLineCount(),i=s.lineNumber,t=o.getLineContent(i),u=this._findFirstMatchInLine(p,t,i,s.column,r);if(u)return u;for(let a=1;a<=m;a++){const l=(i+a-1)%m,f=o.getLineContent(l+1),d=this._findFirstMatchInLine(p,f,l+1,1,r);if(d)return d}return null}static _findFirstMatchInLine(o,s,p,r,m){o.reset(r-1);const i=o.next(s);return i?I(new C.Range(p,i.index+1,p,i.index+1+i[0].length),i,m):null}static findPreviousMatch(o,s,p,r){const m=s.parseSearchRequest();if(!m)return null;const i=new T(m.wordSeparators,m.regex);return m.regex.multiline?this._doFindPreviousMatchMultiline(o,p,i,r):this._doFindPreviousMatchLineByLine(o,p,i,r)}static _doFindPreviousMatchMultiline(o,s,p,r){const m=this._doFindMatchesMultiline(o,new C.Range(1,1,s.lineNumber,s.column),p,r,10*k);if(m.length>0)return m[m.length-1];const i=o.getLineCount();return s.lineNumber!==i||s.column!==o.getLineMaxColumn(i)?this._doFindPreviousMatchMultiline(o,new y.Position(i,o.getLineMaxColumn(i)),p,r):null}static _doFindPreviousMatchLineByLine(o,s,p,r){const m=o.getLineCount(),i=s.lineNumber,t=o.getLineContent(i).substring(0,s.column-1),u=this._findLastMatchInLine(p,t,i,r);if(u)return u;for(let a=1;a<=m;a++){const l=(m+i-a-1)%m,f=o.getLineContent(l+1),d=this._findLastMatchInLine(p,f,l+1,r);if(d)return d}return null}static _findLastMatchInLine(o,s,p,r){let m=null,i;for(o.reset(0);i=o.next(s);)m=I(new C.Range(p,i.index+1,p,i.index+1+i[0].length),i,r);return m}}e.TextModelSearch=v;function h(b,o,s,p,r){if(p===0)return!0;const m=o.charCodeAt(p-1);if(b.get(m)!==0||m===13||m===10)return!0;if(r>0){const i=o.charCodeAt(p);if(b.get(i)!==0)return!0}return!1}function w(b,o,s,p,r){if(p+r===s)return!0;const m=o.charCodeAt(p+r);if(b.get(m)!==0||m===13||m===10)return!0;if(r>0){const i=o.charCodeAt(p+r-1);if(b.get(i)!==0)return!0}return!1}function E(b,o,s,p,r){return h(b,o,s,p,r)&&w(b,o,s,p,r)}e.isValidMatch=E;class T{constructor(o,s){this._wordSeparators=o,this._searchRegex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(o){this._searchRegex.lastIndex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(o){const s=o.length;let p;do{if(this._prevMatchStartIndex+this._prevMatchLength===s||(p=this._searchRegex.exec(o),!p))return null;const r=p.index,m=p[0].length;if(r===this._prevMatchStartIndex&&m===this._prevMatchLength){if(m===0){g.getNextCodePoint(o,s,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=r,this._prevMatchLength=m,!this._wordSeparators||E(this._wordSeparators,o,s,r,m))return p}while(p);return null}}e.Searcher=T}),define(fe[110],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(k=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)k.indexOf(D)>=0||(_+="\\"+D);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=g();function L(k){let _=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)_=k;else{let D="g";k.ignoreCase&&(D+="i"),k.multiline&&(D+="m"),k.unicode&&(D+="u"),_=new RegExp(k.source,D)}return _.lastIndex=0,_}e.ensureValidWordDefinition=L;const y={maxLen:1e3,windowSize:15,timeBudget:150};function C(k,_,D,P,I=y){if(D.length>I.maxLen){let E=k-I.maxLen/2;return E<0?E=0:P+=E,D=D.substring(E,k+I.maxLen/2),C(k,_,D,P,I)}const c=Date.now(),v=k-1-P;let h=-1,w=null;for(let E=1;!(Date.now()-c>=I.timeBudget);E++){const T=v-I.windowSize*E;_.lastIndex=Math.max(0,T);const b=n(_,D,v,h);if(!b&&w||(w=b,T<=0))break;h=T}if(w){let E={word:w[0],startColumn:P+1+w.index,endColumn:P+1+w.index+w[0].length};return _.lastIndex=0,E}return null}e.getWordAtText=C;function n(k,_,D,P){let I;for(;I=k.exec(_);){const c=I.index||0;if(c<=D&&k.lastIndex>=D)return I;if(P>0&&c>P)return null}return null}}),define(fe[147],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class L{constructor(k){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let _=0,D=k.notIn.length;_<D;_++)switch(k.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=L;class y{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of k)C(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),C(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),C(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),C(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&C(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=y;function C(n,k,_){n.has(k)?n.get(k).push(_):n.set(k,[_])}}),define(fe[83],me([0,1,31,9]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function y(C,n,k,_){if(Array.isArray(C)){let D=0;for(const P of C){const I=y(P,n,k,_);if(I===10)return I;I>D&&(D=I)}return D}else{if(typeof C=="string")return _?C==="*"?5:C===k?10:0:0;if(C){const{language:D,pattern:P,scheme:I,hasAccessToAllModels:c}=C;if(!_&&!c)return 0;let v=0;if(I)if(I===n.scheme)v=10;else if(I==="*")v=5;else return 0;if(D)if(D===k)v=10;else if(D==="*")v=Math.max(v,5);else return 0;if(P){let h;if(typeof P=="string"?h=P:h={...P,base:(0,L.normalize)(P.base)},h===n.fsPath||(0,g.match)(h,n.fsPath))v=10;else return 0}return v}else return 0}}e.score=y}),define(fe[148],me([0,1,108]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var L;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class y{constructor(h,w,E){const T=new Uint8Array(h*w);for(let b=0,o=h*w;b<o;b++)T[b]=E;this._data=T,this.rows=h,this.cols=w}get(h,w){return this._data[h*this.cols+w]}set(h,w,E){this._data[h*this.cols+w]=E}}e.Uint8Matrix=y;class C{constructor(h){let w=0,E=0;for(let b=0,o=h.length;b<o;b++){let[s,p,r]=h[b];p>w&&(w=p),s>E&&(E=s),r>E&&(E=r)}w++,E++;let T=new y(E,w,0);for(let b=0,o=h.length;b<o;b++){let[s,p,r]=h[b];T.set(s,p,r)}this._states=T,this._maxCharCode=w}nextState(h,w){return w<0||w>=this._maxCharCode?0:this._states.get(h,w)}}e.StateMachine=C;let n=null;function k(){return n===null&&(n=new C([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),n}var _;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let D=null;function P(){if(D===null){D=new g.CharacterClassifier(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<v.length;w++)D.set(v.charCodeAt(w),1);const h=".,;";for(let w=0;w<h.length;w++)D.set(h.charCodeAt(w),2)}return D}class I{static _createLink(h,w,E,T,b){let o=b-1;do{const s=w.charCodeAt(o);if(h.get(s)!==2)break;o--}while(o>T);if(T>0){const s=w.charCodeAt(T-1),p=w.charCodeAt(o);(s===40&&p===41||s===91&&p===93||s===123&&p===125)&&o--}return{range:{startLineNumber:E,startColumn:T+1,endLineNumber:E,endColumn:o+2},url:w.substring(T,o+1)}}static computeLinks(h,w=k()){const E=P();let T=[];for(let b=1,o=h.getLineCount();b<=o;b++){const s=h.getLineContent(b),p=s.length;let r=0,m=0,i=0,t=1,u=!1,a=!1,l=!1,f=!1;for(;r<p;){let d=!1;const S=s.charCodeAt(r);if(t===13){let A;switch(S){case 40:u=!0,A=0;break;case 41:A=u?0:1;break;case 91:l=!0,a=!0,A=0;break;case 93:l=!1,A=a?0:1;break;case 123:f=!0,A=0;break;case 125:A=f?0:1;break;case 39:A=i===34||i===96?0:1;break;case 34:A=i===39||i===96?0:1;break;case 96:A=i===39||i===34?0:1;break;case 42:A=i===42?1:0;break;case 124:A=i===124?1:0;break;case 32:A=l?0:1;break;default:A=E.get(S)}A===1&&(T.push(I._createLink(E,s,b,m,r)),d=!0)}else if(t===12){let A;S===91?(a=!0,A=0):A=E.get(S),A===1?d=!0:t=13}else t=w.nextState(t,S),t===0&&(d=!0);d&&(t=1,u=!1,a=!1,f=!1,m=r+1,i=S),r++}t===13&&T.push(I._createLink(E,s,b,m,p))}return T}}e.LinkComputer=I;function c(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:I.computeLinks(v)}e.computeLinks=c}),define(fe[149],me([0,1,3,6]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class y{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(n){this._onDidChange.fire({changedLanguages:n,changedColorMap:!1})}register(n,k){return this._map.set(n,k),this.fire([n]),(0,L.toDisposable)(()=>{this._map.get(n)===k&&(this._map.delete(n),this.fire([n]))})}registerPromise(n,k){let _=null,D=!1;return this._promises.set(n,k.then(P=>{this._promises.delete(n),!(D||!P)&&(_=this.register(n,P))})),(0,L.toDisposable)(()=>{D=!0,_&&_.dispose()})}getPromise(n){const k=this.get(n);if(k)return Promise.resolve(k);const _=this._promises.get(n);return _?_.then(D=>this.get(n)):null}get(n){return this._map.get(n)||null}setColorMap(n){this._colorMap=n,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=y}),define(fe[111],me([0,1,22,12]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var y;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(y||(y={}));function C(I){for(let c=0,v=I.length;c<v;c+=4){const h=I[c+0],w=I[c+1],E=I[c+2],T=I[c+3];I[c+0]=T,I[c+1]=E,I[c+2]=w,I[c+3]=h}}function n(I){const c=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.isLittleEndian()||C(c),g.VSBuffer.wrap(c)}function k(I){const c=I.buffer;if(L.isLittleEndian()||C(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const v=new Uint8Array(c.byteLength);return v.set(c),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function _(I){const c=new Uint32Array(D(I));let v=0;if(c[v++]=I.id,I.type==="full")c[v++]=1,c[v++]=I.data.length,c.set(I.data,v),v+=I.data.length;else{c[v++]=2,c[v++]=I.deltas.length;for(const h of I.deltas)c[v++]=h.start,c[v++]=h.deleteCount,h.data?(c[v++]=h.data.length,c.set(h.data,v),v+=h.data.length):c[v++]=0}return n(c)}e.encodeSemanticTokensDto=_;function D(I){let c=0;if(c+=1+1,I.type==="full")c+=1+I.data.length;else{c+=1,c+=(1+1+1)*I.deltas.length;for(const v of I.deltas)v.data&&(c+=v.data.length)}return c}function P(I){const c=k(I);let v=0;const h=c[v++];if(c[v++]===1){const b=c[v++],o=c.subarray(v,v+b);return v+=b,{id:h,type:"full",data:o}}const E=c[v++];let T=[];for(let b=0;b<E;b++){const o=c[v++],s=c[v++],p=c[v++];let r;p>0&&(r=c.subarray(v,v+p),v+=p),T[b]={start:o,deleteCount:s,data:r}}return{id:h,type:"delta",deltas:T}}e.decodeSemanticTokensDto=P}),define(fe[112],me([0,1,15,99]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class y{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,D){_=(0,L.toUint32)(_);const P=this.values,I=this.prefixSum,c=D.length;return c===0?!1:(this.values=new Uint32Array(P.length+c),this.values.set(P.subarray(0,_),0),this.values.set(P.subarray(_),_+c),this.values.set(D,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(_,D){return _=(0,L.toUint32)(_),D=(0,L.toUint32)(D),this.values[_]===D?!1:(this.values[_]=D,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,D){_=(0,L.toUint32)(_),D=(0,L.toUint32)(D);const P=this.values,I=this.prefixSum;if(_>=P.length)return!1;let c=P.length-_;return D>=c&&(D=c),D===0?!1:(this.values=new Uint32Array(P.length-D),this.values.set(P.subarray(0,_),0),this.values.set(P.subarray(_+D),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(I.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(_){return _<0?0:(_=(0,L.toUint32)(_),this._getPrefixSum(_))}_getPrefixSum(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),_>=this.values.length&&(_=this.values.length-1);for(let P=D;P<=_;P++)this.prefixSum[P]=this.prefixSum[P-1]+this.values[P];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalSum();let D=0,P=this.values.length-1,I=0,c=0,v=0;for(;D<=P;)if(I=D+(P-D)/2|0,c=this.prefixSum[I],v=c-this.values[I],_<v)P=I-1;else if(_>=c)D=I+1;else break;return new n(I,_-v)}}e.PrefixSumComputer=y;class C{constructor(_){this._values=_,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(_){return this._ensureValid(),_===0?0:this._prefixSum[_-1]}getIndexOf(_){this._ensureValid();const D=this._indexBySum[_],P=D>0?this._prefixSum[D-1]:0;return new n(D,_-P)}removeValues(_,D){this._values.splice(_,D),this._invalidate(_)}insertValues(_,D){this._values=(0,g.arrayInsert)(this._values,_,D),this._invalidate(_)}_invalidate(_){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,_-1)}_ensureValid(){if(!this._isValid){for(let _=this._validEndIndex+1,D=this._values.length;_<D;_++){const P=this._values[_],I=_>0?this._prefixSum[_-1]:0;this._prefixSum[_]=I+P;for(let c=0;c<P;c++)this._indexBySum[I+c]=_}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(_,D){this._values[_]!==D&&(this._values[_]=D,this._invalidate(_))}}e.ConstantTimePrefixSumComputer=C;class n{constructor(_,D){this.index=_,this.remainder=D,this._prefixSumIndexOfResultBrand=void 0,this.index=_,this.remainder=D}}e.PrefixSumIndexOfResult=n}),define(fe[150],me([0,1,8,51,112]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class C{constructor(k,_,D,P){this._uri=k,this._lines=_,this._eol=D,this._versionId=P,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const _=k.changes;for(const D of _)this._acceptDeleteRange(D.range),this._acceptInsertText(new L.Position(D.range.startLineNumber,D.range.startColumn),D.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,_=this._lines.length,D=new Uint32Array(_);for(let P=0;P<_;P++)D[P]=this._lines[P].length+k;this._lineStarts=new y.PrefixSumComputer(D)}}_setLineText(k,_){this._lines[k]=_,this._lineStarts&&this._lineStarts.setValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,_){if(_.length===0)return;let D=(0,g.splitLines)(_);if(D.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+D[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}D[D.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+D[0]);let P=new Uint32Array(D.length-1);for(let I=1;I<D.length;I++)this._lines.splice(k.lineNumber+I-1,0,D[I]),P[I-1]=D[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,P)}}e.MirrorTextModel=C}),define(fe[151],me([19,20]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(fe[152],me([0,1,151]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,y=L*60,C=y*24,n=C*7,k=C*30,_=C*365;function D(I,c){typeof I!="number"&&(I=I.getTime());const v=Math.round((new Date().getTime()-I)/1e3);if(v<-30)return(0,g.localize)(0,null,D(new Date().getTime()+v*1e3,!1));if(v<30)return(0,g.localize)(1,null);let h;return v<L?(h=v,c?h===1?(0,g.localize)(2,null,h):(0,g.localize)(3,null,h):h===1?(0,g.localize)(4,null,h):(0,g.localize)(5,null,h)):v<y?(h=Math.floor(v/L),c?h===1?(0,g.localize)(6,null,h):(0,g.localize)(7,null,h):h===1?(0,g.localize)(8,null,h):(0,g.localize)(9,null,h)):v<C?(h=Math.floor(v/y),c?h===1?(0,g.localize)(10,null,h):(0,g.localize)(11,null,h):h===1?(0,g.localize)(12,null,h):(0,g.localize)(13,null,h)):v<n?(h=Math.floor(v/C),c?h===1?(0,g.localize)(14,null,h):(0,g.localize)(15,null,h):h===1?(0,g.localize)(16,null,h):(0,g.localize)(17,null,h)):v<k?(h=Math.floor(v/n),c?h===1?(0,g.localize)(18,null,h):(0,g.localize)(19,null,h):h===1?(0,g.localize)(20,null,h):(0,g.localize)(21,null,h)):v<_?(h=Math.floor(v/k),c?h===1?(0,g.localize)(22,null,h):(0,g.localize)(23,null,h):h===1?(0,g.localize)(24,null,h):(0,g.localize)(25,null,h)):(h=Math.floor(v/_),c?h===1?(0,g.localize)(26,null,h):(0,g.localize)(27,null,h):h===1?(0,g.localize)(28,null,h):(0,g.localize)(29,null,h))}e.fromNow=D;function P(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(fe[153],me([19,20]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(fe[52],me([0,1,15,13,153]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function C(D,P){return P&&(D.stack||D.stacktrace)?y.localize(0,null,k(D),n(D.stack)||n(D.stacktrace)):k(D)}function n(D){return Array.isArray(D)?D.join(`
`):D}function k(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?y.localize(1,null,D.message):D.message||y.localize(2,null)}function _(D=null,P=!1){if(!D)return y.localize(3,null);if(Array.isArray(D)){const I=g.coalesce(D),c=_(I[0],P);return I.length>1?y.localize(4,null,c,I.length):c}if(L.isString(D))return D;if(D.detail){const I=D.detail;if(I.error)return C(I.error,P);if(I.exception)return C(I.exception,P)}return D.stack?C(D,P):D.message?D.message:y.localize(5,null)}e.toErrorMessage=_}),define(fe[154],me([19,20]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(fe[113],me([0,1,39,30,10,25,9,12,38,95,13,143,28,154]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(r,m){if(k.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};m&&(i.cwd=m);const t=g.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(u=>{t.once("error",a=>{u({success:!1,error:a})}),t.once("exit",(a,l)=>{u(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?h(i.status):1})}else if(k.isLinux||k.isMacintosh)try{const i=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{g.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(u,a,l)=>{t(u?{success:!1,error:u}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function E(r){!r||(delete r.DEBUG,k.isMacintosh&&delete r.DYLD_LIBRARY_PATH,k.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=E;function T(r=_.env){return r.comspec||"cmd.exe"}e.getWindowsShell=T;class b{constructor(m,i,t,u){if(i!==void 0&&t!==void 0&&u!==void 0)this.cmd=m,this.args=i,this.shell=t,this.options=u;else{const a=m;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(_.env).forEach(l=>{a[l]=_.env[l]}),Object.keys(this.options.env).forEach(l=>{a[l]=this.options.env[l]}),this.options.env=a}}getSanitizedCommand(){let m=this.cmd.toLowerCase();const i=m.lastIndexOf(n.sep);return i!==-1&&(m=m.substring(i+1)),b.WellKnowCommands[m]?m:"other"}start(m){return k.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(_.cwd()))?Promise.reject(new Error(v.localize(0,null))):this.useExec().then(i=>{let t,u;const a=new Promise((l,f)=>{t=l,u=f});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=g.exec(l,this.options,(f,d,S)=>{this.childProcess=null;const A=f;A&&A.killed?u({killed:this.terminateRequested,stdout:d.toString(),stderr:S.toString()}):this.handleExec(t,m,f,d,S)})}else{let l=null;const f=d=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(d,t,m,u);const S={terminated:this.terminateRequested};P.isNumber(d)&&(S.cmdCode=d),t(S)};if(this.shell&&k.isWindows){const d=C.deepClone(this.options);d.windowsVerbatimArguments=!0,d.detached=!1;let S=!1,A=!1;const R=[];let B=this.ensureQuotes(this.cmd);R.push(B.value),S=B.quoted,this.args&&this.args.forEach(F=>{B=this.ensureQuotes(F),R.push(B.value),A=A&&B.quoted});const x=["/s","/c"];S?A?x.push('"'+R.join(" ")+'"'):R.length>1?x.push('"'+R[0]+'" '+R.slice(1).join(" ")):x.push('"'+R[0]+'"'):x.push(R.join(" ")),l=g.spawn(T(),x,d)}else this.cmd&&(l=g.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(P.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",d=>{this.childProcess=null,u({terminated:this.terminateRequested,error:d})}),l.pid&&(this.childProcess.on("close",f),this.handleSpawn(l,t,m,u,!0)))}return a})}handleClose(m,i,t,u){}ensureQuotes(m){return b.regexp.test(m)?{value:'"'+m+'"',quoted:!0}:{value:m,quoted:m.length>0&&m[0]==='"'&&m[m.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(m=>m.pid,m=>-1):new Promise(m=>{this.pidResolve=m})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(m=>(this.terminateRequested=!0,w(m,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),m=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(m=>{if(!this.shell||!k.isWindows)return m(!1);const i=g.spawn(T(),["/s","/c"]);i.on("error",t=>m(!0)),i.on("exit",t=>m(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class o extends b{constructor(m,i,t,u){super(m,i,t,u);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(m,i,t,u,a){[u,a].forEach((l,f)=>{const d=new I.LineDecoder;d.write(l).forEach(R=>{i({line:R,source:f===0?0:1})});const A=d.end();A&&i({line:A,source:f===0?0:1})}),m({terminated:this.terminateRequested,error:t})}handleSpawn(m,i,t,u,a){const l=new I.LineDecoder,f=new I.LineDecoder;m.stdout.on("data",d=>{l.write(d).forEach(A=>t({line:A,source:0}))}),m.stderr.on("data",d=>{f.write(d).forEach(A=>t({line:A,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=f}handleClose(m,i,t,u){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&t({line:a,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&t({line:l,source:1})}}e.LineProcess=o;function s(r){let m=[],i=!1;const t=function(u){if(i){m.push(u);return}(!r.send(u,l=>{if(l&&console.error(l),i=!1,m.length>0){const f=m.slice(0);m=[],f.forEach(d=>t(d))}})||k.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=s;var p;(function(r){async function m(i,t,u){if(n.isAbsolute(i))return i;if(t===void 0&&(t=_.cwd()),n.dirname(i)!=="."||(u===void 0&&P.isString(_.env.PATH)&&(u=_.env.PATH.split(n.delimiter)),u===void 0||u.length===0))return n.join(t,i);async function l(f){if(await c.Promises.exists(f)){let d;try{d=await c.Promises.stat(f)}catch(S){S.message.startsWith("EACCES")&&(d=await c.Promises.lstat(f))}return d?!d.isDirectory():!1}return!1}for(let f of u){let d;if(n.isAbsolute(f)?d=n.join(f,i):d=n.join(t,f,i),await l(d))return d;let S=d+".com";if(await l(S)||(S=d+".exe",await l(S)))return S}return n.join(t,i)}r.findExecutable=m})(p=e.win32||(e.win32={}))}),define(fe[155],me([19,20]),function(Y,e){return Y.create("vs/editor/common/config/editorOptions",e)}),define(fe[114],me([0,1,155,12,110]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var C;(function(J){J[J.None=0]="None",J[J.Keep=1]="Keep",J[J.Brackets=2]="Brackets",J[J.Advanced=3]="Advanced",J[J.Full=4]="Full"})(C=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class n{constructor(ie){this._values=ie}hasChanged(ie){return this._values[ie]}}e.ConfigurationChangedEvent=n;class k{constructor(){this._values=[]}_read(ie){return this._values[ie]}get(ie){return this._values[ie]}_write(ie,_e){this._values[ie]=_e}}e.ValidatedEditorOptions=k;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class D{constructor(ie,_e,Qe,et){this.id=ie,this.name=_e,this.defaultValue=Qe,this.schema=et}compute(ie,_e,Qe){return Qe}}class P{constructor(ie,_e=null){this.schema=void 0,this.id=ie,this.name="_never_",this.defaultValue=void 0,this.deps=_e}validate(ie){return this.defaultValue}}class I{constructor(ie,_e,Qe,et){this.id=ie,this.name=_e,this.defaultValue=Qe,this.schema=et}validate(ie){return typeof ie=="undefined"?this.defaultValue:ie}compute(ie,_e,Qe){return Qe}}function c(J,ie){return typeof J=="undefined"?ie:J==="false"?!1:Boolean(J)}e.boolean=c;class v extends I{constructor(ie,_e,Qe,et=void 0){typeof et!="undefined"&&(et.type="boolean",et.default=Qe),super(ie,_e,Qe,et)}validate(ie){return c(ie,this.defaultValue)}}function h(J,ie,_e,Qe){if(typeof J=="undefined")return ie;let et=parseInt(J,10);return isNaN(et)?ie:(et=Math.max(_e,et),et=Math.min(Qe,et),et|0)}e.clampedInt=h;class w extends I{constructor(ie,_e,Qe,et,ce,Ie=void 0){typeof Ie!="undefined"&&(Ie.type="integer",Ie.default=Qe,Ie.minimum=et,Ie.maximum=ce),super(ie,_e,Qe,Ie),this.minimum=et,this.maximum=ce}static clampedInt(ie,_e,Qe,et){return h(ie,_e,Qe,et)}validate(ie){return w.clampedInt(ie,this.defaultValue,this.minimum,this.maximum)}}class E extends I{constructor(ie,_e,Qe,et,ce){typeof ce!="undefined"&&(ce.type="number",ce.default=Qe),super(ie,_e,Qe,ce),this.validationFn=et}static clamp(ie,_e,Qe){return ie<_e?_e:ie>Qe?Qe:ie}static float(ie,_e){if(typeof ie=="number")return ie;if(typeof ie=="undefined")return _e;const Qe=parseFloat(ie);return isNaN(Qe)?_e:Qe}validate(ie){return this.validationFn(E.float(ie,this.defaultValue))}}class T extends I{static string(ie,_e){return typeof ie!="string"?_e:ie}constructor(ie,_e,Qe,et=void 0){typeof et!="undefined"&&(et.type="string",et.default=Qe),super(ie,_e,Qe,et)}validate(ie){return T.string(ie,this.defaultValue)}}function b(J,ie,_e){return typeof J!="string"||_e.indexOf(J)===-1?ie:J}e.stringSet=b;class o extends I{constructor(ie,_e,Qe,et,ce=void 0){typeof ce!="undefined"&&(ce.type="string",ce.enum=et,ce.default=Qe),super(ie,_e,Qe,ce),this._allowedValues=et}validate(ie){return b(ie,this.defaultValue,this._allowedValues)}}class s extends D{constructor(ie,_e,Qe,et,ce,Ie,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.enum=ce,Ne.default=et),super(ie,_e,Qe,Ne),this._allowedValues=ce,this._convert=Ie}validate(ie){return typeof ie!="string"?this.defaultValue:this._allowedValues.indexOf(ie)===-1?this.defaultValue:this._convert(ie)}}function p(J){switch(J){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ie){switch(ie){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ie,_e,Qe){return Qe===0?ie.accessibilitySupport:Qe}}class m extends D{constructor(){const ie={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",ie,{"editor.comments.insertSpace":{type:"boolean",default:ie.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ie.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertSpace:c(_e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(_e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(J){J[J.Hidden=0]="Hidden",J[J.Blink=1]="Blink",J[J.Smooth=2]="Smooth",J[J.Phase=3]="Phase",J[J.Expand=4]="Expand",J[J.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t(J){switch(J){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(J){J[J.Line=1]="Line",J[J.Block=2]="Block",J[J.Underline=3]="Underline",J[J.LineThin=4]="LineThin",J[J.BlockOutline=5]="BlockOutline",J[J.UnderlineThin=6]="UnderlineThin"})(u=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(J){switch(J){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function l(J){switch(J){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class f extends P{constructor(){super(126,[65,33])}compute(ie,_e,Qe){const et=["monaco-editor"];return _e.get(33)&&et.push(_e.get(33)),ie.extraEditorClassName&&et.push(ie.extraEditorClassName),_e.get(65)==="default"?et.push("mouse-default"):_e.get(65)==="copy"&&et.push("mouse-copy"),_e.get(99)&&et.push("showUnused"),_e.get(124)&&et.push("showDeprecated"),et.join(" ")}}class d extends v{constructor(){super(32,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ie,_e,Qe){return Qe&&ie.emptySelectionClipboard}}class S extends D{constructor(){const ie={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",ie,{"editor.find.cursorMoveOnType":{type:"boolean",default:ie.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ie.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ie.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ie.globalFindClipboard,description:g.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ie.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:ie.loop,description:g.localize(18,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{cursorMoveOnType:c(_e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ie.seedSearchStringFromSelection=="boolean"?ie.seedSearchStringFromSelection?"always":"never":b(_e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ie.autoFindInSelection=="boolean"?ie.autoFindInSelection?"always":"never":b(_e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(_e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(_e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(_e.loop,this.defaultValue.loop)}}}class A extends D{constructor(){super(44,"fontLigatures",A.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(ie){return typeof ie=="undefined"?this.defaultValue:typeof ie=="string"?ie==="false"?A.OFF:ie==="true"?A.ON:ie:Boolean(ie)?A.ON:A.OFF}}e.EditorFontLigatures=A,A.OFF='"liga" off, "calt" off',A.ON='"liga" on, "calt" on';class R extends P{constructor(){super(43)}compute(ie,_e,Qe){return ie.fontInfo}}class B extends I{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(22,null)})}validate(ie){let _e=E.float(ie,this.defaultValue);return _e===0?e.EDITOR_FONT_DEFAULTS.fontSize:E.clamp(_e,6,100)}compute(ie,_e,Qe){return ie.fontInfo.fontSize}}class x extends D{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:g.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(24,null)})}validate(ie){return ie==="normal"||ie==="bold"?ie:String(w.clampedInt(ie,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class F extends D{constructor(){const ie={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},_e={type:"string",enum:["peek","gotoAndPeek","goto"],default:ie.multiple,enumDescriptions:[g.localize(25,null),g.localize(26,null),g.localize(27,null)]},Qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",ie,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(29,null),..._e},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(30,null),..._e},"editor.gotoLocation.multipleDeclarations":{description:g.localize(31,null),..._e},"editor.gotoLocation.multipleImplementations":{description:g.localize(32,null),..._e},"editor.gotoLocation.multipleReferences":{description:g.localize(33,null),..._e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ie.alternativeDefinitionCommand,enum:Qe,description:g.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ie.alternativeTypeDefinitionCommand,enum:Qe,description:g.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ie.alternativeDeclarationCommand,enum:Qe,description:g.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ie.alternativeImplementationCommand,enum:Qe,description:g.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ie.alternativeReferenceCommand,enum:Qe,description:g.localize(38,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{multiple:b(_e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:_e.multipleDefinitions??b(_e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:_e.multipleTypeDefinitions??b(_e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:_e.multipleDeclarations??b(_e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:_e.multipleImplementations??b(_e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:_e.multipleReferences??b(_e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:T.string(_e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:T.string(_e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:T.string(_e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:T.string(_e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:T.string(_e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends D{constructor(){const ie={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",ie,{"editor.hover.enabled":{type:"boolean",default:ie.enabled,description:g.localize(39,null)},"editor.hover.delay":{type:"number",default:ie.delay,description:g.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:ie.sticky,description:g.localize(41,null)},"editor.hover.above":{type:"boolean",default:ie.above,description:g.localize(42,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:c(_e.enabled,this.defaultValue.enabled),delay:w.clampedInt(_e.delay,this.defaultValue.delay,0,1e4),sticky:c(_e.sticky,this.defaultValue.sticky),above:c(_e.above,this.defaultValue.above)}}}var M;(function(J){J[J.None=0]="None",J[J.Text=1]="Text",J[J.Blocks=2]="Blocks"})(M=e.RenderMinimap||(e.RenderMinimap={}));class H extends P{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(ie,_e,Qe){return H.computeLayout(_e,{memory:ie.memory,outerWidth:ie.outerWidth,outerHeight:ie.outerHeight,isDominatedByLongLines:ie.isDominatedByLongLines,lineHeight:ie.fontInfo.lineHeight,viewLineCount:ie.viewLineCount,lineNumbersDigitCount:ie.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ie.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ie.fontInfo.maxDigitWidth,pixelRatio:ie.pixelRatio})}static computeContainedMinimapLineCount(ie){const _e=ie.height/ie.lineHeight,Qe=ie.scrollBeyondLastLine?_e-1:0,et=(ie.viewLineCount+Qe)/(ie.pixelRatio*ie.height),ce=Math.floor(ie.viewLineCount/et);return{typicalViewportLineCount:_e,extraLinesBeyondLastLine:Qe,desiredRatio:et,minimapLineCount:ce}}static _computeMinimapLayout(ie,_e){const Qe=ie.outerWidth,et=ie.outerHeight,ce=ie.pixelRatio;if(!ie.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ce*et),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:et};const Ie=_e.stableMinimapLayoutInput,Ne=Ie&&ie.outerHeight===Ie.outerHeight&&ie.lineHeight===Ie.lineHeight&&ie.typicalHalfwidthCharacterWidth===Ie.typicalHalfwidthCharacterWidth&&ie.pixelRatio===Ie.pixelRatio&&ie.scrollBeyondLastLine===Ie.scrollBeyondLastLine&&ie.minimap.enabled===Ie.minimap.enabled&&ie.minimap.side===Ie.minimap.side&&ie.minimap.size===Ie.minimap.size&&ie.minimap.showSlider===Ie.minimap.showSlider&&ie.minimap.renderCharacters===Ie.minimap.renderCharacters&&ie.minimap.maxColumn===Ie.minimap.maxColumn&&ie.minimap.scale===Ie.minimap.scale&&ie.verticalScrollbarWidth===Ie.verticalScrollbarWidth&&ie.isViewportWrapping===Ie.isViewportWrapping,Xe=ie.lineHeight,it=ie.typicalHalfwidthCharacterWidth,ft=ie.scrollBeyondLastLine,tt=ie.minimap.renderCharacters;let ut=ce>=2?Math.round(ie.minimap.scale*2):ie.minimap.scale;const Re=ie.minimap.maxColumn,ve=ie.minimap.size,Te=ie.minimap.side,se=ie.verticalScrollbarWidth,ue=ie.viewLineCount,be=ie.remainingWidth,we=ie.isViewportWrapping,Fe=tt?2:3;let qe=Math.floor(ce*et);const ze=qe/ce;let Ye=!1,ct=!1,xe=Fe*ut,ge=ut/ce,Ee=1;if(ve==="fill"||ve==="fit"){const{typicalViewportLineCount:mt,extraLinesBeyondLastLine:Ct,desiredRatio:Et,minimapLineCount:gt}=H.computeContainedMinimapLineCount({viewLineCount:ue,scrollBeyondLastLine:ft,height:et,lineHeight:Xe,pixelRatio:ce});if(ue/gt>1)Ye=!0,ct=!0,ut=1,xe=1,ge=ut/ce;else{let vt=!1,Tt=ut+1;if(ve==="fit"){const yt=Math.ceil((ue+Ct)*xe);we&&Ne&&be<=_e.stableFitRemainingWidth?(vt=!0,Tt=_e.stableFitMaxMinimapScale):vt=yt>qe}if(ve==="fill"||vt){Ye=!0;const yt=ut;xe=Math.min(Xe*ce,Math.max(1,Math.floor(1/Et))),we&&Ne&&be<=_e.stableFitRemainingWidth&&(Tt=_e.stableFitMaxMinimapScale),ut=Math.min(Tt,Math.max(1,Math.floor(xe/Fe))),ut>yt&&(Ee=Math.min(2,ut/yt)),ge=ut/ce/Ee,qe=Math.ceil(Math.max(mt,ue+Ct)*xe),we?(_e.stableMinimapLayoutInput=ie,_e.stableFitRemainingWidth=be,_e.stableFitMaxMinimapScale=ut):(_e.stableMinimapLayoutInput=null,_e.stableFitRemainingWidth=0)}}}const ae=Math.floor(Re*ge),K=Math.min(ae,Math.max(0,Math.floor((be-se-2)*ge/(it+ge)))+e.MINIMAP_GUTTER_WIDTH);let Ce=Math.floor(ce*K);const Le=Ce/ce;Ce=Math.floor(Ce*Ee);const nt=tt?1:2,Ge=Te==="left"?0:Qe-K-se;return{renderMinimap:nt,minimapLeft:Ge,minimapWidth:K,minimapHeightIsEditorHeight:Ye,minimapIsSampling:ct,minimapScale:ut,minimapLineHeight:xe,minimapCanvasInnerWidth:Ce,minimapCanvasInnerHeight:qe,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:ze}}static computeLayout(ie,_e){const Qe=_e.outerWidth|0,et=_e.outerHeight|0,ce=_e.lineHeight|0,Ie=_e.lineNumbersDigitCount|0,Ne=_e.typicalHalfwidthCharacterWidth,Xe=_e.maxDigitWidth,it=_e.pixelRatio,ft=_e.viewLineCount,tt=ie.get(121),ut=tt==="inherit"?ie.get(120):tt,Re=ut==="inherit"?ie.get(116):ut,ve=ie.get(119),Te=ie.get(2),se=_e.isDominatedByLongLines,ue=ie.get(49),be=ie.get(59).renderType!==0,we=ie.get(60),Fe=ie.get(93),qe=ie.get(64),ze=ie.get(91),Ye=ze.verticalScrollbarSize,ct=ze.verticalHasArrows,xe=ze.arrowSize,ge=ze.horizontalScrollbarSize,Ee=ie.get(57),ae=ie.get(37);let K;if(typeof Ee=="string"&&/^\d+(\.\d+)?ch$/.test(Ee)){const kt=parseFloat(Ee.substr(0,Ee.length-2));K=w.clampedInt(kt*Ne,0,0,1e3)}else K=w.clampedInt(Ee,0,0,1e3);ae&&(K+=16);let Ce=0;if(be){const kt=Math.max(Ie,we);Ce=Math.round(kt*Xe)}let Le=0;ue&&(Le=ce);let nt=0,Ge=nt+Le,mt=Ge+Ce,Ct=mt+K;const Et=Qe-Le-Ce-K;let gt=!1,bt=!1,vt=-1;Te!==2&&(ut==="inherit"&&se?(gt=!0,bt=!0):Re==="on"||Re==="bounded"?bt=!0:Re==="wordWrapColumn"&&(vt=ve));const Tt=H._computeMinimapLayout({outerWidth:Qe,outerHeight:et,lineHeight:ce,typicalHalfwidthCharacterWidth:Ne,pixelRatio:it,scrollBeyondLastLine:Fe,minimap:qe,verticalScrollbarWidth:Ye,viewLineCount:ft,remainingWidth:Et,isViewportWrapping:bt},_e.memory||new _);Tt.renderMinimap!==0&&Tt.minimapLeft===0&&(nt+=Tt.minimapWidth,Ge+=Tt.minimapWidth,mt+=Tt.minimapWidth,Ct+=Tt.minimapWidth);const yt=Et-Tt.minimapWidth,$t=Math.max(1,Math.floor((yt-Ye-2)/Ne)),jt=ct?xe:0;return bt&&(vt=Math.max(1,$t),Re==="bounded"&&(vt=Math.min(vt,ve))),{width:Qe,height:et,glyphMarginLeft:nt,glyphMarginWidth:Le,lineNumbersLeft:Ge,lineNumbersWidth:Ce,decorationsLeft:mt,decorationsWidth:K,contentLeft:Ct,contentWidth:yt,minimap:Tt,viewportColumn:$t,isWordWrapMinified:gt,isViewportWrapping:bt,wrappingColumn:vt,verticalScrollbarWidth:Ye,horizontalScrollbarHeight:ge,overviewRuler:{top:jt,width:Ye,height:et-2*jt,right:0}}}}e.EditorLayoutInfoComputer=H;class N extends D{constructor(){const ie={enabled:!0};super(56,"lightbulb",ie,{"editor.lightbulb.enabled":{type:"boolean",default:ie.enabled,description:g.localize(43,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:c(ie.enabled,this.defaultValue.enabled)}}}class U extends D{constructor(){const ie={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",ie,{"editor.inlayHints.enabled":{type:"boolean",default:ie.enabled,description:g.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:ie.fontSize,markdownDescription:g.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:ie.fontFamily,markdownDescription:g.localize(46,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:c(_e.enabled,this.defaultValue.enabled),fontSize:w.clampedInt(_e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:T.string(_e.fontFamily,this.defaultValue.fontFamily)}}}class V extends E{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ie=>E.clamp(ie,0,150),{markdownDescription:g.localize(47,null)})}compute(ie,_e,Qe){return ie.fontInfo.lineHeight}}class O extends D{constructor(){const ie={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",ie,{"editor.minimap.enabled":{type:"boolean",default:ie.enabled,description:g.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(49,null),g.localize(50,null),g.localize(51,null)],default:ie.size,description:g.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ie.side,description:g.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ie.showSlider,description:g.localize(54,null)},"editor.minimap.scale":{type:"number",default:ie.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ie.renderCharacters,description:g.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:ie.maxColumn,description:g.localize(57,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:c(_e.enabled,this.defaultValue.enabled),size:b(_e.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(_e.side,this.defaultValue.side,["right","left"]),showSlider:b(_e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(_e.renderCharacters,this.defaultValue.renderCharacters),scale:w.clampedInt(_e.scale,1,1,3),maxColumn:w.clampedInt(_e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function W(J){return J==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class j extends D{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(59,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{top:w.clampedInt(_e.top,0,0,1e3),bottom:w.clampedInt(_e.bottom,0,0,1e3)}}}class X extends D{constructor(){const ie={enabled:!0,cycle:!1};super(75,"parameterHints",ie,{"editor.parameterHints.enabled":{type:"boolean",default:ie.enabled,description:g.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:ie.cycle,description:g.localize(61,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:c(_e.enabled,this.defaultValue.enabled),cycle:c(_e.cycle,this.defaultValue.cycle)}}}class Q extends P{constructor(){super(127)}compute(ie,_e,Qe){return ie.pixelRatio}}class de extends D{constructor(){const ie={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",ie,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ie.strings,description:g.localize(62,null)},comments:{type:"boolean",default:ie.comments,description:g.localize(63,null)},other:{type:"boolean",default:ie.other,description:g.localize(64,null)}}}],default:ie,description:g.localize(65,null)});this.defaultValue=ie}validate(ie){if(typeof ie=="boolean")return ie;if(ie&&typeof ie=="object"){const _e=ie,Qe={other:c(_e.other,this.defaultValue.other),comments:c(_e.comments,this.defaultValue.comments),strings:c(_e.strings,this.defaultValue.strings)};return Qe.other&&Qe.comments&&Qe.strings?!0:!Qe.other&&!Qe.comments&&!Qe.strings?!1:Qe}return this.defaultValue}}var Se;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval",J[J.Custom=4]="Custom"})(Se=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class De extends D{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(66,null),g.localize(67,null),g.localize(68,null),g.localize(69,null)],default:"on",description:g.localize(70,null)})}validate(ie){let _e=this.defaultValue.renderType,Qe=this.defaultValue.renderFn;return typeof ie!="undefined"&&(typeof ie=="function"?(_e=4,Qe=ie):ie==="interval"?_e=3:ie==="relative"?_e=2:ie==="on"?_e=1:_e=0),{renderType:_e,renderFn:Qe}}}function Pe(J){const ie=J.get(86);return ie==="editable"?J.get(80):ie!=="on"}e.filterValidationDecorations=Pe;class Be extends D{constructor(){const ie=[],_e={type:"number",description:g.localize(71,null)};super(90,"rulers",ie,{type:"array",items:{anyOf:[_e,{type:["object"],properties:{column:_e,color:{type:"string",description:g.localize(72,null),format:"color-hex"}}}]},default:ie,description:g.localize(73,null)})}validate(ie){if(Array.isArray(ie)){let _e=[];for(let Qe of ie)if(typeof Qe=="number")_e.push({column:w.clampedInt(Qe,0,0,1e4),color:null});else if(Qe&&typeof Qe=="object"){const et=Qe;_e.push({column:w.clampedInt(et.column,0,0,1e4),color:et.color})}return _e.sort((Qe,et)=>Qe.column-et.column),_e}return this.defaultValue}}function We(J,ie){if(typeof J!="string")return ie;switch(J){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends D{constructor(){const ie={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",ie,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(74,null),g.localize(75,null),g.localize(76,null)],default:"auto",description:g.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(78,null),g.localize(79,null),g.localize(80,null)],default:"auto",description:g.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ie.verticalScrollbarSize,description:g.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ie.horizontalScrollbarSize,description:g.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ie.scrollByPage,description:g.localize(84,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie,Qe=w.clampedInt(_e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),et=w.clampedInt(_e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:w.clampedInt(_e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:We(_e.vertical,this.defaultValue.vertical),horizontal:We(_e.horizontal,this.defaultValue.horizontal),useShadows:c(_e.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(_e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(_e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(_e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(_e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Qe,horizontalSliderSize:w.clampedInt(_e.horizontalSliderSize,Qe,0,1e3),verticalScrollbarSize:et,verticalSliderSize:w.clampedInt(_e.verticalSliderSize,et,0,1e3),scrollByPage:c(_e.scrollByPage,this.defaultValue.scrollByPage)}}}class G extends D{constructor(){const ie={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",ie,{"editor.inlineSuggest.enabled":{type:"boolean",default:ie.enabled,description:g.localize(85,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{enabled:c(_e.enabled,this.defaultValue.enabled),mode:b(_e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class ee extends D{constructor(){const ie={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",ie,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ie.enabled,description:g.localize(86,null)}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{enabled:c(ie.enabled,this.defaultValue.enabled)}}}class ne extends D{constructor(){const ie={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",ie,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(87,null),g.localize(88,null),g.localize(89,null)],default:ie.bracketPairs,description:g.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(91,null),g.localize(92,null),g.localize(93,null)],default:ie.bracketPairsHorizontal,description:g.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ie.highlightActiveBracketPair,description:g.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:ie.indentation,description:g.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:ie.highlightActiveIndentation,description:g.localize(97,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{bracketPairs:le(_e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:le(_e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(_e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(_e.indentation,this.defaultValue.indentation),highlightActiveIndentation:c(_e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function le(J,ie,_e){const Qe=_e.indexOf(J);return Qe===-1?ie:_e[Qe]}class Z extends D{constructor(){const ie={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",ie,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(98,null),g.localize(99,null)],default:ie.insertMode,description:g.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ie.filterGraceful,description:g.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:ie.localityBonus,description:g.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ie.shareSuggestSelections,markdownDescription:g.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ie.snippetsPreventQuickSuggestions,description:g.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:ie.showIcons,description:g.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ie.showStatusBar,description:g.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:ie.preview,description:g.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ie.showInlineDetails,description:g.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(139,null)}})}validate(ie){if(!ie||typeof ie!="object")return this.defaultValue;const _e=ie;return{insertMode:b(_e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(_e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(_e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(_e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(_e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:c(_e.showIcons,this.defaultValue.showIcons),showStatusBar:c(_e.showStatusBar,this.defaultValue.showStatusBar),preview:c(_e.preview,this.defaultValue.preview),previewMode:b(_e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(_e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(_e.showMethods,this.defaultValue.showMethods),showFunctions:c(_e.showFunctions,this.defaultValue.showFunctions),showConstructors:c(_e.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(_e.showDeprecated,this.defaultValue.showDeprecated),showFields:c(_e.showFields,this.defaultValue.showFields),showVariables:c(_e.showVariables,this.defaultValue.showVariables),showClasses:c(_e.showClasses,this.defaultValue.showClasses),showStructs:c(_e.showStructs,this.defaultValue.showStructs),showInterfaces:c(_e.showInterfaces,this.defaultValue.showInterfaces),showModules:c(_e.showModules,this.defaultValue.showModules),showProperties:c(_e.showProperties,this.defaultValue.showProperties),showEvents:c(_e.showEvents,this.defaultValue.showEvents),showOperators:c(_e.showOperators,this.defaultValue.showOperators),showUnits:c(_e.showUnits,this.defaultValue.showUnits),showValues:c(_e.showValues,this.defaultValue.showValues),showConstants:c(_e.showConstants,this.defaultValue.showConstants),showEnums:c(_e.showEnums,this.defaultValue.showEnums),showEnumMembers:c(_e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(_e.showKeywords,this.defaultValue.showKeywords),showWords:c(_e.showWords,this.defaultValue.showWords),showColors:c(_e.showColors,this.defaultValue.showColors),showFiles:c(_e.showFiles,this.defaultValue.showFiles),showReferences:c(_e.showReferences,this.defaultValue.showReferences),showFolders:c(_e.showFolders,this.defaultValue.showFolders),showTypeParameters:c(_e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(_e.showSnippets,this.defaultValue.showSnippets),showUsers:c(_e.showUsers,this.defaultValue.showUsers),showIssues:c(_e.showIssues,this.defaultValue.showIssues)}}}class re extends D{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(140,null),default:!0,type:"boolean"}})}validate(ie){return!ie||typeof ie!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(ie.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class pe extends P{constructor(){super(128,[80])}compute(ie,_e,Qe){return _e.get(80)?!0:ie.tabFocusMode}}var Me;(function(J){J[J.None=0]="None",J[J.Same=1]="Same",J[J.Indent=2]="Indent",J[J.DeepIndent=3]="DeepIndent"})(Me=e.WrappingIndent||(e.WrappingIndent={}));function je(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Ke extends P{constructor(){super(130,[129])}compute(ie,_e,Qe){const et=_e.get(129);return{isDominatedByLongLines:ie.isDominatedByLongLines,isWordWrapMinified:et.isWordWrapMinified,isViewportWrapping:et.isViewportWrapping,wrappingColumn:et.wrappingColumn}}}const Ze="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",lt="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?rt:L.isLinux?lt:Ze,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(J){return e.editorOptionsRegistry[J.id]=J,J}var at;(function(J){J[J.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",J[J.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",J[J.accessibilitySupport=2]="accessibilitySupport",J[J.accessibilityPageSize=3]="accessibilityPageSize",J[J.ariaLabel=4]="ariaLabel",J[J.autoClosingBrackets=5]="autoClosingBrackets",J[J.autoClosingDelete=6]="autoClosingDelete",J[J.autoClosingOvertype=7]="autoClosingOvertype",J[J.autoClosingQuotes=8]="autoClosingQuotes",J[J.autoIndent=9]="autoIndent",J[J.automaticLayout=10]="automaticLayout",J[J.autoSurround=11]="autoSurround",J[J.bracketPairColorization=12]="bracketPairColorization",J[J.guides=13]="guides",J[J.codeLens=14]="codeLens",J[J.codeLensFontFamily=15]="codeLensFontFamily",J[J.codeLensFontSize=16]="codeLensFontSize",J[J.colorDecorators=17]="colorDecorators",J[J.columnSelection=18]="columnSelection",J[J.comments=19]="comments",J[J.contextmenu=20]="contextmenu",J[J.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",J[J.cursorBlinking=22]="cursorBlinking",J[J.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",J[J.cursorStyle=24]="cursorStyle",J[J.cursorSurroundingLines=25]="cursorSurroundingLines",J[J.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",J[J.cursorWidth=27]="cursorWidth",J[J.disableLayerHinting=28]="disableLayerHinting",J[J.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",J[J.domReadOnly=30]="domReadOnly",J[J.dragAndDrop=31]="dragAndDrop",J[J.emptySelectionClipboard=32]="emptySelectionClipboard",J[J.extraEditorClassName=33]="extraEditorClassName",J[J.fastScrollSensitivity=34]="fastScrollSensitivity",J[J.find=35]="find",J[J.fixedOverflowWidgets=36]="fixedOverflowWidgets",J[J.folding=37]="folding",J[J.foldingStrategy=38]="foldingStrategy",J[J.foldingHighlight=39]="foldingHighlight",J[J.foldingImportsByDefault=40]="foldingImportsByDefault",J[J.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",J[J.fontFamily=42]="fontFamily",J[J.fontInfo=43]="fontInfo",J[J.fontLigatures=44]="fontLigatures",J[J.fontSize=45]="fontSize",J[J.fontWeight=46]="fontWeight",J[J.formatOnPaste=47]="formatOnPaste",J[J.formatOnType=48]="formatOnType",J[J.glyphMargin=49]="glyphMargin",J[J.gotoLocation=50]="gotoLocation",J[J.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",J[J.hover=52]="hover",J[J.inDiffEditor=53]="inDiffEditor",J[J.inlineSuggest=54]="inlineSuggest",J[J.letterSpacing=55]="letterSpacing",J[J.lightbulb=56]="lightbulb",J[J.lineDecorationsWidth=57]="lineDecorationsWidth",J[J.lineHeight=58]="lineHeight",J[J.lineNumbers=59]="lineNumbers",J[J.lineNumbersMinChars=60]="lineNumbersMinChars",J[J.linkedEditing=61]="linkedEditing",J[J.links=62]="links",J[J.matchBrackets=63]="matchBrackets",J[J.minimap=64]="minimap",J[J.mouseStyle=65]="mouseStyle",J[J.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",J[J.mouseWheelZoom=67]="mouseWheelZoom",J[J.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",J[J.multiCursorModifier=69]="multiCursorModifier",J[J.multiCursorPaste=70]="multiCursorPaste",J[J.occurrencesHighlight=71]="occurrencesHighlight",J[J.overviewRulerBorder=72]="overviewRulerBorder",J[J.overviewRulerLanes=73]="overviewRulerLanes",J[J.padding=74]="padding",J[J.parameterHints=75]="parameterHints",J[J.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",J[J.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",J[J.quickSuggestions=78]="quickSuggestions",J[J.quickSuggestionsDelay=79]="quickSuggestionsDelay",J[J.readOnly=80]="readOnly",J[J.renameOnType=81]="renameOnType",J[J.renderControlCharacters=82]="renderControlCharacters",J[J.renderFinalNewline=83]="renderFinalNewline",J[J.renderLineHighlight=84]="renderLineHighlight",J[J.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",J[J.renderValidationDecorations=86]="renderValidationDecorations",J[J.renderWhitespace=87]="renderWhitespace",J[J.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",J[J.roundedSelection=89]="roundedSelection",J[J.rulers=90]="rulers",J[J.scrollbar=91]="scrollbar",J[J.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",J[J.scrollBeyondLastLine=93]="scrollBeyondLastLine",J[J.scrollPredominantAxis=94]="scrollPredominantAxis",J[J.selectionClipboard=95]="selectionClipboard",J[J.selectionHighlight=96]="selectionHighlight",J[J.selectOnLineNumbers=97]="selectOnLineNumbers",J[J.showFoldingControls=98]="showFoldingControls",J[J.showUnused=99]="showUnused",J[J.snippetSuggestions=100]="snippetSuggestions",J[J.smartSelect=101]="smartSelect",J[J.smoothScrolling=102]="smoothScrolling",J[J.stickyTabStops=103]="stickyTabStops",J[J.stopRenderingLineAfter=104]="stopRenderingLineAfter",J[J.suggest=105]="suggest",J[J.suggestFontSize=106]="suggestFontSize",J[J.suggestLineHeight=107]="suggestLineHeight",J[J.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",J[J.suggestSelection=109]="suggestSelection",J[J.tabCompletion=110]="tabCompletion",J[J.tabIndex=111]="tabIndex",J[J.unusualLineTerminators=112]="unusualLineTerminators",J[J.useShadowDOM=113]="useShadowDOM",J[J.useTabStops=114]="useTabStops",J[J.wordSeparators=115]="wordSeparators",J[J.wordWrap=116]="wordWrap",J[J.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",J[J.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",J[J.wordWrapColumn=119]="wordWrapColumn",J[J.wordWrapOverride1=120]="wordWrapOverride1",J[J.wordWrapOverride2=121]="wordWrapOverride2",J[J.wrappingIndent=122]="wrappingIndent",J[J.wrappingStrategy=123]="wrappingStrategy",J[J.showDeprecated=124]="showDeprecated",J[J.inlayHints=125]="inlayHints",J[J.editorClassName=126]="editorClassName",J[J.pixelRatio=127]="pixelRatio",J[J.tabFocusMode=128]="tabFocusMode",J[J.layoutInfo=129]="layoutInfo",J[J.wrappingInfo=130]="wrappingInfo"})(at=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new v(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(141,null)})),acceptSuggestionOnEnter:ye(new o(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(142,null),""],markdownDescription:g.localize(143,null)})),accessibilitySupport:ye(new r),accessibilityPageSize:ye(new w(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(144,null)})),ariaLabel:ye(new T(4,"ariaLabel",g.localize(145,null))),autoClosingBrackets:ye(new o(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(146,null),g.localize(147,null),""],description:g.localize(148,null)})),autoClosingDelete:ye(new o(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(149,null),""],description:g.localize(150,null)})),autoClosingOvertype:ye(new o(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(151,null),""],description:g.localize(152,null)})),autoClosingQuotes:ye(new o(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(153,null),g.localize(154,null),""],description:g.localize(155,null)})),autoIndent:ye(new s(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[g.localize(156,null),g.localize(157,null),g.localize(158,null),g.localize(159,null),g.localize(160,null)],description:g.localize(161,null)})),automaticLayout:ye(new v(10,"automaticLayout",!1)),autoSurround:ye(new o(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(162,null),g.localize(163,null),g.localize(164,null),""],description:g.localize(165,null)})),bracketPairColorization:ye(new ee),bracketPairGuides:ye(new ne),stickyTabStops:ye(new v(103,"stickyTabStops",!1,{description:g.localize(166,null)})),codeLens:ye(new v(14,"codeLens",!0,{description:g.localize(167,null)})),codeLensFontFamily:ye(new T(15,"codeLensFontFamily","",{description:g.localize(168,null)})),codeLensFontSize:ye(new w(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(169,null)})),colorDecorators:ye(new v(17,"colorDecorators",!0,{description:g.localize(170,null)})),columnSelection:ye(new v(18,"columnSelection",!1,{description:g.localize(171,null)})),comments:ye(new m),contextmenu:ye(new v(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new v(21,"copyWithSyntaxHighlighting",!0,{description:g.localize(172,null)})),cursorBlinking:ye(new s(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:g.localize(173,null)})),cursorSmoothCaretAnimation:ye(new v(23,"cursorSmoothCaretAnimation",!1,{description:g.localize(174,null)})),cursorStyle:ye(new s(24,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],l,{description:g.localize(175,null)})),cursorSurroundingLines:ye(new w(25,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(176,null)})),cursorSurroundingLinesStyle:ye(new o(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(177,null),g.localize(178,null)],description:g.localize(179,null)})),cursorWidth:ye(new w(27,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(180,null)})),disableLayerHinting:ye(new v(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new v(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new v(30,"domReadOnly",!1)),dragAndDrop:ye(new v(31,"dragAndDrop",!0,{description:g.localize(181,null)})),emptySelectionClipboard:ye(new d),extraEditorClassName:ye(new T(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new E(34,"fastScrollSensitivity",5,J=>J<=0?5:J,{markdownDescription:g.localize(182,null)})),find:ye(new S),fixedOverflowWidgets:ye(new v(36,"fixedOverflowWidgets",!1)),folding:ye(new v(37,"folding",!0,{description:g.localize(183,null)})),foldingStrategy:ye(new o(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(184,null),g.localize(185,null)],description:g.localize(186,null)})),foldingHighlight:ye(new v(39,"foldingHighlight",!0,{description:g.localize(187,null)})),foldingImportsByDefault:ye(new v(40,"foldingImportsByDefault",!1,{description:g.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new v(41,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(189,null)})),fontFamily:ye(new T(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(190,null)})),fontInfo:ye(new R),fontLigatures2:ye(new A),fontSize:ye(new B),fontWeight:ye(new x),formatOnPaste:ye(new v(47,"formatOnPaste",!1,{description:g.localize(191,null)})),formatOnType:ye(new v(48,"formatOnType",!1,{description:g.localize(192,null)})),glyphMargin:ye(new v(49,"glyphMargin",!0,{description:g.localize(193,null)})),gotoLocation:ye(new F),hideCursorInOverviewRuler:ye(new v(51,"hideCursorInOverviewRuler",!1,{description:g.localize(194,null)})),hover:ye(new $),inDiffEditor:ye(new v(53,"inDiffEditor",!1)),letterSpacing:ye(new E(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,J=>E.clamp(J,-5,20),{description:g.localize(195,null)})),lightbulb:ye(new N),lineDecorationsWidth:ye(new I(57,"lineDecorationsWidth",10)),lineHeight:ye(new V),lineNumbers:ye(new De),lineNumbersMinChars:ye(new w(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new v(61,"linkedEditing",!1,{description:g.localize(196,null)})),links:ye(new v(62,"links",!0,{description:g.localize(197,null)})),matchBrackets:ye(new o(63,"matchBrackets","always",["always","near","never"],{description:g.localize(198,null)})),minimap:ye(new O),mouseStyle:ye(new o(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new E(66,"mouseWheelScrollSensitivity",1,J=>J===0?1:J,{markdownDescription:g.localize(199,null)})),mouseWheelZoom:ye(new v(67,"mouseWheelZoom",!1,{markdownDescription:g.localize(200,null)})),multiCursorMergeOverlapping:ye(new v(68,"multiCursorMergeOverlapping",!0,{description:g.localize(201,null)})),multiCursorModifier:ye(new s(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],W,{markdownEnumDescriptions:[g.localize(202,null),g.localize(203,null)],markdownDescription:g.localize(204,null)})),multiCursorPaste:ye(new o(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(205,null),g.localize(206,null)],markdownDescription:g.localize(207,null)})),occurrencesHighlight:ye(new v(71,"occurrencesHighlight",!0,{description:g.localize(208,null)})),overviewRulerBorder:ye(new v(72,"overviewRulerBorder",!0,{description:g.localize(209,null)})),overviewRulerLanes:ye(new w(73,"overviewRulerLanes",3,0,3)),padding:ye(new j),parameterHints:ye(new X),peekWidgetDefaultFocus:ye(new o(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(210,null),g.localize(211,null)],description:g.localize(212,null)})),definitionLinkOpensInPeek:ye(new v(77,"definitionLinkOpensInPeek",!1,{description:g.localize(213,null)})),quickSuggestions:ye(new de),quickSuggestionsDelay:ye(new w(79,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(214,null)})),readOnly:ye(new v(80,"readOnly",!1)),renameOnType:ye(new v(81,"renameOnType",!1,{description:g.localize(215,null),markdownDeprecationMessage:g.localize(216,null)})),renderControlCharacters:ye(new v(82,"renderControlCharacters",!0,{description:g.localize(217,null),restricted:!0})),renderFinalNewline:ye(new v(83,"renderFinalNewline",!0,{description:g.localize(218,null)})),renderLineHighlight:ye(new o(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(219,null)],description:g.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new v(85,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(221,null)})),renderValidationDecorations:ye(new o(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new o(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(222,null),g.localize(223,null),g.localize(224,null),""],description:g.localize(225,null)})),revealHorizontalRightPadding:ye(new w(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new v(89,"roundedSelection",!0,{description:g.localize(226,null)})),rulers:ye(new Be),scrollbar:ye(new He),scrollBeyondLastColumn:ye(new w(92,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(227,null)})),scrollBeyondLastLine:ye(new v(93,"scrollBeyondLastLine",!0,{description:g.localize(228,null)})),scrollPredominantAxis:ye(new v(94,"scrollPredominantAxis",!0,{description:g.localize(229,null)})),selectionClipboard:ye(new v(95,"selectionClipboard",!0,{description:g.localize(230,null),included:L.isLinux})),selectionHighlight:ye(new v(96,"selectionHighlight",!0,{description:g.localize(231,null)})),selectOnLineNumbers:ye(new v(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new o(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(232,null),g.localize(233,null)],description:g.localize(234,null)})),showUnused:ye(new v(99,"showUnused",!0,{description:g.localize(235,null)})),showDeprecated:ye(new v(124,"showDeprecated",!0,{description:g.localize(236,null)})),inlayHints:ye(new U),snippetSuggestions:ye(new o(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(237,null),g.localize(238,null),g.localize(239,null),g.localize(240,null)],description:g.localize(241,null)})),smartSelect:ye(new re),smoothScrolling:ye(new v(102,"smoothScrolling",!1,{description:g.localize(242,null)})),stopRenderingLineAfter:ye(new w(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new Z),inlineSuggest:ye(new G),suggestFontSize:ye(new w(106,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(243,null)})),suggestLineHeight:ye(new w(107,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(244,null)})),suggestOnTriggerCharacters:ye(new v(108,"suggestOnTriggerCharacters",!0,{description:g.localize(245,null)})),suggestSelection:ye(new o(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(246,null),g.localize(247,null),g.localize(248,null)],description:g.localize(249,null)})),tabCompletion:ye(new o(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(250,null),g.localize(251,null),g.localize(252,null)],description:g.localize(253,null)})),tabIndex:ye(new w(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new o(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(254,null),g.localize(255,null),g.localize(256,null)],description:g.localize(257,null)})),useShadowDOM:ye(new v(113,"useShadowDOM",!0)),useTabStops:ye(new v(114,"useTabStops",!0,{description:g.localize(258,null)})),wordSeparators:ye(new T(115,"wordSeparators",y.USUAL_WORD_SEPARATORS,{description:g.localize(259,null)})),wordWrap:ye(new o(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(260,null),g.localize(261,null),g.localize(262,null),g.localize(263,null)],description:g.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new T(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new T(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new w(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(265,null)})),wordWrapOverride1:ye(new o(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new o(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new s(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],je,{enumDescriptions:[g.localize(266,null),g.localize(267,null),g.localize(268,null),g.localize(269,null)],description:g.localize(270,null)})),wrappingStrategy:ye(new o(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(271,null),g.localize(272,null)],description:g.localize(273,null)})),editorClassName:ye(new f),pixelRatio:ye(new Q),tabFocusMode:ye(new pe),layoutInfo:ye(new H),wrappingInfo:ye(new Ke)}}),define(fe[156],me([19,20]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(fe[157],me([19,20]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(fe[158],me([19,20]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(fe[159],me([19,20]),function(Y,e){return Y.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(fe[160],me([19,20]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(fe[161],me([19,20]),function(Y,e){return Y.create("vs/platform/markers/common/markers",e)}),define(fe[162],me([19,20]),function(Y,e){return Y.create("vs/platform/theme/common/iconRegistry",e)}),define(fe[163],me([19,20]),function(Y,e){return Y.create("vs/platform/workspaces/common/workspaces",e)}),define(fe[164],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(fe[165],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostExtensionService",e)}),define(fe[166],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostProgress",e)}),define(fe[167],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostStatusBar",e)}),define(fe[168],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTerminalService",e)}),define(fe[169],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostTreeViews",e)}),define(fe[170],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/common/extHostWorkspace",e)}),define(fe[171],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostDebugService",e)}),define(fe[172],me([19,20]),function(Y,e){return Y.create("vs/workbench/api/node/extHostTunnelService",e)}),define(fe[173],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/editor",e)}),define(fe[174],me([19,20]),function(Y,e){return Y.create("vs/workbench/common/views",e)}),define(fe[175],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(fe[176],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(fe[177],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(fe[178],me([19,20]),function(Y,e){return Y.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(fe[179],me([19,20]),function(Y,e){return Y.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(fe[180],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var g;(function(n){n[n.ACTIVATE=1]="ACTIVATE",n[n.RESTORE=2]="RESTORE",n[n.PRESERVE=3]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var L;(function(n){n[n.PICK=0]="PICK",n[n.DISABLED=1]="DISABLED",n[n.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(L=e.EditorResolution||(e.EditorResolution={}));var y;(function(n){n[n.API=0]="API",n[n.USER=1]="USER"})(y=e.EditorOpenContext||(e.EditorOpenContext={}));var C;(function(n){n[n.Center=0]="Center",n[n.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",n[n.NearTop=2]="NearTop",n[n.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(C=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(fe[181],me([0,1,158]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function C(c){return c=c.trim(),c==="*"||L.test(c)}e.isValidVersionStr=C;function n(c){if(!C(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let v=c.match(L);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=n;function k(c){if(!c)return null;let v=c.majorBase,h=c.majorMustEqual,w=c.minorBase,E=c.minorMustEqual,T=c.patchBase,b=c.patchMustEqual;c.hasCaret&&(v===0||(E=!1),b=!1);let o=0;if(c.preRelease){const s=y.exec(c.preRelease);if(s){const[,p,r,m]=s;o=Date.UTC(Number(p),Number(r)-1,Number(m))}}return{majorBase:v,majorMustEqual:h,minorBase:w,minorMustEqual:E,patchBase:T,patchMustEqual:b,isMinimum:c.hasGreaterEquals,notBefore:o}}e.normalizeVersion=k;function _(c,v,h){let w;typeof c=="string"?w=k(n(c)):w=c;let E;v instanceof Date?E=v.getTime():typeof v=="string"&&(E=new Date(v).getTime());let T;if(typeof h=="string"?T=k(n(h)):T=h,!w||!T)return!1;let b=w.majorBase,o=w.minorBase,s=w.patchBase,p=T.majorBase,r=T.minorBase,m=T.patchBase,i=T.notBefore,t=T.majorMustEqual,u=T.minorMustEqual,a=T.patchMustEqual;return T.isMinimum?b>p?!0:b<p?!1:o>r?!0:o<r||E&&E<i?!1:s>=m:(b===1&&p===0&&(!t||!u||!a)&&(p=1,r=0,m=0,t=!0,u=!1,a=!1),b<p?!1:b>p?!t:o<r?!1:o>r?!u:s<m?!1:s>m?!a:!(E&&E<i))}e.isValidVersion=_;function D(c,v,h,w){return h.isBuiltin||typeof h.main=="undefined"?!0:I(c,v,h.engines.vscode,w)}e.isValidExtensionVersion=D;function P(c,v,h){return c==="*"||I(v,h,c)}e.isEngineValid=P;function I(c,v,h,w=[]){let E=k(n(h));if(!E)return w.push(g.localize(0,null,h)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return w.push(g.localize(1,null,h)),!1}else if(!E.majorMustEqual)return w.push(g.localize(2,null,h)),!1;return _(c,v,E)?!0:(w.push(g.localize(3,null,c,h)),!1)}}),define(fe[115],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class g{constructor(y,C=[],n=!1){this.ctor=y,this.staticArguments=C,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=g}),define(fe[84],me([0,1,115]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function y(n,k,_){k instanceof g.SyncDescriptor||(k=new g.SyncDescriptor(k,[],_)),L.push([n,k])}e.registerSingleton=y;function C(){return L}e.getSingletonServiceDescriptors=C}),define(fe[182],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(C){this.incoming=new Map,this.outgoing=new Map,this.data=C}}e.Node=g;class L{constructor(C){this._hashFn=C,this._nodes=new Map}roots(){const C=[];for(let n of this._nodes.values())n.outgoing.size===0&&C.push(n);return C}insertEdge(C,n){const k=this.lookupOrInsertNode(C),_=this.lookupOrInsertNode(n);k.outgoing.set(this._hashFn(n),_),_.incoming.set(this._hashFn(C),k)}removeNode(C){const n=this._hashFn(C);this._nodes.delete(n);for(let k of this._nodes.values())k.outgoing.delete(n),k.incoming.delete(n)}lookupOrInsertNode(C){const n=this._hashFn(C);let k=this._nodes.get(n);return k||(k=new g(C),this._nodes.set(n,k)),k}lookup(C){return this._nodes.get(this._hashFn(C))}isEmpty(){return this._nodes.size===0}toString(){let C=[];for(let[n,k]of this._nodes)C.push(`${n}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return C.join(`
`)}findCycleSlow(){for(let[C,n]of this._nodes){const k=new Set([C]),_=this._findCycle(n,k);if(_)return _}}_findCycle(C,n){for(let[k,_]of C.outgoing){if(n.has(k))return[...n,k].join(" -> ");n.add(k);const D=this._findCycle(_,n);if(D)return D;n.delete(k)}}}e.Graph=L}),define(fe[4],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function k(_){return _[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=k})(g=e._util||(e._util={})),e.IInstantiationService=y("instantiationService");function L(n,k,_,D){k[g.DI_TARGET]===k?k[g.DI_DEPENDENCIES].push({id:n,index:_,optional:D}):(k[g.DI_DEPENDENCIES]=[{id:n,index:_,optional:D}],k[g.DI_TARGET]=k)}function y(n){if(g.serviceIds.has(n))return g.serviceIds.get(n);const k=function(_,D,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(k,_,P,!1)};return k.toString=()=>n,g.serviceIds.set(n,k),k}e.createDecorator=y;function C(n){return n}e.refineServiceDecorator=C}),define(fe[183],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,g.createDecorator)("modelService");function L(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.shouldSynchronizeModel=L}),define(fe[184],me([0,1,3,49,6,24,79,83,183]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function D(w){return typeof w=="string"?!1:Array.isArray(w)?w.every(D):!!w.exclusive}class P{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(E,T){let b={selector:E,provider:T,_score:-1,_time:this._clock++};return this._entries.push(b),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,y.toDisposable)(()=>{if(b){let o=this._entries.indexOf(b);o>=0&&(this._entries.splice(o,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),b=void 0)}})}has(E){return this.all(E).length>0}all(E){if(!E)return[];this._updateScores(E);const T=[];for(let b of this._entries)b._score>0&&T.push(b.provider);return T}ordered(E){const T=[];return this._orderedForEach(E,b=>T.push(b.provider)),T}orderedGroups(E){const T=[];let b,o;return this._orderedForEach(E,s=>{b&&o===s._score?b.push(s.provider):(o=s._score,b=[s.provider],T.push(b))}),T}_orderedForEach(E,T){if(!!E){this._updateScores(E);for(const b of this._entries)b._score>0&&T(b)}}_updateScores(E){let T={uri:E.uri.toString(),language:E.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===T.language&&this._lastCandidate.uri===T.uri)){this._lastCandidate=T;for(let b of this._entries)if(b._score=(0,k.score)(b.selector,E.uri,E.getLanguageId(),(0,_.shouldSynchronizeModel)(E)),D(b.selector)&&b._score>0){for(let o of this._entries)o._score=0;b._score=1e3;break}this._entries.sort(P._compareByScoreAndTime)}}static _compareByScoreAndTime(E,T){return E._score<T._score?1:E._score>T._score?-1:E._time<T._time?1:E._time>T._time?-1:0}}e.LanguageFeatureRegistry=P;const I=new WeakMap;let c=0;function v(w){let E=I.get(w);return E===void 0&&(E=++c,I.set(w,E)),E}class h{constructor(E,T,b=Number.MAX_SAFE_INTEGER){this._registry=E,this.min=T,this.max=b,this._cache=new C.LRUCache(50,.7)}_key(E){return E.id+this._registry.all(E).reduce((T,b)=>(0,L.doHash)(v(b),T),0)}_clamp(E){return E===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(E*1.3)))}get(E){const T=this._key(E),b=this._cache.get(T);return this._clamp(b?.value)}update(E,T){const b=this._key(E);let o=this._cache.get(b);return o||(o=new n.MovingAverage,this._cache.set(b,o)),o.update(T),this.get(E)}}e.LanguageFeatureRequestDelays=h}),define(fe[85],me([0,1,2,42,184,149,48]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(d){d[d.Null=0]="Null",d[d.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));var _;(function(d){d[d.NotSet=-1]="NotSet",d[d.None=0]="None",d[d.Italic=1]="Italic",d[d.Bold=2]="Bold",d[d.Underline=4]="Underline"})(_=e.FontStyle||(e.FontStyle={}));var D;(function(d){d[d.None=0]="None",d[d.DefaultForeground=1]="DefaultForeground",d[d.DefaultBackground=2]="DefaultBackground"})(D=e.ColorId||(e.ColorId={}));var P;(function(d){d[d.Other=0]="Other",d[d.Comment=1]="Comment",d[d.String=2]="String",d[d.RegEx=4]="RegEx"})(P=e.StandardTokenType||(e.StandardTokenType={}));var I;(function(d){d[d.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",d[d.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",d[d.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",d[d.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",d[d.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",d[d.ITALIC_MASK=2048]="ITALIC_MASK",d[d.BOLD_MASK=4096]="BOLD_MASK",d[d.UNDERLINE_MASK=8192]="UNDERLINE_MASK",d[d.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",d[d.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",d[d.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",d[d.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",d[d.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",d[d.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",d[d.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",d[d.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",d[d.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",d[d.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(I=e.MetadataConsts||(e.MetadataConsts={}));class c{static getLanguageId(S){return(S&255)>>>0}static getTokenType(S){return(S&1792)>>>8}static getFontStyle(S){return(S&14336)>>>11}static getForeground(S){return(S&8372224)>>>14}static getBackground(S){return(S&4286578688)>>>23}static getClassNameFromMetadata(S){let A=this.getForeground(S),R="mtk"+A,B=this.getFontStyle(S);return B&1&&(R+=" mtki"),B&2&&(R+=" mtkb"),B&4&&(R+=" mtku"),R}static getInlineStyleFromMetadata(S,A){const R=this.getForeground(S),B=this.getFontStyle(S);let x=`color: ${A[R]};`;return B&1&&(x+="font-style: italic;"),B&2&&(x+="font-weight: bold;"),B&4&&(x+="text-decoration: underline;"),x}}e.TokenMetadata=c;var v;(function(d){d[d.Method=0]="Method",d[d.Function=1]="Function",d[d.Constructor=2]="Constructor",d[d.Field=3]="Field",d[d.Variable=4]="Variable",d[d.Class=5]="Class",d[d.Struct=6]="Struct",d[d.Interface=7]="Interface",d[d.Module=8]="Module",d[d.Property=9]="Property",d[d.Event=10]="Event",d[d.Operator=11]="Operator",d[d.Unit=12]="Unit",d[d.Value=13]="Value",d[d.Constant=14]="Constant",d[d.Enum=15]="Enum",d[d.EnumMember=16]="EnumMember",d[d.Keyword=17]="Keyword",d[d.Text=18]="Text",d[d.Color=19]="Color",d[d.File=20]="File",d[d.Reference=21]="Reference",d[d.Customcolor=22]="Customcolor",d[d.Folder=23]="Folder",d[d.TypeParameter=24]="TypeParameter",d[d.User=25]="User",d[d.Issue=26]="Issue",d[d.Snippet=27]="Snippet"})(v=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let d=Object.create(null);return d[0]="symbol-method",d[1]="symbol-function",d[2]="symbol-constructor",d[3]="symbol-field",d[4]="symbol-variable",d[5]="symbol-class",d[6]="symbol-struct",d[7]="symbol-interface",d[8]="symbol-module",d[9]="symbol-property",d[10]="symbol-event",d[11]="symbol-operator",d[12]="symbol-unit",d[13]="symbol-value",d[14]="symbol-constant",d[15]="symbol-enum",d[16]="symbol-enum-member",d[17]="symbol-keyword",d[27]="symbol-snippet",d[18]="symbol-text",d[19]="symbol-color",d[20]="symbol-file",d[21]="symbol-reference",d[22]="symbol-customcolor",d[23]="symbol-folder",d[24]="symbol-type-parameter",d[25]="account",d[26]="issues",function(S){const A=d[S];let R=A&&n.iconRegistry.get(A);return R||(console.info("No codicon found for CompletionItemKind "+S),R=n.Codicon.symbolProperty),R.classNames}}(),e.completionKindFromString=function(){let d=Object.create(null);return d.method=0,d.function=1,d.constructor=2,d.field=3,d.variable=4,d.class=5,d.struct=6,d.interface=7,d.module=8,d.property=9,d.event=10,d.operator=11,d.unit=12,d.value=13,d.constant=14,d.enum=15,d["enum-member"]=16,d.enumMember=16,d.keyword=17,d.snippet=27,d.text=18,d.color=19,d.file=20,d.reference=21,d.customcolor=22,d.folder=23,d["type-parameter"]=24,d.typeParameter=24,d.account=25,d.issue=26,function(S,A){let R=d[S];return typeof R=="undefined"&&!A&&(R=9),R}}();var h;(function(d){d[d.Deprecated=1]="Deprecated"})(h=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(d){d[d.KeepWhitespace=1]="KeepWhitespace",d[d.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var E;(function(d){d[d.Invoke=0]="Invoke",d[d.TriggerCharacter=1]="TriggerCharacter",d[d.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var T;(function(d){d[d.Automatic=0]="Automatic",d[d.Explicit=1]="Explicit"})(T=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(d){d[d.Invoke=1]="Invoke",d[d.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var o;(function(d){d[d.Invoke=1]="Invoke",d[d.TriggerCharacter=2]="TriggerCharacter",d[d.ContentChange=3]="ContentChange"})(o=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var s;(function(d){d[d.Text=0]="Text",d[d.Read=1]="Read",d[d.Write=2]="Write"})(s=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(d){return d&&g.URI.isUri(d.uri)&&L.Range.isIRange(d.range)&&(L.Range.isIRange(d.originSelectionRange)||L.Range.isIRange(d.targetSelectionRange))}e.isLocationLink=p;var r;(function(d){d[d.File=0]="File",d[d.Module=1]="Module",d[d.Namespace=2]="Namespace",d[d.Package=3]="Package",d[d.Class=4]="Class",d[d.Method=5]="Method",d[d.Property=6]="Property",d[d.Field=7]="Field",d[d.Constructor=8]="Constructor",d[d.Enum=9]="Enum",d[d.Interface=10]="Interface",d[d.Function=11]="Function",d[d.Variable=12]="Variable",d[d.Constant=13]="Constant",d[d.String=14]="String",d[d.Number=15]="Number",d[d.Boolean=16]="Boolean",d[d.Array=17]="Array",d[d.Object=18]="Object",d[d.Key=19]="Key",d[d.Null=20]="Null",d[d.EnumMember=21]="EnumMember",d[d.Struct=22]="Struct",d[d.Event=23]="Event",d[d.Operator=24]="Operator",d[d.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var m;(function(d){d[d.Deprecated=1]="Deprecated"})(m=e.SymbolTag||(e.SymbolTag={}));var i;(function(d){const S=new Map;S.set("file",0),S.set("module",1),S.set("namespace",2),S.set("package",3),S.set("class",4),S.set("method",5),S.set("property",6),S.set("field",7),S.set("constructor",8),S.set("enum",9),S.set("interface",10),S.set("function",11),S.set("variable",12),S.set("constant",13),S.set("string",14),S.set("number",15),S.set("boolean",16),S.set("array",17),S.set("object",18),S.set("key",19),S.set("null",20),S.set("enum-member",21),S.set("struct",22),S.set("event",23),S.set("operator",24),S.set("type-parameter",25);const A=new Map;A.set(0,"file"),A.set(1,"module"),A.set(2,"namespace"),A.set(3,"package"),A.set(4,"class"),A.set(5,"method"),A.set(6,"property"),A.set(7,"field"),A.set(8,"constructor"),A.set(9,"enum"),A.set(10,"interface"),A.set(11,"function"),A.set(12,"variable"),A.set(13,"constant"),A.set(14,"string"),A.set(15,"number"),A.set(16,"boolean"),A.set(17,"array"),A.set(18,"object"),A.set(19,"key"),A.set(20,"null"),A.set(21,"enum-member"),A.set(22,"struct"),A.set(23,"event"),A.set(24,"operator"),A.set(25,"type-parameter");function R(F){return S.get(F)}d.fromString=R;function B(F){return A.get(F)}d.toString=B;function x(F,$){const M=A.get(F);let H=M&&n.iconRegistry.get("symbol-"+M);return H||(console.info("No codicon found for SymbolKind "+F),H=n.Codicon.symbolProperty),`${$?"inline":"block"} ${H.classNames}`}d.toCssClassName=x})(i=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(S){this.value=S}}e.FoldingRangeKind=t,t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region");var u;(function(d){d[d.Collapsed=0]="Collapsed",d[d.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var a;(function(d){d[d.Editing=0]="Editing",d[d.Preview=1]="Preview"})(a=e.CommentMode||(e.CommentMode={}));var l;(function(d){d[d.Other=0]="Other",d[d.Type=1]="Type",d[d.Parameter=2]="Parameter"})(l=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new y.LanguageFeatureRegistry,e.RenameProviderRegistry=new y.LanguageFeatureRegistry,e.CompletionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new y.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new y.LanguageFeatureRegistry,e.HoverProviderRegistry=new y.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new y.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new y.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new y.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new y.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new y.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new y.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new y.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new y.LanguageFeatureRegistry,e.LinkProviderRegistry=new y.LanguageFeatureRegistry,e.ColorProviderRegistry=new y.LanguageFeatureRegistry,e.SelectionRangeRegistry=new y.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new y.LanguageFeatureRegistry,e.TokenizationRegistry=new C.TokenizationRegistryImpl;var f;(function(d){d[d.None=0]="None",d[d.Option=1]="Option",d[d.Default=2]="Default",d[d.Preferred=3]="Preferred"})(f=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(fe[53],me([0,1,12,8,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let C=g.userAgent||"";const n=new Map;n.set("false",!1),n.set("true",!0),n.set("isMac",g.isMacintosh),n.set("isLinux",g.isLinux),n.set("isWindows",g.isWindows),n.set("isWeb",g.isWeb),n.set("isMacNative",g.isMacintosh&&!g.isWeb),n.set("isEdge",C.indexOf("Edg/")>=0),n.set("isFirefox",C.indexOf("Firefox")>=0),n.set("isChrome",C.indexOf("Chrome")>=0),n.set("isSafari",C.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var _;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return c.INSTANCE}static true(){return v.INSTANCE}static has(F){return h.create(F)}static equals(F,$){return w.create(F,$)}static notEquals(F,$){return b.create(F,$)}static regex(F,$){return t.create(F,$)}static in(F,$){return E.create(F,$)}static not(F){return o.create(F)}static and(...F){return l.create(F,null)}static or(...F){return f.create(F,null,!0)}static greater(F,$){return p.create(F,$)}static greaterEquals(F,$){return r.create(F,$)}static smaller(F,$){return m.create(F,$)}static smallerEquals(F,$){return i.create(F,$)}static deserialize(F,$=!1){if(!!F)return this._deserializeOrExpression(F,$)}static _deserializeOrExpression(F,$){let M=F.split("||");return f.create(M.map(H=>this._deserializeAndExpression(H,$)),null,!0)}static _deserializeAndExpression(F,$){let M=F.split("&&");return l.create(M.map(H=>this._deserializeOne(H,$)),null)}static _deserializeOne(F,$){if(F=F.trim(),F.indexOf("!=")>=0){let M=F.split("!=");return b.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("==")>=0){let M=F.split("==");return w.create(M[0].trim(),this._deserializeValue(M[1],$))}if(F.indexOf("=~")>=0){let M=F.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],$))}if(F.indexOf(" in ")>=0){let M=F.split(" in ");return E.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const M=F.split(">=");return r.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const M=F.split(">");return p.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const M=F.split("<=");return i.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const M=F.split("<");return m.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(F)?o.create(F.substr(1).trim()):h.create(F)}static _deserializeValue(F,$){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;let M=/^'([^']*)'$/.exec(F);return M?M[1].trim():F}static _deserializeRegexValue(F,$){if((0,L.isFalsyOrWhitespace)(F)){if($)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=F.indexOf("/"),H=F.lastIndexOf("/");if(M===H||M<0){if($)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}let N=F.slice(M+1,H),U=F[H+1]==="i"?"i":"";try{return new RegExp(N,U)}catch(V){if($)throw new Error(`bad regexp-value '${F}', parse error: ${V}`);return console.warn(`bad regexp-value '${F}', parse error: ${V}`),null}}}e.ContextKeyExpr=D;function P(x,F){const $=x?x.substituteConstants():void 0,M=F?F.substituteConstants():void 0;return!$&&!M?!0:!$||!M?!1:$.equals(M)}e.expressionsAreEqualWithConstantSubstitution=P;function I(x,F){return x.cmp(F)}class c{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=c,c.INSTANCE=new c;class v{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return c.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class h{constructor(F,$){this.key=F,this.negated=$,this.type=2}static create(F,$=null){const M=n.get(F);return typeof M=="boolean"?M?v.INSTANCE:c.INSTANCE:new h(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:S(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=n.get(this.key);return typeof F=="boolean"?F?v.INSTANCE:c.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.negated||(this.negated=o.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class w{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=4}static create(F,$,M=null){if(typeof $=="boolean")return $?h.create(F,M):o.create(F,M);const H=n.get(F);return typeof H=="boolean"?$===(H?"true":"false")?v.INSTANCE:c.INSTANCE:new w(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=n.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?v.INSTANCE:c.INSTANCE}return this}evaluate(F){return F.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(F){return F.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=w;class E{constructor(F,$){this.key=F,this.valueKey=$,this.type=10,this.negated=null}static create(F,$){return new E(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.valueKey,F.key,F.valueKey)}equals(F){return F.type===this.type?this.key===F.key&&this.valueKey===F.valueKey:!1}substituteConstants(){return this}evaluate(F){const $=F.getValue(this.valueKey),M=F.getValue(this.key);return Array.isArray($)?$.indexOf(M)>=0:typeof M=="string"&&typeof $=="object"&&$!==null?k.call($,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(F){return F.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=T.create(this)),this.negated}}e.ContextKeyInExpr=E;class T{constructor(F){this._actual=F,this.type=11}static create(F){return new T(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new T(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotInExpr=T;class b{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=5}static create(F,$,M=null){if(typeof $=="boolean")return $?o.create(F,M):h.create(F,M);const H=n.get(F);return typeof H=="boolean"?$===(H?"true":"false")?c.INSTANCE:v.INSTANCE:new b(F,$,M)}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){const F=n.get(this.key);if(typeof F=="boolean"){const $=F?"true":"false";return this.value===$?c.INSTANCE:v.INSTANCE}return this}evaluate(F){return F.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(F){return F.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=b;class o{constructor(F,$){this.key=F,this.negated=$,this.type=3}static create(F,$=null){const M=n.get(F);return typeof M=="boolean"?M?c.INSTANCE:v.INSTANCE:new o(F,$)}cmp(F){return F.type!==this.type?this.type-F.type:S(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=n.get(this.key);return typeof F=="boolean"?F?c.INSTANCE:v.INSTANCE:this}evaluate(F){return!F.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(F){return F.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=o;function s(x,F){if(typeof x=="string"){const $=parseFloat(x);isNaN($)||(x=$)}return typeof x=="string"||typeof x=="number"?F(x):c.INSTANCE}class p{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=12}static create(F,$,M=null){return s($,H=>new p(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=p;class r{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=13}static create(F,$,M=null){return s($,H=>new r(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(F){return F.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class m{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=14}static create(F,$,M=null){return s($,H=>new m(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=m;class i{constructor(F,$,M){this.key=F,this.value=$,this.negated=M,this.type=15}static create(F,$,M=null){return s($,H=>new i(F,H,M))}cmp(F){return F.type!==this.type?this.type-F.type:A(this.key,this.value,F.key,F.value)}equals(F){return F.type===this.type?this.key===F.key&&this.value===F.value:!1}substituteConstants(){return this}evaluate(F){return typeof this.value=="string"?!1:parseFloat(F.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(F){return F.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class t{constructor(F,$){this.key=F,this.regexp=$,this.type=7,this.negated=null}static create(F,$){return new t(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.key<F.key)return-1;if(this.key>F.key)return 1;const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return $<M?-1:$>M?1:0}equals(F){if(F.type===this.type){const $=this.regexp?this.regexp.source:"",M=F.regexp?F.regexp.source:"";return this.key===F.key&&$===M}return!1}substituteConstants(){return this}evaluate(F){let $=F.getValue(this.key);return this.regexp?this.regexp.test($):!1}serialize(){const F=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${F}`}keys(){return[this.key]}map(F){return F.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=u.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class u{constructor(F){this._actual=F,this.type=8}static create(F){return new u(F)}cmp(F){return F.type!==this.type?this.type-F.type:this._actual.cmp(F._actual)}equals(F){return F.type===this.type?this._actual.equals(F._actual):!1}substituteConstants(){return this}evaluate(F){return!this._actual.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(F){return new u(this._actual.map(F))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;function a(x){let F=null;for(let $=0,M=x.length;$<M;$++){const H=x[$].substituteConstants();if(x[$]!==H&&F===null){F=[];for(let N=0;N<$;N++)F[N]=x[N]}F!==null&&(F[$]=H)}return F===null?x:F}class l{constructor(F,$){this.expr=F,this.negated=$,this.type=6}static create(F,$){return l._normalizeArr(F,$)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const H=I(this.expr[$],F.expr[$]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=a(this.expr);return F===this.expr?this:l.create(F,this.negated)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].evaluate(F))return!1;return!0}static _normalizeArr(F,$){const M=[];let H=!1;for(const N of F)if(!!N){if(N.type===1){H=!0;continue}if(N.type===0)return c.INSTANCE;if(N.type===6){M.push(...N.expr);continue}M.push(N)}if(M.length===0&&H)return v.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(I);for(let N=1;N<M.length;N++)M[N-1].equals(M[N])&&(M.splice(N,1),N--);if(M.length===1)return M[0];for(;M.length>1;){const N=M[M.length-1];if(N.type!==9)break;M.pop();const U=M.pop(),V=M.length===0,O=f.create(N.expr.map(W=>l.create([W,U],null)),null,V);O&&(M.push(O),M.sort(I))}return M.length===1?M[0]:new l(M,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new l(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){const F=[];for(let $ of this.expr)F.push($.negate());this.negated=f.create(F,this,!0)}return this.negated}}class f{constructor(F,$){this.expr=F,this.negated=$,this.type=9}static create(F,$,M){return f._normalizeArr(F,$,M)}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let $=0,M=this.expr.length;$<M;$++){const H=I(this.expr[$],F.expr[$]);if(H!==0)return H}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let $=0,M=this.expr.length;$<M;$++)if(!this.expr[$].equals(F.expr[$]))return!1;return!0}return!1}substituteConstants(){const F=a(this.expr);return F===this.expr?this:f.create(F,this.negated,!1)}evaluate(F){for(let $=0,M=this.expr.length;$<M;$++)if(this.expr[$].evaluate(F))return!0;return!1}static _normalizeArr(F,$,M){let H=[],N=!1;if(F){for(let U=0,V=F.length;U<V;U++){const O=F[U];if(!!O){if(O.type===0){N=!0;continue}if(O.type===1)return v.INSTANCE;if(O.type===9){H=H.concat(O.expr);continue}H.push(O)}}if(H.length===0&&N)return c.INSTANCE;H.sort(I)}if(H.length!==0){if(H.length===1)return H[0];for(let U=1;U<H.length;U++)H[U-1].equals(H[U])&&(H.splice(U,1),U--);if(H.length===1)return H[0];if(M){for(let U=0;U<H.length;U++)for(let V=U+1;V<H.length;V++)R(H[U],H[V])&&(H.splice(V,1),V--);if(H.length===1)return H[0]}return new f(H,$)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(let $ of this.expr)F.push(...$.keys());return F}map(F){return new f(this.expr.map($=>$.map(F)),null)}negate(){if(!this.negated){let F=[];for(let $ of this.expr)F.push($.negate());for(;F.length>1;){const $=F.shift(),M=F.shift(),H=[];for(const U of B($))for(const V of B(M))H.push(l.create([U,V],null));const N=F.length===0;F.unshift(f.create(H,null,N))}this.negated=F[0]}return this.negated}}class d extends h{constructor(F,$,M){super(F,null);this._defaultValue=$,typeof M=="object"?d._info.push({...M,key:F}):M!==!0&&d._info.push({key:F,description:M,type:$!=null?typeof $:void 0})}static all(){return d._info.values()}bindTo(F){return F.createKey(this.key,this._defaultValue)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return w.create(this.key,F)}notEqualsTo(F){return b.create(this.key,F)}}e.RawContextKey=d,d._info=[],e.IContextKeyService=(0,y.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function S(x,F){return x<F?-1:x>F?1:0}function A(x,F,$,M){return x<$?-1:x>$?1:F<M?-1:F>M?1:0}function R(x,F){if(F.type===6&&x.type!==9&&x.type!==6){for(const H of F.expr)if(x.equals(H))return!0}const $=x.negate(),M=B($).concat(B(F));M.sort(I);for(let H=0;H<M.length;H++){const U=M[H].negate();for(let V=H+1;V<M.length;V++){const O=M[V];if(U.equals(O))return!0}}return!1}e.implies=R;function B(x){return x.type===9?x.expr:[x]}}),define(fe[185],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,g.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,g.refineServiceDecorator)(e.IEnvironmentService)}),define(fe[186],me([0,1,10,157,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var C;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(C=e.TargetPlatform||(e.TargetPlatform={}));function n(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function k(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function _(o,s){switch(o){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=_;function D(o,s){return s==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=D;function P(o,s,p){return D(s,p)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===p?!0:I(p).includes(o)}e.isTargetPlatformCompatible=P;function I(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function c(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=c;var v;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var h;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var w;(function(o){o.Install="install",o.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var E;(function(o){o[o.None=0]="None",o[o.Install=1]="Install",o[o.Update=2]="Update"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var T;(function(o){o.Unsupported="Unsupported",o.Malicious="Malicious",o.Incompatible="Incompatible",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(T=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class b extends Error{constructor(s,p){super(s);this.code=p,this.name=p}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=g.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(fe[187],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,g.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,g.createDecorator)("externalTerminal")}),define(fe[188],me([0,1,39,10,9,12,95,28,113,159,187]),function(Y,e,g,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=D.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends c{openTerminal(s,p){return this.spawnTerminal(g,s,_.getWindowsShell(),p)}spawnTerminal(s,p,r,m){const i=p.windowsExec||v.getDefaultTerminalWindows();m&&m[1]===":"&&(m=m[0].toUpperCase()+m.substr(1));const t=y.basename(i).toLowerCase();if(t==="cmder"||t==="cmder.exe")return s.spawn(i,m?[m]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return i.indexOf(" ")>=0&&u.push('""'),u.push(i),(t==="wt"||t==="wt.exe")&&u.push("-d ."),new Promise((a,l)=>{const f=E(process),d=s.spawn(r,u,{cwd:m,env:f});d.on("error",l),d.on("exit",()=>a())})}runInTerminal(s,p,r,m,i){const t="windowsExec"in i&&i.windowsExec?i.windowsExec:v.getDefaultTerminalWindows();return new Promise((u,a)=>{const l=`"${p} - ${I}"`,f=`""${r.join('" "')}" & pause"`,d=["/c","start",l,"/wait",t,"/c",f],S=Object.assign({},E(process),m);Object.keys(S).filter(B=>S[B]===null).forEach(B=>delete S[B]);const A={cwd:p,env:S,windowsVerbatimArguments:!0};g.spawn(v.CMD,d,A).on("error",B=>{a(T(B))}),u(void 0)})}static getDefaultTerminalWindows(){if(!v._DEFAULT_TERMINAL_WINDOWS){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return v._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=v,v.CMD="cmd.exe";class h extends c{openTerminal(s,p){return this.spawnTerminal(g,s,p)}runInTerminal(s,p,r,m,i){const t=i.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((u,a)=>{if(t===P.DEFAULT_TERMINAL_OSX||t==="iTerm.app"){const l=t===P.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",d=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${l}.scpt`,Y).fsPath,"-t",s||I,"-w",p];for(let R of r)d.push("-a"),d.push(R);if(m){const R=Object.assign({},E(process),m);for(let B in R){const x=R[B];x===null?(d.push("-u"),d.push(B)):(d.push("-e"),d.push(`${B}=${x}`))}}let S="";const A=g.spawn(h.OSASCRIPT,d);A.on("error",R=>{a(T(R))}),A.stderr.on("data",R=>{S+=R.toString()}),A.on("exit",R=>{if(R===0)u(void 0);else if(S){const B=S.split(`
`,1);a(new Error(B[0]))}else a(new Error(D.localize(1,null,l,R)))})}else a(new Error(D.localize(2,null,t)))})}spawnTerminal(s,p,r){const m=p.osxExec||P.DEFAULT_TERMINAL_OSX;return new Promise((i,t)=>{const u=["-a",m];r&&u.push(r);const a=E(process),l=s.spawn("/usr/bin/open",u,{cwd:r,env:a});l.on("error",t),l.on("exit",()=>i())})}}e.MacExternalTerminalService=h,h.OSASCRIPT="/usr/bin/osascript";class w extends c{openTerminal(s,p){return this.spawnTerminal(g,s,p)}runInTerminal(s,p,r,m,i){const t=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((u,a)=>{let l=[];t.then(f=>{f.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const d=`${b(r)}; echo; read -p "${w.WAIT_MESSAGE}" -n1;`;l.push(`''${d}''`);const S=Object.assign({},E(process),m);Object.keys(S).filter(x=>S[x]===null).forEach(x=>delete S[x]);const A={cwd:p,env:S};let R="";const B=g.spawn(f,l,A);B.on("error",x=>{a(T(x))}),B.stderr.on("data",x=>{R+=x.toString()}),B.on("exit",x=>{if(x===0)u(void 0);else if(R){const F=R.split(`
`,1);a(new Error(F[0]))}else a(new Error(D.localize(4,null,f,x)))})})})}static async getDefaultTerminalLinuxReady(){if(!w._DEFAULT_TERMINAL_LINUX_READY)if(!C.isLinux)w._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const s=await k.Promises.exists("/etc/debian_version");w._DEFAULT_TERMINAL_LINUX_READY=new Promise(p=>{s?p("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?p("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?p("konsole"):process.env.COLORTERM?p(process.env.COLORTERM):process.env.TERM?p(process.env.TERM):p("xterm")})}return w._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(s,p,r){const m=p.linuxExec?Promise.resolve(p.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,t)=>{m.then(u=>{const a=E(process),l=s.spawn(u,[],{cwd:r,env:a});l.on("error",t),l.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w,w.WAIT_MESSAGE=D.localize(3,null);function E(o){const s={...o.env};return(0,n.sanitizeProcessEnvironment)(s),s}function T(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(D.localize(5,null,o.path)):o}function b(o){let s="";for(let p of o)p.indexOf(" ")>=0?s+='"'+p+'"':s+=p,s+=" ";return s}}),define(fe[43],me([0,1,24,9,8,13,2,160,4]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,_.createDecorator)("fileService");function D(M){return M.create===!0}e.isFileOpenForWriteOptions=D;var P;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var I;(function(M){M[M.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var c;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(c=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function v(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=v;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function w(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function E(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=E;var T;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(T=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(H,N){super(H);this.code=N}}e.FileSystemProviderError=b;function o(M,H){const N=new b(M.toString(),H);return p(N,H),N}e.createFileSystemProviderError=o;function s(M){return M||o((0,k.localize)(0,null),T.Unknown)}e.ensureFileSystemProviderError=s;function p(M,H){return M.name=H?`${H} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=p;function r(M){if(!M)return T.Unknown;if(M instanceof b)return M.code;const H=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!H)return T.Unknown;switch(H[1]){case T.FileExists:return T.FileExists;case T.FileIsADirectory:return T.FileIsADirectory;case T.FileNotADirectory:return T.FileNotADirectory;case T.FileNotFound:return T.FileNotFound;case T.FileExceedsMemoryLimit:return T.FileExceedsMemoryLimit;case T.FileTooLarge:return T.FileTooLarge;case T.FileWriteLocked:return T.FileWriteLocked;case T.NoPermissions:return T.NoPermissions;case T.Unavailable:return T.Unavailable}return T.Unknown}e.toFileSystemProviderErrorCode=r;function m(M){if(M instanceof f)return M.fileOperationResult;switch(r(M)){case T.FileNotFound:return 1;case T.FileIsADirectory:return 0;case T.FileNotADirectory:return 10;case T.FileWriteLocked:return 5;case T.NoPermissions:return 6;case T.FileExists:return 4;case T.FileExceedsMemoryLimit:return 9;case T.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=m;var i;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class t{constructor(H,N,U){this.resource=H,this.operation=N,this.target=U}isOperation(H){return this.operation===H}}e.FileOperationEvent=t;var u;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class a{constructor(H,N){this.added=void 0,this.updated=void 0,this.deleted=void 0;const U=new Map;for(const V of H){const O=U.get(V.type);O?O.push([V.resource,V]):U.set(V.type,[[V.resource,V]])}for(const[V,O]of U)switch(V){case 1:this.added=g.TernarySearchTree.forUris(()=>N),this.added.fill(O);break;case 0:this.updated=g.TernarySearchTree.forUris(()=>N),this.updated.fill(O);break;case 2:this.deleted=g.TernarySearchTree.forUris(()=>N),this.deleted.fill(O);break}}contains(H,...N){return this.doContains(H,{includeChildren:!1},...N)}affects(H,...N){return this.doContains(H,{includeChildren:!0},...N)}doContains(H,N,...U){if(!H)return!1;const V=U.length>0;return!!((!V||U.includes(1))&&(this.added?.get(H)||N.includeChildren&&this.added?.findSuperstr(H))||(!V||U.includes(0))&&(this.updated?.get(H)||N.includeChildren&&this.updated?.findSuperstr(H))||(!V||U.includes(2))&&(this.deleted?.findSubstr(H)||N.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=a;function l(M,H,N){return!M||!H||M===H||H.length>M.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),N?(0,y.startsWithIgnoreCase)(M,H):M.indexOf(H)===0)}e.isParent=l;class f extends Error{constructor(H,N,U){super(H);this.fileOperationResult=N,this.options=U}}e.FileOperationError=f;class d extends f{constructor(H,N,U){super(H,2,U);this.stat=N}}e.NotModifiedSinceFileOperationError=d;var S;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function R(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=R;async function B(M,H){if(!H.hasProvider(n.URI.from({scheme:M.scheme})))return new Promise(N=>{const U=H.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===M.scheme&&V.added&&(U.dispose(),N())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(H){return(0,C.isNumber)(H)||(H=0),H<x.KB?(0,k.localize)(1,null,H.toFixed(0)):H<x.MB?(0,k.localize)(2,null,(H/x.KB).toFixed(2)):H<x.GB?(0,k.localize)(3,null,(H/x.MB).toFixed(2)):H<x.TB?(0,k.localize)(4,null,(H/x.GB).toFixed(2)):(0,k.localize)(5,null,(H/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var F;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function $(M){return{maxFileSize:M===0?300*x.MB:16*x.GB,maxHeapSize:M===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=$}),define(fe[86],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...y){this._entries=new Map;for(let[C,n]of y)this.set(C,n)}set(y,C){const n=this._entries.get(y);return this._entries.set(y,C),n}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}e.ServiceCollection=g}),define(fe[189],me([0,1,16,18,115,182,4,86]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class D extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class P{constructor(h=new k.ServiceCollection,w=!1,E){this._activeInstantiations=new Set,this._services=h,this._strict=w,this._parent=E,this._services.set(n.IInstantiationService,this)}createChild(h){return new P(h,this._strict,this)}invokeFunction(h,...w){let E=c.traceInvocation(h),T=!1;try{return h({get:o=>{if(T)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(o,E);if(!s)throw new Error(`[invokeFunction] unknown service '${o}'`);return s}},...w)}finally{T=!0,E.stop()}}createInstance(h,...w){let E,T;return h instanceof y.SyncDescriptor?(E=c.traceCreation(h.ctor),T=this._createInstance(h.ctor,h.staticArguments.concat(w),E)):(E=c.traceCreation(h),T=this._createInstance(h,w,E)),E.stop(),T}_createInstance(h,w=[],E){let T=n._util.getServiceDependencies(h).sort((s,p)=>s.index-p.index),b=[];for(const s of T){let p=this._getOrCreateServiceInstance(s.id,E);if(!p&&this._strict&&!s.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${s.id}.`);b.push(p)}let o=T.length>0?T[0].index:w.length;if(w.length!==o){console.warn(`[createInstance] First service dependency of ${h.name} at position ${o+1} conflicts with ${w.length} static arguments`);let s=o-w.length;s>0?w=w.concat(new Array(s)):w=w.slice(0,o)}return new h(...[...w,...b])}_setServiceInstance(h,w){if(this._services.get(h)instanceof y.SyncDescriptor)this._services.set(h,w);else if(this._parent)this._parent._setServiceInstance(h,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let w=this._services.get(h);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):w}_getOrCreateServiceInstance(h,w){let E=this._getServiceInstanceOrDescriptor(h);return E instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,E,w.branch(h,!0)):(w.branch(h,!1),E)}_safeCreateAndCacheServiceInstance(h,w,E){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,w,E)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,w,E){const T=new C.Graph(s=>s.id.toString());let b=0;const o=[{id:h,desc:w,_trace:E}];for(;o.length;){const s=o.pop();if(T.lookupOrInsertNode(s),b++>1e3)throw new D(T);for(let p of n._util.getServiceDependencies(s.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(p.id);if(!r&&!p.optional&&console.warn(`[createInstance] ${h} depends on ${p.id} which is NOT registered.`),r instanceof y.SyncDescriptor){const m={id:p.id,desc:r,_trace:s._trace.branch(p.id,!0)};T.insertEdge(s,m),o.push(m)}}}for(;;){const s=T.roots();if(s.length===0){if(!T.isEmpty())throw new D(T);break}for(const{data:p}of s){if(this._getServiceInstanceOrDescriptor(p.id)instanceof y.SyncDescriptor){const m=this._createServiceInstanceWithOwner(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this._setServiceInstance(p.id,m)}T.removeNode(p)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,w,E=[],T,b){if(this._services.get(h)instanceof y.SyncDescriptor)return this._createServiceInstance(w,E,T,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,w,E,T,b);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(h,w=[],E,T){if(E){const b=new g.IdleValue(()=>this._createInstance(h,w,T));return new Proxy(Object.create(null),{get(o,s){if(s in o)return o[s];let p=b.value,r=p[s];return typeof r!="function"||(r=r.bind(p),o[s]=r),r},set(o,s,p){return b.value[s]=p,!0}})}else return this._createInstance(h,w,T)}}e.InstantiationService=P;var I;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(I||(I={}));class c{constructor(h,w){this.type=h,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return _?new c(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(h){return _?new c(0,h.name):c._None}branch(h,w){let E=new c(2,h.toString());return this._dep.push([h,w,E]),E}stop(){let h=Date.now()-this._start;c._totals+=h;let w=!1;function E(b,o){let s=[],p=new Array(b+1).join("	");for(const[r,m,i]of o._dep)if(m&&i){w=!0,s.push(`${p}CREATES -> ${r}`);let t=E(b+1,i);t&&s.push(t)}else s.push(`${p}uses -> ${r}`);return s.join(`
`)}let T=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(h>2||w)&&console.log(T.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(fe[11],me([0,1,52,3,6,12,4]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,n.createDecorator)("logService"),e.ILoggerService=(0,n.createDecorator)("loggerService");function k(){return new Date().toISOString()}var _;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;function D(m,i,t){switch(i){case _.Trace:m.trace(t);break;case _.Debug:m.debug(t);break;case _.Info:m.info(t);break;case _.Warning:m.warn(t);break;case _.Error:m.error(t);break;case _.Critical:m.critical(t);break;default:throw new Error("Invalid log level")}}e.log=D;function P(m){let i="";for(let t=0;t<m.length;t++){let u=m[t];if(typeof u=="object")try{u=JSON.stringify(u)}catch(a){}i+=(t>0?" ":"")+u}return i}e.format=P;class I extends y.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=I;class c extends I{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(_.Trace)&&this.log(_.Trace,P([i,...t]))}debug(i,...t){this.checkLogLevel(_.Debug)&&this.log(_.Debug,P([i,...t]))}info(i,...t){this.checkLogLevel(_.Info)&&this.log(_.Info,P([i,...t]))}warn(i,...t){this.checkLogLevel(_.Warning)&&this.log(_.Warning,P([i,...t]))}error(i,...t){if(this.checkLogLevel(_.Error))if(i instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=i.stack,this.log(_.Error,P(u))}else this.log(_.Error,P([i,...t]))}critical(i,...t){this.checkLogLevel(_.Critical)&&this.log(_.Critical,P([i,...t]))}flush(){}}e.AbstractMessageLogger=c;class v extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!C.isWindows}trace(i,...t){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...t):console.log(`[main ${k()}]`,i,...t))}debug(i,...t){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...t):console.log(`[main ${k()}]`,i,...t))}info(i,...t){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,i,...t):console.log(`[main ${k()}]`,i,...t))}warn(i,...t){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,i,...t):console.warn(`[main ${k()}]`,i,...t))}error(i,...t){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,i,...t):console.error(`[main ${k()}]`,i,...t))}critical(i,...t){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,i,...t):console.error(`[main ${k()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=v;class h extends I{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class w extends I{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,g.toErrorMessage)(i,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class E extends I{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const u of this.logServices)u.trace(i,...t)}debug(i,...t){for(const u of this.logServices)u.debug(i,...t)}info(i,...t){for(const u of this.logServices)u.info(i,...t)}warn(i,...t){for(const u of this.logServices)u.warn(i,...t)}error(i,...t){for(const u of this.logServices)u.error(i,...t)}critical(i,...t){for(const u of this.logServices)u.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=E;class T extends y.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=T;class b extends y.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(u=>{this.logLevel=u,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(u))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let u=this.loggers.get(i.toString());return u||(u=this.doCreateLogger(i,t?.always?_.Trace:this.logLevel,t),this.loggers.set(i.toString(),u),t?.always||this.logLevelChangeableLoggers.push(u)),u}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class o{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(i){}getLevel(){return _.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=o;function s(m){if(m.verbose)return _.Trace;if(typeof m.logLevel=="string"){const i=p(m.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=s;function p(m){switch(m){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=p;function r(m){switch(m){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=r}),define(fe[190],me([0,1,43,11]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function y(_,D,P,I,c){try{const v=await new Promise((w,E)=>{Y(["spdlog"],w,E)});v.setFlushOn(L.LogLevel.Trace);const h=await v.createAsyncRotatingLogger(_,D,P,I);return c&&h.clearFormatters(),h}catch(v){console.error(v)}return null}function C(_,D,P,I){const c=Y.__$__nodeRequire("spdlog");return c.setFlushOn(L.LogLevel.Trace),c.createRotatingLogger(_,D,P,I)}e.createRotatingLogger=C;function n(_,D,P){switch(D){case L.LogLevel.Trace:_.trace(P);break;case L.LogLevel.Debug:_.debug(P);break;case L.LogLevel.Info:_.info(P);break;case L.LogLevel.Warning:_.warn(P);break;case L.LogLevel.Error:_.error(P);break;case L.LogLevel.Critical:_.critical(P);break;default:throw new Error("Invalid log level")}}class k extends L.AbstractMessageLogger{constructor(D,P,I,c,v){super();this.buffer=[],this.setLevel(v),this._loggerCreationPromise=this._createSpdLogLogger(D,P,I,c),this._register(this.onDidChangeLogLevel(h=>{this._logger&&this._logger.setLevel(h)}))}async _createSpdLogLogger(D,P,I,c){const v=I?6:1,h=30/v*g.ByteSize.MB,w=await y(D,P,h,v,c);if(w){this._logger=w,this._logger.setLevel(this.getLevel());for(const{level:E,message:T}of this.buffer)n(this._logger,E,T);this.buffer=[]}}log(D,P){this._logger?n(this._logger,D,P):this.getLevel()<=D&&this.buffer.push({level:D,message:P})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(fe[116],me([0,1,50,161,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var C;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(C=e.MarkerTag||(e.MarkerTag={}));var n;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(n=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function D(h,w){return w-h}_.compare=D;const P=Object.create(null);P[_.Error]=(0,L.localize)(0,null),P[_.Warning]=(0,L.localize)(1,null),P[_.Info]=(0,L.localize)(2,null);function I(h){return P[h]||""}_.toString=I;function c(h){switch(h){case g.default.Error:return _.Error;case g.default.Warning:return _.Warning;case g.default.Info:return _.Info;case g.default.Ignore:return _.Hint}}_.fromSeverity=c;function v(h){switch(h){case _.Error:return g.default.Error;case _.Warning:return g.default.Warning;case _.Info:return g.default.Info;case _.Hint:return g.default.Ignore}}_.toSeverity=v}(n=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(_){const D="";function P(c){return I(c,!0)}_.makeKey=P;function I(c,v){let h=[D];return c.source?h.push(c.source.replace("\xA6","\\\xA6")):h.push(D),c.code?typeof c.code=="string"?h.push(c.code.replace("\xA6","\\\xA6")):h.push(c.code.value.replace("\xA6","\\\xA6")):h.push(D),c.severity!==void 0&&c.severity!==null?h.push(n.toString(c.severity)):h.push(D),c.message&&v?h.push(c.message.replace("\xA6","\\\xA6")):h.push(D),c.startLineNumber!==void 0&&c.startLineNumber!==null?h.push(c.startLineNumber.toString()):h.push(D),c.startColumn!==void 0&&c.startColumn!==null?h.push(c.startColumn.toString()):h.push(D),c.endLineNumber!==void 0&&c.endLineNumber!==null?h.push(c.endLineNumber.toString()):h.push(D),c.endColumn!==void 0&&c.endColumn!==null?h.push(c.endColumn.toString()):h.push(D),h.push(D),h.join("\xA6")}_.makeKeyOptionalMessage=I})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,y.createDecorator)("markerService")}),define(fe[191],me([0,1,3,50,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,y.createDecorator)("notificationService");var C;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.GLOBAL=1]="GLOBAL"})(C=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var n;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(n=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new _,this.onDidClose=g.Event.None,this.onDidChangeVisibility=g.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.NoOpNotification=k;class _{infinite(){}done(){}total(P){}worked(P){}}e.NoOpProgress=_}),define(fe[192],me([0,1,6,8,2,4]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,C.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(_){return{resolved:_,dispose(){}}}});function n(_,D){return y.URI.isUri(_)?(0,L.equalsIgnoreCase)(_.scheme,D):(0,L.startsWithIgnoreCase)(_,D+":")}e.matchesScheme=n;function k(_,...D){return D.some(P=>n(_,P))}e.matchesSomeScheme=k}),define(fe[193],me([0,1,10,12,38,23]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const k=L.globals.vscode.context.configuration();if(k)n=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const k=(0,C.dirname)(g.FileAccess.asFileUri("",Y));n=Y.__$__nodeRequire((0,C.joinPath)(k,"product.json").fsPath);const _=Y.__$__nodeRequire((0,C.joinPath)(k,"package.json").fsPath);y.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`}),Object.assign(n,{version:_.version})}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=n});var $e=this&&this.__param||function(Y,e){return function(g,L){e(g,L,Y)}};define(fe[117],me([0,1,16,21,6,4]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,C.createDecorator)("progressService");var n;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(n=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let _=class extends y.Disposable{constructor(I,c){super();this.deferred=new g.DeferredPromise,c.withProgress(I,v=>(this.reporter=v,this.lastStep&&v.report(this.lastStep),this.deferred.p)),this._register((0,y.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=Ve([$e(1,e.IProgressService)],_),e.UnmanagedProgress=_;class D extends y.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new y.DisposableStore)}start(I){this.stop();const c=++this.currentOperationId,v=new L.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,y.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,y.toDisposable)(()=>v.cancel())),this.currentOperationDisposables.add((0,y.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:v.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=(0,C.createDecorator)("editorProgressService")}),define(fe[35],me([0,1,58,13]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class y{constructor(){this.data=new Map}add(n,k){g.ok(L.isString(n)),g.ok(L.isObject(k)),g.ok(!this.data.has(n),"There is already an extension with this id"),this.data.set(n,k)}knows(n){return this.data.has(n)}as(n){return this.data.get(n)||null}}e.Registry=new y}),define(fe[118],me([0,1,3,35]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function y(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class C{constructor(){this._onDidChangeSchema=new g.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,D){this.schemasById[y(_)]=D,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const n=new C;L.Registry.add(e.Extensions.JSONContribution,n)}),define(fe[87],me([0,1,15,3,13,156,118,35]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var _;(function(b){b.Multiline="multilineText",b.Singleline="singlelineText"})(_=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const P=k.Registry.as(n.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:C.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(o,s=!0){this.registerConfigurations([o],s)}registerConfigurations(o,s=!0){const p=this.doRegisterConfigurations(o,s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(o){const s=this.doDeregisterConfigurations(o);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}updateConfigurations({add:o,remove:s}){const p=[];p.push(...this.doDeregisterConfigurations(s)),p.push(...this.doRegisterConfigurations(o,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,g.distinct)(p))}registerDefaultConfigurations(o){const s=[],p=[];for(const r of o)for(const m in r)if(s.push(m),e.OVERRIDE_PROPERTY_PATTERN.test(m)){this.defaultValues[m]={...this.defaultValues[m]||{},...r[m]};const i={type:"object",default:this.defaultValues[m],description:C.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId};p.push(v(m)),this.configurationProperties[m]=i,this.defaultLanguageConfigurationOverridesNode.properties[m]=i}else{this.defaultValues[m]=r[m];const i=this.configurationProperties[m];i&&(this.updatePropertyDefaultValue(m,i),this.updateSchema(m,i))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterDefaultConfigurations(o){const s=[];for(const p of o)for(const r in p)if(s.push(r),delete this.defaultValues[r],e.OVERRIDE_PROPERTY_PATTERN.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const m=this.configurationProperties[r];m&&(this.updatePropertyDefaultValue(r,m),this.updateSchema(r,m))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const s of o)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,s){const p=[];return o.forEach(r=>{p.push(...this.validateAndRegisterProperties(r,s,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),p}doDeregisterConfigurations(o){const s=[],p=r=>{if(r.properties)for(const m in r.properties)s.push(m),delete this.configurationProperties[m],this.removeFromSchema(m,r.properties[m]);r.allOf&&r.allOf.forEach(m=>p(m))};for(const r of o){p(r);const m=this.configurationContributors.indexOf(r);m!==-1&&this.configurationContributors.splice(m,1)}return s}validateAndRegisterProperties(o,s=!0,p,r=3){r=y.isUndefinedOrNull(o.scope)?r:o.scope;let m=[],i=o.properties;if(i)for(let u in i){if(s&&E(u)){delete i[u];continue}const a=i[u];if(this.updatePropertyDefaultValue(u,a),e.OVERRIDE_PROPERTY_PATTERN.test(u)?a.scope=void 0:(a.scope=y.isUndefinedOrNull(a.scope)?r:a.scope,a.restricted=y.isUndefinedOrNull(a.restricted)?!!p?.restrictedConfigurations?.includes(u):a.restricted),i[u].hasOwnProperty("included")&&!i[u].included){this.excludedConfigurationProperties[u]=i[u],delete i[u];continue}else this.configurationProperties[u]=i[u];!i[u].deprecationMessage&&i[u].markdownDeprecationMessage&&(i[u].deprecationMessage=i[u].markdownDeprecationMessage),m.push(u)}let t=o.allOf;if(t)for(let u of t)m.push(...this.validateAndRegisterProperties(u,s,p,r));return m}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(o){const s=p=>{let r=p.properties;if(r)for(const i in r)this.updateSchema(i,r[i]);let m=p.allOf;m&&m.forEach(s)};s(o)}updateSchema(o,s){switch(e.allSettings.properties[o]=s,s.scope){case 1:e.applicationSettings.properties[o]=s;break;case 2:e.machineSettings.properties[o]=s;break;case 6:e.machineOverridableSettings.properties[o]=s;break;case 3:e.windowSettings.properties[o]=s;break;case 4:e.resourceSettings.properties[o]=s;break;case 5:e.resourceSettings.properties[o]=s,this.resourceLanguageSettingsSchema.properties[o]=s;break}}removeFromSchema(o,s){switch(delete e.allSettings.properties[o],s.scope){case 1:delete e.applicationSettings.properties[o];break;case 2:delete e.machineSettings.properties[o];break;case 6:delete e.machineOverridableSettings.properties[o];break;case 3:delete e.windowSettings.properties[o];break;case 4:case 5:delete e.resourceSettings.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const s=`[${o}]`,p={type:"object",description:C.localize(2,null),errorMessage:C.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,p),e.allSettings.properties[s]=p,e.applicationSettings.properties[s]=p,e.machineSettings.properties[s]=p,e.machineOverridableSettings.properties[s]=p,e.windowSettings.properties[s]=p,e.resourceSettings.properties[s]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,s){let p=this.defaultValues[o];y.isUndefined(p)&&(p=s.default),y.isUndefined(p)&&(p=h(s.type)),s.default=p}}const c="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(c);function v(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=v;function h(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const w=new I;k.Registry.add(e.Extensions.Configuration,w);function E(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?C.localize(5,null,b):w.getConfigurationProperties()[b]!==void 0?C.localize(6,null,b):null:C.localize(4,null)}e.validateProperty=E;function T(){const b=[],o=w.getConfigurationProperties();for(const s of Object.keys(o))b.push([s,o[s].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=T}),define(fe[119],me([0,1,25,13,2,87,4,35]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,n.createDecorator)("configurationService");function _(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof y.URI)}e.isConfigurationOverrides=_;var D;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=P;function I(m,i){const t=i?m?i.keys.filter(A=>m.keys.indexOf(A)===-1):[...i.keys]:[],u=m?i?m.keys.filter(A=>i.keys.indexOf(A)===-1):[...m.keys]:[],a=[];if(i&&m){for(const A of m.keys)if(i.keys.indexOf(A)!==-1){const R=T(m.contents,A),B=T(i.contents,A);g.equals(R,B)||a.push(A)}}const l=[],f=A=>{const R={};for(const B of A)for(const x of B.identifiers)R[p(x)]=B;return R},d=i?f(i.overrides):{},S=m?f(m.overrides):{};if(Object.keys(d).length)for(const A of t){const R=d[A];R&&l.push([(0,C.overrideIdentifierFromKey)(A),R.keys])}if(Object.keys(S).length)for(const A of u){const R=S[A];R&&l.push([(0,C.overrideIdentifierFromKey)(A),R.keys])}if(Object.keys(d).length&&Object.keys(S).length)for(const A of a){const R=S[A],B=d[A];if(R&&B){const x=I({contents:R.contents,keys:R.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});l.push([(0,C.overrideIdentifierFromKey)(A),[...x.added,...x.removed,...x.updated]])}}return{added:t,removed:u,updated:a,overrides:l}}e.compare=I;function c(m,i){const t=[];for(const u of Object.keys(m))if(C.OVERRIDE_PROPERTY_PATTERN.test(u)){const a={};for(const l in m[u])a[l]=m[u][l];t.push({identifiers:[(0,C.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(a),contents:v(a,i)})}return t}e.toOverrides=c;function v(m,i){const t=Object.create(null);for(let u in m)h(t,u,m[u],i);return t}e.toValuesTree=v;function h(m,i,t,u){const a=i.split("."),l=a.pop();let f=m;for(let d=0;d<a.length;d++){let S=a[d],A=f[S];switch(typeof A){case"undefined":A=f[S]=Object.create(null);break;case"object":break;default:u(`Ignoring ${i} as ${a.slice(0,d+1).join(".")} is ${JSON.stringify(A)}`);return}f=A}if(typeof f=="object"&&f!==null)try{f[l]=t}catch(d){u(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(f)}`)}else u(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(f)}`)}e.addToValueTree=h;function w(m,i){const t=i.split(".");E(m,t)}e.removeFromValueTree=w;function E(m,i){const t=i.shift();if(i.length===0){delete m[t];return}if(Object.keys(m).indexOf(t)!==-1){const u=m[t];typeof u=="object"&&!Array.isArray(u)&&(E(u,i),Object.keys(u).length===0&&delete m[t])}}function T(m,i,t){function u(f,d){let S=f;for(const A of d){if(typeof S!="object"||S===null)return;S=S[A]}return S}const a=i.split("."),l=u(m,a);return typeof l=="undefined"?t:l}e.getConfigurationValue=T;function b(m,i,t){Object.keys(i).forEach(u=>{u!=="__proto__"&&(u in m?L.isObject(m[u])&&L.isObject(i[u])?b(m[u],i[u],t):t&&(m[u]=i[u]):m[u]=i[u])})}e.merge=b;function o(){const m=k.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(m)}e.getConfigurationKeys=o;function s(){const m=Object.create(null),i=k.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let t in i){let u=i[t].default;h(m,t,u,a=>console.error(`Conflict in default settings: ${a}`))}return m}e.getDefaultValues=s;function p(m){return`[${m}]`}e.keyFromOverrideIdentifier=p;function r(m,i,t){const u=m.inspect(i),a=m.inspect(t);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:u.defaultValue}e.getMigratedSettingValue=r}),define(fe[194],me([0,1,15,3,61,6,24,25,13,2,119,87,35]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class v{constructor(r={},m=[],i=[]){this._contents=r,this._keys=m,this._overrides=i,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,P.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,m){const i=this.getContentsForOverrideIdentifer(m);return i?r?(0,P.getConfigurationValue)(i,r):i:void 0}getKeysForOverrideIdentifier(r){for(const m of this.overrides)if(m.identifiers.indexOf(r)!==-1)return m.keys;return[]}override(r){let m=this.overrideConfigurations.get(r);return m||(m=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,m)),m}merge(...r){const m=k.deepClone(this.contents),i=k.deepClone(this.overrides),t=[...this.keys];for(const u of r){this.mergeContents(m,u.contents);for(const a of u.overrides){const[l]=i.filter(f=>g.equals(f.identifiers,a.identifiers));l?this.mergeContents(l.contents,a.contents):i.push(k.deepClone(a))}for(const a of u.keys)t.indexOf(a)===-1&&t.push(a)}return new v(m,t,i)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const m=this.getContentsForOverrideIdentifer(r);if(!m||typeof m!="object"||!Object.keys(m).length)return this;let i={};for(const t of g.distinct([...Object.keys(this.contents),...Object.keys(m)])){let u=this.contents[t],a=m[t];a&&(typeof u=="object"&&typeof a=="object"?(u=k.deepClone(u),this.mergeContents(u,a)):u=a),i[t]=u}return new v(i,this.keys,this.overrides)}mergeContents(r,m){for(const i of Object.keys(m)){if(i in r&&_.isObject(r[i])&&_.isObject(m[i])){this.mergeContents(r[i],m[i]);continue}r[i]=k.deepClone(m[i])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?k.deepFreeze(r):r}getContentsForOverrideIdentifer(r){for(const m of this.overrides)if(m.identifiers.indexOf(r)!==-1)return m.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,m){this.addKey(r),(0,P.addToValueTree)(this.contents,r,m,i=>{throw new Error(i)})}removeValue(r){this.removeKey(r)&&(0,P.removeFromValueTree)(this.contents,r)}addKey(r){let m=this.keys.length;for(let i=0;i<m;i++)r.indexOf(this.keys[i])===0&&(m=i);this.keys.splice(m,1,r)}removeKey(r){let m=this.keys.indexOf(r);return m!==-1?(this.keys.splice(m,1),!0):!1}}e.ConfigurationModel=v;class h extends v{constructor(){const r=(0,P.getDefaultValues)(),m=(0,P.getConfigurationKeys)(),i=[];for(const t of Object.keys(r))I.OVERRIDE_PROPERTY_PATTERN.test(t)&&i.push({identifiers:[(0,I.overrideIdentifierFromKey)(t).trim()],keys:Object.keys(r[t]),contents:(0,P.toValuesTree)(r[t],u=>console.error(`Conflict in default settings file: ${u}`))});super(r,m,i)}}e.DefaultConfigurationModel=h;class w{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,m){if(!_.isUndefinedOrNull(r)){const i=this.doParseContent(r);this.parseRaw(i,m)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,m){this._raw=r;const{contents:i,keys:t,overrides:u,restricted:a}=this.doParseRaw(r,m);this._configurationModel=new v(i,t,u),this._restrictedConfigurations=a||[]}doParseContent(r){let m={},i=null,t=[],u=[],a=[];function l(d){Array.isArray(t)?t.push(d):i!==null&&(t[i]=d)}let f={onObjectBegin:()=>{let d={};l(d),u.push(t),t=d,i=null},onObjectProperty:d=>{i=d},onObjectEnd:()=>{t=u.pop()},onArrayBegin:()=>{let d=[];l(d),u.push(t),t=d,i=null},onArrayEnd:()=>{t=u.pop()},onLiteralValue:l,onError:(d,S,A)=>{a.push({error:d,offset:S,length:A})}};if(r)try{y.visit(r,f),m=t[0]||{}}catch(d){console.error(`Error while parsing settings file ${this._name}: ${d}`),this._parseErrors=[d]}return m}doParseRaw(r,m){const i=c.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),t=this.filter(r,i,!0,m);r=t.raw;const u=(0,P.toValuesTree)(r,f=>console.error(`Conflict in settings file ${this._name}: ${f}`)),a=Object.keys(r),l=(0,P.toOverrides)(r,f=>console.error(`Conflict in settings file ${this._name}: ${f}`));return{contents:u,keys:a,overrides:l,restricted:t.restricted}}filter(r,m,i,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:r,restricted:[]};const u={},a=[];for(let l in r)if(I.OVERRIDE_PROPERTY_PATTERN.test(l)&&i){const f=this.filter(r[l],m,!1,t);u[l]=f.raw,a.push(...f.restricted)}else{const f=m[l],d=f?typeof f.scope!="undefined"?f.scope:3:void 0;f?.restricted&&a.push(l),(d===void 0||t.scopes===void 0||t.scopes.includes(d))&&(t.skipRestricted&&f?.restricted||(u[l]=r[l]))}return{raw:u,restricted:a}}}e.ConfigurationModelParser=w;class E extends C.Disposable{constructor(r,m,i,t){super();this.userSettingsResource=r,this.scopes=m,this.fileService=t,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class T{constructor(r,m,i=new v,t=new v,u=new n.ResourceMap,a=new v,l=new n.ResourceMap,f=!0){this._defaultConfiguration=r,this._localUserConfiguration=m,this._remoteUserConfiguration=i,this._workspaceConfiguration=t,this._folderConfigurations=u,this._memoryConfiguration=a,this._memoryConfigurationByResource=l,this._freeze=f,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new n.ResourceMap,this._userConfiguration=null}getValue(r,m,i){return this.getConsolidateConfigurationModel(m,i).getValue(r)}updateValue(r,m,i={}){let t;i.resource?(t=this._memoryConfigurationByResource.get(i.resource),t||(t=new v,this._memoryConfigurationByResource.set(i.resource,t))):t=this._memoryConfiguration,m===void 0?t.removeValue(r):t.setValue(r,m),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,m,i){const t=this.getConsolidateConfigurationModel(m,i),u=this.getFolderConfigurationModelForResource(m.resource,i),a=m.resource?this._memoryConfigurationByResource.get(m.resource)||this._memoryConfiguration:this._memoryConfiguration,l=m.overrideIdentifier?this._defaultConfiguration.freeze().override(m.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),f=m.overrideIdentifier?this.userConfiguration.freeze().override(m.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),d=m.overrideIdentifier?this.localUserConfiguration.freeze().override(m.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),S=m.overrideIdentifier?this.remoteUserConfiguration.freeze().override(m.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),A=i?m.overrideIdentifier?this._workspaceConfiguration.freeze().override(m.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,R=u?m.overrideIdentifier?u.freeze().override(m.overrideIdentifier).getValue(r):u.freeze().getValue(r):void 0,B=m.overrideIdentifier?a.override(m.overrideIdentifier).getValue(r):a.getValue(r),x=t.getValue(r),F=g.distinct(g.flatten(t.overrides.map($=>$.identifiers))).filter($=>t.getOverrideValue(r,$)!==void 0);return{defaultValue:l,userValue:f,userLocalValue:d,userRemoteValue:S,workspaceValue:A,workspaceFolderValue:R,memoryValue:B,value:x,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:m.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,m.overrideIdentifier):void 0}:void 0,user:f!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:m.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,m.overrideIdentifier):void 0}:void 0,userLocal:d!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:m.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,m.overrideIdentifier):void 0}:void 0,userRemote:S!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:m.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,m.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:m.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,m.overrideIdentifier):void 0}:void 0,workspaceFolder:R!==void 0?{value:u?.freeze().getValue(r),override:m.overrideIdentifier?u?.freeze().getOverrideValue(r,m.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:a.getValue(r),override:m.overrideIdentifier?a.getOverrideValue(r,m.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(r){const m=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:m?m.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,m){this._folderConfigurations.set(r,m),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,m){const i=m.filter(t=>I.OVERRIDE_PROPERTY_PATTERN.test(t)).map(t=>{const u=(0,I.overrideIdentifierFromKey)(t),a=this._defaultConfiguration.getKeysForOverrideIdentifier(u),l=r.getKeysForOverrideIdentifier(u),f=[...l.filter(d=>a.indexOf(d)===-1),...a.filter(d=>l.indexOf(d)===-1),...a.filter(d=>!k.equals(this._defaultConfiguration.override(u).getValue(d),r.override(u).getValue(d)))];return[u,f]});return this.updateDefaultConfiguration(r),{keys:m,overrides:i}}compareAndUpdateLocalUserConfiguration(r){const{added:m,updated:i,removed:t,overrides:u}=(0,P.compare)(this.localUserConfiguration,r),a=[...m,...i,...t];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:u}}compareAndUpdateRemoteUserConfiguration(r){const{added:m,updated:i,removed:t,overrides:u}=(0,P.compare)(this.remoteUserConfiguration,r);let a=[...m,...i,...t];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:u}}compareAndUpdateWorkspaceConfiguration(r){const{added:m,updated:i,removed:t,overrides:u}=(0,P.compare)(this.workspaceConfiguration,r);let a=[...m,...i,...t];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:u}}compareAndUpdateFolderConfiguration(r,m){const i=this.folderConfigurations.get(r),{added:t,updated:u,removed:a,overrides:l}=(0,P.compare)(i,m);let f=[...t,...u,...a];return(f.length||!i)&&this.updateFolderConfiguration(r,m),{keys:f,overrides:l}}compareAndDeleteFolderConfiguration(r){const m=this.folderConfigurations.get(r);if(!m)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:i,updated:t,removed:u,overrides:a}=(0,P.compare)(m,void 0);return{keys:[...i,...t,...u],overrides:a}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,m){let i=this.getConsolidatedConfigurationModelForResource(r,m);return r.overrideIdentifier?i.override(r.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:r},m){let i=this.getWorkspaceConsolidatedConfiguration();if(m&&r){const t=m.getFolder(r);t&&(i=this.getFolderConsolidatedConfiguration(t.uri)||i);const u=this._memoryConfigurationByResource.get(r);u&&(i=i.merge(u))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let m=this._foldersConsolidatedConfigurations.get(r);if(!m){const i=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(r);t?(m=i.merge(t),this._freeze&&(m=m.freeze()),this._foldersConsolidatedConfigurations.set(r,m)):m=i}return m}getFolderConfigurationModelForResource(r,m){if(m&&r){const i=m.getFolder(r);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,m)=>{const{contents:i,overrides:t,keys:u}=this._folderConfigurations.get(m);return r.push([m,{contents:i,overrides:t,keys:u}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(m=>r.add(m)),this.userConfiguration.freeze().keys.forEach(m=>r.add(m)),this._workspaceConfiguration.freeze().keys.forEach(m=>r.add(m)),this._folderConfigurations.forEach(m=>m.freeze().keys.forEach(i=>r.add(i))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const m=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>m.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>m.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>m.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(r).forEach(t=>m.add(t))),[...m.values()]}static parse(r){const m=this.parseConfigurationModel(r.defaults),i=this.parseConfigurationModel(r.user),t=this.parseConfigurationModel(r.workspace),u=r.folders.reduce((a,l)=>(a.set(D.URI.revive(l[0]),this.parseConfigurationModel(l[1])),a),new n.ResourceMap);return new T(m,i,new v,t,u,new v,new n.ResourceMap,!1)}static parseConfigurationModel(r){return new v(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=T;function b(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const r=new Set,m=new Map;for(const t of p)t.keys.forEach(u=>r.add(u)),t.overrides.forEach(([u,a])=>{const l=(0,n.getOrSet)(m,u,new Set);a.forEach(f=>l.add(f))});const i=[];return m.forEach((t,u)=>i.push([u,[...t.values()]])),{keys:[...r.values()],overrides:i}}e.mergeChanges=b;class o{constructor(r,m,i,t){this.change=r,this.previous=m,this.currentConfiguraiton=i,this.currentWorkspace=t,this._previousConfiguration=void 0;const u=new Set;r.keys.forEach(l=>u.add(l)),r.overrides.forEach(([,l])=>l.forEach(f=>u.add(f))),this.affectedKeys=[...u.values()];const a=new v;this.affectedKeys.forEach(l=>a.setValue(l,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=T.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,m){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(m){const i=this.previousConfiguration?this.previousConfiguration.getValue(r,m,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(r,m,this.currentWorkspace);return!k.equals(i,t)}return!0}return!1}doesAffectedKeysTreeContains(r,m){let i=(0,P.toValuesTree)({[m]:!0},()=>{}),t;for(;typeof i=="object"&&(t=Object.keys(i)[0]);){if(r=r[t],!r)return!1;i=i[t]}return!0}}e.ConfigurationChangeEvent=o;class s extends o{constructor(r,m,i,t){super({keys:r.allKeys(),overrides:[]},void 0,r,m);this.source=i,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=s}),define(fe[120],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,g.createDecorator)("remoteAuthorityResolverService");var L;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(n,k=L.Unknown,_){super(n);this._message=n,this._code=k,this._detail=_,this.isHandled=k===L.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(n){return n instanceof y&&n._code===L.TemporarilyNotAvailable}static isNoResolverFound(n){return n instanceof y&&n._code===L.NoResolverFound}static isHandled(n){return n instanceof y&&n.isHandled}}e.RemoteAuthorityResolverError=y}),define(fe[64],me([0,1,10]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(D){return D.scheme===g.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=L;function y(D){if(!D)return;const P=D.indexOf("+");return P<0?D:D.substr(0,P)}e.getRemoteName=y;function C(D){return D.scheme!==g.Schemas.file&&D.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=C;function n(D){if(D.folders.length)return D.folders.every(P=>C(P.uri))?D.folders[0].uri:void 0;if(D.configuration&&C(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=n;function k(D){return n(D)?.scheme}e.getVirtualWorkspaceScheme=k;function _(D){return n(D)!==void 0}e.isVirtualWorkspace=_}),define(fe[27],me([0,1,8,4,64]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function C(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.getWorkspaceSupportTypeMessage=C;function n(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=n,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class _{constructor(v){this.value=v,this._lower=v.toLowerCase()}static equals(v,h){if(typeof v=="undefined"||v===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof v=="string"||typeof h=="string"){let w=typeof v=="string"?v:v.value,E=typeof h=="string"?h:h.value;return g.equalsIgnoreCase(w,E)}return v._lower===h._lower}static toKey(v){return typeof v=="string"?v.toLowerCase():v._lower}}e.ExtensionIdentifier=_;function D(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function P(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function I(c,v){if(v){const h=`onResolveRemoteAuthority:${(0,y.getRemoteName)(v)}`;return c.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(fe[195],me([0,1,8,27]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function y(h,w){return h.uuid&&w.uuid?h.uuid===w.uuid:h.id===w.id?!0:(0,g.compareIgnoreCase)(h.id,w.id)===0}e.areSameExtensions=y;class C{constructor(w,E){this.version=E,this.id=w.id,this.uuid=w.uuid}key(){return`${this.id}-${this.version}`}equals(w){return w instanceof C?y(this,w)&&this.version===w.version:!1}}e.ExtensionIdentifierWithVersion=C;function n(h,w){return`${h}.${w}`}e.getExtensionId=n;function k(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function _(h,w){return k(n(h,w))}e.getGalleryExtensionId=_;function D(h,w){const E=[],T=b=>{for(const o of E)if(o.some(s=>y(w(s),w(b))))return o;return null};for(const b of h){const o=T(b);o?o.push(b):E.push([b])}return E}e.groupByExtension=D;function P(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function I(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function c(h){const w=new Set;for(const E of h)E.malicious&&w.add(E.id.id);return w}e.getMaliciousExtensionsSet=c;function v(h,w){const E=[],T=w.manifest.extensionDependencies?.slice(0)??[];for(;T.length;){const b=T.shift();if(b&&E.every(o=>!y(o.identifier,{id:b}))){const o=h.filter(s=>y(s.identifier,{id:b}));o.length===1&&(E.push(o[0]),T.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=v}),define(fe[121],me([0,1,3,12,4,11]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,y.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,y.createDecorator)("sharedTunnelsService");var n;(function(h){h.Http="http",h.Https="https"})(n=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var _;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(_=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function D(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=D,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=I;function c(h,w){return w?w!==1&&h<1024:!L.isWindows&&h<1024}e.isPortPrivileged=c;let v=class{constructor(w){this.logService=w,this._onTunnelOpened=new g.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new g.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new g.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w,E){return this._tunnelProvider=w,w?(this._canElevate=E.elevation,this._privacyOptions=E.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],E=Array.from(this._tunnels.values());for(let T of E){const b=Array.from(T.values());for(let o of b){const s=await o.value;s&&w.push(s)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:E}of w.values())await E.then(T=>T?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,E,T,b,o=!1,s=k.Private,p){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${T} on local port ${b}.`),!w)return;E||(E="localhost");const r=this.retainOrCreateTunnel(w,E,T,b,o,s,p);return r?r.then(m=>{if(!m){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,T);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(m);return(m.tunnelRemoteHost!==E||m.tunnelRemotePort!==T)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const E=this._tunnels.get(w.tunnelRemoteHost);if(E){const T=E.get(w.tunnelRemotePort);T&&(T.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,T))}}}}async tryDisposeTunnel(w,E,T){if(T.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${E}.`);const b=T.value.then(async o=>{o&&(await o.dispose(!0),this._onTunnelClosed.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(E),b}}async closeTunnel(w,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${E} `);const T=this._tunnels.get(w);if(T&&T.has(E)){const b=T.get(E);b.refcount=0,await this.tryDisposeTunnel(w,E,b)}}addTunnelToMap(w,E,T){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(E,{refcount:1,value:T})}async removeEmptyTunnelFromMap(w,E){const T=this._tunnels.get(w);T&&(await T.get(E)||T.delete(E),T.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,E){let T=[w];P(w)?(T.push(...e.LOCALHOST_ADDRESSES),T.push(...e.ALL_INTERFACES_ADDRESSES)):I(w)&&T.push(...e.ALL_INTERFACES_ADDRESSES);const b=T.map(o=>this._tunnels.get(o));for(const o of b){const s=o?.get(E);if(s)return s}}canTunnel(w){return!!D(w)}createWithProvider(w,E,T,b,o,s,p){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${T} on local port ${b}.`);const m={elevationRequired:o?c(b===void 0?T:b):!1},i={remoteAddress:{host:E,port:T},localAddressPort:b,privacy:s,public:s!==k.Private,protocol:p},t=w.forwardPort(i,m);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(E,T,t),t}};v=Ve([$e(0,C.ILogService)],v),e.AbstractTunnelService=v}),define(fe[196],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class g{constructor(){this.validators=new Map}vsda(){return new Promise((y,C)=>Y(["vsda"],y,C))}async createNewMessage(y){try{const C=await this.vsda(),n=new C.validator;if(n){const k=String(g._nextId++);return this.validators.set(k,n),{id:k,data:n.createNewMessage(y)}}}catch(C){}return{id:"",data:y}}async validate(y,C){if(!y.id)return!0;const n=this.validators.get(y.id);if(!n)return!1;this.validators.delete(y.id);try{return n.validate(C)==="ok"}catch(k){return!1}}async sign(y){try{const C=await this.vsda(),n=new C.signer;if(n)return n.sign(y)}catch(C){}return y}}e.SignService=g,g._nextId=1}),define(fe[197],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(y){this._callback=y,this._terminalBufferMap=new Map}dispose(){for(const y of this._terminalBufferMap.values())y.dispose()}startBuffering(y,C,n=5){let k;return k=C(_=>{const D=typeof _=="string"?_:_.data;let P=this._terminalBufferMap.get(y);if(P){P.data.push(D);return}const I=setTimeout(()=>this.flushBuffer(y),n);P={data:[D],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(y),k.dispose()}},this._terminalBufferMap.set(y,P)}),k}stopBuffering(y){const C=this._terminalBufferMap.get(y);C&&C.dispose()}flushBuffer(y){const C=this._terminalBufferMap.get(y);C&&(this._terminalBufferMap.delete(y),this._callback(y,C.data.join("")))}}e.TerminalDataBufferer=g}),define(fe[198],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var g;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(g=e.ColorScheme||(e.ColorScheme={}))}),define(fe[65],me([0,1,48,3,6,4,35,198]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,C.createDecorator)("themeService");var _;(function(E){function T(b){return b&&typeof b=="object"&&typeof b.id=="string"}E.isThemeColor=T})(_=e.ThemeColor||(e.ThemeColor={}));function D(E){return{id:E}}e.themeColorFromId=D;var P;(function(E){function T(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||_.isThemeColor(i.color))}E.isThemeIcon=T;const b=new RegExp(`^\\$\\((${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?)\\)$`);function o(i){const t=b.exec(i);if(!t)return;let[,u]=t;return{id:u}}E.fromString=o;function s(i,t){let u=i.id;const a=u.lastIndexOf("~");return a!==-1&&(u=u.substring(0,a)),t&&(u=`${u}~${t}`),{id:u}}E.modify=s;function p(i){const t=i.id.lastIndexOf("~");if(t!==-1)return i.id.substring(t+1)}E.getModifier=p;function r(i,t){return i.id===t.id&&i.color?.id===t.color?.id}E.isEqual=r;function m(i,t){return{id:i.id,color:t?D(t):void 0}}E.asThemeIcon=m,E.asClassNameArray=g.CSSIcon.asClassNameArray,E.asClassName=g.CSSIcon.asClassName,E.asCSSSelector=g.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=g.Codicon.file,e.FolderThemeIcon=g.Codicon.folder;function I(E){switch(E){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(T){return this.themingParticipants.push(T),this.onThemingParticipantAddedEmitter.fire(T),(0,y.toDisposable)(()=>{const b=this.themingParticipants.indexOf(T);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let v=new c;n.Registry.add(e.Extensions.ThemingContribution,v);function h(E){return v.onColorThemeChange(E)}e.registerThemingParticipant=h;class w extends y.Disposable{constructor(T){super();this.themeService=T,this.theme=T.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(T){this.theme=T,this.updateStyles()}updateStyles(){}getColor(T,b){let o=this.theme.getColor(T);return o&&b&&(o=b(o,this.theme)),o?o.toString():null}}e.Themable=w}),define(fe[199],me([0,1,16,48,3,162,118,35,65]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class D{constructor(){this._onDidChange=new y.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,C.localize)(0,null)},fontCharacter:{type:"string",description:(0,C.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${L.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(T,b,o,s){const p=this.iconsById[T];if(p){if(o&&!p.description){p.description=o,this.iconSchema.properties[T].markdownDescription=`${o} $(${T})`;const i=this.iconReferenceSchema.enum.indexOf(T);i!==-1&&(this.iconReferenceSchema.enumDescriptions[i]=o),this._onDidChange.fire()}return p}let r={id:T,description:o,defaults:b,deprecationMessage:s};this.iconsById[T]=r;let m={$ref:"#/definitions/icons"};return s&&(m.deprecationMessage=s),o&&(m.markdownDescription=`${o}: $(${T})`),this.iconSchema.properties[T]=m,this.iconReferenceSchema.enum.push(T),this.iconReferenceSchema.enumDescriptions.push(o||""),this._onDidChange.fire(),{id:T}}deregisterIcon(T){delete this.iconsById[T],delete this.iconSchema.properties[T];const b=this.iconReferenceSchema.enum.indexOf(T);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(T=>this.iconsById[T])}getIcon(T){return this.iconsById[T]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(T,b){const o=this.iconFontsById[T];if(o)return o;let s={id:T,definition:b};return this.iconFontsById[T]=s,this._onDidChange.fire(),s}deregisterIconFont(T){delete this.iconFontsById[T]}getIconFonts(){return Object.keys(this.iconFontsById).map(T=>this.iconFontsById[T])}getIconFont(T){return this.iconFontsById[T]}toString(){const T=(p,r)=>p.id.localeCompare(r.id),b=p=>{for(;_.ThemeIcon.isThemeIcon(p.defaults);)p=this.iconsById[p.defaults.id];return`codicon codicon-${p?p.id:""}`};let o=[];o.push("| preview     | identifier                        | default codicon ID                | description"),o.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.iconsById).map(p=>this.iconsById[p]);for(const p of s.filter(r=>!!r.description).sort(T))o.push(`|<i class="${b(p)}"></i>|${p.id}|${_.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);o.push("| preview     | identifier                        "),o.push("| ----------- | --------------------------------- |");for(const p of s.filter(r=>!_.ThemeIcon.isThemeIcon(r.defaults)).sort(T))o.push(`|<i class="${b(p)}"></i>|${p.id}|`);return o.join(`
`)}}const P=new D;k.Registry.add(e.Extensions.IconContribution,P);function I(E,T,b,o){return P.registerIcon(E,T,b,o)}e.registerIcon=I;function c(){return P}e.getIconRegistry=c;function v(){for(const E of L.iconRegistry.all)P.registerIcon(E.id,E.definition,E.description);L.iconRegistry.onDidRegister(E=>P.registerIcon(E.id,E.definition,E.description))}v(),e.iconsSchemaId="vscode://schemas/icons";let h=k.Registry.as(n.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,P.getIconSchema());const w=new g.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);P.onDidChange(()=>{w.isScheduled()||w.schedule()}),e.widgetClose=I("widget-close",L.Codicon.close,(0,C.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",L.Codicon.arrowUp,(0,C.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",L.Codicon.arrowDown,(0,C.localize)(4,null)),e.syncing=_.ThemeIcon.modify(L.Codicon.sync,"spin"),e.spinningLoading=_.ThemeIcon.modify(L.Codicon.loading,"spin")}),define(fe[44],me([0,1,24,23,2,4]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");var n;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(n=e.WorkbenchState||(e.WorkbenchState={}));function k(c){const v=c;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.isWorkspace=k;function _(c){const v=c;return!!(v&&typeof v=="object"&&y.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.isWorkspaceFolder=_;class D{constructor(v,h,w,E,T){this._id=v,this._transient=w,this._configuration=E,this._ignorePathCasing=T,this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=h}update(v){this._id=v.id,this._configuration=v.configuration,this._transient=v.transient,this._ignorePathCasing=v._ignorePathCasing,this.folders=v.folders}get folders(){return this._folders}set folders(v){this._folders=v,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(v){this._configuration=v}getFolder(v){return v&&this._foldersMap.findSubstr(v.with({scheme:v.scheme,authority:v.authority,path:v.path}))||null}updateFoldersMap(){this._foldersMap=g.TernarySearchTree.forUris(this._ignorePathCasing);for(const v of this.folders)this._foldersMap.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=D;class P{constructor(v,h){this.raw=h,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,L.joinPath)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=P;function I(c){return new P({uri:c,index:0,name:(0,L.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=I}),define(fe[200],me([0,1,30,61,140,81,10,9,12,23,2,163,4,64,44]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const w=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(M){return(typeof M=="string"?(0,k.extname)(M):(0,D.extname)(M))===w}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,c.createDecorator)("workspacesService");function T(M){return M.hasOwnProperty("workspace")}e.isRecentWorkspace=T;function b(M){return M.hasOwnProperty("folderUri")}e.isRecentFolder=b;function o(M){return M.hasOwnProperty("fileUri")}e.isRecentFile=o;function s(M){const H=M;return typeof H?.id=="string"&&P.URI.isUri(H.uri)}e.isSingleFolderWorkspaceIdentifier=s;function p(M){if(M.configuration)return{id:M.id,configPath:M.configuration};if(M.folders.length===1)return{id:M.id,uri:M.folders[0].uri}}e.toWorkspaceIdentifier=p;function r(M){const H=M;return typeof H?.id=="string"&&P.URI.isUri(H.configPath)}e.isWorkspaceIdentifier=r;function m(M){const H=M;if(H?.uri)return{id:H.id,uri:P.URI.revive(H.uri)};const N=M;if(N?.configPath)return{id:N.id,configPath:P.URI.revive(N.configPath)};if(M?.id)return{id:M.id}}e.reviveIdentifier=m;function i(M,H){return D.extUriBiasedIgnorePathCase.isEqualOrParent(M,H.untitledWorkspacesHome)}e.isUntitledWorkspace=i;function t(M){return u(M)||a(M)}e.isStoredWorkspaceFolder=t;function u(M){const H=M;return typeof H?.path=="string"&&(!H.name||typeof H.name=="string")}e.isRawFileWorkspaceFolder=u;function a(M){const H=M;return typeof H?.uri=="string"&&(!H.name||typeof H.name=="string")}e.isRawUriWorkspaceFolder=a;function l(M,H,N,U,V=!_.isWindows,O){if(M.scheme!==U.scheme)return{name:N,uri:M.toString(!0)};let W=H?void 0:O.relativePath(U,M);if(W!==void 0)W.length===0?W=".":_.isWindows&&M.scheme===n.Schemas.file&&!V&&(W=W.replace(/\//g,"\\"));else if(M.scheme===n.Schemas.file)W=M.fsPath,_.isWindows&&(W=(0,C.normalizeDriveLetter)(W),V&&(W=(0,g.toSlashes)(W)));else{if(!O.isEqualAuthority(M.authority,U.authority))return{name:N,uri:M.toString(!0)};W=M.path}return{name:N,path:W}}e.getStoredWorkspaceFolder=l;function f(M,H,N){let U=[],V=new Set;const O=N.dirname(H);for(let W of M){let j;if(u(W))W.path&&(j=N.resolvePath(O,W.path));else if(a(W))try{j=P.URI.parse(W.uri),j.path[0]!=="/"&&(j=j.with({path:"/"+j.path}))}catch(X){console.warn(X)}if(j){let X=N.getComparisonKey(j);if(!V.has(X)){V.add(X);const Q=W.name||N.basenameOrAuthority(j);U.push(new h.WorkspaceFolder({uri:j,name:Q,index:U.length},W))}}}return U}e.toWorkspaceFolders=f;function d(M,H,N,U,V){let O=S(H,M);const W=V.dirname(H),j=V.dirname(U),X=[],Q=A(O.folders);for(const Pe of O.folders){const Be=u(Pe)?V.resolvePath(W,Pe.path):P.URI.parse(Pe.uri);let We;N?We=!1:We=!u(Pe)||(0,k.isAbsolute)(Pe.path),X.push(l(Be,We,Pe.name,j,Q,V))}const de={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},Se=y.setProperty(M,["folders"],X,de);let De=y.applyEdits(M,Se);return(0,D.isEqualAuthority)(O.remoteAuthority,(0,v.getRemoteAuthority)(U))&&(De=y.applyEdits(De,y.removeProperty(De,["remoteAuthority"],de))),De}e.rewriteWorkspaceFileForNewLocation=d;function S(M,H){let N=L.parse(H);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(U=>t(U));else throw new Error(`${M} looks like an invalid workspace file.`);return N}function A(M){return _.isWindows?M.some(H=>u(H)&&H.path.indexOf("/")>=0):!0}e.useSlashForPath=A;function R(M){return M.workspace&&typeof M.workspace=="object"&&typeof M.workspace.id=="string"&&typeof M.workspace.configPath=="string"}function B(M){return typeof M.folderUri=="string"}function x(M){return typeof M.fileUri=="string"}function F(M,H){const N={workspaces:[],files:[]};if(M){const U=function(O,W){for(let j=0;j<O.length;j++)try{W(O[j],j)}catch(X){H.warn(`Error restoring recent entry ${JSON.stringify(O[j])}: ${X.toString()}. Skip entry.`)}},V=M;if(Array.isArray(V.entries))U(V.entries,O=>{const W=O.label,j=O.remoteAuthority;R(O)?N.workspaces.push({label:W,remoteAuthority:j,workspace:{id:O.workspace.id,configPath:P.URI.parse(O.workspace.configPath)}}):B(O)?N.workspaces.push({label:W,remoteAuthority:j,folderUri:P.URI.parse(O.folderUri)}):x(O)&&N.files.push({label:W,remoteAuthority:j,fileUri:P.URI.parse(O.fileUri)})});else{const O=M;Array.isArray(O.workspaces3)&&U(O.workspaces3,(W,j)=>{const X=Array.isArray(O.workspaceLabels)&&O.workspaceLabels[j]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?N.workspaces.push({label:X,workspace:{id:W.id,configPath:P.URI.parse(W.configURIPath)}}):typeof W=="string"&&N.workspaces.push({label:X,folderUri:P.URI.parse(W)})}),Array.isArray(O.files2)&&U(O.files2,(W,j)=>{const X=Array.isArray(O.fileLabels)&&O.fileLabels[j]||void 0;typeof W=="string"&&N.files.push({label:X,fileUri:P.URI.parse(W)})})}}return N}e.restoreRecentlyOpened=F;function $(M){const H={entries:[]};for(const N of M.workspaces)b(N)?H.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):H.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of M.files)H.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return H}e.toStoreData=$}),define(fe[88],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(y){this.id=y,this._data=new Map,this._idPool=1}add(y){const C=this._idPool++;return this._data.set(C,y),this.logDebugInfo(),C}get(y,C){return this._data.has(y)?this._data.get(y)[C]:void 0}delete(y){this._data.delete(y),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(fe[45],me([0,1,10,23,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map,this.extUri=new L.ExtUri(k=>{const _=this._providerInfo.get(k.scheme);return!(_===void 0||_&1024)})}$acceptProviderInfos(k,_){_===null?this._providerInfo.delete(k):this._providerInfo.set(k,_)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=(0,y.createDecorator)("IExtHostFileSystemInfo")}),define(fe[26],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,g.createDecorator)("IExtHostInitDataService")}),define(fe[201],me([0,1,16]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(n,k,_){this._deferredPromises=new Map,this._id=n,this._shared=k,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const P of D.values())P.complete()}catch(P){for(const I of D.values())I.error(P)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,n])=>n!==void 0).map(([n])=>n)}get whenReady(){return this._init}get(n,k){let _=this._value[n];return typeof _=="undefined"&&(_=k),_}update(n,k){this._value[n]=k;let _=this._deferredPromises.get(n);if(_!==void 0)return _.p;const D=new g.DeferredPromise;return this._deferredPromises.set(n,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=L;class y extends L{constructor(n,k){super(n.identifier.value,!0,k);this._extension=n}setKeysForSync(n){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},n)}}e.ExtensionGlobalMemento=y}),define(fe[202],me([0,1,3,2,11]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(k,_){this._logService=k,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(k,_,D){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptModelChanged(_.value,D)}$acceptDirtyStateChanged(k,_){this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k)).acceptDirty(_)}$acceptModelSaved(k){const _=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(k,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",k.path,_);const D=this._notebooksAndEditors.getNotebookDocument(L.URI.revive(k));D.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:D.apiNotebook})}};C=Ve([$e(0,y.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(fe[14],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,g.createDecorator)("IExtHostRpcService");class L{constructor(C){this.getProxy=C.getProxy.bind(C),this.set=C.set.bind(C),this.assertRegistered=C.assertRegistered.bind(C),this.drain=C.drain.bind(C)}}e.ExtHostRpcService=L});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[203],me([0,1,27,3]),function(Y,e,g,L){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class C{constructor(k,_){y.set(this,void 0),this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(k.identifier),st(this,y,_,"f"),Oe(this,y,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(k){return Oe(this,y,"f").get(this._id,k)}store(k,_){return Oe(this,y,"f").store(this._id,k,_)}delete(k){return Oe(this,y,"f").delete(this._id,k)}}e.ExtensionSecrets=C,y=new WeakMap}),define(fe[122],me([0,1,4,3]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class y{constructor(){this._onDidChangeTelemetryEnabled=new L.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(n){this._enabled=n}$onDidChangeTelemetryEnabled(n){this._enabled=n,this._onDidChangeTelemetryEnabled.fire(n)}}e.ExtHostTelemetry=y,e.IExtHostTelemetry=(0,g.createDecorator)("IExtHostTelemetry")}),define(fe[66],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var g;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(g=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const L=new WeakMap,y=(b,o)=>{const s={controllerId:o};return L.set(b,s),s};e.createPrivateApiFor=y;const C=b=>L.get(b);e.getPrivateApiFor=C;const n=(b,o,s,p)=>{let r=s;return{enumerable:!0,configurable:!1,get(){return r},set(m){if(!p(r,m)){const i=r;r=m,b.listener?.({op:3,key:o,value:m,previous:i})}}}},k=(b,o)=>b===o,_={range:(b,o)=>b===o?!0:!b||!o?!1:b.isEqual(o),label:k,description:k,busy:k,error:k,canResolveChildren:k,tags:(b,o)=>!(b.length!==o.length||b.some(s=>!o.find(p=>s.id===p.id)))},D=Object.keys(_),P=(b,o)=>({range:n(b,"range",void 0,_.range),label:n(b,"label",o,_.label),description:n(b,"description",void 0,_.description),canResolveChildren:n(b,"canResolveChildren",!1,_.canResolveChildren),busy:n(b,"busy",!1,_.busy),error:n(b,"error",void 0,_.error),tags:n(b,"tags",[],_.tags)}),I=(b,o)=>{const s=new Map;for(const p of D)_[p](b[p],o[p])||s.set(p,o[p]);return s};e.diffTestItems=I;class c extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.DuplicateTestItemError=c;class v extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=v;class h extends Error{constructor(o,s,p){super(`TestItem with ID "${o}" is from controller "${s}" and cannot be added as a child of an item from controller "${p}".`)}}e.MixedTestItemController=h;const w=b=>{const o=(0,e.getPrivateApiFor)(b);let s=new Map;return{get size(){return s.size},forEach(p,r){for(const m of s.values())p.call(r,m,this)},replace(p){const r=new Map,m=new Set(s.keys()),i={op:4,ops:[]};for(const t of p){if(!(t instanceof E))throw new v(t.id);const u=(0,e.getPrivateApiFor)(t).controllerId;if(u!==o.controllerId)throw new h(t.id,u,o.controllerId);if(r.has(t.id))throw new c(t.id);r.set(t.id,t),m.delete(t.id),i.ops.push({op:0,item:t})}for(const t of m.keys())i.ops.push({op:1,id:t});o.listener?.(i),s=r},add(p){if(!(p instanceof E))throw new v(p.id);s.set(p.id,p),o.listener?.({op:0,item:p})},delete(p){s.delete(p)&&o.listener?.({op:1,id:p})},get(p){return s.get(p)},toJSON(){return Array.from(s.values())},[Symbol.iterator](){return s.values()}}};class E{constructor(o,s,p,r){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const m=(0,e.createPrivateApiFor)(this,o);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return m.parent instanceof T?void 0:m.parent}},children:{value:w(this),enumerable:!0,writable:!1},...P(m,p)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=E;class T extends E{constructor(o,s){super(o,o,s,void 0)}}e.TestItemRootImpl=T}),define(fe[54],me([0,1,4,121,3,14]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var n;(function(_){function D(I){return{remoteAddress:I.remoteAddress,localAddress:I.localAddress,public:!!I.public,privacy:I.privacy??(I.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:I.protocol}}_.fromApiTunnel=D;function P(I){return{remoteAddress:{host:I.tunnelRemoteHost,port:I.tunnelRemotePort},localAddress:I.localAddress,public:I.privacy!==L.TunnelPrivacyId.ConstantPrivate&&I.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:I.privacy,protocol:I.protocol}}_.fromServiceTunnel=P})(n=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,g.createDecorator)("IExtHostTunnelService");let k=class{constructor(D){this.onDidChangeTunnels=new y.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,I,c,v){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([$e(0,C.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[7],me([0,1,15,18,98,24,102,8,13,2,32,43,120]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c){"use strict";var v,h,w,E,T,b,o,s,p,r,m,i,t,u,a,l,f,d,S,A;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R(q){function z(){return Reflect.construct(q,arguments,this.constructor)}return Object.defineProperty(z,"name",Object.getOwnPropertyDescriptor(q,"name")),Object.setPrototypeOf(z,q),Object.setPrototypeOf(z.prototype,q.prototype),z}let B=T=class{constructor(z){v.set(this,void 0),st(this,v,z,"f")}static from(...z){let oe=z;return new T(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}dispose(){typeof Oe(this,v,"f")=="function"&&(Oe(this,v,"f").call(this),st(this,v,void 0,"f"))}};v=new WeakMap,B=T=Ve([R],B),e.Disposable=B;let x=b=class{constructor(z,oe){if(z<0)throw(0,L.illegalArgument)("line must be non-negative");if(oe<0)throw(0,L.illegalArgument)("character must be non-negative");this._line=z,this._character=oe}static Min(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let ke=1;ke<z.length;ke++){const Je=z[ke];Je.isBefore(oe)&&(oe=Je)}return oe}static Max(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let ke=1;ke<z.length;ke++){const Je=z[ke];Je.isAfter(oe)&&(oe=Je)}return oe}static isPosition(z){if(!z)return!1;if(z instanceof b)return!0;let{line:oe,character:ke}=z;return typeof oe=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<z._character}isBeforeOrEqual(z){return this._line<z._line?!0:z._line<this._line?!1:this._character<=z._character}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this._line===z._line&&this._character===z._character}compareTo(z){return this._line<z._line?-1:this._line>z.line?1:this._character<z._character?-1:this._character>z._character?1:0}translate(z,oe=0){if(z===null||oe===null)throw(0,L.illegalArgument)();let ke;return typeof z=="undefined"?ke=0:typeof z=="number"?ke=z:(ke=typeof z.lineDelta=="number"?z.lineDelta:0,oe=typeof z.characterDelta=="number"?z.characterDelta:0),ke===0&&oe===0?this:new b(this.line+ke,this.character+oe)}with(z,oe=this.character){if(z===null||oe===null)throw(0,L.illegalArgument)();let ke;return typeof z=="undefined"?ke=this.line:typeof z=="number"?ke=z:(ke=typeof z.line=="number"?z.line:this.line,oe=typeof z.character=="number"?z.character:this.character),ke===this.line&&oe===this.character?this:new b(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};x=b=Ve([R],x),e.Position=x;let F=o=class{constructor(z,oe,ke,Je){let ot,ht;if(typeof z=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new x(z,oe),ht=new x(ke,Je)):z instanceof x&&oe instanceof x&&(ot=z,ht=oe),!ot||!ht)throw new Error("Invalid arguments");ot.isBefore(ht)?(this._start=ot,this._end=ht):(this._start=ht,this._end=ot)}static isRange(z){return z instanceof o?!0:z?x.isPosition(z.start)&&x.isPosition(z.end):!1}get start(){return this._start}get end(){return this._end}contains(z){return z instanceof o?this.contains(z._start)&&this.contains(z._end):z instanceof x?!(z.isBefore(this._start)||this._end.isBefore(z)):!1}isEqual(z){return this._start.isEqual(z._start)&&this._end.isEqual(z._end)}intersection(z){const oe=x.Max(z.start,this._start),ke=x.Min(z.end,this._end);if(!oe.isAfter(ke))return new o(oe,ke)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const oe=x.Min(z.start,this._start),ke=x.Max(z.end,this.end);return new o(oe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(z,oe=this.end){if(z===null||oe===null)throw(0,L.illegalArgument)();let ke;return z?x.isPosition(z)?ke=z:(ke=z.start||this.start,oe=z.end||this.end):ke=this.start,ke.isEqual(this._start)&&oe.isEqual(this.end)?this:new o(ke,oe)}toJSON(){return[this.start,this.end]}};F=o=Ve([R],F),e.Range=F;let $=s=class extends F{constructor(z,oe,ke,Je){let ot,ht;if(typeof z=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"?(ot=new x(z,oe),ht=new x(ke,Je)):z instanceof x&&oe instanceof x&&(ot=z,ht=oe),!ot||!ht)throw new Error("Invalid arguments");super(ot,ht);this._anchor=ot,this._active=ht}static isSelection(z){return z instanceof s?!0:z?F.isRange(z)&&x.isPosition(z.anchor)&&x.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};$=s=Ve([R],$),e.Selection=$;class M{constructor(z,oe,ke){if(typeof z!="string"||z.length===0)throw(0,L.illegalArgument)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,L.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,L.illegalArgument)("connectionToken");this.host=z,this.port=Math.round(oe),this.connectionToken=ke}}e.ResolvedAuthority=M;class H extends Error{constructor(z,oe=c.RemoteAuthorityResolverErrorCode.Unknown,ke){super(z);this._message=z,this._code=oe,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,H.prototype)}static NotAvailable(z,oe){return new H(z,c.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(z){return new H(z,c.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=H;var N;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(N=e.EndOfLine||(e.EndOfLine={}));var U;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(U=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let V=p=class{constructor(z,oe){this._range=z,this._newText=oe}static isTextEdit(z){return z instanceof p?!0:z?F.isRange(z)&&typeof z.newText=="string":!1}static replace(z,oe){return new p(z,oe)}static insert(z,oe){return p.replace(new F(z,z),oe)}static delete(z){return p.replace(z,"")}static setEndOfLine(z){const oe=new p(new F(new x(0,0),new x(0,0)),"");return oe.newEol=z,oe}get range(){return this._range}set range(z){if(z&&!F.isRange(z))throw(0,L.illegalArgument)("range");this._range=z}get newText(){return this._newText||""}set newText(z){if(z&&typeof z!="string")throw(0,L.illegalArgument)("newText");this._newText=z}get newEol(){return this._newEol}set newEol(z){if(z&&typeof z!="number")throw(0,L.illegalArgument)("newEol");this._newEol=z}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};V=p=Ve([R],V),e.TextEdit=V;var O;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace"})(O=e.FileEditType||(e.FileEditType={}));let W=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(z,oe,ke,Je){this._edits.push({_type:1,from:z,to:oe,options:ke,metadata:Je})}createFile(z,oe,ke){this._edits.push({_type:1,from:void 0,to:z,options:oe,metadata:ke})}deleteFile(z,oe,ke){this._edits.push({_type:1,from:z,to:void 0,options:oe,metadata:ke})}replaceNotebookMetadata(z,oe,ke){this._edits.push({_type:3,metadata:ke,uri:z,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(z,oe,ke,Je,ot){let ht,pt,It=[],Rt;if(Vt.isNotebookRange(oe)&&Mt.isNotebookCellDataArray(ke)&&!Mt.isNotebookCellDataArray(Je)?(ht=oe.start,pt=oe.end,It=ke,Rt=Je):typeof oe=="number"&&typeof ke=="number"&&Mt.isNotebookCellDataArray(Je)&&(ht=oe,pt=ke,It=Je,Rt=ot),ht===void 0||pt===void 0)throw new Error("Invalid arguments");(ht!==pt||It.length>0)&&this._edits.push({_type:5,uri:z,index:ht,count:pt-ht,cells:It,metadata:Rt})}replaceNotebookCellMetadata(z,oe,ke,Je){this._edits.push({_type:3,metadata:Je,uri:z,edit:{editType:8,index:oe,metadata:ke}})}replace(z,oe,ke,Je){this._edits.push({_type:2,uri:z,edit:new V(oe,ke),metadata:Je})}insert(z,oe,ke,Je){this.replace(z,new F(oe,oe),ke,Je)}delete(z,oe,ke){this.replace(z,oe,"",ke)}has(z){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===z.toString())}set(z,oe){if(oe)for(const ke of oe)ke&&this._edits.push({_type:2,uri:z,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Je=this._edits[ke];Je._type===2&&Je.uri.toString()===z.toString()&&(this._edits[ke]=void 0)}(0,g.coalesceInPlace)(this._edits)}}get(z){const oe=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===z.toString()&&oe.push(ke.edit);return oe}entries(){const z=new C.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ke=z.get(oe.uri);ke||(ke=[oe.uri,[]],z.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};W=Ve([R],W),e.WorkspaceEdit=W;let j=r=class{constructor(z){this._tabstop=1,this.value=z||""}static isSnippetString(z){return z instanceof r?!0:z?typeof z.value=="string":!1}static _escape(z){return z.replace(/\$|}|\\/g,"\\$&")}appendText(z){return this.value+=r._escape(z),this}appendTabstop(z=this._tabstop++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,oe=this._tabstop++){if(typeof z=="function"){const ke=new r;ke._tabstop=this._tabstop,z(ke),this._tabstop=ke._tabstop,z=ke.value}else z=r._escape(z);return this.value+="${",this.value+=oe,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,oe=this._tabstop++){const ke=z.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(z,oe){if(typeof oe=="function"){const ke=new r;ke._tabstop=this._tabstop,oe(ke),this._tabstop=ke._tabstop,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};j=r=Ve([R],j),e.SnippetString=j;var X;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(X=e.DiagnosticTag||(e.DiagnosticTag={}));var Q;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(Q=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let de=m=class{constructor(z,oe){if(this.uri=z,oe)if(oe instanceof F)this.range=oe;else if(oe instanceof x)this.range=new F(oe,oe);else throw new Error("Illegal argument")}static isLocation(z){return z instanceof m?!0:z?F.isRange(z.range)&&D.URI.isUri(z.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};de=m=Ve([R],de),e.Location=de;let Se=class{constructor(z,oe){this.location=z,this.message=oe}static is(z){return z?typeof z.message=="string"&&z.location&&F.isRange(z.location.range)&&D.URI.isUri(z.location.uri):!1}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.location.range.isEqual(oe.location.range)&&z.location.uri.toString()===oe.location.uri.toString()}};Se=Ve([R],Se),e.DiagnosticRelatedInformation=Se;let De=class{constructor(z,oe,ke=Q.Error){if(!F.isRange(z))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=z,this.message=oe,this.severity=ke}toJSON(){return{severity:Q[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.severity===oe.severity&&z.code===oe.code&&z.severity===oe.severity&&z.source===oe.source&&z.range.isEqual(oe.range)&&(0,g.equals)(z.tags,oe.tags)&&(0,g.equals)(z.relatedInformation,oe.relatedInformation,Se.isEqual)}};De=Ve([R],De),e.Diagnostic=De;let Pe=class{constructor(z,oe){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=oe}};Pe=Ve([R],Pe),e.Hover=Pe;var Be;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(Be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(z,oe=Be.Text){this.range=z,this.kind=oe}toJSON(){return{range:this.range,kind:Be[this.kind]}}};We=Ve([R],We),e.DocumentHighlight=We;var He;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var G;(function(q){q[q.Deprecated=1]="Deprecated"})(G=e.SymbolTag||(e.SymbolTag={}));let ee=i=class{constructor(z,oe,ke,Je,ot){this.name=z,this.kind=oe,this.containerName=ot,typeof ke=="string"&&(this.containerName=ke),Je instanceof de?this.location=Je:ke instanceof F&&(this.location=new de(Je,ke)),i.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};ee=i=Ve([R],ee),e.SymbolInformation=ee;let ne=t=class{constructor(z,oe,ke,Je,ot){this.name=z,this.detail=oe,this.kind=ke,this.range=Je,this.selectionRange=ot,this.children=[],t.validate(this)}static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children&&z.children.forEach(t.validate)}};ne=t=Ve([R],ne),e.DocumentSymbol=ne;var le;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(le=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let Z=class{constructor(z,oe){this.title=z,this.kind=oe}};Z=Ve([R],Z),e.CodeAction=Z;let re=u=class{constructor(z){this.value=z}append(z){return new u(this.value?this.value+u.sep+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+u.sep)}};re.sep=".",re=u=Ve([R],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let pe=class{constructor(z,oe){if(this.range=z,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};pe=Ve([R],pe),e.SelectionRange=pe;class Me{constructor(z,oe,ke,Je,ot,ht){this.kind=z,this.name=oe,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=ht}}e.CallHierarchyItem=Me;class je{constructor(z,oe){this.fromRanges=oe,this.from=z}}e.CallHierarchyIncomingCall=je;class Ke{constructor(z,oe){this.fromRanges=oe,this.to=z}}e.CallHierarchyOutgoingCall=Ke;var Ze;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let rt=class{constructor(z,oe){this.range=z,this.command=oe}get isResolved(){return!!this.command}};rt=Ve([R],rt),e.CodeLens=rt;let lt=a=class{constructor(z,oe=!1){h.set(this,void 0),st(this,h,new y.MarkdownString(z,{supportThemeIcons:oe}),"f")}static isMarkdownString(z){return z instanceof a?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}get value(){return Oe(this,h,"f").value}set value(z){Oe(this,h,"f").value=z}get isTrusted(){return Oe(this,h,"f").isTrusted}set isTrusted(z){Oe(this,h,"f").isTrusted=z}get supportThemeIcons(){return Oe(this,h,"f").supportThemeIcons}set supportThemeIcons(z){Oe(this,h,"f").supportThemeIcons=z}get supportHtml(){return Oe(this,h,"f").supportHtml}set supportHtml(z){Oe(this,h,"f").supportHtml=z}appendText(z){return Oe(this,h,"f").appendText(z),this}appendMarkdown(z){return Oe(this,h,"f").appendMarkdown(z),this}appendCodeblock(z,oe){return Oe(this,h,"f").appendCodeblock(oe??"",z),this}};h=new WeakMap,lt=a=Ve([R],lt),e.MarkdownString=lt;let ye=class{constructor(z,oe){this.label=z,this.documentation=oe}};ye=Ve([R],ye),e.ParameterInformation=ye;let at=class{constructor(z,oe){this.label=z,this.documentation=oe,this.parameters=[]}};at=Ve([R],at),e.SignatureInformation=at;let J=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};J=Ve([R],J),e.SignatureHelp=J;var ie;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(ie=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var _e;(function(q){q[q.Other=0]="Other",q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(_e=e.InlayHintKind||(e.InlayHintKind={}));let Qe=class{constructor(z,oe,ke){this.text=z,this.position=oe,this.kind=ke}};Qe=Ve([R],Qe),e.InlayHint=Qe;var et;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(et=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ce;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(ce=e.CompletionItemKind||(e.CompletionItemKind={}));var Ie;(function(q){q[q.Deprecated=1]="Deprecated"})(Ie=e.CompletionItemTag||(e.CompletionItemTag={}));let Ne=class{constructor(z,oe){this.label=z,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&ce[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ne=Ve([R],Ne),e.CompletionItem=Ne;let Xe=class{constructor(z=[],oe=!1){this.items=z,this.isIncomplete=oe}};Xe=Ve([R],Xe),e.CompletionList=Xe;let it=class{constructor(z,oe,ke){this.text=z,this.range=oe,this.command=ke}};it=Ve([R],it),e.InlineSuggestion=it;let ft=class{constructor(z){this.items=z}};ft=Ve([R],ft),e.InlineSuggestions=ft;var tt;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(tt=e.ViewColumn||(e.ViewColumn={}));var ut;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(ut=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Re;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(Re=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ve;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Te;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var se;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var be;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(be=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function z(oe){switch(oe){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=z}(se=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let we=class{constructor(z,oe){if(oe&&!D.URI.isUri(oe))throw(0,L.illegalArgument)("target");if(!F.isRange(z)||z.isEmpty)throw(0,L.illegalArgument)("range");this.range=z,this.target=oe}};we=Ve([R],we),e.DocumentLink=we;let Fe=class{constructor(z,oe,ke,Je){this.red=z,this.green=oe,this.blue=ke,this.alpha=Je}};Fe=Ve([R],Fe),e.Color=Fe;let qe=class{constructor(z,oe){if(oe&&!(oe instanceof Fe))throw(0,L.illegalArgument)("color");if(!F.isRange(z)||z.isEmpty)throw(0,L.illegalArgument)("range");this.range=z,this.color=oe}};qe=Ve([R],qe),e.ColorInformation=qe;let ze=class{constructor(z){if(!z||typeof z!="string")throw(0,L.illegalArgument)("label");this.label=z}};ze=Ve([R],ze),e.ColorPresentation=ze;var Ye;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Ye=e.ColorFormat||(e.ColorFormat={}));var ct;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(ct=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class xe{constructor(z,oe,ke){if(this.startIndex=z,this.length=oe,this.tooltip=ke,typeof z!="number"||z<0)throw(0,L.illegalArgument)("startIndex");if(typeof oe!="number"||oe<1)throw(0,L.illegalArgument)("length");if(ke!==void 0&&typeof ke!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=xe;var ge;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(ge=e.TerminalLocation||(e.TerminalLocation={}));class Ee{constructor(z){this.options=z,typeof z!="object"&&(0,L.illegalArgument)("options")}}e.TerminalProfile=Ee;var ae;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(ae=e.TaskRevealKind||(e.TaskRevealKind={}));var K;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(K=e.TaskPanelKind||(e.TaskPanelKind={}));let Ce=l=class{constructor(z,oe){if(this.label=oe,typeof z!="string"||typeof oe!="string")throw(0,L.illegalArgument)("name");this._id=z}static from(z){switch(z){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};Ce.Clean=new l("clean","Clean"),Ce.Build=new l("build","Build"),Ce.Rebuild=new l("rebuild","Rebuild"),Ce.Test=new l("test","Test"),Ce=l=Ve([R],Ce),e.TaskGroup=Ce;function Le(q){let z="";for(let oe=0;oe<q.length;oe++)z+=q[oe].replace(/,/g,",,")+",";return z}let nt=class{constructor(z,oe,ke){if(typeof z!="string")throw(0,L.illegalArgument)("process");this._args=[],this._process=z,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ke):this._options=oe)}get process(){return this._process}set process(z){if(typeof z!="string")throw(0,L.illegalArgument)("process");this._process=z}get args(){return this._args}set args(z){Array.isArray(z)||(z=[]),this._args=z}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("process"),this._process!==void 0&&z.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)z.push(oe);return Le(z)}};nt=Ve([R],nt),e.ProcessExecution=nt;let Ge=class{constructor(z,oe,ke){if(this._args=[],Array.isArray(oe)){if(!z)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,L.illegalArgument)("command");this._command=z,this._args=oe,this._options=ke}else{if(typeof z!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=z,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(z){if(typeof z!="string")throw(0,L.illegalArgument)("commandLine");this._commandLine=z}get command(){return this._command?this._command:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,L.illegalArgument)("command");this._command=z}get args(){return this._args}set args(z){this._args=z||[]}get options(){return this._options}set options(z){this._options=z}computeId(){const z=[];if(z.push("shell"),this._commandLine!==void 0&&z.push(this._commandLine),this._command!==void 0&&z.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)z.push(typeof oe=="string"?oe:oe.value);return Le(z)}};Ge=Ve([R],Ge),e.ShellExecution=Ge;var mt;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var Ct;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Ct=e.TaskScope||(e.TaskScope={}));class Et{constructor(z){this._callback=z}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(z){this._callback=z}get callback(){return this._callback}}e.CustomExecution=Et;let gt=f=class{constructor(z,oe,ke,Je,ot,ht){this.__deprecated=!1,this._definition=this.definition=z;let pt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ke,this.execution=Je,pt=ot,this.__deprecated=!0):oe===Ct.Global||oe===Ct.Workspace?(this.target=oe,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,pt=ht):(this.target=oe,this._name=this.name=ke,this._source=this.source=Je,this.execution=ot,pt=ht),typeof pt=="string"?(this._problemMatchers=[pt],this._hasDefinedMatchers=!0):Array.isArray(pt)?(this._problemMatchers=pt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(z){this.__id=z}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof nt?this._definition={type:f.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:f.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:f.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:f.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(z){if(z==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=z}get scope(){return this._scope}set target(z){this.clear(),this._scope=z}get name(){return this._name}set name(z){if(typeof z!="string")throw(0,L.illegalArgument)("name");this.clear(),this._name=z}get execution(){return this._execution}set execution(z){z===null&&(z=void 0),this.clear(),this._execution=z;const oe=this._definition.type;(f.EmptyType===oe||f.ProcessType===oe||f.ShellType===oe||f.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(z){if(Array.isArray(z))this.clear(),this._problemMatchers=z,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.clear(),this._isBackground=z}get source(){return this._source}set source(z){if(typeof z!="string"||z.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=z}get group(){return this._group}set group(z){z===null&&(z=void 0),this.clear(),this._group=z}get detail(){return this._detail}set detail(z){z===null&&(z=void 0),this._detail=z}get presentationOptions(){return this._presentationOptions}set presentationOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._presentationOptions=z}get runOptions(){return this._runOptions}set runOptions(z){z==null&&(z=Object.create(null)),this.clear(),this._runOptions=z}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=f=Ve([R],gt),e.Task=gt;var bt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(bt=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(z,oe=Tt.None){this.collapsibleState=oe,D.URI.isUri(z)?this.resourceUri=z:this.label=z}};vt=Ve([R],vt),e.TreeItem=vt;var Tt;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let yt=class{constructor(z,oe){this.id=z,this.color=oe}};yt=Ve([R],yt),e.ThemeIcon=yt,yt.File=new yt("file"),yt.Folder=new yt("folder");let $t=class{constructor(z){this.id=z}};$t=Ve([R],$t),e.ThemeColor=$t;var jt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(jt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(z,oe){if(typeof z!="string"&&(!z||!D.URI.isUri(z)&&!D.URI.isUri(z.uri)))throw(0,L.illegalArgument)("base");if(typeof oe!="string")throw(0,L.illegalArgument)("pattern");typeof z=="string"?(this.baseFolder=D.URI.file(z),this.base=z):D.URI.isUri(z)?(this.baseFolder=z,this.base=z.fsPath):(this.baseFolder=z.uri,this.base=z.uri.fsPath),this.pattern=oe}};kt=Ve([R],kt),e.RelativePattern=kt;let Wt=class{constructor(z,oe,ke,Je){this.enabled=typeof z=="boolean"?z:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};Wt=Ve([R],Wt),e.Breakpoint=Wt;let nn=class extends Wt{constructor(z,oe,ke,Je,ot){super(oe,ke,Je,ot);if(z===null)throw(0,L.illegalArgument)("location");this.location=z}};nn=Ve([R],nn),e.SourceBreakpoint=nn;let _t=class extends Wt{constructor(z,oe,ke,Je,ot){super(oe,ke,Je,ot);this.functionName=z}};_t=Ve([R],_t),e.FunctionBreakpoint=_t;let Xt=class extends Wt{constructor(z,oe,ke,Je,ot,ht,pt){super(Je,ot,ht,pt);if(!oe)throw(0,L.illegalArgument)("dataId");this.label=z,this.dataId=oe,this.canPersist=ke}};Xt=Ve([R],Xt),e.DataBreakpoint=Xt;let qt=class{constructor(z,oe,ke){this.command=z,this.args=oe||[],this.options=ke}};qt=Ve([R],qt),e.DebugAdapterExecutable=qt;let rn=class{constructor(z,oe){this.port=z,this.host=oe}};rn=Ve([R],rn),e.DebugAdapterServer=rn;let sn=class{constructor(z){this.path=z}};sn=Ve([R],sn),e.DebugAdapterNamedPipeServer=sn;let At=class{constructor(z){this.implementation=z}};At=Ve([R],At),e.DebugAdapterInlineImplementation=At;let Yt=class{constructor(z,oe){this.range=z,this.expression=oe}};Yt=Ve([R],Yt),e.EvaluatableExpression=Yt;var En;(function(q){q[q.Automatic=0]="Automatic",q[q.Explicit=1]="Explicit"})(En=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ht=class{constructor(z,oe){this.range=z,this.text=oe}};Ht=Ve([R],Ht),e.InlineValueText=Ht;let zt=class{constructor(z,oe,ke=!0){this.range=z,this.variableName=oe,this.caseSensitiveLookup=ke}};zt=Ve([R],zt),e.InlineValueVariableLookup=zt;let wt=class{constructor(z,oe){this.range=z,this.expression=oe}};wt=Ve([R],wt),e.InlineValueEvaluatableExpression=wt;let on=class{constructor(z,oe){this.frameId=z,this.stoppedLocation=oe}};on=Ve([R],on),e.InlineValueContext=on;var Nt;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let Ut=d=class extends Error{constructor(z,oe=I.FileSystemProviderErrorCode.Unknown,ke){super(D.URI.isUri(z)?z.toString(!0):z);this.code=ke?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(z){return new d(z,I.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(z){return new d(z,I.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(z){return new d(z,I.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(z){return new d(z,I.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(z){return new d(z,I.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(z){return new d(z,I.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}};Ut=d=Ve([R],Ut),e.FileSystemError=Ut;let Jt=class{constructor(z,oe,ke){this.start=z,this.end=oe,this.kind=ke}};Jt=Ve([R],Jt),e.FoldingRange=Jt;var _n;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(_n=e.FoldingRangeKind||(e.FoldingRangeKind={}));var mn;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(mn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Sn;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Sn=e.CommentMode||(e.CommentMode={}));class gn{constructor(z,oe=[]){this.tokenTypes=z,this.tokenModifiers=oe}}e.SemanticTokensLegend=gn;function Zt(q){return typeof q=="undefined"||(0,_.isStringArray)(q)}class an{constructor(z){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,z){this._hasLegend=!0;for(let oe=0,ke=z.tokenTypes.length;oe<ke;oe++)this._tokenTypeStrToInt.set(z.tokenTypes[oe],oe);for(let oe=0,ke=z.tokenModifiers.length;oe<ke;oe++)this._tokenModifierStrToInt.set(z.tokenModifiers[oe],oe)}}push(z,oe,ke,Je,ot){if(typeof z=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Je=="number"&&(typeof ot=="number"||typeof ot=="undefined"))return typeof ot=="undefined"&&(ot=0),this._pushEncoded(z,oe,ke,Je,ot);if(F.isRange(z)&&typeof oe=="string"&&Zt(ke))return this._push(z,oe,ke);throw(0,L.illegalArgument)()}_push(z,oe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Je=z.start.line,ot=z.start.character,ht=z.end.character-z.start.character,pt=this._tokenTypeStrToInt.get(oe);let It=0;if(ke)for(const Rt of ke){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Ft=this._tokenModifierStrToInt.get(Rt);It|=1<<Ft>>>0}this._pushEncoded(Je,ot,ht,pt,It)}_pushEncoded(z,oe,ke,Je,ot){if(this._dataIsSortedAndDeltaEncoded&&(z<this._prevLine||z===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const It=this._data.length/5|0;let Rt=0,Ft=0;for(let Ot=0;Ot<It;Ot++){let xt=this._data[5*Ot],hn=this._data[5*Ot+1];xt===0?(xt=Rt,hn+=Ft):xt+=Rt,this._data[5*Ot]=xt,this._data[5*Ot+1]=hn,Rt=xt,Ft=hn}}let ht=z,pt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ht-=this._prevLine,ht===0&&(pt-=this._prevChar)),this._data[this._dataLen++]=ht,this._data[this._dataLen++]=pt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Je,this._data[this._dataLen++]=ot,this._prevLine=z,this._prevChar=oe}static _sortAndDeltaEncode(z){let oe=[];const ke=z.length/5|0;for(let pt=0;pt<ke;pt++)oe[pt]=pt;oe.sort((pt,It)=>{const Rt=z[5*pt],Ft=z[5*It];if(Rt===Ft){const Ot=z[5*pt+1],xt=z[5*It+1];return Ot-xt}return Rt-Ft});const Je=new Uint32Array(z.length);let ot=0,ht=0;for(let pt=0;pt<ke;pt++){const It=5*oe[pt],Rt=z[It+0],Ft=z[It+1],Ot=z[It+2],xt=z[It+3],hn=z[It+4],Bn=Rt-ot,Kn=Bn===0?Ft-ht:Ft,fn=5*pt;Je[fn+0]=Bn,Je[fn+1]=Kn,Je[fn+2]=Ot,Je[fn+3]=xt,Je[fn+4]=hn,ot=Rt,ht=Ft}return Je}build(z){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),z):new Gt(an._sortAndDeltaEncode(this._data),z)}}e.SemanticTokensBuilder=an;class Gt{constructor(z,oe){this.resultId=oe,this.data=z}}e.SemanticTokens=Gt;class cn{constructor(z,oe,ke){this.start=z,this.deleteCount=oe,this.data=ke}}e.SemanticTokensEdit=cn;class Cn{constructor(z,oe){this.resultId=oe,this.edits=z}}e.SemanticTokensEdits=Cn;var yn;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(yn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Kt;(function(q){q[q.Initial=1]="Initial",q[q.Dynamic=2]="Dynamic"})(Kt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let en=class{constructor(){}};en.Back={iconPath:new yt("arrow-left")},en=Ve([R],en),e.QuickInputButtons=en;var Dn;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(Dn=e.ExtensionKind||(e.ExtensionKind={}));class kn{constructor(z,oe,ke){this.badge=z,this.tooltip=oe,this.color=ke}static validate(z){if(z.badge){let oe=(0,k.nextCharLength)(z.badge,0);if(oe<z.badge.length&&(oe+=(0,k.nextCharLength)(z.badge,oe)),z.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=kn;let ln=class{constructor(z){this.kind=z}};ln=Ve([R],ln),e.ColorTheme=ln;var un;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast"})(un=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(z,oe){if(z<0)throw(0,L.illegalArgument)("start must be positive");if(oe<0)throw(0,L.illegalArgument)("end must be positive");z<=oe?(this._start=z,this._end=oe):(this._start=oe,this._end=z)}static isNotebookRange(z){return z instanceof Vt?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(z){let oe=this._start,ke=this._end;return z.start!==void 0&&(oe=z.start),z.end!==void 0&&(ke=z.end),oe===this._start&&ke===this._end?this:new Vt(oe,ke)}}e.NotebookRange=Vt;class Mt{constructor(z,oe,ke,Je,ot,ht,pt){this.kind=z,this.value=oe,this.languageId=ke,this.mime=Je,this.outputs=ot??[],this.metadata=ht,this.executionSummary=pt,Mt.validate(this)}static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(oe=>Mt.isNotebookCellData(oe))}static isNotebookCellData(z){return!0}}e.NotebookCellData=Mt;class Ue{constructor(z){this.cells=z}}e.NotebookData=Ue;class Lt{constructor(z,oe){this.data=z,this.mime=oe;const ke=(0,n.normalizeMimeType)(oe,!0);if(!ke)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}static isNotebookCellOutputItem(z){return z instanceof Lt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const oe={name:z.name,message:z.message,stack:z.stack};return Lt.json(oe,"application/vnd.code.notebook.error")}static stdout(z){return Lt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Lt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,oe="application/octet-stream"){return new Lt(z,oe)}static text(z,oe=n.Mimes.text){const ke=Oe(Lt,w,"f",E).encode(String(z));return new Lt(ke,oe)}static json(z,oe="application/json"){const ke=JSON.stringify(z,void 0,"	");return Lt.text(ke,oe)}}e.NotebookCellOutputItem=Lt,w=Lt,E={value:new TextEncoder};class Qt{constructor(z,oe,ke){this.items=Qt.ensureUniqueMimeTypes(z,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=(0,P.generateUuid)(),this.metadata=oe??ke)}static isNotebookCellOutput(z){return z instanceof Qt?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&(0,_.isArray)(z.items)}static ensureUniqueMimeTypes(z,oe=!1){const ke=new Set,Je=new Set;for(let ot=0;ot<z.length;ot++){const ht=z[ot],pt=(0,n.normalizeMimeType)(ht.mime);if(!ke.has(pt)){ke.add(pt);continue}Je.add(ot),oe&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Je.size===0?z:z.filter((ot,ht)=>!Je.has(ht))}}e.NotebookCellOutput=Qt;var St;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(St=e.NotebookCellKind||(e.NotebookCellKind={}));var In;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(In=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Pn;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(Pn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var pn;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(pn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class vn{constructor(z,oe){this.text=z,this.alignment=oe}}e.NotebookCellStatusBarItem=vn;var Tn;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(Tn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class An{constructor(z,oe=[]){this.uri=z,this.provides=(0,g.asArray)(oe)}}e.NotebookRendererScript=An;let dn=class{constructor(z,oe){this.label=z,this.timestamp=oe}};dn=Ve([R],dn),e.TimelineItem=dn;var Rn;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(Rn=e.ExtensionMode||(e.ExtensionMode={}));var wn;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(wn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class Fn{constructor(z,oe){this.ranges=z,this.wordPattern=oe}}e.LinkedEditingRanges=Fn;class Mn{constructor(z,oe){this._port=z,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var On;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(On=e.TestResultState||(e.TestResultState={}));var Nn;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(Nn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let te=class{constructor(z=void 0,oe=void 0,ke=void 0){this.include=z,this.exclude=oe,this.profile=ke}};te=Ve([R],te),e.TestRunRequest=te;let he=S=class{constructor(z){this.message=z}static diff(z,oe,ke){const Je=new S(z);return Je.expectedOutput=oe,Je.actualOutput=ke,Je}};he=S=Ve([R],he),e.TestMessage=he;let Ae=class{constructor(z){this.id=z}};Ae=Ve([R],Ae),e.TestTag=Ae;let dt=class{constructor(z,oe){this.covered=z,this.total=oe}};dt=Ve([R],dt),e.CoveredCount=dt;let Dt=A=class{constructor(z,oe,ke,Je){this.uri=z,this.statementCoverage=oe,this.branchCoverage=ke,this.functionCoverage=Je}static fromDetails(z,oe){const ke=new dt(0,0),Je=new dt(0,0),ot=new dt(0,0);for(const pt of oe)if("branches"in pt){ke.total+=1,ke.covered+=pt.executionCount>0?1:0;for(const It of pt.branches)Je.total+=1,Je.covered+=It.executionCount>0?1:0}else ot.total+=1,ot.covered+=pt.executionCount>0?1:0;const ht=new A(z,ke,Je.total>0?Je:void 0,ot.total>0?ot:void 0);return ht.detailedCoverage=oe,ht}};Dt=A=Ve([R],Dt),e.FileCoverage=Dt;let Pt=class{constructor(z,oe,ke=[]){this.executionCount=z,this.location=oe,this.branches=ke}};Pt=Ve([R],Pt),e.StatementCoverage=Pt;let Un=class{constructor(z,oe){this.executionCount=z,this.location=oe}};Un=Ve([R],Un),e.BranchCoverage=Un;let xn=class{constructor(z,oe){this.executionCount=z,this.location=oe}};xn=Ve([R],xn),e.FunctionCoverage=xn;var Vn;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(Vn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var jn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(jn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var qn;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(qn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Gn{constructor(z,oe,ke,Je,ot,ht){this.kind=z,this.name=oe,this.detail=ke,this.uri=Je,this.range=ot,this.selectionRange=ht}}e.TypeHierarchyItem=Gn}),define(fe[123],me([0,1,58,10,8,150,110,7,15]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const D=new Map;function P(h,w){w?D.set(h,w):D.delete(h)}e.setWordDefinitionFor=P;function I(h){return D.get(h)}e.getWordDefinitionFor=I;class c extends C.MirrorTextModel{constructor(w,E,T,b,o,s,p,r){super(E,T,b,o);this._proxy=w,this._languageId=s,this._isDirty=p,this._notebook=r,this._isDisposed=!1}dispose(){(0,g.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(w){return(0,_.equals)(this._lines,w)}get document(){if(!this._document){const w=this;this._document={get uri(){return w._uri},get fileName(){return w._uri.fsPath},get isUntitled(){return w._uri.scheme===L.Schemas.untitled},get languageId(){return w._languageId},get version(){return w._versionId},get isClosed(){return w._isDisposed},get isDirty(){return w._isDirty},get notebook(){return w._notebook},save(){return w._save()},getText(E){return E?w._getTextInRange(E):w.getText()},get eol(){return w._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return w._lines.length},lineAt(E){return w._lineAt(E)},offsetAt(E){return w._offsetAt(E)},positionAt(E){return w._positionAt(E)},validateRange(E){return w._validateRange(E)},validatePosition(E){return w._validatePosition(E)},getWordRangeAtPosition(E,T){return w._getWordRangeAtPosition(E,T)}}}return Object.freeze(this._document)}_acceptLanguageId(w){(0,g.ok)(!this._isDisposed),this._languageId=w}_acceptIsDirty(w){(0,g.ok)(!this._isDisposed),this._isDirty=w}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(w){const E=this._validateRange(w);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const T=this._eol,b=E.start.line,o=E.end.line,s=[];s.push(this._lines[b].substring(E.start.character));for(let p=b+1;p<o;p++)s.push(this._lines[p]);return s.push(this._lines[o].substring(0,E.end.character)),s.join(T)}_lineAt(w){let E;if(w instanceof k.Position?E=w.line:typeof w=="number"&&(E=w),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new v(E,this._lines[E],E===this._lines.length-1)}_offsetAt(w){return w=this._validatePosition(w),this._ensureLineStarts(),this._lineStarts.getPrefixSum(w.line-1)+w.character}_positionAt(w){w=Math.floor(w),w=Math.max(0,w),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(w),T=this._lines[E.index].length;return new k.Position(E.index,Math.min(E.remainder,T))}_validateRange(w){if(!(w instanceof k.Range))throw new Error("Invalid argument");const E=this._validatePosition(w.start),T=this._validatePosition(w.end);return E===w.start&&T===w.end?w:new k.Range(E.line,E.character,T.line,T.character)}_validatePosition(w){if(!(w instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return w.with(0,0);let{line:E,character:T}=w,b=!1;if(E<0)E=0,T=0,b=!0;else if(E>=this._lines.length)E=this._lines.length-1,T=this._lines[E].length,b=!0;else{const o=this._lines[E].length;T<0?(T=0,b=!0):T>o&&(T=o,b=!0)}return b?new k.Position(E,T):w}_getWordRangeAtPosition(w,E){const T=this._validatePosition(w);if(!E)E=I(this._languageId);else if((0,y.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const b=(0,n.getWordAtText)(T.character+1,(0,n.ensureValidWordDefinition)(E),this._lines[T.line],0);if(b)return new k.Range(T.line,b.startColumn-1,T.line,b.endColumn-1)}}e.ExtHostDocumentData=c;class v{constructor(w,E,T){this._line=w,this._text=E,this._isLastLine=T}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=v}),define(fe[204],me([0,1,7,3,112,6,83,24,2,32]),function(Y,e,g,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class P{constructor(c,v,h,w){this._notebook=h,this._selector=w,this._disposables=new C.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:(0,D.generateUuid)()}),this._init(),this._disposables.add(v.onDidChangeDocument(T=>{const b=this._cellUris.get(T.document.uri);b!==void 0&&(this._cellLengths.setValue(b,this._cells[b].document.getText().length+1),this._cellLines.setValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=T=>{T===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(T=>E(T.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const c=[],v=[];for(const h of this._notebook.getCells())h.kind===g.NotebookCellKind.Code&&(!this._selector||(0,n.score)(this._selector,h.document.uri,h.document.languageId,!0))&&(this._cellUris.set(h.document.uri,this._cells.length),this._cells.push(h),c.push(h.document.getText().length+1),v.push(h.document.lineCount));this._cellLengths=new y.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new y.PrefixSumComputer(new Uint32Array(v))}get version(){return this._versionId}getText(c){if(!c){let b="";for(const o of this._cells)b+=o.document.getText()+`
`;return b=b.slice(0,-1),b}if(c.isEmpty)return"";const v=this.locationAt(c.start),h=this.locationAt(c.end),w=this._cellUris.get(v.uri),E=this._cellUris.get(h.uri);if(w===void 0||E===void 0)return"";if(w===E)return this._cells[w].document.getText(new g.Range(v.range.start,h.range.end));const T=[this._cells[w].document.getText(new g.Range(v.range.start,new g.Position(this._cells[w].document.lineCount,0)))];for(let b=w+1;b<E;b++)T.push(this._cells[b].document.getText());return T.push(this._cells[E].document.getText(new g.Range(new g.Position(0,0),h.range.end))),T.join(`
`)}offsetAt(c){const v=this._cellLines.getIndexOf(c.line),h=this._cellLengths.getPrefixSum(v.index-1),w=this._cells[v.index].document.offsetAt(c.with(v.remainder));return h+w}positionAt(c){if(typeof c=="number"){const h=this._cellLengths.getIndexOf(c),w=this._cellLines.getPrefixSum(h.index-1);return this._cells[h.index].document.positionAt(h.remainder).translate(w)}const v=this._cellUris.get(c.uri);if(v!==void 0){const h=this._cellLines.getPrefixSum(v-1);return new g.Position(h+c.range.start.line,c.range.start.character)}return new g.Position(0,0)}locationAt(c){g.Range.isRange(c)||(c=new g.Range(c,c));const v=this._cellLines.getIndexOf(c.start.line);let h=v;c.isEmpty||(h=this._cellLines.getIndexOf(c.end.line));const w=new g.Position(v.remainder,c.start.character),E=new g.Position(h.remainder,c.end.character),T=new g.Range(w,E),b=this._cells[v.index];return new g.Location(b.document.uri,b.document.validateRange(T))}contains(c){return this._cellUris.has(c)}validateRange(c){const v=this.validatePosition(c.start),h=this.validatePosition(c.end);return c.with(v,h)}validatePosition(c){const v=this._cellLines.getIndexOf(c.line),h=new g.Position(v.remainder,c.character),w=this._cells[v.index].document.validatePosition(h),E=this._cellLines.getPrefixSum(v.index-1);return new g.Position(E+w.line,w.character)}}e.ExtHostNotebookConcatDocument=P}),define(fe[205],me([0,1,7,14,3]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let C=class{constructor(k){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new y.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let _=k==="light"?g.ColorThemeKind.Light:k==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTheming=C}),define(fe[67],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,g.createDecorator)("IURITransformerService");class L{constructor(C){C?(this.transformIncoming=C.transformIncoming.bind(C),this.transformOutgoing=C.transformOutgoing.bind(C),this.transformOutgoingURI=C.transformOutgoingURI.bind(C),this.transformOutgoingScheme=C.transformOutgoingScheme.bind(C)):(this.transformIncoming=n=>n,this.transformOutgoing=n=>n,this.transformOutgoingURI=n=>n,this.transformOutgoingScheme=n=>n)}}e.URITransformerService=L}),define(fe[206],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(_){let D=this.buffers.indexOf(_);return D<0&&(D=this.buffers.length,this.buffers.push(_)),D}}function y(k,_){if(_.serializeBuffersForPostMessage){const D=new L,P=(v,h)=>{if(h instanceof ArrayBuffer){const w=D.add(h);return{$$vscode_array_buffer_reference$$:!0,index:w}}else if(ArrayBuffer.isView(h)){const w=C(h);if(w){const E=D.add(h.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:w,byteLength:h.byteLength,byteOffset:h.byteOffset}}}}return h},I=JSON.stringify(k,P),c=D.buffers.map(v=>{const h=new Uint8Array(v);return g.VSBuffer.wrap(h)});return{message:I,buffers:c}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=y;function C(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function n(k,_){const D=_.map(c=>{const v=new ArrayBuffer(c.byteLength);return new Uint8Array(v).set(c.buffer),v}),P=_.length?(c,v)=>{if(typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const h=v,{index:w}=h,E=D[w];if(h.view)switch(h.view.type){case 1:return new Int8Array(E,h.view.byteOffset,h.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,h.view.byteOffset,h.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,h.view.byteOffset,h.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,h.view.byteOffset,h.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,h.view.byteOffset,h.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,h.view.byteOffset,h.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,h.view.byteOffset,h.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,h.view.byteOffset,h.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,h.view.byteOffset,h.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,h.view.byteOffset,h.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,h.view.byteOffset,h.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return v}:void 0;return{message:JSON.parse(k,P),arrayBuffers:D}}e.deserializeWebviewMessage=n}),define(fe[207],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var g;(function(L){function y(n){const k={items:new Map};return n.types.forEach((_,D)=>{k.items.set(_,{asString:async()=>n.items[D].asString})}),k}L.toITreeDataTransfer=y;async function C(n){const k={types:[],items:[]},_=Array.from(n.items.entries());for(const D of _)k.types.push(D[0]),k.items.push({asString:await D[1].asString()});return k}L.toTreeDataTransferDTO=C})(g=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(fe[89],me([0,1,10,2]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function y(k,_){return k.scheme===g.Schemas.http||k.scheme===g.Schemas.https?k:(_&&_.authority&&_.isRemote&&k.scheme===g.Schemas.file&&(k=L.URI.from({scheme:g.Schemas.vscodeRemote,authority:_.authority,path:k.path})),L.URI.from({scheme:g.Schemas.https,authority:`${k.scheme}+${C(k.authority)}.${e.webviewRootResourceAuthority}`,path:k.path,fragment:k.fragment,query:k.query}))}e.asWebviewUri=y;function C(k){return k.replace(/./g,_=>{const D=_.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?_:"-"+D.toString(16).padStart(4,"0")})}function n(k){return k.replace(/-([0-9a-f]{4})/g,(_,D)=>String.fromCharCode(parseInt(D,16)))}e.decodeAuthority=n}),define(fe[208],me([0,1,3,6,89]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class C{constructor(k,_,D){this._proxy=k,this._editors=_,this._initData=D,this._handlePool=0,this._disposables=new L.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const P=_.getVisibleTextEditors();for(const I of this._insets.values())P.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(k=>k.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(k,_,D,P,I){let c;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===k){c=o;break}if(!c)throw new Error("not a visible editor");const v=this,h=this._handlePool++,w=new g.Emitter,E=new g.Emitter,T=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,y.asWebviewUri)(o,v._initData.remote)}get cspSource(){return y.webviewGenericCspSource}set options(o){this._options=o,v._proxy.$setOptions(h,o)}get options(){return this._options}set html(o){this._html=o,v._proxy.$setHtml(h,o)}get html(){return this._html}get onDidReceiveMessage(){return w.event}postMessage(o){return v._proxy.$postMessage(h,o)}},b=new class{constructor(){this.editor=k,this.line=_,this.height=D,this.webview=T,this.onDidDispose=E.event}dispose(){v._insets.has(h)&&(v._insets.delete(h),v._proxy.$disposeEditorInset(h),E.fire(),E.dispose(),w.dispose())}};return this._proxy.$createEditorInset(h,c.id,c.value.document.uri,_+1,D,P||{},I.identifier,I.extensionLocation),this._insets.set(h,{editor:k,inset:b,onDidReceiveMessage:w}),b}$onDidDispose(k){const _=this._insets.get(k);_&&_.inset.dispose()}$onDidReceiveMessage(k,_){const D=this._insets.get(k);D&&D.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=C}),define(fe[209],me([0,1,173,13,2,6,4,53,35,43,15,10]),function(Y,e,g,L,y,C,n,k,_,D,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,g.localize)(0,null),providerDisplayName:(0,g.localize)(1,null)},e.ActiveEditorDirtyContext=new k.RawContextKey("activeEditorIsDirty",!1,(0,g.localize)(2,null)),e.ActiveEditorPinnedContext=new k.RawContextKey("activeEditorIsNotPreview",!1,(0,g.localize)(3,null)),e.ActiveEditorStickyContext=new k.RawContextKey("activeEditorIsPinned",!1,(0,g.localize)(4,null)),e.ActiveEditorReadonlyContext=new k.RawContextKey("activeEditorIsReadonly",!1,(0,g.localize)(5,null)),e.ActiveEditorCanRevertContext=new k.RawContextKey("activeEditorCanRevert",!1,(0,g.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new k.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new k.RawContextKey("activeEditor",null,{type:"string",description:(0,g.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new k.RawContextKey("activeEditorAvailableEditorIds","",(0,g.localize)(8,null)),e.TextCompareEditorVisibleContext=new k.RawContextKey("textCompareEditorVisible",!1,(0,g.localize)(9,null)),e.TextCompareEditorActiveContext=new k.RawContextKey("textCompareEditorActive",!1,(0,g.localize)(10,null)),e.SideBySideEditorActiveContext=new k.RawContextKey("sideBySideEditorActive",!1,(0,g.localize)(11,null)),e.EditorGroupEditorsCountContext=new k.RawContextKey("groupEditorsCount",0,(0,g.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new k.RawContextKey("activeEditorGroupEmpty",!1,(0,g.localize)(13,null)),e.ActiveEditorGroupIndexContext=new k.RawContextKey("activeEditorGroupIndex",0,(0,g.localize)(14,null)),e.ActiveEditorGroupLastContext=new k.RawContextKey("activeEditorGroupLast",!1,(0,g.localize)(15,null)),e.ActiveEditorGroupLockedContext=new k.RawContextKey("activeEditorGroupLocked",!1,(0,g.localize)(16,null)),e.MultipleEditorGroupsContext=new k.RawContextKey("multipleEditorGroups",!1,(0,g.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new k.RawContextKey("editorIsOpen",!1,(0,g.localize)(18,null)),e.InEditorZenModeContext=new k.RawContextKey("inZenMode",!1,(0,g.localize)(19,null)),e.IsCenteredLayoutContext=new k.RawContextKey("isCenteredLayout",!1,(0,g.localize)(20,null)),e.SplitEditorsVertically=new k.RawContextKey("splitEditorsVertically",!1,(0,g.localize)(21,null)),e.EditorAreaVisibleContext=new k.RawContextKey("editorAreaVisible",!0,(0,g.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function c(x,F,$){for(const M of $.visibleEditorPanes)if(M.group.id===F&&x.matches(M.input))return M.getViewState()}e.findViewStateForEditor=c;function v(x){if(p(x))return!1;const F=x;return y.URI.isUri(F?.resource)}e.isResourceEditorInput=v;function h(x){if(p(x))return!1;const F=x;return F?.original!==void 0&&F.modified!==void 0}e.isResourceDiffEditorInput=h;function w(x){if(p(x)||h(x))return!1;const F=x;return F?.primary!==void 0&&F.secondary!==void 0}e.isResourceSideBySideEditorInput=w;function E(x){if(p(x))return!1;const F=x;return F?F.resource===void 0||F.resource.scheme===I.Schemas.untitled||F.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=E;var T;(function(x){x[x.SHORT=0]="SHORT",x[x.MEDIUM=1]="MEDIUM",x[x.LONG=2]="LONG"})(T=e.Verbosity||(e.Verbosity={}));var b;(function(x){x[x.EXPLICIT=1]="EXPLICIT",x[x.AUTO=2]="AUTO",x[x.FOCUS_CHANGE=3]="FOCUS_CHANGE",x[x.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var o;(function(x){x[x.None=0]="None",x[x.Readonly=2]="Readonly",x[x.Untitled=4]="Untitled",x[x.Singleton=8]="Singleton",x[x.RequiresTrust=16]="RequiresTrust",x[x.CanSplitInGroup=32]="CanSplitInGroup",x[x.ForceDescription=64]="ForceDescription"})(o=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class s extends C.Disposable{}e.AbstractEditorInput=s;function p(x){return x instanceof s}e.isEditorInput=p;function r(x){const F=x;return y.URI.isUri(F?.preferredResource)}function m(x){const F=x;return p(F?.primary)&&p(F?.secondary)}e.isSideBySideEditorInput=m;function i(x){const F=x;return p(F?.modified)&&p(F?.original)}e.isDiffEditorInput=i;function t(x){return p(x?.editor)}e.isEditorInputWithOptions=t;function u(x){const F=x;return t(x)&&F?.group!==void 0}e.isEditorInputWithOptionsAndGroup=u;function a(x){const F=x;return typeof F?.groupId=="number"&&p(F.editor)}e.isEditorIdentifier=a;var l;(function(x){x[x.UNKNOWN=0]="UNKNOWN",x[x.REPLACE=1]="REPLACE",x[x.MOVE=2]="MOVE",x[x.UNPIN=3]="UNPIN"})(l=e.EditorCloseContext||(e.EditorCloseContext={}));var f;(function(x){x[x.PRIMARY=1]="PRIMARY",x[x.SECONDARY=2]="SECONDARY",x[x.BOTH=3]="BOTH",x[x.ANY=4]="ANY"})(f=e.SideBySideEditor||(e.SideBySideEditor={}));class d{getOriginalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:H,secondary:N}=this.getSideEditors(F);if(H&&N){if($?.supportSideBySide===f.BOTH)return{primary:this.getOriginalUri(H,{filterByScheme:$.filterByScheme}),secondary:this.getOriginalUri(N,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===f.ANY)return this.getOriginalUri(H,{filterByScheme:$.filterByScheme})??this.getOriginalUri(N,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===f.PRIMARY?H:N}}if(h(F)||w(F))return;const M=r(F)?F.preferredResource:F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}getSideEditors(F){return m(F)||w(F)?{primary:F.primary,secondary:F.secondary}:i(F)||h(F)?{primary:F.modified,secondary:F.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(F,$){if(!F)return;if($?.supportSideBySide){const{primary:H,secondary:N}=this.getSideEditors(F);if(H&&N){if($?.supportSideBySide===f.BOTH)return{primary:this.getCanonicalUri(H,{filterByScheme:$.filterByScheme}),secondary:this.getCanonicalUri(N,{filterByScheme:$.filterByScheme})};if($?.supportSideBySide===f.ANY)return this.getCanonicalUri(H,{filterByScheme:$.filterByScheme})??this.getCanonicalUri(N,{filterByScheme:$.filterByScheme});F=$.supportSideBySide===f.PRIMARY?H:N}}if(h(F)||w(F))return;const M=F.resource;return!M||!$||!$.filterByScheme?M:this.filterUri(M,$.filterByScheme)}filterUri(F,$){if(Array.isArray($)){if($.some(M=>F.scheme===M))return F}else if($===F.scheme)return F}}e.EditorResourceAccessor=new d;var S;(function(x){x[x.LEFT=0]="LEFT",x[x.RIGHT=1]="RIGHT"})(S=e.CloseDirection||(e.CloseDirection={}));class A{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(F){const $=this.instantiationService=F.get(n.IInstantiationService);for(const[M,H]of this.editorSerializerConstructors)this.createEditorSerializer(M,H,$);this.editorSerializerConstructors.clear()}createEditorSerializer(F,$,M){const H=M.createInstance($);this.editorSerializerInstances.set(F,H)}registerFileEditorFactory(F){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=F}getFileEditorFactory(){return(0,L.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(F,$){if(this.editorSerializerConstructors.has(F)||this.editorSerializerInstances.has(F))throw new Error(`A editor serializer with type ID '${F}' was already registered.`);return this.instantiationService?this.createEditorSerializer(F,$,this.instantiationService):this.editorSerializerConstructors.set(F,$),(0,C.toDisposable)(()=>{this.editorSerializerConstructors.delete(F),this.editorSerializerInstances.delete(F)})}getEditorSerializer(F){return this.editorSerializerInstances.get(typeof F=="string"?F:F.typeId)}}_.Registry.add(e.EditorExtensions.EditorFactory,new A);async function R(x,F){if(!x||!x.length)return[];const $=await Promise.all(x.map(async M=>{const H=y.URI.revive(M.fileUri);if(!H||!await F.canHandleResource(H))return;let U=M.exists,V=M.type;if(typeof U!="boolean"||typeof V!="number")try{V=(await F.resolve(H)).isFile?D.FileType.File:D.FileType.Unknown,U=!0}catch{U=!1}if(!U&&M.openOnlyIfExists||V!==D.FileType.File)return;const O={selection:U?M.selection:void 0,pinned:!0,override:M.editorOverrideId};let W;return U?W={resource:H,options:O}:W={resource:H,options:O,forceUntitled:!0},W}));return(0,P.coalesce)($)}e.pathsToEditors=R;var B;(function(x){x[x.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",x[x.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(fe[210],me([0,1,3,53,174,4,6,24,35,15,59,25,48,199]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,v.registerIcon)("default-view-icon",c.Codicon.window,(0,y.localize)(0,null));var h;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(h=e.Extensions||(e.Extensions={}));var w;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel",u[u.AuxiliaryBar=2]="AuxiliaryBar"})(w=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function E(u){switch(u){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=E;function T(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=T;class b extends n.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new g.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new g.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,D.flatten)([...this.viewContainers.values()])}registerViewContainer(a,l,f){const d=this.get(a.id);if(d)return d;const S=a;return S.openCommandActionDescriptor=f?.donotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,k.getOrSet)(this.viewContainers,l,[]).push(S),f?.isDefault&&this.defaultViewContainers.push(S),this._onDidRegister.fire({viewContainer:S,viewContainerLocation:l}),S}deregisterViewContainer(a){for(const l of this.viewContainers.keys()){const f=this.viewContainers.get(l),d=f?.indexOf(a);if(d!==-1){f?.splice(d,1),f.length===0&&this.viewContainers.delete(l),this._onDidDeregister.fire({viewContainer:a,viewContainerLocation:l});return}}}get(a){return this.all.filter(l=>l.id===a)[0]}getViewContainers(a){return[...this.viewContainers.get(a)||[]]}getViewContainerLocation(a){return[...this.viewContainers.keys()].filter(l=>this.getViewContainers(l).filter(f=>f?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.defaultViewContainers.find(l=>this.getViewContainerLocation(l)===a)}}_.Registry.add(h.ViewContainersRegistry,new b);var o;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(o=e.ViewContentGroups||(e.ViewContentGroups={}));function s(u,a){const l=u.group??o.More,f=a.group??o.More;return l!==f?l.localeCompare(f):(u.order??5)-(a.order??5)}class p extends n.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new g.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new g.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new g.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new g.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new P.SetMap}registerViews(a,l){this.registerViews2([{views:a,viewContainer:l}])}registerViews2(a){a.forEach(({views:l,viewContainer:f})=>this.addViews(l,f)),this._onViewsRegistered.fire(a)}deregisterViews(a,l){const f=this.removeViews(a,l);f.length&&this._onViewsDeregistered.fire({views:f,viewContainer:l})}moveViews(a,l){for(const f of this._views.keys())if(f!==l){const d=this.removeViews(a,f);d.length&&(this.addViews(d,l),this._onDidChangeContainer.fire({views:d,from:f,to:l}))}}getViews(a){return this._views.get(a)||[]}getView(a){for(const l of this._viewContainers){const f=(this._views.get(l)||[]).filter(d=>d.id===a)[0];if(f)return f}return null}getViewContainer(a){for(const l of this._viewContainers)if((this._views.get(l)||[]).filter(d=>d.id===a)[0])return l;return null}registerViewWelcomeContent(a,l){return this._viewWelcomeContents.add(a,l),this._onDidChangeViewWelcomeContent.fire(a),(0,n.toDisposable)(()=>{this._viewWelcomeContents.delete(a,l),this._onDidChangeViewWelcomeContent.fire(a)})}registerViewWelcomeContent2(a,l){const f=new Map;for(const[d,S]of l)this._viewWelcomeContents.add(a,S),f.set(d,(0,n.toDisposable)(()=>{this._viewWelcomeContents.delete(a,S),this._onDidChangeViewWelcomeContent.fire(a)}));return this._onDidChangeViewWelcomeContent.fire(a),f}getViewWelcomeContent(a){const l=[];return this._viewWelcomeContents.forEach(a,f=>l.push(f)),l.sort(s)}addViews(a,l){let f=this._views.get(l);f||(f=[],this._views.set(l,f),this._viewContainers.push(l));for(const d of a){if(this.getView(d.id)!==null)throw new Error((0,y.localize)(1,null,d.id));f.push(d)}}removeViews(a,l){const f=this._views.get(l);if(!f)return[];const d=[],S=[];for(const A of f)a.includes(A)?d.push(A):S.push(A);return d.length&&(S.length?this._views.set(l,S):(this._views.delete(l),this._viewContainers.splice(this._viewContainers.indexOf(l),1))),d}}_.Registry.add(h.ViewsRegistry,new p),e.IViewsService=(0,C.createDecorator)("viewsService"),e.FocusedViewContext=new L.RawContextKey("focusedView","",(0,y.localize)(2,null));function r(u){return`view.${u}.visible`}e.getVisbileViewContextKey=r,e.IViewDescriptorService=(0,C.createDecorator)("viewDescriptorService");var m;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(m=e.ViewVisibilityState||(e.ViewVisibilityState={}));var i;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(i=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class t{constructor(a,l){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,a),this._hasResolve=!!l,this.resolve=async f=>{if(l&&!this.resolved){const d=await l(f);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}f.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(fe[124],me([0,1,3,16,175]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class C{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,_,D,P){const I={command:k};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof P=="number"){const c=setTimeout(()=>{clearTimeout(c);const v=this.pendingRequests.get(I.seq);if(v){this.pendingRequests.delete(I.seq);const h={type:"response",seq:0,request_seq:I.seq,success:!1,command:k,message:(0,y.localize)(0,null,P,k)};v(h)}},P)}return D&&this.pendingRequests.set(I.seq,D),I.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,_){return k.type!=="event"||_.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,L.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const _=k,D=this.pendingRequests.get(_.request_seq);D&&(this.pendingRequests.delete(_.request_seq),D(_));break}}}internalSend(k,_){_.type=k,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((_,D)=>k.set(D,_)),await(0,L.timeout)(500),k.forEach((_,D)=>{_({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=C}),define(fe[211],me([0,1,8,2,9,25,10]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function _(i,t,u){return i.replace(k,function(a,l){return t&&l.length>0&&l[0]!=="_"?a:u&&u.hasOwnProperty(l)?u[l]:a})}e.formatPII=_;function D(i){const t={};for(const u of Object.keys(i))u.startsWith("!")||(t[u]=i[u]);return t}e.filterExceptionsFromTelemetry=D;function P(i){return i.configuration.request==="attach"&&!I(i)&&(!i.parentSession||P(i.parentSession))}e.isSessionAttach=P;function I(i){let t=i.configuration.type;if(!!t)return t==="vslsShare"&&(t=i.configuration.adapterProxy.configuration.type),(0,g.equalsIgnoreCase)(t,"extensionhost")||(0,g.equalsIgnoreCase)(t,"pwa-extensionhost")?i:i.parentSession?I(i.parentSession):void 0}e.getExtensionHostDebugSession=I;function c(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=c;function v(i,t,u){let a,l=0,f=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,d=null;for(;d=f.exec(i);){let S=d.index+1,A=S+d[0].length;if(S<=t&&A>=u){a=d[0],l=S;break}}if(a){let S=/\w+/g,A=null;for(;(A=S.exec(a))&&!(A.index+1+l+A[0].length>=u););A&&(a=a.substring(0,S.lastIndex))}return a?{start:l,end:l+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=v;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function w(i){return!!(i&&i.match(h))}e.isUri=w;function E(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(w(i.path))return L.URI.parse(i.path);if((0,y.isAbsolute)(i.path))return L.URI.file(i.path)}return i.path}function T(i){if(typeof i.path=="object"){const t=L.URI.revive(i.path);if(t)return t.scheme===n.Schemas.file?t.fsPath:t.toString()}return i.path}function b(i,t){const u=t?E:T,a=(0,C.deepClone)(i);return s(a,(l,f)=>{l&&f&&(f.path=u(f))}),a}e.convertToDAPaths=b;function o(i,t){const u=t?E:T,a=(0,C.deepClone)(i);return s(a,(l,f)=>{!l&&f&&(f.path=u(f))}),a}e.convertToVSCPaths=o;function s(i,t){switch(i.type){case"event":const u=i;switch(u.event){case"output":t(!1,u.body.source);break;case"loadedSource":t(!1,u.body.source);break;case"breakpoint":t(!1,u.body.breakpoint.source);break;default:break}break;case"request":const a=i;switch(a.command){case"setBreakpoints":t(!0,a.arguments.source);break;case"breakpointLocations":t(!0,a.arguments.source);break;case"source":t(!0,a.arguments.source);break;case"gotoTargets":t(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(f=>t(!1,f));break;default:break}break;case"response":const l=i;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(f=>t(!1,f.source));break;case"loadedSources":l.body.sources.forEach(f=>t(!1,f));break;case"scopes":l.body.scopes.forEach(f=>t(!1,f.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(f=>t(!1,f.source));break;case"setBreakpoints":l.body.breakpoints.forEach(f=>t(!1,f.source));break;default:break}break}}function p(i){return i.filter(t=>!t.presentation?.hidden).sort((t,u)=>t.presentation?u.presentation?t.presentation.group?u.presentation.group?t.presentation.group!==u.presentation.group?t.presentation.group.localeCompare(u.presentation.group):r(t.presentation.order,u.presentation.order):-1:u.presentation.group?1:r(t.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=p;function r(i,t){return typeof i!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:i-t}async function m(i,t){const u=i.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorMode});if(u!=="none"&&(await t.saveAll(),u==="allEditorsInActiveGroup")){const a=t.activeEditorPane;a&&await t.save({editor:a.input,groupId:a.group.id})}await i.reloadConfiguration()}e.saveAllBeforeDebugStart=m}),define(fe[212],me([0,1,28,39,176,125,9,8,25,12,186,124]),function(Y,e,g,L,y,C,n,k,_,D,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class c extends I.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(b,o){this.outputStream=o,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,b.on("data",s=>this.handleData(s))}sendMessage(b){if(this.outputStream){const o=JSON.stringify(b);this.outputStream.write(`Content-Length: ${Buffer.byteLength(o,"utf8")}${c.TWO_CRLF}${o}`,"utf8")}}handleData(b){for(this.rawData=Buffer.concat([this.rawData,b]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const o=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,o.length>0)try{this.acceptMessage(JSON.parse(o))}catch(s){this._onError.fire(new Error((s.message||s)+`
`+o))}continue}}else{const o=this.rawData.indexOf(c.TWO_CRLF);if(o!==-1){const p=this.rawData.toString("utf8",0,o).split(c.HEADER_LINESEPARATOR);for(const r of p){const m=r.split(c.HEADER_FIELDSEPARATOR);m[0]==="Content-Length"&&(this.contentLength=Number(m[1]))}this.rawData=this.rawData.slice(o+c.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=c,c.TWO_CRLF=`\r
\r
`,c.HEADER_LINESEPARATOR=/\r?\n/,c.HEADER_FIELDSEPARATOR=/: */;class v extends c{startSession(){return new Promise((b,o)=>{let s=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),b(),s=!0}),this.socket.on("close",()=>{s?this._onError.fire(new Error("connection closed")):o(new Error("connection closed"))}),this.socket.on("error",p=>{s?this._onError.fire(p):o(p)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=v;class h extends v{constructor(b){super();this.adapterServer=b}createConnection(b){return C.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",b)}}e.SocketDebugAdapter=h;class w extends v{constructor(b){super();this.adapterServer=b}createConnection(b){return C.createConnection(this.adapterServer.path,b)}}e.NamedPipeDebugAdapter=w;class E extends c{constructor(b,o,s){super();this.adapterExecutable=b,this.debugType=o,this.outputService=s}async startSession(){const b=this.adapterExecutable.command,o=this.adapterExecutable.args,s=this.adapterExecutable.options||{};try{if(b)if(n.isAbsolute(b)){if(!await g.Promises.exists(b))throw new Error(y.localize(0,null,b))}else b.indexOf("/")<0&&b.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.debugType));let p=process.env;if(s.env&&Object.keys(s.env).length>0&&(p=_.mixin(_.deepClone(process.env),s.env)),b==="node")if(Array.isArray(o)&&o.length>0){const m=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:p,execArgv:m?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};s.cwd&&(i.cwd=s.cwd);const t=L.fork(o[0],o.slice(1),i);if(!t.pid)throw new Error(y.localize(2,null,o[0]));this.serverProcess=t}else throw new Error(y.localize(3,null));else{const m={env:p};s.cwd&&(m.cwd=s.cwd),this.serverProcess=L.spawn(b,o,m)}this.serverProcess.on("error",m=>{this._onError.fire(m)}),this.serverProcess.on("exit",(m,i)=>{this._onExit.fire(m)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",m=>{this._onError.fire(m)}),this.serverProcess.stdin.on("error",m=>{this._onError.fire(m)});const r=this.outputService;if(r){const m=i=>i.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",i=>{const t=r.getChannel(P.ExtensionsChannelId);t&&t.append(m(i))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(p){this._onError.fire(p)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),D.isWindows?new Promise((b,o)=>{const s=L.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(p,r,m){if(p)return o(p)});s.on("exit",b),s.on("error",o)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(b,o){if(!b)return;const s=Object.create(null);b.runtime&&(b.runtime.indexOf("./")===0?s.runtime=n.join(o,b.runtime):s.runtime=b.runtime),b.runtimeArgs&&(s.runtimeArgs=b.runtimeArgs),b.program&&(n.isAbsolute(b.program)?s.program=b.program:s.program=n.join(o,b.program)),b.args&&(s.args=b.args);const p=b;return p.win&&(s.win=E.extract(p.win,o)),p.winx86&&(s.winx86=E.extract(p.winx86,o)),p.windows&&(s.windows=E.extract(p.windows,o)),p.osx&&(s.osx=E.extract(p.osx,o)),p.linux&&(s.linux=E.extract(p.linux,o)),s}static platformAdapterExecutable(b,o){let s=Object.create(null);o=o.toLowerCase();for(const u of b)if(u.contributes){const a=u.contributes.debuggers;a&&a.length>0&&a.filter(l=>typeof l.type=="string"&&k.equalsIgnoreCase(l.type,o)).forEach(l=>{const f=E.extract(l,u.extensionLocation.fsPath);s=_.mixin(s,f,u.isBuiltin)})}let p;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?p=s.winx86||s.win||s.windows:D.isWindows?p=s.win||s.windows:D.isMacintosh?p=s.osx:D.isLinux&&(p=s.linux),p=p||s;let r=p.program||s.program;const m=p.args||s.args;let i=p.runtime||s.runtime;const t=p.runtimeArgs||s.runtimeArgs;if(i)return{type:"executable",command:i,args:(t||[]).concat(typeof r=="string"?[r]:[]).concat(m||[])};if(r)return{type:"executable",command:r,args:m||[]}}}e.ExecutableDebugAdapter=E}),define(fe[213],me([0,1,39,12,30,188]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function n(c,v){return new Promise((h,w)=>{let E="";const T=g.spawn(c,v);T.pid&&T.stdout.on("data",b=>{E+=b.toString()}),T.on("error",b=>{w(b)}),T.on("close",b=>{h(E)})})}let k;function _(c,v){if(!k)if(L.isWindows)k=new C.WindowsExternalTerminalService;else if(L.isMacintosh)k=new C.MacExternalTerminalService;else if(L.isLinux)k=new C.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const h=v.getConfiguration("terminal");return k.runInTerminal(c.title,c.cwd,c.args,c.env||{},h.external||{})}e.runInExternalTerminal=_;async function D(c){if(c)if(L.isWindows){const v=await new Promise((h,w)=>{Y(["windows-process-tree"],h,w)});return new Promise(h=>{v.getProcessTree(c,w=>{h(w.children.length>0)})})}else return n("/usr/bin/pgrep",["-lP",String(c)]).then(v=>{const h=v.trim();return!(h.length===0||h.indexOf(" tmux")>=0)},v=>!0);return Promise.resolve(!0)}e.hasChildProcesses=D;var P;(function(c){c[c.cmd=0]="cmd",c[c.powershell=1]="powershell",c[c.bash=2]="bash"})(P||(P={}));function I(c,v,h,w){c=c.trim().toLowerCase();let E;c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0?E=1:c.indexOf("cmd.exe")>=0?E=0:c.indexOf("bash")>=0?E=2:L.isWindows?E=0:E=2;let T,b=" ";switch(E){case 1:if(T=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),h){const s=(0,y.getDriveLetter)(h);s&&(b+=`${s}:; `),b+=`cd ${T(h)}; `}if(w)for(let s in w){const p=w[s];p===null?b+=`Remove-Item env:${s}; `:b+=`\${env:${s}}='${p}'; `}if(v.length>0){const s=T(v.shift());b+=s[0]==="'"?`& ${s} `:`${s} `;for(let p of v)b+=`${T(p)} `}break;case 0:if(T=s=>(s=s.replace(/\"/g,'""'),s.indexOf(" ")>=0||s.indexOf('"')>=0||s.length===0?`"${s}"`:s),h){const s=(0,y.getDriveLetter)(h);s&&(b+=`${s}: && `),b+=`cd ${T(h)} && `}if(w){b+='cmd /C "';for(let s in w){let p=w[s];p===null?b+=`set "${s}=" && `:(p=p.replace(/[\^\&\|\<\>]/g,r=>`^${r}`),b+=`set "${s}=${p}" && `)}}for(let s of v)b+=`${T(s)} `;w&&(b+='"');break;case 2:T=s=>(s=s.replace(/(["'\\\$])/g,"\\$1"),s.indexOf(" ")>=0||s.indexOf(";")>=0||s.length===0?`"${s}"`:s);const o=s=>/[^\w@%\/+=,.:^-]/.test(s)?`'${s.replace(/'/g,"'\\''")}'`:s;if(h&&(b+=`cd ${T(h)} ; `),w){b+="/usr/bin/env";for(let s in w){const p=w[s];p===null?b+=` -u ${o(s)}`:b+=` ${o(`${s}=${p}`)}`}b+=" "}for(let s of v)b+=`${T(s)} `;break}return b}e.prepareCommand=I}),define(fe[126],me([0,1,31,78,102,10,9,12,53]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(S){S[S.Markup=1]="Markup",S[S.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",y.Mimes.latex,y.Mimes.markdown,"image/png","image/jpeg",y.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[y.Mimes.latex,y.Mimes.markdown,"application/json",y.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(S){S[S.Running=1]="Running",S[S.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var I;(function(S){S[S.Pending=2]="Pending",S[S.Executing=3]="Executing"})(I=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var c;(function(S){S[S.WithHardKernelDependency=0]="WithHardKernelDependency",S[S.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",S[S.Pure=2]="Pure",S[S.Never=3]="Never"})(c=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var v;(function(S){S.Always="always",S.Never="never",S.Optional="optional"})(v=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(S){S[S.ModelChange=1]="ModelChange",S[S.Move=2]="Move",S[S.ChangeLanguage=5]="ChangeLanguage",S[S.Initialize=6]="Initialize",S[S.ChangeCellMetadata=7]="ChangeCellMetadata",S[S.Output=8]="Output",S[S.OutputItem=9]="OutputItem",S[S.ChangeCellContent=10]="ChangeCellContent",S[S.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",S[S.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",S[S.ChangeCellMime=13]="ChangeCellMime",S[S.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var w;(function(S){S[S.Handle=0]="Handle",S[S.Index=1]="Index"})(w=e.SelectionStateType||(e.SelectionStateType={}));var E;(function(S){S[S.Replace=1]="Replace",S[S.Output=2]="Output",S[S.Metadata=3]="Metadata",S[S.CellLanguage=4]="CellLanguage",S[S.DocumentMetadata=5]="DocumentMetadata",S[S.Move=6]="Move",S[S.OutputItems=7]="OutputItems",S[S.PartialMetadata=8]="PartialMetadata",S[S.PartialInternalMetadata=9]="PartialInternalMetadata"})(E=e.CellEditType||(e.CellEditType={}));var T;(function(S){S.scheme=C.Schemas.vscodeNotebookCell;const A=/^ch(\d{7,})/;function R(M,H){return M.with({scheme:S.scheme,fragment:`ch${H.toString().padStart(7,"0")}${M.scheme!==C.Schemas.file?M.scheme:""}`})}S.generate=R;function B(M){if(M.scheme!==S.scheme)return;const H=A.exec(M.fragment);return H?{handle:Number(H[1]),notebook:M.with({scheme:M.fragment.substr(H[0].length)||C.Schemas.file,fragment:null})}:void 0}S.parse=B;function x(M){if(M.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const H=A.exec(M.fragment);return H?{handle:Number(H[1]),notebook:M.with({scheme:M.fragment.substr(H[0].length)||C.Schemas.file,fragment:null})}:void 0}S.parseCellMetadataUri=x;function F(M,H,N){return M.with({scheme:N,fragment:`ch${H.toString().padStart(7,"0")}${M.scheme!==C.Schemas.file?M.scheme:""}`})}S.generateCellUri=F;function $(M,H){if(M.scheme!==H)return;const N=A.exec(M.fragment);return N?{handle:Number(N[1]),notebook:M.with({scheme:M.fragment.substr(N[0].length)||C.Schemas.file,fragment:null})}:void 0}S.parseCellUri=$})(T=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[y.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function o(S){return b.get(S)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=o;function s(S){return b.get(S)?.supportedByCore??!1}e.mimeTypeSupportedByCore=s;function p(S){return b.get(S)?.mergeable??!1}e.mimeTypeIsMergeable=p;const r=S=>k.isWindows?S.replace(/\//g,"\\"):S;class m{constructor(A=[],R=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=R,this.order=[...new Set(A)].map(B=>({pattern:B,matches:g.parse(r(B))}))}sort(A){const R=new Map(L.Iterable.map(A,x=>[x,r(x)]));let B=[];for(const{matches:x}of this.order)for(const[F,$]of R)if(x($)){B.push(F),R.delete(F);break}return R.size&&(B=B.concat([...R.keys()].sort((x,F)=>this.defaultOrder.indexOf(x)-this.defaultOrder.indexOf(F)))),B}prioritize(A,R){const B=this.findIndex(A);if(B===-1){this.order.unshift({pattern:A,matches:g.parse(r(A))});return}const x=new Set(R.map($=>this.findIndex($,B)));x.delete(-1);const F=Array.from(x).sort();this.order.splice(B+1,0,...F.map($=>this.order[$]));for(let $=F.length-1;$>=0;$--)this.order.splice(F[$],1)}toArray(){return this.order.map(A=>A.pattern)}findIndex(A,R=this.order.length){const B=r(A);for(let x=0;x<R;x++)if(this.order[x].matches(B))return x;return-1}}e.MimeTypeDisplayOrder=m;function i(S,A,R,B=(x,F)=>x===F){const x=[];function F(H,N,U){if(N===0&&U.length===0)return;const V=x[x.length-1];V&&V.start+V.deleteCount===H?(V.deleteCount+=N,V.toInsert.push(...U)):x.push({start:H,deleteCount:N,toInsert:U})}let $=0,M=0;for(;;){if($===S.length){F($,0,A.slice(M));break}if(M===A.length){F($,S.length-$,[]);break}const H=S[$],N=A[M];if(B(H,N)){$+=1,M+=1;continue}R(N)?(F($,1,[]),$+=1):(F($,0,[N]),M+=1)}return x}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(S){S.default="default",S.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(S){const A=S;return!!((typeof A.include=="string"||g.isRelativePattern(A.include))&&(typeof A.exclude=="string"||g.isRelativePattern(A.exclude)))}e.isDocumentExcludePattern=u;function a(S,A,R){if(Array.isArray(S.viewType)&&S.viewType.indexOf(A)>=0||S.viewType===A)return!0;if(S.filenamePattern){let B=u(S.filenamePattern)?S.filenamePattern.include:S.filenamePattern,x=u(S.filenamePattern)?S.filenamePattern.exclude:void 0;if(g.match(B,(0,n.basename)(R.fsPath).toLowerCase()))return!(x&&g.match(x,(0,n.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class l{constructor(A){this.textModel=A}getElements(){const A=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)A[R]=this.textModel.cells[R].getHashValue();return A}}e.CellSequence=l,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var f;(function(S){S[S.Left=1]="Left",S[S.Right=2]="Right"})(f=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class d{static create(A){return`${d._prefix}${A}`}static parse(A){if(A.startsWith(d._prefix))return A.substr(d._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=d,d._prefix="notebook/"}),define(fe[214],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(y){y[y.Output=1]="Output",y[y.OutputItems=2]="OutputItems",y[y.ExecutionState=3]="ExecutionState",y[y.Complete=4]="Complete"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,g.createDecorator)("INotebookExecutionService")}),define(fe[215],me([0,1,4,53]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new L.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new L.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new L.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,g.createDecorator)(e.OUTPUT_SERVICE_ID);var y;(function(C){C[C.Append=1]="Append",C[C.Replace=2]="Replace",C[C.Clear=3]="Clear"})(y=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(fe[216],me([0,1,178,4,53]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new y.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new y.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new y.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=(0,L.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(fe[217],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=g;function L(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=L}),define(fe[127],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var g;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(g=e.TestResultState||(e.TestResultState={}));var L;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(I){I[I.Error=0]="Error",I[I.Info=1]="Info"})(y=e.TestMessageType||(e.TestMessageType={}));var C;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(C=e.TestItemExpandState||(e.TestItemExpandState={}));const n=(I,c)=>{c.expand!==void 0&&(I.expand=c.expand),c.item!==void 0&&(I.item=I.item?Object.assign(I.item,c.item):c.item)};e.applyTestItemUpdate=n;var k;(function(I){I[I.Function=0]="Function",I[I.Statement=1]="Statement"})(k=e.DetailType||(e.DetailType={}));var _;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.Remove=2]="Remove",I[I.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",I[I.Retire=4]="Retire",I[I.AddTag=5]="AddTag",I[I.RemoveTag=6]="RemoveTag"})(_=e.TestDiffOpType||(e.TestDiffOpType={}));class D{add(c){}update(c){}remove(c,v){}complete(){}}e.IncrementalChangeCollector=D;class P{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(c){const v=this.createChangeCollector();for(const h of c)switch(h[0]){case 0:{const w=h[1];if(w.parent){if(this.items.has(w.parent)){const E=this.items.get(w.parent);E.children.add(w.item.extId);const T=this.createItem(w,E);this.items.set(w.item.extId,T),v.add(T)}}else{const E=this.createItem(w);this.roots.add(E),this.items.set(w.item.extId,E),v.add(E)}w.expand===2&&this.busyControllerCount++;break}case 1:{const w=h[1],E=this.items.get(w.extId);if(!E)break;w.expand!==void 0&&(E.expand===2&&this.busyControllerCount--,w.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(E,w),v.update(E);break}case 2:{const w=this.items.get(h[1]);if(!w)break;w.parent?this.items.get(w.parent).children.delete(w.item.extId):this.roots.delete(w);const E=[[h[1]]];for(;E.length;)for(const T of E.pop()){const b=this.items.get(T);b&&(E.push(b.children),this.items.delete(T),v.remove(b,b!==w),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(h[1]);break;case 3:this.updatePendingRoots(h[1]);break;case 5:this._tags.set(h[1].id,h[1]);break;case 6:this._tags.delete(h[1]);break}v.complete()}retireTest(c){}updatePendingRoots(c){this.pendingRootCount+=c}createChangeCollector(){return new D}}e.AbstractIncrementalTestCollection=P}),define(fe[90],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var g;(function(C){C.Delimiter="\0"})(g=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(C){C[C.IsSame=0]="IsSame",C[C.Disconnected=1]="Disconnected",C[C.IsChild=2]="IsChild",C[C.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class y{constructor(n,k=n.length){if(this.path=n,this.viewEnd=k,n.length===0||k<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(n,k,_=n.parent){if(n.id===k)return new y([k]);let D=[n.id];for(let P=_;P&&P.id!==k;P=P.parent)D.push(P.id);return D.push(k),new y(D.reverse())}static isRoot(n){return!n.includes("\0")}static fromString(n){return new y(n.split("\0"))}static join(n,k){return new y([...n.path,k])}static joinToString(n,k){return n.toString()+"\0"+k}static compare(n,k){return n===k?0:k.startsWith(n+"\0")?2:n.startsWith(k+"\0")?3:1}get parentId(){return this.viewEnd>1?new y(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let n=1;n<=this.viewEnd;n++)yield new y(this.path,n)}compare(n){if(typeof n=="string")return y.compare(this.toString(),n);for(let k=0;k<n.viewEnd&&k<this.viewEnd;k++)if(n.path[k]!==this.path[k])return 1;return n.viewEnd>this.viewEnd?2:n.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let n=1;n<this.viewEnd;n++)this.stringifed+="\0",this.stringifed+=this.path[n]}return this.stringifed}}e.TestId=y}),define(fe[218],me([0,1,9,38,13,25,12,81,179]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(I,c,v){this._contributedVariables=new Map,this._context=I,this._labelService=c,v&&(this._envVariablesPromise=v.then(h=>this.prepareEnv(h)))}prepareEnv(I){if(n.isWindows){const c=Object.create(null);return Object.keys(I).forEach(v=>{c[v.toLowerCase()]=I[v]}),c}return I}resolveWithEnvironment(I,c,v){return this.recursiveResolve(this.prepareEnv(I),c?c.uri:void 0,v)}async resolveAsync(I,c){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,c)}async resolveAnyBase(I,c,v,h){const w=C.deepClone(c);return n.isWindows&&w.windows?Object.keys(w.windows).forEach(E=>w[E]=w.windows[E]):n.isMacintosh&&w.osx?Object.keys(w.osx).forEach(E=>w[E]=w.osx[E]):n.isLinux&&w.linux&&Object.keys(w.linux).forEach(E=>w[E]=w.linux[E]),delete w.windows,delete w.osx,delete w.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,w,v,h)}async resolveAnyAsync(I,c,v){return this.resolveAnyBase(I,c,v)}async resolveAnyMap(I,c,v){const h=new Map;return{newConfig:await this.resolveAnyBase(I,c,v,h),resolvedVariables:h}}resolveWithInteractionReplace(I,c,v,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,c,v,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,c){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,c)}recursiveResolve(I,c,v,h,w){if(y.isString(v))return this.resolveString(I,c,v,h,w);if(y.isArray(v))return v.map(E=>this.recursiveResolve(I,c,E,h,w));if(y.isObject(v)){let E=Object.create(null);return Object.keys(v).forEach(T=>{const b=this.resolveString(I,c,T,h,w);E[b]=this.recursiveResolve(I,c,v[T],h,w)}),E}return v}resolveString(I,c,v,h,w){return v.replace(D.VARIABLE_REGEXP,(T,b)=>{if(b.includes(D.VARIABLE_LHS))return T;let o=this.evaluateSingleVariable(I,T,b,c,h);return w&&w.set(b,o),o!==T&&y.isString(o)&&o.match(D.VARIABLE_REGEXP)&&(o=this.resolveString(I,c,o,h,w)),o})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,c,v,h,w){let E;const T=v.split(":");T.length>1&&(v=T[0],E=T[1]);const b=()=>{const p=this._context.getFilePath();if(p)return p;throw new Error((0,_.localize)(0,null,c))},o=()=>{const p=b();if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new Error((0,_.localize)(1,null,c,g.basename(p)))},s=()=>{if(E){const p=this._context.getFolderUri(E);if(p)return p;throw new Error((0,_.localize)(2,null,c,E))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,_.localize)(3,null,c)):new Error((0,_.localize)(4,null,c))};switch(v){case"env":if(E){if(I){const p=I[n.isWindows?E.toLowerCase():E];if(y.isString(p))return p}return""}throw new Error((0,_.localize)(5,null,c));case"config":if(E){const p=this._context.getConfigurationValue(h,E);if(y.isUndefinedOrNull(p))throw new Error((0,_.localize)(6,null,c,E));if(y.isObject(p))throw new Error((0,_.localize)(7,null,c,E));return p}throw new Error((0,_.localize)(8,null,c));case"command":return this.resolveFromMap(c,E,w,"command");case"input":return this.resolveFromMap(c,E,w,"input");default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(s()));case"cwd":return h||E?(0,k.normalizeDriveLetter)(this.fsPath(s())):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(s()));case"lineNumber":const p=this._context.getLineNumber();if(p)return p;throw new Error((0,_.localize)(9,null,c));case"selectedText":const r=this._context.getSelectedText();if(r)return r;throw new Error((0,_.localize)(10,null,c));case"file":return b();case"fileWorkspaceFolder":return o();case"relativeFile":return h||E?g.relative(this.fsPath(s()),b()):b();case"relativeFileDirname":const m=g.dirname(b());if(h||E){const a=g.relative(this.fsPath(s()),m);return a.length===0?".":a}return m;case"fileDirname":return g.dirname(b());case"fileExtname":return g.extname(b());case"fileBasename":return g.basename(b());case"fileBasenameNoExtension":const i=g.basename(b());return i.slice(0,i.length-g.extname(i).length);case"fileDirnameBasename":return g.basename(g.dirname(b()));case"execPath":const t=this._context.getExecPath();return t||c;case"execInstallFolder":const u=this._context.getAppRoot();return u||c;case"pathSeparator":return g.sep;default:try{const a=E?`${v}:${E}`:v;return this.resolveFromMap(c,a,w,void 0)}catch(a){return c}}}}resolveFromMap(I,c,v,h){if(c&&v){const w=h===void 0?v[c]:v[h+":"+c];if(typeof w=="string")return w;throw new Error((0,_.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(fe[128],me([0,1,4,209]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,g.createDecorator)("editorGroupsService");var y;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(y=e.GroupDirection||(e.GroupDirection={}));var C;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var n;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(n=e.GroupLocation||(e.GroupLocation={}));var k;(function(w){w[w.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",w[w.EVEN=1]="EVEN",w[w.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var _;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(_=e.MergeGroupMode||(e.MergeGroupMode={}));function D(w){const E=w;return(0,L.isEditorInput)(E?.editor)&&(0,L.isEditorInput)(E?.replacement)}e.isEditorReplacement=D;var P;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(w){w[w.GROUP_ACTIVE=0]="GROUP_ACTIVE",w[w.GROUP_INDEX=1]="GROUP_INDEX",w[w.GROUP_LOCKED=2]="GROUP_LOCKED",w[w.EDITOR_OPEN=3]="EDITOR_OPEN",w[w.EDITOR_CLOSE=4]="EDITOR_CLOSE",w[w.EDITOR_MOVE=5]="EDITOR_MOVE",w[w.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",w[w.EDITOR_LABEL=7]="EDITOR_LABEL",w[w.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",w[w.EDITOR_PIN=9]="EDITOR_PIN",w[w.EDITOR_STICKY=10]="EDITOR_STICKY",w[w.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(I=e.GroupChangeKind||(e.GroupChangeKind={}));var c;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(c=e.OpenEditorContext||(e.OpenEditorContext={}));function v(w){const E=w;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.isEditorGroup=v;function h(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=h}),define(fe[219],me([0,1,4,128]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,g.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function y(C){const n=C;return typeof C=="number"||(0,L.isEditorGroup)(n)}e.isPreferredGroup=y}),define(fe[17],me([0,1,15,22,98,294,62,25,13,2,42,85,180,116,66,126,90,219,7]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ge){function Ee(K){const{selectionStartLineNumber:Ce,selectionStartColumn:Le,positionLineNumber:nt,positionColumn:Ge}=K,mt=new b.Position(Ce-1,Le-1),Ct=new b.Position(nt-1,Ge-1);return new b.Selection(mt,Ct)}ge.to=Ee;function ae(K){const{anchor:Ce,active:Le}=K;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ge.from=ae})(o=e.Selection||(e.Selection={}));var s;(function(ge){function Ee(K){if(!K)return;const{start:Ce,end:Le}=K;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ge.from=Ee;function ae(K){if(!K)return;const{startLineNumber:Ce,startColumn:Le,endLineNumber:nt,endColumn:Ge}=K;return new b.Range(Ce-1,Le-1,nt-1,Ge-1)}ge.to=ae})(s=e.Range||(e.Range={}));var p;(function(ge){function Ee(ae){switch(ae){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}ge.to=Ee})(p=e.TokenType||(e.TokenType={}));var r;(function(ge){function Ee(K){return new b.Position(K.lineNumber-1,K.column-1)}ge.to=Ee;function ae(K){return{lineNumber:K.line+1,column:K.character+1}}ge.from=ae})(r=e.Position||(e.Position={}));var m;(function(ge){function Ee(Ce,Le){return(0,g.coalesce)((0,g.asArray)(Ce).map(nt=>ae(nt,Le)))}ge.from=Ee;function ae(Ce,Le){if(typeof Ce=="string")return{$serialized:!0,language:Ce};if(Ce)return{$serialized:!0,language:Ce.language,scheme:K(Ce.scheme,Le),pattern:typeof Ce.pattern=="undefined"?void 0:ce.from(Ce.pattern),exclusive:Ce.exclusive}}function K(Ce,Le){return Le&&typeof Ce=="string"?Le.transformOutgoingScheme(Ce):Ce}})(m=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(ge){function Ee(K){switch(K){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}ge.from=Ee;function ae(K){switch(K){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}ge.to=ae})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var t;(function(ge){function Ee(K){let Ce;return K.code&&((0,_.isString)(K.code)||(0,_.isNumber)(K.code)?Ce=String(K.code):Ce={value:String(K.code.value),target:K.code.target}),{...s.from(K.range),message:K.message,source:K.source,code:Ce,severity:a.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(u.from),tags:Array.isArray(K.tags)?(0,g.coalesce)(K.tags.map(i.from)):void 0}}ge.from=Ee;function ae(K){const Ce=new b.Diagnostic(s.to(K),K.message,a.to(K.severity));return Ce.source=K.source,Ce.code=(0,_.isString)(K.code)?K.code:K.code?.value,Ce.relatedInformation=K.relatedInformation&&K.relatedInformation.map(u.to),Ce.tags=K.tags&&(0,g.coalesce)(K.tags.map(i.to)),Ce}ge.to=ae})(t=e.Diagnostic||(e.Diagnostic={}));var u;(function(ge){function Ee(K){return{...s.from(K.location.range),message:K.message,resource:K.location.uri}}ge.from=Ee;function ae(K){return new b.DiagnosticRelatedInformation(new b.Location(K.resource,s.to(K)),K.message)}ge.to=ae})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var a;(function(ge){function Ee(K){switch(K){case b.DiagnosticSeverity.Error:return v.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return v.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return v.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return v.MarkerSeverity.Hint}return v.MarkerSeverity.Error}ge.from=Ee;function ae(K){switch(K){case v.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case v.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case v.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case v.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ge.to=ae})(a=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(ge){function Ee(K){return typeof K=="number"&&K>=b.ViewColumn.One?K-1:K===b.ViewColumn.Beside?T.SIDE_GROUP:T.ACTIVE_GROUP}ge.from=Ee;function ae(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ge.to=ae})(l=e.ViewColumn||(e.ViewColumn={}));function f(ge){return typeof ge.range!="undefined"}function d(ge){return ge.length===0?!0:!!f(ge[0])}e.isDecorationOptionsArr=d;var S;(function(ge){function Ee(Ge){return Ge.map(ge.from)}ge.fromMany=Ee;function ae(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function K(Ge){let mt;if(ae(Ge)){const{language:bt,value:vt}=Ge;mt={value:"```"+bt+`
`+vt+"\n```\n"}}else b.MarkdownString.isMarkdownString(Ge)?mt={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml}:typeof Ge=="string"?mt={value:Ge}:mt={value:""};const Ct=Object.create(null);mt.uris=Ct;const Et=bt=>{try{let vt=D.URI.parse(bt,!0);vt=vt.with({query:Ce(vt.query,Ct)}),Ct[bt]=vt}catch(vt){}return""},gt=new C.Renderer;return gt.link=Et,gt.image=bt=>Et(y.parseHrefAndDimensions(bt).href),C(mt.value,{renderer:gt}),mt}ge.from=K;function Ce(Ge,mt){if(!Ge)return Ge;let Ct;try{Ct=(0,n.parse)(Ge)}catch(gt){}if(!Ct)return Ge;let Et=!1;return Ct=(0,k.cloneAndChange)(Ct,gt=>{if(D.URI.isUri(gt)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[bt]=gt,Et=!0,bt}else return}),Et?JSON.stringify(Ct):Ge}function Le(Ge){const mt=new b.MarkdownString(Ge.value,Ge.supportThemeIcons);return mt.isTrusted=Ge.isTrusted,mt.supportHtml=Ge.supportHtml,mt}ge.to=Le;function nt(Ge){if(!!Ge)return typeof Ge=="string"?Ge:ge.from(Ge)}ge.fromStrict=nt})(S=e.MarkdownString||(e.MarkdownString={}));function A(ge){return d(ge)?ge.map(Ee=>({range:s.from(Ee.range),hoverMessage:Array.isArray(Ee.hoverMessage)?S.fromMany(Ee.hoverMessage):Ee.hoverMessage?S.from(Ee.hoverMessage):void 0,renderOptions:Ee.renderOptions})):ge.map(Ee=>({range:s.from(Ee)}))}e.fromRangeOrRangeWithMessage=A;function R(ge){return typeof ge=="undefined"?ge:typeof ge=="string"?D.URI.file(ge):ge}e.pathOrURIToURI=R;var B;(function(ge){function Ee(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?R(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ge.from=Ee})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var x;(function(ge){function Ee(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?B.from(ae.before):void 0,after:ae.after?B.from(ae.after):void 0}}ge.from=Ee})(x=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ge){function Ee(ae){if(typeof ae=="undefined")return ae;switch(ae){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}ge.from=Ee})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(ge){function Ee(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?F.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?x.from(ae.light):void 0,dark:ae.dark?x.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?R(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?B.from(ae.before):void 0,after:ae.after?B.from(ae.after):void 0}}ge.from=Ee})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var M;(function(ge){function Ee(K){return{text:K.newText,eol:K.newEol&&J.from(K.newEol),range:s.from(K.range)}}ge.from=Ee;function ae(K){const Ce=new b.TextEdit(s.to(K.range),K.text);return Ce.newEol=typeof K.eol=="undefined"?void 0:J.to(K.eol),Ce}ge.to=ae})(M=e.TextEdit||(e.TextEdit={}));var H;(function(ge){function Ee(K,Ce,Le){const nt={edits:[]};if(K instanceof b.WorkspaceEdit)for(let Ge of K._allEntries())if(Ge._type===1)nt.edits.push({_type:1,oldUri:Ge.from,newUri:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2){const mt=Ce?.getDocument(Ge.uri);nt.edits.push({_type:2,resource:Ge.uri,edit:M.from(Ge.edit),modelVersionId:mt?.version,metadata:Ge.metadata})}else Ge._type===3?nt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,edit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version}):Ge._type===5&&nt.edits.push({_type:3,metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Le?.getNotebookDocument(Ge.uri,!0)?.apiNotebook.version,edit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(tt.from)}});return nt}ge.from=Ee;function ae(K){const Ce=new b.WorkspaceEdit;for(const Le of K.edits)Le.edit?Ce.replace(D.URI.revive(Le.resource),s.to(Le.edit.range),Le.edit.text):Ce.renameFile(D.URI.revive(Le.oldUri),D.URI.revive(Le.newUri),Le.options);return Ce}ge.to=ae})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var N;(function(ge){const Ee=Object.create(null);Ee[b.SymbolKind.File]=0,Ee[b.SymbolKind.Module]=1,Ee[b.SymbolKind.Namespace]=2,Ee[b.SymbolKind.Package]=3,Ee[b.SymbolKind.Class]=4,Ee[b.SymbolKind.Method]=5,Ee[b.SymbolKind.Property]=6,Ee[b.SymbolKind.Field]=7,Ee[b.SymbolKind.Constructor]=8,Ee[b.SymbolKind.Enum]=9,Ee[b.SymbolKind.Interface]=10,Ee[b.SymbolKind.Function]=11,Ee[b.SymbolKind.Variable]=12,Ee[b.SymbolKind.Constant]=13,Ee[b.SymbolKind.String]=14,Ee[b.SymbolKind.Number]=15,Ee[b.SymbolKind.Boolean]=16,Ee[b.SymbolKind.Array]=17,Ee[b.SymbolKind.Object]=18,Ee[b.SymbolKind.Key]=19,Ee[b.SymbolKind.Null]=20,Ee[b.SymbolKind.EnumMember]=21,Ee[b.SymbolKind.Struct]=22,Ee[b.SymbolKind.Event]=23,Ee[b.SymbolKind.Operator]=24,Ee[b.SymbolKind.TypeParameter]=25;function ae(Ce){return typeof Ee[Ce]=="number"?Ee[Ce]:6}ge.from=ae;function K(Ce){for(const Le in Ee)if(Ee[Le]===Ce)return Number(Le);return b.SymbolKind.Property}ge.to=K})(N=e.SymbolKind||(e.SymbolKind={}));var U;(function(ge){function Ee(K){switch(K){case b.SymbolTag.Deprecated:return 1}}ge.from=Ee;function ae(K){switch(K){case 1:return b.SymbolTag.Deprecated}}ge.to=ae})(U=e.SymbolTag||(e.SymbolTag={}));var V;(function(ge){function Ee(K){return{name:K.name,kind:N.from(K.kind),tags:K.tags&&K.tags.map(U.from),containerName:K.containerName,location:Q.from(K.location)}}ge.from=Ee;function ae(K){const Ce=new b.SymbolInformation(K.name,N.to(K.kind),K.containerName,Q.to(K.location));return Ce.tags=K.tags&&K.tags.map(U.to),Ce}ge.to=ae})(V=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var O;(function(ge){function Ee(K){const Ce={name:K.name||"!!MISSING: name!!",detail:K.detail,range:s.from(K.range),selectionRange:s.from(K.selectionRange),kind:N.from(K.kind),tags:K.tags?.map(U.from)??[]};return K.children&&(Ce.children=K.children.map(Ee)),Ce}ge.from=Ee;function ae(K){const Ce=new b.DocumentSymbol(K.name,K.detail,N.to(K.kind),s.to(K.range),s.to(K.selectionRange));return(0,g.isNonEmptyArray)(K.tags)&&(Ce.tags=K.tags.map(U.to)),K.children&&(Ce.children=K.children.map(ae)),Ce}ge.to=ae})(O=e.DocumentSymbol||(e.DocumentSymbol={}));var W;(function(ge){function Ee(K){const Ce=new b.CallHierarchyItem(N.to(K.kind),K.name,K.detail||"",D.URI.revive(K.uri),s.to(K.range),s.to(K.selectionRange));return Ce._sessionId=K._sessionId,Ce._itemId=K._itemId,Ce}ge.to=Ee;function ae(K,Ce,Le){if(Ce=Ce??K._sessionId,Le=Le??K._itemId,Ce===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Le,name:K.name,detail:K.detail,kind:N.from(K.kind),uri:K.uri,range:s.from(K.range),selectionRange:s.from(K.selectionRange),tags:K.tags?.map(U.from)}}ge.from=ae})(W=e.CallHierarchyItem||(e.CallHierarchyItem={}));var j;(function(ge){function Ee(ae){return new b.CallHierarchyIncomingCall(W.to(ae.from),ae.fromRanges.map(K=>s.to(K)))}ge.to=Ee})(j=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var X;(function(ge){function Ee(ae){return new b.CallHierarchyOutgoingCall(W.to(ae.to),ae.fromRanges.map(K=>s.to(K)))}ge.to=Ee})(X=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var Q;(function(ge){function Ee(K){return{range:K.range&&s.from(K.range),uri:K.uri}}ge.from=Ee;function ae(K){return new b.Location(D.URI.revive(K.uri),s.to(K.range))}ge.to=ae})(Q=e.location||(e.location={}));var de;(function(ge){function Ee(K){const Ce=K,Le=K;return{originSelectionRange:Ce.originSelectionRange?s.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Le.uri,range:s.from(Ce.targetRange?Ce.targetRange:Le.range),targetSelectionRange:Ce.targetSelectionRange?s.from(Ce.targetSelectionRange):void 0}}ge.from=Ee;function ae(K){return{targetUri:D.URI.revive(K.uri),targetRange:s.to(K.range),targetSelectionRange:K.targetSelectionRange?s.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?s.to(K.originSelectionRange):void 0}}ge.to=ae})(de=e.DefinitionLink||(e.DefinitionLink={}));var Se;(function(ge){function Ee(K){return{range:s.from(K.range),contents:S.fromMany(K.contents)}}ge.from=Ee;function ae(K){return new b.Hover(K.contents.map(S.to),s.to(K.range))}ge.to=ae})(Se=e.Hover||(e.Hover={}));var De;(function(ge){function Ee(K){return{range:s.from(K.range),expression:K.expression}}ge.from=Ee;function ae(K){return new b.EvaluatableExpression(s.to(K.range),K.expression)}ge.to=ae})(De=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ge){function Ee(K){if(K instanceof b.InlineValueText)return{type:"text",range:s.from(K.range),text:K.text};if(K instanceof b.InlineValueVariableLookup)return{type:"variable",range:s.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ge.from=Ee;function ae(K){switch(K.type){case"text":return{range:s.to(K.range),text:K.text};case"variable":return{range:s.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:s.to(K.range),expression:K.expression}}}ge.to=ae})(Pe=e.InlineValue||(e.InlineValue={}));var Be;(function(ge){function Ee(K){return{frameId:K.frameId,stoppedLocation:s.from(K.stoppedLocation)}}ge.from=Ee;function ae(K){return new b.InlineValueContext(K.frameId,s.to(K.stoppedLocation))}ge.to=ae})(Be=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(ge){function Ee(K){return{range:s.from(K.range),kind:K.kind}}ge.from=Ee;function ae(K){return new b.DocumentHighlight(s.to(K.range),K.kind)}ge.to=ae})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(ge){function Ee(ae){switch(ae){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}ge.to=Ee})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(ge){function Ee(ae){return{triggerKind:He.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ge.to=Ee})(G=e.CompletionContext||(e.CompletionContext={}));var ee;(function(ge){function Ee(K){switch(K){case b.CompletionItemTag.Deprecated:return 1}}ge.from=Ee;function ae(K){switch(K){case 1:return b.CompletionItemTag.Deprecated}}ge.to=ae})(ee=e.CompletionItemTag||(e.CompletionItemTag={}));var ne;(function(ge){const Ee=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function ae(Le){return Ee.get(Le)??9}ge.from=ae;const K=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function Ce(Le){return K.get(Le)??b.CompletionItemKind.Property}ge.to=Ce})(ne=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function(ge){function Ee(ae,K){const Ce=new b.CompletionItem(ae.label);return Ce.insertText=ae.insertText,Ce.kind=ne.to(ae.kind),Ce.tags=ae.tags?.map(ee.to),Ce.detail=ae.detail,Ce.documentation=y.isMarkdownString(ae.documentation)?S.to(ae.documentation):ae.documentation,Ce.sortText=ae.sortText,Ce.filterText=ae.filterText,Ce.preselect=ae.preselect,Ce.commitCharacters=ae.commitCharacters,P.Range.isIRange(ae.range)?Ce.range=s.to(ae.range):typeof ae.range=="object"&&(Ce.range={inserting:s.to(ae.range.insert),replacing:s.to(ae.range.replace)}),Ce.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Ce.insertText=new b.SnippetString(ae.insertText):(Ce.insertText=ae.insertText,Ce.textEdit=Ce.range instanceof b.Range?new b.TextEdit(Ce.range,Ce.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Ce.additionalTextEdits=ae.additionalTextEdits.map(Le=>M.to(Le))),Ce.command=K&&ae.command?K.fromInternal(ae.command):void 0,Ce}ge.to=Ee})(le=e.CompletionItem||(e.CompletionItem={}));var Z;(function(ge){function Ee(K){return{label:K.label,documentation:K.documentation?S.fromStrict(K.documentation):void 0}}ge.from=Ee;function ae(K){return{label:K.label,documentation:y.isMarkdownString(K.documentation)?S.to(K.documentation):K.documentation}}ge.to=ae})(Z=e.ParameterInformation||(e.ParameterInformation={}));var re;(function(ge){function Ee(K){return{label:K.label,documentation:K.documentation?S.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.from):[],activeParameter:K.activeParameter}}ge.from=Ee;function ae(K){return{label:K.label,documentation:y.isMarkdownString(K.documentation)?S.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Z.to):[],activeParameter:K.activeParameter}}ge.to=ae})(re=e.SignatureInformation||(e.SignatureInformation={}));var pe;(function(ge){function Ee(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(re.from):[]}}ge.from=Ee;function ae(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(re.to):[]}}ge.to=ae})(pe=e.SignatureHelp||(e.SignatureHelp={}));var Me;(function(ge){function Ee(K){return{text:K.text,position:r.from(K.position),kind:je.from(K.kind??b.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}ge.from=Ee;function ae(K){const Ce=new b.InlayHint(K.text,r.to(K.position),je.to(K.kind));return Ce.whitespaceAfter=K.whitespaceAfter,Ce.whitespaceBefore=K.whitespaceBefore,Ce}ge.to=ae})(Me=e.InlayHint||(e.InlayHint={}));var je;(function(ge){function Ee(K){return K}ge.from=Ee;function ae(K){return K}ge.to=ae})(je=e.InlayHintKind||(e.InlayHintKind={}));var Ke;(function(ge){function Ee(K){return{range:s.from(K.range),url:K.target,tooltip:K.tooltip}}ge.from=Ee;function ae(K){let Ce;if(K.url)try{Ce=typeof K.url=="string"?D.URI.parse(K.url,!0):D.URI.revive(K.url)}catch(Le){}return new b.DocumentLink(s.to(K.range),Ce)}ge.to=ae})(Ke=e.DocumentLink||(e.DocumentLink={}));var Ze;(function(ge){function Ee(K){const Ce=new b.ColorPresentation(K.label);return K.textEdit&&(Ce.textEdit=M.to(K.textEdit)),K.additionalTextEdits&&(Ce.additionalTextEdits=K.additionalTextEdits.map(Le=>M.to(Le))),Ce}ge.to=Ee;function ae(K){return{label:K.label,textEdit:K.textEdit?M.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Ce=>M.from(Ce)):void 0}}ge.from=ae})(Ze=e.ColorPresentation||(e.ColorPresentation={}));var rt;(function(ge){function Ee(K){return new b.Color(K[0],K[1],K[2],K[3])}ge.to=Ee;function ae(K){return[K.red,K.green,K.blue,K.alpha]}ge.from=ae})(rt=e.Color||(e.Color={}));var lt;(function(ge){function Ee(K){return{range:s.from(K.range)}}ge.from=Ee;function ae(K){return new b.SelectionRange(s.to(K.range))}ge.to=ae})(lt=e.SelectionRange||(e.SelectionRange={}));var ye;(function(ge){function Ee(ae){switch(ae){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}ge.to=Ee})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var at;(function(ge){function Ee(K){switch(K){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}ge.from=Ee;function ae(K){switch(K){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}ge.to=ae})(at=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var J;(function(ge){function Ee(K){if(K===b.EndOfLine.CRLF)return 1;if(K===b.EndOfLine.LF)return 0}ge.from=Ee;function ae(K){if(K===1)return b.EndOfLine.CRLF;if(K===0)return b.EndOfLine.LF}ge.to=ae})(J=e.EndOfLine||(e.EndOfLine={}));var ie;(function(ge){function Ee(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ge.from=Ee})(ie=e.ProgressLocation||(e.ProgressLocation={}));var _e;(function(ge){function Ee(ae){const K={start:ae.start+1,end:ae.end+1};return ae.kind&&(K.kind=Qe.from(ae.kind)),K}ge.from=Ee})(_e=e.FoldingRange||(e.FoldingRange={}));var Qe;(function(ge){function Ee(ae){if(ae)switch(ae){case b.FoldingRangeKind.Comment:return I.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return I.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return I.FoldingRangeKind.Region}}ge.from=Ee})(Qe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(ge){function Ee(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?s.from(ae.selection):void 0,override:typeof ae.override=="boolean"?c.EditorResolution.DISABLED:void 0}}ge.from=Ee})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ce;(function(ge){function Ee(K){return K instanceof b.RelativePattern||typeof K=="string"?K:ae(K)?new b.RelativePattern(K.base,K.pattern):K}ge.from=Ee;function ae(K){const Ce=K;return Ce&&typeof Ce.base=="string"&&typeof Ce.pattern=="string"}})(ce=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(ge){function Ee(ae){if(ae){if(Array.isArray(ae))return ae.map(Ee);if(typeof ae=="string")return ae;{const K=ae;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:ce.from(K.pattern),exclusive:K.exclusive}}}else return}ge.from=Ee})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(ge){function Ee(K){return{start:K.start,end:K.end}}ge.from=Ee;function ae(K){return new b.NotebookRange(K.start,K.end)}ge.to=ae})(Ne=e.NotebookRange||(e.NotebookRange={}));var Xe;(function(ge){function Ee(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ge.to=Ee;function ae(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ge.from=ae})(Xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var it;(function(ge){function Ee(K){switch(K){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}ge.from=Ee;function ae(K){switch(K){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}ge.to=ae})(it=e.NotebookCellKind||(e.NotebookCellKind={}));var ft;(function(ge){function Ee(K){const Ce={metadata:K.metadata??Object.create(null),cells:[]};for(let Le of K.cells)b.NotebookCellData.validate(Le),Ce.cells.push(tt.from(Le));return Ce}ge.from=Ee;function ae(K){const Ce=new b.NotebookData(K.cells.map(tt.to));return(0,_.isEmptyObject)(K.metadata)||(Ce.metadata=K.metadata),Ce}ge.to=ae})(ft=e.NotebookData||(e.NotebookData={}));var tt;(function(ge){function Ee(K){return{cellKind:it.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Xe.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Re.from):[]}}ge.from=Ee;function ae(K){return new b.NotebookCellData(it.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Re.to):void 0,K.metadata,K.internalMetadata?Xe.to(K.internalMetadata):void 0)}ge.to=ae})(tt=e.NotebookCellData||(e.NotebookCellData={}));var ut;(function(ge){function Ee(K){return{mime:K.mime,valueBytes:L.VSBuffer.wrap(K.data)}}ge.from=Ee;function ae(K){return new b.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}ge.to=ae})(ut=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Re;(function(ge){function Ee(K){return{outputId:K.id,items:K.items.map(ut.from),metadata:K.metadata}}ge.from=Ee;function ae(K){const Ce=K.items.map(ut.to);return new b.NotebookCellOutput(Ce,K.outputId,K.metadata)}ge.to=ae})(Re=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ve;(function(ge){function Ee(Le){if(Le!=null){if(Le instanceof b.RelativePattern||typeof Le=="string")return Le;if(Ce(Le))return new b.RelativePattern(Le.base,Le.pattern);if(K(Le))return{include:ce.from(Le.include)||void 0,exclude:ce.from(Le.exclude)||void 0}}}ge.from=Ee;function ae(Le){return typeof Le=="string"?Le:Ce(Le)?{base:Le.base,pattern:Le.pattern}:{include:Le.include,exclude:Le.exclude}}ge.to=ae;function K(Le){const nt=Le,Ge=ce.from(nt.include);if(!(Ge&&Ge instanceof b.RelativePattern||typeof Ge=="string"))return!1;const mt=ce.from(nt.exclude);return!!(mt&&mt instanceof b.RelativePattern||typeof mt=="string")}function Ce(Le){const nt=Le;return nt&&typeof nt.base=="string"&&typeof nt.pattern=="string"}})(ve=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(ge){function Ee(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?B.from(ae.top):void 0}}ge.from=Ee})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var se;(function(ge){function Ee(ae,K,Ce){const Le=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Ce),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ge.from=Ee})(se=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ge){function Ee(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{}}}ge.from=Ee})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var be;(function(ge){function Ee(K){return{uri:K.uri,provides:K.provides}}ge.from=Ee;function ae(K){return new b.NotebookRendererScript(D.URI.revive(K.uri),K.provides)}ge.to=ae})(be=e.NotebookRendererScript||(e.NotebookRendererScript={}));var we;(function(ge){function Ee(K){return{message:S.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location?Q.from(K.location):void 0}}ge.from=Ee;function ae(K){const Ce=new b.TestMessage(typeof K.message=="string"?K.message:S.to(K.message));return Ce.actualOutput=K.actual,Ce.expectedOutput=K.expected,Ce.location=K.location?Q.to(K.location):void 0,Ce}ge.to=ae})(we=e.TestMessage||(e.TestMessage={}));var Fe;(function(ge){let Ee;(function(ae){ae.Delimiter="\0"})(Ee||(Ee={})),ge.namespace=(ae,K)=>ae+"\0"+K,ge.denamespace=ae=>{const K=ae.indexOf("\0");return{ctrlId:ae.slice(0,K),tagId:ae.slice(K+1)}}})(Fe=e.TestTag||(e.TestTag={}));var qe;(function(ge){function Ee(Le){const nt=(0,h.getPrivateApiFor)(Le).controllerId;return{extId:E.TestId.fromExtHostTestItem(Le,nt).toString(),label:Le.label,uri:Le.uri,tags:Le.tags.map(Ge=>Fe.namespace(nt,Ge.id)),range:s.from(Le.range)||null,description:Le.description||null,error:Le.error&&S.fromStrict(Le.error)||null}}ge.from=Ee;function ae(Le){return{parent:void 0,error:void 0,id:E.TestId.fromString(Le.extId).localId,label:Le.label,uri:D.URI.revive(Le.uri),tags:(Le.tags||[]).map(nt=>{const{tagId:Ge}=Fe.denamespace(nt);return new b.TestTag(Ge)}),range:s.to(Le.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Le.description||void 0}}ge.toPlain=ae;function K(Le){const nt=E.TestId.fromString(Le.extId),Ge=new h.TestItemImpl(nt.controllerId,nt.localId,Le.label,D.URI.revive(Le.uri));return Ge.range=s.to(Le.range||void 0),Ge.description=Le.description||void 0,Ge}function Ce(Le){let nt;for(const Ge of Le.tests){const mt=K(Ge.item);(0,h.getPrivateApiFor)(mt).parent=nt,nt=mt}return nt}ge.toItemFromContext=Ce})(qe=e.TestItem||(e.TestItem={})),function(ge){function Ee(K){return{id:K.id}}ge.from=Ee;function ae(K){return new b.TestTag(K.id)}ge.to=ae}(Fe=e.TestTag||(e.TestTag={}));var ze;(function(ge){const Ee=(K,Ce)=>{const Le={...qe.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(nt=>({state:nt.state,duration:nt.duration,messages:nt.messages.filter(Ge=>Ge.type===0).map(we.to)})),children:K.children.map(nt=>Ce.get(nt)).filter(_.isDefined).map(nt=>Ee(nt,Ce))};for(const nt of Le.children)nt.parent=Le;return Le};function ae(K){const Ce=[],Le=new Map;for(const nt of K.items)Le.set(nt.item.extId,nt),K.request.targets.some(Ge=>Ge.controllerId===nt.controllerId&&Ge.testIds.includes(nt.item.extId))&&Ce.push(nt);return{completedAt:K.completedAt,results:Ce.map(nt=>Ee(nt,Le))}}ge.to=ae})(ze=e.TestResults||(e.TestResults={}));var Ye;(function(ge){function Ee(Le){return{covered:Le.covered,total:Le.covered}}function ae(Le){return"line"in Le?r.from(Le):s.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:ae(Le.location),type:1,branches:Le.branches.length?Le.branches.map(nt=>({count:nt.executionCount,location:nt.location&&ae(nt.location)})):void 0}:{type:0,count:Le.executionCount,location:ae(Le.location)}}ge.fromDetailed=K;function Ce(Le){return{uri:Le.uri,statement:Ee(Le.statementCoverage),branch:Le.branchCoverage&&Ee(Le.branchCoverage),function:Le.functionCoverage&&Ee(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}ge.fromFile=Ce})(Ye=e.TestCoverage||(e.TestCoverage={}));var ct;(function(ge){function Ee(ae){switch(ae){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}ge.to=Ee})(ct=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var xe;(function(ge){function Ee(K){const Ce=new b.TypeHierarchyItem(N.to(K.kind),K.name,K.detail||"",D.URI.revive(K.uri),s.to(K.range),s.to(K.selectionRange));return Ce._sessionId=K._sessionId,Ce._itemId=K._itemId,Ce}ge.to=Ee;function ae(K,Ce,Le){if(Ce=Ce??K._sessionId,Le=Le??K._itemId,Ce===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Le,kind:N.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:s.from(K.range),selectionRange:s.from(K.selectionRange),tags:K.tags?.map(U.from)}}ge.from=ae})(xe=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(fe[220],me([0,1,2,18,7,17,94]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(D,P,I,c={timeout:1500,errors:3}){this._logService=D,this._documents=P,this._mainThreadBulkEdits=I,this._thresholds=c,this._callbacks=new n.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(P,I,c)=>{const h={dispose:this._callbacks.push([P,I,D])};return Array.isArray(c)&&c.push(h),h}}async $participateInSave(D,P){const I=g.URI.revive(D);let c=!1;const v=setTimeout(()=>c=!0,this._thresholds.timeout),h=[];try{for(let w of[...this._callbacks]){if(c)break;const E=this._documents.getDocument(I),T=await this._deliverEventAsyncAndBlameBadListeners(w,{document:E,reason:C.TextDocumentSaveReason.to(P)});h.push(T)}}finally{clearTimeout(v)}return h}_deliverEventAsyncAndBlameBadListeners([D,P,I],c){const v=this._badListeners.get(D);return typeof v=="number"&&v>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,D,P,c).then(()=>!0,h=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(h),!(h instanceof Error)||h.message!=="concurrent_edits"){const w=this._badListeners.get(D);this._badListeners.set(D,w?w+1:1),typeof w=="number"&&w>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,P,I,c){const v=[],h=Date.now(),{document:w,reason:E}=c,{version:T}=w,b=Object.freeze({document:w,reason:E,waitUntil(o){if(Object.isFrozen(v))throw(0,L.illegalState)("waitUntil can not be called async");v.push(Promise.resolve(o))}});try{P.apply(I,[b])}catch(o){return Promise.reject(o)}return Object.freeze(v),new Promise((o,s)=>{const p=setTimeout(()=>s(new Error("timeout")),this._thresholds.timeout);return Promise.all(v).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-h}ms`),clearTimeout(p),o(r)}).catch(r=>{clearTimeout(p),s(r)})}).then(o=>{const s={edits:[]};for(const p of o)if(Array.isArray(p)&&p.every(r=>r instanceof y.TextEdit))for(const{newText:r,newEol:m,range:i}of p)s.edits.push({_type:2,resource:w.uri,edit:{range:i&&C.Range.from(i),text:r,eol:m&&C.EndOfLine.from(m)}});if(s.edits.length!==0)return T===w.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(s):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(fe[221],me([0,1,3,31,2,17,7]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class k{constructor(P,I,c,v,h){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,c&&(this._config+=1),v&&(this._config+=2),h&&(this._config+=4);const w=(0,L.parse)(I),E=P(T=>{if(!c)for(let b of T.created){const o=y.URI.revive(b);w(o.fsPath)&&this._onDidCreate.fire(o)}if(!v)for(let b of T.changed){const o=y.URI.revive(b);w(o.fsPath)&&this._onDidChange.fire(o)}if(!h)for(let b of T.deleted){const o=y.URI.revive(b);w(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=n.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,E)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class _{constructor(P,I,c){this._logService=I,this._extHostDocumentsAndEditors=c,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new g.AsyncEmitter,this._onWillCreateFile=new g.AsyncEmitter,this._onWillDeleteFile=new g.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(P,I,c,v){return new k(this._onFileSystemEvent.event,P,I,c,v)}$onFileEvent(P){this._onFileSystemEvent.fire(P)}$onDidRunFileOperation(P,I){switch(P){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(c=>({oldUri:y.URI.revive(c.source),newUri:y.URI.revive(c.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(c=>y.URI.revive(c.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:I.map(c=>y.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(P){return this._createWillExecuteEvent(P,this._onWillRenameFile)}getOnWillCreateFileEvent(P){return this._createWillExecuteEvent(P,this._onWillCreateFile)}getOnWillDeleteFileEvent(P){return this._createWillExecuteEvent(P,this._onWillDeleteFile)}_createWillExecuteEvent(P,I){return(c,v,h)=>{const w=function(T){c.call(v,T)};return w.extension=P,I.event(w,void 0,h)}}async $onWillRunFileOperation(P,I,c,v){switch(P){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(h=>({oldUri:y.URI.revive(h.source),newUri:y.URI.revive(h.target)}))},c,v);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(h=>y.URI.revive(h.target))},c,v);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(h=>y.URI.revive(h.target))},c,v)}}async _fireWillEvent(P,I,c,v){const h=new Set,w=[];if(await P.fireAsync(I,v,async(T,b)=>{const o=Date.now(),s=await Promise.resolve(T);s instanceof n.WorkspaceEdit&&(w.push(s),h.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-o>c&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),v.isCancellationRequested||w.length===0)return;const E={edits:[]};for(let T of w){let{edits:b}=C.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);E.edits=E.edits.concat(b)}return{edit:E,extensionNames:Array.from(h)}}}e.ExtHostFileSystemEventService=_}),define(fe[222],me([0,1,10,25,2,17,7,126]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(c,v,h,w){this.start=c,this.deletedCount=v,this.deletedItems=h,this.items=w}static asApiEvents(c){return c.map(v=>({start:v.start,deletedCount:v.deletedCount,deletedItems:v.deletedItems,items:v.items.map(h=>h.apiCell)}))}}class D{constructor(c,v,h){this.notebook=c,this._extHostDocument=v,this._cellData=h,this.handle=h.handle,this.uri=y.URI.revive(h.uri),this.cellKind=h.cellKind,this._outputs=h.outputs.map(C.NotebookCellOutput.to),this._internalMetadata=h.internalMetadata??{},this._metadata=Object.freeze(h.metadata??{}),this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(h.internalMetadata??{}))}static asModelAddData(c,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,v=this._extHostDocument.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:C.NotebookCellKind.to(this._cellData.cellKind),document:v.document,get mime(){return c._mime},set mime(h){c._mime=h},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(C.NotebookCellOutput.to)}setOutputItems(c,v,h){const w=h.map(C.NotebookCellOutputItem.to),E=this._outputs.find(T=>T.id===c);E&&(v||(E.items.length=0),E.items.push(...w))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(C.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=D;class P{constructor(c,v,h,w,E,T){this._proxy=c,this._textDocumentsAndEditors=v,this._textDocuments=h,this._emitter=w,this.uri=E,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=T.viewType,this._metadata=Object.freeze(T.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,T.cells]],!0),this._versionId=T.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===g.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(v){return v=c._validateIndex(v),c._cells[v].apiCell},getCells(v){return(v?c._getCells(v):c._cells).map(w=>w.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,v){this._versionId=c.versionId,this._isDirty=v;for(const h of c.rawEvents)h.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(h.changes,!1):h.kind===k.NotebookCellsChangeType.Move?this._moveCell(h.index,h.newIdx):h.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(h.index,h.outputs):h.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(h.index,h.outputId,h.append,h.outputItems):h.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(h.index,h.language):h.kind===k.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(h.index,h.mime):h.kind===k.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(h.index,h.metadata):h.kind===k.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(h.index,h.internalMetadata)}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let v=c.start|0,h=c.end|0;return v<0&&(v=0),h>this._cells.length&&(h=this._cells.length),c.with({start:v,end:h})}_getCells(c){c=this._validateRange(c);const v=[];for(let h=c.start;h<c.end;h++)v.push(this._cells[h]);return v}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,v){if(this._disposed)return;const h=[],w=[],E=[];c.reverse().forEach(T=>{const o=T[2].map(r=>{const m=new D(this,this._textDocumentsAndEditors,r);return v||w.push(D.asModelAddData(this.apiNotebook,r)),m}),s=new _(T[0],T[1],[],o),p=this._cells.splice(T[0],T[1],...o);for(const r of p)E.push(r.uri),s.deletedItems.push(r.apiCell);h.push(s)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:E}),v||this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(h)}))}_moveCell(c,v){const h=this._cells.splice(c,1);this._cells.splice(v,0,...h);const w=[new _(c,1,h.map(E=>E.apiCell),[]),new _(v,0,[],h)];this._emitter.emitModelChange((0,L.deepFreeze)({document:this.apiNotebook,changes:_.asApiEvents(w)}))}_setCellOutputs(c,v){const h=this._cells[c];h.setOutputs(v),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_setCellOutputItems(c,v,h,w){const E=this._cells[c];E.setOutputItems(v,h,w),this._emitter.emitCellOutputsChange((0,L.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(c,v){const h=this._cells[c];h.apiCell.document.languageId!==v&&this._textDocuments.$acceptModelModeChanged(h.uri,v)}_changeCellMime(c,v){const h=this._cells[c];h.apiCell.mime=v}_changeCellMetadata(c,v){const h=this._cells[c],w=h.apiCell.metadata;h.setMetadata(v);const E=h.apiCell.metadata;(0,L.equals)(w,E)||this._emitter.emitCellMetadataChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell}))}_changeCellInternalMetadata(c,v){const h=this._cells[c],w=h.internalMetadata;if(h.setInternalMetadata(v),w.runState!==v.runState){const E=v.runState??n.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,L.deepFreeze)({document:this.apiNotebook,cell:h.apiCell,state:E}))}}getCellFromApiCell(c){return this._cells.find(v=>v.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(v=>v.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(fe[129],me([0,1,7,17,18]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class C{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,D){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:D})}replaceCells(_,D,P){this._throwIfFinalized(),!(_===D&&P.length===0)&&this._collectedEdits.push({editType:1,index:_,count:D-_,cells:P.map(L.NotebookCellData.from)})}}class n{constructor(_,D,P,I,c,v){this.id=_,this._proxy=D,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=I,this._viewColumn=v}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(D){if(!Array.isArray(D)||!D.every(g.NotebookRange.isNotebookRange))throw(0,y.illegalArgument)("selections");_._selections=D,_._trySetSelections(D)},get visibleRanges(){return _._visibleRanges},revealRange(D,P){_._proxy.$tryRevealRange(_.id,L.NotebookRange.from(D),P??g.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(D){const P=new C(this.document.version);return D(P),_._applyEdit(P.finalize())},setDecorations(D,P){return _.setDecorations(D,P)}},n.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(L.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const D=[];let P=-1;for(let I=0;I<_.cellEdits.length;I++){if(P<0){D.push(_.cellEdits[I]),P++;continue}const v=D[P],h=_.cellEdits[I];if(v.editType===1&&h.editType===1&&v.index===h.index){v.cells.push(..._.cellEdits[I].cells),v.count+=_.cellEdits[I].count;continue}D.push(_.cellEdits[I]),P++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,D)}setDecorations(_,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return D.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,L.NotebookRange.from(D),_.key)}}e.ExtHostNotebookEditor=n,n.apiEditorsToExtHost=new WeakMap}),define(fe[223],me([0,1,17,117,166,21,60,18]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class _{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,v,h){const w=this._handles++,{title:E,location:T,cancellable:b}=v,o={label:(0,y.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(w,{location:g.ProgressLocation.from(T),title:E,source:o,cancellable:b},c).catch(k.onUnexpectedExternalError),this._withProgress(w,h,!!b)}_withProgress(c,v,h){let w;h&&(w=new C.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,w));const E=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),w&&w.dispose()};let T;try{T=v(new P(this._proxy,c),h&&w?w.token:C.CancellationToken.None)}catch(b){throw E(c),b}return T.then(b=>E(c),b=>E(c)),T}$acceptProgressCanceled(c){const v=this._mapHandleToCancellationSource.get(c);v&&(v.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=_;function D(I,c){return I.message=c.message,typeof c.increment=="number"&&(typeof I.increment=="number"?I.increment+=c.increment:I.increment=c.increment),I}class P extends L.Progress{constructor(c,v){super(h=>this.throttledReport(h));this._proxy=c,this._handle=v}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}Ve([(0,n.throttle)(100,(I,c)=>D(I,c),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(fe[130],me([0,1,58,18,77,17,7]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(c,v,h){const w=k._Keys.nextId();c.$registerTextEditorDecorationType(v.identifier,w,C.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:w,dispose(){c.$removeTextEditorDecorationType(w)}})}}e.TextEditorDecorationType=k,k._Keys=new y.IdGenerator("TextEditorDecorationType");class _{constructor(c,v){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=v.undoStopBefore,this._undoStopAfter=v.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,v){this._throwIfFinalized();let h=null;if(c instanceof n.Position)h=new n.Range(c,c);else if(c instanceof n.Range)h=c;else throw new Error("Unrecognized location");this._pushEdit(h,v,!1)}insert(c,v){this._throwIfFinalized(),this._pushEdit(new n.Range(c,c),v,!0)}delete(c){this._throwIfFinalized();let v=null;if(c instanceof n.Range)v=c;else throw new Error("Unrecognized location");this._pushEdit(v,null,!0)}_pushEdit(c,v,h){const w=this._document.validateRange(c);this._collectedEdits.push({range:w,text:v,forceMoveMarkers:h})}setEndOfLine(c){if(this._throwIfFinalized(),c!==n.EndOfLine.LF&&c!==n.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=_;class D{constructor(c,v,h,w){this._proxy=c,this._id=v,this._accept(h),this._logService=w;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(T){E._setTabSize(T)},get insertSpaces(){return E._insertSpaces},set insertSpaces(T){E._setInsertSpaces(T)},get cursorStyle(){return E._cursorStyle},set cursorStyle(T){E._setCursorStyle(T)},get lineNumbers(){return E._lineNumbers},set lineNumbers(T){E._setLineNumbers(T)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=C.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const v=Math.floor(c);return v>0?v:null}if(typeof c=="string"){const v=parseInt(c,10);return isNaN(v)?null:v>0?v:null}return null}_setTabSize(c){const v=this._validateTabSize(c);if(v!==null){if(typeof v=="number"){if(this._tabSize===v)return;this._tabSize=v}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:v}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const v=this._validateInsertSpaces(c);if(typeof v=="boolean"){if(this._insertSpaces===v)return;this._insertSpaces=v}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:v}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:C.TextEditorLineNumbersStyle.from(c)})))}assign(c){const v={};let h=!1;if(typeof c.tabSize!="undefined"){const w=this._validateTabSize(c.tabSize);w==="auto"?(h=!0,v.tabSize=w):typeof w=="number"&&this._tabSize!==w&&(this._tabSize=w,h=!0,v.tabSize=w)}if(typeof c.insertSpaces!="undefined"){const w=this._validateInsertSpaces(c.insertSpaces);w==="auto"?(h=!0,v.insertSpaces=w):this._insertSpaces!==w&&(this._insertSpaces=w,h=!0,v.insertSpaces=w)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,h=!0,v.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,h=!0,v.lineNumbers=C.TextEditorLineNumbersStyle.from(c.lineNumbers)),h&&this._warnOnError(this._proxy.$trySetOptions(this._id,v))}_warnOnError(c){c.catch(v=>this._logService.warn(v))}}e.ExtHostTextEditorOptions=D;class P{constructor(c,v,h,w,E,T,b,o){this.id=c,this._proxy=v,this._logService=h,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new D(this._proxy,this.id,T,h),this._visibleRanges=b,this._viewColumn=o;const s=this;this.value=Object.freeze({get document(){return w.getValue()},set document(p){throw(0,L.readonly)("document")},get selection(){return s._selections&&s._selections[0]},set selection(p){if(!(p instanceof n.Selection))throw(0,L.illegalArgument)("selection");s._selections=[p],s._trySetSelection()},get selections(){return s._selections},set selections(p){if(!Array.isArray(p)||p.some(r=>!(r instanceof n.Selection)))throw(0,L.illegalArgument)("selections");s._selections=p,s._trySetSelection()},get visibleRanges(){return s._visibleRanges},set visibleRanges(p){throw(0,L.readonly)("visibleRanges")},get options(){return s._options.value},set options(p){s._disposed||s._options.assign(p)},get viewColumn(){return s._viewColumn},set viewColumn(p){throw(0,L.readonly)("viewColumn")},edit(p,r={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const m=new _(w.getValue(),r);return p(m),s._applyEdit(m)},insertSnippet(p,r,m={undoStopBefore:!0,undoStopAfter:!0}){if(s._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let i;if(!r||Array.isArray(r)&&r.length===0)i=s._selections.map(t=>C.Range.from(t));else if(r instanceof n.Position){const{lineNumber:t,column:u}=C.Position.from(r);i=[{startLineNumber:t,startColumn:u,endLineNumber:t,endColumn:u}]}else if(r instanceof n.Range)i=[C.Range.from(r)];else{i=[];for(const t of r)if(t instanceof n.Range)i.push(C.Range.from(t));else{const{lineNumber:u,column:a}=C.Position.from(t);i.push({startLineNumber:u,startColumn:a,endLineNumber:u,endColumn:a})}}return v.$tryInsertSnippet(c,p.value,i,m)},setDecorations(p,r){const m=r.length===0;m&&!s._hasDecorationsForKey.has(p.key)||(m?s._hasDecorationsForKey.delete(p.key):s._hasDecorationsForKey.add(p.key),s._runOnProxy(()=>{if(C.isDecorationOptionsArr(r))return v.$trySetDecorations(c,p.key,C.fromRangeOrRangeWithMessage(r));{const i=new Array(4*r.length);for(let t=0,u=r.length;t<u;t++){const a=r[t];i[4*t]=a.start.line+1,i[4*t+1]=a.start.character+1,i[4*t+2]=a.end.line+1,i[4*t+3]=a.end.character+1}return v.$trySetDecorationsFast(c,p.key,i)}}))},revealRange(p,r){s._runOnProxy(()=>v.$tryRevealRange(c,C.Range.from(p),r||n.TextEditorRevealType.Default))},show(p){v.$tryShowEditor(c,C.ViewColumn.from(p))},hide(){v.$tryHideEditor(c)}})}dispose(){(0,g.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,g.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,g.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,g.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,g.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(C.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const v=c.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const h=v.edits.map(E=>E.range);h.sort((E,T)=>E.end.line===T.end.line?E.end.character===T.end.character?E.start.line===T.start.line?E.start.character-T.start.character:E.start.line-T.start.line:E.end.character-T.end.character:E.end.line-T.end.line);for(let E=0,T=h.length-1;E<T;E++){const b=h[E].end;if(h[E+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=v.edits.map(E=>({range:C.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,v.documentVersionId,w,{setEndOfLine:typeof v.setEndOfLine=="number"?C.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this._logService.warn(v),null))}}e.ExtHostTextEditor=P}),define(fe[224],me([0,1,169,23,2,3,6,210,16,7,13,15,17,21,207]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function w(b,o){if((0,P.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let s;return Array.isArray(b.highlights)&&(s=b.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),s=s.length?s:void 0),{label:b.label,highlights:s}}}class E{constructor(o,s,p){this._proxy=o,this.commands=s,this.logService=p,this.treeViews=new Map;function r(m){return m&&m.$treeViewId&&m.$treeItemHandle}s.registerArgumentProcessor({processArgument:m=>r(m)?this.convertArgument(m):Array.isArray(m)&&m.length>0?m.map(i=>r(i)?this.convertArgument(i):i):m})}registerTreeDataProvider(o,s,p){const r=this.createTreeView(o,{treeDataProvider:s},p);return{dispose:()=>r.dispose()}}createTreeView(o,s,p){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=s.dragAndDropController!==void 0,m=this._proxy.$registerTreeViewDataProvider(o,{showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,canDragAndDrop:r}),i=this.createExtHostTreeView(o,s,p);return{get onDidCollapseElement(){return i.onDidCollapseElement},get onDidExpandElement(){return i.onDidExpandElement},get selection(){return i.selectedElements},get onDidChangeSelection(){return i.onDidChangeSelection},get visible(){return i.visible},get onDidChangeVisibility(){return i.onDidChangeVisibility},get message(){return i.message},set message(t){i.message=t},get title(){return i.title},set title(t){i.title=t},get description(){return i.description},set description(t){i.description=t},reveal:(t,u)=>i.reveal(t,u),dispose:async()=>{await m,this.treeViews.delete(o),i.dispose()}}}$getChildren(o,s){const p=this.treeViews.get(o);return p?p.getChildren(s):Promise.reject(new Error((0,g.localize)(0,null,o)))}async $onDrop(o,s,p){const r=this.treeViews.get(o);if(!r)return Promise.reject(new Error((0,g.localize)(1,null,o)));const m=h.TreeDataTransferConverter.toITreeDataTransfer(s);if(m.items.has(k.TREE_ITEM_DATA_TRANSFER_TYPE)){const t=JSON.parse(await m.items.get(k.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(u=>r.getExtensionElement(u)).filter(u=>!!u);t.length>0?m.items.set(k.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(t)}):m.items.delete(k.TREE_ITEM_DATA_TRANSFER_TYPE)}return r.onDrop(m,p)}async $hasResolve(o){const s=this.treeViews.get(o);if(!s)throw new Error((0,g.localize)(2,null,o));return s.hasResolve}$resolve(o,s,p){const r=this.treeViews.get(o);if(!r)throw new Error((0,g.localize)(3,null,o));return r.resolveTreeItem(s,p)}$setExpanded(o,s,p){const r=this.treeViews.get(o);if(!r)throw new Error((0,g.localize)(4,null,o));r.setExpanded(s,p)}$setSelection(o,s){const p=this.treeViews.get(o);if(!p)throw new Error((0,g.localize)(5,null,o));p.setSelection(s)}$setVisible(o,s){const p=this.treeViews.get(o);if(!p)throw new Error((0,g.localize)(6,null,o));p.setVisible(s)}createExtHostTreeView(o,s,p){const r=new T(o,s,this._proxy,this.commands.converter,this.logService,p);return this.treeViews.set(o,r),r}convertArgument(o){const s=this.treeViews.get(o.$treeViewId);return s?s.getExtensionElement(o.$treeItemHandle):null}}e.ExtHostTreeViews=E;class T extends n.Disposable{constructor(o,s,p,r,m,i){super();if(this.viewId=o,this.proxy=p,this.commands=r,this.logService=m,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new C.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new C.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new C.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new C.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new C.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new v.CancellationTokenSource,i.contributes&&i.contributes.views)for(const a in i.contributes.views)for(const l of i.contributes.views[a])l.id===o&&(this._title=l.name);this.dataProvider=s.treeDataProvider,this.dndController=s.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(a=>this._onDidChangeData.fire({message:!1,element:a}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let t,u;this._register(C.Event.debounce(this._onDidChangeData.event,(a,l)=>(a||(a={message:!1,elements:[]}),l.element!==!1&&(t||(t=new Promise(f=>u=f),this.refreshPromise=this.refreshPromise.then(()=>t)),Array.isArray(l.element)?a.elements.push(...l.element):a.elements.push(l.element)),l.message&&(a.message=!0),a),200,!0)(({message:a,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const f=u;return t=null,this.refresh(l).then(()=>f())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(o=>this.getExtensionElement(o)).filter(o=>!(0,P.isUndefinedOrNull)(o))}async getChildren(o){const s=o?this.getExtensionElement(o):void 0;if(o&&!s)return this.logService.error(`No tree item with id '${o}' found.`),Promise.resolve([]);let p=this.getChildrenNodes(o);return p||(p=await this.fetchChildrenNodes(s)),p?p.map(r=>r.item):void 0}getExtensionElement(o){return this.elements.get(o)}reveal(o,s){s=s||{select:!0,focus:!1};const p=(0,P.isUndefinedOrNull)(s.select)?!0:s.select,r=(0,P.isUndefinedOrNull)(s.focus)?!1:s.focus,m=(0,P.isUndefinedOrNull)(s.expand)?!1:s.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):o?this.refreshPromise.then(()=>this.resolveUnknownParentChain(o)).then(i=>this.resolveTreeNode(o,i[i.length-1]).then(t=>this.proxy.$reveal(this.viewId,{item:t.item,parentChain:i.map(u=>u.item)},{select:p,focus:r,expand:m})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:p,focus:r,expand:m})}get message(){return this._message}set message(o){this._message=o,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(o){this._title=o,this.proxy.$setTitle(this.viewId,o,this._description)}get description(){return this._description}set description(o){this._description=o,this.proxy.$setTitle(this.viewId,this._title,o)}setExpanded(o,s){const p=this.getExtensionElement(o);p&&(s?this._onDidExpandElement.fire(Object.freeze({element:p})):this._onDidCollapseElement.fire(Object.freeze({element:p})))}setSelection(o){(0,I.equals)(this._selectedHandles,o)||(this._selectedHandles=o,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(o){o!==this._visible&&(this._visible=o,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(o,s){const p=this.getExtensionElement(s);if(!!p)return(0,_.asPromise)(()=>this.dndController?.onDrop(o,p))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(o,s){if(!this.dataProvider.resolveTreeItem)return;const p=this.elements.get(o);if(p){const r=this.nodes.get(p);if(r){const m=await this.dataProvider.resolveTreeItem(r.extensionItem,p,s)??r.extensionItem;return r.item.tooltip=this.getTooltip(m.tooltip),r.item.command=this.getCommand(r.disposableStore,m.command),r.item}}}resolveUnknownParentChain(o){return this.resolveParent(o).then(s=>s?this.resolveUnknownParentChain(s).then(p=>this.resolveTreeNode(s,p[p.length-1]).then(r=>(p.push(r),p))):Promise.resolve([]))}resolveParent(o){const s=this.nodes.get(o);return s?Promise.resolve(s.parent?this.elements.get(s.parent.item.handle):void 0):(0,_.asPromise)(()=>this.dataProvider.getParent(o))}resolveTreeNode(o,s){const p=this.nodes.get(o);return p?Promise.resolve(p):(0,_.asPromise)(()=>this.dataProvider.getTreeItem(o)).then(r=>this.createHandle(o,r,s,!0)).then(r=>this.getChildren(s?s.item.handle:void 0).then(()=>{const m=this.getExtensionElement(r);if(m){const i=this.nodes.get(m);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(o){if(o){let s;if(typeof o=="string"){const p=this.getExtensionElement(o);s=p?this.nodes.get(p):void 0}else s=o;return s&&s.children||void 0}return this.roots}async fetchChildrenNodes(o){this.clearChildren(o);const s=new v.CancellationTokenSource(this._refreshCancellationSource.token);try{const p=o?this.nodes.get(o):void 0,r=await this.dataProvider.getChildren(o);if(s.token.isCancellationRequested)return;const m=await Promise.all((0,I.coalesce)(r||[]).map(async i=>{const t=await this.dataProvider.getTreeItem(i);return t&&!s.token.isCancellationRequested?this.createAndRegisterTreeNode(i,t,p):null}));return s.token.isCancellationRequested?void 0:(0,I.coalesce)(m)}finally{s.dispose()}}refresh(o){if(o.some(p=>!p))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new v.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const p=this.getHandlesToRefresh(o);if(p.length)return this.refreshHandles(p)}return Promise.resolve(void 0)}getHandlesToRefresh(o){const s=new Set,p=o.map(m=>this.nodes.get(m));for(const m of p)if(m&&!s.has(m.item.handle)){let i=m;for(;i&&i.parent&&p.findIndex(t=>i&&i.parent&&t&&t.item.handle===i.parent.item.handle)===-1;){const t=this.elements.get(i.parent.item.handle);i=t?this.nodes.get(t):void 0}i&&!i.parent&&s.add(m.item.handle)}const r=[];return s.forEach(m=>{const i=this.elements.get(m);if(i){const t=this.nodes.get(i);t&&(!t.parent||!s.has(t.parent.item.handle))&&r.push(m)}}),r}refreshHandles(o){const s={};return Promise.all(o.map(p=>this.refreshNode(p).then(r=>{r&&(s[p]=r.item)}))).then(()=>Object.keys(s).length?this.proxy.$refresh(this.viewId,s):void 0)}refreshNode(o){const s=this.getExtensionElement(o);if(s){const p=this.nodes.get(s);if(p)return this.clearChildren(s),(0,_.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(r=>{if(r){const m=this.createTreeNode(s,r,p.parent);return this.updateNodeCache(s,m,p,p.parent),p.dispose(),m}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(o,s,p){const r=this.createTreeNode(o,s,p);if(s.id&&this.elements.has(r.item.handle))throw new Error((0,g.localize)(7,null,s.id));return this.addNodeToCache(o,r),this.addNodeToParentCache(r,p),r}getTooltip(o){return D.MarkdownString.isMarkdownString(o)?c.MarkdownString.from(o):o}getCommand(o,s){return s?this.commands.toInternal(s,o):void 0}createTreeNode(o,s,p){const r=new n.DisposableStore,m=this.createHandle(o,s,p),i=this.getLightIconPath(s);return{item:{handle:m,parentHandle:p?p.item.handle:void 0,label:w(s.label,this.extension),description:s.description,resourceUri:s.resourceUri,tooltip:this.getTooltip(s.tooltip),command:this.getCommand(r,s.command),contextValue:s.contextValue,icon:i,iconDark:this.getDarkIconPath(s)||i,themeIcon:this.getThemeIcon(s),collapsibleState:(0,P.isUndefinedOrNull)(s.collapsibleState)?D.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation},extensionItem:s,parent:p,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(o){return o.iconPath instanceof D.ThemeIcon?o.iconPath:void 0}createHandle(o,{id:s,label:p,resourceUri:r},m,i){if(s)return`${T.ID_HANDLE_PREFIX}/${s}`;const t=w(p,this.extension),u=m?m.item.handle:T.LABEL_HANDLE_PREFIX;let a=t?t.label:r?(0,L.basename)(r):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const l=this.nodes.has(o)?this.nodes.get(o).item.handle:void 0,f=this.getChildrenNodes(m)||[];let d,S=0;do{if(d=`${u}/${S}:${a}`,i||!this.elements.has(d)||l===d)break;S++}while(S<=f.length);return d}getLightIconPath(o){if(o.iconPath&&!(o.iconPath instanceof D.ThemeIcon))return typeof o.iconPath=="string"||y.URI.isUri(o.iconPath)?this.getIconPath(o.iconPath):this.getIconPath(o.iconPath.light)}getDarkIconPath(o){if(o.iconPath&&!(o.iconPath instanceof D.ThemeIcon)&&o.iconPath.dark)return this.getIconPath(o.iconPath.dark)}getIconPath(o){return y.URI.isUri(o)?o:y.URI.file(o)}addNodeToCache(o,s){this.elements.set(s.item.handle,o),this.nodes.set(o,s)}updateNodeCache(o,s,p,r){this.elements.delete(s.item.handle),this.nodes.delete(o),s.item.handle!==p.item.handle&&this.elements.delete(p.item.handle),this.addNodeToCache(o,s);const m=this.getChildrenNodes(r)||[],i=m.filter(t=>t.item.handle===p.item.handle)[0];i&&m.splice(m.indexOf(i),1,s)}addNodeToParentCache(o,s){s?(s.children||(s.children=[]),s.children.push(o)):(this.roots||(this.roots=[]),this.roots.push(o))}clearChildren(o){if(o){const s=this.nodes.get(o);if(s){if(s.children)for(const p of s.children){const r=this.elements.get(p.item.handle);r&&this.clear(r)}s.children=void 0}}else this.clearAll()}clear(o){const s=this.nodes.get(o);if(s){if(s.children)for(const p of s.children){const r=this.elements.get(p.item.handle);r&&this.clear(r)}this.nodes.delete(o),this.elements.delete(s.item.handle),s.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(o=>o.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}T.LABEL_HANDLE_PREFIX="0",T.ID_HANDLE_PREFIX="1"}),define(fe[225],me([0,1,16,3,6,13,66,17,127,90]),function(Y,e,g,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class P extends y.Disposable{constructor(c){super();this.controllerId=c,this.debounceSendDiff=this._register(new g.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new L.Emitter),this.root=new n.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(c){this._resolveHandler=c;for(const v of this.tree.values())this.updateExpandability(v)}collectDiff(){const c=this.diff;return this.diff=[],c}pushDiff(c){const v=this.diff[this.diff.length-1];if(v&&c[0]===1){if(v[0]===1&&v[1].extId===c[1].extId){(0,_.applyTestItemUpdate)(v[1],c[1]);return}if(v[0]===0&&v[1].item.extId===c[1].extId){(0,_.applyTestItemUpdate)(v[1],c[1]);return}}this.diff.push(c),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(c,v){const h=this.tree.get(c);if(!!h){if((h.expandLevels===void 0||v>h.expandLevels)&&(h.expandLevels=v),h.expand===1){const w=this.resolveChildren(h);return w.isOpen()?this.expandChildren(h,v-1):w.wait().then(()=>this.expandChildren(h,v-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.expandChildren(h,v-1)):this.expandChildren(h,v-1)}}dispose(){for(const c of this.tree.values())(0,n.getPrivateApiFor)(c.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(c,v){switch(v.op){case 2:this.pushDiff([4,c.fullId.toString()]);break;case 1:this.removeItem(D.TestId.joinToString(c.fullId,v.id));break;case 0:this.upsertItem(v.item,c);break;case 4:for(const b of v.ops)this.onTestItemEvent(c,b);break;case 3:const{key:h,value:w,previous:E}=v,T=c.fullId.toString();switch(h){case"canResolveChildren":this.updateExpandability(c);break;case"tags":this.diffTagRefs(w,E,T);break;case"range":this.pushDiff([1,{extId:T,item:{range:k.Range.from(w)}}]);break;case"error":this.pushDiff([1,{extId:T,item:{error:k.MarkdownString.fromStrict(w)||null}}]);break;default:this.pushDiff([1,{extId:T,item:{[h]:w??null}}]);break}break;default:(0,C.assertNever)(v)}}upsertItem(c,v){if(!(c instanceof n.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${c.id} did not`);const h=D.TestId.fromExtHostTestItem(c,this.root.id,v?.actual),w=(0,n.getPrivateApiFor)(c);w.parent&&w.parent!==v?.actual&&w.parent.children.delete(c.id);let E=this.tree.get(h.toString());if(!E){E={fullId:h,actual:c,parent:v?h.parentId:null,expandLevels:v?.expandLevels?v.expandLevels-1:void 0,expand:0},c.tags.forEach(this.incrementTagRefs,this),this.tree.set(E.fullId.toString(),E),this.setItemParent(c,v),this.pushDiff([0,{parent:E.parent&&E.parent.toString(),controllerId:this.controllerId,expand:E.expand,item:k.TestItem.from(c)}]),this.connectItemAndChildren(c,E,v);return}if(E.actual===c){this.connectItem(c,E,v);return}const T=E.actual.children,b=E.actual,o=(0,n.diffTestItems)(b,c);(0,n.getPrivateApiFor)(b).listener=void 0,E.actual=c,E.expand=0;for(const[s,p]of o)this.onTestItemEvent(E,{op:3,key:s,value:p,previous:b[s]});this.connectItemAndChildren(c,E,v);for(const s of T)c.children.get(s.id)||this.removeItem(D.TestId.joinToString(h,s.id))}diffTagRefs(c,v,h){const w=new Set(v.map(E=>E.id));for(const E of c)w.delete(E.id)||this.incrementTagRefs(E);this.pushDiff([1,{extId:h,item:{tags:c.map(E=>k.TestTag.namespace(this.controllerId,E.id))}}]),w.forEach(this.decrementTagRefs,this)}incrementTagRefs(c){const v=this.tags.get(c.id);v?v.refCount++:(this.tags.set(c.id,{refCount:1}),this.pushDiff([5,{id:k.TestTag.namespace(this.controllerId,c.id),ctrlLabel:this.root.label}]))}decrementTagRefs(c){const v=this.tags.get(c);v&&!--v.refCount&&(this.tags.delete(c),this.pushDiff([6,k.TestTag.namespace(this.controllerId,c)]))}setItemParent(c,v){(0,n.getPrivateApiFor)(c).parent=v&&v.actual!==this.root?v.actual:void 0}connectItem(c,v,h){this.setItemParent(c,h);const w=(0,n.getPrivateApiFor)(c);w.parent=h?.actual,w.listener=E=>this.onTestItemEvent(v,E),this.updateExpandability(v)}connectItemAndChildren(c,v,h){this.connectItem(c,v,h);for(const w of c.children)this.upsertItem(w,v)}updateExpandability(c){let v;this._resolveHandler?c.resolveBarrier?v=c.resolveBarrier.isOpen()?3:2:v=c.actual.canResolveChildren?1:0:v=0,v!==c.expand&&(c.expand=v,this.pushDiff([1,{extId:c.fullId.toString(),expand:v}]),v===1&&c.expandLevels!==void 0&&this.resolveChildren(c))}expandChildren(c,v){if(v<0)return;const h=[];for(const w of c.actual.children){const E=this.expand(D.TestId.joinToString(c.fullId,w.id),v);(0,g.isThenable)(E)&&h.push(E)}if(h.length)return Promise.all(h).then(()=>{})}resolveChildren(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this._resolveHandler){const E=new g.Barrier;return E.open(),E}c.expand=2,this.pushExpandStateUpdate(c);const v=c.resolveBarrier=new g.Barrier,h=E=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),c.actual!==this.root&&(c.actual.error=E.stack||E.message||String(E))};let w;try{w=this._resolveHandler(c.actual===this.root?void 0:c.actual)}catch(E){h(E)}return(0,g.isThenable)(w)?w.catch(h).then(()=>{v.open(),this.updateExpandability(c)}):(v.open(),this.updateExpandability(c)),c.resolveBarrier}pushExpandStateUpdate(c){this.pushDiff([1,{extId:c.fullId.toString(),expand:c.expand}])}removeItem(c){const v=this.tree.get(c);if(!v)throw new Error("attempting to remove non-existent child");this.pushDiff([2,c]);const h=[v];for(;h.length;){const w=h.pop();if(!!w){(0,n.getPrivateApiFor)(w.actual).listener=void 0;for(const E of w.actual.tags)this.decrementTagRefs(E.id);this.tree.delete(w.fullId.toString());for(const E of w.actual.children)h.push(this.tree.get(D.TestId.joinToString(w.fullId,E.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.diffOpEmitter.fire(c)}}e.SingleUseTestCollection=P}),define(fe[226],me([0,1,4,185]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,g.refineServiceDecorator)(L.IEnvironmentService)}),define(fe[227],me([0,1,27,3,9]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class C{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=C;class n{constructor(P){this._onDidChange=new L.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=P,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const P of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(P.identifier),P),this._extensionsArr.push(P),Array.isArray(P.activationEvents))for(let I of P.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(P.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(P)}}keepOnly(P){const I=new Set;P.forEach(c=>I.add(g.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>I.has(g.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(P,I){P.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(P));const c=n._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(c.map(v=>v.identifier)),I.length>0){const v=new Set;I.forEach(h=>v.add(g.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>!v.has(g.ExtensionIdentifier.toKey(h.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new C(c)}static _findLoopingExtensions(P){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,T){this.addNode(E),this.addNode(T),this._arcs.has(E)?this._arcs.get(E).push(T):this._arcs.set(E,[T])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,T){const b=I.getArcs(E);for(let o=0;o<b.length;o++)if(!T.has(b[o]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let E of P){const T=g.ExtensionIdentifier.toKey(E.identifier);if(c.set(T,E),E.extensionDependencies)for(let b of E.extensionDependencies){const o=g.ExtensionIdentifier.toKey(b);I.addArc(T,o)}}let v=new Set;I.getNodes().filter(E=>I.getArcs(E).length===0).forEach(E=>v.add(E));let h=I.getNodes().filter(E=>!v.has(E)),w;do{w=!1;for(let E=0;E<h.length;E++){const T=h[E];I.hasOnlyGoodArcs(T,v)&&(h.splice(E,1),E--,v.add(T),w=!0)}}while(w);return h.map(E=>c.get(E))}containsActivationEvent(P){return this._activationMap.has(P)}containsExtension(P){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const I=this._activationMap.get(P);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(P){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(P));return I||void 0}}e.ExtensionDescriptionRegistry=n;var k;(function(D){D[D.Builtin=0]="Builtin",D[D.User=1]="User",D[D.Dev=2]="Dev"})(k||(k={}));function _(D,P){const I=D.isBuiltin?0:D.isUnderDevelopment?2:1,c=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(I!==c)return I-c;const v=y.posix.basename(D.extensionLocation.path),h=y.posix.basename(P.extensionLocation.path);return v<h?-1:v>h?1:0}}),define(fe[228],me([0,1,22]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var L;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(L=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var y;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(y=e.MessageType||(e.MessageType={}));function C(k){const _=g.VSBuffer.alloc(1);switch(k){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=C;function n(k,_){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=n}),define(fe[29],me([0,1,3,2,4,27,195]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new C.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,y.createDecorator)("extensionService");var k;(function(s){s[s.None=0]="None",s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(k=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function _(s){switch(s){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=_;class D{constructor(p){this.dependency=p}}e.MissingExtensionDependency=D;var P;(function(s){s[s.LocalProcess=0]="LocalProcess",s[s.LocalWebWorker=1]="LocalWebWorker",s[s.Remote=2]="Remote"})(P=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(s){switch(s){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=I;function c(s,p){return p&&s.enabledApiProposals?.includes(p)?!0:Boolean(s.enableProposedApi)}e.isProposedApiEnabled=c;function v(s,p){if(!c(s,p))throw new Error(`[${s.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=v;class h{constructor(p,r,m,i){this.codeLoadingTime=p,this.activateCallTime=r,this.activateResolvedTime=m,this.activationReason=i}}e.ActivationTimes=h;class w{constructor(p,r){this.description=p,this.value=r}}e.ExtensionPointContribution=w,e.ExtensionHostLogFileName="exthost";var E;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(E=e.ActivationKind||(e.ActivationKind={}));function T(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,n.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation}}e.toExtension=T;function b(s,p){return{identifier:new C.ExtensionIdentifier(s.identifier.id),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!p,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid}}e.toExtensionDescription=b;class o{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(p){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(p){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(p,r){return Promise.resolve()}_onWillActivateExtension(p){}_onDidActivateExtension(p,r,m,i,t){}_onDidActivateExtensionError(p,r){}_onExtensionRuntimeError(p,r){}_onExtensionHostExit(p){}}e.NullExtensionService=o}),define(fe[229],me([0,1,27,29,11]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class n{constructor(h,w,E,T){this.startup=h,this.codeLoadingTime=w,this.activateCallTime=E,this.activateResolvedTime=T}}e.ExtensionActivationTimes=n,n.NONE=new n(!1,-1,-1,-1);class k{constructor(h){this._startup=h,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(h,w){return h===-1||w===-1?-1:w-h}build(){return new n(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class _{constructor(h,w,E,T,b,o){this.activationFailed=h,this.activationFailedError=w,this.activationTimes=E,this.module=T,this.exports=b,this.subscriptions=o}}e.ActivatedExtension=_;class D extends _{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class P extends _{constructor(){super(!1,null,n.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=P;class I extends _{constructor(h){super(!0,h,n.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let c=class{constructor(h,w,E,T,b){this._logService=b,this._registry=h,this._resolvedExtensionsSet=new Set,w.forEach(o=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(o))),this._hostExtensionsMap=new Map,E.forEach(o=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(o),o)),this._host=T,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(h){const w=g.ExtensionIdentifier.toKey(h);return this._activatedExtensions.has(w)}getActivatedExtension(h){const w=g.ExtensionIdentifier.toKey(h),E=this._activatedExtensions.get(w);if(!E)throw new Error("Extension `"+h.value+"` is not known or not activated");return E}activateByEvent(h,w){if(this._alreadyActivatedEvents[h])return C;const E=this._registry.getExtensionDescriptionsForActivationEvent(h);return this._activateExtensions(E.map(T=>({id:T.identifier,reason:{startup:w,extensionId:T.identifier,activationEvent:h}}))).then(()=>{this._alreadyActivatedEvents[h]=!0})}activateById(h,w){const E=this._registry.getExtensionDescription(h);if(!E)throw new Error("Extension `"+h+"` is not known");return this._activateExtensions([{id:E.identifier,reason:w}])}_handleActivateRequest(h,w,E){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(h.id))){w[g.ExtensionIdentifier.toKey(h.id)]=h;return}const T=this._registry.getExtensionDescription(h.id);if(!T){const s=new Error(`Cannot activate unknown extension '${h.id.value}'`);this._host.onExtensionActivationError(h.id,s,new L.MissingExtensionDependency(h.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(h.id),new I(s));return}const b=typeof T.extensionDependencies=="undefined"?[]:T.extensionDependencies;let o=!0;for(let s=0,p=b.length;s<p;s++){const r=b[s];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(r)))continue;const m=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(r));if(m&&!m.activationFailed)continue;if(m&&m.activationFailed){const a=T.displayName||T.identifier.value,l=this._registry.getExtensionDescription(r),f=l&&l.displayName||r,d=new Error(`Cannot activate the '${a}' extension because its dependency '${f}' failed to activate`);d.detail=m.activationFailedError,this._host.onExtensionActivationError(T.identifier,d,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(T.identifier),new I(d));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(r))){o=!1,w[g.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(r)),reason:h.reason};continue}const i=this._registry.getExtensionDescription(r);if(i){if(!i.main&&!i.browser)continue;o=!1,w[g.ExtensionIdentifier.toKey(r)]={id:i.identifier,reason:h.reason};continue}const t=T.displayName||T.identifier.value,u=new Error(`Cannot activate the '${t}' extension because it depends on unknown extension '${r}'`);this._host.onExtensionActivationError(T.identifier,u,new L.MissingExtensionDependency(r)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(T.identifier),new I(u));return}o?w[g.ExtensionIdentifier.toKey(T.identifier)]=h:E.push(h)}_activateExtensions(h){if(h.length===0||(h=h.filter(b=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(b.id))),h.length===0))return Promise.resolve(void 0);const w=Object.create(null),E=[];for(let b=0,o=h.length;b<o;b++)this._handleActivateRequest(h[b],w,E);for(let b=0,o=E.length;b<o;b++){const s=g.ExtensionIdentifier.toKey(E[b].id);w[s]&&delete w[s]}const T=Object.keys(w).map(b=>w[b]);return E.length===0?Promise.all(T.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(T).then(b=>this._activateExtensions(E))}_activateExtension(h,w){const E=g.ExtensionIdentifier.toKey(h);if(this._activatedExtensions.has(E))return Promise.resolve(void 0);const T=this._activatingExtensions.get(E);if(T)return T;const b=this._host.actualActivateExtension(h,w).then(void 0,o=>{const s=new Error;return o&&o.name&&(s.name=o.name),o&&o.message?s.message=`Activating extension '${h.value}' failed: ${o.message}.`:s.message=`Activating extension '${h.value}' failed: ${o}.`,o&&o.stack&&(s.stack=o.stack),this._host.onExtensionActivationError(h,s,null),this._logService.error(`Activating extension ${h.value} failed due to an error:`),this._logService.error(o),new I(o)}).then(o=>{this._activatedExtensions.set(E,o),this._activatingExtensions.delete(E)});return this._activatingExtensions.set(E,b),b}};c=Ve([$e(4,y.ILogService)],c),e.ExtensionsActivator=c}),define(fe[230],me([0,1,11,26,29]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let C=class extends g.LogService{constructor(k,_){super(k.createLogger(_.logFile,{name:y.ExtensionHostLogFileName}))}};C=Ve([$e(0,g.ILoggerService),$e(1,L.IExtHostInitDataService)],C),e.ExtHostLogService=C}),define(fe[231],me([0,1,18]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class L{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((C,n)=>{this._actualOk=C,this._actualErr=n,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(C){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=C,this._actual&&this._actualOk(C))}resolveErr(C){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=C,this._actual?this._actualErr(C):(0,g.onUnexpectedError)(C))}then(C,n){return this._ensureActual().then(C,n)}catch(C){return this._ensureActual().then(void 0,C)}finally(C){return this._ensureActual().finally(C)}}e.LazyPromise=L}),define(fe[55],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(D,P){this._proxyIdentifierBrand=void 0,this.isMain=D,this.sid=P,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const L=[];function y(_){const D=new g(!0,_);return L[D.nid]=D,D}e.createMainContextProxyIdentifier=y;function C(_){const D=new g(!1,_);return L[D.nid]=D,D}e.createExtHostContextProxyIdentifier=C;function n(_){return L[_].sid}e.getStringIdentifierForProxy=n;class k{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=k}),define(fe[5],me([0,1,62,2,55]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var C;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(C=e.UIKind||(e.UIKind={}));var n;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(n=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var D;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(D=e.CellOutputKind||(e.CellOutputKind={}));var P;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(P=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var c;(function(o){o.name="$ident";function s(r,m){return Object.defineProperty(r,o.name,{value:m,enumerable:!0}),r}o.mixin=s;function p(r){return r[o.name]}o.of=p})(c=e.ObjectIdentifier||(e.ObjectIdentifier={}));class v{static mixin(s){return s._id=v._n++,s}}e.IdObject=v,v._n=0;var h;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(h=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var w;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(w=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var E;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(E=e.WorkspaceEditType||(e.WorkspaceEditType={}));function T(o){if(o&&o.edits)for(const s of o.edits)typeof s.resource=="object"?s.resource=L.URI.revive(s.resource):(s.newUri=L.URI.revive(s.newUri),s.oldUri=L.URI.revive(s.oldUri)),s.metadata&&s.metadata.iconPath&&(s.metadata=(0,g.revive)(s.metadata));return o}e.reviveWorkspaceEditDto=T;var b;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,y.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,y.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,y.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,y.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,y.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,y.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,y.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,y.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,y.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,y.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,y.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,y.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,y.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,y.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,y.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,y.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,y.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,y.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,y.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,y.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,y.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,y.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,y.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,y.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,y.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,y.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,y.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,y.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,y.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,y.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,y.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,y.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,y.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,y.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,y.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,y.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,y.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,y.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,y.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,y.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,y.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,y.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,y.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,y.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,y.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,y.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,y.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,y.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,y.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,y.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,y.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,y.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,y.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,y.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,y.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,y.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,y.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(fe[91],me([0,1,5,3,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class C{constructor(k){this._onDidChangePassword=new L.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,_){return this._proxy.$getPassword(k,_)}store(k,_,D){return this._proxy.$setPassword(k,_,D)}delete(k,_){return this._proxy.$deletePassword(k,_)}}e.ExtHostSecretState=C,e.IExtHostSecretState=(0,y.createDecorator)("IExtHostSecretState")}),define(fe[68],me([0,1,4,11,5,14]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,g.createDecorator)("IExtHostApiDeprecationService");let n=class{constructor(_,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(y.MainContext.MainThreadTelemetry)}report(_,D,P){const I=this.getUsageKey(_,D);this._reportedUsages.has(I)||(this._reportedUsages.add(I),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${P}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:_}))}getUsageKey(_,D){return`${_}-${D.identifier.value}`}};n=Ve([$e(0,C.IExtHostRpcService),$e(1,L.ILogService)],n),e.ExtHostApiDeprecationService=n,e.NullApiDeprecationService=Object.freeze(new class{report(k,_,D){}})}),define(fe[232],me([0,1,3,5,7,27]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class n{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}async getSession(_,D,P,I={}){const c=C.ExtensionIdentifier.toKey(_.identifier),v=this._inFlightRequests.get(c)||[],h=[...P].sort().join(" ");let w=v.find(E=>E.scopes===h);if(w)return w.result;{const E=this._getSession(_,c,D,P,I);w={scopes:h,result:E},v.push(w),this._inFlightRequests.set(c,v);try{await E}finally{const T=v.findIndex(b=>b.scopes===h);T>-1&&(v.splice(T),this._inFlightRequests.set(c,v))}return E}}async _getSession(_,D,P,I,c={}){await this._proxy.$ensureProvider(P);const v=_.displayName||_.name;return this._proxy.$getSession(P,I,D,v,c)}async removeSession(_,D){const P=this._authenticationProviders.get(_);return P?P.provider.removeSession(D):this._proxy.$removeSession(_,D)}registerAuthenticationProvider(_,D,P,I){if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:D,provider:P,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(v=>v.id===_)||this._providers.push({id:_,label:D});const c=P.onDidChangeSessions(v=>{this._proxy.$sendDidChangeSessions(_,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this._proxy.$registerAuthenticationProvider(_,D,I?.supportsMultipleAccounts??!1),new y.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(_);const v=this._providers.findIndex(h=>h.id===_);v>-1&&this._providers.splice(v),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,D){const P=this._authenticationProviders.get(_);if(P)return Promise.resolve(P.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,D){const P=this._authenticationProviders.get(_);if(P)return Promise.resolve(P.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,D){const P=this._authenticationProviders.get(_);if(P)return Promise.resolve(P.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,D){return this._onDidChangeSessions.fire({provider:{id:_,label:D}}),Promise.resolve()}}e.ExtHostAuthentication=n}),define(fe[233],me([0,1,5,14,17]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let C=class{constructor(k,_){this._extHostDocumentsAndEditors=_,this._proxy=k.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const _=y.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostBulkEdits=C}),define(fe[234],me([0,1,5]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(C){const n=C.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return n.$readText()},writeText(k){return n.$writeText(k)}})}}e.ExtHostClipboard=L}),define(fe[40],me([0,1,13,7,17,25,5,15,11,62,42,51,2,6,4,14,66,22,55,52]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(u,a){this._commands=new Map,this._apiCommands=new Map,this._proxy=u.getProxy(n.MainContext.MainThreadCommands),this._logService=a,this.converter=new p(this,l=>{const f=this._apiCommands.get(l);return f?.result===m.Void?f:void 0},a),this._argumentProcessors=[{processArgument(l){return(0,D.revive)(l)}},{processArgument(l){return(0,C.cloneAndChange)(l,function(f){if(P.Range.isIRange(f))return y.Range.to(f);if(I.Position.isIPosition(f))return y.Position.to(f);if(P.Range.isIRange(f.range)&&c.URI.isUri(f.uri))return y.location.to(f);if(f instanceof T.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(u){this._argumentProcessors.push(u)}registerApiCommand(u){const a=this.registerCommand(!1,u.id,async(...l)=>{const f=u.args.map((S,A)=>{if(!S.validate(l[A]))throw new Error(`Invalid argument '${S.name}' when running '${u.id}', received: ${l[A]}`);return S.convert(l[A])}),d=await this.executeCommand(u.internalId,...f);return u.result.convert(d,l,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this._apiCommands.set(u.id,u),new L.Disposable(()=>{a.dispose(),this._apiCommands.delete(u.id)})}registerCommand(u,a,l,f,d,S){if(this._logService.trace("ExtHostCommands#registerCommand",a),!a.trim().length)throw new Error("invalid id");if(this._commands.has(a))throw new Error(`command '${a}' already exists`);return this._commands.set(a,{callback:l,thisArg:f,description:d,extension:S}),u&&this._proxy.$registerCommand(a),new L.Disposable(()=>{this._commands.delete(a)&&u&&this._proxy.$unregisterCommand(a)})}executeCommand(u,...a){return this._logService.trace("ExtHostCommands#executeCommand",u),this._doExecuteCommand(u,a,!0)}async _doExecuteCommand(u,a,l){if(this._commands.has(u))return this._executeContributedCommand(u,a,!1);{let f=!1;const d=(0,C.cloneAndChange)(a,function(S){if(S instanceof L.Position)return y.Position.from(S);if(S instanceof L.Range)return y.Range.from(S);if(S instanceof L.Location)return y.location.from(S);if(L.NotebookRange.isNotebookRange(S))return y.NotebookRange.from(S);if(S instanceof ArrayBuffer)return f=!0,T.VSBuffer.wrap(new Uint8Array(S));if(S instanceof Uint8Array)return f=!0,T.VSBuffer.wrap(S);if(!Array.isArray(S))return S});try{const S=await this._proxy.$executeCommand(u,f?new b.SerializableObjectWithBuffers(d):d,l);return(0,D.revive)(S)}catch(S){if(S instanceof Error&&S.message==="$executeCommand:retry")return this._doExecuteCommand(u,a,!1);throw S}}}async _executeContributedCommand(u,a,l){const f=this._commands.get(u);if(!f)throw new Error("Unknown command");let{callback:d,thisArg:S,description:A}=f;if(A)for(let R=0;R<A.args.length;R++)try{(0,g.validateConstraint)(a[R],A.args[R].constraint)}catch(B){throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${A.args[R].name}' - ${A.args[R].description}`)}try{return await d.apply(S,a)}catch(R){if(u===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...a);B&&(u=B.command)}throw this._logService.error(R,u,f.extension?.identifier),l?new class extends Error{constructor(){super((0,o.toErrorMessage)(R));this.id=u,this.source=f.extension?.displayName??f.extension?.name}}:R}}$executeContributedCommand(u,...a){return this._logService.trace("ExtHostCommands#$executeContributedCommand",u),this._commands.has(u)?(a=a.map(l=>this._argumentProcessors.reduce((f,d)=>d.processArgument(f),l)),this._executeContributedCommand(u,a,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this._logService.trace("ExtHostCommands#getCommands",u),this._proxy.$getCommands().then(a=>(u&&(a=a.filter(l=>l[0]!=="_")),a))}$getContributedCommandHandlerDescriptions(){const u=Object.create(null);for(let[a,l]of this._commands){let{description:f}=l;f&&(u[a]=f)}return Promise.resolve(u)}};s=Ve([$e(0,w.IExtHostRpcService),$e(1,_.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,h.createDecorator)("IExtHostCommands");class p{constructor(u,a,l){this._commands=u,this._lookupApiCommand=a,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(u,a){if(!u)return;const l={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return l;const f=this._lookupApiCommand(u.command);if(f)l.id=f.internalId,l.arguments=f.args.map((d,S)=>d.convert(u.arguments&&u.arguments[S]));else if((0,k.isNonEmptyArray)(u.arguments)){const d=++this._cachIdPool;this._cache.set(d,u),a.add((0,v.toDisposable)(()=>{this._cache.delete(d),this._logService.trace("CommandsConverter#DISPOSE",d)})),l.$ident=d,l.id=this.delegatingCommandId,l.arguments=[d],this._logService.trace("CommandsConverter#CREATE",u.command,d)}return l}fromInternal(u){const a=n.ObjectIdentifier.of(u);return typeof a=="number"?this._cache.get(a):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this._cache.get(u[0])}_executeConvertedCommand(...u){const a=this.getActualCommand(...u);return this._logService.trace("CommandsConverter#EXECUTE",u[0],a?a.command:"MISSING"),a?this._commands.executeCommand(a.command,...a.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=p;class r{constructor(u,a,l,f){this.name=u,this.description=a,this.validate=l,this.convert=f}optional(){return new r(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,a){return new r(u??this.name,a??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",t=>c.URI.isUri(t),t=>t),r.Position=new r("position","A position in a text document",t=>L.Position.isPosition(t),y.Position.from),r.Range=new r("range","A range in a text document",t=>L.Range.isRange(t),y.Range.from),r.Selection=new r("selection","A selection in a text document",t=>L.Selection.isSelection(t),y.Selection.from),r.Number=new r("number","",t=>typeof t=="number",t=>t),r.String=new r("string","",t=>typeof t=="string",t=>t),r.CallHierarchyItem=new r("item","A call hierarchy item",t=>t instanceof L.CallHierarchyItem,y.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",t=>t instanceof L.TypeHierarchyItem,y.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",t=>t instanceof E.TestItemImpl,y.TestItem.from);class m{constructor(u,a){this.description=u,this.convert=a}}e.ApiCommandResult=m,m.Void=new m("no result",t=>t);class i{constructor(u,a,l,f,d){this.id=u,this.internalId=a,this.description=l,this.args=f,this.result=d}}e.ApiCommand=i}),define(fe[235],me([0,1,17,7,85,40,15,111]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",P(g.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,v)=>{if((0,n.isFalsyOrEmpty)(c))return;class h extends L.SymbolInformation{static to(E){const T=new h(E.name,g.SymbolKind.to(E.kind),E.containerName||"",new L.Location(v[0],g.Range.to(E.range)));return T.detail=E.detail,T.range=T.location.range,T.selectionRange=g.Range.to(E.selectionRange),T.children=E.children?E.children.map(h.to):[],T}}return c.map(h.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(g.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",c=>typeof c=="string",c=>c),new C.ApiCommandArgument("options","Formatting options",c=>!0,c=>c)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",P(g.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",P(g.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",P(g.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",c=>Array.isArray(c)&&c.every(v=>L.Position.isPosition(v)),c=>c.map(g.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",c=>c.map(v=>{let h;for(const w of v.reverse())h=new L.SelectionRange(g.Range.to(w),h);return h}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",c=>{const v=[];if(Array.isArray(c))for(let h of c)v.push(...h[1].map(g.WorkspaceSymbol.to));return v})),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",c=>c.map(g.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",c=>{if(!!c)return{range:g.Range.to(c.range),placeholder:c.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",c=>{if(!!c){if(c.rejectReason)throw new Error(c.rejectReason);return g.WorkspaceEdit.to(c)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(g.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const v=(0,k.decodeSemanticTokensDto)(c);if(v.type==="full")return new L.SemanticTokens(v.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",c=>{if(!!c)return new L.SemanticTokensLegend(c.tokenTypes,c.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const v=(0,k.decodeSemanticTokensDto)(c);if(v.type==="full")return new L.SemanticTokens(v.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(c,v,h)=>{if(!c)return new L.CompletionList([]);const w=c.suggestions.map(E=>g.CompletionItem.to(E,h));return new L.CompletionList(w,c.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",c=>{if(c)return g.SignatureHelp.to(c)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(c,v,h)=>P(w=>new L.CodeLens(g.Range.to(w.range),w.command&&h.fromInternal(w.command)))(c))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>L.Range.isRange(c),c=>L.Selection.isSelection(c)?g.Selection.from(c):g.Range.from(c)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(c,v,h)=>P(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(w.command)}else{const E=new L.CodeAction(w.title,w.kind?new L.CodeActionKind(w.kind):void 0);return w.edit&&(E.edit=g.WorkspaceEdit.to(w.edit)),w.command&&(E.command=h.fromInternal(w.command)),E.isPreferred=w.isPreferred,E}})(c))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(v=>new L.ColorInformation(g.Range.to(v.range),g.Color.to(v.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",c=>c instanceof L.Color,g.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:g.Range.from(c.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(g.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",c=>c.map(g.InlayHint.to))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",P(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(v=>g.NotebookExclusiveDocumentPattern.to(v))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",c=>c.map(g.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[c,void 0]:[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[g.ViewColumn.from(c.viewColumn),g.TextEditorOpenOptions.from(c)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",c=>c.map(g.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class D{static register(v){_.forEach(v.registerApiCommand,v)}}e.ExtHostApiCommands=D;function P(c){return v=>{if(Array.isArray(v))return v.map(c)}}function I(c){if(!Array.isArray(c))return;const v=[];for(const h of c)y.isLocationLink(h)?v.push(g.DefinitionLink.to(h)):v.push(g.location.to(h));return v}}),define(fe[236],me([0,1,16,60,3,6,2,85,27,17,7,5]),function(Y,e,g,L,y,C,n,k,_,D,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(v,h,w){const E=v.getProxy(I.MainContext.MainThreadComments);class T{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const u=this._commentControllers.get(t.handle);return u||t}else if(t&&t.$mid===7){const u=this._commentControllers.get(t.commentControlHandle);if(!u)return t;const a=u.getCommentThread(t.commentThreadHandle);return a||t}else if(t&&t.$mid===8){const u=this._commentControllers.get(t.thread.commentControlHandle);if(!u)return t;const a=u.getCommentThread(t.thread.commentThreadHandle);return a?{thread:a,text:t.text}:t}else if(t&&t.$mid===9){const u=this._commentControllers.get(t.thread.commentControlHandle);if(!u)return t;const a=u.getCommentThread(t.thread.commentThreadHandle);if(!a)return t;let l=t.commentUniqueId,f=a.getCommentByUniqueId(l);return f||t}else if(t&&t.$mid===10){const u=this._commentControllers.get(t.thread.commentControlHandle);if(!u)return t;const a=u.getCommentThread(t.thread.commentThreadHandle);if(!a)return t;let l=t.text,f=t.commentUniqueId,d=a.getCommentByUniqueId(f);return d?(d.body=l,d):t}return t}})}createCommentController(t,u,a){const l=T.handlePool++,f=new o(t,l,u,a);this._commentControllers.set(f.handle,f);const d=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(t.identifier))||[];return d.push(f),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(t.identifier),d),f.value}$createCommentThreadTemplate(t,u,a){const l=this._commentControllers.get(t);!l||l.$createCommentThreadTemplate(u,a)}async $updateCommentThreadTemplate(t,u,a){const l=this._commentControllers.get(t);!l||l.$updateCommentThreadTemplate(u,a)}$deleteCommentThread(t,u){const a=this._commentControllers.get(t);a&&a.$deleteCommentThread(u)}$provideCommentingRanges(t,u,a){const l=this._commentControllers.get(t);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const f=w.getDocument(n.URI.revive(u));return(0,g.asPromise)(()=>l.commentingRangeProvider.provideCommentingRanges(f,a)).then(d=>d?d.map(S=>D.Range.from(S)):void 0)}$toggleReaction(t,u,a,l,f){const d=this._commentControllers.get(t);return!d||!d.reactionHandler?Promise.resolve(void 0):(0,g.asPromise)(()=>{const S=d.getCommentThread(u);if(S){const A=S.getCommentByUniqueId(l.uniqueIdInThread);if(d!==void 0&&A&&d.reactionHandler)return d.reactionHandler(A,r(f))}return Promise.resolve(void 0)})}dispose(){}}T.handlePool=0;class b{constructor(t,u,a,l,f,d,S){this._commentControllerHandle=u,this._id=a,this._uri=l,this._range=f,this._comments=d,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new y.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputDisposables.value=new C.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),E.$createCommentThread(u,this.handle,this._id,this._uri,D.Range.from(this._range),S),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=d,this._localDisposables.push({dispose:()=>{E.$deleteCommentThread(u,this.handle)}});const A=this;this.value={get uri(){return A.uri},get range(){return A.range},set range(R){A.range=R},get comments(){return A.comments},set comments(R){A.comments=R},get collapsibleState(){return A.collapsibleState},set collapsibleState(R){A.collapsibleState=R},get canReply(){return A.canReply},set canReply(R){A.canReply=R},get contextValue(){return A.contextValue},set contextValue(R){A.contextValue=R},get label(){return A.label},set label(R){A.label=R},dispose:()=>{A.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new C.DisposableStore);const t=a=>Object.prototype.hasOwnProperty.call(this.modifications,a),u={};t("range")&&(u.range=D.Range.from(this._range)),t("label")&&(u.label=this.label),t("contextValue")&&(u.contextValue=this.contextValue??null),t("comments")&&(u.comments=this._comments.map(a=>s(this,a,this._commentsMap))),t("collapsibleState")&&(u.collapseState=m(this._collapseState)),t("canReply")&&(u.canReply=this.canReply),this.modifications={},E.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(t){for(let u of this._commentsMap){let a=u[0],l=u[1];if(t===l)return a}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}b._handlePool=0,Ve([(0,L.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class o{constructor(t,u,a,l){this._extension=t,this._handle=u,this._id=a,this._label=l,this._threads=new Map,E.$registerCommentController(this.handle,a,l);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(d){f.options=d},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(d){f.commentingRangeProvider=d},get reactionHandler(){return f.reactionHandler},set reactionHandler(d){f.reactionHandler=d},createCommentThread(d,S,A){return f.createCommentThread(d,S,A).value},dispose:()=>{f.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{E.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,E.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,E.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,E.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,u,a,l){if(typeof t=="string"){const f=new b(this.id,this.handle,t,u,a,l,this._extension.identifier);return this._threads.set(f.handle,f),f}else{const f=new b(this.id,this.handle,void 0,t,u,a,this._extension.identifier);return this._threads.set(f.handle,f),f}}$createCommentThreadTemplate(t,u){const a=new b(this.id,this.handle,void 0,n.URI.revive(t),D.Range.to(u),[],this._extension.identifier);return a.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(a.handle,a),a}$updateCommentThreadTemplate(t,u){let a=this._threads.get(t);a&&(a.range=D.Range.to(u))}$deleteCommentThread(t){let u=this._threads.get(t);u&&u.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function s(i,t,u){let a=u.get(t);a||(a=++i.commentHandle,u.set(t,a));const l=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:a,body:D.MarkdownString.from(t.body),userName:t.author.name,userIconPath:l,label:t.label,commentReactions:t.reactions?t.reactions.map(f=>p(f)):void 0}}function p(i){return{label:i.label,iconPath:i.iconPath?D.pathOrURIToURI(i.iconPath):void 0,count:i.count,hasReacted:i.authorHasReacted}}function r(i){return{label:i.label||"",count:i.count||0,iconPath:i.iconPath?n.URI.revive(i.iconPath):"",authorHasReacted:i.hasReacted||!1}}function m(i){if(i!==void 0)switch(i){case P.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}return new T}e.createExtHostComments=c}),define(fe[131],me([0,1,2,5,7,4,14,11,15,8,9]),function(Y,e,g,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class bn{constructor(v,h){this._logService=h,this._provider=new Map,this._proxy=v.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(v,h){const w=bn._handlePool++;this._provider.set(w,{provider:v,extensionId:h}),this._proxy.$registerDecorationProvider(w,h.value);const E=v.onDidChangeFileDecorations&&v.onDidChangeFileDecorations(T=>{if(!T){this._proxy.$onDidChange(w,null);return}let b=(0,_.asArray)(T);if(b.length<=bn._maxEventSize){this._proxy.$onDidChange(w,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",h.value,b.length);const o=b.map(r=>({uri:r,rank:(0,D.count)(r.path,"/")})),s=(0,_.groupBy)(o,(r,m)=>r.rank-m.rank||(0,D.compare)(r.uri.path,m.uri.path));let p=[];e:for(let r of s){let m;for(let i of r){let t=(0,P.dirname)(i.uri.path);if(m!==t&&(m=t,p.push(i.uri)>=bn._maxEventSize))break e}}this._proxy.$onDidChange(w,p)});return new y.Disposable(()=>{E?.dispose(),this._proxy.$unregisterDecorationProvider(w),this._provider.delete(w)})}async $provideDecorations(v,h,w){if(!this._provider.has(v))return Object.create(null);const E=Object.create(null),{provider:T,extensionId:b}=this._provider.get(v);return await Promise.all(h.map(async o=>{try{const{uri:s,id:p}=o,r=await Promise.resolve(T.provideFileDecoration(g.URI.revive(s),w));if(!r)return;try{y.FileDecoration.validate(r),E[p]=[r.propagate,r.tooltip,r.badge,r.color]}catch(m){this._logService.warn(`INVALID decoration from extension '${b.value}': ${m}`)}}catch(s){this._logService.error(s)}})),E}};I._handlePool=0,I._maxEventSize=250,I=Ve([$e(0,n.IExtHostRpcService),$e(1,k.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,C.createDecorator)("IExtHostDecorations")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[237],me([0,1,164,116,2,5,7,17,3,11,24,45]),function(Y,e,g,L,y,C,n,k,_,D,P,I){"use strict";var c,v,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class w{constructor(b,o,s,p,r,m){this._name=b,this._owner=o,this._maxDiagnosticsPerFile=s,c.set(this,void 0),v.set(this,void 0),h.set(this,void 0),this._isDisposed=!1,st(this,h,new P.ResourceMap(i=>p.getComparisonKey(i)),"f"),st(this,c,r,"f"),st(this,v,m,"f")}dispose(){this._isDisposed||(Oe(this,v,"f").fire([...Oe(this,h,"f").keys()]),Oe(this,c,"f")&&Oe(this,c,"f").$clear(this._owner),Oe(this,h,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(b,o){if(!b){this.clear();return}this._checkDisposed();let s=[];if(y.URI.isUri(b)){if(!o){this.delete(b);return}Oe(this,h,"f").set(b,o.slice()),s=[b]}else if(Array.isArray(b)){s=[];let r;b=[...b].sort(w._compareIndexedTuplesByUri);for(const m of b){const[i,t]=m;if((!r||i.toString()!==r.toString())&&(r&&Oe(this,h,"f").get(r).length===0&&Oe(this,h,"f").delete(r),r=i,s.push(i),Oe(this,h,"f").set(i,[])),t){const u=Oe(this,h,"f").get(i);u&&u.push(...t)}else{const u=Oe(this,h,"f").get(i);u&&(u.length=0)}}}if(Oe(this,v,"f").fire(s),!Oe(this,c,"f"))return;const p=[];for(let r of s){let m=[];const i=Oe(this,h,"f").get(r);if(i)if(i.length>this._maxDiagnosticsPerFile){m=[];const t=[n.DiagnosticSeverity.Error,n.DiagnosticSeverity.Warning,n.DiagnosticSeverity.Information,n.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(let a of i)if(a.severity===t[u]&&m.push(k.Diagnostic.from(a))===this._maxDiagnosticsPerFile)break e;m.push({severity:L.MarkerSeverity.Info,message:(0,g.localize)(0,null,i.length-this._maxDiagnosticsPerFile),startLineNumber:m[m.length-1].startLineNumber,startColumn:m[m.length-1].startColumn,endLineNumber:m[m.length-1].endLineNumber,endColumn:m[m.length-1].endColumn})}else m=i.map(t=>k.Diagnostic.from(t));p.push([r,m])}Oe(this,c,"f").$changeMany(this._owner,p)}delete(b){this._checkDisposed(),Oe(this,v,"f").fire([b]),Oe(this,h,"f").delete(b),Oe(this,c,"f")&&Oe(this,c,"f").$changeMany(this._owner,[[b,void 0]])}clear(){this._checkDisposed(),Oe(this,v,"f").fire([...Oe(this,h,"f").keys()]),Oe(this,h,"f").clear(),Oe(this,c,"f")&&Oe(this,c,"f").$clear(this._owner)}forEach(b,o){this._checkDisposed();for(let s of Oe(this,h,"f").keys())b.apply(o,[s,this.get(s),this])}get(b){this._checkDisposed();const o=Oe(this,h,"f").get(b);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(b){return this._checkDisposed(),Array.isArray(Oe(this,h,"f").get(b))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(b,o){return b[0].toString()<o[0].toString()?-1:b[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=w,c=new WeakMap,v=new WeakMap,h=new WeakMap;let E=class tn{constructor(b,o,s){this._logService=o,this._fileSystemInfoService=s,this._collections=new Map,this._onDidChangeDiagnostics=new _.DebounceEmitter({merge:p=>p.flat(),delay:50}),this.onDidChangeDiagnostics=_.Event.map(this._onDidChangeDiagnostics.event,tn._mapper),this._proxy=b.getProxy(C.MainContext.MainThreadDiagnostics)}static _mapper(b){const o=new P.ResourceMap;for(const s of b)o.set(s,s);return{uris:Object.freeze(Array.from(o.values()))}}createDiagnosticCollection(b,o){const{_collections:s,_proxy:p,_onDidChangeDiagnostics:r,_logService:m,_fileSystemInfoService:i}=this,t=new class{$changeMany(l,f){p.$changeMany(l,f),m.trace("[DiagnosticCollection] change many (extension, owner, uris)",b.value,l,f.length===0?"CLEARING":f)}$clear(l){p.$clear(l),m.trace("[DiagnosticCollection] remove all (extension, owner)",b.value,l)}dispose(){p.dispose()}};let u;if(!o)o="_generated_diagnostic_collection_name_#"+tn._idPool++,u=o;else if(!s.has(o))u=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do u=o+tn._idPool++;while(s.has(u))}return new class extends w{constructor(){super(o,u,tn._maxDiagnosticsPerFile,i.extUri,t,r);s.set(u,this)}dispose(){super.dispose(),s.delete(u)}}}getDiagnostics(b){if(b)return this._getDiagnostics(b);{const o=new Map,s=[];for(const p of this._collections.values())p.forEach((r,m)=>{let i=o.get(r.toString());typeof i=="undefined"&&(i=s.length,o.set(r.toString(),i),s.push([r,[]])),s[i][1]=s[i][1].concat(...m)});return s}}_getDiagnostics(b){let o=[];for(let s of this._collections.values())s.has(b)&&(o=o.concat(s.get(b)));return o}$acceptMarkersChange(b){if(!this._mirrorCollection){const o="_generated_mirror",s=new w(o,o,tn._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(o,s),this._mirrorCollection=s}for(const[o,s]of b)this._mirrorCollection.set(y.URI.revive(o),s.map(k.Diagnostic.to))}};E._idPool=0,E._maxDiagnosticsPerFile=1e3,E=Ve([$e(1,D.ILogService),$e(2,I.IExtHostFileSystemInfo)],E),e.ExtHostDiagnostics=E}),define(fe[238],me([0,1,2,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class y{constructor(n){this._proxy=n.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(n){return this._proxy.$showOpenDialog(n).then(k=>k?k.map(_=>g.URI.revive(_)):void 0)}showSaveDialog(n){return this._proxy.$showSaveDialog(n).then(k=>k?g.URI.revive(k):void 0)}}e.ExtHostDialogs=y}),define(fe[239],me([0,1,18,2,7,5,10,21,8]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(I,c,v){this._documentsAndEditors=c,this._logService=v,this._documentContentProviders=new Map,this._proxy=I.getProxy(C.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,c){if(Object.keys(n.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const v=D._handlePool++;this._documentContentProviders.set(v,c),this._proxy.$registerTextContentProvider(v,I);let h;return typeof c.onDidChange=="function"&&(h=c.onDidChange(w=>{if(w.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(w)&&this.$provideTextDocumentContent(v,w).then(E=>{if(!E&&typeof E!="string")return;const T=this._documentsAndEditors.getDocument(w);if(!T)return;const b=(0,_.splitLines)(E);if(!T.equalLines(b))return this._proxy.$onVirtualDocumentChange(w,E)},g.onUnexpectedError)})),new y.Disposable(()=>{this._documentContentProviders.delete(v)&&this._proxy.$unregisterTextContentProvider(v),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(I,c){const v=this._documentContentProviders.get(I);return v?Promise.resolve(v.provideTextDocumentContent(L.URI.revive(c),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=D,D._handlePool=0}),define(fe[240],me([0,1,3,6,2,5,123,17,13,25,7]),function(Y,e,g,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class I{constructor(v,h){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new L.DisposableStore,this._documentLoader=new Map,this._proxy=v.getProxy(C.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(w=>{for(const E of w)this._onDidRemoveDocument.fire(E.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(w=>{for(const E of w)this._onDidAddDocument.fire(E.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(v){if(!v)return;const h=this._documentsAndEditors.getDocument(v);if(h)return h}getDocument(v){const h=this.getDocumentData(v);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return h.document}ensureDocumentData(v){const h=this._documentsAndEditors.getDocument(v);if(h)return Promise.resolve(h);let w=this._documentLoader.get(v.toString());return w||(w=this._proxy.$tryOpenDocument(v).then(E=>{this._documentLoader.delete(v.toString());const T=y.URI.revive(E);return(0,_.assertIsDefined)(this._documentsAndEditors.getDocument(T))},E=>(this._documentLoader.delete(v.toString()),Promise.reject(E))),this._documentLoader.set(v.toString(),w)),w}createDocumentData(v){return this._proxy.$tryCreateDocument(v).then(h=>y.URI.revive(h))}$acceptModelModeChanged(v,h){const w=y.URI.revive(v),E=this._documentsAndEditors.getDocument(w);if(!E)throw new Error("unknown document");this._onDidRemoveDocument.fire(E.document),E._acceptLanguageId(h),this._onDidAddDocument.fire(E.document)}$acceptModelSaved(v){const h=y.URI.revive(v),w=this._documentsAndEditors.getDocument(h);if(!w)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this._onDidSaveDocument.fire(w.document)}$acceptDirtyStateChanged(v,h){const w=y.URI.revive(v),E=this._documentsAndEditors.getDocument(w);if(!E)throw new Error("unknown document");E._acceptIsDirty(h),this._onDidChangeDocument.fire({document:E.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,h,w){const E=y.URI.revive(v),T=this._documentsAndEditors.getDocument(E);if(!T)throw new Error("unknown document");T._acceptIsDirty(w),T.onEvents(h);let b;h.isUndoing?b=P.TextDocumentChangeReason.Undo:h.isRedoing&&(b=P.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,D.deepFreeze)({document:T.document,contentChanges:h.changes.map(o=>({range:k.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:b}))}setWordDefinitionFor(v,h){(0,n.setWordDefinitionFor)(v,h)}}e.ExtHostDocuments=I}),define(fe[46],me([0,1,58,3,6,2,4,5,123,14,130,17,11,24,10,78,141]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class T{constructor(s){this.value=s,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(s,p){this._extHostRpc=s,this._logService=p,this._activeEditorId=null,this._editors=new Map,this._documents=new v.ResourceMap,this._onDidAddDocuments=new L.Emitter,this._onDidRemoveDocuments=new L.Emitter,this._onDidChangeVisibleTextEditors=new L.Emitter,this._onDidChangeActiveTextEditor=new L.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const p=[],r=[],m=[];if(s.removedDocuments)for(const i of s.removedDocuments){const t=C.URI.revive(i),u=this._documents.get(t);u?.unref()&&(this._documents.delete(t),p.push(u.value))}if(s.addedDocuments)for(const i of s.addedDocuments){const t=C.URI.revive(i.uri);let u=this._documents.get(t);if(u&&t.scheme!==h.Schemas.vscodeNotebookCell&&t.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);u||(u=new T(new _.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),t,i.lines,i.EOL,i.versionId,i.languageId,i.isDirty,i.notebook)),this._documents.set(t,u),r.push(u.value)),u.ref()}if(s.removedEditors)for(const i of s.removedEditors){const t=this._editors.get(i);this._editors.delete(i),t&&m.push(t)}if(s.addedEditors)for(const i of s.addedEditors){const t=C.URI.revive(i.documentUri);g.ok(this._documents.has(t),`document '${t}' does not exist`),g.ok(!this._editors.has(i.id),`editor '${i.id}' already exists!`);const u=this._documents.get(t).value,a=new P.ExtHostTextEditor(i.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>u.document),i.selections.map(I.Selection.to),i.options,i.visibleRanges.map(l=>I.Range.to(l)),typeof i.editorPosition=="number"?I.ViewColumn.to(i.editorPosition):void 0);this._editors.set(i.id,a)}s.newActiveEditor!==void 0&&(g.ok(s.newActiveEditor===null||this._editors.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this._activeEditorId=s.newActiveEditor),(0,y.dispose)(p),(0,y.dispose)(m),s.removedDocuments&&this._onDidRemoveDocuments.fire(p),s.addedDocuments&&this._onDidAddDocuments.fire(r),(s.removedEditors||s.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(i=>i.value)),s.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(s){return this._documents.get(s)?.value}allDocuments(){return w.Iterable.map(this._documents.values(),s=>s.value)}getEditor(s){return this._editors.get(s)}activeEditor(s){if(!this._activeEditorId)return;const p=this._editors.get(this._activeEditorId);return s?p:p?.value}allEditors(){return[...this._editors.values()]}};b=Ve([$e(0,D.IExtHostRpcService),$e(1,c.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,n.createDecorator)("IExtHostDocumentsAndEditors")}),define(fe[56],me([0,1,17,5,2,3,4,14,16]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,n.createDecorator)("IExtHostEditorTabs");let D=class{constructor(I){this._onDidChangeTabs=new C.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new C.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=I.getProxy(L.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(I){let c=-1;this._tabs=I.map((h,w)=>(h.isActive&&(c=w),Object.freeze({label:h.label,viewColumn:g.ViewColumn.to(h.viewColumn),index:w,resource:y.URI.revive(h.resource),additionalResourcesAndViewIds:h.additionalResourcesAndViewIds.map(({resource:E,viewId:T})=>({resource:y.URI.revive(E),viewId:T})),viewId:h.editorId,isActive:h.isActive,move:async(E,T)=>{this._proxy.$moveTab(h,E,g.ViewColumn.from(T)),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(h),await(0,_.raceTimeout)(C.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((h,w)=>h.viewColumn===w.viewColumn?h.index-w.index:h.viewColumn-w.viewColumn);const v=this._activeTab;this._activeTab=c===-1?void 0:this._tabs[c],this._activeTab!==v&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};D=Ve([$e(0,k.IExtHostRpcService)],D),e.ExtHostEditorTabs=D}),define(fe[241],me([0,1,2,5,6,7,17,148,8,22,29]),function(Y,e,g,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class I{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const w=this._schemes.indexOf(h);w>=0&&(this._schemes.splice(w,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),w=[];let E,T,b=14,o=14;for(const s of h){let p=E?(0,_.commonPrefixLength)(E,s):0;for(p===0?T=1:T=o;p<s.length;p++)p+1===s.length?(b=o,o=9):o+=1,w.push([T,s.toUpperCase().charCodeAt(p),o]),w.push([T,s.toLowerCase().charCodeAt(p),o]),T=o;E=s,o=b}w.push([9,58,10]),w.push([10,47,12]),this._stateMachine=new k.StateMachine(w)}}provideDocumentLinks(h){this._initStateMachine();const w=[],E=k.LinkComputer.computeLinks({getLineContent(T){return h.lineAt(T-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const T of E){const b=n.DocumentLink.to(T);b.target&&w.push(b)}return w}}class c{constructor(h,w){this._extHostLanguageFeatures=w,this._linkProvider=new I,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,w,E,T={}){if(this._registeredSchemes.has(w))throw new Error(`a provider for the scheme '${w}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(w),this._registeredSchemes.add(w),this._fsProvider.set(b,E);let o=2;T.isCaseSensitive&&(o+=1024),T.isReadonly&&(o+=2048),typeof E.copy=="function"&&(o+=8),typeof E.open=="function"&&typeof E.close=="function"&&typeof E.read=="function"&&typeof E.write=="function"&&((0,P.checkProposedApiEnabled)(h,"fsChunks"),o+=4),this._proxy.$registerFileSystemProvider(b,w,o).catch(p=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${w}`),console.error(p)});const s=E.onDidChangeFile(p=>{const r=[];for(const m of p){let{uri:i,type:t}=m;if(i.scheme!==w)continue;let u;switch(t){case C.FileChangeType.Changed:u=0;break;case C.FileChangeType.Created:u=1;break;case C.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:i,type:u})}this._proxy.$onFileSystemChange(b,r)});return(0,y.toDisposable)(()=>{s.dispose(),this._linkProvider.delete(w),this._registeredSchemes.delete(w),this._fsProvider.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(h){const{type:w,ctime:E,mtime:T,size:b,permissions:o}=h;return{type:w,ctime:E,mtime:T,size:b,permissions:o}}$stat(h,w){return Promise.resolve(this._getFsProvider(h).stat(g.URI.revive(w))).then(E=>c._asIStat(E))}$readdir(h,w){return Promise.resolve(this._getFsProvider(h).readDirectory(g.URI.revive(w)))}$readFile(h,w){return Promise.resolve(this._getFsProvider(h).readFile(g.URI.revive(w))).then(E=>D.VSBuffer.wrap(E))}$writeFile(h,w,E,T){return Promise.resolve(this._getFsProvider(h).writeFile(g.URI.revive(w),E.buffer,T))}$delete(h,w,E){return Promise.resolve(this._getFsProvider(h).delete(g.URI.revive(w),E))}$rename(h,w,E,T){return Promise.resolve(this._getFsProvider(h).rename(g.URI.revive(w),g.URI.revive(E),T))}$copy(h,w,E,T){const b=this._getFsProvider(h);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(g.URI.revive(w),g.URI.revive(E),T))}$mkdir(h,w){return Promise.resolve(this._getFsProvider(h).createDirectory(g.URI.revive(w)))}$watch(h,w,E,T){const b=this._getFsProvider(h).watch(g.URI.revive(E),T);this._watches.set(w,b)}$unwatch(h,w){const E=this._watches.get(w);E&&(E.dispose(),this._watches.delete(w))}$open(h,w,E){const T=this._getFsProvider(h);if(!T.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(T.open(g.URI.revive(w),E))}$close(h,w){const E=this._getFsProvider(h);if(!E.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(E.close(w))}$read(h,w,E,T){const b=this._getFsProvider(h);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const o=D.VSBuffer.alloc(T);return Promise.resolve(b.read(w,E,o.buffer,0,T)).then(s=>o.slice(0,s))}$write(h,w,E,T){const b=this._getFsProvider(h);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(w,E,T.buffer,0,T.byteLength))}_getFsProvider(h){const w=this._fsProvider.get(h);if(!w){const E=new Error;throw E.name="ENOPRO",E.message="no provider",E}return w}}e.ExtHostFileSystem=c}),define(fe[69],me([0,1,5,43,7,22,4,14,45]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let D=class Bt{constructor(I,c){const v=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(h){return v.$stat(h).catch(Bt._handleError)},readDirectory(h){return v.$readdir(h).catch(Bt._handleError)},createDirectory(h){return v.$mkdir(h).catch(Bt._handleError)},async readFile(h){return v.$readFile(h).then(w=>w.buffer).catch(Bt._handleError)},writeFile(h,w){return v.$writeFile(h,C.VSBuffer.wrap(w)).catch(Bt._handleError)},delete(h,w){return v.$delete(h,{recursive:!1,useTrash:!1,...w}).catch(Bt._handleError)},rename(h,w,E){return v.$rename(h,w,{overwrite:!1,...E}).catch(Bt._handleError)},copy(h,w,E){return v.$copy(h,w,{overwrite:!1,...E}).catch(Bt._handleError)},isWritableFileSystem(h){const w=c.getCapabilities(h);if(typeof w=="number")return!(w&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new y.FileSystemError(String(I));if(I.name==="ENOPRO")throw y.FileSystemError.Unavailable(I.message);switch(I.name){case L.FileSystemProviderErrorCode.FileExists:throw y.FileSystemError.FileExists(I.message);case L.FileSystemProviderErrorCode.FileNotFound:throw y.FileSystemError.FileNotFound(I.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw y.FileSystemError.FileNotADirectory(I.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw y.FileSystemError.FileIsADirectory(I.message);case L.FileSystemProviderErrorCode.NoPermissions:throw y.FileSystemError.NoPermissions(I.message);case L.FileSystemProviderErrorCode.Unavailable:throw y.FileSystemError.Unavailable(I.message);default:throw new y.FileSystemError(I.message,I.name)}}};D=Ve([$e(0,k.IExtHostRpcService),$e(1,_.IExtHostFileSystemInfo)],D),e.ExtHostConsumerFileSystem=D,e.IExtHostConsumerFileSystem=(0,n.createDecorator)("IExtHostConsumerFileSystem")}),define(fe[242],me([0,1,2,40]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class y{constructor(n,k,_,D){this._extHostNotebooks=k,this._textDocumentsAndEditors=_,this._commands=D;const P=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",I=>!0,I=>I),new L.ApiCommandArgument("resource","Interactive resource Uri",I=>!0,I=>I),new L.ApiCommandArgument("controllerId","Notebook controller Id",I=>!0,I=>I),new L.ApiCommandArgument("title","Interactive editor title",I=>!0,I=>I)],new L.ApiCommandResult("Notebook and input URI",I=>{if(I.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(I.notebookEditorId);return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:g.URI.revive(I.notebookUri),inputUri:g.URI.revive(I.inputUri)}}));this._commands.registerApiCommand(P)}$willAddInteractiveDocument(n,k,_,D){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:k,lines:[""],languageId:_,uri:n,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(g.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(n,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[n]})}}e.ExtHostInteractive=y}),define(fe[243],me([0,1,6,5]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class y{constructor(n){this._handlePool=0,this._proxy=n.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(n){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,n),(0,g.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=y}),define(fe[244],me([0,1,2,25,17,7,5,8,42,15,13,145,6,111,77,88,47,18,3]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class o{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentSymbols(G,ee){const ne=this._documents.getDocument(G),le=await this._provider.provideDocumentSymbols(ne,ee);if(!(0,D.isFalsyOrEmpty)(le))return le[0]instanceof C.DocumentSymbol?le.map(y.DocumentSymbol.from):o._asDocumentSymbolTree(le)}static _asDocumentSymbolTree(G){G=G.slice(0).sort((le,Z)=>{let re=le.location.range.start.compareTo(Z.location.range.start);return re===0&&(re=Z.location.range.end.compareTo(le.location.range.end)),re});const ee=[],ne=[];for(const le of G){const Z={name:le.name||"!!MISSING: name!!",kind:y.SymbolKind.from(le.kind),tags:le.tags?.map(y.SymbolTag.from)||[],detail:"",containerName:le.containerName,range:y.Range.from(le.location.range),selectionRange:y.Range.from(le.location.range),children:[]};for(;;){if(ne.length===0){ne.push(Z),ee.push(Z);break}const re=ne[ne.length-1];if(_.Range.containsRange(re.range,Z.range)&&!_.Range.equalsRange(re.range,Z.range)){re.children&&re.children.push(Z),ne.push(Z);break}ne.pop()}}return ee}}class s{constructor(G,ee,ne){this._documents=G,this._commands=ee,this._provider=ne,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(G,ee){const ne=this._documents.getDocument(G),le=await this._provider.provideCodeLenses(ne,ee);if(!le||ee.isCancellationRequested)return;const Z=this._cache.add(le),re=new c.DisposableStore;this._disposables.set(Z,re);const pe={cacheId:Z,lenses:[]};for(let Me=0;Me<le.length;Me++)pe.lenses.push({cacheId:[Z,Me],range:y.Range.from(le[Me].range),command:this._commands.toInternal(le[Me].command,re)});return pe}async resolveCodeLens(G,ee){const ne=G.cacheId&&this._cache.get(...G.cacheId);if(!ne)return;let le;if(typeof this._provider.resolveCodeLens!="function"||ne.isResolved?le=ne:le=await this._provider.resolveCodeLens(ne,ee),le||(le=ne),ee.isCancellationRequested)return;const Z=G.cacheId&&this._disposables.get(G.cacheId[0]);if(!!Z)return G.command=this._commands.toInternal(le.command??s._badCmd,Z),G}releaseCodeLenses(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}}s._badCmd={command:"missing",title:"!!MISSING: command!!"};function p(He){return Array.isArray(He)?He.map(y.DefinitionLink.from):He?[y.DefinitionLink.from(He)]:[]}class r{constructor(G,ee){this._documents=G,this._provider=ee}async provideDefinition(G,ee,ne){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideDefinition(le,Z,ne);return p(re)}}class m{constructor(G,ee){this._documents=G,this._provider=ee}async provideDeclaration(G,ee,ne){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideDeclaration(le,Z,ne);return p(re)}}class i{constructor(G,ee){this._documents=G,this._provider=ee}async provideImplementation(G,ee,ne){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideImplementation(le,Z,ne);return p(re)}}class t{constructor(G,ee){this._documents=G,this._provider=ee}async provideTypeDefinition(G,ee,ne){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideTypeDefinition(le,Z,ne);return p(re)}}class u{constructor(G,ee){this._documents=G,this._provider=ee}async provideHover(G,ee,ne){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideHover(le,Z,ne);if(!(!re||(0,D.isFalsyOrEmpty)(re.contents)))return re.range||(re.range=le.getWordRangeAtPosition(Z)),re.range||(re.range=new C.Range(Z,Z)),y.Hover.from(re)}}class a{constructor(G,ee){this._documents=G,this._provider=ee}async provideEvaluatableExpression(G,ee,ne){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideEvaluatableExpression(le,Z,ne);if(re)return y.EvaluatableExpression.from(re)}}class l{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlineValues(G,ee,ne,le){const Z=this._documents.getDocument(G),re=await this._provider.provideInlineValues(Z,y.Range.to(ee),y.InlineValueContext.to(ne),le);if(Array.isArray(re))return re.map(pe=>y.InlineValue.from(pe))}}class f{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentHighlights(G,ee,ne){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideDocumentHighlights(le,Z,ne);if(Array.isArray(re))return re.map(y.DocumentHighlight.from)}}class d{constructor(G,ee){this._documents=G,this._provider=ee}async provideLinkedEditingRanges(G,ee,ne){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.provideLinkedEditingRanges(le,Z,ne);if(re&&Array.isArray(re.ranges))return{ranges:(0,D.coalesce)(re.ranges.map(y.Range.from)),wordPattern:re.wordPattern}}}class S{constructor(G,ee){this._documents=G,this._provider=ee}async provideReferences(G,ee,ne,le){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=await this._provider.provideReferences(Z,re,ne,le);if(Array.isArray(pe))return pe.map(y.location.from)}}class A{constructor(G,ee,ne,le,Z,re,pe){this._documents=G,this._commands=ee,this._diagnostics=ne,this._provider=le,this._logService=Z,this._extension=re,this._apiDeprecation=pe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(G,ee,ne,le){const Z=this._documents.getDocument(G),re=I.Selection.isISelection(ee)?y.Selection.to(ee):y.Range.to(ee),pe=[];for(const lt of this._diagnostics.getDiagnostics(G))if(re.intersection(lt.range)&&pe.push(lt)>A._maxCodeActionsPerFile)break;const Me={diagnostics:pe,only:ne.only?new C.CodeActionKind(ne.only):void 0,triggerKind:y.CodeActionTriggerKind.to(ne.trigger)},je=await this._provider.provideCodeActions(Z,re,Me,le);if(!(0,D.isNonEmptyArray)(je)||le.isCancellationRequested)return;const Ke=this._cache.add(je),Ze=new c.DisposableStore;this._disposables.set(Ke,Ze);const rt=[];for(let lt=0;lt<je.length;lt++){const ye=je[lt];!ye||(A._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,Ze)})):(Me.only&&(ye.kind?Me.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Me.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Ke,lt],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,Ze),diagnostics:ye.diagnostics&&ye.diagnostics.map(y.Diagnostic.from),edit:ye.edit&&y.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:Ke,actions:rt}}async resolveCodeAction(G,ee){const[ne,le]=G,Z=this._cache.get(ne,le);if(!Z||A._isCommand(Z)||!this._provider.resolveCodeAction)return;const re=await this._provider.resolveCodeAction(Z,ee)??Z;return re?.edit?y.WorkspaceEdit.from(re.edit):void 0}releaseCodeActions(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}static _isCommand(G){return typeof G.command=="string"&&typeof G.title=="string"}}A._maxCodeActionsPerFile=1e3;class R{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentFormattingEdits(G,ee,ne){const le=this._documents.getDocument(G),Z=await this._provider.provideDocumentFormattingEdits(le,ee,ne);if(Array.isArray(Z))return Z.map(y.TextEdit.from)}}class B{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeFormattingEdits(G,ee,ne,le){const Z=this._documents.getDocument(G),re=y.Range.to(ee),pe=await this._provider.provideDocumentRangeFormattingEdits(Z,re,ne,le);if(Array.isArray(pe))return pe.map(y.TextEdit.from)}}class x{constructor(G,ee){this._documents=G,this._provider=ee,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(G,ee,ne,le,Z){const re=this._documents.getDocument(G),pe=y.Position.to(ee),Me=await this._provider.provideOnTypeFormattingEdits(re,pe,ne,le,Z);if(Array.isArray(Me))return Me.map(y.TextEdit.from)}}class F{constructor(G,ee){this._provider=G,this._logService=ee,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(G,ee){const ne=n.IdObject.mixin({symbols:[]}),le=await this._provider.provideWorkspaceSymbols(G,ee);if((0,D.isNonEmptyArray)(le))for(const Z of le){if(!Z)continue;if(!Z.name){this._logService.warn("INVALID SymbolInformation, lacks name",Z);continue}const re=n.IdObject.mixin(y.WorkspaceSymbol.from(Z));this._symbolCache.set(re._id,Z),ne.symbols.push(re)}return ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne}async resolveWorkspaceSymbol(G,ee){if(typeof this._provider.resolveWorkspaceSymbol!="function")return G;const ne=this._symbolCache.get(G._id);if(ne){const le=await this._provider.resolveWorkspaceSymbol(ne,ee);return le&&(0,L.mixin)(G,y.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(G){const ee=this._resultCache.get(G);if(ee){for(let[ne,le]=ee;ne<=le;ne++)this._symbolCache.delete(ne);this._resultCache.delete(G)}}}class ${constructor(G,ee,ne){this._documents=G,this._provider=ee,this._logService=ne}static supportsResolving(G){return typeof G.prepareRename=="function"}async provideRenameEdits(G,ee,ne,le){const Z=this._documents.getDocument(G),re=y.Position.to(ee);try{const pe=await this._provider.provideRenameEdits(Z,re,ne,le);return pe?y.WorkspaceEdit.from(pe):void 0}catch(pe){const Me=$._asMessage(pe);return Me?{rejectReason:Me,edits:void 0}:Promise.reject(pe)}}async resolveRenameLocation(G,ee,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(G),Z=y.Position.to(ee);try{const re=await this._provider.prepareRename(le,Z,ne);let pe,Me;if(C.Range.isRange(re)?(pe=re,Me=le.getText(re)):(0,P.isObject)(re)&&(pe=re.range,Me=re.placeholder),!pe||!Me)return;if(pe.start.line>Z.line||pe.end.line<Z.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:y.Range.from(pe),text:Me}}catch(re){const pe=$._asMessage(re);return pe?{rejectReason:pe,range:void 0,text:void 0}:Promise.reject(re)}}static _asMessage(G){return typeof G=="string"?G:G instanceof Error&&typeof G.message=="string"?G.message:void 0}}class M{constructor(G,ee){this.resultId=G,this.tokens=ee}}class H{constructor(G,ee){this._documents=G,this._provider=ee,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(G,ee,ne){const le=this._documents.getDocument(G),Z=ee!==0?this._previousResults.get(ee):null;let re=typeof Z?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(le,Z.resultId,ne):await this._provider.provideDocumentSemanticTokens(le,ne);return Z&&this._previousResults.delete(ee),re?(re=H._fixProvidedSemanticTokens(re),this._send(H._convertToEdits(Z,re),re)):null}async releaseDocumentSemanticColoring(G){this._previousResults.delete(G)}static _fixProvidedSemanticTokens(G){return H._isSemanticTokens(G)?H._isCorrectSemanticTokens(G)?G:new C.SemanticTokens(new Uint32Array(G.data),G.resultId):H._isSemanticTokensEdits(G)?H._isCorrectSemanticTokensEdits(G)?G:new C.SemanticTokensEdits(G.edits.map(ee=>new C.SemanticTokensEdit(ee.start,ee.deleteCount,ee.data?new Uint32Array(ee.data):ee.data)),G.resultId):G}static _isSemanticTokens(G){return G&&!!G.data}static _isCorrectSemanticTokens(G){return G.data instanceof Uint32Array}static _isSemanticTokensEdits(G){return G&&Array.isArray(G.edits)}static _isCorrectSemanticTokensEdits(G){for(const ee of G.edits)if(!(ee.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(G,ee){if(!H._isSemanticTokens(ee)||!G||!G.tokens)return ee;const ne=G.tokens,le=ne.length,Z=ee.data,re=Z.length;let pe=0;const Me=Math.min(le,re);for(;pe<Me&&ne[pe]===Z[pe];)pe++;if(pe===le&&pe===re)return new C.SemanticTokensEdits([],ee.resultId);let je=0;const Ke=Me-pe;for(;je<Ke&&ne[le-je-1]===Z[re-je-1];)je++;return new C.SemanticTokensEdits([{start:pe,deleteCount:le-pe-je,data:Z.subarray(pe,re-je)}],ee.resultId)}_send(G,ee){if(H._isSemanticTokens(G)){const ne=this._nextResultId++;return this._previousResults.set(ne,new M(G.resultId,G.data)),(0,v.encodeSemanticTokensDto)({id:ne,type:"full",data:G.data})}if(H._isSemanticTokensEdits(G)){const ne=this._nextResultId++;return H._isSemanticTokens(ee)?this._previousResults.set(ne,new M(ee.resultId,ee.data)):this._previousResults.set(ne,new M(G.resultId)),(0,v.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(G.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=H;class N{constructor(G,ee){this._documents=G,this._provider=ee}async provideDocumentRangeSemanticTokens(G,ee,ne){const le=this._documents.getDocument(G),Z=await this._provider.provideDocumentRangeSemanticTokens(le,y.Range.to(ee),ne);return Z?this._send(Z):null}_send(G){return(0,v.encodeSemanticTokensDto)({id:0,type:"full",data:G.data})}}e.DocumentRangeSemanticTokensAdapter=N;class U{constructor(G,ee,ne,le,Z){this._documents=G,this._commands=ee,this._provider=ne,this._apiDeprecation=le,this._extension=Z,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(G){return typeof G.resolveCompletionItem=="function"}async provideCompletionItems(G,ee,ne,le){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=Z.getWordRangeAtPosition(re)||new C.Range(re,re),Me=pe.with({end:re}),je=new E.StopWatch(!0),Ke=await this._provider.provideCompletionItems(Z,re,le,y.CompletionContext.to(ne));if(!Ke||le.isCancellationRequested)return;const Ze=Array.isArray(Ke)?new C.CompletionList(Ke):Ke,rt=U.supportsResolving(this._provider)?this._cache.add(Ze.items):this._cache.add([]),lt=new c.DisposableStore;this._disposables.set(rt,lt);const ye=[],at={x:rt,b:ye,a:{replace:y.Range.from(pe),insert:y.Range.from(Me)},c:Ze.isIncomplete||void 0,d:je.elapsed()};for(let J=0;J<Ze.items.length;J++){const ie=Ze.items[J],_e=this._convertCompletionItem(ie,[rt,J],Me,pe);ye.push(_e)}return at}async resolveCompletionItem(G,ee){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...G);if(!ne)return;const le=await this._provider.resolveCompletionItem(ne,ee);if(!!le)return this._convertCompletionItem(le,G)}releaseCompletionItems(G){this._disposables.get(G)?.dispose(),this._disposables.delete(G),this._cache.delete(G)}_convertCompletionItem(G,ee,ne,le){const Z=this._disposables.get(ee[0]);if(!Z)throw Error("DisposableStore is missing...");const re={x:ee,a:G.label,b:G.kind!==void 0?y.CompletionItemKind.from(G.kind):void 0,n:G.tags&&G.tags.map(y.CompletionItemTag.from),c:G.detail,d:typeof G.documentation=="undefined"?void 0:y.MarkdownString.fromStrict(G.documentation),e:G.sortText!==G.label?G.sortText:void 0,f:G.filterText!==G.label?G.filterText:void 0,g:G.preselect||void 0,i:G.keepWhitespace?1:0,k:G.commitCharacters,l:G.additionalTextEdits&&G.additionalTextEdits.map(y.TextEdit.from),m:this._commands.toInternal(G.command,Z)};G.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),re.h=G.textEdit.newText):typeof G.insertText=="string"?re.h=G.insertText:G.insertText instanceof C.SnippetString&&(re.h=G.insertText.value,re.i|=4);let pe;return G.textEdit?pe=G.textEdit.range:G.range&&(pe=G.range),C.Range.isRange(pe)?re.j=y.Range.from(pe):pe&&(!ne?.isEqual(pe.inserting)||!le?.isEqual(pe.replacing))&&(re.j={insert:y.Range.from(pe.inserting),replace:y.Range.from(pe.replacing)}),re}}class V{constructor(G,ee,ne){this._documents=G,this._provider=ee,this._commands=ne,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(G,ee,ne,le){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=await this._provider.provideInlineCompletionItems(Z,re,{selectedCompletionInfo:ne.selectedSuggestionInfo?{range:y.Range.to(ne.selectedSuggestionInfo.range),text:ne.selectedSuggestionInfo.text}:void 0,triggerKind:ne.triggerKind},le);if(!pe||le.isCancellationRequested)return;const Me=(0,P.isArray)(pe)?{items:pe}:pe,je=this._cache.add(Me.items);let Ke;return{pid:je,items:Me.items.map((Ze,rt)=>{let lt;return Ze.command&&(Ke||(Ke=new c.DisposableStore,this._disposables.set(je,Ke)),lt=this._commands.toInternal(Ze.command,Ke)),{text:Ze.text,range:Ze.range?y.Range.from(Ze.range):void 0,command:lt,idx:rt}})}}disposeCompletions(G){this._cache.delete(G);const ee=this._disposables.get(G);ee&&ee.clear(),this._disposables.delete(G)}handleDidShowCompletionItem(G,ee){const ne=this._cache.get(G,ee);ne&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(G){let ee=O.map.get(G);return ee||(ee=new O,O.map.set(G,ee)),ee}fireOnDidShowCompletionItem(G){this._onDidShowCompletionItemEmitter.fire(G)}}e.InlineCompletionController=O,O.map=new WeakMap;class W{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("SignatureHelp")}async provideSignatureHelp(G,ee,ne,le){const Z=this._documents.getDocument(G),re=y.Position.to(ee),pe=this.reviveContext(ne),Me=await this._provider.provideSignatureHelp(Z,re,le,pe);if(Me){const je=this._cache.add([Me]);return{...y.SignatureHelp.from(Me),id:je}}}reviveContext(G){let ee;if(G.activeSignatureHelp){const ne=y.SignatureHelp.to(G.activeSignatureHelp),le=this._cache.get(G.activeSignatureHelp.id,0);le?(ee=le,ee.activeSignature=ne.activeSignature,ee.activeParameter=ne.activeParameter):ee=ne}return{...G,activeSignatureHelp:ee}}releaseSignatureHelp(G){this._cache.delete(G)}}class j{constructor(G,ee){this._documents=G,this._provider=ee}async provideInlayHints(G,ee,ne){const le=this._documents.getDocument(G),Z=await this._provider.provideInlayHints(le,y.Range.to(ee),ne);return Z?{hints:Z.map(y.InlayHint.from)}:void 0}}class X{constructor(G,ee){this._documents=G,this._provider=ee,this._cache=new w.Cache("DocumentLink")}async provideLinks(G,ee){const ne=this._documents.getDocument(G),le=await this._provider.provideDocumentLinks(ne,ee);if(!(!Array.isArray(le)||le.length===0)&&!ee.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.filter(X._validateLink).map(y.DocumentLink.from)};{const Z=this._cache.add(le),re={links:[],id:Z};for(let pe=0;pe<le.length;pe++){if(!X._validateLink(le[pe]))continue;const Me=y.DocumentLink.from(le[pe]);Me.cacheId=[Z,pe],re.links.push(Me)}return re}}}static _validateLink(G){return G.target&&G.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(G,ee){if(typeof this._provider.resolveDocumentLink!="function")return;const ne=this._cache.get(...G);if(!ne)return;const le=await this._provider.resolveDocumentLink(ne,ee);if(!(!le||!X._validateLink(le)))return y.DocumentLink.from(le)}releaseLinks(G){this._cache.delete(G)}}class Q{constructor(G,ee){this._documents=G,this._provider=ee}async provideColors(G,ee){const ne=this._documents.getDocument(G),le=await this._provider.provideDocumentColors(ne,ee);return Array.isArray(le)?le.map(re=>({color:y.Color.from(re.color),range:y.Range.from(re.range)})):[]}async provideColorPresentations(G,ee,ne){const le=this._documents.getDocument(G),Z=y.Range.to(ee.range),re=y.Color.to(ee.color),pe=await this._provider.provideColorPresentations(re,{document:le,range:Z},ne);if(!!Array.isArray(pe))return pe.map(y.ColorPresentation.from)}}class de{constructor(G,ee){this._documents=G,this._provider=ee}async provideFoldingRanges(G,ee,ne){const le=this._documents.getDocument(G),Z=await this._provider.provideFoldingRanges(le,ee,ne);if(!!Array.isArray(Z))return Z.map(y.FoldingRange.from)}}class Se{constructor(G,ee,ne){this._documents=G,this._provider=ee,this._logService=ne}async provideSelectionRanges(G,ee,ne){const le=this._documents.getDocument(G),Z=ee.map(y.Position.to),re=await this._provider.provideSelectionRanges(le,Z,ne);if(!(0,D.isNonEmptyArray)(re))return[];if(re.length!==Z.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const pe=[];for(let Me=0;Me<Z.length;Me++){const je=[];pe.push(je);let Ke=Z[Me],Ze=re[Me];for(;;){if(!Ze.range.contains(Ke))throw new Error("INVALID selection range, must contain the previous range");if(je.push(y.SelectionRange.from(Ze)),!Ze.parent)break;Ke=Ze.range,Ze=Ze.parent}}return pe}}class De{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,ne){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.prepareCallHierarchy(le,Z,ne);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideCallsTo(G,ee,ne){const le=this._itemFromCache(G,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyIncomingCalls(le,ne);if(!!Z)return Z.map(re=>({from:this._cacheAndConvertItem(G,re.from),fromRanges:re.fromRanges.map(pe=>y.Range.from(pe))}))}async provideCallsFrom(G,ee,ne){const le=this._itemFromCache(G,ee);if(!le)throw new Error("missing call hierarchy item");const Z=await this._provider.provideCallHierarchyOutgoingCalls(le,ne);if(!!Z)return Z.map(re=>({to:this._cacheAndConvertItem(G,re.to),fromRanges:re.fromRanges.map(pe=>y.Range.from(pe))}))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const ne=this._cache.get(G),le=y.CallHierarchyItem.from(ee,G,ne.size.toString(36));return ne.set(le._itemId,ee),le}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Pe{constructor(G,ee){this._documents=G,this._provider=ee,this._idPool=new h.IdGenerator(""),this._cache=new Map}async prepareSession(G,ee,ne){const le=this._documents.getDocument(G),Z=y.Position.to(ee),re=await this._provider.prepareTypeHierarchy(le,Z,ne);if(!re)return;const pe=this._idPool.nextId();return this._cache.set(pe,new Map),Array.isArray(re)?re.map(Me=>this._cacheAndConvertItem(pe,Me)):[this._cacheAndConvertItem(pe,re)]}async provideSupertypes(G,ee,ne){const le=this._itemFromCache(G,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySupertypes(le,ne);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}async provideSubtypes(G,ee,ne){const le=this._itemFromCache(G,ee);if(!le)throw new Error("missing type hierarchy item");const Z=await this._provider.provideTypeHierarchySubtypes(le,ne);if(!!Z)return Z.map(re=>this._cacheAndConvertItem(G,re))}releaseSession(G){this._cache.delete(G)}_cacheAndConvertItem(G,ee){const ne=this._cache.get(G),le=y.TypeHierarchyItem.from(ee,G,ne.size.toString(36));return ne.set(le._itemId,ee),le}_itemFromCache(G,ee){return this._cache.get(G)?.get(ee)}}class Be{constructor(G,ee){this.adapter=G,this.extension=ee}}class We{constructor(G,ee,ne,le,Z,re,pe){this._adapter=new Map,this._uriTransformer=ee,this._proxy=G.getProxy(n.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=le,this._diagnostics=Z,this._logService=re,this._apiDeprecation=pe}_transformDocumentSelector(G){return y.DocumentSelector.from(G,this._uriTransformer)}_createDisposable(G){return new C.Disposable(()=>{this._adapter.delete(G),this._proxy.$unregister(G)})}_nextHandle(){return We._handlePool++}_withAdapter(G,ee,ne,le,Z=!1){const re=this._adapter.get(G);if(!re)return Promise.resolve(le);if(re.adapter instanceof ee){let pe;re.extension&&(pe=Date.now(),this._logService.trace(`[${re.extension.identifier.value}] INVOKE provider '${ee.name}'`));const Me=ne(re.adapter,re.extension),je=re.extension;return je&&Promise.resolve(Me).then(()=>this._logService.trace(`[${je.identifier.value}] provider DONE after ${Date.now()-pe}ms`),Ke=>{Z&&Ke instanceof T.CancellationError||(this._logService.error(`[${je.identifier.value}] provider FAILED`),this._logService.error(Ke))}),Me}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(G,ee){const ne=this._nextHandle();return this._adapter.set(ne,new Be(G,ee)),ne}static _extLabel(G){return G.displayName||G.name}registerDocumentSymbolProvider(G,ee,ne,le){const Z=this._addNewAdapter(new o(this._documents,ne),G),re=le&&le.label||We._extLabel(G);return this._proxy.$registerDocumentSymbolProvider(Z,this._transformDocumentSelector(ee),re),this._createDisposable(Z)}$provideDocumentSymbols(G,ee,ne){return this._withAdapter(G,o,le=>le.provideDocumentSymbols(g.URI.revive(ee),ne),void 0)}registerCodeLensProvider(G,ee,ne){const le=this._nextHandle(),Z=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new s(this._documents,this._commands.converter,ne),G)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(le);if(Z!==void 0){const pe=ne.onDidChangeCodeLenses(Me=>this._proxy.$emitCodeLensEvent(Z));re=C.Disposable.from(re,pe)}return re}$provideCodeLenses(G,ee,ne){return this._withAdapter(G,s,le=>le.provideCodeLenses(g.URI.revive(ee),ne),void 0)}$resolveCodeLens(G,ee,ne){return this._withAdapter(G,s,le=>le.resolveCodeLens(ee,ne),void 0)}$releaseCodeLenses(G,ee){this._withAdapter(G,s,ne=>Promise.resolve(ne.releaseCodeLenses(ee)),void 0)}registerDefinitionProvider(G,ee,ne){const le=this._addNewAdapter(new r(this._documents,ne),G);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDefinition(G,ee,ne,le){return this._withAdapter(G,r,Z=>Z.provideDefinition(g.URI.revive(ee),ne,le),[])}registerDeclarationProvider(G,ee,ne){const le=this._addNewAdapter(new m(this._documents,ne),G);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDeclaration(G,ee,ne,le){return this._withAdapter(G,m,Z=>Z.provideDeclaration(g.URI.revive(ee),ne,le),[])}registerImplementationProvider(G,ee,ne){const le=this._addNewAdapter(new i(this._documents,ne),G);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideImplementation(G,ee,ne,le){return this._withAdapter(G,i,Z=>Z.provideImplementation(g.URI.revive(ee),ne,le),[])}registerTypeDefinitionProvider(G,ee,ne){const le=this._addNewAdapter(new t(this._documents,ne),G);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideTypeDefinition(G,ee,ne,le){return this._withAdapter(G,t,Z=>Z.provideTypeDefinition(g.URI.revive(ee),ne,le),[])}registerHoverProvider(G,ee,ne,le){const Z=this._addNewAdapter(new u(this._documents,ne),G);return this._proxy.$registerHoverProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideHover(G,ee,ne,le){return this._withAdapter(G,u,Z=>Z.provideHover(g.URI.revive(ee),ne,le),void 0)}registerEvaluatableExpressionProvider(G,ee,ne,le){const Z=this._addNewAdapter(new a(this._documents,ne),G);return this._proxy.$registerEvaluatableExpressionProvider(Z,this._transformDocumentSelector(ee)),this._createDisposable(Z)}$provideEvaluatableExpression(G,ee,ne,le){return this._withAdapter(G,a,Z=>Z.provideEvaluatableExpression(g.URI.revive(ee),ne,le),void 0)}registerInlineValuesProvider(G,ee,ne,le){const Z=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new l(this._documents,ne),G);this._proxy.$registerInlineValuesProvider(re,this._transformDocumentSelector(ee),Z);let pe=this._createDisposable(re);if(Z!==void 0){const Me=ne.onDidChangeInlineValues(je=>this._proxy.$emitInlineValuesEvent(Z));pe=C.Disposable.from(pe,Me)}return pe}$provideInlineValues(G,ee,ne,le,Z){return this._withAdapter(G,l,re=>re.provideInlineValues(g.URI.revive(ee),ne,le,Z),void 0)}registerDocumentHighlightProvider(G,ee,ne){const le=this._addNewAdapter(new f(this._documents,ne),G);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentHighlights(G,ee,ne,le){return this._withAdapter(G,f,Z=>Z.provideDocumentHighlights(g.URI.revive(ee),ne,le),void 0)}registerLinkedEditingRangeProvider(G,ee,ne){const le=this._addNewAdapter(new d(this._documents,ne),G);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideLinkedEditingRanges(G,ee,ne,le){return this._withAdapter(G,d,async Z=>{const re=await Z.provideLinkedEditingRanges(g.URI.revive(ee),ne,le);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?We._serializeRegExp(re.wordPattern):void 0}},void 0)}registerReferenceProvider(G,ee,ne){const le=this._addNewAdapter(new S(this._documents,ne),G);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideReferences(G,ee,ne,le,Z){return this._withAdapter(G,S,re=>re.provideReferences(g.URI.revive(ee),ne,le,Z),void 0)}registerCodeActionProvider(G,ee,ne,le){const Z=new c.DisposableStore,re=this._addNewAdapter(new A(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,G,this._apiDeprecation),G);return this._proxy.$registerQuickFixSupport(re,this._transformDocumentSelector(ee),{providedKinds:le?.providedCodeActionKinds?.map(pe=>pe.value),documentation:le?.documentation?.map(pe=>({kind:pe.kind.value,command:this._commands.converter.toInternal(pe.command,Z)}))},We._extLabel(G),Boolean(ne.resolveCodeAction)),Z.add(this._createDisposable(re)),Z}$provideCodeActions(G,ee,ne,le,Z){return this._withAdapter(G,A,re=>re.provideCodeActions(g.URI.revive(ee),ne,le,Z),void 0)}$resolveCodeAction(G,ee,ne){return this._withAdapter(G,A,le=>le.resolveCodeAction(ee,ne),void 0)}$releaseCodeActions(G,ee){this._withAdapter(G,A,ne=>Promise.resolve(ne.releaseCodeActions(ee)),void 0)}registerDocumentFormattingEditProvider(G,ee,ne){const le=this._addNewAdapter(new R(this._documents,ne),G);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(le)}$provideDocumentFormattingEdits(G,ee,ne,le){return this._withAdapter(G,R,Z=>Z.provideDocumentFormattingEdits(g.URI.revive(ee),ne,le),void 0)}registerDocumentRangeFormattingEditProvider(G,ee,ne){const le=this._addNewAdapter(new B(this._documents,ne),G);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(ee),G.identifier,G.displayName||G.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(G,ee,ne,le,Z){return this._withAdapter(G,B,re=>re.provideDocumentRangeFormattingEdits(g.URI.revive(ee),ne,le,Z),void 0)}registerOnTypeFormattingEditProvider(G,ee,ne,le){const Z=this._addNewAdapter(new x(this._documents,ne),G);return this._proxy.$registerOnTypeFormattingSupport(Z,this._transformDocumentSelector(ee),le,G.identifier),this._createDisposable(Z)}$provideOnTypeFormattingEdits(G,ee,ne,le,Z,re){return this._withAdapter(G,x,pe=>pe.provideOnTypeFormattingEdits(g.URI.revive(ee),ne,le,Z,re),void 0)}registerWorkspaceSymbolProvider(G,ee){const ne=this._addNewAdapter(new F(ee,this._logService),G);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(G,ee,ne){return this._withAdapter(G,F,le=>le.provideWorkspaceSymbols(ee,ne),{symbols:[]})}$resolveWorkspaceSymbol(G,ee,ne){return this._withAdapter(G,F,le=>le.resolveWorkspaceSymbol(ee,ne),void 0)}$releaseWorkspaceSymbols(G,ee){this._withAdapter(G,F,ne=>ne.releaseWorkspaceSymbols(ee),void 0)}registerRenameProvider(G,ee,ne){const le=this._addNewAdapter(new $(this._documents,ne,this._logService),G);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(ee),$.supportsResolving(ne)),this._createDisposable(le)}$provideRenameEdits(G,ee,ne,le,Z){return this._withAdapter(G,$,re=>re.provideRenameEdits(g.URI.revive(ee),ne,le,Z),void 0)}$resolveRenameLocation(G,ee,ne,le){return this._withAdapter(G,$,Z=>Z.resolveRenameLocation(g.URI.revive(ee),ne,le),void 0)}registerDocumentSemanticTokensProvider(G,ee,ne,le){const Z=this._nextHandle(),re=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(Z,new Be(new H(this._documents,ne),G)),this._proxy.$registerDocumentSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le,re);let pe=this._createDisposable(Z);if(re){const Me=ne.onDidChangeSemanticTokens(je=>this._proxy.$emitDocumentSemanticTokensEvent(re));pe=C.Disposable.from(pe,Me)}return pe}$provideDocumentSemanticTokens(G,ee,ne,le){return this._withAdapter(G,H,Z=>Z.provideDocumentSemanticTokens(g.URI.revive(ee),ne,le),null,!0)}$releaseDocumentSemanticTokens(G,ee){this._withAdapter(G,H,ne=>ne.releaseDocumentSemanticColoring(ee),void 0)}registerDocumentRangeSemanticTokensProvider(G,ee,ne,le){const Z=this._addNewAdapter(new N(this._documents,ne),G);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Z,this._transformDocumentSelector(ee),le),this._createDisposable(Z)}$provideDocumentRangeSemanticTokens(G,ee,ne,le){return this._withAdapter(G,N,Z=>Z.provideDocumentRangeSemanticTokens(g.URI.revive(ee),ne,le),null,!0)}registerCompletionItemProvider(G,ee,ne,le){const Z=this._addNewAdapter(new U(this._documents,this._commands.converter,ne,this._apiDeprecation,G),G);return this._proxy.$registerSuggestSupport(Z,this._transformDocumentSelector(ee),le,U.supportsResolving(ne),`${G.identifier.value}(${le.join("")})`),this._createDisposable(Z)}$provideCompletionItems(G,ee,ne,le,Z){return this._withAdapter(G,U,re=>re.provideCompletionItems(g.URI.revive(ee),ne,le,Z),void 0)}$resolveCompletionItem(G,ee,ne){return this._withAdapter(G,U,le=>le.resolveCompletionItem(ee,ne),void 0)}$releaseCompletionItems(G,ee){this._withAdapter(G,U,ne=>ne.releaseCompletionItems(ee),void 0)}registerInlineCompletionsProvider(G,ee,ne){const le=this._addNewAdapter(new V(this._documents,ne,this._commands.converter),G);return this._proxy.$registerInlineCompletionsSupport(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideInlineCompletions(G,ee,ne,le,Z){return this._withAdapter(G,V,re=>re.provideInlineCompletions(g.URI.revive(ee),ne,le,Z),void 0)}$handleInlineCompletionDidShow(G,ee,ne){this._withAdapter(G,V,async le=>{le.handleDidShowCompletionItem(ee,ne)},void 0)}$freeInlineCompletionsList(G,ee){this._withAdapter(G,V,async ne=>{ne.disposeCompletions(ee)},void 0)}registerSignatureHelpProvider(G,ee,ne,le){const Z=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,re=this._addNewAdapter(new W(this._documents,ne),G);return this._proxy.$registerSignatureHelpProvider(re,this._transformDocumentSelector(ee),Z),this._createDisposable(re)}$provideSignatureHelp(G,ee,ne,le,Z){return this._withAdapter(G,W,re=>re.provideSignatureHelp(g.URI.revive(ee),ne,le,Z),void 0)}$releaseSignatureHelp(G,ee){this._withAdapter(G,W,ne=>ne.releaseSignatureHelp(ee),void 0)}registerInlayHintsProvider(G,ee,ne){const le=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Z=this._addNewAdapter(new j(this._documents,ne),G);this._proxy.$registerInlayHintsProvider(Z,this._transformDocumentSelector(ee),le);let re=this._createDisposable(Z);if(le!==void 0){const pe=ne.onDidChangeInlayHints(Me=>this._proxy.$emitInlayHintsEvent(le));re=C.Disposable.from(re,pe)}return re}$provideInlayHints(G,ee,ne,le){return this._withAdapter(G,j,Z=>Z.provideInlayHints(g.URI.revive(ee),ne,le),void 0)}registerDocumentLinkProvider(G,ee,ne){const le=this._addNewAdapter(new X(this._documents,ne),G);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(ee),typeof ne.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(G,ee,ne){return this._withAdapter(G,X,le=>le.provideLinks(g.URI.revive(ee),ne),void 0)}$resolveDocumentLink(G,ee,ne){return this._withAdapter(G,X,le=>le.resolveLink(ee,ne),void 0)}$releaseDocumentLinks(G,ee){this._withAdapter(G,X,ne=>ne.releaseLinks(ee),void 0)}registerColorProvider(G,ee,ne){const le=this._addNewAdapter(new Q(this._documents,ne),G);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideDocumentColors(G,ee,ne){return this._withAdapter(G,Q,le=>le.provideColors(g.URI.revive(ee),ne),[])}$provideColorPresentations(G,ee,ne,le){return this._withAdapter(G,Q,Z=>Z.provideColorPresentations(g.URI.revive(ee),ne,le),void 0)}registerFoldingRangeProvider(G,ee,ne){const le=this._nextHandle(),Z=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new Be(new de(this._documents,ne),G)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(ee),Z);let re=this._createDisposable(le);if(Z!==void 0){const pe=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Z));re=C.Disposable.from(re,pe)}return re}$provideFoldingRanges(G,ee,ne,le){return this._withAdapter(G,de,Z=>Z.provideFoldingRanges(g.URI.revive(ee),ne,le),void 0)}registerSelectionRangeProvider(G,ee,ne){const le=this._addNewAdapter(new Se(this._documents,ne,this._logService),G);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$provideSelectionRanges(G,ee,ne,le){return this._withAdapter(G,Se,Z=>Z.provideSelectionRanges(g.URI.revive(ee),ne,le),[])}registerCallHierarchyProvider(G,ee,ne){const le=this._addNewAdapter(new De(this._documents,ne),G);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareCallHierarchy(G,ee,ne,le){return this._withAdapter(G,De,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),ne,le)),void 0)}$provideCallHierarchyIncomingCalls(G,ee,ne,le){return this._withAdapter(G,De,Z=>Z.provideCallsTo(ee,ne,le),void 0)}$provideCallHierarchyOutgoingCalls(G,ee,ne,le){return this._withAdapter(G,De,Z=>Z.provideCallsFrom(ee,ne,le),void 0)}$releaseCallHierarchy(G,ee){this._withAdapter(G,De,ne=>Promise.resolve(ne.releaseSession(ee)),void 0)}registerTypeHierarchyProvider(G,ee,ne){const le=this._addNewAdapter(new Pe(this._documents,ne),G);return this._proxy.$registerTypeHierarchyProvider(le,this._transformDocumentSelector(ee)),this._createDisposable(le)}$prepareTypeHierarchy(G,ee,ne,le){return this._withAdapter(G,Pe,Z=>Promise.resolve(Z.prepareSession(g.URI.revive(ee),ne,le)),void 0)}$provideTypeHierarchySupertypes(G,ee,ne,le){return this._withAdapter(G,Pe,Z=>Z.provideSupertypes(ee,ne,le),void 0)}$provideTypeHierarchySubtypes(G,ee,ne,le){return this._withAdapter(G,Pe,Z=>Z.provideSubtypes(ee,ne,le),void 0)}$releaseTypeHierarchy(G,ee){this._withAdapter(G,Pe,ne=>Promise.resolve(ne.releaseSession(ee)),void 0)}static _serializeRegExp(G){return{pattern:G.source,flags:(0,k.regExpFlags)(G)}}static _serializeIndentationRule(G){return{decreaseIndentPattern:We._serializeRegExp(G.decreaseIndentPattern),increaseIndentPattern:We._serializeRegExp(G.increaseIndentPattern),indentNextLinePattern:G.indentNextLinePattern?We._serializeRegExp(G.indentNextLinePattern):void 0,unIndentedLinePattern:G.unIndentedLinePattern?We._serializeRegExp(G.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(G){return{beforeText:We._serializeRegExp(G.beforeText),afterText:G.afterText?We._serializeRegExp(G.afterText):void 0,previousLineText:G.previousLineText?We._serializeRegExp(G.previousLineText):void 0,action:G.action}}static _serializeOnEnterRules(G){return G.map(We._serializeOnEnterRule)}setLanguageConfiguration(G,ee,ne){let{wordPattern:le}=ne;if(le&&(0,k.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(ee,le):this._documents.setWordDefinitionFor(ee,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",G,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",G,"Do not use.");const Z=this._nextHandle(),re={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?We._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?We._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?We._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Z,ee,re),this._createDisposable(Z)}$setWordDefinitions(G){for(const ee of G)this._documents.setWordDefinitionFor(ee.languageId,new RegExp(ee.regexSource,ee.regexFlags))}}e.ExtHostLanguageFeatures=We,We._handlePool=0}),define(fe[245],me([0,1,5,17,7,50,16,6]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class _{constructor(P,I,c,v){this._documents=I,this._commands=c,this._uriTransformer=v,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=P.getProxy(g.MainContext.MainThreadLanguages)}$acceptLanguageIds(P){this._languageIds=P}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(P,I){await this._proxy.$changeLanguage(P,I);const c=this._documents.getDocumentData(P);if(!c)throw new Error(`document '${P.toString}' NOT found`);return c.document}async tokenAtPosition(P,I){const c=P.version,v=L.Position.from(I),h=await this._proxy.$tokensAtPosition(P.uri,v),w={type:y.StandardTokenType.Other,range:P.getWordRangeAtPosition(I)??new y.Range(I.line,I.character,I.line,I.character)};if(!h)return w;const E={range:L.Range.to(h.range),type:L.TokenType.to(h.type)};return!E.range.contains(I)||c!==P.version?w:E}createLanguageStatusItem(P,I,c){const v=this._handlePool++,h=this._proxy,w=this._ids,E=`${P.identifier.value}/${I}`;if(w.has(E))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);w.add(E);const T={selector:c,id:I,name:P.displayName??P.name,severity:y.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let b,o=new k.DisposableStore;const s=()=>{b?.dispose(),b=(0,n.disposableTimeout)(()=>{o.clear(),this._proxy.$setLanguageStatus(v,{id:E,name:T.name??P.displayName??P.name,source:P.displayName??P.name,selector:L.DocumentSelector.from(T.selector,this._uriTransformer),label:T.text,detail:T.detail??"",severity:T.severity===y.LanguageStatusSeverity.Error?C.default.Error:T.severity===y.LanguageStatusSeverity.Warning?C.default.Warning:C.default.Info,command:T.command&&this._commands.toInternal(T.command,o),accessibilityInfo:T.accessibilityInformation})},0)},p={dispose(){o.dispose(),b?.dispose(),h.$removeLanguageStatus(v),w.delete(E)},get id(){return T.id},get name(){return T.name},set name(r){T.name=r,s()},get selector(){return T.selector},set selector(r){T.selector=r,s()},get text(){return T.text},set text(r){T.text=r,s()},get detail(){return T.detail},set detail(r){T.detail=r,s()},get severity(){return T.severity},set severity(r){T.severity=r,s()},get accessibilityInformation(){return T.accessibilityInformation},set accessibilityInformation(r){T.accessibilityInformation=r,s()},get command(){return T.command},set command(r){T.command=r,s()}};return s(),p}}e.ExtHostLanguages=_}),define(fe[132],me([0,1,11,5,26,14,3]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let k=class extends g.AbstractLoggerService{constructor(P,I){const c=new n.Emitter;super(I.logLevel,c.event);this._proxy=P.getProxy(L.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(c)}$setLevel(P){this._onDidChangeLogLevel.fire(P)}doCreateLogger(P,I,c){return new _(this._proxy,P,I,c)}};k=Ve([$e(0,C.IExtHostRpcService),$e(1,y.IExtHostInitDataService)],k),e.ExtHostLoggerService=k;class _ extends g.AbstractMessageLogger{constructor(P,I,c,v){super(v?.always);this.proxy=P,this.file=I,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.proxy.$createLogger(I,v).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(P,I){const c=[[P,I]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(P){this.proxy.$log(this.file,P)}}}),define(fe[246],me([0,1,5,11,29]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function C(k){return k&&k.title}let n=class{constructor(_,D){this._logService=D,this._proxy=_.getProxy(g.MainContext.MainThreadMessageService)}showMessage(_,D,P,I,c){const v={extension:_};let h;typeof I=="string"||C(I)?h=[I,...c]:(v.modal=I?.modal,v.useCustom=I?.useCustom,v.detail=I?.detail,h=c),v.useCustom&&(0,y.checkProposedApiEnabled)(_,"resolvers");const w=[];for(let E=0;E<h.length;E++){const T=h[E];if(typeof T=="string")w.push({title:T,handle:E,isCloseAffordance:!1});else if(typeof T=="object"){let{title:b,isCloseAffordance:o}=T;w.push({title:b,isCloseAffordance:!!o,handle:E})}else this._logService.warn("Invalid message item:",T)}return this._proxy.$showMessage(D,P,v,w).then(E=>{if(typeof E=="number")return h[E]})}};n=Ve([$e(1,L.ILogService)],n),e.ExtHostMessageService=n}),define(fe[247],me([0,1,22,3,49,6,24,8,13,2,88,5,17,7,55,222,129]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class T{constructor(o,s,p,r,m){this._textDocumentsAndEditors=p,this._textDocuments=r,this._extensionStoragePaths=m,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new n.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new L.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new L.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new L.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new L.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new L.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new L.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new P.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=o.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=o.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=o.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=s.converter,s.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===12){const t=i.notebookEditor?.notebookUri,u=i.cell.handle,l=this._documents.get(t)?.getCell(u);if(l)return l.apiCell}return i}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(o=>o.apiEditor)}getEditorById(o){const s=this._editors.get(o);if(!s)throw new Error(`unknown text editor: ${o}. known editors: ${[...this._editors.keys()]} `);return s}getIdByEditor(o){for(const[s,p]of this._editors)if(p.apiEditor===o)return s}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(o,s){const p=this._documents.get(o);if(!p&&!s)throw new Error(`NO notebook document for '${o}'`);return p}_getProviderData(o){const s=this._notebookContentProviders.get(o);if(!s)throw new Error(`NO provider for '${o}'`);return s}registerNotebookContentProvider(o,s,p,r,m){if((0,k.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(s))throw new Error(`Notebook provider for '${s}' already registered`);this._notebookContentProviders.set(s,{extension:o,provider:p});let i;return p.onDidChangeNotebookContentOptions&&(i=p.onDidChangeNotebookContentOptions(()=>{const t=c.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(s,t)})),this._notebookProxy.$registerNotebookProvider({id:o.identifier,location:o.extensionLocation},s,c.NotebookDocumentContentOptions.from(r),T._convertNotebookRegistrationData(o,m)),new v.Disposable(()=>{i?.dispose(),this._notebookContentProviders.delete(s),this._notebookProxy.$unregisterNotebookProvider(s)})}static _convertNotebookRegistrationData(o,s){if(!s)return;const p=s.filenamePattern.map(r=>c.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(s.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:o.identifier,providerDisplayName:o.displayName||o.name,displayName:s.displayName,filenamePattern:p,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(o,s,p){const r=T._notebookStatusBarItemProviderHandlePool++,m=typeof p.onDidChangeCellStatusBarItems=="function"?T._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,m,s);let i;return m!==void 0&&(i=p.onDidChangeCellStatusBarItems(t=>this._notebookProxy.$emitCellStatusBarEvent(m))),new v.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,m),i&&i.dispose()})}async createNotebookDocument(o){const s=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:o.viewType,content:o.content&&c.NotebookData.from(o.content)});return D.URI.revive(s)}async openNotebookDocument(o){const s=this._documents.get(o);if(s)return s.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenNotebook(o),r=this._documents.get(D.URI.revive(p));return(0,_.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(o,s){D.URI.isUri(o)&&(o=await this.openNotebookDocument(o));let p;typeof s=="object"?p={position:c.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(c.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:p={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(o.uri,o.notebookType,p),m=r&&this._editors.get(r)?.apiEditor;if(m)return m;throw r?new Error(`Could NOT open editor for "${o.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${o.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(o,s,p,r){const m=this._notebookStatusBarItemProviders.get(o),i=D.URI.revive(s),t=this._documents.get(i);if(!t||!m)return;const u=t.getCellFromIndex(p);if(!u)return;const a=await m.provideCellStatusBarItems(u.apiCell,r);if(!a)return;const l=new C.DisposableStore,f=this._statusBarCache.add([l]),S=(Array.isArray(a)?a:[a]).map(A=>c.NotebookStatusBarItem.from(A,this._commandsConverter,l));return{cacheId:f,items:S}}$releaseNotebookCellStatusBarItems(o){this._statusBarCache.delete(o)}registerNotebookSerializer(o,s,p,r,m){if((0,k.isFalsyOrWhitespace)(s))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,p),this._notebookProxy.$registerNotebookSerializer(i,{id:o.identifier,location:o.extensionLocation},s,c.NotebookDocumentContentOptions.from(r),T._convertNotebookRegistrationData(o,m)),(0,C.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(o,s,p){const r=this._notebookSerializer.get(o);if(!r)throw new Error("NO serializer found");const m=await r.deserializeNotebook(s.buffer,p);return new h.SerializableObjectWithBuffers(c.NotebookData.from(m))}async $notebookToData(o,s,p){const r=this._notebookSerializer.get(o);if(!r)throw new Error("NO serializer found");const m=await r.serializeNotebook(c.NotebookData.to(s.value),p);return g.VSBuffer.wrap(m)}async $openNotebook(o,s,p,r,m){const{provider:i}=this._getProviderData(o),t=await i.openNotebook(D.URI.revive(s),{backupId:p,untitledDocumentData:r?.buffer},m);return new h.SerializableObjectWithBuffers({metadata:t.metadata??Object.create(null),cells:t.cells.map(c.NotebookCellData.from)})}async $saveNotebook(o,s,p){const r=this.getNotebookDocument(D.URI.revive(s)),{provider:m}=this._getProviderData(o);return await m.saveNotebook(r.apiNotebook,p),!0}async $saveNotebookAs(o,s,p,r){const m=this.getNotebookDocument(D.URI.revive(s)),{provider:i}=this._getProviderData(o);return await i.saveNotebookAs(D.URI.revive(p),m.apiNotebook,r),!0}async $backupNotebook(o,s,p){const r=this.getNotebookDocument(D.URI.revive(s)),m=this._getProviderData(o),i=this._extensionStoragePaths.workspaceValue(m.extension)??this._extensionStoragePaths.globalValue(m.extension),t=String((0,y.hash)([r.uri.toString(),this._backupIdPool++])),u=D.URI.joinPath(i,t),a=await m.provider.backupNotebook(r.apiNotebook,{destination:u},p);return r.updateBackup(a),a.id}_createExtHostEditor(o,s,p){if(this._editors.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const r=new E.ExtHostNotebookEditor(s,this._notebookEditorsProxy,o,p.visibleRanges.map(c.NotebookRange.to),p.selections.map(c.NotebookRange.to),typeof p.viewColumn=="number"?c.ViewColumn.to(p.viewColumn):void 0);this._editors.set(s,r)}$acceptDocumentAndEditorsDelta(o){if(o.value.removedDocuments)for(const p of o.value.removedDocuments){const r=D.URI.revive(p),m=this._documents.get(r);m&&(m.dispose(),this._documents.delete(r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:m.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(m.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===r.toString()&&this._editors.delete(i.id)}if(o.value.addedDocuments){const p=[];for(const r of o.value.addedDocuments){const m=D.URI.revive(r.uri);if(this._documents.has(m))throw new Error(`adding EXISTING notebook ${m} `);const i=this,t=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(u){i._onDidChangeNotebookCells.fire(u)},emitCellOutputsChange(u){i._onDidChangeCellOutputs.fire(u)},emitCellMetadataChange(u){i._onDidChangeCellMetadata.fire(u)},emitCellExecutionStateChange(u){i._onDidChangeCellExecutionState.fire(u)}},m,r);p.push(...r.cells.map(u=>w.ExtHostCell.asModelAddData(t.apiNotebook,u))),this._documents.get(m)?.dispose(),this._documents.set(m,t),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this._onDidOpenNotebookDocument.fire(t.apiNotebook)}}if(o.value.addedEditors)for(const p of o.value.addedEditors){if(this._editors.has(p.id))return;const r=D.URI.revive(p.documentUri),m=this._documents.get(r);m&&this._createExtHostEditor(m,p.id,p)}const s=[];if(o.value.removedEditors)for(const p of o.value.removedEditors){const r=this._editors.get(p);r&&(this._editors.delete(p),this._activeNotebookEditor?.id===r.id&&(this._activeNotebookEditor=void 0),s.push(r))}if(o.value.visibleEditors){this._visibleNotebookEditors=o.value.visibleEditors.map(r=>this._editors.get(r)).filter(r=>!!r);const p=new Set;this._visibleNotebookEditors.forEach(r=>p.add(r.id));for(const r of this._editors.values()){const m=p.has(r.id);r._acceptVisibility(m)}this._visibleNotebookEditors=[...this._editors.values()].map(r=>r).filter(r=>r.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}o.value.newActiveEditor===null?this._activeNotebookEditor=void 0:o.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(o.value.newActiveEditor)),o.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=T,T._notebookStatusBarItemProviderHandlePool=0}),define(fe[248],me([0,1,3,77,11,5,14,17]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(I,c){const v=_._Keys.nextId();I.$registerNotebookEditorDecorationType(v,k.NotebookDecorationRenderOptions.from(c)),this.value={key:v,dispose(){I.$removeNotebookEditorDecorationType(v)}}}}_._Keys=new L.IdGenerator("NotebookEditorDecorationType");let D=class{constructor(I,c,v){this._logService=I,this._extHostRpc=c,this._notebooksAndEditors=v,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new _(this._extHostRpc.getProxy(C.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,c);const v=this._notebooksAndEditors.getEditorById(I);c.visibleRanges&&v._acceptVisibleRanges(c.visibleRanges.ranges.map(k.NotebookRange.to)),c.selections&&v._acceptSelections(c.selections.selections.map(k.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:v.apiEditor,visibleRanges:v.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:v.apiEditor,selections:v.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const c in I)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(k.ViewColumn.to(I[c]))}};D=Ve([$e(0,y.ILogService),$e(1,n.IExtHostRpcService)],D),e.ExtHostNotebookEditors=D}),define(fe[249],me([0,1,15,16,21,3,6,24,2,27,11,5,40,17,7,89,214,29,55]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let o=class{constructor(i,t,u,a,l){this._initData=t,this._extHostNotebook=u,this._commands=a,this._logService=l,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=i.getProxy(I.MainContext.MainThreadNotebookKernels);const f=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",d=>!0,d=>{if(d&&"notebookEditor"in d&&"id"in d){const S=this._extHostNotebook.getIdByEditor(d.notebookEditor);return{id:d.id,extension:d.extension,notebookEditorId:S}}else if(d&&"notebookEditor"in d){const S=this._extHostNotebook.getIdByEditor(d.notebookEditor);if(S===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${d.notebookEditor.document.uri.toString()}`);return{notebookEditorId:S}}return d})],c.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(i,t,u,a,l,f){for(let W of this._kernelData.values())if(W.controller.id===t&&D.ExtensionIdentifier.equals(i.identifier,W.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const d=this._handlePool++,S=this;this._logService.trace(`NotebookController[${d}], CREATED by ${i.identifier.value}, ${t}`);const A=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${i.identifier}'`);let R=!1;const B=new n.DisposableStore,x=new C.Emitter,F=new C.Emitter,$={id:`${i.identifier.value}/${t}`,notebookType:u,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:a||i.identifier.value,preloads:f?f.map(v.NotebookRendererScript.from):[]};let M=l??A,H;this._proxy.$addKernel(d,$).catch(W=>{console.log(W),R=!0});let N=0;const U=()=>{if(R)return;const W=++N;Promise.resolve().then(()=>{W===N&&this._proxy.$updateKernel(d,$)})},V=new k.ResourceMap,O={get id(){return t},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return $.label},set label(W){$.label=W??i.displayName??i.name,U()},get detail(){return $.detail??""},set detail(W){$.detail=W,U()},get description(){return $.description??""},set description(W){$.description=W,U()},get kind(){return(0,T.checkProposedApiEnabled)(i,"notebookControllerKind"),$.kind??""},set kind(W){(0,T.checkProposedApiEnabled)(i,"notebookControllerKind"),$.kind=W,U()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(W){$.supportedLanguages=W,U()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(W){$.supportsExecutionOrder=W,U()},get rendererScripts(){return $.preloads?$.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return M},set executeHandler(W){M=W??A},get interruptHandler(){return H},set interruptHandler(W){H=W,$.supportsInterrupt=Boolean(W),U()},createNotebookCellExecution(W){if(R)throw new Error("notebook controller is DISPOSED");if(!V.has(W.notebook.uri))throw S._logService.trace(`NotebookController[${d}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(j=>j.toString())),new Error(`notebook controller is NOT associated to notebook: ${W.notebook.uri.toString()}`);return S._createNotebookCellExecution(W)},dispose:()=>{R||(this._logService.trace(`NotebookController[${d}], DISPOSED`),R=!0,this._kernelData.delete(d),B.dispose(),x.dispose(),F.dispose(),this._proxy.$removeKernel(d))},updateNotebookAffinity(W,j){S._proxy.$updateNotebookPriority(d,W.uri,j)},onDidReceiveMessage:F.event,postMessage(W,j){return(0,T.checkProposedApiEnabled)(i,"notebookMessaging"),S._proxy.$postMessage(d,j&&S._extHostNotebook.getIdByEditor(j),W)},asWebviewUri(W){return(0,T.checkProposedApiEnabled)(i,"notebookMessaging"),(0,w.asWebviewUri)(W,S._initData.remote)}};return this._kernelData.set(d,{extensionId:i.identifier,controller:O,onDidReceiveMessage:F,onDidChangeSelection:x,associatedNotebooks:V}),O}$acceptNotebookAssociation(i,t,u){const a=this._kernelData.get(i);if(a){const l=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));u?a.associatedNotebooks.set(l.uri,!0):a.associatedNotebooks.delete(l.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,l.uri.toString(),u),a.onDidChangeSelection.fire({selected:u,notebook:l.apiNotebook})}}async $executeCells(i,t,u){const a=this._kernelData.get(i);if(!a)return;const l=this._extHostNotebook.getNotebookDocument(_.URI.revive(t)),f=[];for(let d of u){const S=l.getCell(d);S&&f.push(S.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,l.uri.toString(),f.length),await a.controller.executeHandler.call(a.controller,f,l.apiNotebook,a.controller)}catch(d){this._logService.error(`NotebookController[${i}] execute cells FAILED`,d),console.error(d)}}async $cancelCells(i,t,u){const a=this._kernelData.get(i);if(!a)return;const l=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));if(a.controller.interruptHandler)await a.controller.interruptHandler.call(a.controller,l.apiNotebook);else for(let f of u){const d=l.getCell(f);d&&this._activeExecutions.get(d.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,t,u){const a=this._kernelData.get(i);if(!a)return;const l=this._extHostNotebook.getEditorById(t);a.onDidReceiveMessage.fire(Object.freeze({editor:l.apiEditor,message:u}))}_createNotebookCellExecution(i){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const a=new p(u.notebook,u,this._proxy);this._activeExecutions.set(u.uri,a);const l=a.onDidChangeState(()=>{a.state===s.Resolved&&(a.dispose(),l.dispose(),this._activeExecutions.delete(u.uri))});return a.asApiObject()}};o=Ve([$e(4,P.ILogService)],o),e.ExtHostNotebookKernels=o;var s;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(s||(s={}));class p extends n.Disposable{constructor(i,t,u){super();this._document=i,this._cell=t,this._proxy=u,this._handle=p.HANDLE++,this._onDidChangeState=new C.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=s.Init,this._tokenSource=this._register(new y.CancellationTokenSource),this._collector=new r(10,a=>this.update(a)),this._executionOrder=t.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const t=Array.isArray(i)?i:[i];return this._proxy.$updateExecutions(new b.SerializableObjectWithBuffers(t))}verifyStateForOutput(){if(this._state===s.Init)throw new Error("Must call start before modifying cell output");if(this._state===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let t=this._cell;if(i&&(t=this._document.getCellFromApiCell(i)),!t)throw new Error("INVALID cell");return t.handle}validateAndConvertOutputs(i){return i.map(t=>{const u=h.NotebookCellOutput.ensureUniqueMimeTypes(t.items,!0);return u===t.items?v.NotebookCellOutput.from(t):v.NotebookCellOutput.from({items:u,id:t.id,metadata:t.metadata})})}async updateOutputs(i,t,u){const a=this.cellIndexToHandle(t),l=this.validateAndConvertOutputs((0,g.asArray)(i));return this.updateSoon({editType:E.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:a,append:u,outputs:l})}async updateOutputItems(i,t,u){return i=h.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(i),!0),this.updateSoon({editType:E.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:i.map(v.NotebookCellOutputItem.from),outputId:t.id,append:u})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(u){i._executionOrder=u,i.update([{editType:E.CellExecutionUpdateType.ExecutionState,executionHandle:i._handle,executionOrder:i._executionOrder}])},start(u){if(i._state===s.Resolved||i._state===s.Started)throw new Error("Cannot call start again");i._state=s.Started,i._onDidChangeState.fire(),i.update({editType:E.CellExecutionUpdateType.ExecutionState,executionHandle:i._handle,runStartTime:u})},end(u,a){if(i._state===s.Resolved)throw new Error("Cannot call resolve twice");i._state=s.Resolved,i._onDidChangeState.fire(),i.updateSoon({editType:E.CellExecutionUpdateType.Complete,executionHandle:i._handle,runEndTime:a,lastRunSuccess:u}),i._collector.flush(),i._proxy.$removeExecution(i._handle)},clearOutput(u){return i.verifyStateForOutput(),i.updateOutputs([],u,!1)},appendOutput(u,a){return i.verifyStateForOutput(),i.updateOutputs(u,a,!0)},replaceOutput(u,a){return i.verifyStateForOutput(),i.updateOutputs(u,a,!1)},appendOutputItems(u,a){return i.verifyStateForOutput(),i.updateOutputItems(u,a,!0)},replaceOutputItems(u,a){return i.verifyStateForOutput(),i.updateOutputItems(u,a,!1)}})}}p.HANDLE=0;class r{constructor(i,t){this.delay=i,this.callback=t,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new L.DeferredPromise,this.startedTimer=Date.now(),(0,L.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const t=this.batch;return this.batch=[],this.callback(t).finally(()=>i.complete())}}}),define(fe[250],me([0,1,3,5,129,29]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class n{constructor(_,D){this._extHostNotebook=D,this._rendererMessageEmitters=new Map,this.proxy=_.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(_,D,P){const I=this._extHostNotebook.getEditorById(_);this._rendererMessageEmitters.get(D)?.fire({editor:I.apiEditor,message:P})}createRendererMessaging(_,D){if(!_.contributes?.notebookRenderer?.some(v=>v.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);const P=(0,C.isProposedApiEnabled)(_,"notebookEditor"),I=new WeakMap;return{onDidReceiveMessage:(v,h,w)=>{const E=P?v:T=>{const b={};I.set(b,T.editor),v({editor:b,message:T.message})};return this.getOrCreateEmitterFor(D).event(E,h,w)},postMessage:(v,h)=>{y.ExtHostNotebookEditor.apiEditorsToExtHost.has(v)&&([v,h]=[h,v]);const w=P?h:I.get(h),E=w&&y.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.proxy.$postMessage(E?.id,D,v)}}}getOrCreateEmitterFor(_){let D=this._rendererMessageEmitters.get(_);return D||(D=new g.Emitter({onLastListenerRemove:()=>{D?.dispose(),this._rendererMessageEmitters.delete(_)}}),this._rendererMessageEmitters.set(_,D),D)}}e.ExtHostNotebookRenderers=n}),define(fe[133],me([0,1,5,6,4,14,11,215,69,26,45,152,22]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class v extends L.Disposable{constructor(E,T,b,o){super();this.id=E,this.name=T,this.logger=b,this.proxy=o,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(E){this.append(E+`
`)}append(E){this.write(E),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Append))}clear(){const E=this.offset;this.logger.flush(),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Clear,E)}replace(E){const T=this.offset;this.write(E),this.proxy.$update(this.id,k.OutputChannelUpdateMode.Replace,T),this.visible&&this.logger.flush()}show(E,T){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof E=="boolean"?E:T))}hide(){this.proxy.$close(this.id)}write(E){this.offset+=c.VSBuffer.fromString(E).byteLength,this.logger.info(E)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=v;let h=class{constructor(E,T,b,o,s){this.extHostFileSystem=b,this.extHostFileSystemInfo=o,this.loggerService=s,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=E.getProxy(g.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(T.logsLocation,`output_logging_${(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(E){this.visibleChannelId=E;for(const[T,b]of this.channels)b.visible=T===this.visibleChannelId}createOutputChannel(E,T){if(E=E.trim(),!E)throw new Error("illegal argument `name`. must not be falsy");const b=this.doCreateOutputChannel(E,T);return b.then(o=>{this.channels.set(o.id,o),o.visible=o.id===this.visibleChannelId}),this.createExtHostOutputChannel(E,b)}async doCreateOutputChannel(E,T){const b=await this.createOutputDirectory(),o=this.extHostFileSystemInfo.extUri.joinPath(b,`${this.namePool++}-${E.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(o,{always:!0,donotRotate:!0,donotUseFormatters:!0}),p=await this.proxy.$register(E,!1,o,T.identifier.value);return new v(p,E,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(E,T){let b=!1;const o=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return E},append(s){o(),T.then(p=>p.append(s))},appendLine(s){o(),T.then(p=>p.appendLine(s))},clear(){o(),T.then(s=>s.clear())},replace(s){o(),T.then(p=>p.replace(s))},show(s,p){o(),T.then(r=>r.show(s,p))},hide(){o(),T.then(s=>s.hide())},dispose(){b=!0,T.then(s=>s.dispose())}}}};h=Ve([$e(0,C.IExtHostRpcService),$e(1,D.IExtHostInitDataService),$e(2,_.IExtHostConsumerFileSystem),$e(3,P.IExtHostFileSystemInfo),$e(4,n.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(fe[251],me([0,1,16,21,3,6,5,2,7,18,15,50,65]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function v(h,w,E){const T=h.getProxy(n.MainContext.MainThreadQuickOpen);class b{constructor(a,l){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=l}showQuickPick(a,l,f,d=L.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(a),A=++this._instances,R=T.$show(A,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},d),B={},x=R.then(()=>B);return Promise.race([x,S]).then(F=>{if(F!==B)return S.then($=>{const M=[];for(let H=0;H<$.length;H++){const N=$[H];let U,V,O,W,j;typeof N=="string"?U=N:(U=N.label,V=N.description,O=N.detail,W=N.picked,j=N.alwaysShow),M.push({label:U,description:V,handle:H,detail:O,picked:W,alwaysShow:j})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{f.onDidSelectItem($[H])}),T.$setItems(A,M),R.then(H=>{if(typeof H=="number")return $[H];if(Array.isArray(H))return H.map(N=>$[N])})})}).then(void 0,F=>{if(!(0,D.isPromiseCanceledError)(F))return T.$setError(A,F),Promise.reject(F)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,l=L.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,T.$input(a,typeof this._validateInput=="function",l).then(void 0,f=>{if(!(0,D.isPromiseCanceledError)(f))return Promise.reject(f)})}$validateInput(a){return this._validateInput?(0,g.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,l=L.CancellationToken.None){const f=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!f)return;const d=await this._workspace.getWorkspaceFolders2();if(!!d)return d.find(S=>S.uri.toString()===f.uri.toString())}createQuickPick(a,l){const f=new i(a,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(a){const l=new t(a,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(a,l){const f=this._sessions.get(a);f&&f._fireDidChangeValue(l)}$onDidAccept(a){const l=this._sessions.get(a);l&&l._fireDidAccept()}$onDidChangeActive(a,l){const f=this._sessions.get(a);f instanceof i&&f._fireDidChangeActive(l)}$onDidChangeSelection(a,l){const f=this._sessions.get(a);f instanceof i&&f._fireDidChangeSelection(l)}$onDidTriggerButton(a,l){const f=this._sessions.get(a);f&&f._fireDidTriggerButton(l)}$onDidTriggerItemButton(a,l,f){const d=this._sessions.get(a);d instanceof i&&d._fireDidTriggerItemButton(l,f)}$onDidHide(a){const l=this._sessions.get(a);l&&l._fireDidHide()}}class o{constructor(a,l){this._extensionId=a,this._onDidDispose=l,this._id=i._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new y.Emitter,this._onDidChangeValueEmitter=new y.Emitter,this._onDidTriggerButtonEmitter=new y.Emitter,this._onDidHideEmitter=new y.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((l,f)=>{const d=l===_.QuickInputButtons.Back?-1:f;this._handlesToButtons.set(d,l)}),this.update({buttons:a.map((l,f)=>({...m(l),tooltip:l.tooltip,handle:l===_.QuickInputButtons.Back?-1:f}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const l=this._handlesToButtons.get(a);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,C.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),T.$dispose(this._id))}update(a){if(!this._disposed){for(const l of Object.keys(a)){const f=a[l];this._pendingUpdate[l]=f===void 0?null:f}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){T.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}o._nextId=1;function s(u){if(u instanceof _.ThemeIcon)return{id:u.id};const a=r(u),l=p(u);return{dark:typeof a=="string"?k.URI.file(a):a,light:typeof l=="string"?k.URI.file(l):l}}function p(u){return typeof u=="object"&&"light"in u?u.light:u}function r(u){return typeof u=="object"&&"dark"in u?u.dark:u}function m(u){const a=s(u.iconPath);let l,f;return"id"in a?f=c.ThemeIcon.asClassName(a):l=a,{iconPath:l,iconClass:f}}class i extends o{constructor(a,l){super(a,l);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new y.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new y.Emitter,this._onDidTriggerItemButtonEmitter=new y.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((l,f)=>{this._handlesToItems.set(f,l),this._itemsToHandles.set(l,f)}),this.update({items:a.map((l,f)=>({label:l.label,description:l.description,handle:f,detail:l.detail,picked:l.picked,alwaysShow:l.alwaysShow,buttons:l.buttons?.map((d,S)=>({...m(d),tooltip:d.tooltip,handle:S}))}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(a){this._keepScrollPosition=a,this.update({keepScrollPosition:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(a){const l=(0,P.coalesce)(a.map(f=>this._handlesToItems.get(f)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(a){const l=(0,P.coalesce)(a.map(f=>this._handlesToItems.get(f)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}_fireDidTriggerItemButton(a,l){const f=this._handlesToItems.get(a);if(!f||!f.buttons||!f.buttons.length)return;const d=f.buttons[l];d&&this._onDidTriggerItemButtonEmitter.fire({button:d,item:f})}}class t extends o{constructor(a,l){super(a,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?I.default.Error:I.default.Ignore})}}return new b(w,E)}e.createExtHostQuickOpen=v}),define(fe[252],me([0,1,2,3,60,6,16,5,15,100,11,27,65,17,29]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function w(a){if(a)return typeof a.iconPath=="string"?g.URI.file(a.iconPath):g.URI.isUri(a.iconPath)||c.ThemeIcon.isThemeIcon(a.iconPath)?a.iconPath:void 0}function E(a,l){if(!a.iconPath&&!l.iconPath)return 0;if(a.iconPath){if(!l.iconPath)return 1}else return-1;const f=typeof a.iconPath=="string"?a.iconPath:g.URI.isUri(a.iconPath)?a.iconPath.fsPath:a.iconPath.id,d=typeof l.iconPath=="string"?l.iconPath:g.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id;return(0,D.comparePaths)(f,d)}function T(a,l){let f=0;if(a.strikeThrough!==l.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==l.faded)return a.faded?1:-1;if(a.tooltip!==l.tooltip)return(a.tooltip||"").localeCompare(l.tooltip||"");if(f=E(a,l),f!==0)return f;if(a.light&&l.light)f=E(a.light,l.light);else{if(a.light)return 1;if(l.light)return-1}if(f!==0)return f;if(a.dark&&l.dark)f=E(a.dark,l.dark);else{if(a.dark)return 1;if(l.dark)return-1}return f}function b(a,l){if(a.command!==l.command)return a.command<l.command?-1:1;if(a.title!==l.title)return a.title<l.title?-1:1;if(a.tooltip!==l.tooltip){if(a.tooltip!==void 0&&l.tooltip!==void 0)return a.tooltip<l.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(l.tooltip!==void 0)return-1}if(a.arguments===l.arguments)return 0;if(a.arguments)if(l.arguments){if(a.arguments.length!==l.arguments.length)return a.arguments.length-l.arguments.length}else return 1;else return-1;for(let f=0;f<a.arguments.length;f++){const d=a.arguments[f],S=l.arguments[f];if(d!==S)return d<S?-1:1}return 0}function o(a,l){let f=(0,D.comparePaths)(a.resourceUri.fsPath,l.resourceUri.fsPath,!0);if(f!==0)return f;if(a.command&&l.command)f=b(a.command,l.command);else{if(a.command)return 1;if(l.command)return-1}if(f!==0)return f;if(a.decorations&&l.decorations)f=T(a.decorations,l.decorations);else{if(a.decorations)return 1;if(l.decorations)return-1}return f}function s(a,l){for(let f=0;f<a.length;f++)if(a[f]!==l[f])return!1;return!0}function p(a,l){return a.command===l.command&&a.title===l.title&&a.tooltip===l.tooltip&&(a.arguments&&l.arguments?s(a.arguments,l.arguments):a.arguments===l.arguments)}function r(a,l){return(0,_.equals)(a,l,p)}class m{constructor(l,f,d){this._extension=l,this._proxy=f,this._sourceControlHandle=d,this._value="",this._onDidChange=new L.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(l){this._proxy.$setInputBoxValue(this._sourceControlHandle,l),this.updateValue(l)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(l){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,l),this._placeholder=l}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(l){if((0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),l&&typeof l!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=l,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!l)}get visible(){return this._visible}set visible(l){l=!!l,this._visible!==l&&(this._visible=l,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,l))}showValidationMessage(l,f){(0,h.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,l,f)}$onInputBoxValueChange(l){this.updateValue(l)}updateValue(l){this._value=l,this._onDidChange.fire(l)}}e.ExtHostSCMInputBox=m;class i{constructor(l,f,d,S,A){this._proxy=l,this._commands=f,this._sourceControlHandle=d,this._id=S,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new L.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=i._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(l){this._label=l,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,l)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(l){this._hideWhenEmpty=l,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(l){this._resourceStates=[...l],this._onDidUpdateResourceStates.fire()}getResourceState(l){return this._resourceStatesMap.get(l)}$executeResourceCommand(l,f){const d=this._resourceStatesCommandsMap.get(l);return d?(0,n.asPromise)(()=>this._commands.executeCommand(d.command,...d.arguments||[],f)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const l=[...this._resourceStates].sort(o),d=(0,_.sortedDiff)(this._resourceSnapshot,l,o).map(R=>{const B=R.toInsert.map(x=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,x);const $=x.resourceUri;let M;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const de=new C.DisposableStore;M=this._commands.converter.toInternal(x.command,de),this._resourceStatesDisposablesMap.set(F,de)}else this._resourceStatesCommandsMap.set(F,x.command);const H=w(x.decorations),N=x.decorations&&w(x.decorations.light)||H,U=x.decorations&&w(x.decorations.dark)||H,V=[N,U],O=x.decorations&&x.decorations.tooltip||"",W=x.decorations&&!!x.decorations.strikeThrough,j=x.decorations&&!!x.decorations.faded,X=x.contextValue||"";return{rawResource:[F,$,V,O,W,j,X,M],handle:F}});return{start:R.start,deleteCount:R.deleteCount,toInsert:B}}),S=d.map(({start:R,deleteCount:B,toInsert:x})=>[R,B,x.map(F=>F.rawResource)]),A=d.reverse();for(const{start:R,deleteCount:B,toInsert:x}of A){const F=x.map(M=>M.handle),$=this._handlesSnapshot.splice(R,B,...F);for(const M of $)this._resourceStatesMap.delete(M),this._resourceStatesCommandsMap.delete(M),this._resourceStatesDisposablesMap.get(M)?.dispose(),this._resourceStatesDisposablesMap.delete(M)}return this._resourceSnapshot=l,S}dispose(){this._disposed=!0,this._onDidDispose.fire()}}i._handlePool=0;class t{constructor(l,f,d,S,A,R){this._extension=l,this._proxy=f,this._commands=d,this._id=S,this._label=A,this._rootUri=R,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new C.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new C.MutableDisposable,this._statusBarDisposables=new C.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new L.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new m(l,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,S,A,R)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(l){this._count!==l&&(this._count=l,this._proxy.$updateSourceControl(this.handle,{count:l}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(l){this._quickDiffProvider=l,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!l})}get commitTemplate(){return this._commitTemplate}set commitTemplate(l){l!==this._commitTemplate&&(this._commitTemplate=l,this._proxy.$updateSourceControl(this.handle,{commitTemplate:l}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(l){this._acceptInputDisposables.value=new C.DisposableStore,this._acceptInputCommand=l;const f=this._commands.converter.toInternal(l,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:f})}get actionButton(){return(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(l){(0,h.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new C.DisposableStore,this._actionButton=l;const f=l!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:f??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(l){if(this._statusBarCommands&&l&&r(this._statusBarCommands,l))return;this._statusBarDisposables.value=new C.DisposableStore,this._statusBarCommands=l;const f=(l||[]).map(d=>this._commands.converter.toInternal(d,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:f})}get selected(){return this._selected}createResourceGroup(l,f){const d=new i(this._proxy,this._commands,this.handle,l,f),S=L.Event.once(d.onDidDispose)(()=>this.createdResourceGroups.delete(d));return this.createdResourceGroups.set(d,S),this.eventuallyAddResourceGroups(),d}eventuallyAddResourceGroups(){const l=[],f=[];for(const[d,S]of this.createdResourceGroups){S.dispose();const A=d.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(d),this.eventuallyUpdateResourceStates()});L.Event.once(d.onDidDispose)(()=>{this.updatedResourceGroups.delete(d),A.dispose(),this._groups.delete(d.handle),this._proxy.$unregisterGroup(this.handle,d.handle)}),l.push([d.handle,d.id,d.label,d.features]);const R=d._takeResourceStateSnapshot();R.length>0&&f.push([d.handle,R]),this._groups.set(d.handle,d)}this._proxy.$registerGroups(this.handle,l,f),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const l=[];this.updatedResourceGroups.forEach(f=>{const d=f._takeResourceStateSnapshot();d.length!==0&&l.push([f.handle,d])}),l.length>0&&this._proxy.$spliceResourceStates(this.handle,l),this.updatedResourceGroups.clear()}getResourceGroup(l){return this._groups.get(l)}setSelectionState(l){this._selected=l,this._onDidChangeSelection.fire(l)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(l=>l.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}t._handlePool=0,Ve([(0,y.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Ve([(0,y.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let u=class $n{constructor(l,f,d){this._commands=f,this.logService=d,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new L.Emitter,this._proxy=l.getProxy(k.MainContext.MainThreadSCM),this._telemetry=l.getProxy(k.MainContext.MainThreadTelemetry),f.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===3){const A=this._sourceControls.get(S.sourceControlHandle);if(!A)return S;const R=A.getResourceGroup(S.groupHandle);return R?R.getResourceState(S.handle):S}else if(S&&S.$mid===4){const A=this._sourceControls.get(S.sourceControlHandle);return A?A.getResourceGroup(S.groupHandle):S}else if(S&&S.$mid===5){const A=this._sourceControls.get(S.handle);return A||S}return S}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(l,f,d,S){this.logService.trace("ExtHostSCM#createSourceControl",l.identifier.value,f,d,S),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:l.identifier.value});const A=$n._handlePool++,R=new t(l,this._proxy,this._commands,f,d,S);this._sourceControls.set(A,R);const B=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier))||[];return B.push(R),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(l.identifier),B),R}getLastInputBox(l){this.logService.trace("ExtHostSCM#getLastInputBox",l.identifier.value);const f=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(l.identifier)),d=f&&f[f.length-1];return d&&d.inputBox}$provideOriginalResource(l,f,d){const S=g.URI.revive(f);this.logService.trace("ExtHostSCM#$provideOriginalResource",l,S.toString());const A=this._sourceControls.get(l);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,n.asPromise)(()=>A.quickDiffProvider.provideOriginalResource(S,d)).then(R=>R||null)}$onInputBoxValueChange(l,f){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",l);const d=this._sourceControls.get(l);return d&&d.inputBox.$onInputBoxValueChange(f),Promise.resolve(void 0)}$executeResourceCommand(l,f,d,S){this.logService.trace("ExtHostSCM#$executeResourceCommand",l,f,d);const A=this._sourceControls.get(l);if(!A)return Promise.resolve(void 0);const R=A.getResourceGroup(f);return R?R.$executeResourceCommand(d,S):Promise.resolve(void 0)}$validateInput(l,f,d){this.logService.trace("ExtHostSCM#$validateInput",l);const S=this._sourceControls.get(l);return!S||!S.inputBox.validateInput?Promise.resolve(void 0):(0,n.asPromise)(()=>S.inputBox.validateInput(f,d)).then(A=>{if(!A)return Promise.resolve(void 0);const R=v.MarkdownString.fromStrict(A.message);return R?Promise.resolve([R,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(l){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",l),l!==void 0&&this._sourceControls.get(l)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=l,Promise.resolve(void 0)}};u._handlePool=0,u=Ve([$e(2,P.ILogService)],u),e.ExtHostSCM=u});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[253],me([0,1,7,5,167,6,17,13]),function(Y,e,g,L,y,C,n,k){"use strict";var _,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class P{constructor(h,w,E,T,b=g.StatusBarAlignment.Left,o){_.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new C.DisposableStore,st(this,_,h,"f"),st(this,D,w,"f"),this._entryId=P.ID_GEN++,this._extension=E,this._id=T,this._alignment=b,this._priority=this.validatePriority(o)}validatePriority(h){if(!!(0,k.isNumber)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!P.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){this._command?.fromApi!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Oe(this,D,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Oe(this,D,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let h;this._extension?this._id?h=`${this._extension.identifier.value}.${this._id}`:h=this._extension.identifier.value:h=this._id;let w;this._name?w=this._name:w=(0,y.localize)(0,null,this._extension.displayName||this._extension.name);let E=this._color;this._backgroundColor&&(E=P.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const T=this._tooltip?n.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,_,"f").$setEntry(this._entryId,h,w,this._text,T,this._command?.internal,E,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=P,_=new WeakMap,D=new WeakMap,P.ID_GEN=0,P.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new g.ThemeColor("statusBarItem.warningForeground")]]);class I{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,y.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const w={message:h};return this._messages.unshift(w),this._update(),new g.Disposable(()=>{const E=this._messages.indexOf(w);E>=0&&(this._messages.splice(E,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(h,w){this._proxy=h.getProxy(L.MainContext.MainThreadStatusBar),this._commands=w,this._statusMessage=new I(this)}createStatusBarEntry(h,w,E,T){return new P(this._proxy,this._commands,h,w,E,T)}setStatusBarMessage(h,w){const E=this._statusMessage.setMessage(h);let T;return typeof w=="number"?T=setTimeout(()=>E.dispose(),w):typeof w!="undefined"&&w.then(()=>E.dispose(),()=>E.dispose()),new g.Disposable(()=>{E.dispose(),clearTimeout(T)})}}e.ExtHostStatusBar=c}),define(fe[92],me([0,1,5,3,4]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class C{constructor(k){this._onDidChangeStorage=new L.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,_){this._proxy.$registerExtensionStorageKeysToSync(k,_)}getValue(k,_,D){return this._proxy.$getValue(k,_).then(P=>P||D)}setValue(k,_,D){return this._proxy.$setValue(k,_,D)}$acceptValue(k,_,D){this._onDidChangeStorage.fire({shared:k,key:_,value:D})}}e.ExtHostStorage=C,e.IExtHostStorage=(0,y.createDecorator)("IExtHostStorage")}),define(fe[70],me([0,1,4,26,11,69,2]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,g.createDecorator)("IExtensionStoragePaths");let k=class{constructor(D,P,I){this._logService=P,this._extHostFileSystem=I,this._workspace=D.workspace??void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(D){return n.URI.joinPath(this._environment.workspaceStorageHome,D)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const D=this._workspace.id,P=await this._getWorkspaceStorageURI(D);try{return await this._extHostFileSystem.value.stat(P),this._logService.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",P),await this._extHostFileSystem.value.createDirectory(P),await this._extHostFileSystem.value.writeFile(n.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:n.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),P}catch(I){this._logService.error("[ExtHostStorage]",I);return}}workspaceValue(D){if(this._value)return n.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return n.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};k=Ve([$e(0,L.IExtHostInitDataService),$e(1,y.ILogService),$e(2,C.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(fe[34],me([0,1,3,5,4,2,14,6,7,168,18,217,21,32,197,65,13,16]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,y.createDecorator)("IExtHostTerminalService");class b{constructor(a,l,f,d){this._proxy=a,this._id=l,this._creationOptions=f,this._name=d,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(A=>this._pidPromiseComplete=A);const S=this;this.value={get name(){return S._name||""},get processId(){return S._pidPromise},get creationOptions(){return S._creationOptions},get exitStatus(){return S._exitStatus},get state(){return S._state},sendText(A,R=!0){S._checkDisposed(),S._proxy.$sendText(S._id,A,R)},show(A){S._checkDisposed(),S._proxy.$show(S._id,A)},hide(){S._checkDisposed(),S._proxy.$hide(S._id)},dispose(){S._disposed||(S._disposed=!0,S._proxy.$dispose(S._id))},get dimensions(){if(!(S._cols===void 0||S._rows===void 0))return{columns:S._cols,rows:S._rows}}}}async create(a,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:a.name,shellPath:(0,E.withNullAsUndefined)(a.shellPath),shellArgs:(0,E.withNullAsUndefined)(a.shellArgs),cwd:(0,E.withNullAsUndefined)(a.cwd),env:(0,E.withNullAsUndefined)(a.env),icon:(0,E.withNullAsUndefined)(i(a.iconPath)),color:w.ThemeColor.isThemeColor(a.color)?a.color.id:void 0,initialText:(0,E.withNullAsUndefined)(a.message),strictEnv:(0,E.withNullAsUndefined)(a.strictEnv),hideFromUser:(0,E.withNullAsUndefined)(a.hideFromUser),isFeatureTerminal:(0,E.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,E.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(a.location,l?.resolvedExtHostIdentifier)})}async createExtensionTerminal(a,l,f,d){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:f,color:w.ThemeColor.isThemeColor(d)?d.id:void 0,location:this._serializeParentTerminal(a,l)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(a,l){return typeof a=="object"?"parentTerminal"in a&&a.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in a?{viewColumn:a.viewColumn,preserveFocus:a.preserveFocus}:void 0:a}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(a){this._name=a}setExitCode(a){this._exitStatus=Object.freeze({code:a})}setDimensions(a,l){return a===this._cols&&l===this._rows||a===0||l===0?!1:(this._cols=a,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(a){this._pidPromiseComplete?(this._pidPromiseComplete(a),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==a&&(this._pidPromise=Promise.resolve(a))})}}e.ExtHostTerminal=b;class o{constructor(a){this._pty=a,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new g.Emitter,this._onDidChangeProperty=new g.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(a){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${a}`)}updateProperty(a,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${a}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(a){this._pty.handleInput&&this._pty.handleInput(a)}resize(a,l){this._pty.setDimensions&&this._pty.setDimensions({columns:a,rows:l})}async processBinary(a){}acknowledgeDataEvent(a){}async setUnicodeVersion(a){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(a){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose&&this._pty.onDidClose((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName&&this._pty.onDidChangeName(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(a||void 0),this._pty.setDimensions&&a&&this._pty.setDimensions(a),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=o;let s=1,p=class extends k.Disposable{constructor(a,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new g.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new g.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new g.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new g.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(L.MainContext.MainThreadTerminalService),this._bufferer=new h.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(a),this._register({dispose:()=>{for(const[f,d]of this._terminalProcesses)d.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(a=>a.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(a){return(a?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(a,l){const f=new b(this._proxy,(0,v.generateUuid)(),a,a.name),d=new o(a.pty);return f.createExtensionTerminal(a.location,this._serializeParentTerminal(a,l).resolvedExtHostIdentifier,i(a.iconPath),t(a.color)).then(S=>{const A=this._setupExtHostProcessListeners(S,d);this._terminalProcessDisposables[S]=A}),this._terminals.push(f),f.value}_serializeParentTerminal(a,l){if(l=l||{},a.location&&typeof a.location=="object"&&"parentTerminal"in a.location){const f=a.location.parentTerminal;if(f){const d=this._terminals.find(S=>S.value===f);d&&(l.resolvedExtHostIdentifier=d._id)}}else a.location&&typeof a.location!="object"?l.location=a.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(a,l){if(!this._getTerminalById(a))throw new Error(`Cannot resolve terminal with id ${a} for virtual process`);const d=new o(l),S=this._setupExtHostProcessListeners(a,d);this._terminalProcessDisposables[a]=S}async $acceptActiveTerminalChanged(a){const l=this._activeTerminal;if(a===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const f=this._getTerminalById(a);f&&(this._activeTerminal=f,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(a,l){const f=this._getTerminalById(a);f&&this._onDidWriteTerminalData.fire({terminal:f.value,data:l})}async $acceptTerminalDimensions(a,l,f){const d=this._getTerminalById(a);d&&d.setDimensions(l,f)&&this._onDidChangeTerminalDimensions.fire({terminal:d.value,dimensions:d.value.dimensions})}async $acceptTerminalMaximumDimensions(a,l,f){this._terminalProcesses.get(a)?.resize(l,f)}async $acceptTerminalTitleChange(a,l){const f=this._getTerminalById(a);f&&(f.name=l)}async $acceptTerminalClosed(a,l){const f=this._getTerminalObjectIndexById(this._terminals,a);if(f!==null){const d=this._terminals.splice(f,1)[0];d.setExitCode(l),this._onDidCloseTerminal.fire(d.value)}}$acceptTerminalOpened(a,l,f,d){if(l){const R=this._getTerminalObjectIndexById(this._terminals,l);if(R!==null){this._terminals[R]._id=a,this._onDidOpenTerminal.fire(this.terminals[R]),this._terminals[R].isOpen=!0;return}}const S={name:d.name,shellPath:d.executable,shellArgs:d.args,cwd:typeof d.cwd=="string"?d.cwd:C.URI.revive(d.cwd),env:d.env,hideFromUser:d.hideFromUser},A=new b(this._proxy,a,S,f);this._terminals.push(A),this._onDidOpenTerminal.fire(A.value),A.isOpen=!0}async $acceptTerminalProcessId(a,l){const f=this._getTerminalById(a);f&&f._setProcessId(l)}async $startExtensionTerminal(a,l){const f=this._getTerminalById(a);if(!f)return{message:(0,D.localize)(0,null,a)};f.isOpen||await new Promise(S=>{const A=this.onDidOpenTerminal(async R=>{R===f.value&&(A.dispose(),S())})});const d=this._terminalProcesses.get(a);d?d.startSendingEvents(l):this._extensionTerminalAwaitingStart[a]={initialDimensions:l}}_setupExtHostProcessListeners(a,l){const f=new k.DisposableStore;f.add(l.onProcessReady(S=>this._proxy.$sendProcessReady(a,S.pid,S.cwd))),f.add(l.onDidChangeProperty(S=>this._proxy.$sendProcessProperty(a,S))),this._bufferer.startBuffering(a,l.onProcessData),f.add(l.onProcessExit(S=>this._onProcessExit(a,S))),this._terminalProcesses.set(a,l);const d=this._extensionTerminalAwaitingStart[a];return d&&l instanceof o&&(l.startSendingEvents(d.initialDimensions),delete this._extensionTerminalAwaitingStart[a]),f}$acceptProcessAckDataEvent(a,l){this._terminalProcesses.get(a)?.acknowledgeDataEvent(l)}$acceptProcessInput(a,l){this._terminalProcesses.get(a)?.input(l)}$acceptTerminalInteraction(a){const l=this._getTerminalById(a);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(a,l,f){try{this._terminalProcesses.get(a)?.resize(l,f)}catch(d){if(d.code!=="EPIPE"&&d.code!=="ERR_IPC_CHANNEL_CLOSED")throw d}}$acceptProcessShutdown(a,l){this._terminalProcesses.get(a)?.shutdown(l)}$acceptProcessRequestInitialCwd(a){this._terminalProcesses.get(a)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(a,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(a){this._terminalProcesses.get(a)?.getCwd().then(l=>this._proxy.$sendProcessProperty(a,{type:"cwd",value:l}))}$acceptProcessRequestLatency(a){return a}registerLinkProvider(a){return this._linkProviders.add(a),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(a),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(a,l,f){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,f),this._proxy.$registerProfileProvider(l,a.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(a,l){const f=new c.CancellationTokenSource().token;let d=await this._profileProviders.get(a)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(d&&!("options"in d)&&(d={options:d}),!d||!("options"in d))throw new Error(`No terminal profile options provided for id "${a}"`);if("pty"in d.options){this.createExtensionTerminal(d.options,l);return}this.createTerminalFromOptions(d.options,l)}}async $provideLinks(a,l){const f=this._getTerminalById(a);if(!f)return[];this._terminalLinkCache.delete(a);const d=this._terminalLinkCancellationSource.get(a);d&&d.dispose(!0);const S=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(a,S);const A=[],R={terminal:f.value,line:l},B=[];for(const $ of this._linkProviders)B.push(T.Promises.withAsyncBody(async M=>{S.token.onCancellationRequested(()=>M({provider:$,links:[]}));const H=await $.provideTerminalLinks(R,S.token)||[];S.token.isCancellationRequested||M({provider:$,links:H})}));const x=await Promise.all(B);if(S.token.isCancellationRequested)return[];const F=new Map;for(const $ of x)$&&$.links.length>0&&A.push(...$.links.map(M=>{const H={id:s++,startIndex:M.startIndex,length:M.length,label:M.tooltip};return F.set(H.id,{provider:$.provider,link:M}),H}));return this._terminalLinkCache.set(a,F),A}$activateLink(a,l){const f=this._terminalLinkCache.get(a)?.get(l);!f||f.provider.handleTerminalLink(f.link)}_onProcessExit(a,l){this._bufferer.stopBuffering(a),this._terminalProcesses.delete(a),delete this._extensionTerminalAwaitingStart[a];const f=this._terminalProcessDisposables[a];f&&(f.dispose(),delete this._terminalProcessDisposables[a]),this._proxy.$sendProcessExit(a,l)}_getTerminalById(a){return this._getTerminalObjectById(this._terminals,a)}_getTerminalObjectById(a,l){const f=this._getTerminalObjectIndexById(a,l);return f!==null?a[f]:null}_getTerminalObjectIndexById(a,l){let f=null;return a.some((d,S)=>d._id===l?(f=S,!0):!1),f}getEnvironmentVariableCollection(a){let l=this._environmentVariableCollections.get(a.identifier.value);return l||(l=new r,this._setEnvironmentVariableCollection(a.identifier.value,l)),l}_syncEnvironmentVariableCollection(a,l){const f=(0,I.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(a,l.persistent,f.length===0?void 0:f)}$initEnvironmentVariableCollections(a){a.forEach(l=>{const f=l[0],d=new r(l[1]);this._setEnvironmentVariableCollection(f,d)})}$acceptDefaultProfile(a,l){this._defaultProfile=a,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(a,l){this._environmentVariableCollections.set(a,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(a,l)})}};p=Ve([$e(1,n.IExtHostRpcService)],p),e.BaseExtHostTerminalService=p;class r{constructor(a){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(a)}get persistent(){return this._persistent}set persistent(a){this._persistent=a,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(a,l){this._setIfDiffers(a,{value:l,type:_.EnvironmentVariableMutatorType.Replace})}append(a,l){this._setIfDiffers(a,{value:l,type:_.EnvironmentVariableMutatorType.Append})}prepend(a,l){this._setIfDiffers(a,{value:l,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(a,l){const f=this.map.get(a);(!f||f.value!==l.value||f.type!==l.type)&&(this.map.set(a,l),this._onDidChangeCollection.fire())}get(a){return this.map.get(a)}forEach(a,l){this.map.forEach((f,d)=>a.call(l,d,f,this))}delete(a){this.map.delete(a),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=r;let m=class extends p{constructor(a){super(!1,a)}createTerminal(a,l,f){throw new P.NotSupportedError}createTerminalFromOptions(a,l){throw new P.NotSupportedError}};m=Ve([$e(0,n.IExtHostRpcService)],m),e.WorkerExtHostTerminalService=m;function i(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function t(u){return w.ThemeColor.isThemeColor(u)?u:void 0}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[254],me([0,1,15,22,21,3,76,49,6,25,13,32,5,14,66,17,7,225,127,90]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b,o){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let p=class{constructor(R,B){this.resultsChangedEmitter=new C.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(c.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new m(this.proxy),B.registerArgumentProcessor({processArgument:x=>x?.$mid===13?w.TestItem.toItemFromContext(x):x})}createTestController(R,B){if(this.controllers.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const x=new _.DisposableStore,F=x.add(new T.SingleUseTestCollection(R));F.root.label=B;const $=new Map,M=this.proxy,H={items:F.root.children,get label(){return B},set label(U){B=U,F.root.label=U,M.$updateControllerLabel(R,B)},get id(){return R},createRunProfile:(U,V,O,W,j)=>{let X=(0,k.hash)(U);for(;$.has(X);)X++;const Q=new d(this.proxy,R,X,U,V,O,W,j);return $.set(X,Q),Q},createTestItem(U,V,O){return new h.TestItemImpl(R,U,V,O)},createTestRun:(U,V,O=!0)=>this.runTracker.createTestRun(R,F,U,V,O),set resolveHandler(U){F.resolveHandler=U},get resolveHandler(){return F.resolveHandler},dispose:()=>{x.dispose()}};H.createRunConfiguration=H.createRunProfile,M.$registerTestController(R,B),x.add((0,_.toDisposable)(()=>M.$unregisterTestController(R)));const N={controller:H,collection:F,profiles:$};return this.controllers.set(R,N),x.add((0,_.toDisposable)(()=>this.controllers.delete(R))),x.add(F.onDidGenerateDiff(U=>M.$publishDiff(R,U))),H}createTestObserver(){return this.observer.checkout()}async runTests(R,B=y.CancellationToken.None){const x=i(R);if(!x)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.controllers.get(x.controllerId);if(!F)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:R.include?.map($=>$.id)??[F.collection.root.id],profileGroup:S[x.kind],profileId:x.profileId,controllerId:x.controllerId}],exclude:R.exclude?.map($=>$.id)},B)}$provideFileCoverage(R,B,x){return(0,g.mapFind)(this.runTracker.trackers,$=>$.id===R?$.getCoverage(B):void 0)?.provideFileCoverage(x)??Promise.resolve([])}$resolveFileCoverage(R,B,x,F){return(0,g.mapFind)(this.runTracker.trackers,M=>M.id===R?M.getCoverage(B):void 0)?.resolveFileCoverage(x,F)??Promise.resolve([])}$configureRunProfile(R,B){this.controllers.get(R)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(R){this.results=Object.freeze(R.map(B=>(0,D.deepFreeze)(w.TestResults.to(B))).concat(this.results).sort((B,x)=>x.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(R,B){const x=this.controllers.get(o.TestId.fromString(R).controllerId)?.collection;x&&(await x.expand(R,B<0?Infinity:B),x.flushDiff())}$acceptDiff(R){this.observer.applyDiff(R)}async $runControllerTests(R,B){const x=this.controllers.get(R.controllerId);if(!x)return;const{collection:F,profiles:$}=x,M=$.get(R.profileId);if(!M)return;const H=R.testIds.map(O=>F.tree.get(O)).filter(P.isDefined),N=R.excludeExtIds.map(O=>x.collection.tree.get(O)).filter(P.isDefined).filter(O=>H.some(W=>W.fullId.compare(O.fullId)===2));if(!H.length)return;const U=new E.TestRunRequest(H.some(O=>O.actual instanceof h.TestItemRootImpl)?void 0:H.map(O=>O.actual),N.map(O=>O.actual),M),V=this.runTracker.prepareForMainThreadTestRun(U,t.fromInternal(R,x.collection),B);try{await M.runHandler(U,B)}finally{V.isRunning&&!B.isCancellationRequested&&await C.Event.toPromise(V.onEnd),V.dispose()}}$cancelExtensionTestRun(R){R===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(R)}};p=Ve([$e(0,v.IExtHostRpcService)],p),e.ExtHostTesting=p;class r extends _.Disposable{constructor(R,B,x){super();this.dto=R,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new C.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new y.CancellationTokenSource(x)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:F}of this.tasks.values())F.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(R){return this.tasks.get(R)?.coverage}createRun(R){const B=this.dto.id,x=this.dto.controllerId,F=(0,I.generateUuid)(),$=new u(this.proxy,B,F),M=V=>(O,...W)=>{if(N){console.warn(`Setting the state of test "${O.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(O)||(this.ensureTestIsKnown(O),V(O,...W))},H=(V,O)=>{const W=O instanceof Array?O.map(w.TestMessage.from):[w.TestMessage.from(O)];if(V.uri&&V.range){const j={range:w.Range.from(V.range),uri:V.uri};for(const X of W)X.location=X.location||j}this.proxy.$appendTestMessagesInRun(B,F,o.TestId.fromExtHostTestItem(V,x).toString(),W)};let N=!1;const U={isPersisted:this.dto.isPersisted,token:this.cts.token,name:R,get coverageProvider(){return $.coverageProvider},set coverageProvider(V){$.coverageProvider=V},enqueued:M(V=>{this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(V,x).toString(),1)}),skipped:M(V=>{this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(V,x).toString(),5)}),started:M(V=>{this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(V,x).toString(),2)}),errored:M((V,O,W)=>{H(V,O),this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(V,x).toString(),6,W)}),failed:M((V,O,W)=>{H(V,O),this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(V,x).toString(),4,W)}),passed:M((V,O)=>{this.proxy.$updateTestStateInRun(B,F,o.TestId.fromExtHostTestItem(V,this.dto.controllerId).toString(),3,O)}),appendOutput:(V,O,W)=>{N||(W&&(this.dto.isIncluded(W)?this.ensureTestIsKnown(W):W=void 0),this.proxy.$appendOutputToRun(B,F,L.VSBuffer.fromString(V),O&&w.location.from(O),W&&o.TestId.fromExtHostTestItem(W,x).toString()))},end:()=>{N||(N=!0,this.proxy.$finishedTestRunTask(B,F),this.tasks.delete(F),this.isRunning||this.dispose())}};return this.tasks.set(F,{run:U,coverage:$}),this.proxy.$startedTestRunTask(B,{id:F,name:R,running:!0}),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(R){if(!(R instanceof h.TestItemImpl))throw new h.InvalidTestItemError(R.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(R,this.dto.controllerId).toString()))return;const B=[],x=this.dto.colllection.root;for(;;){const F=w.TestItem.from(R);if(B.unshift(F),this.sharedTestIds.has(F.extId)||(this.sharedTestIds.add(F.extId),R===x))break;R=R.parent||x}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class m{constructor(R){this.proxy=R,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(R,B,x){return this.getTracker(R,B,x)}cancelRunById(R){for(const B of this.tracked.values())if(B.id===R){B.dispose();return}}cancelAllRuns(){for(const R of this.tracked.values())R.dispose()}createTestRun(R,B,x,F,$){const M=this.tracked.get(x);if(M)return M.createRun(F);const H=t.fromPublic(R,B,x,$),N=i(x);this.proxy.$startedExtensionTestRun({controllerId:R,profile:N&&{group:S[N.kind],id:N.profileId},exclude:x.exclude?.map(V=>V.id)??[],id:H.id,include:x.include?.map(V=>V.id)??[B.root.id],persist:$});const U=this.getTracker(x,H);return U.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),U.createRun(F)}getTracker(R,B,x){const F=new r(B,this.proxy,x);return this.tracked.set(R,F),F.onEnd(()=>this.tracked.delete(R)),F}}e.TestRunCoordinator=m;const i=A=>{if(!!A.profile){if(!(A.profile instanceof d))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return A.profile}};class t{constructor(R,B,x,F,$,M){this.controllerId=R,this.id=B,this.isPersisted=$,this.colllection=M,this.includePrefix=x.map(H=>H+"\0"),this.excludePrefix=F.map(H=>H+"\0")}static fromPublic(R,B,x,F){return new t(R,(0,I.generateUuid)(),x.include?.map($=>o.TestId.fromExtHostTestItem($,R).toString())??[R],x.exclude?.map($=>o.TestId.fromExtHostTestItem($,R).toString())??[],F,B)}static fromInternal(R,B){return new t(R.controllerId,R.runId,R.testIds,R.excludeExtIds,!0,B)}isIncluded(R){const B=o.TestId.fromExtHostTestItem(R,this.controllerId).toString()+"\0";for(const x of this.excludePrefix)if(B===x||B.startsWith(x))return!1;for(const x of this.includePrefix)if(B===x||B.startsWith(x))return!0;return!1}}e.TestRunDto=t;class u{constructor(R,B,x){this.proxy=R,this.runId=B,this.taskId=x}set coverageProvider(R){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!R||(this._coverageProvider=R,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(R){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(R))());try{return(await this.fileCoverage)?.map(w.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(R,B){const x=await this.fileCoverage;let F=x?.[R];return!this._coverageProvider||!x||!F?[]:(F.detailedCoverage||(F=x[R]=await this._coverageProvider.resolveFileCoverage?.(F,B)??F),F.detailedCoverage?.map(w.TestCoverage.fromDetailed)??[])}}class a extends b.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,w.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:B,removed:x}=this;return{get added(){return[...R].map(F=>F.revived)},get updated(){return[...B].map(F=>F.revived)},get removed(){return[...x].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class l extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new C.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,B){return{...R,revived:w.TestItem.toPlain(R.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new a(this.changeEmitter)}}e.MirroredTestCollection=l;class f{constructor(R){this.proxy=R}checkout(){this.current||(this.current=this.createObserverData());const R=this.current;return R.observers++,{onDidChangeTest:R.tests.onDidChangeTests,get tests(){return[...R.tests.rootTests].map(B=>B.revived)},dispose:(0,n.once)(()=>{--R.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(R){return this.current?.tests.getMirroredTestDataByReference(R)}applyDiff(R){this.current?.tests.apply(R)}createObserverData(){const R=new l;return this.proxy.$subscribeToDiffs(),{observers:0,tests:R}}}class d{constructor(R,B,x,F,$,M,H=!1,N=void 0){this.controllerId=B,this.profileId=x,this._label=F,this.kind=$,this.runHandler=M,this._isDefault=H,this._tag=N,s.set(this,void 0),st(this,s,R,"f");const U=S[$];if(typeof U!="number")throw new Error(`Unknown TestRunProfile.group ${$}`);Oe(this,s,"f").$publishTestRunProfile({profileId:x,controllerId:B,tag:N?w.TestTag.namespace(this.controllerId,N.id):null,label:F,group:U,isDefault:H,hasConfigurationHandler:!1})}get label(){return this._label}set label(R){R!==this._label&&(this._label=R,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:R}))}get isDefault(){return this._isDefault}set isDefault(R){R!==this._isDefault&&(this._isDefault=R,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:R}))}get tag(){return this._tag}set tag(R){R?.id!==this._tag?.id&&(this._tag=R,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:R?w.TestTag.namespace(this.controllerId,R.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(R){R!==this._configureHandler&&(this._configureHandler=R,Oe(this,s,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!R}))}dispose(){Oe(this,s,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=d,s=new WeakMap;const S={[E.TestRunProfileKind.Coverage]:8,[E.TestRunProfileKind.Debug]:4,[E.TestRunProfileKind.Run]:2}}),define(fe[255],me([0,1,3,15,5,130,17,7]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(P,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=P.getProxy(y.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(P){const I=this._extHostDocumentsAndEditors.allEditors();return P?I:I.map(c=>c.value)}async showTextDocument(P,I,c){let v;typeof I=="number"?v={position:n.ViewColumn.from(I),preserveFocus:c}:typeof I=="object"?v={position:n.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?n.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:v={preserveFocus:!1};const h=await this._proxy.$tryShowTextDocument(P.uri,v),w=h&&this._extHostDocumentsAndEditors.getEditor(h);if(w)return w.value;throw h?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,I){return new C.TextEditorDecorationType(this._proxy,P,I).value}$acceptEditorPropertiesChanged(P,I){const c=this._extHostDocumentsAndEditors.getEditor(P);if(!c)throw new Error("unknown text editor");if(I.options&&c._acceptOptions(I.options),I.selections){const v=I.selections.selections.map(n.Selection.to);c._acceptSelections(v)}if(I.visibleRanges){const v=L.coalesce(I.visibleRanges.map(n.Range.to));c._acceptVisibleRanges(v)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...I.options,lineNumbers:n.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const v=k.TextEditorSelectionChangeKind.fromValue(I.selections.source),h=I.selections.selections.map(n.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:h,kind:v})}if(I.visibleRanges){const v=L.coalesce(I.visibleRanges.map(n.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:v})}}$acceptEditorPositionData(P){for(const I in P){const c=this._extHostDocumentsAndEditors.getEditor(I);if(!c)throw new Error("Unknown text editor");const v=n.ViewColumn.to(P[I]);c.value.viewColumn!==v&&(c._acceptViewColumn(v),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:v}))}}getDiffInformation(P){return Promise.resolve(this._proxy.$getDiffInformation(P))}}e.ExtHostEditors=_}),define(fe[256],me([0,1,2,4,5,6,7]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class k{constructor(P,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=P.getProxy(y.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===11){const v=c.uri===void 0?void 0:g.URI.revive(c.uri);return this._itemsBySourceAndUriMap.get(c.source)?.get(_(v))?.get(c.handle)}return c}})}async $getTimeline(P,I,c,v,h){return this._providers.get(P)?.provideTimeline(g.URI.revive(I),c,v,h)}registerTimelineProvider(P,I,c,v){const h=new C.DisposableStore,w=this.convertTimelineItem(I.id,v,h).bind(this);let E;I.onDidChange&&(E=I.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:I.id}),this));const T=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:P,onDidChange:void 0,async provideTimeline(b,o,s,p){p?.resetCache&&(h.clear(),T.get(I.id)?.clear());const r=await I.provideTimeline(b,o,s);if(r==null)return;const m=w(b,p);return{...r,source:I.id,items:r.items.map(m)}},dispose(){for(const b of T.values())b.get(I.id)?.clear();E?.dispose(),h.dispose()}})}convertTimelineItem(P,I,c){return(v,h)=>{let w;if(h?.cacheResults){let E=this._itemsBySourceAndUriMap.get(P);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(P,E));const T=_(v);w=E.get(T),w===void 0&&(w=new Map,E.set(T,w))}return E=>{const{iconPath:T,...b}=E,o=`${P}|${E.id??E.timestamp}`;w?.set(o,E);let s,p,r;return E.iconPath&&(T instanceof n.ThemeIcon?r={id:T.id,color:T.color}:g.URI.isUri(T)?(s=T,p=T):{light:s,dark:p}=T),{...b,id:b.id??void 0,handle:o,source:P,command:E.command?I.toInternal(E.command,c):void 0,icon:s,iconDark:p,themeIcon:r,accessibilityInformation:E.accessibilityInformation}}}}registerTimelineProviderCore(P){if(this._providers.get(P.id))throw new Error(`Timeline Provider ${P.id} already exists.`);return this._proxy.$registerTimelineProvider({id:P.id,label:P.label,scheme:P.scheme}),this._providers.set(P.id,P),(0,C.toDisposable)(()=>{for(const c of this._itemsBySourceAndUriMap.values())c.get(P.id)?.clear();this._providers.delete(P.id),this._proxy.$unregisterTimelineProvider(P.id),P.dispose()})}}e.ExtHostTimeline=k;function _(D){return D?.toString()}}),define(fe[257],me([0,1,6,10,2,5]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class n{constructor(_){this._openers=new Map,this._proxy=_.getProxy(C.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,D,P,I){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const c=I.schemes.find(v=>!n.supportedSchemes.has(v));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,P),this._proxy.$registerUriOpener(D,I.schemes,_,I.label),(0,g.toDisposable)(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(_,D,P){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const c=y.URI.revive(D);return I.canOpenExternalUri(c,P)}async $openUri(_,D,P){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(y.URI.revive(D.resolvedUri),{sourceUri:y.URI.revive(D.sourceUri)},P)}}e.ExtHostUriOpeners=n,n.supportedSchemes=new Set([L.Schemas.http,L.Schemas.https])}),define(fe[258],me([0,1,5,2,6,18,27]),function(Y,e,g,L,y,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(D,P){if(this.handles.has(n.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const I=k.HandlePool++;return this.handles.add(n.ExtensionIdentifier.toKey(D)),this.handlers.set(I,P),this._proxy.$registerUriHandler(I,D),(0,y.toDisposable)(()=>{this.handles.delete(n.ExtensionIdentifier.toKey(D)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(D,P){const I=this.handlers.get(D);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(P))}catch(c){(0,C.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(D){return L.URI.revive(await this._proxy.$createAppUri(D))}}e.ExtHostUrls=k,k.HandlePool=0});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[71],me([0,1,3,10,2,181,206,89,5]),function(Y,e,g,L,y,C,n,k,_){"use strict";var D,P,I,c,v,h,w,E,T,b,o,s;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class p{constructor(f,d,S,A,R,B,x){D.set(this,void 0),P.set(this,void 0),I.set(this,void 0),c.set(this,void 0),v.set(this,void 0),h.set(this,void 0),w.set(this,""),E.set(this,void 0),T.set(this,!1),b.set(this,!1),o.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,s.set(this,new g.Emitter),this._onDidDispose=Oe(this,s,"f").event,st(this,D,f,"f"),st(this,P,d,"f"),st(this,E,S,"f"),st(this,c,A,"f"),st(this,v,R,"f"),st(this,h,B,"f"),st(this,o,r(B),"f"),st(this,I,x,"f")}dispose(){st(this,T,!0,"f"),Oe(this,s,"f").fire(),Oe(this,s,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return st(this,b,!0,"f"),(0,k.asWebviewUri)(f,Oe(this,c,"f").remote)}get cspSource(){const f=Oe(this,h,"f").extensionLocation;if(f.scheme===L.Schemas.https||f.scheme===L.Schemas.http){let d=f.toString();return d.endsWith("/")||(d+="/"),d+" "+k.webviewGenericCspSource}return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,w,"f")}set html(f){this.assertNotDisposed(),Oe(this,w,"f")!==f&&(st(this,w,f,"f"),!Oe(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(st(this,b,!0,"f"),Oe(this,I,"f").report("Webview vscode-resource: uris",Oe(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,P,"f").$setHtml(Oe(this,D,"f"),f))}get options(){return this.assertNotDisposed(),Oe(this,E,"f")}set options(f){this.assertNotDisposed(),Oe(this,P,"f").$setOptions(Oe(this,D,"f"),t(Oe(this,h,"f"),Oe(this,v,"f"),f)),st(this,E,f,"f")}async postMessage(f){if(Oe(this,T,"f"))return!1;const d=(0,n.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:Oe(this,o,"f")});return Oe(this,P,"f").$postMessage(Oe(this,D,"f"),d.message,...d.buffers)}assertNotDisposed(){if(Oe(this,T,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=p,D=new WeakMap,P=new WeakMap,I=new WeakMap,c=new WeakMap,v=new WeakMap,h=new WeakMap,w=new WeakMap,E=new WeakMap,T=new WeakMap,b=new WeakMap,o=new WeakMap,s=new WeakMap;function r(l){try{const f=(0,C.normalizeVersion)((0,C.parseVersion)(l.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;class m{constructor(f,d,S,A,R){this.initData=d,this.workspace=S,this._logService=A,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=f.getProxy(_.MainContext.MainThreadWebviews)}$onMessage(f,d,...S){const A=this.getWebview(f);if(A){const{message:R}=(0,n.deserializeWebviewMessage)(d,S);A._onMessageEmitter.fire(R)}}$onMissingCsp(f,d){this._logService.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,d,S){const A=new p(f,this._webviewProxy,u(d),this.initData,this.workspace,S,this._deprecationService);return this._webviews.set(f,A),A._onDidDispose(()=>{this._webviews.delete(f)}),A}deleteWebview(f){this._webviews.delete(f)}getWebview(f){return this._webviews.get(f)}}e.ExtHostWebviews=m;function i(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=i;function t(l,f,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||a(l,f)}}e.serializeWebviewOptions=t;function u(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(f=>y.URI.from(f))}}e.reviveOptions=u;function a(l,f){return[...(f?.getWorkspaceFolders()||[]).map(d=>d.uri),l.extensionLocation]}}),define(fe[259],me([0,1,21,49,6,10,23,2,17,71,88,5,7]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class v{constructor(r,m){this.document=r,this._storagePath=m,this._backupCounter=1,this._edits=new P.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,m){await this.getEdit(r).undo(),m||this.disposeBackup()}async redo(r,m){await this.getEdit(r).redo(),m||this.disposeBackup()}disposeEdits(r){for(const m of r)this._edits.delete(m)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=s(this.document.uri)+this._backupCounter++;return(0,n.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const m=this._edits.get(r,0);if(!m)throw new Error("No edit found");return m}}class h{constructor(){this._documents=new Map}get(r,m){return this._documents.get(this.key(r,m))}add(r,m,i){const t=this.key(r,m.uri);if(this._documents.has(t))throw new Error(`Document already exists for viewType:${r} resource:${m.uri}`);const u=new v(m,i);return this._documents.set(t,u),u}delete(r,m){const i=this.key(r,m.uri);this._documents.delete(i)}key(r,m){return`${r}@@@${m}`}}var w;(function(p){p[p.Text=0]="Text",p[p.Custom=1]="Custom"})(w||(w={}));class E{constructor(){this._providers=new Map}addTextProvider(r,m,i){return this.add(0,r,m,i)}addCustomProvider(r,m,i){return this.add(1,r,m,i)}get(r){return this._providers.get(r)}add(r,m,i,t){if(this._providers.has(m))throw new Error(`Provider for viewType:${m} already registered`);return this._providers.set(m,{type:r,extension:i,provider:t}),new c.Disposable(()=>this._providers.delete(m))}}class T{constructor(r,m,i,t,u){this._extHostDocuments=m,this._extensionStoragePaths=i,this._extHostWebview=t,this._extHostWebviewPanels=u,this._editorProviders=new E,this._documents=new h,this._proxy=r.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,m,i,t){const u=new y.DisposableStore;return b(i)?(u.add(this._editorProviders.addTextProvider(m,r,i)),this._proxy.$registerTextEditorProvider((0,D.toExtensionData)(r),m,t.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor},(0,D.shouldSerializeBuffersForPostMessage)(r))):(u.add(this._editorProviders.addCustomProvider(m,r,i)),this.supportEditing(i)&&u.add(i.onDidChangeCustomDocument(a=>{const l=this.getCustomDocumentEntry(m,a.document.uri);if(o(a)){const f=l.addEdit(a);this._proxy.$onDidEdit(a.document.uri,m,f,a.label)}else this._proxy.$onContentChange(a.document.uri,m)})),this._proxy.$registerCustomEditorProvider((0,D.toExtensionData)(r),m,t.webviewOptions||{},!!t.supportsMultipleEditorsPerDocument,(0,D.shouldSerializeBuffersForPostMessage)(r))),c.Disposable.from(u,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(m)}))}async $createCustomDocument(r,m,i,t,u){const a=this._editorProviders.get(m);if(!a)throw new Error(`No provider found for '${m}'`);if(a.type!==1)throw new Error(`Invalid provide type for '${m}'`);const l=k.URI.revive(r),f=await a.provider.openCustomDocument(l,{backupId:i,untitledDocumentData:t?.buffer},u);let d;return this.supportEditing(a.provider)&&this._extensionStoragePaths&&(d=this._extensionStoragePaths.workspaceValue(a.extension)??this._extensionStoragePaths.globalValue(a.extension)),this._documents.add(m,f,d),{editable:this.supportEditing(a.provider)}}async $disposeCustomDocument(r,m){const i=this._editorProviders.get(m);if(!i)throw new Error(`No provider found for '${m}'`);if(i.type!==1)throw new Error(`Invalid provider type for '${m}'`);const t=k.URI.revive(r),{document:u}=this.getCustomDocumentEntry(m,t);this._documents.delete(m,u),u.dispose()}async $resolveWebviewEditor(r,m,i,t,u,a){const l=this._editorProviders.get(i);if(!l)throw new Error(`No provider found for '${i}'`);const f=_.ViewColumn.to(u),d=this._extHostWebview.createNewWebview(m,t.webviewOptions,l.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(m,i,t.title,f,t.panelOptions,d),A=k.URI.revive(r);switch(l.type){case 1:{const{document:R}=this.getCustomDocumentEntry(i,A);return l.provider.resolveCustomEditor(R,S,a)}case 0:{const R=this._extHostDocuments.getDocument(A);return l.provider.resolveCustomTextEditor(R,S,a)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,m,i){this.getCustomDocumentEntry(m,r).disposeEdits(i)}async $onMoveCustomEditor(r,m,i){const t=this._editorProviders.get(i);if(!t)throw new Error(`No provider found for '${i}'`);if(!t.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${i}'`);const u=this._extHostWebviewPanels.getWebviewPanel(r);if(!u)throw new Error("No webview found");const a=k.URI.revive(m),l=this._extHostDocuments.getDocument(a);await t.provider.moveCustomTextEditor(l,u,g.CancellationToken.None)}async $undo(r,m,i,t){return this.getCustomDocumentEntry(m,r).undo(i,t)}async $redo(r,m,i,t){return this.getCustomDocumentEntry(m,r).redo(i,t)}async $revert(r,m,i){const t=this.getCustomDocumentEntry(m,r);await this.getCustomEditorProvider(m).revertCustomDocument(t.document,i),t.disposeBackup()}async $onSave(r,m,i){const t=this.getCustomDocumentEntry(m,r);await this.getCustomEditorProvider(m).saveCustomDocument(t.document,i),t.disposeBackup()}async $onSaveAs(r,m,i,t){const u=this.getCustomDocumentEntry(m,r);return this.getCustomEditorProvider(m).saveCustomDocumentAs(u.document,k.URI.revive(i),t)}async $backup(r,m,i){const t=this.getCustomDocumentEntry(m,r),a=await this.getCustomEditorProvider(m).backupCustomDocument(t.document,{destination:t.getNewBackupUri()},i);return t.updateBackup(a),a.id}getCustomDocumentEntry(r,m){const i=this._documents.get(r,k.URI.revive(m));if(!i)throw new Error("No custom document found");return i}getCustomEditorProvider(r){const i=this._editorProviders.get(r)?.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(r){return!!r.onDidChangeCustomDocument}}e.ExtHostCustomEditors=T;function b(p){return typeof p.resolveCustomTextEditor=="function"}function o(p){return typeof p.undo=="function"&&typeof p.redo=="function"}function s(p){const r=p.scheme===C.Schemas.file||p.scheme===C.Schemas.untitled?p.fsPath:p.toString();return(0,L.hash)(r)+""}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[260],me([0,1,3,6,2,32,17,71,5,7]),function(Y,e,g,L,y,C,n,k,_,D){"use strict";var P,I,c,v,h,w,E,T,b,o,s,p,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class m extends L.Disposable{constructor(a,l,f,d,S,A,R){super();P.set(this,void 0),I.set(this,void 0),c.set(this,void 0),v.set(this,void 0),h.set(this,void 0),w.set(this,void 0),E.set(this,void 0),T.set(this,void 0),b.set(this,!0),o.set(this,!0),s.set(this,!1),p.set(this,this._register(new g.Emitter)),this.onDidDispose=Oe(this,p,"f").event,r.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Oe(this,r,"f").event,st(this,P,a,"f"),st(this,I,l,"f"),st(this,c,f,"f"),st(this,h,A,"f"),st(this,T,S,"f"),st(this,w,d,"f"),st(this,v,R,"f")}dispose(){Oe(this,s,"f")||(st(this,s,!0,"f"),Oe(this,p,"f").fire(),Oe(this,I,"f").$disposeWebview(Oe(this,P,"f")),Oe(this,v,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,v,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,c,"f")}get title(){return this.assertNotDisposed(),Oe(this,w,"f")}set title(a){this.assertNotDisposed(),Oe(this,w,"f")!==a&&(st(this,w,a,"f"),Oe(this,I,"f").$setTitle(Oe(this,P,"f"),a))}get iconPath(){return this.assertNotDisposed(),Oe(this,E,"f")}set iconPath(a){this.assertNotDisposed(),Oe(this,E,"f")!==a&&(st(this,E,a,"f"),Oe(this,I,"f").$setIconPath(Oe(this,P,"f"),y.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Oe(this,h,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,T,"f")=="number"&&Oe(this,T,"f")<0))return Oe(this,T,"f")}get active(){return this.assertNotDisposed(),Oe(this,o,"f")}get visible(){return this.assertNotDisposed(),Oe(this,b,"f")}_updateViewState(a){Oe(this,s,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(st(this,o,a.active,"f"),st(this,b,a.visible,"f"),st(this,T,a.viewColumn,"f"),Oe(this,r,"f").fire({webviewPanel:this}))}reveal(a,l){this.assertNotDisposed(),Oe(this,I,"f").$reveal(Oe(this,P,"f"),{viewColumn:a?n.ViewColumn.from(a):void 0,preserveFocus:!!l})}assertNotDisposed(){if(Oe(this,s,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,I=new WeakMap,c=new WeakMap,v=new WeakMap,h=new WeakMap,w=new WeakMap,E=new WeakMap,T=new WeakMap,b=new WeakMap,o=new WeakMap,s=new WeakMap,p=new WeakMap,r=new WeakMap;class i{constructor(a,l,f){this.webviews=l,this.workspace=f,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=a.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,C.generateUuid)()}createWebviewPanel(a,l,f,d,S={}){const A=typeof d=="object"?d.viewColumn:d,R={viewColumn:n.ViewColumn.from(A),preserveFocus:typeof d=="object"&&!!d.preserveFocus},B=(0,k.shouldSerializeBuffersForPostMessage)(a),x=i.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(a),x,l,{title:f,panelOptions:t(S),webviewOptions:(0,k.serializeWebviewOptions)(a,this.workspace,S),serializeBuffersForPostMessage:B},R);const F=this.webviews.createNewWebview(x,S,a);return this.createNewWebviewPanel(x,l,f,A,S,F)}$onDidChangeWebviewPanelViewStates(a){const l=Object.keys(a);l.sort((f,d)=>{const S=a[f],A=a[d];return S.active?1:A.active?-1:+S.visible-+A.visible});for(const f of l){const d=this.getWebviewPanel(f);if(!d)continue;const S=a[f];d._updateViewState({active:S.active,visible:S.visible,viewColumn:n.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this._webviewPanels.delete(a),this.webviews.deleteWebview(a)}registerWebviewPanelSerializer(a,l,f){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:f,extension:a}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(a)}),new D.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(a,l,f,d){const S=this._serializers.get(l);if(!S)throw new Error(`No serializer found for '${l}'`);const{serializer:A,extension:R}=S,B=this.webviews.createNewWebview(a,f.webviewOptions,R),x=this.createNewWebviewPanel(a,l,f.title,d,f.panelOptions,B);await A.deserializeWebviewPanel(x,f.state)}createNewWebviewPanel(a,l,f,d,S,A){const R=new m(a,this._proxy,l,f,d,S,A);return this._webviewPanels.set(a,R),R}getWebviewPanel(a){return this._webviewPanels.get(a)}}e.ExtHostWebviewPanels=i;function t(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[261],me([0,1,3,6,71,5,7]),function(Y,e,g,L,y,C,n){"use strict";var k,_,D,P,I,c,v,h,w,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class T extends L.Disposable{constructor(s,p,r,m,i,t){super();k.set(this,void 0),_.set(this,void 0),D.set(this,void 0),P.set(this,void 0),I.set(this,!1),c.set(this,void 0),v.set(this,void 0),h.set(this,void 0),w.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Oe(this,w,"f").event,E.set(this,this._register(new g.Emitter)),this.onDidDispose=Oe(this,E,"f").event,st(this,D,r,"f"),st(this,v,m,"f"),st(this,k,s,"f"),st(this,_,p,"f"),st(this,P,i,"f"),st(this,c,t,"f")}dispose(){Oe(this,I,"f")||(st(this,I,!0,"f"),Oe(this,E,"f").fire(),Oe(this,P,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,v,"f")}set title(s){this.assertNotDisposed(),Oe(this,v,"f")!==s&&(st(this,v,s,"f"),Oe(this,_,"f").$setWebviewViewTitle(Oe(this,k,"f"),s))}get description(){return this.assertNotDisposed(),Oe(this,h,"f")}set description(s){this.assertNotDisposed(),Oe(this,h,"f")!==s&&(st(this,h,s,"f"),Oe(this,_,"f").$setWebviewViewDescription(Oe(this,k,"f"),s))}get visible(){return Oe(this,c,"f")}get webview(){return Oe(this,P,"f")}get viewType(){return Oe(this,D,"f")}_setVisible(s){s===Oe(this,c,"f")||Oe(this,I,"f")||(st(this,c,s,"f"),Oe(this,w,"f").fire())}show(s){this.assertNotDisposed(),Oe(this,_,"f").$show(Oe(this,k,"f"),!!s)}assertNotDisposed(){if(Oe(this,I,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,_=new WeakMap,D=new WeakMap,P=new WeakMap,I=new WeakMap,c=new WeakMap,v=new WeakMap,h=new WeakMap,w=new WeakMap,E=new WeakMap;class b{constructor(s,p){this._extHostWebview=p,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=s.getProxy(C.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(s,p,r,m){if(this._viewProviders.has(p))throw new Error(`View provider for '${p}' already registered`);return this._viewProviders.set(p,{provider:r,extension:s}),this._proxy.$registerWebviewViewProvider((0,y.toExtensionData)(s),p,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new n.Disposable(()=>{this._viewProviders.delete(p),this._proxy.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(s,p,r,m,i){const t=this._viewProviders.get(p);if(!t)throw new Error(`No view provider found for '${p}'`);const{provider:u,extension:a}=t,l=this._extHostWebview.createNewWebview(s,{},a),f=new T(s,this._proxy,p,r,l,!0);this._webviewViews.set(s,f),await u.resolveWebviewView(f,{state:m},i)}async $onDidChangeWebviewViewVisibility(s,p){this.getWebviewView(s)._setVisible(p)}async $disposeWebviewView(s){const p=this.getWebviewView(s);this._webviewViews.delete(s),p.dispose(),this._extHostWebview.deleteWebview(s)}getWebviewView(s){const p=this._webviewViews.get(s);if(!p)throw new Error("No webview found");return p}}e.ExtHostWebviewViews=b}),define(fe[134],me([0,1,3,5,2,10,8,4,14]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class Wn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Wn.InitialState,this._proxy=I.getProxy(L.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state={...this._state,focused:I},this._onDidChangeWindowState.fire(this._state))}openUri(I,c){let v;if(typeof I=="string"){v=I;try{I=y.URI.parse(I)}catch(h){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,n.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,v,c)}async asExternalUri(I,c){if((0,n.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const v=await this._proxy.$asExternalUri(I,c);return y.URI.from(v)}};D.InitialState={focused:!0},D=Ve([$e(0,_.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(fe[262],me([0,1,9,82,32,40,6,5,2,14]),function(Y,e,g,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let P=class extends n.Disposable{constructor(c,v){super();const h=c.getProxy(k.MainContext.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async w=>{const E=_.URI.file((0,g.join)((0,L.tmpdir)(),(0,y.generateUuid)()));return await h.$download(w,E),E})}};P=Ve([$e(0,D.IExtHostRpcService),$e(1,C.IExtHostCommands)],P),e.ExtHostDownloadService=P}),define(fe[263],me([0,1,132,10,190,32]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class n extends g.ExtHostLoggerService{doCreateLogger(_,D,P){return _.scheme===L.Schemas.file?new y.SpdLogLogger(P?.name||(0,C.generateUuid)(),_.fsPath,!P?.donotRotate,!!P?.donotUseFormatters,D):super.doCreateLogger(_,D,P)}}e.ExtHostLoggerService=n}),define(fe[264],me([0,1,63,9,2,70,6,10,16,28]),function(Y,e,g,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class P extends C.ExtensionStoragePaths{constructor(){super(...arguments);this._workspaceStorageLock=null}async _getWorkspaceStorageURI(r){const m=await super._getWorkspaceStorageURI(r);if(m.scheme!==k.Schemas.file)return m;if(this._environment.skipWorkspaceStorageLock)return this._logService.info(`Skipping acquiring lock for ${m.fsPath}.`),m;const i=m.fsPath;let t=0;do{let u;t===0?u=i:u=/[/\\]$/.test(i)?`${i.substr(0,i.length-1)}-${t}`:`${i}-${t}`,await I(u);const a=L.join(u,"vscode.lock"),l=await w(this._logService,a,!1);if(l)return this._workspaceStorageLock=l,process.on("exit",()=>{l.dispose()}),y.URI.file(u);t++}while(t<10);return m}onWillDeactivateAll(){this._workspaceStorageLock&&this._workspaceStorageLock.setWillRelease(6e3)}}e.ExtensionStoragePaths=P;async function I(p){try{await D.Promises.stat(p);return}catch{}try{await D.Promises.mkdir(p,{recursive:!0})}catch{}}const c=1e3,v=10*60*1e3;class h extends n.Disposable{constructor(r,m){super();this.logService=r,this.filename=m,this._timer=this._register(new _.IntervalTimer),this._timer.cancelAndSet(async()=>{const i=await E(r,m);(!i||i.pid!==process.pid)&&(r.info(`Lock '${m}': The lock was lost unexpectedly.`),this._timer.cancel());try{await D.Promises.utimes(m,new Date,new Date)}catch(t){r.error(t),r.info(`Lock '${m}': Could not update mtime.`)}},c)}dispose(){super.dispose();try{g.unlinkSync(this.filename)}catch(r){}}async setWillRelease(r){this.logService.info(`Lock '${this.filename}': Marking the lockfile as scheduled to be released in ${r} ms.`);try{const m={pid:process.pid,willReleaseAt:Date.now()+r};await D.Promises.writeFile(this.filename,JSON.stringify(m),{flag:"w"})}catch(m){this.logService.error(m)}}}async function w(p,r,m){try{const t={pid:process.pid,willReleaseAt:0};await D.Promises.writeFile(r,JSON.stringify(t),{flag:"wx"})}catch(t){p.error(t)}const i=await E(p,r);return!i||i.pid!==process.pid?m?(p.info(`Lock '${r}': Could not acquire lock, giving up.`),null):(p.info(`Lock '${r}': Could not acquire lock, checking if the file is stale.`),o(p,r)):(p.info(`Lock '${r}': Lock acquired.`),new h(p,r))}async function E(p,r){let m;try{m=await D.Promises.readFile(r)}catch(i){return p.error(i),null}try{return JSON.parse(String(m))}catch(i){return p.error(i),null}}async function T(p,r){let m;try{m=await D.Promises.stat(r)}catch(i){return p.error(i),0}return m.mtime.getTime()}function b(p){try{return process.kill(p,0),!0}catch(r){return!1}}async function o(p,r){const m=await E(p,r);if(!m)return p.info(`Lock '${r}': Could not read pid of lock holder.`),s(p,r);if(m.willReleaseAt){let l=m.willReleaseAt-Date.now();if(l<5e3){for(l>0?p.info(`Lock '${r}': The lockfile is scheduled to be released in ${l} ms.`):p.info(`Lock '${r}': The lockfile is scheduled to have been released.`);l>0;){if(await(0,_.timeout)(Math.min(100,l)),await T(p,r)===0)return s(p,r);l=m.willReleaseAt-Date.now()}return s(p,r)}}if(!b(m.pid))return p.info(`Lock '${r}': The pid ${m.pid} appears to be gone.`),s(p,r);const i=await T(p,r),t=Date.now()-i;if(t<=v)return p.info(`Lock '${r}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;p.info(`Lock '${r}': The lock looks stale, waiting for 2s.`),await(0,_.timeout)(2e3);const u=await T(p,r),a=Date.now()-u;return a<=v?(p.info(`Lock '${r}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null):(p.info(`Lock '${r}': The lock looks stale even after waiting for 2s.`),s(p,r))}async function s(p,r){p.info(`Lock '${r}': Deleting a stale lock.`);try{await D.Promises.unlink(r)}catch(m){}return w(p,r,!0)}}),define(fe[265],me([0,1,32,14,34]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let C=class extends y.BaseExtHostTerminalService{constructor(k){super(!0,k)}createTerminal(k,_,D){return this.createTerminalFromOptions({name:k,shellPath:_,shellArgs:D})}createTerminalFromOptions(k,_){const D=new y.ExtHostTerminal(this._proxy,(0,g.generateUuid)(),k,k.name);return this._terminals.push(D),D.create(k,this._serializeParentTerminal(k,_)),D.value}};C=Ve([$e(0,L.IExtHostRpcService)],C),e.ExtHostTerminalService=C}),define(fe[266],me([0,1,5,14,172,6,26,2,39,23,28,7,12,54,3,121,79,11]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(f,d,S){this.remoteAddress=f,this.localAddress=d,this._dispose=S,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function o(l){const f=l.trim().split(`
`),d=[];return f.forEach(A=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(A);R&&R.length>=3&&d.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),d.reduce((A,R)=>(A[R.socket]=R,A),{})}e.getSockets=o;function s(...l){const f=[].concat(...l.map(r));return[...new Map(f.filter(d=>d.st==="0A").map(d=>{const S=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:p(S[0]),port:parseInt(S[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=s;function p(l){let f="";if(l.length===8)for(let d=l.length-2;d>=0;d-=2)f+=parseInt(l.substr(d,2),16),d!==0&&(f+=".");else for(let d=l.length-4;d>=0;d-=4)f+=parseInt(l.substr(d,4),16).toString(16),d!==0&&(f+=":");return f}e.parseIpAddress=p;function r(l){const f=l.trim().split(`
`),d=f.shift().trim().split(/\s+/).filter(A=>A!=="rx_queue"&&A!=="tm->when");return f.map(A=>A.trim().split(/\s+/).reduce((R,B,x)=>(R[d[x]||x]=B,R),{}))}e.loadConnectionTable=r;function m(l){return!!l.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||l.indexOf("out/vs/server/main.js")!==-1||l.indexOf("_productName=VSCode")!==-1}function i(l){const f=l.trim().split(`
`),d=[];return f.forEach(S=>{const A=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(S);A&&A.length>=4&&d.push({pid:parseInt(A[1],10),ppid:parseInt(A[2]),cmd:A[3]})}),d}e.getRootProcesses=i;async function t(l,f,d){const S=d.reduce((R,B)=>(R[B.pid]=B,R),{}),A=[];return l.forEach(({socket:R,ip:B,port:x})=>{const F=f[R]?f[R].pid:void 0,$=F?S[F]?.cmd:void 0;F&&$&&!m($)&&A.push({host:B,port:x,detail:$,pid:F})}),A}e.findPorts=t;function u(l,f,d){const S=new Map,A=i(f);for(const R of l){const B=d.get(R.port);if(B){S.set(R.port,B);continue}const x=A.find(F=>F.cmd.includes(`${R.port}`));if(x){let F=x,$;do $=A.find(M=>M.ppid===F.pid),$&&(F=$);while($);S.set(R.port,{host:R.ip,port:R.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else S.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return S}e.tryFindRootPorts=u;let a=class extends C.Disposable{constructor(f,d,S){super();this.logService=S,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=f.getProxy(g.MainContext.MainThreadTunnelService),c.isLinux&&d.remote.isRemote&&d.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(f,d){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${f.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const S=await this._proxy.$openTunnel(d,f.displayName);if(S){const A=new b(S.remoteAddress,S.localAddress,()=>this._proxy.$closeTunnel(S.remoteAddress));return this._register(A),A}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(f){return Math.max(f*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(f,d){const S=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(S,{selector:f,provider:d}),this._proxy.$registerPortsAttributesProvider(f,S),new I.Disposable(()=>{this._portAttributesProviders.delete(S),this._proxy.$unregisterPortsAttributesProvider(S)})}async $providePortAttributes(f,d,S,A,R){const B=[];for(const F of f){const $=this._portAttributesProviders.get(F);if(!$)return[];B.push(...await Promise.all(d.map(async M=>$.provider.providePortAttributes(M,S,A,R))))}const x=B.filter(F=>!!F);return x.length>0?x.map(F=>({autoForwardAction:F.autoForwardAction,port:F.port})):[]}async $registerCandidateFinder(f){if(f&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=f;let d=new E.MovingAverage,S;for(;this._candidateFindingEnabled;){const A=new Date().getTime(),R=(await this.findCandidatePorts()).filter(x=>(0,w.isLocalhost)(x.host)||(0,w.isAllInterfaces)(x.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(x=>x.port).join(", ")}`);const B=new Date().getTime()-A;d.update(B),(!S||JSON.stringify(S)!==JSON.stringify(R))&&(S=R,await this._proxy.$onFoundNewCandidates(S)),await new Promise(x=>setTimeout(()=>x(),this.calculateDelay(d.value)))}}async setTunnelExtensionFunctions(f){if(f){if(f.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(f.candidatePortSource),f.showCandidatePort&&(this._showCandidatePort=f.showCandidatePort,this._proxy.$setCandidateFilter()),f.tunnelFactory){this._forwardPortProvider=f.tunnelFactory;let d=f.tunnelFeatures?.privacyOptions??[];f.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:y.localize(0,null),themeIcon:"lock"},{id:"public",label:y.localize(1,null),themeIcon:"eye"}]),this._proxy.$setTunnelProvider({elevation:!!f.tunnelFeatures?.elevation,public:!!f.tunnelFeatures?.public,privacyOptions:d})}}else this._forwardPortProvider=void 0;return(0,C.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(f,d){if(this._extensionTunnels.has(f.host)){const S=this._extensionTunnels.get(f.host);S.has(f.port)&&(d&&S.get(f.port).disposeListener.dispose(),await S.get(f.port).tunnel.dispose(),S.delete(f.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(f,d){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const S=this._forwardPortProvider(f,d);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),S!==void 0){const A=await S;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(f.remoteAddress.host)||this._extensionTunnels.set(f.remoteAddress.host,new Map);const R=this._register(A.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(A.remoteAddress))));return this._extensionTunnels.get(f.remoteAddress.host).set(f.remoteAddress.port,{tunnel:A,disposeListener:R}),v.TunnelDto.fromApiTunnel(A)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(S){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(f){const d=await Promise.all(f.map(A=>this._showCandidatePort(A.host,A.port,A.detail??""))),S=f.filter((A,R)=>d[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${f.map(A=>A.port).join(", ")} to ${S.map(A=>A.port).join(", ")}`),S}async findCandidatePorts(){let f="",d="";try{f=await P.Promises.readFile("/proc/net/tcp","utf8"),d=await P.Promises.readFile("/proc/net/tcp6","utf8")}catch(N){}const S=s(f,d),A=await new Promise(N=>{(0,_.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(U,V,O)=>{N(V)})}),R=o(A),B=await P.Promises.readdir("/proc"),x=[];for(let N of B)try{const U=Number(N),V=D.joinPath(k.URI.file("/proc"),N);if((await P.Promises.stat(V.fsPath)).isDirectory()&&!isNaN(U)){const W=await P.Promises.readlink(D.joinPath(V,"cwd").fsPath),j=await P.Promises.readFile(D.joinPath(V,"cmdline").fsPath,"utf8");x.push({pid:U,cwd:W,cmd:j})}}catch(U){}const F=[],$=S.filter(N=>{const U=R[N.socket];return U||F.push(N),U}),M=t($,R,x);let H;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const N=await new Promise(U=>{(0,_.exec)("ps -F -A -l | grep root",(V,O,W)=>{U(O)})});this._foundRootPorts=u(F,N,this._foundRootPorts),H=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${H.join(", ")}`)}return M.then(N=>H?N.concat(H):N)}};a=Ve([$e(0,L.IExtHostRpcService),$e(1,n.IExtHostInitDataService),$e(2,T.ILogService)],a),e.ExtHostTunnelService=a}),define(fe[267],me([0,1,16,22,21,18,3,6,103,231,55]),function(Y,e,g,L,y,C,n,k,_,D,P){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(S,A){try{return JSON.stringify(S,A)}catch(R){return"null"}}const v="$$ref$$",h={[v]:-1};class w{constructor(A,R){this.jsonString=A,this.referencedBuffers=R}}function E(S,A=null,R=!1){const B=[];return{jsonString:(R?c:JSON.stringify)(S,(F,$)=>{if(typeof $=="undefined")return h;if(typeof $=="object"){if($ instanceof L.VSBuffer){const M=B.push($)-1;return{[v]:M}}if(A)return A(F,$)}return $}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=E;function T(S,A,R){return JSON.parse(S,(B,x)=>{if(x){const F=x[v];if(typeof F=="number")return A[F];if(R&&x.$mid===1)return R.transformIncoming(x)}return x})}e.parseJsonAndRestoreBufferRefs=T;function b(S,A){return JSON.stringify(S,A)}function o(S){return S?(A,R)=>R&&R.$mid===1?S.transformOutgoing(R):R:null}var s;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(s=e.RequestInitiator||(e.RequestInitiator={}));var p;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(p=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},m=Symbol.for("rpcProtocol"),i=Symbol.for("rpcProxy");class t extends k.Disposable{constructor(A,R=null,B=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new n.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=A,this._logger=R,this._uriTransformer=B,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let x=0,F=P.ProxyIdentifier.count;x<F;x++)this._locals[x]=null,this._proxies[x]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(x=>this._receiveOneMessage(x))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(A=>{this._pendingRPCReplies[A].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(A){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(A){this._unresponsiveTime=Date.now()+t.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(A){this._responsiveState!==A&&(this._responsiveState=A,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(A){return this._uriTransformer?(0,_.transformIncomingURIs)(A,this._uriTransformer):A}getProxy(A){const{nid:R,sid:B}=A;return this._proxies[R]||(this._proxies[R]=this._createProxy(R,B)),this._proxies[R]}_createProxy(A,R){let B={get:(x,F)=>(typeof F=="string"&&!x[F]&&F.charCodeAt(0)===36&&(x[F]=(...$)=>this._remoteCall(A,F,$)),F===i?R:x[F])};return new Proxy(Object.create(null),B)}set(A,R){return this._locals[A.nid]=R,R}assertRegistered(A){for(let R=0,B=A.length;R<B;R++){const x=A[R];if(!this._locals[x.nid])throw new Error(`Missing actor ${x.sid} (isMain: ${x.isMain})`)}}_receiveOneMessage(A){if(this._isDisposed)return;const R=A.byteLength,B=u.read(A,0),x=B.readUInt8(),F=B.readUInt32();switch(x){case 1:case 2:{let{rpcId:$,method:M,args:H}=l.deserializeRequestJSONArgs(B);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(R,F,$,M,H,x===2);break}case 3:case 4:{let{rpcId:$,method:M,args:H}=l.deserializeRequestMixedArgs(B);this._uriTransformer&&(H=(0,_.transformIncomingURIs)(H,this._uriTransformer)),this._receiveRequest(R,F,$,M,H,x===4);break}case 5:{this._logger&&this._logger.logIncoming(R,F,0,"ack"),this._onDidReceiveAcknowledge(F);break}case 6:{this._receiveCancel(R,F);break}case 7:{this._receiveReply(R,F,void 0);break}case 9:{let $=l.deserializeReplyOKJSON(B);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(R,F,$);break}case 10:{const $=l.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(R,F,$);break}case 8:{let $=l.deserializeReplyOKVSBuffer(B);this._receiveReply(R,F,$);break}case 11:{let $=l.deserializeReplyErrError(B);this._uriTransformer&&($=(0,_.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(R,F,$);break}case 12:{this._receiveReplyErr(R,F,void 0);break}default:console.error("received unexpected message"),console.error(A)}}_receiveRequest(A,R,B,x,F,$){this._logger&&this._logger.logIncoming(A,R,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(B)}.${x}(`,F);const M=String(R);let H,N;if($){const V=new y.CancellationTokenSource;F.push(V.token),H=this._invokeHandler(B,x,F),N=()=>V.cancel()}else H=this._invokeHandler(B,x,F),N=r;this._cancelInvokedHandlers[M]=N;const U=l.serializeAcknowledged(R);this._logger&&this._logger.logOutgoing(U.byteLength,R,1,"ack"),this._protocol.send(U),H.then(V=>{delete this._cancelInvokedHandlers[M];const O=l.serializeReplyOK(R,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"reply:",V),this._protocol.send(O)},V=>{delete this._cancelInvokedHandlers[M];const O=l.serializeReplyErr(R,V);this._logger&&this._logger.logOutgoing(O.byteLength,R,1,"replyErr:",V),this._protocol.send(O)})}_receiveCancel(A,R){this._logger&&this._logger.logIncoming(A,R,1,"receiveCancel");const B=String(R);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(A,R,B){this._logger&&this._logger.logIncoming(A,R,0,"receiveReply:",B);const x=String(R);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x],F.resolveOk(B)}_receiveReplyErr(A,R,B){this._logger&&this._logger.logIncoming(A,R,0,"receiveReplyErr:",B);const x=String(R);if(!this._pendingRPCReplies.hasOwnProperty(x))return;const F=this._pendingRPCReplies[x];delete this._pendingRPCReplies[x];let $;B&&(B.$isError?($=new Error,$.name=B.name,$.message=B.message,$.stack=B.stack):$=B),F.resolveErr($)}_invokeHandler(A,R,B){try{return Promise.resolve(this._doInvokeHandler(A,R,B))}catch(x){return Promise.reject(x)}}_doInvokeHandler(A,R,B){const x=this._locals[A];if(!x)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(A));let F=x[R];if(typeof F!="function")throw new Error("Unknown method "+R+" on actor "+(0,P.getStringIdentifierForProxy)(A));return F.apply(x,B)}_remoteCall(A,R,B){if(this._isDisposed)return Promise.reject(C.canceled());let x=null;if(B.length>0&&y.CancellationToken.isCancellationToken(B[B.length-1])&&(x=B.pop()),x&&x.isCancellationRequested)return Promise.reject(C.canceled());const F=l.serializeRequestArguments(B,this._uriReplacer),$=++this._lastMessageId,M=String($),H=new D.LazyPromise;x&&x.onCancellationRequested(()=>{const U=l.serializeCancel($);this._logger&&this._logger.logOutgoing(U.byteLength,$,0,"cancel"),this._protocol.send(l.serializeCancel($))}),this._pendingRPCReplies[M]=H,this._onWillSendRequest($);const N=l.serializeRequest($,A,R,F,!!x);return this._logger&&this._logger.logOutgoing(N.byteLength,$,0,`request: ${(0,P.getStringIdentifierForProxy)(A)}.${R}(`,B),this._protocol.send(N),H}}e.RPCProtocol=t,I=m,t.UNRESPONSIVE_TIME=3*1e3;class u{constructor(A,R){this._buff=A,this._offset=R}static alloc(A,R,B){let x=new u(L.VSBuffer.alloc(B+1+4),0);return x.writeUInt8(A),x.writeUInt32(R),x}static read(A,R){return new u(A,R)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(A){this._buff.writeUInt8(A,this._offset),this._offset+=1}readUInt8(){const A=this._buff.readUInt8(this._offset);return this._offset+=1,A}writeUInt32(A){this._buff.writeUInt32BE(A,this._offset),this._offset+=4}readUInt32(){const A=this._buff.readUInt32BE(this._offset);return this._offset+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this._buff.writeUInt8(A.byteLength,this._offset),this._offset+=1,this._buff.set(A,this._offset),this._offset+=A.byteLength}readShortString(){const A=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,B}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readLongString(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+A).toString();return this._offset+=A,B}writeBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this._buff.writeUInt32BE(A.byteLength,this._offset),this._offset+=4,this._buff.set(A,this._offset),this._offset+=A.byteLength}readVSBuffer(){const A=this._buff.readUInt32BE(this._offset);this._offset+=4;const R=this._buff.slice(this._offset,this._offset+A);return this._offset+=A,R}static sizeMixedArray(A){let R=0;R+=1;for(let B=0,x=A.length;B<x;B++){const F=A[B];switch(R+=1,F.type){case 1:R+=this.sizeLongString(F.value);break;case 2:R+=this.sizeVSBuffer(F.value);break;case 3:R+=this.sizeUInt32,R+=this.sizeLongString(F.value);for(let $=0;$<F.buffers.length;++$)R+=this.sizeVSBuffer(F.buffers[$]);break;case 4:break}}return R}writeMixedArray(A){this._buff.writeUInt8(A.length,this._offset),this._offset+=1;for(let R=0,B=A.length;R<B;R++){const x=A[R];switch(x.type){case 1:this.writeUInt8(1),this.writeLongString(x.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(x.value);break;case 3:this.writeUInt8(3),this.writeUInt32(x.buffers.length),this.writeLongString(x.value);for(let F=0;F<x.buffers.length;++F)this.writeBuffer(x.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this._buff.readUInt8(this._offset);this._offset+=1;let R=new Array(A);for(let B=0;B<A;B++)switch(this.readUInt8()){case 1:R[B]=this.readLongString();break;case 2:R[B]=this.readVSBuffer();break;case 3:const F=this.readUInt32(),$=this.readLongString(),M=[];for(let H=0;H<F;++H)M.push(this.readVSBuffer());R[B]=new P.SerializableObjectWithBuffers(T($,M,null));break;case 4:R[B]=void 0;break}return R}}u.sizeUInt32=4;var a;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(a||(a={}));class l{static _useMixedArgSerialization(A){for(let R=0,B=A.length;R<B;R++)if(A[R]instanceof L.VSBuffer||A[R]instanceof P.SerializableObjectWithBuffers||typeof A[R]=="undefined")return!0;return!1}static serializeRequestArguments(A,R){if(this._useMixedArgSerialization(A)){const B=[];for(let x=0,F=A.length;x<F;x++){const $=A[x];if($ instanceof L.VSBuffer)B[x]={type:2,value:$};else if(typeof $=="undefined")B[x]={type:4};else if($ instanceof P.SerializableObjectWithBuffers){const{jsonString:M,referencedBuffers:H}=E($.value,R);B[x]={type:3,value:L.VSBuffer.fromString(M),buffers:H}}else B[x]={type:1,value:L.VSBuffer.fromString(b($,R))}}return{type:1,args:B}}return{type:0,args:b(A,R)}}static serializeRequest(A,R,B,x,F){switch(x.type){case 0:return this._requestJSONArgs(A,R,B,x.args,F);case 1:return this._requestMixedArgs(A,R,B,x.args,F)}}static _requestJSONArgs(A,R,B,x,F){const $=L.VSBuffer.fromString(B),M=L.VSBuffer.fromString(x);let H=0;H+=u.sizeUInt8(),H+=u.sizeShortString($),H+=u.sizeLongString(M);let N=u.alloc(F?2:1,A,H);return N.writeUInt8(R),N.writeShortString($),N.writeLongString(M),N.buffer}static deserializeRequestJSONArgs(A){const R=A.readUInt8(),B=A.readShortString(),x=A.readLongString();return{rpcId:R,method:B,args:JSON.parse(x)}}static _requestMixedArgs(A,R,B,x,F){const $=L.VSBuffer.fromString(B);let M=0;M+=u.sizeUInt8(),M+=u.sizeShortString($),M+=u.sizeMixedArray(x);let H=u.alloc(F?4:3,A,M);return H.writeUInt8(R),H.writeShortString($),H.writeMixedArray(x),H.buffer}static deserializeRequestMixedArgs(A){const R=A.readUInt8(),B=A.readShortString(),x=A.readMixedArray(),F=new Array(x.length);for(let $=0,M=x.length;$<M;$++){const H=x[$];typeof H=="string"?F[$]=JSON.parse(H):F[$]=H}return{rpcId:R,method:B,args:F}}static serializeAcknowledged(A){return u.alloc(5,A,0).buffer}static serializeCancel(A){return u.alloc(6,A,0).buffer}static serializeReplyOK(A,R,B){if(typeof R=="undefined")return this._serializeReplyOKEmpty(A);if(R instanceof L.VSBuffer)return this._serializeReplyOKVSBuffer(A,R);if(R instanceof P.SerializableObjectWithBuffers){const{jsonString:x,referencedBuffers:F}=E(R.value,B,!0);return this._serializeReplyOKJSONWithBuffers(A,x,F)}else return this._serializeReplyOKJSON(A,c(R,B))}static _serializeReplyOKEmpty(A){return u.alloc(7,A,0).buffer}static _serializeReplyOKVSBuffer(A,R){let B=0;B+=u.sizeVSBuffer(R);let x=u.alloc(8,A,B);return x.writeVSBuffer(R),x.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static _serializeReplyOKJSON(A,R){const B=L.VSBuffer.fromString(R);let x=0;x+=u.sizeLongString(B);let F=u.alloc(9,A,x);return F.writeLongString(B),F.buffer}static _serializeReplyOKJSONWithBuffers(A,R,B){const x=L.VSBuffer.fromString(R);let F=0;F+=u.sizeUInt32,F+=u.sizeLongString(x);for(const M of B)F+=u.sizeVSBuffer(M);let $=u.alloc(10,A,F);$.writeUInt32(B.length),$.writeLongString(x);for(const M of B)$.writeBuffer(M);return $.buffer}static deserializeReplyOKJSON(A){const R=A.readLongString();return JSON.parse(R)}static deserializeReplyOKJSONWithBuffers(A,R){const B=A.readUInt32(),x=A.readLongString(),F=[];for(let $=0;$<B;++$)F.push(A.readVSBuffer());return new P.SerializableObjectWithBuffers(T(x,F,R))}static serializeReplyErr(A,R){return R?this._serializeReplyErrEror(A,R):this._serializeReplyErrEmpty(A)}static _serializeReplyErrEror(A,R){const B=L.VSBuffer.fromString(c(C.transformErrorForSerialization(R),null));let x=0;x+=u.sizeLongString(B);let F=u.alloc(11,A,x);return F.writeLongString(B),F.buffer}static deserializeReplyErrError(A){const R=A.readLongString();return JSON.parse(R)}static _serializeReplyErrEmpty(A){return u.alloc(12,A,0).buffer}}var f;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var d;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(d||(d={}))}),define(fe[268],me([0,1,4]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,g.createDecorator)("remoteAgentService")}),define(fe[269],me([0,1,10,9,12,2,4,64,44,226,268]),function(Y,e,g,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,n.createDecorator)("pathService");let I=class Hn{constructor(v,h,w,E){this.localUserHome=v,this.remoteAgentService=h,this.environmentService=w,this.contextService=E,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||y.OS)(),this.resolveUserHome=(async()=>{const T=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=T?.userHome||v})()}get defaultUriScheme(){return Hn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(v,h){if(v.remoteAuthority)return g.Schemas.vscodeRemote;const w=(0,k.getVirtualWorkspaceScheme)(h.getWorkspace());if(w)return w;const E=h.getWorkspace().folders[0];if(E)return E.uri.scheme;const T=h.getWorkspace().configuration;return T?T.scheme:g.Schemas.file}async userHome(v){return v?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(v=>v===1?L.win32:L.posix)}async fileURI(v){let h="";if(await this.resolveOS===1&&(v=v.replace(/\\/g,"/")),v[0]==="/"&&v[1]==="/"){const E=v.indexOf("/",2);E===-1?(h=v.substring(2),v="/"):(h=v.substring(2,E),v=v.substring(E)||"/")}return C.URI.from({scheme:g.Schemas.file,authority:h,path:v,query:"",fragment:""})}};I=Ve([$e(1,P.IRemoteAgentService),$e(2,D.IWorkbenchEnvironmentService),$e(3,_.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(fe[72],me([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(n,k){this.line=n,this.character=k}isBefore(n){return!1}isBeforeOrEqual(n){return!1}isAfter(n){return!1}isAfterOrEqual(n){return!1}isEqual(n){return!1}compareTo(n){return 0}translate(n,k){return new g(0,0)}with(n){return new g(0,0)}}e.Position=g;class L{constructor(n,k,_,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(n,k),this.end=new g(_,D)}contains(n){return!1}isEqual(n){return!1}intersection(n){}union(n){return new L(0,0,0,0)}with(n){return new L(0,0,0,0)}}e.Range=L;var y;(function(C){C[C.Information=1]="Information",C[C.Warning=2]="Warning"})(y=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(fe[33],me([0,1,15,31,25,30,8,4,9,18,72,13]),function(Y,e,g,L,y,C,n,k,_,D,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",v=" characters skipped \u27EB",h=(c.length+v.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var w;(function(U){U[U.file=0]="file",U[U.text=1]="text"})(w=e.SearchProviderType||(e.SearchProviderType={}));var E;(function(U){U[U.File=1]="File",U[U.Text=2]="Text"})(E=e.QueryType||(e.QueryType={}));function T(U){return!!U.preview}e.resultIsMatch=T;function b(U){return!!U.resource}e.isFileMatch=b;function o(U){return!!U.message}e.isProgressMessage=o;var s;(function(U){U[U.Normal=0]="Normal",U[U.NewSearchStarted=1]="NewSearchStarted"})(s=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class p{constructor(V){this.resource=V,this.results=[]}}e.FileMatch=p;class r{constructor(V,O,W){this.ranges=O;const j=Array.isArray(O)?O:[O];if(W&&W.matchLines===1&&m(j)){V=(0,n.getNLines)(V,W.matchLines);let X="",Q=0,de=0;const Se=Math.floor(W.charsPerLine/5),De=[];for(const Pe of j){const Be=Math.max(Pe.startColumn-Se,0),We=Pe.startColumn+W.charsPerLine;if(Be>de+Se+h){const He=c+(Be-de)+v;X+=He+V.slice(Be,We),Q+=Be-(de+He.length)}else X+=V.slice(de,We);De.push(new t(0,Pe.startColumn-Q,Pe.endColumn-Q)),de=We}this.preview={text:X,matches:Array.isArray(this.ranges)?De:De[0]}}else{const X=Array.isArray(O)?O[0].startLineNumber:O.startLineNumber;this.preview={text:V,matches:(0,g.mapArrayOrNot)(O,Q=>new i(Q.startLineNumber-X,Q.startColumn,Q.endLineNumber-X,Q.endColumn))}}}}e.TextSearchMatch=r;function m(U){const V=U[0].startLineNumber;for(const O of U)if(O.startLineNumber!==V||O.endLineNumber!==V)return!1;return!0}class i{constructor(V,O,W,j){this.startLineNumber=V,this.startColumn=O,this.endLineNumber=W,this.endColumn=j}}e.SearchRange=i;class t extends i{constructor(V,O,W){super(V,O,V,W)}}e.OneLineRange=t;var u;(function(U){U.Default="default",U.FileNames="fileNames",U.Type="type",U.Modified="modified",U.CountDescending="countDescending",U.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function a(U,V=!0){const O=U&&U.files&&U.files.exclude,W=V&&U&&U.search&&U.search.exclude;if(!O&&!W)return;if(!O||!W)return O||W;let j=Object.create(null);return j=y.mixin(j,y.deepClone(O)),j=y.mixin(j,y.deepClone(W),!0),j}e.getExcludes=a;function l(U,V){return U.excludePattern&&L.match(U.excludePattern,V)?!1:U.includePattern||U.usingSearchPaths?U.includePattern&&L.match(U.includePattern,V)?!0:U.usingSearchPaths?!!U.folderQueries&&U.folderQueries.some(O=>{const W=O.folder.fsPath;if(C.isEqualOrParent(V,W)){const j=_.relative(W,V);return!O.includePattern||!!L.match(O.includePattern,j)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var f;(function(U){U[U.unknownEncoding=1]="unknownEncoding",U[U.regexParseError=2]="regexParseError",U[U.globParseError=3]="globParseError",U[U.invalidLiteral=4]="invalidLiteral",U[U.rgProcessError=5]="rgProcessError",U[U.other=6]="other",U[U.canceled=7]="canceled"})(f=e.SearchErrorCode||(e.SearchErrorCode={}));class d extends Error{constructor(V,O){super(V);this.code=O}}e.SearchError=d;function S(U){const V=U.message;if((0,D.isPromiseCanceledError)(U))return new d(V,f.canceled);try{const O=JSON.parse(V);return new d(O.message,O.code)}catch(O){return new d(V,f.other)}}e.deserializeSearchError=S;function A(U){const V={message:U.message,code:U.code};return new Error(JSON.stringify(V))}e.serializeSearchError=A;function R(U){return U.type==="error"?!0:U.type==="success"}e.isSerializedSearchComplete=R;function B(U){return U.type==="success"}e.isSerializedSearchSuccess=B;function x(U){return!!U.path}e.isSerializedFileMatch=x;function F(U,V){const O=U.searchPath?U.searchPath:U.relativePath;return(0,n.fuzzyContains)(O,V)}e.isFilePatternMatch=F;class ${constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function M(U,V){const O={...U||{},...V||{}};return Object.keys(O).filter(W=>{const j=O[W];return typeof j=="boolean"&&j})}e.resolvePatternsForProvider=M;class H{constructor(V,O){this._parsedIncludeExpression=null,this._excludeExpression={...V.excludePattern||{},...O.excludePattern||{}},this._parsedExcludeExpression=L.parse(this._excludeExpression);let W=V.includePattern;O.includePattern&&(W?W={...W,...O.includePattern}:W=O.includePattern),W&&(this._parsedIncludeExpression=L.parse(W))}matchesExcludesSync(V,O,W){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,O,W))}includedInQuerySync(V,O,W){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(V,O,W)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(V,O,W))}includedInQuery(V,O,W){const j=this._parsedExcludeExpression(V,O,W),X=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(V,O,W):!0;return(0,I.isPromise)(j)?j.then(Q=>Q?!1:X()):X()}hasSiblingExcludeClauses(){return N(this._excludeExpression)}}e.QueryGlobTester=H;function N(U){for(const V in U)if(typeof U[V]!="boolean")return!0;return!1}}),define(fe[36],me([0,1,15,16,21,3,24,10,79,23,8,13,2,170,4,11,191,44,45,26,14,7,33,5]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b,o,s,p,r,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(A,R,B){return new D.ExtUri(x=>l(x,B)).isEqual(A,R)}function t(A,R,B){return i(A.uri,R.uri,B)?0:(0,P.compare)(A.uri.toString(),R.uri.toString())}function u(A,R,B){return A.index!==R.index?A.index<R.index?-1:1:i(A.uri,R.uri,B)?(0,P.compare)(A.name,R.name):(0,P.compare)(A.uri.toString(),R.uri.toString())}function a(A,R,B,x){const F=A.slice(0).sort((M,H)=>B(M,H,x)),$=R.slice(0).sort((M,H)=>B(M,H,x));return(0,g.delta)(F,$,(M,H)=>B(M,H,x))}function l(A,R){const B=R.getCapabilities(A.scheme);return!(B&&B&1024)}class f extends T.Workspace{constructor(R,B,x,F,$,M,H){super(R,x.map(N=>new T.WorkspaceFolder(N)),F,$,H);this._name=B,this._isUntitled=M,this._workspaceFolders=[],this._structure=n.TernarySearchTree.forUris(H),x.forEach(N=>{this._workspaceFolders.push(N),this._structure.set(N.uri,N)})}static toExtHostWorkspace(R,B,x,F){if(!R)return{workspace:null,added:[],removed:[]};const{id:$,name:M,folders:H,configuration:N,transient:U,isUntitled:V}=R,O=[],W=B;B?H.forEach((de,Se)=>{const De=c.URI.revive(de.uri),Pe=f._findFolder(x||B,De,F);Pe?(Pe.name=de.name,Pe.index=de.index,O.push(Pe)):O.push({uri:De,name:de.name,index:Se})}):O.push(...H.map(({uri:de,name:Se,index:De})=>({uri:c.URI.revive(de),name:Se,index:De}))),O.sort((de,Se)=>de.index<Se.index?-1:1);const j=new f($,M,O,!!U,N?c.URI.revive(N):null,!!V,de=>l(de,F)),{added:X,removed:Q}=a(W?W.workspaceFolders:[],j.workspaceFolders,t,F);return{workspace:j,added:X,removed:Q}}static _findFolder(R,B,x){for(let F=0;F<R.folders.length;F++){const $=R.workspaceFolders[F];if(i($.uri,B,x))return $}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(R,B){return B&&this._structure.get(R)&&(R=(0,D.dirname)(R)),this._structure.findSubstr(R)}resolveWorkspaceFolder(R){return this._structure.get(R)}}let d=class{constructor(R,B,x,F){this._onDidChangeWorkspace=new C.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new C.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=F,this._extHostFileSystemInfo=x,this._requestIdProvider=new _.Counter,this._barrier=new L.Barrier,this._proxy=R.getProxy(m.MainContext.MainThreadWorkspace),this._messageService=R.getProxy(m.MainContext.MainThreadMessageService);const $=B.workspace;this._confirmedWorkspace=$?new f($.id,$.name,[],!!$.transient,$.configuration?c.URI.revive($.configuration):null,!!$.isUntitled,M=>l(M,x)):void 0}$initializeWorkspace(R,B){this._trusted=B,this.$acceptWorkspaceData(R),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:k.Schemas.untitled,path:(0,D.basename)((0,D.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(R,B,x,...F){const $=[];if(Array.isArray(F)&&F.forEach(V=>{c.URI.isUri(V.uri)&&!$.some(O=>i(O.uri,V.uri,this._extHostFileSystemInfo))&&$.push({uri:V.uri,name:V.name||(0,D.basenameOrAuthority)(V.uri)})}),this._unconfirmedWorkspace||[B,x].some(V=>typeof V!="number"||V<0)||x===0&&$.length===0)return!1;const M=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+x>M.length)return!1;const H=M.slice(0);H.splice(B,x,...$.map(V=>({uri:V.uri,name:V.name||(0,D.basenameOrAuthority)(V.uri),index:void 0})));for(let V=0;V<H.length;V++){const O=H[V];if(H.some((W,j)=>j!==V&&i(O.uri,W.uri,this._extHostFileSystemInfo)))return!1}H.forEach((V,O)=>V.index=O);const{added:N,removed:U}=a(M,H,u,this._extHostFileSystemInfo);if(N.length===0&&U.length===0)return!1;if(this._proxy){const V=R.displayName||R.name;this._proxy.$updateWorkspaceFolders(V,B,x,$).then(void 0,O=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,v.localize)(0,null,V,O.toString()),{extension:R},[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(R,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async getWorkspaceFolder2(R,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(R,B)}async resolveWorkspaceFolder(R){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(R)}getPath(){if(!this._actualWorkspace)return;const{folders:R}=this._actualWorkspace;if(R.length!==0)return R[0].uri.fsPath}getRelativePath(R,B){let x,F="";if(typeof R=="string"?(x=c.URI.file(R),F=R):typeof R!="undefined"&&(x=R,F=R.fsPath),!x)return F;const $=this.getWorkspaceFolder(x,!0);if(!$)return F;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let M=(0,D.relativePath)($.uri,x);return B&&$.name&&(M=`${$.name}/${M}`),M}trySetWorkspaceFolders(R){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:R,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(R){const{workspace:B,added:x,removed:F}=f.toExtHostWorkspace(R,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:x,removed:F}))}findFiles(R,B,x,F,$=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let M;if(B===null?M=!1:B&&(typeof B=="string"?M=B:M=B.pattern),$&&$.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:N}=S(R);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(H),(0,I.withUndefinedAsNull)(N),(0,I.withUndefinedAsNull)(M),(0,I.withUndefinedAsNull)(x),$).then(U=>Array.isArray(U)?U.map(V=>c.URI.revive(V)):[])}async findTextInFiles(R,B,x,F,$=y.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const M=this._requestIdProvider.getNext(),H=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:N,folder:U}=S(B.include),V=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,O={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:H,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:N,excludePattern:V},W=!1;if(this._activeSearchCallbacks[M]=j=>{if(W)return;const X=c.URI.revive(j.resource);j.results.forEach(Q=>{(0,r.resultIsMatch)(Q)?x({uri:X,preview:{text:Q.preview.text,matches:(0,g.mapArrayOrNot)(Q.preview.matches,de=>new p.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,g.mapArrayOrNot)(Q.ranges,de=>new p.Range(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):x({uri:X,text:Q.text,lineNumber:Q.lineNumber})})},$.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(R,(0,I.withUndefinedAsNull)(U),O,M,$);return delete this._activeSearchCallbacks[M],j||{}}catch(j){throw delete this._activeSearchCallbacks[M],j}}$handleTextSearchResult(R,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](R)}saveAll(R){return this._proxy.$saveAll(R)}resolveProxy(R){return this._proxy.$resolveProxy(R)}get trusted(){return this._trusted}requestWorkspaceTrust(R){return this._proxy.$requestWorkspaceTrust(R)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};d=Ve([$e(0,s.IExtHostRpcService),$e(1,o.IExtHostInitDataService),$e(2,b.IExtHostFileSystemInfo),$e(3,w.ILogService)],d),e.ExtHostWorkspace=d,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function S(A){let R,B;return A&&(typeof A=="string"?R=A:(R=A.pattern,B=A.baseFolder||c.URI.file(A.base))),{includePattern:R,folder:B}}}),define(fe[37],me([0,1,25,3,36,5,7,194,87,13,16,4,14,11,2]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function w(m,i){if(i){const t=i.split(".");let u=m;for(let a=0;u&&a<t.length;a++)u=u[t[a]];return u}}function E(m){return m instanceof h.URI}function T(m){return m&&m.uri instanceof h.URI&&m.languageId&&typeof m.languageId=="string"}function b(m){return m&&!m.uri&&m.languageId&&typeof m.languageId=="string"}function o(m){return m&&m.uri instanceof h.URI&&(!m.name||typeof m.name=="string")&&(!m.index||typeof m.index=="number")}function s(m){if(E(m))return{resource:m};if(T(m))return{resource:m.uri,overrideIdentifier:m.languageId};if(b(m))return{overrideIdentifier:m.languageId};if(o(m))return{resource:m.uri};if(m===null)return{resource:null}}let p=class{constructor(i,t,u){this._proxy=i.getProxy(C.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=u,this._barrier=new P.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(i=>this._actual)}$initializeConfiguration(i){this._actual=new r(this._proxy,this._extHostWorkspace,i,this._logService),this._barrier.open()}$acceptConfigurationChanged(i,t){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(i,t))}};p=Ve([$e(0,c.IExtHostRpcService),$e(1,y.IExtHostWorkspace),$e(2,v.ILogService)],p),e.ExtHostConfiguration=p;class r{constructor(i,t,u,a){this._onDidChangeConfiguration=new L.Emitter,this._proxy=i,this._logService=a,this._extHostWorkspace=t,this._configuration=k.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(i,t){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,u))}getConfiguration(i,t,u){const a=s(t)||{},l=this._toReadonlyValue(i?w(this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace),i):this._configuration.getValue(void 0,a,this._extHostWorkspace.workspace));i&&this._validateConfigurationAccess(i,a,u?.identifier);function f(S){if(S==null)return null;if(typeof S=="boolean")return S?1:4;switch(S){case n.ConfigurationTarget.Global:return 1;case n.ConfigurationTarget.Workspace:return 4;case n.ConfigurationTarget.WorkspaceFolder:return 5}}const d={has(S){return typeof w(l,S)!="undefined"},get:(S,A)=>{this._validateConfigurationAccess(i?`${i}.${S}`:S,a,u?.identifier);let R=w(l,S);if(typeof R=="undefined")R=A;else{let B;const x=(F,$)=>{let M;const H=()=>{B=B||(0,g.deepClone)(l),M=M||w(B,$)};return(0,D.isObject)(F)?new Proxy(F,{get:(N,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return H(),()=>M;if(B)return M=M||w(B,$),M[U];const V=N[U];return typeof U=="string"?x(V,`${$}.${U}`):V},set:(N,U,V)=>(H(),M&&(M[U]=V),!0),deleteProperty:(N,U)=>(H(),M&&delete M[U],!0),defineProperty:(N,U,V)=>(H(),M&&Object.defineProperty(M,U,V),!0)}):F};R=x(R,S)}return R},update:(S,A,R,B)=>{S=i?`${i}.${S}`:S;const x=f(R);return A!==void 0?this._proxy.$updateConfigurationOption(x,S,A,a,B):this._proxy.$removeConfigurationOption(x,S,a,B)},inspect:S=>{S=i?`${i}.${S}`:S;const A=(0,g.deepClone)(this._configuration.inspect(S,a,this._extHostWorkspace.workspace));if(A)return{key:S,defaultValue:A.default?.value,globalValue:A.user?.value,workspaceValue:A.workspace?.value,workspaceFolderValue:A.workspaceFolder?.value,defaultLanguageValue:A.default?.override,globalLanguageValue:A.user?.override,workspaceLanguageValue:A.workspace?.override,workspaceFolderLanguageValue:A.workspaceFolder?.override,languageIds:A.overrideIdentifiers}}};return typeof l=="object"&&(0,g.mixin)(d,l,!1),Object.freeze(d)}_toReadonlyValue(i){const t=u=>(0,D.isObject)(u)?new Proxy(u,{get:(a,l)=>t(a[l]),set:(a,l,f)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(a,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(a,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return t(i)}_validateConfigurationAccess(i,t,u){const a=_.OVERRIDE_PROPERTY_PATTERN.test(i)?4:this._configurationScopes.get(i),l=u?`[${u.value}] `:"";if(a===4){typeof t?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${i}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){t?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${i}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(i,t){const u=new k.ConfigurationChangeEvent(i,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(a,l)=>u.affectsConfiguration(a,s(l))})}_toMap(i){return i.reduce((t,u)=>(t.set(u[0],u[1]),t),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[73],me([0,1,2,16,3,5,7,36,46,37,21,34,14,26,4,10,12,11,68,216,18]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b,o,s){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var m;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(m=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var i;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(i=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var t;(function($){function M(U){if(U){const V=U;return V&&!!V.process}else return!1}$.is=M;function H(U){if(U==null)return;const V={process:U.process,args:U.args};return U.options&&(V.options=i.from(U.options)),V}$.from=H;function N(U){if(U!=null)return new n.ProcessExecution(U.process,U.args,U.options)}$.to=N})(t=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function($){function M(N){if(N!=null)return N}$.from=M;function H(N){if(N!=null)return N}$.to=H})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var a;(function($){function M(U){if(U){const V=U;return V&&(!!V.commandLine||!!V.command)}else return!1}$.is=M;function H(U){if(U==null)return;const V={};return U.commandLine!==void 0?V.commandLine=U.commandLine:(V.command=U.command,V.args=U.args),U.options&&(V.options=u.from(U.options)),V}$.from=H;function N(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new n.ShellExecution(U.commandLine,U.options):new n.ShellExecution(U.command,U.args?U.args:[],U.options)}$.to=N})(a=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function($){function M(U){if(U){let V=U;return V&&V.customExecution==="customExecution"}else return!1}$.is=M;function H(U){return{customExecution:"customExecution"}}$.from=H;function N(U,V){return V.get(U)}$.to=N})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var f;(function($){function M(H,N){let U;return H.scope!==void 0&&typeof H.scope!="number"?U=H.scope.uri:H.scope!==void 0&&typeof H.scope=="number"&&(H.scope===n.TaskScope.Workspace&&N&&N.workspaceFile?U=N.workspaceFile:U=o.USER_TASKS_GROUP_KEY),{id:H._id,workspaceFolder:U}}$.from=M})(f=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function($){function M(H){if(H!=null)return{_id:H.id,isDefault:H.isDefault}}$.from=M})(d=e.TaskGroupDTO||(e.TaskGroupDTO={}));var S;(function($){function M(U,V){if(U==null)return[];const O=[];for(let W of U){const j=H(W,V);j&&O.push(j)}return O}$.fromMany=M;function H(U,V){if(U==null)return;let O;U.execution instanceof n.ProcessExecution?O=t.from(U.execution):U.execution instanceof n.ShellExecution?O=a.from(U.execution):U.execution&&U.execution instanceof n.CustomExecution&&(O=l.from(U.execution));const W=r.from(U.definition);let j;return U.scope?typeof U.scope=="number"?j=U.scope:j=U.scope.uri:j=n.TaskScope.Workspace,!W||!j?void 0:{_id:U._id,definition:W,name:U.name,source:{extensionId:V.identifier.value,label:U.source,scope:j},execution:O,isBackground:U.isBackground,group:d.from(U.group),presentationOptions:m.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}$.from=H;async function N(U,V,O){if(U==null)return;let W;t.is(U.execution)?W=t.to(U.execution):a.is(U.execution)?W=a.to(U.execution):l.is(U.execution)&&(W=l.to(U._id,O));const j=r.to(U.definition);let X;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?X=U.source.scope:X=await V.resolveWorkspaceFolder(g.URI.revive(U.source.scope)):X=n.TaskScope.Workspace),!j||!X)return;const Q=new n.Task(j,X,U.name,U.source.label,W,U.problemMatchers);return U.isBackground!==void 0&&(Q.isBackground=U.isBackground),U.group!==void 0&&(Q.group=n.TaskGroup.from(U.group._id),Q.group&&U.group.isDefault&&(Q.group=new n.TaskGroup(Q.group.id,Q.group.label),U.group.isDefault&&(Q.group.isDefault=U.group.isDefault))),U.presentationOptions&&(Q.presentationOptions=m.to(U.presentationOptions)),U._id&&(Q._id=U._id),U.detail&&(Q.detail=U.detail),Q}$.to=N})(S=e.TaskDTO||(e.TaskDTO={}));var A;(function($){function M(N){return N}$.from=M;function H(N){if(!!N)return Object.assign(Object.create(null),N)}$.to=H})(A=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(M,H,N){this._id=H,this._task=N,p.set(this,void 0),st(this,p,M,"f")}get task(){return this._task}terminate(){Oe(this,p,"f").terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}p=new WeakMap;var B;(function($){function M(H){return{id:H._id,task:void 0}}$.from=M})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let x=class{constructor(M,H,N,U,V,O,W,j){this._onDidExecuteTask=new y.Emitter,this._onDidTerminateTask=new y.Emitter,this._onDidTaskProcessStarted=new y.Emitter,this._onDidTaskProcessEnded=new y.Emitter,this._proxy=M.getProxy(C.MainContext.MainThreadTask),this._workspaceProvider=N,this._editorService=U,this._configurationService=V,this._terminalService=O,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=j,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(M,H,N){if(!N)return new n.Disposable(()=>{});const U=this.nextHandle();return this._handlers.set(U,{type:H,provider:N,extension:M}),this._proxy.$registerTaskProvider(U,H),new n.Disposable(()=>{this._handlers.delete(U),this._proxy.$unregisterTaskProvider(U)})}registerTaskSystem(M,H){this._proxy.$registerTaskSystem(M,H)}fetchTasks(M){return this._proxy.$fetchTasks(A.from(M)).then(async H=>{const N=[];for(let U of H){const V=await S.to(U,this._workspaceProvider,this._providedCustomExecutions2);V&&N.push(V)}return N})}get taskExecutions(){const M=[];return this._taskExecutions.forEach(H=>M.push(H)),M}terminateTask(M){if(!(M instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(M._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(M,H,N){const U=this._providedCustomExecutions2.get(M.id);U&&(this._activeCustomExecutions2.set(M.id,U),this._terminalService.attachPtyToTerminal(H,await U.callback(N))),this._lastStartedTask=M.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(M)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(M){const H=await this.getTaskExecution(M);this._taskExecutionPromises.delete(M.id),this._taskExecutions.delete(M.id),this.customExecutionComplete(M),this._onDidTerminateTask.fire({execution:H})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(M){const H=await this.getTaskExecution(M.id);this._onDidTaskProcessStarted.fire({execution:H,processId:M.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(M){const H=await this.getTaskExecution(M.id);this._onDidTaskProcessEnded.fire({execution:H,exitCode:M.exitCode})}$provideTasks(M,H){const N=this._handlers.get(M);if(!N)return Promise.reject(new Error("no handler found"));const U=[],V=(0,L.asPromise)(()=>N.provider.provideTasks(P.CancellationToken.None)).then(O=>this.provideTasksInternal(H,U,N,O));return new Promise(O=>{V.then(W=>{Promise.all(U).then(()=>{O(W)})})})}async $resolveTask(M,H){const N=this._handlers.get(M);if(!N)return Promise.reject(new Error("no handler found"));if(H.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${H.definition.type}] cannot be resolved by provider of type [${N.type}].`);const U=await S.to(H,this._workspaceProvider,this._providedCustomExecutions2);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const V=await N.provider.resolveTask(U,P.CancellationToken.None);if(!V)return;this.checkDeprecation(V,N);const O=S.from(V,N.extension);if(!O)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(O.execution)&&await this.addCustomExecution(O,V,!0),await this.resolveTaskInternal(O)}nextHandle(){return this._handleCounter++}async addCustomExecution(M,H,N){const U=await this._proxy.$createTaskId(M);!N&&!this._providedCustomExecutions2.has(U)&&(this._notProvidedCustomExecutions.add(U),this._activeCustomExecutions2.set(U,H.execution)),this._providedCustomExecutions2.set(U,H.execution)}async getTaskExecution(M,H){if(typeof M=="string"){const V=this._taskExecutionPromises.get(M);if(!V)throw new Error("Unexpected: The specified task is missing an execution");return V}let N=this._taskExecutionPromises.get(M.id);if(N)return N;const U=new Promise((V,O)=>{function W(j,X,Q){Q?V(new R(j,X.id,Q)):O("Unexpected: Task does not exist.")}H?W(this,M,H):S.to(M.task,this._workspaceProvider,this._providedCustomExecutions2).then(j=>W(this,M,j))});return this._taskExecutionPromises.set(M.id,U),U.then(V=>(this._taskExecutions.set(M.id,V),V),V=>Promise.reject(V))}checkDeprecation(M,H){M._deprecated&&this._deprecationService.report("Task.constructor",H.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(M){this._activeCustomExecutions2.get(M.id)&&this._activeCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.has(M.id)&&this._lastStartedTask!==M.id&&(this._providedCustomExecutions2.delete(M.id),this._notProvidedCustomExecutions.delete(M.id));let N=this._notProvidedCustomExecutions.values(),U=N.next();for(;!U.done;)!this._activeCustomExecutions2.has(U.value)&&this._lastStartedTask!==U.value&&(this._providedCustomExecutions2.delete(U.value),this._notProvidedCustomExecutions.delete(U.value)),U=N.next()}};x=Ve([$e(0,c.IExtHostRpcService),$e(1,v.IExtHostInitDataService),$e(2,k.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,T.ILogService),$e(7,b.IExtHostApiDeprecationService)],x),e.ExtHostTaskBase=x;let F=class extends x{constructor(M,H,N,U,V,O,W,j){super(M,H,N,U,V,O,W,j);this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(M,H){if(!H.execution)throw new Error("Tasks to execute must include an execution");const N=S.from(H,M);if(N===void 0)throw new Error("Task is not valid");if(l.is(N.execution))await this.addCustomExecution(N,H,!1);else throw new s.NotSupportedError;const U=await this.getTaskExecution(await this._proxy.$getTaskExecution(N),H);return this._proxy.$executeTask(N).catch(V=>{throw new Error(V)}),U}provideTasksInternal(M,H,N,U){const V=[];if(U)for(let O of U){this.checkDeprecation(O,N),(!O.definition||!M[O.definition.type])&&this._logService.warn(`The task [${O.source}, ${O.name}] uses an undefined task type. The task will be ignored in the future.`);const W=S.from(O,N.extension);W&&l.is(W.execution)?(V.push(W),H.push(this.addCustomExecution(W,O,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:V,extension:N.extension}}async resolveTaskInternal(M){if(l.is(M.execution))return M;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(M,H){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,H,N){}};F=Ve([$e(0,c.IExtHostRpcService),$e(1,v.IExtHostInitDataService),$e(2,k.IExtHostWorkspace),$e(3,_.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,I.IExtHostTerminalService),$e(6,T.ILogService),$e(7,b.IExtHostApiDeprecationService)],F),e.WorkerExtHostTask=F,e.IExtHostTask=(0,h.createDecorator)("IExtHostTask")}),define(fe[270],me([0,1,15,59,31,81,24,10,9,23,8,13,2,146,177,119,44,128,269,33]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let s=class{constructor(f,d,S,A){this.configurationService=f,this.workspaceContextService=d,this.editorGroupsService=S,this.pathService=A}text(f,d,S={}){f=this.getContentPattern(f,S);const A=this.configurationService.getValue(),R=d&&d.some(x=>!this.configurationService.getValue({resource:x}).search.useRipgrep);return{...this.commonQuery(d?.map(E.toWorkspaceFolder),S),type:2,contentPattern:f,previewOptions:S.previewOptions,maxFileSize:S.maxFileSize,usePCRE2:A.search.usePCRE2||R||!1,beforeContext:S.beforeContext,afterContext:S.afterContext,userDisabledExcludesAndIgnoreFiles:S.disregardExcludeSettings&&S.disregardIgnoreFiles}}getContentPattern(f,d){const S=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const A={...f,wordSeparators:S.editor.wordSeparators};return this.isCaseSensitive(f,d)&&(A.isCaseSensitive=!0),this.isMultiline(f)&&(A.isMultiline=!0),A}file(f,d={}){return{...this.commonQuery(f,d),type:1,filePattern:d.filePattern?d.filePattern.trim():d.filePattern,exists:d.exists,sortByScore:d.sortByScore,cacheKey:d.cacheKey}}handleIncludeExclude(f,d){return f?(f=Array.isArray(f)?f.map(t):t(f),d?this.parseSearchPaths(f):{pattern:r(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],d={}){const S=this.handleIncludeExclude(d.includePattern,d.expandPatterns),A=this.handleIncludeExclude(d.excludePattern,d.expandPatterns),R=f.length>1,B=(S.searchPaths&&S.searchPaths.length?S.searchPaths.map($=>this.getFolderQueryForSearchPath($,d,A)):f.map($=>this.getFolderQueryForRoot($,d,A,R))).filter($=>!!$),x={_reason:d._reason,folderQueries:B,usingSearchPaths:!!(S.searchPaths&&S.searchPaths.length),extraFileResources:d.extraFileResources,excludePattern:A.pattern,includePattern:S.pattern,onlyOpenEditors:d.onlyOpenEditors,maxResults:d.maxResults};if(d.onlyOpenEditors){const M=g.coalesce(g.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(U=>U.resource)))).filter(N=>(0,o.pathIncludedInQuery)(x,N.fsPath)),H=this.commonQueryFromFileList(M);return{...x,...H}}const F=d.extraFileResources&&d.extraFileResources.filter($=>(0,o.pathIncludedInQuery)(x,$.fsPath));return x.extraFileResources=F&&F.length?F:void 0,x}commonQueryFromFileList(f){const d=[],S=new n.ResourceMap,A={};let R=!1;return f.forEach(B=>{if(B.scheme===k.Schemas.walkThrough)return;if((0,D.isAbsolutePath)(B)){const F=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:_.dirname(B.fsPath)});let $=S.get(F);$||(R=!0,$={folder:F,includePattern:{}},d.push($),S.set(F,$));const M=_.relative(F.fsPath,B.fsPath);(0,I.assertIsDefined)($.includePattern)[M.replace(/\\/g,"/")]=!0}else B.fsPath&&(R=!0,A[B.fsPath]=!0)}),{folderQueries:d,includePattern:A,usingSearchPaths:!0,excludePattern:R?void 0:{"**/*":!0}}}isCaseSensitive(f,d){if(d.isSmartCase){if(f.isRegExp){if(P.containsUppercaseCharacter(f.pattern,!0))return!0}else if(P.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,v.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const d=H=>_.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),A=(Array.isArray(f)?f:m(f)).map(H=>{const N=this.pathService.resolvedUserHome;return N?(0,C.untildify)(H,N.scheme===k.Schemas.file?N.fsPath:N.path):H}),R=L.groupBy(A,H=>d(H)?"searchPaths":"exprSegments"),B=(R.exprSegments||[]).map(H=>P.rtrim(H,"/")).map(H=>P.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),i(H))),x={},F=this.expandSearchPathPatterns(R.searchPaths||[]);F&&F.length&&(x.searchPaths=F);const $=g.flatten(B),M=r(...$);return M&&(x.pattern=M),x}getExcludesForFolder(f,d){return d.disregardExcludeSettings?void 0:(0,o.getExcludes)(f,!d.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const d=g.flatten(f.map(A=>{let{pathPortion:R,globPortion:B}=p(A);B&&(B=u(B));const x=this.expandOneSearchPath(R);return g.flatten(x.map(F=>this.resolveOneSearchPathPattern(F,B)))})),S=new Map;return d.forEach(A=>{const R=A.searchPath.toString(),B=S.get(R);B?A.pattern&&(B.pattern=B.pattern||{},B.pattern[A.pattern]=!0):S.set(R,{searchPath:A.searchPath,pattern:A.pattern?r(A.pattern):void 0})}),Array.from(S.values())}expandOneSearchPath(f){if(_.isAbsolute(f)){const d=this.workspaceContextService.getWorkspace().folders;return d[0]&&d[0].uri.scheme!==k.Schemas.file?[{searchPath:d[0].uri.with({path:f})}]:[{searchPath:c.URI.file(_.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const d=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=t(f),f.startsWith("../")||f===".."){const A=_.posix.resolve(d.path,f);return[{searchPath:d.with({path:A})}]}const S=u(f);return[{searchPath:d,pattern:S}]}else{if(f==="./"||f===".\\")return[];{const d=f.replace(/^\.[\/\\]/,""),A=this.workspaceContextService.getWorkspace().folders.map(R=>{const B=d.match(new RegExp(`^${P.escapeRegExpCharacters(R.name)}(?:/(.*)|$)`));return B?{match:B,folder:R}:null}).filter(I.isDefined);if(A.length)return A.map(R=>{const B=R.match[1];return{searchPath:R.folder.uri,pattern:B&&u(B)}});{const R=f.match(/\.[\/\\](.+)[\/\\]?/),B=R?R[1]:f,x=h.localize(0,null,B);throw new Error(x)}}}}resolveOneSearchPathPattern(f,d){const S=f.pattern&&d?`${f.pattern}/${d}`:f.pattern||d,A=[{searchPath:f.searchPath,pattern:S}];return S&&!S.endsWith("**")&&A.push({searchPath:f.searchPath,pattern:S+"/**"}),A}getFolderQueryForSearchPath(f,d,S){const A=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(f.searchPath),d,S,!1);return A?{...A,includePattern:f.pattern}:null}getFolderQueryForRoot(f,d,S,A){let R;const B=c.URI.isUri(f)?f:f.uri;if(S.searchPaths){const H=S.searchPaths.filter(N=>(0,D.isEqual)(N.searchPath,B))[0];if(H&&!H.pattern)return null;H&&(R=H.pattern)}const x=this.configurationService.getValue({resource:B}),$={...this.getExcludesForFolder(x,d)||{},...R||{}},M=c.URI.isUri(f)?(0,D.basename)(f):f.name;return{folder:B,folderName:A?M:void 0,excludePattern:Object.keys($).length>0?$:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof d.disregardIgnoreFiles=="boolean"?d.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof d.disregardGlobalIgnoreFiles=="boolean"?d.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof d.ignoreSymlinks=="boolean"?d.ignoreSymlinks:!x.search.followSymlinks}}};s=Ve([$e(0,w.IConfigurationService),$e(1,E.IWorkspaceContextService),$e(2,T.IEditorGroupsService),$e(3,b.IPathService)],s),e.QueryBuilder=s;function p(l){const f=l.match(/[\*\{\}\(\)\[\]\?]/);if(f){const d=f.index,S=l.substr(0,d).match(/[/|\\][^/\\]*$/);if(S){let A=l.substr(0,S.index);return A.match(/[/\\]/)||(A+="/"),{pathPortion:A,globPortion:l.substr((S.index||0)+1)}}}return{pathPortion:l}}function r(...l){return l.length?l.reduce((f,d)=>(f[d]=!0,f),Object.create(null)):void 0}function m(l){return y.splitGlobAware(l,",").map(f=>f.trim()).filter(f=>!!f.length)}function i(l){return[`**/${l}/**`,`**/${l}`].map(d=>d.replace(/\*\*\/\*\*/g,"**"))}function t(l){return l.replace(/\\/g,"/")}function u(l){return t(l).replace(/^\.\//,"").replace(/\/+$/g,"")}function a(l,f){l=g.distinct(l,A=>A.toString());const d=[],S=f.getWorkspace();return l&&l.forEach(A=>{let R;if(f.getWorkbenchState()===2)R=(0,D.relativePath)(S.folders[0].uri,A),R&&R!=="."&&(R="./"+R);else{const B=f.getWorkspaceFolder(A);if(B){const x=B.name;if(S.folders.filter($=>$.name===x).length===1){const $=(0,D.relativePath)(B.uri,A);$===""?R=`./${B.name}`:R=`./${B.name}/${$}`}else R=A.fsPath}}R&&d.push(R)}),d}e.resolveResourcesForSearchIncludes=a}),define(fe[271],me([0,1,23,2,21,18,4,270,33,44]),function(Y,e,g,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const P=7e3;function I(w,E){const T=E.activationEvents;if(!T)return Promise.resolve(void 0);const b=[],o=[];for(const t of T)if(/^workspaceContains:/.test(t)){const u=t.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||w.forceUsingSearch?o.push(u):b.push(u)}if(b.length===0&&o.length===0)return Promise.resolve(void 0);let s;const p=new Promise((t,u)=>{s=t}),r=t=>s({activationEvent:t}),m=Promise.all(b.map(t=>c(w,t,r))).then(()=>{}),i=v(w,E.identifier,o,r);return Promise.all([m,i]).then(()=>{s(void 0)}),p}e.checkActivateWorkspaceContainsExtension=I;async function c(w,E,T){for(const b of w.folders)if(await w.exists(g.joinPath(L.URI.revive(b),E))){T(`workspaceContains:${E}`);return}}async function v(w,E,T,b){if(T.length===0)return Promise.resolve(void 0);const o=new y.CancellationTokenSource,s=w.checkExists(w.folders,T,o.token),p=setTimeout(async()=>{o.cancel(),b(`workspaceContainsTimeout:${T.join(",")}`)},P);let r=!1;try{r=await s}catch(m){C.isPromiseCanceledError(m)||C.onUnexpectedError(m)}o.dispose(),clearTimeout(p),r&&b(`workspaceContains:${T.join(",")}`)}function h(w,E,T,b){const o=w.get(n.IInstantiationService),s=w.get(_.ISearchService),r=o.createInstance(k.QueryBuilder).file(E.map(m=>(0,D.toWorkspaceFolder)(L.URI.revive(m))),{_reason:"checkExists",includePattern:T,exists:!0});return s.fileSearch(r,b).then(m=>!!m.limitHit,m=>C.isPromiseCanceledError(m)?!1:Promise.reject(m))}e.checkGlobFileExists=h});var st=this&&this.__classPrivateFieldSet||function(Y,e,g,L,y){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!y)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!y:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?y.call(Y,g):y?y.value=g:e.set(Y,g),g},Oe=this&&this.__classPrivateFieldGet||function(Y,e,g,L){if(g==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?L:g==="a"?L.call(Y):L?L.value:e.get(Y)};define(fe[41],me([0,1,165,9,74,23,16,6,24,2,11,5,37,229,92,36,29,227,18,27,22,201,7,120,4,26,70,14,86,54,34,3,271,91,203,10]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b,o,s,p,r,m,i,t,u,a,l,f,d,S,A,R,B,x){"use strict";var F,$,M;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,i.createDecorator)("IHostUtils");let H=class zn extends k.Disposable{constructor(O,W,j,X,Q,de,Se,De,Pe,Be){super();this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=W,this._extHostContext=j,this._initData=Se,this._extHostWorkspace=X,this._extHostConfiguration=Q,this._logService=de,this._extHostTunnelService=Pe,this._extHostTerminalService=Be,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new n.Barrier,this._readyToStartExtensionHost=new n.Barrier,this._readyToRunExtensions=new n.Barrier,this._eagerExtensionsActivated=new n.Barrier,this._registry=new T.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new h.ExtHostStorage(this._extHostContext),this._secretState=new R.ExtHostSecretState(this._extHostContext),this._storagePath=De,this._instaService=O.createChild(new l.ServiceCollection([h.IExtHostStorage,this._storage],[R.IExtHostSecretState,this._secretState]));const We=new Set;this._initData.hostExtensions.forEach(He=>We.add(o.ExtensionIdentifier.toKey(He))),this._activator=new v.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,G,ee)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,b.transformErrorForSerialization(G),ee)},actualActivateExtension:async(He,G)=>{if(We.has(o.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,G),new v.HostExtension;const ee=this._registry.getExtensionDescription(He);return this._activateExtension(ee,G)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),y.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(O){b.onUnexpectedError(O)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let O=[];try{O=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(W){}await Promise.all(O)}isActivated(O){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(O):!1}_activateByEvent(O,W){return this._activator.activateByEvent(O,W)}_activateById(O,W){return this._activator.activateById(O,W)}activateByIdWithErrors(O,W){return this._activateById(O,W).then(()=>{const j=this._activator.getActivatedExtension(O);if(j.activationFailed)return Promise.reject(j.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(O=>this._registry)}getExtensionExports(O){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(O).exports:null}async _realPathExtensionUri(O){if(O.scheme!==x.Schemas.file)return O;const W=await this._hostUtils.realpath(O.fsPath);return D.URI.file(W)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const O=_.TernarySearchTree.forUris(W=>C.extUriBiasedIgnorePathCase.ignorePathCasing(W));for(const W of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(W)){const j=await this._realPathExtensionUri(W.extensionLocation);O.set(j,W)}return O})()),this._extensionPathIndex}_deactivate(O){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(O))return W;const j=this._activator.getActivatedExtension(O);if(!j)return W;try{typeof j.module.deactivate=="function"&&(W=Promise.resolve(j.module.deactivate()).then(void 0,X=>(this._logService.error(X),Promise.resolve(void 0))))}catch(X){this._logService.error(X)}try{(0,k.dispose)(j.subscriptions)}catch(X){this._logService.error(X)}return W}async _activateExtension(O,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(O.identifier),this._doActivateExtension(O,W).then(j=>{const X=j.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(O.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,W),this._logExtensionActivationTimes(O,W,"success",X),j},j=>{throw this._logExtensionActivationTimes(O,W,"failure"),j})}_logExtensionActivationTimes(O,W,j,X){const Q=N(O,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Q,...X||{},outcome:j})}_doActivateExtension(O,W){const j=N(O,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",j);const X=this._getEntryPoint(O);if(!X)return Promise.resolve(new v.EmptyExtension(v.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${O.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${O.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this._logService.flush();const Q=new v.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(O.identifier,(0,C.joinPath)(O.extensionLocation,X),Q),this._loadExtensionContext(O)]).then(de=>(y.mark(`code/extHost/willActivateExtension/${O.identifier.value}`),zn._callActivate(this._logService,O.identifier,de[0],de[1],Q))).then(de=>(y.mark(`code/extHost/didActivateExtension/${O.identifier.value}`),de))}_loadExtensionContext(O){const W=new p.ExtensionGlobalMemento(O,this._storage),j=new p.ExtensionMemento(O.identifier.value,!1,this._storage),X=new B.ExtensionSecrets(O,this._secretState),Q=O.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,de=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${O.identifier.value}`),Promise.all([W.whenReady,j.whenReady,this._storagePath.whenReady]).then(()=>{const Se=this;let De;return Object.freeze({globalState:W,workspaceState:j,secrets:X,subscriptions:[],get extensionUri(){return O.extensionLocation},get extensionPath(){return O.extensionLocation.fsPath},asAbsolutePath(Pe){return L.join(O.extensionLocation.fsPath,Pe)},get storagePath(){return Se._storagePath.workspaceValue(O)?.fsPath},get globalStoragePath(){return Se._storagePath.globalValue(O).fsPath},get logPath(){return L.join(Se._initData.logsLocation.fsPath,O.identifier.value)},get logUri(){return D.URI.joinPath(Se._initData.logsLocation,O.identifier.value)},get storageUri(){return Se._storagePath.workspaceValue(O)},get globalStorageUri(){return Se._storagePath.globalValue(O)},get extensionMode(){return Q},get extension(){return De===void 0&&(De=new U(Se,O.identifier,O,de)),De},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(O,"extensionRuntime"),Se.extensionRuntime},get environmentVariableCollection(){return Se._extHostTerminalService.getEnvironmentVariableCollection(O)}})})}static _callActivate(O,W,j,X,Q){return j=j||{activate:void 0,deactivate:void 0},this._callActivateOptional(O,W,j,X,Q).then(de=>new v.ActivatedExtension(!1,null,Q.build(),j,de,X.subscriptions))}static _callActivateOptional(O,W,j,X,Q){if(typeof j.activate=="function")try{Q.activateCallStart(),O.trace(`ExtensionService#_callActivateOptional ${W.value}`);const de=typeof global=="object"?global:self,Se=j.activate.apply(de,[X]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(Se).then(De=>(Q.activateResolveStop(),De))}catch(de){return Promise.reject(de)}else return Promise.resolve(j)}_activateOneStartupFinished(O,W){this._activateById(O.identifier,{startup:!1,extensionId:O.identifier,activationEvent:W}).then(void 0,j=>{this._logService.error(j)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(y.getMarks());for(const O of this._registry.getAllExtensionDescriptions())if(O.activationEvents)for(const W of O.activationEvents)W==="onStartupFinished"&&this._activateOneStartupFinished(O,W)}_handleEagerExtensions(){const O=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],j=this._handleWorkspaceContainsEagerExtensions(W),X=Promise.all([O,j]).then(()=>{});return Promise.race([X,(0,n.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(O){return O.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(O,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(O,W){if(this.isActivated(W.identifier))return;const j=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:O.map(de=>de.uri),forceUsingSearch:j,exists:de=>this._hostUtils.exists(de.fsPath),checkExists:(de,Se,De)=>this._mainThreadWorkspaceProxy.$checkExists(de,Se,De)},Q=await(0,A.checkActivateWorkspaceContainsExtension)(X,W);if(!!Q)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:Q.activationEvent}).then(void 0,de=>this._logService.error(de))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(O){throw console.error(O),O}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:O,extensionTestsLocationURI:W}=this._initData.environment;if(!O||!W)throw new Error(g.localize(0,null));const j=await this._loadCommonJSModule(null,W,new v.ExtensionActivationTimesBuilder(!1));if(!j||typeof j.run!="function")throw new Error(g.localize(1,null,W.toString()));return new Promise((X,Q)=>{const de=(Pe,Be)=>{Pe?Q(Pe):X(typeof Be=="number"&&Be>0?1:0)},Se=(0,C.originalFSPath)(W),De=j.run(Se,de);De&&De.then&&De.then(()=>{X(0)}).catch(Pe=>{Q(Pe.toString())})})}async $extensionTestsExit(O){this._logService.info(`Extension host terminating: test runner requested exit with code ${O}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${O}`),this._logService.flush(),this._hostUtils.exit(O)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(O,W){return this._resolvers[O]=W,(0,k.toDisposable)(()=>{delete this._resolvers[O]})}async _activateAndGetResolver(O){const W=O.indexOf("+");if(W===-1)throw new Error("Not an authority that can be resolved!");const j=O.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${j}`,!1),{authorityPrefix:j,resolver:this._resolvers[j]}}async $resolveAuthority(O,W){const{authorityPrefix:j,resolver:X}=await this._activateAndGetResolver(O);if(!X)return{type:"error",error:{code:m.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${j}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(X)),y.mark(`code/extHost/willResolveAuthority/${j}`);const Q=await X.resolve(O,{resolveAttempt:W});y.mark(`code/extHost/didResolveAuthorityOK/${j}`);const de={authority:O,host:Q.host,port:Q.port,connectionToken:Q.connectionToken},Se={extensionHostEnv:Q.extensionHostEnv,isTrusted:Q.isTrusted};return{type:"ok",value:{authority:de,options:Se,tunnelInformation:{environmentTunnels:Q.environmentTunnels}}}}catch(Q){if(y.mark(`code/extHost/didResolveAuthorityError/${j}`),Q instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q}}async $getCanonicalURI(O,W){const{authorityPrefix:j,resolver:X}=await this._activateAndGetResolver(O);if(!X)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${j}`);const Q=D.URI.revive(W);if(typeof X.getCanonicalURI=="undefined")return Q;const de=await(0,n.asPromise)(()=>X.getCanonicalURI(Q));return de||Q}$startExtensionHost(O){return this._registry.keepOnly(O),this._startExtensionHost()}$activateByEvent(O,W){return W===1?this._activateByEvent(O,!1):this._readyToRunExtensions.wait().then(j=>this._activateByEvent(O,!1))}async $activate(O,W){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(O)?(await this._activateById(O,W),!0):!1}async $deltaExtensions(O,W){O.forEach(X=>X.extensionLocation=D.URI.revive(X.extensionLocation));const j=await this.getExtensionPathIndex();return await Promise.all(W.map(async X=>{const Q=this._registry.getExtensionDescription(X);Q&&j.delete(await this._realPathExtensionUri(Q.extensionLocation))})),await Promise.all(O.map(async X=>{const Q=await this._realPathExtensionUri(X.extensionLocation);j.set(Q,X)})),this._registry.deltaExtensions(O,W),Promise.resolve(void 0)}async $test_latency(O){return O}async $test_up(O){return O.byteLength}async $test_down(O){let W=s.VSBuffer.alloc(O),j=Math.random()%256;for(let X=0;X<O;X++)W.writeUInt8(j,X);return W}async $updateRemoteConnectionData(O){this._remoteConnectionData=O,this._onDidChangeRemoteConnectionData.fire()}};H=Ve([$e(0,i.IInstantiationService),$e(1,e.IHostUtils),$e(2,a.IExtHostRpcService),$e(3,w.IExtHostWorkspace),$e(4,c.IExtHostConfiguration),$e(5,P.ILogService),$e(6,t.IExtHostInitDataService),$e(7,u.IExtensionStoragePaths),$e(8,f.IExtHostTunnelService),$e(9,d.IExtHostTerminalService)],H),e.AbstractExtHostExtensionService=H;function N(V,O){return{id:V.identifier.value,name:V.name,extensionVersion:V.version,publisherDisplayName:V.publisher,activationEvents:V.activationEvents?V.activationEvents.join(","):null,isBuiltin:V.isBuiltin,reason:O.activationEvent,reasonId:O.extensionId.value}}e.IExtHostExtensionService=(0,i.createDecorator)("IExtHostExtensionService");class U{constructor(O,W,j,X){F.set(this,void 0),$.set(this,void 0),M.set(this,void 0),st(this,F,O,"f"),st(this,$,W,"f"),st(this,M,j.identifier,"f"),this.id=j.identifier.value,this.extensionUri=j.extensionLocation,this.extensionPath=L.normalize((0,C.originalFSPath)(j.extensionLocation)),this.packageJSON=j,this.extensionKind=X}get isActive(){return Oe(this,F,"f").isActivated(Oe(this,M,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,F,"f").getExtensionExports(Oe(this,M,"f"))}activate(){return Oe(this,F,"f").activateByIdWithErrors(Oe(this,M,"f"),{startup:!1,extensionId:Oe(this,$,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=U,F=new WeakMap,$=new WeakMap,M=new WeakMap}),define(fe[57],me([0,1,9,2,3,16,5,7,124,36,41,46,218,37,211,14,4,13,38,56]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let s=class{constructor(l,f,d,S,A,R){this._workspaceService=f,this._extensionService=d,this._editorsService=S,this._configurationService=A,this._editorTabs=R,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new y.Emitter,this._onDidTerminateDebugSession=new y.Emitter,this._onDidChangeActiveDebugSession=new y.Emitter,this._onDidReceiveDebugSessionCustomEvent=new y.Emitter,this._debugServiceProxy=l.getProxy(n.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new y.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new r(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(x=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,f){const d=l;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let S=`debug:${encodeURIComponent(d.path||"")}`,A="?";return f&&(S+=`${A}session=${encodeURIComponent(f.id)}`,A="&"),S+=`${A}ref=${d.sourceReference}`,L.URI.parse(S)}else{if(d.path)return L.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const f=[];for(const d of l.getAllExtensionDescriptions())if(d.contributes){const S=d.contributes.debuggers;if(S&&S.length>0)for(const A of S)(0,h.isDebuggerMainContribution)(A)&&f.push(A.type)}this._debugServiceProxy.$registerDebugTypes(f)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(f=>l.push(f)),l}addBreakpoints(l){this.startBreakpoints();const f=l.filter(A=>{const R=A.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,A),!0)});this.fireBreakpointChanges(f,[],[]);const d=[],S=new Map;for(const A of f)if(A instanceof k.SourceBreakpoint){let R=S.get(A.location.uri.toString());R||(R={type:"sourceMulti",uri:A.location.uri,lines:[]},S.set(A.location.uri.toString(),R),d.push(R)),R.lines.push({id:A.id,enabled:A.enabled,condition:A.condition,hitCondition:A.hitCondition,logMessage:A.logMessage,line:A.location.range.start.line,character:A.location.range.start.character})}else A instanceof k.FunctionBreakpoint&&d.push({type:"function",id:A.id,enabled:A.enabled,hitCondition:A.hitCondition,logMessage:A.logMessage,condition:A.condition,functionName:A.functionName});return this._debugServiceProxy.$registerBreakpoints(d)}removeBreakpoints(l){this.startBreakpoints();const f=l.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],f,[]);const d=f.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),S=f.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),A=f.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(d,S,A)}startDebugging(l,f,d){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,f,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,debugUI:d.debugUI,suppressSaveBeforeStart:d.suppressSaveBeforeStart})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,f,d){if(!f)return new k.Disposable(()=>{});const S=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:S,provider:f}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,d,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,S),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(A=>A.provider!==f),this._debugServiceProxy.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(l,f,d){if(!d)return new k.Disposable(()=>{});if(!this.definesDebugType(l,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.getAdapterDescriptorFactoryByType(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:f,handle:S,factory:d}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(f,S),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(A=>A.factory!==d),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(l,f){if(!f)return new k.Disposable(()=>{});const d=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:d,factory:f}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(S=>S.factory!==f)})}async $runInTerminal(l,f){return Promise.resolve(void 0)}async $substituteVariables(l,f){if(!this._variableResolver){const[A,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(A||[],this._editorsService,R)}let d;const S=await this.getFolder(l);return S&&(d={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(d,f)}createDebugAdapter(l,f){if(l.type==="implementation")return new t(l.implementation)}createSignService(){}async $startDASession(l,f){const d=this,S=await this.getSession(f);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(S.type),S).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const R=this.convertToDto(A),B=this.createDebugAdapter(R,S);if(!B)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const x=B;return this._debugAdapters.set(l,x),this.getDebugAdapterTrackers(S).then(F=>(F&&this._debugAdaptersTrackers.set(l,F),x.onMessage(async $=>{if($.type==="request"&&$.command==="handshake"){const M=$,H={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(M.arguments.value);H.body={signature:N},x.sendResponse(H)}else throw new Error("no signer")}catch(N){H.success=!1,H.message=N.message,x.sendResponse(H)}}else F&&F.onDidSendMessage&&F.onDidSendMessage($),$=(0,h.convertToVSCPaths)($,!0),d._debugServiceProxy.$acceptDAMessage(l,$)}),x.onError($=>{F&&F.onError&&F.onError($),this._debugServiceProxy.$acceptDAError(l,$.name,$.message,$.stack)}),x.onExit($=>{F&&F.onExit&&F.onExit((0,T.withNullAsUndefined)($),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,T.withNullAsUndefined)($),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),x.startSession()))})}$sendDAMessage(l,f){f=(0,h.convertToDAPaths)(f,!1);const d=this._debugAdaptersTrackers.get(l);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(f);const S=this._debugAdapters.get(l);S&&S.sendMessage(f)}$stopDASession(l){const f=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),f&&f.onWillStopSession&&f.onWillStopSession();const d=this._debugAdapters.get(l);return this._debugAdapters.delete(l),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const f=[],d=[],S=[];if(l.added)for(const A of l.added){const R=A.id;if(R&&!this._breakpoints.has(R)){let B;if(A.type==="function")B=new k.FunctionBreakpoint(A.functionName,A.enabled,A.condition,A.hitCondition,A.logMessage);else if(A.type==="data")B=new k.DataBreakpoint(A.label,A.dataId,A.canPersist,A.enabled,A.hitCondition,A.condition,A.logMessage);else{const x=L.URI.revive(A.uri);B=new k.SourceBreakpoint(new k.Location(x,new k.Position(A.line,A.character)),A.enabled,A.condition,A.hitCondition,A.logMessage)}B._id=R,this._breakpoints.set(R,B),f.push(B)}}if(l.removed)for(const A of l.removed){const R=this._breakpoints.get(A);R&&(this._breakpoints.delete(A),d.push(R))}if(l.changed){for(const A of l.changed)if(A.id){const R=this._breakpoints.get(A.id);if(R){if(R instanceof k.FunctionBreakpoint&&A.type==="function"){const B=R;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.functionName=A.functionName}else if(R instanceof k.SourceBreakpoint&&A.type==="source"){const B=R;B.enabled=A.enabled,B.condition=A.condition,B.hitCondition=A.hitCondition,B.logMessage=A.logMessage,B.location=new k.Location(L.URI.revive(A.uri),new k.Position(A.line,A.character))}S.push(R)}}}this.fireBreakpointChanges(f,d,S)}$provideDebugConfigurations(l,f,d){return(0,C.asPromise)(async()=>{const S=this.getConfigProviderByHandle(l);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const A=await this.getFolder(f);return S.provideDebugConfigurations(A,d)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(l,f,d,S){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(l);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(f);return A.resolveDebugConfiguration(R,d,S)})}$resolveDebugConfigurationWithSubstitutedVariables(l,f,d,S){return(0,C.asPromise)(async()=>{const A=this.getConfigProviderByHandle(l);if(!A)throw new Error("no DebugConfigurationProvider found");if(!A.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(f);return A.resolveDebugConfigurationWithSubstitutedVariables(R,d,S)})}async $provideDebugAdapter(l,f){const d=this.getAdapterDescriptorFactoryByHandle(l);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.getSession(f);return this.getAdapterDescriptor(d,S).then(A=>{if(!A)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.convertToDto(A)})}async $acceptDebugSessionStarted(l){const f=await this.getSession(l);this._onDidStartDebugSession.fire(f)}async $acceptDebugSessionTerminated(l){const f=await this.getSession(l);f&&(this._onDidTerminateDebugSession.fire(f),this._debugSessions.delete(f.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,f){const d=await this.getSession(l);d&&d._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(l,f){const S={session:await this.getSession(l),event:f.event,body:f.body};this._onDidReceiveDebugSessionCustomEvent.fire(S)}convertToDto(l){if(l instanceof k.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof k.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const f=this._adapterFactories.filter(d=>d.type===l);if(f.length>0)return f[0].factory}getAdapterDescriptorFactoryByHandle(l){const f=this._adapterFactories.filter(d=>d.handle===l);if(f.length>0)return f[0].factory}getConfigProviderByHandle(l){const f=this._configProviders.filter(d=>d.handle===l);if(f.length>0)return f[0].provider}definesDebugType(l,f){if(l.contributes){const d=l.contributes.debuggers;if(d&&d.length>0){for(const S of d)if(S.label&&S.type&&S.type===f)return!0}}return!1}getDebugAdapterTrackers(l){const d=l.configuration.type,S=this._trackerFactories.filter(A=>A.type===d||A.type==="*").map(A=>(0,C.asPromise)(()=>A.factory.createDebugAdapterTracker(l)).then(R=>R,R=>null));return Promise.race([Promise.all(S).then(A=>{const R=A.filter(B=>!!B);if(R.length>0)return new i(R)}),new Promise((A,R)=>{const B=setTimeout(()=>{clearTimeout(B),R(new Error("timeout"))},1e3)})]).catch(A=>{})}async getAdapterDescriptor(l,f){const d=f.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new k.DebugAdapterServer(d));if(l){const A=await this._extensionService.getExtensionRegistry();return(0,C.asPromise)(()=>l.createDebugAdapterDescriptor(f,this.daExecutableFromPackage(f,A))).then(R=>{if(R)return R})}const S=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(f,S))}daExecutableFromPackage(l,f){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,f,d){(l.length>0||f.length>0||d.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:f,changed:d}))}async getSession(l){if(l)if(typeof l=="string"){const f=this._debugSessions.get(l);if(f)return f}else{let f=this._debugSessions.get(l.id);if(!f){const d=await this.getFolder(l.folderUri),S=l.parent?this._debugSessions.get(l.parent):void 0;f=new p(this._debugServiceProxy,l.id,l.type,l.name,d,l.configuration,S),this._debugSessions.set(f.id,f),this._debugServiceProxy.$sessionCached(f.id)}return f}throw new Error("cannot find session")}getFolder(l){if(l){const f=L.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}};s=Ve([$e(0,w.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,v.IExtHostConfiguration),$e(5,o.IExtHostEditorTabs)],s),e.ExtHostDebugServiceBase=s;class p{constructor(l,f,d,S,A,R,B){this._debugServiceProxy=l,this._id=f,this._type=d,this._name=S,this._workspaceFolder=A,this._configuration=R,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}get parentSession(){return this._parentSession}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,f){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,f)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=p;class r{constructor(l){this.value=Object.freeze({append(f){l.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.ExtHostDebugConsole=r;class m extends c.AbstractVariableResolverService{constructor(l,f,d,S,A){function R(){if(f){const B=f.activeEditor();if(B)return B.document.uri;const x=S.tabs.filter(F=>F.isActive);if(x.length>0){const F=x[0].resource;return F&&(F.primary||F.secondary)?F.primary??F.secondary:x[0].resource}}}super({getFolderUri:B=>{const x=l.filter(F=>F.name===B);if(x&&x.length>0)return x[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(B,x)=>d.getConfiguration(void 0,B).get(x),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=R();if(B)return g.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(A){const B=R();if(B){const x=A.getWorkspaceFolder(B);if(x)return g.normalize(x.uri.fsPath)}}},getSelectedText:()=>{if(f){const B=f.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(f){const B=f.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=m;class i{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(f=>f.onError?f.onError(l):void 0)}onExit(l,f){this.trackers.forEach(d=>d.onExit?d.onExit(l,f):void 0)}}class t extends _.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends s{constructor(l,f,d,S,A,R){super(l,f,d,S,A,R)}createVariableResolver(l,f,d){return new m(l,f,d,this._editorTabs)}};u=Ve([$e(0,w.IExtHostRpcService),$e(1,D.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,I.IExtHostDocumentsAndEditors),$e(4,v.IExtHostConfiguration),$e(5,o.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(fe[272],me([0,1,74,2,5,37,29,27,14,26,4,41,38,11]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(o,s,p,r,m,i,t){this._apiFactory=o,this._extensionRegistry=s,this._instaService=p,this._extHostConfiguration=r,this._extHostExtensionService=m,this._initData=i,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const o=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new w(this._apiFactory,s,this._extensionRegistry,o,this._logService)),this.register(this._instaService.createInstance(E,s)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(T,s,this._initData.environment.appUriScheme))}register(o){if(Array.isArray(o.nodeModuleName))for(let s of o.nodeModuleName)this._factories.set(s,o);else this._factories.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this._alternatives.push(s=>o.alternativeModuleName(s))}};h=Ve([$e(2,P.IInstantiationService),$e(3,C.IExtHostConfiguration),$e(4,I.IExtHostExtensionService),$e(5,D.IExtHostInitDataService),$e(6,v.ILogService)],h),e.RequireInterceptor=h;class w{constructor(o,s,p,r,m){this._apiFactory=o,this._extensionPaths=s,this._extensionRegistry=p,this._configProvider=r,this._logService=m,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(o,s){const p=this._extensionPaths.findSubstr(s);if(p){let r=this._extApiImpl.get(k.ExtensionIdentifier.toKey(p.identifier));return r||(r=this._apiFactory(p,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(p.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((m,i)=>r+=`	${i} -> ${m.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(n.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(o,s,p){this._extensionPaths=o,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(y.MainContext.MainThreadTelemetry);const{environment:r}=p,m=s.getProxy(y.MainContext.MainThreadKeytar);if(r.appRoot){let i=r.appRoot.fsPath;c.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,t)=>m.$getPassword(i,t),setPassword:(i,t,u)=>m.$setPassword(i,t,u),deletePassword:(i,t)=>m.$deletePassword(i,t),findPassword:i=>m.$findPassword(i),findCredentials(i){return m.$findCredentials(i)}}}load(o,s){const p=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:p?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(o){const s=o.length;if(s<=7||!this.alternativeNames)return;const p=s-7;if((o.charAt(p)==="/"||o.charAt(p)==="\\")&&o.endsWith("keytar")&&(o=o.replace(/\\/g,"/"),this.alternativeNames.has(o)))return"keytar"}};E=Ve([$e(1,_.IExtHostRpcService),$e(2,D.IExtHostInitDataService)],E);let T=class{constructor(o,s,p){this._extensionPaths=o,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=p.getProxy(y.MainContext.MainThreadTelemetry);const r=p.getProxy(y.MainContext.MainThreadWindow);this._impl=(m,i)=>{const t=L.URI.parse(m);return i?this.callOriginal(m,i):t.scheme==="http"||t.scheme==="https"?r.$openUri(t,m,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?r.$openUri(t,m,{}):this.callOriginal(m,i)}}load(o,s,p){const r=this._extensionPaths.findSubstr(s);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=p(o),this._impl}callOriginal(o,s){return this.sendNoForwardTelemetry(),this._original(o,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};T=Ve([$e(2,_.IExtHostRpcService)],T)}),define(fe[273],me([0,1,171,12,7,212,36,41,46,37,34,14,57,196,16,213,56]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let T=class extends c.ExtHostDebugServiceBase{constructor(s,p,r,m,i,t,u){super(s,p,r,m,i,u);this._terminalService=t,this._integratedTerminalInstances=new b}createDebugAdapter(s,p){switch(s.type){case"server":return new C.SocketDebugAdapter(s);case"pipeServer":return new C.NamedPipeDebugAdapter(s);case"executable":return new C.ExecutableDebugAdapter(s,p.type)}return super.createDebugAdapter(s,p)}daExecutableFromPackage(s,p){const r=C.ExecutableDebugAdapter.platformAdapterExecutable(p.getAllExtensionDescriptions(),s.type);if(r)return new y.DebugAdapterExecutable(r.command,r.args,r.options)}createSignService(){return new v.SignService}async $runInTerminal(s,p){if(s.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(R=>{this._integratedTerminalInstances.onTerminalClosed(R)}));const r=await this._configurationService.getConfigProvider(),m=this._terminalService.getDefaultShell(!0),i=this._terminalService.getDefaultShellArgs(!0),t=s.title||g.localize(0,null),u=JSON.stringify({shell:m,shellArgs:i});let a=await this._integratedTerminalInstances.checkout(u,t),l,f=!1;if(a)l=s.cwd;else{const R={shellPath:m,shellArgs:i,cwd:s.cwd,name:t,iconPath:new y.ThemeIcon("debug")};f=!0,a=this._terminalService.createTerminalFromOptions(R,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(a,u)}a.show(!0);const d=await a.processId;f?await new Promise(R=>setTimeout(R,1e3)):r.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(m.indexOf("powershell")>=0||m.indexOf("pwsh")>=0||m.indexOf("cmd.exe")>=0?a.sendText("cls"):m.indexOf("bash")>=0?a.sendText("clear"):L.isWindows?a.sendText("cls"):a.sendText("clear"));const S=(0,w.prepareCommand)(m,s.args,l,s.env);a.sendText(S);const A=this.onDidTerminateDebugSession(R=>{R.id===p&&(this._integratedTerminalInstances.free(a),A.dispose())});return d}else if(s.kind==="external")return(0,w.runInExternalTerminal)(s,await this._configurationService.getConfigProvider());return super.$runInTerminal(s,p)}createVariableResolver(s,p,r){return new c.ExtHostVariableResolverService(s,p,r,this._editorTabs,this._workspaceService)}};T=Ve([$e(0,I.IExtHostRpcService),$e(1,n.IExtHostWorkspace),$e(2,k.IExtHostExtensionService),$e(3,_.IExtHostDocumentsAndEditors),$e(4,D.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,E.IExtHostEditorTabs)],T),e.ExtHostDebugService=T;class b{constructor(){this._terminalInstances=new Map}async checkout(s,p){const m=[...this._terminalInstances.entries()].map(([i,t])=>(0,h.createCancelablePromise)(async u=>{if(i.name!==p||t.lastUsedAt!==-1&&await(0,w.hasChildProcesses)(await i.processId))return null;const a=Date.now();return t.lastUsedAt+b.minUseDelay>a||u.isCancellationRequested||t.config!==s?null:(t.lastUsedAt=a,i)}));return await(0,h.firstParallel)(m,i=>!!i)}insert(s,p){this._terminalInstances.set(s,{lastUsedAt:Date.now(),config:p})}free(s){const p=this._terminalInstances.get(s);p&&(p.lastUsedAt=-1)}onTerminalClosed(s){this._terminalInstances.delete(s)}}b.minUseDelay=1e3}),define(fe[274],me([0,1,9,2,113,36,57,46,37,44,34,14,26,73,10,11,68,56,23,82]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let s=class extends v.ExtHostTaskBase{constructor(r,m,i,t,u,a,l,f,d){super(r,m,i,t,u,a,l,f);this.workspaceService=i,this.editorTabs=d,m.remote.isRemote&&m.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:m.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(r,m){const i=m;if(!m.execution&&i._id===void 0)throw new Error("Tasks to execute must include an execution");if(i._id!==void 0){const t=v.TaskHandleDTO.from(i,this.workspaceService),u=await this._proxy.$getTaskExecution(t);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.getTaskExecution(u,m);return this._proxy.$executeTask(t).catch(()=>{}),a}else{const t=v.TaskDTO.from(m,r);if(t===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,m,!1);const u=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),m);return this._proxy.$executeTask(t).catch(()=>{}),u}}provideTasksInternal(r,m,i,t){const u=[];if(t)for(let a of t){this.checkDeprecation(a,i),(!a.definition||!r[a.definition.type])&&this._logService.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const l=v.TaskDTO.from(a,i.extension);l&&(u.push(l),v.CustomExecutionDTO.is(l.execution)&&m.push(this.addCustomExecution(l,a,!0)))}return{tasks:u,extension:i.extension}}async resolveTaskInternal(r){return r}async getVariableResolver(r){if(this._variableResolver===void 0){const m=await this._configurationService.getConfigProvider();this._variableResolver=new n.ExtHostVariableResolverService(r,this._editorService,m,this.editorTabs,this.workspaceService)}return this._variableResolver}async getAFolder(r){let m=r&&r.length>0?r[0]:void 0;if(!m){const i=L.URI.file((0,o.homedir)());m=new D.WorkspaceFolder({uri:i,name:b.basename(i),index:0})}return{uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(r,m){const i=L.URI.revive(r),t={process:void 0,variables:Object.create(null)},u=await this._workspaceProvider.resolveWorkspaceFolder(i),a=await this._workspaceProvider.getWorkspaceFolders2()??[],l=await this.getVariableResolver(a),f=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.getAFolder(a);for(let d of m.variables)t.variables[d]=await l.resolveAsync(f,d);if(m.process!==void 0){let d;if(m.process.path!==void 0){d=m.process.path.split(g.delimiter);for(let S=0;S<d.length;S++)d[S]=await l.resolveAsync(f,d[S])}t.process=await y.win32.findExecutable(await l.resolveAsync(f,m.process.name),m.process.cwd!==void 0?await l.resolveAsync(f,m.process.cwd):void 0,d)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(r,m,i){return y.win32.findExecutable(r,m,i)}};s=Ve([$e(0,I.IExtHostRpcService),$e(1,c.IExtHostInitDataService),$e(2,C.IExtHostWorkspace),$e(3,k.IExtHostDocumentsAndEditors),$e(4,_.IExtHostConfiguration),$e(5,P.IExtHostTerminalService),$e(6,w.ILogService),$e(7,E.IExtHostApiDeprecationService),$e(8,T.IExtHostEditorTabs)],s),e.ExtHostTask=s}),define(fe[275],me([0,1,16,18,74,6,2,5,267,11,84,86,26,189,14,67,41,34]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(s,p,r,m){this._disposables=new C.DisposableStore,this._isTerminating=!1,this._hostUtils=r,this._rpcProtocol=new _.RPCProtocol(s,null,m),p=b._transform(p,this._rpcProtocol);const i=new I.ServiceCollection(...(0,P.getSingletonServiceDescriptors)());i.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...p}),i.set(h.IExtHostRpcService,new h.ExtHostRpcService(this._rpcProtocol)),i.set(w.IURITransformerService,new w.URITransformerService(m)),i.set(E.IHostUtils,r);const t=new v.InstantiationService(i,!0),u=t.invokeFunction(d=>d.get(T.IExtHostTerminalService));this._disposables.add(u),this._logService=t.invokeFunction(d=>d.get(D.ILogService)),y.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",p),this._extensionService=t.invokeFunction(d=>d.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const a=new WeakMap;this._extensionService.getExtensionPathIndex().then(d=>{Error.prepareStackTrace=(S,A)=>{let R="",B,x;for(const F of A)R+=`
	at ${F.toString()}`,x=F.getFileName(),!B&&x&&(B=d.findSubstr(n.URI.file(x)));return a.set(S,B),`${S.name||"Error"}: ${S.message||""}${R}`}});const l=this._rpcProtocol.getProxy(k.MainContext.MainThreadExtensionService),f=this._rpcProtocol.getProxy(k.MainContext.MainThreadErrors);L.setUnexpectedErrorHandler(d=>{const S=L.transformErrorForSerialization(d),A=a.get(d);A?l.$onExtensionRuntimeError(A.identifier,S):f.$onUnexpectedError(S)})}terminate(s){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${s}`),this._logService.flush(),this._disposables.dispose(),L.setUnexpectedErrorHandler(r=>{this._logService.error(r)}),this._rpcProtocol.dispose();const p=this._extensionService.deactivateAll();Promise.race([(0,g.timeout)(5e3),p]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(s,p){s.extensions.forEach(m=>m.extensionLocation=n.URI.revive(p.transformIncomingURIs(m.extensionLocation))),s.environment.appRoot=n.URI.revive(p.transformIncomingURIs(s.environment.appRoot));const r=s.environment.extensionDevelopmentLocationURI;return r&&(s.environment.extensionDevelopmentLocationURI=r.map(m=>n.URI.revive(p.transformIncomingURIs(m)))),s.environment.extensionTestsLocationURI=n.URI.revive(p.transformIncomingURIs(s.environment.extensionTestsLocationURI)),s.environment.globalStorageHome=n.URI.revive(p.transformIncomingURIs(s.environment.globalStorageHome)),s.environment.workspaceStorageHome=n.URI.revive(p.transformIncomingURIs(s.environment.workspaceStorageHome)),s.logsLocation=n.URI.revive(p.transformIncomingURIs(s.logsLocation)),s.logFile=n.URI.revive(p.transformIncomingURIs(s.logFile)),s.workspace=p.transformIncomingURIs(s.workspace),s}}e.ExtensionHostMain=b}),define(fe[276],me([0,1,9,21,52,31,23,47,33]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(c,v,h){this.config=c,this.provider=v,this.sessionToken=h,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&C.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&C.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const v=this.config.folderQueries||[];return new Promise((h,w)=>{const E=T=>{this.resultCount++,c(T)};if(this.isCanceled)return h({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(T=>{const b=T.toString(),o=g.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,o)||this.matchFile(E,{base:T,basename:o})}),Promise.all(v.map(T=>this.searchInFolder(T,E))).then(T=>{h({limitHit:this.isLimitHit,stats:T[0]||void 0})},T=>{w(new Error((0,y.toErrorMessage)(T)))})})}async searchInFolder(c,v){const h=new L.CancellationTokenSource,w=this.getSearchOptionsForFolder(c),E=this.initDirectoryTree(),T=new _.QueryGlobTester(this.config,c),b=!T.hasSiblingExcludeClauses();let o;try{this.activeCancellationTokens.add(h),o=k.StopWatch.create();const s=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},w,h.token),p=o.elapsed(),r=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(s&&s.forEach(m=>{const i=g.posix.relative(c.folder.path,m.path);if(b){const t=g.basename(m.path);this.matchFile(v,{base:c.folder,relativePath:i,basename:t});return}this.addDirectoryEntries(E,c.folder,i,v)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,T,v),{providerTime:p,postProcessTime:r.elapsed()})}finally{h.dispose(),this.activeCancellationTokens.delete(h)}}getSearchOptionsForFolder(c){const v=(0,_.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),h=(0,_.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:h,includes:v,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},v,h,w){if(h===this.filePattern){const T=g.basename(this.filePattern);this.matchFile(w,{base:v,relativePath:this.filePattern,basename:T})}function E(T){const b=g.basename(T),o=g.dirname(T);let s=c[o];s||(s=c[o]=[],E(o)),s.push({base:v,relativePath:T,basename:b})}E(h)}matchDirectoryTree({rootEntries:c,pathToEntries:v},h,w){const E=this,T=this.filePattern;function b(o){const s=C.hasSiblingFn(()=>o.map(p=>p.basename));for(let p=0,r=o.length;p<r;p++){const m=o[p],{relativePath:i,basename:t}=m;if(h.matchesExcludesSync(i,t,T!==t?s:void 0))continue;const u=v[i];if(u)b(u);else{if(i===T)continue;E.matchFile(w,m)}if(E.isLimitHit)break}}b(c)}matchFile(c,v){(!this.includePattern||v.relativePath&&this.includePattern(v.relativePath,v.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(v))}}class P{constructor(){this.sessions=new Map}fileSearch(c,v,h,w){const E=this.getSessionTokenSource(c.cacheKey),T=new D(c,v,E&&E.token);let b=0;const o=s=>{b+=s.length,h(s.map(p=>this.rawMatchToSearchItem(p)))};return this.doSearch(T,P.BATCH_SIZE,o,w).then(s=>({limitHit:s.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:s.stats}}))}clearCache(c){const v=this.getSessionTokenSource(c);v&&v.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new L.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:n.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,v,h,w){w.onCancellationRequested(()=>{c.cancel()});const E=b=>{b&&(T.push(b),v>0&&T.length>=v&&(h(T),T=[]))};let T=[];return c.search(E).then(b=>(T.length&&h(T),b),b=>(T.length&&h(T),Promise.reject(b)))}}e.FileSearchManager=P,P.BATCH_SIZE=512}),define(fe[135],me([0,1,15,21,52,31,10,9,23,13,2,33]),function(Y,e,g,L,y,C,n,k,_,D,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(o,s,p,r){this.query=o,this.provider=s,this.fileUtils=p,this.processType=r,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(o,s){const p=this.query.folderQueries||[],r=new L.CancellationTokenSource;return s.onCancellationRequested(()=>r.cancel()),new Promise((m,i)=>{this.collector=new h(o);let t=!1;const u=(a,l)=>{if(!t&&!this.isLimitHit){const f=this.resultSize(a);E(a)&&typeof this.query.maxResults=="number"&&this.resultCount+f>this.query.maxResults&&(this.isLimitHit=!0,t=!0,r.cancel(),a=this.trimResultToSize(a,this.query.maxResults-this.resultCount));const d=this.resultSize(a);this.resultCount+=d,(d>0||!E(a))&&this.collector.add(a,l)}};Promise.all(p.map((a,l)=>this.searchInFolder(a,f=>u(f,l),r.token))).then(a=>{r.dispose(),this.collector.flush();const l=a.some(f=>!!f&&!!f.limitHit);m({limitHit:this.isLimitHit||l,messages:(0,g.flatten)(a.map(f=>f?.message?(0,D.isArray)(f.message)?f.message:[f.message]:[])),stats:{type:this.processType}})},a=>{r.dispose();const l=(0,y.toErrorMessage)(a);i(new Error(l))})})}resultSize(o){return E(o)?Array.isArray(o.ranges)?o.ranges.length:1:0}trimResultToSize(o,s){const p=Array.isArray(o.ranges)?o.ranges:[o.ranges],r=Array.isArray(o.preview.matches)?o.preview.matches:[o.preview.matches];return{ranges:p.slice(0,s),preview:{matches:r.slice(0,s),text:o.preview.text},uri:o.uri}}async searchInFolder(o,s,p){const r=new I.QueryGlobTester(this.query,o),m=[],i={report:a=>{if(!this.validateProviderResult(a))return;const l=o.folder.scheme===n.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(a.uri))):void 0,f=_.relativePath(o.folder,a.uri);if(f){const d=r.includedInQuery(f,k.basename(f),l);(0,D.isPromise)(d)?m.push(d.then(S=>{S&&s(a)})):d&&s(a)}}},t=this.getSearchOptionsForFolder(o),u=await this.provider.provideTextSearchResults(v(this.query.contentPattern),t,i,p);return m.length&&await Promise.all(m),u}validateProviderResult(o){if(E(o)){if(Array.isArray(o.ranges)){if(!Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(o.preview.matches.length!==o.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(o.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(o){const s=(0,I.resolvePatternsForProvider)(this.query.includePattern,o.includePattern),p=(0,I.resolvePatternsForProvider)(this.query.excludePattern,o.excludePattern),r={folder:P.URI.from(o.folder),excludes:p,includes:s,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,encoding:o.fileEncoding&&this.fileUtils.toCanonicalName(o.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return r.usePCRE2=this.query.usePCRE2,r}}e.TextSearchManager=c;function v(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class h{constructor(o){this._onResult=o,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new T(512,s=>this.sendItems(s))}add(o,s){this._currentFileMatch&&(this._currentFolderIdx!==s||!_.isEqual(this._currentUri,o.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=s,this._currentFileMatch={resource:o.uri,results:[]}),this._currentFileMatch.results.push(w(o))}pushToCollector(){const o=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,o)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(o){this._onResult(o)}}e.TextSearchResultsCollector=h;function w(b){return E(b)?{preview:{matches:(0,g.mapArrayOrNot)(b.preview.matches,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character})),text:b.preview.text},ranges:(0,g.mapArrayOrNot)(b.ranges,o=>({startLineNumber:o.start.line,startColumn:o.start.character,endLineNumber:o.end.line,endColumn:o.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function E(b){return!!b.preview}e.extensionResultIsMatch=E;class T{constructor(o,s){this.maxBatchSize=o,this.cb=s,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(o,s){!o||this.addItemToBatch(o,s)}addItems(o,s){!o||this.addItemsToBatch(o,s)}addItemToBatch(o,s){this.batch.push(o),this.batchSize+=s,this.onUpdate()}addItemsToBatch(o,s){this.batch=this.batch.concat(o),this.batchSize+=s,this.onUpdate()}onUpdate(){this.totalNumberCompleted<T.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},T.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=T,T.TIMEOUT=4e3,T.START_BATCH_AFTER_COUNT=50}),define(fe[75],me([0,1,6,5,4,276,14,67,11,2,135]),function(Y,e,g,L,y,C,n,k,_,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,y.createDecorator)("IExtHostSearch");let I=class{constructor(w,E,T){this.extHostRpc=w,this._uriTransformer=E,this._logService=T,this._proxy=this.extHostRpc.getProxy(L.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new C.FileSearchManager}_transformScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}registerTextSearchProvider(w,E){if(this._textSearchUsedSchemes.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this._textSearchUsedSchemes.add(w);const T=this._handlePool++;return this._textSearchProvider.set(T,E),this._proxy.$registerTextSearchProvider(T,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._textSearchUsedSchemes.delete(w),this._textSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}registerFileSearchProvider(w,E){if(this._fileSearchUsedSchemes.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this._fileSearchUsedSchemes.add(w);const T=this._handlePool++;return this._fileSearchProvider.set(T,E),this._proxy.$registerFileSearchProvider(T,this._transformScheme(w)),(0,g.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(w),this._fileSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}$provideFileSearchResults(w,E,T,b){const o=c(T),s=this._fileSearchProvider.get(w);if(s)return this._fileSearchManager.fileSearch(o,s,p=>{this._proxy.$handleFileMatch(w,E,p.map(r=>r.resource))},b);throw new Error("unknown provider: "+w)}$clearCache(w){return this._fileSearchManager.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,E,T,b){const o=this._textSearchProvider.get(w);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const s=c(T);return this.createTextSearchManager(s,o).search(r=>this._proxy.$handleTextMatch(w,E,r),b)}$enableExtensionHostSearch(){}createTextSearchManager(w,E){return new P.TextSearchManager(w,E,{readdir:T=>Promise.resolve([]),toCanonicalName:T=>T},"textSearchProvider")}};I=Ve([$e(0,n.IExtHostRpcService),$e(1,k.IURITransformerService),$e(2,_.ILogService)],I),e.ExtHostSearch=I;function c(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(v),extraFileResources:h.extraFileResources&&h.extraFileResources.map(w=>D.URI.revive(w))}}e.reviveQuery=c;function v(h){return{...h,folder:D.URI.revive(h.folder)}}}),define(fe[277],me([0,1,21,18,3,50,2,114,109,147,83,43,5,235,234,40,236,37,237,238,239,220,240,46,41,241,221,244,245,246,133,223,251,252,253,92,34,255,224,17,7,258,71,134,36,59,208,243,64,131,73,57,75,11,67,14,26,247,205,54,68,232,256,204,70,69,261,259,260,233,45,254,257,91,56,122,249,72,250,10,192,248,202,242,29]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b,o,s,p,r,m,i,t,u,a,l,f,d,S,A,R,B,x,F,$,M,H,N,U,V,O,W,j,X,Q,de,Se,De,Pe,Be,We,He,G,ee,ne,le,Z,re,pe,Me,je,Ke,Ze,rt,lt,ye,at,J,ie,_e,Qe,et,ce,Ie,Ne,Xe,it,ft,tt,ut,Re,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Te(se){const ue=se.get(ee.IExtHostInitDataService),be=se.get(J.IExtHostFileSystemInfo),we=se.get(Ze.IExtHostConsumerFileSystem),Fe=se.get(i.IExtHostExtensionService),qe=se.get(W.IExtHostWorkspace),ze=se.get(ce.IExtHostTelemetry),Ye=se.get(T.IExtHostConfiguration),ct=se.get(He.IURITransformerService),xe=se.get(G.IExtHostRpcService),ge=se.get(x.IExtHostStorage),Ee=se.get(Ke.IExtensionStoragePaths),ae=se.get(We.ILoggerService),K=se.get(We.ILogService),Ce=se.get(Z.IExtHostTunnelService),Le=se.get(re.IExtHostApiDeprecationService),nt=se.get(O.IExtHostWindow),Ge=se.get(Qe.IExtHostSecretState),mt=se.get(et.IExtHostEditorTabs);xe.set(c.ExtHostContext.ExtHostFileSystemInfo,be),xe.set(c.ExtHostContext.ExtHostLogLevelServiceShape,ae),xe.set(c.ExtHostContext.ExtHostWorkspace,qe),xe.set(c.ExtHostContext.ExtHostConfiguration,Ye),xe.set(c.ExtHostContext.ExtHostExtensionService,Fe),xe.set(c.ExtHostContext.ExtHostStorage,ge),xe.set(c.ExtHostContext.ExtHostTunnelService,Ce),xe.set(c.ExtHostContext.ExtHostWindow,nt),xe.set(c.ExtHostContext.ExtHostSecretState,Ge),xe.set(c.ExtHostContext.ExtHostTelemetry,ze),xe.set(c.ExtHostContext.ExtHostEditorTabs,mt);const Ct=xe.set(c.ExtHostContext.ExtHostDecorations,se.get(Se.IExtHostDecorations)),Et=xe.set(c.ExtHostContext.ExtHostDocumentsAndEditors,se.get(m.IExtHostDocumentsAndEditors)),gt=xe.set(c.ExtHostContext.ExtHostCommands,se.get(w.IExtHostCommands)),bt=xe.set(c.ExtHostContext.ExtHostTerminalService,se.get(F.IExtHostTerminalService)),vt=xe.set(c.ExtHostContext.ExtHostDebugService,se.get(Pe.IExtHostDebugService)),Tt=xe.set(c.ExtHostContext.ExtHostSearch,se.get(Be.IExtHostSearch)),yt=xe.set(c.ExtHostContext.ExtHostTask,se.get(De.IExtHostTask)),$t=xe.set(c.ExtHostContext.ExtHostOutputService,se.get(d.IExtHostOutputService)),jt=xe.set(c.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(xe)),kt=xe.set(c.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(xe,Et)),Wt=xe.set(c.ExtHostContext.ExtHostDocumentContentProviders,new s.ExtHostDocumentContentProvider(xe,Et,K)),nn=xe.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new p.ExtHostDocumentSaveParticipant(K,kt,xe.getProxy(c.MainContext.MainThreadBulkEdits))),_t=xe.set(c.ExtHostContext.ExtHostNotebook,new ne.ExtHostNotebookController(xe,gt,Et,kt,Ee)),Xt=xe.set(c.ExtHostContext.ExtHostNotebookDocuments,new ut.ExtHostNotebookDocuments(K,_t)),qt=xe.set(c.ExtHostContext.ExtHostNotebookEditors,new tt.ExtHostNotebookEditors(K,xe,_t)),rn=xe.set(c.ExtHostContext.ExtHostNotebookKernels,new Ie.ExtHostNotebookKernels(xe,ue,_t,gt,K)),sn=xe.set(c.ExtHostContext.ExtHostNotebookRenderers,new Xe.ExtHostNotebookRenderers(xe,_t)),At=xe.set(c.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(xe,Et)),Yt=xe.set(c.ExtHostContext.ExtHostTreeViews,new M.ExtHostTreeViews(xe.getProxy(c.MainContext.MainThreadTreeViews),gt,K)),En=xe.set(c.ExtHostContext.ExtHostEditorInsets,new X.ExtHostEditorInsets(xe.getProxy(c.MainContext.MainThreadEditorInsets),At,ue)),Ht=xe.set(c.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(xe,K,be)),zt=xe.set(c.ExtHostContext.ExtHostLanguages,new l.ExtHostLanguages(xe,kt,gt.converter,ct)),wt=xe.set(c.ExtHostContext.ExtHostLanguageFeatures,new a.ExtHostLanguageFeatures(xe,ct,kt,gt,Ht,K,Le)),on=xe.set(c.ExtHostContext.ExtHostFileSystem,new t.ExtHostFileSystem(xe,wt)),Nt=xe.set(c.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(xe,K,Et)),Ut=xe.set(c.ExtHostContext.ExtHostQuickOpen,(0,A.createExtHostQuickOpen)(xe,qe,gt)),Jt=xe.set(c.ExtHostContext.ExtHostSCM,new R.ExtHostSCM(xe,gt,K)),_n=xe.set(c.ExtHostContext.ExtHostComments,(0,E.createExtHostComments)(xe,gt,kt)),mn=xe.set(c.ExtHostContext.ExtHostProgress,new S.ExtHostProgress(xe.getProxy(c.MainContext.MainThreadProgress))),Sn=xe.set(c.ExtHostContext.ExtHosLabelService,new Q.ExtHostLabelService(xe)),gn=xe.set(c.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(xe)),Zt=xe.set(c.ExtHostContext.ExtHostAuthentication,new pe.ExtHostAuthentication(xe)),an=xe.set(c.ExtHostContext.ExtHostTimeline,new Me.ExtHostTimeline(xe,gt)),Gt=xe.set(c.ExtHostContext.ExtHostWebviews,new V.ExtHostWebviews(xe,{remote:ue.remote},qe,K,Le)),cn=xe.set(c.ExtHostContext.ExtHostWebviewPanels,new ye.ExtHostWebviewPanels(xe,Gt,qe)),Cn=xe.set(c.ExtHostContext.ExtHostCustomEditors,new lt.ExtHostCustomEditors(xe,kt,Ee,Gt,cn)),yn=xe.set(c.ExtHostContext.ExtHostWebviewViews,new rt.ExtHostWebviewViews(xe,Gt)),Kt=xe.set(c.ExtHostContext.ExtHostTesting,new ie.ExtHostTesting(xe,gt)),en=xe.set(c.ExtHostContext.ExtHostUriOpeners,new _e.ExtHostUriOpeners(xe));xe.set(c.ExtHostContext.ExtHostInteractive,new Re.ExtHostInteractive(xe,_t,Et,gt));const Dn=(0,j.values)(c.ExtHostContext);xe.assertRegistered(Dn);const kn=new at.ExtHostBulkEdits(xe,Et),ln=new h.ExtHostClipboard(xe),un=new f.ExtHostMessageService(xe,K),Vt=new o.ExtHostDialogs(xe),Mt=new B.ExtHostStatusBar(xe,gt.converter);return v.ExtHostApiCommands.register(gt),function(Ue,Lt,Qt){const St=function(){let te=!Ue.isUnderDevelopment;function he(){te||(K.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Ae(dt){if(Array.isArray(dt))dt.forEach(Ae);else if(typeof dt=="string")he();else{const Dt=dt;typeof Dt.scheme=="undefined"&&he(),typeof Dt.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Ue,"documentFiltersExclusive")}return dt}}(),In={getSession(te,he,Ae){return Ae?.forceNewSession&&(0,ve.checkProposedApiEnabled)(Ue,"authSession"),Zt.getSession(Ue,te,he,Ae)},async hasSession(te,he){return(0,ve.checkProposedApiEnabled)(Ue,"authSession"),!!await Zt.getSession(Ue,te,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(te,he,Ae,dt){return Zt.registerAuthenticationProvider(te,he,Ae,dt)}},Pn={registerCommand(te,he,Ae){return gt.registerCommand(!0,te,he,Ae,void 0,Ue)},registerTextEditorCommand(te,he,Ae){return gt.registerCommand(!0,te,(...dt)=>{const Dt=At.getActiveTextEditor();if(!Dt){K.warn("Cannot execute "+te+" because there is no active text editor.");return}return Dt.edit(Pt=>{he.apply(Ae,[Dt,Pt,...dt])}).then(Pt=>{Pt||K.warn("Edits from command "+te+" were not applied.")},Pt=>{K.warn("An error occurred while running command "+te,Pt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(te,he,Ae)=>((0,ve.checkProposedApiEnabled)(Ue,"diffCommand"),gt.registerCommand(!0,te,async(...dt)=>{const Dt=Et.activeEditor(!0);if(!Dt){K.warn("Cannot execute "+te+" because there is no active text editor.");return}const Pt=await At.getDiffInformation(Dt.id);he.apply(Ae,[Pt,...dt])},void 0,void 0,Ue)),executeCommand(te,...he){return gt.executeCommand(te,...he)},getCommands(te=!1){return gt.getCommands(te)}},pn={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return bt.getDefaultShell(!1)},get isTelemetryEnabled(){return ze.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return ze.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,he){return nt.openUri(te,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ue.environment.appUriScheme)return jt.createAppUri(te);try{return await nt.asExternalUri(te,{allowTunneling:!!ue.remote.authority})}catch(he){if((0,ft.matchesScheme)(te,it.Schemas.http)||(0,ft.matchesScheme)(te,it.Schemas.https))return te;throw he}},get remoteName(){return(0,de.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Ue,"resolvers"),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(pn);const vn=ue.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,Tn={createTestController(te,he){return Kt.createTestController(te,he)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Ue,"testObserver"),Kt.createTestObserver()},runTests(te){return(0,ve.checkProposedApiEnabled)(Ue,"testObserver"),Kt.runTests(te)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Ue,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Ue,"testObserver"),Kt.results}},An={getExtension(te){const he=Lt.getExtensionDescription(te);if(he)return new i.Extension(Fe,Ue.identifier,he,vn)},get all(){return Lt.getAllExtensionDescriptions().map(te=>new i.Extension(Fe,Ue.identifier,te,vn))},get onDidChange(){return Lt.onDidChange}},dn={createDiagnosticCollection(te){return Ht.createDiagnosticCollection(Ue.identifier,te)},get onDidChangeDiagnostics(){return Ht.onDidChangeDiagnostics},getDiagnostics:te=>Ht.getDiagnostics(te),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(te,he){return zt.changeLanguage(te.uri,he)},match(te,he){return(0,P.score)(H.LanguageSelector.from(te),he.uri,he.languageId,!0)},registerCodeActionsProvider(te,he,Ae){return wt.registerCodeActionProvider(Ue,St(te),he,Ae)},registerCodeLensProvider(te,he){return wt.registerCodeLensProvider(Ue,St(te),he)},registerDefinitionProvider(te,he){return wt.registerDefinitionProvider(Ue,St(te),he)},registerDeclarationProvider(te,he){return wt.registerDeclarationProvider(Ue,St(te),he)},registerImplementationProvider(te,he){return wt.registerImplementationProvider(Ue,St(te),he)},registerTypeDefinitionProvider(te,he){return wt.registerTypeDefinitionProvider(Ue,St(te),he)},registerHoverProvider(te,he){return wt.registerHoverProvider(Ue,St(te),he,Ue.identifier)},registerEvaluatableExpressionProvider(te,he){return wt.registerEvaluatableExpressionProvider(Ue,St(te),he,Ue.identifier)},registerInlineValuesProvider(te,he){return wt.registerInlineValuesProvider(Ue,St(te),he,Ue.identifier)},registerDocumentHighlightProvider(te,he){return wt.registerDocumentHighlightProvider(Ue,St(te),he)},registerLinkedEditingRangeProvider(te,he){return wt.registerLinkedEditingRangeProvider(Ue,St(te),he)},registerReferenceProvider(te,he){return wt.registerReferenceProvider(Ue,St(te),he)},registerRenameProvider(te,he){return wt.registerRenameProvider(Ue,St(te),he)},registerDocumentSymbolProvider(te,he,Ae){return wt.registerDocumentSymbolProvider(Ue,St(te),he,Ae)},registerWorkspaceSymbolProvider(te){return wt.registerWorkspaceSymbolProvider(Ue,te)},registerDocumentFormattingEditProvider(te,he){return wt.registerDocumentFormattingEditProvider(Ue,St(te),he)},registerDocumentRangeFormattingEditProvider(te,he){return wt.registerDocumentRangeFormattingEditProvider(Ue,St(te),he)},registerOnTypeFormattingEditProvider(te,he,Ae,...dt){return wt.registerOnTypeFormattingEditProvider(Ue,St(te),he,[Ae].concat(dt))},registerDocumentSemanticTokensProvider(te,he,Ae){return wt.registerDocumentSemanticTokensProvider(Ue,St(te),he,Ae)},registerDocumentRangeSemanticTokensProvider(te,he,Ae){return wt.registerDocumentRangeSemanticTokensProvider(Ue,St(te),he,Ae)},registerSignatureHelpProvider(te,he,Ae,...dt){return typeof Ae=="object"?wt.registerSignatureHelpProvider(Ue,St(te),he,Ae):wt.registerSignatureHelpProvider(Ue,St(te),he,typeof Ae=="undefined"?[]:[Ae,...dt])},registerCompletionItemProvider(te,he,...Ae){return wt.registerCompletionItemProvider(Ue,St(te),he,Ae)},registerInlineCompletionItemProvider(te,he){return(0,ve.checkProposedApiEnabled)(Ue,"inlineCompletions"),wt.registerInlineCompletionsProvider(Ue,St(te),he)},registerDocumentLinkProvider(te,he){return wt.registerDocumentLinkProvider(Ue,St(te),he)},registerColorProvider(te,he){return wt.registerColorProvider(Ue,St(te),he)},registerFoldingRangeProvider(te,he){return wt.registerFoldingRangeProvider(Ue,St(te),he)},registerSelectionRangeProvider(te,he){return wt.registerSelectionRangeProvider(Ue,te,he)},registerCallHierarchyProvider(te,he){return wt.registerCallHierarchyProvider(Ue,te,he)},registerTypeHierarchyProvider(te,he){return wt.registerTypeHierarchyProvider(Ue,te,he)},setLanguageConfiguration:(te,he)=>wt.setLanguageConfiguration(Ue,te,he),getTokenInformationAtPosition(te,he){return(0,ve.checkProposedApiEnabled)(Ue,"tokenInformation"),zt.tokenAtPosition(te,he)},registerInlayHintsProvider(te,he){return(0,ve.checkProposedApiEnabled)(Ue,"inlayHints"),wt.registerInlayHintsProvider(Ue,te,he)},createLanguageStatusItem(te,he){return(0,ve.checkProposedApiEnabled)(Ue,"languageStatus"),zt.createLanguageStatusItem(Ue,te,he)}},Rn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(te,he,Ae){const dt=await(n.URI.isUri(te)?Promise.resolve(wn.openTextDocument(te)):Promise.resolve(te));return At.showTextDocument(dt,he,Ae)},createTextEditorDecorationType(te){return At.createTextEditorDecorationType(Ue,te)},onDidChangeActiveTextEditor(te,he,Ae){return At.onDidChangeActiveTextEditor(te,he,Ae)},onDidChangeVisibleTextEditors(te,he,Ae){return At.onDidChangeVisibleTextEditors(te,he,Ae)},onDidChangeTextEditorSelection(te,he,Ae){return At.onDidChangeTextEditorSelection(te,he,Ae)},onDidChangeTextEditorOptions(te,he,Ae){return At.onDidChangeTextEditorOptions(te,he,Ae)},onDidChangeTextEditorVisibleRanges(te,he,Ae){return At.onDidChangeTextEditorVisibleRanges(te,he,Ae)},onDidChangeTextEditorViewColumn(te,he,Ae){return At.onDidChangeTextEditorViewColumn(te,he,Ae)},onDidCloseTerminal(te,he,Ae){return bt.onDidCloseTerminal(te,he,Ae)},onDidOpenTerminal(te,he,Ae){return bt.onDidOpenTerminal(te,he,Ae)},onDidChangeActiveTerminal(te,he,Ae){return bt.onDidChangeActiveTerminal(te,he,Ae)},onDidChangeTerminalDimensions(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Ue,"terminalDimensions"),bt.onDidChangeTerminalDimensions(te,he,Ae)},onDidChangeTerminalState(te,he,Ae){return bt.onDidChangeTerminalState(te,he,Ae)},onDidWriteTerminalData(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Ue,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(te,he,Ae)},get state(){return nt.state},onDidChangeWindowState(te,he,Ae){return nt.onDidChangeWindowState(te,he,Ae)},showInformationMessage(te,...he){return un.showMessage(Ue,C.default.Info,te,he[0],he.slice(1))},showWarningMessage(te,...he){return un.showMessage(Ue,C.default.Warning,te,he[0],he.slice(1))},showErrorMessage(te,...he){return un.showMessage(Ue,C.default.Error,te,he[0],he.slice(1))},showQuickPick(te,he,Ae){return Ut.showQuickPick(te,(0,ve.isProposedApiEnabled)(Ue,void 0),he,Ae)},showWorkspaceFolderPick(te){return Ut.showWorkspaceFolderPick(te)},showInputBox(te,he){return Ut.showInput(te,he)},showOpenDialog(te){return Vt.showOpenDialog(te)},showSaveDialog(te){return Vt.showSaveDialog(te)},createStatusBarItem(te,he,Ae){let dt,Dt,Pt;return typeof te=="string"?(dt=te,Dt=he,Pt=Ae):(Dt=te,Pt=he),Mt.createStatusBarEntry(Ue,dt,Dt,Pt)},setStatusBarMessage(te,he){return Mt.setStatusBarMessage(te,he)},withScmProgress(te){return Le.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),mn.withProgress(Ue,{location:N.ProgressLocation.SourceControl},(he,Ae)=>te({report(dt){}}))},withProgress(te,he){return mn.withProgress(Ue,te,he)},createOutputChannel(te){return $t.createOutputChannel(te,Ue)},createWebviewPanel(te,he,Ae,dt){return cn.createWebviewPanel(Ue,te,he,Ae,dt)},createWebviewTextEditorInset(te,he,Ae,dt){return(0,ve.checkProposedApiEnabled)(Ue,"editorInsets"),En.createWebviewEditorInset(te,he,Ae,dt,Ue)},createTerminal(te,he,Ae){return typeof te=="object"?("location"in te&&(0,ve.checkProposedApiEnabled)(Ue,"terminalLocation"),"pty"in te?bt.createExtensionTerminal(te):bt.createTerminalFromOptions(te)):bt.createTerminal(te,he,Ae)},registerTerminalLinkProvider(te){return bt.registerLinkProvider(te)},registerTerminalProfileProvider(te,he){return bt.registerProfileProvider(Ue,te,he)},registerTreeDataProvider(te,he){return Yt.registerTreeDataProvider(te,he,Ue)},createTreeView(te,he){return Yt.createTreeView(te,he,Ue)},registerWebviewPanelSerializer:(te,he)=>cn.registerWebviewPanelSerializer(Ue,te,he),registerCustomEditorProvider:(te,he,Ae={})=>Cn.registerCustomEditorProvider(Ue,te,he,Ae),registerFileDecorationProvider(te){return Ct.registerFileDecorationProvider(te,Ue.identifier)},registerUriHandler(te){return jt.registerUriHandler(Ue.identifier,te)},createQuickPick(){return Ut.createQuickPick(Ue.identifier,(0,ve.isProposedApiEnabled)(Ue,void 0))},createInputBox(){return Ut.createInputBox(Ue.identifier)},get activeColorTheme(){return gn.activeColorTheme},onDidChangeActiveColorTheme(te,he,Ae){return gn.onDidChangeActiveColorTheme(te,he,Ae)},registerWebviewViewProvider(te,he,Ae){return yn.registerWebviewViewProvider(Ue,te,he,Ae?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),_t.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),_t.onDidChangeActiveNotebookEditor(te,he,Ae)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),_t.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),_t.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),qt.onDidChangeNotebookEditorSelection(te,he,Ae)},onDidChangeNotebookEditorVisibleRanges(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),qt.onDidChangeNotebookEditorVisibleRanges(te,he,Ae)},showNotebookDocument(te,he){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),_t.showNotebookDocument(te,he)},registerExternalUriOpener(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Ue,"externalUriOpener"),en.registerExternalUriOpener(Ue.identifier,te,he,Ae)},get tabs(){return(0,ve.checkProposedApiEnabled)(Ue,"tabs"),mt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Ue,"tabs"),mt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Ue,"tabs"),mt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Ue,"tabs"),mt.onDidChangeActiveTab},getInlineCompletionItemController(te){return(0,ve.checkProposedApiEnabled)(Ue,"inlineCompletions"),a.InlineCompletionController.get(te)}},wn={get rootPath(){return Le.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),qe.getPath()},set rootPath(te){throw L.readonly()},getWorkspaceFolder(te){return qe.getWorkspaceFolder(te)},get workspaceFolders(){return qe.getWorkspaceFolders()},get name(){return qe.name},set name(te){throw L.readonly()},get workspaceFile(){return qe.workspaceFile},set workspaceFile(te){throw L.readonly()},updateWorkspaceFolders:(te,he,...Ae)=>qe.updateWorkspaceFolders(Ue,te,he||0,...Ae),onDidChangeWorkspaceFolders:function(te,he,Ae){return qe.onDidChangeWorkspace(te,he,Ae)},asRelativePath:(te,he)=>qe.getRelativePath(te,he),findFiles:(te,he,Ae,dt)=>qe.findFiles(H.GlobPattern.from(te),H.GlobPattern.from(he),Ae,Ue.identifier,dt),findTextInFiles:(te,he,Ae,dt)=>{(0,ve.checkProposedApiEnabled)(Ue,"findTextInFiles");let Dt,Pt;return typeof he=="object"?(Dt=he,Pt=Ae):(Dt={},Pt=he,dt=Ae),qe.findTextInFiles(te,Dt||{},Pt,Ue.identifier,dt)},saveAll:te=>qe.saveAll(te),applyEdit(te){return kn.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,he,Ae,dt)=>Nt.createFileSystemWatcher(H.GlobPattern.from(te),he,Ae,dt),get textDocuments(){return kt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw L.readonly()},openTextDocument(te){let he;const Ae=te;if(typeof te=="string")he=Promise.resolve(n.URI.file(te));else if(n.URI.isUri(te))he=Promise.resolve(te);else if(!Ae||typeof Ae=="object")he=kt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(dt=>kt.ensureDocumentData(dt).then(Dt=>Dt.document))},onDidOpenTextDocument:(te,he,Ae)=>kt.onDidAddDocument(te,he,Ae),onDidCloseTextDocument:(te,he,Ae)=>kt.onDidRemoveDocument(te,he,Ae),onDidChangeTextDocument:(te,he,Ae)=>kt.onDidChangeDocument(te,he,Ae),onDidSaveTextDocument:(te,he,Ae)=>kt.onDidSaveDocument(te,he,Ae),onWillSaveTextDocument:(te,he,Ae)=>nn.getOnWillSaveTextDocumentEvent(Ue)(te,he,Ae),get notebookDocuments(){return _t.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,he){let Ae;if(n.URI.isUri(te))Ae=te,await _t.openNotebookDocument(te);else if(typeof te=="string")Ae=n.URI.revive(await _t.createNotebookDocument({viewType:te,content:he}));else throw new Error("Invalid arguments");return _t.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return _t.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return _t.onDidCloseNotebookDocument},registerNotebookSerializer(te,he,Ae,dt){return _t.registerNotebookSerializer(Ue,te,he,Ae,(0,ve.isProposedApiEnabled)(Ue,"notebookLiveShare")?dt:void 0)},registerNotebookContentProvider:(te,he,Ae,dt)=>((0,ve.checkProposedApiEnabled)(Ue,"notebookContentProvider"),_t.registerNotebookContentProvider(Ue,te,he,Ae,(0,ve.isProposedApiEnabled)(Ue,"notebookLiveShare")?dt:void 0)),onDidChangeConfiguration:(te,he,Ae)=>Qt.onDidChangeConfiguration(te,he,Ae),getConfiguration(te,he){return he=arguments.length===1?void 0:he,Qt.getConfiguration(te,he,Ue)},registerTextDocumentContentProvider(te,he){return Wt.registerTextDocumentContentProvider(te,he)},registerTaskProvider:(te,he)=>(Le.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Ue,te,he)),registerFileSystemProvider(te,he,Ae){return on.registerFileSystemProvider(Ue,te,he,Ae)},get fs(){return we.value},registerFileSearchProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Ue,"fileSearchProvider"),Tt.registerFileSearchProvider(te,he)),registerTextSearchProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Ue,"textSearchProvider"),Tt.registerTextSearchProvider(te,he)),registerRemoteAuthorityResolver:(te,he)=>((0,ve.checkProposedApiEnabled)(Ue,"resolvers"),Fe.registerRemoteAuthorityResolver(te,he)),registerResourceLabelFormatter:te=>((0,ve.checkProposedApiEnabled)(Ue,"resolvers"),Sn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,he,Ae)=>Nt.onDidCreateFile(te,he,Ae),onDidDeleteFiles:(te,he,Ae)=>Nt.onDidDeleteFile(te,he,Ae),onDidRenameFiles:(te,he,Ae)=>Nt.onDidRenameFile(te,he,Ae),onWillCreateFiles:(te,he,Ae)=>Nt.getOnWillCreateFileEvent(Ue)(te,he,Ae),onWillDeleteFiles:(te,he,Ae)=>Nt.getOnWillDeleteFileEvent(Ue)(te,he,Ae),onWillRenameFiles:(te,he,Ae)=>Nt.getOnWillRenameFileEvent(Ue)(te,he,Ae),openTunnel:te=>((0,ve.checkProposedApiEnabled)(Ue,"resolvers"),Ce.openTunnel(Ue,te).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Ue,"resolvers"),Ce.getTunnels()},onDidChangeTunnels:(te,he,Ae)=>((0,ve.checkProposedApiEnabled)(Ue,"resolvers"),Ce.onDidChangeTunnels(te,he,Ae)),registerPortAttributesProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Ue,"portsAttributes"),Ce.registerPortsAttributesProvider(te,he)),registerTimelineProvider:(te,he)=>((0,ve.checkProposedApiEnabled)(Ue,"timeline"),an.registerTimelineProvider(te,he,Ue.identifier,gt.converter)),get isTrusted(){return qe.trusted},requestWorkspaceTrust:te=>((0,ve.checkProposedApiEnabled)(Ue,"workspaceTrust"),qe.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,he,Ae)=>qe.onDidGrantWorkspaceTrust(te,he,Ae)},Ln={get inputBox(){return Le.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Jt.getLastInputBox(Ue)},createSourceControl(te,he,Ae){return Jt.createSourceControl(Ue,te,he,Ae)}},Fn={createCommentController(te,he){return _n.createCommentController(Ue,te,he)}},Mn={get activeDebugSession(){return vt.activeDebugSession},get activeDebugConsole(){return vt.activeDebugConsole},get breakpoints(){return vt.breakpoints},onDidStartDebugSession(te,he,Ae){return vt.onDidStartDebugSession(te,he,Ae)},onDidTerminateDebugSession(te,he,Ae){return vt.onDidTerminateDebugSession(te,he,Ae)},onDidChangeActiveDebugSession(te,he,Ae){return vt.onDidChangeActiveDebugSession(te,he,Ae)},onDidReceiveDebugSessionCustomEvent(te,he,Ae){return vt.onDidReceiveDebugSessionCustomEvent(te,he,Ae)},onDidChangeBreakpoints(te,he,Ae){return vt.onDidChangeBreakpoints(te,he,Ae)},registerDebugConfigurationProvider(te,he,Ae){return vt.registerDebugConfigurationProvider(te,he,Ae||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,he){return vt.registerDebugAdapterDescriptorFactory(Ue,te,he)},registerDebugAdapterTrackerFactory(te,he){return vt.registerDebugAdapterTrackerFactory(te,he)},startDebugging(te,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?vt.startDebugging(te,he,{parentSession:Ae}):vt.startDebugging(te,he,Ae||{})},stopDebugging(te){return vt.stopDebugging(te)},addBreakpoints(te){return vt.addBreakpoints(te)},removeBreakpoints(te){return vt.removeBreakpoints(te)},asDebugSourceUri(te,he){return vt.asDebugSourceUri(te,he)}},On={registerTaskProvider:(te,he)=>yt.registerTaskProvider(Ue,te,he),fetchTasks:te=>yt.fetchTasks(te),executeTask:te=>yt.executeTask(Ue,te),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(te,he,Ae)=>yt.onDidStartTask(te,he,Ae),onDidEndTask:(te,he,Ae)=>yt.onDidEndTask(te,he,Ae),onDidStartTaskProcess:(te,he,Ae)=>yt.onDidStartTaskProcess(te,he,Ae),onDidEndTaskProcess:(te,he,Ae)=>yt.onDidEndTaskProcess(te,he,Ae)},Nn={createNotebookController(te,he,Ae,dt,Dt){return rn.createNotebookController(Ue,te,he,Ae,dt,(0,ve.isProposedApiEnabled)(Ue,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(te,he)=>_t.registerNotebookCellStatusBarItemProvider(Ue,te,he),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),Xt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(te){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditorDecorationType"),qt.createNotebookEditorDecorationType(te)},createRendererMessaging(te){return sn.createRendererMessaging(Ue,te)},onDidChangeNotebookDocumentMetadata(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),Xt.onDidChangeNotebookDocumentMetadata(te,he,Ae)},onDidChangeNotebookCells(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),_t.onDidChangeNotebookCells(te,he,Ae)},onDidChangeNotebookCellExecutionState(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Ue,"notebookCellExecutionState"),_t.onDidChangeNotebookCellExecutionState(te,he,Ae)},onDidChangeCellOutputs(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),_t.onDidChangeCellOutputs(te,he,Ae)},onDidChangeCellMetadata(te,he,Ae){return(0,ve.checkProposedApiEnabled)(Ue,"notebookEditor"),_t.onDidChangeCellMetadata(te,he,Ae)},createConcatTextDocument(te,he){return(0,ve.checkProposedApiEnabled)(Ue,"notebookConcatTextDocument"),new je.ExtHostNotebookConcatDocument(_t,kt,te,he)}};return{version:ue.version,authentication:In,commands:Pn,comments:Fn,debug:Mn,env:pn,extensions:An,languages:dn,notebooks:Nn,scm:Ln,tasks:On,tests:Tn,window:Rn,workspace:wn,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:y.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:D.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalLocation:N.TerminalLocation,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,TextDocumentChangeReason:N.TextDocumentChangeReason,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,TypeHierarchyItem:N.TypeHierarchyItem,UIKind:c.UIKind,Uri:n.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestResultState:N.TestResultState,TestRunRequest:N.TestRunRequest,TestMessage:N.TestMessage,TestTag:N.TestTag,TestRunProfileKind:N.TestRunProfileKind,TextSearchCompleteMessageType:Ne.TextSearchCompleteMessageType,CoveredCount:N.CoveredCount,FileCoverage:N.FileCoverage,StatementCoverage:N.StatementCoverage,BranchCoverage:N.BranchCoverage,FunctionCoverage:N.FunctionCoverage,WorkspaceTrustState:N.WorkspaceTrustState,LanguageStatusSeverity:N.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Te}),define(fe[278],me([0,1,84,133,36,131,37,40,46,34,73,57,75,92,54,68,134,69,45,91,122,56,132,11,230]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b,o,s,p,r,m,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(m.ILoggerService,r.ExtHostLoggerService),(0,g.registerSingleton)(m.ILogService,i.ExtHostLogService),(0,g.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,g.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,g.registerSingleton)(n.IExtHostConfiguration,n.ExtHostConfiguration),(0,g.registerSingleton)(T.IExtHostConsumerFileSystem,T.ExtHostConsumerFileSystem),(0,g.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,g.registerSingleton)(C.IExtHostDecorations,C.ExtHostDecorations),(0,g.registerSingleton)(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),(0,g.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,g.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService),(0,g.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,g.registerSingleton)(v.IExtHostStorage,v.ExtHostStorage),(0,g.registerSingleton)(P.IExtHostTask,P.WorkerExtHostTask),(0,g.registerSingleton)(D.IExtHostTerminalService,D.WorkerExtHostTerminalService),(0,g.registerSingleton)(h.IExtHostTunnelService,h.ExtHostTunnelService),(0,g.registerSingleton)(E.IExtHostWindow,E.ExtHostWindow),(0,g.registerSingleton)(y.IExtHostWorkspace,y.ExtHostWorkspace),(0,g.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,g.registerSingleton)(s.IExtHostTelemetry,s.ExtHostTelemetry),(0,g.registerSingleton)(p.IExtHostEditorTabs,p.ExtHostEditorTabs)}),define(fe[93],me([0,1,15,11,33,72]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function n(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.anchorGlob=n;function k(I,c,v,h){const w=(0,g.mapArrayOrNot)(v,_),E=new y.TextSearchMatch(c,w,h),T=E.preview.matches;return{ranges:(0,g.mapArrayOrNot)(w,D),uri:I,preview:{text:E.preview.text,matches:(0,g.mapArrayOrNot)(T,D)}}}e.createTextSearchResult=k;function _(I){return new y.SearchRange(I.start.line,I.start.character,I.end.line,I.end.character)}function D(I){return new C.Range(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let P=class{constructor(c,v){this.prefix=c,this.logService=v}appendLine(c){this.logService.debug(`${this.prefix}#search`,c)}};P=Ve([$e(1,L.ILogService)],P),e.OutputChannel=P}),define(fe[279],me([0,1,96,22]),function(Y,e,g,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function y(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(m=>m===r)}e.isUTFEncoding=y,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const C=512,n=512,k=512*8,_=512*128;class D{constructor(m){this.iconvLiteDecoder=m}static async create(m){let i;if(m!==e.UTF8)i=(await new Promise((u,a)=>{Y(["iconv-lite-umd"],u,a)})).getDecoder(v(m));else{const t=new TextDecoder;i={write(u){return t.decode(u,{stream:!0})},end(){return t.decode()}}}return new D(i)}write(m){return this.iconvLiteDecoder.write(m)}end(){return this.iconvLiteDecoder.end()}}function P(r,m){const i=m.minBytesRequiredForDetection??m.guessEncoding?k:n;return new Promise((t,u)=>{const a=(0,g.newWriteableStream)(A=>A.join("")),l=[];let f=0,d;const S=async()=>{try{const A=await p({buffer:L.VSBuffer.concat(l),bytesRead:f},m.guessEncoding);A.encoding=await m.overwriteEncoding(A.encoding),d=await D.create(A.encoding);const R=d.write(L.VSBuffer.concat(l).buffer);a.write(R),l.length=0,f=0,t({stream:a,detected:A})}catch(A){u(A)}};(0,g.listenStream)(r,{onData:async A=>{d?a.write(d.write(A.buffer)):(l.push(A),f+=A.byteLength,f>=i&&(r.pause(),await S(),setTimeout(()=>r.resume())))},onError:A=>a.error(A),onEnd:async()=>{d||await S(),a.end(d?.end())}})})}e.toDecodeStream=P;async function I(r,m,i){const u=(await new Promise((f,d)=>{Y(["iconv-lite-umd"],f,d)})).getEncoder(v(m),i);let a=!1,l=!1;return{read(){if(l)return null;const f=r.read();if(typeof f!="string"){if(l=!0,!a&&i?.addBOM)switch(m){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const d=u.end();return d&&d.length>0?(a=!0,L.VSBuffer.wrap(d)):null}return a=!0,L.VSBuffer.wrap(u.write(f))}}}e.toEncodeReadable=I;async function c(r){return(await new Promise((i,t)=>{Y(["iconv-lite-umd"],i,t)})).encodingExists(v(r))}e.encodingExists=c;function v(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=v;function h(r,m){if(!r||m<e.UTF16be_BOM.length)return null;const i=r.readUInt8(0),t=r.readUInt8(1);if(i===e.UTF16be_BOM[0]&&t===e.UTF16be_BOM[1])return e.UTF16be;if(i===e.UTF16le_BOM[0]&&t===e.UTF16le_BOM[1])return e.UTF16le;if(m<e.UTF8_BOM.length)return null;const u=r.readUInt8(2);return i===e.UTF8_BOM[0]&&t===e.UTF8_BOM[1]&&u===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=h;const w=["ascii","utf-16","utf-32"];async function E(r){const m=await new Promise((l,f)=>{Y(["jschardet"],l,f)}),i=r.slice(0,_),t=o(i.buffer),u=m.detect(t);if(!u||!u.encoding)return null;const a=u.encoding.toLowerCase();return 0<=w.indexOf(a)?null:b(u.encoding)}const T={ibm866:"cp866",big5:"cp950"};function b(r){const m=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return T[m]||m}function o(r){let m="";for(let i=0;i<r.length;i++)m+=String.fromCharCode(r[i]);return m}function s(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const m=r.match(/windows(\d+)/);return m?"windows-"+m[1]:r}}e.toCanonicalName=s;function p({buffer:r,bytesRead:m},i){let t=h(r,m),u=!1;if(t!==e.UTF16be&&t!==e.UTF16le&&r){let a=!0,l=!0,f=!1;for(let d=0;d<m&&d<C;d++){const S=d%2==1,A=r.readUInt8(d)===0;if(A&&(f=!0),a&&(S&&!A||!S&&A)&&(a=!1),l&&(S&&A||!S&&!A)&&(l=!1),A&&!a&&!l)break}f&&(a?t=e.UTF16le:l?t=e.UTF16be:u=!0)}return i&&!u&&!t&&r?E(r.slice(0,m)).then(a=>({seemsBinary:!1,encoding:a})):{seemsBinary:u,encoding:t}}e.detectEncodingFromBuffer=p,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(fe[136],me([0,1,279,28,135]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class C extends y.TextSearchManager{constructor(k,_,D=L,P="searchProcess"){super(k,_,{readdir:I=>D.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,g.toCanonicalName)(I)},P)}}e.NativeTextSearchManager=C}),define(fe[280],me([0,1,281,295,296,2,297,29]),function(Y,e,g,L,y,C,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function _(c,v,h,w,E,T){const b=T.environment.useHostProxy,o=typeof b=="boolean"?b:!T.remote.isRemote,s=(0,n.createProxyResolver)({resolveProxy:r=>c.resolveProxy(r),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(r,m,...i)=>{switch(r){case n.LogLevel.Trace:w.trace(m,...i);break;case n.LogLevel.Debug:w.debug(m,...i);break;case n.LogLevel.Info:w.info(m,...i);break;case n.LogLevel.Warning:w.warn(m,...i);break;case n.LogLevel.Error:w.error(m,...i);break;case n.LogLevel.Critical:w.critical(m,...i);break;case n.LogLevel.Off:break;default:t(r,m,i);break}function t(u,a,...l){w.error("Unknown log level",u),w.error(a,...l)}},getLogLevel:()=>w.getLevel(),proxyResolveTelemetry:r=>{E.$publicLog2("resolveProxy",r)},useHostProxy:o,env:process.env}),p=D(v,s);return I(h,p)}e.connectProxyResolver=_;function D(c,v){const h={config:c.getConfiguration("http").get("proxySupport")||"off"};c.onDidChangeConfiguration(E=>{h.config=c.getConfiguration("http").get("proxySupport")||"off"});const w={config:!!c.getConfiguration("http").get("systemCertificates")};return c.onDidChangeConfiguration(E=>{w.config=!!c.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},g,(0,n.createHttpPatch)(g,v,{config:"off"},w,!0)),on:Object.assign({},g,(0,n.createHttpPatch)(g,v,{config:"on"},w,!0)),override:Object.assign({},g,(0,n.createHttpPatch)(g,v,{config:"override"},w,!0)),onRequest:Object.assign({},g,(0,n.createHttpPatch)(g,v,h,w,!0)),default:Object.assign(g,(0,n.createHttpPatch)(g,v,h,w,!1))},https:{off:Object.assign({},L,(0,n.createHttpPatch)(L,v,{config:"off"},w,!0)),on:Object.assign({},L,(0,n.createHttpPatch)(L,v,{config:"on"},w,!0)),override:Object.assign({},L,(0,n.createHttpPatch)(L,v,{config:"override"},w,!0)),onRequest:Object.assign({},L,(0,n.createHttpPatch)(L,v,h,w,!0)),default:Object.assign(L,(0,n.createHttpPatch)(L,v,h,w,!1))},tls:Object.assign(y,(0,n.createTlsPatch)(y))}}const P=new Map;function I(c,v){return c.getExtensionPathIndex().then(h=>{const w=Y.__$__nodeRequire("module"),E=w._load;w._load=function(b,o,s){if(b==="tls")return v.tls;if(b!=="http"&&b!=="https")return E.apply(this,arguments);const p=v[b],r=h.findSubstr(C.URI.file(o.filename));let m=P.get(r);if(m||P.set(r,m={}),!m[b]){let i=p.default;r&&(0,k.isProposedApiEnabled)(r,void 0)&&(i=p[r.proxySupport]||p.onRequest),m[b]={...i}}return m[b]}})}}),define(fe[282],me([0,1,39,9,80,30,12,8,93,283]),function(Y,e,g,L,y,C,n,k,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const P=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(o,s,p,r){const m=c(o,s,p,r),i=s.folder.fsPath;return{cmd:g.spawn(P,m.args,{cwd:i}),rgDiskPath:P,siblingClauses:m.siblingClauses,rgArgs:m,cwd:i}}e.spawnRipgrepCmd=I;function c(o,s,p,r){const m=["--files","--hidden","--case-sensitive"];h([s],p,!1).forEach(t=>{const u=(0,_.anchorGlob)(t);if(m.push("-g",u),n.isMacintosh){const a=(0,y.normalizeNFD)(u);a!==u&&m.push("-g",a)}});const i=v([s],r,void 0,!1);return i.globArgs.forEach(t=>{const u=`!${(0,_.anchorGlob)(t)}`;if(m.push("-g",u),n.isMacintosh){const a=(0,y.normalizeNFD)(u);a!==u&&m.push("-g",a)}}),s.disregardIgnoreFiles!==!1?m.push("--no-ignore"):m.push("--no-ignore-parent"),s.ignoreSymlinks||m.push("--follow"),o.exists&&m.push("--quiet"),m.push("--no-config"),s.disregardGlobalIgnoreFiles&&m.push("--no-ignore-global"),{args:m,siblingClauses:i.siblingClauses}}function v(o,s,p,r=!0){const m=[];let i={};return o.forEach(t=>{const u=Object.assign({},t.excludePattern||{},s||{}),a=w(u,r?t.folder.fsPath:void 0,p);m.push(...a.globArgs),a.siblingClauses&&(i=Object.assign(i,a.siblingClauses))}),{globArgs:m,siblingClauses:i}}e.foldersToRgExcludeGlobs=v;function h(o,s,p=!0){const r=[];return o.forEach(m=>{const i=Object.assign({},s||{},m.includePattern||{}),t=w(i,p?m.folder.fsPath:void 0);r.push(...t.globArgs)}),r}e.foldersToIncludeGlobs=h;function w(o,s,p){const r=[],m={};return Object.keys(o).forEach(i=>{if(p&&p.has(i)||!i)return;const t=o[i];i=T(s?E(s,i):i),i.startsWith("\\\\")?i="\\\\"+i.substr(2).replace(/\\/g,"/"):i=i.replace(/\\/g,"/"),typeof t=="boolean"&&t?(i.startsWith("\\\\")&&(i+="**"),r.push(b(i))):t&&t.when&&(m[i]=t)}),{globArgs:r,siblingClauses:m}}function E(o,s){return L.isAbsolute(s)?s:L.join(o,s)}e.getAbsoluteGlob=E;function T(o){return o=k.rtrim(o,"\\"),k.rtrim(o,"/")}function b(o){return C.getRoot(o).toLowerCase()==="c:/"?o.replace(/^c:[/\\]/i,"/"):o}e.fixDriveC=b}),define(fe[284],me([0,1,39,63,9,104,15,52,31,80,30,12,47,8,13,28,33,282,101]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const o=new Set;process.on("exit",()=>{o.forEach(i=>i())});class s{constructor(t){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=t,this.filePattern=t.filePattern||"",this.includePattern=t.includePattern&&_.parse(t.includePattern),this.maxResults=t.maxResults||null,this.exists=!!t.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,b.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=t.excludePattern&&_.parse(t.excludePattern),this.folderExcludePatterns=new Map,t.folderQueries.forEach(u=>{const a=Object.assign({},u.excludePattern||{},this.config.excludePattern||{}),l=u.folder.fsPath;t.folderQueries.map(f=>f.folder.fsPath).filter(f=>f!==l).forEach(f=>{(0,P.isEqualOrParent)(f,l)&&(a[y.relative(l,f)]=!0)}),this.folderExcludePatterns.set(l,new r(a,l))})}cancel(){this.isCanceled=!0,o.forEach(t=>t())}walk(t,u,a,l,f){if(this.fileWalkSW=c.StopWatch.create(!1),this.isCanceled)return f(null,this.isLimitHit);u.forEach(d=>{const S=y.basename(d.fsPath);this.globalExcludePattern&&this.globalExcludePattern(d.fsPath,S)||this.matchFile(a,{relativePath:d.fsPath,searchPath:void 0})}),this.cmdSW=c.StopWatch.create(!1),this.parallel(t,(d,S)=>{this.call(this.cmdTraversal,this,d,a,l,A=>{if(A){const R=(0,k.toErrorMessage)(A);console.error(R),this.errors.push(R),S(A,void 0)}else S(null,void 0)})},(d,S)=>{this.fileWalkSW.stop();const A=d?n.coalesce(d)[0]:null;f(A,this.isLimitHit)})}parallel(t,u,a){const l=new Array(t.length),f=new Array(t.length);let d=!1,S=0;if(t.length===0)return a(null,[]);t.forEach((A,R)=>{u(A,(B,x)=>{if(B?(d=!0,l[R]=null,f[R]=B):(l[R]=x,f[R]=null),++S===t.length)return a(d?f:null,l)})})}call(t,u,...a){try{t.apply(u,a)}catch(l){a[a.length-1](l)}}cmdTraversal(t,u,a,l){const f=t.folder.fsPath,d=I.isMacintosh;let S;const A=()=>S&&S.kill();o.add(A);let R=N=>{o.delete(A),R=()=>{},l(N)},B="";const x=this.initDirectoryTree();let F;const $=(0,T.spawnRipgrepCmd)(this.config,t,this.config.includePattern,this.folderExcludePatterns.get(t.folder.fsPath).expression);S=$.cmd,F=!Object.keys($.siblingClauses).length;const M=$.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let H=`${$.rgDiskPath} ${M}
 - cwd: ${$.cwd}`;$.rgArgs.siblingClauses&&(H+=`
 - Sibling clauses: ${JSON.stringify($.rgArgs.siblingClauses)}`),a({message:H}),this.cmdResultCount=0,this.collectStdout(S,"utf8",a,(N,U,V)=>{if(N){R(N);return}if(this.isLimitHit){R();return}const W=(B+(d?D.normalizeNFC(U||""):U)).split(`
`);if(V){const j=W.length;W[j-1]=W[j-1].trim(),W[j-1]||W.pop()}else B=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){R(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,F){for(const j of W)if(this.matchFile(u,{base:f,relativePath:j,searchPath:this.getSearchPath(t,j)}),this.isLimitHit){A();break}(V||this.isLimitHit)&&R();return}this.addDirectoryEntries(t,x,f,W,u),V&&(this.matchDirectoryTree(x,f,u),R())})}spawnFindCmd(t){const u=this.folderExcludePatterns.get(t.folder.fsPath),a=u.getBasenameTerms(),l=u.getPathTerms(),f=["-L","."];if(a.length||l.length){f.push("-not","(","(");for(const d of a)f.push("-name",d),f.push("-o");for(const d of l)f.push("-path",d),f.push("-o");f.pop(),f.push(")","-prune",")")}return f.push("-type","f"),g.spawn("find",f,{cwd:t.folder.fsPath})}readStdout(t,u,a){let l="";this.collectStdout(t,u,()=>{},(f,d,S)=>{if(f){a(f);return}l+=d,S&&a(null,l)})}collectStdout(t,u,a,l){let f=(A,R,B)=>{(A||B)&&(f=()=>{},this.cmdSW&&this.cmdSW.stop()),l(A,R,B)},d=!1;t.stdout?(this.forwardData(t.stdout,u,f),t.stdout.once("data",()=>d=!0)):a({message:"stdout is null"});let S;t.stderr?S=this.collectData(t.stderr):a({message:"stderr is null"}),t.on("error",A=>{f(A)}),t.on("close",A=>{let R;!d&&(R=this.decodeData(S,u))&&m(R)?f(new Error(`command failed with error code ${A}: ${this.decodeData(S,u)}`)):(this.exists&&A===0&&(this.isLimitHit=!0),f(null,"",!0))})}forwardData(t,u,a){const l=new C.StringDecoder(u);return t.on("data",f=>{a(null,l.write(f))}),l}collectData(t){const u=[];return t.on("data",a=>{u.push(a)}),u}decodeData(t,u){const a=new C.StringDecoder(u);return t.map(l=>a.write(l)).join("")}initDirectoryTree(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}addDirectoryEntries(t,{pathToEntries:u},a,l,f){l.indexOf(this.filePattern)!==-1&&this.matchFile(f,{base:a,relativePath:this.filePattern,searchPath:this.getSearchPath(t,this.filePattern)});const d=S=>{const A=y.basename(S),R=y.dirname(S);let B=u[R];B||(B=u[R]=[],d(R)),B.push({base:a,relativePath:S,basename:A,searchPath:this.getSearchPath(t,S)})};l.forEach(d)}matchDirectoryTree({rootEntries:t,pathToEntries:u},a,l){const f=this,d=this.folderExcludePatterns.get(a),S=this.filePattern;function A(R){f.directoriesWalked++;const B=_.hasSiblingFn(()=>R.map(x=>x.basename));for(let x=0,F=R.length;x<F;x++){const $=R[x],{relativePath:M,basename:H}=$;if(d.test(M,H,S!==H?B:void 0))continue;const N=u[M];if(N)A(N);else{if(f.filesWalked++,M===S)continue;f.matchFile(l,$)}if(f.isLimitHit)break}}A(t)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(t,u,a,l,f){const d=t.folder,S=_.hasSiblingFn(()=>a);this.parallel(a,(A,R)=>{if(this.isCanceled||this.isLimitHit)return R(null);const B=u?[u,A].join(y.sep):A;if(this.folderExcludePatterns.get(t.folder.fsPath).test(B,A,this.config.filePattern!==A?S:void 0))return R(null);const x=[d.fsPath,B].join(y.sep);L.lstat(x,(F,$)=>{if(F||this.isCanceled||this.isLimitHit)return R(null);this.statLinkIfNeeded(x,$,(M,H)=>M||this.isCanceled||this.isLimitHit?R(null):H.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(x,$,(N,U)=>N||this.isCanceled||this.isLimitHit||(U=U||"",this.walkedPaths[U])?R(null):(this.walkedPaths[U]=!0,w.Promises.readdir(x).then(V=>{if(this.isCanceled||this.isLimitHit)return R(null);this.doWalk(t,B,V,l,O=>R(O||null))},V=>{R(null)})))):(this.filesWalked++,B===this.filePattern||this.maxFilesize&&h.isNumber(H.size)&&H.size>this.maxFilesize||this.matchFile(l,{base:d.fsPath,relativePath:B,searchPath:this.getSearchPath(t,B)}),R(null,void 0)))})},A=>{const R=A&&n.coalesce(A);return f(R&&R.length>0?R[0]:void 0)})}matchFile(t,u){this.isFileMatch(u)&&(!this.includePattern||this.includePattern(u.relativePath,y.basename(u.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||t(u))}isFileMatch(t){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(t,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(t,u,a){return u.isSymbolicLink()?L.stat(t,a):a(null,u)}realPathIfNeeded(t,u,a){return u.isSymbolicLink()?L.realpath(t,(l,f)=>l?a(l):a(null,f)):a(null,t)}getSearchPath(t,u){return t.folderName?y.join(t.folderName,u):u}}e.FileWalker=s;class p{constructor(t){this.folderQueries=t.folderQueries,this.extraFiles=t.extraFileResources||[],this.walker=new s(t)}search(t,u,a){this.walker.walk(this.folderQueries,this.extraFiles,t,u,(l,f)=>{a(l,{limitHit:f,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=p;class r{constructor(t,u){this.expression=t,this.root=u,this.init(t)}init(t){let u,a;Object.keys(t).filter(l=>t[l]).forEach(l=>{y.isAbsolute(l)?(u=u||_.getEmptyExpression(),u[l]=t[l]):(a=a||_.getEmptyExpression(),a[l]=t[l])}),this.absoluteParsedExpr=u&&_.parse(u,{trimForExclusions:!0}),this.relativeParsedExpr=a&&_.parse(a,{trimForExclusions:!0})}test(t,u,a){return this.relativeParsedExpr&&this.relativeParsedExpr(t,u,a)||this.absoluteParsedExpr&&this.absoluteParsedExpr(y.join(this.root,t),u,a)}getBasenameTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getBasenameTerms(this.relativeParsedExpr)),t}getPathTerms(){const t=[];return this.absoluteParsedExpr&&t.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&t.push(..._.getPathTerms(this.relativeParsedExpr)),t}}function m(i){const t=i.trim().split(`
`),u=t[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return v.uppercaseFirstLetter(t[t.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}e.rgErrorMsgForDisplay=m}),define(fe[137],me([0,1,39,298,104,15,59,31,9,8,2,33,72,299,283,93]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=h.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class T{constructor(d){this.outputChannel=d}provideTextSearchResults(d,S,A,R){return this.outputChannel.appendLine(`provideTextSearchResults ${d.pattern}, ${JSON.stringify({...S,folder:S.folder.toString()})}`),new Promise((B,x)=>{R.onCancellationRequested(()=>O());const F=m(d,S),$=S.folder.fsPath,M=F.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.outputChannel.appendLine(`${E} ${M}
 - cwd: ${$}`);let H=g.spawn(E,F,{cwd:$});H.on("error",de=>{console.error(de),this.outputChannel.appendLine("Error: "+(de&&de.message)),x((0,I.serializeSearchError)(new I.SearchError(de&&de.message,I.SearchErrorCode.rgProcessError)))});let N=!1;const U=new s(S.maxResults,$,S.previewOptions);U.on("result",de=>{N=!0,j="",A.report(de)});let V=!1;const O=()=>{V=!0,H&&H.kill(),U&&U.cancel()};let W=!1;U.on("hitLimit",()=>{W=!0,O()});let j="";H.stdout.on("data",de=>{U.handleData(de),N||(j+=de)});let X=!1;H.stdout.once("data",()=>X=!0);let Q="";H.stderr.on("data",de=>{const Se=de.toString();this.outputChannel.appendLine(Se),Q+=Se}),H.on("close",()=>{if(this.outputChannel.appendLine(X?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),j&&this.outputChannel.appendLine(`Got data without result: ${j}`),this.outputChannel.appendLine(""),V)B({limitHit:W});else{U.flush(),H=null;let de;Q&&!X&&(de=b(Q))?x((0,I.serializeSearchError)(new I.SearchError(de.message,de.code))):B({limitHit:W})}})})}}e.RipgrepTextSearchEngine=T;function b(f){const d=f.split(`
`),S=d[0].trim();if(d.some(R=>R.startsWith("regex parse error")))return new I.SearchError(o(d),I.SearchErrorCode.regexParseError);const A=S.match(/grep config error: unknown encoding: (.*)/);if(A)return new I.SearchError(`Unknown encoding: ${A[1]}`,I.SearchErrorCode.unknownEncoding);if(S.startsWith("error parsing glob"))return new I.SearchError(S.charAt(0).toUpperCase()+S.substr(1),I.SearchErrorCode.globParseError);if(S.startsWith("the literal"))return new I.SearchError(S.charAt(0).toUpperCase()+S.substr(1),I.SearchErrorCode.invalidLiteral);if(S.startsWith("PCRE2: error compiling pattern"))return new I.SearchError(S,I.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=b;function o(f){const d=["Regex parse error"],S=f.filter(A=>A.startsWith("PCRE2:"));if(S.length>=1){const A=S[0].replace("PCRE2:","");if(A.indexOf(":")!==-1&&A.split(":").length>=2){const R=A.split(":")[1];d.push(":"+R)}}return d.join("")}e.buildRegexParseError=o;class s extends L.EventEmitter{constructor(d,S,A){super();this.maxResults=d,this.rootFolder=S,this.previewOptions=A,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new y.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(d,S){return super.on(d,S),this}handleData(d){if(this.isDone)return;const S=typeof d=="string"?d:this.stringDecoder.write(d);this.handleDecodedData(S)}handleDecodedData(d){let S=d.indexOf(`
`);const A=this.remainder+d;if(S>=0)S+=this.remainder.length;else{this.remainder=A;return}let R=0;for(;S>=0;)this.handleLine(A.substring(R,S).trim()),R=S+1,S=A.indexOf(`
`,R);this.remainder=A.substring(R)}handleLine(d){if(this.isDone||!d)return;let S;try{S=JSON.parse(d)}catch(A){throw new Error(`malformed line from rg: ${d}`)}if(S.type==="match"){const A=p(S.data.path),R=P.URI.file(_.join(this.rootFolder,A)),B=this.createTextSearchMatch(S.data,R);this.onResult(B),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(S.type==="context"){const A=p(S.data.path),R=P.URI.file(_.join(this.rootFolder,A));this.createTextSearchContext(S.data,R).forEach(x=>this.onResult(x))}}createTextSearchMatch(d,S){const A=d.line_number-1,R=p(d.lines),B=Buffer.from(R);let x=0,F=0,$=A;d.submatches.length===0&&d.submatches.push(R.length?{start:0,end:1,match:{text:R[0]}}:{start:0,end:0,match:{text:""}});const M=(0,C.coalesce)(d.submatches.map((H,N)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);const U=p(H.match),V=B.slice(x,H.start).toString().length,O=F+V,W=r(U),j=$,X=W.numLines+j,Q=W.numLines>0?W.lastLineLength:W.lastLineLength+O;return x=H.end,F=Q,$=X,new c.Range(j,O,X,Q)}));return(0,w.createTextSearchResult)(S,R,M,this.previewOptions)}createTextSearchContext(d,S){const A=p(d.lines),R=d.line_number;return A.replace(/\r?\n$/,"").split(`
`).map((B,x)=>({text:B,uri:S,lineNumber:R+x}))}onResult(d){this.emit("result",d)}}e.RipgrepParser=s;function p(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function r(f){const d=/\n/g;let S=0,A=-1,R;for(;R=d.exec(f);)S++,A=R.index;const B=A>=0?f.length-A-1:f.length;return{numLines:S,lastLineLength:B}}function m(f,d){const S=["--hidden"];S.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:A,otherIncludes:R}=(0,n.groupBy)(d.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(R&&R.length){const x=new Set;R.forEach(F=>{x.add(F)}),S.push("-g","!*"),x.forEach(F=>{i(F).map(w.anchorGlob).forEach($=>{S.push("-g",$)})})}A&&A.length&&A.forEach(x=>{S.push("-g",x)}),d.excludes.map(w.anchorGlob).forEach(x=>S.push("-g",`!${x}`)),d.maxFileSize&&S.push("--max-filesize",d.maxFileSize+""),d.useIgnoreFiles?S.push("--no-ignore-parent"):S.push("--no-ignore"),d.followSymlinks&&S.push("--follow"),d.encoding&&d.encoding!=="utf8"&&S.push("--encoding",d.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,D.escapeRegExpCharacters)(f.pattern),f.isRegExp=!0),d.usePCRE2&&S.push("--pcre2"),S.push("--crlf"),f.isRegExp&&(f.pattern=t(f.pattern),S.push("--auto-hybrid-regex"));let B;if(f.isWordMatch){const F=(0,D.createRegExp)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");S.push("--regexp",F)}else if(f.isRegExp){let x=a(f.pattern);x=l(x),S.push("--regexp",x)}else B=f.pattern,S.push("--fixed-strings");return S.push("--no-config"),d.useGlobalIgnoreFiles||S.push("--no-ignore-global"),S.push("--json"),f.isMultiline&&S.push("--multiline"),d.beforeContext&&S.push("--before-context",d.beforeContext+""),d.afterContext&&S.push("--after-context",d.afterContext+""),S.push("--"),B&&S.push(B),S.push("."),S}function i(f){const d=(0,k.splitGlobAware)(f,"/");return d.map((S,A)=>d.slice(0,A+1).join("/"))}e.spreadGlobComponents=i;function t(f){const d=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(d);)f=f.replace(d,"$1\\x{$2}");const S=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(S);)f=f.replace(S,"$1\\x{$2}");return f}e.unicodeEscapesToPCRE2=t;const u=f=>f.type==="Assertion"&&f.kind==="lookbehind";function a(f){let d;try{d=new v.RegExpParser().parsePattern(f)}catch{return f}let S="",A=0;const R=(F,$,M)=>{S+=f.slice(A,F)+M,A=$},B=[];return new v.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const $=B[0];if(!$)R(F.start,F.end,"\\r?\\n");else if(!B.some(u))if($.type==="CharacterClass")if($.negate){const M=f.slice($.start+2,F.start)+f.slice(F.end,$.end-1);if($.parent?.type==="Quantifier"){const H=$.parent;R(H.start,H.end,(M?`[^${M}]`:".")+(H.greedy?"+":"*"))}else R($.start,$.end,"(?!\\r?\\n"+(M?`|[${M}]`:"")+")")}else{const M=f.slice($.start+1,F.start)+f.slice(F.end,$.end-1);R($.start,$.end,M===""?"\\r?\\n":`(?:[${M}]|\\r?\\n)`)}else $.type==="Quantifier"&&R(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){B.unshift(F)},onQuantifierLeave(){B.shift()},onCharacterClassRangeEnter(F){B.unshift(F)},onCharacterClassRangeLeave(){B.shift()},onCharacterClassEnter(F){B.unshift(F)},onCharacterClassLeave(){B.shift()},onAssertionEnter(F){u(F)&&B.push(F)},onAssertionLeave(F){B[0]===F&&B.shift()}}).visit(d),S+=f.slice(A),S}e.fixRegexNewline=a;function l(f){return f.replace(/\n/g,"\\r?\\n")}e.fixNewline=l}),define(fe[285],me([0,1,21,137,117,10]),function(Y,e,g,L,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class n{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,P,I,c){const v=new L.RipgrepTextSearchEngine(this.outputChannel);if(P.folder.scheme===C.Schemas.userData){const h={...P,folder:P.folder.with({scheme:C.Schemas.file})},w=new y.Progress(E=>I.report({...E,uri:E.uri.with({scheme:P.folder.scheme})}));return this.withToken(c,E=>v.provideTextSearchResults(D,h,w,E))}else return this.withToken(c,h=>v.provideTextSearchResults(D,P,I,h))}async withToken(D,P){const I=k(D);this.inProgress.add(I);const c=await P(I.token);return this.inProgress.delete(I),c}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=n;function k(_){const D=new g.CancellationTokenSource;return _.onCancellationRequested(()=>D.cancel()),D}}),define(fe[286],me([0,1,28,137,136]),function(Y,e,g,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class C{constructor(_){this.query=_}search(_,D,P){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(v){P({message:v})}},c=new y.NativeTextSearchManager(this.query,new L.RipgrepTextSearchEngine(I),g);return new Promise((v,h)=>c.search(w=>{D(w.map(n))},_).then(w=>v({limitHit:w.limitHit,type:"success",stats:w.stats}),h))}}e.TextSearchEngineAdapter=C;function n(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((_,D)=>{if(D.ranges){const P=D;return _+(Array.isArray(P.ranges)?P.ranges.length:1)}else return _+1},0)}}}),define(fe[287],me([0,1,15,16,18,3,101,9,47,2,43,33,284,286]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class h{constructor(s="searchProcess"){this.processType=s,this.caches=Object.create(null)}fileSearch(s){let p;const r=T(s),m=new C.Emitter({onFirstListenerDidAdd:()=>{p=(0,L.createCancelablePromise)(i=>this.doFileSearchWithEngine(c.Engine,r,t=>m.fire(t),i)),p.then(i=>m.fire(i),i=>m.fire({type:"error",error:{message:i.message,stack:i.stack}}))},onLastListenerRemove:()=>{p.cancel()}});return m.event}textSearch(s){let p;const r=T(s),m=new C.Emitter({onFirstListenerDidAdd:()=>{p=(0,L.createCancelablePromise)(i=>this.ripgrepTextSearch(r,t=>m.fire(t),i)),p.then(i=>m.fire(i),i=>m.fire({type:"error",error:{message:i.message,stack:i.stack}}))},onLastListenerRemove:()=>{p.cancel()}});return m.event}ripgrepTextSearch(s,p,r){return s.maxFileSize=(0,P.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new v.TextSearchEngineAdapter(s).search(r,p,p)}doFileSearch(s,p,r){return this.doFileSearchWithEngine(c.Engine,s,p,r)}doFileSearchWithEngine(s,p,r,m,i=h.BATCH_SIZE){let t=0;const u=l=>{Array.isArray(l)?(t+=l.length,r(l.map(f=>this.rawMatchToSearchItem(f)))):l.relativePath?(t++,r(this.rawMatchToSearchItem(l))):r(l)};if(p.sortByScore){let l=this.trySortedSearchFromCache(p,u,m);if(!l){const f=p.maxResults?Object.assign({},p,{maxResults:null}):p,d=new s(f);l=this.doSortedSearch(d,p,r,u,m)}return new Promise((f,d)=>{l.then(([S,A])=>{const R=A.map(B=>this.rawMatchToSearchItem(B));this.sendProgress(R,r,i),f(S)},d)})}const a=new s(p);return this.doSearch(a,u,i,m).then(l=>({limitHit:l.limitHit,type:"success",stats:{detailStats:l.stats,type:this.processType,fromCache:!1,resultCount:t,sortingTime:void 0}}))}rawMatchToSearchItem(s){return{path:s.base?(0,k.join)(s.base,s.relativePath):s.relativePath}}doSortedSearch(s,p,r,m,i){const t=new C.Emitter;let u=(0,L.createCancelablePromise)(l=>{let f=[];const d=S=>{Array.isArray(S)?f=S:(m(S),t.fire(S))};return this.doSearch(s,d,-1,l).then(S=>[S,f])}),a;if(p.cacheKey){a=this.getOrCreateCache(p.cacheKey);const l={promise:u,event:t.event,resolved:!1};a.resultsToSearchCache[p.filePattern||""]=l,u.then(()=>{l.resolved=!0},f=>{delete a.resultsToSearchCache[p.filePattern||""]}),u=this.preventCancellation(u)}return u.then(([l,f])=>{const d=a?a.scorerCache:Object.create(null),S=(typeof p.maxResults!="number"||p.maxResults>0)&&_.StopWatch.create(!1);return this.sortResults(p,f,d,i).then(A=>{const R=S?S.elapsed():-1;return[{type:"success",stats:{detailStats:l.stats,sortingTime:R,fromCache:!1,type:this.processType,workspaceFolderCount:p.folderQueries.length,resultCount:A.length},messages:l.messages,limitHit:l.limitHit||typeof p.maxResults=="number"&&f.length>p.maxResults},A]})})}getOrCreateCache(s){const p=this.caches[s];return p||(this.caches[s]=new w)}trySortedSearchFromCache(s,p,r){const m=s.cacheKey&&this.caches[s.cacheKey];if(!m)return;const i=this.getResultsFromCache(m,s.filePattern||"",p,r);if(i)return i.then(([t,u,a])=>{const l=_.StopWatch.create(!1);return this.sortResults(s,u,m.scorerCache,r).then(f=>{const d=l.elapsed(),S={fromCache:!0,detailStats:a,type:this.processType,resultCount:u.length,sortingTime:d};return[{type:"success",limitHit:t.limitHit||typeof s.maxResults=="number"&&u.length>s.maxResults,stats:S},f]})})}sortResults(s,p,r,m){const i=(0,n.prepareQuery)(s.filePattern||""),t=(a,l)=>(0,n.compareItemsByFuzzyScore)(a,l,i,!0,E,r),u=typeof s.maxResults=="number"?s.maxResults:Number.MAX_VALUE;return g.topAsync(p,t,u,1e4,m)}sendProgress(s,p,r){if(r&&r>0)for(let m=0;m<s.length;m+=r)p(s.slice(m,m+r));else p(s)}getResultsFromCache(s,p,r,m){const i=_.StopWatch.create(!1),t=p.indexOf(k.sep)>=0;let u;for(const d in s.resultsToSearchCache)if(p.startsWith(d)){if(t&&d.indexOf(k.sep)<0&&d!=="")continue;const S=s.resultsToSearchCache[d];u={promise:this.preventCancellation(S.promise),event:S.event,resolved:S.resolved};break}if(!u)return null;const a=i.elapsed(),l=_.StopWatch.create(!1),f=u.event(r);return m&&m.onCancellationRequested(()=>{f.dispose()}),u.promise.then(([d,S])=>{if(m&&m.isCancellationRequested)throw(0,y.canceled)();const A=[],R=(0,n.prepareQuery)(p).normalizedLowercase;for(const B of S)!(0,I.isFilePatternMatch)(B,R)||A.push(B);return[d,A,{cacheWasResolved:u.resolved,cacheLookupTime:a,cacheFilterTime:l.elapsed(),cacheEntryCount:S.length}]})}doSearch(s,p,r,m){return new Promise((i,t)=>{let u=[];m&&m.onCancellationRequested(()=>s.cancel()),s.search(a=>{a&&(r?(u.push(a),r>0&&u.length>=r&&(p(u),u=[])):p(a))},a=>{p(a)},(a,l)=>{u.length&&p(u),a?t(a):i(l)})})}clearCache(s){return delete this.caches[s],Promise.resolve(void 0)}preventCancellation(s){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(p,r){return s.then(p,r)}catch(p){return this.then(void 0,p)}finally(p){return s.finally(p)}}}}e.SearchService=h,h.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const E=new class{getItemLabel(o){return(0,k.basename)(o.relativePath)}getItemDescription(o){return(0,k.dirname)(o.relativePath)}getItemPath(o){return o.relativePath}};function T(o){return{...o,folderQueries:o.folderQueries&&o.folderQueries.map(b),extraFileResources:o.extraFileResources&&o.extraFileResources.map(s=>D.URI.revive(s))}}function b(o){return{...o,folder:D.URI.revive(o.folder)}}}),define(fe[288],me([0,1,6,10,2,28,11,26,14,75,67,33,287,285,93,136]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends D.ExtHostSearch{constructor(b,o,s,p){super(b,s,p);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,this._registeredEHSearchProvider=!1;const r=new h.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(L.Schemas.userData,new v.RipgrepSearchProvider(r)),o.remote.isRemote&&o.remote.authority&&this._registerEHSearchProviders()}$enableExtensionHostSearch(){this._registerEHSearchProviders()}_registerEHSearchProviders(){if(this._registeredEHSearchProvider)return;this._registeredEHSearchProvider=!0;const b=new h.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(L.Schemas.file,new v.RipgrepSearchProvider(b)),this.registerInternalFileSearchProvider(L.Schemas.file,new c.SearchService("fileSearchProvider"))}registerInternalFileSearchProvider(b,o){const s=this._handlePool++;return this._internalFileSearchProvider=o,this._internalFileSearchHandle=s,this._proxy.$registerFileSearchProvider(s,this._transformScheme(b)),(0,g.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(s)})}$provideFileSearchResults(b,o,s,p){const r=(0,D.reviveQuery)(s);return b===this._internalFileSearchHandle?this.doInternalFileSearch(b,o,r,p):super.$provideFileSearchResults(b,o,s,p)}doInternalFileSearch(b,o,s,p){const r=m=>{if((0,I.isSerializedFileMatch)(m)&&(m=[m]),Array.isArray(m)){this._proxy.$handleFileMatch(b,o,m.map(i=>y.URI.file(i.path)));return}m.message&&this._logService.debug("ExtHostSearch",m.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(s,r,p)}$clearCache(b){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(b),super.$clearCache(b)}createTextSearchManager(b,o){return new w.NativeTextSearchManager(b,o,void 0,"textSearchProvider")}};E=Ve([$e(0,_.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,P.IURITransformerService),$e(3,n.ILogService)],E),e.NativeExtHostSearch=E}),define(fe[138],me([0,1,300,125,82,22,18,3,6,9,12,32,106,107,301]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{constructor(l){this.socket=l,this._errorListener=f=>{if(f){if(f.code==="EPIPE")return;(0,n.onUnexpectedError)(f)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(l){const f=d=>l(C.VSBuffer.wrap(d));return this.socket.on("data",f),{dispose:()=>this.socket.off("data",f)}}onClose(l){const f=d=>{l({type:0,hadError:d,error:void 0})};return this.socket.on("close",f),{dispose:()=>this.socket.off("close",f)}}onEnd(l){return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(l){if(!this.socket.destroyed)try{this.socket.write(l.buffer,f=>{if(f){if(f.code==="EPIPE")return;(0,n.onUnexpectedError)(f)}})}catch(f){if(f.code==="EPIPE")return;(0,n.onUnexpectedError)(f)}}end(){this.socket.end()}drain(){return new Promise((l,f)=>{if(this.socket.bufferSize===0){l();return}const d=()=>{this.socket.off("close",d),this.socket.off("end",d),this.socket.off("error",d),this.socket.off("timeout",d),this.socket.off("drain",d),l()};this.socket.on("close",d),this.socket.on("end",d),this.socket.on("error",d),this.socket.on("timeout",d),this.socket.on("drain",d)})}}e.NodeSocket=w;var E;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var T;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(T||(T={}));class b extends _.Disposable{constructor(l,f,d,S){super();this._onDidZlibFlush=this._register(new k.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=f,this._recordInflateBytes=S,f?(this._zlibInflate=h.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",A=>{console.error(A),(0,n.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibInflate.on("data",A=>{this._pendingInflateData.push(A)}),d&&(this._zlibInflate.write(d.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{console.error(A),(0,n.onUnexpectedError)(A),this._onClose.fire({type:0,hadError:!0,error:A})}),this._zlibDeflate.on("data",A=>{this._pendingDeflateData.push(A)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new v.ChunkStream,this._register(this.socket.onData(A=>this._acceptChunk(A))),this._register(this.socket.onClose(A=>this._onClose.fire(A)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this._onData.event(l)}onClose(l){return this._onClose.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){this._totalOutgoingDataBytes+=l.byteLength,this._zlibDeflate?(this._zlibDeflate.write(l.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let f=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,f=f.slice(0,f.length-4),this._isEnded||this._write(C.VSBuffer.wrap(f),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(l,!1)}_write(l,f){let d=2;l.byteLength<126?d+=0:l.byteLength<2**16?d+=2:d+=8;const S=C.VSBuffer.alloc(d);if(f?S.writeUInt8(194,0):S.writeUInt8(130,0),l.byteLength<126)S.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){S.writeUInt8(126,1);let A=1;S.writeUInt8(l.byteLength>>>8&255,++A),S.writeUInt8(l.byteLength>>>0&255,++A)}else{S.writeUInt8(127,1);let A=1;S.writeUInt8(0,++A),S.writeUInt8(0,++A),S.writeUInt8(0,++A),S.writeUInt8(0,++A),S.writeUInt8(l.byteLength>>>24&255,++A),S.writeUInt8(l.byteLength>>>16&255,++A),S.writeUInt8(l.byteLength>>>8&255,++A),S.writeUInt8(l.byteLength>>>0&255,++A)}this._totalOutgoingWireBytes+=S.byteLength+l.byteLength,this.socket.write(C.VSBuffer.concat([S,l]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(l){if(l.byteLength!==0){for(this._totalIncomingWireBytes+=l.byteLength,this._incomingData.acceptChunk(l);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const f=this._incomingData.peek(this._state.readLen),d=f.readUInt8(0),S=(d&128)>>>7,A=(d&64)>>>6,R=f.readUInt8(1),B=(R&128)>>>7,x=R&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(x===126?2:0)+(x===127?8:0),this._state.fin=S,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(A)),this._state.firstFrameOfMessage=Boolean(S),this._state.mask=0}else if(this._state.state===2){const f=this._incomingData.read(this._state.readLen),d=f.readUInt8(1),S=(d&128)>>>7;let A=d&127,R=1;A===126?A=f.readUInt8(++R)*2**8+f.readUInt8(++R):A===127&&(A=f.readUInt8(++R)*0+f.readUInt8(++R)*0+f.readUInt8(++R)*0+f.readUInt8(++R)*0+f.readUInt8(++R)*2**24+f.readUInt8(++R)*2**16+f.readUInt8(++R)*2**8+f.readUInt8(++R));let B=0;S&&(B=f.readUInt8(++R)*2**24+f.readUInt8(++R)*2**16+f.readUInt8(++R)*2**8+f.readUInt8(++R)),this._state.state=3,this._state.readLen=A,this._state.mask=B}else if(this._state.state===3){const f=this._incomingData.read(this._state.readLen);o(f,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(f.buffer)),this._zlibInflate.write(f.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const d=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=d.length,this._onData.fire(C.VSBuffer.wrap(d))})):(this._totalIncomingDataBytes+=f.byteLength,this._onData.fire(f))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await k.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=b;function o(a,l){if(l===0)return;let f=a.byteLength>>>2;for(let x=0;x<f;x++){const F=a.readUInt32BE(x*4);a.writeUInt32BE(F^l,x*4)}let d=f*4,S=a.byteLength-d;const A=l>>>24&255,R=l>>>16&255,B=l>>>8&255;S>=1&&a.writeUInt8(a.readUInt8(d)^A,d),S>=2&&a.writeUInt8(a.readUInt8(d+1)^R,d+1),S>=3&&a.writeUInt8(a.readUInt8(d+2)^B,d+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function p(){const a=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let l;return e.XDG_RUNTIME_DIR?l=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):l=(0,D.join)((0,y.tmpdir)(),`vscode-ipc-${a}.sock`),m(l),l}e.createRandomIPCHandle=p;function r(a,l,f){const d=(0,g.createHash)("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${d}-${f}-${l}-sock`;let S;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?S=(0,D.join)(e.XDG_RUNTIME_DIR,`vscode-${d.substr(0,8)}-${f}-${l}.sock`):S=(0,D.join)(a,`${f}-${l}.sock`),m(S),S}e.createStaticIPCHandle=r;function m(a){const l=s[P.platform];typeof l=="number"&&a.length>=l&&console.warn(`WARNING: IPC handle "${a}" is longer than ${l} chars, try a shorter --user-data-dir`)}class i extends c.IPCServer{constructor(l){super(i.toClientConnectionEvent(l));this.server=l}static toClientConnectionEvent(l){const f=k.Event.fromNodeEventEmitter(l,"connection");return k.Event.map(f,d=>({protocol:new v.Protocol(new w(d)),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(d,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=i;function t(a){return new Promise((l,f)=>{const d=(0,L.createServer)();d.on("error",f),d.listen(a,()=>{d.removeListener("error",f),l(new i(d))})})}e.serve=t;function u(a,l){return new Promise((f,d)=>{const S=(0,L.createConnection)(a,()=>{S.removeListener("error",d),f(v.Client.fromSocket(new w(S),l))});S.once("error",d)})}e.connect=u}),define(fe[289],me([0,1,138,281,63,40,2,200,11]),function(Y,e,g,L,y,C,n,k,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(c,v,h){this._commands=c,this.logService=v,this._ipcHandlePath=h,this._server=L.createServer((w,E)=>this.onRequest(w,E)),this.setup().catch(w=>(v.error(w),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",c=>this.logService.error(c))}catch(c){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(c,v){const h=[];c.setEncoding("utf8"),c.on("data",w=>h.push(w)),c.on("end",()=>{const w=JSON.parse(h.join(""));switch(w.type){case"open":this.open(w,v);break;case"openExternal":this.openExternal(w,v);break;case"status":this.getStatus(w,v);break;case"extensionManagement":this.manageExtensions(w,v).catch(this.logService.error);break;default:v.writeHead(404),v.write(`Unknown message type: ${w.type}`,E=>{E&&this.logService.error(E)}),v.end();break}})}open(c,v){let{fileURIs:h,folderURIs:w,forceNewWindow:E,diffMode:T,addMode:b,forceReuseWindow:o,gotoLineMode:s,waitMarkerFilePath:p}=c;const r=[];if(Array.isArray(w))for(const m of w)try{r.push({folderUri:n.URI.parse(m)})}catch(i){}if(Array.isArray(h))for(const m of h)try{(0,k.hasWorkspaceFileExtension)(m)?r.push({workspaceUri:n.URI.parse(m)}):r.push({fileUri:n.URI.parse(m)})}catch(i){}if(r.length){const m=p?n.URI.file(p):void 0,t={forceNewWindow:E,diffMode:T,addMode:b,gotoLineMode:s,forceReuseWindow:o,preferNewWindow:!o&&!m&&!b,waitMarkerFileURI:m};this._commands.executeCommand("_remoteCLI.windowOpen",r,t)}v.writeHead(200),v.end()}async openExternal(c,v){for(const h of c.uris){const w=n.URI.parse(h),E=w.scheme==="file"?w:h;await this._commands.executeCommand("_remoteCLI.openExternal",E)}v.writeHead(200),v.end()}async manageExtensions(c,v){try{const h=T=>T?.map(b=>/\.vsix$/i.test(b)?n.URI.parse(b):b),w={list:c.list,install:h(c.install),uninstall:h(c.uninstall),force:c.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",w);v.writeHead(200),v.write(E)}catch(h){v.writeHead(500),v.write(String(h),w=>{w&&this.logService.error(w)})}v.end()}async getStatus(c,v){try{const h=await this._commands.executeCommand("_remoteCLI.getSystemStatus");v.writeHead(200),v.write(h),v.end()}catch(h){v.writeHead(500),v.write(String(h),w=>{w&&this.logService.error(w)}),v.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&y.existsSync(this._ipcHandlePath)&&y.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let P=class extends D{constructor(c,v){super(c,v,(0,g.createRandomIPCHandle)())}};P=Ve([$e(0,C.IExtHostCommands),$e(1,_.ILogService)],P),e.CLIServer=P}),define(fe[290],me([0,1,74,277,272,5,280,41,262,2,10,7,289,105]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends y.RequireInterceptor{_installInterceptor(){const T=this,b=Y.__$__nodeRequire("module"),o=b._load;b._load=function(p,r,m){for(let i of T._alternatives){let t=i(p);if(t){p=t;break}}return T._factories.has(p)?T._factories.get(p).load(p,D.URI.file((0,v.realpathSync)(r.filename)),i=>o.apply(this,[i,r,m])):o.apply(this,arguments)}}}class w extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=I.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const T=this._instaService.invokeFunction(L.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const r=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=r.ipcHandlePath}await this._instaService.createInstance(h,T,this._registry).install(),g.mark("code/extHost/didInitAPI");const o=await this._extHostConfiguration.getConfigProvider();await(0,n.connectProxyResolver)(this._extHostWorkspace,o,this,this._logService,this._mainThreadTelemetryProxy,this._initData),g.mark("code/extHost/didInitProxyResolver");const s=process.send,p=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);process.send=(...r)=>r.length===0||!r[0]||r[0].type!=="__$console"?s.apply(process,r):(p.$logExtensionHostMessage(r[0]),!1)}_getEntryPoint(T){return T.main}_loadCommonJSModule(T,b,o){if(b.scheme!==P.Schemas.file)throw new Error(`Cannot load URI: '${b}', must be of file-scheme`);let s=null;o.codeLoadingStart(),this._logService.trace(`ExtensionService#loadCommonJSModule ${b.toString(!0)}`),this._logService.flush();try{T&&g.mark(`code/extHost/willLoadExtensionCode/${T.value}`),s=Y.__$__nodeRequire(b.fsPath)}catch(p){return Promise.reject(p)}finally{T&&g.mark(`code/extHost/didLoadExtensionCode/${T.value}`),o.codeLoadingStop()}return Promise.resolve(s)}async $setRemoteEnvironment(T){if(!!this._initData.remote.isRemote)for(const b in T){const o=T[b];o===null?delete process.env[b]:process.env[b]=o}}}e.ExtHostExtensionService=w}),define(fe[291],me([0,1,84,265,274,273,288,290,266,57,41,75,73,34,54,70,264,263,11]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.registerSingleton)(P.IExtHostExtensionService,k.ExtHostExtensionService),(0,g.registerSingleton)(b.ILoggerService,T.ExtHostLoggerService),(0,g.registerSingleton)(w.IExtensionStoragePaths,E.ExtensionStoragePaths),(0,g.registerSingleton)(D.IExtHostDebugService,C.ExtHostDebugService),(0,g.registerSingleton)(I.IExtHostSearch,n.NativeExtHostSearch),(0,g.registerSingleton)(c.IExtHostTask,y.ExtHostTask),(0,g.registerSingleton)(v.IExtHostTerminalService,L.ExtHostTerminalService),(0,g.registerSingleton)(h.IExtHostTunnelService,_.ExtHostTunnelService)}),define(fe[292],me([0,1,125,302,74,18,107,138,193,228,275,22,103,28,105,16,114,278,291]),function(Y,e,g,L,y,C,n,k,_,D,P,I,c,v,h,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let u=0;u<process.execArgv.length;u++)process.execArgv[u]==="--inspect-port=0"&&(process.execArgv.splice(u,1),u--)}();const T=L(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"],boolean:["skipWorkspaceStorageLock"]});(function(){const t=Y.__$__nodeRequire("module"),u=t._load;t._load=function(a){if(a==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return u.apply(this,arguments)}})();const b=process.exit.bind(process);function o(t){process.exit=function(u){if(t)b(u);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const u=new Error("An extension called process.crash() and this was prevented.");console.warn(u.stack)}}let s=function(t){b()};function p(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((t,u)=>{let a=null,l=setTimeout(()=>{s("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const f=108e5,d=3e5,S=new w.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (1)"),f),A=new w.ProcessTimeRunOnceScheduler(()=>s("renderer disconnected for too long (2)"),d);process.on("message",(B,x)=>{if(B&&B.type==="VSCODE_EXTHOST_IPC_SOCKET"){const F=I.VSBuffer.wrap(Buffer.from(B.initialDataChunk,"base64"));let $;if(B.skipWebSocketFrames)$=new k.NodeSocket(x);else{const M=I.VSBuffer.wrap(Buffer.from(B.inflateBytes,"base64"));$=new k.WebSocketNodeSocket(new k.NodeSocket(x),B.permessageDeflate,M,!1)}a?(S.cancel(),A.cancel(),a.beginAcceptReconnection($,F),a.endAcceptReconnection()):(clearTimeout(l),a=new n.PersistentProtocol($,F),a.onDidDispose(()=>s("renderer disconnected")),t(a),a.onSocketClose(()=>{S.schedule()}))}if(B&&B.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(A.isScheduled())return;S.isScheduled()&&A.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const t=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((u,a)=>{const l=g.createConnection(t,()=>{l.removeListener("error",a),u(new n.PersistentProtocol(new k.NodeSocket(l)))});l.once("error",a),l.on("close",()=>{s("renderer closed the socket")})})}}async function r(){const t=await p();return new class{constructor(){this._onMessage=new n.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,t.onMessage(u=>{(0,D.isMessageOfType)(u,2)?(this._terminating=!0,s("received terminate message from renderer")):this._onMessage.fire(u)})}send(u){this._terminating||t.send(u)}drain(){return t.drain()}}}function m(t){return new Promise(u=>{const a=t.onMessage(l=>{a.dispose();const f=JSON.parse(l.toString()),d=f.commit,S=_.default.commit;d&&S&&d!==S&&b(55);let A=0;setInterval(function(){try{process.kill(f.parentPid,0),A=0}catch(B){B&&B.code==="EPERM"?(A++,A>=3&&s(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${B.message} (code: ${B.code}) (errno: ${B.errno})`)):s(`parent process ${f.parentPid} does not exist anymore: ${B.message} (code: ${B.code}) (errno: ${B.errno})`)}},1e3);let R;try{R=Y.__$__nodeRequire("native-watchdog"),R.start(f.parentPid)}catch(B){(0,C.onUnexpectedError)(B)}t.send((0,D.createMessageOfType)(0)),u({protocol:t,initData:f})});t.send((0,D.createMessageOfType)(1))})}async function i(){const t=[];process.on("unhandledRejection",(A,R)=>{t.push(R),setTimeout(()=>{const B=t.indexOf(R);B>=0&&R.catch(x=>{t.splice(B,1),(0,C.isPromiseCanceledError)(x)||(console.warn(`rejected promise not handled within 1 second: ${x}`),x&&x.stack&&console.warn(`stack trace: ${x.stack}`),A&&(0,C.onUnexpectedError)(A))})},1e3)}),process.on("rejectionHandled",A=>{const R=t.indexOf(A);R>=0&&t.splice(R,1)}),process.on("uncaughtException",function(A){(0,C.onUnexpectedError)(A)}),y.mark("code/extHost/willConnectToRenderer");const u=await r();y.mark("code/extHost/didConnectToRenderer");const a=await m(u);y.mark("code/extHost/didWaitForInitData");const{initData:l}=a;o(!!l.environment.extensionTestsLocationURI),l.environment.useHostProxy=T.useHostProxy!==void 0?T.useHostProxy!=="false":void 0,l.environment.skipWorkspaceStorageLock=(0,E.boolean)(T.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(R){b(R)}exists(R){return v.Promises.exists(R)}realpath(R){return(0,h.realpath)(R)}};let d=null;if(l.remote.authority&&T.uriTransformerPath)try{const R=Y.__$__nodeRequire(T.uriTransformerPath)(l.remote.authority);d=new c.URITransformer(R)}catch(A){console.error(A)}const S=new P.ExtensionHostMain(a.protocol,l,f,d);s=A=>S.terminate(A)}e.startExtensionHostProcess=i}),define(fe[303],me([0,1,292]),function(Y,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,g.startExtensionHostProcess)().catch(L=>console.log(L))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3bd29c1d6c6ef5b6265614def99b7257b671ae19/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
