/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/platform/contextkey/common/contextkey","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/base/common/errorMessage","vs/platform/files/common/files","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(re){for(var e=[],l=0,M=re.length;l<M;l++)e[l]=be[re[l]];return e};define(be[43],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function l(M,E){if(!M)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=l}),define(be[54],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const l=Object.prototype.hasOwnProperty;function M(F){const _=[];for(let n in F)l.call(F,n)&&_.push(F[n]);return _}e.values=M;function E(F,_){for(let n in F)if(l.call(F,n)&&_({key:n,value:F[n]},function(){delete F[n]})===!1)return}e.forEach=E;function T(F,_){const n=Object.create(null);for(const m of F){const a=_(m);let h=n[a];h||(h=n[a]=[]),h.push(m)}return n}e.groupBy=T;function t(F){const _=Object.create(null);return F&&F.forEach((n,m)=>{_[m]=n}),_}e.fromMap=t;function A(F,_){const n=[],m=[];for(let a of F)_.has(a)||n.push(a);for(let a of _)F.has(a)||m.push(a);return{removed:n,added:m}}e.diffSets=A;function D(F,_){const n=[],m=[];for(let[a,h]of F)_.has(a)||n.push(h);for(let[a,h]of _)F.has(a)||m.push(h);return{removed:n,added:m}}e.diffMaps=D;class I{constructor(){this.map=new Map}add(_,n){let m=this.map.get(_);m||(m=new Set,this.map.set(_,m)),m.add(n)}delete(_,n){const m=this.map.get(_);!m||(m.delete(n),m.size===0&&this.map.delete(_))}forEach(_,n){const m=this.map.get(_);!m||m.forEach(n)}}e.SetMap=I}),define(be[55],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function l(t){return(A,D,I)=>{let F=null,_=null;if(typeof I.value=="function"?(F="value",_=I.value):typeof I.get=="function"&&(F="get",_=I.get),!_)throw new Error("not supported");I[F]=t(_,D)}}e.createDecorator=l;function M(t,A,D){let I=null,F=null;if(typeof D.value=="function"?(I="value",F=D.value,F.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(I="get",F=D.get),!F)throw new Error("not supported");const _=`$memoize$${A}`;D[I]=function(...n){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:F.apply(this,n)}),this[_]}}e.memoize=M;function E(t,A,D){return l((I,F)=>{const _=`$debounce$${F}`,n=`$debounce$result$${F}`;return function(...m){this[n]||(this[n]=D?D():void 0),clearTimeout(this[_]),A&&(this[n]=A(this[n],...m),m=[this[n]]),this[_]=setTimeout(()=>{I.apply(this,m),this[n]=D?D():void 0},t)}})}e.debounce=E;function T(t,A,D){return l((I,F)=>{const _=`$throttle$timer$${F}`,n=`$throttle$result$${F}`,m=`$throttle$lastRun$${F}`,a=`$throttle$pending$${F}`;return function(...h){if(this[n]||(this[n]=D?D():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),A&&(this[n]=A(this[n],...h)),this[a])return;const g=this[m]+t;g<=Date.now()?(this[m]=Date.now(),I.apply(this,[this[n]]),this[n]=D?D():void 0):(this[a]=!0,this[_]=setTimeout(()=>{this[a]=!1,this[m]=Date.now(),I.apply(this,[this[n]]),this[n]=D?D():void 0},g-Date.now()))}})}e.throttle=T}),define(be[56],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class l{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=l,e.defaultGenerator=new l("id#")}),define(be[102],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var l;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(l=e.ScanError||(e.ScanError={}));var M;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(r){r.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function t(r,b=!1){let o=0,i=r.length,p="",c=0,u=16,w=0;function f(x){let N=0,V=0;for(;N<x;){const W=r.charCodeAt(o);if(W>=48&&W<=57)V=V*16+W-48;else if(W>=65&&W<=70)V=V*16+W-65+10;else if(W>=97&&W<=102)V=V*16+W-97+10;else break;o++,N++}return N<x&&(V=-1),V}function y(x){o=x,p="",c=0,u=16,w=0}function R(){const x=o;if(r.charCodeAt(o)===48)o++;else for(o++;o<r.length&&I(r.charCodeAt(o));)o++;if(o<r.length&&r.charCodeAt(o)===46)if(o++,o<r.length&&I(r.charCodeAt(o)))for(o++;o<r.length&&I(r.charCodeAt(o));)o++;else return w=3,r.substring(x,o);let N=o;if(o<r.length&&(r.charCodeAt(o)===69||r.charCodeAt(o)===101))if(o++,(o<r.length&&r.charCodeAt(o)===43||r.charCodeAt(o)===45)&&o++,o<r.length&&I(r.charCodeAt(o))){for(o++;o<r.length&&I(r.charCodeAt(o));)o++;N=o}else w=3;return r.substring(x,N)}function P(){let x="",N=o;for(;;){if(o>=i){x+=r.substring(N,o),w=2;break}const V=r.charCodeAt(o);if(V===34){x+=r.substring(N,o),o++;break}if(V===92){if(x+=r.substring(N,o),o++,o>=i){w=2;break}switch(r.charCodeAt(o++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:const $=f(4);$>=0?x+=String.fromCharCode($):w=4;break;default:w=5}N=o;continue}if(V>=0&&V<=31)if(D(V)){x+=r.substring(N,o),w=2;break}else w=6;o++}return x}function B(){if(p="",w=0,c=o,o>=i)return c=i,u=17;let x=r.charCodeAt(o);if(A(x)){do o++,p+=String.fromCharCode(x),x=r.charCodeAt(o);while(A(x));return u=15}if(D(x))return o++,p+=String.fromCharCode(x),x===13&&r.charCodeAt(o)===10&&(o++,p+=`
`),u=14;switch(x){case 123:return o++,u=1;case 125:return o++,u=2;case 91:return o++,u=3;case 93:return o++,u=4;case 58:return o++,u=6;case 44:return o++,u=5;case 34:return o++,p=P(),u=10;case 47:const N=o-1;if(r.charCodeAt(o+1)===47){for(o+=2;o<i&&!D(r.charCodeAt(o));)o++;return p=r.substring(N,o),u=12}if(r.charCodeAt(o+1)===42){o+=2;const V=i-1;let W=!1;for(;o<V;){if(r.charCodeAt(o)===42&&r.charCodeAt(o+1)===47){o+=2,W=!0;break}o++}return W||(o++,w=1),p=r.substring(N,o),u=13}return p+=String.fromCharCode(x),o++,u=16;case 45:if(p+=String.fromCharCode(x),o++,o===i||!I(r.charCodeAt(o)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=R(),u=11;default:for(;o<i&&L(x);)o++,x=r.charCodeAt(o);if(c!==o){switch(p=r.substring(c,o),p){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return p+=String.fromCharCode(x),o++,u=16}}function L(x){if(A(x)||D(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let x;do x=B();while(x>=12&&x<=15);return x}return{setPosition:y,getPosition:()=>o,scan:b?k:B,getToken:()=>u,getTokenValue:()=>p,getTokenOffset:()=>c,getTokenLength:()=>o-c,getTokenError:()=>w}}e.createScanner=t;function A(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function D(r){return r===10||r===13||r===8232||r===8233}function I(r){return r>=48&&r<=57}var F;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(F||(F={}));function _(r,b){const o=[],i=new Object;let p;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function w(f,y,R,P){c.value=f,c.offset=y,c.length=R,c.type=P,c.colonOffset=void 0,p=c}try{s(r,{onObjectBegin:(f,y)=>{if(b<=f)throw i;p=void 0,u=b>f,o.push("")},onObjectProperty:(f,y,R)=>{if(b<y||(w(f,y,R,"property"),o[o.length-1]=f,b<=y+R))throw i},onObjectEnd:(f,y)=>{if(b<=f)throw i;p=void 0,o.pop()},onArrayBegin:(f,y)=>{if(b<=f)throw i;p=void 0,o.push(0)},onArrayEnd:(f,y)=>{if(b<=f)throw i;p=void 0,o.pop()},onLiteralValue:(f,y,R)=>{if(b<y||(w(f,y,R,C(f)),b<=y+R))throw i},onSeparator:(f,y,R)=>{if(b<=y)throw i;if(f===":"&&p&&p.type==="property")p.colonOffset=y,u=!1,p=void 0;else if(f===","){const P=o[o.length-1];typeof P=="number"?o[o.length-1]=P+1:(u=!0,o[o.length-1]=""),p=void 0}}})}catch(f){if(f!==i)throw f}return{path:o,previousNode:p,isAtPropertyKey:u,matches:f=>{let y=0;for(let R=0;y<f.length&&R<o.length;R++)if(f[y]===o[R]||f[y]==="*")y++;else if(f[y]!=="**")return!1;return y===f.length}}}e.getLocation=_;function n(r,b=[],o=T.DEFAULT){let i=null,p=[];const c=[];function u(f){Array.isArray(p)?p.push(f):i!==null&&(p[i]=f)}return s(r,{onObjectBegin:()=>{const f={};u(f),c.push(p),p=f,i=null},onObjectProperty:f=>{i=f},onObjectEnd:()=>{p=c.pop()},onArrayBegin:()=>{const f=[];u(f),c.push(p),p=f,i=null},onArrayEnd:()=>{p=c.pop()},onLiteralValue:u,onError:(f,y,R)=>{b.push({error:f,offset:y,length:R})}},o),p[0]}e.parse=n;function m(r,b=[],o=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(f){i.type==="property"&&(i.length=f-i.offset,i=i.parent)}function c(f){return i.children.push(f),f}s(r,{onObjectBegin:f=>{i=c({type:"object",offset:f,length:-1,parent:i,children:[]})},onObjectProperty:(f,y,R)=>{i=c({type:"property",offset:y,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:f,offset:y,length:R,parent:i})},onObjectEnd:(f,y)=>{i.length=f+y-i.offset,i=i.parent,p(f+y)},onArrayBegin:(f,y)=>{i=c({type:"array",offset:f,length:-1,parent:i,children:[]})},onArrayEnd:(f,y)=>{i.length=f+y-i.offset,i=i.parent,p(f+y)},onLiteralValue:(f,y,R)=>{c({type:C(f),offset:y,length:R,parent:i,value:f}),p(y+R)},onSeparator:(f,y,R)=>{i.type==="property"&&(f===":"?i.colonOffset=y:f===","&&p(y))},onError:(f,y,R)=>{b.push({error:f,offset:y,length:R})}},o);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=m;function a(r,b){if(!r)return;let o=r;for(let i of b)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let p=!1;for(const c of o.children)if(Array.isArray(c.children)&&c.children[0].value===i){o=c.children[1],p=!0;break}if(!p)return}else{const p=i;if(o.type!=="array"||p<0||!Array.isArray(o.children)||p>=o.children.length)return;o=o.children[p]}return o}e.findNodeAtLocation=a;function h(r){if(!r.parent||!r.parent.children)return[];const b=h(r.parent);if(r.parent.type==="property"){const o=r.parent.children[0].value;b.push(o)}else if(r.parent.type==="array"){const o=r.parent.children.indexOf(r);o!==-1&&b.push(o)}return b}e.getNodePath=h;function g(r){switch(r.type){case"array":return r.children.map(g);case"object":const b=Object.create(null);for(let o of r.children){const i=o.children[1];i&&(b[o.children[0].value]=g(i))}return b;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=g;function S(r,b,o=!1){return b>=r.offset&&b<r.offset+r.length||o&&b===r.offset+r.length}e.contains=S;function v(r,b,o=!1){if(S(r,b,o)){const i=r.children;if(Array.isArray(i))for(let p=0;p<i.length&&i[p].offset<=b;p++){const c=v(i[p],b,o);if(c)return c}return r}}e.findNodeAtOffset=v;function s(r,b,o=T.DEFAULT){const i=t(r,!1);function p(ue){return ue?()=>ue(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(ue){return ue?Fe=>ue(Fe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=p(b.onObjectBegin),w=c(b.onObjectProperty),f=p(b.onObjectEnd),y=p(b.onArrayBegin),R=p(b.onArrayEnd),P=c(b.onLiteralValue),B=c(b.onSeparator),L=p(b.onComment),k=c(b.onError),x=o&&o.disallowComments,N=o&&o.allowTrailingComma;function V(){for(;;){const ue=i.scan();switch(i.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:x||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(ue){case 12:case 13:x?W(10):L();break;case 16:W(1);break;case 15:case 14:break;default:return ue}}}function W(ue,Fe=[],Ke=[]){if(k(ue),Fe.length+Ke.length>0){let Oe=i.getToken();for(;Oe!==17;){if(Fe.indexOf(Oe)!==-1){V();break}else if(Ke.indexOf(Oe)!==-1)break;Oe=V()}}}function $(ue){const Fe=i.getTokenValue();return ue?P(Fe):w(Fe),V(),!0}function X(){switch(i.getToken()){case 11:let ue=0;try{ue=JSON.parse(i.getTokenValue()),typeof ue!="number"&&(W(2),ue=0)}catch(Fe){W(2)}P(ue);break;case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return V(),!0}function j(){return i.getToken()!==10?(W(3,[],[2,5]),!1):($(!1),i.getToken()===6?(B(":"),V(),ve()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Q(){u(),V();let ue=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ue||W(4,[],[]),B(","),V(),i.getToken()===2&&N)break}else ue&&W(6,[],[]);j()||W(4,[],[2,5]),ue=!0}return f(),i.getToken()!==2?W(7,[2],[]):V(),!0}function le(){y(),V();let ue=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ue||W(4,[],[]),B(","),V(),i.getToken()===4&&N)break}else ue&&W(6,[],[]);ve()||W(4,[],[4,5]),ue=!0}return R(),i.getToken()!==4?W(8,[4],[]):V(),!0}function ve(){switch(i.getToken()){case 3:return le();case 1:return Q();case 10:return $(!0);default:return X()}}return V(),i.getToken()===17?o.allowEmptyContent?!0:(W(4,[],[]),!1):ve()?(i.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=s;function d(r,b){let o=t(r),i=[],p,c=0,u;do switch(u=o.getPosition(),p=o.scan(),p){case 12:case 13:case 17:c!==u&&i.push(r.substring(c,u)),b!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,b)),c=o.getPosition();break}while(p!==17);return i.join("")}e.stripComments=d;function C(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(be[103],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class l{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new l(()=>E(this.getValue()))}}e.Lazy=l}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Ie,ge){for(var Ce=0;Ce<ge.length;Ce++){var ee=ge[Ce];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(Ie,ee.key,ee)}}function e(Ie,ge,Ce){return ge&&re(Ie.prototype,ge),Ce&&re(Ie,Ce),Ie}function l(Ie,ge){if(!!Ie){if(typeof Ie=="string")return M(Ie,ge);var Ce=Object.prototype.toString.call(Ie).slice(8,-1);if(Ce==="Object"&&Ie.constructor&&(Ce=Ie.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Ie);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return M(Ie,ge)}}function M(Ie,ge){(ge==null||ge>Ie.length)&&(ge=Ie.length);for(var Ce=0,ee=new Array(ge);Ce<ge;Ce++)ee[Ce]=Ie[Ce];return ee}function E(Ie,ge){var Ce=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(Ce)return(Ce=Ce.call(Ie)).next.bind(Ce);if(Array.isArray(Ie)||(Ce=l(Ie))||ge&&Ie&&typeof Ie.length=="number"){Ce&&(Ie=Ce);var ee=0;return function(){return ee>=Ie.length?{done:!0}:{done:!1,value:Ie[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var T={exports:{}};function t(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function A(Ie){T.exports.defaults=Ie}T.exports={defaults:t(),getDefaults:t,changeDefaults:A};var D=/[&<>"']/,I=/[&<>"']/g,F=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,n={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(ge){return n[ge]};function a(Ie,ge){if(ge){if(D.test(Ie))return Ie.replace(I,m)}else if(F.test(Ie))return Ie.replace(_,m);return Ie}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(Ie){return Ie.replace(h,function(ge,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var S=/(^|[^\[])\^/g;function v(Ie,ge){Ie=Ie.source||Ie,ge=ge||"";var Ce={replace:function(se,fe){return fe=fe.source||fe,fe=fe.replace(S,"$1"),Ie=Ie.replace(se,fe),Ce},getRegex:function(){return new RegExp(Ie,ge)}};return Ce}var s=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(Ie,ge,Ce){if(Ie){var ee;try{ee=decodeURIComponent(g(Ce)).replace(s,"").toLowerCase()}catch(se){return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ge&&!d.test(Ce)&&(Ce=p(ge,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(se){return null}return Ce}var r={},b=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(Ie,ge){r[" "+Ie]||(b.test(Ie)?r[" "+Ie]=Ie+"/":r[" "+Ie]=f(Ie,"/",!0)),Ie=r[" "+Ie];var Ce=Ie.indexOf(":")===-1;return ge.substring(0,2)==="//"?Ce?ge:Ie.replace(o,"$1")+ge:ge.charAt(0)==="/"?Ce?ge:Ie.replace(i,"$1")+ge:Ie+ge}var c={exec:function(){}};function u(Ie){for(var ge=1,Ce,ee;ge<arguments.length;ge++){Ce=arguments[ge];for(ee in Ce)Object.prototype.hasOwnProperty.call(Ce,ee)&&(Ie[ee]=Ce[ee])}return Ie}function w(Ie,ge){var Ce=Ie.replace(/\|/g,function(fe,he,ke){for(var Le=!1,Me=he;--Me>=0&&ke[Me]==="\\";)Le=!Le;return Le?"|":" |"}),ee=Ce.split(/ \|/),se=0;if(ee[0].trim()||ee.shift(),ee[ee.length-1].trim()||ee.pop(),ee.length>ge)ee.splice(ge);else for(;ee.length<ge;)ee.push("");for(;se<ee.length;se++)ee[se]=ee[se].trim().replace(/\\\|/g,"|");return ee}function f(Ie,ge,Ce){var ee=Ie.length;if(ee===0)return"";for(var se=0;se<ee;){var fe=Ie.charAt(ee-se-1);if(fe===ge&&!Ce)se++;else if(fe!==ge&&Ce)se++;else break}return Ie.substr(0,ee-se)}function y(Ie,ge){if(Ie.indexOf(ge[1])===-1)return-1;for(var Ce=Ie.length,ee=0,se=0;se<Ce;se++)if(Ie[se]==="\\")se++;else if(Ie[se]===ge[0])ee++;else if(Ie[se]===ge[1]&&(ee--,ee<0))return se;return-1}function R(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Ie,ge){if(ge<1)return"";for(var Ce="";ge>1;)ge&1&&(Ce+=Ie),ge>>=1,Ie+=Ie;return Ce+Ie}var B={escape:a,unescape:g,edit:v,cleanUrl:C,resolveUrl:p,noopTest:c,merge:u,splitCells:w,rtrim:f,findClosingBracket:y,checkSanitizeDeprecation:R,repeatString:P},L=T.exports.defaults,k=B.rtrim,x=B.splitCells,N=B.escape,V=B.findClosingBracket;function W(Ie,ge,Ce,ee){var se=ge.href,fe=ge.title?N(ge.title):null,he=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){ee.state.inLink=!0;var ke={type:"link",raw:Ce,href:se,title:fe,text:he,tokens:ee.inlineTokens(he,[])};return ee.state.inLink=!1,ke}else return{type:"image",raw:Ce,href:se,title:fe,text:N(he)}}function $(Ie,ge){var Ce=Ie.match(/^(\s+)(?:```)/);if(Ce===null)return ge;var ee=Ce[1];return ge.split(`
`).map(function(se){var fe=se.match(/^\s+/);if(fe===null)return se;var he=fe[0];return he.length>=ee.length?se.slice(ee.length):se}).join(`
`)}var X=function(){function Ie(Ce){this.options=Ce||L}var ge=Ie.prototype;return ge.space=function(ee){var se=this.rules.block.newline.exec(ee);if(se)return se[0].length>1?{type:"space",raw:se[0]}:{raw:`
`}},ge.code=function(ee){var se=this.rules.block.code.exec(ee);if(se){var fe=se[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:se[0],codeBlockStyle:"indented",text:this.options.pedantic?fe:k(fe,`
`)}}},ge.fences=function(ee){var se=this.rules.block.fences.exec(ee);if(se){var fe=se[0],he=$(fe,se[3]||"");return{type:"code",raw:fe,lang:se[2]?se[2].trim():se[2],text:he}}},ge.heading=function(ee){var se=this.rules.block.heading.exec(ee);if(se){var fe=se[2].trim();if(/#$/.test(fe)){var he=k(fe,"#");(this.options.pedantic||!he||/ $/.test(he))&&(fe=he.trim())}var ke={type:"heading",raw:se[0],depth:se[1].length,text:fe,tokens:[]};return this.lexer.inline(ke.text,ke.tokens),ke}},ge.hr=function(ee){var se=this.rules.block.hr.exec(ee);if(se)return{type:"hr",raw:se[0]}},ge.blockquote=function(ee){var se=this.rules.block.blockquote.exec(ee);if(se){var fe=se[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:se[0],tokens:this.lexer.blockTokens(fe,[]),text:fe}}},ge.list=function(ee){var se=this.rules.block.list.exec(ee);if(se){var fe,he,ke,Le,Me,ze,it,Re,ce,me,ne=se[1].trim(),H=ne.length>1,we={type:"list",raw:"",ordered:H,start:H?+ne.slice(0,-1):"",loose:!1,items:[]};ne=H?"\\d{1,9}\\"+ne.slice(-1):"\\"+ne,this.options.pedantic&&(ne=H?ne:"[*+-]");for(var De=new RegExp("^( {0,3}"+ne+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");ee&&!(this.rules.block.hr.test(ee)||!(se=De.exec(ee)));){ce=se[2].split(`
`),this.options.pedantic?(Le=2,me=ce[0].trimLeft()):(Le=se[2].search(/[^ ]/),Le=se[1].length+(Le>4?1:Le),me=ce[0].slice(Le-se[1].length)),ze=!1,fe=se[0],!ce[0]&&/^ *$/.test(ce[1])&&(fe=se[1]+ce.slice(0,2).join(`
`)+`
`,we.loose=!0,ce=[]);var Ge=new RegExp("^ {0,"+Math.min(3,Le-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Me=1;Me<ce.length;Me++){if(Re=ce[Me],this.options.pedantic&&(Re=Re.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Ge.test(Re)){fe=se[1]+ce.slice(0,Me).join(`
`)+`
`;break}if(!ze){Re.trim()||(ze=!0),Re.search(/[^ ]/)>=Le?me+=`
`+Re.slice(Le):me+=`
`+Re;continue}if(Re.search(/[^ ]/)>=Le||!Re.trim()){me+=`
`+Re.slice(Le);continue}else{fe=se[1]+ce.slice(0,Me).join(`
`)+`
`;break}}we.loose||(it?we.loose=!0:/\n *\n *$/.test(fe)&&(it=!0)),this.options.gfm&&(he=/^\[[ xX]\] /.exec(me),he&&(ke=he[0]!=="[ ] ",me=me.replace(/^\[[ xX]\] +/,""))),we.items.push({type:"list_item",raw:fe,task:!!he,checked:ke,loose:!1,text:me}),we.raw+=fe,ee=ee.slice(fe.length)}we.items[we.items.length-1].raw=fe.trimRight(),we.items[we.items.length-1].text=me.trimRight(),we.raw=we.raw.trimRight();var xe=we.items.length;for(Me=0;Me<xe;Me++)this.lexer.state.top=!1,we.items[Me].tokens=this.lexer.blockTokens(we.items[Me].text,[]),we.items[Me].tokens.some(function(ct){return ct.type==="space"})&&(we.loose=!0,we.items[Me].loose=!0);return we}},ge.html=function(ee){var se=this.rules.block.html.exec(ee);if(se){var fe={type:"html",raw:se[0],pre:!this.options.sanitizer&&(se[1]==="pre"||se[1]==="script"||se[1]==="style"),text:se[0]};return this.options.sanitize&&(fe.type="paragraph",fe.text=this.options.sanitizer?this.options.sanitizer(se[0]):N(se[0]),fe.tokens=[],this.lexer.inline(fe.text,fe.tokens)),fe}},ge.def=function(ee){var se=this.rules.block.def.exec(ee);if(se){se[3]&&(se[3]=se[3].substring(1,se[3].length-1));var fe=se[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:fe,raw:se[0],href:se[2],title:se[3]}}},ge.table=function(ee){var se=this.rules.block.table.exec(ee);if(se){var fe={type:"table",header:x(se[1]).map(function(it){return{text:it}}),align:se[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:se[3]?se[3].replace(/\n$/,"").split(`
`):[]};if(fe.header.length===fe.align.length){fe.raw=se[0];var he=fe.align.length,ke,Le,Me,ze;for(ke=0;ke<he;ke++)/^ *-+: *$/.test(fe.align[ke])?fe.align[ke]="right":/^ *:-+: *$/.test(fe.align[ke])?fe.align[ke]="center":/^ *:-+ *$/.test(fe.align[ke])?fe.align[ke]="left":fe.align[ke]=null;for(he=fe.rows.length,ke=0;ke<he;ke++)fe.rows[ke]=x(fe.rows[ke],fe.header.length).map(function(it){return{text:it}});for(he=fe.header.length,Le=0;Le<he;Le++)fe.header[Le].tokens=[],this.lexer.inlineTokens(fe.header[Le].text,fe.header[Le].tokens);for(he=fe.rows.length,Le=0;Le<he;Le++)for(ze=fe.rows[Le],Me=0;Me<ze.length;Me++)ze[Me].tokens=[],this.lexer.inlineTokens(ze[Me].text,ze[Me].tokens);return fe}}},ge.lheading=function(ee){var se=this.rules.block.lheading.exec(ee);if(se){var fe={type:"heading",raw:se[0],depth:se[2].charAt(0)==="="?1:2,text:se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ge.paragraph=function(ee){var se=this.rules.block.paragraph.exec(ee);if(se){var fe={type:"paragraph",raw:se[0],text:se[1].charAt(se[1].length-1)===`
`?se[1].slice(0,-1):se[1],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ge.text=function(ee){var se=this.rules.block.text.exec(ee);if(se){var fe={type:"text",raw:se[0],text:se[0],tokens:[]};return this.lexer.inline(fe.text,fe.tokens),fe}},ge.escape=function(ee){var se=this.rules.inline.escape.exec(ee);if(se)return{type:"escape",raw:se[0],text:N(se[1])}},ge.tag=function(ee){var se=this.rules.inline.tag.exec(ee);if(se)return!this.lexer.state.inLink&&/^<a /i.test(se[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(se[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(se[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(se[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:se[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):N(se[0]):se[0]}},ge.link=function(ee){var se=this.rules.inline.link.exec(ee);if(se){var fe=se[2].trim();if(!this.options.pedantic&&/^</.test(fe)){if(!/>$/.test(fe))return;var he=k(fe.slice(0,-1),"\\");if((fe.length-he.length)%2==0)return}else{var ke=V(se[2],"()");if(ke>-1){var Le=se[0].indexOf("!")===0?5:4,Me=Le+se[1].length+ke;se[2]=se[2].substring(0,ke),se[0]=se[0].substring(0,Me).trim(),se[3]=""}}var ze=se[2],it="";if(this.options.pedantic){var Re=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ze);Re&&(ze=Re[1],it=Re[3])}else it=se[3]?se[3].slice(1,-1):"";return ze=ze.trim(),/^</.test(ze)&&(this.options.pedantic&&!/>$/.test(fe)?ze=ze.slice(1):ze=ze.slice(1,-1)),W(se,{href:ze&&ze.replace(this.rules.inline._escapes,"$1"),title:it&&it.replace(this.rules.inline._escapes,"$1")},se[0],this.lexer)}},ge.reflink=function(ee,se){var fe;if((fe=this.rules.inline.reflink.exec(ee))||(fe=this.rules.inline.nolink.exec(ee))){var he=(fe[2]||fe[1]).replace(/\s+/g," ");if(he=se[he.toLowerCase()],!he||!he.href){var ke=fe[0].charAt(0);return{type:"text",raw:ke,text:ke}}return W(fe,he,fe[0],this.lexer)}},ge.emStrong=function(ee,se,fe){fe===void 0&&(fe="");var he=this.rules.inline.emStrong.lDelim.exec(ee);if(!!he&&!(he[3]&&fe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ke=he[1]||he[2]||"";if(!ke||ke&&(fe===""||this.rules.inline.punctuation.exec(fe))){var Le=he[0].length-1,Me,ze,it=Le,Re=0,ce=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ce.lastIndex=0,se=se.slice(-1*ee.length+Le);(he=ce.exec(se))!=null;)if(Me=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Me){if(ze=Me.length,he[3]||he[4]){it+=ze;continue}else if((he[5]||he[6])&&Le%3&&!((Le+ze)%3)){Re+=ze;continue}if(it-=ze,!(it>0)){if(ze=Math.min(ze,ze+it+Re),Math.min(Le,ze)%2){var me=ee.slice(1,Le+he.index+ze);return{type:"em",raw:ee.slice(0,Le+he.index+ze+1),text:me,tokens:this.lexer.inlineTokens(me,[])}}var ne=ee.slice(2,Le+he.index+ze-1);return{type:"strong",raw:ee.slice(0,Le+he.index+ze+1),text:ne,tokens:this.lexer.inlineTokens(ne,[])}}}}}},ge.codespan=function(ee){var se=this.rules.inline.code.exec(ee);if(se){var fe=se[2].replace(/\n/g," "),he=/[^ ]/.test(fe),ke=/^ /.test(fe)&&/ $/.test(fe);return he&&ke&&(fe=fe.substring(1,fe.length-1)),fe=N(fe,!0),{type:"codespan",raw:se[0],text:fe}}},ge.br=function(ee){var se=this.rules.inline.br.exec(ee);if(se)return{type:"br",raw:se[0]}},ge.del=function(ee){var se=this.rules.inline.del.exec(ee);if(se)return{type:"del",raw:se[0],text:se[2],tokens:this.lexer.inlineTokens(se[2],[])}},ge.autolink=function(ee,se){var fe=this.rules.inline.autolink.exec(ee);if(fe){var he,ke;return fe[2]==="@"?(he=N(this.options.mangle?se(fe[1]):fe[1]),ke="mailto:"+he):(he=N(fe[1]),ke=he),{type:"link",raw:fe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},ge.url=function(ee,se){var fe;if(fe=this.rules.inline.url.exec(ee)){var he,ke;if(fe[2]==="@")he=N(this.options.mangle?se(fe[0]):fe[0]),ke="mailto:"+he;else{var Le;do Le=fe[0],fe[0]=this.rules.inline._backpedal.exec(fe[0])[0];while(Le!==fe[0]);he=N(fe[0]),fe[1]==="www."?ke="http://"+he:ke=he}return{type:"link",raw:fe[0],text:he,href:ke,tokens:[{type:"text",raw:he,text:he}]}}},ge.inlineText=function(ee,se){var fe=this.rules.inline.text.exec(ee);if(fe){var he;return this.lexer.state.inRawBlock?he=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):N(fe[0]):fe[0]:he=N(this.options.smartypants?se(fe[0]):fe[0]),{type:"text",raw:fe[0],text:he}}},Ie}(),j=B.noopTest,Q=B.edit,le=B.merge,ve={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:j,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};ve._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,ve._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ve.def=Q(ve.def).replace("label",ve._label).replace("title",ve._title).getRegex(),ve.bullet=/(?:[*+-]|\d{1,9}[.)])/,ve.listItemStart=Q(/^( *)(bull) */).replace("bull",ve.bullet).getRegex(),ve.list=Q(ve.list).replace(/bull/g,ve.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ve.def.source+")").getRegex(),ve._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ve._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ve.html=Q(ve.html,"i").replace("comment",ve._comment).replace("tag",ve._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ve.paragraph=Q(ve._paragraph).replace("hr",ve.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ve._tag).getRegex(),ve.blockquote=Q(ve.blockquote).replace("paragraph",ve.paragraph).getRegex(),ve.normal=le({},ve),ve.gfm=le({},ve.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ve.gfm.table=Q(ve.gfm.table).replace("hr",ve.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ve._tag).getRegex(),ve.pedantic=le({},ve.normal,{html:Q(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ve._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:j,paragraph:Q(ve.normal._paragraph).replace("hr",ve.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ve.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ue={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:j,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:j,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ue._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ue.punctuation=Q(ue.punctuation).replace(/punctuation/g,ue._punctuation).getRegex(),ue.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ue.escapedEmSt=/\\\*|\\_/g,ue._comment=Q(ve._comment).replace("(?:-->|$)","-->").getRegex(),ue.emStrong.lDelim=Q(ue.emStrong.lDelim).replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimAst=Q(ue.emStrong.rDelimAst,"g").replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimUnd=Q(ue.emStrong.rDelimUnd,"g").replace(/punct/g,ue._punctuation).getRegex(),ue._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ue._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ue._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ue.autolink=Q(ue.autolink).replace("scheme",ue._scheme).replace("email",ue._email).getRegex(),ue._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ue.tag=Q(ue.tag).replace("comment",ue._comment).replace("attribute",ue._attribute).getRegex(),ue._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ue._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ue._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ue.link=Q(ue.link).replace("label",ue._label).replace("href",ue._href).replace("title",ue._title).getRegex(),ue.reflink=Q(ue.reflink).replace("label",ue._label).getRegex(),ue.reflinkSearch=Q(ue.reflinkSearch,"g").replace("reflink",ue.reflink).replace("nolink",ue.nolink).getRegex(),ue.normal=le({},ue),ue.pedantic=le({},ue.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:Q(/^!?\[(label)\]\((.*?)\)/).replace("label",ue._label).getRegex(),reflink:Q(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ue._label).getRegex()}),ue.gfm=le({},ue.normal,{escape:Q(ue.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ue.gfm.url=Q(ue.gfm.url,"i").replace("email",ue.gfm._extended_email).getRegex(),ue.breaks=le({},ue.gfm,{br:Q(ue.br).replace("{2,}","*").getRegex(),text:Q(ue.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var Fe={block:ve,inline:ue},Ke=X,Oe=T.exports.defaults,He=Fe.block,Je=Fe.inline,Ye=B.repeatString;function Qe(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(Ie){var ge="",Ce,ee,se=Ie.length;for(Ce=0;Ce<se;Ce++)ee=Ie.charCodeAt(Ce),Math.random()>.5&&(ee="x"+ee.toString(16)),ge+="&#"+ee+";";return ge}var K=function(){function Ie(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Oe,this.options.tokenizer=this.options.tokenizer||new Ke,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:He.normal,inline:Je.normal};this.options.pedantic?(ee.block=He.pedantic,ee.inline=Je.pedantic):this.options.gfm&&(ee.block=He.gfm,this.options.breaks?ee.inline=Je.breaks:ee.inline=Je.gfm),this.tokenizer.rules=ee}Ie.lex=function(ee,se){var fe=new Ie(se);return fe.lex(ee)},Ie.lexInline=function(ee,se){var fe=new Ie(se);return fe.inlineTokens(ee)};var ge=Ie.prototype;return ge.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ee,this.tokens);for(var se;se=this.inlineQueue.shift();)this.inlineTokens(se.src,se.tokens);return this.tokens},ge.blockTokens=function(ee,se){var fe=this;se===void 0&&(se=[]),this.options.pedantic&&(ee=ee.replace(/^ +$/gm,""));for(var he,ke,Le,Me;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(it){return(he=it.call({lexer:fe},ee,se))?(ee=ee.substring(he.raw.length),se.push(he),!0):!1}))){if(he=this.tokenizer.space(ee)){ee=ee.substring(he.raw.length),he.type&&se.push(he);continue}if(he=this.tokenizer.code(ee)){ee=ee.substring(he.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(he);continue}if(he=this.tokenizer.fences(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.heading(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.hr(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.blockquote(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.list(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.html(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.def(ee)){ee=ee.substring(he.raw.length),ke=se[se.length-1],ke&&(ke.type==="paragraph"||ke.type==="text")?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.raw,this.inlineQueue[this.inlineQueue.length-1].src=ke.text):this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.lheading(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(Le=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var it=Infinity,Re=ee.slice(1),ce=void 0;fe.options.extensions.startBlock.forEach(function(me){ce=me.call({lexer:this},Re),typeof ce=="number"&&ce>=0&&(it=Math.min(it,ce))}),it<Infinity&&it>=0&&(Le=ee.substring(0,it+1))}(),this.state.top&&(he=this.tokenizer.paragraph(Le))){ke=se[se.length-1],Me&&ke.type==="paragraph"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(he),Me=Le.length!==ee.length,ee=ee.substring(he.raw.length);continue}if(he=this.tokenizer.text(ee)){ee=ee.substring(he.raw.length),ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+he.raw,ke.text+=`
`+he.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ke.text):se.push(he);continue}if(ee){var ze="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(ze);break}else throw new Error(ze)}}return this.state.top=!0,se},ge.inline=function(ee,se){this.inlineQueue.push({src:ee,tokens:se})},ge.inlineTokens=function(ee,se){var fe=this;se===void 0&&(se=[]);var he,ke,Le,Me=ee,ze,it,Re;if(this.tokens.links){var ce=Object.keys(this.tokens.links);if(ce.length>0)for(;(ze=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)ce.includes(ze[0].slice(ze[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,ze.index)+"["+Ye("a",ze[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ze=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,ze.index)+"["+Ye("a",ze[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ze=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,ze.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(it||(Re=""),it=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ne){return(he=ne.call({lexer:fe},ee,se))?(ee=ee.substring(he.raw.length),se.push(he),!0):!1}))){if(he=this.tokenizer.escape(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.tag(ee)){ee=ee.substring(he.raw.length),ke=se[se.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):se.push(he);continue}if(he=this.tokenizer.link(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(he.raw.length),ke=se[se.length-1],ke&&he.type==="text"&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):se.push(he);continue}if(he=this.tokenizer.emStrong(ee,Me,Re)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.codespan(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.br(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.del(ee)){ee=ee.substring(he.raw.length),se.push(he);continue}if(he=this.tokenizer.autolink(ee,z)){ee=ee.substring(he.raw.length),se.push(he);continue}if(!this.state.inLink&&(he=this.tokenizer.url(ee,z))){ee=ee.substring(he.raw.length),se.push(he);continue}if(Le=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var ne=Infinity,H=ee.slice(1),we=void 0;fe.options.extensions.startInline.forEach(function(De){we=De.call({lexer:this},H),typeof we=="number"&&we>=0&&(ne=Math.min(ne,we))}),ne<Infinity&&ne>=0&&(Le=ee.substring(0,ne+1))}(),he=this.tokenizer.inlineText(Le,Qe)){ee=ee.substring(he.raw.length),he.raw.slice(-1)!=="_"&&(Re=he.raw.slice(-1)),it=!0,ke=se[se.length-1],ke&&ke.type==="text"?(ke.raw+=he.raw,ke.text+=he.text):se.push(he);continue}if(ee){var me="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(me);break}else throw new Error(me)}}return se},e(Ie,null,[{key:"rules",get:function(){return{block:He,inline:Je}}}]),Ie}(),Z=T.exports.defaults,oe=B.cleanUrl,G=B.escape,ie=function(){function Ie(Ce){this.options=Ce||Z}var ge=Ie.prototype;return ge.code=function(ee,se,fe){var he=(se||"").match(/\S*/)[0];if(this.options.highlight){var ke=this.options.highlight(ee,he);ke!=null&&ke!==ee&&(fe=!0,ee=ke)}return ee=ee.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+G(he,!0)+'">'+(fe?ee:G(ee,!0))+`</code></pre>
`:"<pre><code>"+(fe?ee:G(ee,!0))+`</code></pre>
`},ge.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ge.html=function(ee){return ee},ge.heading=function(ee,se,fe,he){return this.options.headerIds?"<h"+se+' id="'+this.options.headerPrefix+he.slug(fe)+'">'+ee+"</h"+se+`>
`:"<h"+se+">"+ee+"</h"+se+`>
`},ge.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ge.list=function(ee,se,fe){var he=se?"ol":"ul",ke=se&&fe!==1?' start="'+fe+'"':"";return"<"+he+ke+`>
`+ee+"</"+he+`>
`},ge.listitem=function(ee){return"<li>"+ee+`</li>
`},ge.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ge.paragraph=function(ee){return"<p>"+ee+`</p>
`},ge.table=function(ee,se){return se&&(se="<tbody>"+se+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+se+`</table>
`},ge.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ge.tablecell=function(ee,se){var fe=se.header?"th":"td",he=se.align?"<"+fe+' align="'+se.align+'">':"<"+fe+">";return he+ee+"</"+fe+`>
`},ge.strong=function(ee){return"<strong>"+ee+"</strong>"},ge.em=function(ee){return"<em>"+ee+"</em>"},ge.codespan=function(ee){return"<code>"+ee+"</code>"},ge.br=function(){return this.options.xhtml?"<br/>":"<br>"},ge.del=function(ee){return"<del>"+ee+"</del>"},ge.link=function(ee,se,fe){if(ee=oe(this.options.sanitize,this.options.baseUrl,ee),ee===null)return fe;var he='<a href="'+G(ee)+'"';return se&&(he+=' title="'+se+'"'),he+=">"+fe+"</a>",he},ge.image=function(ee,se,fe){if(ee=oe(this.options.sanitize,this.options.baseUrl,ee),ee===null)return fe;var he='<img src="'+ee+'" alt="'+fe+'"';return se&&(he+=' title="'+se+'"'),he+=this.options.xhtml?"/>":">",he},ge.text=function(ee){return ee},Ie}(),de=function(){function Ie(){}var ge=Ie.prototype;return ge.strong=function(ee){return ee},ge.em=function(ee){return ee},ge.codespan=function(ee){return ee},ge.del=function(ee){return ee},ge.html=function(ee){return ee},ge.text=function(ee){return ee},ge.link=function(ee,se,fe){return""+fe},ge.image=function(ee,se,fe){return""+fe},ge.br=function(){return""},Ie}(),Pe=function(){function Ie(){this.seen={}}var ge=Ie.prototype;return ge.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ge.getNextSafeSlug=function(ee,se){var fe=ee,he=0;if(this.seen.hasOwnProperty(fe)){he=this.seen[ee];do he++,fe=ee+"-"+he;while(this.seen.hasOwnProperty(fe))}return se||(this.seen[ee]=he,this.seen[fe]=0),fe},ge.slug=function(ee,se){se===void 0&&(se={});var fe=this.serialize(ee);return this.getNextSafeSlug(fe,se.dryrun)},Ie}(),Ne=ie,We=de,je=Pe,et=T.exports.defaults,ot=B.unescape,ye=function(){function Ie(Ce){this.options=Ce||et,this.options.renderer=this.options.renderer||new Ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new We,this.slugger=new je}Ie.parse=function(ee,se){var fe=new Ie(se);return fe.parse(ee)},Ie.parseInline=function(ee,se){var fe=new Ie(se);return fe.parseInline(ee)};var ge=Ie.prototype;return ge.parse=function(ee,se){se===void 0&&(se=!0);var fe="",he,ke,Le,Me,ze,it,Re,ce,me,ne,H,we,De,Ge,xe,ct,Et,vt,lt,gt=ee.length;for(he=0;he<gt;he++){if(ne=ee[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ne.type]&&(lt=this.options.extensions.renderers[ne.type].call({parser:this},ne),lt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ne.type))){fe+=lt||"";continue}switch(ne.type){case"space":continue;case"hr":{fe+=this.renderer.hr();continue}case"heading":{fe+=this.renderer.heading(this.parseInline(ne.tokens),ne.depth,ot(this.parseInline(ne.tokens,this.textRenderer)),this.slugger);continue}case"code":{fe+=this.renderer.code(ne.text,ne.lang,ne.escaped);continue}case"table":{for(ce="",Re="",Me=ne.header.length,ke=0;ke<Me;ke++)Re+=this.renderer.tablecell(this.parseInline(ne.header[ke].tokens),{header:!0,align:ne.align[ke]});for(ce+=this.renderer.tablerow(Re),me="",Me=ne.rows.length,ke=0;ke<Me;ke++){for(it=ne.rows[ke],Re="",ze=it.length,Le=0;Le<ze;Le++)Re+=this.renderer.tablecell(this.parseInline(it[Le].tokens),{header:!1,align:ne.align[Le]});me+=this.renderer.tablerow(Re)}fe+=this.renderer.table(ce,me);continue}case"blockquote":{me=this.parse(ne.tokens),fe+=this.renderer.blockquote(me);continue}case"list":{for(H=ne.ordered,we=ne.start,De=ne.loose,Me=ne.items.length,me="",ke=0;ke<Me;ke++)xe=ne.items[ke],ct=xe.checked,Et=xe.task,Ge="",xe.task&&(vt=this.renderer.checkbox(ct),De?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=vt+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=vt+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:vt}):Ge+=vt),Ge+=this.parse(xe.tokens,De),me+=this.renderer.listitem(Ge,Et,ct);fe+=this.renderer.list(me,H,we);continue}case"html":{fe+=this.renderer.html(ne.text);continue}case"paragraph":{fe+=this.renderer.paragraph(this.parseInline(ne.tokens));continue}case"text":{for(me=ne.tokens?this.parseInline(ne.tokens):ne.text;he+1<gt&&ee[he+1].type==="text";)ne=ee[++he],me+=`
`+(ne.tokens?this.parseInline(ne.tokens):ne.text);fe+=se?this.renderer.paragraph(me):me;continue}default:{var dt='Token with "'+ne.type+'" type was not found.';if(this.options.silent){console.error(dt);return}else throw new Error(dt)}}}return fe},ge.parseInline=function(ee,se){se=se||this.renderer;var fe="",he,ke,Le,Me=ee.length;for(he=0;he<Me;he++){if(ke=ee[he],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Le=this.options.extensions.renderers[ke.type].call({parser:this},ke),Le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ke.type))){fe+=Le||"";continue}switch(ke.type){case"escape":{fe+=se.text(ke.text);break}case"html":{fe+=se.html(ke.text);break}case"link":{fe+=se.link(ke.href,ke.title,this.parseInline(ke.tokens,se));break}case"image":{fe+=se.image(ke.href,ke.title,ke.text);break}case"strong":{fe+=se.strong(this.parseInline(ke.tokens,se));break}case"em":{fe+=se.em(this.parseInline(ke.tokens,se));break}case"codespan":{fe+=se.codespan(ke.text);break}case"br":{fe+=se.br();break}case"del":{fe+=se.del(this.parseInline(ke.tokens,se));break}case"text":{fe+=se.text(ke.text);break}default:{var ze='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return fe},Ie}(),nt=K,q=ye,J=X,pe=ie,$e=de,qe=Pe,rt=B.merge,ft=B.checkSanitizeDeprecation,ht=B.escape,Ct=T.exports.getDefaults,It=T.exports.changeDefaults,Pt=T.exports.defaults;function Ze(Ie,ge,Ce){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof ge=="function"&&(Ce=ge,ge=null),ge=rt({},Ze.defaults,ge||{}),ft(ge),Ce){var ee=ge.highlight,se;try{se=nt.lex(Ie,ge)}catch(Le){return Ce(Le)}var fe=function(Me){var ze;if(!Me)try{ge.walkTokens&&Ze.walkTokens(se,ge.walkTokens),ze=q.parse(se,ge)}catch(it){Me=it}return ge.highlight=ee,Me?Ce(Me):Ce(null,ze)};if(!ee||ee.length<3||(delete ge.highlight,!se.length))return fe();var he=0;Ze.walkTokens(se,function(Le){Le.type==="code"&&(he++,setTimeout(function(){ee(Le.text,Le.lang,function(Me,ze){if(Me)return fe(Me);ze!=null&&ze!==Le.text&&(Le.text=ze,Le.escaped=!0),he--,he===0&&fe()})},0))}),he===0&&fe();return}try{var ke=nt.lex(Ie,ge);return ge.walkTokens&&Ze.walkTokens(ke,ge.walkTokens),q.parse(ke,ge)}catch(Le){if(Le.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+ht(Le.message+"",!0)+"</pre>";throw Le}}Ze.options=Ze.setOptions=function(Ie){return rt(Ze.defaults,Ie),It(Ze.defaults),Ze},Ze.getDefaults=Ct,Ze.defaults=Pt,Ze.use=function(){for(var Ie=this,ge=arguments.length,Ce=new Array(ge),ee=0;ee<ge;ee++)Ce[ee]=arguments[ee];var se=rt.apply(void 0,[{}].concat(Ce)),fe=Ze.defaults.extensions||{renderers:{},childTokens:{}},he;Ce.forEach(function(ke){if(ke.extensions&&(he=!0,ke.extensions.forEach(function(Me){if(!Me.name)throw new Error("extension name required");if(Me.renderer){var ze=fe.renderers?fe.renderers[Me.name]:null;ze?fe.renderers[Me.name]=function(){for(var it=arguments.length,Re=new Array(it),ce=0;ce<it;ce++)Re[ce]=arguments[ce];var me=Me.renderer.apply(this,Re);return me===!1&&(me=ze.apply(this,Re)),me}:fe.renderers[Me.name]=Me.renderer}if(Me.tokenizer){if(!Me.level||Me.level!=="block"&&Me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Me.level]?fe[Me.level].unshift(Me.tokenizer):fe[Me.level]=[Me.tokenizer],Me.start&&(Me.level==="block"?fe.startBlock?fe.startBlock.push(Me.start):fe.startBlock=[Me.start]:Me.level==="inline"&&(fe.startInline?fe.startInline.push(Me.start):fe.startInline=[Me.start]))}Me.childTokens&&(fe.childTokens[Me.name]=Me.childTokens)})),ke.renderer&&function(){var Me=Ze.defaults.renderer||new pe,ze=function(ce){var me=Me[ce];Me[ce]=function(){for(var ne=arguments.length,H=new Array(ne),we=0;we<ne;we++)H[we]=arguments[we];var De=ke.renderer[ce].apply(Me,H);return De===!1&&(De=me.apply(Me,H)),De}};for(var it in ke.renderer)ze(it);se.renderer=Me}(),ke.tokenizer&&function(){var Me=Ze.defaults.tokenizer||new J,ze=function(ce){var me=Me[ce];Me[ce]=function(){for(var ne=arguments.length,H=new Array(ne),we=0;we<ne;we++)H[we]=arguments[we];var De=ke.tokenizer[ce].apply(Me,H);return De===!1&&(De=me.apply(Me,H)),De}};for(var it in ke.tokenizer)ze(it);se.tokenizer=Me}(),ke.walkTokens){var Le=Ze.defaults.walkTokens;se.walkTokens=function(Me){ke.walkTokens.call(Ie,Me),Le&&Le(Me)}}he&&(se.extensions=fe),Ze.setOptions(se)})},Ze.walkTokens=function(Ie,ge){for(var Ce=function(){var he=se.value;switch(ge(he),he.type){case"table":{for(var ke=E(he.header),Le;!(Le=ke()).done;){var Me=Le.value;Ze.walkTokens(Me.tokens,ge)}for(var ze=E(he.rows),it;!(it=ze()).done;)for(var Re=it.value,ce=E(Re),me;!(me=ce()).done;){var ne=me.value;Ze.walkTokens(ne.tokens,ge)}break}case"list":{Ze.walkTokens(he.items,ge);break}default:Ze.defaults.extensions&&Ze.defaults.extensions.childTokens&&Ze.defaults.extensions.childTokens[he.type]?Ze.defaults.extensions.childTokens[he.type].forEach(function(H){Ze.walkTokens(he[H],ge)}):he.tokens&&Ze.walkTokens(he.tokens,ge)}},ee=E(Ie),se;!(se=ee()).done;)Ce()},Ze.parseInline=function(Ie,ge){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");ge=rt({},Ze.defaults,ge||{}),ft(ge);try{var Ce=nt.lexInline(Ie,ge);return ge.walkTokens&&Ze.walkTokens(Ce,ge.walkTokens),q.parseInline(Ce,ge)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ge.silent)return"<p>An error occurred:</p><pre>"+ht(ee.message+"",!0)+"</pre>";throw ee}},Ze.Parser=q,Ze.parser=q.parse,Ze.Renderer=pe,Ze.TextRenderer=$e,Ze.Lexer=nt,Ze.lexer=nt.lex,Ze.Tokenizer=J,Ze.Slugger=qe,Ze.parse=Ze;var pt=Ze;return pt}),define(be[76],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function l(t,A,D){return Math.min(Math.max(t,A),D)}e.clamp=l;function M(t,A){return(A+t%A)%A}e.rot=M;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class T{constructor(){this._n=1,this._val=0}update(A){return this._val=this._val+(A-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function re(E){const T=[];typeof E=="number"&&T.push("code/timeOrigin",E);function t(D){T.push(D,Date.now())}function A(){const D=[];for(let I=0;I<T.length;I+=2)D.push({name:T[I],startTime:T[I+1]});return D}return{mark:t,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const t of performance.getEntriesByType("mark"))T.push({name:t.name,startTime:Math.round(E+t.startTime)});return T}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function l(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=l(M))}(),define(be[35],Ee([0,1,3]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class M{constructor(){this._icons=new Map,this._onDidRegister=new l.Emitter}add(F){const _=this._icons.get(F.id);_?F.description?_.description=F.description:console.error(`Duplicate registration of codicon ${F.id}`):(this._icons.set(F.id,F),this._onDidRegister.fire(F))}get(F){return this._icons.get(F)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new M;e.iconRegistry=E;function T(I){return I?I.replace(/\$\((.*?)\)/g,(F,_)=>` ${_} `).trim():""}e.getCodiconAriaLabel=T;class t{constructor(F,_,n){this.id=F,this.definition=_,this.description=n,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=t,t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function A(I,F){const _=["codicon","codicon-"+I];return F&&_.push("codicon-modifier-"+F),_}e.getClassNamesArray=A;var D;(function(I){I.iconNameSegment="[A-Za-z0-9]+",I.iconNameExpression="[A-Za-z0-9\\-]+",I.iconModifierExpression="~[A-Za-z]+",I.iconNameCharacter="[A-Za-z0-9\\-~]";const F=new RegExp(`^(${I.iconNameExpression})(${I.iconModifierExpression})?$`);function _(a){if(a instanceof t)return["codicon","codicon-"+a.id];const h=F.exec(a.id);if(!h)return _(t.error);let[,g,S]=h;const v=["codicon","codicon-"+g];return S&&v.push("codicon-modifier-"+S.substr(1)),v}I.asClassNameArray=_;function n(a){return _(a).join(" ")}I.asClassName=n;function m(a){return"."+_(a).join(".")}I.asCSSSelector=m})(D=e.CSSIcon||(e.CSSIcon={}))}),define(be[104],Ee([0,1,16,6]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(s){const d=s;return d?[d.on,d.pause,d.resume,d.destroy].every(C=>typeof C=="function"):!1}e.isReadableStream=E;function T(s){const d=s;return d?E(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=T;function t(s,d){return new A(s,d)}e.newWriteableStream=t;class A{constructor(d,C){this.reducer=d,this.options=C,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(C=>this.pendingWritePromises.push(C))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(C=>C(d))}emitError(d){this.listeners.error.length===0?(0,l.onUnexpectedError)(d):this.listeners.error.slice(0).forEach(C=>C(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,C){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(C),this.resume();break;case"end":this.listeners.end.push(C),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(C),this.state.flowing&&this.flowErrors();break}}removeListener(d,C){if(this.state.destroyed)return;let r;switch(d){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const b=r.indexOf(C);b>=0&&r.splice(b,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const C=[...this.pendingWritePromises];this.pendingWritePromises.length=0,C.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(s,d){const C=[];let r;for(;(r=s.read())!==null;)C.push(r);return d(C)}e.consumeReadable=D;function I(s,d,C){const r=[];let b;for(;(b=s.read())!==null&&r.length<C;)r.push(b);return b===null&&r.length>0?d(r):{read:()=>{if(r.length>0)return r.shift();if(typeof b!="undefined"){const o=b;return b=void 0,o}return s.read()}}}e.peekReadable=I;function F(s,d){return new Promise((C,r)=>{const b=[];_(s,{onData:o=>{d&&b.push(o)},onError:o=>{d?r(o):C(void 0)},onEnd:()=>{C(d?d(b):void 0)}})})}e.consumeStream=F;function _(s,d){s.on("error",C=>d.onError(C)),s.on("end",()=>d.onEnd()),s.on("data",C=>d.onData(C))}e.listenStream=_;function n(s,d){return new Promise((C,r)=>{const b=new M.DisposableStore,o=[],i=u=>{if(o.push(u),o.length>d)return b.dispose(),s.pause(),C({stream:s,buffer:o,ended:!1})},p=u=>r(u),c=()=>C({stream:s,buffer:o,ended:!0});b.add((0,M.toDisposable)(()=>s.removeListener("error",p))),s.on("error",p),b.add((0,M.toDisposable)(()=>s.removeListener("end",c))),s.on("end",c),b.add((0,M.toDisposable)(()=>s.removeListener("data",i))),s.on("data",i)})}e.peekStream=n;function m(s,d){const C=t(d);return C.end(s),C}e.toStream=m;function a(){const s=t(()=>{throw new Error("not supported")});return s.end(),s}e.emptyStream=a;function h(s){let d=!1;return{read:()=>d?null:(d=!0,s)}}e.toReadable=h;function g(s,d,C){const r=t(C);return _(s,{onData:b=>r.write(d.data(b)),onError:b=>r.error(d.error?d.error(b):b),onEnd:()=>r.end()}),r}e.transform=g;function S(s,d,C){let r=!1;return{read:()=>{const b=d.read();return r?b:(r=!0,b!==null?C([s,b]):s)}}}e.prefixedReadable=S;function v(s,d,C){let r=!1;const b=t(C);return _(d,{onData:o=>r?b.write(o):(r=!0,b.write(C([s,o]))),onError:o=>b.error(o),onEnd:()=>{r||(r=!0,b.write(s)),b.end()}}),b}e.prefixedStream=v}),define(be[22],Ee([0,1,104]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer!="undefined";let E,T;class t{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return M?new t(Buffer.allocUnsafe(i)):new t(new Uint8Array(i))}static wrap(i){return M&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new t(i)}static fromString(i,p){return!(p?.dontUseNodeBuffer||!1)&&M?new t(Buffer.from(i)):(E||(E=new TextEncoder),new t(E.encode(i)))}static concat(i,p){if(typeof p=="undefined"){p=0;for(let w=0,f=i.length;w<f;w++)p+=i[w].byteLength}const c=t.alloc(p);let u=0;for(let w=0,f=i.length;w<f;w++){const y=i[w];c.set(y,u),u+=y.byteLength}return c}toString(){return M?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(i,p){return new t(this.buffer.subarray(i,p))}set(i,p){i instanceof t?this.buffer.set(i.buffer,p):this.buffer.set(i,p)}readUInt32BE(i){return I(this.buffer,i)}writeUInt32BE(i,p){F(this.buffer,i,p)}readUInt32LE(i){return _(this.buffer,i)}writeUInt32LE(i,p){n(this.buffer,i,p)}readUInt8(i){return m(this.buffer,i)}writeUInt8(i,p){a(this.buffer,i,p)}}e.VSBuffer=t;function A(o,i){return o[i+0]<<0>>>0|o[i+1]<<8>>>0}e.readUInt16LE=A;function D(o,i,p){o[p+0]=i&255,i=i>>>8,o[p+1]=i&255}e.writeUInt16LE=D;function I(o,i){return o[i]*2**24+o[i+1]*2**16+o[i+2]*2**8+o[i+3]}e.readUInt32BE=I;function F(o,i,p){o[p+3]=i,i=i>>>8,o[p+2]=i,i=i>>>8,o[p+1]=i,i=i>>>8,o[p]=i}e.writeUInt32BE=F;function _(o,i){return o[i+0]<<0>>>0|o[i+1]<<8>>>0|o[i+2]<<16>>>0|o[i+3]<<24>>>0}e.readUInt32LE=_;function n(o,i,p){o[p+0]=i&255,i=i>>>8,o[p+1]=i&255,i=i>>>8,o[p+2]=i&255,i=i>>>8,o[p+3]=i&255}e.writeUInt32LE=n;function m(o,i){return o[i]}e.readUInt8=m;function a(o,i,p){o[p]=i}e.writeUInt8=a;function h(o){return l.consumeReadable(o,i=>t.concat(i))}e.readableToBuffer=h;function g(o){return l.toReadable(o)}e.bufferToReadable=g;function S(o){return l.consumeStream(o,i=>t.concat(i))}e.streamToBuffer=S;async function v(o){return o.ended?t.concat(o.buffer):t.concat([...o.buffer,await S(o.stream)])}e.bufferedStreamToBuffer=v;function s(o){return l.toStream(o,i=>t.concat(i))}e.bufferToStream=s;function d(o){return l.transform(o,{data:i=>typeof i=="string"?t.fromString(i):t.wrap(i)},i=>t.concat(i))}e.streamToBufferReadableStream=d;function C(o){return l.newWriteableStream(i=>t.concat(i),o)}e.newWriteableBufferStream=C;function r(o,i){return l.prefixedReadable(o,i,p=>t.concat(p))}e.prefixedBufferReadable=r;function b(o,i){return l.prefixedStream(o,i,p=>t.concat(p))}e.prefixedBufferStream=b});var Xe=this&&this.__classPrivateFieldSet||function(re,e,l,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,l):E?E.value=l:e.set(re,l),l},Te=this&&this.__classPrivateFieldGet||function(re,e,l,M){if(l==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?M:l==="a"?M.call(re):M?M.value:e.get(re)};define(be[20],Ee([0,1,15,9]),function(re,e,l,M){"use strict";var E,T,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(o,i,p){let c=o.get(i);return c===void 0&&(c=p,o.set(i,c)),c}e.getOrSet=A;function D(o){const i=[];return o.forEach((p,c)=>{i.push(`${c} => ${p}`)}),`Map(${o.size}) {${i.join(", ")}}`}e.mapToString=D;function I(o){const i=[];return o.forEach(p=>{i.push(p)}),`Set(${o.size}) {${i.join(", ")}}`}e.setToString=I;class F{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const p=i.charCodeAt(0),c=this._value.charCodeAt(this._pos);return p-c}value(){return this._value[this._pos]}}e.StringIterator=F;class _{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,M.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class n{constructor(i=!0,p=!0){this._splitOnBackslash=i,this._caseSensitive=p}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const p=this._value.charCodeAt(this._to);if(p===47||this._splitOnBackslash&&p===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,M.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,M.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=n;var m;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(m||(m={}));class a{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new n(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,M.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,M.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,M.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,M.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(g||(g={}));class S{constructor(i){this._iter=i}static forUris(i=()=>!1){return new S(new a(i))}static forPaths(){return new S(new n)}static forStrings(){return new S(new F)}static forConfigKeys(){return new S(new _)}clear(){this._root=void 0}fill(i,p){if(p){const c=p.slice(0);(0,l.shuffle)(c);for(let u of c)this.set(u,i)}else{const c=i.slice(0);(0,l.shuffle)(c);for(let u of c)this.set(u[0],u[1])}}set(i,p){const c=this._iter.reset(i);let u;this._root||(this._root=new h,this._root.segment=c.value());const w=[];for(u=this._root;;){const y=c.cmp(u.segment);if(y>0)u.left||(u.left=new h,u.left.segment=c.value()),w.push([-1,u]),u=u.left;else if(y<0)u.right||(u.right=new h,u.right.segment=c.value()),w.push([1,u]),u=u.right;else if(c.hasNext())c.next(),u.mid||(u.mid=new h,u.mid.segment=c.value()),w.push([0,u]),u=u.mid;else break}const f=u.value;u.value=p,u.key=i;for(let y=w.length-1;y>=0;y--){const R=w[y][1];R.updateHeight();const P=R.balanceFactor();if(P<-1||P>1){const B=w[y][0],L=w[y+1][0];if(B===1&&L===1)w[y][1]=R.rotateLeft();else if(B===-1&&L===-1)w[y][1]=R.rotateRight();else if(B===1&&L===-1)R.right=w[y+1][1]=w[y+1][1].rotateRight(),w[y][1]=R.rotateLeft();else if(B===-1&&L===1)R.left=w[y+1][1]=w[y+1][1].rotateLeft(),w[y][1]=R.rotateRight();else throw new Error;if(y>0)switch(w[y-1][0]){case-1:w[y-1][1].left=w[y][1];break;case 1:w[y-1][1].right=w[y][1];break;case 0:w[y-1][1].mid=w[y][1];break}else this._root=w[0][1]}}return f}get(i){return this._getNode(i)?.value}_getNode(i){const p=this._iter.reset(i);let c=this._root;for(;c;){const u=p.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(p.hasNext())p.next(),c=c.mid;else break}return c}has(i){const p=this._getNode(i);return!(p?.value===void 0&&p?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,p){const c=this._iter.reset(i),u=[];let w=this._root;for(;w;){const f=c.cmp(w.segment);if(f>0)u.push([-1,w]),w=w.left;else if(f<0)u.push([1,w]),w=w.right;else if(c.hasNext())c.next(),u.push([0,w]),w=w.mid;else break}if(!!w){if(p?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const f=this._min(w.right),{key:y,value:R,segment:P}=f;this._delete(f.key,!1),w.key=y,w.value=R,w.segment=P}else{const f=w.left??w.right;if(u.length>0){const[y,R]=u[u.length-1];switch(y){case-1:R.left=f;break;case 0:R.mid=f;break;case 1:R.right=f;break}}else this._root=f}for(let f=u.length-1;f>=0;f--){const y=u[f][1];y.updateHeight();const R=y.balanceFactor();if(R>1?(y.right.balanceFactor()>=0||(y.right=u[f+1][1]=u[f+1][1].rotateRight()),u[f][1]=y.rotateLeft()):R<-1&&(y.left.balanceFactor()<=0||(y.left=u[f+1][1]=u[f+1][1].rotateLeft()),u[f][1]=y.rotateRight()),f>0)switch(u[f-1][0]){case-1:u[f-1][1].left=u[f][1];break;case 1:u[f-1][1].right=u[f][1];break;case 0:u[f-1][1].mid=u[f][1];break}else this._root=u[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const p=this._iter.reset(i);let c=this._root,u;for(;c;){const w=p.cmp(c.segment);if(w>0)c=c.left;else if(w<0)c=c.right;else if(p.hasNext())p.next(),u=c.value||u,c=c.mid;else break}return c&&c.value||u}findSuperstr(i){const p=this._iter.reset(i);let c=this._root;for(;c;){const u=p.cmp(c.segment);if(u>0)c=c.left;else if(u<0)c=c.right;else if(p.hasNext())p.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(i){for(const[p,c]of this)i(c,p)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=p=>{if(!p)return!0;const c=p.balanceFactor();return c<-1||c>1?!1:i(p.left)&&i(p.right)};return i(this._root)}}e.TernarySearchTree=S;class v{constructor(i,p){this.uri=i,this.value=p}}class s{constructor(i,p){this[E]="ResourceMap",i instanceof s?(this.map=new Map(i.map),this.toKey=p??s.defaultToKey):(this.map=new Map,this.toKey=i??s.defaultToKey)}set(i,p){return this.map.set(this.toKey(i),new v(i,p)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,p){typeof p!="undefined"&&(i=i.bind(p));for(let[c,u]of this.map)i(u.value,u.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=s,s.defaultToKey=o=>o.toString();var d;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(d=e.Touch||(e.Touch={}));class C{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,p=0){const c=this._map.get(i);if(!!c)return p!==0&&this.touch(c,p),c.value}set(i,p,c=0){let u=this._map.get(i);if(u)u.value=p,c!==0&&this.touch(u,c);else{switch(u={key:i,value:p,next:void 0,previous:void 0},c){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(i,u),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const p=this._map.get(i);if(!!p)return this._map.delete(i),this.removeItem(p),this._size--,p.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,p){const c=this._state;let u=this._head;for(;u;){if(p?i.bind(p)(u.value,u.key,this):i(u.value,u.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,p=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(c){const w={value:c.key,done:!1};return c=c.next,w}else return{value:void 0,done:!0}}};return u}values(){const i=this,p=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(c){const w={value:c.value,done:!1};return c=c.next,w}else return{value:void 0,done:!0}}};return u}entries(){const i=this,p=this._state;let c=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==p)throw new Error("LinkedMap got modified during iteration.");if(c){const w={value:[c.key,c.value],done:!1};return c=c.next,w}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let p=this._head,c=this.size;for(;p&&c>i;)this._map.delete(p.key),p=p.next,c--;this._head=p,this._size=c,p&&(p.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const p=i.next,c=i.previous;if(!p||!c)throw new Error("Invalid list");p.previous=c,c.next=p}i.next=void 0,i.previous=void 0,this._state++}touch(i,p){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(p!==1&&p!==2)){if(p===1){if(i===this._head)return;const c=i.next,u=i.previous;i===this._tail?(u.next=void 0,this._tail=u):(c.previous=u,u.next=c),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(p===2){if(i===this._tail)return;const c=i.next,u=i.previous;i===this._head?(c.previous=void 0,this._head=c):(c.previous=u,u.next=c),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((p,c)=>{i.push([c,p])}),i}fromJSON(i){this.clear();for(const[p,c]of i)this.set(p,c)}}e.LinkedMap=C;class r extends C{constructor(i,p=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,p),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,p=2){return super.get(i,p)}peek(i){return super.get(i,0)}set(i,p){return super.set(i,p,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class b{constructor(i){t.set(this,void 0),Xe(this,t,i,"f")}get size(){return Te(this,t,"f").size}forEach(i,p){Te(this,t,"f").forEach(i,p)}get(i){return Te(this,t,"f").get(i)}has(i){return Te(this,t,"f").has(i)}entries(){return Te(this,t,"f").entries()}keys(){return Te(this,t,"f").keys()}values(){return Te(this,t,"f").values()}[(t=new WeakMap,Symbol.iterator)](){return Te(this,t,"f").entries()}}e.ReadonlyMapView=b}),define(be[105],Ee([0,1,20,9]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...G){return function(ie,de){for(let Pe=0,Ne=G.length;Pe<Ne;Pe++){const We=G[Pe](ie,de);if(We)return We}return null}}e.or=E,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(G,ie,de){if(!de||de.length<ie.length)return null;let Pe;return G?Pe=M.startsWithIgnoreCase(de,ie):Pe=de.indexOf(ie)===0,Pe?ie.length>0?[{start:0,end:ie.length}]:[]:null}function t(G,ie){const de=ie.toLowerCase().indexOf(G.toLowerCase());return de===-1?null:[{start:de,end:de+G.length}]}e.matchesContiguousSubString=t;function A(G,ie){return D(G.toLowerCase(),ie.toLowerCase(),0,0)}e.matchesSubString=A;function D(G,ie,de,Pe){if(de===G.length)return[];if(Pe===ie.length)return null;if(G[de]===ie[Pe]){let Ne=null;return(Ne=D(G,ie,de+1,Pe+1))?S({start:Pe,end:Pe+1},Ne):null}return D(G,ie,de,Pe+1)}function I(G){return 97<=G&&G<=122}function F(G){return 65<=G&&G<=90}e.isUpper=F;function _(G){return 48<=G&&G<=57}function n(G){return G===32||G===9||G===10||G===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>m.add(G.charCodeAt(0)));function a(G){return n(G)||m.has(G)}function h(G,ie){return G===ie||a(G)&&a(ie)}function g(G){return I(G)||F(G)||_(G)}function S(G,ie){return ie.length===0?ie=[G]:G.end===ie[0].start?ie[0].start=G.start:ie.unshift(G),ie}function v(G,ie){for(let de=ie;de<G.length;de++){const Pe=G.charCodeAt(de);if(F(Pe)||_(Pe)||de>0&&!g(G.charCodeAt(de-1)))return de}return G.length}function s(G,ie,de,Pe){if(de===G.length)return[];if(Pe===ie.length)return null;if(G[de]!==ie[Pe].toLowerCase())return null;{let Ne=null,We=Pe+1;for(Ne=s(G,ie,de+1,Pe+1);!Ne&&(We=v(ie,We))<ie.length;)Ne=s(G,ie,de+1,We),We++;return Ne===null?null:S({start:Pe,end:Pe+1},Ne)}}function d(G){let ie=0,de=0,Pe=0,Ne=0,We=0;for(let nt=0;nt<G.length;nt++)We=G.charCodeAt(nt),F(We)&&ie++,I(We)&&de++,g(We)&&Pe++,_(We)&&Ne++;const je=ie/G.length,et=de/G.length,ot=Pe/G.length,ye=Ne/G.length;return{upperPercent:je,lowerPercent:et,alphaPercent:ot,numericPercent:ye}}function C(G){const{upperPercent:ie,lowerPercent:de}=G;return de===0&&ie>.6}function r(G){const{upperPercent:ie,lowerPercent:de,alphaPercent:Pe,numericPercent:Ne}=G;return de>.2&&ie<.8&&Pe>.6&&Ne<.2}function b(G){let ie=0,de=0,Pe=0,Ne=0;for(let We=0;We<G.length;We++)Pe=G.charCodeAt(We),F(Pe)&&ie++,I(Pe)&&de++,n(Pe)&&Ne++;return(ie===0||de===0)&&Ne===0?G.length<=30:ie<=5}function o(G,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!b(G)||ie.length>60)return null;const de=d(ie);if(!r(de)){if(!C(de))return null;ie=ie.toLowerCase()}let Pe=null,Ne=0;for(G=G.toLowerCase();Ne<ie.length&&(Pe=s(G,ie,0,Ne))===null;)Ne=v(ie,Ne+1);return Pe}e.matchesCamelCase=o;function i(G,ie,de=!1){if(!ie||ie.length===0)return null;let Pe=null,Ne=0;for(G=G.toLowerCase(),ie=ie.toLowerCase();Ne<ie.length&&(Pe=p(G,ie,0,Ne,de))===null;)Ne=c(ie,Ne+1);return Pe}e.matchesWords=i;function p(G,ie,de,Pe,Ne){if(de===G.length)return[];if(Pe===ie.length)return null;if(h(G.charCodeAt(de),ie.charCodeAt(Pe))){let We=null,je=Pe+1;if(We=p(G,ie,de+1,Pe+1,Ne),!Ne)for(;!We&&(je=c(ie,je))<ie.length;)We=p(G,ie,de+1,je,Ne),je++;return We===null?null:S({start:Pe,end:Pe+1},We)}else return null}function c(G,ie){for(let de=ie;de<G.length;de++)if(a(G.charCodeAt(de))||de>0&&a(G.charCodeAt(de-1)))return de;return G.length}const u=E(e.matchesPrefix,o,t),w=E(e.matchesPrefix,o,A),f=new l.LRUCache(1e4);function y(G,ie,de=!1){if(typeof G!="string"||typeof ie!="string")return null;let Pe=f.get(G);Pe||(Pe=new RegExp(M.convertSimple2RegExpPattern(G),"i"),f.set(G,Pe));const Ne=Pe.exec(ie);return Ne?[{start:Ne.index,end:Ne.index+Ne[0].length}]:de?w(G,ie):u(G,ie)}e.matchesFuzzy=y;function R(G,ie){const de=Je(G,G.toLowerCase(),0,ie,ie.toLowerCase(),0,!0);return de?B(de):null}e.matchesFuzzy2=R;function P(G,ie,de,Pe,Ne,We){const je=Math.min(13,G.length);for(;de<je;de++){const et=Je(G,ie,de,Pe,Ne,We,!1);if(et)return et}return[0,We]}e.anyScore=P;function B(G){if(typeof G=="undefined")return[];const ie=[],de=G[1];for(let Pe=G.length-1;Pe>1;Pe--){const Ne=G[Pe]+de,We=ie[ie.length-1];We&&We.end===Ne?We.end=Ne+1:ie.push({start:Ne,end:Ne+1})}return ie}e.createMatches=B;const L=128;function k(){const G=[],ie=[];for(let de=0;de<=L;de++)ie[de]=0;for(let de=0;de<=L;de++)G.push(ie.slice(0));return G}function x(G){const ie=[];for(let de=0;de<=G;de++)ie[de]=0;return ie}const N=x(2*L),V=x(2*L),W=k(),$=k(),X=k(),j=!1;function Q(G,ie,de,Pe,Ne){function We(et,ot,ye=" "){for(;et.length<ot;)et=ye+et;return et}let je=` |   |${Pe.split("").map(et=>We(et,3)).join("|")}
`;for(let et=0;et<=de;et++)et===0?je+=" |":je+=`${ie[et-1]}|`,je+=G[et].slice(0,Ne+1).map(ot=>We(ot.toString(),3)).join("|")+`
`;return je}function le(G,ie,de,Pe){G=G.substr(ie),de=de.substr(Pe),console.log(Q($,G,G.length,de,de.length)),console.log(Q(X,G,G.length,de,de.length)),console.log(Q(W,G,G.length,de,de.length))}function ve(G,ie){if(ie<0||ie>=G.length)return!1;const de=G.codePointAt(ie);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise(de)}}function ue(G,ie){if(ie<0||ie>=G.length)return!1;switch(G.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function Fe(G,ie,de){return ie[G]!==de[G]}function Ke(G,ie,de,Pe,Ne,We,je=!1){for(;ie<de&&Ne<We;)G[ie]===Pe[Ne]&&(je&&(N[ie]=Ne),ie+=1),Ne+=1;return ie===de}e.isPatternInWord=Ke;var Oe;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(Oe||(Oe={}));var He;(function(G){G.Default=[-100,0];function ie(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}G.isDefault=ie})(He=e.FuzzyScore||(e.FuzzyScore={}));function Je(G,ie,de,Pe,Ne,We,je){const et=G.length>L?L:G.length,ot=Pe.length>L?L:Pe.length;if(de>=et||We>=ot||et-de>ot-We||!Ke(ie,de,et,Ne,We,ot,!0))return;Ye(et,ot,de,We,ie,Ne);let ye=1,nt=1,q=de,J=We;const pe=[!1];for(ye=1,q=de;q<et;ye++,q++){const ht=N[q],Ct=V[q],It=q+1<et?V[q+1]:ot;for(nt=ht-We+1,J=ht;J<It;nt++,J++){let Pt=Number.MIN_SAFE_INTEGER,Ze=!1;J<=Ct&&(Pt=Qe(G,ie,q,de,Pe,Ne,J,ot,We,W[ye-1][nt-1]===0,pe));let pt=0;Pt!==Number.MAX_SAFE_INTEGER&&(Ze=!0,pt=Pt+$[ye-1][nt-1]);const Ie=J>ht,ge=Ie?$[ye][nt-1]+(W[ye][nt-1]>0?-5:0):0,Ce=J>ht+1&&W[ye][nt-1]>0,ee=Ce?$[ye][nt-2]+(W[ye][nt-2]>0?-5:0):0;if(Ce&&(!Ie||ee>=ge)&&(!Ze||ee>=pt))$[ye][nt]=ee,X[ye][nt]=3,W[ye][nt]=0;else if(Ie&&(!Ze||ge>=pt))$[ye][nt]=ge,X[ye][nt]=2,W[ye][nt]=0;else if(Ze)$[ye][nt]=pt,X[ye][nt]=1,W[ye][nt]=W[ye-1][nt-1]+1;else throw new Error("not possible")}}if(j&&le(G,de,Pe,We),!pe[0]&&!je)return;ye--,nt--;const $e=[$[ye][nt],We];let qe=0,rt=0;for(;ye>=1;){let ht=nt;do{const Ct=X[ye][ht];if(Ct===3)ht=ht-2;else if(Ct===2)ht=ht-1;else break}while(ht>=1);qe>1&&ie[de+ye-1]===Ne[We+nt-1]&&!Fe(ht+We-1,Pe,Ne)&&qe+1>W[ye][ht]&&(ht=nt),ht===nt?qe++:qe=1,rt||(rt=ht),ye--,nt=ht-1,$e.push(nt)}ot===et&&($e[0]+=2);const ft=rt-et;return $e[0]-=ft,$e}e.fuzzyScore=Je;function Ye(G,ie,de,Pe,Ne,We){let je=G-1,et=ie-1;for(;je>=de&&et>=Pe;)Ne[je]===We[et]&&(V[je]=et,je--),et--}function Qe(G,ie,de,Pe,Ne,We,je,et,ot,ye,nt){if(ie[de]!==We[je])return Number.MIN_SAFE_INTEGER;let q=1,J=!1;return je===de-Pe?q=G[de]===Ne[je]?7:5:Fe(je,Ne,We)&&(je===0||!Fe(je-1,Ne,We))?(q=G[de]===Ne[je]?7:5,J=!0):ve(We,je)&&(je===0||!ve(We,je-1))?q=5:(ve(We,je-1)||ue(We,je-1))&&(q=5,J=!0),q>1&&de===Pe&&(nt[0]=!0),J||(J=Fe(je,Ne,We)||ve(We,je-1)||ue(We,je-1)),de===Pe?je>ot&&(q-=J?3:5):ye?q+=J?2:0:q+=J?0:1,je+1===et&&(q-=J?3:5),q}function z(G,ie,de,Pe,Ne,We,je){return Z(G,ie,de,Pe,Ne,We,!0,je)}e.fuzzyScoreGracefulAggressive=z;function K(G,ie,de,Pe,Ne,We,je){return Z(G,ie,de,Pe,Ne,We,!1,je)}e.fuzzyScoreGraceful=K;function Z(G,ie,de,Pe,Ne,We,je,et){let ot=Je(G,ie,de,Pe,Ne,We,et);if(ot&&!je)return ot;if(G.length>=3){const ye=Math.min(7,G.length-1);for(let nt=de+1;nt<ye;nt++){const q=oe(G,nt);if(q){const J=Je(q,q.toLowerCase(),de,Pe,Ne,We,et);J&&(J[0]-=3,(!ot||J[0]>ot[0])&&(ot=J))}}}return ot}function oe(G,ie){if(ie+1>=G.length)return;const de=G[ie],Pe=G[ie+1];if(de!==Pe)return G.slice(0,ie)+Pe+de+G.slice(ie+2)}}),define(be[106],Ee([0,1,35,105,9]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?\\)`,"g"),t=new RegExp(l.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${T.source}`,"g");function D(g){return g.replace(A,(S,v)=>v?S:`\\${S}`)}e.escapeIcons=D;const I=new RegExp(`\\\\${T.source}`,"g");function F(g){return g.replace(I,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=F;const _=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function n(g){return g.indexOf(e.iconStartMarker)===-1?g:g.replace(_,(S,v,s,d)=>s?S:v||d||"")}e.stripIcons=n;function m(g){const S=g.indexOf(e.iconStartMarker);return S===-1?{text:g}:a(g,S)}e.parseLabelWithIcons=m;function a(g,S){const v=[];let s="";function d(u){if(u){s+=u;for(const w of u)v.push(b)}}let C=-1,r="",b=0,o,i,p=S;const c=g.length;for(d(g.substr(0,S));p<c;)o=g[p],i=g[p+1],o===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(C=p,d(r),r=e.iconStartMarker,p++):o===")"&&C!==-1?(b+=p-C+1,C=-1,r=""):C!==-1?t.test(o)?r+=o:(d(r),C=-1,r=""):d(o),p++;return d(r),{text:s,iconOffsets:v}}function h(g,S,v=!1){const{text:s,iconOffsets:d}=S;if(!d||d.length===0)return(0,M.matchesFuzzy)(g,s,v);const C=(0,E.ltrim)(s," "),r=s.length-C.length,b=(0,M.matchesFuzzy)(g,C,v);if(b)for(const o of b){const i=d[o.start+r]+r;o.start+=i,o.end+=i}return b}e.matchesFuzzyIconAware=h}),define(be[77],Ee([0,1,16,106]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class T{constructor(m="",a=!1){if(this.value=m,typeof this.value!="string")throw(0,l.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(m,a=0){return this.value+=I(this.supportThemeIcons?(0,M.escapeIcons)(m):m).replace(/([ \t]+)/g,(h,g)=>"&nbsp;".repeat(g.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,a){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=T;function t(n){return A(n)?!n.value:Array.isArray(n)?n.every(t):!0}e.isEmptyMarkdownString=t;function A(n){return n instanceof T?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=A;function D(n,m){return n===m?!0:!n||!m?!1:n.value===m.value&&n.isTrusted===m.isTrusted&&n.supportThemeIcons===m.supportThemeIcons}e.markdownStringEqual=D;function I(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function F(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=F;function _(n){const m=[],a=n.split("|").map(g=>g.trim());n=a[0];const h=a[1];if(h){const g=/height=(\d+)/.exec(h),S=/width=(\d+)/.exec(h),v=g?g[1]:"",s=S?S[1]:"",d=isFinite(parseInt(s)),C=isFinite(parseInt(v));d&&m.push(`width="${s}"`),C&&m.push(`height="${v}"`)}return{href:n,dimensions:m}}e.parseHrefAndDimensions=_}),define(be[36],Ee([0,1,9]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(M||(M={})),function(E){const T="error",t="warning",A="warn",D="info",I="ignore";function F(n){return n?l.equalsIgnoreCase(T,n)?E.Error:l.equalsIgnoreCase(t,n)||l.equalsIgnoreCase(A,n)?E.Warning:l.equalsIgnoreCase(D,n)?E.Info:E.Ignore:E.Ignore}E.fromValue=F;function _(n){switch(n){case E.Error:return T;case E.Warning:return t;case E.Info:return D;default:return I}}E.toString=_}(M||(M={})),e.default=M}),define(be[44],Ee([0,1,17,25,9,10]),function(re,e,l,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function t(o){return o===47||o===92}e.isPathSeparator=t;function A(o){return o.replace(/[\\/]/g,l.posix.sep)}e.toSlashes=A;function D(o){return o.indexOf("/")===-1&&(o=A(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=D;function I(o,i=l.posix.sep){if(!o)return"";const p=o.length,c=o.charCodeAt(0);if(t(c)){if(t(o.charCodeAt(1))&&!t(o.charCodeAt(2))){let w=3;const f=w;for(;w<p&&!t(o.charCodeAt(w));w++);if(f!==w&&!t(o.charCodeAt(w+1))){for(w+=1;w<p;w++)if(t(o.charCodeAt(w)))return o.slice(0,w+1).replace(/[\\/]/g,i)}}return i}else if(S(c)&&o.charCodeAt(1)===58)return t(o.charCodeAt(2))?o.slice(0,2)+i:o.slice(0,2);let u=o.indexOf("://");if(u!==-1){for(u+=3;u<p;u++)if(t(o.charCodeAt(u)))return o.slice(0,u+1)}return""}e.getRoot=I;function F(o){if(!M.isWindows||!o||o.length<5)return!1;let i=o.charCodeAt(0);if(i!==92||(i=o.charCodeAt(1),i!==92))return!1;let p=2;const c=p;for(;p<o.length&&(i=o.charCodeAt(p),i!==92);p++);return!(c===p||(i=o.charCodeAt(p+1),isNaN(i)||i===92))}e.isUNC=F;const _=/[\\/:\*\?"<>\|]/g,n=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(o,i=M.isWindows){const p=i?_:n;return!(!o||o.length===0||/^\s+$/.test(o)||(p.lastIndex=0,p.test(o))||i&&m.test(o)||o==="."||o===".."||i&&o[o.length-1]==="."||i&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=a;function h(o,i,p){const c=o===i;return!p||c?c:!o||!i?!1:(0,E.equalsIgnoreCase)(o,i)}e.isEqual=h;function g(o,i,p,c=l.sep){if(o===i)return!0;if(!o||!i||i.length>o.length)return!1;if(p){if(!(0,E.startsWithIgnoreCase)(o,i))return!1;if(i.length===o.length)return!0;let w=i.length;return i.charAt(i.length-1)===c&&w--,o.charAt(w)===c}return i.charAt(i.length-1)!==c&&(i+=c),o.indexOf(i)===0}e.isEqualOrParent=g;function S(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=S;function v(o,i){return M.isWindows&&o.endsWith(":")&&(o+=l.sep),(0,l.isAbsolute)(o)||(o=(0,l.join)(i,o)),o=(0,l.normalize)(o),M.isWindows?(o=(0,E.rtrim)(o,l.sep),o.endsWith(":")&&(o+=l.sep)):(o=(0,E.rtrim)(o,l.sep),o||(o=l.sep)),o}e.sanitizeFilePath=v;function s(o){const i=(0,l.normalize)(o);return M.isWindows?o.length>3?!1:d(i)&&(o.length===2||i.charCodeAt(2)===92):i===l.posix.sep}e.isRootOrDriveLetter=s;function d(o,i){return(i!==void 0?i:M.isWindows)?S(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function C(o){return d(o)?o[0]:void 0}e.getDriveLetter=C;function r(o,i,p){return i.length>o.length?-1:o===i?0:(p&&(o=o.toLowerCase(),i=i.toLowerCase()),o.indexOf(i))}e.indexOfPath=r;function b(o){const i=o.split(":");let p,c,u;if(i.forEach(w=>{const f=Number(w);(0,T.isNumber)(f)?c===void 0?c=f:u===void 0&&(u=f):p=p?[p,w].join(":"):w}),!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:c!==void 0?c:void 0,column:u!==void 0?u:c!==void 0?1:void 0}}e.parseLineAndColumnAware=b}),define(be[23],Ee([0,1,10]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.keys(h).forEach(S=>{h[S]&&typeof h[S]=="object"?g[S]=M(h[S]):g[S]=h[S]}),g}e.deepClone=M;function E(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const S=g.shift();Object.freeze(S);for(const v in S)if(T.call(S,v)){const s=S[v];typeof s=="object"&&!Object.isFrozen(s)&&g.push(s)}}return h}e.deepFreeze=E;const T=Object.prototype.hasOwnProperty;function t(h,g){return A(h,g,new Set)}e.cloneAndChange=t;function A(h,g,S){if((0,l.isUndefinedOrNull)(h))return h;const v=g(h);if(typeof v!="undefined")return v;if((0,l.isArray)(h)){const s=[];for(const d of h)s.push(A(d,g,S));return s}if((0,l.isObject)(h)){if(S.has(h))throw new Error("Cannot clone recursive data-structure");S.add(h);const s={};for(let d in h)T.call(h,d)&&(s[d]=A(h[d],g,S));return S.delete(h),s}return h}function D(h,g,S=!0){return(0,l.isObject)(h)?((0,l.isObject)(g)&&Object.keys(g).forEach(v=>{v in h?S&&((0,l.isObject)(h[v])&&(0,l.isObject)(g[v])?D(h[v],g[v],S):h[v]=g[v]):h[v]=g[v]}),h):g}e.mixin=D;function I(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let S,v;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(S=0;S<h.length;S++)if(!I(h[S],g[S]))return!1}else{const s=[];for(v in h)s.push(v);s.sort();const d=[];for(v in g)d.push(v);if(d.sort(),!I(s,d))return!1;for(S=0;S<s.length;S++)if(!I(h[s[S]],g[s[S]]))return!1}return!0}e.equals=I;function F(h){const g=new Set;return JSON.stringify(h,(S,v)=>{if((0,l.isObject)(v)||Array.isArray(v)){if(g.has(v))return"[Circular]";g.add(v)}return v})}e.safeStringify=F;function _(h,g,S){const v=g(h);return typeof v=="undefined"?S:v}e.getOrDefault=_;function n(h,g){const S=Object.create(null);return!h||!g||Object.keys(g).forEach(s=>{const d=h[s],C=g[s];I(d,C)||(S[s]=C)}),S}e.distinct=n;function m(h,g){const S=g.toLowerCase(),v=Object.keys(h).find(s=>s.toLowerCase()===S);return v?h[v]:h[g]}e.getCaseInsensitive=m;function a(h,g){const S=Object.create(null);for(const[v,s]of Object.entries(h))g(v,s)&&(S[v]=s);return S}e.filter=a}),define(be[57],Ee([0,1,22,9,2]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(F){return JSON.stringify(F,D)}e.stringify=T;function t(F){let _=JSON.parse(F);return _=I(_),_}e.parse=t;var A;(function(F){F[F.Uri=1]="Uri",F[F.Regexp=2]="Regexp",F[F.ScmResource=3]="ScmResource",F[F.ScmResourceGroup=4]="ScmResourceGroup",F[F.ScmProvider=5]="ScmProvider",F[F.CommentController=6]="CommentController",F[F.CommentThread=7]="CommentThread",F[F.CommentThreadReply=8]="CommentThreadReply",F[F.CommentNode=9]="CommentNode",F[F.CommentThreadNode=10]="CommentThreadNode",F[F.TimelineActionContext=11]="TimelineActionContext",F[F.NotebookCellActionContext=12]="NotebookCellActionContext",F[F.TestItemContext=13]="TestItemContext"})(A=e.MarshalledId||(e.MarshalledId={}));function D(F,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,M.regExpFlags)(_)}:_}function I(F,_=0){if(!F||_>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return E.URI.revive(F);case 2:return new RegExp(F.source,F.flags)}if(F instanceof l.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let n=0;n<F.length;++n)F[n]=I(F[n],_+1);else for(const n in F)Object.hasOwnProperty.call(F,n)&&(F[n]=I(F[n],_+1))}return F}e.revive=I}),define(be[11],Ee([0,1,25,2]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeNotebookCellOutput="vscode-notebook-cell-output",A.vscodeInteractive="vscode-interactive",A.vscodeInteractiveInput="vscode-interactive-input",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.vscodeTerminal="vscode-terminal",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.extension="extension",A.vscodeFileResource="vscode-file",A.tmp="tmp",A.vsls="vsls"})(E=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,I,F){this._hosts[D]=I,this._ports[D]=F}setConnectionToken(D,I){this._connectionTokens[D]=I}rewrite(D){if(this._delegate)return this._delegate(D);const I=D.authority;let F=this._hosts[I];F&&F.indexOf(":")!==-1&&(F=`[${F}]`);const _=this._ports[I],n=this._connectionTokens[I];let m=`path=${encodeURIComponent(D.path)}`;return typeof n=="string"&&(m+=`&tkn=${encodeURIComponent(n)}`),M.URI.from({scheme:l.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${F}:${_}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new T;class t{asBrowserUri(D,I){const F=this.toUri(D,I);return F.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(F):F.scheme===E.file&&(l.isNative||typeof l.globals.importScripts=="function"&&l.globals.origin===`${E.vscodeFileResource}://${t.FALLBACK_AUTHORITY}`)?F.with({scheme:E.vscodeFileResource,authority:F.authority||t.FALLBACK_AUTHORITY,query:null,fragment:null}):F}asFileUri(D,I){const F=this.toUri(D,I);return F.scheme===E.vscodeFileResource?F.with({scheme:E.file,authority:F.authority!==t.FALLBACK_AUTHORITY?F.authority:null,query:null,fragment:null}):F}toUri(D,I){return M.URI.isUri(D)?D:M.URI.parse(I.toUrl(D))}}t.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new t}),define(be[24],Ee([0,1,44,11,17,25,9,2]),function(re,e,l,M,E,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(m){return(0,A.uriToFsPath)(m,!0)}e.originalFSPath=D;class I{constructor(a){this._ignorePathCasing=a}compare(a,h,g=!1){return a===h?0:(0,t.compare)(this.getComparisonKey(a,g),this.getComparisonKey(h,g))}isEqual(a,h,g=!1){return a===h?!0:!a||!h?!1:this.getComparisonKey(a,g)===this.getComparisonKey(h,g)}getComparisonKey(a,h=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,h,g=!1){if(a.scheme===h.scheme){if(a.scheme===M.Schemas.file)return l.isEqualOrParent(D(a),D(h),this._ignorePathCasing(a))&&a.query===h.query&&(g||a.fragment===h.fragment);if((0,e.isEqualAuthority)(a.authority,h.authority))return l.isEqualOrParent(a.path,h.path,this._ignorePathCasing(a),"/")&&a.query===h.query&&(g||a.fragment===h.fragment)}return!1}joinPath(a,...h){return A.URI.joinPath(a,...h)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return E.posix.basename(a.path)}extname(a){return E.posix.extname(a.path)}dirname(a){if(a.path.length===0)return a;let h;return a.scheme===M.Schemas.file?h=A.URI.file(E.dirname(D(a))).path:(h=E.posix.dirname(a.path),a.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),h="/")),a.with({path:h})}normalizePath(a){if(!a.path.length)return a;let h;return a.scheme===M.Schemas.file?h=A.URI.file(E.normalize(D(a))).path:h=E.posix.normalize(a.path),a.with({path:h})}relativePath(a,h){if(a.scheme!==h.scheme||!(0,e.isEqualAuthority)(a.authority,h.authority))return;if(a.scheme===M.Schemas.file){const v=E.relative(D(a),D(h));return T.isWindows?l.toSlashes(v):v}let g=a.path||"/",S=h.path||"/";if(this._ignorePathCasing(a)){let v=0;for(const s=Math.min(g.length,S.length);v<s&&!(g.charCodeAt(v)!==S.charCodeAt(v)&&g.charAt(v).toLowerCase()!==S.charAt(v).toLowerCase());v++);g=S.substr(0,v)+g.substr(v)}return E.posix.relative(g,S)}resolvePath(a,h){if(a.scheme===M.Schemas.file){const g=A.URI.file(E.resolve(D(a),h));return a.with({authority:g.authority,path:g.path})}return h=l.toPosixPath(h),a.with({path:E.posix.resolve(a.path,h)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,h){return a===h||a!==void 0&&h!==void 0&&(0,t.equalsIgnoreCase)(a,h)}hasTrailingPathSeparator(a,h=E.sep){if(a.scheme===M.Schemas.file){const g=D(a);return g.length>l.getRoot(g).length&&g[g.length-1]===h}else{const g=a.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,h=E.sep){return(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,h=E.sep){let g=!1;if(a.scheme===M.Schemas.file){const S=D(a);g=S!==void 0&&S.length===l.getRoot(S).length&&S[S.length-1]===h}else{h="/";const S=a.path;g=S.length===1&&S.charCodeAt(S.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(a,h)?a.with({path:a.path+"/"}):a}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(m=>m.scheme===M.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new I(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function F(m,a){const h=[];for(let g=0;g<m.length;g++){const S=a(m[g]);m.some((v,s)=>s===g?!1:(0,e.isEqualOrParent)(S,a(v)))||h.push(m[g])}return h}e.distinctParents=F;var _;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function a(h){const g=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(s=>{const[d,C]=s.split(":");d&&C&&g.set(d,C)});const v=h.path.substring(0,h.path.indexOf(";"));return v&&g.set(m.META_DATA_MIME,v),g}m.parseMetaData=a})(_=e.DataUri||(e.DataUri={}));function n(m,a,h){if(a){let g=m.path;return g&&g[0]!==E.posix.sep&&(g=E.posix.sep+g),m.with({scheme:h,authority:a,path:g})}return m.with({scheme:h})}e.toLocalResource=n}),define(be[13],Ee([0,1,21,16,3,6,24]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function A(W){return!!W&&typeof W.then=="function"}e.isThenable=A;function D(W){const $=new l.CancellationTokenSource,X=W($.token),j=new Promise((Q,le)=>{const ve=$.token.onCancellationRequested(()=>{ve.dispose(),$.dispose(),le((0,M.canceled)())});Promise.resolve(X).then(ue=>{ve.dispose(),$.dispose(),Q(ue)},ue=>{ve.dispose(),$.dispose(),le(ue)})});return new class{cancel(){$.cancel()}then(Q,le){return j.then(Q,le)}catch(Q){return this.then(void 0,Q)}finally(Q){return j.finally(Q)}}}e.createCancelablePromise=D;function I(W,$,X){return Promise.race([W,new Promise(j=>$.onCancellationRequested(()=>j(X)))])}e.raceCancellation=I;async function F(W){let $=-1;const X=W.map((Q,le)=>Q.then(ve=>($=le,ve))),j=await Promise.race(X);return W.forEach((Q,le)=>{le!==$&&Q.cancel()}),j}e.raceCancellablePromises=F;function _(W,$,X){let j;const Q=setTimeout(()=>{j?.(void 0),X?.()},$);return Promise.race([W.finally(()=>clearTimeout(Q)),new Promise(le=>j=le)])}e.raceTimeout=_;function n(W){return new Promise(($,X)=>{const j=W();A(j)?j.then($,X):$(j)})}e.asPromise=n;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const X=()=>{this.queuedPromise=null;const j=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,j};this.queuedPromise=new Promise(j=>{this.activePromise.then(X,X).then(j)})}return new Promise((X,j)=>{this.queuedPromise.then(X,j)})}return this.activePromise=$(),new Promise((X,j)=>{this.activePromise.then(Q=>{this.activePromise=null,X(Q)},Q=>{this.activePromise=null,j(Q)})})}}e.Throttler=m;class a{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=a;class h{constructor(){this.promiseMap=new Map}queue($,X){const Q=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.promiseMap.get($)===Q&&this.promiseMap.delete($)});return this.promiseMap.set($,Q),Q}}e.SequencerByKey=h;class g{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,X=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Q)=>{this.doResolve=j,this.doReject=Q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},X),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,M.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=g;class S{constructor($){this.delayer=new g($),this.throttler=new m}trigger($,X){return this.delayer.trigger(()=>this.throttler.queue($),X)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class v{constructor(){this._isOpen=!1,this._promise=new Promise(($,X)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=v;class s extends v{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=s;function d(W,$){return $?new Promise((X,j)=>{const Q=setTimeout(()=>{le.dispose(),X()},W),le=$.onCancellationRequested(()=>{clearTimeout(Q),le.dispose(),j((0,M.canceled)())})}):D(X=>d(W,X))}e.timeout=d;function C(W,$=0){const X=setTimeout(W,$);return(0,T.toDisposable)(()=>clearTimeout(X))}e.disposableTimeout=C;function r(W){const $=[];let X=0;const j=W.length;function Q(){return X<j?W[X++]():null}function le(ve){ve!=null&&$.push(ve);const ue=Q();return ue?ue.then(le):Promise.resolve($)}return Promise.resolve(null).then(le)}e.sequence=r;function b(W,$=j=>!!j,X=null){let j=0;const Q=W.length,le=()=>{if(j>=Q)return Promise.resolve(X);const ve=W[j++];return Promise.resolve(ve()).then(Fe=>$(Fe)?Promise.resolve(Fe):le())};return le()}e.first=b;function o(W,$=j=>!!j,X=null){if(W.length===0)return Promise.resolve(X);let j=W.length;const Q=()=>{j=-1;for(const le of W)le.cancel?.()};return new Promise((le,ve)=>{for(const ue of W)ue.then(Fe=>{--j>=0&&$(Fe)?(Q(),le(Fe)):j===0&&le(X)}).catch(Fe=>{--j>=0&&(Q(),ve(Fe))})})}e.firstParallel=o;class i{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((X,j)=>{this.outstandingPromises.push({factory:$,c:X,e:j}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const X=$.factory();X.then($.c,$.e),X.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class p extends i{constructor(){super(1)}}e.Queue=p;class c{constructor(){this.queues=new Map}queueFor($,X=t.extUri){const j=X.getComparisonKey($);let Q=this.queues.get(j);return Q||(Q=new p,E.Event.once(Q.onFinished)(()=>{Q?.dispose(),this.queues.delete(j)}),this.queues.set(j,Q)),Q}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=c;class u{constructor($,X){this._token=-1,typeof $=="function"&&typeof X=="number"&&this.setIfNotSet($,X)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,X){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},X)}setIfNotSet($,X){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},X))}}e.TimeoutTimer=u;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,X){this.cancel(),this._token=setInterval(()=>{$()},X)}}e.IntervalTimer=w;class f{constructor($,X){this.timeoutToken=-1,this.runner=$,this.timeout=X,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=f;class y{constructor($,X){X%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=X,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=y;class R extends f{constructor($,X){super($,X);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=R;class P extends T.Disposable{constructor($,X,j,Q){super();this.maxWorkChunkSize=$,this.maxPendingWork=X,this.throttleDelay=j,this.handler=Q,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.maxPendingWork)return!1}else if(this.pending+$.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new f(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=P,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{const $=setTimeout(()=>{const j=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0,clearTimeout($))}}}:e.runWhenIdle=(W,$)=>{const X=requestIdleCallback(W,typeof $=="number"?{timeout:$}:void 0);let j=!1;return{dispose(){j||(j=!0,cancelIdleCallback(X))}}}}();class B{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(X){this._error=X}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=B;async function L(W,$,X){let j;for(let Q=0;Q<X;Q++)try{return await W()}catch(le){j=le,await d($)}throw j}e.retry=L;class k{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,X,j){return this._pending={taskId:$,cancel:()=>j?.(),promise:X},X.then(()=>this.donePending($),()=>this.donePending($)),X}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let X,j;const Q=new Promise((le,ve)=>{X=le,j=ve});this._next={run:$,promise:Q,promiseResolve:X,promiseReject:j}}return this._next.promise}}e.TaskSequentializer=k;class x{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class N{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,X)=>{this.completeCallback=$,this.errorCallback=X})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(X=>{this.completeCallback($),this.resolved=!0,X()})}error($){return new Promise(X=>{this.errorCallback($),this.rejected=!0,X()})}cancel(){new Promise($=>{this.errorCallback((0,M.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=N;var V;(function(W){async function $(j){let Q;const le=await Promise.all(j.map(ve=>ve.then(ue=>ue,ue=>{Q||(Q=ue)})));if(typeof Q!="undefined")throw Q;return le}W.settled=$;function X(j){return new Promise(async(Q,le)=>{try{await j(Q,le)}catch(ve){le(ve)}})}W.withAsyncBody=X})(V=e.Promises||(e.Promises={}))}),define(be[107],Ee([0,1,13,17]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new l.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),T=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),t=new l.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(f,y,R=!1){const P=f||"",B=y||"",L=E.value.collator.compare(P,B);return E.value.collatorIsNumeric&&L===0&&P!==B?P<B?-1:1:L}e.compareFileNames=A;function D(f,y){const R=T.value.collator;return f=f||"",y=y||"",C(R,f,y)}e.compareFileNamesDefault=D;function I(f,y){const R=T.value.collator;return f=f||"",y=y||"",i(f,y)||C(R,f,y)}e.compareFileNamesUpper=I;function F(f,y){const R=T.value.collator;return f=f||"",y=y||"",o(f,y)||C(R,f,y)}e.compareFileNamesLower=F;function _(f,y){return f=f||"",y=y||"",f===y?0:f<y?-1:1}e.compareFileNamesUnicode=_;function n(f,y,R=!1){R||(f=f&&f.toLowerCase(),y=y&&y.toLowerCase());const[P,B]=s(f),[L,k]=s(y);return P!==L?P<L?-1:1:B===k?0:B<k?-1:1}e.noIntlCompareFileNames=n;function m(f,y){const[R,P]=s(f),[B,L]=s(y);let k=E.value.collator.compare(P,L);if(k===0){if(E.value.collatorIsNumeric&&P!==L)return P<L?-1:1;if(k=E.value.collator.compare(R,B),E.value.collatorIsNumeric&&k===0&&R!==B)return R<B?-1:1}return k}e.compareFileExtensions=m;function a(f,y){f=f||"",y=y||"";const R=d(f),P=d(y),B=T.value.collator,L=t.value.collator;return C(L,R,P)||C(B,f,y)}e.compareFileExtensionsDefault=a;function h(f,y){f=f||"",y=y||"";const R=d(f),P=d(y),B=T.value.collator,L=t.value.collator;return C(L,R,P)||i(f,y)||C(B,f,y)}e.compareFileExtensionsUpper=h;function g(f,y){f=f||"",y=y||"";const R=d(f),P=d(y),B=T.value.collator,L=t.value.collator;return C(L,R,P)||o(f,y)||C(B,f,y)}e.compareFileExtensionsLower=g;function S(f,y){f=f||"",y=y||"";const R=d(f).toLowerCase(),P=d(y).toLowerCase();return R!==P?R<P?-1:1:f!==y?f<y?-1:1:0}e.compareFileExtensionsUnicode=S;const v=/^(.*?)(\.([^.]*))?$/;function s(f,y=!1){const R=f?v.exec(f):[];let P=[R&&R[1]||"",R&&R[3]||""];return y&&(!P[0]&&P[1]||P[0]&&P[0].charAt(0)===".")&&(P=[P[0]+"."+P[1],""]),P}function d(f){const y=f?v.exec(f):[];return y&&y[1]&&y[1].charAt(0)!=="."&&y[3]||""}function C(f,y,R){let P=f.compare(y,R);return P!==0?P:y.length!==R.length?y.length<R.length?-1:1:0}function r(f){const y=f.charAt(0);return y.toLocaleUpperCase()!==y}function b(f){const y=f.charAt(0);return y.toLocaleLowerCase()!==y}function o(f,y){return r(f)&&b(y)?-1:b(f)&&r(y)?1:0}function i(f,y){return b(f)&&r(y)?-1:r(f)&&b(y)?1:0}function p(f,y,R=!1){return R||(f=f&&f.toLowerCase(),y=y&&y.toLowerCase()),f===y?0:f<y?-1:1}function c(f,y,R=!1){const P=f.split(M.sep),B=y.split(M.sep),L=P.length-1,k=B.length-1;let x,N;for(let V=0;;V++){if(x=L===V,N=k===V,x&&N)return A(P[V],B[V],R);if(x)return-1;if(N)return 1;const W=p(P[V],B[V],R);if(W!==0)return W}}e.comparePaths=c;function u(f,y,R){const P=f.toLowerCase(),B=y.toLowerCase(),L=w(f,y,R);if(L)return L;const k=P.endsWith(R),x=B.endsWith(R);if(k!==x)return k?-1:1;const N=A(P,B);return N!==0?N:P.localeCompare(B)}e.compareAnything=u;function w(f,y,R){const P=f.toLowerCase(),B=y.toLowerCase(),L=P.startsWith(R),k=B.startsWith(R);if(L!==k)return L?-1:1;if(L&&k){if(P.length<B.length)return-1;if(P.length>B.length)return 1}return 0}e.compareByPrefix=w}),define(be[29],Ee([0,1,13,44,20,17,9]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A;const D="**",I="/",F="[/\\\\]",_="[^/\\\\]",n=/\//g;function m(j){switch(j){case 0:return"";case 1:return`${_}*?`;default:return`(?:${F}|${_}+${F}|${F}${_}+)*?`}}function a(j,Q){if(!j)return[];const le=[];let ve=!1,ue=!1,Fe="";for(const Ke of j){switch(Ke){case Q:if(!ve&&!ue){le.push(Fe),Fe="";continue}break;case"{":ve=!0;break;case"}":ve=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Fe+=Ke}return Fe&&le.push(Fe),le}e.splitGlobAware=a;function h(j){if(!j)return"";let Q="";const le=a(j,I);if(le.every(ve=>ve===D))Q=".*";else{let ve=!1;le.forEach((ue,Fe)=>{if(ue===D){ve||(Q+=m(2),ve=!0);return}let Ke=!1,Oe="",He=!1,Je="";for(const Ye of ue){if(Ye!=="}"&&Ke){Oe+=Ye;continue}if(He&&(Ye!=="]"||!Je)){let Qe;Ye==="-"?Qe=Ye:(Ye==="^"||Ye==="!")&&!Je?Qe="^":Ye===I?Qe="":Qe=t.escapeRegExpCharacters(Ye),Je+=Qe;continue}switch(Ye){case"{":Ke=!0;continue;case"[":He=!0;continue;case"}":Q+=`(?:${a(Oe,",").map(K=>h(K)).join("|")})`,Ke=!1,Oe="";break;case"]":Q+="["+Je+"]",He=!1,Je="";break;case"?":Q+=_;continue;case"*":Q+=m(1);continue;default:Q+=t.escapeRegExpCharacters(Ye)}}Fe<le.length-1&&(le[Fe+1]!==D||Fe+2<le.length)&&(Q+=F),ve=!1})}return Q}const g=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,s=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new E.LRUCache(1e4),b=function(){return!1},o=function(){return null};function i(j,Q){if(!j)return o;let le;typeof j!="string"?le=j.pattern:le=j,le=le.trim();const ve=`${le}_${!!Q.trimForExclusions}`;let ue=r.get(ve);if(ue)return p(ue,j);let Fe;if(g.test(le)){const Ke=le.substr(4);ue=function(Oe,He){return typeof Oe=="string"&&Oe.endsWith(Ke)?le:null}}else(Fe=S.exec(c(le,Q)))?ue=u(Fe[1],le):(Q.trimForExclusions?s:v).test(le)?ue=w(le,Q):(Fe=d.exec(c(le,Q)))?ue=f(Fe[1].substr(1),le,!0):(Fe=C.exec(c(le,Q)))?ue=f(Fe[1],le,!1):ue=y(le);return r.set(ve,ue),p(ue,j)}function p(j,Q){return typeof Q=="string"?j:function(le,ve){return M.isEqualOrParent(le,Q.base)?j(T.relative(Q.base,le),ve):null}}function c(j,Q){return Q.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function u(j,Q){const le=`/${j}`,ve=`\\${j}`,ue=function(Ke,Oe){return typeof Ke!="string"?null:Oe?Oe===j?Q:null:Ke===j||Ke.endsWith(le)||Ke.endsWith(ve)?Q:null},Fe=[j];return ue.basenames=Fe,ue.patterns=[Q],ue.allBasenames=Fe,ue}function w(j,Q){const le=X(j.slice(1,-1).split(",").map(Oe=>i(Oe,Q)).filter(Oe=>Oe!==o),j),ve=le.length;if(!ve)return o;if(ve===1)return le[0];const ue=function(Oe,He){for(let Je=0,Ye=le.length;Je<Ye;Je++)if(le[Je](Oe,He))return j;return null},Fe=le.find(Oe=>!!Oe.allBasenames);Fe&&(ue.allBasenames=Fe.allBasenames);const Ke=le.reduce((Oe,He)=>He.allPaths?Oe.concat(He.allPaths):Oe,[]);return Ke.length&&(ue.allPaths=Ke),ue}function f(j,Q,le){const ve=T.sep===T.posix.sep,ue=ve?j:j.replace(n,T.sep),Fe=T.sep+ue,Ke=T.posix.sep+j,Oe=le?function(He,Je){return typeof He=="string"&&(He===ue||He.endsWith(Fe)||!ve&&(He===j||He.endsWith(Ke)))?Q:null}:function(He,Je){return typeof He=="string"&&(He===ue||!ve&&He===j)?Q:null};return Oe.allPaths=[(le?"*/":"./")+j],Oe}function y(j){try{const Q=new RegExp(`^${h(j)}$`);return function(le){return Q.lastIndex=0,typeof le=="string"&&Q.test(le)?j:null}}catch(Q){return o}}function R(j,Q,le){return!j||typeof Q!="string"?!1:P(j)(Q,void 0,le)}e.match=R;function P(j,Q={}){if(!j)return b;if(typeof j=="string"||x(j)){const le=i(j,Q);if(le===o)return b;const ve=function(ue,Fe){return!!le(ue,Fe)};return le.allBasenames&&(ve.allBasenames=le.allBasenames),le.allPaths&&(ve.allPaths=le.allPaths),ve}return W(j,Q)}e.parse=P;function B(j){if(!j)return;let Q;return le=>(Q||(Q=(j()||Promise.resolve([])).then(ve=>ve?k(ve):{})),Q.then(ve=>!!ve[le]))}e.hasSiblingPromiseFn=B;function L(j){if(!j)return;let Q;return le=>{if(!Q){const ve=j();Q=ve?k(ve):{}}return!!Q[le]}}e.hasSiblingFn=L;function k(j){const Q={};for(const le of j)Q[le]=!0;return Q}function x(j){const Q=j;return Q&&typeof Q.base=="string"&&typeof Q.pattern=="string"}e.isRelativePattern=x;function N(j){return j.allBasenames||[]}e.getBasenameTerms=N;function V(j){return j.allPaths||[]}e.getPathTerms=V;function W(j,Q){const le=X(Object.getOwnPropertyNames(j).map(Oe=>$(Oe,j[Oe],Q)).filter(Oe=>Oe!==o)),ve=le.length;if(!ve)return o;if(!le.some(Oe=>!!Oe.requiresSiblings)){if(ve===1)return le[0];const Oe=function(Ye,Qe){for(let z=0,K=le.length;z<K;z++){const Z=le[z](Ye,Qe);if(Z)return Z}return null},He=le.find(Ye=>!!Ye.allBasenames);He&&(Oe.allBasenames=He.allBasenames);const Je=le.reduce((Ye,Qe)=>Qe.allPaths?Ye.concat(Qe.allPaths):Ye,[]);return Je.length&&(Oe.allPaths=Je),Oe}const ue=function(Oe,He,Je){let Ye;for(let Qe=0,z=le.length;Qe<z;Qe++){const K=le[Qe];K.requiresSiblings&&Je&&(He||(He=T.basename(Oe)),Ye||(Ye=He.substr(0,He.length-T.extname(Oe).length)));const Z=K(Oe,He,Ye,Je);if(Z)return Z}return null},Fe=le.find(Oe=>!!Oe.allBasenames);Fe&&(ue.allBasenames=Fe.allBasenames);const Ke=le.reduce((Oe,He)=>He.allPaths?Oe.concat(He.allPaths):Oe,[]);return Ke.length&&(ue.allPaths=Ke),ue}function $(j,Q,le){if(Q===!1)return o;const ve=i(j,le);if(ve===o)return o;if(typeof Q=="boolean")return ve;if(Q){const ue=Q.when;if(typeof ue=="string"){const Fe=(Ke,Oe,He,Je)=>{if(!Je||!ve(Ke,Oe))return null;const Ye=ue.replace("$(basename)",He),Qe=Je(Ye);return(0,l.isThenable)(Qe)?Qe.then(z=>z?j:null):Qe?j:null};return Fe.requiresSiblings=!0,Fe}}return ve}function X(j,Q){const le=j.filter(Oe=>!!Oe.basenames);if(le.length<2)return j;const ve=le.reduce((Oe,He)=>{const Je=He.basenames;return Je?Oe.concat(Je):Oe},[]);let ue;if(Q){ue=[];for(let Oe=0,He=ve.length;Oe<He;Oe++)ue.push(Q)}else ue=le.reduce((Oe,He)=>{const Je=He.patterns;return Je?Oe.concat(Je):Oe},[]);const Fe=function(Oe,He){if(typeof Oe!="string")return null;if(!He){let Ye;for(Ye=Oe.length;Ye>0;Ye--){const Qe=Oe.charCodeAt(Ye-1);if(Qe===47||Qe===92)break}He=Oe.substr(Ye)}const Je=ve.indexOf(He);return Je!==-1?ue[Je]:null};Fe.basenames=ve,Fe.patterns=ue,Fe.allBasenames=ve;const Ke=j.filter(Oe=>!Oe.basenames);return Ke.push(Fe),Ke}}),define(be[78],Ee([0,1,44,11,17,25,24,9,2]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function I(i,p,c){if(typeof i=="string"&&(i=D.URI.file(i)),c){const w=c.getWorkspaceFolder(i);if(w){const f=c.getWorkspace().folders.length>1;let y;if((0,t.isEqual)(w.uri,i)?y="":y=(0,t.relativePath)(w.uri,i),f){const R=w.name?w.name:(0,t.basename)(w.uri);y=y?R+" \u2022 "+y:R}return y}}if(i.scheme!==M.Schemas.file&&i.scheme!==M.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,l.hasDriveLetter)(i.fsPath))return(0,E.normalize)(_(i.fsPath));let u=(0,E.normalize)(i.fsPath);return!T.isWindows&&p?.userHome&&(u=m(u,p.userHome.fsPath)),u}e.getPathLabel=I;function F(i){if(!i)return;typeof i=="string"&&(i=D.URI.file(i));const p=(0,t.basename)(i)||(i.scheme===M.Schemas.file?i.fsPath:i.path);return T.isWindows&&(0,l.isRootOrDriveLetter)(p)?_(p):p}e.getBaseLabel=F;function _(i,p){return(0,l.hasDriveLetter)(i,p)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=_;let n=Object.create(null);function m(i,p){if(T.isWindows||!i||!p)return i;let c=n.original===p?n.normalized:void 0;return c||(c=`${(0,A.rtrim)(p,E.posix.sep)}${E.posix.sep}`,n={original:p,normalized:c}),(T.isLinux?i.startsWith(c):(0,A.startsWithIgnoreCase)(i,c))&&(i=`~/${i.substr(c.length)}`),i}e.tildify=m;function a(i,p){return i.replace(/^~($|\/|\\)/,`${p}$1`)}e.untildify=a;const h="\u2026",g="\\\\",S="~";function v(i,p=E.sep){const c=new Array(i.length);let u=!1;for(let w=0;w<i.length;w++){let f=i[w];if(f===""){c[w]=`.${p}`;continue}if(!f){c[w]=f;continue}u=!0;let y="";f.indexOf(g)===0?(y=f.substr(0,f.indexOf(g)+g.length),f=f.substr(f.indexOf(g)+g.length)):f.indexOf(p)===0?(y=f.substr(0,f.indexOf(p)+p.length),f=f.substr(f.indexOf(p)+p.length)):f.indexOf(S)===0&&(y=f.substr(0,f.indexOf(S)+S.length),f=f.substr(f.indexOf(S)+S.length));const R=f.split(p);for(let P=1;u&&P<=R.length;P++)for(let B=R.length-P;u&&B>=0;B--){u=!1;let L=R.slice(B,B+P).join(p);for(let k=0;!u&&k<i.length;k++)if(k!==w&&i[k]&&i[k].indexOf(L)>-1){const x=B+P===R.length,N=B>0&&i[k].indexOf(p)>-1?p+L:L,V=i[k].endsWith(N);u=!x||V}if(!u){let k="";(R[0].endsWith(":")||y!=="")&&(B===1&&(B=0,P++,L=R[0]+p+L),B>0&&(k=R[0]+p),k=y+k),B>0&&(k=k+h+p),k=k+L,B+P<R.length&&(k=k+p+h),c[w]=k}}u&&(c[w]=f)}return c}e.shorten=v;var s;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(s||(s={}));function d(i,p=Object.create(null)){const c=[];let u=!1,w="";for(const f of i)if(f==="$"||u&&f==="{")w&&c.push({value:w,type:s.TEXT}),w="",u=!0;else if(f==="}"&&u){const y=p[w];if(typeof y=="string")y.length&&c.push({value:y,type:s.VARIABLE});else if(y){const R=c[c.length-1];(!R||R.type!==s.SEPARATOR)&&c.push({value:y.label,type:s.SEPARATOR})}w="",u=!1}else w+=f;return w&&!u&&c.push({value:w,type:s.TEXT}),c.filter((f,y)=>{if(f.type===s.SEPARATOR){const R=c[y-1],P=c[y+1];return[R,P].every(B=>B&&(B.type===s.VARIABLE||B.type===s.TEXT)&&B.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=d;function C(i,p){return T.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.isMacintosh?"&":"&&"):i.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function r(i,p){return T.isMacintosh||p?i.replace(/\(&&\w\)|&&/g,""):T.isWindows?i.replace(/&&|&/g,c=>c==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=r;function b(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=b;function o(i){const p=i.indexOf("/")!==-1?E.posix:E.win32,c=p.basename(i),u=p.dirname(i);return c.length?{name:c,parentPath:u}:{name:u,parentPath:""}}e.splitName=o}),define(be[79],Ee([0,1,29,11,17,24,9]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var A;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(A=e.Mimes||(e.Mimes={}));let D=[],I=[],F=[];function _(i,p=!1){const c=n(i);D.push(c),c.userConfigured?F.push(c):I.push(c),p&&!c.userConfigured&&D.forEach(u=>{u.mime===c.mime||u.userConfigured||(c.extension&&u.extension===c.extension&&console.warn(`Overwriting extension <<${c.extension}>> to now point to mime <<${c.mime}>>`),c.filename&&u.filename===c.filename&&console.warn(`Overwriting filename <<${c.filename}>> to now point to mime <<${c.mime}>>`),c.filepattern&&u.filepattern===c.filepattern&&console.warn(`Overwriting filepattern <<${c.filepattern}>> to now point to mime <<${c.mime}>>`),c.firstline&&u.firstline===c.firstline&&console.warn(`Overwriting firstline <<${c.firstline}>> to now point to mime <<${c.mime}>>`))})}e.registerTextMime=_;function n(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,l.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(E.posix.sep)>=0:!1}}function m(i){i?(D=D.filter(p=>!p.userConfigured),F=[]):(D=[],I=[],F=[])}e.clearTextMimes=m;function a(i,p){let c;if(i)switch(i.scheme){case M.Schemas.file:c=i.fsPath;break;case M.Schemas.data:c=T.DataUri.parseMetaData(i).get(T.DataUri.META_DATA_LABEL);break;default:c=i.path}if(!c)return[A.unknown];c=c.toLowerCase();const u=(0,E.basename)(c),w=h(c,u,F);if(w)return[w,A.text];const f=h(c,u,I);if(f)return[f,A.text];if(p){const y=g(p);if(y)return[y,A.text]}return[A.unknown]}e.guessMimeTypes=a;function h(i,p,c){let u=null,w=null,f=null;for(let y=c.length-1;y>=0;y--){const R=c[y];if(p===R.filenameLowercase){u=R;break}if(R.filepattern&&(!w||R.filepattern.length>w.filepattern.length)){const P=R.filepatternOnPath?i:p;R.filepatternLowercase?.(P)&&(w=R)}R.extension&&(!f||R.extension.length>f.extension.length)&&p.endsWith(R.extensionLowercase)&&(f=R)}return u?u.mime:w?w.mime:f?f.mime:null}function g(i){if((0,t.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let p=D.length-1;p>=0;p--){const c=D[p];if(!c.firstline)continue;const u=i.match(c.firstline);if(u&&u.length>0)return c.mime}return null}function S(i){return i?typeof i=="string"?i===A.binary||i===A.text||i===A.unknown:i.length===1&&S(i[0]):!0}e.isUnspecific=S;const v={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},s={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function d(i){const p=(0,E.extname)(i),c=v[p.toLowerCase()];return c!==void 0?c:C(i)}e.getMediaOrTextMime=d;function C(i){const p=(0,E.extname)(i);return s[p.toLowerCase()]}e.getMediaMime=C;function r(i){for(const p in s)if(s[p]===i)return p}e.getExtensionForMimeType=r;const b=/^(.+)\/(.+?)(;.+)?$/;function o(i,p){const c=b.exec(i);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:p?void 0:i}e.normalizeMimeType=o}),define(be[108],Ee([0,1,2]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function M(F){return F.toJSON()}class E{constructor(_){this._uriTransformer=_}transformIncoming(_){const n=this._uriTransformer.transformIncoming(_);return n===_?_:M(l.URI.from(n))}transformOutgoing(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:M(l.URI.from(n))}transformOutgoingURI(_){const n=this._uriTransformer.transformOutgoing(_);return n===_?_:l.URI.from(n)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(F){return F}transformOutgoing(F){return F}transformOutgoingURI(F){return F}transformOutgoingScheme(F){return F}};function T(F,_,n){if(!F||n>200)return null;if(typeof F=="object"){if(F instanceof l.URI)return _.transformOutgoing(F);for(let m in F)if(Object.hasOwnProperty.call(F,m)){const a=T(F[m],_,n+1);a!==null&&(F[m]=a)}}return null}function t(F,_){const n=T(F,_,0);return n===null?F:n}e.transformOutgoingURIs=t;function A(F,_,n,m){if(!F||m>200)return null;if(typeof F=="object"){if(F.$mid===1)return n?l.URI.revive(_.transformIncoming(F)):_.transformIncoming(F);for(let a in F)if(Object.hasOwnProperty.call(F,a)){const h=A(F[a],_,n,m+1);h!==null&&(F[a]=h)}}return null}function D(F,_){const n=A(F,_,!1,0);return n===null?F:n}e.transformIncomingURIs=D;function I(F,_){const n=A(F,_,!0,0);return n===null?F:n}e.transformAndReviveIncomingURIs=I}),define(be[37],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(D){return l.test(D)}e.isUUID=M;const E=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));let t;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?t=crypto.getRandomValues.bind(crypto):t=function(D){for(let I=0;I<D.length;I++)D[I]=Math.floor(Math.random()*256);return D};function A(){t(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let D=0,I="";return I+=T[E[D++]],I+=T[E[D++]],I+=T[E[D++]],I+=T[E[D++]],I+="-",I+=T[E[D++]],I+=T[E[D++]],I+="-",I+=T[E[D++]],I+=T[E[D++]],I+="-",I+=T[E[D++]],I+=T[E[D++]],I+="-",I+=T[E[D++]],I+=T[E[D++]],I+=T[E[D++]],I+=T[E[D++]],I+=T[E[D++]],I+=T[E[D++]],I}e.generateUuid=A}),define(be[109],Ee([0,1,231]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var M;(function(t){t[t.Regular=0]="Regular",t[t.Whitespace=1]="Whitespace",t[t.WordSeparator=2]="WordSeparator"})(M=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends l.CharacterClassifier{constructor(A){super(0);for(let D=0,I=A.length;D<I;D++)this.set(A.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function T(t){let A={};return D=>(A.hasOwnProperty(D)||(A[D]=t(D)),A[D])}e.getMapForWordSeparators=T(t=>new E(t))}),define(be[80],Ee([0,1,23]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.IndentGuideHorizontalLine=e.IndentGuide=e.HorizontalGuidesState=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var M;(function(v){v[v.Left=1]="Left",v[v.Center=2]="Center",v[v.Right=4]="Right",v[v.Full=7]="Full"})(M=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(v){v[v.Inline=1]="Inline",v[v.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var T;(function(v){v[v.TextDefined=0]="TextDefined",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(T=e.EndOfLinePreference||(e.EndOfLinePreference={}));var t;(function(v){v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(t=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(v){v[v.LF=0]="LF",v[v.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),this.indentSize=s.tabSize|0,this.insertSpaces=Boolean(s.insertSpaces),this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=Boolean(s.trimAutoWhitespace),this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,l.equals)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class I{constructor(s,d){this._findMatchBrand=void 0,this.range=s,this.matches=d}}e.FindMatch=I;var F;(function(v){v[v.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",v[v.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",v[v.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",v[v.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(F=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(v){v[v.Disabled=0]="Disabled",v[v.EnabledForActive=1]="EnabledForActive",v[v.Enabled=2]="Enabled"})(_=e.HorizontalGuidesState||(e.HorizontalGuidesState={}));class n{constructor(s,d,C){this.visibleColumn=s,this.className=d,this.horizontalLine=C}}e.IndentGuide=n;class m{constructor(s,d){this.top=s,this.endColumn=d}}e.IndentGuideHorizontalLine=m;var a;(function(v){v[v.Left=0]="Left",v[v.Right=1]="Right",v[v.None=2]="None"})(a=e.PositionAffinity||(e.PositionAffinity={}));var h;(function(v){v[v.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(h=e.ModelConstants||(e.ModelConstants={}));class g{constructor(s,d,C,r,b,o){this.identifier=s,this.range=d,this.text=C,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=b,this._isTracked=o}}e.ValidAnnotatedEditOperation=g;class S{constructor(s,d,C){this.reverseEdits=s,this.changes=d,this.trimAutoWhitespaceLineNumbers=C}}e.ApplyEditsResult=S}),define(be[110],Ee([0,1,9,109,111,45,80]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class D{constructor(s,d,C,r){this.searchString=s,this.isRegex=d,this.matchCase=C,this.wordSeparators=r}parseSearchRequest(){if(this.searchString==="")return null;let s;this.isRegex?s=I(this.searchString):s=this.searchString.indexOf(`
`)>=0;let d=null;try{d=l.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:s,global:!0,unicode:!0})}catch(r){return null}if(!d)return null;let C=!this.isRegex&&!s;return C&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(C=this.matchCase),new F(d,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,C?this.searchString:null)}}e.SearchParams=D;function I(v){if(!v||v.length===0)return!1;for(let s=0,d=v.length;s<d;s++)if(v.charCodeAt(s)===92){if(s++,s>=d)break;const r=v.charCodeAt(s);if(r===110||r===114||r===87)return!0}return!1}e.isMultilineRegexSource=I;class F{constructor(s,d,C){this.regex=s,this.wordSeparators=d,this.simpleSearch=C}}e.SearchData=F;function _(v,s,d){if(!d)return new t.FindMatch(v,null);let C=[];for(let r=0,b=s.length;r<b;r++)C[r]=s[r];return new t.FindMatch(v,C)}e.createFindMatch=_;class n{constructor(s){let d=[],C=0;for(let r=0,b=s.length;r<b;r++)s.charCodeAt(r)===10&&(d[C++]=r);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(s){const d=this._lineFeedsOffsets;let C=0,r=d.length-1;if(r===-1||s<=d[0])return 0;for(;C<r;){const b=C+((r-C)/2>>0);d[b]>=s?r=b-1:d[b+1]>=s?(C=b,r=b):C=b+1}return C+1}}class m{static findMatches(s,d,C,r,b){const o=d.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(s,C,new S(o.wordSeparators,o.regex),r,b):this._doFindMatchesLineByLine(s,C,o,r,b):[]}static _getMultilineMatchRange(s,d,C,r,b,o){let i,p=0;r?(p=r.findLineFeedCountBeforeOffset(b),i=d+b+p):i=d+b;let c;if(r){let y=r.findLineFeedCountBeforeOffset(b+o.length)-p;c=i+o.length+y}else c=i+o.length;const u=s.getPositionAt(i),w=s.getPositionAt(c);return new T.Range(u.lineNumber,u.column,w.lineNumber,w.column)}static _doFindMatchesMultiline(s,d,C,r,b){const o=s.getOffsetAt(d.getStartPosition()),i=s.getValueInRange(d,1),p=s.getEOL()===`\r
`?new n(i):null,c=[];let u=0,w;for(C.reset(0);w=C.next(i);)if(c[u++]=_(this._getMultilineMatchRange(s,o,i,p,w.index,w[0]),w,r),u>=b)return c;return c}static _doFindMatchesLineByLine(s,d,C,r,b){const o=[];let i=0;if(d.startLineNumber===d.endLineNumber){const c=s.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return i=this._findMatchesInLine(C,c,d.startLineNumber,d.startColumn-1,i,o,r,b),o}const p=s.getLineContent(d.startLineNumber).substring(d.startColumn-1);i=this._findMatchesInLine(C,p,d.startLineNumber,d.startColumn-1,i,o,r,b);for(let c=d.startLineNumber+1;c<d.endLineNumber&&i<b;c++)i=this._findMatchesInLine(C,s.getLineContent(c),c,0,i,o,r,b);if(i<b){const c=s.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);i=this._findMatchesInLine(C,c,d.endLineNumber,0,i,o,r,b)}return o}static _findMatchesInLine(s,d,C,r,b,o,i,p){const c=s.wordSeparators;if(!i&&s.simpleSearch){const f=s.simpleSearch,y=f.length,R=d.length;let P=-y;for(;(P=d.indexOf(f,P+y))!==-1;)if((!c||g(c,d,R,P,y))&&(o[b++]=new t.FindMatch(new T.Range(C,P+1+r,C,P+1+y+r),null),b>=p))return b;return b}const u=new S(s.wordSeparators,s.regex);let w;u.reset(0);do if(w=u.next(d),w&&(o[b++]=_(new T.Range(C,w.index+1+r,C,w.index+1+w[0].length+r),w,i),b>=p))return b;while(w);return b}static findNextMatch(s,d,C,r){const b=d.parseSearchRequest();if(!b)return null;const o=new S(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindNextMatchMultiline(s,C,o,r):this._doFindNextMatchLineByLine(s,C,o,r)}static _doFindNextMatchMultiline(s,d,C,r){const b=new E.Position(d.lineNumber,1),o=s.getOffsetAt(b),i=s.getLineCount(),p=s.getValueInRange(new T.Range(b.lineNumber,b.column,i,s.getLineMaxColumn(i)),1),c=s.getEOL()===`\r
`?new n(p):null;C.reset(d.column-1);let u=C.next(p);return u?_(this._getMultilineMatchRange(s,o,p,c,u.index,u[0]),u,r):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(s,new E.Position(1,1),C,r):null}static _doFindNextMatchLineByLine(s,d,C,r){const b=s.getLineCount(),o=d.lineNumber,i=s.getLineContent(o),p=this._findFirstMatchInLine(C,i,o,d.column,r);if(p)return p;for(let c=1;c<=b;c++){const u=(o+c-1)%b,w=s.getLineContent(u+1),f=this._findFirstMatchInLine(C,w,u+1,1,r);if(f)return f}return null}static _findFirstMatchInLine(s,d,C,r,b){s.reset(r-1);const o=s.next(d);return o?_(new T.Range(C,o.index+1,C,o.index+1+o[0].length),o,b):null}static findPreviousMatch(s,d,C,r){const b=d.parseSearchRequest();if(!b)return null;const o=new S(b.wordSeparators,b.regex);return b.regex.multiline?this._doFindPreviousMatchMultiline(s,C,o,r):this._doFindPreviousMatchLineByLine(s,C,o,r)}static _doFindPreviousMatchMultiline(s,d,C,r){const b=this._doFindMatchesMultiline(s,new T.Range(1,1,d.lineNumber,d.column),C,r,10*A);if(b.length>0)return b[b.length-1];const o=s.getLineCount();return d.lineNumber!==o||d.column!==s.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(s,new E.Position(o,s.getLineMaxColumn(o)),C,r):null}static _doFindPreviousMatchLineByLine(s,d,C,r){const b=s.getLineCount(),o=d.lineNumber,i=s.getLineContent(o).substring(0,d.column-1),p=this._findLastMatchInLine(C,i,o,r);if(p)return p;for(let c=1;c<=b;c++){const u=(b+o-c-1)%b,w=s.getLineContent(u+1),f=this._findLastMatchInLine(C,w,u+1,r);if(f)return f}return null}static _findLastMatchInLine(s,d,C,r){let b=null,o;for(s.reset(0);o=s.next(d);)b=_(new T.Range(C,o.index+1,C,o.index+1+o[0].length),o,r);return b}}e.TextModelSearch=m;function a(v,s,d,C,r){if(C===0)return!0;const b=s.charCodeAt(C-1);if(v.get(b)!==0||b===13||b===10)return!0;if(r>0){const o=s.charCodeAt(C);if(v.get(o)!==0)return!0}return!1}function h(v,s,d,C,r){if(C+r===d)return!0;const b=s.charCodeAt(C+r);if(v.get(b)!==0||b===13||b===10)return!0;if(r>0){const o=s.charCodeAt(C+r-1);if(v.get(o)!==0)return!0}return!1}function g(v,s,d,C,r){return a(v,s,d,C,r)&&h(v,s,d,C,r)}e.isValidMatch=g;class S{constructor(s,d){this._wordSeparators=s,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(s){this._searchRegex.lastIndex=s,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(s){const d=s.length;let C;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(C=this._searchRegex.exec(s),!C))return null;const r=C.index,b=C[0].length;if(r===this._prevMatchStartIndex&&b===this._prevMatchLength){if(b===0){l.getNextCodePoint(s,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=r,this._prevMatchLength=b,!this._wordSeparators||g(this._wordSeparators,s,d,r,b))return C}while(C);return null}}e.Searcher=S}),define(be[112],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var l;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(l=e.IndentAction||(e.IndentAction={}));class M{constructor(A){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=A.open,this.close=A.close,this._standardTokenMask=0,Array.isArray(A.notIn))for(let D=0,I=A.notIn.length;D<I;D++)switch(A.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(A){return(this._standardTokenMask&A)==0}}e.StandardAutoClosingPairConditional=M;class E{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of A)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=E;function T(t,A,D){t.has(A)?t.get(A).push(D):t.set(A,[D])}}),define(be[58],Ee([0,1,29,17]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(T,t,A,D){if(Array.isArray(T)){let I=0;for(const F of T){const _=E(F,t,A,D);if(_===10)return _;_>I&&(I=_)}return I}else{if(typeof T=="string")return D?T==="*"?5:T===A?10:0:0;if(T){const{language:I,pattern:F,scheme:_,hasAccessToAllModels:n}=T;if(!D&&!n)return 0;let m=0;if(_)if(_===t.scheme)m=10;else if(_==="*")m=5;else return 0;if(I)if(I===A)m=10;else if(I==="*")m=Math.max(m,5);else return 0;if(F){let a;if(typeof F=="string"?a=F:a={...F,base:(0,M.normalize)(F.base)},a===t.fsPath||(0,l.match)(a,t.fsPath))m=10;else return 0}return m}else return 0}}e.score=E}),define(be[113],Ee([0,1,3,6]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new l.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(t){this._onDidChange.fire({changedLanguages:t,changedColorMap:!1})}register(t,A){return this._map.set(t,A),this.fire([t]),(0,M.toDisposable)(()=>{this._map.get(t)===A&&(this._map.delete(t),this.fire([t]))})}registerPromise(t,A){let D=null,I=!1;return this._promises.set(t,A.then(F=>{this._promises.delete(t),!(I||!F)&&(D=this.register(t,F))})),(0,M.toDisposable)(()=>{I=!0,D&&D.dispose()})}getPromise(t){const A=this.get(t);if(A)return Promise.resolve(A);const D=this._promises.get(t);return D?D.then(I=>this.get(t)):null}get(t){return this._map.get(t)||null}setColorMap(t){this._colorMap=t,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(be[81],Ee([0,1,22,25]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(E||(E={}));function T(_){for(let n=0,m=_.length;n<m;n+=4){const a=_[n+0],h=_[n+1],g=_[n+2],S=_[n+3];_[n+0]=S,_[n+1]=g,_[n+2]=h,_[n+3]=a}}function t(_){const n=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return M.isLittleEndian()||T(n),l.VSBuffer.wrap(n)}function A(_){const n=_.buffer;if(M.isLittleEndian()||T(n),n.byteOffset%4==0)return new Uint32Array(n.buffer,n.byteOffset,n.length/4);{const m=new Uint8Array(n.byteLength);return m.set(n),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function D(_){const n=new Uint32Array(I(_));let m=0;if(n[m++]=_.id,_.type==="full")n[m++]=1,n[m++]=_.data.length,n.set(_.data,m),m+=_.data.length;else{n[m++]=2,n[m++]=_.deltas.length;for(const a of _.deltas)n[m++]=a.start,n[m++]=a.deleteCount,a.data?(n[m++]=a.data.length,n.set(a.data,m),m+=a.data.length):n[m++]=0}return t(n)}e.encodeSemanticTokensDto=D;function I(_){let n=0;if(n+=1+1,_.type==="full")n+=1+_.data.length;else{n+=1,n+=(1+1+1)*_.deltas.length;for(const m of _.deltas)m.data&&(n+=m.data.length)}return n}function F(_){const n=A(_);let m=0;const a=n[m++];if(n[m++]===1){const v=n[m++],s=n.subarray(m,m+v);return m+=v,{id:a,type:"full",data:s}}const g=n[m++];let S=[];for(let v=0;v<g;v++){const s=n[m++],d=n[m++],C=n[m++];let r;C>0&&(r=n.subarray(m,m+C),m+=C),S[v]={start:s,deleteCount:d,data:r}}return{id:a,type:"delta",deltas:S}}e.decodeSemanticTokensDto=F}),define(be[114],Ee([18,19]),function(re,e){return re.create("vs/base/common/date",e)}),define(be[115],Ee([0,1,114]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,E=M*60,T=E*24,t=T*7,A=T*30,D=T*365;function I(_,n){typeof _!="number"&&(_=_.getTime());const m=Math.round((new Date().getTime()-_)/1e3);if(m<-30)return(0,l.localize)(0,null,I(new Date().getTime()+m*1e3,!1));if(m<30)return(0,l.localize)(1,null);let a;return m<M?(a=m,n?a===1?(0,l.localize)(2,null,a):(0,l.localize)(3,null,a):a===1?(0,l.localize)(4,null,a):(0,l.localize)(5,null,a)):m<E?(a=Math.floor(m/M),n?a===1?(0,l.localize)(6,null,a):(0,l.localize)(7,null,a):a===1?(0,l.localize)(8,null,a):(0,l.localize)(9,null,a)):m<T?(a=Math.floor(m/E),n?a===1?(0,l.localize)(10,null,a):(0,l.localize)(11,null,a):a===1?(0,l.localize)(12,null,a):(0,l.localize)(13,null,a)):m<t?(a=Math.floor(m/T),n?a===1?(0,l.localize)(14,null,a):(0,l.localize)(15,null,a):a===1?(0,l.localize)(16,null,a):(0,l.localize)(17,null,a)):m<A?(a=Math.floor(m/t),n?a===1?(0,l.localize)(18,null,a):(0,l.localize)(19,null,a):a===1?(0,l.localize)(20,null,a):(0,l.localize)(21,null,a)):m<D?(a=Math.floor(m/A),n?a===1?(0,l.localize)(22,null,a):(0,l.localize)(23,null,a):a===1?(0,l.localize)(24,null,a):(0,l.localize)(25,null,a)):(a=Math.floor(m/D),n?a===1?(0,l.localize)(26,null,a):(0,l.localize)(27,null,a):a===1?(0,l.localize)(28,null,a):(0,l.localize)(29,null,a))}e.fromNow=I;function F(_){return _.getFullYear()+"-"+String(_.getMonth()+1).padStart(2,"0")+"-"+String(_.getDate()).padStart(2,"0")+"T"+String(_.getHours()).padStart(2,"0")+":"+String(_.getMinutes()).padStart(2,"0")+":"+String(_.getSeconds()).padStart(2,"0")+"."+(_.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=F}),define(be[116],Ee([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(be[46],Ee([0,1,15,10,116]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(I,F){return F&&(I.stack||I.stacktrace)?E.localize(0,null,A(I),t(I.stack)||t(I.stacktrace)):A(I)}function t(I){return Array.isArray(I)?I.join(`
`):I}function A(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?E.localize(1,null,I.message):I.message||E.localize(2,null)}function D(I=null,F=!1){if(!I)return E.localize(3,null);if(Array.isArray(I)){const _=l.coalesce(I),n=D(_[0],F);return _.length>1?E.localize(4,null,n,_.length):n}if(M.isString(I))return I;if(I.detail){const _=I.detail;if(_.error)return T(_.error,F);if(_.exception)return T(_.exception,F)}return I.stack?T(I,F):I.message?I.message:E.localize(5,null)}e.toErrorMessage=D}),define(be[117],Ee([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(be[118],Ee([0,1,117,25,119]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(q){q[q.None=0]="None",q[q.Keep=1]="Keep",q[q.Brackets=2]="Brackets",q[q.Advanced=3]="Advanced",q[q.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class t{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=t;class A{constructor(){this._values=[]}_read(J){return this._values[J]}get(J){return this._values[J]}_write(J,pe){this._values[J]=pe}}e.ValidatedEditorOptions=A;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class I{constructor(J,pe,$e,qe){this.id=J,this.name=pe,this.defaultValue=$e,this.schema=qe}compute(J,pe,$e){return $e}}class F{constructor(J,pe=null){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(J){return this.defaultValue}}class _{constructor(J,pe,$e,qe){this.id=J,this.name=pe,this.defaultValue=$e,this.schema=qe}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,pe,$e){return $e}}function n(q,J){return typeof q=="undefined"?J:q==="false"?!1:Boolean(q)}e.boolean=n;class m extends _{constructor(J,pe,$e,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=$e),super(J,pe,$e,qe)}validate(J){return n(J,this.defaultValue)}}function a(q,J,pe,$e){if(typeof q=="undefined")return J;let qe=parseInt(q,10);return isNaN(qe)?J:(qe=Math.max(pe,qe),qe=Math.min($e,qe),qe|0)}e.clampedInt=a;class h extends _{constructor(J,pe,$e,qe,rt,ft=void 0){typeof ft!="undefined"&&(ft.type="integer",ft.default=$e,ft.minimum=qe,ft.maximum=rt),super(J,pe,$e,ft),this.minimum=qe,this.maximum=rt}static clampedInt(J,pe,$e,qe){return a(J,pe,$e,qe)}validate(J){return h.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class g extends _{constructor(J,pe,$e,qe,rt){typeof rt!="undefined"&&(rt.type="number",rt.default=$e),super(J,pe,$e,rt),this.validationFn=qe}static clamp(J,pe,$e){return J<pe?pe:J>$e?$e:J}static float(J,pe){if(typeof J=="number")return J;if(typeof J=="undefined")return pe;const $e=parseFloat(J);return isNaN($e)?pe:$e}validate(J){return this.validationFn(g.float(J,this.defaultValue))}}class S extends _{static string(J,pe){return typeof J!="string"?pe:J}constructor(J,pe,$e,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=$e),super(J,pe,$e,qe)}validate(J){return S.string(J,this.defaultValue)}}function v(q,J,pe){return typeof q!="string"||pe.indexOf(q)===-1?J:q}e.stringSet=v;class s extends _{constructor(J,pe,$e,qe,rt=void 0){typeof rt!="undefined"&&(rt.type="string",rt.enum=qe,rt.default=$e),super(J,pe,$e,rt),this._allowedValues=qe}validate(J){return v(J,this.defaultValue,this._allowedValues)}}class d extends I{constructor(J,pe,$e,qe,rt,ft,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=rt,ht.default=qe),super(J,pe,$e,ht),this._allowedValues=rt,this._convert=ft}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function C(q){switch(q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",description:l.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,pe,$e){return $e===0?J.accessibilitySupport:$e}}class b extends I{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:l.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{insertSpace:n(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(q){q[q.Hidden=0]="Hidden",q[q.Blink=1]="Blink",q[q.Smooth=2]="Smooth",q[q.Phase=3]="Phase",q[q.Expand=4]="Expand",q[q.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function i(q){switch(q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(q){q[q.Line=1]="Line",q[q.Block=2]="Block",q[q.Underline=3]="Underline",q[q.LineThin=4]="LineThin",q[q.BlockOutline=5]="BlockOutline",q[q.UnderlineThin=6]="UnderlineThin"})(p=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function c(q){switch(q){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=c;function u(q){switch(q){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class w extends F{constructor(){super(126,[65,33])}compute(J,pe,$e){const qe=["monaco-editor"];return pe.get(33)&&qe.push(pe.get(33)),J.extraEditorClassName&&qe.push(J.extraEditorClassName),pe.get(65)==="default"?qe.push("mouse-default"):pe.get(65)==="copy"&&qe.push("mouse-copy"),pe.get(99)&&qe.push("showUnused"),pe.get(124)&&qe.push("showDeprecated"),qe.join(" ")}}class f extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(J,pe,$e){return $e&&J.emptySelectionClipboard}}class y extends I{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:l.localize(16,null),included:M.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:l.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{cursorMoveOnType:n(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":v(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":v(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(pe.loop,this.defaultValue.loop)}}}class R extends I{constructor(){super(44,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?R.OFF:J==="true"?R.ON:J:Boolean(J)?R.ON:R.OFF}}e.EditorFontLigatures=R,R.OFF='"liga" off, "calt" off',R.ON='"liga" on, "calt" on';class P extends F{constructor(){super(43)}compute(J,pe,$e){return J.fontInfo}}class B extends _{constructor(){super(45,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(22,null)})}validate(J){let pe=g.float(J,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(pe,6,100)}compute(J,pe,$e){return J.fontInfo.fontSize}}class L extends I{constructor(){super(46,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:L.MINIMUM_VALUE,maximum:L.MAXIMUM_VALUE,errorMessage:l.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:L.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(h.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,L.MINIMUM_VALUE,L.MAXIMUM_VALUE))}}L.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],L.MINIMUM_VALUE=1,L.MAXIMUM_VALUE=1e3;class k extends I{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[l.localize(25,null),l.localize(26,null),l.localize(27,null)]},$e=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(50,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(29,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(30,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:l.localize(31,null),...pe},"editor.gotoLocation.multipleImplementations":{description:l.localize(32,null),...pe},"editor.gotoLocation.multipleReferences":{description:l.localize(33,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:$e,description:l.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:$e,description:l.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:$e,description:l.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:$e,description:l.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:$e,description:l.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{multiple:v(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??v(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??v(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??v(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??v(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??v(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:S.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:S.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:S.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:S.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:S.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends I{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(52,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:l.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,description:l.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:l.localize(41,null)},"editor.hover.above":{type:"boolean",default:J.above,description:l.localize(42,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),delay:h.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:n(pe.sticky,this.defaultValue.sticky),above:n(pe.above,this.defaultValue.above)}}}var N;(function(q){q[q.None=0]="None",q[q.Text=1]="Text",q[q.Blocks=2]="Blocks"})(N=e.RenderMinimap||(e.RenderMinimap={}));class V extends F{constructor(){super(129,[49,57,37,64,91,59,60,93,116,119,120,121,2])}compute(J,pe,$e){return V.computeLayout(pe,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const pe=J.height/J.lineHeight,$e=J.scrollBeyondLastLine?pe-1:0,qe=(J.viewLineCount+$e)/(J.pixelRatio*J.height),rt=Math.floor(J.viewLineCount/qe);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:$e,desiredRatio:qe,minimapLineCount:rt}}static _computeMinimapLayout(J,pe){const $e=J.outerWidth,qe=J.outerHeight,rt=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(rt*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const ft=pe.stableMinimapLayoutInput,ht=ft&&J.outerHeight===ft.outerHeight&&J.lineHeight===ft.lineHeight&&J.typicalHalfwidthCharacterWidth===ft.typicalHalfwidthCharacterWidth&&J.pixelRatio===ft.pixelRatio&&J.scrollBeyondLastLine===ft.scrollBeyondLastLine&&J.minimap.enabled===ft.minimap.enabled&&J.minimap.side===ft.minimap.side&&J.minimap.size===ft.minimap.size&&J.minimap.showSlider===ft.minimap.showSlider&&J.minimap.renderCharacters===ft.minimap.renderCharacters&&J.minimap.maxColumn===ft.minimap.maxColumn&&J.minimap.scale===ft.minimap.scale&&J.verticalScrollbarWidth===ft.verticalScrollbarWidth&&J.isViewportWrapping===ft.isViewportWrapping,Ct=J.lineHeight,It=J.typicalHalfwidthCharacterWidth,Pt=J.scrollBeyondLastLine,Ze=J.minimap.renderCharacters;let pt=rt>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Ie=J.minimap.maxColumn,ge=J.minimap.size,Ce=J.minimap.side,ee=J.verticalScrollbarWidth,se=J.viewLineCount,fe=J.remainingWidth,he=J.isViewportWrapping,ke=Ze?2:3;let Le=Math.floor(rt*qe);const Me=Le/rt;let ze=!1,it=!1,Re=ke*pt,ce=pt/rt,me=1;if(ge==="fill"||ge==="fit"){const{typicalViewportLineCount:ct,extraLinesBeyondLastLine:Et,desiredRatio:vt,minimapLineCount:lt}=V.computeContainedMinimapLineCount({viewLineCount:se,scrollBeyondLastLine:Pt,height:qe,lineHeight:Ct,pixelRatio:rt});if(se/lt>1)ze=!0,it=!0,pt=1,Re=1,ce=pt/rt;else{let dt=!1,Tt=pt+1;if(ge==="fit"){const _t=Math.ceil((se+Et)*Re);he&&ht&&fe<=pe.stableFitRemainingWidth?(dt=!0,Tt=pe.stableFitMaxMinimapScale):dt=_t>Le}if(ge==="fill"||dt){ze=!0;const _t=pt;Re=Math.min(Ct*rt,Math.max(1,Math.floor(1/vt))),he&&ht&&fe<=pe.stableFitRemainingWidth&&(Tt=pe.stableFitMaxMinimapScale),pt=Math.min(Tt,Math.max(1,Math.floor(Re/ke))),pt>_t&&(me=Math.min(2,pt/_t)),ce=pt/rt/me,Le=Math.ceil(Math.max(ct,se+Et)*Re),he?(pe.stableMinimapLayoutInput=J,pe.stableFitRemainingWidth=fe,pe.stableFitMaxMinimapScale=pt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ne=Math.floor(Ie*ce),H=Math.min(ne,Math.max(0,Math.floor((fe-ee-2)*ce/(It+ce)))+e.MINIMAP_GUTTER_WIDTH);let we=Math.floor(rt*H);const De=we/rt;we=Math.floor(we*me);const Ge=Ze?1:2,xe=Ce==="left"?0:$e-H-ee;return{renderMinimap:Ge,minimapLeft:xe,minimapWidth:H,minimapHeightIsEditorHeight:ze,minimapIsSampling:it,minimapScale:pt,minimapLineHeight:Re,minimapCanvasInnerWidth:we,minimapCanvasInnerHeight:Le,minimapCanvasOuterWidth:De,minimapCanvasOuterHeight:Me}}static computeLayout(J,pe){const $e=pe.outerWidth|0,qe=pe.outerHeight|0,rt=pe.lineHeight|0,ft=pe.lineNumbersDigitCount|0,ht=pe.typicalHalfwidthCharacterWidth,Ct=pe.maxDigitWidth,It=pe.pixelRatio,Pt=pe.viewLineCount,Ze=J.get(121),pt=Ze==="inherit"?J.get(120):Ze,Ie=pt==="inherit"?J.get(116):pt,ge=J.get(119),Ce=J.get(2),ee=pe.isDominatedByLongLines,se=J.get(49),fe=J.get(59).renderType!==0,he=J.get(60),ke=J.get(93),Le=J.get(64),Me=J.get(91),ze=Me.verticalScrollbarSize,it=Me.verticalHasArrows,Re=Me.arrowSize,ce=Me.horizontalScrollbarSize,me=J.get(57),ne=J.get(37);let H;if(typeof me=="string"&&/^\d+(\.\d+)?ch$/.test(me)){const St=parseFloat(me.substr(0,me.length-2));H=h.clampedInt(St*ht,0,0,1e3)}else H=h.clampedInt(me,0,0,1e3);ne&&(H+=16);let we=0;if(fe){const St=Math.max(ft,he);we=Math.round(St*Ct)}let De=0;se&&(De=rt);let Ge=0,xe=Ge+De,ct=xe+we,Et=ct+H;const vt=$e-De-we-H;let lt=!1,gt=!1,dt=-1;Ce!==2&&(pt==="inherit"&&ee?(lt=!0,gt=!0):Ie==="on"||Ie==="bounded"?gt=!0:Ie==="wordWrapColumn"&&(dt=ge));const Tt=V._computeMinimapLayout({outerWidth:$e,outerHeight:qe,lineHeight:rt,typicalHalfwidthCharacterWidth:ht,pixelRatio:It,scrollBeyondLastLine:ke,minimap:Le,verticalScrollbarWidth:ze,viewLineCount:Pt,remainingWidth:vt,isViewportWrapping:gt},pe.memory||new D);Tt.renderMinimap!==0&&Tt.minimapLeft===0&&(Ge+=Tt.minimapWidth,xe+=Tt.minimapWidth,ct+=Tt.minimapWidth,Et+=Tt.minimapWidth);const _t=vt-Tt.minimapWidth,$t=Math.max(1,Math.floor((_t-ze-2)/ht)),jt=it?Re:0;return gt&&(dt=Math.max(1,$t),Ie==="bounded"&&(dt=Math.min(dt,ge))),{width:$e,height:qe,glyphMarginLeft:Ge,glyphMarginWidth:De,lineNumbersLeft:xe,lineNumbersWidth:we,decorationsLeft:ct,decorationsWidth:H,contentLeft:Et,contentWidth:_t,minimap:Tt,viewportColumn:$t,isWordWrapMinified:lt,isViewportWrapping:gt,wrappingColumn:dt,verticalScrollbarWidth:ze,horizontalScrollbarHeight:ce,overviewRuler:{top:jt,width:ze,height:qe-2*jt,right:0}}}}e.EditorLayoutInfoComputer=V;class W extends I{constructor(){const J={enabled:!0};super(56,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:l.localize(43,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class $ extends I{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(125,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:l.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:l.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:l.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),fontSize:h.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:S.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class X extends g{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>g.clamp(J,0,150),{markdownDescription:l.localize(47,null)})}compute(J,pe,$e){return J.fontInfo.lineHeight}}class j extends I{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:l.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(49,null),l.localize(50,null),l.localize(51,null)],default:J.size,description:l.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:l.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:l.localize(54,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:l.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:l.localize(57,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),size:v(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:v(pe.side,this.defaultValue.side,["right","left"]),showSlider:v(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(pe.renderCharacters,this.defaultValue.renderCharacters),scale:h.clampedInt(pe.scale,1,1,3),maxColumn:h.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Q(q){return q==="ctrlCmd"?M.isMacintosh?"metaKey":"ctrlKey":"altKey"}class le extends I{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(59,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{top:h.clampedInt(pe.top,0,0,1e3),bottom:h.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends I{constructor(){const J={enabled:!0,cycle:!1};super(75,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:l.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:l.localize(61,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),cycle:n(pe.cycle,this.defaultValue.cycle)}}}class ue extends F{constructor(){super(127)}compute(J,pe,$e){return J.pixelRatio}}class Fe extends I{constructor(){const J={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:l.localize(62,null)},comments:{type:"boolean",default:J.comments,description:l.localize(63,null)},other:{type:"boolean",default:J.other,description:l.localize(64,null)}}}],default:J,description:l.localize(65,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const pe=J,$e={other:n(pe.other,this.defaultValue.other),comments:n(pe.comments,this.defaultValue.comments),strings:n(pe.strings,this.defaultValue.strings)};return $e.other&&$e.comments&&$e.strings?!0:!$e.other&&!$e.comments&&!$e.strings?!1:$e}return this.defaultValue}}var Ke;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative",q[q.Interval=3]="Interval",q[q.Custom=4]="Custom"})(Ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Oe extends I{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null),l.localize(69,null)],default:"on",description:l.localize(70,null)})}validate(J){let pe=this.defaultValue.renderType,$e=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(pe=4,$e=J):J==="interval"?pe=3:J==="relative"?pe=2:J==="on"?pe=1:pe=0),{renderType:pe,renderFn:$e}}}function He(q){const J=q.get(86);return J==="editable"?q.get(80):J!=="on"}e.filterValidationDecorations=He;class Je extends I{constructor(){const J=[],pe={type:"number",description:l.localize(71,null)};super(90,"rulers",J,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:l.localize(72,null),format:"color-hex"}}}]},default:J,description:l.localize(73,null)})}validate(J){if(Array.isArray(J)){let pe=[];for(let $e of J)if(typeof $e=="number")pe.push({column:h.clampedInt($e,0,0,1e4),color:null});else if($e&&typeof $e=="object"){const qe=$e;pe.push({column:h.clampedInt(qe.column,0,0,1e4),color:qe.color})}return pe.sort(($e,qe)=>$e.column-qe.column),pe}return this.defaultValue}}function Ye(q,J){if(typeof q!="string")return J;switch(q){case"hidden":return 2;case"visible":return 3;default:return 1}}class Qe extends I{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(91,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(74,null),l.localize(75,null),l.localize(76,null)],default:"auto",description:l.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(78,null),l.localize(79,null),l.localize(80,null)],default:"auto",description:l.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:l.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:l.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:l.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J,$e=h.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=h.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:h.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ye(pe.vertical,this.defaultValue.vertical),horizontal:Ye(pe.horizontal,this.defaultValue.horizontal),useShadows:n(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:$e,horizontalSliderSize:h.clampedInt(pe.horizontalSliderSize,$e,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:h.clampedInt(pe.verticalSliderSize,qe,0,1e3),scrollByPage:n(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class z extends I{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:l.localize(85,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{enabled:n(pe.enabled,this.defaultValue.enabled),mode:v(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class K extends I{constructor(){const J={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:l.localize(86,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:n(J.enabled,this.defaultValue.enabled)}}}class Z extends I{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:J.bracketPairs,description:l.localize(90,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(91,null),l.localize(92,null),l.localize(93,null)],default:J.bracketPairsHorizontal,description:l.localize(94,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:l.localize(95,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:l.localize(96,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:l.localize(97,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{bracketPairs:oe(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:oe(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:n(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function oe(q,J,pe){const $e=pe.indexOf(q);return $e===-1?J:pe[$e]}class G extends I{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(105,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(98,null),l.localize(99,null)],default:J.insertMode,description:l.localize(100,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:l.localize(101,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:l.localize(102,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:l.localize(103,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:l.localize(104,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:l.localize(105,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:l.localize(106,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:l.localize(107,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:l.localize(108,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(109,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(110,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(111,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(112,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(113,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(114,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(115,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(116,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(117,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(118,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(119,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(120,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(121,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(122,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(123,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(124,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(125,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(126,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(127,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(128,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(129,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(130,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(131,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(132,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(133,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(134,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(135,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(136,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(137,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(138,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(139,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const pe=J;return{insertMode:v(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:n(pe.showIcons,this.defaultValue.showIcons),showStatusBar:n(pe.showStatusBar,this.defaultValue.showStatusBar),preview:n(pe.preview,this.defaultValue.preview),previewMode:v(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(pe.showMethods,this.defaultValue.showMethods),showFunctions:n(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:n(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:n(pe.showFields,this.defaultValue.showFields),showVariables:n(pe.showVariables,this.defaultValue.showVariables),showClasses:n(pe.showClasses,this.defaultValue.showClasses),showStructs:n(pe.showStructs,this.defaultValue.showStructs),showInterfaces:n(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:n(pe.showModules,this.defaultValue.showModules),showProperties:n(pe.showProperties,this.defaultValue.showProperties),showEvents:n(pe.showEvents,this.defaultValue.showEvents),showOperators:n(pe.showOperators,this.defaultValue.showOperators),showUnits:n(pe.showUnits,this.defaultValue.showUnits),showValues:n(pe.showValues,this.defaultValue.showValues),showConstants:n(pe.showConstants,this.defaultValue.showConstants),showEnums:n(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:n(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(pe.showKeywords,this.defaultValue.showKeywords),showWords:n(pe.showWords,this.defaultValue.showWords),showColors:n(pe.showColors,this.defaultValue.showColors),showFiles:n(pe.showFiles,this.defaultValue.showFiles),showReferences:n(pe.showReferences,this.defaultValue.showReferences),showFolders:n(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:n(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(pe.showSnippets,this.defaultValue.showSnippets),showUsers:n(pe.showUsers,this.defaultValue.showUsers),showIssues:n(pe.showIssues,this.defaultValue.showIssues)}}}class ie extends I{constructor(){super(101,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(140,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends F{constructor(){super(128,[80])}compute(J,pe,$e){return pe.get(80)?!0:J.tabFocusMode}}var Pe;(function(q){q[q.None=0]="None",q[q.Same=1]="Same",q[q.Indent=2]="Indent",q[q.DeepIndent=3]="DeepIndent"})(Pe=e.WrappingIndent||(e.WrappingIndent={}));function Ne(q){switch(q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class We extends F{constructor(){super(130,[129])}compute(J,pe,$e){const qe=pe.get(129);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const je="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",ot="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:M.isMacintosh?et:M.isLinux?ot:je,fontWeight:"normal",fontSize:M.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function ye(q){return e.editorOptionsRegistry[q.id]=q,q}var nt;(function(q){q[q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",q[q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",q[q.accessibilitySupport=2]="accessibilitySupport",q[q.accessibilityPageSize=3]="accessibilityPageSize",q[q.ariaLabel=4]="ariaLabel",q[q.autoClosingBrackets=5]="autoClosingBrackets",q[q.autoClosingDelete=6]="autoClosingDelete",q[q.autoClosingOvertype=7]="autoClosingOvertype",q[q.autoClosingQuotes=8]="autoClosingQuotes",q[q.autoIndent=9]="autoIndent",q[q.automaticLayout=10]="automaticLayout",q[q.autoSurround=11]="autoSurround",q[q.bracketPairColorization=12]="bracketPairColorization",q[q.guides=13]="guides",q[q.codeLens=14]="codeLens",q[q.codeLensFontFamily=15]="codeLensFontFamily",q[q.codeLensFontSize=16]="codeLensFontSize",q[q.colorDecorators=17]="colorDecorators",q[q.columnSelection=18]="columnSelection",q[q.comments=19]="comments",q[q.contextmenu=20]="contextmenu",q[q.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",q[q.cursorBlinking=22]="cursorBlinking",q[q.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",q[q.cursorStyle=24]="cursorStyle",q[q.cursorSurroundingLines=25]="cursorSurroundingLines",q[q.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",q[q.cursorWidth=27]="cursorWidth",q[q.disableLayerHinting=28]="disableLayerHinting",q[q.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",q[q.domReadOnly=30]="domReadOnly",q[q.dragAndDrop=31]="dragAndDrop",q[q.emptySelectionClipboard=32]="emptySelectionClipboard",q[q.extraEditorClassName=33]="extraEditorClassName",q[q.fastScrollSensitivity=34]="fastScrollSensitivity",q[q.find=35]="find",q[q.fixedOverflowWidgets=36]="fixedOverflowWidgets",q[q.folding=37]="folding",q[q.foldingStrategy=38]="foldingStrategy",q[q.foldingHighlight=39]="foldingHighlight",q[q.foldingImportsByDefault=40]="foldingImportsByDefault",q[q.unfoldOnClickAfterEndOfLine=41]="unfoldOnClickAfterEndOfLine",q[q.fontFamily=42]="fontFamily",q[q.fontInfo=43]="fontInfo",q[q.fontLigatures=44]="fontLigatures",q[q.fontSize=45]="fontSize",q[q.fontWeight=46]="fontWeight",q[q.formatOnPaste=47]="formatOnPaste",q[q.formatOnType=48]="formatOnType",q[q.glyphMargin=49]="glyphMargin",q[q.gotoLocation=50]="gotoLocation",q[q.hideCursorInOverviewRuler=51]="hideCursorInOverviewRuler",q[q.hover=52]="hover",q[q.inDiffEditor=53]="inDiffEditor",q[q.inlineSuggest=54]="inlineSuggest",q[q.letterSpacing=55]="letterSpacing",q[q.lightbulb=56]="lightbulb",q[q.lineDecorationsWidth=57]="lineDecorationsWidth",q[q.lineHeight=58]="lineHeight",q[q.lineNumbers=59]="lineNumbers",q[q.lineNumbersMinChars=60]="lineNumbersMinChars",q[q.linkedEditing=61]="linkedEditing",q[q.links=62]="links",q[q.matchBrackets=63]="matchBrackets",q[q.minimap=64]="minimap",q[q.mouseStyle=65]="mouseStyle",q[q.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",q[q.mouseWheelZoom=67]="mouseWheelZoom",q[q.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",q[q.multiCursorModifier=69]="multiCursorModifier",q[q.multiCursorPaste=70]="multiCursorPaste",q[q.occurrencesHighlight=71]="occurrencesHighlight",q[q.overviewRulerBorder=72]="overviewRulerBorder",q[q.overviewRulerLanes=73]="overviewRulerLanes",q[q.padding=74]="padding",q[q.parameterHints=75]="parameterHints",q[q.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",q[q.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",q[q.quickSuggestions=78]="quickSuggestions",q[q.quickSuggestionsDelay=79]="quickSuggestionsDelay",q[q.readOnly=80]="readOnly",q[q.renameOnType=81]="renameOnType",q[q.renderControlCharacters=82]="renderControlCharacters",q[q.renderFinalNewline=83]="renderFinalNewline",q[q.renderLineHighlight=84]="renderLineHighlight",q[q.renderLineHighlightOnlyWhenFocus=85]="renderLineHighlightOnlyWhenFocus",q[q.renderValidationDecorations=86]="renderValidationDecorations",q[q.renderWhitespace=87]="renderWhitespace",q[q.revealHorizontalRightPadding=88]="revealHorizontalRightPadding",q[q.roundedSelection=89]="roundedSelection",q[q.rulers=90]="rulers",q[q.scrollbar=91]="scrollbar",q[q.scrollBeyondLastColumn=92]="scrollBeyondLastColumn",q[q.scrollBeyondLastLine=93]="scrollBeyondLastLine",q[q.scrollPredominantAxis=94]="scrollPredominantAxis",q[q.selectionClipboard=95]="selectionClipboard",q[q.selectionHighlight=96]="selectionHighlight",q[q.selectOnLineNumbers=97]="selectOnLineNumbers",q[q.showFoldingControls=98]="showFoldingControls",q[q.showUnused=99]="showUnused",q[q.snippetSuggestions=100]="snippetSuggestions",q[q.smartSelect=101]="smartSelect",q[q.smoothScrolling=102]="smoothScrolling",q[q.stickyTabStops=103]="stickyTabStops",q[q.stopRenderingLineAfter=104]="stopRenderingLineAfter",q[q.suggest=105]="suggest",q[q.suggestFontSize=106]="suggestFontSize",q[q.suggestLineHeight=107]="suggestLineHeight",q[q.suggestOnTriggerCharacters=108]="suggestOnTriggerCharacters",q[q.suggestSelection=109]="suggestSelection",q[q.tabCompletion=110]="tabCompletion",q[q.tabIndex=111]="tabIndex",q[q.unusualLineTerminators=112]="unusualLineTerminators",q[q.useShadowDOM=113]="useShadowDOM",q[q.useTabStops=114]="useTabStops",q[q.wordSeparators=115]="wordSeparators",q[q.wordWrap=116]="wordWrap",q[q.wordWrapBreakAfterCharacters=117]="wordWrapBreakAfterCharacters",q[q.wordWrapBreakBeforeCharacters=118]="wordWrapBreakBeforeCharacters",q[q.wordWrapColumn=119]="wordWrapColumn",q[q.wordWrapOverride1=120]="wordWrapOverride1",q[q.wordWrapOverride2=121]="wordWrapOverride2",q[q.wrappingIndent=122]="wrappingIndent",q[q.wrappingStrategy=123]="wrappingStrategy",q[q.showDeprecated=124]="showDeprecated",q[q.inlayHints=125]="inlayHints",q[q.editorClassName=126]="editorClassName",q[q.pixelRatio=127]="pixelRatio",q[q.tabFocusMode=128]="tabFocusMode",q[q.layoutInfo=129]="layoutInfo",q[q.wrappingInfo=130]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ye(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(141,null)})),acceptSuggestionOnEnter:ye(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(142,null),""],markdownDescription:l.localize(143,null)})),accessibilitySupport:ye(new r),accessibilityPageSize:ye(new h(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(144,null)})),ariaLabel:ye(new S(4,"ariaLabel",l.localize(145,null))),autoClosingBrackets:ye(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(146,null),l.localize(147,null),""],description:l.localize(148,null)})),autoClosingDelete:ye(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(149,null),""],description:l.localize(150,null)})),autoClosingOvertype:ye(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(151,null),""],description:l.localize(152,null)})),autoClosingQuotes:ye(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(153,null),l.localize(154,null),""],description:l.localize(155,null)})),autoIndent:ye(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],C,{enumDescriptions:[l.localize(156,null),l.localize(157,null),l.localize(158,null),l.localize(159,null),l.localize(160,null)],description:l.localize(161,null)})),automaticLayout:ye(new m(10,"automaticLayout",!1)),autoSurround:ye(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(162,null),l.localize(163,null),l.localize(164,null),""],description:l.localize(165,null)})),bracketPairColorization:ye(new K),bracketPairGuides:ye(new Z),stickyTabStops:ye(new m(103,"stickyTabStops",!1,{description:l.localize(166,null)})),codeLens:ye(new m(14,"codeLens",!0,{description:l.localize(167,null)})),codeLensFontFamily:ye(new S(15,"codeLensFontFamily","",{description:l.localize(168,null)})),codeLensFontSize:ye(new h(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(169,null)})),colorDecorators:ye(new m(17,"colorDecorators",!0,{description:l.localize(170,null)})),columnSelection:ye(new m(18,"columnSelection",!1,{description:l.localize(171,null)})),comments:ye(new b),contextmenu:ye(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ye(new m(21,"copyWithSyntaxHighlighting",!0,{description:l.localize(172,null)})),cursorBlinking:ye(new d(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],i,{description:l.localize(173,null)})),cursorSmoothCaretAnimation:ye(new m(23,"cursorSmoothCaretAnimation",!1,{description:l.localize(174,null)})),cursorStyle:ye(new d(24,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],u,{description:l.localize(175,null)})),cursorSurroundingLines:ye(new h(25,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(176,null)})),cursorSurroundingLinesStyle:ye(new s(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(177,null),l.localize(178,null)],description:l.localize(179,null)})),cursorWidth:ye(new h(27,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(180,null)})),disableLayerHinting:ye(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ye(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:ye(new m(30,"domReadOnly",!1)),dragAndDrop:ye(new m(31,"dragAndDrop",!0,{description:l.localize(181,null)})),emptySelectionClipboard:ye(new f),extraEditorClassName:ye(new S(33,"extraEditorClassName","")),fastScrollSensitivity:ye(new g(34,"fastScrollSensitivity",5,q=>q<=0?5:q,{markdownDescription:l.localize(182,null)})),find:ye(new y),fixedOverflowWidgets:ye(new m(36,"fixedOverflowWidgets",!1)),folding:ye(new m(37,"folding",!0,{description:l.localize(183,null)})),foldingStrategy:ye(new s(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(184,null),l.localize(185,null)],description:l.localize(186,null)})),foldingHighlight:ye(new m(39,"foldingHighlight",!0,{description:l.localize(187,null)})),foldingImportsByDefault:ye(new m(40,"foldingImportsByDefault",!1,{description:l.localize(188,null)})),unfoldOnClickAfterEndOfLine:ye(new m(41,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(189,null)})),fontFamily:ye(new S(42,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(190,null)})),fontInfo:ye(new P),fontLigatures2:ye(new R),fontSize:ye(new B),fontWeight:ye(new L),formatOnPaste:ye(new m(47,"formatOnPaste",!1,{description:l.localize(191,null)})),formatOnType:ye(new m(48,"formatOnType",!1,{description:l.localize(192,null)})),glyphMargin:ye(new m(49,"glyphMargin",!0,{description:l.localize(193,null)})),gotoLocation:ye(new k),hideCursorInOverviewRuler:ye(new m(51,"hideCursorInOverviewRuler",!1,{description:l.localize(194,null)})),hover:ye(new x),inDiffEditor:ye(new m(53,"inDiffEditor",!1)),letterSpacing:ye(new g(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,q=>g.clamp(q,-5,20),{description:l.localize(195,null)})),lightbulb:ye(new W),lineDecorationsWidth:ye(new _(57,"lineDecorationsWidth",10)),lineHeight:ye(new X),lineNumbers:ye(new Oe),lineNumbersMinChars:ye(new h(60,"lineNumbersMinChars",5,1,300)),linkedEditing:ye(new m(61,"linkedEditing",!1,{description:l.localize(196,null)})),links:ye(new m(62,"links",!0,{description:l.localize(197,null)})),matchBrackets:ye(new s(63,"matchBrackets","always",["always","near","never"],{description:l.localize(198,null)})),minimap:ye(new j),mouseStyle:ye(new s(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ye(new g(66,"mouseWheelScrollSensitivity",1,q=>q===0?1:q,{markdownDescription:l.localize(199,null)})),mouseWheelZoom:ye(new m(67,"mouseWheelZoom",!1,{markdownDescription:l.localize(200,null)})),multiCursorMergeOverlapping:ye(new m(68,"multiCursorMergeOverlapping",!0,{description:l.localize(201,null)})),multiCursorModifier:ye(new d(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Q,{markdownEnumDescriptions:[l.localize(202,null),l.localize(203,null)],markdownDescription:l.localize(204,null)})),multiCursorPaste:ye(new s(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(205,null),l.localize(206,null)],markdownDescription:l.localize(207,null)})),occurrencesHighlight:ye(new m(71,"occurrencesHighlight",!0,{description:l.localize(208,null)})),overviewRulerBorder:ye(new m(72,"overviewRulerBorder",!0,{description:l.localize(209,null)})),overviewRulerLanes:ye(new h(73,"overviewRulerLanes",3,0,3)),padding:ye(new le),parameterHints:ye(new ve),peekWidgetDefaultFocus:ye(new s(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(210,null),l.localize(211,null)],description:l.localize(212,null)})),definitionLinkOpensInPeek:ye(new m(77,"definitionLinkOpensInPeek",!1,{description:l.localize(213,null)})),quickSuggestions:ye(new Fe),quickSuggestionsDelay:ye(new h(79,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(214,null)})),readOnly:ye(new m(80,"readOnly",!1)),renameOnType:ye(new m(81,"renameOnType",!1,{description:l.localize(215,null),markdownDeprecationMessage:l.localize(216,null)})),renderControlCharacters:ye(new m(82,"renderControlCharacters",!0,{description:l.localize(217,null),restricted:!0})),renderFinalNewline:ye(new m(83,"renderFinalNewline",!0,{description:l.localize(218,null)})),renderLineHighlight:ye(new s(84,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(219,null)],description:l.localize(220,null)})),renderLineHighlightOnlyWhenFocus:ye(new m(85,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(221,null)})),renderValidationDecorations:ye(new s(86,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ye(new s(87,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(222,null),l.localize(223,null),l.localize(224,null),""],description:l.localize(225,null)})),revealHorizontalRightPadding:ye(new h(88,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ye(new m(89,"roundedSelection",!0,{description:l.localize(226,null)})),rulers:ye(new Je),scrollbar:ye(new Qe),scrollBeyondLastColumn:ye(new h(92,"scrollBeyondLastColumn",5,0,1073741824,{description:l.localize(227,null)})),scrollBeyondLastLine:ye(new m(93,"scrollBeyondLastLine",!0,{description:l.localize(228,null)})),scrollPredominantAxis:ye(new m(94,"scrollPredominantAxis",!0,{description:l.localize(229,null)})),selectionClipboard:ye(new m(95,"selectionClipboard",!0,{description:l.localize(230,null),included:M.isLinux})),selectionHighlight:ye(new m(96,"selectionHighlight",!0,{description:l.localize(231,null)})),selectOnLineNumbers:ye(new m(97,"selectOnLineNumbers",!0)),showFoldingControls:ye(new s(98,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[l.localize(232,null),l.localize(233,null)],description:l.localize(234,null)})),showUnused:ye(new m(99,"showUnused",!0,{description:l.localize(235,null)})),showDeprecated:ye(new m(124,"showDeprecated",!0,{description:l.localize(236,null)})),inlayHints:ye(new $),snippetSuggestions:ye(new s(100,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(237,null),l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),smartSelect:ye(new ie),smoothScrolling:ye(new m(102,"smoothScrolling",!1,{description:l.localize(242,null)})),stopRenderingLineAfter:ye(new h(104,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ye(new G),inlineSuggest:ye(new z),suggestFontSize:ye(new h(106,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(243,null)})),suggestLineHeight:ye(new h(107,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(244,null)})),suggestOnTriggerCharacters:ye(new m(108,"suggestOnTriggerCharacters",!0,{description:l.localize(245,null)})),suggestSelection:ye(new s(109,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(246,null),l.localize(247,null),l.localize(248,null)],description:l.localize(249,null)})),tabCompletion:ye(new s(110,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(250,null),l.localize(251,null),l.localize(252,null)],description:l.localize(253,null)})),tabIndex:ye(new h(111,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ye(new s(112,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(254,null),l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),useShadowDOM:ye(new m(113,"useShadowDOM",!0)),useTabStops:ye(new m(114,"useTabStops",!0,{description:l.localize(258,null)})),wordSeparators:ye(new S(115,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:l.localize(259,null)})),wordWrap:ye(new s(116,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(260,null),l.localize(261,null),l.localize(262,null),l.localize(263,null)],description:l.localize(264,null)})),wordWrapBreakAfterCharacters:ye(new S(117,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ye(new S(118,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ye(new h(119,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(265,null)})),wordWrapOverride1:ye(new s(120,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ye(new s(121,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ye(new d(122,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Ne,{enumDescriptions:[l.localize(266,null),l.localize(267,null),l.localize(268,null),l.localize(269,null)],description:l.localize(270,null)})),wrappingStrategy:ye(new s(123,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[l.localize(271,null),l.localize(272,null)],description:l.localize(273,null)})),editorClassName:ye(new w),pixelRatio:ye(new ue),tabFocusMode:ye(new de),layoutInfo:ye(new V),wrappingInfo:ye(new We)}}),define(be[120],Ee([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[121],Ee([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[122],Ee([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(be[123],Ee([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(be[124],Ee([18,19]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(be[125],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[126],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[127],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(be[128],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[129],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[130],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[131],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[132],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(be[133],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(be[134],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[135],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[136],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[137],Ee([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[138],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var l;(function(t){t[t.ACTIVATE=1]="ACTIVATE",t[t.RESTORE=2]="RESTORE",t[t.PRESERVE=3]="PRESERVE"})(l=e.EditorActivation||(e.EditorActivation={}));var M;(function(t){t[t.PICK=0]="PICK",t[t.DISABLED=1]="DISABLED",t[t.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(M=e.EditorResolution||(e.EditorResolution={}));var E;(function(t){t[t.API=0]="API",t[t.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(t){t[t.Center=0]="Center",t[t.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",t[t.NearTop=2]="NearTop",t[t.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[139],Ee([0,1,121]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function T(n){return n=n.trim(),n==="*"||M.test(n)}e.isValidVersionStr=T;function t(n){if(!T(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=n.match(M);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=t;function A(n){if(!n)return null;let m=n.majorBase,a=n.majorMustEqual,h=n.minorBase,g=n.minorMustEqual,S=n.patchBase,v=n.patchMustEqual;n.hasCaret&&(m===0||(g=!1),v=!1);let s=0;if(n.preRelease){const d=E.exec(n.preRelease);if(d){const[,C,r,b]=d;s=Date.UTC(Number(C),Number(r)-1,Number(b))}}return{majorBase:m,majorMustEqual:a,minorBase:h,minorMustEqual:g,patchBase:S,patchMustEqual:v,isMinimum:n.hasGreaterEquals,notBefore:s}}e.normalizeVersion=A;function D(n,m,a){let h;typeof n=="string"?h=A(t(n)):h=n;let g;m instanceof Date?g=m.getTime():typeof m=="string"&&(g=new Date(m).getTime());let S;if(typeof a=="string"?S=A(t(a)):S=a,!h||!S)return!1;let v=h.majorBase,s=h.minorBase,d=h.patchBase,C=S.majorBase,r=S.minorBase,b=S.patchBase,o=S.notBefore,i=S.majorMustEqual,p=S.minorMustEqual,c=S.patchMustEqual;return S.isMinimum?v>C?!0:v<C?!1:s>r?!0:s<r||g&&g<o?!1:d>=b:(v===1&&C===0&&(!i||!p||!c)&&(C=1,r=0,b=0,i=!0,p=!1,c=!1),v<C?!1:v>C?!i:s<r?!1:s>r?!p:d<b?!1:d>b?!c:!(g&&g<o))}e.isValidVersion=D;function I(n,m,a,h){return a.isBuiltin||typeof a.main=="undefined"?!0:_(n,m,a.engines.vscode,h)}e.isValidExtensionVersion=I;function F(n,m,a){return n==="*"||_(m,a,n)}e.isEngineValid=F;function _(n,m,a,h=[]){let g=A(t(a));if(!g)return h.push(l.localize(0,null,a)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return h.push(l.localize(1,null,a)),!1}else if(!g.majorMustEqual)return h.push(l.localize(2,null,a)),!1;return D(n,m,g)?!0:(h.push(l.localize(3,null,n,a)),!1)}}),define(be[82],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class l{constructor(E,T=[],t=!1){this.ctor=E,this.staticArguments=T,this.supportsDelayedInstantiation=t}}e.SyncDescriptor=l}),define(be[59],Ee([0,1,82]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const M=[];function E(t,A,D){A instanceof l.SyncDescriptor||(A=new l.SyncDescriptor(A,[],D)),M.push([t,A])}e.registerSingleton=E;function T(){return M}e.getSingletonServiceDescriptors=T}),define(be[140],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class l{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=l;class M{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let t of this._nodes.values())t.outgoing.size===0&&T.push(t);return T}insertEdge(T,t){const A=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(t);A.outgoing.set(this._hashFn(t),D),D.incoming.set(this._hashFn(T),A)}removeNode(T){const t=this._hashFn(T);this._nodes.delete(t);for(let A of this._nodes.values())A.outgoing.delete(t),A.incoming.delete(t)}lookupOrInsertNode(T){const t=this._hashFn(T);let A=this._nodes.get(t);return A||(A=new l(T),this._nodes.set(t,A)),A}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[t,A]of this._nodes)T.push(`${t}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,t]of this._nodes){const A=new Set([T]),D=this._findCycle(t,A);if(D)return D}}_findCycle(T,t){for(let[A,D]of T.outgoing){if(t.has(A))return[...t,A].join(" -> ");t.add(A);const I=this._findCycle(D,t);if(I)return I;t.delete(A)}}}e.Graph=M}),define(be[4],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var l;(function(t){t.serviceIds=new Map,t.DI_TARGET="$di$target",t.DI_DEPENDENCIES="$di$dependencies";function A(D){return D[t.DI_DEPENDENCIES]||[]}t.getServiceDependencies=A})(l=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function M(t,A,D,I){A[l.DI_TARGET]===A?A[l.DI_DEPENDENCIES].push({id:t,index:D,optional:I}):(A[l.DI_DEPENDENCIES]=[{id:t,index:D,optional:I}],A[l.DI_TARGET]=A)}function E(t){if(l.serviceIds.has(t))return l.serviceIds.get(t);const A=function(D,I,F){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(A,D,F,!1)};return A.toString=()=>t,l.serviceIds.set(t,A),A}e.createDecorator=E;function T(t){return t}e.refineServiceDecorator=T}),define(be[141],Ee([0,1,4]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,l.createDecorator)("modelService");function M(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=M}),define(be[142],Ee([0,1,3,60,6,20,76,58,141]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function I(h){return typeof h=="string"?!1:Array.isArray(h)?h.every(I):!!h.exclusive}class F{constructor(){this._clock=0,this._entries=[],this._onDidChange=new l.Emitter}get onDidChange(){return this._onDidChange.event}register(g,S){let v={selector:g,provider:S,_score:-1,_time:this._clock++};return this._entries.push(v),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(v){let s=this._entries.indexOf(v);s>=0&&(this._entries.splice(s,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),v=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const S=[];for(let v of this._entries)v._score>0&&S.push(v.provider);return S}ordered(g){const S=[];return this._orderedForEach(g,v=>S.push(v.provider)),S}orderedGroups(g){const S=[];let v,s;return this._orderedForEach(g,d=>{v&&s===d._score?v.push(d.provider):(s=d._score,v=[d.provider],S.push(v))}),S}_orderedForEach(g,S){if(!!g){this._updateScores(g);for(const v of this._entries)v._score>0&&S(v)}}_updateScores(g){let S={uri:g.uri.toString(),language:g.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===S.language&&this._lastCandidate.uri===S.uri)){this._lastCandidate=S;for(let v of this._entries)if(v._score=(0,A.score)(v.selector,g.uri,g.getLanguageId(),(0,D.shouldSynchronizeModel)(g)),I(v.selector)&&v._score>0){for(let s of this._entries)s._score=0;v._score=1e3;break}this._entries.sort(F._compareByScoreAndTime)}}static _compareByScoreAndTime(g,S){return g._score<S._score?1:g._score>S._score?-1:g._time<S._time?1:g._time>S._time?-1:0}}e.LanguageFeatureRegistry=F;const _=new WeakMap;let n=0;function m(h){let g=_.get(h);return g===void 0&&(g=++n,_.set(h,g)),g}class a{constructor(g,S,v=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=S,this.max=v,this._cache=new T.LRUCache(50,.7)}_key(g){return g.id+this._registry.all(g).reduce((S,v)=>(0,M.doHash)(m(v),S),0)}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const S=this._key(g),v=this._cache.get(S);return this._clamp(v?.value)}update(g,S){const v=this._key(g);let s=this._cache.get(v);return s||(s=new t.MovingAverage,this._cache.set(v,s)),s.update(S),this.get(g)}}e.LanguageFeatureRequestDelays=a}),define(be[61],Ee([0,1,2,45,142,113,35]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var A;(function(f){f[f.Null=0]="Null",f[f.PlainText=1]="PlainText"})(A=e.LanguageId||(e.LanguageId={}));var D;(function(f){f[f.NotSet=-1]="NotSet",f[f.None=0]="None",f[f.Italic=1]="Italic",f[f.Bold=2]="Bold",f[f.Underline=4]="Underline"})(D=e.FontStyle||(e.FontStyle={}));var I;(function(f){f[f.None=0]="None",f[f.DefaultForeground=1]="DefaultForeground",f[f.DefaultBackground=2]="DefaultBackground"})(I=e.ColorId||(e.ColorId={}));var F;(function(f){f[f.Other=0]="Other",f[f.Comment=1]="Comment",f[f.String=2]="String",f[f.RegEx=4]="RegEx"})(F=e.StandardTokenType||(e.StandardTokenType={}));var _;(function(f){f[f.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",f[f.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",f[f.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",f[f.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",f[f.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",f[f.ITALIC_MASK=2048]="ITALIC_MASK",f[f.BOLD_MASK=4096]="BOLD_MASK",f[f.UNDERLINE_MASK=8192]="UNDERLINE_MASK",f[f.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",f[f.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",f[f.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",f[f.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",f[f.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",f[f.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",f[f.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",f[f.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",f[f.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",f[f.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(_=e.MetadataConsts||(e.MetadataConsts={}));class n{static getLanguageId(y){return(y&255)>>>0}static getTokenType(y){return(y&1792)>>>8}static getFontStyle(y){return(y&14336)>>>11}static getForeground(y){return(y&8372224)>>>14}static getBackground(y){return(y&4286578688)>>>23}static getClassNameFromMetadata(y){let R=this.getForeground(y),P="mtk"+R,B=this.getFontStyle(y);return B&1&&(P+=" mtki"),B&2&&(P+=" mtkb"),B&4&&(P+=" mtku"),P}static getInlineStyleFromMetadata(y,R){const P=this.getForeground(y),B=this.getFontStyle(y);let L=`color: ${R[P]};`;return B&1&&(L+="font-style: italic;"),B&2&&(L+="font-weight: bold;"),B&4&&(L+="text-decoration: underline;"),L}}e.TokenMetadata=n;var m;(function(f){f[f.Method=0]="Method",f[f.Function=1]="Function",f[f.Constructor=2]="Constructor",f[f.Field=3]="Field",f[f.Variable=4]="Variable",f[f.Class=5]="Class",f[f.Struct=6]="Struct",f[f.Interface=7]="Interface",f[f.Module=8]="Module",f[f.Property=9]="Property",f[f.Event=10]="Event",f[f.Operator=11]="Operator",f[f.Unit=12]="Unit",f[f.Value=13]="Value",f[f.Constant=14]="Constant",f[f.Enum=15]="Enum",f[f.EnumMember=16]="EnumMember",f[f.Keyword=17]="Keyword",f[f.Text=18]="Text",f[f.Color=19]="Color",f[f.File=20]="File",f[f.Reference=21]="Reference",f[f.Customcolor=22]="Customcolor",f[f.Folder=23]="Folder",f[f.TypeParameter=24]="TypeParameter",f[f.User=25]="User",f[f.Issue=26]="Issue",f[f.Snippet=27]="Snippet"})(m=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let f=Object.create(null);return f[0]="symbol-method",f[1]="symbol-function",f[2]="symbol-constructor",f[3]="symbol-field",f[4]="symbol-variable",f[5]="symbol-class",f[6]="symbol-struct",f[7]="symbol-interface",f[8]="symbol-module",f[9]="symbol-property",f[10]="symbol-event",f[11]="symbol-operator",f[12]="symbol-unit",f[13]="symbol-value",f[14]="symbol-constant",f[15]="symbol-enum",f[16]="symbol-enum-member",f[17]="symbol-keyword",f[27]="symbol-snippet",f[18]="symbol-text",f[19]="symbol-color",f[20]="symbol-file",f[21]="symbol-reference",f[22]="symbol-customcolor",f[23]="symbol-folder",f[24]="symbol-type-parameter",f[25]="account",f[26]="issues",function(y){const R=f[y];let P=R&&t.iconRegistry.get(R);return P||(console.info("No codicon found for CompletionItemKind "+y),P=t.Codicon.symbolProperty),P.classNames}}(),e.completionKindFromString=function(){let f=Object.create(null);return f.method=0,f.function=1,f.constructor=2,f.field=3,f.variable=4,f.class=5,f.struct=6,f.interface=7,f.module=8,f.property=9,f.event=10,f.operator=11,f.unit=12,f.value=13,f.constant=14,f.enum=15,f["enum-member"]=16,f.enumMember=16,f.keyword=17,f.snippet=27,f.text=18,f.color=19,f.file=20,f.reference=21,f.customcolor=22,f.folder=23,f["type-parameter"]=24,f.typeParameter=24,f.account=25,f.issue=26,function(y,R){let P=f[y];return typeof P=="undefined"&&!R&&(P=9),P}}();var a;(function(f){f[f.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var h;(function(f){f[f.KeepWhitespace=1]="KeepWhitespace",f[f.InsertAsSnippet=4]="InsertAsSnippet"})(h=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(f){f[f.Invoke=0]="Invoke",f[f.TriggerCharacter=1]="TriggerCharacter",f[f.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(f){f[f.Automatic=0]="Automatic",f[f.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var v;(function(f){f[f.Invoke=1]="Invoke",f[f.Auto=2]="Auto"})(v=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var s;(function(f){f[f.Invoke=1]="Invoke",f[f.TriggerCharacter=2]="TriggerCharacter",f[f.ContentChange=3]="ContentChange"})(s=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var d;(function(f){f[f.Text=0]="Text",f[f.Read=1]="Read",f[f.Write=2]="Write"})(d=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function C(f){return f&&l.URI.isUri(f.uri)&&M.Range.isIRange(f.range)&&(M.Range.isIRange(f.originSelectionRange)||M.Range.isIRange(f.targetSelectionRange))}e.isLocationLink=C;var r;(function(f){f[f.File=0]="File",f[f.Module=1]="Module",f[f.Namespace=2]="Namespace",f[f.Package=3]="Package",f[f.Class=4]="Class",f[f.Method=5]="Method",f[f.Property=6]="Property",f[f.Field=7]="Field",f[f.Constructor=8]="Constructor",f[f.Enum=9]="Enum",f[f.Interface=10]="Interface",f[f.Function=11]="Function",f[f.Variable=12]="Variable",f[f.Constant=13]="Constant",f[f.String=14]="String",f[f.Number=15]="Number",f[f.Boolean=16]="Boolean",f[f.Array=17]="Array",f[f.Object=18]="Object",f[f.Key=19]="Key",f[f.Null=20]="Null",f[f.EnumMember=21]="EnumMember",f[f.Struct=22]="Struct",f[f.Event=23]="Event",f[f.Operator=24]="Operator",f[f.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var b;(function(f){f[f.Deprecated=1]="Deprecated"})(b=e.SymbolTag||(e.SymbolTag={}));var o;(function(f){const y=new Map;y.set("file",0),y.set("module",1),y.set("namespace",2),y.set("package",3),y.set("class",4),y.set("method",5),y.set("property",6),y.set("field",7),y.set("constructor",8),y.set("enum",9),y.set("interface",10),y.set("function",11),y.set("variable",12),y.set("constant",13),y.set("string",14),y.set("number",15),y.set("boolean",16),y.set("array",17),y.set("object",18),y.set("key",19),y.set("null",20),y.set("enum-member",21),y.set("struct",22),y.set("event",23),y.set("operator",24),y.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function P(k){return y.get(k)}f.fromString=P;function B(k){return R.get(k)}f.toString=B;function L(k,x){const N=R.get(k);let V=N&&t.iconRegistry.get("symbol-"+N);return V||(console.info("No codicon found for SymbolKind "+k),V=t.Codicon.symbolProperty),`${x?"inline":"block"} ${V.classNames}`}f.toCssClassName=L})(o=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(y){this.value=y}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var p;(function(f){f[f.Collapsed=0]="Collapsed",f[f.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(f){f[f.Editing=0]="Editing",f[f.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var u;(function(f){f[f.Other=0]="Other",f[f.Type=1]="Type",f[f.Parameter=2]="Parameter"})(u=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var w;(function(f){f[f.None=0]="None",f[f.Option=1]="Option",f[f.Default=2]="Default",f[f.Preferred=3]="Preferred"})(w=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[38],Ee([0,1,25,9,4]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=l.userAgent||"";const t=new Map;t.set("false",!1),t.set("true",!0),t.set("isMac",l.isMacintosh),t.set("isLinux",l.isLinux),t.set("isWindows",l.isWindows),t.set("isWeb",l.isWeb),t.set("isMacNative",l.isMacintosh&&!l.isWeb),t.set("isEdge",T.indexOf("Edg/")>=0),t.set("isFirefox",T.indexOf("Firefox")>=0),t.set("isChrome",T.indexOf("Chrome")>=0),t.set("isSafari",T.indexOf("Safari")>=0);const A=Object.prototype.hasOwnProperty;var D;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return n.INSTANCE}static true(){return m.INSTANCE}static has(k){return a.create(k)}static equals(k,x){return h.create(k,x)}static notEquals(k,x){return v.create(k,x)}static regex(k,x){return i.create(k,x)}static in(k,x){return g.create(k,x)}static not(k){return s.create(k)}static and(...k){return u.create(k,null)}static or(...k){return w.create(k,null,!0)}static greater(k,x){return C.create(k,x)}static greaterEquals(k,x){return r.create(k,x)}static smaller(k,x){return b.create(k,x)}static smallerEquals(k,x){return o.create(k,x)}static deserialize(k,x=!1){if(!!k)return this._deserializeOrExpression(k,x)}static _deserializeOrExpression(k,x){let N=k.split("||");return w.create(N.map(V=>this._deserializeAndExpression(V,x)),null,!0)}static _deserializeAndExpression(k,x){let N=k.split("&&");return u.create(N.map(V=>this._deserializeOne(V,x)),null)}static _deserializeOne(k,x){if(k=k.trim(),k.indexOf("!=")>=0){let N=k.split("!=");return v.create(N[0].trim(),this._deserializeValue(N[1],x))}if(k.indexOf("==")>=0){let N=k.split("==");return h.create(N[0].trim(),this._deserializeValue(N[1],x))}if(k.indexOf("=~")>=0){let N=k.split("=~");return i.create(N[0].trim(),this._deserializeRegexValue(N[1],x))}if(k.indexOf(" in ")>=0){let N=k.split(" in ");return g.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const N=k.split(">=");return r.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const N=k.split(">");return C.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const N=k.split("<=");return o.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const N=k.split("<");return b.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(k)?s.create(k.substr(1).trim()):a.create(k)}static _deserializeValue(k,x){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let N=/^'([^']*)'$/.exec(k);return N?N[1].trim():k}static _deserializeRegexValue(k,x){if((0,M.isFalsyOrWhitespace)(k)){if(x)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=k.indexOf("/"),V=k.lastIndexOf("/");if(N===V||N<0){if(x)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let W=k.slice(N+1,V),$=k[V+1]==="i"?"i":"";try{return new RegExp(W,$)}catch(X){if(x)throw new Error(`bad regexp-value '${k}', parse error: ${X}`);return console.warn(`bad regexp-value '${k}', parse error: ${X}`),null}}}e.ContextKeyExpr=I;function F(L,k){const x=L?L.substituteConstants():void 0,N=k?k.substituteConstants():void 0;return!x&&!N?!0:!x||!N?!1:x.equals(N)}e.expressionsAreEqualWithConstantSubstitution=F;function _(L,k){return L.cmp(k)}class n{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=n,n.INSTANCE=new n;class m{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return n.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class a{constructor(k,x){this.key=k,this.negated=x,this.type=2}static create(k,x=null){const N=t.get(k);return typeof N=="boolean"?N?m.INSTANCE:n.INSTANCE:new a(k,x)}cmp(k){return k.type!==this.type?this.type-k.type:y(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=t.get(this.key);return typeof k=="boolean"?k?m.INSTANCE:n.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=s.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=a;class h{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=4}static create(k,x,N=null){if(typeof x=="boolean")return x?a.create(k,N):s.create(k,N);const V=t.get(k);return typeof V=="boolean"?x===(V?"true":"false")?m.INSTANCE:n.INSTANCE:new h(k,x,N)}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=t.get(this.key);if(typeof k=="boolean"){const x=k?"true":"false";return this.value===x?m.INSTANCE:n.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=h;class g{constructor(k,x){this.key=k,this.valueKey=x,this.type=10,this.negated=null}static create(k,x){return new g(k,x)}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const x=k.getValue(this.valueKey),N=k.getValue(this.key);return Array.isArray(x)?x.indexOf(N)>=0:typeof N=="string"&&typeof x=="object"&&x!==null?A.call(x,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=S.create(this)),this.negated}}e.ContextKeyInExpr=g;class S{constructor(k){this._actual=k,this.type=11}static create(k){return new S(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new S(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class v{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=5}static create(k,x,N=null){if(typeof x=="boolean")return x?s.create(k,N):a.create(k,N);const V=t.get(k);return typeof V=="boolean"?x===(V?"true":"false")?n.INSTANCE:m.INSTANCE:new v(k,x,N)}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=t.get(this.key);if(typeof k=="boolean"){const x=k?"true":"false";return this.value===x?n.INSTANCE:m.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=v;class s{constructor(k,x){this.key=k,this.negated=x,this.type=3}static create(k,x=null){const N=t.get(k);return typeof N=="boolean"?N?n.INSTANCE:m.INSTANCE:new s(k,x)}cmp(k){return k.type!==this.type?this.type-k.type:y(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=t.get(this.key);return typeof k=="boolean"?k?n.INSTANCE:m.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=a.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=s;function d(L,k){if(typeof L=="string"){const x=parseFloat(L);isNaN(x)||(L=x)}return typeof L=="string"||typeof L=="number"?k(L):n.INSTANCE}class C{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=12}static create(k,x,N=null){return d(x,V=>new C(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=C;class r{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=13}static create(k,x,N=null){return d(x,V=>new r(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=b.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class b{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=14}static create(k,x,N=null){return d(x,V=>new b(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=b;class o{constructor(k,x,N){this.key=k,this.value=x,this.negated=N,this.type=15}static create(k,x,N=null){return d(x,V=>new o(k,V,N))}cmp(k){return k.type!==this.type?this.type-k.type:R(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class i{constructor(k,x){this.key=k,this.regexp=x,this.type=7,this.negated=null}static create(k,x){return new i(k,x)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const x=this.regexp?this.regexp.source:"",N=k.regexp?k.regexp.source:"";return x<N?-1:x>N?1:0}equals(k){if(k.type===this.type){const x=this.regexp?this.regexp.source:"",N=k.regexp?k.regexp.source:"";return this.key===k.key&&x===N}return!1}substituteConstants(){return this}evaluate(k){let x=k.getValue(this.key);return this.regexp?this.regexp.test(x):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=p.create(this)),this.negated}}e.ContextKeyRegexExpr=i;class p{constructor(k){this._actual=k,this.type=8}static create(k){return new p(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new p(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=p;function c(L){let k=null;for(let x=0,N=L.length;x<N;x++){const V=L[x].substituteConstants();if(L[x]!==V&&k===null){k=[];for(let W=0;W<x;W++)k[W]=L[W]}k!==null&&(k[x]=V)}return k===null?L:k}class u{constructor(k,x){this.expr=k,this.negated=x,this.type=6}static create(k,x){return u._normalizeArr(k,x)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=_(this.expr[x],k.expr[x]);if(V!==0)return V}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(k.expr[x]))return!1;return!0}return!1}substituteConstants(){const k=c(this.expr);return k===this.expr?this:u.create(k,this.negated)}evaluate(k){for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].evaluate(k))return!1;return!0}static _normalizeArr(k,x){const N=[];let V=!1;for(const W of k)if(!!W){if(W.type===1){V=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){N.push(...W.expr);continue}N.push(W)}if(N.length===0&&V)return m.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(_);for(let W=1;W<N.length;W++)N[W-1].equals(N[W])&&(N.splice(W,1),W--);if(N.length===1)return N[0];for(;N.length>1;){const W=N[N.length-1];if(W.type!==9)break;N.pop();const $=N.pop(),X=N.length===0,j=w.create(W.expr.map(Q=>u.create([Q,$],null)),null,X);j&&(N.push(j),N.sort(_))}return N.length===1?N[0]:new u(N,x)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let x of this.expr)k.push(...x.keys());return k}map(k){return new u(this.expr.map(x=>x.map(k)),null)}negate(){if(!this.negated){const k=[];for(let x of this.expr)k.push(x.negate());this.negated=w.create(k,this,!0)}return this.negated}}class w{constructor(k,x){this.expr=k,this.negated=x,this.type=9}static create(k,x,N){return w._normalizeArr(k,x,N)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let x=0,N=this.expr.length;x<N;x++){const V=_(this.expr[x],k.expr[x]);if(V!==0)return V}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let x=0,N=this.expr.length;x<N;x++)if(!this.expr[x].equals(k.expr[x]))return!1;return!0}return!1}substituteConstants(){const k=c(this.expr);return k===this.expr?this:w.create(k,this.negated,!1)}evaluate(k){for(let x=0,N=this.expr.length;x<N;x++)if(this.expr[x].evaluate(k))return!0;return!1}static _normalizeArr(k,x,N){let V=[],W=!1;if(k){for(let $=0,X=k.length;$<X;$++){const j=k[$];if(!!j){if(j.type===0){W=!0;continue}if(j.type===1)return m.INSTANCE;if(j.type===9){V=V.concat(j.expr);continue}V.push(j)}}if(V.length===0&&W)return n.INSTANCE;V.sort(_)}if(V.length!==0){if(V.length===1)return V[0];for(let $=1;$<V.length;$++)V[$-1].equals(V[$])&&(V.splice($,1),$--);if(V.length===1)return V[0];if(N){for(let $=0;$<V.length;$++)for(let X=$+1;X<V.length;X++)P(V[$],V[X])&&(V.splice(X,1),X--);if(V.length===1)return V[0]}return new w(V,x)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let x of this.expr)k.push(...x.keys());return k}map(k){return new w(this.expr.map(x=>x.map(k)),null)}negate(){if(!this.negated){let k=[];for(let x of this.expr)k.push(x.negate());for(;k.length>1;){const x=k.shift(),N=k.shift(),V=[];for(const $ of B(x))for(const X of B(N))V.push(u.create([$,X],null));const W=k.length===0;k.unshift(w.create(V,null,W))}this.negated=k[0]}return this.negated}}class f extends a{constructor(k,x,N){super(k,null);this._defaultValue=x,typeof N=="object"?f._info.push({...N,key:k}):N!==!0&&f._info.push({key:k,description:N,type:x!=null?typeof x:void 0})}static all(){return f._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return h.create(this.key,k)}notEqualsTo(k){return v.create(this.key,k)}}e.RawContextKey=f,f._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function y(L,k){return L<k?-1:L>k?1:0}function R(L,k,x,N){return L<x?-1:L>x?1:k<N?-1:k>N?1:0}function P(L,k){if(k.type===6&&L.type!==9&&L.type!==6){for(const V of k.expr)if(L.equals(V))return!0}const x=L.negate(),N=B(x).concat(B(k));N.sort(_);for(let V=0;V<N.length;V++){const $=N[V].negate();for(let X=V+1;X<N.length;X++){const j=N[X];if($.equals(j))return!0}}return!1}e.implies=P;function B(L){return L.type===9?L.expr:[L]}}),define(be[143],Ee([0,1,4]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,l.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,l.refineServiceDecorator)(e.IEnvironmentService)}),define(be[47],Ee([0,1,20,17,9,10,2,122,4]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function I(N){return N.create===!0}e.isFileOpenForWriteOptions=I;var F;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(F=e.FileType||(e.FileType={}));var _;(function(N){N[N.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var n;(function(N){N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock"})(n=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(N){return!!(N.capabilities&2)}e.hasReadWriteCapability=m;function a(N){return!!(N.capabilities&8)}e.hasFileFolderCopyCapability=a;function h(N){return!!(N.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function g(N){return!!(N.capabilities&16)}e.hasFileReadStreamCapability=g;var S;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class v extends Error{constructor(V,W){super(V);this.code=W}}e.FileSystemProviderError=v;function s(N,V){const W=new v(N.toString(),V);return C(W,V),W}e.createFileSystemProviderError=s;function d(N){return N||s((0,A.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=d;function C(N,V){return N.name=V?`${V} (FileSystemError)`:"FileSystemError",N}e.markAsFileSystemProviderError=C;function r(N){if(!N)return S.Unknown;if(N instanceof v)return N.code;const V=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!V)return S.Unknown;switch(V[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=r;function b(N){if(N instanceof w)return N.fileOperationResult;switch(r(N)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=b;var o;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY"})(o=e.FileOperation||(e.FileOperation={}));class i{constructor(V,W,$){this.resource=V,this.operation=W,this.target=$}isOperation(V){return this.operation===V}}e.FileOperationEvent=i;var p;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(p=e.FileChangeType||(e.FileChangeType={}));class c{constructor(V,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;const $=new Map;for(const X of V){const j=$.get(X.type);j?j.push([X.resource,X]):$.set(X.type,[[X.resource,X]])}for(const[X,j]of $)switch(X){case 1:this.added=l.TernarySearchTree.forUris(()=>W),this.added.fill(j);break;case 0:this.updated=l.TernarySearchTree.forUris(()=>W),this.updated.fill(j);break;case 2:this.deleted=l.TernarySearchTree.forUris(()=>W),this.deleted.fill(j);break}}contains(V,...W){return this.doContains(V,{includeChildren:!1},...W)}affects(V,...W){return this.doContains(V,{includeChildren:!0},...W)}doContains(V,W,...$){if(!V)return!1;const X=$.length>0;return!!((!X||$.includes(1))&&(this.added?.get(V)||W.includeChildren&&this.added?.findSuperstr(V))||(!X||$.includes(0))&&(this.updated?.get(V)||W.includeChildren&&this.updated?.findSuperstr(V))||(!X||$.includes(2))&&(this.deleted?.findSubstr(V)||W.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function u(N,V,W){return!N||!V||N===V||V.length>N.length?!1:(V.charAt(V.length-1)!==M.sep&&(V+=M.sep),W?(0,E.startsWithIgnoreCase)(N,V):N.indexOf(V)===0)}e.isParent=u;class w extends Error{constructor(V,W,$){super(V);this.fileOperationResult=W,this.options=$}}e.FileOperationError=w;class f extends w{constructor(V,W,$){super(V,2,$);this.stat=W}}e.NotModifiedSinceFileOperationError=f;var y;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",N[N.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function P(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.etag=P;async function B(N,V){if(!V.hasProvider(t.URI.from({scheme:N.scheme})))return new Promise(W=>{const $=V.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===N.scheme&&X.added&&($.dispose(),W())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class L{static formatSize(V){return(0,T.isNumber)(V)||(V=0),V<L.KB?(0,A.localize)(1,null,V.toFixed(0)):V<L.MB?(0,A.localize)(2,null,(V/L.KB).toFixed(2)):V<L.GB?(0,A.localize)(3,null,(V/L.MB).toFixed(2)):V<L.TB?(0,A.localize)(4,null,(V/L.GB).toFixed(2)):(0,A.localize)(5,null,(V/L.TB).toFixed(2))}}e.ByteSize=L,L.KB=1024,L.MB=L.KB*L.KB,L.GB=L.MB*L.KB,L.TB=L.GB*L.KB;var k;(function(N){N[N.IA32=0]="IA32",N[N.OTHER=1]="OTHER"})(k=e.Arch||(e.Arch={}));function x(N){return{maxFileSize:N===0?300*L.MB:16*L.GB,maxHeapSize:N===0?700*L.MB:2*700*L.MB}}e.getPlatformLimits=x}),define(be[62],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class l{constructor(...E){this._entries=new Map;for(let[T,t]of E)this.set(T,t)}set(E,T){const t=this._entries.get(E);return this._entries.set(E,T),t}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=l}),define(be[144],Ee([0,1,13,16,82,140,4,62]),function(re,e,l,M,E,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class I extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class F{constructor(a=new A.ServiceCollection,h=!1,g){this._activeInstantiations=new Set,this._services=a,this._strict=h,this._parent=g,this._services.set(t.IInstantiationService,this)}createChild(a){return new F(a,this._strict,this)}invokeFunction(a,...h){let g=n.traceInvocation(a),S=!1;try{return a({get:s=>{if(S)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(s,g);if(!d)throw new Error(`[invokeFunction] unknown service '${s}'`);return d}},...h)}finally{S=!0,g.stop()}}createInstance(a,...h){let g,S;return a instanceof E.SyncDescriptor?(g=n.traceCreation(a.ctor),S=this._createInstance(a.ctor,a.staticArguments.concat(h),g)):(g=n.traceCreation(a),S=this._createInstance(a,h,g)),g.stop(),S}_createInstance(a,h=[],g){let S=t._util.getServiceDependencies(a).sort((d,C)=>d.index-C.index),v=[];for(const d of S){let C=this._getOrCreateServiceInstance(d.id,g);if(!C&&this._strict&&!d.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${d.id}.`);v.push(C)}let s=S.length>0?S[0].index:h.length;if(h.length!==s){console.warn(`[createInstance] First service dependency of ${a.name} at position ${s+1} conflicts with ${h.length} static arguments`);let d=s-h.length;d>0?h=h.concat(new Array(d)):h=h.slice(0,s)}return new a(...[...h,...v])}_setServiceInstance(a,h){if(this._services.get(a)instanceof E.SyncDescriptor)this._services.set(a,h);else if(this._parent)this._parent._setServiceInstance(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let h=this._services.get(a);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):h}_getOrCreateServiceInstance(a,h){let g=this._getServiceInstanceOrDescriptor(a);return g instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,g,h.branch(a,!0)):(h.branch(a,!1),g)}_safeCreateAndCacheServiceInstance(a,h,g){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,h,g)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,h,g){const S=new T.Graph(d=>d.id.toString());let v=0;const s=[{id:a,desc:h,_trace:g}];for(;s.length;){const d=s.pop();if(S.lookupOrInsertNode(d),v++>1e3)throw new I(S);for(let C of t._util.getServiceDependencies(d.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(C.id);if(!r&&!C.optional&&console.warn(`[createInstance] ${a} depends on ${C.id} which is NOT registered.`),r instanceof E.SyncDescriptor){const b={id:C.id,desc:r,_trace:d._trace.branch(C.id,!0)};S.insertEdge(d,b),s.push(b)}}}for(;;){const d=S.roots();if(d.length===0){if(!S.isEmpty())throw new I(S);break}for(const{data:C}of d){if(this._getServiceInstanceOrDescriptor(C.id)instanceof E.SyncDescriptor){const b=this._createServiceInstanceWithOwner(C.id,C.desc.ctor,C.desc.staticArguments,C.desc.supportsDelayedInstantiation,C._trace);this._setServiceInstance(C.id,b)}S.removeNode(C)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,h,g=[],S,v){if(this._services.get(a)instanceof E.SyncDescriptor)return this._createServiceInstance(h,g,S,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,h,g,S,v);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(a,h=[],g,S){if(g){const v=new l.IdleValue(()=>this._createInstance(a,h,S));return new Proxy(Object.create(null),{get(s,d){if(d in s)return s[d];let C=v.value,r=C[d];return typeof r!="function"||(r=r.bind(C),s[d]=r),r},set(s,d,C){return v.value[d]=C,!0}})}else return this._createInstance(a,h,S)}}e.InstantiationService=F;var _;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(_||(_={}));class n{constructor(a,h){this.type=a,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return D?new n(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):n._None}static traceCreation(a){return D?new n(0,a.name):n._None}branch(a,h){let g=new n(2,a.toString());return this._dep.push([a,h,g]),g}stop(){let a=Date.now()-this._start;n._totals+=a;let h=!1;function g(v,s){let d=[],C=new Array(v+1).join("	");for(const[r,b,o]of s._dep)if(b&&o){h=!0,d.push(`${C}CREATES -> ${r}`);let i=g(v+1,o);i&&d.push(i)}else d.push(`${C}uses -> ${r}`);return d.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${n._totals.toFixed(2)}ms)`];(a>2||h)&&console.log(S.join(`
`))}}n._None=new class extends n{constructor(){super(-1,null)}stop(){}branch(){return this}},n._totals=0}),define(be[12],Ee([0,1,46,3,6,25,4]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,t.createDecorator)("logService"),e.ILoggerService=(0,t.createDecorator)("loggerService");function A(){return new Date().toISOString()}var D;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;function I(b,o,i){switch(o){case D.Trace:b.trace(i);break;case D.Debug:b.debug(i);break;case D.Info:b.info(i);break;case D.Warning:b.warn(i);break;case D.Error:b.error(i);break;case D.Critical:b.critical(i);break;default:throw new Error("Invalid log level")}}e.log=I;function F(b){let o="";for(let i=0;i<b.length;i++){let p=b[i];if(typeof p=="object")try{p=JSON.stringify(p)}catch(c){}o+=(i>0?" ":"")+p}return o}e.format=F;class _ extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new M.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=_;class n extends _{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...i){this.checkLogLevel(D.Trace)&&this.log(D.Trace,F([o,...i]))}debug(o,...i){this.checkLogLevel(D.Debug)&&this.log(D.Debug,F([o,...i]))}info(o,...i){this.checkLogLevel(D.Info)&&this.log(D.Info,F([o,...i]))}warn(o,...i){this.checkLogLevel(D.Warning)&&this.log(D.Warning,F([o,...i]))}error(o,...i){if(this.checkLogLevel(D.Error))if(o instanceof Error){const p=Array.prototype.slice.call(arguments);p[0]=o.stack,this.log(D.Error,F(p))}else this.log(D.Error,F([o,...i]))}critical(o,...i){this.checkLogLevel(D.Critical)&&this.log(D.Critical,F([o,...i]))}flush(){}}e.AbstractMessageLogger=n;class m extends _{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!T.isWindows}trace(o,...i){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,o,...i):console.log(`[main ${A()}]`,o,...i))}debug(o,...i){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,o,...i):console.log(`[main ${A()}]`,o,...i))}info(o,...i){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,o,...i):console.log(`[main ${A()}]`,o,...i))}warn(o,...i){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,o,...i):console.warn(`[main ${A()}]`,o,...i))}error(o,...i){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,o,...i):console.error(`[main ${A()}]`,o,...i))}critical(o,...i){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,o,...i):console.error(`[main ${A()}]`,o,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class a extends _{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...i){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",o,...i)}debug(o,...i){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...i)}info(o,...i){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",o,...i)}warn(o,...i){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",o,...i)}error(o,...i){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",o,...i)}critical(o,...i){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...i)}dispose(){}flush(){}}e.ConsoleLogger=a;class h extends _{constructor(o,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(i)}trace(o,...i){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(o),...i])}debug(o,...i){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(o),...i])}info(o,...i){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(o),...i])}warn(o,...i){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(o),...i])}error(o,...i){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(o),...i])}critical(o,...i){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(o),...i])}extractMessage(o){return typeof o=="string"?o:(0,l.toErrorMessage)(o,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class g extends _{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const i of this.logServices)i.setLevel(o);super.setLevel(o)}trace(o,...i){for(const p of this.logServices)p.trace(o,...i)}debug(o,...i){for(const p of this.logServices)p.debug(o,...i)}info(o,...i){for(const p of this.logServices)p.info(o,...i)}warn(o,...i){for(const p of this.logServices)p.warn(o,...i)}error(o,...i){for(const p of this.logServices)p.error(o,...i)}critical(o,...i){for(const p of this.logServices)p.critical(o,...i)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=g;class S extends E.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...i){this.logger.trace(o,...i)}debug(o,...i){this.logger.debug(o,...i)}info(o,...i){this.logger.info(o,...i)}warn(o,...i){this.logger.warn(o,...i)}error(o,...i){this.logger.error(o,...i)}critical(o,...i){this.logger.critical(o,...i)}flush(){this.logger.flush()}}e.LogService=S;class v extends E.Disposable{constructor(o,i){super();this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(p=>{this.logLevel=p,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(p))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,i){let p=this.loggers.get(o.toString());return p||(p=this.doCreateLogger(o,i?.always?D.Trace:this.logLevel,i),this.loggers.set(o.toString(),p),i?.always||this.logLevelChangeableLoggers.push(p)),p}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class s{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(o){}getLevel(){return D.Info}trace(o,...i){}debug(o,...i){}info(o,...i){}warn(o,...i){}error(o,...i){}critical(o,...i){}dispose(){}flush(){}}e.NullLogService=s;function d(b){if(b.verbose)return D.Trace;if(typeof b.logLevel=="string"){const o=C(b.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function C(b){switch(b){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=C;function r(b){switch(b){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=r}),define(be[83],Ee([0,1,36,123,4]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var t;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(t=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function I(a,h){return h-a}D.compare=I;const F=Object.create(null);F[D.Error]=(0,M.localize)(0,null),F[D.Warning]=(0,M.localize)(1,null),F[D.Info]=(0,M.localize)(2,null);function _(a){return F[a]||""}D.toString=_;function n(a){switch(a){case l.default.Error:return D.Error;case l.default.Warning:return D.Warning;case l.default.Info:return D.Info;case l.default.Ignore:return D.Hint}}D.fromSeverity=n;function m(a){switch(a){case D.Error:return l.default.Error;case D.Warning:return l.default.Warning;case D.Info:return l.default.Info;case D.Hint:return l.default.Ignore}}D.toSeverity=m}(t=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(D){const I="";function F(n){return _(n,!0)}D.makeKey=F;function _(n,m){let a=[I];return n.source?a.push(n.source.replace("\xA6","\\\xA6")):a.push(I),n.code?typeof n.code=="string"?a.push(n.code.replace("\xA6","\\\xA6")):a.push(n.code.value.replace("\xA6","\\\xA6")):a.push(I),n.severity!==void 0&&n.severity!==null?a.push(t.toString(n.severity)):a.push(I),n.message&&m?a.push(n.message.replace("\xA6","\\\xA6")):a.push(I),n.startLineNumber!==void 0&&n.startLineNumber!==null?a.push(n.startLineNumber.toString()):a.push(I),n.startColumn!==void 0&&n.startColumn!==null?a.push(n.startColumn.toString()):a.push(I),n.endLineNumber!==void 0&&n.endLineNumber!==null?a.push(n.endLineNumber.toString()):a.push(I),n.endColumn!==void 0&&n.endColumn!==null?a.push(n.endColumn.toString()):a.push(I),a.push(I),a.join("\xA6")}D.makeKeyOptionalMessage=_})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[145],Ee([0,1,3,36,4]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=M.default,e.INotificationService=(0,E.createDecorator)("notificationService");var T;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var t;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(t=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new D,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(F){}updateMessage(F){}updateActions(F){}close(){}}e.NoOpNotification=A;class D{infinite(){}done(){}total(F){}worked(F){}}e.NoOpProgress=D}),define(be[146],Ee([0,1,6,9,2,4]),function(re,e,l,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return l.Disposable.None},registerValidator(){return l.Disposable.None},registerExternalUriResolver(){return l.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return l.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function t(D,I){return E.URI.isUri(D)?(0,M.equalsIgnoreCase)(D.scheme,I):(0,M.startsWithIgnoreCase)(D,I+":")}e.matchesScheme=t;function A(D,...I){return I.some(F=>t(D,F))}e.matchesSomeScheme=A});var Ue=this&&this.__decorate||function(re,e,l,M){var E=arguments.length,T=E<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,l):M,t;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(re,e,l,M);else for(var A=re.length-1;A>=0;A--)(t=re[A])&&(T=(E<3?t(T):E>3?t(e,l,T):t(e,l))||T);return E>3&&T&&Object.defineProperty(e,l,T),T},Be=this&&this.__param||function(re,e){return function(l,M){e(l,M,re)}};define(be[147],Ee([0,1,13,21,6,4]),function(re,e,l,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,T.createDecorator)("progressService");var t;(function(F){F[F.Explorer=1]="Explorer",F[F.Scm=3]="Scm",F[F.Extensions=5]="Extensions",F[F.Window=10]="Window",F[F.Notification=15]="Notification",F[F.Dialog=20]="Dialog"})(t=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let D=class extends E.Disposable{constructor(_,n){super();this.deferred=new l.DeferredPromise,n.withProgress(_,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};D=Ue([Be(1,e.IProgressService)],D),e.UnmanagedProgress=D;class I extends E.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(_){this.stop();const n=++this.currentOperationId,m=new M.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{n===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:n,token:m.token,stop:()=>this.doStop(n),isCurrent:()=>this.currentOperationId===n}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,T.createDecorator)("editorProgressService")}),define(be[30],Ee([0,1,43,10]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(t,A){l.ok(M.isString(t)),l.ok(M.isObject(A)),l.ok(!this.data.has(t),"There is already an extension with this id"),this.data.set(t,A)}knows(t){return this.data.has(t)}as(t){return this.data.get(t)||null}}e.Registry=new E}),define(be[84],Ee([0,1,3,30]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class T{constructor(){this._onDidChangeSchema=new l.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,I){this.schemasById[E(D)]=I,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const t=new T;M.Registry.add(e.Extensions.JSONContribution,t)}),define(be[63],Ee([0,1,15,3,10,120,84,30]),function(re,e,l,M,E,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const F=A.Registry.as(t.Extensions.JSONContribution);class _{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new M.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new M.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(s,d=!0){this.registerConfigurations([s],d)}registerConfigurations(s,d=!0){const C=this.doRegisterConfigurations(s,d);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}deregisterConfigurations(s){const d=this.doDeregisterConfigurations(s);F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}updateConfigurations({add:s,remove:d}){const C=[];C.push(...this.doDeregisterConfigurations(d)),C.push(...this.doRegisterConfigurations(s,!1)),F.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,l.distinct)(C))}registerDefaultConfigurations(s){const d=[],C=[];for(const r of s)for(const b in r)if(d.push(b),e.OVERRIDE_PROPERTY_PATTERN.test(b)){this.defaultValues[b]={...this.defaultValues[b]||{},...r[b]};const o={type:"object",default:this.defaultValues[b],description:T.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId};C.push(m(b)),this.configurationProperties[b]=o,this.defaultLanguageConfigurationOverridesNode.properties[b]=o}else{this.defaultValues[b]=r[b];const o=this.configurationProperties[b];o&&(this.updatePropertyDefaultValue(b,o),this.updateSchema(b,o))}this.registerOverrideIdentifiers(C),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterDefaultConfigurations(s){const d=[];for(const C of s)for(const r in C)if(d.push(r),delete this.defaultValues[r],e.OVERRIDE_PROPERTY_PATTERN.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const b=this.configurationProperties[r];b&&(this.updatePropertyDefaultValue(r,b),this.updateSchema(r,b))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const d of s)this.overrideIdentifiers.add(d);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,d){const C=[];return s.forEach(r=>{C.push(...this.validateAndRegisterProperties(r,d,r.extensionInfo)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),C}doDeregisterConfigurations(s){const d=[],C=r=>{if(r.properties)for(const b in r.properties)d.push(b),delete this.configurationProperties[b],this.removeFromSchema(b,r.properties[b]);r.allOf&&r.allOf.forEach(b=>C(b))};for(const r of s){C(r);const b=this.configurationContributors.indexOf(r);b!==-1&&this.configurationContributors.splice(b,1)}return d}validateAndRegisterProperties(s,d=!0,C,r=3){r=E.isUndefinedOrNull(s.scope)?r:s.scope;let b=[],o=s.properties;if(o)for(let p in o){if(d&&g(p)){delete o[p];continue}const c=o[p];if(this.updatePropertyDefaultValue(p,c),e.OVERRIDE_PROPERTY_PATTERN.test(p)?c.scope=void 0:(c.scope=E.isUndefinedOrNull(c.scope)?r:c.scope,c.restricted=E.isUndefinedOrNull(c.restricted)?!!C?.restrictedConfigurations?.includes(p):c.restricted),o[p].hasOwnProperty("included")&&!o[p].included){this.excludedConfigurationProperties[p]=o[p],delete o[p];continue}else this.configurationProperties[p]=o[p];!o[p].deprecationMessage&&o[p].markdownDeprecationMessage&&(o[p].deprecationMessage=o[p].markdownDeprecationMessage),b.push(p)}let i=s.allOf;if(i)for(let p of i)b.push(...this.validateAndRegisterProperties(p,d,C,r));return b}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(s){const d=C=>{let r=C.properties;if(r)for(const o in r)this.updateSchema(o,r[o]);let b=C.allOf;b&&b.forEach(d)};d(s)}updateSchema(s,d){switch(e.allSettings.properties[s]=d,d.scope){case 1:e.applicationSettings.properties[s]=d;break;case 2:e.machineSettings.properties[s]=d;break;case 6:e.machineOverridableSettings.properties[s]=d;break;case 3:e.windowSettings.properties[s]=d;break;case 4:e.resourceSettings.properties[s]=d;break;case 5:e.resourceSettings.properties[s]=d,this.resourceLanguageSettingsSchema.properties[s]=d;break}}removeFromSchema(s,d){switch(delete e.allSettings.properties[s],d.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const d=`[${s}]`,C={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(d,C),e.allSettings.properties[d]=C,e.applicationSettings.properties[d]=C,e.machineSettings.properties[d]=C,e.machineOverridableSettings.properties[d]=C,e.windowSettings.properties[d]=C,e.resourceSettings.properties[d]=C}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,d){let C=this.defaultValues[s];E.isUndefined(C)&&(C=d.default),E.isUndefined(C)&&(C=a(d.type)),d.default=C}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function m(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=m;function a(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const h=new _;A.Registry.add(e.Extensions.Configuration,h);function g(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?T.localize(5,null,v):h.getConfigurationProperties()[v]!==void 0?T.localize(6,null,v):null:T.localize(4,null)}e.validateProperty=g;function S(){const v=[],s=h.getConfigurationProperties();for(const d of Object.keys(s))v.push([d,s[d].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=S}),define(be[85],Ee([0,1,23,10,2,63,4,30]),function(re,e,l,M,E,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,t.createDecorator)("configurationService");function D(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof E.URI)}e.isConfigurationOverrides=D;var I;(function(b){b[b.USER=1]="USER",b[b.USER_LOCAL=2]="USER_LOCAL",b[b.USER_REMOTE=3]="USER_REMOTE",b[b.WORKSPACE=4]="WORKSPACE",b[b.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",b[b.DEFAULT=6]="DEFAULT",b[b.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function F(b){switch(b){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=F;function _(b,o){const i=o?b?o.keys.filter(R=>b.keys.indexOf(R)===-1):[...o.keys]:[],p=b?o?b.keys.filter(R=>o.keys.indexOf(R)===-1):[...b.keys]:[],c=[];if(o&&b){for(const R of b.keys)if(o.keys.indexOf(R)!==-1){const P=S(b.contents,R),B=S(o.contents,R);l.equals(P,B)||c.push(R)}}const u=[],w=R=>{const P={};for(const B of R)for(const L of B.identifiers)P[C(L)]=B;return P},f=o?w(o.overrides):{},y=b?w(b.overrides):{};if(Object.keys(f).length)for(const R of i){const P=f[R];P&&u.push([(0,T.overrideIdentifierFromKey)(R),P.keys])}if(Object.keys(y).length)for(const R of p){const P=y[R];P&&u.push([(0,T.overrideIdentifierFromKey)(R),P.keys])}if(Object.keys(f).length&&Object.keys(y).length)for(const R of c){const P=y[R],B=f[R];if(P&&B){const L=_({contents:P.contents,keys:P.keys,overrides:[]},{contents:B.contents,keys:B.keys,overrides:[]});u.push([(0,T.overrideIdentifierFromKey)(R),[...L.added,...L.removed,...L.updated]])}}return{added:i,removed:p,updated:c,overrides:u}}e.compare=_;function n(b,o){const i=[];for(const p of Object.keys(b))if(T.OVERRIDE_PROPERTY_PATTERN.test(p)){const c={};for(const u in b[p])c[u]=b[p][u];i.push({identifiers:[(0,T.overrideIdentifierFromKey)(p).trim()],keys:Object.keys(c),contents:m(c,o)})}return i}e.toOverrides=n;function m(b,o){const i=Object.create(null);for(let p in b)a(i,p,b[p],o);return i}e.toValuesTree=m;function a(b,o,i,p){const c=o.split("."),u=c.pop();let w=b;for(let f=0;f<c.length;f++){let y=c[f],R=w[y];switch(typeof R){case"undefined":R=w[y]=Object.create(null);break;case"object":break;default:p(`Ignoring ${o} as ${c.slice(0,f+1).join(".")} is ${JSON.stringify(R)}`);return}w=R}if(typeof w=="object"&&w!==null)try{w[u]=i}catch(f){p(`Ignoring ${o} as ${c.join(".")} is ${JSON.stringify(w)}`)}else p(`Ignoring ${o} as ${c.join(".")} is ${JSON.stringify(w)}`)}e.addToValueTree=a;function h(b,o){const i=o.split(".");g(b,i)}e.removeFromValueTree=h;function g(b,o){const i=o.shift();if(o.length===0){delete b[i];return}if(Object.keys(b).indexOf(i)!==-1){const p=b[i];typeof p=="object"&&!Array.isArray(p)&&(g(p,o),Object.keys(p).length===0&&delete b[i])}}function S(b,o,i){function p(w,f){let y=w;for(const R of f){if(typeof y!="object"||y===null)return;y=y[R]}return y}const c=o.split("."),u=p(b,c);return typeof u=="undefined"?i:u}e.getConfigurationValue=S;function v(b,o,i){Object.keys(o).forEach(p=>{p!=="__proto__"&&(p in b?M.isObject(b[p])&&M.isObject(o[p])?v(b[p],o[p],i):i&&(b[p]=o[p]):b[p]=o[p])})}e.merge=v;function s(){const b=A.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(b)}e.getConfigurationKeys=s;function d(){const b=Object.create(null),o=A.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let i in o){let p=o[i].default;a(b,i,p,c=>console.error(`Conflict in default settings: ${c}`))}return b}e.getDefaultValues=d;function C(b){return`[${b}]`}e.keyFromOverrideIdentifier=C;function r(b,o,i){const p=b.inspect(o),c=b.inspect(i);return typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:p.defaultValue}e.getMigratedSettingValue=r}),define(be[148],Ee([0,1,15,3,102,6,20,23,10,2,85,63,30]),function(re,e,l,M,E,T,t,A,D,I,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(r={},b=[],o=[]){this._contents=r,this._keys=b,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,F.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,b){const o=this.getContentsForOverrideIdentifer(b);return o?r?(0,F.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){for(const b of this.overrides)if(b.identifiers.indexOf(r)!==-1)return b.keys;return[]}override(r){let b=this.overrideConfigurations.get(r);return b||(b=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,b)),b}merge(...r){const b=A.deepClone(this.contents),o=A.deepClone(this.overrides),i=[...this.keys];for(const p of r){this.mergeContents(b,p.contents);for(const c of p.overrides){const[u]=o.filter(w=>l.equals(w.identifiers,c.identifiers));u?this.mergeContents(u.contents,c.contents):o.push(A.deepClone(c))}for(const c of p.keys)i.indexOf(c)===-1&&i.push(c)}return new m(b,i,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const b=this.getContentsForOverrideIdentifer(r);if(!b||typeof b!="object"||!Object.keys(b).length)return this;let o={};for(const i of l.distinct([...Object.keys(this.contents),...Object.keys(b)])){let p=this.contents[i],c=b[i];c&&(typeof p=="object"&&typeof c=="object"?(p=A.deepClone(p),this.mergeContents(p,c)):p=c),o[i]=p}return new m(o,this.keys,this.overrides)}mergeContents(r,b){for(const o of Object.keys(b)){if(o in r&&D.isObject(r[o])&&D.isObject(b[o])){this.mergeContents(r[o],b[o]);continue}r[o]=A.deepClone(b[o])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?A.deepFreeze(r):r}getContentsForOverrideIdentifer(r){for(const b of this.overrides)if(b.identifiers.indexOf(r)!==-1)return b.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,b){this.addKey(r),(0,F.addToValueTree)(this.contents,r,b,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,F.removeFromValueTree)(this.contents,r)}addKey(r){let b=this.keys.length;for(let o=0;o<b;o++)r.indexOf(this.keys[o])===0&&(b=o);this.keys.splice(b,1,r)}removeKey(r){let b=this.keys.indexOf(r);return b!==-1?(this.keys.splice(b,1),!0):!1}}e.ConfigurationModel=m;class a extends m{constructor(){const r=(0,F.getDefaultValues)(),b=(0,F.getConfigurationKeys)(),o=[];for(const i of Object.keys(r))_.OVERRIDE_PROPERTY_PATTERN.test(i)&&o.push({identifiers:[(0,_.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(r[i]),contents:(0,F.toValuesTree)(r[i],p=>console.error(`Conflict in default settings file: ${p}`))});super(r,b,o)}}e.DefaultConfigurationModel=a;class h{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,b){if(!D.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,b)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,b){this._raw=r;const{contents:o,keys:i,overrides:p,restricted:c}=this.doParseRaw(r,b);this._configurationModel=new m(o,i,p),this._restrictedConfigurations=c||[]}doParseContent(r){let b={},o=null,i=[],p=[],c=[];function u(f){Array.isArray(i)?i.push(f):o!==null&&(i[o]=f)}let w={onObjectBegin:()=>{let f={};u(f),p.push(i),i=f,o=null},onObjectProperty:f=>{o=f},onObjectEnd:()=>{i=p.pop()},onArrayBegin:()=>{let f=[];u(f),p.push(i),i=f,o=null},onArrayEnd:()=>{i=p.pop()},onLiteralValue:u,onError:(f,y,R)=>{c.push({error:f,offset:y,length:R})}};if(r)try{E.visit(r,w),b=i[0]||{}}catch(f){console.error(`Error while parsing settings file ${this._name}: ${f}`),this._parseErrors=[f]}return b}doParseRaw(r,b){const o=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),i=this.filter(r,o,!0,b);r=i.raw;const p=(0,F.toValuesTree)(r,w=>console.error(`Conflict in settings file ${this._name}: ${w}`)),c=Object.keys(r),u=(0,F.toOverrides)(r,w=>console.error(`Conflict in settings file ${this._name}: ${w}`));return{contents:p,keys:c,overrides:u,restricted:i.restricted}}filter(r,b,o,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:r,restricted:[]};const p={},c=[];for(let u in r)if(_.OVERRIDE_PROPERTY_PATTERN.test(u)&&o){const w=this.filter(r[u],b,!1,i);p[u]=w.raw,c.push(...w.restricted)}else{const w=b[u],f=w?typeof w.scope!="undefined"?w.scope:3:void 0;w?.restricted&&c.push(u),(f===void 0||i.scopes===void 0||i.scopes.includes(f))&&(i.skipRestricted&&w?.restricted||(p[u]=r[u]))}return{raw:p,restricted:c}}}e.ConfigurationModelParser=h;class g extends T.Disposable{constructor(r,b,o,i){super();this.userSettingsResource=r,this.scopes=b,this.fileService=i,this._onDidChange=this._register(new M.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(M.Event.filter(this.fileService.onDidFilesChange,p=>p.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class S{constructor(r,b,o=new m,i=new m,p=new t.ResourceMap,c=new m,u=new t.ResourceMap,w=!0){this._defaultConfiguration=r,this._localUserConfiguration=b,this._remoteUserConfiguration=o,this._workspaceConfiguration=i,this._folderConfigurations=p,this._memoryConfiguration=c,this._memoryConfigurationByResource=u,this._freeze=w,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new t.ResourceMap,this._userConfiguration=null}getValue(r,b,o){return this.getConsolidateConfigurationModel(b,o).getValue(r)}updateValue(r,b,o={}){let i;o.resource?(i=this._memoryConfigurationByResource.get(o.resource),i||(i=new m,this._memoryConfigurationByResource.set(o.resource,i))):i=this._memoryConfiguration,b===void 0?i.removeValue(r):i.setValue(r,b),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,b,o){const i=this.getConsolidateConfigurationModel(b,o),p=this.getFolderConfigurationModelForResource(b.resource,o),c=b.resource?this._memoryConfigurationByResource.get(b.resource)||this._memoryConfiguration:this._memoryConfiguration,u=b.overrideIdentifier?this._defaultConfiguration.freeze().override(b.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),w=b.overrideIdentifier?this.userConfiguration.freeze().override(b.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),f=b.overrideIdentifier?this.localUserConfiguration.freeze().override(b.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),y=b.overrideIdentifier?this.remoteUserConfiguration.freeze().override(b.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),R=o?b.overrideIdentifier?this._workspaceConfiguration.freeze().override(b.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,P=p?b.overrideIdentifier?p.freeze().override(b.overrideIdentifier).getValue(r):p.freeze().getValue(r):void 0,B=b.overrideIdentifier?c.override(b.overrideIdentifier).getValue(r):c.getValue(r),L=i.getValue(r),k=l.distinct(l.flatten(i.overrides.map(x=>x.identifiers))).filter(x=>i.getOverrideValue(r,x)!==void 0);return{defaultValue:u,userValue:w,userLocalValue:f,userRemoteValue:y,workspaceValue:R,workspaceFolderValue:P,memoryValue:B,value:L,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:b.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,b.overrideIdentifier):void 0}:void 0,user:w!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:b.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,b.overrideIdentifier):void 0}:void 0,userLocal:f!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:b.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,b.overrideIdentifier):void 0}:void 0,userRemote:y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:b.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,b.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:b.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,b.overrideIdentifier):void 0}:void 0,workspaceFolder:P!==void 0?{value:p?.freeze().getValue(r),override:b.overrideIdentifier?p?.freeze().getOverrideValue(r,b.overrideIdentifier):void 0}:void 0,memory:B!==void 0?{value:c.getValue(r),override:b.overrideIdentifier?c.getOverrideValue(r,b.overrideIdentifier):void 0}:void 0,overrideIdentifiers:k.length?k:void 0}}keys(r){const b=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:b?b.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,b){this._folderConfigurations.set(r,b),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,b){const o=b.filter(i=>_.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const p=(0,_.overrideIdentifierFromKey)(i),c=this._defaultConfiguration.getKeysForOverrideIdentifier(p),u=r.getKeysForOverrideIdentifier(p),w=[...u.filter(f=>c.indexOf(f)===-1),...c.filter(f=>u.indexOf(f)===-1),...c.filter(f=>!A.equals(this._defaultConfiguration.override(p).getValue(f),r.override(p).getValue(f)))];return[p,w]});return this.updateDefaultConfiguration(r),{keys:b,overrides:o}}compareAndUpdateLocalUserConfiguration(r){const{added:b,updated:o,removed:i,overrides:p}=(0,F.compare)(this.localUserConfiguration,r),c=[...b,...o,...i];return c.length&&this.updateLocalUserConfiguration(r),{keys:c,overrides:p}}compareAndUpdateRemoteUserConfiguration(r){const{added:b,updated:o,removed:i,overrides:p}=(0,F.compare)(this.remoteUserConfiguration,r);let c=[...b,...o,...i];return c.length&&this.updateRemoteUserConfiguration(r),{keys:c,overrides:p}}compareAndUpdateWorkspaceConfiguration(r){const{added:b,updated:o,removed:i,overrides:p}=(0,F.compare)(this.workspaceConfiguration,r);let c=[...b,...o,...i];return c.length&&this.updateWorkspaceConfiguration(r),{keys:c,overrides:p}}compareAndUpdateFolderConfiguration(r,b){const o=this.folderConfigurations.get(r),{added:i,updated:p,removed:c,overrides:u}=(0,F.compare)(o,b);let w=[...i,...p,...c];return(w.length||!o)&&this.updateFolderConfiguration(r,b),{keys:w,overrides:u}}compareAndDeleteFolderConfiguration(r){const b=this.folderConfigurations.get(r);if(!b)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:i,removed:p,overrides:c}=(0,F.compare)(b,void 0);return{keys:[...o,...i,...p],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,b){let o=this.getConsolidatedConfigurationModelForResource(r,b);return r.overrideIdentifier?o.override(r.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:r},b){let o=this.getWorkspaceConsolidatedConfiguration();if(b&&r){const i=b.getFolder(r);i&&(o=this.getFolderConsolidatedConfiguration(i.uri)||o);const p=this._memoryConfigurationByResource.get(r);p&&(o=o.merge(p))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let b=this._foldersConsolidatedConfigurations.get(r);if(!b){const o=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(r);i?(b=o.merge(i),this._freeze&&(b=b.freeze()),this._foldersConsolidatedConfigurations.set(r,b)):b=o}return b}getFolderConfigurationModelForResource(r,b){if(b&&r){const o=b.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,b)=>{const{contents:o,overrides:i,keys:p}=this._folderConfigurations.get(b);return r.push([b,{contents:o,overrides:i,keys:p}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(b=>r.add(b)),this.userConfiguration.freeze().keys.forEach(b=>r.add(b)),this._workspaceConfiguration.freeze().keys.forEach(b=>r.add(b)),this._folderConfigurations.forEach(b=>b.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const b=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>b.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>b.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>b.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(i=>b.add(i))),[...b.values()]}static parse(r){const b=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.user),i=this.parseConfigurationModel(r.workspace),p=r.folders.reduce((c,u)=>(c.set(I.URI.revive(u[0]),this.parseConfigurationModel(u[1])),c),new t.ResourceMap);return new S(b,o,new m,i,p,new m,new t.ResourceMap,!1)}static parseConfigurationModel(r){return new m(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=S;function v(...C){if(C.length===0)return{keys:[],overrides:[]};if(C.length===1)return C[0];const r=new Set,b=new Map;for(const i of C)i.keys.forEach(p=>r.add(p)),i.overrides.forEach(([p,c])=>{const u=(0,t.getOrSet)(b,p,new Set);c.forEach(w=>u.add(w))});const o=[];return b.forEach((i,p)=>o.push([p,[...i.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=v;class s{constructor(r,b,o,i){this.change=r,this.previous=b,this.currentConfiguraiton=o,this.currentWorkspace=i,this._previousConfiguration=void 0;const p=new Set;r.keys.forEach(u=>p.add(u)),r.overrides.forEach(([,u])=>u.forEach(w=>p.add(w))),this.affectedKeys=[...p.values()];const c=new m;this.affectedKeys.forEach(u=>c.setValue(u,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,b){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(b){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,b,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(r,b,this.currentWorkspace);return!A.equals(o,i)}return!0}return!1}doesAffectedKeysTreeContains(r,b){let o=(0,F.toValuesTree)({[b]:!0},()=>{}),i;for(;typeof o=="object"&&(i=Object.keys(o)[0]);){if(r=r[i],!r)return!1;o=o[i]}return!0}}e.ConfigurationChangeEvent=s;class d extends s{constructor(r,b,o,i){super({keys:r.allKeys(),overrides:[]},void 0,r,b);this.source=o,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=d}),define(be[86],Ee([0,1,4]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,l.createDecorator)("remoteAuthorityResolverService");var M;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(M=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(t,A=M.Unknown,D){super(t);this._message=t,this._code=A,this._detail=D,this.isHandled=A===M.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(t){return t instanceof E&&t._code===M.TemporarilyNotAvailable}static isNoResolverFound(t){return t instanceof E&&t._code===M.NoResolverFound}static isHandled(t){return t instanceof E&&t.isHandled}}e.RemoteAuthorityResolverError=E}),define(be[64],Ee([0,1,11]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function M(I){return I.scheme===l.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=M;function E(I){if(!I)return;const F=I.indexOf("+");return F<0?I:I.substr(0,F)}e.getRemoteName=E;function T(I){return I.scheme!==l.Schemas.file&&I.scheme!==l.Schemas.vscodeRemote}e.isVirtualResource=T;function t(I){if(I.folders.length)return I.folders.every(F=>T(F.uri))?I.folders[0].uri:void 0;if(I.configuration&&T(I.configuration))return I.configuration}e.getVirtualWorkspaceLocation=t;function A(I){return t(I)?.scheme}e.getVirtualWorkspaceScheme=A;function D(I){return t(I)!==void 0}e.isVirtualWorkspace=D}),define(be[26],Ee([0,1,9,4,64]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=T;function t(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=t,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class D{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,a){if(typeof m=="undefined"||m===null)return typeof a=="undefined"||a===null;if(typeof a=="undefined"||a===null)return!1;if(typeof m=="string"||typeof a=="string"){let h=typeof m=="string"?m:m.value,g=typeof a=="string"?a:a.value;return l.equalsIgnoreCase(h,g)}return m._lower===a._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=D;function I(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function F(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=F;function _(n,m){if(m){const a=`onResolveRemoteAuthority:${(0,E.getRemoteName)(m)}`;return n.activationEvents?.indexOf(a)!==-1}return!1}e.isResolverExtension=_,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[149],Ee([0,1,9,26]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(a,h){return a.uuid&&h.uuid?a.uuid===h.uuid:a.id===h.id?!0:(0,l.compareIgnoreCase)(a.id,h.id)===0}e.areSameExtensions=E;class T{constructor(h,g){this.version=g,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof T?E(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=T;function t(a,h){return`${a}.${h}`}e.getExtensionId=t;function A(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function D(a,h){return A(t(a,h))}e.getGalleryExtensionId=D;function I(a,h){const g=[],S=v=>{for(const s of g)if(s.some(d=>E(h(d),h(v))))return s;return null};for(const v of a){const s=S(v);s?s.push(v):g.push([v])}return g}e.groupByExtension=I;function F(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=F;function _(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new M.ExtensionIdentifier("pprice.better-merge");function n(a){const h=new Set;for(const g of a)g.malicious&&h.add(g.id.id);return h}e.getMaliciousExtensionsSet=n;function m(a,h){const g=[],S=h.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const v=S.shift();if(v&&g.every(s=>!E(s.identifier,{id:v}))){const s=a.filter(d=>E(d.identifier,{id:v}));s.length===1&&(g.push(s[0]),S.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}e.getExtensionDependencies=m}),define(be[150],Ee([0,1,3,25,4,12]),function(re,e,l,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,E.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,E.createDecorator)("sharedTunnelsService");var t;(function(a){a.Http="http",a.Https="https"})(t=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function F(a){return e.LOCALHOST_ADDRESSES.indexOf(a)>=0}e.isLocalhost=F,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function _(a){return e.ALL_INTERFACES_ADDRESSES.indexOf(a)>=0}e.isAllInterfaces=_;function n(a,h){return h?h!==1&&a<1024:!M.isWindows&&a<1024}e.isPortPrivileged=n;let m=class{constructor(h){this.logService=h,this._onTunnelOpened=new l.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new l.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new l.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h,g){return this._tunnelProvider=h,h?(this._canElevate=g.elevation,this._privacyOptions=g.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],g=Array.from(this._tunnels.values());for(let S of g){const v=Array.from(S.values());for(let s of v){const d=await s.value;d&&h.push(d)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:g}of h.values())await g.then(S=>S?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,g,S,v,s=!1,d=A.Private,C){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${S} on local port ${v}.`),!h)return;g||(g="localhost");const r=this.retainOrCreateTunnel(h,g,S,v,s,d,C);return r?r.then(b=>{if(!b){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(g,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(b);return(b.tunnelRemoteHost!==g||b.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const g=this._tunnels.get(h.tunnelRemoteHost);if(g){const S=g.get(h.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,S))}}}}async tryDisposeTunnel(h,g,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${g}.`);const v=S.value.then(async s=>{s&&(await s.dispose(!0),this._onTunnelClosed.fire({host:s.tunnelRemoteHost,port:s.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(g),v}}async closeTunnel(h,g){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${g} `);const S=this._tunnels.get(h);if(S&&S.has(g)){const v=S.get(g);v.refcount=0,await this.tryDisposeTunnel(h,g,v)}}addTunnelToMap(h,g,S){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(g,{refcount:1,value:S})}async removeEmptyTunnelFromMap(h,g){const S=this._tunnels.get(h);S&&(await S.get(g)||S.delete(g),S.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,g){let S=[h];F(h)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):_(h)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const v=S.map(s=>this._tunnels.get(s));for(const s of v){const d=s?.get(g);if(d)return d}}canTunnel(h){return!!I(h)}createWithProvider(h,g,S,v,s,d,C){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${S} on local port ${v}.`);const b={elevationRequired:s?n(v===void 0?S:v):!1},o={remoteAddress:{host:g,port:S},localAddressPort:v,privacy:d,public:d!==A.Private,protocol:C},i=h.forwardPort(o,b);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(g,S,i),i}};m=Ue([Be(0,T.ILogService)],m),e.AbstractTunnelService=m}),define(be[151],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class l{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,T,t=5){let A;return A=T(D=>{const I=typeof D=="string"?D:D.data;let F=this._terminalBufferMap.get(E);if(F){F.data.push(I);return}const _=setTimeout(()=>this.flushBuffer(E),t);F={data:[I],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(E),A.dispose()}},this._terminalBufferMap.set(E,F)}),A}stopBuffering(E){const T=this._terminalBufferMap.get(E);T&&T.dispose()}flushBuffer(E){const T=this._terminalBufferMap.get(E);T&&(this._terminalBufferMap.delete(E),this._callback(E,T.data.join("")))}}e.TerminalDataBufferer=l}),define(be[152],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var l;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST="hc"})(l=e.ColorScheme||(e.ColorScheme={}))}),define(be[48],Ee([0,1,35,3,6,4,30,152]),function(re,e,l,M,E,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var D;(function(g){function S(v){return v&&typeof v=="object"&&typeof v.id=="string"}g.isThemeColor=S})(D=e.ThemeColor||(e.ThemeColor={}));function I(g){return{id:g}}e.themeColorFromId=I;var F;(function(g){function S(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||D.isThemeColor(o.color))}g.isThemeIcon=S;const v=new RegExp(`^\\$\\((${l.CSSIcon.iconNameExpression}(?:${l.CSSIcon.iconModifierExpression})?)\\)$`);function s(o){const i=v.exec(o);if(!i)return;let[,p]=i;return{id:p}}g.fromString=s;function d(o,i){let p=o.id;const c=p.lastIndexOf("~");return c!==-1&&(p=p.substring(0,c)),i&&(p=`${p}~${i}`),{id:p}}g.modify=d;function C(o){const i=o.id.lastIndexOf("~");if(i!==-1)return o.id.substring(i+1)}g.getModifier=C;function r(o,i){return o.id===i.id&&o.color?.id===i.color?.id}g.isEqual=r;function b(o,i){return{id:o.id,color:i?I(i):void 0}}g.asThemeIcon=b,g.asClassNameArray=l.CSSIcon.asClassNameArray,g.asClassName=l.CSSIcon.asClassName,g.asCSSSelector=l.CSSIcon.asCSSSelector})(F=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=l.Codicon.file,e.FolderThemeIcon=l.Codicon.folder;function _(g){switch(g){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class n{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new M.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,E.toDisposable)(()=>{const v=this.themingParticipants.indexOf(S);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new n;t.Registry.add(e.Extensions.ThemingContribution,m);function a(g){return m.onColorThemeChange(g)}e.registerThemingParticipant=a;class h extends E.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,v){let s=this.theme.getColor(S);return s&&v&&(s=v(s,this.theme)),s?s.toString():null}}e.Themable=h}),define(be[153],Ee([0,1,13,35,3,124,84,30,48]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class I{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${M.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(S,v,s,d){const C=this.iconsById[S];if(C){if(s&&!C.description){C.description=s,this.iconSchema.properties[S].markdownDescription=`${s} $(${S})`;const o=this.iconReferenceSchema.enum.indexOf(S);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=s),this._onDidChange.fire()}return C}let r={id:S,description:s,defaults:v,deprecationMessage:d};this.iconsById[S]=r;let b={$ref:"#/definitions/icons"};return d&&(b.deprecationMessage=d),s&&(b.markdownDescription=`${s}: $(${S})`),this.iconSchema.properties[S]=b,this.iconReferenceSchema.enum.push(S),this.iconReferenceSchema.enumDescriptions.push(s||""),this._onDidChange.fire(),{id:S}}deregisterIcon(S){delete this.iconsById[S],delete this.iconSchema.properties[S];const v=this.iconReferenceSchema.enum.indexOf(S);v!==-1&&(this.iconReferenceSchema.enum.splice(v,1),this.iconReferenceSchema.enumDescriptions.splice(v,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(S=>this.iconsById[S])}getIcon(S){return this.iconsById[S]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(S,v){const s=this.iconFontsById[S];if(s)return s;let d={id:S,definition:v};return this.iconFontsById[S]=d,this._onDidChange.fire(),d}deregisterIconFont(S){delete this.iconFontsById[S]}getIconFonts(){return Object.keys(this.iconFontsById).map(S=>this.iconFontsById[S])}getIconFont(S){return this.iconFontsById[S]}toString(){const S=(C,r)=>C.id.localeCompare(r.id),v=C=>{for(;D.ThemeIcon.isThemeIcon(C.defaults);)C=this.iconsById[C.defaults.id];return`codicon codicon-${C?C.id:""}`};let s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.iconsById).map(C=>this.iconsById[C]);for(const C of d.filter(r=>!!r.description).sort(S))s.push(`|<i class="${v(C)}"></i>|${C.id}|${D.ThemeIcon.isThemeIcon(C.defaults)?C.defaults.id:C.id}|${C.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const C of d.filter(r=>!D.ThemeIcon.isThemeIcon(r.defaults)).sort(S))s.push(`|<i class="${v(C)}"></i>|${C.id}|`);return s.join(`
`)}}const F=new I;A.Registry.add(e.Extensions.IconContribution,F);function _(g,S,v,s){return F.registerIcon(g,S,v,s)}e.registerIcon=_;function n(){return F}e.getIconRegistry=n;function m(){for(const g of M.iconRegistry.all)F.registerIcon(g.id,g.definition,g.description);M.iconRegistry.onDidRegister(g=>F.registerIcon(g.id,g.definition,g.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let a=A.Registry.as(t.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,F.getIconSchema());const h=new l.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);F.onDidChange(()=>{h.isScheduled()||h.schedule()}),e.widgetClose=_("widget-close",M.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=_("goto-previous-location",M.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=_("goto-next-location",M.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=D.ThemeIcon.modify(M.Codicon.sync,"spin"),e.spinningLoading=D.ThemeIcon.modify(M.Codicon.loading,"spin")}),define(be[49],Ee([0,1,20,24,2,4]),function(re,e,l,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");var t;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(t=e.WorkbenchState||(e.WorkbenchState={}));function A(n){const m=n;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=A;function D(n){const m=n;return!!(m&&typeof m=="object"&&E.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=D;class I{constructor(m,a,h,g,S){this._id=m,this._transient=h,this._configuration=g,this._ignorePathCasing=S,this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=l.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=I;class F{constructor(m,a){this.raw=a,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,M.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=F;function _(n){return new F({uri:n,index:0,name:(0,M.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=_}),define(be[65],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class l{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const T=this._idPool++;return this._data.set(T,E),this.logDebugInfo(),T}get(E,T){return this._data.has(E)?this._data.get(E)[T]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!l.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=l,l.enableDebugLogging=!1}),define(be[31],Ee([0,1,11,24,4]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class T{constructor(){this._systemSchemes=new Set(Object.keys(l.Schemas)),this._providerInfo=new Map,this.extUri=new M.ExtUri(A=>{const D=this._providerInfo.get(A.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(A,D){D===null?this._providerInfo.delete(A):this._providerInfo.set(A,D)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=T,e.IExtHostFileSystemInfo=(0,E.createDecorator)("IExtHostFileSystemInfo")}),define(be[27],Ee([0,1,4]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,l.createDecorator)("IExtHostInitDataService")}),define(be[154],Ee([0,1,13]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class M{constructor(t,A,D){this._deferredPromises=new Map,this._id=t,this._shared=A,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(I=>(this._value=I,this)),this._storageListener=this._storage.onDidChangeStorage(I=>{I.shared===this._shared&&I.key===this._id&&(this._value=I.value)}),this._scheduler=new l.RunOnceScheduler(()=>{const I=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const F of I.values())F.complete()}catch(F){for(const _ of I.values())_.error(F)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,t])=>t!==void 0).map(([t])=>t)}get whenReady(){return this._init}get(t,A){let D=this._value[t];return typeof D=="undefined"&&(D=A),D}update(t,A){this._value[t]=A;let D=this._deferredPromises.get(t);if(D!==void 0)return D.p;const I=new l.DeferredPromise;return this._deferredPromises.set(t,I),this._scheduler.isScheduled()||this._scheduler.schedule(),I.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=M;class E extends M{constructor(t,A){super(t.identifier.value,!0,A);this._extension=t}setKeysForSync(t){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},t)}}e.ExtensionGlobalMemento=E}),define(be[155],Ee([0,1,3,2,12]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let T=class{constructor(A,D){this._logService=A,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new l.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new l.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(A,D,I){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(D.value,I)}$acceptDirtyStateChanged(A,D){this._notebooksAndEditors.getNotebookDocument(M.URI.revive(A)).acceptDirty(D)}$acceptModelSaved(A){const D=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(A));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(A,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",A.path,D);const I=this._notebooksAndEditors.getNotebookDocument(M.URI.revive(A));I.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:I.apiNotebook})}};T=Ue([Be(0,E.ILogService)],T),e.ExtHostNotebookDocuments=T}),define(be[14],Ee([0,1,4]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,l.createDecorator)("IExtHostRpcService");class M{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=M});var Xe=this&&this.__classPrivateFieldSet||function(re,e,l,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,l):E?E.value=l:e.set(re,l),l},Te=this&&this.__classPrivateFieldGet||function(re,e,l,M){if(l==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?M:l==="a"?M.call(re):M?M.value:e.get(re)};define(be[156],Ee([0,1,26,3]),function(re,e,l,M){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(A,D){E.set(this,void 0),this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._id=l.ExtensionIdentifier.toKey(A.identifier),Xe(this,E,D,"f"),Te(this,E,"f").onDidChangePassword(I=>{I.extensionId===this._id&&this._onDidChange.fire({key:I.key})})}get(A){return Te(this,E,"f").get(this._id,A)}store(A,D){return Te(this,E,"f").store(this._id,A,D)}delete(A){return Te(this,E,"f").delete(this._id,A)}}e.ExtensionSecrets=T,E=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new M.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(t){this._enabled=t}$onDidChangeTelemetryEnabled(t){this._enabled=t,this._onDidChangeTelemetryEnabled.fire(t)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,l.createDecorator)("IExtHostTelemetry")}),define(be[50],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var l;(function(v){v[v.Upsert=0]="Upsert",v[v.RemoveChild=1]="RemoveChild",v[v.Invalidated=2]="Invalidated",v[v.SetProp=3]="SetProp",v[v.Bulk=4]="Bulk"})(l=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const M=new WeakMap,E=(v,s)=>{const d={controllerId:s};return M.set(v,d),d};e.createPrivateApiFor=E;const T=v=>M.get(v);e.getPrivateApiFor=T;const t=(v,s,d,C)=>{let r=d;return{enumerable:!0,configurable:!1,get(){return r},set(b){if(!C(r,b)){const o=r;r=b,v.listener?.({op:3,key:s,value:b,previous:o})}}}},A=(v,s)=>v===s,D={range:(v,s)=>v===s?!0:!v||!s?!1:v.isEqual(s),label:A,description:A,busy:A,error:A,canResolveChildren:A,tags:(v,s)=>!(v.length!==s.length||v.some(d=>!s.find(C=>d.id===C.id)))},I=Object.keys(D),F=(v,s)=>({range:t(v,"range",void 0,D.range),label:t(v,"label",s,D.label),description:t(v,"description",void 0,D.description),canResolveChildren:t(v,"canResolveChildren",!1,D.canResolveChildren),busy:t(v,"busy",!1,D.busy),error:t(v,"error",void 0,D.error),tags:t(v,"tags",[],D.tags)}),_=(v,s)=>{const d=new Map;for(const C of I)D[C](v[C],s[C])||d.set(C,s[C]);return d};e.diffTestItems=_;class n extends Error{constructor(s){super(`Attempted to insert a duplicate test item ID ${s}`)}}e.DuplicateTestItemError=n;class m extends Error{constructor(s){super(`TestItem with ID "${s}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class a extends Error{constructor(s,d,C){super(`TestItem with ID "${s}" is from controller "${d}" and cannot be added as a child of an item from controller "${C}".`)}}e.MixedTestItemController=a;const h=v=>{const s=(0,e.getPrivateApiFor)(v);let d=new Map;return{get size(){return d.size},forEach(C,r){for(const b of d.values())C.call(r,b,this)},replace(C){const r=new Map,b=new Set(d.keys()),o={op:4,ops:[]};for(const i of C){if(!(i instanceof g))throw new m(i.id);const p=(0,e.getPrivateApiFor)(i).controllerId;if(p!==s.controllerId)throw new a(i.id,p,s.controllerId);if(r.has(i.id))throw new n(i.id);r.set(i.id,i),b.delete(i.id),o.ops.push({op:0,item:i})}for(const i of b.keys())o.ops.push({op:1,id:i});s.listener?.(o),d=r},add(C){if(!(C instanceof g))throw new m(C.id);d.set(C.id,C),s.listener?.({op:0,item:C})},delete(C){d.delete(C)&&s.listener?.({op:1,id:C})},get(C){return d.get(C)},toJSON(){return Array.from(d.values())},[Symbol.iterator](){return d.values()}}};class g{constructor(s,d,C,r){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const b=(0,e.createPrivateApiFor)(this,s);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return b.parent instanceof S?void 0:b.parent}},children:{value:h(this),enumerable:!0,writable:!1},...F(b,C)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=g;class S extends g{constructor(s,d){super(s,s,d,void 0)}}e.TestItemRootImpl=S}),define(be[66],Ee([0,1,4,150,3,14]),function(re,e,l,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var t;(function(D){function I(_){return{remoteAddress:_.remoteAddress,localAddress:_.localAddress,public:!!_.public,privacy:_.privacy??(_.public?M.TunnelPrivacyId.Public:M.TunnelPrivacyId.Private),protocol:_.protocol}}D.fromApiTunnel=I;function F(_){return{remoteAddress:{host:_.tunnelRemoteHost,port:_.tunnelRemotePort},localAddress:_.localAddress,public:_.privacy!==M.TunnelPrivacyId.ConstantPrivate&&_.privacy!==M.TunnelPrivacyId.ConstantPrivate,privacy:_.privacy,protocol:_.protocol}}D.fromServiceTunnel=F})(t=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,l.createDecorator)("IExtHostTunnelService");let A=class{constructor(I){this.onDidChangeTunnels=new E.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,F){}async getTunnels(){return[]}async setTunnelExtensionFunctions(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,F){return{dispose:()=>{}}}async $providePortAttributes(I,F,_,n,m){return[]}async $forwardPort(I,F){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Ue([Be(0,T.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var Xe=this&&this.__classPrivateFieldSet||function(re,e,l,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,l):E?E.value=l:e.set(re,l),l},Te=this&&this.__classPrivateFieldGet||function(re,e,l,M){if(l==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?M:l==="a"?M.call(re):M?M.value:e.get(re)};define(be[7],Ee([0,1,15,16,77,20,79,9,10,2,37,47,86]),function(re,e,l,M,E,T,t,A,D,I,F,_,n){"use strict";var m,a,h,g,S,v,s,d,C,r,b,o,i,p,c,u,w,f,y,R;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function P(U){function O(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(O,U),Object.setPrototypeOf(O.prototype,U.prototype),O}let B=S=class{constructor(O){m.set(this,void 0),Xe(this,m,O,"f")}static from(...O){let te=O;return new S(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof Te(this,m,"f")=="function"&&(Te(this,m,"f").call(this),Xe(this,m,void 0,"f"))}};m=new WeakMap,B=S=Ue([P],B),e.Disposable=B;let L=v=class{constructor(O,te){if(O<0)throw(0,M.illegalArgument)("line must be non-negative");if(te<0)throw(0,M.illegalArgument)("character must be non-negative");this._line=O,this._character=te}static Min(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let _e=1;_e<O.length;_e++){const Ve=O[_e];Ve.isBefore(te)&&(te=Ve)}return te}static Max(...O){if(O.length===0)throw new TypeError;let te=O[0];for(let _e=1;_e<O.length;_e++){const Ve=O[_e];Ve.isAfter(te)&&(te=Ve)}return te}static isPosition(O){if(!O)return!1;if(O instanceof v)return!0;let{line:te,character:_e}=O;return typeof te=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,te=0){if(O===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,te=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&te===0?this:new v(this.line+_e,this.character+te)}with(O,te=this.character){if(O===null||te===null)throw(0,M.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,te=typeof O.character=="number"?O.character:this.character),_e===this.line&&te===this.character?this:new v(_e,te)}toJSON(){return{line:this.line,character:this.character}}};L=v=Ue([P],L),e.Position=L;let k=s=class{constructor(O,te,_e,Ve){let tt,at;if(typeof O=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ve=="number"?(tt=new L(O,te),at=new L(_e,Ve)):O instanceof L&&te instanceof L&&(tt=O,at=te),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(O){return O instanceof s?!0:O?L.isPosition(O.start)&&L.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof s?this.contains(O._start)&&this.contains(O._end):O instanceof L?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const te=L.Max(O.start,this._start),_e=L.Min(O.end,this._end);if(!te.isAfter(_e))return new s(te,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const te=L.Min(O.start,this._start),_e=L.Max(O.end,this.end);return new s(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,te=this.end){if(O===null||te===null)throw(0,M.illegalArgument)();let _e;return O?L.isPosition(O)?_e=O:(_e=O.start||this.start,te=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new s(_e,te)}toJSON(){return[this.start,this.end]}};k=s=Ue([P],k),e.Range=k;let x=d=class extends k{constructor(O,te,_e,Ve){let tt,at;if(typeof O=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ve=="number"?(tt=new L(O,te),at=new L(_e,Ve)):O instanceof L&&te instanceof L&&(tt=O,at=te),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(O){return O instanceof d?!0:O?k.isRange(O)&&L.isPosition(O.anchor)&&L.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=d=Ue([P],x),e.Selection=x;class N{constructor(O,te,_e){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,M.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=N;class V extends Error{constructor(O,te=n.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(O,te){return new V(O,n.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(O){return new V(O,n.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var W;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var $;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})($=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let X=C=class{constructor(O,te){this._range=O,this._newText=te}static isTextEdit(O){return O instanceof C?!0:O?k.isRange(O)&&typeof O.newText=="string":!1}static replace(O,te){return new C(O,te)}static insert(O,te){return C.replace(new k(O,O),te)}static delete(O){return C.replace(O,"")}static setEndOfLine(O){const te=new C(new k(new L(0,0),new L(0,0)),"");return te.newEol=O,te}get range(){return this._range}set range(O){if(O&&!k.isRange(O))throw(0,M.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,M.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,M.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};X=C=Ue([P],X),e.TextEdit=X;var j;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(j=e.FileEditType||(e.FileEditType={}));let Q=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,te,_e,Ve){this._edits.push({_type:1,from:O,to:te,options:_e,metadata:Ve})}createFile(O,te,_e){this._edits.push({_type:1,from:void 0,to:O,options:te,metadata:_e})}deleteFile(O,te,_e){this._edits.push({_type:1,from:O,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(O,te,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(O,te,_e,Ve,tt){let at,ut,Dt=[],Rt;if(Vt.isNotebookRange(te)&&Lt.isNotebookCellDataArray(_e)&&!Lt.isNotebookCellDataArray(Ve)?(at=te.start,ut=te.end,Dt=_e,Rt=Ve):typeof te=="number"&&typeof _e=="number"&&Lt.isNotebookCellDataArray(Ve)&&(at=te,ut=_e,Dt=Ve,Rt=tt),at===void 0||ut===void 0)throw new Error("Invalid arguments");(at!==ut||Dt.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:ut-at,cells:Dt,metadata:Rt})}replaceNotebookCellMetadata(O,te,_e,Ve){this._edits.push({_type:3,metadata:Ve,uri:O,edit:{editType:8,index:te,metadata:_e}})}replace(O,te,_e,Ve){this._edits.push({_type:2,uri:O,edit:new X(te,_e),metadata:Ve})}insert(O,te,_e,Ve){this.replace(O,new k(te,te),_e,Ve)}delete(O,te,_e){this.replace(O,te,"",_e)}has(O){return this._edits.some(te=>te._type===2&&te.uri.toString()===O.toString())}set(O,te){if(te)for(const _e of te)_e&&this._edits.push({_type:2,uri:O,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ve=this._edits[_e];Ve._type===2&&Ve.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,l.coalesceInPlace)(this._edits)}}get(O){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&te.push(_e.edit);return te}entries(){const O=new T.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=O.get(te.uri);_e||(_e=[te.uri,[]],O.set(te.uri,_e)),_e[1].push(te.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Q=Ue([P],Q),e.WorkspaceEdit=Q;let le=r=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof r?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=r._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,te=this._tabstop++){if(typeof O=="function"){const _e=new r;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=r._escape(O);return this.value+="${",this.value+=te,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,te=this._tabstop++){const _e=O.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,te){if(typeof te=="function"){const _e=new r;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,te&&(this.value+=":",this.value+=te),this.value+="}",this}};le=r=Ue([P],le),e.SnippetString=le;var ve;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(ve=e.DiagnosticTag||(e.DiagnosticTag={}));var ue;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ue=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=b=class{constructor(O,te){if(this.uri=O,te)if(te instanceof k)this.range=te;else if(te instanceof L)this.range=new k(te,te);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof b?!0:O?k.isRange(O.range)&&I.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=b=Ue([P],Fe),e.Location=Fe;let Ke=class{constructor(O,te){this.location=O,this.message=te}static is(O){return O?typeof O.message=="string"&&O.location&&k.isRange(O.location.range)&&I.URI.isUri(O.location.uri):!1}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.location.range.isEqual(te.location.range)&&O.location.uri.toString()===te.location.uri.toString()}};Ke=Ue([P],Ke),e.DiagnosticRelatedInformation=Ke;let Oe=class{constructor(O,te,_e=ue.Error){if(!k.isRange(O))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=O,this.message=te,this.severity=_e}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,te){return O===te?!0:!O||!te?!1:O.message===te.message&&O.severity===te.severity&&O.code===te.code&&O.severity===te.severity&&O.source===te.source&&O.range.isEqual(te.range)&&(0,l.equals)(O.tags,te.tags)&&(0,l.equals)(O.relatedInformation,te.relatedInformation,Ke.isEqual)}};Oe=Ue([P],Oe),e.Diagnostic=Oe;let He=class{constructor(O,te){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=te}};He=Ue([P],He),e.Hover=He;var Je;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Je=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ye=class{constructor(O,te=Je.Text){this.range=O,this.kind=te}toJSON(){return{range:this.range,kind:Je[this.kind]}}};Ye=Ue([P],Ye),e.DocumentHighlight=Ye;var Qe;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var z;(function(U){U[U.Deprecated=1]="Deprecated"})(z=e.SymbolTag||(e.SymbolTag={}));let K=o=class{constructor(O,te,_e,Ve,tt){this.name=O,this.kind=te,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ve instanceof Fe?this.location=Ve:_e instanceof k&&(this.location=new Fe(Ve,_e)),o.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};K=o=Ue([P],K),e.SymbolInformation=K;let Z=i=class{constructor(O,te,_e,Ve,tt){this.name=O,this.detail=te,this.kind=_e,this.range=Ve,this.selectionRange=tt,this.children=[],i.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(i.validate)}};Z=i=Ue([P],Z),e.DocumentSymbol=Z;var oe;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(oe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let G=class{constructor(O,te){this.title=O,this.kind=te}};G=Ue([P],G),e.CodeAction=G;let ie=p=class{constructor(O){this.value=O}append(O){return new p(this.value?this.value+p.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+p.sep)}};ie.sep=".",ie=p=Ue([P],ie),e.CodeActionKind=ie,ie.Empty=new ie(""),ie.QuickFix=ie.Empty.append("quickfix"),ie.Refactor=ie.Empty.append("refactor"),ie.RefactorExtract=ie.Refactor.append("extract"),ie.RefactorInline=ie.Refactor.append("inline"),ie.RefactorRewrite=ie.Refactor.append("rewrite"),ie.Source=ie.Empty.append("source"),ie.SourceOrganizeImports=ie.Source.append("organizeImports"),ie.SourceFixAll=ie.Source.append("fixAll");let de=class{constructor(O,te){if(this.range=O,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};de=Ue([P],de),e.SelectionRange=de;class Pe{constructor(O,te,_e,Ve,tt,at){this.kind=O,this.name=te,this.detail=_e,this.uri=Ve,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=Pe;class Ne{constructor(O,te){this.fromRanges=te,this.from=O}}e.CallHierarchyIncomingCall=Ne;class We{constructor(O,te){this.fromRanges=te,this.to=O}}e.CallHierarchyOutgoingCall=We;var je;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(je=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(O,te){this.range=O,this.command=te}get isResolved(){return!!this.command}};et=Ue([P],et),e.CodeLens=et;let ot=c=class{constructor(O,te=!1){a.set(this,void 0),Xe(this,a,new E.MarkdownString(O,{supportThemeIcons:te}),"f")}static isMarkdownString(O){return O instanceof c?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Te(this,a,"f").value}set value(O){Te(this,a,"f").value=O}get isTrusted(){return Te(this,a,"f").isTrusted}set isTrusted(O){Te(this,a,"f").isTrusted=O}get supportThemeIcons(){return Te(this,a,"f").supportThemeIcons}set supportThemeIcons(O){Te(this,a,"f").supportThemeIcons=O}get supportHtml(){return Te(this,a,"f").supportHtml}set supportHtml(O){Te(this,a,"f").supportHtml=O}appendText(O){return Te(this,a,"f").appendText(O),this}appendMarkdown(O){return Te(this,a,"f").appendMarkdown(O),this}appendCodeblock(O,te){return Te(this,a,"f").appendCodeblock(te??"",O),this}};a=new WeakMap,ot=c=Ue([P],ot),e.MarkdownString=ot;let ye=class{constructor(O,te){this.label=O,this.documentation=te}};ye=Ue([P],ye),e.ParameterInformation=ye;let nt=class{constructor(O,te){this.label=O,this.documentation=te,this.parameters=[]}};nt=Ue([P],nt),e.SignatureInformation=nt;let q=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};q=Ue([P],q),e.SignatureHelp=q;var J;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(J=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var pe;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(pe=e.InlayHintKind||(e.InlayHintKind={}));let $e=class{constructor(O,te,_e){this.text=O,this.position=te,this.kind=_e}};$e=Ue([P],$e),e.InlayHint=$e;var qe;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var rt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(rt=e.CompletionItemKind||(e.CompletionItemKind={}));var ft;(function(U){U[U.Deprecated=1]="Deprecated"})(ft=e.CompletionItemTag||(e.CompletionItemTag={}));let ht=class{constructor(O,te){this.label=O,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ht=Ue([P],ht),e.CompletionItem=ht;let Ct=class{constructor(O=[],te=!1){this.items=O,this.isIncomplete=te}};Ct=Ue([P],Ct),e.CompletionList=Ct;let It=class{constructor(O,te,_e){this.text=O,this.range=te,this.command=_e}};It=Ue([P],It),e.InlineSuggestion=It;let Pt=class{constructor(O){this.items=O}};Pt=Ue([P],Pt),e.InlineSuggestions=Pt;var Ze;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Ze=e.ViewColumn||(e.ViewColumn={}));var pt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(pt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ge;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(ge=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ce;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ee;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(ee=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var se;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(se=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var fe;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(fe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function O(te){switch(te){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=O}(ee=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let he=class{constructor(O,te){if(te&&!I.URI.isUri(te))throw(0,M.illegalArgument)("target");if(!k.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.target=te}};he=Ue([P],he),e.DocumentLink=he;let ke=class{constructor(O,te,_e,Ve){this.red=O,this.green=te,this.blue=_e,this.alpha=Ve}};ke=Ue([P],ke),e.Color=ke;let Le=class{constructor(O,te){if(te&&!(te instanceof ke))throw(0,M.illegalArgument)("color");if(!k.isRange(O)||O.isEmpty)throw(0,M.illegalArgument)("range");this.range=O,this.color=te}};Le=Ue([P],Le),e.ColorInformation=Le;let Me=class{constructor(O){if(!O||typeof O!="string")throw(0,M.illegalArgument)("label");this.label=O}};Me=Ue([P],Me),e.ColorPresentation=Me;var ze;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(ze=e.ColorFormat||(e.ColorFormat={}));var it;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Re{constructor(O,te,_e){if(this.startIndex=O,this.length=te,this.tooltip=_e,typeof O!="number"||O<0)throw(0,M.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,M.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,M.illegalArgument)("tooltip")}}e.TerminalLink=Re;var ce;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ce=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(O){this.options=O,typeof O!="object"&&(0,M.illegalArgument)("options")}}e.TerminalProfile=me;var ne;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(ne=e.TaskRevealKind||(e.TaskRevealKind={}));var H;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(H=e.TaskPanelKind||(e.TaskPanelKind={}));let we=u=class{constructor(O,te){if(this.label=te,typeof O!="string"||typeof te!="string")throw(0,M.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};we.Clean=new u("clean","Clean"),we.Build=new u("build","Build"),we.Rebuild=new u("rebuild","Rebuild"),we.Test=new u("test","Test"),we=u=Ue([P],we),e.TaskGroup=we;function De(U){let O="";for(let te=0;te<U.length;te++)O+=U[te].replace(/,/g,",,")+",";return O}let Ge=class{constructor(O,te,_e){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._args=[],this._process=O,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,M.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let te of this._args)O.push(te);return De(O)}};Ge=Ue([P],Ge),e.ProcessExecution=Ge;let xe=class{constructor(O,te,_e){if(this._args=[],Array.isArray(te)){if(!O)throw(0,M.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O,this._args=te,this._options=_e}else{if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O,this._options=te}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,M.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,M.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)O.push(typeof te=="string"?te:te.value);return De(O)}};xe=Ue([P],xe),e.ShellExecution=xe;var ct;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ct=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class vt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,F.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=vt;let lt=w=class{constructor(O,te,_e,Ve,tt,at){this.__deprecated=!1,this._definition=this.definition=O;let ut;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=Ve,ut=tt,this.__deprecated=!0):te===Et.Global||te===Et.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=Ve,this.execution=tt,ut=at):(this.target=te,this._name=this.name=_e,this._source=this.source=Ve,this.execution=tt,ut=at),typeof ut=="string"?(this._problemMatchers=[ut],this._hasDefinedMatchers=!0):Array.isArray(ut)?(this._problemMatchers=ut,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Ge?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof xe?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,F.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,M.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,M.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const te=this._definition.type;(w.EmptyType===te||w.ProcessType===te||w.ShellType===te||w.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,M.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};lt.ExtensionCallbackType="customExecution",lt.ProcessType="process",lt.ShellType="shell",lt.EmptyType="$empty",lt=w=Ue([P],lt),e.Task=lt;var gt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(gt=e.ProgressLocation||(e.ProgressLocation={}));let dt=class{constructor(O,te=Tt.None){this.collapsibleState=te,I.URI.isUri(O)?this.resourceUri=O:this.label=O}};dt=Ue([P],dt),e.TreeItem=dt;var Tt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Tt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let _t=class{constructor(O,te){this.id=O,this.color=te}};_t=Ue([P],_t),e.ThemeIcon=_t,_t.File=new _t("file"),_t.Folder=new _t("folder");let $t=class{constructor(O){this.id=O}};$t=Ue([P],$t),e.ThemeColor=$t;var jt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(jt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let St=class{constructor(O,te){if(typeof O!="string"&&(!O||!I.URI.isUri(O)&&!I.URI.isUri(O.uri)))throw(0,M.illegalArgument)("base");if(typeof te!="string")throw(0,M.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=I.URI.file(O),this.base=O):I.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=te}};St=Ue([P],St),e.RelativePattern=St;let Wt=class{constructor(O,te,_e,Ve){this.enabled=typeof O=="boolean"?O:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,F.generateUuid)()),this._id}};Wt=Ue([P],Wt),e.Breakpoint=Wt;let ii=class extends Wt{constructor(O,te,_e,Ve,tt){super(te,_e,Ve,tt);if(O===null)throw(0,M.illegalArgument)("location");this.location=O}};ii=Ue([P],ii),e.SourceBreakpoint=ii;let wt=class extends Wt{constructor(O,te,_e,Ve,tt){super(te,_e,Ve,tt);this.functionName=O}};wt=Ue([P],wt),e.FunctionBreakpoint=wt;let Yt=class extends Wt{constructor(O,te,_e,Ve,tt,at,ut){super(Ve,tt,at,ut);if(!te)throw(0,M.illegalArgument)("dataId");this.label=O,this.dataId=te,this.canPersist=_e}};Yt=Ue([P],Yt),e.DataBreakpoint=Yt;let qt=class{constructor(O,te,_e){this.command=O,this.args=te||[],this.options=_e}};qt=Ue([P],qt),e.DebugAdapterExecutable=qt;let ni=class{constructor(O,te){this.port=O,this.host=te}};ni=Ue([P],ni),e.DebugAdapterServer=ni;let ri=class{constructor(O){this.path=O}};ri=Ue([P],ri),e.DebugAdapterNamedPipeServer=ri;let At=class{constructor(O){this.implementation=O}};At=Ue([P],At),e.DebugAdapterInlineImplementation=At;let Jt=class{constructor(O,te){this.range=O,this.expression=te}};Jt=Ue([P],Jt),e.EvaluatableExpression=Jt;var bi;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let zt=class{constructor(O,te){this.range=O,this.text=te}};zt=Ue([P],zt),e.InlineValueText=zt;let Ht=class{constructor(O,te,_e=!0){this.range=O,this.variableName=te,this.caseSensitiveLookup=_e}};Ht=Ue([P],Ht),e.InlineValueVariableLookup=Ht;let mt=class{constructor(O,te){this.range=O,this.expression=te}};mt=Ue([P],mt),e.InlineValueEvaluatableExpression=mt;let oi=class{constructor(O,te){this.frameId=O,this.stoppedLocation=te}};oi=Ue([P],oi),e.InlineValueContext=oi;var Nt;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Nt=e.FileChangeType||(e.FileChangeType={}));let xt=f=class extends Error{constructor(O,te=_.FileSystemProviderErrorCode.Unknown,_e){super(I.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,_.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new f(O,_.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(O){return new f(O,_.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(O){return new f(O,_.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(O){return new f(O,_.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(O){return new f(O,_.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(O){return new f(O,_.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};xt=f=Ue([P],xt),e.FileSystemError=xt;let Xt=class{constructor(O,te,_e){this.start=O,this.end=te,this.kind=_e}};Xt=Ue([P],Xt),e.FoldingRange=Xt;var Ei;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Ei=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _i;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(_i=e.CommentMode||(e.CommentMode={}));class mi{constructor(O,te=[]){this.tokenTypes=O,this.tokenModifiers=te}}e.SemanticTokensLegend=mi;function Zt(U){return typeof U=="undefined"||(0,D.isStringArray)(U)}class si{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let te=0,_e=O.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(O.tokenTypes[te],te);for(let te=0,_e=O.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(O.tokenModifiers[te],te)}}push(O,te,_e,Ve,tt){if(typeof O=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof Ve=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,te,_e,Ve,tt);if(k.isRange(O)&&typeof te=="string"&&Zt(_e))return this._push(O,te,_e);throw(0,M.illegalArgument)()}_push(O,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ve=O.start.line,tt=O.start.character,at=O.end.character-O.start.character,ut=this._tokenTypeStrToInt.get(te);let Dt=0;if(_e)for(const Rt of _e){if(!this._tokenModifierStrToInt.has(Rt))throw new Error("`tokenModifier` is not in the provided legend");const Mt=this._tokenModifierStrToInt.get(Rt);Dt|=1<<Mt>>>0}this._pushEncoded(Ve,tt,at,ut,Dt)}_pushEncoded(O,te,_e,Ve,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let Rt=0,Mt=0;for(let Ot=0;Ot<Dt;Ot++){let Ut=this._data[5*Ot],di=this._data[5*Ot+1];Ut===0?(Ut=Rt,di+=Mt):Ut+=Rt,this._data[5*Ot]=Ut,this._data[5*Ot+1]=di,Rt=Ut,Mt=di}}let at=O,ut=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ut-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ut,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=te}static _sortAndDeltaEncode(O){let te=[];const _e=O.length/5|0;for(let ut=0;ut<_e;ut++)te[ut]=ut;te.sort((ut,Dt)=>{const Rt=O[5*ut],Mt=O[5*Dt];if(Rt===Mt){const Ot=O[5*ut+1],Ut=O[5*Dt+1];return Ot-Ut}return Rt-Mt});const Ve=new Uint32Array(O.length);let tt=0,at=0;for(let ut=0;ut<_e;ut++){const Dt=5*te[ut],Rt=O[Dt+0],Mt=O[Dt+1],Ot=O[Dt+2],Ut=O[Dt+3],di=O[Dt+4],Ui=Rt-tt,Gi=Ui===0?Mt-at:Mt,hi=5*ut;Ve[hi+0]=Ui,Ve[hi+1]=Gi,Ve[hi+2]=Ot,Ve[hi+3]=Ut,Ve[hi+4]=di,tt=Rt,at=Mt}return Ve}build(O){return this._dataIsSortedAndDeltaEncoded?new Gt(new Uint32Array(this._data),O):new Gt(si._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=si;class Gt{constructor(O,te){this.resultId=te,this.data=O}}e.SemanticTokens=Gt;class ai{constructor(O,te,_e){this.start=O,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=ai;class yi{constructor(O,te){this.resultId=te,this.edits=O}}e.SemanticTokensEdits=yi;var Si;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Si=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Kt;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Kt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ei=class{constructor(){}};ei.Back={iconPath:new _t("arrow-left")},ei=Ue([P],ei),e.QuickInputButtons=ei;var Ci;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(Ci=e.ExtensionKind||(e.ExtensionKind={}));class Di{constructor(O,te,_e){this.badge=O,this.tooltip=te,this.color=_e}static validate(O){if(O.badge){let te=(0,A.nextCharLength)(O.badge,0);if(te<O.badge.length&&(te+=(0,A.nextCharLength)(O.badge,te)),O.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Di;let ci=class{constructor(O){this.kind=O}};ci=Ue([P],ci),e.ColorTheme=ci;var li;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(li=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(O,te){if(O<0)throw(0,M.illegalArgument)("start must be positive");if(te<0)throw(0,M.illegalArgument)("end must be positive");O<=te?(this._start=O,this._end=te):(this._start=te,this._end=O)}static isNotebookRange(O){return O instanceof Vt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let te=this._start,_e=this._end;return O.start!==void 0&&(te=O.start),O.end!==void 0&&(_e=O.end),te===this._start&&_e===this._end?this:new Vt(te,_e)}}e.NotebookRange=Vt;class Lt{constructor(O,te,_e,Ve,tt,at,ut){this.kind=O,this.value=te,this.languageId=_e,this.mime=Ve,this.outputs=tt??[],this.metadata=at,this.executionSummary=ut,Lt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(te=>Lt.isNotebookCellData(te))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Lt;class Ae{constructor(O){this.cells=O}}e.NotebookData=Ae;class Ft{constructor(O,te){this.data=O,this.mime=te;const _e=(0,t.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof Ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const te={name:O.name,message:O.message,stack:O.stack};return Ft.json(te,"application/vnd.code.notebook.error")}static stdout(O){return Ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,te="application/octet-stream"){return new Ft(O,te)}static text(O,te=t.Mimes.text){const _e=Te(Ft,h,"f",g).encode(String(O));return new Ft(_e,te)}static json(O,te="application/json"){const _e=JSON.stringify(O,void 0,"	");return Ft.text(_e,te)}}e.NotebookCellOutputItem=Ft,h=Ft,g={value:new TextEncoder};class Qt{constructor(O,te,_e){this.items=Qt.ensureUniqueMimeTypes(O,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,F.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(O){return O instanceof Qt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,D.isArray)(O.items)}static ensureUniqueMimeTypes(O,te=!1){const _e=new Set,Ve=new Set;for(let tt=0;tt<O.length;tt++){const at=O[tt],ut=(0,t.normalizeMimeType)(at.mime);if(!_e.has(ut)){_e.add(ut);continue}Ve.add(tt),te&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ve.size===0?O:O.filter((tt,at)=>!Ve.has(at))}}e.NotebookCellOutput=Qt;var bt;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var ki;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(ki=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ii;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ii=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var gi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(gi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pi{constructor(O,te){this.text=O,this.alignment=te}}e.NotebookCellStatusBarItem=pi;var Pi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Pi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Ti{constructor(O,te=[]){this.uri=O,this.provides=(0,l.asArray)(te)}}e.NotebookRendererScript=Ti;let ui=class{constructor(O,te){this.label=O,this.timestamp=te}};ui=Ue([P],ui),e.TimelineItem=ui;var Ai;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Ai=e.ExtensionMode||(e.ExtensionMode={}));var vi;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(vi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ri;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=4]="RegEx"})(Ri=e.StandardTokenType||(e.StandardTokenType={}));class Fi{constructor(O,te){this.ranges=O,this.wordPattern=te}}e.LinkedEditingRanges=Fi;class Mi{constructor(O,te){this._port=O,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mi;var Li;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(Li=e.TestResultState||(e.TestResultState={}));var Oi;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(Oi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Y=class{constructor(O=void 0,te=void 0,_e=void 0){this.include=O,this.exclude=te,this.profile=_e}};Y=Ue([P],Y),e.TestRunRequest=Y;let ae=y=class{constructor(O){this.message=O}static diff(O,te,_e){const Ve=new y(O);return Ve.expectedOutput=te,Ve.actualOutput=_e,Ve}};ae=y=Ue([P],ae),e.TestMessage=ae;let Se=class{constructor(O){this.id=O}};Se=Ue([P],Se),e.TestTag=Se;let st=class{constructor(O,te){this.covered=O,this.total=te}};st=Ue([P],st),e.CoveredCount=st;let yt=R=class{constructor(O,te,_e,Ve){this.uri=O,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=Ve}static fromDetails(O,te){const _e=new st(0,0),Ve=new st(0,0),tt=new st(0,0);for(const ut of te)if("branches"in ut){_e.total+=1,_e.covered+=ut.executionCount>0?1:0;for(const Dt of ut.branches)Ve.total+=1,Ve.covered+=Dt.executionCount>0?1:0}else tt.total+=1,tt.covered+=ut.executionCount>0?1:0;const at=new R(O,_e,Ve.total>0?Ve:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=te,at}};yt=R=Ue([P],yt),e.FileCoverage=yt;let kt=class{constructor(O,te,_e=[]){this.executionCount=O,this.location=te,this.branches=_e}};kt=Ue([P],kt),e.StatementCoverage=kt;let Ni=class{constructor(O,te){this.executionCount=O,this.location=te}};Ni=Ue([P],Ni),e.BranchCoverage=Ni;let xi=class{constructor(O,te){this.executionCount=O,this.location=te}};xi=Ue([P],xi),e.FunctionCoverage=xi;var Hi;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Vi;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Vi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ji;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(ji=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class qi{constructor(O,te,_e,Ve,tt,at){this.kind=O,this.name=te,this.detail=_e,this.uri=Ve,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=qi}),define(be[88],Ee([0,1,43,11,9,232,119,7,15]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const I=new Map;function F(a,h){h?I.set(a,h):I.delete(a)}e.setWordDefinitionFor=F;function _(a){return I.get(a)}e.getWordDefinitionFor=_;class n extends T.MirrorTextModel{constructor(h,g,S,v,s,d,C,r){super(g,S,v,s);this._proxy=h,this._languageId=d,this._isDirty=C,this._notebook=r,this._isDisposed=!1}dispose(){(0,l.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,D.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===M.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},get notebook(){return h._notebook},save(){return h._save()},getText(g){return g?h._getTextInRange(g):h.getText()},get eol(){return h._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(g){return h._lineAt(g)},offsetAt(g){return h._offsetAt(g)},positionAt(g){return h._positionAt(g)},validateRange(g){return h._validateRange(g)},validatePosition(g){return h._validatePosition(g)},getWordRangeAtPosition(g,S){return h._getWordRangeAtPosition(g,S)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,l.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,l.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const g=this._validateRange(h);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const S=this._eol,v=g.start.line,s=g.end.line,d=[];d.push(this._lines[v].substring(g.start.character));for(let C=v+1;C<s;C++)d.push(this._lines[C]);return d.push(this._lines[s].substring(0,g.end.character)),d.join(S)}_lineAt(h){let g;if(h instanceof A.Position?g=h.line:typeof h=="number"&&(g=h),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new m(g,this._lines[g],g===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(h),S=this._lines[g.index].length;return new A.Position(g.index,Math.min(g.remainder,S))}_validateRange(h){if(!(h instanceof A.Range))throw new Error("Invalid argument");const g=this._validatePosition(h.start),S=this._validatePosition(h.end);return g===h.start&&S===h.end?h:new A.Range(g.line,g.character,S.line,S.character)}_validatePosition(h){if(!(h instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:g,character:S}=h,v=!1;if(g<0)g=0,S=0,v=!0;else if(g>=this._lines.length)g=this._lines.length-1,S=this._lines[g].length,v=!0;else{const s=this._lines[g].length;S<0?(S=0,v=!0):S>s&&(S=s,v=!0)}return v?new A.Position(g,S):h}_getWordRangeAtPosition(h,g){const S=this._validatePosition(h);if(!g)g=_(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const v=(0,t.getWordAtText)(S.character+1,(0,t.ensureValidWordDefinition)(g),this._lines[S.line],0);if(v)return new A.Range(S.line,v.startColumn-1,S.line,v.endColumn-1)}}e.ExtHostDocumentData=n;class m{constructor(h,g,S){this._line=h,this._text=g,this._isLastLine=S}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(be[157],Ee([0,1,7,3,233,6,58,20,2,37]),function(re,e,l,M,E,T,t,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class F{constructor(n,m,a,h){this._notebook=a,this._selector=h,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,I.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(S=>{const v=this._cellUris.get(S.document.uri);v!==void 0&&(this._cellLengths.setValue(v,this._cells[v].document.getText().length+1),this._cellLines.setValue(v,this._cells[v].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const g=S=>{S===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(n.onDidChangeNotebookCells(S=>g(S.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const n=[],m=[];for(const a of this._notebook.getCells())a.kind===l.NotebookCellKind.Code&&(!this._selector||(0,t.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),n.push(a.document.getText().length+1),m.push(a.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(n)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(n){if(!n){let v="";for(const s of this._cells)v+=s.document.getText()+`
`;return v=v.slice(0,-1),v}if(n.isEmpty)return"";const m=this.locationAt(n.start),a=this.locationAt(n.end),h=this._cellUris.get(m.uri),g=this._cellUris.get(a.uri);if(h===void 0||g===void 0)return"";if(h===g)return this._cells[h].document.getText(new l.Range(m.range.start,a.range.end));const S=[this._cells[h].document.getText(new l.Range(m.range.start,new l.Position(this._cells[h].document.lineCount,0)))];for(let v=h+1;v<g;v++)S.push(this._cells[v].document.getText());return S.push(this._cells[g].document.getText(new l.Range(new l.Position(0,0),a.range.end))),S.join(`
`)}offsetAt(n){const m=this._cellLines.getIndexOf(n.line),a=this._cellLengths.getPrefixSum(m.index-1),h=this._cells[m.index].document.offsetAt(n.with(m.remainder));return a+h}positionAt(n){if(typeof n=="number"){const a=this._cellLengths.getIndexOf(n),h=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(h)}const m=this._cellUris.get(n.uri);if(m!==void 0){const a=this._cellLines.getPrefixSum(m-1);return new l.Position(a+n.range.start.line,n.range.start.character)}return new l.Position(0,0)}locationAt(n){l.Range.isRange(n)||(n=new l.Range(n,n));const m=this._cellLines.getIndexOf(n.start.line);let a=m;n.isEmpty||(a=this._cellLines.getIndexOf(n.end.line));const h=new l.Position(m.remainder,n.start.character),g=new l.Position(a.remainder,n.end.character),S=new l.Range(h,g),v=this._cells[m.index];return new l.Location(v.document.uri,v.document.validateRange(S))}contains(n){return this._cellUris.has(n)}validateRange(n){const m=this.validatePosition(n.start),a=this.validatePosition(n.end);return n.with(m,a)}validatePosition(n){const m=this._cellLines.getIndexOf(n.line),a=new l.Position(m.remainder,n.character),h=this._cells[m.index].document.validatePosition(a),g=this._cellLines.getPrefixSum(m.index-1);return new l.Position(g+h.line,h.character)}}e.ExtHostNotebookConcatDocument=F}),define(be[158],Ee([0,1,7,14,3]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(A){this._actual=new l.ColorTheme(l.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let D=A==="light"?l.ColorThemeKind.Light:A==="dark"?l.ColorThemeKind.Dark:l.ColorThemeKind.HighContrast;this._actual=new l.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ue([Be(0,M.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(be[67],Ee([0,1,4]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,l.createDecorator)("IURITransformerService");class M{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=t=>t,this.transformOutgoing=t=>t,this.transformOutgoingURI=t=>t,this.transformOutgoingScheme=t=>t)}}e.URITransformerService=M}),define(be[159],Ee([0,1,22]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class M{constructor(){this.buffers=[]}add(D){let I=this.buffers.indexOf(D);return I<0&&(I=this.buffers.length,this.buffers.push(D)),I}}function E(A,D){if(D.serializeBuffersForPostMessage){const I=new M,F=(m,a)=>{if(a instanceof ArrayBuffer){const h=I.add(a);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(a)){const h=T(a);if(h){const g=I.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:h,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},_=JSON.stringify(A,F),n=I.buffers.map(m=>{const a=new Uint8Array(m);return l.VSBuffer.wrap(a)});return{message:_,buffers:n}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=E;function T(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function t(A,D){const I=D.map(n=>{const m=new ArrayBuffer(n.byteLength);return new Uint8Array(m).set(n.buffer),m}),F=D.length?(n,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const a=m,{index:h}=a,g=I[h];if(a.view)switch(a.view.type){case 1:return new Int8Array(g,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return m}:void 0;return{message:JSON.parse(A,F),arrayBuffers:I}}e.deserializeWebviewMessage=t}),define(be[160],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var l;(function(M){function E(t){const A={items:new Map};return t.types.forEach((D,I)=>{A.items.set(D,{asString:async()=>t.items[I].asString})}),A}M.toITreeDataTransfer=E;async function T(t){const A={types:[],items:[]},D=Array.from(t.items.entries());for(const I of D)A.types.push(I[0]),A.items.push({asString:await I[1].asString()});return A}M.toTreeDataTransferDTO=T})(l=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[68],Ee([0,1,11,2]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(A,D){return A.scheme===l.Schemas.http||A.scheme===l.Schemas.https?A:(D&&D.authority&&D.isRemote&&A.scheme===l.Schemas.file&&(A=M.URI.from({scheme:l.Schemas.vscodeRemote,authority:D.authority,path:A.path})),M.URI.from({scheme:l.Schemas.https,authority:`${A.scheme}+${T(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=E;function T(A){return A.replace(/./g,D=>{const I=D.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?D:"-"+I.toString(16).padStart(4,"0")})}function t(A){return A.replace(/-([0-9a-f]{4})/g,(D,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=t}),define(be[161],Ee([0,1,3,6,68]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(A,D,I){this._proxy=A,this._editors=D,this._initData=I,this._handlePool=0,this._disposables=new M.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const F=D.getVisibleTextEditors();for(const _ of this._insets.values())F.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,D,I,F,_){let n;for(const s of this._editors.getVisibleTextEditors(!0))if(s.value===A){n=s;break}if(!n)throw new Error("not a visible editor");const m=this,a=this._handlePool++,h=new l.Emitter,g=new l.Emitter,S=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(s){return(0,E.asWebviewUri)(s,m._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(s){this._options=s,m._proxy.$setOptions(a,s)}get options(){return this._options}set html(s){this._html=s,m._proxy.$setHtml(a,s)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(s){return m._proxy.$postMessage(a,s)}},v=new class{constructor(){this.editor=A,this.line=D,this.height=I,this.webview=S,this.onDidDispose=g.event}dispose(){m._insets.has(a)&&(m._insets.delete(a),m._proxy.$disposeEditorInset(a),g.fire(),g.dispose(),h.dispose())}};return this._proxy.$createEditorInset(a,n.id,n.value.document.uri,D+1,I,F||{},_.identifier,_.extensionLocation),this._insets.set(a,{editor:A,inset:v,onDidReceiveMessage:h}),v}$onDidDispose(A){const D=this._insets.get(A);D&&D.inset.dispose()}$onDidReceiveMessage(A,D){const I=this._insets.get(A);I&&I.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=T}),define(be[162],Ee([0,1,132,10,2,6,4,38,30,47,15,11]),function(re,e,l,M,E,T,t,A,D,I,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.ActiveEditorDirtyContext=new A.RawContextKey("activeEditorIsDirty",!1,(0,l.localize)(2,null)),e.ActiveEditorPinnedContext=new A.RawContextKey("activeEditorIsNotPreview",!1,(0,l.localize)(3,null)),e.ActiveEditorStickyContext=new A.RawContextKey("activeEditorIsPinned",!1,(0,l.localize)(4,null)),e.ActiveEditorReadonlyContext=new A.RawContextKey("activeEditorIsReadonly",!1,(0,l.localize)(5,null)),e.ActiveEditorCanRevertContext=new A.RawContextKey("activeEditorCanRevert",!1,(0,l.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new A.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new A.RawContextKey("activeEditor",null,{type:"string",description:(0,l.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new A.RawContextKey("activeEditorAvailableEditorIds","",(0,l.localize)(8,null)),e.TextCompareEditorVisibleContext=new A.RawContextKey("textCompareEditorVisible",!1,(0,l.localize)(9,null)),e.TextCompareEditorActiveContext=new A.RawContextKey("textCompareEditorActive",!1,(0,l.localize)(10,null)),e.SideBySideEditorActiveContext=new A.RawContextKey("sideBySideEditorActive",!1,(0,l.localize)(11,null)),e.EditorGroupEditorsCountContext=new A.RawContextKey("groupEditorsCount",0,(0,l.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new A.RawContextKey("activeEditorGroupEmpty",!1,(0,l.localize)(13,null)),e.ActiveEditorGroupIndexContext=new A.RawContextKey("activeEditorGroupIndex",0,(0,l.localize)(14,null)),e.ActiveEditorGroupLastContext=new A.RawContextKey("activeEditorGroupLast",!1,(0,l.localize)(15,null)),e.ActiveEditorGroupLockedContext=new A.RawContextKey("activeEditorGroupLocked",!1,(0,l.localize)(16,null)),e.MultipleEditorGroupsContext=new A.RawContextKey("multipleEditorGroups",!1,(0,l.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new A.RawContextKey("editorIsOpen",!1,(0,l.localize)(18,null)),e.InEditorZenModeContext=new A.RawContextKey("inZenMode",!1,(0,l.localize)(19,null)),e.IsCenteredLayoutContext=new A.RawContextKey("isCenteredLayout",!1,(0,l.localize)(20,null)),e.SplitEditorsVertically=new A.RawContextKey("splitEditorsVertically",!1,(0,l.localize)(21,null)),e.EditorAreaVisibleContext=new A.RawContextKey("editorAreaVisible",!0,(0,l.localize)(22,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function n(L,k,x){for(const N of x.visibleEditorPanes)if(N.group.id===k&&L.matches(N.input))return N.getViewState()}e.findViewStateForEditor=n;function m(L){if(C(L))return!1;const k=L;return E.URI.isUri(k?.resource)}e.isResourceEditorInput=m;function a(L){if(C(L))return!1;const k=L;return k?.original!==void 0&&k.modified!==void 0}e.isResourceDiffEditorInput=a;function h(L){if(C(L)||a(L))return!1;const k=L;return k?.primary!==void 0&&k.secondary!==void 0}e.isResourceSideBySideEditorInput=h;function g(L){if(C(L))return!1;const k=L;return k?k.resource===void 0||k.resource.scheme===_.Schemas.untitled||k.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;var S;(function(L){L[L.SHORT=0]="SHORT",L[L.MEDIUM=1]="MEDIUM",L[L.LONG=2]="LONG"})(S=e.Verbosity||(e.Verbosity={}));var v;(function(L){L[L.EXPLICIT=1]="EXPLICIT",L[L.AUTO=2]="AUTO",L[L.FOCUS_CHANGE=3]="FOCUS_CHANGE",L[L.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));var s;(function(L){L[L.None=0]="None",L[L.Readonly=2]="Readonly",L[L.Untitled=4]="Untitled",L[L.Singleton=8]="Singleton",L[L.RequiresTrust=16]="RequiresTrust",L[L.CanSplitInGroup=32]="CanSplitInGroup",L[L.ForceDescription=64]="ForceDescription"})(s=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends T.Disposable{}e.AbstractEditorInput=d;function C(L){return L instanceof d}e.isEditorInput=C;function r(L){const k=L;return E.URI.isUri(k?.preferredResource)}function b(L){const k=L;return C(k?.primary)&&C(k?.secondary)}e.isSideBySideEditorInput=b;function o(L){const k=L;return C(k?.modified)&&C(k?.original)}e.isDiffEditorInput=o;function i(L){return C(L?.editor)}e.isEditorInputWithOptions=i;function p(L){const k=L;return i(L)&&k?.group!==void 0}e.isEditorInputWithOptionsAndGroup=p;function c(L){const k=L;return typeof k?.groupId=="number"&&C(k.editor)}e.isEditorIdentifier=c;var u;(function(L){L[L.UNKNOWN=0]="UNKNOWN",L[L.REPLACE=1]="REPLACE",L[L.MOVE=2]="MOVE",L[L.UNPIN=3]="UNPIN"})(u=e.EditorCloseContext||(e.EditorCloseContext={}));var w;(function(L){L[L.PRIMARY=1]="PRIMARY",L[L.SECONDARY=2]="SECONDARY",L[L.BOTH=3]="BOTH",L[L.ANY=4]="ANY"})(w=e.SideBySideEditor||(e.SideBySideEditor={}));class f{getOriginalUri(k,x){if(!k)return;if(x?.supportSideBySide){const{primary:V,secondary:W}=this.getSideEditors(k);if(V&&W){if(x?.supportSideBySide===w.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(W,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===w.ANY)return this.getOriginalUri(V,{filterByScheme:x.filterByScheme})??this.getOriginalUri(W,{filterByScheme:x.filterByScheme});k=x.supportSideBySide===w.PRIMARY?V:W}}if(a(k)||h(k))return;const N=r(k)?k.preferredResource:k.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}getSideEditors(k){return b(k)||h(k)?{primary:k.primary,secondary:k.secondary}:o(k)||a(k)?{primary:k.modified,secondary:k.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(k,x){if(!k)return;if(x?.supportSideBySide){const{primary:V,secondary:W}=this.getSideEditors(k);if(V&&W){if(x?.supportSideBySide===w.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(W,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===w.ANY)return this.getCanonicalUri(V,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(W,{filterByScheme:x.filterByScheme});k=x.supportSideBySide===w.PRIMARY?V:W}}if(a(k)||h(k))return;const N=k.resource;return!N||!x||!x.filterByScheme?N:this.filterUri(N,x.filterByScheme)}filterUri(k,x){if(Array.isArray(x)){if(x.some(N=>k.scheme===N))return k}else if(x===k.scheme)return k}}e.EditorResourceAccessor=new f;var y;(function(L){L[L.LEFT=0]="LEFT",L[L.RIGHT=1]="RIGHT"})(y=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(k){const x=this.instantiationService=k.get(t.IInstantiationService);for(const[N,V]of this.editorSerializerConstructors)this.createEditorSerializer(N,V,x);this.editorSerializerConstructors.clear()}createEditorSerializer(k,x,N){const V=N.createInstance(x);this.editorSerializerInstances.set(k,V)}registerFileEditorFactory(k){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=k}getFileEditorFactory(){return(0,M.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(k,x){if(this.editorSerializerConstructors.has(k)||this.editorSerializerInstances.has(k))throw new Error(`A editor serializer with type ID '${k}' was already registered.`);return this.instantiationService?this.createEditorSerializer(k,x,this.instantiationService):this.editorSerializerConstructors.set(k,x),(0,T.toDisposable)(()=>{this.editorSerializerConstructors.delete(k),this.editorSerializerInstances.delete(k)})}getEditorSerializer(k){return this.editorSerializerInstances.get(typeof k=="string"?k:k.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new R);async function P(L,k){if(!L||!L.length)return[];const x=await Promise.all(L.map(async N=>{const V=E.URI.revive(N.fileUri);if(!V||!await k.canHandleResource(V))return;let $=N.exists,X=N.type;if(typeof $!="boolean"||typeof X!="number")try{X=(await k.resolve(V)).isFile?I.FileType.File:I.FileType.Unknown,$=!0}catch{$=!1}if(!$&&N.openOnlyIfExists||X!==I.FileType.File)return;const j={selection:$?N.selection:void 0,pinned:!0,override:N.editorOverrideId};let Q;return $?Q={resource:V,options:j}:Q={resource:V,options:j,forceUntitled:!0},Q}));return(0,F.coalesce)(x)}e.pathsToEditors=P;var B;(function(L){L[L.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",L[L.SEQUENTIAL=1]="SEQUENTIAL"})(B=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[163],Ee([0,1,3,38,133,4,6,20,30,15,54,23,35,153]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",n.Codicon.window,(0,E.localize)(0,null));var a;(function(p){p.ViewContainersRegistry="workbench.registry.view.containers",p.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var h;(function(p){p[p.Sidebar=0]="Sidebar",p[p.Panel=1]="Panel",p[p.AuxiliaryBar=2]="AuxiliaryBar"})(h=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function g(p){switch(p){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=g;function S(p){return`viewContainer.${p}.enabled`}e.getEnabledViewContainerContextKey=S;class v extends t.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new l.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new l.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,I.flatten)([...this.viewContainers.values()])}registerViewContainer(c,u,w){const f=this.get(c.id);if(f)return f;const y=c;return y.openCommandActionDescriptor=w?.donotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,A.getOrSet)(this.viewContainers,u,[]).push(y),w?.isDefault&&this.defaultViewContainers.push(y),this._onDidRegister.fire({viewContainer:y,viewContainerLocation:u}),y}deregisterViewContainer(c){for(const u of this.viewContainers.keys()){const w=this.viewContainers.get(u),f=w?.indexOf(c);if(f!==-1){w?.splice(f,1),w.length===0&&this.viewContainers.delete(u),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:u});return}}}get(c){return this.all.filter(u=>u.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(u=>this.getViewContainers(u).filter(w=>w?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(u=>this.getViewContainerLocation(u)===c)}}D.Registry.add(a.ViewContainersRegistry,new v);var s;(function(p){p.Open="2_open",p.Debug="4_debug",p.SCM="5_scm",p.More="9_more"})(s=e.ViewContentGroups||(e.ViewContentGroups={}));function d(p,c){const u=p.group??s.More,w=c.group??s.More;return u!==w?u.localeCompare(w):(p.order??5)-(c.order??5)}class C extends t.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new l.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new l.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new l.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new l.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new F.SetMap}registerViews(c,u){this.registerViews2([{views:c,viewContainer:u}])}registerViews2(c){c.forEach(({views:u,viewContainer:w})=>this.addViews(u,w)),this._onViewsRegistered.fire(c)}deregisterViews(c,u){const w=this.removeViews(c,u);w.length&&this._onViewsDeregistered.fire({views:w,viewContainer:u})}moveViews(c,u){for(const w of this._views.keys())if(w!==u){const f=this.removeViews(c,w);f.length&&(this.addViews(f,u),this._onDidChangeContainer.fire({views:f,from:w,to:u}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const u of this._viewContainers){const w=(this._views.get(u)||[]).filter(f=>f.id===c)[0];if(w)return w}return null}getViewContainer(c){for(const u of this._viewContainers)if((this._views.get(u)||[]).filter(f=>f.id===c)[0])return u;return null}registerViewWelcomeContent(c,u){return this._viewWelcomeContents.add(c,u),this._onDidChangeViewWelcomeContent.fire(c),(0,t.toDisposable)(()=>{this._viewWelcomeContents.delete(c,u),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,u){const w=new Map;for(const[f,y]of u)this._viewWelcomeContents.add(c,y),w.set(f,(0,t.toDisposable)(()=>{this._viewWelcomeContents.delete(c,y),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),w}getViewWelcomeContent(c){const u=[];return this._viewWelcomeContents.forEach(c,w=>u.push(w)),u.sort(d)}addViews(c,u){let w=this._views.get(u);w||(w=[],this._views.set(u,w),this._viewContainers.push(u));for(const f of c){if(this.getView(f.id)!==null)throw new Error((0,E.localize)(1,null,f.id));w.push(f)}}removeViews(c,u){const w=this._views.get(u);if(!w)return[];const f=[],y=[];for(const R of w)c.includes(R)?f.push(R):y.push(R);return f.length&&(y.length?this._views.set(u,y):(this._views.delete(u),this._viewContainers.splice(this._viewContainers.indexOf(u),1))),f}}D.Registry.add(a.ViewsRegistry,new C),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new M.RawContextKey("focusedView","",(0,E.localize)(2,null));function r(p){return`view.${p}.visible`}e.getVisbileViewContextKey=r,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var b;(function(p){p[p.Default=0]="Default",p[p.Expand=1]="Expand"})(b=e.ViewVisibilityState||(e.ViewVisibilityState={}));var o;(function(p){p[p.None=0]="None",p[p.Collapsed=1]="Collapsed",p[p.Expanded=2]="Expanded"})(o=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(c,u){this.resolved=!1,this._hasResolve=!1,(0,_.mixin)(this,c),this._hasResolve=!!u,this.resolve=async w=>{if(u&&!this.resolved){const f=await u(w);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}w.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[164],Ee([0,1,3,13,134]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new l.Emitter,this._onExit=new l.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,D,I,F){const _={command:A};if(D&&Object.keys(D).length>0&&(_.arguments=D),this.internalSend("request",_),typeof F=="number"){const n=setTimeout(()=>{clearTimeout(n);const m=this.pendingRequests.get(_.seq);if(m){this.pendingRequests.delete(_.seq);const a={type:"response",seq:0,request_seq:_.seq,success:!1,command:A,message:(0,E.localize)(0,null,F,A)};m(a)}},F)}return I&&this.pendingRequests.set(_.seq,I),_.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,D){return A.type!=="event"||D.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,M.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":const D=A,I=this.pendingRequests.get(D.request_seq);I&&(this.pendingRequests.delete(D.request_seq),I(D));break}}}internalSend(A,D){D.type=A,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((D,I)=>A.set(I,D)),await(0,M.timeout)(500),A.forEach((D,I)=>{D({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(I)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(be[165],Ee([0,1,9,2,17,23,11]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function D(o,i,p){return o.replace(A,function(c,u){return i&&u.length>0&&u[0]!=="_"?c:p&&p.hasOwnProperty(u)?p[u]:c})}e.formatPII=D;function I(o){const i={};for(const p of Object.keys(o))p.startsWith("!")||(i[p]=o[p]);return i}e.filterExceptionsFromTelemetry=I;function F(o){return o.configuration.request==="attach"&&!_(o)&&(!o.parentSession||F(o.parentSession))}e.isSessionAttach=F;function _(o){let i=o.configuration.type;if(!!i)return i==="vslsShare"&&(i=o.configuration.adapterProxy.configuration.type),(0,l.equalsIgnoreCase)(i,"extensionhost")||(0,l.equalsIgnoreCase)(i,"pwa-extensionhost")?o:o.parentSession?_(o.parentSession):void 0}e.getExtensionHostDebugSession=_;function n(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=n;function m(o,i,p){let c,u=0,w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,f=null;for(;f=w.exec(o);){let y=f.index+1,R=y+f[0].length;if(y<=i&&R>=p){c=f[0],u=y;break}}if(c){let y=/\w+/g,R=null;for(;(R=y.exec(c))&&!(R.index+1+u+R[0].length>=p););R&&(c=c.substring(0,y.lastIndex))}return c?{start:u,end:u+c.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(o){return!!(o&&o.match(a))}e.isUri=h;function g(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(h(o.path))return M.URI.parse(o.path);if((0,E.isAbsolute)(o.path))return M.URI.file(o.path)}return o.path}function S(o){if(typeof o.path=="object"){const i=M.URI.revive(o.path);if(i)return i.scheme===t.Schemas.file?i.fsPath:i.toString()}return o.path}function v(o,i){const p=i?g:S,c=(0,T.deepClone)(o);return d(c,(u,w)=>{u&&w&&(w.path=p(w))}),c}e.convertToDAPaths=v;function s(o,i){const p=i?g:S,c=(0,T.deepClone)(o);return d(c,(u,w)=>{!u&&w&&(w.path=p(w))}),c}e.convertToVSCPaths=s;function d(o,i){switch(o.type){case"event":const p=o;switch(p.event){case"output":i(!1,p.body.source);break;case"loadedSource":i(!1,p.body.source);break;case"breakpoint":i(!1,p.body.breakpoint.source);break;default:break}break;case"request":const c=o;switch(c.command){case"setBreakpoints":i(!0,c.arguments.source);break;case"breakpointLocations":i(!0,c.arguments.source);break;case"source":i(!0,c.arguments.source);break;case"gotoTargets":i(!0,c.arguments.source);break;case"launchVSCode":c.arguments.args.forEach(w=>i(!1,w));break;default:break}break;case"response":const u=o;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(w=>i(!1,w.source));break;case"loadedSources":u.body.sources.forEach(w=>i(!1,w));break;case"scopes":u.body.scopes.forEach(w=>i(!1,w.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(w=>i(!1,w.source));break;case"setBreakpoints":u.body.breakpoints.forEach(w=>i(!1,w.source));break;default:break}break}}function C(o){return o.filter(i=>!i.presentation?.hidden).sort((i,p)=>i.presentation?p.presentation?i.presentation.group?p.presentation.group?i.presentation.group!==p.presentation.group?i.presentation.group.localeCompare(p.presentation.group):r(i.presentation.order,p.presentation.order):-1:p.presentation.group?1:r(i.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.getVisibleAndSorted=C;function r(o,i){return typeof o!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:o-i}async function b(o,i){const p=o.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorMode});if(p!=="none"&&(await i.saveAll(),p==="allEditorsInActiveGroup")){const c=i.activeEditorPane;c&&await i.save({editor:c.input,groupId:c.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=b}),define(be[89],Ee([0,1,29,166,79,11,17,25,38]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var I;(function(y){y[y.Markup=1]="Markup",y[y.Code=2]="Code"})(I=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",E.Mimes.latex,E.Mimes.markdown,"image/png","image/jpeg",E.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[E.Mimes.latex,E.Mimes.markdown,"application/json",E.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["vscode.ipynb"])],["ms-toolsai.jupyter-renderers",new Set(["vscode.ipynb"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var F;(function(y){y[y.Running=1]="Running",y[y.Idle=2]="Idle"})(F=e.NotebookRunState||(e.NotebookRunState={}));var _;(function(y){y[y.Pending=2]="Pending",y[y.Executing=3]="Executing"})(_=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var n;(function(y){y[y.WithHardKernelDependency=0]="WithHardKernelDependency",y[y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",y[y.Pure=2]="Pure",y[y.Never=3]="Never"})(n=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(y){y.Always="always",y.Never="never",y.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var a;(function(y){y[y.ModelChange=1]="ModelChange",y[y.Move=2]="Move",y[y.ChangeLanguage=5]="ChangeLanguage",y[y.Initialize=6]="Initialize",y[y.ChangeCellMetadata=7]="ChangeCellMetadata",y[y.Output=8]="Output",y[y.OutputItem=9]="OutputItem",y[y.ChangeCellContent=10]="ChangeCellContent",y[y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",y[y.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",y[y.ChangeCellMime=13]="ChangeCellMime",y[y.Unknown=100]="Unknown"})(a=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(y){y[y.Handle=0]="Handle",y[y.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(y){y[y.Replace=1]="Replace",y[y.Output=2]="Output",y[y.Metadata=3]="Metadata",y[y.CellLanguage=4]="CellLanguage",y[y.DocumentMetadata=5]="DocumentMetadata",y[y.Move=6]="Move",y[y.OutputItems=7]="OutputItems",y[y.PartialMetadata=8]="PartialMetadata",y[y.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));var S;(function(y){y.scheme=T.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function P(N,V){return N.with({scheme:y.scheme,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==T.Schemas.file?N.scheme:""}`})}y.generate=P;function B(N){if(N.scheme!==y.scheme)return;const V=R.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||T.Schemas.file,fragment:null})}:void 0}y.parse=B;function L(N){if(N.scheme!==T.Schemas.vscodeNotebookCellMetadata)return;const V=R.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substr(V[0].length)||T.Schemas.file,fragment:null})}:void 0}y.parseCellMetadataUri=L;function k(N,V,W){return N.with({scheme:W,fragment:`ch${V.toString().padStart(7,"0")}${N.scheme!==T.Schemas.file?N.scheme:""}`})}y.generateCellUri=k;function x(N,V){if(N.scheme!==V)return;const W=R.exec(N.fragment);return W?{handle:Number(W[1]),notebook:N.with({scheme:N.fragment.substr(W[0].length)||T.Schemas.file,fragment:null})}:void 0}y.parseCellUri=x})(S=e.CellUri||(e.CellUri={}));const v=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[E.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function s(y){return v.get(y)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=s;function d(y){return v.get(y)?.supportedByCore??!1}e.mimeTypeSupportedByCore=d;function C(y){return v.get(y)?.mergeable??!1}e.mimeTypeIsMergeable=C;const r=y=>A.isWindows?y.replace(/\//g,"\\"):y;class b{constructor(R=[],P=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=P,this.order=[...new Set(R)].map(B=>({pattern:B,matches:l.parse(r(B))}))}sort(R){const P=new Map(M.Iterable.map(R,L=>[L,r(L)]));let B=[];for(const{matches:L}of this.order)for(const[k,x]of P)if(L(x)){B.push(k),P.delete(k);break}return P.size&&(B=B.concat([...P.keys()].sort((L,k)=>this.defaultOrder.indexOf(L)-this.defaultOrder.indexOf(k)))),B}prioritize(R,P){const B=this.findIndex(R);if(B===-1){this.order.unshift({pattern:R,matches:l.parse(r(R))});return}const L=new Set(P.map(x=>this.findIndex(x,B)));L.delete(-1);const k=Array.from(L).sort();this.order.splice(B+1,0,...k.map(x=>this.order[x]));for(let x=k.length-1;x>=0;x--)this.order.splice(k[x],1)}toArray(){return this.order.map(R=>R.pattern)}findIndex(R,P=this.order.length){const B=r(R);for(let L=0;L<P;L++)if(this.order[L].matches(B))return L;return-1}}e.MimeTypeDisplayOrder=b;function o(y,R,P,B=(L,k)=>L===k){const L=[];function k(V,W,$){if(W===0&&$.length===0)return;const X=L[L.length-1];X&&X.start+X.deleteCount===V?(X.deleteCount+=W,X.toInsert.push(...$)):L.push({start:V,deleteCount:W,toInsert:$})}let x=0,N=0;for(;;){if(x===y.length){k(x,0,R.slice(N));break}if(N===R.length){k(x,y.length-x,[]);break}const V=y[x],W=R[N];if(B(V,W)){x+=1,N+=1;continue}P(W)?(k(x,1,[]),x+=1):(k(x,0,[W]),N+=1)}return L}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(y){y.default="default",y.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function p(y){const R=y;return!!((typeof R.include=="string"||l.isRelativePattern(R.include))&&(typeof R.exclude=="string"||l.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=p;function c(y,R,P){if(Array.isArray(y.viewType)&&y.viewType.indexOf(R)>=0||y.viewType===R)return!0;if(y.filenamePattern){let B=p(y.filenamePattern)?y.filenamePattern.include:y.filenamePattern,L=p(y.filenamePattern)?y.filenamePattern.exclude:void 0;if(l.match(B,(0,t.basename)(P.fsPath).toLowerCase()))return!(L&&l.match(L,(0,t.basename)(P.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=c;class u{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let P=0;P<this.textModel.cells.length;P++)R[P]=this.textModel.cells[P].getHashValue();return R}}e.CellSequence=u,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize"};var w;(function(y){y[y.Left=1]="Left",y[y.Right=2]="Right"})(w=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class f{static create(R){return`${f._prefix}${R}`}static parse(R){if(R.startsWith(f._prefix))return R.substr(f._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=f,f._prefix="notebook/"}),define(be[167],Ee([0,1,4]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var M;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(M=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,l.createDecorator)("INotebookExecutionService")}),define(be[168],Ee([0,1,4,38]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new M.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new M.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new M.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,l.createDecorator)(e.OUTPUT_SERVICE_ID);var E;(function(T){T[T.Append=1]="Append",T[T.Replace=2]="Replace",T[T.Clear=3]="Clear"})(E=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(be[169],Ee([0,1,136,4,38]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,l.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,l.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,l.localize(2,null)),e.ITaskService=(0,M.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[170],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function l(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=l;function M(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=M}),define(be[90],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var l;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(l=e.TestResultState||(e.TestResultState={}));var M;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var T;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(T=e.TestItemExpandState||(e.TestItemExpandState={}));const t=(_,n)=>{n.expand!==void 0&&(_.expand=n.expand),n.item!==void 0&&(_.item=_.item?Object.assign(_.item,n.item):n.item)};e.applyTestItemUpdate=t;var A;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(A=e.DetailType||(e.DetailType={}));var D;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire",_[_.AddTag=5]="AddTag",_[_.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class I{add(n){}update(n){}remove(n,m){}complete(){}}e.IncrementalChangeCollector=I;class F{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(n){const m=this.createChangeCollector();for(const a of n)switch(a[0]){case 0:{const h=a[1];if(h.parent){if(this.items.has(h.parent)){const g=this.items.get(h.parent);g.children.add(h.item.extId);const S=this.createItem(h,g);this.items.set(h.item.extId,S),m.add(S)}}else{const g=this.createItem(h);this.roots.add(g),this.items.set(h.item.extId,g),m.add(g)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=a[1],g=this.items.get(h.extId);if(!g)break;h.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,h),m.update(g);break}case 2:{const h=this.items.get(a[1]);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h);const g=[[a[1]]];for(;g.length;)for(const S of g.pop()){const v=this.items.get(S);v&&(g.push(v.children),this.items.delete(S),m.remove(v,v!==h),v.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break;case 5:this._tags.set(a[1].id,a[1]);break;case 6:this._tags.delete(a[1]);break}m.complete()}retireTest(n){}updatePendingRoots(n){this.pendingRootCount+=n}createChangeCollector(){return new I}}e.AbstractIncrementalTestCollection=F}),define(be[69],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(T){T.Delimiter="\0"})(l=e.TestIdPathParts||(e.TestIdPathParts={}));var M;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(M=e.TestPosition||(e.TestPosition={}));class E{constructor(t,A=t.length){if(this.path=t,this.viewEnd=A,t.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(t,A,D=t.parent){if(t.id===A)return new E([A]);let I=[t.id];for(let F=D;F&&F.id!==A;F=F.parent)I.push(F.id);return I.push(A),new E(I.reverse())}static isRoot(t){return!t.includes("\0")}static fromString(t){return new E(t.split("\0"))}static join(t,A){return new E([...t.path,A])}static joinToString(t,A){return t.toString()+"\0"+A}static compare(t,A){return t===A?0:A.startsWith(t+"\0")?2:t.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let t=1;t<=this.viewEnd;t++)yield new E(this.path,t)}compare(t){if(typeof t=="string")return E.compare(this.toString(),t);for(let A=0;A<t.viewEnd&&A<this.viewEnd;A++)if(t.path[A]!==this.path[A])return 1;return t.viewEnd>this.viewEnd?2:t.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let t=1;t<this.viewEnd;t++)this.stringifed+="\0",this.stringifed+=this.path[t]}return this.stringifed}}e.TestId=E}),define(be[171],Ee([0,1,17,91,10,23,25,78,137]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(_,n,m){this._contributedVariables=new Map,this._context=_,this._labelService=n,m&&(this._envVariablesPromise=m.then(a=>this.prepareEnv(a)))}prepareEnv(_){if(t.isWindows){const n=Object.create(null);return Object.keys(_).forEach(m=>{n[m.toLowerCase()]=_[m]}),n}return _}resolveWithEnvironment(_,n,m){return this.recursiveResolve(this.prepareEnv(_),n?n.uri:void 0,m)}async resolveAsync(_,n){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,n)}async resolveAnyBase(_,n,m,a){const h=T.deepClone(n);return t.isWindows&&h.windows?Object.keys(h.windows).forEach(g=>h[g]=h.windows[g]):t.isMacintosh&&h.osx?Object.keys(h.osx).forEach(g=>h[g]=h.osx[g]):t.isLinux&&h.linux&&Object.keys(h.linux).forEach(g=>h[g]=h.linux[g]),delete h.windows,delete h.osx,delete h.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,h,m,a)}async resolveAnyAsync(_,n,m){return this.resolveAnyBase(_,n,m)}async resolveAnyMap(_,n,m){const a=new Map;return{newConfig:await this.resolveAnyBase(_,n,m,a),resolvedVariables:a}}resolveWithInteractionReplace(_,n,m,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,n,m,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,n){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,n)}recursiveResolve(_,n,m,a,h){if(E.isString(m))return this.resolveString(_,n,m,a,h);if(E.isArray(m))return m.map(g=>this.recursiveResolve(_,n,g,a,h));if(E.isObject(m)){let g=Object.create(null);return Object.keys(m).forEach(S=>{const v=this.resolveString(_,n,S,a,h);g[v]=this.recursiveResolve(_,n,m[S],a,h)}),g}return m}resolveString(_,n,m,a,h){return m.replace(I.VARIABLE_REGEXP,(S,v)=>{if(v.includes(I.VARIABLE_LHS))return S;let s=this.evaluateSingleVariable(_,S,v,n,a);return h&&h.set(v,s),s!==S&&E.isString(s)&&s.match(I.VARIABLE_REGEXP)&&(s=this.resolveString(_,n,s,a,h)),s})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,n,m,a,h){let g;const S=m.split(":");S.length>1&&(m=S[0],g=S[1]);const v=()=>{const C=this._context.getFilePath();if(C)return C;throw new Error((0,D.localize)(0,null,n))},s=()=>{const C=v();if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new Error((0,D.localize)(1,null,n,l.basename(C)))},d=()=>{if(g){const C=this._context.getFolderUri(g);if(C)return C;throw new Error((0,D.localize)(2,null,n,g))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,n)):new Error((0,D.localize)(4,null,n))};switch(m){case"env":if(g){if(_){const C=_[t.isWindows?g.toLowerCase():g];if(E.isString(C))return C}return""}throw new Error((0,D.localize)(5,null,n));case"config":if(g){const C=this._context.getConfigurationValue(a,g);if(E.isUndefinedOrNull(C))throw new Error((0,D.localize)(6,null,n,g));if(E.isObject(C))throw new Error((0,D.localize)(7,null,n,g));return C}throw new Error((0,D.localize)(8,null,n));case"command":return this.resolveFromMap(n,g,h,"command");case"input":return this.resolveFromMap(n,g,h,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(d()));case"cwd":return a||g?(0,A.normalizeDriveLetter)(this.fsPath(d())):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return l.basename(this.fsPath(d()));case"lineNumber":const C=this._context.getLineNumber();if(C)return C;throw new Error((0,D.localize)(9,null,n));case"selectedText":const r=this._context.getSelectedText();if(r)return r;throw new Error((0,D.localize)(10,null,n));case"file":return v();case"fileWorkspaceFolder":return s();case"relativeFile":return a||g?l.relative(this.fsPath(d()),v()):v();case"relativeFileDirname":const b=l.dirname(v());if(a||g){const c=l.relative(this.fsPath(d()),b);return c.length===0?".":c}return b;case"fileDirname":return l.dirname(v());case"fileExtname":return l.extname(v());case"fileBasename":return l.basename(v());case"fileBasenameNoExtension":const o=l.basename(v());return o.slice(0,o.length-l.extname(o).length);case"fileDirnameBasename":return l.basename(l.dirname(v()));case"execPath":const i=this._context.getExecPath();return i||n;case"execInstallFolder":const p=this._context.getAppRoot();return p||n;case"pathSeparator":return l.sep;default:try{const c=g?`${m}:${g}`:m;return this.resolveFromMap(n,c,h,void 0)}catch(c){return n}}}}resolveFromMap(_,n,m,a){if(n&&m){const h=a===void 0?m[n]:m[a+":"+n];if(typeof h=="string")return h;throw new Error((0,D.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=I,I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,162]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,l.createDecorator)("editorGroupsService");var E;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var T;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(T=e.GroupOrientation||(e.GroupOrientation={}));var t;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(t=e.GroupLocation||(e.GroupLocation={}));var A;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function I(h){const g=h;return(0,M.isEditorInput)(g?.editor)&&(0,M.isEditorInput)(g?.replacement)}e.isEditorReplacement=I;var F;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(F=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(h){h[h.GROUP_ACTIVE=0]="GROUP_ACTIVE",h[h.GROUP_INDEX=1]="GROUP_INDEX",h[h.GROUP_LOCKED=2]="GROUP_LOCKED",h[h.EDITOR_OPEN=3]="EDITOR_OPEN",h[h.EDITOR_CLOSE=4]="EDITOR_CLOSE",h[h.EDITOR_MOVE=5]="EDITOR_MOVE",h[h.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",h[h.EDITOR_LABEL=7]="EDITOR_LABEL",h[h.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",h[h.EDITOR_PIN=9]="EDITOR_PIN",h[h.EDITOR_STICKY=10]="EDITOR_STICKY",h[h.EDITOR_DIRTY=11]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function m(h){const g=h;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.isEditorGroup=m;function a(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(be[172],Ee([0,1,4,92]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,l.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(T){const t=T;return typeof T=="number"||(0,M.isEditorGroup)(t)}e.isPreferredGroup=E}),define(be[8],Ee([0,1,15,22,77,234,57,23,10,2,45,61,138,83,50,89,69,172,7]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ce){function me(H){const{selectionStartLineNumber:we,selectionStartColumn:De,positionLineNumber:Ge,positionColumn:xe}=H,ct=new v.Position(we-1,De-1),Et=new v.Position(Ge-1,xe-1);return new v.Selection(ct,Et)}ce.to=me;function ne(H){const{anchor:we,active:De}=H;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:De.line+1,positionColumn:De.character+1}}ce.from=ne})(s=e.Selection||(e.Selection={}));var d;(function(ce){function me(H){if(!H)return;const{start:we,end:De}=H;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:De.line+1,endColumn:De.character+1}}ce.from=me;function ne(H){if(!H)return;const{startLineNumber:we,startColumn:De,endLineNumber:Ge,endColumn:xe}=H;return new v.Range(we-1,De-1,Ge-1,xe-1)}ce.to=ne})(d=e.Range||(e.Range={}));var C;(function(ce){function me(ne){switch(ne){case 1:return v.StandardTokenType.Comment;case 0:return v.StandardTokenType.Other;case 4:return v.StandardTokenType.RegEx;case 2:return v.StandardTokenType.String}}ce.to=me})(C=e.TokenType||(e.TokenType={}));var r;(function(ce){function me(H){return new v.Position(H.lineNumber-1,H.column-1)}ce.to=me;function ne(H){return{lineNumber:H.line+1,column:H.character+1}}ce.from=ne})(r=e.Position||(e.Position={}));var b;(function(ce){function me(we,De){return(0,l.coalesce)((0,l.asArray)(we).map(Ge=>ne(Ge,De)))}ce.from=me;function ne(we,De){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:H(we.scheme,De),pattern:typeof we.pattern=="undefined"?void 0:rt.from(we.pattern),exclusive:we.exclusive}}function H(we,De){return De&&typeof we=="string"?De.transformOutgoingScheme(we):we}})(b=e.DocumentSelector||(e.DocumentSelector={}));var o;(function(ce){function me(H){switch(H){case v.DiagnosticTag.Unnecessary:return 1;case v.DiagnosticTag.Deprecated:return 2}}ce.from=me;function ne(H){switch(H){case 1:return v.DiagnosticTag.Unnecessary;case 2:return v.DiagnosticTag.Deprecated;default:return}}ce.to=ne})(o=e.DiagnosticTag||(e.DiagnosticTag={}));var i;(function(ce){function me(H){let we;return H.code&&((0,D.isString)(H.code)||(0,D.isNumber)(H.code)?we=String(H.code):we={value:String(H.code.value),target:H.code.target}),{...d.from(H.range),message:H.message,source:H.source,code:we,severity:c.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(p.from),tags:Array.isArray(H.tags)?(0,l.coalesce)(H.tags.map(o.from)):void 0}}ce.from=me;function ne(H){const we=new v.Diagnostic(d.to(H),H.message,c.to(H.severity));return we.source=H.source,we.code=(0,D.isString)(H.code)?H.code:H.code?.value,we.relatedInformation=H.relatedInformation&&H.relatedInformation.map(p.to),we.tags=H.tags&&(0,l.coalesce)(H.tags.map(o.to)),we}ce.to=ne})(i=e.Diagnostic||(e.Diagnostic={}));var p;(function(ce){function me(H){return{...d.from(H.location.range),message:H.message,resource:H.location.uri}}ce.from=me;function ne(H){return new v.DiagnosticRelatedInformation(new v.Location(H.resource,d.to(H)),H.message)}ce.to=ne})(p=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var c;(function(ce){function me(H){switch(H){case v.DiagnosticSeverity.Error:return m.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return m.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return m.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return m.MarkerSeverity.Hint}return m.MarkerSeverity.Error}ce.from=me;function ne(H){switch(H){case m.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case m.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case m.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case m.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}ce.to=ne})(c=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var u;(function(ce){function me(H){return typeof H=="number"&&H>=v.ViewColumn.One?H-1:H===v.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}ce.from=me;function ne(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}ce.to=ne})(u=e.ViewColumn||(e.ViewColumn={}));function w(ce){return typeof ce.range!="undefined"}function f(ce){return ce.length===0?!0:!!w(ce[0])}e.isDecorationOptionsArr=f;var y;(function(ce){function me(xe){return xe.map(ce.from)}ce.fromMany=me;function ne(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function H(xe){let ct;if(ne(xe)){const{language:gt,value:dt}=xe;ct={value:"```"+gt+`
`+dt+"\n```\n"}}else v.MarkdownString.isMarkdownString(xe)?ct={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml}:typeof xe=="string"?ct={value:xe}:ct={value:""};const Et=Object.create(null);ct.uris=Et;const vt=gt=>{try{let dt=I.URI.parse(gt,!0);dt=dt.with({query:we(dt.query,Et)}),Et[gt]=dt}catch(dt){}return""},lt=new T.Renderer;return lt.link=vt,lt.image=gt=>vt(E.parseHrefAndDimensions(gt).href),T(ct.value,{renderer:lt}),ct}ce.from=H;function we(xe,ct){if(!xe)return xe;let Et;try{Et=(0,t.parse)(xe)}catch(lt){}if(!Et)return xe;let vt=!1;return Et=(0,A.cloneAndChange)(Et,lt=>{if(I.URI.isUri(lt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[gt]=lt,vt=!0,gt}else return}),vt?JSON.stringify(Et):xe}function De(xe){const ct=new v.MarkdownString(xe.value,xe.supportThemeIcons);return ct.isTrusted=xe.isTrusted,ct.supportHtml=xe.supportHtml,ct}ce.to=De;function Ge(xe){if(!!xe)return typeof xe=="string"?xe:ce.from(xe)}ce.fromStrict=Ge})(y=e.MarkdownString||(e.MarkdownString={}));function R(ce){return f(ce)?ce.map(me=>({range:d.from(me.range),hoverMessage:Array.isArray(me.hoverMessage)?y.fromMany(me.hoverMessage):me.hoverMessage?y.from(me.hoverMessage):void 0,renderOptions:me.renderOptions})):ce.map(me=>({range:d.from(me)}))}e.fromRangeOrRangeWithMessage=R;function P(ce){return typeof ce=="undefined"?ce:typeof ce=="string"?I.URI.file(ce):ce}e.pathOrURIToURI=P;var B;(function(ce){function me(ne){return typeof ne=="undefined"?ne:{contentText:ne.contentText,contentIconPath:ne.contentIconPath?P(ne.contentIconPath):void 0,border:ne.border,borderColor:ne.borderColor,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,color:ne.color,backgroundColor:ne.backgroundColor,margin:ne.margin,width:ne.width,height:ne.height}}ce.from=me})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var L;(function(ce){function me(ne){return typeof ne=="undefined"?ne:{backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?P(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?B.from(ne.before):void 0,after:ne.after?B.from(ne.after):void 0}}ce.from=me})(L=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var k;(function(ce){function me(ne){if(typeof ne=="undefined")return ne;switch(ne){case v.DecorationRangeBehavior.OpenOpen:return 0;case v.DecorationRangeBehavior.ClosedClosed:return 1;case v.DecorationRangeBehavior.OpenClosed:return 2;case v.DecorationRangeBehavior.ClosedOpen:return 3}}ce.from=me})(k=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(ce){function me(ne){return{isWholeLine:ne.isWholeLine,rangeBehavior:ne.rangeBehavior?k.from(ne.rangeBehavior):void 0,overviewRulerLane:ne.overviewRulerLane,light:ne.light?L.from(ne.light):void 0,dark:ne.dark?L.from(ne.dark):void 0,backgroundColor:ne.backgroundColor,outline:ne.outline,outlineColor:ne.outlineColor,outlineStyle:ne.outlineStyle,outlineWidth:ne.outlineWidth,border:ne.border,borderColor:ne.borderColor,borderRadius:ne.borderRadius,borderSpacing:ne.borderSpacing,borderStyle:ne.borderStyle,borderWidth:ne.borderWidth,fontStyle:ne.fontStyle,fontWeight:ne.fontWeight,textDecoration:ne.textDecoration,cursor:ne.cursor,color:ne.color,opacity:ne.opacity,letterSpacing:ne.letterSpacing,gutterIconPath:ne.gutterIconPath?P(ne.gutterIconPath):void 0,gutterIconSize:ne.gutterIconSize,overviewRulerColor:ne.overviewRulerColor,before:ne.before?B.from(ne.before):void 0,after:ne.after?B.from(ne.after):void 0}}ce.from=me})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var N;(function(ce){function me(H){return{text:H.newText,eol:H.newEol&&q.from(H.newEol),range:d.from(H.range)}}ce.from=me;function ne(H){const we=new v.TextEdit(d.to(H.range),H.text);return we.newEol=typeof H.eol=="undefined"?void 0:q.to(H.eol),we}ce.to=ne})(N=e.TextEdit||(e.TextEdit={}));var V;(function(ce){function me(H,we,De){const Ge={edits:[]};if(H instanceof v.WorkspaceEdit)for(let xe of H._allEntries())if(xe._type===1)Ge.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata});else if(xe._type===2){const ct=we?.getDocument(xe.uri);Ge.edits.push({_type:2,resource:xe.uri,edit:N.from(xe.edit),modelVersionId:ct?.version,metadata:xe.metadata})}else xe._type===3?Ge.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version}):xe._type===5&&Ge.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:De?.getNotebookDocument(xe.uri,!0)?.apiNotebook.version,edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(Ze.from)}});return Ge}ce.from=me;function ne(H){const we=new v.WorkspaceEdit;for(const De of H.edits)De.edit?we.replace(I.URI.revive(De.resource),d.to(De.edit.range),De.edit.text):we.renameFile(I.URI.revive(De.oldUri),I.URI.revive(De.newUri),De.options);return we}ce.to=ne})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(ce){const me=Object.create(null);me[v.SymbolKind.File]=0,me[v.SymbolKind.Module]=1,me[v.SymbolKind.Namespace]=2,me[v.SymbolKind.Package]=3,me[v.SymbolKind.Class]=4,me[v.SymbolKind.Method]=5,me[v.SymbolKind.Property]=6,me[v.SymbolKind.Field]=7,me[v.SymbolKind.Constructor]=8,me[v.SymbolKind.Enum]=9,me[v.SymbolKind.Interface]=10,me[v.SymbolKind.Function]=11,me[v.SymbolKind.Variable]=12,me[v.SymbolKind.Constant]=13,me[v.SymbolKind.String]=14,me[v.SymbolKind.Number]=15,me[v.SymbolKind.Boolean]=16,me[v.SymbolKind.Array]=17,me[v.SymbolKind.Object]=18,me[v.SymbolKind.Key]=19,me[v.SymbolKind.Null]=20,me[v.SymbolKind.EnumMember]=21,me[v.SymbolKind.Struct]=22,me[v.SymbolKind.Event]=23,me[v.SymbolKind.Operator]=24,me[v.SymbolKind.TypeParameter]=25;function ne(we){return typeof me[we]=="number"?me[we]:6}ce.from=ne;function H(we){for(const De in me)if(me[De]===we)return Number(De);return v.SymbolKind.Property}ce.to=H})(W=e.SymbolKind||(e.SymbolKind={}));var $;(function(ce){function me(H){switch(H){case v.SymbolTag.Deprecated:return 1}}ce.from=me;function ne(H){switch(H){case 1:return v.SymbolTag.Deprecated}}ce.to=ne})($=e.SymbolTag||(e.SymbolTag={}));var X;(function(ce){function me(H){return{name:H.name,kind:W.from(H.kind),tags:H.tags&&H.tags.map($.from),containerName:H.containerName,location:ue.from(H.location)}}ce.from=me;function ne(H){const we=new v.SymbolInformation(H.name,W.to(H.kind),H.containerName,ue.to(H.location));return we.tags=H.tags&&H.tags.map($.to),we}ce.to=ne})(X=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var j;(function(ce){function me(H){const we={name:H.name||"!!MISSING: name!!",detail:H.detail,range:d.from(H.range),selectionRange:d.from(H.selectionRange),kind:W.from(H.kind),tags:H.tags?.map($.from)??[]};return H.children&&(we.children=H.children.map(me)),we}ce.from=me;function ne(H){const we=new v.DocumentSymbol(H.name,H.detail,W.to(H.kind),d.to(H.range),d.to(H.selectionRange));return(0,l.isNonEmptyArray)(H.tags)&&(we.tags=H.tags.map($.to)),H.children&&(we.children=H.children.map(ne)),we}ce.to=ne})(j=e.DocumentSymbol||(e.DocumentSymbol={}));var Q;(function(ce){function me(H){const we=new v.CallHierarchyItem(W.to(H.kind),H.name,H.detail||"",I.URI.revive(H.uri),d.to(H.range),d.to(H.selectionRange));return we._sessionId=H._sessionId,we._itemId=H._itemId,we}ce.to=me;function ne(H,we,De){if(we=we??H._sessionId,De=De??H._itemId,we===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:De,name:H.name,detail:H.detail,kind:W.from(H.kind),uri:H.uri,range:d.from(H.range),selectionRange:d.from(H.selectionRange),tags:H.tags?.map($.from)}}ce.from=ne})(Q=e.CallHierarchyItem||(e.CallHierarchyItem={}));var le;(function(ce){function me(ne){return new v.CallHierarchyIncomingCall(Q.to(ne.from),ne.fromRanges.map(H=>d.to(H)))}ce.to=me})(le=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ve;(function(ce){function me(ne){return new v.CallHierarchyOutgoingCall(Q.to(ne.to),ne.fromRanges.map(H=>d.to(H)))}ce.to=me})(ve=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ue;(function(ce){function me(H){return{range:H.range&&d.from(H.range),uri:H.uri}}ce.from=me;function ne(H){return new v.Location(I.URI.revive(H.uri),d.to(H.range))}ce.to=ne})(ue=e.location||(e.location={}));var Fe;(function(ce){function me(H){const we=H,De=H;return{originSelectionRange:we.originSelectionRange?d.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:De.uri,range:d.from(we.targetRange?we.targetRange:De.range),targetSelectionRange:we.targetSelectionRange?d.from(we.targetSelectionRange):void 0}}ce.from=me;function ne(H){return{targetUri:I.URI.revive(H.uri),targetRange:d.to(H.range),targetSelectionRange:H.targetSelectionRange?d.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?d.to(H.originSelectionRange):void 0}}ce.to=ne})(Fe=e.DefinitionLink||(e.DefinitionLink={}));var Ke;(function(ce){function me(H){return{range:d.from(H.range),contents:y.fromMany(H.contents)}}ce.from=me;function ne(H){return new v.Hover(H.contents.map(y.to),d.to(H.range))}ce.to=ne})(Ke=e.Hover||(e.Hover={}));var Oe;(function(ce){function me(H){return{range:d.from(H.range),expression:H.expression}}ce.from=me;function ne(H){return new v.EvaluatableExpression(d.to(H.range),H.expression)}ce.to=ne})(Oe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var He;(function(ce){function me(H){if(H instanceof v.InlineValueText)return{type:"text",range:d.from(H.range),text:H.text};if(H instanceof v.InlineValueVariableLookup)return{type:"variable",range:d.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof v.InlineValueEvaluatableExpression)return{type:"expression",range:d.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}ce.from=me;function ne(H){switch(H.type){case"text":return{range:d.to(H.range),text:H.text};case"variable":return{range:d.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:d.to(H.range),expression:H.expression}}}ce.to=ne})(He=e.InlineValue||(e.InlineValue={}));var Je;(function(ce){function me(H){return{frameId:H.frameId,stoppedLocation:d.from(H.stoppedLocation)}}ce.from=me;function ne(H){return new v.InlineValueContext(H.frameId,d.to(H.stoppedLocation))}ce.to=ne})(Je=e.InlineValueContext||(e.InlineValueContext={}));var Ye;(function(ce){function me(H){return{range:d.from(H.range),kind:H.kind}}ce.from=me;function ne(H){return new v.DocumentHighlight(d.to(H.range),H.kind)}ce.to=ne})(Ye=e.DocumentHighlight||(e.DocumentHighlight={}));var Qe;(function(ce){function me(ne){switch(ne){case 1:return v.CompletionTriggerKind.TriggerCharacter;case 2:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return v.CompletionTriggerKind.Invoke}}ce.to=me})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var z;(function(ce){function me(ne){return{triggerKind:Qe.to(ne.triggerKind),triggerCharacter:ne.triggerCharacter}}ce.to=me})(z=e.CompletionContext||(e.CompletionContext={}));var K;(function(ce){function me(H){switch(H){case v.CompletionItemTag.Deprecated:return 1}}ce.from=me;function ne(H){switch(H){case 1:return v.CompletionItemTag.Deprecated}}ce.to=ne})(K=e.CompletionItemTag||(e.CompletionItemTag={}));var Z;(function(ce){const me=new Map([[v.CompletionItemKind.Method,0],[v.CompletionItemKind.Function,1],[v.CompletionItemKind.Constructor,2],[v.CompletionItemKind.Field,3],[v.CompletionItemKind.Variable,4],[v.CompletionItemKind.Class,5],[v.CompletionItemKind.Interface,7],[v.CompletionItemKind.Struct,6],[v.CompletionItemKind.Module,8],[v.CompletionItemKind.Property,9],[v.CompletionItemKind.Unit,12],[v.CompletionItemKind.Value,13],[v.CompletionItemKind.Constant,14],[v.CompletionItemKind.Enum,15],[v.CompletionItemKind.EnumMember,16],[v.CompletionItemKind.Keyword,17],[v.CompletionItemKind.Snippet,27],[v.CompletionItemKind.Text,18],[v.CompletionItemKind.Color,19],[v.CompletionItemKind.File,20],[v.CompletionItemKind.Reference,21],[v.CompletionItemKind.Folder,23],[v.CompletionItemKind.Event,10],[v.CompletionItemKind.Operator,11],[v.CompletionItemKind.TypeParameter,24],[v.CompletionItemKind.Issue,26],[v.CompletionItemKind.User,25]]);function ne(De){return me.get(De)??9}ce.from=ne;const H=new Map([[0,v.CompletionItemKind.Method],[1,v.CompletionItemKind.Function],[2,v.CompletionItemKind.Constructor],[3,v.CompletionItemKind.Field],[4,v.CompletionItemKind.Variable],[5,v.CompletionItemKind.Class],[7,v.CompletionItemKind.Interface],[6,v.CompletionItemKind.Struct],[8,v.CompletionItemKind.Module],[9,v.CompletionItemKind.Property],[12,v.CompletionItemKind.Unit],[13,v.CompletionItemKind.Value],[14,v.CompletionItemKind.Constant],[15,v.CompletionItemKind.Enum],[16,v.CompletionItemKind.EnumMember],[17,v.CompletionItemKind.Keyword],[27,v.CompletionItemKind.Snippet],[18,v.CompletionItemKind.Text],[19,v.CompletionItemKind.Color],[20,v.CompletionItemKind.File],[21,v.CompletionItemKind.Reference],[23,v.CompletionItemKind.Folder],[10,v.CompletionItemKind.Event],[11,v.CompletionItemKind.Operator],[24,v.CompletionItemKind.TypeParameter],[25,v.CompletionItemKind.User],[26,v.CompletionItemKind.Issue]]);function we(De){return H.get(De)??v.CompletionItemKind.Property}ce.to=we})(Z=e.CompletionItemKind||(e.CompletionItemKind={}));var oe;(function(ce){function me(ne,H){const we=new v.CompletionItem(ne.label);return we.insertText=ne.insertText,we.kind=Z.to(ne.kind),we.tags=ne.tags?.map(K.to),we.detail=ne.detail,we.documentation=E.isMarkdownString(ne.documentation)?y.to(ne.documentation):ne.documentation,we.sortText=ne.sortText,we.filterText=ne.filterText,we.preselect=ne.preselect,we.commitCharacters=ne.commitCharacters,F.Range.isIRange(ne.range)?we.range=d.to(ne.range):typeof ne.range=="object"&&(we.range={inserting:d.to(ne.range.insert),replacing:d.to(ne.range.replace)}),we.keepWhitespace=typeof ne.insertTextRules=="undefined"?!1:Boolean(ne.insertTextRules&1),typeof ne.insertTextRules!="undefined"&&ne.insertTextRules&4?we.insertText=new v.SnippetString(ne.insertText):(we.insertText=ne.insertText,we.textEdit=we.range instanceof v.Range?new v.TextEdit(we.range,we.insertText):void 0),ne.additionalTextEdits&&ne.additionalTextEdits.length>0&&(we.additionalTextEdits=ne.additionalTextEdits.map(De=>N.to(De))),we.command=H&&ne.command?H.fromInternal(ne.command):void 0,we}ce.to=me})(oe=e.CompletionItem||(e.CompletionItem={}));var G;(function(ce){function me(H){return{label:H.label,documentation:H.documentation?y.fromStrict(H.documentation):void 0}}ce.from=me;function ne(H){return{label:H.label,documentation:E.isMarkdownString(H.documentation)?y.to(H.documentation):H.documentation}}ce.to=ne})(G=e.ParameterInformation||(e.ParameterInformation={}));var ie;(function(ce){function me(H){return{label:H.label,documentation:H.documentation?y.fromStrict(H.documentation):void 0,parameters:Array.isArray(H.parameters)?H.parameters.map(G.from):[],activeParameter:H.activeParameter}}ce.from=me;function ne(H){return{label:H.label,documentation:E.isMarkdownString(H.documentation)?y.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(G.to):[],activeParameter:H.activeParameter}}ce.to=ne})(ie=e.SignatureInformation||(e.SignatureInformation={}));var de;(function(ce){function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(ie.from):[]}}ce.from=me;function ne(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(ie.to):[]}}ce.to=ne})(de=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(ce){function me(H){return{text:H.text,position:r.from(H.position),kind:Ne.from(H.kind??v.InlayHintKind.Other),whitespaceBefore:H.whitespaceBefore,whitespaceAfter:H.whitespaceAfter}}ce.from=me;function ne(H){const we=new v.InlayHint(H.text,r.to(H.position),Ne.to(H.kind));return we.whitespaceAfter=H.whitespaceAfter,we.whitespaceBefore=H.whitespaceBefore,we}ce.to=ne})(Pe=e.InlayHint||(e.InlayHint={}));var Ne;(function(ce){function me(H){return H}ce.from=me;function ne(H){return H}ce.to=ne})(Ne=e.InlayHintKind||(e.InlayHintKind={}));var We;(function(ce){function me(H){return{range:d.from(H.range),url:H.target,tooltip:H.tooltip}}ce.from=me;function ne(H){let we;if(H.url)try{we=typeof H.url=="string"?I.URI.parse(H.url,!0):I.URI.revive(H.url)}catch(De){}return new v.DocumentLink(d.to(H.range),we)}ce.to=ne})(We=e.DocumentLink||(e.DocumentLink={}));var je;(function(ce){function me(H){const we=new v.ColorPresentation(H.label);return H.textEdit&&(we.textEdit=N.to(H.textEdit)),H.additionalTextEdits&&(we.additionalTextEdits=H.additionalTextEdits.map(De=>N.to(De))),we}ce.to=me;function ne(H){return{label:H.label,textEdit:H.textEdit?N.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(we=>N.from(we)):void 0}}ce.from=ne})(je=e.ColorPresentation||(e.ColorPresentation={}));var et;(function(ce){function me(H){return new v.Color(H[0],H[1],H[2],H[3])}ce.to=me;function ne(H){return[H.red,H.green,H.blue,H.alpha]}ce.from=ne})(et=e.Color||(e.Color={}));var ot;(function(ce){function me(H){return{range:d.from(H.range)}}ce.from=me;function ne(H){return new v.SelectionRange(d.to(H.range))}ce.to=ne})(ot=e.SelectionRange||(e.SelectionRange={}));var ye;(function(ce){function me(ne){switch(ne){case 2:return v.TextDocumentSaveReason.AfterDelay;case 1:return v.TextDocumentSaveReason.Manual;case 3:case 4:return v.TextDocumentSaveReason.FocusOut}}ce.to=me})(ye=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var nt;(function(ce){function me(H){switch(H){case v.TextEditorLineNumbersStyle.Off:return 0;case v.TextEditorLineNumbersStyle.Relative:return 2;case v.TextEditorLineNumbersStyle.On:default:return 1}}ce.from=me;function ne(H){switch(H){case 0:return v.TextEditorLineNumbersStyle.Off;case 2:return v.TextEditorLineNumbersStyle.Relative;case 1:default:return v.TextEditorLineNumbersStyle.On}}ce.to=ne})(nt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var q;(function(ce){function me(H){if(H===v.EndOfLine.CRLF)return 1;if(H===v.EndOfLine.LF)return 0}ce.from=me;function ne(H){if(H===1)return v.EndOfLine.CRLF;if(H===0)return v.EndOfLine.LF}ce.to=ne})(q=e.EndOfLine||(e.EndOfLine={}));var J;(function(ce){function me(ne){if(typeof ne=="object")return ne.viewId;switch(ne){case v.ProgressLocation.SourceControl:return 3;case v.ProgressLocation.Window:return 10;case v.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ce.from=me})(J=e.ProgressLocation||(e.ProgressLocation={}));var pe;(function(ce){function me(ne){const H={start:ne.start+1,end:ne.end+1};return ne.kind&&(H.kind=$e.from(ne.kind)),H}ce.from=me})(pe=e.FoldingRange||(e.FoldingRange={}));var $e;(function(ce){function me(ne){if(ne)switch(ne){case v.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}ce.from=me})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var qe;(function(ce){function me(ne){if(ne)return{pinned:typeof ne.preview=="boolean"?!ne.preview:void 0,inactive:ne.background,preserveFocus:ne.preserveFocus,selection:typeof ne.selection=="object"?d.from(ne.selection):void 0,override:typeof ne.override=="boolean"?n.EditorResolution.DISABLED:void 0}}ce.from=me})(qe=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var rt;(function(ce){function me(H){return H instanceof v.RelativePattern||typeof H=="string"?H:ne(H)?new v.RelativePattern(H.base,H.pattern):H}ce.from=me;function ne(H){const we=H;return we&&typeof we.base=="string"&&typeof we.pattern=="string"}})(rt=e.GlobPattern||(e.GlobPattern={}));var ft;(function(ce){function me(ne){if(ne){if(Array.isArray(ne))return ne.map(me);if(typeof ne=="string")return ne;{const H=ne;return{language:H.language,scheme:H.scheme,pattern:typeof H.pattern=="undefined"?void 0:rt.from(H.pattern),exclusive:H.exclusive}}}else return}ce.from=me})(ft=e.LanguageSelector||(e.LanguageSelector={}));var ht;(function(ce){function me(H){return{start:H.start,end:H.end}}ce.from=me;function ne(H){return new v.NotebookRange(H.start,H.end)}ce.to=ne})(ht=e.NotebookRange||(e.NotebookRange={}));var Ct;(function(ce){function me(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}ce.to=me;function ne(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}ce.from=ne})(Ct=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var It;(function(ce){function me(H){switch(H){case v.NotebookCellKind.Markup:return h.CellKind.Markup;case v.NotebookCellKind.Code:default:return h.CellKind.Code}}ce.from=me;function ne(H){switch(H){case h.CellKind.Markup:return v.NotebookCellKind.Markup;case h.CellKind.Code:default:return v.NotebookCellKind.Code}}ce.to=ne})(It=e.NotebookCellKind||(e.NotebookCellKind={}));var Pt;(function(ce){function me(H){const we={metadata:H.metadata??Object.create(null),cells:[]};for(let De of H.cells)v.NotebookCellData.validate(De),we.cells.push(Ze.from(De));return we}ce.from=me;function ne(H){const we=new v.NotebookData(H.cells.map(Ze.to));return(0,D.isEmptyObject)(H.metadata)||(we.metadata=H.metadata),we}ce.to=ne})(Pt=e.NotebookData||(e.NotebookData={}));var Ze;(function(ce){function me(H){return{cellKind:It.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Ct.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Ie.from):[]}}ce.from=me;function ne(H){return new v.NotebookCellData(It.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Ie.to):void 0,H.metadata,H.internalMetadata?Ct.to(H.internalMetadata):void 0)}ce.to=ne})(Ze=e.NotebookCellData||(e.NotebookCellData={}));var pt;(function(ce){function me(H){return{mime:H.mime,valueBytes:M.VSBuffer.wrap(H.data)}}ce.from=me;function ne(H){return new v.NotebookCellOutputItem(H.valueBytes.buffer,H.mime)}ce.to=ne})(pt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(ce){function me(H){return{outputId:H.id,items:H.items.map(pt.from),metadata:H.metadata}}ce.from=me;function ne(H){const we=H.items.map(pt.to);return new v.NotebookCellOutput(we,H.outputId,H.metadata)}ce.to=ne})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ge;(function(ce){function me(De){if(De!=null){if(De instanceof v.RelativePattern||typeof De=="string")return De;if(we(De))return new v.RelativePattern(De.base,De.pattern);if(H(De))return{include:rt.from(De.include)||void 0,exclude:rt.from(De.exclude)||void 0}}}ce.from=me;function ne(De){return typeof De=="string"?De:we(De)?{base:De.base,pattern:De.pattern}:{include:De.include,exclude:De.exclude}}ce.to=ne;function H(De){const Ge=De,xe=rt.from(Ge.include);if(!(xe&&xe instanceof v.RelativePattern||typeof xe=="string"))return!1;const ct=rt.from(Ge.exclude);return!!(ct&&ct instanceof v.RelativePattern||typeof ct=="string")}function we(De){const Ge=De;return Ge&&typeof Ge.base=="string"&&typeof Ge.pattern=="string"}})(ge=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ce;(function(ce){function me(ne){return{backgroundColor:ne.backgroundColor,borderColor:ne.borderColor,top:ne.top?B.from(ne.top):void 0}}ce.from=me})(Ce=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ee;(function(ce){function me(ne,H,we){const De=typeof ne.command=="string"?{title:"",command:ne.command}:ne.command;return{alignment:ne.alignment===v.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(De,we),text:ne.text,tooltip:ne.tooltip,accessibilityInformation:ne.accessibilityInformation,priority:ne.priority}}ce.from=me})(ee=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var se;(function(ce){function me(ne){return{transientOutputs:ne?.transientOutputs??!1,transientCellMetadata:ne?.transientCellMetadata??{},transientDocumentMetadata:ne?.transientDocumentMetadata??{}}}ce.from=me})(se=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var fe;(function(ce){function me(H){return{uri:H.uri,provides:H.provides}}ce.from=me;function ne(H){return new v.NotebookRendererScript(I.URI.revive(H.uri),H.provides)}ce.to=ne})(fe=e.NotebookRendererScript||(e.NotebookRendererScript={}));var he;(function(ce){function me(H){return{message:y.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,location:H.location?ue.from(H.location):void 0}}ce.from=me;function ne(H){const we=new v.TestMessage(typeof H.message=="string"?H.message:y.to(H.message));return we.actualOutput=H.actual,we.expectedOutput=H.expected,we.location=H.location?ue.to(H.location):void 0,we}ce.to=ne})(he=e.TestMessage||(e.TestMessage={}));var ke;(function(ce){let me;(function(ne){ne.Delimiter="\0"})(me||(me={})),ce.namespace=(ne,H)=>ne+"\0"+H,ce.denamespace=ne=>{const H=ne.indexOf("\0");return{ctrlId:ne.slice(0,H),tagId:ne.slice(H+1)}}})(ke=e.TestTag||(e.TestTag={}));var Le;(function(ce){function me(De){const Ge=(0,a.getPrivateApiFor)(De).controllerId;return{extId:g.TestId.fromExtHostTestItem(De,Ge).toString(),label:De.label,uri:De.uri,tags:De.tags.map(xe=>ke.namespace(Ge,xe.id)),range:d.from(De.range)||null,description:De.description||null,error:De.error&&y.fromStrict(De.error)||null}}ce.from=me;function ne(De){return{parent:void 0,error:void 0,id:g.TestId.fromString(De.extId).localId,label:De.label,uri:I.URI.revive(De.uri),tags:(De.tags||[]).map(Ge=>{const{tagId:xe}=ke.denamespace(Ge);return new v.TestTag(xe)}),range:d.to(De.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:De.description||void 0}}ce.toPlain=ne;function H(De){const Ge=g.TestId.fromString(De.extId),xe=new a.TestItemImpl(Ge.controllerId,Ge.localId,De.label,I.URI.revive(De.uri));return xe.range=d.to(De.range||void 0),xe.description=De.description||void 0,xe}function we(De){let Ge;for(const xe of De.tests){const ct=H(xe.item);(0,a.getPrivateApiFor)(ct).parent=Ge,Ge=ct}return Ge}ce.toItemFromContext=we})(Le=e.TestItem||(e.TestItem={})),function(ce){function me(H){return{id:H.id}}ce.from=me;function ne(H){return new v.TestTag(H.id)}ce.to=ne}(ke=e.TestTag||(e.TestTag={}));var Me;(function(ce){const me=(H,we)=>{const De={...Le.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(xe=>xe.type===0).map(he.to)})),children:H.children.map(Ge=>we.get(Ge)).filter(D.isDefined).map(Ge=>me(Ge,we))};for(const Ge of De.children)Ge.parent=De;return De};function ne(H){const we=[],De=new Map;for(const Ge of H.items)De.set(Ge.item.extId,Ge),H.request.targets.some(xe=>xe.controllerId===Ge.controllerId&&xe.testIds.includes(Ge.item.extId))&&we.push(Ge);return{completedAt:H.completedAt,results:we.map(Ge=>me(Ge,De))}}ce.to=ne})(Me=e.TestResults||(e.TestResults={}));var ze;(function(ce){function me(De){return{covered:De.covered,total:De.covered}}function ne(De){return"line"in De?r.from(De):d.from(De)}function H(De){return"branches"in De?{count:De.executionCount,location:ne(De.location),type:1,branches:De.branches.length?De.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ne(Ge.location)})):void 0}:{type:0,count:De.executionCount,location:ne(De.location)}}ce.fromDetailed=H;function we(De){return{uri:De.uri,statement:me(De.statementCoverage),branch:De.branchCoverage&&me(De.branchCoverage),function:De.functionCoverage&&me(De.functionCoverage),details:De.detailedCoverage?.map(H)}}ce.fromFile=we})(ze=e.TestCoverage||(e.TestCoverage={}));var it;(function(ce){function me(ne){switch(ne){case 1:return v.CodeActionTriggerKind.Invoke;case 2:return v.CodeActionTriggerKind.Automatic}}ce.to=me})(it=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Re;(function(ce){function me(H){const we=new v.TypeHierarchyItem(W.to(H.kind),H.name,H.detail||"",I.URI.revive(H.uri),d.to(H.range),d.to(H.selectionRange));return we._sessionId=H._sessionId,we._itemId=H._itemId,we}ce.to=me;function ne(H,we,De){if(we=we??H._sessionId,De=De??H._itemId,we===void 0||De===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:De,kind:W.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:d.from(H.range),selectionRange:d.from(H.selectionRange),tags:H.tags?.map($.from)}}ce.from=ne})(Re=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[173],Ee([0,1,2,16,7,8,235]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(I,F,_,n={timeout:1500,errors:3}){this._logService=I,this._documents=F,this._mainThreadBulkEdits=_,this._thresholds=n,this._callbacks=new t.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(I){return(F,_,n)=>{const a={dispose:this._callbacks.push([F,_,I])};return Array.isArray(n)&&n.push(a),a}}async $participateInSave(I,F){const _=l.URI.revive(I);let n=!1;const m=setTimeout(()=>n=!0,this._thresholds.timeout),a=[];try{for(let h of[...this._callbacks]){if(n)break;const g=this._documents.getDocument(_),S=await this._deliverEventAsyncAndBlameBadListeners(h,{document:g,reason:T.TextDocumentSaveReason.to(F)});a.push(S)}}finally{clearTimeout(m)}return a}_deliverEventAsyncAndBlameBadListeners([I,F,_],n){const m=this._badListeners.get(I);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,I,F,n).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const h=this._badListeners.get(I);this._badListeners.set(I,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(I,F,_,n){const m=[],a=Date.now(),{document:h,reason:g}=n,{version:S}=h,v=Object.freeze({document:h,reason:g,waitUntil(s){if(Object.isFrozen(m))throw(0,M.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(s))}});try{F.apply(_,[v])}catch(s){return Promise.reject(s)}return Object.freeze(m),new Promise((s,d)=>{const C=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(C),s(r)}).catch(r=>{clearTimeout(C),d(r)})}).then(s=>{const d={edits:[]};for(const C of s)if(Array.isArray(C)&&C.every(r=>r instanceof E.TextEdit))for(const{newText:r,newEol:b,range:o}of C)d.edits.push({_type:2,resource:h.uri,edit:{range:o&&T.Range.from(o),text:r,eol:b&&T.EndOfLine.from(b)}});if(d.edits.length!==0)return S===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(be[174],Ee([0,1,3,29,2,8,7]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class A{constructor(F,_,n,m,a){this._onDidCreate=new l.Emitter,this._onDidChange=new l.Emitter,this._onDidDelete=new l.Emitter,this._config=0,n&&(this._config+=1),m&&(this._config+=2),a&&(this._config+=4);const h=(0,M.parse)(_),g=F(S=>{if(!n)for(let v of S.created){const s=E.URI.revive(v);h(s.fsPath)&&this._onDidCreate.fire(s)}if(!m)for(let v of S.changed){const s=E.URI.revive(v);h(s.fsPath)&&this._onDidChange.fire(s)}if(!a)for(let v of S.deleted){const s=E.URI.revive(v);h(s.fsPath)&&this._onDidDelete.fire(s)}});this._disposable=t.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,g)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(F,_,n){this._logService=_,this._extHostDocumentsAndEditors=n,this._onFileSystemEvent=new l.Emitter,this._onDidRenameFile=new l.Emitter,this._onDidCreateFile=new l.Emitter,this._onDidDeleteFile=new l.Emitter,this._onWillRenameFile=new l.AsyncEmitter,this._onWillCreateFile=new l.AsyncEmitter,this._onWillDeleteFile=new l.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(F,_,n,m){return new A(this._onFileSystemEvent.event,F,_,n,m)}$onFileEvent(F){this._onFileSystemEvent.fire(F)}$onDidRunFileOperation(F,_){switch(F){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(n=>({oldUri:E.URI.revive(n.source),newUri:E.URI.revive(n.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(n=>E.URI.revive(n.target))}));break;default:}}getOnWillRenameFileEvent(F){return this._createWillExecuteEvent(F,this._onWillRenameFile)}getOnWillCreateFileEvent(F){return this._createWillExecuteEvent(F,this._onWillCreateFile)}getOnWillDeleteFileEvent(F){return this._createWillExecuteEvent(F,this._onWillDeleteFile)}_createWillExecuteEvent(F,_){return(n,m,a)=>{const h=function(S){n.call(m,S)};return h.extension=F,_.event(h,void 0,a)}}async $onWillRunFileOperation(F,_,n,m){switch(F){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(a=>({oldUri:E.URI.revive(a.source),newUri:E.URI.revive(a.target)}))},n,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(a=>E.URI.revive(a.target))},n,m);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(a=>E.URI.revive(a.target))},n,m)}}async _fireWillEvent(F,_,n,m){const a=new Set,h=[];if(await F.fireAsync(_,m,async(S,v)=>{const s=Date.now(),d=await Promise.resolve(S);d instanceof t.WorkspaceEdit&&(h.push(d),a.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-s>n&&this._logService.warn("SLOW file-participant",v.extension.identifier)}),m.isCancellationRequested||h.length===0)return;const g={edits:[]};for(let S of h){let{edits:v}=T.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);g.edits=g.edits.concat(v)}return{edit:g,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=D}),define(be[175],Ee([0,1,11,23,2,8,7,89]),function(re,e,l,M,E,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(n,m,a,h){this.start=n,this.deletedCount=m,this.deletedItems=a,this.items=h}static asApiEvents(n){return n.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(a=>a.apiCell)}))}}class I{constructor(n,m,a){this.notebook=n,this._extHostDocument=m,this._cellData=a,this.handle=a.handle,this.uri=E.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=Object.freeze(a.metadata??{}),this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(a.internalMetadata??{}))}static asModelAddData(n,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:n}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const n=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return n.notebook.getCellIndex(n)},notebook:n.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return n._mime},set mime(a){n._mime=a},get outputs(){return n._outputs.slice(0)},get metadata(){return n._metadata},get executionSummary(){return n._previousResult}})}return this._apiCell}setOutputs(n){this._outputs=n.map(T.NotebookCellOutput.to)}setOutputItems(n,m,a){const h=a.map(T.NotebookCellOutputItem.to),g=this._outputs.find(S=>S.id===n);g&&(m||(g.items.length=0),g.items.push(...h))}setMetadata(n){this._metadata=Object.freeze(n)}setInternalMetadata(n){this._internalMetadata=n,this._previousResult=Object.freeze(T.NotebookCellExecutionSummary.to(n))}setMime(n){}}e.ExtHostCell=I;class F{constructor(n,m,a,h,g,S){this._proxy=n,this._textDocumentsAndEditors=m,this._textDocuments=a,this._emitter=h,this.uri=g,this.handle=F._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=S.viewType,this._metadata=Object.freeze(S.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,S.cells]],!0),this._versionId=S.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const n=this;this._notebook={get uri(){return n.uri},get version(){return n._versionId},get notebookType(){return n._notebookType},get isDirty(){return n._isDirty},get isUntitled(){return n.uri.scheme===l.Schemas.untitled},get isClosed(){return n._disposed},get metadata(){return n._metadata},get cellCount(){return n._cells.length},cellAt(m){return m=n._validateIndex(m),n._cells[m].apiCell},getCells(m){return(m?n._getCells(m):n._cells).map(h=>h.apiCell)},save(){return n._save()}}}return this._notebook}updateBackup(n){this._backup?.delete(),this._backup=n}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(n){n.metadata&&(this._metadata=Object.freeze({...this._metadata,...n.metadata}))}acceptDirty(n){this._isDirty=n}acceptModelChanged(n,m){this._versionId=n.versionId,this._isDirty=m;for(const a of n.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===A.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===A.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===A.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===A.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(n){return n=n|0,n<0?0:n>=this._cells.length?this._cells.length-1:n}_validateRange(n){let m=n.start|0,a=n.end|0;return m<0&&(m=0),a>this._cells.length&&(a=this._cells.length),n.with({start:m,end:a})}_getCells(n){n=this._validateRange(n);const m=[];for(let a=n.start;a<n.end;a++)m.push(this._cells[a]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(n,m){if(this._disposed)return;const a=[],h=[],g=[];n.reverse().forEach(S=>{const s=S[2].map(r=>{const b=new I(this,this._textDocumentsAndEditors,r);return m||h.push(I.asModelAddData(this.apiNotebook,r)),b}),d=new D(S[0],S[1],[],s),C=this._cells.splice(S[0],S[1],...s);for(const r of C)g.push(r.uri),d.deletedItems.push(r.apiCell);a.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:g}),m||this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(a)}))}_moveCell(n,m){const a=this._cells.splice(n,1);this._cells.splice(m,0,...a);const h=[new D(n,1,a.map(g=>g.apiCell),[]),new D(m,0,[],a)];this._emitter.emitModelChange((0,M.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(h)}))}_setCellOutputs(n,m){const a=this._cells[n];a.setOutputs(m),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(n,m,a,h){const g=this._cells[n];g.setOutputItems(m,a,h),this._emitter.emitCellOutputsChange((0,M.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(n,m){const a=this._cells[n];a.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(a.uri,m)}_changeCellMime(n,m){const a=this._cells[n];a.apiCell.mime=m}_changeCellMetadata(n,m){const a=this._cells[n],h=a.apiCell.metadata;a.setMetadata(m);const g=a.apiCell.metadata;(0,M.equals)(h,g)||this._emitter.emitCellMetadataChange((0,M.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(n,m){const a=this._cells[n],h=a.internalMetadata;if(a.setInternalMetadata(m),h.runState!==m.runState){const g=m.runState??t.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,M.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:g}))}}getCellFromApiCell(n){return this._cells.find(m=>m.apiCell===n)}getCellFromIndex(n){return this._cells[n]}getCell(n){return this._cells.find(m=>m.handle===n)}getCellIndex(n){return this._cells.indexOf(n)}}e.ExtHostNotebookDocument=F,F._handlePool=0}),define(be[93],Ee([0,1,7,8,16]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class T{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,I){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:I})}replaceCells(D,I,F){this._throwIfFinalized(),!(D===I&&F.length===0)&&this._collectedEdits.push({editType:1,index:D,count:I-D,cells:F.map(M.NotebookCellData.from)})}}class t{constructor(D,I,F,_,n,m){this.id=D,this._proxy=I,this.notebookData=F,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=n,this._visibleRanges=_,this._viewColumn=m}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(I){if(!Array.isArray(I)||!I.every(l.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");D._selections=I,D._trySetSelections(I)},get visibleRanges(){return D._visibleRanges},revealRange(I,F){D._proxy.$tryRevealRange(D.id,M.NotebookRange.from(I),F??l.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(I){const F=new T(this.document.version);return I(F),D._applyEdit(F.finalize())},setDecorations(I,F){return D.setDecorations(I,F)}},t.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(M.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const I=[];let F=-1;for(let _=0;_<D.cellEdits.length;_++){if(F<0){I.push(D.cellEdits[_]),F++;continue}const m=I[F],a=D.cellEdits[_];if(m.editType===1&&a.editType===1&&m.index===a.index){m.cells.push(...D.cellEdits[_].cells),m.count+=D.cellEdits[_].count;continue}I.push(D.cellEdits[_]),F++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,I)}setDecorations(D,I){if(!(I.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return I.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,M.NotebookRange.from(I),D.key)}}e.ExtHostNotebookEditor=t,t.apiEditorsToExtHost=new WeakMap}),define(be[176],Ee([0,1,8,147,127,21,55,16]),function(re,e,l,M,E,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(n){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=n}async withProgress(n,m,a){const h=this._handles++,{title:g,location:S,cancellable:v}=m,s={label:(0,E.localize)(0,null,n.displayName||n.name),id:n.identifier.value};return this._proxy.$startProgress(h,{location:l.ProgressLocation.from(S),title:g,source:s,cancellable:v},n).catch(A.onUnexpectedExternalError),this._withProgress(h,a,!!v)}_withProgress(n,m,a){let h;a&&(h=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(n,h));const g=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),h&&h.dispose()};let S;try{S=m(new F(this._proxy,n),a&&h?h.token:T.CancellationToken.None)}catch(v){throw g(n),v}return S.then(v=>g(n),v=>g(n)),S}$acceptProgressCanceled(n){const m=this._mapHandleToCancellationSource.get(n);m&&(m.cancel(),this._mapHandleToCancellationSource.delete(n))}}e.ExtHostProgress=D;function I(_,n){return _.message=n.message,typeof n.increment=="number"&&(typeof _.increment=="number"?_.increment+=n.increment:_.increment=n.increment),_}class F extends M.Progress{constructor(n,m){super(a=>this.throttledReport(a));this._proxy=n,this._handle=m}throttledReport(n){this._proxy.$progressReport(this._handle,n)}}Ue([(0,t.throttle)(100,(_,n)=>I(_,n),()=>Object.create(null))],F.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,43,16,56,8,7]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(n,m,a){const h=A._Keys.nextId();n.$registerTextEditorDecorationType(m.identifier,h,T.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:h,dispose(){n.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=A,A._Keys=new E.IdGenerator("TextEditorDecorationType");class D{constructor(n,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=n,this._documentVersionId=n.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(n,m){this._throwIfFinalized();let a=null;if(n instanceof t.Position)a=new t.Range(n,n);else if(n instanceof t.Range)a=n;else throw new Error("Unrecognized location");this._pushEdit(a,m,!1)}insert(n,m){this._throwIfFinalized(),this._pushEdit(new t.Range(n,n),m,!0)}delete(n){this._throwIfFinalized();let m=null;if(n instanceof t.Range)m=n;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(n,m,a){const h=this._document.validateRange(n);this._collectedEdits.push({range:h,text:m,forceMoveMarkers:a})}setEndOfLine(n){if(this._throwIfFinalized(),n!==t.EndOfLine.LF&&n!==t.EndOfLine.CRLF)throw(0,M.illegalArgument)("endOfLine");this._setEndOfLine=n}}e.TextEditorEdit=D;class I{constructor(n,m,a,h){this._proxy=n,this._id=m,this._accept(a),this._logService=h;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(S){g._setTabSize(S)},get insertSpaces(){return g._insertSpaces},set insertSpaces(S){g._setInsertSpaces(S)},get cursorStyle(){return g._cursorStyle},set cursorStyle(S){g._setCursorStyle(S)},get lineNumbers(){return g._lineNumbers},set lineNumbers(S){g._setLineNumbers(S)}}}_accept(n){this._tabSize=n.tabSize,this._insertSpaces=n.insertSpaces,this._cursorStyle=n.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(n.lineNumbers)}_validateTabSize(n){if(n==="auto")return"auto";if(typeof n=="number"){const m=Math.floor(n);return m>0?m:null}if(typeof n=="string"){const m=parseInt(n,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(n){const m=this._validateTabSize(n);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(n){return n==="auto"?"auto":n==="false"?!1:Boolean(n)}_setInsertSpaces(n){const m=this._validateInsertSpaces(n);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(n){this._cursorStyle!==n&&(this._cursorStyle=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:n})))}_setLineNumbers(n){this._lineNumbers!==n&&(this._lineNumbers=n,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(n)})))}assign(n){const m={};let a=!1;if(typeof n.tabSize!="undefined"){const h=this._validateTabSize(n.tabSize);h==="auto"?(a=!0,m.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,a=!0,m.tabSize=h)}if(typeof n.insertSpaces!="undefined"){const h=this._validateInsertSpaces(n.insertSpaces);h==="auto"?(a=!0,m.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,a=!0,m.insertSpaces=h)}typeof n.cursorStyle!="undefined"&&this._cursorStyle!==n.cursorStyle&&(this._cursorStyle=n.cursorStyle,a=!0,m.cursorStyle=n.cursorStyle),typeof n.lineNumbers!="undefined"&&this._lineNumbers!==n.lineNumbers&&(this._lineNumbers=n.lineNumbers,a=!0,m.lineNumbers=T.TextEditorLineNumbersStyle.from(n.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(n){n.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=I;class F{constructor(n,m,a,h,g,S,v,s){this.id=n,this._proxy=m,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new I(this._proxy,this.id,S,a),this._visibleRanges=v,this._viewColumn=s;const d=this;this.value=Object.freeze({get document(){return h.getValue()},set document(C){throw(0,M.readonly)("document")},get selection(){return d._selections&&d._selections[0]},set selection(C){if(!(C instanceof t.Selection))throw(0,M.illegalArgument)("selection");d._selections=[C],d._trySetSelection()},get selections(){return d._selections},set selections(C){if(!Array.isArray(C)||C.some(r=>!(r instanceof t.Selection)))throw(0,M.illegalArgument)("selections");d._selections=C,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(C){throw(0,M.readonly)("visibleRanges")},get options(){return d._options.value},set options(C){d._disposed||d._options.assign(C)},get viewColumn(){return d._viewColumn},set viewColumn(C){throw(0,M.readonly)("viewColumn")},edit(C,r={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new D(h.getValue(),r);return C(b),d._applyEdit(b)},insertSnippet(C,r,b={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!r||Array.isArray(r)&&r.length===0)o=d._selections.map(i=>T.Range.from(i));else if(r instanceof t.Position){const{lineNumber:i,column:p}=T.Position.from(r);o=[{startLineNumber:i,startColumn:p,endLineNumber:i,endColumn:p}]}else if(r instanceof t.Range)o=[T.Range.from(r)];else{o=[];for(const i of r)if(i instanceof t.Range)o.push(T.Range.from(i));else{const{lineNumber:p,column:c}=T.Position.from(i);o.push({startLineNumber:p,startColumn:c,endLineNumber:p,endColumn:c})}}return m.$tryInsertSnippet(n,C.value,o,b)},setDecorations(C,r){const b=r.length===0;b&&!d._hasDecorationsForKey.has(C.key)||(b?d._hasDecorationsForKey.delete(C.key):d._hasDecorationsForKey.add(C.key),d._runOnProxy(()=>{if(T.isDecorationOptionsArr(r))return m.$trySetDecorations(n,C.key,T.fromRangeOrRangeWithMessage(r));{const o=new Array(4*r.length);for(let i=0,p=r.length;i<p;i++){const c=r[i];o[4*i]=c.start.line+1,o[4*i+1]=c.start.character+1,o[4*i+2]=c.end.line+1,o[4*i+3]=c.end.character+1}return m.$trySetDecorationsFast(n,C.key,o)}}))},revealRange(C,r){d._runOnProxy(()=>m.$tryRevealRange(n,T.Range.from(C),r||t.TextEditorRevealType.Default))},show(C){m.$tryShowEditor(n,T.ViewColumn.from(C))},hide(){m.$tryHideEditor(n)}})}dispose(){(0,l.ok)(!this._disposed),this._disposed=!0}_acceptOptions(n){(0,l.ok)(!this._disposed),this._options._accept(n)}_acceptVisibleRanges(n){(0,l.ok)(!this._disposed),this._visibleRanges=n}_acceptViewColumn(n){(0,l.ok)(!this._disposed),this._viewColumn=n}_acceptSelections(n){(0,l.ok)(!this._disposed),this._selections=n}async _trySetSelection(){const n=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,n)),this.value}_applyEdit(n){const m=n.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const a=m.edits.map(g=>g.range);a.sort((g,S)=>g.end.line===S.end.line?g.end.character===S.end.character?g.start.line===S.start.line?g.start.character-S.start.character:g.start.line-S.start.line:g.end.character-S.end.character:g.end.line-S.end.line);for(let g=0,S=a.length-1;g<S;g++){const v=a[g].end;if(a[g+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=m.edits.map(g=>({range:T.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,h,{setEndOfLine:typeof m.setEndOfLine=="number"?T.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(n){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):n().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=F}),define(be[177],Ee([0,1,130,24,2,3,6,163,13,7,10,15,8,21,160]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(v,s){if((0,F.isString)(v))return{label:v};if(v&&typeof v=="object"&&typeof v.label=="string"){let d;return Array.isArray(v.highlights)&&(d=v.highlights.filter(C=>C.length===2&&typeof C[0]=="number"&&typeof C[1]=="number"),d=d.length?d:void 0),{label:v.label,highlights:d}}}class g{constructor(s,d,C){this._proxy=s,this.commands=d,this.logService=C,this.treeViews=new Map;function r(b){return b&&b.$treeViewId&&b.$treeItemHandle}d.registerArgumentProcessor({processArgument:b=>r(b)?this.convertArgument(b):Array.isArray(b)&&b.length>0?b.map(o=>r(o)?this.convertArgument(o):o):b})}registerTreeDataProvider(s,d,C){const r=this.createTreeView(s,{treeDataProvider:d},C);return{dispose:()=>r.dispose()}}createTreeView(s,d,C){if(!d||!d.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=d.dragAndDropController!==void 0,b=this._proxy.$registerTreeViewDataProvider(s,{showCollapseAll:!!d.showCollapseAll,canSelectMany:!!d.canSelectMany,canDragAndDrop:r}),o=this.createExtHostTreeView(s,d,C);return{get onDidCollapseElement(){return o.onDidCollapseElement},get onDidExpandElement(){return o.onDidExpandElement},get selection(){return o.selectedElements},get onDidChangeSelection(){return o.onDidChangeSelection},get visible(){return o.visible},get onDidChangeVisibility(){return o.onDidChangeVisibility},get message(){return o.message},set message(i){o.message=i},get title(){return o.title},set title(i){o.title=i},get description(){return o.description},set description(i){o.description=i},reveal:(i,p)=>o.reveal(i,p),dispose:async()=>{await b,this.treeViews.delete(s),o.dispose()}}}$getChildren(s,d){const C=this.treeViews.get(s);return C?C.getChildren(d):Promise.reject(new Error((0,l.localize)(0,null,s)))}async $onDrop(s,d,C){const r=this.treeViews.get(s);if(!r)return Promise.reject(new Error((0,l.localize)(1,null,s)));const b=a.TreeDataTransferConverter.toITreeDataTransfer(d);if(b.items.has(A.TREE_ITEM_DATA_TRANSFER_TYPE)){const i=JSON.parse(await b.items.get(A.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(p=>r.getExtensionElement(p)).filter(p=>!!p);i.length>0?b.items.set(A.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(i)}):b.items.delete(A.TREE_ITEM_DATA_TRANSFER_TYPE)}return r.onDrop(b,C)}async $hasResolve(s){const d=this.treeViews.get(s);if(!d)throw new Error((0,l.localize)(2,null,s));return d.hasResolve}$resolve(s,d,C){const r=this.treeViews.get(s);if(!r)throw new Error((0,l.localize)(3,null,s));return r.resolveTreeItem(d,C)}$setExpanded(s,d,C){const r=this.treeViews.get(s);if(!r)throw new Error((0,l.localize)(4,null,s));r.setExpanded(d,C)}$setSelection(s,d){const C=this.treeViews.get(s);if(!C)throw new Error((0,l.localize)(5,null,s));C.setSelection(d)}$setVisible(s,d){const C=this.treeViews.get(s);if(!C)throw new Error((0,l.localize)(6,null,s));C.setVisible(d)}createExtHostTreeView(s,d,C){const r=new S(s,d,this._proxy,this.commands.converter,this.logService,C);return this.treeViews.set(s,r),r}convertArgument(s){const d=this.treeViews.get(s.$treeViewId);return d?d.getExtensionElement(s.$treeItemHandle):null}}e.ExtHostTreeViews=g;class S extends t.Disposable{constructor(s,d,C,r,b,o){super();if(this.viewId=s,this.proxy=C,this.commands=r,this.logService=b,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new m.CancellationTokenSource,o.contributes&&o.contributes.views)for(const c in o.contributes.views)for(const u of o.contributes.views[c])u.id===s&&(this._title=u.name);this.dataProvider=d.treeDataProvider,this.dndController=d.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(c=>this._onDidChangeData.fire({message:!1,element:c}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let i,p;this._register(T.Event.debounce(this._onDidChangeData.event,(c,u)=>(c||(c={message:!1,elements:[]}),u.element!==!1&&(i||(i=new Promise(w=>p=w),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(u.element)?c.elements.push(...u.element):c.elements.push(u.element)),u.message&&(c.message=!0),c),200,!0)(({message:c,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=p;return i=null,this.refresh(u).then(()=>w())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(s=>this.getExtensionElement(s)).filter(s=>!(0,F.isUndefinedOrNull)(s))}async getChildren(s){const d=s?this.getExtensionElement(s):void 0;if(s&&!d)return this.logService.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let C=this.getChildrenNodes(s);return C||(C=await this.fetchChildrenNodes(d)),C?C.map(r=>r.item):void 0}getExtensionElement(s){return this.elements.get(s)}reveal(s,d){d=d||{select:!0,focus:!1};const C=(0,F.isUndefinedOrNull)(d.select)?!0:d.select,r=(0,F.isUndefinedOrNull)(d.focus)?!1:d.focus,b=(0,F.isUndefinedOrNull)(d.expand)?!1:d.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.refreshPromise.then(()=>this.resolveUnknownParentChain(s)).then(o=>this.resolveTreeNode(s,o[o.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:o.map(p=>p.item)},{select:C,focus:r,expand:b})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:C,focus:r,expand:b})}get message(){return this._message}set message(s){this._message=s,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(s){this._title=s,this.proxy.$setTitle(this.viewId,s,this._description)}get description(){return this._description}set description(s){this._description=s,this.proxy.$setTitle(this.viewId,this._title,s)}setExpanded(s,d){const C=this.getExtensionElement(s);C&&(d?this._onDidExpandElement.fire(Object.freeze({element:C})):this._onDidCollapseElement.fire(Object.freeze({element:C})))}setSelection(s){(0,_.equals)(this._selectedHandles,s)||(this._selectedHandles=s,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(s){s!==this._visible&&(this._visible=s,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(s,d){const C=this.getExtensionElement(d);if(!!C)return(0,D.asPromise)(()=>this.dndController?.onDrop(s,C))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(s,d){if(!this.dataProvider.resolveTreeItem)return;const C=this.elements.get(s);if(C){const r=this.nodes.get(C);if(r){const b=await this.dataProvider.resolveTreeItem(r.extensionItem,C,d)??r.extensionItem;return r.item.tooltip=this.getTooltip(b.tooltip),r.item.command=this.getCommand(r.disposableStore,b.command),r.item}}}resolveUnknownParentChain(s){return this.resolveParent(s).then(d=>d?this.resolveUnknownParentChain(d).then(C=>this.resolveTreeNode(d,C[C.length-1]).then(r=>(C.push(r),C))):Promise.resolve([]))}resolveParent(s){const d=this.nodes.get(s);return d?Promise.resolve(d.parent?this.elements.get(d.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(s))}resolveTreeNode(s,d){const C=this.nodes.get(s);return C?Promise.resolve(C):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(s)).then(r=>this.createHandle(s,r,d,!0)).then(r=>this.getChildren(d?d.item.handle:void 0).then(()=>{const b=this.getExtensionElement(r);if(b){const o=this.nodes.get(b);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}getChildrenNodes(s){if(s){let d;if(typeof s=="string"){const C=this.getExtensionElement(s);d=C?this.nodes.get(C):void 0}else d=s;return d&&d.children||void 0}return this.roots}async fetchChildrenNodes(s){this.clearChildren(s);const d=new m.CancellationTokenSource(this._refreshCancellationSource.token);try{const C=s?this.nodes.get(s):void 0,r=await this.dataProvider.getChildren(s);if(d.token.isCancellationRequested)return;const b=await Promise.all((0,_.coalesce)(r||[]).map(async o=>{const i=await this.dataProvider.getTreeItem(o);return i&&!d.token.isCancellationRequested?this.createAndRegisterTreeNode(o,i,C):null}));return d.token.isCancellationRequested?void 0:(0,_.coalesce)(b)}finally{d.dispose()}}refresh(s){if(s.some(C=>!C))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new m.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const C=this.getHandlesToRefresh(s);if(C.length)return this.refreshHandles(C)}return Promise.resolve(void 0)}getHandlesToRefresh(s){const d=new Set,C=s.map(b=>this.nodes.get(b));for(const b of C)if(b&&!d.has(b.item.handle)){let o=b;for(;o&&o.parent&&C.findIndex(i=>o&&o.parent&&i&&i.item.handle===o.parent.item.handle)===-1;){const i=this.elements.get(o.parent.item.handle);o=i?this.nodes.get(i):void 0}o&&!o.parent&&d.add(b.item.handle)}const r=[];return d.forEach(b=>{const o=this.elements.get(b);if(o){const i=this.nodes.get(o);i&&(!i.parent||!d.has(i.parent.item.handle))&&r.push(b)}}),r}refreshHandles(s){const d={};return Promise.all(s.map(C=>this.refreshNode(C).then(r=>{r&&(d[C]=r.item)}))).then(()=>Object.keys(d).length?this.proxy.$refresh(this.viewId,d):void 0)}refreshNode(s){const d=this.getExtensionElement(s);if(d){const C=this.nodes.get(d);if(C)return this.clearChildren(d),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(r=>{if(r){const b=this.createTreeNode(d,r,C.parent);return this.updateNodeCache(d,b,C,C.parent),C.dispose(),b}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(s,d,C){const r=this.createTreeNode(s,d,C);if(d.id&&this.elements.has(r.item.handle))throw new Error((0,l.localize)(7,null,d.id));return this.addNodeToCache(s,r),this.addNodeToParentCache(r,C),r}getTooltip(s){return I.MarkdownString.isMarkdownString(s)?n.MarkdownString.from(s):s}getCommand(s,d){return d?this.commands.toInternal(d,s):void 0}createTreeNode(s,d,C){const r=new t.DisposableStore,b=this.createHandle(s,d,C),o=this.getLightIconPath(d);return{item:{handle:b,parentHandle:C?C.item.handle:void 0,label:h(d.label,this.extension),description:d.description,resourceUri:d.resourceUri,tooltip:this.getTooltip(d.tooltip),command:this.getCommand(r,d.command),contextValue:d.contextValue,icon:o,iconDark:this.getDarkIconPath(d)||o,themeIcon:this.getThemeIcon(d),collapsibleState:(0,F.isUndefinedOrNull)(d.collapsibleState)?I.TreeItemCollapsibleState.None:d.collapsibleState,accessibilityInformation:d.accessibilityInformation},extensionItem:d,parent:C,children:void 0,disposableStore:r,dispose(){r.dispose()}}}getThemeIcon(s){return s.iconPath instanceof I.ThemeIcon?s.iconPath:void 0}createHandle(s,{id:d,label:C,resourceUri:r},b,o){if(d)return`${S.ID_HANDLE_PREFIX}/${d}`;const i=h(C,this.extension),p=b?b.item.handle:S.LABEL_HANDLE_PREFIX;let c=i?i.label:r?(0,M.basename)(r):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const u=this.nodes.has(s)?this.nodes.get(s).item.handle:void 0,w=this.getChildrenNodes(b)||[];let f,y=0;do{if(f=`${p}/${y}:${c}`,o||!this.elements.has(f)||u===f)break;y++}while(y<=w.length);return f}getLightIconPath(s){if(s.iconPath&&!(s.iconPath instanceof I.ThemeIcon))return typeof s.iconPath=="string"||E.URI.isUri(s.iconPath)?this.getIconPath(s.iconPath):this.getIconPath(s.iconPath.light)}getDarkIconPath(s){if(s.iconPath&&!(s.iconPath instanceof I.ThemeIcon)&&s.iconPath.dark)return this.getIconPath(s.iconPath.dark)}getIconPath(s){return E.URI.isUri(s)?s:E.URI.file(s)}addNodeToCache(s,d){this.elements.set(d.item.handle,s),this.nodes.set(s,d)}updateNodeCache(s,d,C,r){this.elements.delete(d.item.handle),this.nodes.delete(s),d.item.handle!==C.item.handle&&this.elements.delete(C.item.handle),this.addNodeToCache(s,d);const b=this.getChildrenNodes(r)||[],o=b.filter(i=>i.item.handle===C.item.handle)[0];o&&b.splice(b.indexOf(o),1,d)}addNodeToParentCache(s,d){d?(d.children||(d.children=[]),d.children.push(s)):(this.roots||(this.roots=[]),this.roots.push(s))}clearChildren(s){if(s){const d=this.nodes.get(s);if(d){if(d.children)for(const C of d.children){const r=this.elements.get(C.item.handle);r&&this.clear(r)}d.children=void 0}}else this.clearAll()}clear(s){const d=this.nodes.get(s);if(d){if(d.children)for(const C of d.children){const r=this.elements.get(C.item.handle);r&&this.clear(r)}this.nodes.delete(s),this.elements.delete(d.item.handle),d.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(s=>s.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}S.LABEL_HANDLE_PREFIX="0",S.ID_HANDLE_PREFIX="1"}),define(be[178],Ee([0,1,13,3,6,10,50,8,90,69]),function(re,e,l,M,E,T,t,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class F extends E.Disposable{constructor(n){super();this.controllerId=n,this.debounceSendDiff=this._register(new l.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new M.Emitter),this.root=new t.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(n){this._resolveHandler=n;for(const m of this.tree.values())this.updateExpandability(m)}collectDiff(){const n=this.diff;return this.diff=[],n}pushDiff(n){const m=this.diff[this.diff.length-1];if(m&&n[0]===1){if(m[0]===1&&m[1].extId===n[1].extId){(0,D.applyTestItemUpdate)(m[1],n[1]);return}if(m[0]===0&&m[1].item.extId===n[1].extId){(0,D.applyTestItemUpdate)(m[1],n[1]);return}}this.diff.push(n),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(n,m){const a=this.tree.get(n);if(!!a){if((a.expandLevels===void 0||m>a.expandLevels)&&(a.expandLevels=m),a.expand===1){const h=this.resolveChildren(a);return h.isOpen()?this.expandChildren(a,m-1):h.wait().then(()=>this.expandChildren(a,m-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,m-1)):this.expandChildren(a,m-1)}}dispose(){for(const n of this.tree.values())(0,t.getPrivateApiFor)(n.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(n,m){switch(m.op){case 2:this.pushDiff([4,n.fullId.toString()]);break;case 1:this.removeItem(I.TestId.joinToString(n.fullId,m.id));break;case 0:this.upsertItem(m.item,n);break;case 4:for(const v of m.ops)this.onTestItemEvent(n,v);break;case 3:const{key:a,value:h,previous:g}=m,S=n.fullId.toString();switch(a){case"canResolveChildren":this.updateExpandability(n);break;case"tags":this.diffTagRefs(h,g,S);break;case"range":this.pushDiff([1,{extId:S,item:{range:A.Range.from(h)}}]);break;case"error":this.pushDiff([1,{extId:S,item:{error:A.MarkdownString.fromStrict(h)||null}}]);break;default:this.pushDiff([1,{extId:S,item:{[a]:h??null}}]);break}break;default:(0,T.assertNever)(m)}}upsertItem(n,m){if(!(n instanceof t.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${n.id} did not`);const a=I.TestId.fromExtHostTestItem(n,this.root.id,m?.actual),h=(0,t.getPrivateApiFor)(n);h.parent&&h.parent!==m?.actual&&h.parent.children.delete(n.id);let g=this.tree.get(a.toString());if(!g){g={fullId:a,actual:n,parent:m?a.parentId:null,expandLevels:m?.expandLevels?m.expandLevels-1:void 0,expand:0},n.tags.forEach(this.incrementTagRefs,this),this.tree.set(g.fullId.toString(),g),this.setItemParent(n,m),this.pushDiff([0,{parent:g.parent&&g.parent.toString(),controllerId:this.controllerId,expand:g.expand,item:A.TestItem.from(n)}]),this.connectItemAndChildren(n,g,m);return}if(g.actual===n){this.connectItem(n,g,m);return}const S=g.actual.children,v=g.actual,s=(0,t.diffTestItems)(v,n);(0,t.getPrivateApiFor)(v).listener=void 0,g.actual=n,g.expand=0;for(const[d,C]of s)this.onTestItemEvent(g,{op:3,key:d,value:C,previous:v[d]});this.connectItemAndChildren(n,g,m);for(const d of S)n.children.get(d.id)||this.removeItem(I.TestId.joinToString(a,d.id))}diffTagRefs(n,m,a){const h=new Set(m.map(g=>g.id));for(const g of n)h.delete(g.id)||this.incrementTagRefs(g);this.pushDiff([1,{extId:a,item:{tags:n.map(g=>A.TestTag.namespace(this.controllerId,g.id))}}]),h.forEach(this.decrementTagRefs,this)}incrementTagRefs(n){const m=this.tags.get(n.id);m?m.refCount++:(this.tags.set(n.id,{refCount:1}),this.pushDiff([5,{id:A.TestTag.namespace(this.controllerId,n.id),ctrlLabel:this.root.label}]))}decrementTagRefs(n){const m=this.tags.get(n);m&&!--m.refCount&&(this.tags.delete(n),this.pushDiff([6,A.TestTag.namespace(this.controllerId,n)]))}setItemParent(n,m){(0,t.getPrivateApiFor)(n).parent=m&&m.actual!==this.root?m.actual:void 0}connectItem(n,m,a){this.setItemParent(n,a);const h=(0,t.getPrivateApiFor)(n);h.parent=a?.actual,h.listener=g=>this.onTestItemEvent(m,g),this.updateExpandability(m)}connectItemAndChildren(n,m,a){this.connectItem(n,m,a);for(const h of n.children)this.upsertItem(h,m)}updateExpandability(n){let m;this._resolveHandler?n.resolveBarrier?m=n.resolveBarrier.isOpen()?3:2:m=n.actual.canResolveChildren?1:0:m=0,m!==n.expand&&(n.expand=m,this.pushDiff([1,{extId:n.fullId.toString(),expand:m}]),m===1&&n.expandLevels!==void 0&&this.resolveChildren(n))}expandChildren(n,m){if(m<0)return;const a=[];for(const h of n.actual.children){const g=this.expand(I.TestId.joinToString(n.fullId,h.id),m);(0,l.isThenable)(g)&&a.push(g)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this._resolveHandler){const g=new l.Barrier;return g.open(),g}n.expand=2,this.pushExpandStateUpdate(n);const m=n.resolveBarrier=new l.Barrier,a=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),n.actual!==this.root&&(n.actual.error=g.stack||g.message||String(g))};let h;try{h=this._resolveHandler(n.actual===this.root?void 0:n.actual)}catch(g){a(g)}return(0,l.isThenable)(h)?h.catch(a).then(()=>{m.open(),this.updateExpandability(n)}):(m.open(),this.updateExpandability(n)),n.resolveBarrier}pushExpandStateUpdate(n){this.pushDiff([1,{extId:n.fullId.toString(),expand:n.expand}])}removeItem(n){const m=this.tree.get(n);if(!m)throw new Error("attempting to remove non-existent child");this.pushDiff([2,n]);const a=[m];for(;a.length;){const h=a.pop();if(!!h){(0,t.getPrivateApiFor)(h.actual).listener=void 0;for(const g of h.actual.tags)this.decrementTagRefs(g.id);this.tree.delete(h.fullId.toString());for(const g of h.actual.children)a.push(this.tree.get(I.TestId.joinToString(h.fullId,g.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.diffOpEmitter.fire(n)}}e.SingleUseTestCollection=F}),define(be[179],Ee([0,1,4,143]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,l.refineServiceDecorator)(M.IEnvironmentService)}),define(be[180],Ee([0,1,26,3,17]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(F){this.removedDueToLooping=F}}e.DeltaExtensionsResult=T;class t{constructor(F){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=F,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const F of this._extensionDescriptions){if(this._extensionsMap.has(l.ExtensionIdentifier.toKey(F.identifier))){console.error("Extension `"+F.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(l.ExtensionIdentifier.toKey(F.identifier),F),this._extensionsArr.push(F),Array.isArray(F.activationEvents))for(let _ of F.activationEvents)_==="onUri"&&(_=`onUri:${l.ExtensionIdentifier.toKey(F.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(F)}}keepOnly(F){const _=new Set;F.forEach(n=>_.add(l.ExtensionIdentifier.toKey(n))),this._extensionDescriptions=this._extensionDescriptions.filter(n=>_.has(l.ExtensionIdentifier.toKey(n.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(F,_){F.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(F));const n=t._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(n.map(m=>m.identifier)),_.length>0){const m=new Set;_.forEach(a=>m.add(l.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!m.has(l.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(n)}static _findLoopingExtensions(F){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,S){this.addNode(g),this.addNode(S),this._arcs.has(g)?this._arcs.get(g).push(S):this._arcs.set(g,[S])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,S){const v=_.getArcs(g);for(let s=0;s<v.length;s++)if(!S.has(v[s]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let g of F){const S=l.ExtensionIdentifier.toKey(g.identifier);if(n.set(S,g),g.extensionDependencies)for(let v of g.extensionDependencies){const s=l.ExtensionIdentifier.toKey(v);_.addArc(S,s)}}let m=new Set;_.getNodes().filter(g=>_.getArcs(g).length===0).forEach(g=>m.add(g));let a=_.getNodes().filter(g=>!m.has(g)),h;do{h=!1;for(let g=0;g<a.length;g++){const S=a[g];_.hasOnlyGoodArcs(S,m)&&(a.splice(g,1),g--,m.add(S),h=!0)}}while(h);return a.map(g=>n.get(g))}containsActivationEvent(F){return this._activationMap.has(F)}containsExtension(F){return this._extensionsMap.has(l.ExtensionIdentifier.toKey(F))}getExtensionDescriptionsForActivationEvent(F){const _=this._activationMap.get(F);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(F){const _=this._extensionsMap.get(l.ExtensionIdentifier.toKey(F));return _||void 0}}e.ExtensionDescriptionRegistry=t;var A;(function(I){I[I.Builtin=0]="Builtin",I[I.User=1]="User",I[I.Dev=2]="Dev"})(A||(A={}));function D(I,F){const _=I.isBuiltin?0:I.isUnderDevelopment?2:1,n=F.isBuiltin?0:F.isUnderDevelopment?2:1;if(_!==n)return _-n;const m=E.posix.basename(I.extensionLocation.path),a=E.posix.basename(F.extensionLocation.path);return m<a?-1:m>a?1:0}}),define(be[181],Ee([0,1,22]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var M;(function(A){A[A.VersionMismatch=55]="VersionMismatch",A[A.UnexpectedError=81]="UnexpectedError"})(M=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(A){A[A.Initialized=0]="Initialized",A[A.Ready=1]="Ready",A[A.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function T(A){const D=l.VSBuffer.alloc(1);switch(A){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=T;function t(A,D){if(A.byteLength!==1)return!1;switch(A.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=t}),define(be[28],Ee([0,1,3,2,4,26,149]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var A;(function(d){d[d.None=0]="None",d[d.LocalProcess=1]="LocalProcess",d[d.LocalWebWorker=2]="LocalWebWorker",d[d.Remote=3]="Remote"})(A=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(d){switch(d){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class I{constructor(C){this.dependency=C}}e.MissingExtensionDependency=I;var F;(function(d){d[d.LocalProcess=0]="LocalProcess",d[d.LocalWebWorker=1]="LocalWebWorker",d[d.Remote=2]="Remote"})(F=e.ExtensionHostKind||(e.ExtensionHostKind={}));function _(d){switch(d){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=_;function n(d,C){return C&&d.enabledApiProposals?.includes(C)?!0:Boolean(d.enableProposedApi)}e.isProposedApiEnabled=n;function m(d,C){if(!n(d,C))throw new Error(`[${d.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${d.identifier.value}`)}e.checkProposedApiEnabled=m;class a{constructor(C,r,b,o){this.codeLoadingTime=C,this.activateCallTime=r,this.activateResolvedTime=b,this.activationReason=o}}e.ActivationTimes=a;class h{constructor(C,r){this.description=C,this.value=r}}e.ExtensionPointContribution=h,e.ExtensionHostLogFileName="exthost";var g;(function(d){d[d.Normal=0]="Normal",d[d.Immediate=1]="Immediate"})(g=e.ActivationKind||(e.ActivationKind={}));function S(d){return{type:d.isBuiltin?0:1,isBuiltin:d.isBuiltin||d.isUserBuiltin,identifier:{id:(0,t.getGalleryExtensionId)(d.publisher,d.name),uuid:d.uuid},manifest:d,location:d.extensionLocation}}e.toExtension=S;function v(d,C){return{identifier:new T.ExtensionIdentifier(d.identifier.id),isBuiltin:d.type===0,isUserBuiltin:d.type===1&&d.isBuiltin,isUnderDevelopment:!!C,extensionLocation:d.location,...d.manifest,uuid:d.identifier.uuid}}e.toExtensionDescription=v;class s{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None}activateByEvent(C){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(C){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(C){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(C){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(C,r){return Promise.resolve()}_onWillActivateExtension(C){}_onDidActivateExtension(C,r,b,o,i){}_onDidActivateExtensionError(C,r){}_onExtensionRuntimeError(C,r){}_onExtensionHostExit(C){}}e.NullExtensionService=s}),define(be[182],Ee([0,1,26,28,12]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class t{constructor(a,h,g,S){this.startup=a,this.codeLoadingTime=h,this.activateCallTime=g,this.activateResolvedTime=S}}e.ExtensionActivationTimes=t,t.NONE=new t(!1,-1,-1,-1);class A{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,h){return a===-1||h===-1?-1:h-a}build(){return new t(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=A;class D{constructor(a,h,g,S,v,s){this.activationFailed=a,this.activationFailedError=h,this.activationTimes=g,this.module=S,this.exports=v,this.subscriptions=s}}e.ActivatedExtension=D;class I extends D{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=I;class F extends D{constructor(){super(!1,null,t.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=F;class _ extends D{constructor(a){super(!0,a,t.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let n=class{constructor(a,h,g,S,v){this._logService=v,this._registry=a,this._resolvedExtensionsSet=new Set,h.forEach(s=>this._resolvedExtensionsSet.add(l.ExtensionIdentifier.toKey(s))),this._hostExtensionsMap=new Map,g.forEach(s=>this._hostExtensionsMap.set(l.ExtensionIdentifier.toKey(s),s)),this._host=S,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const h=l.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(h)}getActivatedExtension(a){const h=l.ExtensionIdentifier.toKey(a),g=this._activatedExtensions.get(h);if(!g)throw new Error("Extension `"+a.value+"` is not known or not activated");return g}activateByEvent(a,h){if(this._alreadyActivatedEvents[a])return T;const g=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(g.map(S=>({id:S.identifier,reason:{startup:h,extensionId:S.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,h){const g=this._registry.getExtensionDescription(a);if(!g)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:g.identifier,reason:h}])}_handleActivateRequest(a,h,g){if(this._hostExtensionsMap.has(l.ExtensionIdentifier.toKey(a.id))){h[l.ExtensionIdentifier.toKey(a.id)]=a;return}const S=this._registry.getExtensionDescription(a.id);if(!S){const d=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,d,new M.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(l.ExtensionIdentifier.toKey(a.id),new _(d));return}const v=typeof S.extensionDependencies=="undefined"?[]:S.extensionDependencies;let s=!0;for(let d=0,C=v.length;d<C;d++){const r=v[d];if(this._resolvedExtensionsSet.has(l.ExtensionIdentifier.toKey(r)))continue;const b=this._activatedExtensions.get(l.ExtensionIdentifier.toKey(r));if(b&&!b.activationFailed)continue;if(b&&b.activationFailed){const c=S.displayName||S.identifier.value,u=this._registry.getExtensionDescription(r),w=u&&u.displayName||r,f=new Error(`Cannot activate the '${c}' extension because its dependency '${w}' failed to activate`);f.detail=b.activationFailedError,this._host.onExtensionActivationError(S.identifier,f,null),this._activatedExtensions.set(l.ExtensionIdentifier.toKey(S.identifier),new _(f));return}if(this._hostExtensionsMap.has(l.ExtensionIdentifier.toKey(r))){s=!1,h[l.ExtensionIdentifier.toKey(r)]={id:this._hostExtensionsMap.get(l.ExtensionIdentifier.toKey(r)),reason:a.reason};continue}const o=this._registry.getExtensionDescription(r);if(o){if(!o.main&&!o.browser)continue;s=!1,h[l.ExtensionIdentifier.toKey(r)]={id:o.identifier,reason:a.reason};continue}const i=S.displayName||S.identifier.value,p=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${r}'`);this._host.onExtensionActivationError(S.identifier,p,new M.MissingExtensionDependency(r)),this._activatedExtensions.set(l.ExtensionIdentifier.toKey(S.identifier),new _(p));return}s?h[l.ExtensionIdentifier.toKey(S.identifier)]=a:g.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(v=>!this._activatedExtensions.has(l.ExtensionIdentifier.toKey(v.id))),a.length===0))return Promise.resolve(void 0);const h=Object.create(null),g=[];for(let v=0,s=a.length;v<s;v++)this._handleActivateRequest(a[v],h,g);for(let v=0,s=g.length;v<s;v++){const d=l.ExtensionIdentifier.toKey(g[v].id);h[d]&&delete h[d]}const S=Object.keys(h).map(v=>h[v]);return g.length===0?Promise.all(S.map(v=>this._activateExtension(v.id,v.reason))).then(v=>{}):this._activateExtensions(S).then(v=>this._activateExtensions(g))}_activateExtension(a,h){const g=l.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(g))return Promise.resolve(void 0);const S=this._activatingExtensions.get(g);if(S)return S;const v=this._host.actualActivateExtension(a,h).then(void 0,s=>{const d=new Error;return s&&s.name&&(d.name=s.name),s&&s.message?d.message=`Activating extension '${a.value}' failed: ${s.message}.`:d.message=`Activating extension '${a.value}' failed: ${s}.`,s&&s.stack&&(d.stack=s.stack),this._host.onExtensionActivationError(a,d,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(s),new _(s)}).then(s=>{this._activatedExtensions.set(g,s),this._activatingExtensions.delete(g)});return this._activatingExtensions.set(g,v),v}};n=Ue([Be(4,E.ILogService)],n),e.ExtensionsActivator=n}),define(be[183],Ee([0,1,12,27,28]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let T=class extends l.LogService{constructor(A,D){super(A.createLogger(D.logFile,{name:E.ExtensionHostLogFileName}))}};T=Ue([Be(0,l.ILoggerService),Be(1,M.IExtHostInitDataService)],T),e.ExtHostLogService=T}),define(be[184],Ee([0,1,16]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class M{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,t)=>{this._actualOk=T,this._actualErr=t,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,l.onUnexpectedError)(T))}then(T,t){return this._ensureActual().then(T,t)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=M}),define(be[39],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class l{constructor(I,F){this._proxyIdentifierBrand=void 0,this.isMain=I,this.sid=F,this.nid=++l.count}}e.ProxyIdentifier=l,l.count=0;const M=[];function E(D){const I=new l(!0,D);return M[I.nid]=I,I}e.createMainContextProxyIdentifier=E;function T(D){const I=new l(!1,D);return M[I.nid]=I,I}e.createExtHostContextProxyIdentifier=T;function t(D){return M[D].sid}e.getStringIdentifierForProxy=t;class A{constructor(I){this.value=I}}e.SerializableObjectWithBuffers=A}),define(be[5],Ee([0,1,57,2,39]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var t;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(t=e.TextEditorRevealType||(e.TextEditorRevealType={}));var A;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var I;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(I=e.CellOutputKind||(e.CellOutputKind={}));var F;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(F=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var n;(function(s){s.name="$ident";function d(r,b){return Object.defineProperty(r,s.name,{value:b,enumerable:!0}),r}s.mixin=d;function C(r){return r[s.name]}s.of=C})(n=e.ObjectIdentifier||(e.ObjectIdentifier={}));class m{static mixin(d){return d._id=m._n++,d}}e.IdObject=m,m._n=0;var a;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.command="m",s.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var h;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(h=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var g;(function(s){s[s.File=1]="File",s[s.Text=2]="Text",s[s.Cell=3]="Cell"})(g=e.WorkspaceEditType||(e.WorkspaceEditType={}));function S(s){if(s&&s.edits)for(const d of s.edits)typeof d.resource=="object"?d.resource=M.URI.revive(d.resource):(d.newUri=M.URI.revive(d.newUri),d.oldUri=M.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,l.revive)(d.metadata));return s}e.reviveWorkspaceEditDto=S;var v;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(v=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,E.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[70],Ee([0,1,5,3,4]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(A){this._onDidChangePassword=new M.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(l.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,D){return this._proxy.$getPassword(A,D)}store(A,D,I){return this._proxy.$setPassword(A,D,I)}delete(A,D){return this._proxy.$deletePassword(A,D)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(be[71],Ee([0,1,4,12,5,14]),function(re,e,l,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,l.createDecorator)("IExtHostApiDeprecationService");let t=class{constructor(D,I){this._extHostLogService=I,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(E.MainContext.MainThreadTelemetry)}report(D,I,F){const _=this.getUsageKey(D,I);this._reportedUsages.has(_)||(this._reportedUsages.add(_),I.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${F}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:D}))}getUsageKey(D,I){return`${D}-${I.identifier.value}`}};t=Ue([Be(0,T.IExtHostRpcService),Be(1,M.ILogService)],t),e.ExtHostApiDeprecationService=t,e.NullApiDeprecationService=Object.freeze(new class{report(A,D,I){}})}),define(be[185],Ee([0,1,3,5,7,26]),function(re,e,l,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class t{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new l.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(M.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,I,F,_={}){const n=T.ExtensionIdentifier.toKey(D.identifier),m=this._inFlightRequests.get(n)||[],a=[...F].sort().join(" ");let h=m.find(g=>g.scopes===a);if(h)return h.result;{const g=this._getSession(D,n,I,F,_);h={scopes:a,result:g},m.push(h),this._inFlightRequests.set(n,m);try{await g}finally{const S=m.findIndex(v=>v.scopes===a);S>-1&&(m.splice(S),this._inFlightRequests.set(n,m))}return g}}async _getSession(D,I,F,_,n={}){await this._proxy.$ensureProvider(F);const m=D.displayName||D.name;return this._proxy.$getSession(F,_,I,m,n)}async removeSession(D,I){const F=this._authenticationProviders.get(D);return F?F.provider.removeSession(I):this._proxy.$removeSession(D,I)}registerAuthenticationProvider(D,I,F,_){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:I,provider:F,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(m=>m.id===D)||this._providers.push({id:D,label:I});const n=F.onDidChangeSessions(m=>{this._proxy.$sendDidChangeSessions(D,{added:m.added??[],changed:m.changed??[],removed:m.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,I,_?.supportsMultipleAccounts??!1),new E.Disposable(()=>{n.dispose(),this._authenticationProviders.delete(D);const m=this._providers.findIndex(a=>a.id===D);m>-1&&this._providers.splice(m),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,I){const F=this._authenticationProviders.get(D);if(F)return Promise.resolve(F.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,I){const F=this._authenticationProviders.get(D);if(F)return Promise.resolve(F.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,I){const F=this._authenticationProviders.get(D);if(F)return Promise.resolve(F.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,I){return this._onDidChangeSessions.fire({provider:{id:D,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=t}),define(be[186],Ee([0,1,5,14,8]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(A,D){this._extHostDocumentsAndEditors=D,this._proxy=A.getProxy(l.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(A){const D=E.WorkspaceEdit.from(A,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};T=Ue([Be(0,M.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(be[187],Ee([0,1,5]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class M{constructor(T){const t=T.getProxy(l.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return t.$readText()},writeText(A){return t.$writeText(A)}})}}e.ExtHostClipboard=M}),define(be[40],Ee([0,1,10,7,8,23,5,15,12,57,45,111,2,6,4,14,50,22,39,46]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let d=class{constructor(p,c){this._commands=new Map,this._apiCommands=new Map,this._proxy=p.getProxy(t.MainContext.MainThreadCommands),this._logService=c,this.converter=new C(this,u=>{const w=this._apiCommands.get(u);return w?.result===b.Void?w:void 0},c),this._argumentProcessors=[{processArgument(u){return(0,I.revive)(u)}},{processArgument(u){return(0,T.cloneAndChange)(u,function(w){if(F.Range.isIRange(w))return E.Range.to(w);if(_.Position.isIPosition(w))return E.Position.to(w);if(F.Range.isIRange(w.range)&&n.URI.isUri(w.uri))return E.location.to(w);if(w instanceof S.VSBuffer)return w.buffer.buffer;if(!Array.isArray(w))return w})}}]}registerArgumentProcessor(p){this._argumentProcessors.push(p)}registerApiCommand(p){const c=this.registerCommand(!1,p.id,async(...u)=>{const w=p.args.map((y,R)=>{if(!y.validate(u[R]))throw new Error(`Invalid argument '${y.name}' when running '${p.id}', received: ${u[R]}`);return y.convert(u[R])}),f=await this.executeCommand(p.internalId,...w);return p.result.convert(f,u,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this._apiCommands.set(p.id,p),new M.Disposable(()=>{c.dispose(),this._apiCommands.delete(p.id)})}registerCommand(p,c,u,w,f,y){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:u,thisArg:w,description:f,extension:y}),p&&this._proxy.$registerCommand(c),new M.Disposable(()=>{this._commands.delete(c)&&p&&this._proxy.$unregisterCommand(c)})}executeCommand(p,...c){return this._logService.trace("ExtHostCommands#executeCommand",p),this._doExecuteCommand(p,c,!0)}async _doExecuteCommand(p,c,u){if(this._commands.has(p))return this._executeContributedCommand(p,c,!1);{let w=!1;const f=(0,T.cloneAndChange)(c,function(y){if(y instanceof M.Position)return E.Position.from(y);if(y instanceof M.Range)return E.Range.from(y);if(y instanceof M.Location)return E.location.from(y);if(M.NotebookRange.isNotebookRange(y))return E.NotebookRange.from(y);if(y instanceof ArrayBuffer)return w=!0,S.VSBuffer.wrap(new Uint8Array(y));if(y instanceof Uint8Array)return w=!0,S.VSBuffer.wrap(y);if(!Array.isArray(y))return y});try{const y=await this._proxy.$executeCommand(p,w?new v.SerializableObjectWithBuffers(f):f,u);return(0,I.revive)(y)}catch(y){if(y instanceof Error&&y.message==="$executeCommand:retry")return this._doExecuteCommand(p,c,!1);throw y}}}async _executeContributedCommand(p,c,u){const w=this._commands.get(p);if(!w)throw new Error("Unknown command");let{callback:f,thisArg:y,description:R}=w;if(R)for(let P=0;P<R.args.length;P++)try{(0,l.validateConstraint)(c[P],R.args[P].constraint)}catch(B){throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${R.args[P].name}' - ${R.args[P].description}`)}try{return await f.apply(y,c)}catch(P){if(p===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...c);B&&(p=B.command)}throw this._logService.error(P,p,w.extension?.identifier),u?new class extends Error{constructor(){super((0,s.toErrorMessage)(P));this.id=p,this.source=w.extension?.displayName??w.extension?.name}}:P}}$executeContributedCommand(p,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",p),this._commands.has(p)?(c=c.map(u=>this._argumentProcessors.reduce((w,f)=>f.processArgument(w),u)),this._executeContributedCommand(p,c,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this._logService.trace("ExtHostCommands#getCommands",p),this._proxy.$getCommands().then(c=>(p&&(c=c.filter(u=>u[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const p=Object.create(null);for(let[c,u]of this._commands){let{description:w}=u;w&&(p[c]=w)}return Promise.resolve(p)}};d=Ue([Be(0,h.IExtHostRpcService),Be(1,D.ILogService)],d),e.ExtHostCommands=d,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class C{constructor(p,c,u){this._commands=p,this._lookupApiCommand=c,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(p,c){if(!p)return;const u={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return u;const w=this._lookupApiCommand(p.command);if(w)u.id=w.internalId,u.arguments=w.args.map((f,y)=>f.convert(p.arguments&&p.arguments[y]));else if((0,A.isNonEmptyArray)(p.arguments)){const f=++this._cachIdPool;this._cache.set(f,p),c.add((0,m.toDisposable)(()=>{this._cache.delete(f),this._logService.trace("CommandsConverter#DISPOSE",f)})),u.$ident=f,u.id=this.delegatingCommandId,u.arguments=[f],this._logService.trace("CommandsConverter#CREATE",p.command,f)}return u}fromInternal(p){const c=t.ObjectIdentifier.of(p);return typeof c=="number"?this._cache.get(c):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this._cache.get(p[0])}_executeConvertedCommand(...p){const c=this.getActualCommand(...p);return this._logService.trace("CommandsConverter#EXECUTE",p[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=C;class r{constructor(p,c,u,w){this.name=p,this.description=c,this.validate=u,this.convert=w}optional(){return new r(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,c){return new r(p??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=r,r.Uri=new r("uri","Uri of a text document",i=>n.URI.isUri(i),i=>i),r.Position=new r("position","A position in a text document",i=>M.Position.isPosition(i),E.Position.from),r.Range=new r("range","A range in a text document",i=>M.Range.isRange(i),E.Range.from),r.Selection=new r("selection","A selection in a text document",i=>M.Selection.isSelection(i),E.Selection.from),r.Number=new r("number","",i=>typeof i=="number",i=>i),r.String=new r("string","",i=>typeof i=="string",i=>i),r.CallHierarchyItem=new r("item","A call hierarchy item",i=>i instanceof M.CallHierarchyItem,E.CallHierarchyItem.from),r.TypeHierarchyItem=new r("item","A type hierarchy item",i=>i instanceof M.TypeHierarchyItem,E.TypeHierarchyItem.from),r.TestItem=new r("testItem","A VS Code TestItem",i=>i instanceof g.TestItemImpl,E.TestItem.from);class b{constructor(p,c){this.description=p,this.convert=c}}e.ApiCommandResult=b,b.Void=new b("no result",i=>i);class o{constructor(p,c,u,w,f){this.id=p,this.internalId=c,this.description=u,this.args=w,this.result=f}}e.ApiCommand=o}),define(be[188],Ee([0,1,8,7,61,40,15,81]),function(re,e,l,M,E,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new T.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",F(l.DocumentHighlight.to))),new T.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,m)=>{if((0,t.isFalsyOrEmpty)(n))return;class a extends M.SymbolInformation{static to(g){const S=new a(g.name,l.SymbolKind.to(g.kind),g.containerName||"",new M.Location(m[0],l.Range.to(g.range)));return S.detail=g.detail,S.range=S.location.range,S.selectionRange=l.Range.to(g.selectionRange),S.children=g.children?g.children.map(a.to):[],S}}return n.map(a.to)})),new T.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(l.TextEdit.to))),new T.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range,new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(l.TextEdit.to))),new T.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,new T.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new T.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new T.ApiCommandResult("A promise that resolves to an array of TextEdits.",F(l.TextEdit.to))),new T.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new T.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Location-instances.",F(l.location.to))),new T.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to an array of Hover-instances.",F(l.Hover.to))),new T.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(m=>M.Position.isPosition(m)),n=>n.map(l.Position.from))],new T.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(m=>{let a;for(const h of m.reverse())a=new M.SelectionRange(l.Range.to(h),a);return a}))),new T.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[T.ApiCommandArgument.String.with("query","Search string")],new T.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>{const m=[];if(Array.isArray(n))for(let a of n)m.push(...a[1].map(l.WorkspaceSymbol.to));return m})),new T.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(l.CallHierarchyItem.to))),new T.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(l.CallHierarchyIncomingCall.to))),new T.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[T.ApiCommandArgument.CallHierarchyItem],new T.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(l.CallHierarchyOutgoingCall.to))),new T.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:l.Range.to(n.range),placeholder:n.text}})),new T.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("newName","The new symbol name")],new T.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return l.WorkspaceEdit.to(n)}})),new T.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new T.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(l.DocumentLink.to))),new T.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,A.decodeSemanticTokensDto)(n);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range.optional()],new T.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new M.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new T.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const m=(0,A.decodeSemanticTokensDto)(n);if(m.type==="full")return new M.SemanticTokens(m.data,void 0)})),new T.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new T.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,m,a)=>{if(!n)return new M.CompletionList([]);const h=n.suggestions.map(g=>l.CompletionItem.to(g,a));return new M.CompletionList(h,n.incomplete)})),new T.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position,T.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new T.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return l.SignatureHelp.to(n)})),new T.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new T.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,m,a)=>F(h=>new M.CodeLens(l.Range.to(h.range),h.command&&a.fromInternal(h.command)))(n))),new T.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>M.Range.isRange(n),n=>M.Selection.isSelection(n)?l.Selection.from(n):l.Range.from(n)),T.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),T.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new T.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,m,a)=>F(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(h.command)}else{const g=new M.CodeAction(h.title,h.kind?new M.CodeActionKind(h.kind):void 0);return h.edit&&(g.edit=l.WorkspaceEdit.to(h.edit)),h.command&&(g.command=a.fromInternal(h.command)),g.isPreferred=h.isPreferred,g}})(n))),new T.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[T.ApiCommandArgument.Uri],new T.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(m=>new M.ColorInformation(l.Range.to(m.range),l.Color.to(m.color))):[])),new T.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new T.ApiCommandArgument("color","The color to show and insert",n=>n instanceof M.Color,l.Color.from),new T.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:l.Range.from(n.range)}))],new T.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(l.ColorPresentation.to):[])),new T.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of Inlay objects",n=>n.map(l.InlayHint.to))),new T.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new T.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",F(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(m=>l.NotebookExclusiveDocumentPattern.to(m))})))),new T.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Range],new T.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(l.InlineValue.to))),new T.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[T.ApiCommandArgument.Uri,new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[l.ViewColumn.from(n.viewColumn),l.TextEditorOpenOptions.from(n)])).optional(),T.ApiCommandArgument.String.with("label","").optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[T.ApiCommandArgument.Uri.with("resource","Resource to open"),T.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[n,void 0]:[l.ViewColumn.from(n.viewColumn),l.TextEditorOpenOptions.from(n)])).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[T.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),T.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),T.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new T.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[l.ViewColumn.from(n.viewColumn),l.TextEditorOpenOptions.from(n)]).optional()],T.ApiCommandResult.Void),new T.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[T.ApiCommandArgument.Uri,T.ApiCommandArgument.Position],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(l.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(l.TypeHierarchyItem.to))),new T.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[T.ApiCommandArgument.TypeHierarchyItem],new T.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(l.TypeHierarchyItem.to))),new T.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[T.ApiCommandArgument.TestItem],T.ApiCommandResult.Void)];class I{static register(m){D.forEach(m.registerApiCommand,m)}}e.ExtHostApiCommands=I;function F(n){return m=>{if(Array.isArray(m))return m.map(n)}}function _(n){if(!Array.isArray(n))return;const m=[];for(const a of n)E.isLocationLink(a)?m.push(l.DefinitionLink.to(a)):m.push(l.location.to(a));return m}}),define(be[189],Ee([0,1,13,55,3,6,2,61,26,8,7,5]),function(re,e,l,M,E,T,t,A,D,I,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function n(m,a,h){const g=m.getProxy(_.MainContext.MainThreadComments);class S{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const p=this._commentControllers.get(i.handle);return p||i}else if(i&&i.$mid===7){const p=this._commentControllers.get(i.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.commentThreadHandle);return c||i}else if(i&&i.$mid===8){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);return c?{thread:c,text:i.text}:i}else if(i&&i.$mid===9){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;let u=i.commentUniqueId,w=c.getCommentByUniqueId(u);return w||i}else if(i&&i.$mid===10){const p=this._commentControllers.get(i.thread.commentControlHandle);if(!p)return i;const c=p.getCommentThread(i.thread.commentThreadHandle);if(!c)return i;let u=i.text,w=i.commentUniqueId,f=c.getCommentByUniqueId(w);return f?(f.body=u,f):i}return i}})}createCommentController(i,p,c){const u=S.handlePool++,w=new s(i,u,p,c);this._commentControllers.set(w.handle,w);const f=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(i.identifier))||[];return f.push(w),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(i.identifier),f),w.value}$createCommentThreadTemplate(i,p,c){const u=this._commentControllers.get(i);!u||u.$createCommentThreadTemplate(p,c)}async $updateCommentThreadTemplate(i,p,c){const u=this._commentControllers.get(i);!u||u.$updateCommentThreadTemplate(p,c)}$deleteCommentThread(i,p){const c=this._commentControllers.get(i);c&&c.$deleteCommentThread(p)}$provideCommentingRanges(i,p,c){const u=this._commentControllers.get(i);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const w=h.getDocument(t.URI.revive(p));return(0,l.asPromise)(()=>u.commentingRangeProvider.provideCommentingRanges(w,c)).then(f=>f?f.map(y=>I.Range.from(y)):void 0)}$toggleReaction(i,p,c,u,w){const f=this._commentControllers.get(i);return!f||!f.reactionHandler?Promise.resolve(void 0):(0,l.asPromise)(()=>{const y=f.getCommentThread(p);if(y){const R=y.getCommentByUniqueId(u.uniqueIdInThread);if(f!==void 0&&R&&f.reactionHandler)return f.reactionHandler(R,r(w))}return Promise.resolve(void 0)})}dispose(){}}S.handlePool=0;class v{constructor(i,p,c,u,w,f,y){this._commentControllerHandle=p,this._id=c,this._uri=u,this._range=w,this._comments=f,this.handle=v._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),g.$createCommentThread(p,this.handle,this._id,this._uri,I.Range.from(this._range),y),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=f,this._localDisposables.push({dispose:()=>{g.$deleteCommentThread(p,this.handle)}});const R=this;this.value={get uri(){return R.uri},get range(){return R.range},set range(P){R.range=P},get comments(){return R.comments},set comments(P){R.comments=P},get collapsibleState(){return R.collapsibleState},set collapsibleState(P){R.collapsibleState=P},get canReply(){return R.canReply},set canReply(P){R.canReply=P},get contextValue(){return R.contextValue},set contextValue(P){R.contextValue=P},get label(){return R.label},set label(P){R.label=P},dispose:()=>{R.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const i=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),p={};i("range")&&(p.range=I.Range.from(this._range)),i("label")&&(p.label=this.label),i("contextValue")&&(p.contextValue=this.contextValue??null),i("comments")&&(p.comments=this._comments.map(c=>d(this,c,this._commentsMap))),i("collapsibleState")&&(p.collapseState=b(this._collapseState)),i("canReply")&&(p.canReply=this.canReply),this.modifications={},g.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,p)}getCommentByUniqueId(i){for(let p of this._commentsMap){let c=p[0],u=p[1];if(i===u)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}v._handlePool=0,Ue([(0,M.debounce)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class s{constructor(i,p,c,u){this._extension=i,this._handle=p,this._id=c,this._label=u,this._threads=new Map,g.$registerCommentController(this.handle,c,u);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(f){w.options=f},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(f){w.commentingRangeProvider=f},get reactionHandler(){return w.reactionHandler},set reactionHandler(f){w.reactionHandler=f},createCommentThread(f,y,R){return w.createCommentThread(f,y,R).value},dispose:()=>{w.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{g.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,g.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,g.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,g.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,p,c,u){if(typeof i=="string"){const w=new v(this.id,this.handle,i,p,c,u,this._extension.identifier);return this._threads.set(w.handle,w),w}else{const w=new v(this.id,this.handle,void 0,i,p,c,this._extension.identifier);return this._threads.set(w.handle,w),w}}$createCommentThreadTemplate(i,p){const c=new v(this.id,this.handle,void 0,t.URI.revive(i),I.Range.to(p),[],this._extension.identifier);return c.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(i,p){let c=this._threads.get(i);c&&(c.range=I.Range.to(p))}$deleteCommentThread(i){let p=this._threads.get(i);p&&p.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function d(o,i,p){let c=p.get(i);c||(c=++o.commentHandle,p.set(i,c));const u=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:c,body:I.MarkdownString.from(i.body),userName:i.author.name,userIconPath:u,label:i.label,commentReactions:i.reactions?i.reactions.map(w=>C(w)):void 0}}function C(o){return{label:o.label,iconPath:o.iconPath?I.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function r(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?t.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function b(o){if(o!==void 0)switch(o){case F.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case F.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}return new S}e.createExtHostComments=n}),define(be[95],Ee([0,1,2,5,7,4,14,12,15,9,17]),function(re,e,l,M,E,T,t,A,D,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class wi{constructor(m,a){this._logService=a,this._provider=new Map,this._proxy=m.getProxy(M.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,a){const h=wi._handlePool++;this._provider.set(h,{provider:m,extensionId:a}),this._proxy.$registerDecorationProvider(h,a.value);const g=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(S=>{if(!S){this._proxy.$onDidChange(h,null);return}let v=(0,D.asArray)(S);if(v.length<=wi._maxEventSize){this._proxy.$onDidChange(h,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,v.length);const s=v.map(r=>({uri:r,rank:(0,I.count)(r.path,"/")})),d=(0,D.groupBy)(s,(r,b)=>r.rank-b.rank||(0,I.compare)(r.uri.path,b.uri.path));let C=[];e:for(let r of d){let b;for(let o of r){let i=(0,F.dirname)(o.uri.path);if(b!==i&&(b=i,C.push(o.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(h,C)});return new E.Disposable(()=>{g?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(m,a,h){if(!this._provider.has(m))return Object.create(null);const g=Object.create(null),{provider:S,extensionId:v}=this._provider.get(m);return await Promise.all(a.map(async s=>{try{const{uri:d,id:C}=s,r=await Promise.resolve(S.provideFileDecoration(l.URI.revive(d),h));if(!r)return;try{E.FileDecoration.validate(r),g[C]=[r.propagate,r.tooltip,r.badge,r.color]}catch(b){this._logService.warn(`INVALID decoration from extension '${v.value}': ${b}`)}}catch(d){this._logService.error(d)}})),g}};_._handlePool=0,_._maxEventSize=250,_=Ue([Be(0,t.IExtHostRpcService),Be(1,A.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(re,e,l,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,l):E?E.value=l:e.set(re,l),l},Te=this&&this.__classPrivateFieldGet||function(re,e,l,M){if(l==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?M:l==="a"?M.call(re):M?M.value:e.get(re)};define(be[190],Ee([0,1,125,83,2,5,7,8,3,12,20,31]),function(re,e,l,M,E,T,t,A,D,I,F,_){"use strict";var n,m,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(v,s,d,C,r,b){this._name=v,this._owner=s,this._maxDiagnosticsPerFile=d,n.set(this,void 0),m.set(this,void 0),a.set(this,void 0),this._isDisposed=!1,Xe(this,a,new F.ResourceMap(o=>C.getComparisonKey(o)),"f"),Xe(this,n,r,"f"),Xe(this,m,b,"f")}dispose(){this._isDisposed||(Te(this,m,"f").fire([...Te(this,a,"f").keys()]),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner),Te(this,a,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,s){if(!v){this.clear();return}this._checkDisposed();let d=[];if(E.URI.isUri(v)){if(!s){this.delete(v);return}Te(this,a,"f").set(v,s.slice()),d=[v]}else if(Array.isArray(v)){d=[];let r;v=[...v].sort(h._compareIndexedTuplesByUri);for(const b of v){const[o,i]=b;if((!r||o.toString()!==r.toString())&&(r&&Te(this,a,"f").get(r).length===0&&Te(this,a,"f").delete(r),r=o,d.push(o),Te(this,a,"f").set(o,[])),i){const p=Te(this,a,"f").get(o);p&&p.push(...i)}else{const p=Te(this,a,"f").get(o);p&&(p.length=0)}}}if(Te(this,m,"f").fire(d),!Te(this,n,"f"))return;const C=[];for(let r of d){let b=[];const o=Te(this,a,"f").get(r);if(o)if(o.length>this._maxDiagnosticsPerFile){b=[];const i=[t.DiagnosticSeverity.Error,t.DiagnosticSeverity.Warning,t.DiagnosticSeverity.Information,t.DiagnosticSeverity.Hint];e:for(let p=0;p<4;p++)for(let c of o)if(c.severity===i[p]&&b.push(A.Diagnostic.from(c))===this._maxDiagnosticsPerFile)break e;b.push({severity:M.MarkerSeverity.Info,message:(0,l.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:b[b.length-1].startLineNumber,startColumn:b[b.length-1].startColumn,endLineNumber:b[b.length-1].endLineNumber,endColumn:b[b.length-1].endColumn})}else b=o.map(i=>A.Diagnostic.from(i));C.push([r,b])}Te(this,n,"f").$changeMany(this._owner,C)}delete(v){this._checkDisposed(),Te(this,m,"f").fire([v]),Te(this,a,"f").delete(v),Te(this,n,"f")&&Te(this,n,"f").$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Te(this,m,"f").fire([...Te(this,a,"f").keys()]),Te(this,a,"f").clear(),Te(this,n,"f")&&Te(this,n,"f").$clear(this._owner)}forEach(v,s){this._checkDisposed();for(let d of Te(this,a,"f").keys())v.apply(s,[d,this.get(d),this])}get(v){this._checkDisposed();const s=Te(this,a,"f").get(v);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Te(this,a,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,s){return v[0].toString()<s[0].toString()?-1:v[0].toString()>s[0].toString()?1:0}}e.DiagnosticCollection=h,n=new WeakMap,m=new WeakMap,a=new WeakMap;let g=class ti{constructor(v,s,d){this._logService=s,this._fileSystemInfoService=d,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:C=>C.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,ti._mapper),this._proxy=v.getProxy(T.MainContext.MainThreadDiagnostics)}static _mapper(v){const s=new F.ResourceMap;for(const d of v)s.set(d,d);return{uris:Object.freeze(Array.from(s.values()))}}createDiagnosticCollection(v,s){const{_collections:d,_proxy:C,_onDidChangeDiagnostics:r,_logService:b,_fileSystemInfoService:o}=this,i=new class{$changeMany(u,w){C.$changeMany(u,w),b.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,u,w.length===0?"CLEARING":w)}$clear(u){C.$clear(u),b.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,u)}dispose(){C.dispose()}};let p;if(!s)s="_generated_diagnostic_collection_name_#"+ti._idPool++,p=s;else if(!d.has(s))p=s;else{this._logService.warn(`DiagnosticCollection with name '${s}' does already exist.`);do p=s+ti._idPool++;while(d.has(p))}return new class extends h{constructor(){super(s,p,ti._maxDiagnosticsPerFile,o.extUri,i,r);d.set(p,this)}dispose(){super.dispose(),d.delete(p)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const s=new Map,d=[];for(const C of this._collections.values())C.forEach((r,b)=>{let o=s.get(r.toString());typeof o=="undefined"&&(o=d.length,s.set(r.toString(),o),d.push([r,[]])),d[o][1]=d[o][1].concat(...b)});return d}}_getDiagnostics(v){let s=[];for(let d of this._collections.values())d.has(v)&&(s=s.concat(d.get(v)));return s}$acceptMarkersChange(v){if(!this._mirrorCollection){const s="_generated_mirror",d=new h(s,s,ti._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(s,d),this._mirrorCollection=d}for(const[s,d]of v)this._mirrorCollection.set(E.URI.revive(s),d.map(A.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=Ue([Be(1,I.ILogService),Be(2,_.IExtHostFileSystemInfo)],g),e.ExtHostDiagnostics=g}),define(be[191],Ee([0,1,2,5]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(t){this._proxy=t.getProxy(M.MainContext.MainThreadDialogs)}showOpenDialog(t){return this._proxy.$showOpenDialog(t).then(A=>A?A.map(D=>l.URI.revive(D)):void 0)}showSaveDialog(t){return this._proxy.$showSaveDialog(t).then(A=>A?l.URI.revive(A):void 0)}}e.ExtHostDialogs=E}),define(be[192],Ee([0,1,16,2,7,5,11,21,9]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(_,n,m){this._documentsAndEditors=n,this._logService=m,this._documentContentProviders=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,n){if(Object.keys(t.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const m=I._handlePool++;this._documentContentProviders.set(m,n),this._proxy.$registerTextContentProvider(m,_);let a;return typeof n.onDidChange=="function"&&(a=n.onDidChange(h=>{if(h.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(m,h).then(g=>{if(!g&&typeof g!="string")return;const S=this._documentsAndEditors.getDocument(h);if(!S)return;const v=(0,D.splitLines)(g);if(!S.equalLines(v))return this._proxy.$onVirtualDocumentChange(h,g)},l.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(_,n){const m=this._documentContentProviders.get(_);return m?Promise.resolve(m.provideTextDocumentContent(M.URI.revive(n),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${n.scheme}`))}}e.ExtHostDocumentContentProvider=I,I._handlePool=0}),define(be[193],Ee([0,1,3,6,2,5,88,8,10,23,7]),function(re,e,l,M,E,T,t,A,D,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(m,a){this._onDidAddDocument=new l.Emitter,this._onDidRemoveDocument=new l.Emitter,this._onDidChangeDocument=new l.Emitter,this._onDidSaveDocument=new l.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new M.DisposableStore,this._documentLoader=new Map,this._proxy=m.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const g of h)this._onDidRemoveDocument.fire(g.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const g of h)this._onDidAddDocument.fire(g.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(m){if(!m)return;const a=this._documentsAndEditors.getDocument(m);if(a)return a}getDocument(m){const a=this.getDocumentData(m);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${m}'`);return a.document}ensureDocumentData(m){const a=this._documentsAndEditors.getDocument(m);if(a)return Promise.resolve(a);let h=this._documentLoader.get(m.toString());return h||(h=this._proxy.$tryOpenDocument(m).then(g=>{this._documentLoader.delete(m.toString());const S=E.URI.revive(g);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(S))},g=>(this._documentLoader.delete(m.toString()),Promise.reject(g))),this._documentLoader.set(m.toString(),h)),h}createDocumentData(m){return this._proxy.$tryCreateDocument(m).then(a=>E.URI.revive(a))}$acceptModelModeChanged(m,a){const h=E.URI.revive(m),g=this._documentsAndEditors.getDocument(h);if(!g)throw new Error("unknown document");this._onDidRemoveDocument.fire(g.document),g._acceptLanguageId(a),this._onDidAddDocument.fire(g.document)}$acceptModelSaved(m){const a=E.URI.revive(m),h=this._documentsAndEditors.getDocument(a);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(m,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(m,a){const h=E.URI.revive(m),g=this._documentsAndEditors.getDocument(h);if(!g)throw new Error("unknown document");g._acceptIsDirty(a),this._onDidChangeDocument.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(m,a,h){const g=E.URI.revive(m),S=this._documentsAndEditors.getDocument(g);if(!S)throw new Error("unknown document");S._acceptIsDirty(h),S.onEvents(a);let v;a.isUndoing?v=F.TextDocumentChangeReason.Undo:a.isRedoing&&(v=F.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,I.deepFreeze)({document:S.document,contentChanges:a.changes.map(s=>({range:A.Range.to(s.range),rangeOffset:s.rangeOffset,rangeLength:s.rangeLength,text:s.text})),reason:v}))}setWordDefinitionFor(m,a){(0,t.setWordDefinitionFor)(m,a)}}e.ExtHostDocuments=_}),define(be[51],Ee([0,1,43,3,6,2,4,5,88,14,94,8,12,20,11,166,103]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class S{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(d,C){this._extHostRpc=d,this._logService=C,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new M.Emitter,this._onDidRemoveDocuments=new M.Emitter,this._onDidChangeVisibleTextEditors=new M.Emitter,this._onDidChangeActiveTextEditor=new M.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const C=[],r=[],b=[];if(d.removedDocuments)for(const o of d.removedDocuments){const i=T.URI.revive(o),p=this._documents.get(i);p?.unref()&&(this._documents.delete(i),C.push(p.value))}if(d.addedDocuments)for(const o of d.addedDocuments){const i=T.URI.revive(o.uri);let p=this._documents.get(i);if(p&&i.scheme!==a.Schemas.vscodeNotebookCell&&i.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);p||(p=new S(new D.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),i,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(i,p),r.push(p.value)),p.ref()}if(d.removedEditors)for(const o of d.removedEditors){const i=this._editors.get(o);this._editors.delete(o),i&&b.push(i)}if(d.addedEditors)for(const o of d.addedEditors){const i=T.URI.revive(o.documentUri);l.ok(this._documents.has(i),`document '${i}' does not exist`),l.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const p=this._documents.get(i).value,c=new F.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>p.document),o.selections.map(_.Selection.to),o.options,o.visibleRanges.map(u=>_.Range.to(u)),typeof o.editorPosition=="number"?_.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,c)}d.newActiveEditor!==void 0&&(l.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),(0,E.dispose)(C),(0,E.dispose)(b),d.removedDocuments&&this._onDidRemoveDocuments.fire(C),d.addedDocuments&&this._onDidAddDocuments.fire(r),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){return this._documents.get(d)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const C=this._editors.get(this._activeEditorId);return d?C:C?.value}allEditors(){return[...this._editors.values()]}};v=Ue([Be(0,I.IExtHostRpcService),Be(1,n.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,t.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[72],Ee([0,1,8,5,2,3,4,14,13]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,t.createDecorator)("IExtHostEditorTabs");let I=class{constructor(_){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new T.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=_.getProxy(M.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(_){let n=-1;this._tabs=_.map((a,h)=>(a.isActive&&(n=h),Object.freeze({label:a.label,viewColumn:l.ViewColumn.to(a.viewColumn),index:h,resource:E.URI.revive(a.resource),additionalResourcesAndViewIds:a.additionalResourcesAndViewIds.map(({resource:g,viewId:S})=>({resource:E.URI.revive(g),viewId:S})),viewId:a.editorId,isActive:a.isActive,move:async(g,S)=>{this._proxy.$moveTab(a,g,l.ViewColumn.from(S)),await(0,D.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(a),await(0,D.raceTimeout)(T.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((a,h)=>a.viewColumn===h.viewColumn?a.index-h.index:a.viewColumn-h.viewColumn);const m=this._activeTab;this._activeTab=n===-1?void 0:this._tabs[n],this._activeTab!==m&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};I=Ue([Be(0,A.IExtHostRpcService)],I),e.ExtHostEditorTabs=I}),define(be[194],Ee([0,1,2,5,6,7,8,236,9,22,28]),function(re,e,l,M,E,T,t,A,D,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class _{constructor(){this._schemes=[]}add(a){this._stateMachine=void 0,this._schemes.push(a)}delete(a){const h=this._schemes.indexOf(a);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const a=this._schemes.sort(),h=[];let g,S,v=14,s=14;for(const d of a){let C=g?(0,D.commonPrefixLength)(g,d):0;for(C===0?S=1:S=s;C<d.length;C++)C+1===d.length?(v=s,s=9):s+=1,h.push([S,d.toUpperCase().charCodeAt(C),s]),h.push([S,d.toLowerCase().charCodeAt(C),s]),S=s;g=d,s=v}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new A.StateMachine(h)}}provideDocumentLinks(a){this._initStateMachine();const h=[],g=A.LinkComputer.computeLinks({getLineContent(S){return a.lineAt(S-1).text},getLineCount(){return a.lineCount}},this._stateMachine);for(const S of g){const v=t.DocumentLink.to(S);v.target&&h.push(v)}return h}}class n{constructor(a,h){this._extHostLanguageFeatures=h,this._linkProvider=new _,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=a.getProxy(M.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(a,h,g,S={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const v=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(v,g);let s=2;S.isCaseSensitive&&(s+=1024),S.isReadonly&&(s+=2048),typeof g.copy=="function"&&(s+=8),typeof g.open=="function"&&typeof g.close=="function"&&typeof g.read=="function"&&typeof g.write=="function"&&((0,F.checkProposedApiEnabled)(a,"fsChunks"),s+=4),this._proxy.$registerFileSystemProvider(v,h,s).catch(C=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${h}`),console.error(C)});const d=g.onDidChangeFile(C=>{const r=[];for(const b of C){let{uri:o,type:i}=b;if(o.scheme!==h)continue;let p;switch(i){case T.FileChangeType.Changed:p=0;break;case T.FileChangeType.Created:p=1;break;case T.FileChangeType.Deleted:p=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:o,type:p})}this._proxy.$onFileSystemChange(v,r)});return(0,E.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(a){const{type:h,ctime:g,mtime:S,size:v,permissions:s}=a;return{type:h,ctime:g,mtime:S,size:v,permissions:s}}$stat(a,h){return Promise.resolve(this._getFsProvider(a).stat(l.URI.revive(h))).then(g=>n._asIStat(g))}$readdir(a,h){return Promise.resolve(this._getFsProvider(a).readDirectory(l.URI.revive(h)))}$readFile(a,h){return Promise.resolve(this._getFsProvider(a).readFile(l.URI.revive(h))).then(g=>I.VSBuffer.wrap(g))}$writeFile(a,h,g,S){return Promise.resolve(this._getFsProvider(a).writeFile(l.URI.revive(h),g.buffer,S))}$delete(a,h,g){return Promise.resolve(this._getFsProvider(a).delete(l.URI.revive(h),g))}$rename(a,h,g,S){return Promise.resolve(this._getFsProvider(a).rename(l.URI.revive(h),l.URI.revive(g),S))}$copy(a,h,g,S){const v=this._getFsProvider(a);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(l.URI.revive(h),l.URI.revive(g),S))}$mkdir(a,h){return Promise.resolve(this._getFsProvider(a).createDirectory(l.URI.revive(h)))}$watch(a,h,g,S){const v=this._getFsProvider(a).watch(l.URI.revive(g),S);this._watches.set(h,v)}$unwatch(a,h){const g=this._watches.get(h);g&&(g.dispose(),this._watches.delete(h))}$open(a,h,g){const S=this._getFsProvider(a);if(!S.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(S.open(l.URI.revive(h),g))}$close(a,h){const g=this._getFsProvider(a);if(!g.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(g.close(h))}$read(a,h,g,S){const v=this._getFsProvider(a);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const s=I.VSBuffer.alloc(S);return Promise.resolve(v.read(h,g,s.buffer,0,S)).then(d=>s.slice(0,d))}$write(a,h,g,S){const v=this._getFsProvider(a);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(h,g,S.buffer,0,S.byteLength))}_getFsProvider(a){const h=this._fsProvider.get(a);if(!h){const g=new Error;throw g.name="ENOPRO",g.message="no provider",g}return h}}e.ExtHostFileSystem=n}),define(be[52],Ee([0,1,5,47,7,22,4,14,31]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let I=class Bt{constructor(_,n){const m=_.getProxy(l.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return m.$stat(a).catch(Bt._handleError)},readDirectory(a){return m.$readdir(a).catch(Bt._handleError)},createDirectory(a){return m.$mkdir(a).catch(Bt._handleError)},async readFile(a){return m.$readFile(a).then(h=>h.buffer).catch(Bt._handleError)},writeFile(a,h){return m.$writeFile(a,T.VSBuffer.wrap(h)).catch(Bt._handleError)},delete(a,h){return m.$delete(a,{recursive:!1,useTrash:!1,...h}).catch(Bt._handleError)},rename(a,h,g){return m.$rename(a,h,{overwrite:!1,...g}).catch(Bt._handleError)},copy(a,h,g){return m.$copy(a,h,{overwrite:!1,...g}).catch(Bt._handleError)},isWritableFileSystem(a){const h=n.getCapabilities(a);if(typeof h=="number")return!(h&2048)}})}static _handleError(_){if(!(_ instanceof Error))throw new E.FileSystemError(String(_));if(_.name==="ENOPRO")throw E.FileSystemError.Unavailable(_.message);switch(_.name){case M.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(_.message);case M.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(_.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(_.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(_.message);case M.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(_.message);case M.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(_.message);default:throw new E.FileSystemError(_.message,_.name)}}};I=Ue([Be(0,A.IExtHostRpcService),Be(1,D.IExtHostFileSystemInfo)],I),e.ExtHostConsumerFileSystem=I,e.IExtHostConsumerFileSystem=(0,t.createDecorator)("IExtHostConsumerFileSystem")}),define(be[195],Ee([0,1,2,40]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(t,A,D,I){this._extHostNotebooks=A,this._textDocumentsAndEditors=D,this._commands=I;const F=new M.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new M.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new M.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new M.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new M.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const n=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:l.URI.revive(_.notebookUri),inputUri:l.URI.revive(_.inputUri),notebookEditor:n.apiEditor}}return{notebookUri:l.URI.revive(_.notebookUri),inputUri:l.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(F)}$willAddInteractiveDocument(t,A,D,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:D,uri:t,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(l.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(t,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[t]})}}e.ExtHostInteractive=E}),define(be[196],Ee([0,1,6,5]),function(re,e,l,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(t){this._handlePool=0,this._proxy=t.getProxy(M.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(t){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,t),(0,l.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=E}),define(be[197],Ee([0,1,2,23,8,7,5,9,45,15,10,237,6,81,56,65,198,16,3]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentSymbols(z,K){const Z=this._documents.getDocument(z),oe=await this._provider.provideDocumentSymbols(Z,K);if(!(0,I.isFalsyOrEmpty)(oe))return oe[0]instanceof T.DocumentSymbol?oe.map(E.DocumentSymbol.from):s._asDocumentSymbolTree(oe)}static _asDocumentSymbolTree(z){z=z.slice(0).sort((oe,G)=>{let ie=oe.location.range.start.compareTo(G.location.range.start);return ie===0&&(ie=G.location.range.end.compareTo(oe.location.range.end)),ie});const K=[],Z=[];for(const oe of z){const G={name:oe.name||"!!MISSING: name!!",kind:E.SymbolKind.from(oe.kind),tags:oe.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:oe.containerName,range:E.Range.from(oe.location.range),selectionRange:E.Range.from(oe.location.range),children:[]};for(;;){if(Z.length===0){Z.push(G),K.push(G);break}const ie=Z[Z.length-1];if(D.Range.containsRange(ie.range,G.range)&&!D.Range.equalsRange(ie.range,G.range)){ie.children&&ie.children.push(G),Z.push(G);break}Z.pop()}}return K}}class d{constructor(z,K,Z){this._documents=z,this._commands=K,this._provider=Z,this._cache=new h.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,K){const Z=this._documents.getDocument(z),oe=await this._provider.provideCodeLenses(Z,K);if(!oe||K.isCancellationRequested)return;const G=this._cache.add(oe),ie=new n.DisposableStore;this._disposables.set(G,ie);const de={cacheId:G,lenses:[]};for(let Pe=0;Pe<oe.length;Pe++)de.lenses.push({cacheId:[G,Pe],range:E.Range.from(oe[Pe].range),command:this._commands.toInternal(oe[Pe].command,ie)});return de}async resolveCodeLens(z,K){const Z=z.cacheId&&this._cache.get(...z.cacheId);if(!Z)return;let oe;if(typeof this._provider.resolveCodeLens!="function"||Z.isResolved?oe=Z:oe=await this._provider.resolveCodeLens(Z,K),oe||(oe=Z),K.isCancellationRequested)return;const G=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!G)return z.command=this._commands.toInternal(oe.command??d._badCmd,G),z}releaseCodeLenses(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}}d._badCmd={command:"missing",title:"!!MISSING: command!!"};function C(Qe){return Array.isArray(Qe)?Qe.map(E.DefinitionLink.from):Qe?[E.DefinitionLink.from(Qe)]:[]}class r{constructor(z,K){this._documents=z,this._provider=K}async provideDefinition(z,K,Z){const oe=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideDefinition(oe,G,Z);return C(ie)}}class b{constructor(z,K){this._documents=z,this._provider=K}async provideDeclaration(z,K,Z){const oe=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideDeclaration(oe,G,Z);return C(ie)}}class o{constructor(z,K){this._documents=z,this._provider=K}async provideImplementation(z,K,Z){const oe=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideImplementation(oe,G,Z);return C(ie)}}class i{constructor(z,K){this._documents=z,this._provider=K}async provideTypeDefinition(z,K,Z){const oe=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideTypeDefinition(oe,G,Z);return C(ie)}}class p{constructor(z,K){this._documents=z,this._provider=K}async provideHover(z,K,Z){const oe=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideHover(oe,G,Z);if(!(!ie||(0,I.isFalsyOrEmpty)(ie.contents)))return ie.range||(ie.range=oe.getWordRangeAtPosition(G)),ie.range||(ie.range=new T.Range(G,G)),E.Hover.from(ie)}}class c{constructor(z,K){this._documents=z,this._provider=K}async provideEvaluatableExpression(z,K,Z){const oe=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideEvaluatableExpression(oe,G,Z);if(ie)return E.EvaluatableExpression.from(ie)}}class u{constructor(z,K){this._documents=z,this._provider=K}async provideInlineValues(z,K,Z,oe){const G=this._documents.getDocument(z),ie=await this._provider.provideInlineValues(G,E.Range.to(K),E.InlineValueContext.to(Z),oe);if(Array.isArray(ie))return ie.map(de=>E.InlineValue.from(de))}}class w{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentHighlights(z,K,Z){const oe=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideDocumentHighlights(oe,G,Z);if(Array.isArray(ie))return ie.map(E.DocumentHighlight.from)}}class f{constructor(z,K){this._documents=z,this._provider=K}async provideLinkedEditingRanges(z,K,Z){const oe=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.provideLinkedEditingRanges(oe,G,Z);if(ie&&Array.isArray(ie.ranges))return{ranges:(0,I.coalesce)(ie.ranges.map(E.Range.from)),wordPattern:ie.wordPattern}}}class y{constructor(z,K){this._documents=z,this._provider=K}async provideReferences(z,K,Z,oe){const G=this._documents.getDocument(z),ie=E.Position.to(K),de=await this._provider.provideReferences(G,ie,Z,oe);if(Array.isArray(de))return de.map(E.location.from)}}class R{constructor(z,K,Z,oe,G,ie,de){this._documents=z,this._commands=K,this._diagnostics=Z,this._provider=oe,this._logService=G,this._extension=ie,this._apiDeprecation=de,this._cache=new h.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(z,K,Z,oe){const G=this._documents.getDocument(z),ie=_.Selection.isISelection(K)?E.Selection.to(K):E.Range.to(K),de=[];for(const ot of this._diagnostics.getDiagnostics(z))if(ie.intersection(ot.range)&&de.push(ot)>R._maxCodeActionsPerFile)break;const Pe={diagnostics:de,only:Z.only?new T.CodeActionKind(Z.only):void 0,triggerKind:E.CodeActionTriggerKind.to(Z.trigger)},Ne=await this._provider.provideCodeActions(G,ie,Pe,oe);if(!(0,I.isNonEmptyArray)(Ne)||oe.isCancellationRequested)return;const We=this._cache.add(Ne),je=new n.DisposableStore;this._disposables.set(We,je);const et=[];for(let ot=0;ot<Ne.length;ot++){const ye=Ne[ot];!ye||(R._isCommand(ye)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:ye.title,command:this._commands.toInternal(ye,je)})):(Pe.only&&(ye.kind?Pe.only.contains(ye.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action is of kind '${ye.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[We,ot],title:ye.title,command:ye.command&&this._commands.toInternal(ye.command,je),diagnostics:ye.diagnostics&&ye.diagnostics.map(E.Diagnostic.from),edit:ye.edit&&E.WorkspaceEdit.from(ye.edit),kind:ye.kind&&ye.kind.value,isPreferred:ye.isPreferred,disabled:ye.disabled?.reason})))}return{cacheId:We,actions:et}}async resolveCodeAction(z,K){const[Z,oe]=z,G=this._cache.get(Z,oe);if(!G||R._isCommand(G)||!this._provider.resolveCodeAction)return;const ie=await this._provider.resolveCodeAction(G,K)??G;return ie?.edit?E.WorkspaceEdit.from(ie.edit):void 0}releaseCodeActions(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}R._maxCodeActionsPerFile=1e3;class P{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentFormattingEdits(z,K,Z){const oe=this._documents.getDocument(z),G=await this._provider.provideDocumentFormattingEdits(oe,K,Z);if(Array.isArray(G))return G.map(E.TextEdit.from)}}class B{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentRangeFormattingEdits(z,K,Z,oe){const G=this._documents.getDocument(z),ie=E.Range.to(K),de=await this._provider.provideDocumentRangeFormattingEdits(G,ie,Z,oe);if(Array.isArray(de))return de.map(E.TextEdit.from)}}class L{constructor(z,K){this._documents=z,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,K,Z,oe,G){const ie=this._documents.getDocument(z),de=E.Position.to(K),Pe=await this._provider.provideOnTypeFormattingEdits(ie,de,Z,oe,G);if(Array.isArray(Pe))return Pe.map(E.TextEdit.from)}}class k{constructor(z,K){this._provider=z,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(z,K){const Z=t.IdObject.mixin({symbols:[]}),oe=await this._provider.provideWorkspaceSymbols(z,K);if((0,I.isNonEmptyArray)(oe))for(const G of oe){if(!G)continue;if(!G.name){this._logService.warn("INVALID SymbolInformation, lacks name",G);continue}const ie=t.IdObject.mixin(E.WorkspaceSymbol.from(G));this._symbolCache.set(ie._id,G),Z.symbols.push(ie)}return Z.symbols.length>0&&this._resultCache.set(Z._id,[Z.symbols[0]._id,Z.symbols[Z.symbols.length-1]._id]),Z}async resolveWorkspaceSymbol(z,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const Z=this._symbolCache.get(z._id);if(Z){const oe=await this._provider.resolveWorkspaceSymbol(Z,K);return oe&&(0,M.mixin)(z,E.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(z){const K=this._resultCache.get(z);if(K){for(let[Z,oe]=K;Z<=oe;Z++)this._symbolCache.delete(Z);this._resultCache.delete(z)}}}class x{constructor(z,K,Z){this._documents=z,this._provider=K,this._logService=Z}static supportsResolving(z){return typeof z.prepareRename=="function"}async provideRenameEdits(z,K,Z,oe){const G=this._documents.getDocument(z),ie=E.Position.to(K);try{const de=await this._provider.provideRenameEdits(G,ie,Z,oe);return de?E.WorkspaceEdit.from(de):void 0}catch(de){const Pe=x._asMessage(de);return Pe?{rejectReason:Pe,edits:void 0}:Promise.reject(de)}}async resolveRenameLocation(z,K,Z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(z),G=E.Position.to(K);try{const ie=await this._provider.prepareRename(oe,G,Z);let de,Pe;if(T.Range.isRange(ie)?(de=ie,Pe=oe.getText(ie)):(0,F.isObject)(ie)&&(de=ie.range,Pe=ie.placeholder),!de||!Pe)return;if(de.start.line>G.line||de.end.line<G.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(de),text:Pe}}catch(ie){const de=x._asMessage(ie);return de?{rejectReason:de,range:void 0,text:void 0}:Promise.reject(ie)}}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class N{constructor(z,K){this.resultId=z,this.tokens=K}}class V{constructor(z,K){this._documents=z,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(z,K,Z){const oe=this._documents.getDocument(z),G=K!==0?this._previousResults.get(K):null;let ie=typeof G?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(oe,G.resultId,Z):await this._provider.provideDocumentSemanticTokens(oe,Z);return G&&this._previousResults.delete(K),ie?(ie=V._fixProvidedSemanticTokens(ie),this._send(V._convertToEdits(G,ie),ie)):null}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return V._isSemanticTokens(z)?V._isCorrectSemanticTokens(z)?z:new T.SemanticTokens(new Uint32Array(z.data),z.resultId):V._isSemanticTokensEdits(z)?V._isCorrectSemanticTokensEdits(z)?z:new T.SemanticTokensEdits(z.edits.map(K=>new T.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const K of z.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,K){if(!V._isSemanticTokens(K)||!z||!z.tokens)return K;const Z=z.tokens,oe=Z.length,G=K.data,ie=G.length;let de=0;const Pe=Math.min(oe,ie);for(;de<Pe&&Z[de]===G[de];)de++;if(de===oe&&de===ie)return new T.SemanticTokensEdits([],K.resultId);let Ne=0;const We=Pe-de;for(;Ne<We&&Z[oe-Ne-1]===G[ie-Ne-1];)Ne++;return new T.SemanticTokensEdits([{start:de,deleteCount:oe-de-Ne,data:G.subarray(de,ie-Ne)}],K.resultId)}_send(z,K){if(V._isSemanticTokens(z)){const Z=this._nextResultId++;return this._previousResults.set(Z,new N(z.resultId,z.data)),(0,m.encodeSemanticTokensDto)({id:Z,type:"full",data:z.data})}if(V._isSemanticTokensEdits(z)){const Z=this._nextResultId++;return V._isSemanticTokens(K)?this._previousResults.set(Z,new N(K.resultId,K.data)):this._previousResults.set(Z,new N(z.resultId)),(0,m.encodeSemanticTokensDto)({id:Z,type:"delta",deltas:(z.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=V;class W{constructor(z,K){this._documents=z,this._provider=K}async provideDocumentRangeSemanticTokens(z,K,Z){const oe=this._documents.getDocument(z),G=await this._provider.provideDocumentRangeSemanticTokens(oe,E.Range.to(K),Z);return G?this._send(G):null}_send(z){return(0,m.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=W;class ${constructor(z,K,Z,oe,G){this._documents=z,this._commands=K,this._provider=Z,this._apiDeprecation=oe,this._extension=G,this._cache=new h.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,K,Z,oe){const G=this._documents.getDocument(z),ie=E.Position.to(K),de=G.getWordRangeAtPosition(ie)||new T.Range(ie,ie),Pe=de.with({end:ie}),Ne=new g.StopWatch(!0),We=await this._provider.provideCompletionItems(G,ie,oe,E.CompletionContext.to(Z));if(!We||oe.isCancellationRequested)return;const je=Array.isArray(We)?new T.CompletionList(We):We,et=$.supportsResolving(this._provider)?this._cache.add(je.items):this._cache.add([]),ot=new n.DisposableStore;this._disposables.set(et,ot);const ye=[],nt={x:et,b:ye,a:{replace:E.Range.from(de),insert:E.Range.from(Pe)},c:je.isIncomplete||void 0,d:Ne.elapsed()};for(let q=0;q<je.items.length;q++){const J=je.items[q],pe=this._convertCompletionItem(J,[et,q],Pe,de);ye.push(pe)}return nt}async resolveCompletionItem(z,K){if(typeof this._provider.resolveCompletionItem!="function")return;const Z=this._cache.get(...z);if(!Z)return;const oe=await this._provider.resolveCompletionItem(Z,K);if(!!oe)return this._convertCompletionItem(oe,z)}releaseCompletionItems(z){this._disposables.get(z)?.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,K,Z,oe){const G=this._disposables.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const ie={x:K,a:z.label,b:z.kind!==void 0?E.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(E.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(z.command,G)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ie.h=z.textEdit.newText):typeof z.insertText=="string"?ie.h=z.insertText:z.insertText instanceof T.SnippetString&&(ie.h=z.insertText.value,ie.i|=4);let de;return z.textEdit?de=z.textEdit.range:z.range&&(de=z.range),T.Range.isRange(de)?ie.j=E.Range.from(de):de&&(!Z?.isEqual(de.inserting)||!oe?.isEqual(de.replacing))&&(ie.j={insert:E.Range.from(de.inserting),replace:E.Range.from(de.replacing)}),ie}}class X{constructor(z,K,Z){this._documents=z,this._provider=K,this._commands=Z,this._cache=new h.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(z,K,Z,oe){const G=this._documents.getDocument(z),ie=E.Position.to(K),de=await this._provider.provideInlineCompletionItems(G,ie,{selectedCompletionInfo:Z.selectedSuggestionInfo?{range:E.Range.to(Z.selectedSuggestionInfo.range),text:Z.selectedSuggestionInfo.text}:void 0,triggerKind:Z.triggerKind},oe);if(!de||oe.isCancellationRequested)return;const Pe=(0,F.isArray)(de)?{items:de}:de,Ne=this._cache.add(Pe.items);let We;return{pid:Ne,items:Pe.items.map((je,et)=>{let ot;return je.command&&(We||(We=new n.DisposableStore,this._disposables.set(Ne,We)),ot=this._commands.toInternal(je.command,We)),{text:je.text,range:je.range?E.Range.from(je.range):void 0,command:ot,idx:et}})}}disposeCompletions(z){this._cache.delete(z);const K=this._disposables.get(z);K&&K.clear(),this._disposables.delete(z)}handleDidShowCompletionItem(z,K){const Z=this._cache.get(z,K);Z&&j.get(this._provider).fireOnDidShowCompletionItem({completionItem:Z})}}class j{constructor(){this._onDidShowCompletionItemEmitter=new v.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(z){let K=j.map.get(z);return K||(K=new j,j.map.set(z,K)),K}fireOnDidShowCompletionItem(z){this._onDidShowCompletionItemEmitter.fire(z)}}e.InlineCompletionController=j,j.map=new WeakMap;class Q{constructor(z,K){this._documents=z,this._provider=K,this._cache=new h.Cache("SignatureHelp")}async provideSignatureHelp(z,K,Z,oe){const G=this._documents.getDocument(z),ie=E.Position.to(K),de=this.reviveContext(Z),Pe=await this._provider.provideSignatureHelp(G,ie,oe,de);if(Pe){const Ne=this._cache.add([Pe]);return{...E.SignatureHelp.from(Pe),id:Ne}}}reviveContext(z){let K;if(z.activeSignatureHelp){const Z=E.SignatureHelp.to(z.activeSignatureHelp),oe=this._cache.get(z.activeSignatureHelp.id,0);oe?(K=oe,K.activeSignature=Z.activeSignature,K.activeParameter=Z.activeParameter):K=Z}return{...z,activeSignatureHelp:K}}releaseSignatureHelp(z){this._cache.delete(z)}}class le{constructor(z,K){this._documents=z,this._provider=K}async provideInlayHints(z,K,Z){const oe=this._documents.getDocument(z),G=await this._provider.provideInlayHints(oe,E.Range.to(K),Z);return G?{hints:G.map(E.InlayHint.from)}:void 0}}class ve{constructor(z,K){this._documents=z,this._provider=K,this._cache=new h.Cache("DocumentLink")}async provideLinks(z,K){const Z=this._documents.getDocument(z),oe=await this._provider.provideDocumentLinks(Z,K);if(!(!Array.isArray(oe)||oe.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.filter(ve._validateLink).map(E.DocumentLink.from)};{const G=this._cache.add(oe),ie={links:[],id:G};for(let de=0;de<oe.length;de++){if(!ve._validateLink(oe[de]))continue;const Pe=E.DocumentLink.from(oe[de]);Pe.cacheId=[G,de],ie.links.push(Pe)}return ie}}}static _validateLink(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,K){if(typeof this._provider.resolveDocumentLink!="function")return;const Z=this._cache.get(...z);if(!Z)return;const oe=await this._provider.resolveDocumentLink(Z,K);if(!(!oe||!ve._validateLink(oe)))return E.DocumentLink.from(oe)}releaseLinks(z){this._cache.delete(z)}}class ue{constructor(z,K){this._documents=z,this._provider=K}async provideColors(z,K){const Z=this._documents.getDocument(z),oe=await this._provider.provideDocumentColors(Z,K);return Array.isArray(oe)?oe.map(ie=>({color:E.Color.from(ie.color),range:E.Range.from(ie.range)})):[]}async provideColorPresentations(z,K,Z){const oe=this._documents.getDocument(z),G=E.Range.to(K.range),ie=E.Color.to(K.color),de=await this._provider.provideColorPresentations(ie,{document:oe,range:G},Z);if(!!Array.isArray(de))return de.map(E.ColorPresentation.from)}}class Fe{constructor(z,K){this._documents=z,this._provider=K}async provideFoldingRanges(z,K,Z){const oe=this._documents.getDocument(z),G=await this._provider.provideFoldingRanges(oe,K,Z);if(!!Array.isArray(G))return G.map(E.FoldingRange.from)}}class Ke{constructor(z,K,Z){this._documents=z,this._provider=K,this._logService=Z}async provideSelectionRanges(z,K,Z){const oe=this._documents.getDocument(z),G=K.map(E.Position.to),ie=await this._provider.provideSelectionRanges(oe,G,Z);if(!(0,I.isNonEmptyArray)(ie))return[];if(ie.length!==G.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const de=[];for(let Pe=0;Pe<G.length;Pe++){const Ne=[];de.push(Ne);let We=G[Pe],je=ie[Pe];for(;;){if(!je.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(Ne.push(E.SelectionRange.from(je)),!je.parent)break;We=je.range,je=je.parent}}return de}}class Oe{constructor(z,K){this._documents=z,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(z,K,Z){const oe=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.prepareCallHierarchy(oe,G,Z);if(!ie)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ie)?ie.map(Pe=>this._cacheAndConvertItem(de,Pe)):[this._cacheAndConvertItem(de,ie)]}async provideCallsTo(z,K,Z){const oe=this._itemFromCache(z,K);if(!oe)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyIncomingCalls(oe,Z);if(!!G)return G.map(ie=>({from:this._cacheAndConvertItem(z,ie.from),fromRanges:ie.fromRanges.map(de=>E.Range.from(de))}))}async provideCallsFrom(z,K,Z){const oe=this._itemFromCache(z,K);if(!oe)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyOutgoingCalls(oe,Z);if(!!G)return G.map(ie=>({to:this._cacheAndConvertItem(z,ie.to),fromRanges:ie.fromRanges.map(de=>E.Range.from(de))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,K){const Z=this._cache.get(z),oe=E.CallHierarchyItem.from(K,z,Z.size.toString(36));return Z.set(oe._itemId,K),oe}_itemFromCache(z,K){return this._cache.get(z)?.get(K)}}class He{constructor(z,K){this._documents=z,this._provider=K,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(z,K,Z){const oe=this._documents.getDocument(z),G=E.Position.to(K),ie=await this._provider.prepareTypeHierarchy(oe,G,Z);if(!ie)return;const de=this._idPool.nextId();return this._cache.set(de,new Map),Array.isArray(ie)?ie.map(Pe=>this._cacheAndConvertItem(de,Pe)):[this._cacheAndConvertItem(de,ie)]}async provideSupertypes(z,K,Z){const oe=this._itemFromCache(z,K);if(!oe)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySupertypes(oe,Z);if(!!G)return G.map(ie=>this._cacheAndConvertItem(z,ie))}async provideSubtypes(z,K,Z){const oe=this._itemFromCache(z,K);if(!oe)throw new Error("missing type hierarchy item");const G=await this._provider.provideTypeHierarchySubtypes(oe,Z);if(!!G)return G.map(ie=>this._cacheAndConvertItem(z,ie))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,K){const Z=this._cache.get(z),oe=E.TypeHierarchyItem.from(K,z,Z.size.toString(36));return Z.set(oe._itemId,K),oe}_itemFromCache(z,K){return this._cache.get(z)?.get(K)}}class Je{constructor(z,K){this.adapter=z,this.extension=K}}class Ye{constructor(z,K,Z,oe,G,ie,de){this._adapter=new Map,this._uriTransformer=K,this._proxy=z.getProxy(t.MainContext.MainThreadLanguageFeatures),this._documents=Z,this._commands=oe,this._diagnostics=G,this._logService=ie,this._apiDeprecation=de}_transformDocumentSelector(z){return E.DocumentSelector.from(z,this._uriTransformer)}_createDisposable(z){return new T.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Ye._handlePool++}_withAdapter(z,K,Z,oe,G=!1){const ie=this._adapter.get(z);if(!ie)return Promise.resolve(oe);if(ie.adapter instanceof K){let de;ie.extension&&(de=Date.now(),this._logService.trace(`[${ie.extension.identifier.value}] INVOKE provider '${K.name}'`));const Pe=Z(ie.adapter,ie.extension),Ne=ie.extension;return Ne&&Promise.resolve(Pe).then(()=>this._logService.trace(`[${Ne.identifier.value}] provider DONE after ${Date.now()-de}ms`),We=>{G&&We instanceof S.CancellationError||(this._logService.error(`[${Ne.identifier.value}] provider FAILED`),this._logService.error(We))}),Pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,K){const Z=this._nextHandle();return this._adapter.set(Z,new Je(z,K)),Z}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,K,Z,oe){const G=this._addNewAdapter(new s(this._documents,Z),z),ie=oe&&oe.label||Ye._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(G,this._transformDocumentSelector(K),ie),this._createDisposable(G)}$provideDocumentSymbols(z,K,Z){return this._withAdapter(z,s,oe=>oe.provideDocumentSymbols(l.URI.revive(K),Z),void 0)}registerCodeLensProvider(z,K,Z){const oe=this._nextHandle(),G=typeof Z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Je(new d(this._documents,this._commands.converter,Z),z)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(K),G);let ie=this._createDisposable(oe);if(G!==void 0){const de=Z.onDidChangeCodeLenses(Pe=>this._proxy.$emitCodeLensEvent(G));ie=T.Disposable.from(ie,de)}return ie}$provideCodeLenses(z,K,Z){return this._withAdapter(z,d,oe=>oe.provideCodeLenses(l.URI.revive(K),Z),void 0)}$resolveCodeLens(z,K,Z){return this._withAdapter(z,d,oe=>oe.resolveCodeLens(K,Z),void 0)}$releaseCodeLenses(z,K){this._withAdapter(z,d,Z=>Promise.resolve(Z.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(z,K,Z){const oe=this._addNewAdapter(new r(this._documents,Z),z);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDefinition(z,K,Z,oe){return this._withAdapter(z,r,G=>G.provideDefinition(l.URI.revive(K),Z,oe),[])}registerDeclarationProvider(z,K,Z){const oe=this._addNewAdapter(new b(this._documents,Z),z);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDeclaration(z,K,Z,oe){return this._withAdapter(z,b,G=>G.provideDeclaration(l.URI.revive(K),Z,oe),[])}registerImplementationProvider(z,K,Z){const oe=this._addNewAdapter(new o(this._documents,Z),z);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideImplementation(z,K,Z,oe){return this._withAdapter(z,o,G=>G.provideImplementation(l.URI.revive(K),Z,oe),[])}registerTypeDefinitionProvider(z,K,Z){const oe=this._addNewAdapter(new i(this._documents,Z),z);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideTypeDefinition(z,K,Z,oe){return this._withAdapter(z,i,G=>G.provideTypeDefinition(l.URI.revive(K),Z,oe),[])}registerHoverProvider(z,K,Z,oe){const G=this._addNewAdapter(new p(this._documents,Z),z);return this._proxy.$registerHoverProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideHover(z,K,Z,oe){return this._withAdapter(z,p,G=>G.provideHover(l.URI.revive(K),Z,oe),void 0)}registerEvaluatableExpressionProvider(z,K,Z,oe){const G=this._addNewAdapter(new c(this._documents,Z),z);return this._proxy.$registerEvaluatableExpressionProvider(G,this._transformDocumentSelector(K)),this._createDisposable(G)}$provideEvaluatableExpression(z,K,Z,oe){return this._withAdapter(z,c,G=>G.provideEvaluatableExpression(l.URI.revive(K),Z,oe),void 0)}registerInlineValuesProvider(z,K,Z,oe){const G=typeof Z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ie=this._addNewAdapter(new u(this._documents,Z),z);this._proxy.$registerInlineValuesProvider(ie,this._transformDocumentSelector(K),G);let de=this._createDisposable(ie);if(G!==void 0){const Pe=Z.onDidChangeInlineValues(Ne=>this._proxy.$emitInlineValuesEvent(G));de=T.Disposable.from(de,Pe)}return de}$provideInlineValues(z,K,Z,oe,G){return this._withAdapter(z,u,ie=>ie.provideInlineValues(l.URI.revive(K),Z,oe,G),void 0)}registerDocumentHighlightProvider(z,K,Z){const oe=this._addNewAdapter(new w(this._documents,Z),z);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDocumentHighlights(z,K,Z,oe){return this._withAdapter(z,w,G=>G.provideDocumentHighlights(l.URI.revive(K),Z,oe),void 0)}registerLinkedEditingRangeProvider(z,K,Z){const oe=this._addNewAdapter(new f(this._documents,Z),z);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideLinkedEditingRanges(z,K,Z,oe){return this._withAdapter(z,f,async G=>{const ie=await G.provideLinkedEditingRanges(l.URI.revive(K),Z,oe);if(ie)return{ranges:ie.ranges,wordPattern:ie.wordPattern?Ye._serializeRegExp(ie.wordPattern):void 0}},void 0)}registerReferenceProvider(z,K,Z){const oe=this._addNewAdapter(new y(this._documents,Z),z);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideReferences(z,K,Z,oe,G){return this._withAdapter(z,y,ie=>ie.provideReferences(l.URI.revive(K),Z,oe,G),void 0)}registerCodeActionProvider(z,K,Z,oe){const G=new n.DisposableStore,ie=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,Z,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(ie,this._transformDocumentSelector(K),{providedKinds:oe?.providedCodeActionKinds?.map(de=>de.value),documentation:oe?.documentation?.map(de=>({kind:de.kind.value,command:this._commands.converter.toInternal(de.command,G)}))},Ye._extLabel(z),Boolean(Z.resolveCodeAction)),G.add(this._createDisposable(ie)),G}$provideCodeActions(z,K,Z,oe,G){return this._withAdapter(z,R,ie=>ie.provideCodeActions(l.URI.revive(K),Z,oe,G),void 0)}$resolveCodeAction(z,K,Z){return this._withAdapter(z,R,oe=>oe.resolveCodeAction(K,Z),void 0)}$releaseCodeActions(z,K){this._withAdapter(z,R,Z=>Promise.resolve(Z.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(z,K,Z){const oe=this._addNewAdapter(new P(this._documents,Z),z);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(K),z.identifier,z.displayName||z.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(z,K,Z,oe){return this._withAdapter(z,P,G=>G.provideDocumentFormattingEdits(l.URI.revive(K),Z,oe),void 0)}registerDocumentRangeFormattingEditProvider(z,K,Z){const oe=this._addNewAdapter(new B(this._documents,Z),z);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(K),z.identifier,z.displayName||z.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(z,K,Z,oe,G){return this._withAdapter(z,B,ie=>ie.provideDocumentRangeFormattingEdits(l.URI.revive(K),Z,oe,G),void 0)}registerOnTypeFormattingEditProvider(z,K,Z,oe){const G=this._addNewAdapter(new L(this._documents,Z),z);return this._proxy.$registerOnTypeFormattingSupport(G,this._transformDocumentSelector(K),oe,z.identifier),this._createDisposable(G)}$provideOnTypeFormattingEdits(z,K,Z,oe,G,ie){return this._withAdapter(z,L,de=>de.provideOnTypeFormattingEdits(l.URI.revive(K),Z,oe,G,ie),void 0)}registerWorkspaceSymbolProvider(z,K){const Z=this._addNewAdapter(new k(K,this._logService),z);return this._proxy.$registerNavigateTypeSupport(Z),this._createDisposable(Z)}$provideWorkspaceSymbols(z,K,Z){return this._withAdapter(z,k,oe=>oe.provideWorkspaceSymbols(K,Z),{symbols:[]})}$resolveWorkspaceSymbol(z,K,Z){return this._withAdapter(z,k,oe=>oe.resolveWorkspaceSymbol(K,Z),void 0)}$releaseWorkspaceSymbols(z,K){this._withAdapter(z,k,Z=>Z.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(z,K,Z){const oe=this._addNewAdapter(new x(this._documents,Z,this._logService),z);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(K),x.supportsResolving(Z)),this._createDisposable(oe)}$provideRenameEdits(z,K,Z,oe,G){return this._withAdapter(z,x,ie=>ie.provideRenameEdits(l.URI.revive(K),Z,oe,G),void 0)}$resolveRenameLocation(z,K,Z,oe){return this._withAdapter(z,x,G=>G.resolveRenameLocation(l.URI.revive(K),Z,oe),void 0)}registerDocumentSemanticTokensProvider(z,K,Z,oe){const G=this._nextHandle(),ie=typeof Z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(G,new Je(new V(this._documents,Z),z)),this._proxy.$registerDocumentSemanticTokensProvider(G,this._transformDocumentSelector(K),oe,ie);let de=this._createDisposable(G);if(ie){const Pe=Z.onDidChangeSemanticTokens(Ne=>this._proxy.$emitDocumentSemanticTokensEvent(ie));de=T.Disposable.from(de,Pe)}return de}$provideDocumentSemanticTokens(z,K,Z,oe){return this._withAdapter(z,V,G=>G.provideDocumentSemanticTokens(l.URI.revive(K),Z,oe),null,!0)}$releaseDocumentSemanticTokens(z,K){this._withAdapter(z,V,Z=>Z.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(z,K,Z,oe){const G=this._addNewAdapter(new W(this._documents,Z),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(G,this._transformDocumentSelector(K),oe),this._createDisposable(G)}$provideDocumentRangeSemanticTokens(z,K,Z,oe){return this._withAdapter(z,W,G=>G.provideDocumentRangeSemanticTokens(l.URI.revive(K),Z,oe),null,!0)}registerCompletionItemProvider(z,K,Z,oe){const G=this._addNewAdapter(new $(this._documents,this._commands.converter,Z,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(G,this._transformDocumentSelector(K),oe,$.supportsResolving(Z),`${z.identifier.value}(${oe.join("")})`),this._createDisposable(G)}$provideCompletionItems(z,K,Z,oe,G){return this._withAdapter(z,$,ie=>ie.provideCompletionItems(l.URI.revive(K),Z,oe,G),void 0)}$resolveCompletionItem(z,K,Z){return this._withAdapter(z,$,oe=>oe.resolveCompletionItem(K,Z),void 0)}$releaseCompletionItems(z,K){this._withAdapter(z,$,Z=>Z.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(z,K,Z){const oe=this._addNewAdapter(new X(this._documents,Z,this._commands.converter),z);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideInlineCompletions(z,K,Z,oe,G){return this._withAdapter(z,X,ie=>ie.provideInlineCompletions(l.URI.revive(K),Z,oe,G),void 0)}$handleInlineCompletionDidShow(z,K,Z){this._withAdapter(z,X,async oe=>{oe.handleDidShowCompletionItem(K,Z)},void 0)}$freeInlineCompletionsList(z,K){this._withAdapter(z,X,async Z=>{Z.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(z,K,Z,oe){const G=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,ie=this._addNewAdapter(new Q(this._documents,Z),z);return this._proxy.$registerSignatureHelpProvider(ie,this._transformDocumentSelector(K),G),this._createDisposable(ie)}$provideSignatureHelp(z,K,Z,oe,G){return this._withAdapter(z,Q,ie=>ie.provideSignatureHelp(l.URI.revive(K),Z,oe,G),void 0)}$releaseSignatureHelp(z,K){this._withAdapter(z,Q,Z=>Z.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(z,K,Z){const oe=typeof Z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,G=this._addNewAdapter(new le(this._documents,Z),z);this._proxy.$registerInlayHintsProvider(G,this._transformDocumentSelector(K),oe);let ie=this._createDisposable(G);if(oe!==void 0){const de=Z.onDidChangeInlayHints(Pe=>this._proxy.$emitInlayHintsEvent(oe));ie=T.Disposable.from(ie,de)}return ie}$provideInlayHints(z,K,Z,oe){return this._withAdapter(z,le,G=>G.provideInlayHints(l.URI.revive(K),Z,oe),void 0)}registerDocumentLinkProvider(z,K,Z){const oe=this._addNewAdapter(new ve(this._documents,Z),z);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(K),typeof Z.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(z,K,Z){return this._withAdapter(z,ve,oe=>oe.provideLinks(l.URI.revive(K),Z),void 0)}$resolveDocumentLink(z,K,Z){return this._withAdapter(z,ve,oe=>oe.resolveLink(K,Z),void 0)}$releaseDocumentLinks(z,K){this._withAdapter(z,ve,Z=>Z.releaseLinks(K),void 0)}registerColorProvider(z,K,Z){const oe=this._addNewAdapter(new ue(this._documents,Z),z);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideDocumentColors(z,K,Z){return this._withAdapter(z,ue,oe=>oe.provideColors(l.URI.revive(K),Z),[])}$provideColorPresentations(z,K,Z,oe){return this._withAdapter(z,ue,G=>G.provideColorPresentations(l.URI.revive(K),Z,oe),void 0)}registerFoldingRangeProvider(z,K,Z){const oe=this._nextHandle(),G=typeof Z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new Je(new Fe(this._documents,Z),z)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(K),G);let ie=this._createDisposable(oe);if(G!==void 0){const de=Z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(G));ie=T.Disposable.from(ie,de)}return ie}$provideFoldingRanges(z,K,Z,oe){return this._withAdapter(z,Fe,G=>G.provideFoldingRanges(l.URI.revive(K),Z,oe),void 0)}registerSelectionRangeProvider(z,K,Z){const oe=this._addNewAdapter(new Ke(this._documents,Z,this._logService),z);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$provideSelectionRanges(z,K,Z,oe){return this._withAdapter(z,Ke,G=>G.provideSelectionRanges(l.URI.revive(K),Z,oe),[])}registerCallHierarchyProvider(z,K,Z){const oe=this._addNewAdapter(new Oe(this._documents,Z),z);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$prepareCallHierarchy(z,K,Z,oe){return this._withAdapter(z,Oe,G=>Promise.resolve(G.prepareSession(l.URI.revive(K),Z,oe)),void 0)}$provideCallHierarchyIncomingCalls(z,K,Z,oe){return this._withAdapter(z,Oe,G=>G.provideCallsTo(K,Z,oe),void 0)}$provideCallHierarchyOutgoingCalls(z,K,Z,oe){return this._withAdapter(z,Oe,G=>G.provideCallsFrom(K,Z,oe),void 0)}$releaseCallHierarchy(z,K){this._withAdapter(z,Oe,Z=>Promise.resolve(Z.releaseSession(K)),void 0)}registerTypeHierarchyProvider(z,K,Z){const oe=this._addNewAdapter(new He(this._documents,Z),z);return this._proxy.$registerTypeHierarchyProvider(oe,this._transformDocumentSelector(K)),this._createDisposable(oe)}$prepareTypeHierarchy(z,K,Z,oe){return this._withAdapter(z,He,G=>Promise.resolve(G.prepareSession(l.URI.revive(K),Z,oe)),void 0)}$provideTypeHierarchySupertypes(z,K,Z,oe){return this._withAdapter(z,He,G=>G.provideSupertypes(K,Z,oe),void 0)}$provideTypeHierarchySubtypes(z,K,Z,oe){return this._withAdapter(z,He,G=>G.provideSubtypes(K,Z,oe),void 0)}$releaseTypeHierarchy(z,K){this._withAdapter(z,He,Z=>Promise.resolve(Z.releaseSession(K)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,A.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Ye._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Ye._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ye._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ye._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Ye._serializeRegExp(z.beforeText),afterText:z.afterText?Ye._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Ye._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Ye._serializeOnEnterRule)}setLanguageConfiguration(z,K,Z){let{wordPattern:oe}=Z;if(oe&&(0,A.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(K,oe):this._documents.setWordDefinitionFor(K,void 0),Z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),Z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const G=this._nextHandle(),ie={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?Ye._serializeRegExp(Z.wordPattern):void 0,indentationRules:Z.indentationRules?Ye._serializeIndentationRule(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?Ye._serializeOnEnterRules(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport};return this._proxy.$setLanguageConfiguration(G,K,ie),this._createDisposable(G)}$setWordDefinitions(z){for(const K of z)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=Ye,Ye._handlePool=0}),define(be[199],Ee([0,1,5,8,7,36,13,6]),function(re,e,l,M,E,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(F,_,n,m){this._documents=_,this._commands=n,this._uriTransformer=m,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=F.getProxy(l.MainContext.MainThreadLanguages)}$acceptLanguageIds(F){this._languageIds=F}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(F,_){await this._proxy.$changeLanguage(F,_);const n=this._documents.getDocumentData(F);if(!n)throw new Error(`document '${F.toString}' NOT found`);return n.document}async tokenAtPosition(F,_){const n=F.version,m=M.Position.from(_),a=await this._proxy.$tokensAtPosition(F.uri,m),h={type:E.StandardTokenType.Other,range:F.getWordRangeAtPosition(_)??new E.Range(_.line,_.character,_.line,_.character)};if(!a)return h;const g={range:M.Range.to(a.range),type:M.TokenType.to(a.type)};return!g.range.contains(_)||n!==F.version?h:g}createLanguageStatusItem(F,_,n){const m=this._handlePool++,a=this._proxy,h=this._ids,g=`${F.identifier.value}/${_}`;if(h.has(g))throw new Error(`LanguageStatusItem with id '${_}' ALREADY exists`);h.add(g);const S={selector:n,id:_,name:F.displayName??F.name,severity:E.LanguageStatusSeverity.Information,command:void 0,text:"",detail:""};let v,s=new A.DisposableStore;const d=()=>{v?.dispose(),v=(0,t.disposableTimeout)(()=>{s.clear(),this._proxy.$setLanguageStatus(m,{id:g,name:S.name??F.displayName??F.name,source:F.displayName??F.name,selector:M.DocumentSelector.from(S.selector,this._uriTransformer),label:S.text,detail:S.detail??"",severity:S.severity===E.LanguageStatusSeverity.Error?T.default.Error:S.severity===E.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:S.command&&this._commands.toInternal(S.command,s),accessibilityInfo:S.accessibilityInformation})},0)},C={dispose(){s.dispose(),v?.dispose(),a.$removeLanguageStatus(m),h.delete(g)},get id(){return S.id},get name(){return S.name},set name(r){S.name=r,d()},get selector(){return S.selector},set selector(r){S.selector=r,d()},get text(){return S.text},set text(r){S.text=r,d()},get detail(){return S.detail},set detail(r){S.detail=r,d()},get severity(){return S.severity},set severity(r){S.severity=r,d()},get accessibilityInformation(){return S.accessibilityInformation},set accessibilityInformation(r){S.accessibilityInformation=r,d()},get command(){return S.command},set command(r){S.command=r,d()}};return d(),C}}e.ExtHostLanguages=D}),define(be[200],Ee([0,1,12,5,27,14,3]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends l.AbstractLoggerService{constructor(F,_){const n=new t.Emitter;super(_.logLevel,n.event);this._proxy=F.getProxy(M.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(n)}$setLevel(F){this._onDidChangeLogLevel.fire(F)}doCreateLogger(F,_,n){return new D(this._proxy,F,_,n)}};A=Ue([Be(0,T.IExtHostRpcService),Be(1,E.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class D extends l.AbstractMessageLogger{constructor(F,_,n,m){super(m?.always);this.proxy=F,this.file=_,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(n),this.proxy.$createLogger(_,m).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(F,_){const n=[[F,_]];this.isLoggerCreated?this.doLog(n):this.buffer.push(...n)}doLog(F){this.proxy.$log(this.file,F)}}}),define(be[201],Ee([0,1,5,12,28]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(A){return A&&A.title}let t=class{constructor(D,I){this._logService=I,this._proxy=D.getProxy(l.MainContext.MainThreadMessageService)}showMessage(D,I,F,_,n){const m={extension:D};let a;typeof _=="string"||T(_)?a=[_,...n]:(m.modal=_?.modal,m.useCustom=_?.useCustom,m.detail=_?.detail,a=n),m.useCustom&&(0,E.checkProposedApiEnabled)(D,"resolvers");const h=[];for(let g=0;g<a.length;g++){const S=a[g];if(typeof S=="string")h.push({title:S,handle:g,isCloseAffordance:!1});else if(typeof S=="object"){let{title:v,isCloseAffordance:s}=S;h.push({title:v,isCloseAffordance:!!s,handle:g})}else this._logService.warn("Invalid message item:",S)}return this._proxy.$showMessage(I,F,m,h).then(g=>{if(typeof g=="number")return a[g]})}};t=Ue([Be(1,M.ILogService)],t),e.ExtHostMessageService=t}),define(be[202],Ee([0,1,22,3,60,6,20,9,10,2,65,5,8,7,39,175,93]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class S{constructor(s,d,C,r,b){this._textDocumentsAndEditors=C,this._textDocuments=r,this._extensionStoragePaths=b,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new t.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new M.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new M.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new M.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new M.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new M.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new M.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new M.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new F.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=d.converter,d.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const i=o.notebookEditor?.notebookUri,p=o.cell.handle,u=this._documents.get(i)?.getCell(p);if(u)return u.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){const d=this._editors.get(s);if(!d)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);return d}getIdByEditor(s){for(const[d,C]of this._editors)if(C.apiEditor===s)return d}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(s,d){const C=this._documents.get(s);if(!C&&!d)throw new Error(`NO notebook document for '${s}'`);return C}_getProviderData(s){const d=this._notebookContentProviders.get(s);if(!d)throw new Error(`NO provider for '${s}'`);return d}registerNotebookContentProvider(s,d,C,r,b){if((0,A.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(d))throw new Error(`Notebook provider for '${d}' already registered`);this._notebookContentProviders.set(d,{extension:s,provider:C});let o;return C.onDidChangeNotebookContentOptions&&(o=C.onDidChangeNotebookContentOptions(()=>{const i=n.NotebookDocumentContentOptions.from(C.options);this._notebookProxy.$updateNotebookProviderOptions(d,i)})),this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation},d,n.NotebookDocumentContentOptions.from(r),S._convertNotebookRegistrationData(s,b)),new m.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(d),this._notebookProxy.$unregisterNotebookProvider(d)})}static _convertNotebookRegistrationData(s,d){if(!d)return;const C=d.filenamePattern.map(r=>n.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(d.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:d.displayName,filenamePattern:C,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,d,C){const r=S._notebookStatusBarItemProviderHandlePool++,b=typeof C.onDidChangeCellStatusBarItems=="function"?S._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,C),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,b,d);let o;return b!==void 0&&(o=C.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(b))),new m.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,b),o&&o.dispose()})}async createNotebookDocument(s){const d=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:s.viewType,content:s.content&&n.NotebookData.from(s.content)});return I.URI.revive(d)}async openNotebookDocument(s){const d=this._documents.get(s);if(d)return d.apiNotebook;const C=await this._notebookDocumentsProxy.$tryOpenNotebook(s),r=this._documents.get(I.URI.revive(C));return(0,D.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(s,d){I.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let C;typeof d=="object"?C={position:n.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(n.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:C={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.notebookType,C),b=r&&this._editors.get(r)?.apiEditor;if(b)return b;throw r?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,d,C,r){const b=this._notebookStatusBarItemProviders.get(s),o=I.URI.revive(d),i=this._documents.get(o);if(!i||!b)return;const p=i.getCellFromIndex(C);if(!p)return;const c=await b.provideCellStatusBarItems(p.apiCell,r);if(!c)return;const u=new T.DisposableStore,w=this._statusBarCache.add([u]),y=(Array.isArray(c)?c:[c]).map(R=>n.NotebookStatusBarItem.from(R,this._commandsConverter,u));return{cacheId:w,items:y}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,d,C,r,b){if((0,A.isFalsyOrWhitespace)(d))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,C),this._notebookProxy.$registerNotebookSerializer(o,{id:s.identifier,location:s.extensionLocation},d,n.NotebookDocumentContentOptions.from(r),S._convertNotebookRegistrationData(s,b)),(0,T.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(s,d,C){const r=this._notebookSerializer.get(s);if(!r)throw new Error("NO serializer found");const b=await r.deserializeNotebook(d.buffer,C);return new a.SerializableObjectWithBuffers(n.NotebookData.from(b))}async $notebookToData(s,d,C){const r=this._notebookSerializer.get(s);if(!r)throw new Error("NO serializer found");const b=await r.serializeNotebook(n.NotebookData.to(d.value),C);return l.VSBuffer.wrap(b)}async $openNotebook(s,d,C,r,b){const{provider:o}=this._getProviderData(s),i=await o.openNotebook(I.URI.revive(d),{backupId:C,untitledDocumentData:r?.buffer},b);return new a.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(n.NotebookCellData.from)})}async $saveNotebook(s,d,C){const r=this.getNotebookDocument(I.URI.revive(d)),{provider:b}=this._getProviderData(s);return await b.saveNotebook(r.apiNotebook,C),!0}async $saveNotebookAs(s,d,C,r){const b=this.getNotebookDocument(I.URI.revive(d)),{provider:o}=this._getProviderData(s);return await o.saveNotebookAs(I.URI.revive(C),b.apiNotebook,r),!0}async $backupNotebook(s,d,C){const r=this.getNotebookDocument(I.URI.revive(d)),b=this._getProviderData(s),o=this._extensionStoragePaths.workspaceValue(b.extension)??this._extensionStoragePaths.globalValue(b.extension),i=String((0,E.hash)([r.uri.toString(),this._backupIdPool++])),p=I.URI.joinPath(o,i),c=await b.provider.backupNotebook(r.apiNotebook,{destination:p},C);return r.updateBackup(c),c.id}_createExtHostEditor(s,d,C){if(this._editors.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const r=new g.ExtHostNotebookEditor(d,this._notebookEditorsProxy,s,C.visibleRanges.map(n.NotebookRange.to),C.selections.map(n.NotebookRange.to),typeof C.viewColumn=="number"?n.ViewColumn.to(C.viewColumn):void 0);this._editors.set(d,r)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const C of s.value.removedDocuments){const r=I.URI.revive(C),b=this._documents.get(r);b&&(b.dispose(),this._documents.delete(r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===r.toString()&&this._editors.delete(o.id)}if(s.value.addedDocuments){const C=[];for(const r of s.value.addedDocuments){const b=I.URI.revive(r.uri);if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const o=this,i=new h.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(p){o._onDidChangeNotebookCells.fire(p)},emitCellOutputsChange(p){o._onDidChangeCellOutputs.fire(p)},emitCellMetadataChange(p){o._onDidChangeCellMetadata.fire(p)},emitCellExecutionStateChange(p){o._onDidChangeCellExecutionState.fire(p)}},b,r);C.push(...r.cells.map(p=>h.ExtHostCell.asModelAddData(i.apiNotebook,p))),this._documents.get(b)?.dispose(),this._documents.set(b,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(s.value.addedEditors)for(const C of s.value.addedEditors){if(this._editors.has(C.id))return;const r=I.URI.revive(C.documentUri),b=this._documents.get(r);b&&this._createExtHostEditor(b,C.id,C)}const d=[];if(s.value.removedEditors)for(const C of s.value.removedEditors){const r=this._editors.get(C);r&&(this._editors.delete(C),this._activeNotebookEditor?.id===r.id&&(this._activeNotebookEditor=void 0),d.push(r))}if(s.value.visibleEditors){this._visibleNotebookEditors=s.value.visibleEditors.map(r=>this._editors.get(r)).filter(r=>!!r);const C=new Set;this._visibleNotebookEditors.forEach(r=>C.add(r.id));for(const r of this._editors.values()){const b=C.has(r.id);r._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(r=>r).filter(r=>r.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this._activeNotebookEditor=void 0:s.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=S,S._notebookStatusBarItemProviderHandlePool=0}),define(be[203],Ee([0,1,3,56,12,5,14,8]),function(re,e,l,M,E,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(_,n){const m=D._Keys.nextId();_.$registerNotebookEditorDecorationType(m,A.NotebookDecorationRenderOptions.from(n)),this.value={key:m,dispose(){_.$removeNotebookEditorDecorationType(m)}}}}D._Keys=new M.IdGenerator("NotebookEditorDecorationType");let I=class{constructor(_,n,m){this._logService=_,this._extHostRpc=n,this._notebooksAndEditors=m,this._onDidChangeNotebookEditorSelection=new l.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new l.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new D(this._extHostRpc.getProxy(T.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,n){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,n);const m=this._notebooksAndEditors.getEditorById(_);n.visibleRanges&&m._acceptVisibleRanges(n.visibleRanges.ranges.map(A.NotebookRange.to)),n.selections&&m._acceptSelections(n.selections.selections.map(A.NotebookRange.to)),n.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:m.apiEditor,visibleRanges:m.apiEditor.visibleRanges}),n.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:m.apiEditor,selections:m.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const n in _)this._notebooksAndEditors.getEditorById(n)._acceptViewColumn(A.ViewColumn.to(_[n]))}};I=Ue([Be(0,E.ILogService),Be(1,t.IExtHostRpcService)],I),e.ExtHostNotebookEditors=I}),define(be[204],Ee([0,1,15,13,21,3,6,20,2,26,12,5,40,8,7,68,167,28,39]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let s=class{constructor(o,i,p,c,u){this._initData=i,this._extHostNotebook=p,this._commands=c,this._logService=u,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=o.getProxy(_.MainContext.MainThreadNotebookKernels);const w=new n.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new n.ApiCommandArgument("options","Select kernel options",f=>!0,f=>{if(f&&"notebookEditor"in f&&"id"in f){const y=this._extHostNotebook.getIdByEditor(f.notebookEditor);return{id:f.id,extension:f.extension,notebookEditorId:y}}else if(f&&"notebookEditor"in f){const y=this._extHostNotebook.getIdByEditor(f.notebookEditor);if(y===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${f.notebookEditor.document.uri.toString()}`);return{notebookEditorId:y}}return f})],n.ApiCommandResult.Void);this._commands.registerApiCommand(w)}createNotebookController(o,i,p,c,u,w){for(let Q of this._kernelData.values())if(Q.controller.id===i&&I.ExtensionIdentifier.equals(o.identifier,Q.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const f=this._handlePool++,y=this;this._logService.trace(`NotebookController[${f}], CREATED by ${o.identifier.value}, ${i}`);const R=()=>console.warn(`NO execute handler from notebook controller '${x.id}' of extension: '${o.identifier}'`);let P=!1;const B=new t.DisposableStore,L=new T.Emitter,k=new T.Emitter,x={id:`${o.identifier.value}/${i}`,notebookType:p,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:c||o.identifier.value,preloads:w?w.map(m.NotebookRendererScript.from):[]};let N=u??R,V;this._proxy.$addKernel(f,x).catch(Q=>{console.log(Q),P=!0});let W=0;const $=()=>{if(P)return;const Q=++W;Promise.resolve().then(()=>{Q===W&&this._proxy.$updateKernel(f,x)})},X=new A.ResourceMap,j={get id(){return i},get notebookType(){return x.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return x.label},set label(Q){x.label=Q??o.displayName??o.name,$()},get detail(){return x.detail??""},set detail(Q){x.detail=Q,$()},get description(){return x.description??""},set description(Q){x.description=Q,$()},get kind(){return(0,S.checkProposedApiEnabled)(o,"notebookControllerKind"),x.kind??""},set kind(Q){(0,S.checkProposedApiEnabled)(o,"notebookControllerKind"),x.kind=Q,$()},get supportedLanguages(){return x.supportedLanguages},set supportedLanguages(Q){x.supportedLanguages=Q,$()},get supportsExecutionOrder(){return x.supportsExecutionOrder??!1},set supportsExecutionOrder(Q){x.supportsExecutionOrder=Q,$()},get rendererScripts(){return x.preloads?x.preloads.map(m.NotebookRendererScript.to):[]},get executeHandler(){return N},set executeHandler(Q){N=Q??R},get interruptHandler(){return V},set interruptHandler(Q){V=Q,x.supportsInterrupt=Boolean(Q),$()},createNotebookCellExecution(Q){if(P)throw new Error("notebook controller is DISPOSED");if(!X.has(Q.notebook.uri))throw y._logService.trace(`NotebookController[${f}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(X.keys()).map(le=>le.toString())),new Error(`notebook controller is NOT associated to notebook: ${Q.notebook.uri.toString()}`);return y._createNotebookCellExecution(Q)},dispose:()=>{P||(this._logService.trace(`NotebookController[${f}], DISPOSED`),P=!0,this._kernelData.delete(f),B.dispose(),L.dispose(),k.dispose(),this._proxy.$removeKernel(f))},updateNotebookAffinity(Q,le){y._proxy.$updateNotebookPriority(f,Q.uri,le)},onDidReceiveMessage:k.event,postMessage(Q,le){return(0,S.checkProposedApiEnabled)(o,"notebookMessaging"),y._proxy.$postMessage(f,le&&y._extHostNotebook.getIdByEditor(le),Q)},asWebviewUri(Q){return(0,S.checkProposedApiEnabled)(o,"notebookMessaging"),(0,h.asWebviewUri)(Q,y._initData.remote)}};return this._kernelData.set(f,{extensionId:o.identifier,controller:j,onDidReceiveMessage:k,onDidChangeSelection:L,associatedNotebooks:X}),j}$acceptNotebookAssociation(o,i,p){const c=this._kernelData.get(o);if(c){const u=this._extHostNotebook.getNotebookDocument(D.URI.revive(i));p?c.associatedNotebooks.set(u.uri,!0):c.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${o}] ASSOCIATE notebook`,u.uri.toString(),p),c.onDidChangeSelection.fire({selected:p,notebook:u.apiNotebook})}}async $executeCells(o,i,p){const c=this._kernelData.get(o);if(!c)return;const u=this._extHostNotebook.getNotebookDocument(D.URI.revive(i)),w=[];for(let f of p){const y=u.getCell(f);y&&w.push(y.apiCell)}try{this._logService.trace(`NotebookController[${o}] EXECUTE cells`,u.uri.toString(),w.length),await c.controller.executeHandler.call(c.controller,w,u.apiNotebook,c.controller)}catch(f){this._logService.error(`NotebookController[${o}] execute cells FAILED`,f),console.error(f)}}async $cancelCells(o,i,p){const c=this._kernelData.get(o);if(!c)return;const u=this._extHostNotebook.getNotebookDocument(D.URI.revive(i));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,u.apiNotebook);else for(let w of p){const f=u.getCell(w);f&&this._activeExecutions.get(f.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,i,p){const c=this._kernelData.get(o);if(!c)return;const u=this._extHostNotebook.getEditorById(i);c.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:p}))}_createNotebookCellExecution(o){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!p)throw new Error("invalid cell");if(this._activeExecutions.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const c=new C(p.notebook,p,this._proxy);this._activeExecutions.set(p.uri,c);const u=c.onDidChangeState(()=>{c.state===d.Resolved&&(c.dispose(),u.dispose(),this._activeExecutions.delete(p.uri))});return c.asApiObject()}};s=Ue([Be(4,F.ILogService)],s),e.ExtHostNotebookKernels=s;var d;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(d||(d={}));class C extends t.Disposable{constructor(o,i,p){super();this._document=o,this._cell=i,this._proxy=p,this._handle=C.HANDLE++,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=d.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new r(10,c=>this.update(c)),this._executionOrder=i.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(o){await this._collector.addItem(o)}async update(o){const i=Array.isArray(o)?o:[o];return this._proxy.$updateExecutions(new v.SerializableObjectWithBuffers(i))}verifyStateForOutput(){if(this._state===d.Init)throw new Error("Must call start before modifying cell output");if(this._state===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(o){let i=this._cell;if(o&&(i=this._document.getCellFromApiCell(o)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(o){return o.map(i=>{const p=a.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return p===i.items?m.NotebookCellOutput.from(i):m.NotebookCellOutput.from({items:p,id:i.id,metadata:i.metadata})})}async updateOutputs(o,i,p){const c=this.cellIndexToHandle(i),u=this.validateAndConvertOutputs((0,l.asArray)(o));return this.updateSoon({editType:g.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:c,append:p,outputs:u})}async updateOutputItems(o,i,p){return o=a.NotebookCellOutput.ensureUniqueMimeTypes((0,l.asArray)(o),!0),this.updateSoon({editType:g.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:o.map(m.NotebookCellOutputItem.from),outputId:i.id,append:p})}asApiObject(){const o=this;return Object.freeze({get token(){return o._tokenSource.token},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(p){o._executionOrder=p,o.update([{editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:o._handle,executionOrder:o._executionOrder}])},start(p){if(o._state===d.Resolved||o._state===d.Started)throw new Error("Cannot call start again");o._state=d.Started,o._onDidChangeState.fire(),o.update({editType:g.CellExecutionUpdateType.ExecutionState,executionHandle:o._handle,runStartTime:p})},end(p,c){if(o._state===d.Resolved)throw new Error("Cannot call resolve twice");o._state=d.Resolved,o._onDidChangeState.fire(),o.updateSoon({editType:g.CellExecutionUpdateType.Complete,executionHandle:o._handle,runEndTime:c,lastRunSuccess:p}),o._collector.flush(),o._proxy.$removeExecution(o._handle)},clearOutput(p){return o.verifyStateForOutput(),o.updateOutputs([],p,!1)},appendOutput(p,c){return o.verifyStateForOutput(),o.updateOutputs(p,c,!0)},replaceOutput(p,c){return o.verifyStateForOutput(),o.updateOutputs(p,c,!1)},appendOutputItems(p,c){return o.verifyStateForOutput(),o.updateOutputItems(p,c,!0)},replaceOutputItems(p,c){return o.verifyStateForOutput(),o.updateOutputItems(p,c,!1)}})}}C.HANDLE=0;class r{constructor(o,i){this.delay=o,this.callback=i,this.batch=[],this.startedTimer=Date.now()}addItem(o){return this.batch.push(o),this.currentDeferred||(this.currentDeferred=new M.DeferredPromise,this.startedTimer=Date.now(),(0,M.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const o=this.currentDeferred;this.currentDeferred=void 0;const i=this.batch;return this.batch=[],this.callback(i).finally(()=>o.complete())}}}),define(be[205],Ee([0,1,3,5,93,28]),function(re,e,l,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class t{constructor(D,I){this._extHostNotebook=I,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(M.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,I,F){const _=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(I)?.fire({editor:_.apiEditor,message:F})}createRendererMessaging(D,I){if(!D.contributes?.notebookRenderer?.some(m=>m.id===I))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${I})`);const F=(0,T.isProposedApiEnabled)(D,"notebookEditor"),_=new WeakMap;return{onDidReceiveMessage:(m,a,h)=>{const g=F?m:S=>{const v={};_.set(v,S.editor),m({editor:v,message:S.message})};return this.getOrCreateEmitterFor(I).event(g,a,h)},postMessage:(m,a)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(m)&&([m,a]=[a,m]);const h=F?a:_.get(a),g=h&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(h);return this.proxy.$postMessage(g?.id,I,m)}}}getOrCreateEmitterFor(D){let I=this._rendererMessageEmitters.get(D);return I||(I=new l.Emitter({onLastListenerRemove:()=>{I?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,I),I)}}e.ExtHostNotebookRenderers=t}),define(be[96],Ee([0,1,5,6,4,14,12,168,52,27,31,115,22]),function(re,e,l,M,E,T,t,A,D,I,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class m extends M.Disposable{constructor(g,S,v,s){super();this.id=g,this.name=S,this.logger=v,this.proxy=s,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(g){this.append(g+`
`)}append(g){this.write(g),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const g=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,g)}replace(g){const S=this.offset;this.write(g),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,S),this.visible&&this.logger.flush()}show(g,S){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof g=="boolean"?g:S))}hide(){this.proxy.$close(this.id)}write(g){this.offset+=n.VSBuffer.fromString(g).byteLength,this.logger.info(g)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=m;let a=class{constructor(g,S,v,s,d){this.extHostFileSystem=v,this.extHostFileSystemInfo=s,this.loggerService=d,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=g.getProxy(l.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(S.logsLocation,`output_logging_${(0,_.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.visibleChannelId=g;for(const[S,v]of this.channels)v.visible=S===this.visibleChannelId}createOutputChannel(g,S){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const v=this.doCreateOutputChannel(g,S);return v.then(s=>{this.channels.set(s.id,s),s.visible=s.id===this.visibleChannelId}),this.createExtHostOutputChannel(g,v)}async doCreateOutputChannel(g,S){const v=await this.createOutputDirectory(),s=this.extHostFileSystemInfo.extUri.joinPath(v,`${this.namePool++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.loggerService.createLogger(s,{always:!0,donotRotate:!0,donotUseFormatters:!0}),C=await this.proxy.$register(g,!1,s,S.identifier.value);return new m(C,g,d,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(g,S){let v=!1;const s=()=>{if(v)throw new Error("Channel has been closed")};return{get name(){return g},append(d){s(),S.then(C=>C.append(d))},appendLine(d){s(),S.then(C=>C.appendLine(d))},clear(){s(),S.then(d=>d.clear())},replace(d){s(),S.then(C=>C.replace(d))},show(d,C){s(),S.then(r=>r.show(d,C))},hide(){s(),S.then(d=>d.hide())},dispose(){v=!0,S.then(d=>d.dispose())}}}};a=Ue([Be(0,T.IExtHostRpcService),Be(1,I.IExtHostInitDataService),Be(2,D.IExtHostConsumerFileSystem),Be(3,F.IExtHostFileSystemInfo),Be(4,t.ILoggerService)],a),e.ExtHostOutputService=a,e.IExtHostOutputService=(0,E.createDecorator)("IExtHostOutputService")}),define(be[206],Ee([0,1,13,21,3,6,5,2,7,16,15,36,48]),function(re,e,l,M,E,T,t,A,D,I,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(a,h,g){const S=a.getProxy(t.MainContext.MainThreadQuickOpen);class v{constructor(c,u){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=u}showQuickPick(c,u,w,f=M.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(c),R=++this._instances,P=S.$show(R,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},f),B={},L=P.then(()=>B);return Promise.race([L,y]).then(k=>{if(k!==B)return y.then(x=>{const N=[];for(let V=0;V<x.length;V++){const W=x[V];let $,X,j,Q,le;typeof W=="string"?$=W:($=W.label,X=W.description,j=W.detail,Q=W.picked,le=W.alwaysShow),N.push({label:$,description:X,handle:V,detail:j,picked:Q,alwaysShow:le})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=V=>{w.onDidSelectItem(x[V])}),S.$setItems(R,N),P.then(V=>{if(typeof V=="number")return x[V];if(Array.isArray(V))return V.map(W=>x[W])})})}).then(void 0,k=>{if(!(0,I.isPromiseCanceledError)(k))return S.$setError(R,k),Promise.reject(k)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,u=M.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,S.$input(c,typeof this._validateInput=="function",u).then(void 0,w=>{if(!(0,I.isPromiseCanceledError)(w))return Promise.reject(w)})}$validateInput(c){return this._validateInput?(0,l.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,u=M.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!w)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(y=>y.uri.toString()===w.uri.toString())}createQuickPick(c,u){const w=new o(c,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(c){const u=new i(c,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(c,u){const w=this._sessions.get(c);w&&w._fireDidChangeValue(u)}$onDidAccept(c){const u=this._sessions.get(c);u&&u._fireDidAccept()}$onDidChangeActive(c,u){const w=this._sessions.get(c);w instanceof o&&w._fireDidChangeActive(u)}$onDidChangeSelection(c,u){const w=this._sessions.get(c);w instanceof o&&w._fireDidChangeSelection(u)}$onDidTriggerButton(c,u){const w=this._sessions.get(c);w&&w._fireDidTriggerButton(u)}$onDidTriggerItemButton(c,u,w){const f=this._sessions.get(c);f instanceof o&&f._fireDidTriggerItemButton(u,w)}$onDidHide(c){const u=this._sessions.get(c);u&&u._fireDidHide()}}class s{constructor(c,u){this._extensionId=c,this._onDidDispose=u,this._id=o._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((u,w)=>{const f=u===D.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(f,u)}),this.update({buttons:c.map((u,w)=>({...b(u),tooltip:u.tooltip,handle:u===D.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const u=this._handlesToButtons.get(c);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(c){if(!this._disposed){for(const u of Object.keys(c)){const w=c[u];this._pendingUpdate[u]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}s._nextId=1;function d(p){if(p instanceof D.ThemeIcon)return{id:p.id};const c=r(p),u=C(p);return{dark:typeof c=="string"?A.URI.file(c):c,light:typeof u=="string"?A.URI.file(u):u}}function C(p){return typeof p=="object"&&"light"in p?p.light:p}function r(p){return typeof p=="object"&&"dark"in p?p.dark:p}function b(p){const c=d(p.iconPath);let u,w;return"id"in c?w=n.ThemeIcon.asClassName(c):u=c,{iconPath:u,iconClass:w}}class o extends s{constructor(c,u){super(c,u);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((u,w)=>{this._handlesToItems.set(w,u),this._itemsToHandles.set(u,w)}),this.update({items:c.map((u,w)=>({label:u.label,description:u.description,handle:w,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow,buttons:u.buttons?.map((f,y)=>({...b(f),tooltip:f.tooltip,handle:y}))}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(c){const u=(0,F.coalesce)(c.map(w=>this._handlesToItems.get(w)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(c){const u=(0,F.coalesce)(c.map(w=>this._handlesToItems.get(w)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}_fireDidTriggerItemButton(c,u){const w=this._handlesToItems.get(c);if(!w||!w.buttons||!w.buttons.length)return;const f=w.buttons[u];f&&this._onDidTriggerItemButtonEmitter.fire({button:f,item:w})}}class i extends s{constructor(c,u){super(c,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?_.default.Error:_.default.Ignore})}}return new v(h,g)}e.createExtHostQuickOpen=m}),define(be[207],Ee([0,1,2,3,55,6,13,5,15,107,12,26,48,8,28]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(c){if(c)return typeof c.iconPath=="string"?l.URI.file(c.iconPath):l.URI.isUri(c.iconPath)||n.ThemeIcon.isThemeIcon(c.iconPath)?c.iconPath:void 0}function g(c,u){if(!c.iconPath&&!u.iconPath)return 0;if(c.iconPath){if(!u.iconPath)return 1}else return-1;const w=typeof c.iconPath=="string"?c.iconPath:l.URI.isUri(c.iconPath)?c.iconPath.fsPath:c.iconPath.id,f=typeof u.iconPath=="string"?u.iconPath:l.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id;return(0,I.comparePaths)(w,f)}function S(c,u){let w=0;if(c.strikeThrough!==u.strikeThrough)return c.strikeThrough?1:-1;if(c.faded!==u.faded)return c.faded?1:-1;if(c.tooltip!==u.tooltip)return(c.tooltip||"").localeCompare(u.tooltip||"");if(w=g(c,u),w!==0)return w;if(c.light&&u.light)w=g(c.light,u.light);else{if(c.light)return 1;if(u.light)return-1}if(w!==0)return w;if(c.dark&&u.dark)w=g(c.dark,u.dark);else{if(c.dark)return 1;if(u.dark)return-1}return w}function v(c,u){if(c.command!==u.command)return c.command<u.command?-1:1;if(c.title!==u.title)return c.title<u.title?-1:1;if(c.tooltip!==u.tooltip){if(c.tooltip!==void 0&&u.tooltip!==void 0)return c.tooltip<u.tooltip?-1:1;if(c.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(c.arguments===u.arguments)return 0;if(c.arguments)if(u.arguments){if(c.arguments.length!==u.arguments.length)return c.arguments.length-u.arguments.length}else return 1;else return-1;for(let w=0;w<c.arguments.length;w++){const f=c.arguments[w],y=u.arguments[w];if(f!==y)return f<y?-1:1}return 0}function s(c,u){let w=(0,I.comparePaths)(c.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(w!==0)return w;if(c.command&&u.command)w=v(c.command,u.command);else{if(c.command)return 1;if(u.command)return-1}if(w!==0)return w;if(c.decorations&&u.decorations)w=S(c.decorations,u.decorations);else{if(c.decorations)return 1;if(u.decorations)return-1}return w}function d(c,u){for(let w=0;w<c.length;w++)if(c[w]!==u[w])return!1;return!0}function C(c,u){return c.command===u.command&&c.title===u.title&&c.tooltip===u.tooltip&&(c.arguments&&u.arguments?d(c.arguments,u.arguments):c.arguments===u.arguments)}function r(c,u){return(0,D.equals)(c,u,C)}class b{constructor(u,w,f){this._extension=u,this._proxy=w,this._sourceControlHandle=f,this._value="",this._onDidChange=new M.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(u){if((0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}showValidationMessage(u,w){(0,a.checkProposedApiEnabled)(this._extension,"scmValidation"),this._proxy.$showValidationMessage(this._sourceControlHandle,u,w)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=b;class o{constructor(u,w,f,y,R){this._proxy=u,this._commands=w,this._sourceControlHandle=f,this._id=y,this._label=R,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new M.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new M.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=o._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,w){const f=this._resourceStatesCommandsMap.get(u);return f?(0,t.asPromise)(()=>this._commands.executeCommand(f.command,...f.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const u=[...this._resourceStates].sort(s),f=(0,D.sortedDiff)(this._resourceSnapshot,u,s).map(P=>{const B=P.toInsert.map(L=>{const k=this._resourceHandlePool++;this._resourceStatesMap.set(k,L);const x=L.resourceUri;let N;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const Fe=new T.DisposableStore;N=this._commands.converter.toInternal(L.command,Fe),this._resourceStatesDisposablesMap.set(k,Fe)}else this._resourceStatesCommandsMap.set(k,L.command);const V=h(L.decorations),W=L.decorations&&h(L.decorations.light)||V,$=L.decorations&&h(L.decorations.dark)||V,X=[W,$],j=L.decorations&&L.decorations.tooltip||"",Q=L.decorations&&!!L.decorations.strikeThrough,le=L.decorations&&!!L.decorations.faded,ve=L.contextValue||"";return{rawResource:[k,x,X,j,Q,le,ve,N],handle:k}});return{start:P.start,deleteCount:P.deleteCount,toInsert:B}}),y=f.map(({start:P,deleteCount:B,toInsert:L})=>[P,B,L.map(k=>k.rawResource)]),R=f.reverse();for(const{start:P,deleteCount:B,toInsert:L}of R){const k=L.map(N=>N.handle),x=this._handlesSnapshot.splice(P,B,...k);for(const N of x)this._resourceStatesMap.delete(N),this._resourceStatesCommandsMap.delete(N),this._resourceStatesDisposablesMap.get(N)?.dispose(),this._resourceStatesDisposablesMap.delete(N)}return this._resourceSnapshot=u,y}dispose(){this._disposed=!0,this._onDidDispose.fire()}}o._handlePool=0;class i{constructor(u,w,f,y,R,P){this._extension=u,this._proxy=w,this._commands=f,this._id=y,this._label=R,this._rootUri=P,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new T.MutableDisposable,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new M.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new b(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,y,R,P)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=u;const w=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get actionButton(){return(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(u){(0,a.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new T.DisposableStore,this._actionButton=u;const w=u!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;this._proxy.$updateSourceControl(this.handle,{actionButton:w??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&r(this._statusBarCommands,u))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=u;const w=(u||[]).map(f=>this._commands.converter.toInternal(f,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(u,w){const f=new o(this._proxy,this._commands,this.handle,u,w),y=M.Event.once(f.onDidDispose)(()=>this.createdResourceGroups.delete(f));return this.createdResourceGroups.set(f,y),this.eventuallyAddResourceGroups(),f}eventuallyAddResourceGroups(){const u=[],w=[];for(const[f,y]of this.createdResourceGroups){y.dispose();const R=f.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(f),this.eventuallyUpdateResourceStates()});M.Event.once(f.onDidDispose)(()=>{this.updatedResourceGroups.delete(f),R.dispose(),this._groups.delete(f.handle),this._proxy.$unregisterGroup(this.handle,f.handle)}),u.push([f.handle,f.id,f.label,f.features]);const P=f._takeResourceStateSnapshot();P.length>0&&w.push([f.handle,P]),this._groups.set(f.handle,f)}this._proxy.$registerGroups(this.handle,u,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(w=>{const f=w._takeResourceStateSnapshot();f.length!==0&&u.push([w.handle,f])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,Ue([(0,E.debounce)(100)],i.prototype,"eventuallyAddResourceGroups",null),Ue([(0,E.debounce)(100)],i.prototype,"eventuallyUpdateResourceStates",null);let p=class Bi{constructor(u,w,f){this._commands=w,this.logService=f,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new M.Emitter,this._proxy=u.getProxy(A.MainContext.MainThreadSCM),this._telemetry=u.getProxy(A.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===3){const R=this._sourceControls.get(y.sourceControlHandle);if(!R)return y;const P=R.getResourceGroup(y.groupHandle);return P?P.getResourceState(y.handle):y}else if(y&&y.$mid===4){const R=this._sourceControls.get(y.sourceControlHandle);return R?R.getResourceGroup(y.groupHandle):y}else if(y&&y.$mid===5){const R=this._sourceControls.get(y.handle);return R||y}return y}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,w,f,y){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,w,f,y),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const R=Bi._handlePool++,P=new i(u,this._proxy,this._commands,w,f,y);this._sourceControls.set(R,P);const B=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(u.identifier))||[];return B.push(P),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(u.identifier),B),P}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const w=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(u.identifier)),f=w&&w[w.length-1];return f&&f.inputBox}$provideOriginalResource(u,w,f){const y=l.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,y.toString());const R=this._sourceControls.get(u);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,t.asPromise)(()=>R.quickDiffProvider.provideOriginalResource(y,f)).then(P=>P||null)}$onInputBoxValueChange(u,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const f=this._sourceControls.get(u);return f&&f.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(u,w,f,y){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,w,f);const R=this._sourceControls.get(u);if(!R)return Promise.resolve(void 0);const P=R.getResourceGroup(w);return P?P.$executeResourceCommand(f,y):Promise.resolve(void 0)}$validateInput(u,w,f){this.logService.trace("ExtHostSCM#$validateInput",u);const y=this._sourceControls.get(u);return!y||!y.inputBox.validateInput?Promise.resolve(void 0):(0,t.asPromise)(()=>y.inputBox.validateInput(w,f)).then(R=>{if(!R)return Promise.resolve(void 0);const P=m.MarkdownString.fromStrict(R.message);return P?Promise.resolve([P,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(u){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&this._sourceControls.get(u)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};p._handlePool=0,p=Ue([Be(2,F.ILogService)],p),e.ExtHostSCM=p});var Xe=this&&this.__classPrivateFieldSet||function(re,e,l,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,l):E?E.value=l:e.set(re,l),l},Te=this&&this.__classPrivateFieldGet||function(re,e,l,M){if(l==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?M:l==="a"?M.call(re):M?M.value:e.get(re)};define(be[208],Ee([0,1,7,5,128,6,8,10]),function(re,e,l,M,E,T,t,A){"use strict";var D,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class F{constructor(a,h,g,S,v=l.StatusBarAlignment.Left,s){D.set(this,void 0),I.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,Xe(this,D,a,"f"),Xe(this,I,h,"f"),this._entryId=F.ID_GEN++,this._extension=g,this._id=S,this._alignment=v,this._priority=this.validatePriority(s)}validatePriority(a){if(!!(0,A.isNumber)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(a){this._text=a,this.update()}set name(a){this._name=a,this.update()}set tooltip(a){this._tooltip=a,this.update()}set color(a){this._color=a,this.update()}set backgroundColor(a){a&&!F.ALLOWED_BACKGROUND_COLORS.has(a.id)&&(a=void 0),this._backgroundColor=a,this.update()}set command(a){this._command?.fromApi!==a&&(this._internalCommandRegistration.clear(),typeof a=="string"?this._command={fromApi:a,internal:Te(this,I,"f").toInternal({title:"",command:a},this._internalCommandRegistration)}:a?this._command={fromApi:a,internal:Te(this,I,"f").toInternal(a,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(a){this._accessibilityInformation=a,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Te(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let a;this._extension?this._id?a=`${this._extension.identifier.value}.${this._id}`:a=this._extension.identifier.value:a=this._id;let h;this._name?h=this._name:h=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let g=this._color;this._backgroundColor&&(g=F.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const S=this._tooltip?t.MarkdownString.fromStrict(this._tooltip):void 0;Te(this,D,"f").$setEntry(this._entryId,a,h,this._text,S,this._command?.internal,g,this._backgroundColor,this._alignment===l.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=F,D=new WeakMap,I=new WeakMap,F.ID_GEN=0,F.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new l.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.ThemeColor("statusBarItem.warningForeground")]]);class _{constructor(a){this._messages=[],this._item=a.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(a){const h={message:a};return this._messages.unshift(h),this._update(),new l.Disposable(()=>{const g=this._messages.indexOf(h);g>=0&&(this._messages.splice(g,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class n{constructor(a,h){this._proxy=a.getProxy(M.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new _(this)}createStatusBarEntry(a,h,g,S){return new F(this._proxy,this._commands,a,h,g,S)}setStatusBarMessage(a,h){const g=this._statusMessage.setMessage(a);let S;return typeof h=="number"?S=setTimeout(()=>g.dispose(),h):typeof h!="undefined"&&h.then(()=>g.dispose(),()=>g.dispose()),new l.Disposable(()=>{g.dispose(),clearTimeout(S)})}}e.ExtHostStatusBar=n}),define(be[73],Ee([0,1,5,3,4]),function(re,e,l,M,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(A){this._onDidChangeStorage=new M.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(l.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,D){this._proxy.$registerExtensionStorageKeysToSync(A,D)}getValue(A,D,I){return this._proxy.$getValue(A,D).then(F=>F||I)}setValue(A,D,I){return this._proxy.$setValue(A,D,I)}$acceptValue(A,D,I){this._onDidChangeStorage.fire({shared:A,key:D,value:I})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(be[74],Ee([0,1,4,27,12,52,2]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,l.createDecorator)("IExtensionStoragePaths");let A=class{constructor(I,F,_){this._logService=F,this._extHostFileSystem=_,this._workspace=I.workspace??void 0,this._environment=I.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(n=>this._value=n)}async _getWorkspaceStorageURI(I){return t.URI.joinPath(this._environment.workspaceStorageHome,I)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const I=this._workspace.id,F=await this._getWorkspaceStorageURI(I);try{return await this._extHostFileSystem.value.stat(F),this._logService.trace("[ExtHostStorage] storage dir already exists",F),F}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",F),await this._extHostFileSystem.value.createDirectory(F),await this._extHostFileSystem.value.writeFile(t.URI.joinPath(F,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:t.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),F}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(I){if(this._value)return t.URI.joinPath(this._value,I.identifier.value)}globalValue(I){return t.URI.joinPath(this._environment.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=Ue([Be(0,M.IExtHostInitDataService),Be(1,E.ILogService),Be(2,T.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(be[41],Ee([0,1,3,5,4,2,14,6,7,129,16,170,21,37,151,48,10,13]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class v{constructor(c,u,w,f){this._proxy=c,this._id=u,this._creationOptions=w,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(R=>this._pidPromiseComplete=R);const y=this;this.value={get name(){return y._name||""},get processId(){return y._pidPromise},get creationOptions(){return y._creationOptions},get exitStatus(){return y._exitStatus},get state(){return y._state},sendText(R,P=!0){y._checkDisposed(),y._proxy.$sendText(y._id,R,P)},show(R){y._checkDisposed(),y._proxy.$show(y._id,R)},hide(){y._checkDisposed(),y._proxy.$hide(y._id)},dispose(){y._disposed||(y._disposed=!0,y._proxy.$dispose(y._id))},get dimensions(){if(!(y._cols===void 0||y._rows===void 0))return{columns:y._cols,rows:y._rows}}}}async create(c,u){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:c.name,shellPath:(0,g.withNullAsUndefined)(c.shellPath),shellArgs:(0,g.withNullAsUndefined)(c.shellArgs),cwd:(0,g.withNullAsUndefined)(c.cwd),env:(0,g.withNullAsUndefined)(c.env),icon:(0,g.withNullAsUndefined)(o(c.iconPath)),color:h.ThemeColor.isThemeColor(c.color)?c.color.id:void 0,initialText:(0,g.withNullAsUndefined)(c.message),strictEnv:(0,g.withNullAsUndefined)(c.strictEnv),hideFromUser:(0,g.withNullAsUndefined)(c.hideFromUser),isFeatureTerminal:(0,g.withNullAsUndefined)(u?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,g.withNullAsUndefined)(u?.useShellEnvironment),location:u?.location||this._serializeParentTerminal(c.location,u?.resolvedExtHostIdentifier)})}async createExtensionTerminal(c,u,w,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:w,color:h.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(c,u)}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(c,u){return typeof c=="object"?"parentTerminal"in c&&c.parentTerminal&&u?{parentTerminal:u}:"viewColumn"in c?{viewColumn:c.viewColumn,preserveFocus:c.preserveFocus}:void 0:c}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(c){this._name=c}setExitCode(c){this._exitStatus=Object.freeze({code:c})}setDimensions(c,u){return c===this._cols&&u===this._rows||c===0||u===0?!1:(this._cols=c,this._rows=u,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(c){this._pidPromiseComplete?(this._pidPromiseComplete(c),this._pidPromiseComplete=void 0):this._pidPromise.then(u=>{u!==c&&(this._pidPromise=Promise.resolve(c))})}}e.ExtHostTerminal=v;class s{constructor(c){this._pty=c,this.id=0,this.shouldPersist=!1,this._capabilities=[],this._onProcessData=new l.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new l.Emitter,this._onDidChangeProperty=new l.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new l.Emitter,this.onProcessExit=this._onProcessExit.event}get capabilities(){return this._capabilities}get onProcessReady(){return this._onProcessReady.event}refreshProperty(c){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${c}`)}updateProperty(c,u){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${c}, value: ${u}`)}async start(){}shutdown(){this._pty.close()}input(c){this._pty.handleInput&&this._pty.handleInput(c)}resize(c,u){this._pty.setDimensions&&this._pty.setDimensions({columns:c,rows:u})}async processBinary(c){}acknowledgeDataEvent(c){}async setUnicodeVersion(c){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(c){this._pty.onDidWrite(u=>this._onProcessData.fire(u)),this._pty.onDidClose&&this._pty.onDidClose((u=void 0)=>{this._onProcessExit.fire(u===void 0?void 0:u)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(u=>{u&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:u.columns,rows:u.rows}})}),this._pty.onDidChangeName&&this._pty.onDidChangeName(u=>{this._onDidChangeProperty.fire({type:"title",value:u})}),this._pty.open(c||void 0),this._pty.setDimensions&&c&&this._pty.setDimensions(c),this._onProcessReady.fire({pid:-1,cwd:"",capabilities:this._capabilities})}}e.ExtHostPseudoterminal=s;let d=1,C=class extends A.Disposable{constructor(c,u){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new l.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new l.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new l.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new l.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new l.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=u.getProxy(M.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new l.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(c),this._register({dispose:()=>{for(const[w,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(c=>c.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(c){return(c?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(c,u){const w=new v(this._proxy,(0,m.generateUuid)(),c,c.name),f=new s(c.pty);return w.createExtensionTerminal(c.location,this._serializeParentTerminal(c,u).resolvedExtHostIdentifier,o(c.iconPath),i(c.color)).then(y=>{const R=this._setupExtHostProcessListeners(y,f);this._terminalProcessDisposables[y]=R}),this._terminals.push(w),w.value}_serializeParentTerminal(c,u){if(u=u||{},c.location&&typeof c.location=="object"&&"parentTerminal"in c.location){const w=c.location.parentTerminal;if(w){const f=this._terminals.find(y=>y.value===w);f&&(u.resolvedExtHostIdentifier=f._id)}}else c.location&&typeof c.location!="object"?u.location=c.location:u.location&&typeof u.location=="object"&&"splitActiveTerminal"in u.location&&(u.location={splitActiveTerminal:!0});return u}attachPtyToTerminal(c,u){if(!this._getTerminalById(c))throw new Error(`Cannot resolve terminal with id ${c} for virtual process`);const f=new s(u),y=this._setupExtHostProcessListeners(c,f);this._terminalProcessDisposables[c]=y}async $acceptActiveTerminalChanged(c){const u=this._activeTerminal;if(c===null){this._activeTerminal=void 0,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const w=this._getTerminalById(c);w&&(this._activeTerminal=w,u!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(c,u){const w=this._getTerminalById(c);w&&this._onDidWriteTerminalData.fire({terminal:w.value,data:u})}async $acceptTerminalDimensions(c,u,w){const f=this._getTerminalById(c);f&&f.setDimensions(u,w)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(c,u,w){this._terminalProcesses.get(c)?.resize(u,w)}async $acceptTerminalTitleChange(c,u){const w=this._getTerminalById(c);w&&(w.name=u)}async $acceptTerminalClosed(c,u){const w=this._getTerminalObjectIndexById(this._terminals,c);if(w!==null){const f=this._terminals.splice(w,1)[0];f.setExitCode(u),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(c,u,w,f){if(u){const P=this._getTerminalObjectIndexById(this._terminals,u);if(P!==null){this._terminals[P]._id=c,this._onDidOpenTerminal.fire(this.terminals[P]),this._terminals[P].isOpen=!0;return}}const y={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:T.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},R=new v(this._proxy,c,y,w);this._terminals.push(R),this._onDidOpenTerminal.fire(R.value),R.isOpen=!0}async $acceptTerminalProcessId(c,u){const w=this._getTerminalById(c);w&&w._setProcessId(u)}async $startExtensionTerminal(c,u){const w=this._getTerminalById(c);if(!w)return{message:(0,I.localize)(0,null,c)};w.isOpen||await new Promise(y=>{const R=this.onDidOpenTerminal(async P=>{P===w.value&&(R.dispose(),y())})});const f=this._terminalProcesses.get(c);f?f.startSendingEvents(u):this._extensionTerminalAwaitingStart[c]={initialDimensions:u}}_setupExtHostProcessListeners(c,u){const w=new A.DisposableStore;w.add(u.onProcessReady(y=>this._proxy.$sendProcessReady(c,y.pid,y.cwd))),w.add(u.onDidChangeProperty(y=>this._proxy.$sendProcessProperty(c,y))),this._bufferer.startBuffering(c,u.onProcessData),w.add(u.onProcessExit(y=>this._onProcessExit(c,y))),this._terminalProcesses.set(c,u);const f=this._extensionTerminalAwaitingStart[c];return f&&u instanceof s&&(u.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[c]),w}$acceptProcessAckDataEvent(c,u){this._terminalProcesses.get(c)?.acknowledgeDataEvent(u)}$acceptProcessInput(c,u){this._terminalProcesses.get(c)?.input(u)}$acceptTerminalInteraction(c){const u=this._getTerminalById(c);u?.setInteractedWith()&&this._onDidChangeTerminalState.fire(u.value)}$acceptProcessResize(c,u,w){try{this._terminalProcesses.get(c)?.resize(u,w)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(c,u){this._terminalProcesses.get(c)?.shutdown(u)}$acceptProcessRequestInitialCwd(c){this._terminalProcesses.get(c)?.getInitialCwd().then(u=>this._proxy.$sendProcessProperty(c,{type:"initialCwd",value:u}))}$acceptProcessRequestCwd(c){this._terminalProcesses.get(c)?.getCwd().then(u=>this._proxy.$sendProcessProperty(c,{type:"cwd",value:u}))}$acceptProcessRequestLatency(c){return c}registerLinkProvider(c){return this._linkProviders.add(c),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(c),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(c,u,w){if(this._profileProviders.has(u))throw new Error(`Terminal profile provider "${u}" already registered`);return this._profileProviders.set(u,w),this._proxy.$registerProfileProvider(u,c.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(u),this._proxy.$unregisterProfileProvider(u)})}async $createContributedProfileTerminal(c,u){const w=new n.CancellationTokenSource().token;let f=await this._profileProviders.get(c)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${c}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,u);return}this.createTerminalFromOptions(f.options,u)}}async $provideLinks(c,u){const w=this._getTerminalById(c);if(!w)return[];this._terminalLinkCache.delete(c);const f=this._terminalLinkCancellationSource.get(c);f&&f.dispose(!0);const y=new n.CancellationTokenSource;this._terminalLinkCancellationSource.set(c,y);const R=[],P={terminal:w.value,line:u},B=[];for(const x of this._linkProviders)B.push(S.Promises.withAsyncBody(async N=>{y.token.onCancellationRequested(()=>N({provider:x,links:[]}));const V=await x.provideTerminalLinks(P,y.token)||[];y.token.isCancellationRequested||N({provider:x,links:V})}));const L=await Promise.all(B);if(y.token.isCancellationRequested)return[];const k=new Map;for(const x of L)x&&x.links.length>0&&R.push(...x.links.map(N=>{const V={id:d++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return k.set(V.id,{provider:x.provider,link:N}),V}));return this._terminalLinkCache.set(c,k),R}$activateLink(c,u){const w=this._terminalLinkCache.get(c)?.get(u);!w||w.provider.handleTerminalLink(w.link)}_onProcessExit(c,u){this._bufferer.stopBuffering(c),this._terminalProcesses.delete(c),delete this._extensionTerminalAwaitingStart[c];const w=this._terminalProcessDisposables[c];w&&(w.dispose(),delete this._terminalProcessDisposables[c]),this._proxy.$sendProcessExit(c,u)}_getTerminalById(c){return this._getTerminalObjectById(this._terminals,c)}_getTerminalObjectById(c,u){const w=this._getTerminalObjectIndexById(c,u);return w!==null?c[w]:null}_getTerminalObjectIndexById(c,u){let w=null;return c.some((f,y)=>f._id===u?(w=y,!0):!1),w}getEnvironmentVariableCollection(c){let u=this._environmentVariableCollections.get(c.identifier.value);return u||(u=new r,this._setEnvironmentVariableCollection(c.identifier.value,u)),u}_syncEnvironmentVariableCollection(c,u){const w=(0,_.serializeEnvironmentVariableCollection)(u.map);this._proxy.$setEnvironmentVariableCollection(c,u.persistent,w.length===0?void 0:w)}$initEnvironmentVariableCollections(c){c.forEach(u=>{const w=u[0],f=new r(u[1]);this._setEnvironmentVariableCollection(w,f)})}$acceptDefaultProfile(c,u){this._defaultProfile=c,this._defaultAutomationProfile=u}_setEnvironmentVariableCollection(c,u){this._environmentVariableCollections.set(c,u),u.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(c,u)})}};C=Ue([Be(1,t.IExtHostRpcService)],C),e.BaseExtHostTerminalService=C;class r{constructor(c){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new l.Emitter,this.map=new Map(c)}get persistent(){return this._persistent}set persistent(c){this._persistent=c,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(c,u){this._setIfDiffers(c,{value:u,type:D.EnvironmentVariableMutatorType.Replace})}append(c,u){this._setIfDiffers(c,{value:u,type:D.EnvironmentVariableMutatorType.Append})}prepend(c,u){this._setIfDiffers(c,{value:u,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(c,u){const w=this.map.get(c);(!w||w.value!==u.value||w.type!==u.type)&&(this.map.set(c,u),this._onDidChangeCollection.fire())}get(c){return this.map.get(c)}forEach(c,u){this.map.forEach((w,f)=>c.call(u,f,w,this))}delete(c){this.map.delete(c),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=r;let b=class extends C{constructor(c){super(!1,c)}createTerminal(c,u,w){throw new F.NotSupportedError}createTerminalFromOptions(c,u){throw new F.NotSupportedError}};b=Ue([Be(0,t.IExtHostRpcService)],b),e.WorkerExtHostTerminalService=b;function o(p){if(!(!p||typeof p=="string"))return"id"in p?{id:p.id,color:p.color}:p}function i(p){return h.ThemeColor.isThemeColor(p)?p:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(re,e,l,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,l):E?E.value=l:e.set(re,l),l},Te=this&&this.__classPrivateFieldGet||function(re,e,l,M){if(l==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?M:l==="a"?M.call(re):M?M.value:e.get(re)};define(be[209],Ee([0,1,15,22,21,3,238,60,6,23,10,37,5,14,50,8,7,178,90,69]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v,s){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let C=class{constructor(P,B){this.resultsChangedEmitter=new T.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=P.getProxy(n.MainContext.MainThreadTesting),this.observer=new w(this.proxy),this.runTracker=new b(this.proxy),B.registerArgumentProcessor({processArgument:L=>L?.$mid===13?h.TestItem.toItemFromContext(L):L})}createTestController(P,B){if(this.controllers.has(P))throw new Error(`Attempt to insert a duplicate controller with ID "${P}"`);const L=new D.DisposableStore,k=L.add(new S.SingleUseTestCollection(P));k.root.label=B;const x=new Map,N=this.proxy,V={items:k.root.children,get label(){return B},set label($){B=$,k.root.label=$,N.$updateControllerLabel(P,B)},get id(){return P},createRunProfile:($,X,j,Q,le)=>{let ve=(0,A.hash)($);for(;x.has(ve);)ve++;const ue=new f(this.proxy,P,ve,$,X,j,Q,le);return x.set(ve,ue),ue},createTestItem($,X,j){return new a.TestItemImpl(P,$,X,j)},createTestRun:($,X,j=!0)=>this.runTracker.createTestRun(P,k,$,X,j),set resolveHandler($){k.resolveHandler=$},get resolveHandler(){return k.resolveHandler},dispose:()=>{L.dispose()}};V.createRunConfiguration=V.createRunProfile,N.$registerTestController(P,B),L.add((0,D.toDisposable)(()=>N.$unregisterTestController(P)));const W={controller:V,collection:k,profiles:x};return this.controllers.set(P,W),L.add((0,D.toDisposable)(()=>this.controllers.delete(P))),L.add(k.onDidGenerateDiff($=>N.$publishDiff(P,$))),V}createTestObserver(){return this.observer.checkout()}async runTests(P,B=E.CancellationToken.None){const L=o(P);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const k=this.controllers.get(L.controllerId);if(!k)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:P.include?.map(x=>x.id)??[k.collection.root.id],profileGroup:y[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:P.exclude?.map(x=>x.id)},B)}$provideFileCoverage(P,B,L){return(0,l.mapFind)(this.runTracker.trackers,x=>x.id===P?x.getCoverage(B):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(P,B,L,k){return(0,l.mapFind)(this.runTracker.trackers,N=>N.id===P?N.getCoverage(B):void 0)?.resolveFileCoverage(L,k)??Promise.resolve([])}$configureRunProfile(P,B){this.controllers.get(P)?.profiles.get(B)?.configureHandler?.()}$publishTestResults(P){this.results=Object.freeze(P.map(B=>(0,I.deepFreeze)(h.TestResults.to(B))).concat(this.results).sort((B,L)=>L.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(P,B){const L=this.controllers.get(s.TestId.fromString(P).controllerId)?.collection;L&&(await L.expand(P,B<0?Infinity:B),L.flushDiff())}$acceptDiff(P){this.observer.applyDiff(P)}async $runControllerTests(P,B){const L=this.controllers.get(P.controllerId);if(!L)return;const{collection:k,profiles:x}=L,N=x.get(P.profileId);if(!N)return;const V=P.testIds.map(j=>k.tree.get(j)).filter(F.isDefined),W=P.excludeExtIds.map(j=>L.collection.tree.get(j)).filter(F.isDefined).filter(j=>V.some(Q=>Q.fullId.compare(j.fullId)===2));if(!V.length)return;const $=new g.TestRunRequest(V.some(j=>j.actual instanceof a.TestItemRootImpl)?void 0:V.map(j=>j.actual),W.map(j=>j.actual),N),X=this.runTracker.prepareForMainThreadTestRun($,i.fromInternal(P,L.collection),B);try{await N.runHandler($,B)}finally{X.isRunning&&!B.isCancellationRequested&&await T.Event.toPromise(X.onEnd),X.dispose()}}$cancelExtensionTestRun(P){P===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(P)}};C=Ue([Be(0,m.IExtHostRpcService)],C),e.ExtHostTesting=C;class r extends D.Disposable{constructor(P,B,L){super();this.dto=P,this.proxy=B,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new T.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:k}of this.tasks.values())k.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(P){return this.tasks.get(P)?.coverage}createRun(P){const B=this.dto.id,L=this.dto.controllerId,k=(0,_.generateUuid)(),x=new p(this.proxy,B,k),N=X=>(j,...Q)=>{if(W){console.warn(`Setting the state of test "${j.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(j)||(this.ensureTestIsKnown(j),X(j,...Q))},V=(X,j)=>{const Q=j instanceof Array?j.map(h.TestMessage.from):[h.TestMessage.from(j)];if(X.uri&&X.range){const le={range:h.Range.from(X.range),uri:X.uri};for(const ve of Q)ve.location=ve.location||le}this.proxy.$appendTestMessagesInRun(B,k,s.TestId.fromExtHostTestItem(X,L).toString(),Q)};let W=!1;const $={isPersisted:this.dto.isPersisted,token:this.cts.token,name:P,get coverageProvider(){return x.coverageProvider},set coverageProvider(X){x.coverageProvider=X},enqueued:N(X=>{this.proxy.$updateTestStateInRun(B,k,s.TestId.fromExtHostTestItem(X,L).toString(),1)}),skipped:N(X=>{this.proxy.$updateTestStateInRun(B,k,s.TestId.fromExtHostTestItem(X,L).toString(),5)}),started:N(X=>{this.proxy.$updateTestStateInRun(B,k,s.TestId.fromExtHostTestItem(X,L).toString(),2)}),errored:N((X,j,Q)=>{V(X,j),this.proxy.$updateTestStateInRun(B,k,s.TestId.fromExtHostTestItem(X,L).toString(),6,Q)}),failed:N((X,j,Q)=>{V(X,j),this.proxy.$updateTestStateInRun(B,k,s.TestId.fromExtHostTestItem(X,L).toString(),4,Q)}),passed:N((X,j)=>{this.proxy.$updateTestStateInRun(B,k,s.TestId.fromExtHostTestItem(X,this.dto.controllerId).toString(),3,j)}),appendOutput:(X,j,Q)=>{W||(Q&&(this.dto.isIncluded(Q)?this.ensureTestIsKnown(Q):Q=void 0),this.proxy.$appendOutputToRun(B,k,M.VSBuffer.fromString(X),j&&h.location.from(j),Q&&s.TestId.fromExtHostTestItem(Q,L).toString()))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(B,k),this.tasks.delete(k),this.isRunning||this.dispose())}};return this.tasks.set(k,{run:$,coverage:x}),this.proxy.$startedTestRunTask(B,{id:k,name:P,running:!0}),$}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(P){if(!(P instanceof a.TestItemImpl))throw new a.InvalidTestItemError(P.id);if(this.sharedTestIds.has(s.TestId.fromExtHostTestItem(P,this.dto.controllerId).toString()))return;const B=[],L=this.dto.colllection.root;for(;;){const k=h.TestItem.from(P);if(B.unshift(k),this.sharedTestIds.has(k.extId)||(this.sharedTestIds.add(k.extId),P===L))break;P=P.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,B)}}class b{constructor(P){this.proxy=P,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(P,B,L){return this.getTracker(P,B,L)}cancelRunById(P){for(const B of this.tracked.values())if(B.id===P){B.dispose();return}}cancelAllRuns(){for(const P of this.tracked.values())P.dispose()}createTestRun(P,B,L,k,x){const N=this.tracked.get(L);if(N)return N.createRun(k);const V=i.fromPublic(P,B,L,x),W=o(L);this.proxy.$startedExtensionTestRun({controllerId:P,profile:W&&{group:y[W.kind],id:W.profileId},exclude:L.exclude?.map(X=>X.id)??[],id:V.id,include:L.include?.map(X=>X.id)??[B.root.id],persist:x});const $=this.getTracker(L,V);return $.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),$.createRun(k)}getTracker(P,B,L){const k=new r(B,this.proxy,L);return this.tracked.set(P,k),k.onEnd(()=>this.tracked.delete(P)),k}}e.TestRunCoordinator=b;const o=R=>{if(!!R.profile){if(!(R.profile instanceof f))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return R.profile}};class i{constructor(P,B,L,k,x,N){this.controllerId=P,this.id=B,this.isPersisted=x,this.colllection=N,this.includePrefix=L.map(V=>V+"\0"),this.excludePrefix=k.map(V=>V+"\0")}static fromPublic(P,B,L,k){return new i(P,(0,_.generateUuid)(),L.include?.map(x=>s.TestId.fromExtHostTestItem(x,P).toString())??[P],L.exclude?.map(x=>s.TestId.fromExtHostTestItem(x,P).toString())??[],k,B)}static fromInternal(P,B){return new i(P.controllerId,P.runId,P.testIds,P.excludeExtIds,!0,B)}isIncluded(P){const B=s.TestId.fromExtHostTestItem(P,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(B===L||B.startsWith(L))return!1;for(const L of this.includePrefix)if(B===L||B.startsWith(L))return!0;return!1}}e.TestRunDto=i;class p{constructor(P,B,L){this.proxy=P,this.runId=B,this.taskId=L}set coverageProvider(P){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!P||(this._coverageProvider=P,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(P){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(P))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch(B){throw this.fileCoverage=void 0,B}}async resolveFileCoverage(P,B){const L=await this.fileCoverage;let k=L?.[P];return!this._coverageProvider||!L||!k?[]:(k.detailedCoverage||(k=L[P]=await this._coverageProvider.resolveFileCoverage?.(k,B)??k),k.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class c extends v.IncrementalChangeCollector{constructor(P){super();this.emitter=P,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(P){this.added.add(P)}update(P){Object.assign(P.revived,h.TestItem.toPlain(P.item)),this.added.has(P)||this.updated.add(P)}remove(P){if(this.added.has(P)){this.added.delete(P);return}if(this.updated.delete(P),P.parent&&this.alreadyRemoved.has(P.parent)){this.alreadyRemoved.add(P.item.extId);return}this.removed.add(P)}getChangeEvent(){const{added:P,updated:B,removed:L}=this;return{get added(){return[...P].map(k=>k.revived)},get updated(){return[...B].map(k=>k.revived)},get removed(){return[...L].map(k=>k.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class u extends v.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new T.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(P){return this.items.get(P)}getMirroredTestDataByReference(P){return this.items.get(P.id)}createItem(P,B){return{...P,revived:h.TestItem.toPlain(P.item),depth:B?B.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=u;class w{constructor(P){this.proxy=P}checkout(){this.current||(this.current=this.createObserverData());const P=this.current;return P.observers++,{onDidChangeTest:P.tests.onDidChangeTests,get tests(){return[...P.tests.rootTests].map(B=>B.revived)},dispose:(0,t.once)(()=>{--P.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(P){return this.current?.tests.getMirroredTestDataByReference(P)}applyDiff(P){this.current?.tests.apply(P)}createObserverData(){const P=new u;return this.proxy.$subscribeToDiffs(),{observers:0,tests:P}}}class f{constructor(P,B,L,k,x,N,V=!1,W=void 0){this.controllerId=B,this.profileId=L,this._label=k,this.kind=x,this.runHandler=N,this._isDefault=V,this._tag=W,d.set(this,void 0),Xe(this,d,P,"f");const $=y[x];if(typeof $!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Te(this,d,"f").$publishTestRunProfile({profileId:L,controllerId:B,tag:W?h.TestTag.namespace(this.controllerId,W.id):null,label:k,group:$,isDefault:V,hasConfigurationHandler:!1})}get label(){return this._label}set label(P){P!==this._label&&(this._label=P,Te(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:P}))}get isDefault(){return this._isDefault}set isDefault(P){P!==this._isDefault&&(this._isDefault=P,Te(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:P}))}get tag(){return this._tag}set tag(P){P?.id!==this._tag?.id&&(this._tag=P,Te(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:P?h.TestTag.namespace(this.controllerId,P.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(P){P!==this._configureHandler&&(this._configureHandler=P,Te(this,d,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!P}))}dispose(){Te(this,d,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=f,d=new WeakMap;const y={[g.TestRunProfileKind.Coverage]:8,[g.TestRunProfileKind.Debug]:4,[g.TestRunProfileKind.Run]:2}}),define(be[210],Ee([0,1,3,15,5,94,8,7]),function(re,e,l,M,E,T,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(F,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new l.Emitter,this._onDidChangeTextEditorOptions=new l.Emitter,this._onDidChangeTextEditorVisibleRanges=new l.Emitter,this._onDidChangeTextEditorViewColumn=new l.Emitter,this._onDidChangeActiveTextEditor=new l.Emitter,this._onDidChangeVisibleTextEditors=new l.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=F.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(n=>this._onDidChangeVisibleTextEditors.fire(n)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(n=>this._onDidChangeActiveTextEditor.fire(n))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(F){const _=this._extHostDocumentsAndEditors.allEditors();return F?_:_.map(n=>n.value)}async showTextDocument(F,_,n){let m;typeof _=="number"?m={position:t.ViewColumn.from(_),preserveFocus:n}:typeof _=="object"?m={position:t.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?t.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:m={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(F.uri,m),h=a&&this._extHostDocumentsAndEditors.getEditor(a);if(h)return h.value;throw a?new Error(`Could NOT open editor for "${F.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${F.uri.toString()}".`)}createTextEditorDecorationType(F,_){return new T.TextEditorDecorationType(this._proxy,F,_).value}$acceptEditorPropertiesChanged(F,_){const n=this._extHostDocumentsAndEditors.getEditor(F);if(!n)throw new Error("unknown text editor");if(_.options&&n._acceptOptions(_.options),_.selections){const m=_.selections.selections.map(t.Selection.to);n._acceptSelections(m)}if(_.visibleRanges){const m=M.coalesce(_.visibleRanges.map(t.Range.to));n._acceptVisibleRanges(m)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:n.value,options:{..._.options,lineNumbers:t.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const m=A.TextEditorSelectionChangeKind.fromValue(_.selections.source),a=_.selections.selections.map(t.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:n.value,selections:a,kind:m})}if(_.visibleRanges){const m=M.coalesce(_.visibleRanges.map(t.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:n.value,visibleRanges:m})}}$acceptEditorPositionData(F){for(const _ in F){const n=this._extHostDocumentsAndEditors.getEditor(_);if(!n)throw new Error("Unknown text editor");const m=t.ViewColumn.to(F[_]);n.value.viewColumn!==m&&(n._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:n.value,viewColumn:m}))}}getDiffInformation(F){return Promise.resolve(this._proxy.$getDiffInformation(F))}}e.ExtHostEditors=D}),define(be[211],Ee([0,1,2,4,5,6,7]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,M.createDecorator)("IExtHostTimeline");class A{constructor(F,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=F.getProxy(E.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===11){const m=n.uri===void 0?void 0:l.URI.revive(n.uri);return this._itemsBySourceAndUriMap.get(n.source)?.get(D(m))?.get(n.handle)}return n}})}async $getTimeline(F,_,n,m,a){return this._providers.get(F)?.provideTimeline(l.URI.revive(_),n,m,a)}registerTimelineProvider(F,_,n,m){const a=new T.DisposableStore,h=this.convertTimelineItem(_.id,m,a).bind(this);let g;_.onDidChange&&(g=_.onDidChange(v=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:_.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:F,onDidChange:void 0,async provideTimeline(v,s,d,C){C?.resetCache&&(a.clear(),S.get(_.id)?.clear());const r=await _.provideTimeline(v,s,d);if(r==null)return;const b=h(v,C);return{...r,source:_.id,items:r.items.map(b)}},dispose(){for(const v of S.values())v.get(_.id)?.clear();g?.dispose(),a.dispose()}})}convertTimelineItem(F,_,n){return(m,a)=>{let h;if(a?.cacheResults){let g=this._itemsBySourceAndUriMap.get(F);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(F,g));const S=D(m);h=g.get(S),h===void 0&&(h=new Map,g.set(S,h))}return g=>{const{iconPath:S,...v}=g,s=`${F}|${g.id??g.timestamp}`;h?.set(s,g);let d,C,r;return g.iconPath&&(S instanceof t.ThemeIcon?r={id:S.id,color:S.color}:l.URI.isUri(S)?(d=S,C=S):{light:d,dark:C}=S),{...v,id:v.id??void 0,handle:s,source:F,command:g.command?_.toInternal(g.command,n):void 0,icon:d,iconDark:C,themeIcon:r,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(F){if(this._providers.get(F.id))throw new Error(`Timeline Provider ${F.id} already exists.`);return this._proxy.$registerTimelineProvider({id:F.id,label:F.label,scheme:F.scheme}),this._providers.set(F.id,F),(0,T.toDisposable)(()=>{for(const n of this._itemsBySourceAndUriMap.values())n.get(F.id)?.clear();this._providers.delete(F.id),this._proxy.$unregisterTimelineProvider(F.id),F.dispose()})}}e.ExtHostTimeline=A;function D(I){return I?.toString()}}),define(be[212],Ee([0,1,6,11,2,5]),function(re,e,l,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class t{constructor(D){this._openers=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,I,F,_){if(this._openers.has(I))throw new Error(`Opener with id '${I}' already registered`);const n=_.schemes.find(m=>!t.supportedSchemes.has(m));if(n)throw new Error(`Scheme '${n}' is not supported. Only http and https are currently supported.`);return this._openers.set(I,F),this._proxy.$registerUriOpener(I,_.schemes,D,_.label),(0,l.toDisposable)(()=>{this._openers.delete(I),this._proxy.$unregisterUriOpener(I)})}async $canOpenUri(D,I,F){const _=this._openers.get(D);if(!_)throw new Error(`Unknown opener with id: ${D}`);const n=E.URI.revive(I);return _.canOpenExternalUri(n,F)}async $openUri(D,I,F){const _=this._openers.get(D);if(!_)throw new Error(`Unknown opener id: '${D}'`);return _.openExternalUri(E.URI.revive(I.resolvedUri),{sourceUri:E.URI.revive(I.sourceUri)},F)}}e.ExtHostUriOpeners=t,t.supportedSchemes=new Set([M.Schemas.http,M.Schemas.https])}),define(be[213],Ee([0,1,5,2,6,16,26]),function(re,e,l,M,E,T,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(I){this.handles=new Set,this.handlers=new Map,this._proxy=I.getProxy(l.MainContext.MainThreadUrls)}registerUriHandler(I,F){if(this.handles.has(t.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const _=A.HandlePool++;return this.handles.add(t.ExtensionIdentifier.toKey(I)),this.handlers.set(_,F),this._proxy.$registerUriHandler(_,I),(0,E.toDisposable)(()=>{this.handles.delete(t.ExtensionIdentifier.toKey(I)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(I,F){const _=this.handlers.get(I);if(!_)return Promise.resolve(void 0);try{_.handleUri(M.URI.revive(F))}catch(n){(0,T.onUnexpectedError)(n)}return Promise.resolve(void 0)}async createAppUri(I){return M.URI.revive(await this._proxy.$createAppUri(I))}}e.ExtHostUrls=A,A.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(re,e,l,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,l):E?E.value=l:e.set(re,l),l},Te=this&&this.__classPrivateFieldGet||function(re,e,l,M){if(l==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?M:l==="a"?M.call(re):M?M.value:e.get(re)};define(be[53],Ee([0,1,3,11,2,139,159,68,5]),function(re,e,l,M,E,T,t,A,D){"use strict";var I,F,_,n,m,a,h,g,S,v,s,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class C{constructor(w,f,y,R,P,B,L){I.set(this,void 0),F.set(this,void 0),_.set(this,void 0),n.set(this,void 0),m.set(this,void 0),a.set(this,void 0),h.set(this,""),g.set(this,void 0),S.set(this,!1),v.set(this,!1),s.set(this,!1),this._onMessageEmitter=new l.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new l.Emitter),this._onDidDispose=Te(this,d,"f").event,Xe(this,I,w,"f"),Xe(this,F,f,"f"),Xe(this,g,y,"f"),Xe(this,n,R,"f"),Xe(this,m,P,"f"),Xe(this,a,B,"f"),Xe(this,s,r(B),"f"),Xe(this,_,L,"f")}dispose(){Xe(this,S,!0,"f"),Te(this,d,"f").fire(),Te(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return Xe(this,v,!0,"f"),(0,A.asWebviewUri)(w,Te(this,n,"f").remote)}get cspSource(){const w=Te(this,a,"f").extensionLocation;if(w.scheme===M.Schemas.https||w.scheme===M.Schemas.http){let f=w.toString();return f.endsWith("/")||(f+="/"),f+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Te(this,h,"f")}set html(w){this.assertNotDisposed(),Te(this,h,"f")!==w&&(Xe(this,h,w,"f"),!Te(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(Xe(this,v,!0,"f"),Te(this,_,"f").report("Webview vscode-resource: uris",Te(this,a,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Te(this,F,"f").$setHtml(Te(this,I,"f"),w))}get options(){return this.assertNotDisposed(),Te(this,g,"f")}set options(w){this.assertNotDisposed(),Te(this,F,"f").$setOptions(Te(this,I,"f"),i(Te(this,a,"f"),Te(this,m,"f"),w)),Xe(this,g,w,"f")}async postMessage(w){if(Te(this,S,"f"))return!1;const f=(0,t.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Te(this,s,"f")});return Te(this,F,"f").$postMessage(Te(this,I,"f"),f.message,...f.buffers)}assertNotDisposed(){if(Te(this,S,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=C,I=new WeakMap,F=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,a=new WeakMap,h=new WeakMap,g=new WeakMap,S=new WeakMap,v=new WeakMap,s=new WeakMap,d=new WeakMap;function r(u){try{const w=(0,T.normalizeVersion)((0,T.parseVersion)(u.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;class b{constructor(w,f,y,R,P){this.initData=f,this.workspace=y,this._logService=R,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=w.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(w,f,...y){const R=this.getWebview(w);if(R){const{message:P}=(0,t.deserializeWebviewMessage)(f,y);R._onMessageEmitter.fire(P)}}$onMissingCsp(w,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,f,y){const R=new C(w,this._webviewProxy,p(f),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(w,R),R._onDidDispose(()=>{this._webviews.delete(w)}),R}deleteWebview(w){this._webviews.delete(w)}getWebview(w){return this._webviews.get(w)}}e.ExtHostWebviews=b;function o(u){return{id:u.identifier,location:u.extensionLocation}}e.toExtensionData=o;function i(u,w,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||c(u,w)}}e.serializeWebviewOptions=i;function p(u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots?.map(w=>E.URI.from(w))}}e.reviveOptions=p;function c(u,w){return[...(w?.getWorkspaceFolders()||[]).map(f=>f.uri),u.extensionLocation]}}),define(be[214],Ee([0,1,21,60,6,11,24,2,8,53,65,5,7]),function(re,e,l,M,E,T,t,A,D,I,F,_,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(r,b){this.document=r,this._storagePath=b,this._backupCounter=1,this._edits=new F.Cache("custom documents")}addEdit(r){return this._edits.add([r])}async undo(r,b){await this.getEdit(r).undo(),b||this.disposeBackup()}async redo(r,b){await this.getEdit(r).redo(),b||this.disposeBackup()}disposeEdits(r){for(const b of r)this._edits.delete(b)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const r=d(this.document.uri)+this._backupCounter++;return(0,t.joinPath)(this._storagePath,r)}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(r){const b=this._edits.get(r,0);if(!b)throw new Error("No edit found");return b}}class a{constructor(){this._documents=new Map}get(r,b){return this._documents.get(this.key(r,b))}add(r,b,o){const i=this.key(r,b.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${r} resource:${b.uri}`);const p=new m(b,o);return this._documents.set(i,p),p}delete(r,b){const o=this.key(r,b.uri);this._documents.delete(o)}key(r,b){return`${r}@@@${b}`}}var h;(function(C){C[C.Text=0]="Text",C[C.Custom=1]="Custom"})(h||(h={}));class g{constructor(){this._providers=new Map}addTextProvider(r,b,o){return this.add(0,r,b,o)}addCustomProvider(r,b,o){return this.add(1,r,b,o)}get(r){return this._providers.get(r)}add(r,b,o,i){if(this._providers.has(b))throw new Error(`Provider for viewType:${b} already registered`);return this._providers.set(b,{type:r,extension:o,provider:i}),new n.Disposable(()=>this._providers.delete(b))}}class S{constructor(r,b,o,i,p){this._extHostDocuments=b,this._extensionStoragePaths=o,this._extHostWebview=i,this._extHostWebviewPanels=p,this._editorProviders=new g,this._documents=new a,this._proxy=r.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(r,b,o,i){const p=new E.DisposableStore;return v(o)?(p.add(this._editorProviders.addTextProvider(b,r,o)),this._proxy.$registerTextEditorProvider((0,I.toExtensionData)(r),b,i.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(r))):(p.add(this._editorProviders.addCustomProvider(b,r,o)),this.supportEditing(o)&&p.add(o.onDidChangeCustomDocument(c=>{const u=this.getCustomDocumentEntry(b,c.document.uri);if(s(c)){const w=u.addEdit(c);this._proxy.$onDidEdit(c.document.uri,b,w,c.label)}else this._proxy.$onContentChange(c.document.uri,b)})),this._proxy.$registerCustomEditorProvider((0,I.toExtensionData)(r),b,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(r))),n.Disposable.from(p,new n.Disposable(()=>{this._proxy.$unregisterEditorProvider(b)}))}async $createCustomDocument(r,b,o,i,p){const c=this._editorProviders.get(b);if(!c)throw new Error(`No provider found for '${b}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${b}'`);const u=A.URI.revive(r),w=await c.provider.openCustomDocument(u,{backupId:o,untitledDocumentData:i?.buffer},p);let f;return this.supportEditing(c.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(c.extension)??this._extensionStoragePaths.globalValue(c.extension)),this._documents.add(b,w,f),{editable:this.supportEditing(c.provider)}}async $disposeCustomDocument(r,b){const o=this._editorProviders.get(b);if(!o)throw new Error(`No provider found for '${b}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${b}'`);const i=A.URI.revive(r),{document:p}=this.getCustomDocumentEntry(b,i);this._documents.delete(b,p),p.dispose()}async $resolveWebviewEditor(r,b,o,i,p,c){const u=this._editorProviders.get(o);if(!u)throw new Error(`No provider found for '${o}'`);const w=D.ViewColumn.to(p),f=this._extHostWebview.createNewWebview(b,i.webviewOptions,u.extension),y=this._extHostWebviewPanels.createNewWebviewPanel(b,o,i.title,w,i.panelOptions,f),R=A.URI.revive(r);switch(u.type){case 1:{const{document:P}=this.getCustomDocumentEntry(o,R);return u.provider.resolveCustomEditor(P,y,c)}case 0:{const P=this._extHostDocuments.getDocument(R);return u.provider.resolveCustomTextEditor(P,y,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,b,o){this.getCustomDocumentEntry(b,r).disposeEdits(o)}async $onMoveCustomEditor(r,b,o){const i=this._editorProviders.get(o);if(!i)throw new Error(`No provider found for '${o}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const p=this._extHostWebviewPanels.getWebviewPanel(r);if(!p)throw new Error("No webview found");const c=A.URI.revive(b),u=this._extHostDocuments.getDocument(c);await i.provider.moveCustomTextEditor(u,p,l.CancellationToken.None)}async $undo(r,b,o,i){return this.getCustomDocumentEntry(b,r).undo(o,i)}async $redo(r,b,o,i){return this.getCustomDocumentEntry(b,r).redo(o,i)}async $revert(r,b,o){const i=this.getCustomDocumentEntry(b,r);await this.getCustomEditorProvider(b).revertCustomDocument(i.document,o),i.disposeBackup()}async $onSave(r,b,o){const i=this.getCustomDocumentEntry(b,r);await this.getCustomEditorProvider(b).saveCustomDocument(i.document,o),i.disposeBackup()}async $onSaveAs(r,b,o,i){const p=this.getCustomDocumentEntry(b,r);return this.getCustomEditorProvider(b).saveCustomDocumentAs(p.document,A.URI.revive(o),i)}async $backup(r,b,o){const i=this.getCustomDocumentEntry(b,r),c=await this.getCustomEditorProvider(b).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},o);return i.updateBackup(c),c.id}getCustomDocumentEntry(r,b){const o=this._documents.get(r,A.URI.revive(b));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(r){const o=this._editorProviders.get(r)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(r){return!!r.onDidChangeCustomDocument}}e.ExtHostCustomEditors=S;function v(C){return typeof C.resolveCustomTextEditor=="function"}function s(C){return typeof C.undo=="function"&&typeof C.redo=="function"}function d(C){const r=C.scheme===T.Schemas.file||C.scheme===T.Schemas.untitled?C.fsPath:C.toString();return(0,M.hash)(r)+""}});var Xe=this&&this.__classPrivateFieldSet||function(re,e,l,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,l):E?E.value=l:e.set(re,l),l},Te=this&&this.__classPrivateFieldGet||function(re,e,l,M){if(l==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?M:l==="a"?M.call(re):M?M.value:e.get(re)};define(be[215],Ee([0,1,3,6,2,37,8,53,5,7]),function(re,e,l,M,E,T,t,A,D,I){"use strict";var F,_,n,m,a,h,g,S,v,s,d,C,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class b extends M.Disposable{constructor(c,u,w,f,y,R,P){super();F.set(this,void 0),_.set(this,void 0),n.set(this,void 0),m.set(this,void 0),a.set(this,void 0),h.set(this,void 0),g.set(this,void 0),S.set(this,void 0),v.set(this,!0),s.set(this,!0),d.set(this,!1),C.set(this,this._register(new l.Emitter)),this.onDidDispose=Te(this,C,"f").event,r.set(this,this._register(new l.Emitter)),this.onDidChangeViewState=Te(this,r,"f").event,Xe(this,F,c,"f"),Xe(this,_,u,"f"),Xe(this,n,w,"f"),Xe(this,a,R,"f"),Xe(this,S,y,"f"),Xe(this,h,f,"f"),Xe(this,m,P,"f")}dispose(){Te(this,d,"f")||(Xe(this,d,!0,"f"),Te(this,C,"f").fire(),Te(this,_,"f").$disposeWebview(Te(this,F,"f")),Te(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Te(this,m,"f")}get viewType(){return this.assertNotDisposed(),Te(this,n,"f")}get title(){return this.assertNotDisposed(),Te(this,h,"f")}set title(c){this.assertNotDisposed(),Te(this,h,"f")!==c&&(Xe(this,h,c,"f"),Te(this,_,"f").$setTitle(Te(this,F,"f"),c))}get iconPath(){return this.assertNotDisposed(),Te(this,g,"f")}set iconPath(c){this.assertNotDisposed(),Te(this,g,"f")!==c&&(Xe(this,g,c,"f"),Te(this,_,"f").$setIconPath(Te(this,F,"f"),E.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Te(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Te(this,S,"f")=="number"&&Te(this,S,"f")<0))return Te(this,S,"f")}get active(){return this.assertNotDisposed(),Te(this,s,"f")}get visible(){return this.assertNotDisposed(),Te(this,v,"f")}_updateViewState(c){Te(this,d,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(Xe(this,s,c.active,"f"),Xe(this,v,c.visible,"f"),Xe(this,S,c.viewColumn,"f"),Te(this,r,"f").fire({webviewPanel:this}))}reveal(c,u){this.assertNotDisposed(),Te(this,_,"f").$reveal(Te(this,F,"f"),{viewColumn:c?t.ViewColumn.from(c):void 0,preserveFocus:!!u})}assertNotDisposed(){if(Te(this,d,"f"))throw new Error("Webview is disposed")}}F=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,a=new WeakMap,h=new WeakMap,g=new WeakMap,S=new WeakMap,v=new WeakMap,s=new WeakMap,d=new WeakMap,C=new WeakMap,r=new WeakMap;class o{constructor(c,u,w){this.webviews=u,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(c,u,w,f,y={}){const R=typeof f=="object"?f.viewColumn:f,P={viewColumn:t.ViewColumn.from(R),preserveFocus:typeof f=="object"&&!!f.preserveFocus},B=(0,A.shouldSerializeBuffersForPostMessage)(c),L=o.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(c),L,u,{title:w,panelOptions:i(y),webviewOptions:(0,A.serializeWebviewOptions)(c,this.workspace,y),serializeBuffersForPostMessage:B},P);const k=this.webviews.createNewWebview(L,y,c);return this.createNewWebviewPanel(L,u,w,R,y,k)}$onDidChangeWebviewPanelViewStates(c){const u=Object.keys(c);u.sort((w,f)=>{const y=c[w],R=c[f];return y.active?1:R.active?-1:+y.visible-+R.visible});for(const w of u){const f=this.getWebviewPanel(w);if(!f)continue;const y=c[w];f._updateViewState({active:y.active,visible:y.visible,viewColumn:t.ViewColumn.to(y.position)})}}async $onDidDisposeWebviewPanel(c){this.getWebviewPanel(c)?.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,u,w){if(this._serializers.has(u))throw new Error(`Serializer for '${u}' already registered`);return this._serializers.set(u,{serializer:w,extension:c}),this._proxy.$registerSerializer(u,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(c)}),new I.Disposable(()=>{this._serializers.delete(u),this._proxy.$unregisterSerializer(u)})}async $deserializeWebviewPanel(c,u,w,f){const y=this._serializers.get(u);if(!y)throw new Error(`No serializer found for '${u}'`);const{serializer:R,extension:P}=y,B=this.webviews.createNewWebview(c,w.webviewOptions,P),L=this.createNewWebviewPanel(c,u,w.title,f,w.panelOptions,B);await R.deserializeWebviewPanel(L,w.state)}createNewWebviewPanel(c,u,w,f,y,R){const P=new b(c,this._proxy,u,w,f,y,R);return this._webviewPanels.set(c,P),P}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=o;function i(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(re,e,l,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,l):E?E.value=l:e.set(re,l),l},Te=this&&this.__classPrivateFieldGet||function(re,e,l,M){if(l==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?M:l==="a"?M.call(re):M?M.value:e.get(re)};define(be[216],Ee([0,1,3,6,53,5,7]),function(re,e,l,M,E,T,t){"use strict";var A,D,I,F,_,n,m,a,h,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends M.Disposable{constructor(d,C,r,b,o,i){super();A.set(this,void 0),D.set(this,void 0),I.set(this,void 0),F.set(this,void 0),_.set(this,!1),n.set(this,void 0),m.set(this,void 0),a.set(this,void 0),h.set(this,this._register(new l.Emitter)),this.onDidChangeVisibility=Te(this,h,"f").event,g.set(this,this._register(new l.Emitter)),this.onDidDispose=Te(this,g,"f").event,Xe(this,I,r,"f"),Xe(this,m,b,"f"),Xe(this,A,d,"f"),Xe(this,D,C,"f"),Xe(this,F,o,"f"),Xe(this,n,i,"f")}dispose(){Te(this,_,"f")||(Xe(this,_,!0,"f"),Te(this,g,"f").fire(),Te(this,F,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Te(this,m,"f")}set title(d){this.assertNotDisposed(),Te(this,m,"f")!==d&&(Xe(this,m,d,"f"),Te(this,D,"f").$setWebviewViewTitle(Te(this,A,"f"),d))}get description(){return this.assertNotDisposed(),Te(this,a,"f")}set description(d){this.assertNotDisposed(),Te(this,a,"f")!==d&&(Xe(this,a,d,"f"),Te(this,D,"f").$setWebviewViewDescription(Te(this,A,"f"),d))}get visible(){return Te(this,n,"f")}get webview(){return Te(this,F,"f")}get viewType(){return Te(this,I,"f")}_setVisible(d){d===Te(this,n,"f")||Te(this,_,"f")||(Xe(this,n,d,"f"),Te(this,h,"f").fire())}show(d){this.assertNotDisposed(),Te(this,D,"f").$show(Te(this,A,"f"),!!d)}assertNotDisposed(){if(Te(this,_,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,D=new WeakMap,I=new WeakMap,F=new WeakMap,_=new WeakMap,n=new WeakMap,m=new WeakMap,a=new WeakMap,h=new WeakMap,g=new WeakMap;class v{constructor(d,C){this._extHostWebview=C,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,C,r,b){if(this._viewProviders.has(C))throw new Error(`View provider for '${C}' already registered`);return this._viewProviders.set(C,{provider:r,extension:d}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(d),C,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new t.Disposable(()=>{this._viewProviders.delete(C),this._proxy.$unregisterWebviewViewProvider(C)})}async $resolveWebviewView(d,C,r,b,o){const i=this._viewProviders.get(C);if(!i)throw new Error(`No view provider found for '${C}'`);const{provider:p,extension:c}=i,u=this._extHostWebview.createNewWebview(d,{},c),w=new S(d,this._proxy,C,r,u,!0);this._webviewViews.set(d,w),await p.resolveWebviewView(w,{state:b},o)}async $onDidChangeWebviewViewVisibility(d,C){this.getWebviewView(d)._setVisible(C)}async $disposeWebviewView(d){const C=this.getWebviewView(d);this._webviewViews.delete(d),C.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const C=this._webviewViews.get(d);if(!C)throw new Error("No webview found");return C}}e.ExtHostWebviewViews=v}),define(be[97],Ee([0,1,3,5,2,11,9,4,14]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class $i{constructor(_){this._onDidChangeWindowState=new l.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=$i.InitialState,this._proxy=_.getProxy(M.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(n=>this.$onDidChangeWindowFocus(n))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,n){let m;if(typeof _=="string"){m=_;try{_=E.URI.parse(_)}catch(a){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,t.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,m,n)}async asExternalUri(_,n){if((0,t.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this._proxy.$asExternalUri(_,n);return E.URI.from(m)}};I.InitialState={focused:!0},I=Ue([Be(0,D.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(be[217],Ee([0,1,13,22,21,16,3,6,108,184,39]),function(re,e,l,M,E,T,t,A,D,I,F){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function n(y,R){try{return JSON.stringify(y,R)}catch(P){return"null"}}const m="$$ref$$",a={[m]:-1};class h{constructor(R,P){this.jsonString=R,this.referencedBuffers=P}}function g(y,R=null,P=!1){const B=[];return{jsonString:(P?n:JSON.stringify)(y,(k,x)=>{if(typeof x=="undefined")return a;if(typeof x=="object"){if(x instanceof M.VSBuffer){const N=B.push(x)-1;return{[m]:N}}if(R)return R(k,x)}return x}),referencedBuffers:B}}e.stringifyJsonWithBufferRefs=g;function S(y,R,P){return JSON.parse(y,(B,L)=>{if(L){const k=L[m];if(typeof k=="number")return R[k];if(P&&L.$mid===1)return P.transformIncoming(L)}return L})}e.parseJsonAndRestoreBufferRefs=S;function v(y,R){return JSON.stringify(y,R)}function s(y){return y?(R,P)=>P&&P.$mid===1?y.transformOutgoing(P):P:null}var d;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var C;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(C=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},b=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class i extends A.Disposable{constructor(R,P=null,B=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new t.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=R,this._logger=P,this._uriTransformer=B,this._uriReplacer=s(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let L=0,k=F.ProxyIdentifier.count;L<k;L++)this._locals[L]=null,this._proxies[L]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new l.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(L=>this._receiveOneMessage(L))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(R=>{this._pendingRPCReplies[R].resolveErr(T.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(R){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(R){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(R){this._responsiveState!==R&&(this._responsiveState=R,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(R){return this._uriTransformer?(0,D.transformIncomingURIs)(R,this._uriTransformer):R}getProxy(R){const{nid:P,sid:B}=R;return this._proxies[P]||(this._proxies[P]=this._createProxy(P,B)),this._proxies[P]}_createProxy(R,P){let B={get:(L,k)=>(typeof k=="string"&&!L[k]&&k.charCodeAt(0)===36&&(L[k]=(...x)=>this._remoteCall(R,k,x)),k===o?P:L[k])};return new Proxy(Object.create(null),B)}set(R,P){return this._locals[R.nid]=P,P}assertRegistered(R){for(let P=0,B=R.length;P<B;P++){const L=R[P];if(!this._locals[L.nid])throw new Error(`Missing actor ${L.sid} (isMain: ${L.isMain})`)}}_receiveOneMessage(R){if(this._isDisposed)return;const P=R.byteLength,B=p.read(R,0),L=B.readUInt8(),k=B.readUInt32();switch(L){case 1:case 2:{let{rpcId:x,method:N,args:V}=u.deserializeRequestJSONArgs(B);this._uriTransformer&&(V=(0,D.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(P,k,x,N,V,L===2);break}case 3:case 4:{let{rpcId:x,method:N,args:V}=u.deserializeRequestMixedArgs(B);this._uriTransformer&&(V=(0,D.transformIncomingURIs)(V,this._uriTransformer)),this._receiveRequest(P,k,x,N,V,L===4);break}case 5:{this._logger&&this._logger.logIncoming(P,k,0,"ack"),this._onDidReceiveAcknowledge(k);break}case 6:{this._receiveCancel(P,k);break}case 7:{this._receiveReply(P,k,void 0);break}case 9:{let x=u.deserializeReplyOKJSON(B);this._uriTransformer&&(x=(0,D.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReply(P,k,x);break}case 10:{const x=u.deserializeReplyOKJSONWithBuffers(B,this._uriTransformer);this._receiveReply(P,k,x);break}case 8:{let x=u.deserializeReplyOKVSBuffer(B);this._receiveReply(P,k,x);break}case 11:{let x=u.deserializeReplyErrError(B);this._uriTransformer&&(x=(0,D.transformIncomingURIs)(x,this._uriTransformer)),this._receiveReplyErr(P,k,x);break}case 12:{this._receiveReplyErr(P,k,void 0);break}default:console.error("received unexpected message"),console.error(R)}}_receiveRequest(R,P,B,L,k,x){this._logger&&this._logger.logIncoming(R,P,1,`receiveRequest ${(0,F.getStringIdentifierForProxy)(B)}.${L}(`,k);const N=String(P);let V,W;if(x){const X=new E.CancellationTokenSource;k.push(X.token),V=this._invokeHandler(B,L,k),W=()=>X.cancel()}else V=this._invokeHandler(B,L,k),W=r;this._cancelInvokedHandlers[N]=W;const $=u.serializeAcknowledged(P);this._logger&&this._logger.logOutgoing($.byteLength,P,1,"ack"),this._protocol.send($),V.then(X=>{delete this._cancelInvokedHandlers[N];const j=u.serializeReplyOK(P,X,this._uriReplacer);this._logger&&this._logger.logOutgoing(j.byteLength,P,1,"reply:",X),this._protocol.send(j)},X=>{delete this._cancelInvokedHandlers[N];const j=u.serializeReplyErr(P,X);this._logger&&this._logger.logOutgoing(j.byteLength,P,1,"replyErr:",X),this._protocol.send(j)})}_receiveCancel(R,P){this._logger&&this._logger.logIncoming(R,P,1,"receiveCancel");const B=String(P);this._cancelInvokedHandlers[B]&&this._cancelInvokedHandlers[B]()}_receiveReply(R,P,B){this._logger&&this._logger.logIncoming(R,P,0,"receiveReply:",B);const L=String(P);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const k=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L],k.resolveOk(B)}_receiveReplyErr(R,P,B){this._logger&&this._logger.logIncoming(R,P,0,"receiveReplyErr:",B);const L=String(P);if(!this._pendingRPCReplies.hasOwnProperty(L))return;const k=this._pendingRPCReplies[L];delete this._pendingRPCReplies[L];let x;B&&(B.$isError?(x=new Error,x.name=B.name,x.message=B.message,x.stack=B.stack):x=B),k.resolveErr(x)}_invokeHandler(R,P,B){try{return Promise.resolve(this._doInvokeHandler(R,P,B))}catch(L){return Promise.reject(L)}}_doInvokeHandler(R,P,B){const L=this._locals[R];if(!L)throw new Error("Unknown actor "+(0,F.getStringIdentifierForProxy)(R));let k=L[P];if(typeof k!="function")throw new Error("Unknown method "+P+" on actor "+(0,F.getStringIdentifierForProxy)(R));return k.apply(L,B)}_remoteCall(R,P,B){if(this._isDisposed)return Promise.reject(T.canceled());let L=null;if(B.length>0&&E.CancellationToken.isCancellationToken(B[B.length-1])&&(L=B.pop()),L&&L.isCancellationRequested)return Promise.reject(T.canceled());const k=u.serializeRequestArguments(B,this._uriReplacer),x=++this._lastMessageId,N=String(x),V=new I.LazyPromise;L&&L.onCancellationRequested(()=>{const $=u.serializeCancel(x);this._logger&&this._logger.logOutgoing($.byteLength,x,0,"cancel"),this._protocol.send(u.serializeCancel(x))}),this._pendingRPCReplies[N]=V,this._onWillSendRequest(x);const W=u.serializeRequest(x,R,P,k,!!L);return this._logger&&this._logger.logOutgoing(W.byteLength,x,0,`request: ${(0,F.getStringIdentifierForProxy)(R)}.${P}(`,B),this._protocol.send(W),V}}e.RPCProtocol=i,_=b,i.UNRESPONSIVE_TIME=3*1e3;class p{constructor(R,P){this._buff=R,this._offset=P}static alloc(R,P,B){let L=new p(M.VSBuffer.alloc(B+1+4),0);return L.writeUInt8(R),L.writeUInt32(P),L}static read(R,P){return new p(R,P)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(R){this._buff.writeUInt8(R,this._offset),this._offset+=1}readUInt8(){const R=this._buff.readUInt8(this._offset);return this._offset+=1,R}writeUInt32(R){this._buff.writeUInt32BE(R,this._offset),this._offset+=4}readUInt32(){const R=this._buff.readUInt32BE(this._offset);return this._offset+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this._buff.writeUInt8(R.byteLength,this._offset),this._offset+=1,this._buff.set(R,this._offset),this._offset+=R.byteLength}readShortString(){const R=this._buff.readUInt8(this._offset);this._offset+=1;const B=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,B}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readLongString(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const B=this._buff.slice(this._offset,this._offset+R).toString();return this._offset+=R,B}writeBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this._buff.writeUInt32BE(R.byteLength,this._offset),this._offset+=4,this._buff.set(R,this._offset),this._offset+=R.byteLength}readVSBuffer(){const R=this._buff.readUInt32BE(this._offset);this._offset+=4;const P=this._buff.slice(this._offset,this._offset+R);return this._offset+=R,P}static sizeMixedArray(R){let P=0;P+=1;for(let B=0,L=R.length;B<L;B++){const k=R[B];switch(P+=1,k.type){case 1:P+=this.sizeLongString(k.value);break;case 2:P+=this.sizeVSBuffer(k.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(k.value);for(let x=0;x<k.buffers.length;++x)P+=this.sizeVSBuffer(k.buffers[x]);break;case 4:break}}return P}writeMixedArray(R){this._buff.writeUInt8(R.length,this._offset),this._offset+=1;for(let P=0,B=R.length;P<B;P++){const L=R[P];switch(L.type){case 1:this.writeUInt8(1),this.writeLongString(L.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(L.value);break;case 3:this.writeUInt8(3),this.writeUInt32(L.buffers.length),this.writeLongString(L.value);for(let k=0;k<L.buffers.length;++k)this.writeBuffer(L.buffers[k]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this._buff.readUInt8(this._offset);this._offset+=1;let P=new Array(R);for(let B=0;B<R;B++)switch(this.readUInt8()){case 1:P[B]=this.readLongString();break;case 2:P[B]=this.readVSBuffer();break;case 3:const k=this.readUInt32(),x=this.readLongString(),N=[];for(let V=0;V<k;++V)N.push(this.readVSBuffer());P[B]=new F.SerializableObjectWithBuffers(S(x,N,null));break;case 4:P[B]=void 0;break}return P}}p.sizeUInt32=4;var c;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(c||(c={}));class u{static _useMixedArgSerialization(R){for(let P=0,B=R.length;P<B;P++)if(R[P]instanceof M.VSBuffer||R[P]instanceof F.SerializableObjectWithBuffers||typeof R[P]=="undefined")return!0;return!1}static serializeRequestArguments(R,P){if(this._useMixedArgSerialization(R)){const B=[];for(let L=0,k=R.length;L<k;L++){const x=R[L];if(x instanceof M.VSBuffer)B[L]={type:2,value:x};else if(typeof x=="undefined")B[L]={type:4};else if(x instanceof F.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:V}=g(x.value,P);B[L]={type:3,value:M.VSBuffer.fromString(N),buffers:V}}else B[L]={type:1,value:M.VSBuffer.fromString(v(x,P))}}return{type:1,args:B}}return{type:0,args:v(R,P)}}static serializeRequest(R,P,B,L,k){switch(L.type){case 0:return this._requestJSONArgs(R,P,B,L.args,k);case 1:return this._requestMixedArgs(R,P,B,L.args,k)}}static _requestJSONArgs(R,P,B,L,k){const x=M.VSBuffer.fromString(B),N=M.VSBuffer.fromString(L);let V=0;V+=p.sizeUInt8(),V+=p.sizeShortString(x),V+=p.sizeLongString(N);let W=p.alloc(k?2:1,R,V);return W.writeUInt8(P),W.writeShortString(x),W.writeLongString(N),W.buffer}static deserializeRequestJSONArgs(R){const P=R.readUInt8(),B=R.readShortString(),L=R.readLongString();return{rpcId:P,method:B,args:JSON.parse(L)}}static _requestMixedArgs(R,P,B,L,k){const x=M.VSBuffer.fromString(B);let N=0;N+=p.sizeUInt8(),N+=p.sizeShortString(x),N+=p.sizeMixedArray(L);let V=p.alloc(k?4:3,R,N);return V.writeUInt8(P),V.writeShortString(x),V.writeMixedArray(L),V.buffer}static deserializeRequestMixedArgs(R){const P=R.readUInt8(),B=R.readShortString(),L=R.readMixedArray(),k=new Array(L.length);for(let x=0,N=L.length;x<N;x++){const V=L[x];typeof V=="string"?k[x]=JSON.parse(V):k[x]=V}return{rpcId:P,method:B,args:k}}static serializeAcknowledged(R){return p.alloc(5,R,0).buffer}static serializeCancel(R){return p.alloc(6,R,0).buffer}static serializeReplyOK(R,P,B){if(typeof P=="undefined")return this._serializeReplyOKEmpty(R);if(P instanceof M.VSBuffer)return this._serializeReplyOKVSBuffer(R,P);if(P instanceof F.SerializableObjectWithBuffers){const{jsonString:L,referencedBuffers:k}=g(P.value,B,!0);return this._serializeReplyOKJSONWithBuffers(R,L,k)}else return this._serializeReplyOKJSON(R,n(P,B))}static _serializeReplyOKEmpty(R){return p.alloc(7,R,0).buffer}static _serializeReplyOKVSBuffer(R,P){let B=0;B+=p.sizeVSBuffer(P);let L=p.alloc(8,R,B);return L.writeVSBuffer(P),L.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static _serializeReplyOKJSON(R,P){const B=M.VSBuffer.fromString(P);let L=0;L+=p.sizeLongString(B);let k=p.alloc(9,R,L);return k.writeLongString(B),k.buffer}static _serializeReplyOKJSONWithBuffers(R,P,B){const L=M.VSBuffer.fromString(P);let k=0;k+=p.sizeUInt32,k+=p.sizeLongString(L);for(const N of B)k+=p.sizeVSBuffer(N);let x=p.alloc(10,R,k);x.writeUInt32(B.length),x.writeLongString(L);for(const N of B)x.writeBuffer(N);return x.buffer}static deserializeReplyOKJSON(R){const P=R.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(R,P){const B=R.readUInt32(),L=R.readLongString(),k=[];for(let x=0;x<B;++x)k.push(R.readVSBuffer());return new F.SerializableObjectWithBuffers(S(L,k,P))}static serializeReplyErr(R,P){return P?this._serializeReplyErrEror(R,P):this._serializeReplyErrEmpty(R)}static _serializeReplyErrEror(R,P){const B=M.VSBuffer.fromString(n(T.transformErrorForSerialization(P),null));let L=0;L+=p.sizeLongString(B);let k=p.alloc(11,R,L);return k.writeLongString(B),k.buffer}static deserializeReplyErrError(R){const P=R.readLongString();return JSON.parse(P)}static _serializeReplyErrEmpty(R){return p.alloc(12,R,0).buffer}}var w;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var f;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(f||(f={}))}),define(be[218],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const l=function(T){const t=A=>{self.removeEventListener("message",t);const D=A.data;Object.defineProperties(self,{postMessage:{value(I,F){D.postMessage(I,F)}},onmessage:{get(){return D.onmessage},set(I){D.onmessage=I}}}),D.addEventListener("message",I=>{self.dispatchEvent(new MessageEvent("message",{data:I.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",t)}.toString();class M extends EventTarget{constructor(T,t,A){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${l})('${t}'))`,I=new Blob([D],{type:"application/javascript"}),F=URL.createObjectURL(I),_=new MessageChannel,n=F,m={type:"_newWorker",id:n,port:_.port2,url:F,options:A};T(m,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:n};_.port1.postMessage(a),URL.revokeObjectURL(F),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(a){_.port1.onmessage=a}},onmessageerror:{get(){return _.port1.onmessageerror},set(a){_.port1.onmessageerror=a}}}),_.port1.addEventListener("messageerror",a=>{const h=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(h)}),_.port1.addEventListener("message",a=>{const h=new MessageEvent("message",{data:a.data});this.dispatchEvent(h)}),_.port1.start()}}e.NestedWorker=M}),define(be[219],Ee([0,1,4]),function(re,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,l.createDecorator)("remoteAgentService")}),define(be[220],Ee([0,1,11,17,25,2,4,64,49,179,219]),function(re,e,l,M,E,T,t,A,D,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,t.createDecorator)("pathService");let _=class Wi{constructor(m,a,h,g){this.localUserHome=m,this.remoteAgentService=a,this.environmentService=h,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const S=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=S?.userHome||m})()}get defaultUriScheme(){return Wi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(m,a){if(m.remoteAuthority)return l.Schemas.vscodeRemote;const h=(0,A.getVirtualWorkspaceScheme)(a.getWorkspace());if(h)return h;const g=a.getWorkspace().folders[0];if(g)return g.uri.scheme;const S=a.getWorkspace().configuration;return S?S.scheme:l.Schemas.file}async userHome(m){return m?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(m=>m===1?M.win32:M.posix)}async fileURI(m){let a="";if(await this.resolveOS===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const g=m.indexOf("/",2);g===-1?(a=m.substring(2),m="/"):(a=m.substring(2,g),m=m.substring(g)||"/")}return T.URI.from({scheme:l.Schemas.file,authority:a,path:m,query:"",fragment:""})}};_=Ue([Be(1,F.IRemoteAgentService),Be(2,I.IWorkbenchEnvironmentService),Be(3,D.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(be[98],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class l{constructor(t,A){this.line=t,this.character=A}isBefore(t){return!1}isBeforeOrEqual(t){return!1}isAfter(t){return!1}isAfterOrEqual(t){return!1}isEqual(t){return!1}compareTo(t){return 0}translate(t,A){return new l(0,0)}with(t){return new l(0,0)}}e.Position=l;class M{constructor(t,A,D,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(t,A),this.end=new l(D,I)}contains(t){return!1}isEqual(t){return!1}intersection(t){}union(t){return new M(0,0,0,0)}with(t){return new M(0,0,0,0)}}e.Range=M;var E;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[42],Ee([0,1,15,29,23,44,9,4,17,16,98,10]),function(re,e,l,M,E,T,t,A,D,I,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return F.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const n="\u27EA ",m=" characters skipped \u27EB",a=(n.length+m.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var h;(function($){$[$.file=0]="file",$[$.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var g;(function($){$[$.File=1]="File",$[$.Text=2]="Text"})(g=e.QueryType||(e.QueryType={}));function S($){return!!$.preview}e.resultIsMatch=S;function v($){return!!$.resource}e.isFileMatch=v;function s($){return!!$.message}e.isProgressMessage=s;var d;(function($){$[$.Normal=0]="Normal",$[$.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class C{constructor(X){this.resource=X,this.results=[]}}e.FileMatch=C;class r{constructor(X,j,Q){this.ranges=j;const le=Array.isArray(j)?j:[j];if(Q&&Q.matchLines===1&&b(le)){X=(0,t.getNLines)(X,Q.matchLines);let ve="",ue=0,Fe=0;const Ke=Math.floor(Q.charsPerLine/5),Oe=[];for(const He of le){const Je=Math.max(He.startColumn-Ke,0),Ye=He.startColumn+Q.charsPerLine;if(Je>Fe+Ke+a){const Qe=n+(Je-Fe)+m;ve+=Qe+X.slice(Je,Ye),ue+=Je-(Fe+Qe.length)}else ve+=X.slice(Fe,Ye);Oe.push(new i(0,He.startColumn-ue,He.endColumn-ue)),Fe=Ye}this.preview={text:ve,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const ve=Array.isArray(j)?j[0].startLineNumber:j.startLineNumber;this.preview={text:X,matches:(0,l.mapArrayOrNot)(j,ue=>new o(ue.startLineNumber-ve,ue.startColumn,ue.endLineNumber-ve,ue.endColumn))}}}}e.TextSearchMatch=r;function b($){const X=$[0].startLineNumber;for(const j of $)if(j.startLineNumber!==X||j.endLineNumber!==X)return!1;return!0}class o{constructor(X,j,Q,le){this.startLineNumber=X,this.startColumn=j,this.endLineNumber=Q,this.endColumn=le}}e.SearchRange=o;class i extends o{constructor(X,j,Q){super(X,j,X,Q)}}e.OneLineRange=i;var p;(function($){$.Default="default",$.FileNames="fileNames",$.Type="type",$.Modified="modified",$.CountDescending="countDescending",$.CountAscending="countAscending"})(p=e.SearchSortOrder||(e.SearchSortOrder={}));function c($,X=!0){const j=$&&$.files&&$.files.exclude,Q=X&&$&&$.search&&$.search.exclude;if(!j&&!Q)return;if(!j||!Q)return j||Q;let le=Object.create(null);return le=E.mixin(le,E.deepClone(j)),le=E.mixin(le,E.deepClone(Q),!0),le}e.getExcludes=c;function u($,X){return $.excludePattern&&M.match($.excludePattern,X)?!1:$.includePattern||$.usingSearchPaths?$.includePattern&&M.match($.includePattern,X)?!0:$.usingSearchPaths?!!$.folderQueries&&$.folderQueries.some(j=>{const Q=j.folder.fsPath;if(T.isEqualOrParent(X,Q)){const le=D.relative(Q,X);return!j.includePattern||!!M.match(j.includePattern,le)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var w;(function($){$[$.unknownEncoding=1]="unknownEncoding",$[$.regexParseError=2]="regexParseError",$[$.globParseError=3]="globParseError",$[$.invalidLiteral=4]="invalidLiteral",$[$.rgProcessError=5]="rgProcessError",$[$.other=6]="other",$[$.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(X,j){super(X);this.code=j}}e.SearchError=f;function y($){const X=$.message;if((0,I.isPromiseCanceledError)($))return new f(X,w.canceled);try{const j=JSON.parse(X);return new f(j.message,j.code)}catch(j){return new f(X,w.other)}}e.deserializeSearchError=y;function R($){const X={message:$.message,code:$.code};return new Error(JSON.stringify(X))}e.serializeSearchError=R;function P($){return $.type==="error"?!0:$.type==="success"}e.isSerializedSearchComplete=P;function B($){return $.type==="success"}e.isSerializedSearchSuccess=B;function L($){return!!$.path}e.isSerializedFileMatch=L;function k($,X){const j=$.searchPath?$.searchPath:$.relativePath;return(0,t.fuzzyContains)(j,X)}e.isFilePatternMatch=k;class x{constructor(X){this.path=X,this.results=[]}addMatch(X){this.results.push(X)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=x;function N($,X){const j={...$||{},...X||{}};return Object.keys(j).filter(Q=>{const le=j[Q];return typeof le=="boolean"&&le})}e.resolvePatternsForProvider=N;class V{constructor(X,j){this._parsedIncludeExpression=null,this._excludeExpression={...X.excludePattern||{},...j.excludePattern||{}},this._parsedExcludeExpression=M.parse(this._excludeExpression);let Q=X.includePattern;j.includePattern&&(Q?Q={...Q,...j.includePattern}:Q=j.includePattern),Q&&(this._parsedIncludeExpression=M.parse(Q))}matchesExcludesSync(X,j,Q){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(X,j,Q))}includedInQuerySync(X,j,Q){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(X,j,Q)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(X,j,Q))}includedInQuery(X,j,Q){const le=this._parsedExcludeExpression(X,j,Q),ve=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(X,j,Q):!0;return(0,_.isPromise)(le)?le.then(ue=>ue?!1:ve()):ve()}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=V;function W($){for(const X in $)if(typeof $[X]!="boolean")return!0;return!1}}),define(be[32],Ee([0,1,15,13,21,3,20,11,76,24,9,10,2,131,4,12,145,49,31,27,14,7,42,5]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v,s,d,C,r,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function o(R,P,B){return new I.ExtUri(L=>u(L,B)).isEqual(R,P)}function i(R,P,B){return o(R.uri,P.uri,B)?0:(0,F.compare)(R.uri.toString(),P.uri.toString())}function p(R,P,B){return R.index!==P.index?R.index<P.index?-1:1:o(R.uri,P.uri,B)?(0,F.compare)(R.name,P.name):(0,F.compare)(R.uri.toString(),P.uri.toString())}function c(R,P,B,L){const k=R.slice(0).sort((N,V)=>B(N,V,L)),x=P.slice(0).sort((N,V)=>B(N,V,L));return(0,l.delta)(k,x,(N,V)=>B(N,V,L))}function u(R,P){const B=P.getCapabilities(R.scheme);return!(B&&B&1024)}class w extends S.Workspace{constructor(P,B,L,k,x,N,V){super(P,L.map(W=>new S.WorkspaceFolder(W)),k,x,V);this._name=B,this._isUntitled=N,this._workspaceFolders=[],this._structure=t.TernarySearchTree.forUris(V),L.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(P,B,L,k){if(!P)return{workspace:null,added:[],removed:[]};const{id:x,name:N,folders:V,configuration:W,transient:$,isUntitled:X}=P,j=[],Q=B;B?V.forEach((Fe,Ke)=>{const Oe=n.URI.revive(Fe.uri),He=w._findFolder(L||B,Oe,k);He?(He.name=Fe.name,He.index=Fe.index,j.push(He)):j.push({uri:Oe,name:Fe.name,index:Ke})}):j.push(...V.map(({uri:Fe,name:Ke,index:Oe})=>({uri:n.URI.revive(Fe),name:Ke,index:Oe}))),j.sort((Fe,Ke)=>Fe.index<Ke.index?-1:1);const le=new w(x,N,j,!!$,W?n.URI.revive(W):null,!!X,Fe=>u(Fe,k)),{added:ve,removed:ue}=c(Q?Q.workspaceFolders:[],le.workspaceFolders,i,k);return{workspace:le,added:ve,removed:ue}}static _findFolder(P,B,L){for(let k=0;k<P.folders.length;k++){const x=P.workspaceFolders[k];if(o(x.uri,B,L))return x}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(P,B){return B&&this._structure.get(P)&&(P=(0,I.dirname)(P)),this._structure.findSubstr(P)}resolveWorkspaceFolder(P){return this._structure.get(P)}}let f=class{constructor(P,B,L,k){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=k,this._extHostFileSystemInfo=L,this._requestIdProvider=new D.Counter,this._barrier=new M.Barrier,this._proxy=P.getProxy(b.MainContext.MainThreadWorkspace),this._messageService=P.getProxy(b.MainContext.MainThreadMessageService);const x=B.workspace;this._confirmedWorkspace=x?new w(x.id,x.name,[],!!x.transient,x.configuration?n.URI.revive(x.configuration):null,!!x.isUntitled,N=>u(N,L)):void 0}$initializeWorkspace(P,B){this._trusted=B,this.$acceptWorkspaceData(P),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?n.URI.from({scheme:A.Schemas.untitled,path:(0,I.basename)((0,I.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(P,B,L,...k){const x=[];if(Array.isArray(k)&&k.forEach(X=>{n.URI.isUri(X.uri)&&!x.some(j=>o(j.uri,X.uri,this._extHostFileSystemInfo))&&x.push({uri:X.uri,name:X.name||(0,I.basenameOrAuthority)(X.uri)})}),this._unconfirmedWorkspace||[B,L].some(X=>typeof X!="number"||X<0)||L===0&&x.length===0)return!1;const N=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+L>N.length)return!1;const V=N.slice(0);V.splice(B,L,...x.map(X=>({uri:X.uri,name:X.name||(0,I.basenameOrAuthority)(X.uri),index:void 0})));for(let X=0;X<V.length;X++){const j=V[X];if(V.some((Q,le)=>le!==X&&o(j.uri,Q.uri,this._extHostFileSystemInfo)))return!1}V.forEach((X,j)=>X.index=j);const{added:W,removed:$}=c(N,V,p,this._extHostFileSystemInfo);if(W.length===0&&$.length===0)return!1;if(this._proxy){const X=P.displayName||P.name;this._proxy.$updateWorkspaceFolders(X,B,L,x).then(void 0,j=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(g.Severity.Error,(0,m.localize)(0,null,X,j.toString()),{extension:P},[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(P,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,B)}async getWorkspaceFolder2(P,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,B)}async resolveWorkspaceFolder(P){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(P)}getPath(){if(!this._actualWorkspace)return;const{folders:P}=this._actualWorkspace;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,B){let L,k="";if(typeof P=="string"?(L=n.URI.file(P),k=P):typeof P!="undefined"&&(L=P,k=P.fsPath),!L)return k;const x=this.getWorkspaceFolder(L,!0);if(!x)return k;typeof B=="undefined"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let N=(0,I.relativePath)(x.uri,L);return B&&x.name&&(N=`${x.name}/${N}`),N}trySetWorkspaceFolders(P){this._actualWorkspace&&(this._unconfirmedWorkspace=w.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:P,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:B,added:L,removed:k}=w.toExtHostWorkspace(P,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:L,removed:k}))}findFiles(P,B,L,k,x=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${k.value}, entryPoint: findFiles`);let N;if(B===null?N=!1:B&&(typeof B=="string"?N=B:N=B.pattern),x&&x.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:W}=y(P);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(V),(0,_.withUndefinedAsNull)(W),(0,_.withUndefinedAsNull)(N),(0,_.withUndefinedAsNull)(L),x).then($=>Array.isArray($)?$.map(X=>n.URI.revive(X)):[])}async findTextInFiles(P,B,L,k,x=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${k.value}, entryPoint: findTextInFiles`);const N=this._requestIdProvider.getNext(),V=typeof B.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:W,folder:$}=y(B.include),X=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,j={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:V,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:W,excludePattern:X},Q=!1;if(this._activeSearchCallbacks[N]=le=>{if(Q)return;const ve=n.URI.revive(le.resource);le.results.forEach(ue=>{(0,r.resultIsMatch)(ue)?L({uri:ve,preview:{text:ue.preview.text,matches:(0,l.mapArrayOrNot)(ue.preview.matches,Fe=>new C.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))},ranges:(0,l.mapArrayOrNot)(ue.ranges,Fe=>new C.Range(Fe.startLineNumber,Fe.startColumn,Fe.endLineNumber,Fe.endColumn))}):L({uri:ve,text:ue.text,lineNumber:ue.lineNumber})})},x.isCancellationRequested)return{};try{const le=await this._proxy.$startTextSearch(P,(0,_.withUndefinedAsNull)($),j,N,x);return delete this._activeSearchCallbacks[N],le||{}}catch(le){throw delete this._activeSearchCallbacks[N],le}}$handleTextSearchResult(P,B){this._activeSearchCallbacks[B]&&this._activeSearchCallbacks[B](P)}saveAll(P){return this._proxy.$saveAll(P)}resolveProxy(P){return this._proxy.$resolveProxy(P)}get trusted(){return this._trusted}requestWorkspaceTrust(P){return this._proxy.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};f=Ue([Be(0,d.IExtHostRpcService),Be(1,s.IExtHostInitDataService),Be(2,v.IExtHostFileSystemInfo),Be(3,h.ILogService)],f),e.ExtHostWorkspace=f,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function y(R){let P,B;return R&&(typeof R=="string"?P=R:(P=R.pattern,B=R.baseFolder||n.URI.file(R.base))),{includePattern:P,folder:B}}}),define(be[33],Ee([0,1,23,3,32,5,7,148,63,10,13,4,14,12,2]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(b,o){if(o){const i=o.split(".");let p=b;for(let c=0;p&&c<i.length;c++)p=p[i[c]];return p}}function g(b){return b instanceof a.URI}function S(b){return b&&b.uri instanceof a.URI&&b.languageId&&typeof b.languageId=="string"}function v(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function s(b){return b&&b.uri instanceof a.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function d(b){if(g(b))return{resource:b};if(S(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(v(b))return{overrideIdentifier:b.languageId};if(s(b))return{resource:b.uri};if(b===null)return{resource:null}}let C=class{constructor(o,i,p){this._proxy=o.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=p,this._barrier=new F.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new r(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,i){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(o,i))}};C=Ue([Be(0,n.IExtHostRpcService),Be(1,E.IExtHostWorkspace),Be(2,m.ILogService)],C),e.ExtHostConfiguration=C;class r{constructor(o,i,p,c){this._onDidChangeConfiguration=new M.Emitter,this._proxy=o,this._logService=c,this._extHostWorkspace=i,this._configuration=A.Configuration.parse(p),this._configurationScopes=this._toMap(p.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,i){const p={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,p))}getConfiguration(o,i,p){const c=d(i)||{},u=this._toReadonlyValue(o?h(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,c,p?.identifier);function w(y){if(y==null)return null;if(typeof y=="boolean")return y?1:4;switch(y){case t.ConfigurationTarget.Global:return 1;case t.ConfigurationTarget.Workspace:return 4;case t.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(y){return typeof h(u,y)!="undefined"},get:(y,R)=>{this._validateConfigurationAccess(o?`${o}.${y}`:y,c,p?.identifier);let P=h(u,y);if(typeof P=="undefined")P=R;else{let B;const L=(k,x)=>{let N;const V=()=>{B=B||(0,l.deepClone)(u),N=N||h(B,x)};return(0,I.isObject)(k)?new Proxy(k,{get:(W,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return V(),()=>N;if(B)return N=N||h(B,x),N[$];const X=W[$];return typeof $=="string"?L(X,`${x}.${$}`):X},set:(W,$,X)=>(V(),N&&(N[$]=X),!0),deleteProperty:(W,$)=>(V(),N&&delete N[$],!0),defineProperty:(W,$,X)=>(V(),N&&Object.defineProperty(N,$,X),!0)}):k};P=L(P,y)}return P},update:(y,R,P,B)=>{y=o?`${o}.${y}`:y;const L=w(P);return R!==void 0?this._proxy.$updateConfigurationOption(L,y,R,c,B):this._proxy.$removeConfigurationOption(L,y,c,B)},inspect:y=>{y=o?`${o}.${y}`:y;const R=(0,l.deepClone)(this._configuration.inspect(y,c,this._extHostWorkspace.workspace));if(R)return{key:y,defaultValue:R.default?.value,globalValue:R.user?.value,workspaceValue:R.workspace?.value,workspaceFolderValue:R.workspaceFolder?.value,defaultLanguageValue:R.default?.override,globalLanguageValue:R.user?.override,workspaceLanguageValue:R.workspace?.override,workspaceFolderLanguageValue:R.workspaceFolder?.override,languageIds:R.overrideIdentifiers}}};return typeof u=="object"&&(0,l.mixin)(f,u,!1),Object.freeze(f)}_toReadonlyValue(o){const i=p=>(0,I.isObject)(p)?new Proxy(p,{get:(c,u)=>i(c[u]),set:(c,u,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(c,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(c,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return i(o)}_validateConfigurationAccess(o,i,p){const c=D.OVERRIDE_PROPERTY_PATTERN.test(o)?4:this._configurationScopes.get(o),u=p?`[${p.value}] `:"";if(c===4){typeof i?.resource=="undefined"&&this._logService.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){i?.resource&&this._logService.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,i){const p=new A.ConfigurationChangeEvent(o,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,u)=>p.affectsConfiguration(c,d(u))})}_toMap(o){return o.reduce((i,p)=>(i.set(p[0],p[1]),i),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(re,e,l,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,l):E?E.value=l:e.set(re,l),l},Te=this&&this.__classPrivateFieldGet||function(re,e,l,M){if(l==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?M:l==="a"?M.call(re):M?M.value:e.get(re)};define(be[99],Ee([0,1,2,13,3,5,7,32,51,33,21,41,14,27,4,11,25,12,71,169,16]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v,s,d){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var b;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(b=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(x){function N($){if($){const X=$;return X&&!!X.process}else return!1}x.is=N;function V($){if($==null)return;const X={process:$.process,args:$.args};return $.options&&(X.options=o.from($.options)),X}x.from=V;function W($){if($!=null)return new t.ProcessExecution($.process,$.args,$.options)}x.to=W})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var p;(function(x){function N(W){if(W!=null)return W}x.from=N;function V(W){if(W!=null)return W}x.to=V})(p=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(x){function N($){if($){const X=$;return X&&(!!X.commandLine||!!X.command)}else return!1}x.is=N;function V($){if($==null)return;const X={};return $.commandLine!==void 0?X.commandLine=$.commandLine:(X.command=$.command,X.args=$.args),$.options&&(X.options=p.from($.options)),X}x.from=V;function W($){if(!($==null||$.command===void 0&&$.commandLine===void 0))return $.commandLine?new t.ShellExecution($.commandLine,$.options):new t.ShellExecution($.command,$.args?$.args:[],$.options)}x.to=W})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var u;(function(x){function N($){if($){let X=$;return X&&X.customExecution==="customExecution"}else return!1}x.is=N;function V($){return{customExecution:"customExecution"}}x.from=V;function W($,X){return X.get($)}x.to=W})(u=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function(x){function N(V,W){let $;return V.scope!==void 0&&typeof V.scope!="number"?$=V.scope.uri:V.scope!==void 0&&typeof V.scope=="number"&&(V.scope===t.TaskScope.Workspace&&W&&W.workspaceFile?$=W.workspaceFile:$=s.USER_TASKS_GROUP_KEY),{id:V._id,workspaceFolder:$}}x.from=N})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(x){function N(V){if(V!=null)return{_id:V.id,isDefault:V.isDefault}}x.from=N})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var y;(function(x){function N($,X){if($==null)return[];const j=[];for(let Q of $){const le=V(Q,X);le&&j.push(le)}return j}x.fromMany=N;function V($,X){if($==null)return;let j;$.execution instanceof t.ProcessExecution?j=i.from($.execution):$.execution instanceof t.ShellExecution?j=c.from($.execution):$.execution&&$.execution instanceof t.CustomExecution&&(j=u.from($.execution));const Q=r.from($.definition);let le;return $.scope?typeof $.scope=="number"?le=$.scope:le=$.scope.uri:le=t.TaskScope.Workspace,!Q||!le?void 0:{_id:$._id,definition:Q,name:$.name,source:{extensionId:X.identifier.value,label:$.source,scope:le},execution:j,isBackground:$.isBackground,group:f.from($.group),presentationOptions:b.from($.presentationOptions),problemMatchers:$.problemMatchers,hasDefinedMatchers:$.hasDefinedMatchers,runOptions:$.runOptions?$.runOptions:{reevaluateOnRerun:!0},detail:$.detail}}x.from=V;async function W($,X,j){if($==null)return;let Q;i.is($.execution)?Q=i.to($.execution):c.is($.execution)?Q=c.to($.execution):u.is($.execution)&&(Q=u.to($._id,j));const le=r.to($.definition);let ve;if($.source&&($.source.scope!==void 0?typeof $.source.scope=="number"?ve=$.source.scope:ve=await X.resolveWorkspaceFolder(l.URI.revive($.source.scope)):ve=t.TaskScope.Workspace),!le||!ve)return;const ue=new t.Task(le,ve,$.name,$.source.label,Q,$.problemMatchers);return $.isBackground!==void 0&&(ue.isBackground=$.isBackground),$.group!==void 0&&(ue.group=t.TaskGroup.from($.group._id),ue.group&&$.group.isDefault&&(ue.group=new t.TaskGroup(ue.group.id,ue.group.label),$.group.isDefault&&(ue.group.isDefault=$.group.isDefault))),$.presentationOptions&&(ue.presentationOptions=b.to($.presentationOptions)),$._id&&(ue._id=$._id),$.detail&&(ue.detail=$.detail),ue}x.to=W})(y=e.TaskDTO||(e.TaskDTO={}));var R;(function(x){function N(W){return W}x.from=N;function V(W){if(!!W)return Object.assign(Object.create(null),W)}x.to=V})(R=e.TaskFilterDTO||(e.TaskFilterDTO={}));class P{constructor(N,V,W){this._id=V,this._task=W,C.set(this,void 0),Xe(this,C,N,"f")}get task(){return this._task}terminate(){Te(this,C,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}C=new WeakMap;var B;(function(x){function N(V){return{id:V._id,task:void 0}}x.from=N})(B=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let L=class{constructor(N,V,W,$,X,j,Q,le){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=N.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=W,this._editorService=$,this._configurationService=X,this._terminalService=j,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Q,this._deprecationService=le,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,V,W){if(!W)return new t.Disposable(()=>{});const $=this.nextHandle();return this._handlers.set($,{type:V,provider:W,extension:N}),this._proxy.$registerTaskProvider($,V),new t.Disposable(()=>{this._handlers.delete($),this._proxy.$unregisterTaskProvider($)})}registerTaskSystem(N,V){this._proxy.$registerTaskSystem(N,V)}fetchTasks(N){return this._proxy.$fetchTasks(R.from(N)).then(async V=>{const W=[];for(let $ of V){const X=await y.to($,this._workspaceProvider,this._providedCustomExecutions2);X&&W.push(X)}return W})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(V=>N.push(V)),N}terminateTask(N){if(!(N instanceof P))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,V,W){const $=this._providedCustomExecutions2.get(N.id);$&&(this._activeCustomExecutions2.set(N.id,$),this._terminalService.attachPtyToTerminal(V,await $.callback(W))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const V=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:V})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:V,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const V=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:V,exitCode:N.exitCode})}$provideTasks(N,V){const W=this._handlers.get(N);if(!W)return Promise.reject(new Error("no handler found"));const $=[],X=(0,M.asPromise)(()=>W.provider.provideTasks(F.CancellationToken.None)).then(j=>this.provideTasksInternal(V,$,W,j));return new Promise(j=>{X.then(Q=>{Promise.all($).then(()=>{j(Q)})})})}async $resolveTask(N,V){const W=this._handlers.get(N);if(!W)return Promise.reject(new Error("no handler found"));if(V.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${V.definition.type}] cannot be resolved by provider of type [${W.type}].`);const $=await y.to(V,this._workspaceProvider,this._providedCustomExecutions2);if(!$)throw new Error("Unexpected: Task cannot be resolved.");const X=await W.provider.resolveTask($,F.CancellationToken.None);if(!X)return;this.checkDeprecation(X,W);const j=y.from(X,W.extension);if(!j)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==$.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return u.is(j.execution)&&await this.addCustomExecution(j,X,!0),await this.resolveTaskInternal(j)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,V,W){const $=await this._proxy.$createTaskId(N);!W&&!this._providedCustomExecutions2.has($)&&(this._notProvidedCustomExecutions.add($),this._activeCustomExecutions2.set($,V.execution)),this._providedCustomExecutions2.set($,V.execution)}async getTaskExecution(N,V){if(typeof N=="string"){const X=this._taskExecutionPromises.get(N);if(!X)throw new Error("Unexpected: The specified task is missing an execution");return X}let W=this._taskExecutionPromises.get(N.id);if(W)return W;const $=new Promise((X,j)=>{function Q(le,ve,ue){ue?X(new P(le,ve.id,ue)):j("Unexpected: Task does not exist.")}V?Q(this,N,V):y.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(le=>Q(this,N,le))});return this._taskExecutionPromises.set(N.id,$),$.then(X=>(this._taskExecutions.set(N.id,X),X),X=>Promise.reject(X))}checkDeprecation(N,V){N._deprecated&&this._deprecationService.report("Task.constructor",V.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));let W=this._notProvidedCustomExecutions.values(),$=W.next();for(;!$.done;)!this._activeCustomExecutions2.has($.value)&&this._lastStartedTask!==$.value&&(this._providedCustomExecutions2.delete($.value),this._notProvidedCustomExecutions.delete($.value)),$=W.next()}};L=Ue([Be(0,n.IExtHostRpcService),Be(1,m.IExtHostInitDataService),Be(2,A.IExtHostWorkspace),Be(3,D.IExtHostDocumentsAndEditors),Be(4,I.IExtHostConfiguration),Be(5,_.IExtHostTerminalService),Be(6,S.ILogService),Be(7,v.IExtHostApiDeprecationService)],L),e.ExtHostTaskBase=L;let k=class extends L{constructor(N,V,W,$,X,j,Q,le){super(N,V,W,$,X,j,Q,le);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(N,V){if(!V.execution)throw new Error("Tasks to execute must include an execution");const W=y.from(V,N);if(W===void 0)throw new Error("Task is not valid");if(u.is(W.execution))await this.addCustomExecution(W,V,!1);else throw new d.NotSupportedError;const $=await this.getTaskExecution(await this._proxy.$getTaskExecution(W),V);return this._proxy.$executeTask(W).catch(X=>{throw new Error(X)}),$}provideTasksInternal(N,V,W,$){const X=[];if($)for(let j of $){this.checkDeprecation(j,W),(!j.definition||!N[j.definition.type])&&this._logService.warn(`The task [${j.source}, ${j.name}] uses an undefined task type. The task will be ignored in the future.`);const Q=y.from(j,W.extension);Q&&u.is(Q.execution)?(X.push(Q),V.push(this.addCustomExecution(Q,j,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:X,extension:W.extension}}async resolveTaskInternal(N){if(u.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,V){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,V,W){}};k=Ue([Be(0,n.IExtHostRpcService),Be(1,m.IExtHostInitDataService),Be(2,A.IExtHostWorkspace),Be(3,D.IExtHostDocumentsAndEditors),Be(4,I.IExtHostConfiguration),Be(5,_.IExtHostTerminalService),Be(6,S.ILogService),Be(7,v.IExtHostApiDeprecationService)],k),e.WorkerExtHostTask=k,e.IExtHostTask=(0,a.createDecorator)("IExtHostTask")}),define(be[221],Ee([0,1,15,54,29,78,20,11,17,24,9,10,2,110,135,85,49,92,220,42]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(w,f,y,R){this.configurationService=w,this.workspaceContextService=f,this.editorGroupsService=y,this.pathService=R}text(w,f,y={}){w=this.getContentPattern(w,y);const R=this.configurationService.getValue(),P=f&&f.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(f?.map(g.toWorkspaceFolder),y),type:2,contentPattern:w,previewOptions:y.previewOptions,maxFileSize:y.maxFileSize,usePCRE2:R.search.usePCRE2||P||!1,beforeContext:y.beforeContext,afterContext:y.afterContext,userDisabledExcludesAndIgnoreFiles:y.disregardExcludeSettings&&y.disregardIgnoreFiles}}getContentPattern(w,f){const y=this.configurationService.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const R={...w,wordSeparators:y.editor.wordSeparators};return this.isCaseSensitive(w,f)&&(R.isCaseSensitive=!0),this.isMultiline(w)&&(R.isMultiline=!0),R}file(w,f={}){return{...this.commonQuery(w,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}handleIncludeExclude(w,f){return w?(w=Array.isArray(w)?w.map(i):i(w),f?this.parseSearchPaths(w):{pattern:r(...Array.isArray(w)?w:[w])}):{}}commonQuery(w=[],f={}){const y=this.handleIncludeExclude(f.includePattern,f.expandPatterns),R=this.handleIncludeExclude(f.excludePattern,f.expandPatterns),P=w.length>1,B=(y.searchPaths&&y.searchPaths.length?y.searchPaths.map(x=>this.getFolderQueryForSearchPath(x,f,R)):w.map(x=>this.getFolderQueryForRoot(x,f,R,P))).filter(x=>!!x),L={_reason:f._reason,folderQueries:B,usingSearchPaths:!!(y.searchPaths&&y.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:R.pattern,includePattern:y.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const N=l.coalesce(l.flatten(this.editorGroupsService.groups.map(W=>W.editors.map($=>$.resource)))).filter(W=>(0,s.pathIncludedInQuery)(L,W.fsPath)),V=this.commonQueryFromFileList(N);return{...L,...V}}const k=f.extraFileResources&&f.extraFileResources.filter(x=>(0,s.pathIncludedInQuery)(L,x.fsPath));return L.extraFileResources=k&&k.length?k:void 0,L}commonQueryFromFileList(w){const f=[],y=new t.ResourceMap,R={};let P=!1;return w.forEach(B=>{if(B.scheme===A.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(B)){const k=this.workspaceContextService.getWorkspaceFolder(B)?.uri??B.with({path:D.dirname(B.fsPath)});let x=y.get(k);x||(P=!0,x={folder:k,includePattern:{}},f.push(x),y.set(k,x));const N=D.relative(k.fsPath,B.fsPath);(0,_.assertIsDefined)(x.includePattern)[N.replace(/\\/g,"/")]=!0}else B.fsPath&&(P=!0,R[B.fsPath]=!0)}),{folderQueries:f,includePattern:R,usingSearchPaths:!0,excludePattern:P?void 0:{"**/*":!0}}}isCaseSensitive(w,f){if(f.isSmartCase){if(w.isRegExp){if(F.containsUppercaseCharacter(w.pattern,!0))return!0}else if(F.containsUppercaseCharacter(w.pattern))return!0}return!!w.isCaseSensitive}isMultiline(w){return w.isMultiline||w.isRegExp&&(0,m.isMultilineRegexSource)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const f=V=>D.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),R=(Array.isArray(w)?w:b(w)).map(V=>{const W=this.pathService.resolvedUserHome;return W?(0,T.untildify)(V,W.scheme===A.Schemas.file?W.fsPath:W.path):V}),P=M.groupBy(R,V=>f(V)?"searchPaths":"exprSegments"),B=(P.exprSegments||[]).map(V=>F.rtrim(V,"/")).map(V=>F.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),o(V))),L={},k=this.expandSearchPathPatterns(P.searchPaths||[]);k&&k.length&&(L.searchPaths=k);const x=l.flatten(B),N=r(...x);return N&&(L.pattern=N),L}getExcludesForFolder(w,f){return f.disregardExcludeSettings?void 0:(0,s.getExcludes)(w,!f.disregardSearchExcludeSettings)}expandSearchPathPatterns(w){if(!w||!w.length)return[];const f=l.flatten(w.map(R=>{let{pathPortion:P,globPortion:B}=C(R);B&&(B=p(B));const L=this.expandOneSearchPath(P);return l.flatten(L.map(k=>this.resolveOneSearchPathPattern(k,B)))})),y=new Map;return f.forEach(R=>{const P=R.searchPath.toString(),B=y.get(P);B?R.pattern&&(B.pattern=B.pattern||{},B.pattern[R.pattern]=!0):y.set(P,{searchPath:R.searchPath,pattern:R.pattern?r(R.pattern):void 0})}),Array.from(y.values())}expandOneSearchPath(w){if(D.isAbsolute(w)){const f=this.workspaceContextService.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==A.Schemas.file?[{searchPath:f[0].uri.with({path:w})}]:[{searchPath:n.URI.file(D.normalize(w))}]}if(this.workspaceContextService.getWorkbenchState()===2){const f=this.workspaceContextService.getWorkspace().folders[0].uri;if(w=i(w),w.startsWith("../")||w===".."){const R=D.posix.resolve(f.path,w);return[{searchPath:f.with({path:R})}]}const y=p(w);return[{searchPath:f,pattern:y}]}else{if(w==="./"||w===".\\")return[];{const f=w.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(P=>{const B=f.match(new RegExp(`^${F.escapeRegExpCharacters(P.name)}(?:/(.*)|$)`));return B?{match:B,folder:P}:null}).filter(_.isDefined);if(R.length)return R.map(P=>{const B=P.match[1];return{searchPath:P.folder.uri,pattern:B&&p(B)}});{const P=w.match(/\.[\/\\](.+)[\/\\]?/),B=P?P[1]:w,L=a.localize(0,null,B);throw new Error(L)}}}}resolveOneSearchPathPattern(w,f){const y=w.pattern&&f?`${w.pattern}/${f}`:w.pattern||f,R=[{searchPath:w.searchPath,pattern:y}];return y&&!y.endsWith("**")&&R.push({searchPath:w.searchPath,pattern:y+"/**"}),R}getFolderQueryForSearchPath(w,f,y){const R=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(w.searchPath),f,y,!1);return R?{...R,includePattern:w.pattern}:null}getFolderQueryForRoot(w,f,y,R){let P;const B=n.URI.isUri(w)?w:w.uri;if(y.searchPaths){const V=y.searchPaths.filter(W=>(0,I.isEqual)(W.searchPath,B))[0];if(V&&!V.pattern)return null;V&&(P=V.pattern)}const L=this.configurationService.getValue({resource:B}),x={...this.getExcludesForFolder(L,f)||{},...P||{}},N=n.URI.isUri(w)?(0,I.basename)(w):w.name;return{folder:B,folderName:R?N:void 0,excludePattern:Object.keys(x).length>0?x:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!L.search.followSymlinks}}};d=Ue([Be(0,h.IConfigurationService),Be(1,g.IWorkspaceContextService),Be(2,S.IEditorGroupsService),Be(3,v.IPathService)],d),e.QueryBuilder=d;function C(u){const w=u.match(/[\*\{\}\(\)\[\]\?]/);if(w){const f=w.index,y=u.substr(0,f).match(/[/|\\][^/\\]*$/);if(y){let R=u.substr(0,y.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:u.substr((y.index||0)+1)}}}return{pathPortion:u}}function r(...u){return u.length?u.reduce((w,f)=>(w[f]=!0,w),Object.create(null)):void 0}function b(u){return E.splitGlobAware(u,",").map(w=>w.trim()).filter(w=>!!w.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function i(u){return u.replace(/\\/g,"/")}function p(u){return i(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(u,w){u=l.distinct(u,R=>R.toString());const f=[],y=w.getWorkspace();return u&&u.forEach(R=>{let P;if(w.getWorkbenchState()===2)P=(0,I.relativePath)(y.folders[0].uri,R),P&&P!=="."&&(P="./"+P);else{const B=w.getWorkspaceFolder(R);if(B){const L=B.name;if(y.folders.filter(x=>x.name===L).length===1){const x=(0,I.relativePath)(B.uri,R);x===""?P=`./${B.name}`:P=`./${B.name}/${x}`}else P=R.fsPath}}P&&f.push(P)}),f}e.resolveResourcesForSearchIncludes=c}),define(be[222],Ee([0,1,24,2,21,16,4,221,42,49]),function(re,e,l,M,E,T,t,A,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const F=7e3;function _(h,g){const S=g.activationEvents;if(!S)return Promise.resolve(void 0);const v=[],s=[];for(const i of S)if(/^workspaceContains:/.test(i)){const p=i.substr("workspaceContains:".length);p.indexOf("*")>=0||p.indexOf("?")>=0||h.forceUsingSearch?s.push(p):v.push(p)}if(v.length===0&&s.length===0)return Promise.resolve(void 0);let d;const C=new Promise((i,p)=>{d=i}),r=i=>d({activationEvent:i}),b=Promise.all(v.map(i=>n(h,i,r))).then(()=>{}),o=m(h,g.identifier,s,r);return Promise.all([b,o]).then(()=>{d(void 0)}),C}e.checkActivateWorkspaceContainsExtension=_;async function n(h,g,S){for(const v of h.folders)if(await h.exists(l.joinPath(M.URI.revive(v),g))){S(`workspaceContains:${g}`);return}}async function m(h,g,S,v){if(S.length===0)return Promise.resolve(void 0);const s=new E.CancellationTokenSource,d=h.checkExists(h.folders,S,s.token),C=setTimeout(async()=>{s.cancel(),v(`workspaceContainsTimeout:${S.join(",")}`)},F);let r=!1;try{r=await d}catch(b){T.isPromiseCanceledError(b)||T.onUnexpectedError(b)}s.dispose(),clearTimeout(C),r&&v(`workspaceContains:${S.join(",")}`)}function a(h,g,S,v){const s=h.get(t.IInstantiationService),d=h.get(D.ISearchService),r=s.createInstance(A.QueryBuilder).file(g.map(b=>(0,I.toWorkspaceFolder)(M.URI.revive(b))),{_reason:"checkExists",includePattern:S,exists:!0});return d.fileSearch(r,v).then(b=>!!b.limitHit,b=>T.isPromiseCanceledError(b)?!1:Promise.reject(b))}e.checkGlobFileExists=a});var Xe=this&&this.__classPrivateFieldSet||function(re,e,l,M,E){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?E.call(re,l):E?E.value=l:e.set(re,l),l},Te=this&&this.__classPrivateFieldGet||function(re,e,l,M){if(l==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return l==="m"?M:l==="a"?M.call(re):M?M.value:e.get(re)};define(be[34],Ee([0,1,126,17,75,24,13,6,20,2,12,5,33,182,73,32,28,180,16,26,22,154,7,86,4,27,74,14,62,66,41,3,222,70,156,11]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v,s,d,C,r,b,o,i,p,c,u,w,f,y,R,P,B,L){"use strict";var k,x,N;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let V=class zi extends A.Disposable{constructor(j,Q,le,ve,ue,Fe,Ke,Oe,He,Je){super();this._onDidChangeRemoteConnectionData=this._register(new y.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=Q,this._extHostContext=le,this._initData=Ke,this._extHostWorkspace=ve,this._extHostConfiguration=ue,this._logService=Fe,this._extHostTunnelService=He,this._extHostTerminalService=Je,this._disposables=new A.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new t.Barrier,this._readyToStartExtensionHost=new t.Barrier,this._readyToRunExtensions=new t.Barrier,this._eagerExtensionsActivated=new t.Barrier,this._registry=new S.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new P.ExtHostSecretState(this._extHostContext),this._storagePath=Oe,this._instaService=j.createChild(new u.ServiceCollection([a.IExtHostStorage,this._storage],[P.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(Qe=>Ye.add(s.ExtensionIdentifier.toKey(Qe))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Qe,z,K)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Qe,v.transformErrorForSerialization(z),K)},actualActivateExtension:async(Qe,z)=>{if(Ye.has(s.ExtensionIdentifier.toKey(Qe)))return await this._mainThreadExtensionsProxy.$activateExtension(Qe,z),new m.HostExtension;const K=this._registry.getExtensionDescription(Qe);return this._activateExtension(K,z)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(j){v.onUnexpectedError(j)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let j=[];try{j=this._registry.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this._deactivate(ue))}catch(Q){}await Promise.all(j)}isActivated(j){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(j):!1}_activateByEvent(j,Q){return this._activator.activateByEvent(j,Q)}_activateById(j,Q){return this._activator.activateById(j,Q)}activateByIdWithErrors(j,Q){return this._activateById(j,Q).then(()=>{const le=this._activator.getActivatedExtension(j);if(le.activationFailed)return Promise.reject(le.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(j=>this._registry)}getExtensionExports(j){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(j).exports:null}async _realPathExtensionUri(j){if(j.scheme!==L.Schemas.file)return j;const Q=await this._hostUtils.realpath(j.fsPath);return I.URI.file(Q)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const j=D.TernarySearchTree.forUris(Q=>T.extUriBiasedIgnorePathCase.ignorePathCasing(Q));for(const Q of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(Q)){const le=await this._realPathExtensionUri(Q.extensionLocation);j.set(le,Q)}return j})()),this._extensionPathIndex}_deactivate(j){let Q=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(j))return Q;const le=this._activator.getActivatedExtension(j);if(!le)return Q;try{typeof le.module.deactivate=="function"&&(Q=Promise.resolve(le.module.deactivate()).then(void 0,ve=>(this._logService.error(ve),Promise.resolve(void 0))))}catch(ve){this._logService.error(ve)}try{(0,A.dispose)(le.subscriptions)}catch(ve){this._logService.error(ve)}return Q}async _activateExtension(j,Q){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(j.identifier),this._doActivateExtension(j,Q).then(le=>{const ve=le.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(j.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,Q),this._logExtensionActivationTimes(j,Q,"success",ve),le},le=>{throw this._logExtensionActivationTimes(j,Q,"failure"),le})}_logExtensionActivationTimes(j,Q,le,ve){const ue=W(j,Q);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ue,...ve||{},outcome:le})}_doActivateExtension(j,Q){const le=W(j,Q);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",le);const ve=this._getEntryPoint(j);if(!ve)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${j.identifier.value}, startup: ${Q.startup}, activationEvent: '${Q.activationEvent}'${j.identifier.value!==Q.extensionId.value?`, root cause: ${Q.extensionId.value}`:""}`),this._logService.flush();const ue=new m.ExtensionActivationTimesBuilder(Q.startup);return Promise.all([this._loadCommonJSModule(j.identifier,(0,T.joinPath)(j.extensionLocation,ve),ue),this._loadExtensionContext(j)]).then(Fe=>(E.mark(`code/extHost/willActivateExtension/${j.identifier.value}`),zi._callActivate(this._logService,j.identifier,Fe[0],Fe[1],ue))).then(Fe=>(E.mark(`code/extHost/didActivateExtension/${j.identifier.value}`),Fe))}_loadExtensionContext(j){const Q=new C.ExtensionGlobalMemento(j,this._storage),le=new C.ExtensionMemento(j.identifier.value,!1,this._storage),ve=new B.ExtensionSecrets(j,this._secretState),ue=j.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Fe=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${j.identifier.value}`),Promise.all([Q.whenReady,le.whenReady,this._storagePath.whenReady]).then(()=>{const Ke=this;let Oe;return Object.freeze({globalState:Q,workspaceState:le,secrets:ve,subscriptions:[],get extensionUri(){return j.extensionLocation},get extensionPath(){return j.extensionLocation.fsPath},asAbsolutePath(He){return M.join(j.extensionLocation.fsPath,He)},get storagePath(){return Ke._storagePath.workspaceValue(j)?.fsPath},get globalStoragePath(){return Ke._storagePath.globalValue(j).fsPath},get logPath(){return M.join(Ke._initData.logsLocation.fsPath,j.identifier.value)},get logUri(){return I.URI.joinPath(Ke._initData.logsLocation,j.identifier.value)},get storageUri(){return Ke._storagePath.workspaceValue(j)},get globalStorageUri(){return Ke._storagePath.globalValue(j)},get extensionMode(){return ue},get extension(){return Oe===void 0&&(Oe=new $(Ke,j.identifier,j,Fe)),Oe},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(j,"extensionRuntime"),Ke.extensionRuntime},get environmentVariableCollection(){return Ke._extHostTerminalService.getEnvironmentVariableCollection(j)}})})}static _callActivate(j,Q,le,ve,ue){return le=le||{activate:void 0,deactivate:void 0},this._callActivateOptional(j,Q,le,ve,ue).then(Fe=>new m.ActivatedExtension(!1,null,ue.build(),le,Fe,ve.subscriptions))}static _callActivateOptional(j,Q,le,ve,ue){if(typeof le.activate=="function")try{ue.activateCallStart(),j.trace(`ExtensionService#_callActivateOptional ${Q.value}`);const Fe=typeof global=="object"?global:self,Ke=le.activate.apply(Fe,[ve]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(Ke).then(Oe=>(ue.activateResolveStop(),Oe))}catch(Fe){return Promise.reject(Fe)}else return Promise.resolve(le)}_activateOneStartupFinished(j,Q){this._activateById(j.identifier,{startup:!1,extensionId:j.identifier,activationEvent:Q}).then(void 0,le=>{this._logService.error(le)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const j of this._registry.getAllExtensionDescriptions())if(j.activationEvents)for(const Q of j.activationEvents)Q==="onStartupFinished"&&this._activateOneStartupFinished(j,Q)}_handleEagerExtensions(){const j=this._activateByEvent("*",!0).then(void 0,ue=>{this._logService.error(ue)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ue=>this._handleWorkspaceContainsEagerExtensions(ue.added)));const Q=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],le=this._handleWorkspaceContainsEagerExtensions(Q),ve=Promise.all([j,le]).then(()=>{});return Promise.race([ve,(0,t.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ve}_handleWorkspaceContainsEagerExtensions(j){return j.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(Q=>this._handleWorkspaceContainsEagerExtension(j,Q))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(j,Q){if(this.isActivated(Q.identifier))return;const le=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ve={folders:j.map(Fe=>Fe.uri),forceUsingSearch:le,exists:Fe=>this._hostUtils.exists(Fe.fsPath),checkExists:(Fe,Ke,Oe)=>this._mainThreadWorkspaceProxy.$checkExists(Fe,Ke,Oe)},ue=await(0,R.checkActivateWorkspaceContainsExtension)(ve,Q);if(!!ue)return this._activateById(Q.identifier,{startup:!0,extensionId:Q.identifier,activationEvent:ue.activationEvent}).then(void 0,Fe=>this._logService.error(Fe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(j){throw console.error(j),j}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:j,extensionTestsLocationURI:Q}=this._initData.environment;if(!j||!Q)throw new Error(l.localize(0,null));const le=await this._loadCommonJSModule(null,Q,new m.ExtensionActivationTimesBuilder(!1));if(!le||typeof le.run!="function")throw new Error(l.localize(1,null,Q.toString()));return new Promise((ve,ue)=>{const Fe=(He,Je)=>{He?ue(He):ve(typeof Je=="number"&&Je>0?1:0)},Ke=(0,T.originalFSPath)(Q),Oe=le.run(Ke,Fe);Oe&&Oe.then&&Oe.then(()=>{ve(0)}).catch(He=>{ue(He.toString())})})}async $extensionTestsExit(j){this._logService.info(`Extension host terminating: test runner requested exit with code ${j}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${j}`),this._logService.flush(),this._hostUtils.exit(j)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(j,Q){return this._resolvers[j]=Q,(0,A.toDisposable)(()=>{delete this._resolvers[j]})}async _activateAndGetResolver(j){const Q=j.indexOf("+");if(Q===-1)throw new Error("Not an authority that can be resolved!");const le=j.substr(0,Q);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${le}`,!1),{authorityPrefix:le,resolver:this._resolvers[le]}}async $resolveAuthority(j,Q){const{authorityPrefix:le,resolver:ve}=await this._activateAndGetResolver(j);if(!ve)return{type:"error",error:{code:b.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${le}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ve)),E.mark(`code/extHost/willResolveAuthority/${le}`);const ue=await ve.resolve(j,{resolveAttempt:Q});E.mark(`code/extHost/didResolveAuthorityOK/${le}`);const Fe={authority:j,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},Ke={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted};return{type:"ok",value:{authority:Fe,options:Ke,tunnelInformation:{environmentTunnels:ue.environmentTunnels}}}}catch(ue){if(E.mark(`code/extHost/didResolveAuthorityError/${le}`),ue instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(j,Q){const{authorityPrefix:le,resolver:ve}=await this._activateAndGetResolver(j);if(!ve)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${le}`);const ue=I.URI.revive(Q);if(typeof ve.getCanonicalURI=="undefined")return ue;const Fe=await(0,t.asPromise)(()=>ve.getCanonicalURI(ue));return Fe||ue}$startExtensionHost(j){return this._registry.keepOnly(j),this._startExtensionHost()}$activateByEvent(j,Q){return Q===1?this._activateByEvent(j,!1):this._readyToRunExtensions.wait().then(le=>this._activateByEvent(j,!1))}async $activate(j,Q){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(j)?(await this._activateById(j,Q),!0):!1}async $deltaExtensions(j,Q){j.forEach(ve=>ve.extensionLocation=I.URI.revive(ve.extensionLocation));const le=await this.getExtensionPathIndex();return await Promise.all(Q.map(async ve=>{const ue=this._registry.getExtensionDescription(ve);ue&&le.delete(await this._realPathExtensionUri(ue.extensionLocation))})),await Promise.all(j.map(async ve=>{const ue=await this._realPathExtensionUri(ve.extensionLocation);le.set(ue,ve)})),this._registry.deltaExtensions(j,Q),Promise.resolve(void 0)}async $test_latency(j){return j}async $test_up(j){return j.byteLength}async $test_down(j){let Q=d.VSBuffer.alloc(j),le=Math.random()%256;for(let ve=0;ve<j;ve++)Q.writeUInt8(le,ve);return Q}async $updateRemoteConnectionData(j){this._remoteConnectionData=j,this._onDidChangeRemoteConnectionData.fire()}};V=Ue([Be(0,o.IInstantiationService),Be(1,e.IHostUtils),Be(2,c.IExtHostRpcService),Be(3,h.IExtHostWorkspace),Be(4,n.IExtHostConfiguration),Be(5,F.ILogService),Be(6,i.IExtHostInitDataService),Be(7,p.IExtensionStoragePaths),Be(8,w.IExtHostTunnelService),Be(9,f.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function W(X,j){return{id:X.identifier.value,name:X.name,extensionVersion:X.version,publisherDisplayName:X.publisher,activationEvents:X.activationEvents?X.activationEvents.join(","):null,isBuiltin:X.isBuiltin,reason:j.activationEvent,reasonId:j.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class ${constructor(j,Q,le,ve){k.set(this,void 0),x.set(this,void 0),N.set(this,void 0),Xe(this,k,j,"f"),Xe(this,x,Q,"f"),Xe(this,N,le.identifier,"f"),this.id=le.identifier.value,this.extensionUri=le.extensionLocation,this.extensionPath=M.normalize((0,T.originalFSPath)(le.extensionLocation)),this.packageJSON=le,this.extensionKind=ve}get isActive(){return Te(this,k,"f").isActivated(Te(this,N,"f"))}get exports(){if(this.packageJSON.api!=="none")return Te(this,k,"f").getExtensionExports(Te(this,N,"f"))}activate(){return Te(this,k,"f").activateByIdWithErrors(Te(this,N,"f"),{startup:!1,extensionId:Te(this,x,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=$,k=new WeakMap,x=new WeakMap,N=new WeakMap}),define(be[100],Ee([0,1,17,2,3,13,5,7,164,32,34,51,171,33,165,14,4,10,91,72]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,g.createDecorator)("IExtHostDebugService");let d=class{constructor(u,w,f,y,R,P){this._workspaceService=w,this._extensionService=f,this._editorsService=y,this._configurationService=R,this._editorTabs=P,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=u.getProxy(t.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new r(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(B=>{B.onDidChange(L=>{this.registerAllDebugTypes(B)}),this.registerAllDebugTypes(B)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(u,w){const f=u;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let y=`debug:${encodeURIComponent(f.path||"")}`,R="?";return w&&(y+=`${R}session=${encodeURIComponent(w.id)}`,R="&"),y+=`${R}ref=${f.sourceReference}`,M.URI.parse(y)}else{if(f.path)return M.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(u){const w=[];for(const f of u.getAllExtensionDescriptions())if(f.contributes){const y=f.contributes.debuggers;if(y&&y.length>0)for(const R of y)(0,a.isDebuggerMainContribution)(R)&&w.push(R.type)}this._debugServiceProxy.$registerDebugTypes(w)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const u=[];return this._breakpoints.forEach(w=>u.push(w)),u}addBreakpoints(u){this.startBreakpoints();const w=u.filter(R=>{const P=R.id;return this._breakpoints.has(P)?!1:(this._breakpoints.set(P,R),!0)});this.fireBreakpointChanges(w,[],[]);const f=[],y=new Map;for(const R of w)if(R instanceof A.SourceBreakpoint){let P=y.get(R.location.uri.toString());P||(P={type:"sourceMulti",uri:R.location.uri,lines:[]},y.set(R.location.uri.toString(),P),f.push(P)),P.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof A.FunctionBreakpoint&&f.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(u){this.startBreakpoints();const w=u.filter(P=>this._breakpoints.delete(P.id));this.fireBreakpointChanges([],w,[]);const f=w.filter(P=>P instanceof A.SourceBreakpoint).map(P=>P.id),y=w.filter(P=>P instanceof A.FunctionBreakpoint).map(P=>P.id),R=w.filter(P=>P instanceof A.DataBreakpoint).map(P=>P.id);return this._debugServiceProxy.$unregisterBreakpoints(f,y,R)}startDebugging(u,w,f){return this._debugServiceProxy.$startDebugging(u?u.uri:void 0,w,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,debugUI:f.debugUI,suppressSaveBeforeStart:f.suppressSaveBeforeStart})}stopDebugging(u){return this._debugServiceProxy.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,w,f){if(!w)return new A.Disposable(()=>{});const y=this._configProviderHandleCounter++;return this._configProviders.push({type:u,handle:y,provider:w}),this._debugServiceProxy.$registerDebugConfigurationProvider(u,f,!!w.provideDebugConfigurations,!!w.resolveDebugConfiguration,!!w.resolveDebugConfigurationWithSubstitutedVariables,y),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==w),this._debugServiceProxy.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(u,w,f){if(!f)return new A.Disposable(()=>{});if(!this.definesDebugType(u,w))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${w}' debugger.`);if(this.getAdapterDescriptorFactoryByType(w))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:w,handle:y,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(w,y),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(u,w){if(!w)return new A.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:u,handle:f,factory:w}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(y=>y.factory!==w)})}async $runInTerminal(u,w){return Promise.resolve(void 0)}async $substituteVariables(u,w){if(!this._variableResolver){const[R,P]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,P)}let f;const y=await this.getFolder(u);return y&&(f={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,w)}createDebugAdapter(u,w){if(u.type==="implementation")return new i(u.implementation)}createSignService(){}async $startDASession(u,w){const f=this,y=await this.getSession(w);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(y.type),y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const P=this.convertToDto(R),B=this.createDebugAdapter(P,y);if(!B)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const L=B;return this._debugAdapters.set(u,L),this.getDebugAdapterTrackers(y).then(k=>(k&&this._debugAdaptersTrackers.set(u,k),L.onMessage(async x=>{if(x.type==="request"&&x.command==="handshake"){const N=x,V={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const W=await this._signService.sign(N.arguments.value);V.body={signature:W},L.sendResponse(V)}else throw new Error("no signer")}catch(W){V.success=!1,V.message=W.message,L.sendResponse(V)}}else k&&k.onDidSendMessage&&k.onDidSendMessage(x),x=(0,a.convertToVSCPaths)(x,!0),f._debugServiceProxy.$acceptDAMessage(u,x)}),L.onError(x=>{k&&k.onError&&k.onError(x),this._debugServiceProxy.$acceptDAError(u,x.name,x.message,x.stack)}),L.onExit(x=>{k&&k.onExit&&k.onExit((0,S.withNullAsUndefined)(x),void 0),this._debugServiceProxy.$acceptDAExit(u,(0,S.withNullAsUndefined)(x),void 0)}),k&&k.onWillStartSession&&k.onWillStartSession(),L.startSession()))})}$sendDAMessage(u,w){w=(0,a.convertToDAPaths)(w,!1);const f=this._debugAdaptersTrackers.get(u);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(w);const y=this._debugAdapters.get(u);y&&y.sendMessage(w)}$stopDASession(u){const w=this._debugAdaptersTrackers.get(u);this._debugAdaptersTrackers.delete(u),w&&w.onWillStopSession&&w.onWillStopSession();const f=this._debugAdapters.get(u);return this._debugAdapters.delete(u),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const w=[],f=[],y=[];if(u.added)for(const R of u.added){const P=R.id;if(P&&!this._breakpoints.has(P)){let B;if(R.type==="function")B=new A.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")B=new A.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const L=M.URI.revive(R.uri);B=new A.SourceBreakpoint(new A.Location(L,new A.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}B._id=P,this._breakpoints.set(P,B),w.push(B)}}if(u.removed)for(const R of u.removed){const P=this._breakpoints.get(R);P&&(this._breakpoints.delete(R),f.push(P))}if(u.changed){for(const R of u.changed)if(R.id){const P=this._breakpoints.get(R.id);if(P){if(P instanceof A.FunctionBreakpoint&&R.type==="function"){const B=P;B.enabled=R.enabled,B.condition=R.condition,B.hitCondition=R.hitCondition,B.logMessage=R.logMessage,B.functionName=R.functionName}else if(P instanceof A.SourceBreakpoint&&R.type==="source"){const B=P;B.enabled=R.enabled,B.condition=R.condition,B.hitCondition=R.hitCondition,B.logMessage=R.logMessage,B.location=new A.Location(M.URI.revive(R.uri),new A.Position(R.line,R.character))}y.push(P)}}}this.fireBreakpointChanges(w,f,y)}$provideDebugConfigurations(u,w,f){return(0,T.asPromise)(async()=>{const y=this.getConfigProviderByHandle(u);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(w);return y.provideDebugConfigurations(R,f)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(u,w,f,y){return(0,T.asPromise)(async()=>{const R=this.getConfigProviderByHandle(u);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.getFolder(w);return R.resolveDebugConfiguration(P,f,y)})}$resolveDebugConfigurationWithSubstitutedVariables(u,w,f,y){return(0,T.asPromise)(async()=>{const R=this.getConfigProviderByHandle(u);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.getFolder(w);return R.resolveDebugConfigurationWithSubstitutedVariables(P,f,y)})}async $provideDebugAdapter(u,w){const f=this.getAdapterDescriptorFactoryByHandle(u);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.getSession(w);return this.getAdapterDescriptor(f,y).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(u){const w=await this.getSession(u);this._onDidStartDebugSession.fire(w)}async $acceptDebugSessionTerminated(u){const w=await this.getSession(u);w&&(this._onDidTerminateDebugSession.fire(w),this._debugSessions.delete(w.id))}async $acceptDebugSessionActiveChanged(u){this._activeDebugSession=u?await this.getSession(u):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(u,w){const f=await this.getSession(u);f&&f._acceptNameChanged(w)}async $acceptDebugSessionCustomEvent(u,w){const y={session:await this.getSession(u),event:w.event,body:w.body};this._onDidReceiveDebugSessionCustomEvent.fire(y)}convertToDto(u){if(u instanceof A.DebugAdapterExecutable)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof A.DebugAdapterServer)return{type:"server",port:u.port,host:u.host};if(u instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:u.path};if(u instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(u){const w=this._adapterFactories.filter(f=>f.type===u);if(w.length>0)return w[0].factory}getAdapterDescriptorFactoryByHandle(u){const w=this._adapterFactories.filter(f=>f.handle===u);if(w.length>0)return w[0].factory}getConfigProviderByHandle(u){const w=this._configProviders.filter(f=>f.handle===u);if(w.length>0)return w[0].provider}definesDebugType(u,w){if(u.contributes){const f=u.contributes.debuggers;if(f&&f.length>0){for(const y of f)if(y.label&&y.type&&y.type===w)return!0}}return!1}getDebugAdapterTrackers(u){const f=u.configuration.type,y=this._trackerFactories.filter(R=>R.type===f||R.type==="*").map(R=>(0,T.asPromise)(()=>R.factory.createDebugAdapterTracker(u)).then(P=>P,P=>null));return Promise.race([Promise.all(y).then(R=>{const P=R.filter(B=>!!B);if(P.length>0)return new o(P)}),new Promise((R,P)=>{const B=setTimeout(()=>{clearTimeout(B),P(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(u,w){const f=w.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new A.DebugAdapterServer(f));if(u){const R=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>u.createDebugAdapterDescriptor(w,this.daExecutableFromPackage(w,R))).then(P=>{if(P)return P})}const y=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(w,y))}daExecutableFromPackage(u,w){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(u,w,f){(u.length>0||w.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:u,removed:w,changed:f}))}async getSession(u){if(u)if(typeof u=="string"){const w=this._debugSessions.get(u);if(w)return w}else{let w=this._debugSessions.get(u.id);if(!w){const f=await this.getFolder(u.folderUri),y=u.parent?this._debugSessions.get(u.parent):void 0;w=new C(this._debugServiceProxy,u.id,u.type,u.name,f,u.configuration,y),this._debugSessions.set(w.id,w),this._debugServiceProxy.$sessionCached(w.id)}return w}throw new Error("cannot find session")}getFolder(u){if(u){const w=M.URI.revive(u);return this._workspaceService.resolveWorkspaceFolder(w)}return Promise.resolve(void 0)}};d=Ue([Be(0,h.IExtHostRpcService),Be(1,I.IExtHostWorkspace),Be(2,F.IExtHostExtensionService),Be(3,_.IExtHostDocumentsAndEditors),Be(4,m.IExtHostConfiguration),Be(5,s.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class C{constructor(u,w,f,y,R,P,B){this._debugServiceProxy=u,this._id=w,this._type=f,this._name=y,this._workspaceFolder=R,this._configuration=P,this._parentSession=B}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(u){this._name=u,this._debugServiceProxy.$setDebugSessionName(this._id,u)}get parentSession(){return this._parentSession}_acceptNameChanged(u){this._name=u}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(u,w){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,u,w)}getDebugProtocolBreakpoint(u){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,u.id)}}e.ExtHostDebugSession=C;class r{constructor(u){this.value=Object.freeze({append(w){u.$appendDebugConsole(w)},appendLine(w){this.append(w+`
`)}})}}e.ExtHostDebugConsole=r;class b extends n.AbstractVariableResolverService{constructor(u,w,f,y,R){function P(){if(w){const B=w.activeEditor();if(B)return B.document.uri;const L=y.tabs.filter(k=>k.isActive);if(L.length>0){const k=L[0].resource;return k&&(k.primary||k.secondary)?k.primary??k.secondary:L[0].resource}}}super({getFolderUri:B=>{const L=u.filter(k=>k.name===B);if(L&&L.length>0)return L[0].uri},getWorkspaceFolderCount:()=>u.length,getConfigurationValue:(B,L)=>f.getConfiguration(void 0,B).get(L),getAppRoot:()=>v.cwd(),getExecPath:()=>v.env.VSCODE_EXEC_PATH,getFilePath:()=>{const B=P();if(B)return l.normalize(B.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const B=P();if(B){const L=R.getWorkspaceFolder(B);if(L)return l.normalize(L.uri.fsPath)}}},getSelectedText:()=>{if(w){const B=w.activeEditor();if(B&&!B.selection.isEmpty)return B.document.getText(B.selection)}},getLineNumber:()=>{if(w){const B=w.activeEditor();if(B)return String(B.selection.end.line+1)}}},void 0,Promise.resolve(v.env))}}e.ExtHostVariableResolverService=b;class o{constructor(u){this.trackers=u}onWillStartSession(){this.trackers.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.trackers.forEach(w=>w.onWillReceiveMessage?w.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.trackers.forEach(w=>w.onDidSendMessage?w.onDidSendMessage(u):void 0)}onWillStopSession(){this.trackers.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.trackers.forEach(w=>w.onError?w.onError(u):void 0)}onExit(u,w){this.trackers.forEach(f=>f.onExit?f.onExit(u,w):void 0)}}class i extends D.AbstractDebugAdapter{constructor(u){super();this.implementation=u,u.onDidSendMessage(w=>{this.acceptMessage(w)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.implementation.handleMessage(u)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let p=class extends d{constructor(u,w,f,y,R,P){super(u,w,f,y,R,P)}createVariableResolver(u,w,f){return new b(u,w,f,this._editorTabs)}};p=Ue([Be(0,h.IExtHostRpcService),Be(1,I.IExtHostWorkspace),Be(2,F.IExtHostExtensionService),Be(3,_.IExtHostDocumentsAndEditors),Be(4,m.IExtHostConfiguration),Be(5,s.IExtHostEditorTabs)],p),e.WorkerExtHostDebugService=p}),define(be[223],Ee([0,1,75,2,5,33,28,26,14,27,4,34,91,12]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(s,d,C,r,b,o,i){this._apiFactory=s,this._extensionRegistry=d,this._instaService=C,this._extHostConfiguration=r,this._extHostExtensionService=b,this._initData=o,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),l.mark("code/extHost/willWaitForConfig");const s=await this._extHostConfiguration.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new h(this._apiFactory,d,this._extensionRegistry,s,this._logService)),this.register(this._instaService.createInstance(g,d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(S,d,this._initData.environment.appUriScheme))}register(s){if(Array.isArray(s.nodeModuleName))for(let d of s.nodeModuleName)this._factories.set(d,s);else this._factories.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this._alternatives.push(d=>s.alternativeModuleName(d))}};a=Ue([Be(2,F.IInstantiationService),Be(3,T.IExtHostConfiguration),Be(4,_.IExtHostExtensionService),Be(5,I.IExtHostInitDataService),Be(6,m.ILogService)],a),e.RequireInterceptor=a;class h{constructor(s,d,C,r,b){this._apiFactory=s,this._extensionPaths=d,this._extensionRegistry=C,this._configProvider=r,this._logService=b,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(s,d){const C=this._extensionPaths.findSubstr(d);if(C){let r=this._extApiImpl.get(A.ExtensionIdentifier.toKey(C.identifier));return r||(r=this._apiFactory(C,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(C.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((b,o)=>r+=`	${o} -> ${b.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(t.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(s,d,C){this._extensionPaths=s,this.nodeModuleName="keytar",this._mainThreadTelemetry=d.getProxy(E.MainContext.MainThreadTelemetry);const{environment:r}=C,b=d.getProxy(E.MainContext.MainThreadKeytar);if(r.appRoot){let o=r.appRoot.fsPath;n.platform==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${o}/node_modules.asar/keytar`),this.alternativeNames.add(`${o}/node_modules/keytar`)}this._impl={getPassword:(o,i)=>b.$getPassword(o,i),setPassword:(o,i,p)=>b.$setPassword(o,i,p),deletePassword:(o,i)=>b.$deletePassword(o,i),findPassword:o=>b.$findPassword(o),findCredentials(o){return b.$findCredentials(o)}}}load(s,d){const C=this._extensionPaths.findSubstr(d);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:C?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(s){const d=s.length;if(d<=7||!this.alternativeNames)return;const C=d-7;if((s.charAt(C)==="/"||s.charAt(C)==="\\")&&s.endsWith("keytar")&&(s=s.replace(/\\/g,"/"),this.alternativeNames.has(s)))return"keytar"}};g=Ue([Be(1,D.IExtHostRpcService),Be(2,I.IExtHostInitDataService)],g);let S=class{constructor(s,d,C){this._extensionPaths=s,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=C.getProxy(E.MainContext.MainThreadTelemetry);const r=C.getProxy(E.MainContext.MainThreadWindow);this._impl=(b,o)=>{const i=M.URI.parse(b);return o?this.callOriginal(b,o):i.scheme==="http"||i.scheme==="https"?r.$openUri(i,b,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?r.$openUri(i,b,{}):this.callOriginal(b,o)}}load(s,d,C){const r=this._extensionPaths.findSubstr(d);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=C(s),this._impl}callOriginal(s,d){return this.sendNoForwardTelemetry(),this._original(s,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};S=Ue([Be(2,D.IExtHostRpcService)],S)}),define(be[224],Ee([0,1,13,16,75,6,2,5,217,12,59,62,27,144,14,67,34,41]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class v{constructor(d,C,r,b){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=r,this._rpcProtocol=new D.RPCProtocol(d,null,b),C=v._transform(C,this._rpcProtocol);const o=new _.ServiceCollection(...(0,F.getSingletonServiceDescriptors)());o.set(n.IExtHostInitDataService,{_serviceBrand:void 0,...C}),o.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),o.set(h.IURITransformerService,new h.URITransformerService(b)),o.set(g.IHostUtils,r);const i=new m.InstantiationService(o,!0),p=i.invokeFunction(f=>f.get(S.IExtHostTerminalService));this._disposables.add(p),this._logService=i.invokeFunction(f=>f.get(I.ILogService)),E.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",C),this._extensionService=i.invokeFunction(f=>f.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const c=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(y,R)=>{let P="",B,L;for(const k of R)P+=`
	at ${k.toString()}`,L=k.getFileName(),!B&&L&&(B=f.findSubstr(t.URI.file(L)));return c.set(y,B),`${y.name||"Error"}: ${y.message||""}${P}`}});const u=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),w=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);M.setUnexpectedErrorHandler(f=>{const y=M.transformErrorForSerialization(f),R=c.get(f);R?u.$onExtensionRuntimeError(R.identifier,y):w.$onUnexpectedError(y)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),M.setUnexpectedErrorHandler(r=>{this._logService.error(r)}),this._rpcProtocol.dispose();const C=this._extensionService.deactivateAll();Promise.race([(0,l.timeout)(5e3),C]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(d,C){d.extensions.forEach(b=>b.extensionLocation=t.URI.revive(C.transformIncomingURIs(b.extensionLocation))),d.environment.appRoot=t.URI.revive(C.transformIncomingURIs(d.environment.appRoot));const r=d.environment.extensionDevelopmentLocationURI;return r&&(d.environment.extensionDevelopmentLocationURI=r.map(b=>t.URI.revive(C.transformIncomingURIs(b)))),d.environment.extensionTestsLocationURI=t.URI.revive(C.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=t.URI.revive(C.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=t.URI.revive(C.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=t.URI.revive(C.transformIncomingURIs(d.logsLocation)),d.logFile=t.URI.revive(C.transformIncomingURIs(d.logFile)),d.workspace=C.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=v}),define(be[225],Ee([0,1,17,21,46,29,24,198,42]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(n,m,a){this.config=n,this.provider=m,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=n.filePattern,this.includePattern=n.includePattern&&T.parse(n.includePattern),this.maxResults=n.maxResults||void 0,this.exists=n.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=n.excludePattern&&T.parse(n.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(n=>n.cancel()),this.activeCancellationTokens=new Set}search(n){const m=this.config.folderQueries||[];return new Promise((a,h)=>{const g=S=>{this.resultCount++,n(S)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(S=>{const v=S.toString(),s=l.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,s)||this.matchFile(g,{base:S,basename:s})}),Promise.all(m.map(S=>this.searchInFolder(S,g))).then(S=>{a({limitHit:this.isLimitHit,stats:S[0]||void 0})},S=>{h(new Error((0,E.toErrorMessage)(S)))})})}async searchInFolder(n,m){const a=new M.CancellationTokenSource,h=this.getSearchOptionsForFolder(n),g=this.initDirectoryTree(),S=new D.QueryGlobTester(this.config,n),v=!S.hasSiblingExcludeClauses();let s;try{this.activeCancellationTokens.add(a),s=A.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,a.token),C=s.elapsed(),r=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(b=>{const o=l.posix.relative(n.folder.path,b.path);if(v){const i=l.basename(b.path);this.matchFile(m,{base:n.folder,relativePath:o,basename:i});return}this.addDirectoryEntries(g,n.folder,o,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,S,m),{providerTime:C,postProcessTime:r.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(n){const m=(0,D.resolvePatternsForProvider)(this.config.includePattern,n.includePattern),a=(0,D.resolvePatternsForProvider)(this.config.excludePattern,n.excludePattern);return{folder:n.folder,excludes:a,includes:m,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,followSymlinks:!n.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries({pathToEntries:n},m,a,h){if(a===this.filePattern){const S=l.basename(this.filePattern);this.matchFile(h,{base:m,relativePath:this.filePattern,basename:S})}function g(S){const v=l.basename(S),s=l.dirname(S);let d=n[s];d||(d=n[s]=[],g(s)),d.push({base:m,relativePath:S,basename:v})}g(a)}matchDirectoryTree({rootEntries:n,pathToEntries:m},a,h){const g=this,S=this.filePattern;function v(s){const d=T.hasSiblingFn(()=>s.map(C=>C.basename));for(let C=0,r=s.length;C<r;C++){const b=s[C],{relativePath:o,basename:i}=b;if(a.matchesExcludesSync(o,i,S!==i?d:void 0))continue;const p=m[o];if(p)v(p);else{if(o===S)continue;g.matchFile(h,b)}if(g.isLimitHit)break}}v(n)}matchFile(n,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||n(m))}}class F{constructor(){this.sessions=new Map}fileSearch(n,m,a,h){const g=this.getSessionTokenSource(n.cacheKey),S=new I(n,m,g&&g.token);let v=0;const s=d=>{v+=d.length,a(d.map(C=>this.rawMatchToSearchItem(C)))};return this.doSearch(S,F.BATCH_SIZE,s,h).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:d.stats}}))}clearCache(n){const m=this.getSessionTokenSource(n);m&&m.cancel()}getSessionTokenSource(n){if(!!n)return this.sessions.has(n)||this.sessions.set(n,new M.CancellationTokenSource),this.sessions.get(n)}rawMatchToSearchItem(n){return n.relativePath?{resource:t.joinPath(n.base,n.relativePath)}:{resource:n.base}}doSearch(n,m,a,h){h.onCancellationRequested(()=>{n.cancel()});const g=v=>{v&&(S.push(v),m>0&&S.length>=m&&(a(S),S=[]))};let S=[];return n.search(g).then(v=>(S.length&&a(S),v),v=>(S.length&&a(S),Promise.reject(v)))}}e.FileSearchManager=F,F.BATCH_SIZE=512}),define(be[226],Ee([0,1,15,21,46,29,11,17,24,10,2,42]),function(re,e,l,M,E,T,t,A,D,I,F,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class n{constructor(s,d,C,r){this.query=s,this.provider=d,this.fileUtils=C,this.processType=r,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(s,d){const C=this.query.folderQueries||[],r=new M.CancellationTokenSource;return d.onCancellationRequested(()=>r.cancel()),new Promise((b,o)=>{this.collector=new a(s);let i=!1;const p=(c,u)=>{if(!i&&!this.isLimitHit){const w=this.resultSize(c);g(c)&&typeof this.query.maxResults=="number"&&this.resultCount+w>this.query.maxResults&&(this.isLimitHit=!0,i=!0,r.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const f=this.resultSize(c);this.resultCount+=f,(f>0||!g(c))&&this.collector.add(c,u)}};Promise.all(C.map((c,u)=>this.searchInFolder(c,w=>p(w,u),r.token))).then(c=>{r.dispose(),this.collector.flush();const u=c.some(w=>!!w&&!!w.limitHit);b({limitHit:this.isLimitHit||u,messages:(0,l.flatten)(c.map(w=>w?.message?(0,I.isArray)(w.message)?w.message:[w.message]:[])),stats:{type:this.processType}})},c=>{r.dispose();const u=(0,E.toErrorMessage)(c);o(new Error(u))})})}resultSize(s){return g(s)?Array.isArray(s.ranges)?s.ranges.length:1:0}trimResultToSize(s,d){const C=Array.isArray(s.ranges)?s.ranges:[s.ranges],r=Array.isArray(s.preview.matches)?s.preview.matches:[s.preview.matches];return{ranges:C.slice(0,d),preview:{matches:r.slice(0,d),text:s.preview.text},uri:s.uri}}async searchInFolder(s,d,C){const r=new _.QueryGlobTester(this.query,s),b=[],o={report:c=>{if(!this.validateProviderResult(c))return;const u=s.folder.scheme===t.Schemas.file?T.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(c.uri))):void 0,w=D.relativePath(s.folder,c.uri);if(w){const f=r.includedInQuery(w,A.basename(w),u);(0,I.isPromise)(f)?b.push(f.then(y=>{y&&d(c)})):f&&d(c)}}},i=this.getSearchOptionsForFolder(s),p=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,o,C);return b.length&&await Promise.all(b),p}validateProviderResult(s){if(g(s)){if(Array.isArray(s.ranges)){if(!Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(s.preview.matches.length!==s.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(s.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(s){const d=(0,_.resolvePatternsForProvider)(this.query.includePattern,s.includePattern),C=(0,_.resolvePatternsForProvider)(this.query.excludePattern,s.excludePattern),r={folder:F.URI.from(s.folder),excludes:C,includes:d,useIgnoreFiles:!s.disregardIgnoreFiles,useGlobalIgnoreFiles:!s.disregardGlobalIgnoreFiles,followSymlinks:!s.ignoreSymlinks,encoding:s.fileEncoding&&this.fileUtils.toCanonicalName(s.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return r.usePCRE2=this.query.usePCRE2,r}}e.TextSearchManager=n;function m(v){return{isCaseSensitive:v.isCaseSensitive||!1,isRegExp:v.isRegExp||!1,isWordMatch:v.isWordMatch||!1,isMultiline:v.isMultiline||!1,pattern:v.pattern}}class a{constructor(s){this._onResult=s,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new S(512,d=>this.sendItems(d))}add(s,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!D.isEqual(this._currentUri,s.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:s.uri,results:[]}),this._currentFileMatch.results.push(h(s))}pushToCollector(){const s=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,s)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(s){this._onResult(s)}}e.TextSearchResultsCollector=a;function h(v){return g(v)?{preview:{matches:(0,l.mapArrayOrNot)(v.preview.matches,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character})),text:v.preview.text},ranges:(0,l.mapArrayOrNot)(v.ranges,s=>({startLineNumber:s.start.line,startColumn:s.start.character,endLineNumber:s.end.line,endColumn:s.end.character}))}:{text:v.text,lineNumber:v.lineNumber}}function g(v){return!!v.preview}e.extensionResultIsMatch=g;class S{constructor(s,d){this.maxBatchSize=s,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(s,d){!s||this.addItemToBatch(s,d)}addItems(s,d){!s||this.addItemsToBatch(s,d)}addItemToBatch(s,d){this.batch.push(s),this.batchSize+=d,this.onUpdate()}addItemsToBatch(s,d){this.batch=this.batch.concat(s),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<S.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},S.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=S,S.TIMEOUT=4e3,S.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,6,5,4,225,14,67,12,2,226]),function(re,e,l,M,E,T,t,A,D,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let _=class{constructor(h,g,S){this.extHostRpc=h,this._uriTransformer=g,this._logService=S,this._proxy=this.extHostRpc.getProxy(M.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,g){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const S=this._handlePool++;return this._textSearchProvider.set(S,g),this._proxy.$registerTextSearchProvider(S,this._transformScheme(h)),(0,l.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}registerFileSearchProvider(h,g){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const S=this._handlePool++;return this._fileSearchProvider.set(S,g),this._proxy.$registerFileSearchProvider(S,this._transformScheme(h)),(0,l.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(S),this._proxy.$unregisterProvider(S)})}$provideFileSearchResults(h,g,S,v){const s=n(S),d=this._fileSearchProvider.get(h);if(d)return this._fileSearchManager.fileSearch(s,d,C=>{this._proxy.$handleFileMatch(h,g,C.map(r=>r.resource))},v);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,g,S,v){const s=this._textSearchProvider.get(h);if(!s||!s.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const d=n(S);return this.createTextSearchManager(d,s).search(r=>this._proxy.$handleTextMatch(h,g,r),v)}$enableExtensionHostSearch(){}createTextSearchManager(h,g){return new F.TextSearchManager(h,g,{readdir:S=>Promise.resolve([]),toCanonicalName:S=>S},"textSearchProvider")}};_=Ue([Be(0,t.IExtHostRpcService),Be(1,A.IURITransformerService),Be(2,D.ILogService)],_),e.ExtHostSearch=_;function n(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(m),extraFileResources:a.extraFileResources&&a.extraFileResources.map(h=>I.URI.revive(h))}}e.reviveQuery=n;function m(a){return{...a,folder:I.URI.revive(a.folder)}}}),define(be[227],Ee([0,1,21,16,3,36,2,118,80,112,58,47,5,188,187,40,189,33,190,191,192,173,193,51,34,194,174,197,199,201,96,176,206,207,208,73,41,210,177,8,7,213,53,97,32,54,161,196,64,95,99,100,101,12,67,14,27,202,158,66,71,185,211,157,74,52,216,214,215,186,31,209,212,70,72,87,204,98,205,11,146,203,155,195,28]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v,s,d,C,r,b,o,i,p,c,u,w,f,y,R,P,B,L,k,x,N,V,W,$,X,j,Q,le,ve,ue,Fe,Ke,Oe,He,Je,Ye,Qe,z,K,Z,oe,G,ie,de,Pe,Ne,We,je,et,ot,ye,nt,q,J,pe,$e,qe,rt,ft,ht,Ct,It,Pt,Ze,pt,Ie,ge){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ce(ee){const se=ee.get(K.IExtHostInitDataService),fe=ee.get(q.IExtHostFileSystemInfo),he=ee.get(je.IExtHostConsumerFileSystem),ke=ee.get(o.IExtHostExtensionService),Le=ee.get(Q.IExtHostWorkspace),Me=ee.get(rt.IExtHostTelemetry),ze=ee.get(S.IExtHostConfiguration),it=ee.get(Qe.IURITransformerService),Re=ee.get(z.IExtHostRpcService),ce=ee.get(L.IExtHostStorage),me=ee.get(We.IExtensionStoragePaths),ne=ee.get(Ye.ILoggerService),H=ee.get(Ye.ILogService),we=ee.get(G.IExtHostTunnelService),De=ee.get(ie.IExtHostApiDeprecationService),Ge=ee.get(j.IExtHostWindow),xe=ee.get($e.IExtHostSecretState),ct=ee.get(qe.IExtHostEditorTabs);Re.set(n.ExtHostContext.ExtHostFileSystemInfo,fe),Re.set(n.ExtHostContext.ExtHostLogLevelServiceShape,ne),Re.set(n.ExtHostContext.ExtHostWorkspace,Le),Re.set(n.ExtHostContext.ExtHostConfiguration,ze),Re.set(n.ExtHostContext.ExtHostExtensionService,ke),Re.set(n.ExtHostContext.ExtHostStorage,ce),Re.set(n.ExtHostContext.ExtHostTunnelService,we),Re.set(n.ExtHostContext.ExtHostWindow,Ge),Re.set(n.ExtHostContext.ExtHostSecretState,xe),Re.set(n.ExtHostContext.ExtHostTelemetry,Me),Re.set(n.ExtHostContext.ExtHostEditorTabs,ct);const Et=Re.set(n.ExtHostContext.ExtHostDecorations,ee.get(Ke.IExtHostDecorations)),vt=Re.set(n.ExtHostContext.ExtHostDocumentsAndEditors,ee.get(b.IExtHostDocumentsAndEditors)),lt=Re.set(n.ExtHostContext.ExtHostCommands,ee.get(h.IExtHostCommands)),gt=Re.set(n.ExtHostContext.ExtHostTerminalService,ee.get(k.IExtHostTerminalService)),dt=Re.set(n.ExtHostContext.ExtHostDebugService,ee.get(He.IExtHostDebugService)),Tt=Re.set(n.ExtHostContext.ExtHostSearch,ee.get(Je.IExtHostSearch)),_t=Re.set(n.ExtHostContext.ExtHostTask,ee.get(Oe.IExtHostTask)),$t=Re.set(n.ExtHostContext.ExtHostOutputService,ee.get(f.IExtHostOutputService)),jt=Re.set(n.ExtHostContext.ExtHostUrls,new $.ExtHostUrls(Re)),St=Re.set(n.ExtHostContext.ExtHostDocuments,new r.ExtHostDocuments(Re,vt)),Wt=Re.set(n.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(Re,vt,H)),ii=Re.set(n.ExtHostContext.ExtHostDocumentSaveParticipant,new C.ExtHostDocumentSaveParticipant(H,St,Re.getProxy(n.MainContext.MainThreadBulkEdits))),wt=Re.set(n.ExtHostContext.ExtHostNotebook,new Z.ExtHostNotebookController(Re,lt,vt,St,me)),Yt=Re.set(n.ExtHostContext.ExtHostNotebookDocuments,new pt.ExtHostNotebookDocuments(H,wt)),qt=Re.set(n.ExtHostContext.ExtHostNotebookEditors,new Ze.ExtHostNotebookEditors(H,Re,wt)),ni=Re.set(n.ExtHostContext.ExtHostNotebookKernels,new ft.ExtHostNotebookKernels(Re,se,wt,lt,H)),ri=Re.set(n.ExtHostContext.ExtHostNotebookRenderers,new Ct.ExtHostNotebookRenderers(Re,wt)),At=Re.set(n.ExtHostContext.ExtHostEditors,new x.ExtHostEditors(Re,vt)),Jt=Re.set(n.ExtHostContext.ExtHostTreeViews,new N.ExtHostTreeViews(Re.getProxy(n.MainContext.MainThreadTreeViews),lt,H)),bi=Re.set(n.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(Re.getProxy(n.MainContext.MainThreadEditorInsets),At,se)),zt=Re.set(n.ExtHostContext.ExtHostDiagnostics,new v.ExtHostDiagnostics(Re,H,fe)),Ht=Re.set(n.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Re,St,lt.converter,it)),mt=Re.set(n.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Re,it,St,lt,zt,H,De)),oi=Re.set(n.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Re,mt)),Nt=Re.set(n.ExtHostContext.ExtHostFileSystemEventService,new p.ExtHostFileSystemEventService(Re,H,vt)),xt=Re.set(n.ExtHostContext.ExtHostQuickOpen,(0,R.createExtHostQuickOpen)(Re,Le,lt)),Xt=Re.set(n.ExtHostContext.ExtHostSCM,new P.ExtHostSCM(Re,lt,H)),Ei=Re.set(n.ExtHostContext.ExtHostComments,(0,g.createExtHostComments)(Re,lt,St)),fi=Re.set(n.ExtHostContext.ExtHostProgress,new y.ExtHostProgress(Re.getProxy(n.MainContext.MainThreadProgress))),_i=Re.set(n.ExtHostContext.ExtHosLabelService,new ue.ExtHostLabelService(Re)),mi=Re.set(n.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Re)),Zt=Re.set(n.ExtHostContext.ExtHostAuthentication,new de.ExtHostAuthentication(Re)),si=Re.set(n.ExtHostContext.ExtHostTimeline,new Pe.ExtHostTimeline(Re,lt)),Gt=Re.set(n.ExtHostContext.ExtHostWebviews,new X.ExtHostWebviews(Re,{remote:se.remote},Le,H,De)),ai=Re.set(n.ExtHostContext.ExtHostWebviewPanels,new ye.ExtHostWebviewPanels(Re,Gt,Le)),yi=Re.set(n.ExtHostContext.ExtHostCustomEditors,new ot.ExtHostCustomEditors(Re,St,me,Gt,ai)),Si=Re.set(n.ExtHostContext.ExtHostWebviewViews,new et.ExtHostWebviewViews(Re,Gt)),Kt=Re.set(n.ExtHostContext.ExtHostTesting,new J.ExtHostTesting(Re,lt)),ei=Re.set(n.ExtHostContext.ExtHostUriOpeners,new pe.ExtHostUriOpeners(Re));Re.set(n.ExtHostContext.ExtHostInteractive,new Ie.ExtHostInteractive(Re,wt,vt,lt));const Ci=(0,le.values)(n.ExtHostContext);Re.assertRegistered(Ci);const Di=new nt.ExtHostBulkEdits(Re,vt),ci=new a.ExtHostClipboard(Re),li=new w.ExtHostMessageService(Re,H),Vt=new s.ExtHostDialogs(Re),Lt=new B.ExtHostStatusBar(Re,lt.converter);return m.ExtHostApiCommands.register(lt),function(Ae,Ft,Qt){const bt=function(){let Y=!Ae.isUnderDevelopment;function ae(){Y||(H.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Y=!0)}return function Se(st){if(Array.isArray(st))st.forEach(Se);else if(typeof st=="string")ae();else{const yt=st;typeof yt.scheme=="undefined"&&ae(),typeof yt.exclusive=="boolean"&&(0,ge.checkProposedApiEnabled)(Ae,"documentFiltersExclusive")}return st}}(),ki={getSession(Y,ae,Se){return Se?.forceNewSession&&(0,ge.checkProposedApiEnabled)(Ae,"authSession"),Zt.getSession(Ae,Y,ae,Se)},async hasSession(Y,ae){return(0,ge.checkProposedApiEnabled)(Ae,"authSession"),!!await Zt.getSession(Ae,Y,ae,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(Y,ae,Se,st){return Zt.registerAuthenticationProvider(Y,ae,Se,st)}},Ii={registerCommand(Y,ae,Se){return lt.registerCommand(!0,Y,ae,Se,void 0,Ae)},registerTextEditorCommand(Y,ae,Se){return lt.registerCommand(!0,Y,(...st)=>{const yt=At.getActiveTextEditor();if(!yt){H.warn("Cannot execute "+Y+" because there is no active text editor.");return}return yt.edit(kt=>{ae.apply(Se,[yt,kt,...st])}).then(kt=>{kt||H.warn("Edits from command "+Y+" were not applied.")},kt=>{H.warn("An error occurred while running command "+Y,kt)})},void 0,void 0,Ae)},registerDiffInformationCommand:(Y,ae,Se)=>((0,ge.checkProposedApiEnabled)(Ae,"diffCommand"),lt.registerCommand(!0,Y,async(...st)=>{const yt=vt.activeEditor(!0);if(!yt){H.warn("Cannot execute "+Y+" because there is no active text editor.");return}const kt=await At.getDiffInformation(yt.id);ae.apply(Se,[kt,...st])},void 0,void 0,Ae)),executeCommand(Y,...ae){return lt.executeCommand(Y,...ae)},getCommands(Y=!1){return lt.getCommands(Y)}},gi={get machineId(){return se.telemetryInfo.machineId},get sessionId(){return se.telemetryInfo.sessionId},get language(){return se.environment.appLanguage},get appName(){return se.environment.appName},get appRoot(){return se.environment.appRoot?.fsPath??""},get appHost(){return se.environment.appHost},get uriScheme(){return se.environment.appUriScheme},get clipboard(){return ci.value},get shell(){return gt.getDefaultShell(!1)},get isTelemetryEnabled(){return Me.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Me.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Y=Date.now()-new Date(se.telemetryInfo.firstSessionDate).getTime();return isNaN(Y)?!1:Y<1e3*60*60*24},openExternal(Y,ae){return Ge.openUri(Y,{allowTunneling:!!se.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(Y){if(Y.scheme===se.environment.appUriScheme)return jt.createAppUri(Y);try{return await Ge.asExternalUri(Y,{allowTunneling:!!se.remote.authority})}catch(ae){if((0,Pt.matchesScheme)(Y,It.Schemas.http)||(0,Pt.matchesScheme)(Y,It.Schemas.https))return Y;throw ae}},get remoteName(){return(0,Fe.getRemoteName)(se.remote.authority)},get remoteAuthority(){return(0,ge.checkProposedApiEnabled)(Ae,"resolvers"),se.remote.authority},get uiKind(){return se.uiKind}};se.environment.extensionTestsLocationURI||Object.freeze(gi);const pi=se.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,Pi={createTestController(Y,ae){return Kt.createTestController(Y,ae)},createTestObserver(){return(0,ge.checkProposedApiEnabled)(Ae,"testObserver"),Kt.createTestObserver()},runTests(Y){return(0,ge.checkProposedApiEnabled)(Ae,"testObserver"),Kt.runTests(Y)},get onDidChangeTestResults(){return(0,ge.checkProposedApiEnabled)(Ae,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,ge.checkProposedApiEnabled)(Ae,"testObserver"),Kt.results}},Ti={getExtension(Y){const ae=Ft.getExtensionDescription(Y);if(ae)return new o.Extension(ke,Ae.identifier,ae,pi)},get all(){return Ft.getAllExtensionDescriptions().map(Y=>new o.Extension(ke,Ae.identifier,Y,pi))},get onDidChange(){return Ft.onDidChange}},ui={createDiagnosticCollection(Y){return zt.createDiagnosticCollection(Ae.identifier,Y)},get onDidChangeDiagnostics(){return zt.onDidChangeDiagnostics},getDiagnostics:Y=>zt.getDiagnostics(Y),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(Y,ae){return Ht.changeLanguage(Y.uri,ae)},match(Y,ae){return(0,F.score)(V.LanguageSelector.from(Y),ae.uri,ae.languageId,!0)},registerCodeActionsProvider(Y,ae,Se){return mt.registerCodeActionProvider(Ae,bt(Y),ae,Se)},registerCodeLensProvider(Y,ae){return mt.registerCodeLensProvider(Ae,bt(Y),ae)},registerDefinitionProvider(Y,ae){return mt.registerDefinitionProvider(Ae,bt(Y),ae)},registerDeclarationProvider(Y,ae){return mt.registerDeclarationProvider(Ae,bt(Y),ae)},registerImplementationProvider(Y,ae){return mt.registerImplementationProvider(Ae,bt(Y),ae)},registerTypeDefinitionProvider(Y,ae){return mt.registerTypeDefinitionProvider(Ae,bt(Y),ae)},registerHoverProvider(Y,ae){return mt.registerHoverProvider(Ae,bt(Y),ae,Ae.identifier)},registerEvaluatableExpressionProvider(Y,ae){return mt.registerEvaluatableExpressionProvider(Ae,bt(Y),ae,Ae.identifier)},registerInlineValuesProvider(Y,ae){return mt.registerInlineValuesProvider(Ae,bt(Y),ae,Ae.identifier)},registerDocumentHighlightProvider(Y,ae){return mt.registerDocumentHighlightProvider(Ae,bt(Y),ae)},registerLinkedEditingRangeProvider(Y,ae){return mt.registerLinkedEditingRangeProvider(Ae,bt(Y),ae)},registerReferenceProvider(Y,ae){return mt.registerReferenceProvider(Ae,bt(Y),ae)},registerRenameProvider(Y,ae){return mt.registerRenameProvider(Ae,bt(Y),ae)},registerDocumentSymbolProvider(Y,ae,Se){return mt.registerDocumentSymbolProvider(Ae,bt(Y),ae,Se)},registerWorkspaceSymbolProvider(Y){return mt.registerWorkspaceSymbolProvider(Ae,Y)},registerDocumentFormattingEditProvider(Y,ae){return mt.registerDocumentFormattingEditProvider(Ae,bt(Y),ae)},registerDocumentRangeFormattingEditProvider(Y,ae){return mt.registerDocumentRangeFormattingEditProvider(Ae,bt(Y),ae)},registerOnTypeFormattingEditProvider(Y,ae,Se,...st){return mt.registerOnTypeFormattingEditProvider(Ae,bt(Y),ae,[Se].concat(st))},registerDocumentSemanticTokensProvider(Y,ae,Se){return mt.registerDocumentSemanticTokensProvider(Ae,bt(Y),ae,Se)},registerDocumentRangeSemanticTokensProvider(Y,ae,Se){return mt.registerDocumentRangeSemanticTokensProvider(Ae,bt(Y),ae,Se)},registerSignatureHelpProvider(Y,ae,Se,...st){return typeof Se=="object"?mt.registerSignatureHelpProvider(Ae,bt(Y),ae,Se):mt.registerSignatureHelpProvider(Ae,bt(Y),ae,typeof Se=="undefined"?[]:[Se,...st])},registerCompletionItemProvider(Y,ae,...Se){return mt.registerCompletionItemProvider(Ae,bt(Y),ae,Se)},registerInlineCompletionItemProvider(Y,ae){return(0,ge.checkProposedApiEnabled)(Ae,"inlineCompletions"),mt.registerInlineCompletionsProvider(Ae,bt(Y),ae)},registerDocumentLinkProvider(Y,ae){return mt.registerDocumentLinkProvider(Ae,bt(Y),ae)},registerColorProvider(Y,ae){return mt.registerColorProvider(Ae,bt(Y),ae)},registerFoldingRangeProvider(Y,ae){return mt.registerFoldingRangeProvider(Ae,bt(Y),ae)},registerSelectionRangeProvider(Y,ae){return mt.registerSelectionRangeProvider(Ae,Y,ae)},registerCallHierarchyProvider(Y,ae){return mt.registerCallHierarchyProvider(Ae,Y,ae)},registerTypeHierarchyProvider(Y,ae){return mt.registerTypeHierarchyProvider(Ae,Y,ae)},setLanguageConfiguration:(Y,ae)=>mt.setLanguageConfiguration(Ae,Y,ae),getTokenInformationAtPosition(Y,ae){return(0,ge.checkProposedApiEnabled)(Ae,"tokenInformation"),Ht.tokenAtPosition(Y,ae)},registerInlayHintsProvider(Y,ae){return(0,ge.checkProposedApiEnabled)(Ae,"inlayHints"),mt.registerInlayHintsProvider(Ae,Y,ae)},createLanguageStatusItem(Y,ae){return(0,ge.checkProposedApiEnabled)(Ae,"languageStatus"),Ht.createLanguageStatusItem(Ae,Y,ae)}},Ai={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(Y,ae,Se){const st=await(t.URI.isUri(Y)?Promise.resolve(vi.openTextDocument(Y)):Promise.resolve(Y));return At.showTextDocument(st,ae,Se)},createTextEditorDecorationType(Y){return At.createTextEditorDecorationType(Ae,Y)},onDidChangeActiveTextEditor(Y,ae,Se){return At.onDidChangeActiveTextEditor(Y,ae,Se)},onDidChangeVisibleTextEditors(Y,ae,Se){return At.onDidChangeVisibleTextEditors(Y,ae,Se)},onDidChangeTextEditorSelection(Y,ae,Se){return At.onDidChangeTextEditorSelection(Y,ae,Se)},onDidChangeTextEditorOptions(Y,ae,Se){return At.onDidChangeTextEditorOptions(Y,ae,Se)},onDidChangeTextEditorVisibleRanges(Y,ae,Se){return At.onDidChangeTextEditorVisibleRanges(Y,ae,Se)},onDidChangeTextEditorViewColumn(Y,ae,Se){return At.onDidChangeTextEditorViewColumn(Y,ae,Se)},onDidCloseTerminal(Y,ae,Se){return gt.onDidCloseTerminal(Y,ae,Se)},onDidOpenTerminal(Y,ae,Se){return gt.onDidOpenTerminal(Y,ae,Se)},onDidChangeActiveTerminal(Y,ae,Se){return gt.onDidChangeActiveTerminal(Y,ae,Se)},onDidChangeTerminalDimensions(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Ae,"terminalDimensions"),gt.onDidChangeTerminalDimensions(Y,ae,Se)},onDidChangeTerminalState(Y,ae,Se){return gt.onDidChangeTerminalState(Y,ae,Se)},onDidWriteTerminalData(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Ae,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(Y,ae,Se)},get state(){return Ge.state},onDidChangeWindowState(Y,ae,Se){return Ge.onDidChangeWindowState(Y,ae,Se)},showInformationMessage(Y,...ae){return li.showMessage(Ae,T.default.Info,Y,ae[0],ae.slice(1))},showWarningMessage(Y,...ae){return li.showMessage(Ae,T.default.Warning,Y,ae[0],ae.slice(1))},showErrorMessage(Y,...ae){return li.showMessage(Ae,T.default.Error,Y,ae[0],ae.slice(1))},showQuickPick(Y,ae,Se){return xt.showQuickPick(Y,(0,ge.isProposedApiEnabled)(Ae,void 0),ae,Se)},showWorkspaceFolderPick(Y){return xt.showWorkspaceFolderPick(Y)},showInputBox(Y,ae){return xt.showInput(Y,ae)},showOpenDialog(Y){return Vt.showOpenDialog(Y)},showSaveDialog(Y){return Vt.showSaveDialog(Y)},createStatusBarItem(Y,ae,Se){let st,yt,kt;return typeof Y=="string"?(st=Y,yt=ae,kt=Se):(yt=Y,kt=ae),Lt.createStatusBarEntry(Ae,st,yt,kt)},setStatusBarMessage(Y,ae){return Lt.setStatusBarMessage(Y,ae)},withScmProgress(Y){return De.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),fi.withProgress(Ae,{location:W.ProgressLocation.SourceControl},(ae,Se)=>Y({report(st){}}))},withProgress(Y,ae){return fi.withProgress(Ae,Y,ae)},createOutputChannel(Y){return $t.createOutputChannel(Y,Ae)},createWebviewPanel(Y,ae,Se,st){return ai.createWebviewPanel(Ae,Y,ae,Se,st)},createWebviewTextEditorInset(Y,ae,Se,st){return(0,ge.checkProposedApiEnabled)(Ae,"editorInsets"),bi.createWebviewEditorInset(Y,ae,Se,st,Ae)},createTerminal(Y,ae,Se){return typeof Y=="object"?("location"in Y&&(0,ge.checkProposedApiEnabled)(Ae,"terminalLocation"),"pty"in Y?gt.createExtensionTerminal(Y):gt.createTerminalFromOptions(Y)):gt.createTerminal(Y,ae,Se)},registerTerminalLinkProvider(Y){return gt.registerLinkProvider(Y)},registerTerminalProfileProvider(Y,ae){return gt.registerProfileProvider(Ae,Y,ae)},registerTreeDataProvider(Y,ae){return Jt.registerTreeDataProvider(Y,ae,Ae)},createTreeView(Y,ae){return Jt.createTreeView(Y,ae,Ae)},registerWebviewPanelSerializer:(Y,ae)=>ai.registerWebviewPanelSerializer(Ae,Y,ae),registerCustomEditorProvider:(Y,ae,Se={})=>yi.registerCustomEditorProvider(Ae,Y,ae,Se),registerFileDecorationProvider(Y){return Et.registerFileDecorationProvider(Y,Ae.identifier)},registerUriHandler(Y){return jt.registerUriHandler(Ae.identifier,Y)},createQuickPick(){return xt.createQuickPick(Ae.identifier,(0,ge.isProposedApiEnabled)(Ae,void 0))},createInputBox(){return xt.createInputBox(Ae.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(Y,ae,Se){return mi.onDidChangeActiveColorTheme(Y,ae,Se)},registerWebviewViewProvider(Y,ae,Se){return Si.registerWebviewViewProvider(Ae,Y,ae,Se?.webviewOptions)},get activeNotebookEditor(){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(Y,ae,Se)},get visibleNotebookEditors(){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),qt.onDidChangeNotebookEditorSelection(Y,ae,Se)},onDidChangeNotebookEditorVisibleRanges(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),qt.onDidChangeNotebookEditorVisibleRanges(Y,ae,Se)},showNotebookDocument(Y,ae){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.showNotebookDocument(Y,ae)},registerExternalUriOpener(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Ae,"externalUriOpener"),ei.registerExternalUriOpener(Ae.identifier,Y,ae,Se)},get tabs(){return(0,ge.checkProposedApiEnabled)(Ae,"tabs"),ct.tabs},get activeTab(){return(0,ge.checkProposedApiEnabled)(Ae,"tabs"),ct.activeTab},get onDidChangeTabs(){return(0,ge.checkProposedApiEnabled)(Ae,"tabs"),ct.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ge.checkProposedApiEnabled)(Ae,"tabs"),ct.onDidChangeActiveTab},getInlineCompletionItemController(Y){return(0,ge.checkProposedApiEnabled)(Ae,"inlineCompletions"),c.InlineCompletionController.get(Y)}},vi={get rootPath(){return De.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(Y){throw M.readonly()},getWorkspaceFolder(Y){return Le.getWorkspaceFolder(Y)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(Y){throw M.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(Y){throw M.readonly()},updateWorkspaceFolders:(Y,ae,...Se)=>Le.updateWorkspaceFolders(Ae,Y,ae||0,...Se),onDidChangeWorkspaceFolders:function(Y,ae,Se){return Le.onDidChangeWorkspace(Y,ae,Se)},asRelativePath:(Y,ae)=>Le.getRelativePath(Y,ae),findFiles:(Y,ae,Se,st)=>Le.findFiles(V.GlobPattern.from(Y),V.GlobPattern.from(ae),Se,Ae.identifier,st),findTextInFiles:(Y,ae,Se,st)=>{(0,ge.checkProposedApiEnabled)(Ae,"findTextInFiles");let yt,kt;return typeof ae=="object"?(yt=ae,kt=Se):(yt={},kt=ae,st=Se),Le.findTextInFiles(Y,yt||{},kt,Ae.identifier,st)},saveAll:Y=>Le.saveAll(Y),applyEdit(Y){return Di.applyWorkspaceEdit(Y)},createFileSystemWatcher:(Y,ae,Se,st)=>Nt.createFileSystemWatcher(V.GlobPattern.from(Y),ae,Se,st),get textDocuments(){return St.getAllDocumentData().map(Y=>Y.document)},set textDocuments(Y){throw M.readonly()},openTextDocument(Y){let ae;const Se=Y;if(typeof Y=="string")ae=Promise.resolve(t.URI.file(Y));else if(t.URI.isUri(Y))ae=Promise.resolve(Y);else if(!Se||typeof Se=="object")ae=St.createDocumentData(Se);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(st=>St.ensureDocumentData(st).then(yt=>yt.document))},onDidOpenTextDocument:(Y,ae,Se)=>St.onDidAddDocument(Y,ae,Se),onDidCloseTextDocument:(Y,ae,Se)=>St.onDidRemoveDocument(Y,ae,Se),onDidChangeTextDocument:(Y,ae,Se)=>St.onDidChangeDocument(Y,ae,Se),onDidSaveTextDocument:(Y,ae,Se)=>St.onDidSaveDocument(Y,ae,Se),onWillSaveTextDocument:(Y,ae,Se)=>ii.getOnWillSaveTextDocumentEvent(Ae)(Y,ae,Se),get notebookDocuments(){return wt.notebookDocuments.map(Y=>Y.apiNotebook)},async openNotebookDocument(Y,ae){let Se;if(t.URI.isUri(Y))Se=Y,await wt.openNotebookDocument(Y);else if(typeof Y=="string")Se=t.URI.revive(await wt.createNotebookDocument({viewType:Y,content:ae}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(Se).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(Y,ae,Se,st){return wt.registerNotebookSerializer(Ae,Y,ae,Se,(0,ge.isProposedApiEnabled)(Ae,"notebookLiveShare")?st:void 0)},registerNotebookContentProvider:(Y,ae,Se,st)=>((0,ge.checkProposedApiEnabled)(Ae,"notebookContentProvider"),wt.registerNotebookContentProvider(Ae,Y,ae,Se,(0,ge.isProposedApiEnabled)(Ae,"notebookLiveShare")?st:void 0)),onDidChangeConfiguration:(Y,ae,Se)=>Qt.onDidChangeConfiguration(Y,ae,Se),getConfiguration(Y,ae){return ae=arguments.length===1?void 0:ae,Qt.getConfiguration(Y,ae,Ae)},registerTextDocumentContentProvider(Y,ae){return Wt.registerTextDocumentContentProvider(Y,ae)},registerTaskProvider:(Y,ae)=>(De.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),_t.registerTaskProvider(Ae,Y,ae)),registerFileSystemProvider(Y,ae,Se){return oi.registerFileSystemProvider(Ae,Y,ae,Se)},get fs(){return he.value},registerFileSearchProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Ae,"fileSearchProvider"),Tt.registerFileSearchProvider(Y,ae)),registerTextSearchProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Ae,"textSearchProvider"),Tt.registerTextSearchProvider(Y,ae)),registerRemoteAuthorityResolver:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Ae,"resolvers"),ke.registerRemoteAuthorityResolver(Y,ae)),registerResourceLabelFormatter:Y=>((0,ge.checkProposedApiEnabled)(Ae,"resolvers"),_i.$registerResourceLabelFormatter(Y)),onDidCreateFiles:(Y,ae,Se)=>Nt.onDidCreateFile(Y,ae,Se),onDidDeleteFiles:(Y,ae,Se)=>Nt.onDidDeleteFile(Y,ae,Se),onDidRenameFiles:(Y,ae,Se)=>Nt.onDidRenameFile(Y,ae,Se),onWillCreateFiles:(Y,ae,Se)=>Nt.getOnWillCreateFileEvent(Ae)(Y,ae,Se),onWillDeleteFiles:(Y,ae,Se)=>Nt.getOnWillDeleteFileEvent(Ae)(Y,ae,Se),onWillRenameFiles:(Y,ae,Se)=>Nt.getOnWillRenameFileEvent(Ae)(Y,ae,Se),openTunnel:Y=>((0,ge.checkProposedApiEnabled)(Ae,"resolvers"),we.openTunnel(Ae,Y).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,ge.checkProposedApiEnabled)(Ae,"resolvers"),we.getTunnels()},onDidChangeTunnels:(Y,ae,Se)=>((0,ge.checkProposedApiEnabled)(Ae,"resolvers"),we.onDidChangeTunnels(Y,ae,Se)),registerPortAttributesProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Ae,"portsAttributes"),we.registerPortsAttributesProvider(Y,ae)),registerTimelineProvider:(Y,ae)=>((0,ge.checkProposedApiEnabled)(Ae,"timeline"),si.registerTimelineProvider(Y,ae,Ae.identifier,lt.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:Y=>((0,ge.checkProposedApiEnabled)(Ae,"workspaceTrust"),Le.requestWorkspaceTrust(Y)),onDidGrantWorkspaceTrust:(Y,ae,Se)=>Le.onDidGrantWorkspaceTrust(Y,ae,Se)},Ri={get inputBox(){return De.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),Xt.getLastInputBox(Ae)},createSourceControl(Y,ae,Se){return Xt.createSourceControl(Ae,Y,ae,Se)}},Fi={createCommentController(Y,ae){return Ei.createCommentController(Ae,Y,ae)}},Mi={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},onDidStartDebugSession(Y,ae,Se){return dt.onDidStartDebugSession(Y,ae,Se)},onDidTerminateDebugSession(Y,ae,Se){return dt.onDidTerminateDebugSession(Y,ae,Se)},onDidChangeActiveDebugSession(Y,ae,Se){return dt.onDidChangeActiveDebugSession(Y,ae,Se)},onDidReceiveDebugSessionCustomEvent(Y,ae,Se){return dt.onDidReceiveDebugSessionCustomEvent(Y,ae,Se)},onDidChangeBreakpoints(Y,ae,Se){return dt.onDidChangeBreakpoints(Y,ae,Se)},registerDebugConfigurationProvider(Y,ae,Se){return dt.registerDebugConfigurationProvider(Y,ae,Se||W.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Y,ae){return dt.registerDebugAdapterDescriptorFactory(Ae,Y,ae)},registerDebugAdapterTrackerFactory(Y,ae){return dt.registerDebugAdapterTrackerFactory(Y,ae)},startDebugging(Y,ae,Se){return!Se||typeof Se=="object"&&"configuration"in Se?dt.startDebugging(Y,ae,{parentSession:Se}):dt.startDebugging(Y,ae,Se||{})},stopDebugging(Y){return dt.stopDebugging(Y)},addBreakpoints(Y){return dt.addBreakpoints(Y)},removeBreakpoints(Y){return dt.removeBreakpoints(Y)},asDebugSourceUri(Y,ae){return dt.asDebugSourceUri(Y,ae)}},Li={registerTaskProvider:(Y,ae)=>_t.registerTaskProvider(Ae,Y,ae),fetchTasks:Y=>_t.fetchTasks(Y),executeTask:Y=>_t.executeTask(Ae,Y),get taskExecutions(){return _t.taskExecutions},onDidStartTask:(Y,ae,Se)=>_t.onDidStartTask(Y,ae,Se),onDidEndTask:(Y,ae,Se)=>_t.onDidEndTask(Y,ae,Se),onDidStartTaskProcess:(Y,ae,Se)=>_t.onDidStartTaskProcess(Y,ae,Se),onDidEndTaskProcess:(Y,ae,Se)=>_t.onDidEndTaskProcess(Y,ae,Se)},Oi={createNotebookController(Y,ae,Se,st,yt){return ni.createNotebookController(Ae,Y,ae,Se,st,(0,ge.isProposedApiEnabled)(Ae,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(Y,ae)=>wt.registerNotebookCellStatusBarItemProvider(Ae,Y,ae),get onDidSaveNotebookDocument(){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),Yt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(Y){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditorDecorationType"),qt.createNotebookEditorDecorationType(Y)},createRendererMessaging(Y){return ri.createRendererMessaging(Ae,Y)},onDidChangeNotebookDocumentMetadata(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),Yt.onDidChangeNotebookDocumentMetadata(Y,ae,Se)},onDidChangeNotebookCells(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeNotebookCells(Y,ae,Se)},onDidChangeNotebookCellExecutionState(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Ae,"notebookCellExecutionState"),wt.onDidChangeNotebookCellExecutionState(Y,ae,Se)},onDidChangeCellOutputs(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeCellOutputs(Y,ae,Se)},onDidChangeCellMetadata(Y,ae,Se){return(0,ge.checkProposedApiEnabled)(Ae,"notebookEditor"),wt.onDidChangeCellMetadata(Y,ae,Se)},createConcatTextDocument(Y,ae){return(0,ge.checkProposedApiEnabled)(Ae,"notebookConcatTextDocument"),new Ne.ExtHostNotebookConcatDocument(wt,St,Y,ae)}};return{version:se.version,authentication:ki,commands:Ii,comments:Fi,debug:Mi,env:gi,extensions:Ti,languages:ui,notebooks:Oi,scm:Ri,tasks:Li,tests:Pi,window:Ai,workspace:vi,Breakpoint:W.Breakpoint,CallHierarchyIncomingCall:W.CallHierarchyIncomingCall,CallHierarchyItem:W.CallHierarchyItem,CallHierarchyOutgoingCall:W.CallHierarchyOutgoingCall,CancellationError:M.CancellationError,CancellationTokenSource:l.CancellationTokenSource,CandidatePortSource:n.CandidatePortSource,CodeAction:W.CodeAction,CodeActionKind:W.CodeActionKind,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.CodeLens,Color:W.Color,ColorInformation:W.ColorInformation,ColorPresentation:W.ColorPresentation,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CompletionItem:W.CompletionItem,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.CompletionList,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.CustomExecution,DebugAdapterExecutable:W.DebugAdapterExecutable,DebugAdapterInlineImplementation:W.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:W.DebugAdapterNamedPipeServer,DebugAdapterServer:W.DebugAdapterServer,DebugConfigurationProviderTriggerKind:W.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.Diagnostic,DiagnosticRelatedInformation:W.DiagnosticRelatedInformation,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.Disposable,DocumentHighlight:W.DocumentHighlight,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.DocumentLink,DocumentSymbol:W.DocumentSymbol,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.EvaluatableExpression,InlineValueText:W.InlineValueText,InlineValueVariableLookup:W.InlineValueVariableLookup,InlineValueEvaluatableExpression:W.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.FileDecoration,FileSystemError:W.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:W.FoldingRange,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.FunctionBreakpoint,InlineCompletionItem:W.InlineSuggestion,InlineCompletionList:W.InlineSuggestions,Hover:W.Hover,IndentAction:I.IndentAction,Location:W.Location,MarkdownString:W.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:W.ParameterInformation,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.Position,ProcessExecution:W.ProcessExecution,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.QuickInputButtons,Range:W.Range,RelativePattern:W.RelativePattern,Selection:W.Selection,SelectionRange:W.SelectionRange,SemanticTokens:W.SemanticTokens,SemanticTokensBuilder:W.SemanticTokensBuilder,SemanticTokensEdit:W.SemanticTokensEdit,SemanticTokensEdits:W.SemanticTokensEdits,SemanticTokensLegend:W.SemanticTokensLegend,ShellExecution:W.ShellExecution,ShellQuoting:W.ShellQuoting,SignatureHelp:W.SignatureHelp,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.SignatureInformation,SnippetString:W.SnippetString,SourceBreakpoint:W.SourceBreakpoint,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.SymbolInformation,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.Task,TaskGroup:W.TaskGroup,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.TerminalLink,TerminalLocation:W.TerminalLocation,TerminalProfile:W.TerminalProfile,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.TextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.ThemeColor,ThemeIcon:W.ThemeIcon,TreeItem:W.TreeItem,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.TypeHierarchyItem,UIKind:n.UIKind,Uri:t.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.WorkspaceEdit,InlayHint:W.InlayHint,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.RemoteAuthorityResolverError,ResolvedAuthority:W.ResolvedAuthority,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.TimelineItem,NotebookRange:W.NotebookRange,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.NotebookCellData,NotebookData:W.NotebookData,NotebookRendererScript:W.NotebookRendererScript,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.NotebookCellOutput,NotebookCellOutputItem:W.NotebookCellOutputItem,NotebookCellStatusBarItem:W.NotebookCellStatusBarItem,NotebookControllerAffinity:W.NotebookControllerAffinity,PortAttributes:W.PortAttributes,LinkedEditingRanges:W.LinkedEditingRanges,TestResultState:W.TestResultState,TestRunRequest:W.TestRunRequest,TestMessage:W.TestMessage,TestTag:W.TestTag,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:ht.TextSearchCompleteMessageType,CoveredCount:W.CoveredCount,FileCoverage:W.FileCoverage,StatementCoverage:W.StatementCoverage,BranchCoverage:W.BranchCoverage,FunctionCoverage:W.FunctionCoverage,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=Ce}),define(be[228],Ee([0,1,59,96,32,95,33,40,51,41,99,100,101,73,66,71,97,52,31,70,87,72,200,12,183]),function(re,e,l,M,E,T,t,A,D,I,F,_,n,m,a,h,g,S,v,s,d,C,r,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(b.ILoggerService,r.ExtHostLoggerService),(0,l.registerSingleton)(b.ILogService,o.ExtHostLogService),(0,l.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService),(0,l.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,l.registerSingleton)(t.IExtHostConfiguration,t.ExtHostConfiguration),(0,l.registerSingleton)(S.IExtHostConsumerFileSystem,S.ExtHostConsumerFileSystem),(0,l.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,l.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,l.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,l.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,l.registerSingleton)(M.IExtHostOutputService,M.ExtHostOutputService),(0,l.registerSingleton)(n.IExtHostSearch,n.ExtHostSearch),(0,l.registerSingleton)(m.IExtHostStorage,m.ExtHostStorage),(0,l.registerSingleton)(F.IExtHostTask,F.WorkerExtHostTask),(0,l.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService),(0,l.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,l.registerSingleton)(g.IExtHostWindow,g.ExtHostWindow),(0,l.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,l.registerSingleton)(s.IExtHostSecretState,s.ExtHostSecretState),(0,l.registerSingleton)(d.IExtHostTelemetry,d.ExtHostTelemetry),(0,l.registerSingleton)(C.IExtHostEditorTabs,C.ExtHostEditorTabs)}),define(be[229],Ee([0,1,227,34,223,7,13,5,11]),function(re,e,l,M,E,T,t,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var I;(function(a){const h=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(S,...v)=>{v.forEach(r=>{if(!self.trustedTypes?.isScript(r))throw new Error("TrustedScripts only, please")});const s=v.slice(0,-1).join(","),d=v.pop().toString();return`(function anonymous(${s}) {${d}
})`}});function g(...S){return h?self.eval(h.createScript("",...S)):new Function(...S)}a.create=g})(I||(I={}));class F extends E.RequireInterceptor{_installInterceptor(){}getModule(h,g){for(let S of this._alternatives){let v=S(h);if(v){h=v;break}}if(this._factories.has(h))return this._factories.get(h).load(h,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends M.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const h=this._extHostContext.getProxy(A.MainContext.MainThreadConsole);m(h,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(l.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(F,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(h){return h.browser}async _loadCommonJSModule(h,g,S){g=g.with({path:n(g.path,".js")}),h&&performance.mark(`code/extHost/willFetchExtensionCode/${h.value}`);const v=await fetch(D.FileAccess.asBrowserUri(g).toString(!0));if(h&&performance.mark(`code/extHost/didFetchExtensionCode/${h.value}`),v.status!==200)throw new Error(v.statusText);const s=await v.text(),d=`${g.toString(!0)}#vscode-extension`,C=`${s}
//# sourceURL=${d}`;let r;try{r=I.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(C)??C)}catch(p){throw console.error(h?`Loading code for extension ${h.value} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${g.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}const b={},o={exports:b},i=p=>{const c=this._fakeModules.getModule(p,g);if(c===void 0)throw new Error(`Cannot load module '${p}'`);return c};try{return S.codeLoadingStart(),h&&performance.mark(`code/extHost/willLoadExtensionCode/${h.value}`),r(o,b,i),o.exports!==b?o.exports:b}finally{h&&performance.mark(`code/extHost/didLoadExtensionCode/${h.value}`),S.codeLoadingStop()}}async $setRemoteEnvironment(h){}async _waitForDebuggerAttachment(h=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+h;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,t.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:a=>a});function n(a,h){return a.endsWith(h)?a:a+h}function m(a,h){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(s,d){const C=console[s];console[s]=function(){a.$logExtensionHostMessage({type:"__$console",severity:d,arguments:v(arguments)}),h&&C.apply(console,arguments)}}const S=1e5;function v(s){const d=[],C=[];if(s.length)for(let r=0;r<s.length;r++){if(typeof s[r]=="undefined")s[r]="undefined";else if(s[r]instanceof Error){const b=s[r];b.stack?s[r]=b.stack:s[r]=b.toString()}C.push(s[r])}try{const r=JSON.stringify(C,function(b,o){if(o&&typeof o=="object"){if(d.indexOf(o)!==-1)return"[Circular]";d.push(o)}return o});return r.length>S?"Output omitted for a large object that exceeds the limits":r}catch(r){return`Output omitted for an object that cannot be inspected ('${r.toString()}')`}}}}),define(be[230],Ee([0,1,59,34,74,229]),function(re,e,l,M,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.registerSingleton)(M.IExtHostExtensionService,T.ExtHostExtensionService),(0,l.registerSingleton)(E.IExtensionStoragePaths,E.ExtensionStoragePaths)}),define(be[239],Ee([0,1,22,3,181,224,218,17,75,11,2,228,230]),function(re,e,l,M,E,T,t,A,D,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const n=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const m=fetch.bind(self);if(self.fetch=function(s,d){return s instanceof Request||/^file:/i.test(String(s))&&(s=I.FileAccess.asBrowserUri(F.URI.parse(String(s))).toString(!0)),m(s,d)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,d,C,r,b){return/^file:/i.test(d.toString())&&(d=I.FileAccess.asBrowserUri(F.URI.parse(d.toString())).toString(!0)),super.open(s,d,C??!0,r,b)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:C=>C}),d=self.Worker;Worker=function(C,r){/^file:/i.test(C.toString())&&(C=I.FileAccess.asBrowserUri(F.URI.parse(C.toString())).toString(!0));const o=`(${function(u){function w(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const f=fetch.bind(self);self.fetch=function(P,B){return P instanceof Request?f(P,B):f(w(P),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,B,L,k,x){return super.open(P,w(B),L??!0,k,x)}};const y=importScripts.bind(self);self.importScripts=(...P)=>{y(...P.map(w))};const R=self.trustedTypes?self.trustedTypes.createPolicy("extensionHostWorker",{createScriptURL:P=>P}):void 0;y(R?R.createScriptURL(u):u)}.toString()}('${C}'))`;r=r||{},r.name=r.name||A.basename(C.toString());const i=new Blob([o],{type:"application/javascript"}),p=URL.createObjectURL(i);return new d(s?s.createScriptURL(p):p,r)}}else self.Worker=class extends t.NestedWorker{constructor(s,d){super(n,s,{name:A.basename(s.toString()),...d})}};const a=new class{constructor(){this.pid=void 0}exit(s){_()}async exists(s){return!0}async realpath(s){return s}};class h{constructor(){const d=new MessageChannel,C=new M.Emitter;let r=!1;n(d.port2,[d.port2]),d.port1.onmessage=b=>{const{data:o}=b;if(!(o instanceof ArrayBuffer)){console.warn("UNKNOWN data received",o);return}const i=l.VSBuffer.wrap(new Uint8Array(o,0,o.byteLength));if((0,E.isMessageOfType)(i,2)){r=!0,S("received terminate message from renderer");return}C.fire(i)},this.protocol={onMessage:C.event,send:b=>{if(!r){const o=b.buffer.buffer.slice(b.buffer.byteOffset,b.buffer.byteOffset+b.buffer.byteLength);d.port1.postMessage(o,[o])}}}}}function g(s){return new Promise(d=>{const C=s.onMessage(r=>{C.dispose();const b=JSON.parse(r.toString());s.send((0,E.createMessageOfType)(0)),d({protocol:s,initData:b})});s.send((0,E.createMessageOfType)(1))})}let S=s=>_();function v(){const s=new h;D.mark("code/extHost/willConnectToRenderer"),g(s.protocol).then(d=>{D.mark("code/extHost/didWaitForInitData");const C=new T.ExtensionHostMain(d.protocol,d.initData,a,null);S=r=>C.terminate(r)})}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3bd29c1d6c6ef5b6265614def99b7257b671ae19/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
